function atom_dist, w_in, atom_1, atom_2
;+
;******* *********
;** from VASP MD frames saved in a workspace, calculate
;** the distance between atom_1 and atom_2
;** requires w_in in REAL coordinates eg w_in = xdatcar(/real)
;** JDF 19/7/2010
;-

;get coordinates of atoms

a1_coords = w_in[*,*,atom_1]
a2_coords = w_in[*,*,atom_2]

;calculate interatomic vectors in real cartesian coordinates

a12_vec = a1_coords - a2_coords

;calculate interatomic distance

x2 = a12_vec[*,0]^2
y2 = a12_vec[*,1]^2
z2 = a12_vec[*,2]^2

a12_dist = sqrt(x2+y2+z2)

return, a12_dist

end

