;---------------------------------------------------------------------------
function calc_w_inc, file_in,e_res,w,q_val,temp,mass,ATOMS_SEL;TEMP=TEMP,MEV=MEV,GDOS=GDOS,AS=AS;, ndos, npts
;+
;******* **********
;** Called by build_q_w
;-

; if N_elements(MEV) ne 0 then conv_freq=4.1357

  junk='' & i=0 & conv_freq = 1.
  
  Print,'-------------------------------------------'
  Print,'         Entering incoherent section
  Print,'-------------------------------------------'
  
  Print,'Reading the .d08...'
  lect_d08,file_in,natoms,str_types,mass,n_uneq
  Print,'Reading the .d08: OK'
  Print,'Reading the .d99...'
  lect_d99,file_in,s_tot_uneq,s_inc_uneq,n_uneq
  Print,'Reading the .d99: OK'
 ; Print,'Reading the .d18...'
 ; lect_d18,file_in,freq,tmp,j,ndos,npts
 ; Print,'Reading the .d18: OK'
  Print,'Reading the .d34...'
  lect_d34,file_in,freq,tmp,j,ndos,npts
  Print,'Reading the .d34: OK'

  Print,'Reformating...'
  freq=freq/conv_freq ; frequencies should be in THz
;  tmp=tmp(*,1:j-1) & npart=(j-1)/3 & if npart ne natoms then Print, 'PROBLEM IN NUMBER OF ATOMS...!!!'
  npart=j/3 & if npart ne natoms then Print, 'PROBLEM IN NUMBER OF ATOMS...!!!'
  str_types_uneq=str_types[UNIQ(str_types)] & n_uneq_test=n_elements(str_types_uneq) & if n_uneq ne n_uneq_test then PRINT, 'PROBLEM IN NUMBER OF NON EQUIVALENT ATOMS...!!!'
  s_tot=fltarr(natoms) & s_inc=fltarr(natoms)
  for i=0,n_uneq-1 do begin
    junk=str_types_uneq[i] & good_i=where(str_types EQ junk) & s_tot[good_i]=s_tot_uneq[i] & s_inc[good_i]=s_inc_uneq[i]
  endfor
;  s_inc[0:3]=81. & mass[0:3]=1. ; H case
;   s_inc=s_tot-s_inc ; pseudo-coherent case...
  n_q=n_elements(q_val) & npts2=n_elements(w)
  sqw_inc=fltarr(npts2,n_q,npart)


  Print,'NUMBER OF MODES                  =',ndos
  Print,'NUMBER OF ATOMS IN THE UNIT CELL =',npart
  Print,'NUMBER OF UNEQUIVALENT ATOMS     =',n_uneq
  PRINT,'TYPES                            =',str_types
  PRINT,'MASSES (AMU)                     =',mass
  PRINT,'SCATERING CROSS SECTIONS         =',s_tot
  PRINT,'INCOHERENT CROSS SECTIONS        =',s_inc

  ; Removing the negative frequencies - not renormalizing to unity...
  bad_i=where(freq le 0.,complement=good_i)
;  if bad_i(0) NE -1 then begin & tmp=tmp(good_i,*) & freq=freq(good_i) &                     npts=n_elements(good_i) & endif

;  ; Calculate the Bose population factor
;  bose=1./(1.-exp(-freq*47.993/temp))
;  if N_elements(AS) NE 0 then bose=bose-1.

  ; Calculate the partials dos for each atoms ( g_{d}(w) = \Sum_{alpha} g_{alpha,d}(w) )
tmpp=tmp  
tmp=fltarr(npts,npart)
  for j=0,npart-1 do begin
    tmp[*,j]=tmpp[*,j*3,0]+tmpp[*,j*3+1,1]+tmpp[*,j*3+2,2]
  endfor

  ; Verifying the normalisation of the partials before rebinning---
  ;Fint=fltarr(3*npart)
  ;for i=0,3*npart-1 do Fint(i)=int_tabulated(freq,tmpp(*,i))
  ;PRINT,'Integral of partials dos a,d      =',Fint
  ;PRINT,'Integral of total dos             =',total(Fint)
  Fint=fltarr(npart)
  for i=0,npart-1 do Fint[i]=int_tabulated(freq,tmp[*,i])
  PRINT,'Before Reb.: Integral of partials dos d        =',Fint
  PRINT,'Before Reb.: Integral of total dos             =',total(Fint)

  PRINT,'Rebinning to the w axis for coherent scattering...'
  
  nmax=n_elements(w)
;  w_inc=(findgen(nmax)+1.0)*e_res
  tmp_reb=fltarr(nmax,npart)
  de_freq=freq[1]-freq[0]
  
  Print,'-------------------   Energy rebinning section   -------------------------'
  Print,'e_res chosen is:', e_res,' meV'
  Print,'de_freq found in partials DOS is:', de_freq,' meV'
  Print,'Rebining to e_res...'
  for ipt=0,npart-1 do begin
    ;loop to get frequencies onto f_axis
    for imode=0,n_elements(freq)-1 do begin
        ifq=round(freq[imode]/e_res) & tmp_reb[ifq,ipt]=tmp_reb[ifq,ipt]+tmp[imode,ipt]
    endfor
  endfor
  
  tmp_reb=tmp_reb*de_freq/e_res
  Print,'-------------------   Energy rebinning done   -------------------------'
  
  Fint=fltarr(npart)
  for i=0,npart-1 do Fint[i]=int_tabulated(w,tmp_reb[*,i])
  PRINT,'After Reb.: Integral of partials dos d        =',Fint
  PRINT,'After Reb.: Integral of total dos             =',total(Fint)

  tmp=tmp_reb & freq=w

  dW=fltarr(npart)
  for ipart=0,npart-1 do begin
    ;for ipart=6,8 do begin
    dW[ipart]=int_tabulated(freq,tmp[*,ipart]/freq/tanh(0.5*freq*47.993/temp))
    ;W(ipart)=int_tabulated(freq,tmpp(*,ipart)/freq/tanh(0.5*freq*47.993/temp))
    dW[ipart]=0.5*npart*(1.056/0.166)*dW[ipart]/(mass[ipart]*2*!pi)
    ;W(ipart)=0.5*(10.546/1.6605)*W(ipart)/mass(0)
  endfor
  PRINT,'<U^2> (A-2) at ',temp,' K        =',dW*3.

    PRINT,'Calculating incoherent part...'
    for ipart=0,npart-1 do begin
      for iq=0,n_q-1 do begin
        sqw_inc[*,iq,ipart]=(tmp[*,ipart]*q_val[iq]^2*s_inc[ipart]/mass[ipart])*exp(-q_val[iq]^2*dW[ipart])
        ;if ((ipart EQ 0) OR (ipart EQ 4)) THEN PRINT,q_val(iq),exp(-q_val(iq)^2*dW(ipart))
      endfor
    endfor

  if atoms_sel[0] lt 0 then begin
  sqw_inc=total(sqw_inc,3)
  endif else begin
  sqw_inc=total(sqw_inc[*,*,atoms_sel-1],3)
  endelse
  
  sqw_inc=npart*sqw_inc/8./!pi ; in unit per number of cells

  
  ;generate structure for (q,w)
;  freq=freq*4.1357 ; for frequency in meV
;  datp={x:freq, y:q_val,z:mass, w_tit:tit, x_tit:'frequency [meV]', y_tit:'Q (A-1)', z_tit:'Mass (AMU)'}

;  give_datp, datp
  Print,'-------------------------------------------'
  Print,'         Exiting incoherent section
  Print,'-------------------------------------------'

  return, sqw_inc

end


function build_q_w, Ap, file_in, nmodes, npts, e_res, q_res, q_max,TOTAL=TOTAL,$
                    TEMP=TEMP,SQE=SQE,AS=AS,WCOH=WCOH,WINC=WINC,SPEC=SPEC,ATOMS_SEL=ATOMS_SEL
;+
;******* *********
;** User callable
;**  function to read powder average, coherent structure factor calc from Phonon
;**  currently for cubic systems where k is easy to define
;**  data file is made up of blocks of n_pts_k spectra at n_k k-values
;***************
;**  call is w1=phon_q_w('file.d51', 192, 40, 50, n_files, 0.1, 0.1, 8.0)
;**  'file.d51' is coherent structure factor from PHONON
;**  192 is normally 3*number of atoms in cell
;**    but can be less due to degeneracy
;**  40 is number of k values
;**  50 is number of points per k-value
;**  n_files is number of sampled files
;**  0.1 is e_res in meV
;**  0.1 is q_res in A-1
;**  8.0 is max q-value
;**  a=b=5.85842 & c=22.872 are lattice parameters ... conversion to Q, 3 values for orthorhombic lattice
;** 
;** Modified by S. Rols 02/2014 to calculate incoherent structure factor.
;******************
;-

bid = calc_isf(/compile) ; To have '.d*' readers available here.

junk=' '
junk = STRMID(file_in,3, 1, /REVERSE_OFFSET)
IF junk EQ '.' THEN file_in=STRMID(file_in,0,strlen(file_in)-4)
Print,'FILENAME SEED IS...   ',file_in

e_res=e_res/4.136 ; e_res should be in THz (input in meV)

; Do we need Temperature info?
if N_elements(TEMP) ne 1 then begin ;case Temp not given
  temp=300. ; set it to 300 K by default
  if keyword_set(TOTAL) OR keyword_set(SQE) then begin ; need temp info
  lect_temp_d99,file_in,temp
  endif
endif

if N_elements(ATOMS_SEL) lt 1 then ATOMS_SEL=[-1] ;all atoms selected for incoherent calculation

Print, 'Temperature is ...',temp,' K'

Print,'-------------------------------------------'
Print,'         Entering coherent section
Print,'-------------------------------------------'

;initialise variables
;npts=long(n_k * n_pts_k * n_files) & print, n_files, n_k, n_pts_k, npts
;open file
openr,u,file_in+'.d51',/get_lun & sk='k'  
readf,u,junk & readf,u,junk & s=strmid(junk,8,1)

case (s) of
  sk: begin ; This is Phonon v4
  nx=6  
  end
  else: begin ; This is Phonon v5
  nx=7 & readf,u,junk
  end
endcase

tmp=fltarr(nx,nmodes,npts)
;tmpp=fltarr(nx)
readf,u,tmp & free_lun,u & print,'file read' ;read data
;ic=LONG(0)
;for ipt=0,npts-1 do begin
;  print,ic
;  for im=0,nmodes-1 do begin
;  readf,u,tmpp
;  tmp[*,im,ipt]=tmpp  
;  endfor
;  ic=ic+LONG(1)
;endfor
;pick out q, frequencies and intensities
q  =tmp[1:3,*,*]
freq=reform(tmp[4,*,*]);*4.136 ;in meV
ints=reform(tmp[5,*,*])
;ints=reform(tmp[5,*,*])*0.+1.


; Ap matrix from phonon
;   Ap=[[5.85842000,-2.92921000,0.00000000], $
;      [0.00000000,5.07354055,0.00000000], $
;      [0.00000000,0.00000000,22.87200000]]

;B is inverse of Ap
B=invert(Ap) & print, B, B#Ap

;set up q axis
q_vec=fltarr(npts)
;set up freq/intensity axis
nmax=ceil(max(freq)/e_res)+1.0
print,'number of energy channels=', nmax ; nmax is for max energy transfer
;define energy axis
w=(findgen(nmax)+1.0)*e_res
print, 'energy axis defined'
n_q=round(q_max/q_res)+1.0 & print, 'n_q=',n_q
q_axis=findgen(n_q)*q_res
print, 'Q axis defined'
;
w_axis=fltarr(nmax,npts)
;for each k-point
for ipt=0L,npts-1 do begin
  nmode_neg=0 ; count negative frequencies
  amp=q[*,0,ipt]#B & q_vec[ipt]=sqrt(total(amp^2))*2.0*!PI
  ;loop to get frequencies onto f_axis
  for imode=0,nmodes-1 do begin
    if (freq[imode,ipt] lt 0.0) then begin
      nmode_neg=nmode_neg+1 & print,'NEG. FREQ. FOUND...',nmode_neg
    endif else begin
      ifq=round(freq[imode,ipt]/e_res) & w_axis[ifq,ipt]=w_axis[ifq,ipt]+ints[imode,ipt]
    endelse
  endfor
endfor

print, 'Coherent spectra made'
print, max(q_vec)
w_axis=w_axis/e_res/2. & w_axis_coh=w_axis; For absolute normalization with incoherent part
w_axis_inc=w_axis*0.
;--------------------------
; INCOHERENT S(Q,E) 
if keyword_set(total) then begin
  w_axis_inc=calc_w_inc(file_in,e_res,w,q_vec,temp,mass,ATOMS_SEL)
  w_axis=w_axis_coh+w_axis_inc
endif
;--------------------------
;sort and rebin q and spectra
;n_q=round(q_max/q_res)+1.0 & print, 'n_q=',n_q
wq_axis=fltarr(nmax, n_q) & wq_axis[*,*]=0.0
wq_axis_coh=wq_axis & wq_axis_inc=wq_axis
nq_axis=fltarr(n_q)
for ipt=0L,npts-1 do begin
  iq=round(q_vec[ipt]/q_res)
  wq_axis[*,iq]=wq_axis[*,iq]+w_axis[*,ipt]
  wq_axis_coh[*,iq]=wq_axis_coh[*,iq]+w_axis_coh[*,ipt]
  wq_axis_inc[*,iq]=wq_axis_inc[*,iq]+w_axis_inc[*,ipt]  
  nq_axis[iq]=nq_axis[iq]+1.0
endfor
for iq=0,n_q-1 do begin
  if nq_axis[iq] gt 0. then begin
  wq_axis[*,iq]=wq_axis[*,iq]/nq_axis[iq]
  wq_axis_coh[*,iq]=wq_axis_coh[*,iq]/nq_axis[iq]
  wq_axis_inc[*,iq]=wq_axis_inc[*,iq]/nq_axis[iq]  ; normalise
  endif
endfor
print, 'q sorting/rebinning done'

; Calculate the Bose population factor
bose=1./(1.-exp(-w*47.993/temp)) & if N_elements(AS) NE 0 then bose=bose-1.

IF keyword_set(SQE) THEN BEGIN
  Print,'SQE spectrum requested...'
  for iq=0,n_q-1 do begin
    wq_axis_coh[*,iq]=wq_axis_coh[*,iq]*bose/w
    wq_axis_inc[*,iq]=wq_axis_inc[*,iq]*bose/w
    wq_axis[*,iq]=wq_axis[*,iq]*bose/w    
  endfor
ENDIF ELSE BEGIN
  Print,'GDOS spectrum requested...'
  for iq=0,n_q-1 do begin
    if q_axis[iq] le 0 then begin 
      wq_axis_coh[*,iq]=0.
      wq_axis_inc[*,iq]=0.
      wq_axis[*,iq]=0.
    endif else begin
      wq_axis_coh[*,iq]=wq_axis_coh[*,iq]/q_axis[iq]^2
      wq_axis_inc[*,iq]=wq_axis_inc[*,iq]/q_axis[iq]^2
      wq_axis[*,iq]=wq_axis[*,iq]/q_axis[iq]^2
    endelse
  endfor
  
ENDELSE

w=w*4.136 ; From now on, w in meV


IF N_ELEMENTS(SPEC) EQ 3 THEN BEGIN
  lambda=SPEC[0] & theta_min=SPEC[1] & theta_max=SPEC[2]
  Print,'Calculate S[Q,E] spectrum for lambda=',lambda,' theta_min=',theta_min,' theta_max=',theta_max
  Ei=81.799/lambda^2 & E_max=Ei
  mask_qw=wq_axis*0.
  if N_elements(AS) NE 0 then begin w=-w & E_max=min(w) & endif
  q_min=0.6947*sqrt(2*Ei-w-2.*sqrt(Ei*(Ei-w))*cos(theta_min*!pi/180.))
  q_max=0.6947*sqrt(2*Ei-w-2.*sqrt(Ei*(Ei-w))*cos(theta_max*!pi/180.))
  i=0
  while (abs(w[i]) lt abs(E_max)) do begin
    ind=where(q_axis le q_max[i] and q_axis ge q_min[i])
    if ind[0] gt 0. then mask_qw[i,ind]=1.
    i=i+1
  endwhile
  wq_axis_coh=wq_axis_coh*mask_qw
  wq_axis_inc=wq_axis_inc*mask_qw
  wq_axis=wq_axis*mask_qw

ENDIF
 
if N_elements(AS) NE 0 then begin
  w=reverse(w)
  wq_axis_coh=reverse(wq_axis_coh)
  wq_axis_inc=reverse(wq_axis_inc)
  wq_axis=reverse(wq_axis)
endif

IF (N_ELEMENTS(WINC) GT 0 AND KEYWORD_SET(TOTAL)) THEN BEGIN
datp_inc={x:w, y:q_axis, z:mass, w_tit:'incoherent structure factor', x_tit:'frequency [meV]', y_tit:'q [A-1]'}
GIVE_W,wq_axis_inc,W=WINC 
GIVE_DATP,datp_inc,W=WINC
ENDIF

IF (N_ELEMENTS(WCOH) GT 0) THEN BEGIN
  datp_coh={x:w, y:q_axis, z:mass, w_tit:'coherent structure factor', x_tit:'frequency [meV]', y_tit:'q [A-1]'}
  GIVE_W,wq_axis_coh,W=WCOH
  GIVE_DATP,datp_coh,W=WCOH
ENDIF


;generate structure for (q,w)
datp={x:w, y:q_axis, w_tit:'coherent structure factor', x_tit:'frequency [meV]', y_tit:'q [A-1]'}

Print,'-------------------------------------------'
Print,'         Calculation DONE
Print,'-------------------------------------------'

e_res = e_res*4.136 ;restore input value of e_res in meV (to avoid changes when calling build_q_w repeatedly using an input variable)

give_datp, datp
return, wq_axis

end
