pro lect_mkl,file_in,freq,tmp,j,ndos,npts,mass,natoms,str_types,n_uneq,s_tot_uneq,s_inc_uneq

  ;+
  ;** ********
  ;Routine aiming at listing the different types of atoms in the cell
  ;-
  
;  file_in,natoms,str_types,mass,n_uneq
;  file_in,s_tot_uneq,s_inc_uneq,n_uneq
;  file_in,freq,tmp,j,ndos,npts
;  file_in,natoms,str_types,mass,n_uneq
  
  line='' & ndos = 0. & npts=0. & a=0. & b=0. & c=0. & d=0. & ok=1 & curato=0
  W=0.
  openr,u,file_in+'.mkl',/get_lun
  while ok do begin & readf,u,line  & if strpos(line,'$COORD') ge 0 then ok=0 & endwhile
  ok=1 
  while ok do begin
    readf,u,line
    if strpos(line,'$END') ge 0 then begin
      ok=0
    endif else begin
      reads,line, typ,xc,yc,zc & curato=curato+1 & W=[W,typ]
    endelse
  endwhile
  
    ok=1

  if curato gt 0 then begin
    wn=curato & & W=W[1:wn] & pv=fltarr(3,wn,3*wn) & Vmk=fltarr(3*wn)
    cri3=fltarr(9)

    while ok do begin & readf,u,line  & if strpos(line,'$FREQ') ge 0 then ok=0 & endwhile

    for i=0L,wn-1 do begin

      readf,u,line ; read the X    X    X line...
      readf,u,line & reads,line,xi,yi,zi ; read the eigenfrequencies in cm-1     
      Vmk[3*i]=xi/33.36 ;Cm-1 -> THz
      Vmk[3*i+1]=yi/33.36
      Vmk[3*i+2]=zi/33.36
      
      for j=0L,wn-1 do begin
        readf,u,line & reads,line,cri3 & jj=j+i*wn
        pv[0:2,j,3*i]=cri3[0:2] ; XYZ Real mode1
        pv[0:2,j,3*i+1]=cri3[3:5] ; XYZ Real mode2
        pv[0:2,j,3*i+2]=cri3[6:8] ; XYZ Real mode3
      endfor
    endfor
  endif
  print,'ca continue'
; now calculate the partial dos...
; g(alpha,n,E)=Sum_{j} [<alpha n j I alpha n j>]^2 delta(E-E_{j}
  ndos=wn
  emin=min(Vmk) & emax=max(Vmk) & rangeE=(emax-emin)*1.1 & npts=floor(rangeE/0.025) ; Step of 0.025 THz ~ 0.1 meV
  gau_all=fltarr(npts,ndos*3) & sigma=0.125/2.3548 ;  FWHM = 2.3548 * sigma
  freq=findgen(npts)*0.025-1.1*abs(emin)
  tmp=fltarr(npts,ndos,3)
  
  for i=0,npts-1 do gau_all[i,*]=exp(-(freq[i]-Vmk[*])^2/2/sigma^2)
  
  for i=0,2 do begin
    for j=0,wn-1 do begin
      for n=0,npts-1 do begin
      ei=pv[i,j,*]^2
      tmp[n,j,i]=total(ei*gau_all[n,*])
      endfor
    endfor
  endfor
  
  ; Should return the necessary variables...
  ;  file_in,natoms,str_types,mass,n_uneq
  ;  file_in,s_tot_uneq,s_inc_uneq,n_uneq
  ;  file_in,freq,tmp,j,ndos,npts
  ;  file_in,natoms,str_types,mass,n_uneq
  natoms=wn & n_uneq=natoms & j=ndos
  mass=fltarr(natoms) & for i=0,natoms-1 do mass[i]=d_livTypetoMass(W[i])
  str_types=strarr(natoms) & for i=0,natoms-1 do str_types[i]=d_livTypetoSymb(W[i])+strcompress(string(i+1),/remove_all)
  s_tot_uneq=fltarr(natoms)+1 & s_inc_uneq=s_tot_uneq
  print,'This is the Molekel case... set all scattering cross section to unity !!!!'
  
end
;    
;  
;   
;  readf,u,ndos,junk & readf,u,npts,junk
;  tmp=fltarr(npts,ndos,3) & freq=fltarr(npts)
;  j=0
;  ; Loop until EOF is found:
;  WHILE ~ EOF(u) DO BEGIN
;    if j ne 0 then readf,u,junk
;    readf,u,junk & print,'Reading...'+junk
;    ;print,junk
;    for i=0,npts-1 do begin & readf,u,a,b,c,d & freq[i]=a & tmp[i,j,0]=b & tmp[i,j,1]=c & tmp[i,j,2]=d & endfor
;    ;print, 'DOS# ',j+1, 'read'
;    j=j+1
;  ENDWHILE
;  Print, 'Could read ',j,' partials... over',fix(ndos),' to be read'
;  free_lun,u
;end



pro lect_d08,file_in,natoms,str_types,mass,n_uneq
;+
;** ********
;Routine aiming at listing the different types of atoms in the cell
;-
openr,u,file_in+'.d08',/get_lun
junk='' & njunk=0 & natoms = 0 & n_uneq=0
a=0. & b=0. & c=0.
readf,u,njunk,n_uneq,junk
for i=0,10 do readf,u,junk
readf,u,natoms,junk
readf,u,junk
str_types=strarr(natoms) & mass=fltarr(natoms)
for i=0,natoms-1 do begin & readf,u,junk,a,format='(6X,A7,65X,F10.4)' & str_types[i]=junk & mass[i]=a & endfor
free_lun,u
end

pro lect_d18,file_in,freq,tmp,j,ndos,npts
;+
;** ********
;Routine aiming at listing the different types of atoms in the cell
;-
junk='' & ndos = 0. & npts=0. & a=0. & b=0.
openr,u,file_in+'.d18',/get_lun
readf,u,ndos,junk & readf,u,npts,junk
tmp=fltarr(npts,ndos) & freq=fltarr(npts)
j=0
; Loop until EOF is found:
WHILE ~ EOF(u) DO BEGIN
if j ne 0 then readf,u,junk
readf,u,junk
;print,junk
for i=0,npts-1 do begin & readf,u,a,b & freq[i]=a & tmp[i,j]=b & endfor
;print, 'DOS# ',j+1, 'read'
j=j+1
ENDWHILE
free_lun,u
end

pro lect_d34,file_in,freq,tmp,j,ndos,npts
;+
;** ********
;Routine aiming at listing the different types of atoms in the cell
;-
  junk='' & ndos = 0. & npts=0. & a=0. & b=0. & c=0. & d=0.
  openr,u,file_in+'.d34',/get_lun
  readf,u,ndos,junk & readf,u,npts,junk
  tmp=fltarr(npts,ndos,3) & freq=fltarr(npts)
  j=0
  ; Loop until EOF is found:
  WHILE ~ EOF(u) DO BEGIN
    if j ne 0 then readf,u,junk
    readf,u,junk & print,'Reading...'+junk
    ;print,junk
    for i=0,npts-1 do begin & readf,u,a,b,c,d & freq[i]=a & tmp[i,j,0]=b & tmp[i,j,1]=c & tmp[i,j,2]=d & endfor
    ;print, 'DOS# ',j+1, 'read'
    j=j+1
  ENDWHILE
Print, 'Could read ',j,' partials... over',fix(ndos),' to be read'  
  free_lun,u
end


pro lect_d99,file_in,s_tot,s_inc,n_uneq
;+
;** ********
;Routine aiming at listing the different types of atoms in the cell
;-
junk='' & a=0. & b=0. & c=0.
openr,u,file_in+'.d99',/get_lun
s_inc=fltarr(n_uneq) & s_tot=s_inc
j=0
; Loop until EOF is found:
;WHILE ~ EOF(u) DO BEGIN
WHILE (junk NE '#[.d36]') DO READF,u,junk
readf,u,junk & readf,u,junk
for i=0,n_uneq-1 do begin & readf,u,junk,a,b,c,format='(a15,3(f6.4,5X))' & s_tot[i]=c & s_inc[i]=b & endfor
readf,u,junk
if junk NE '#[.END]' THEN PRINT,'PROBLEM IN READING .d99 FILE'
free_lun,u
end

pro lect_d32,file_in,temp,msd
;+
;** ********
;Routine aiming at listing the different types of atoms in the cell
;-
  junk='' & np = 0. & npts=0. ;& a=0. & b=0. & c=0. & d=0.
  openr,u,file_in+'.d32',/get_lun
  readf,u,np,junk & readf,u,npts,junk
  msd=fltarr(npts,np) & temp=fltarr(npts) & tmp=fltarr(10,npts)
  j=0
  ; Loop until EOF is found:
for ip=0,np-1 do begin
;  WHILE ~ EOF(u) DO BEGIN
    if j ne 0 then readf,u,junk
    readf,u,junk & print,'Reading...'+junk
    ;print,junk
;    for i=0,npts-1 do begin & readf,u,a,b,c,d & freq[i]=a & tmp[i,j,0]=b & tmp[i,j,1]=c & tmp[i,j,2]=d & endfor
readf,u,tmp
msd[*,ip]=tmp[1,*]+tmp[5,*]+tmp[9,*]
    ;print, 'DOS# ',j+1, 'read'
    j=j+1
;  ENDWHILE
endfor
temp=tmp[0,*]
  Print, 'Could read ',j,' MSD... over',fix(np),' to be read'
  free_lun,u
end

;---------------------------------------------------------------------------
function calc_isf, file_in,q_min,dq,nq,TEMP=TEMP,MEV=MEV,GDOS=GDOS,PDOS=PDOS,AS=AS,MSD=MSD,IS_THETA=IS_THETA,MKL=MKL, compile=compile
;+
;******* ********
;pro read_part_pdos, file_in;, ndos, npts
;-
; External function
;d_livMasstoType   NumAt=d_livMasstoType( MassAt )

if keyword_set(compile) then return,1 ; Just to give the '.d*' Readers available to "build_q_w.pro"

forward_function d_livSymbtoType, d_livMasstoType, d_livTypetoMass, d_livTypetoSymb

conv_freq = 1.
if N_elements(TEMP) ne 1 then temp=300.
if N_elements(MEV) ne 0 then conv_freq=4.1357
E_i=81.8204/1.1^2
junk='' & i=0



IF n_elements(MKL) le 0 THEN BEGIN
Print,'Reading the .d08...'
lect_d08,file_in,natoms,str_types,mass,n_uneq
Print,'Reading the .d08: OK'
Print,'Reading the .d99...'
lect_d99,file_in,s_tot_uneq,s_inc_uneq,n_uneq
Print,'Reading the .d99: OK'
;Print,'Reading the .d18...'
;lect_d18,file_in,freq,tmp,j,ndos,npts
;Print,'Reading the .d18: OK'
Print,'Reading the .d34...'
lect_d34,file_in,freq,tmp,j,ndos,npts
Print,'Reading the .d34: OK'
ENDIF ELSE BEGIN
Print,'Reading the .mkl file...'
lect_mkl,file_in,freq,tmp,j,ndos,npts,mass,natoms,str_types,n_uneq,s_tot_uneq,s_inc_uneq
Print,'Reading the .mkl file: OK'
ENDELSE

Print,'Reformating...'
freq=freq/conv_freq ; frequencies should be in THz
;tmp=tmp[*,1:j-1] & npart=[j-1]/3 & if npart ne natoms then Print, 'PROBLEM IN NUMBER OF ATOMS...!!!'
npart=j/3 & if npart ne natoms then begin & Print, 'PROBLEM IN NUMBER OF ATOMS...!!! put npart equal to natoms' & npart=natoms & endif
str_types_uneq=str_types[UNIQ(str_types)] & n_uneq_test=n_elements(str_types_uneq) & if n_uneq ne n_uneq_test then PRINT, 'PROBLEM IN NUMBER OF NON EQUIVALENT ATOMS...!!!'
s_tot=fltarr(natoms) & s_inc=fltarr(natoms)
for i=0,n_uneq-1 do begin
junk=str_types_uneq[i] & good_i=where(str_types EQ junk) & s_tot[good_i]=s_tot_uneq[i] & s_inc[good_i]=s_inc_uneq[i]
endfor

Print,'NUMBER OF MODES                  =',ndos-1
Print,'NUMBER OF ATOMS IN THE UNIT CELL =',npart
Print,'NUMBER OF UNEQUIVALENT ATOMS     =',n_uneq
PRINT,'TYPES                            =',str_types
PRINT,'MASSES (AMU)                     =',mass
PRINT,'SCATERING CROSS SECTIONS         =',s_tot
PRINT,'INCOHERENT CROSS SECTIONS        =',s_inc



; Removing the negative frequencies - not renormalizing to unity...
bad_i=where(freq le 0.,complement=good_i)
;if bad_i[0] NE -1 then begin & tmp=tmp[good_i,*] & freq=freq[good_i] & npts=n_elements(good_i) & endif
if bad_i[0] NE -1 then tmp[bad_i,*,*]=0. ; Put negative modes DOS to zero... tmp(good_i,*) & freq=freq(good_i) & npts=n_elements(good_i) & endif


; Calculate the Bose population factor
bose=1./(1.-exp(-freq*47.993/temp))
if N_elements(AS) NE 0 then bose=bose-1.

; Calculate the partials dos for each atoms ( g_{d}(w) = \Sum_{alpha} g_{alpha,d}(w) )
tmpp=tmp
tst = size(tmp) & tst=tst[2]

if tst gt natoms then begin

tmp=fltarr(npts,npart)

  for j=0,npart-1 do begin
   tmp[*,j]=tmpp[*,j*3,0]+tmpp[*,j*3+1,1]+tmpp[*,j*3+2,2]
endfor
endif else begin
  for j=0,npart-1 do begin
  tmp[*,j]=tmpp[*,j,0]+tmpp[*,j,1]+tmpp[*,j,2]
endfor
endelse

; Verifying the normalisation of the partials:
;Fint=fltarr(3*npart)
;for i=0,3*npart-1 do Fint[i]=int_tabulated(freq,tmpp(*,i))
;PRINT,'Integral of partials dos a,d      =',Fint
;PRINT,'Integral of total dos             =',total(Fint)
Fint=fltarr(npart)
for i=0,npart-1 do Fint[i]=int_tabulated(freq,tmp[*,i])
PRINT,'Integral of partials dos d        =',Fint
PRINT,'Integral of total dos             =',total(Fint)
for i=0,npart-1 do tmp[*,i]=tmp[*,i]/Fint[i]/npart
for i=0,npart-1 do Fint[i]=int_tabulated(freq,tmp[*,i])
PRINT,'Integral of partials dos d        =',Fint
PRINT,'Integral of total dos             =',total(Fint)



; q_values for the S(Q,w)

q_val=findgen(nq)*dq+q_min

dW=fltarr(npart)
for ipart=0,npart-1 do begin
;for ipart=6,8 do begin
dW[ipart]=int_tabulated(freq,tmp[*,ipart]/freq/tanh(0.5*freq*47.993/temp))
;W[ipart]=int_tabulated(freq,tmpp[*,ipart]/freq/tanh(0.5*freq*47.993/temp))
dW[ipart]=0.5*npart*(1.0546/0.166)*dW[ipart]/(mass[ipart]*2*!pi)
;W[ipart]=0.5*(10.546/1.6605)*W[ipart]/mass[0]
endfor
PRINT,'<U^2> (A^2) at ',temp,' K        =',dW*3.

IF N_elements(GDOS) EQ 0 THEN BEGIN
 IF N_elements(PDOS) EQ 0 THEN BEGIN
  PRINT,'SQW is calculated'
  sqE=fltarr(npts,nq,npart)
  for ipart=0,npart-1 do begin
    for iq=0,nq-1 do begin
      sqE[*,iq,ipart]=(tmp[*,ipart]*q_val[iq]^2*s_inc[ipart]/mass[ipart])*exp(-q_val[iq]^2*dW[ipart])*bose/freq
    endfor
  endfor
  tit='Incoherent SF'
 ENDIF ELSE BEGIN
   PRINT,'PDOS is calculated'
   sqE=fltarr(npts,npart)
   for ipart=0,npart-1 do begin
       sqE[*,ipart]=tmp[*,ipart]
   endfor
   tit='Partial DOS (/meV)'
 ENDELSE
ENDIF ELSE BEGIN
PRINT,'GDOS is calculated'
sqE=fltarr(npts,nq,npart)
 if keyword_set(IS_THETA) THEN BEGIN
 freq=freq*4.1357 & ind=where(freq le E_i) &  freq=freq[ind] & sqE=sqE[ind,*,*] & tmp=tmp[ind,*]
 endif
for ipart=0,npart-1 do begin
 for iq=0,nq-1 do begin
  if keyword_set(IS_THETA) THEN BEGIN
  q_val=0.6947*sqrt(2*E_i-freq-2*sqrt(E_i*(E_i-freq))*cos((q_min+dq*iq)*!pi/180.))
  sqE[*,iq,ipart]=q_val[*]^2*(tmp[*,ipart]*s_tot[ipart]/mass[ipart])*exp(-q_val[*]^2*dW[ipart])
  ENDIF ELSE BEGIN
  sqE[*,iq,ipart]=(tmp[*,ipart]*s_tot[ipart]/mass[ipart])*exp(-q_val[iq]^2*dW[ipart])
  ENDELSE
;if ((ipart EQ 0) OR (ipart EQ 4)) THEN PRINT,q_val[iq],exp(-q_val[iq]^2*dW[ipart])
endfor
endfor
tit='Generalized DOS'
;sqE=total(sqE,2) & q_val=mean(q_val)
ENDELSE

if not keyword_set(IS_THETA) THEN freq=freq*4.1357 ; for frequency in meV
q_val=findgen(nq)*dq+q_min
IF N_elements(PDOS) EQ 0 THEN BEGIN
  sqE=sqE/8./!pi ; in unit per atom  (for absolute, multiply by N*r)
  ;generate structure for (q,w)
  datp={x:freq, y:q_val,z:mass, w_tit:tit, x_tit:'frequency [meV]', y_tit:'Q (A-1)', z_tit:'Mass (AMU)'}
ENDIF ELSE BEGIN
  ;generate structure for (q,w)
  datp={x:freq, y:mass,z:mass, w_tit:tit, x_tit:'frequency [meV]', y_tit:'Mass (AMU)', z_tit:'Mass (AMU)'} 
ENDELSE

IF (N_ELEMENTS(MSD) GT 0) THEN BEGIN
  lect_d32,file_in,temp,v_msd
  datp_msd={x:temp, y:mass, z:mass, w_tit:'Mean Square Displacement [A^2]', x_tit:'Temperature [K]', y_tit:'mass [AMU]'}
  GIVE_W,v_msd,W=MSD
  GIVE_DATP,datp_msd,W=MSD
ENDIF

give_datp, datp
Print,'END'

return, sqE

end