 function cont2xdat,natoms, nstructures
;+
;******** *********
;** User callable
;** The call is e.g. w1=cont2xdat(natoms, nstructures)
;**
;** files read automatically are CONTCAR.i
;** output will be an array of coords as when reading XDATCAR
;** and a trajectory file for nMoldyn
;** this function is paired with xdat2cont
;-

; initialise arrays and variables
header=strarr(7)    ; character variables for skipping lines
; coords
coords     = fltarr(nstructures, 3, natoms)
coords_tmp = fltarr(3, natoms)

for i=0,nstructures-1 do begin
  print,'structure ',i
  filename='CONTCAR.'+ string(i) & filename=strcompress(filename,/remove_all)
  openr,f_cont,filename,/get_lun
  readf,f_cont,header           ; header
  readf,f_cont,coords_tmp & coords[i,*,*]=coords_tmp
  free_lun, f_cont
endfor

openw,iunit,'traj.xyz',/get_lun
printf,iunit,'xdatcar-type dummy header - 6 lines'
printf,iunit,'xdatcar-type dummy header - 6 lines'
printf,iunit,'xdatcar-type dummy header - 6 lines'
printf,iunit,'xdatcar-type dummy header - 6 lines'
printf,iunit,'xdatcar-type dummy header - 6 lines'
printf,iunit,'xdatcar-type dummy header - 6 lines'
for i_str=0,nstructures-1 do begin
  coords_tmp=coords[i_str,*,*] & coords_tmp=reform(coords_tmp)
  tochange=where(coords_tmp[*] lt 0.) ; coords less than 0 for -ve shift
  if (tochange[0] ne -1) then coords_tmp[tochange] = coords_tmp[tochange] + 1.0
  for i_atm=0,natoms-1 do printf,iunit, coords_tmp[0,i_atm],' ', coords_tmp[1,i_atm],' ', coords_tmp[2,i_atm]
  printf,iunit,' '
endfor
free_lun, iunit

return, coords

end
