FUNCTION gdos_Q,w_in,Temp=temp,Emin=emin,Emax=emax,Inverse=inverse
;+
;** **** ******
;** User callable
;** S. Rols 11/01 srols@anl.gov
;** The call is w6=gdos(w_in,Temp=T)
;** Last modification 04.02.02 to include QENS_raw treatment
;** Adapted (6/3/8) by M Johnson
;** to calculate gDOS from S(Q,w) from VASP/nMoldyn
;-


COMMON c_lamp_access, inst
COMMON printing, iprint, outstring

take_datp, datp
par=datp.p
x_in=datp.x
y_in=datp.y/10.0 ; nm-1 to A-1
e_in=datp.e
; -------------------------------------------
; Donnees experimentales

Print,'GDOS ## S.R 2002 ##'
lambda=0.

IF (temp EQ 0.0) THEN temp=300.0
IF (n_elements(emax) EQ 0) THEN emax=MAX(x_in)
IF (n_elements(emin) EQ 0) THEN emin=MIN(x_in)
print, 'temp=',temp,'lambda=',lambda,'emin=',emin,'emax=',emax

points=where(x_in ge emin and x_in le emax)

w_buf=w_in & e_buf=e_in & y_out=y_in
;
;Calcul de Q^2
;************************
q2=w_in*0.0
x_in=FLOAT(x_in)
FOR itet=0,n_elements(y_in)-1 DO q2[*,itet]=y_in[itet]^2
;print,'q2=',q2
;
;Calcul de w/n(w) ou n(w) est le facteur de temperature dans le cas Stokes et anti Stokes
;****************************************************************************************
bosex=FLOAT(x_in)
bosex=bosex/(1-exp(-1.*bosex*11.6045/temp))
;
;Corrections
;******************************
indnul=WHERE(ABS(bosex) LE 1.e-12)
IF n_elements(indnul) GT 1 THEN BEGIN
w_buf[indnul,0:n_elements(y_in)-1]=0.
bosex[indnul]=1.
END
w_buf=w_in/q2
e_buf=e_buf/q2
FOR itet=0,n_elements(y_in)-1 DO BEGIN
w_buf[*,itet]=w_buf[*,itet]/bosex[*]
w_buf[*,itet]=w_buf[*,itet]*(x_in[*])^2
e_buf[*,itet]=e_buf[*,itet]/bosex[*]
e_buf[*,itet]=e_buf[*,itet]*(x_in[*])^2
ENDFOR
;
;output
x_out=x_in[points]
e_out=e_buf[points,*]
w_out=w_buf[points,*]
IF (n_elements(inverse) EQ 0) THEN GOTO, output
IF (inverse EQ 1) THEN BEGIN
x_out=reverse(ABS(x_out))
e_out=reverse(e_out)
w_out=reverse(w_out)
ENDIF
output:mod_datp, datp, "e", e_out
mod_datp, datp, "x", x_out
mod_datp, datp, "y", y_out
give_datp, datp
return, w_out
end
