function global_motion,w_in, atom_first, atom_last
;+
;******* *************
;** User callable
;** function to read a workspace from xdatcar in continuous fractional coords
;**
;** use the atoms between first and last to determine the coordinate translation for all atoms
;**
;** so that the average coordinate of the selected atoms is unchanged
;-



; frames and atoms

n_pars   = size(w_in)

n_frames = n_pars[1]                       & print, n_frames

n_atoms  = n_pars[3]                       & print, n_atoms



;determine average coordinate of selected atoms in first frame

one_frame=reform(w_in[0,*,*])

xyz_0=fltarr(3) & xyz=xyz_0

for j=0,2 do xyz_0[j]=total(one_frame[j,atom_first:atom_last],2)/(atom_last - atom_first + 1)

print, 'first frame done'

;loop over remaining

for i=1L,n_frames-1 do begin

  one_frame[*,*]=reform(w_in[i,*,*])

  for j=0,2 do         xyz[j]=total(one_frame[j,atom_first:atom_last],2)/(atom_last - atom_first + 1)

  for k=0,n_atoms-1 do one_frame[*,k]=one_frame[*,k]-xyz+xyz_0 ; translate atoms

  w_in[i,*,*]=one_frame[*,*]

endfor

w_out = w_in

return, w_out



print, 'finished!'



end
