function gr_stats,w_in
;+
;******* **********
;** User callable
;**
;** The call is e.g. w1=gr_stats(w2)
;**
;** w2 is a workspace produced by gr_coord (2D)
;** dimensions are max coord number and
;** n_atom_types^2+1
;** calculate average coordination number for each pair of atoms
;-

take_datp,datp
ncd_max=n_elements(datp.x) & print, ncd_max
n_pairs=n_elements(datp.y) & print, n_pairs
ave_coord=fltarr(n_pairs)
std_coord=fltarr(n_pairs)
w_out=fltarr(n_pairs,2)
print,size(w_in)

; calculate histogram average
for i=0,n_pairs-1 do begin
  print, i
  total_counts=total(w_in[*,i])
  n_total_counts=total(datp.x*w_in[*,i])
  ave_coord[i]=n_total_counts/total_counts > 0.
endfor
w_out[*,0]=ave_coord[*]

; calculate histogram standard deviation
for i=0,n_pairs-1 do begin
  print, i
  total_counts=total(w_in[*,i])
  n_total_counts=total((datp.x-ave_coord[i])^2*w_in[*,i])
  std_coord[i]=n_total_counts/total_counts > 0.
endfor
w_out[*,1]=sqrt(std_coord[*])


return,w_out

end
