pro nmoldyn3_preread, file_in, noShow=noShow
;+
;******* **********
;** User callable
;**
;** The call is e.g. nmoldyn3_preread,'filename'
;** MR.J.
;** This routine allows you to read a nMoldyn3 netCDF file
;** to see what is in it
;** to read the file use nMoldyn3_read, passing parameters to define
;** x, y and data parameters
;** MR.J. Modified 08/11/2011 to write a file 'nMoldynRead.txt' with summary of NCDF file contents
;** D. R.          18/06/2013 see 3D variables
;-

d_info=' '

id       = NCDF_OPEN(file_in)
file_inq = NCDF_INQUIRE(id)
dim      = file_inq.nvars
print ,'file contains ',dim,' data sets'

on_ioerror, MisMol
openw,f_out,'nMoldynRead.txt',/get_lun

for i=0,dim-1 do begin
  var2    = NCDF_VARINQ(id,i)
  strtest = STRMATCH(var2.name,'*total')
  if strtest eq 1 then print, i ,'   variable is a TOTAL'
  dsfid   = NCDF_VARID(id,var2.name)
  NCDF_VARGET,id,dsfid,data
  n_pars  = size(data)
  if n_pars[0] ge 1 then d_info = string(n_pars[1])
  if n_pars[0] ge 2 then d_info = d_info + ',' +string(n_pars[2])
  if n_pars[0] ge 3 then d_info = d_info + ',' +string(n_pars[3])
  print, i,        '   variable is '+var2.name+ '   n-dimensions is '+string(n_pars[0])+ $
         '   dimensions are '+ d_info
  printf, f_out, i,'   variable is '+var2.name+ '   n-dimensions is '+string(n_pars[0])+ $
         '   dimensions are '+ d_info
endfor

free_lun, f_out
NCDF_CLOSE,id
if not keyword_set(noShow) then xdisplayfile, 'nMoldynRead.txt'
MisMol:

end
