function nmoldyn3_read, file_in, xvar, yvar, dvar, zvar
;+
;******* **********
;** User callable
;**
;** The call is e.g. w1=nmoldyn3_read('filename',x,y,d)
;** MR.J.
;** following a pre-read of teh file to see what it contains
;** x,y,d define the variables to choose the dataset (d)
;** and its axes x and y
;** MR.J. Modified 08/11/2011 to read 1D data sets, yvar = -1 in this case
;** D. R.          18/06/2013 to read 3D data sets, zvar >= 0 in this case
;-

if n_elements(zvar) eq 0 then zvar = -1

x_data = 0 & y_data = 0 & z_data = 0
x_title='' & y_title='' & z_title=''

id = NCDF_OPEN(file_in)
file_inq = NCDF_INQUIRE(id)
dim = file_inq.nvars

for i=0,dim-1 do begin
  var = NCDF_VARINQ(id,i)
  dsfid = NCDF_VARID(id,var.name)
  NCDF_VARGET,id,dsfid,data
  if (i eq xvar) then begin
    x_data=data & x_title=var.name
  endif
  if (i eq yvar) then begin
    y_data=data & y_title=var.name
  endif
  if (i eq zvar) then begin
    z_data=data & z_title=var.name
  endif
  if (i eq dvar) then begin
    d_data=data & w_title=var.name
  endif
endfor

NCDF_CLOSE,id

datp={x:x_data, y:y_data, z:z_data, x_tit: x_title, y_tit: y_title, z_tit: z_title, w_tit: w_title}


give_datp, datp
return, d_data

end
