
pro sqw_f, file_out1, file_out2
;+
;** *****
;** call sqw_f,'junk.dat','sqw.dat'
;-

take_w, fsd, w=1
take_datp , datp, w=1
e_i=datp.x
qvalue=datp.y*10.
n=n_elements(e_i)
m=n_elements(qvalue)
fsd_conv=fltarr(n)
e_i=e_i/8.0655 ; e_i in meV


; -------find Q(nm-1)function of w TOSCA
q = CALL_FUNCTION('tosca', e_i) ; q in A^-1
q=q*10 ; q in nm^-1

;print, fsd(0,0),m,n,e_i(0),qvalue(0)

e_i=e_i*8.0655 ; e_i in cm^-1

; ----------------------------------------------------
;S(Q,w)=interpolation(Sw) over Q range
;S(Q,w)=[S(Q0,w)*Q]/[Q+Q0] + [S(Q2,w)*Q]/[Q+Q2]
; ----------------------------------------------------

openw,v1,file_out1,/get_lun
for i=0,n-1 do begin
 for j=1,m-2 do begin
  if (q[i] LE qvalue[j] and q[i] GE qvalue[j-1]) then begin
  fsd[i,j]=fsd[i,j-1]*q[i]/(q[i]+qvalue[j-1])+fsd[i,j+1]*q[i]/(q[i]+qvalue[j+1])
   if (fsd[i,j] GT 0) then begin
   printf,v1,e_i[i],q[i],qvalue[j],fsd[i,j]
   fsd[i]=fsd[i,j]
   endif
  endif
 endfor
endfor

; ------- print final data

for i=0,n-1 do begin
 if (fsd[i] GT 0) then begin
  ;printf,v1,e_i(i),fsd(i)
 endif
endfor
free_lun,v1


; -----------------------------------------------------
;convolute with normalised Gaussian resolution function
;of variable width, FWHM=w.sqrt(2ln2)
;y=(1/w.sqrt(pi/2))exp(-2(x-x0)^2/w^2)
;output spectrum in wavenumbers
; -----------------------------------------------------
;find energy step in order to limit resolution at low energy transfer
e_step=abs(e_i[1]-e_i[2])

;set cutoff energy below which resolution is constant
;cutoff is determined by 1.5 x e_step, Gaussian intensity is not unity
;sampling is not sufficient
cutoff=1.5 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
w_cutoff=cutoff*e_step

;now convolute, i_orig is centre of Gaussian
for i_orig=0,n-1 do begin
 ;define Gaussian, wd is width, pc is pcage of energy transfer, 1.17741 is sqrt(2ln2)
 ;0.79788 is pre-exp to give unit intensity
 pc=0.02 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 wd=e_i[i_orig]*pc/1.177410
  if (wd LT w_cutoff) then begin
  wd=w_cutoff
  endif
 ;select range for intrangeation
 intrange=3.0 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 grange=intrange*wd/e_step
 igrange=floor(grange)
;print, igrange
 imax=i_orig+igrange
 imin=i_orig-igrange
;print, grange,igrange,i_orig,imax,imin
  if (imin LT 1) then begin
  imin=1
  endif
  if (imax GT n-1) then begin
  imax=n-1
  endif

 sum=0
  for i_g=imin,imax do begin
  g=(0.79788/wd)*exp(-(2.0/(wd^2))*(e_i[i_g]-e_i[i_orig])^2)
  sum=sum+g*fsd[i_g]
  ;print, g
  endfor
fsd_conv[i_orig]=sum
endfor

openw,v2,file_out2,/get_lun
for i=0,n-1 do begin
 if (fsd_conv[i] GT 0) then begin
  printf,v2,e_i[i],fsd_conv[i]
 endif
endfor
free_lun,v2


datp.x=e_i
give_datp , datp, w=2
give_w, fsd_conv, w=2

end

FUNCTION tosca, e_i
;+
;******* *****
;** define TOSCA param; 2theta (scattering angle) =135deg,
;** e_f (final energy) 3meV, lambda_f
;-

pi=3.14159
two_theta=135.0*pi/180
e_f=3.0
lambda_f=sqrt(81.0/e_f)
k_f=2*pi/lambda_f
lambda_i=sqrt(81.0/e_i)
k_i=2*pi/lambda_i
q=sqrt(k_i^2+k_f^2-2.0*k_i*k_f*cos(two_theta))
return, q
end

pro sqw_tosca, file_out1, file_out2
;+
;** *********
;** User callable
;** call: sqw_tosca,'junk.dat','sqw.dat'
;-

    sqw_f,     file_out1, file_out2
end
