pro write_xdatcar5, w_in, file_out
;+
;** **************
;** User callable
;** from VASP MD frames stored in a workspace
;** write XDATCAR file, presumably it has been corrected!
;** extra line in header for VASP 5.0 format 21/7/2010 JDF
;-

; frames and atoms

n_pars   = size(w_in)

n_frames = n_pars[1]                       & print, n_frames

n_atoms  = n_pars[3]                       & print, n_atoms

take_datp, datp		; get data structure from workspace



; write xdatcar file

openw,iunit,file_out,/get_lun

printf,iunit, 'XDATCAR from LAMP'

printf,iunit, strsplit(datp.par_txt[11],'=',/extract)

printf,iunit, strsplit(datp.par_txt[12],'=',/extract)

printf,iunit, strsplit(datp.par_txt[13],'=',/extract)

printf,iunit, ' '

for i=0L,n_frames-1 do begin

  coords_tmp=reform(w_in[i,*,*])

  for i_atm=0,n_atoms-1 do printf,iunit, coords_tmp[0,i_atm],' ', coords_tmp[1,i_atm],' ', coords_tmp[2,i_atm]

  printf,iunit,' '

endfor

free_lun, iunit



print, 'finished!'



end

