;******* ************
function brisp_bose_eff, W_in , T=T,lam=lam
;******* **********
;** User callable
;** correction for detailed balance and/or efficiency(energy) (FF, Apr 2007)
;**
;**     Call:   w2=brisp_bose_eff(W1, ...)
;**     ****
;** Input:  M      =S(Q,w) after sqw_pix
;** new version with  x_in=Q and Y_in=E (FF, July 2010)


Wout=0
M=W_in
;*****************************CHECK FOR PARAMETERS******************************
s=size(M)   & s12= s[1]* s[2]

IF (s[0] lt 2) or (s[1] lt 2) or (s[2] lt 2) THEN RETURN, Wout
TAKE_DATP, datp                                    ;workspace variables

x_in=datp.x;  Energy
y_in=datp.y;  Q
e_in=datp.e;  errors

eM=e_in

kB=0.0861735; Boltzmann in meV/K
const4=81.8066	; E(meV)=const4/lambda(A)^2 for neutron

IF (N_ELEMENTS(T) GT 0) THEN BEGIN
T=FLOAT(T)
x=x_in/(kB*T)>(-70)

nw=fltarr(s[1]);	BOSE factor

FOR i=0,s[1]-1 DO BEGIN

IF (x[i] NE 0.) THEN nw[i]=x[i]/(1-exp(-x[i])) ELSE nw[i]=1.

M[i,*]=M[i,*]/nw[i]
eM[i,*]=eM[i,*]/nw[i]

ENDFOR
ENDIF


;
;idx  =where(abs(w_t) gt 5e-5)
;
;e_w_t=EXP(-w_t>(-70.))
;
;D_bal=w_t*0.+1.
;
;if idx[0] ge 0 then D_bal[idx]=w_t[idx]/(1.-e_w_t[idx])
;
;return,D_bal
;
;end



IF (N_ELEMENTS(lam) GT 0) THEN BEGIN
eps=x_in
Ei=const4/lam^2
Ef=Ei-eps
wave=sqrt(const4/Ef)
eff=(1-exp(-1.299*wave))/(1-exp(-1.299*lam))

	FOR ispec=0,s[2]-1 DO BEGIN
	M[*,ispec]=M[*,ispec]/eff
	eM[*,ispec]=eM[*,ispec]/eff
	ENDFOR
ENDIF
Wout=M
e_out=eM

;***** Return All *****

MOD_DATP ,datp,"E",e_out

GIVE_DATP,datp
return,Wout
end
