function brisp_dist, M, CENTER=xy0, PixSize=xypsize, pixel=pixel
;+
;******* **********
;**
;**	Input:	M      =2D or 3D data matrix.
;**	*****	xy0    =[x0,y0] center coordinates (default [n,m]-1 /2.)
;**		xypsize=size of the pixel in Cm default=[.428,1.27].
;**             /pixel  if set, return distance in pixel unit else in Cm (use of xypsize).
;**
;**
;**         ********************   Modification made on 11/03/09 ************************************
;**
;**
;**			The subdivision of the tube in a number of pixel lower than
;**			the default (256) case is taken into account with the parameter kp
;**			Mask ready only for the case 128 pixels!!!!b
;**			No regrouping of tubes allowed
;-


s   =size(M) & if (s[0] lt 2) or (s[1] lt 2) or (s[2] lt 2) THEN RETURN,0
unit=1.
kp=s[1]/256.; scaling between pixel actual size and reference (default=256) size
IF n_elements( xy0)     ne 2 then xy0    =([s[1],s[2]]-1.)/2.
IF n_elements( xyPsize) ne 2 then xyPsize=[.428/kp,1.27] ;[vertical,horizontal] default.
;print,xyPsize
IF n_elements( xyPsize) eq 2 then begin &  Unit=float(max(xyPsize,min=mu))
                                  if xyPsize[0] eq mu then ratioxy=[mu/Unit,1.] $
                                                      else ratioxy=[1.,mu/Unit] & endif
IF n_elements( ratioxy) ne 2 then ratioxy=[1.,1.]
IF keyword_set(pixel)        then unit   = 1.

xo=xy0[0] & yo=xy0[1]

x =findgen(s[1])
x =[[x],[x]]
y =transpose(findgen(s[2]))
x =(congrid(x,s[1],s[2])-xo)*ratioxy[0]
y =(congrid(y,s[1],s[2])-yo)*ratioxy[1]

return, sqrt(x^2+y^2)*unit

end
