;******* ************
function brisp_par, W_in , lambda=lambda, dst=Lsd, ch_w=ch_w, n_ch=n_ch
;+
;******* *********
;** User callable
;**      Macro used to set the wavelength and the sample-detector distance to
;**      the right values, since these values are not reliable
;**     Call:   w2=brisp_par(W1,lambda=wavelenght,dst=distance)
;**     ****
;** Input:  W_in      =2D or 3D data matrix.
;**     lambda  = incident wavelength: 0.99 for PG002, 1.98, for PG004
;**
;** Output: W_in
;**
;** 5/11/07: because of a bug in nomad, possibility to insert also channel width and channels number
;-


TAKE_DATP, datp;	workspace variables

datp.p[21]=lambda
datp.p[27]=Lsd
IF (N_ELEMENTS(ch_w) GT 0) THEN BEGIN
datp.p[18]=ch_w
ENDIF

IF (N_ELEMENTS(n_ch) GT 0) THEN BEGIN
datp.p[2]=n_ch
ENDIF

GIVE_DATP,datp
return,W_in
end
