;******* ************
function eff_corr, M , eff_dat=filein
;+
;******* ********
;** User callable
;** efficiency correction for 2D or 3D brisp data
;**      (to be used just to view the effect of efficiency on data)
;**
;**     Call:   w2=brisp_radial(W1, filein='eff.dat")
;**     ****
;** Input:  M      =2D or 3D data matrix.
;**
;**        filein  = file with efficiency values (size =3 X 160, eff the 2nd column)
;**
;** Output: Wout   = corrected data
;-

Wout=0
;*****************************CHECK FOR PARAMETERS******************************
s=size(M)   & s12= s[1]* s[2]

IF (s[0] lt 2) or (s[1] lt 2) or (s[2] lt 2) THEN RETURN, Wout
TAKE_DATP, datp                                    ;workspace variables

Mbuf=M
;***** Efficiency *****

IF (N_ELEMENTS(filein) GT 0) THEN BEGIN
ON_IOERROR, giveup

OPENR, u, filein, /GET_LUN
ON_IOERROR, readup

eff=fltarr(3,s[2])
READF, u, eff;	efficiency data are in the 2nd column

	IF (s[0] EQ 2) THEN BEGIN
			FOR j=0,s[2]-1 DO BEGIN
			IF (eff[1,j] NE 0) THEN Mbuf[*,j]=Mbuf[*,j]/eff[1,j] ELSE Mbuf[*,j]=Mbuf[*,j]
			ENDFOR
	ENDIF

	IF (s[0] EQ 3) THEN BEGIN
			FOR j=0,s[2]-1 DO BEGIN
			IF (eff[1,j] NE 0) THEN Mbuf[*,j,*]=Mbuf[*,j,*]/eff[1,j] ELSE Mbuf[*,j,*]=Mbuf[*,j,*]
			ENDFOR
	ENDIF

readup:FREE_LUN, u
giveup:
ENDIF

Wout=Mbuf

GIVE_DATP,datp
return,Wout
end
