;******* ************
function mask_make, M ,  excluded=Regions , Stubes=Stub
;+
;******* *********
;** User callable
;** INPUT:  M is a 2D or 3D count from an attenuated direct beam.
;**         Regions is a (4,n) matrix uses to exclude regions [[x1,y1,nx1,ny1],[x2,y2,nx2,ny2]...]
;**         /stubes if set then mask short tubes also (BRISP ONLY)
;**
;** OUTPUT: Wout=2D mask: 1 for masked pixels, 0 elsewhere
;-


;  ***************************CHECK FOR PARAMETERS******************************
Wout=0

take_datp, datp

s=size(M)   & s12= s[1]* s[2]
IF (s[0] lt 2) or (s[1] lt 2) or (s[2] lt 2) THEN RETURN, Win
IF (s[0] eq 3) then Masq=total(M,3)*0. else Masq=M*0.

s1=s[1]-1 & s2=s[2]-1 & b=15<(s2/2) & a=58<(s1/2)


    ;excluded tubes (regions)
    ;************************
    if n_elements(Regions) ge 4 then for i=0,n_elements(Regions)/4-1 do begin
       regx=[Regions[0,i],Regions[0,i]+Regions[2,i]-1]>0<s1
       regy=[Regions[1,i],Regions[1,i]+Regions[3,i]-1]>0<s2
       Masq[regx[0]:regx[1],regy[0]:regy[1]]=1
    endfor
    ;short tubes
    ;***********
    if keyword_set(Stub) then begin
       Masq[0:a,0:b]=1 & Masq[s1-a:s1,0:b]=1 & Masq[0:a,s2-b:s2]=1 & Masq[s1-a:s1,s2-b:s2]=1
    endif

Wout=Masq

return, Wout
end

