function rd_miland, fifi
;+
;******* *********
;** User callable
;** reads an Event file from Miland detector
;-

maxevt=1000000            ;treat by blocks of maxevt (to avoid memory pb)
wout  =0
on_ioerror,mismil & u=-1

openr,u,fifi,/get_lun     ;open fifi
stat  =fstat(u)           ;get the size
events=long(stat.size/4)  ;""
print,events,' events to treat' & wait,.1

if events gt 0 then begin
   L='00000FFF'XUL & M='0000F000'XUL & H='FFFF0000'XUL
   wout =ulonarr(320,320)
   nloop=events/maxevt & rest =events-(nloop*maxevt)
   if nloop gt 0 then tempf=ulonarr(maxevt)
   if rest  gt 0 then templ=ulonarr(rest)
   for i=0,nloop do begin                          ;loop by blocks in fifi
       if (i eq nloop) and (rest gt 0) then begin
           treated=maxevt*i+rest
           readu,u,templ                           ;read last block
           byteorder,templ,/swap_if_big_endian
	         V=(templ and M) & X=(templ and H) & Y=(templ and L) ;split
       endif else begin
           treated=maxevt*i+maxevt
           readu,u,tempf                           ;read full blocks
           byteorder,tempf,/swap_if_big_endian
	         V=(tempf and M) & X=(tempf and H) & Y=(tempf and L) ;split
       endelse
       X=X/2.^16
       idx=where(V/2.^12 eq 3)                     ;loop on valid data
       for j=0L,n_elements(idx)-1 do begin         ;""
           n=idx[j]
	         wout[X[n],Y[n]]=wout[X[n],Y[n]]+1
       endfor
       print,treated,' treated' & wait,.1
   endfor
endif
free_lun,u
return,wout

mismil: if u gt 0 then free_lun,u & lamp_error
return,0
end
