  FUNCTION scale_d16, win, factors=factors
  ;+
  ;******* ***********
  ;**
  ;** User callable
  ;** The call is w6=merge_d16(w1)
  ;**
  ;** win is a 2D diffractogram from D16 as returned by the straight_d16 routine,
  ;** i.e. I(2-theta, scan)
  ;-

  ;get variables associated with win
  take_datp, datp

  s = size(win)
  size_x = s[1]
  if s[0] eq 1 then nscans = 1 else nscans = s[2]

  ;if multiplication factors not given, determine them 
  if n_elements(factors) eq 0 then begin
    factors = [1.0]
    for i = 0, nscans-2 do begin
      lowlim = datp.x[0,i+1]
      uplim  = datp.x[-1,i]
      tmp1 = where(datp.x[*,i] ge lowlim and datp.x[*,i] le uplim)
      tmp2 = where(datp.x[*,i+1] ge lowlim and datp.x[*,i+1] le uplim)
      ;ratio = mean(win[tmp1,i]) / mean(win[tmp2,i+1])
      ratio = median(win[tmp1,i]) / median(win[tmp2,i+1])
      factors = [factors, ratio]
    endfor 
  endif
  
  ;scale scans
  wout = win
  for i = 0, nscans-1 do begin
    wout[*,i]   *= product(factors[0:i])  
    datp.e[*,i] *= product(factors[0:i])
    ;print, 'scan i = ', i, ' x ', product(factors[0:i])
  endfor
  
  give_datp, datp
  return, wout
  end 