;+
; pro d17_errmsg,flag,txt
; LAMP procedure to handle error messages from the D17 LAMP library
;   Will write the message to the screen, to the LAMP log,
;   and to a special D17 error window
; Necessary input:
;   flag = 0 for not printing to the D17 error window
;        = 1 will print to D17 error window and IDL interface window
;        = 2 will only print to D17 error window
;   txt = string to be printed
; ARW 22.4.10
;
; Subroutines:
; d17_errmsg_event: Window event handler
; 
; Calls to:
; Last modified:
;-

;+
; ********************************
; *** d17_errmsg event handler ***
; ********************************
;-
pro d17_errmsg_event,event

  common d17emsgbase,d17emsgall   ; All widget addresses stored here

  widget_control,event.id,get_uvalue=gv
  if (gv eq 'hide') then widget_control,d17emsgall[0],MAP=0

end

;+
; ************************
; *** d17_errmsg widget ***
; *************************
;-
pro d17_errmsg,flag,txt

  common d17emsgbase,d17emsgall   ; All widget addresses stored here

; *** Determine whether the error message window is running and create it if it isn't
  if xregistered('d17_errmsg') eq 0 then begin
    ebase=widget_base(uname='d17errmsg_base',$
        title='D17 LAMP messages',$
        /COLUMN)
    etxt=widget_text(ebase,$
        uname='d17_errmsg_txt',$
        /SCROLL,$
        XSIZE=60,YSIZE=20)
    ebut=widget_button(ebase,$
        uname='d7errmsg_quit',$
        value='OK',$
        uvalue='hide')
    d17emsgall=[ebase,etxt,ebut]

    widget_control,ebase,/realize,map=0
    xmanager,'d17_errmsg',ebase,event_handler='d17_errmsg_event'

  endif
  if flag ne 0 then begin
    widget_control,d17emsgall[0],map=1
    widget_control,d17emsgall[1],set_value=txt,/append
  endif

  if flag ne 2 then print,txt
; show,txt
end
