FUNCTION acc_d2b, win, numor, n
;+
;******* *******
;**
;** User callable
;** The call is e.g. w2 = acc_d2b( w1, 51577, 5)
;**
;** w1 is the workspace containing 51577, the first scan, 5 is the number of scans
;-

;read the first numor and get array dimensions
;datp=1
;win=rdrun(numor,DATP=datp,w=wi)
take_datp,datp
print, n_elements(datp)
npts=(size(win))[1] & print, 'npoints   ',npts
nh  =(size(win))[2] & print, 'nh        ',nh
nt=128             ;number of detector tubes
nsteps=npts/nt     ;number of scan steps e.g.25, n is number of different scans
ang_min=datp.x[0] & print, ang_min

;make array to store all calibration workspaces and enter the first one, just read
w_all=fltarr(n,npts,nh)
w_all[0,*,*]=win
print, 'reading data'
for i=1,n-1 do begin
  newnumor=numor+i
  win=rdrun(newnumor)
  w_all[i,*,*]=win
endfor

;define arrays for storing summed/total counts
n_totpts=npts+(n-1)*nsteps & print, n_totpts
w_tot=fltarr(n_totpts,nh)
i_tot=intarr(n_totpts,nh)

;sum patterns
	w_tot[*,*]=0.0 & i_tot[*,*]=0
	print, 'accumulating scans'
	for i=0,n-1 do begin
	  for j=0,nt-1 do begin
	    alllowlim=nsteps*j     & allhilim=alllowlim+nsteps-1
	    totlowlim=nsteps*(i+j) & tothilim=totlowlim+nsteps-1
	    i_tot[totlowlim:tothilim,*]=i_tot[totlowlim:tothilim,*]+1
	    w_tot[totlowlim:tothilim,*]=w_tot[totlowlim:tothilim,*]+w_all[i,alllowlim:allhilim,*]
	  endfor
	endfor
	;calculate the average
	print, 'average of scans'
	w_tot[*,*]=w_tot[*,*]/i_tot[*,*]
	;calculate angles
	n_ang=(size(w_tot))[1] & print, n_ang
    x_ang=fltarr(n_ang) & for i=0,n_ang-1 do x_ang[i]=i*0.05+ang_min ;& print, x_ang

mod_datp,datp,'x',x_ang & print, datp.x[0],' & ',datp.x[n_ang-1]
mod_datp,datp,'e',sqrt(w_tot[*,*]/n)

give_datp,datp
return, w_tot

end
