FUNCTION acc_mrj, numor, n
;+
;******* *******
;**
;** User callable
;** The call is e.g. w2 = acc_mrj(51577,5)
;**
;** 51577 is the first scan, 5 is the number of scans
;** general addition of workspaces - method
;** read-in all numors
;** make-up multiD arrays of data and angles, arrays read-in will all be same size
;-

;read the first numor and get array dimensions
datp=1
win=rdrun(numor,DATP=datp)
take_datp,datp
print, n_elements(datp)
npts=(size(win))[1] & print, 'npoints   ',npts
nh  =(size(win))[2] & print, 'nh        ',nh
nt=128             ;number of detector tubes
nsteps=npts/nt     ;number of scan steps e.g.25, n is number of different scans

;make array to store all calibration workspaces and enter the first one, just read
w_all=fltarr(n,npts,nh) & w_all[0,*,*]=win
w_ang=intarr(n,npts)    & w_ang[0,*]=round(datp.x*100) ;& print, datp.x(2600:2700)
print, 'reading data'
for i=1,n-1 do begin
  newnumor=numor+i
  win=rdrun(newnumor,DATP=datp)
  w_all[i,*,*]=win & w_ang[i,*]=round(datp.x*100)
endfor

;define arrays for storing summed/total counts
;find min and max angles and angular step ... work with angles*100 as integers
ang_min=round(min(w_ang)) & ang_max=round(max(w_ang)) & print,'limiting angles ',ang_min,ang_max
ang_step=round(abs(w_ang[0,0]-w_ang[0,1])) & print, 'ang step ',ang_step
n_totpts=round((ang_max-ang_min)/ang_step+1) & print, n_totpts
w_tot=fltarr(n_totpts,nh) & w_tot[*,*]=0.0
i_tot=intarr(n_totpts,nh) & i_tot[*,*]=0
x_ang=intarr(n_totpts) & for i=0,n_totpts-1 do x_ang[i]=i*ang_step+ang_min

;sum patterns
;find where a scan matches angles in total
	print, 'accumulating scans'

	for i=0,n-1 do begin ; loop thro scans
	  acount=0
	  for j=0,npts-1 do begin ;loop thro w_ang
	    for k=0,n_totpts-1 do begin ; look for matching angle in x_ang
	      if x_ang[k] eq w_ang[i,j] then begin
	        acount=acount+1
            w_tot[k,*]=w_tot[k,*]+w_all[i,j,*]
            i_tot[k,*]=i_tot[k,*]+1
          endif
        endfor
      endfor
      print,'no. of angles matched ',i, acount
    endfor

	;calculate the average
	print, 'average of scans'
	w_tot[*,*]=w_tot[*,*]/i_tot[*,*]
	;calculate angles
	x_ang=x_ang/100.0

mod_datp,datp,'x',x_ang
mod_datp,datp,'e',sqrt(w_tot[*,*]/n)

give_datp,datp
return, w_tot

end
