pro d19_2_f1b, W_in ,file=fifi ,datp=datp, Xmargin=ttar ,Ymargin=nur
;+
;** *********
;**
;** User callable
;** Export F1B format data
;** Xmargin=[left ,right] number of pixels to ignore (gamma)
;** Ymargin=[lower,upper] number of pixels to ignore (nu)
;-

;Check for inputs
 if n_elements(W_in)   le 1 then return
 if n_elements(datp)   eq 0 then take_datp,datp
 if n_elements(nur)    ne 2 then nur =[0,0]
 if n_elements(ttar)   ne 2 then ttar=[0,0]
 if n_elements(fifi)   ne 1 then fifi='d19'
 sx =(size(W_in))[1] & Eok=1
 Win=W_in[ttar[0]:sx-ttar[1]-1,*,*]
 X  =datp.X[ttar[0]:sx-ttar[1]-1]
 if n_elements(datp.e) ne n_elements(W_in) then Eok=0 else E=datp.e[ttar[0]:sx-ttar[1]-1,*,*]
 siz=size(Win) & sx=siz[1] & sy=1 & sz=1
 if siz[0] gt 1 then sy=siz[2] & if siz[0] gt 2 then sz=siz[3]

 manip=datp.p[27] & mv=(size(datp.pv))[1] -1
 if manip ne 2 then omg=fltarr(sz)+datp.p[2] else omg=reform(datp.pv[4<mv,*])/1000.
;if manip ne 3 then chi=fltarr(nz)+datp.p(1) else chi=reform(datp.pv(5<mv,*))/1000.
 if manip ne 4 then phi=fltarr(sz)+datp.p[0] else phi=reform(datp.pv[6<mv,*])/1000.

;Prepare output
 vol=fltarr(5)
 if (size(datp.Y))[0] eq 1 then m=0 else m=sz-1
 sets=1 & nset=1
 tr1   = 0.
 numor = 0L & reads,datp.PAR_TXT[29],numor ;numor
 xla   = datp.P[4]                         ;wavel
 tstep =(X[sx-1]-X[0])/(sx-1)              ;2thetha step
 tset  = datp.P[6]                         ;temp set
 tcons = datp.P[5]                         ;temp consign
 tsamp = datp.P[7]                         ;temp sample
 vana1 = 46288                             ;vana numors !!!
 vana2 = 46299
 times =stime(dum) & times=strmid(times,0,7)+strmid(times,9,11)
 titlog=datp.time+' 12:12:12'+datp.w_tit
 numlog='     NUMOR : '+string(numor,format='(I6)')
 vollog='     VOL('
 dirlog='          DIRECTORY OF FILE : '+fifi+'.F1B'+'   (CREATED:'
 vanlog='     CALIBRATION WITH NUMORS : '+string(vana1,format='(I6)')+' TO '+string(vana2,format='(I6)')
 fm1log="(1X,I3,'*',1X,'DATE, USERS NAME, TITLE OF DATA SET : ')"
 fm2log="(5X,'MONITOR :',F13.0,5X,'TIME :',2X,F9.2,2X,'SEC.')"
 fm3log="(5X,'2-THETA =',F8.3,3X,'OMEGA =',F8.3,3X,'CHI =',F8.3,3X,'PHI =',F8.3,3X,'TR1 =',F8.3,3X,'LAMBDA =',F8.3)"
 fm4log="(5X,'Step =',F5.3,4X,'Temp. SET =',F8.3,4X,'Temp. REG =',F8.3,4X,'Temp. SAMP =',F8.3)"


;Write .F1B & .LOG
 on_ioerror,miswrt & u=-1 & v=-1
 openw,u,fifi+'.F1B',/get_lun
 openw,v,fifi+'.LOG',/get_lun

 printf,u,sets,format='(I5)'

 printf,v,dirlog ;***LOG FILE***

 for z=0,sz-1 do begin
   tim  =datp.pv[0<mv,z]  ;duration
   xmon =datp.pv[1<mv,z]  ;monitor

   for y=nur[0],sy-1-nur[1] do begin

     Wout =Win[*,y,z]    & idx =where(Wout gt 0) & nidx=n_elements(idx)         ;Counts
     if nidx eq 1 then idx=[0,sx-1] else idx=[idx[0],idx[nidx-1]]
     Wout=round(Wout[idx[0]:idx[1]]) & nx  =n_elements(Wout)

     if Eok then ncnt=round(Wout/(E[idx[0]:idx[1],y,z]^2))>1 else ncnt=Wout*0+1 ;nb mesures

     omega =round(omg[z]        *1000.)/1000.  ;omega
     achi  =round(datp.Y[y,z<m] *1000.)/1000.  ;chi
     aphi  =round(phi[z]        *1000.)/1000.  ;phi
     dtheta=round(X[idx[0]]     *1000.)/1000.  ;gamma

     printf,u,titlog
     printf,u,nset,numor,format='(I3,1X,I6)'
     printf,u,xmon,tim,dtheta,omega,achi,aphi,tr1,xla,tstep,tset,tcons,tsamp, format='(F13.0,F9.0,1X,10(F8.3,1X))'
     printf,u,nx,vana1,vana2, format='(I4,1X,"0.000E+00 0.000E+00 0.000E+00 0.000E+00 0.000E+00 ","CALIBRATED WITH VANA NUMORS:",I6," To",I6)'

     ki=long(nx/10) & kr=nx-10*ki & ks=strtrim(string(kr),2)
     for i=0,ki-1 do begin & j=i*10
         printf,u,ncnt[j+0],Wout[j+0],ncnt[j+1],Wout[j+1],ncnt[j+2],Wout[j+2],ncnt[j+3],Wout[j+3],ncnt[j+4],Wout[j+4],$
	     ncnt[j+5],Wout[j+5],ncnt[j+6],Wout[j+6],ncnt[j+7],Wout[j+7],ncnt[j+8],Wout[j+8],ncnt[j+9],Wout[j+9],$
         format='(10(I2,I8))'     & endfor
     if kr gt 0 then begin
         tmpv=lonarr(kr*2) & tmx1=indgen(kr)*2 & tmx2=tmx1+1
	     tmpv[tmx1]=ncnt[ki*10:*] & tmpv[tmx2]=Wout[ki*10:*]
	     printf,u,tmpv,format='('+ks+'(I2,I8))' & endif

     printf,u,'     -1000'

     printf,v,vanlog & printf,v,'' & printf,v,nset,format=fm1log & printf,v,'    '+titlog ;***LOG FILE***
     printf,v,numlog & printf,v,xmon,tim,format=fm2log                                    ;***LOG FILE***
     printf,v,dtheta,omega,achi,aphi,tr1,xla,format=fm3log                                ;***LOG FILE***
     printf,v,tstep,tset,tcons,tsamp,format=fm4log & printf,v,vollog                      ;***LOG FILE***

     nset=nset+1
   endfor
 endfor
 printf,u,'    -10000'
 free_lun,u & u=-1
 free_lun,v & v=-1
 return
miswrt: if u gt 0 then free_lun,u & print,!error_state.msg
        if v gt 0 then free_lun,v
end
