pro d19_ratios, ratio,lowBord,uppBord ,seq
;+
;** **********
;** ratio correction 2005 and before
;-

;if seq eq 1 then $
par=[[0.0	,0.0	,0.0   ],$
     [1.0144	,8.7327	,249.53],$
     [.99309	,4.0235	,248.14],$
     [.89698	,4.0154	,250.50],$
     [.97024	,8.4272	,249.12],$
     [.97173	,3.9265	,250.11],$
     [.99152	,7.9865	,250.38],$
     [1.0251	,1.1245	,247.47],$
     [1.0678	,7.9235	,250.01],$
     [1.0038	,6.4523	,248.60],$
     [1.0572	,5.1278	,250.10],$
     [.93970	,4.8354	,252.25],$
     [.98241	,2.1065	,251.23],$
     [.96106	,3.2078	,250.21],$
     [1.0572	,2.8352	,252.56],$
     [1.0144	,6.5354	,252.62],$
     [1.0144	,3.8195	,252.77],$
     [1.0785	,3.8254	,246.74],$
     [0.0	,0.0	,0.0   ],$
     [0.0	,0.0	,0.0   ]]

ratio  =reverse(reform(par[0,*]))
lowBord=reverse(reform(par[1,*]))
uppBord=reverse(reform(par[2,*]))
end

function d19_cor, Win ,pathcal ,errors=Eout ,date=an
;+
;******* *******
;**
;** Correct D19 frames from electronic defaults.
;-

common cor2_d19, cor_Yd,cor_Yf,cor_Yg,cor_Ya,cor_Yb ,cor_Xd

forward_function finefile

lamp_loop_so, SFdll ;We may have loops in C code

nmat=8 & Yok=1 ;set nmat=0 for no X correction , Yok=0 for no Y correction

siz=SIZE(Win) & sx=640L & sy=256L & nWires=32 & Eok=0
if (siz[0] eq 3  ) then  sz=siz[3] else sz=1L        ;Check for correct input
if (siz[1] ne sx ) or (siz[2] ne sy) then return,Win
if arg_present(Eout) then Eok=1
if (an lt '06') or (an gt '70') then seq=1 else seq=0

;(2006) and after
if seq eq  0   then begin ;Y correction
 if n_elements(cor_Yd) le 1 then begin & on_ioerror,misYdet & ok=0
    fifiY='d19_Ydet.cor.gz.20'+an
    fifi = finefile(pathcal+fifiY ,count=fifiN)
    if fifiN eq 0 then fifiY='d19_Ydet.cor.gz'
    openr,u,pathcal+fifiY,/get_lun,/compress
    print, ' Reading '+fifiY+' correction file ...' & wait ,.01
    cor_Yd=fltarr(sy,sx)
    readf,u,cor_Yd & free_lun,u
    cor_Yd=transpose(temporary(cor_Yd))-1.
    cor_Yd=reverse(cor_Yd,1,/overwrite)
    ok=1
    misYdet: if (not ok) then begin & print,!error_state.msg & return,Win & endif
 endif

 if not Yok then wout=win else begin
  tim1=systime(1)
  print,' Vertical electronic corrections started ...',format='(A,$)' & wait ,.01
  wout = win*0.
  win /= 100.
  reb  = long(100. *sy)
  
  if SFdll gt ' '  then begin ;Try the C code if there.
    bid = CALL_EXTERNAL(SFdll, 'D19_Ycor',$
      sx, sy, sz, sx, sy, cor_Yd, sx, sy, sz, Win, $
      reb, sx, sy, sz, Wout, $
      VALUE=[1, 1, 1, 1, 1, 0, 1, 1, 1, 0, 1, 1, 1, 1, 0 ], /I_VALUE, /CDECL)
    if (bid ne 1) then begin & lamp_loop_so,/reset & SFdll='' & endif
  endif
  
  if SFdll le ' ' then begin ;Use IDL code
  for j=0,sx-1 do begin
     zd   = cor_Yd[j,*]
     wini = rebin(reform(Win[j,*,*]),reb,sz,/sample)
     for y=1,sy-1 do Wout[j,y,*]=total(wini[zd[y-1]+1 : zd[y] , *] ,1)
  endfor    ;j gamma
  wini=0
  endif
  
  tim2=systime(1) & print,strtrim(round(tim2-tim1),2)+' sec'
 endelse
 
 if nmat gt 0 then begin ;X correction
 if n_elements(cor_Xd) le 1 then begin & on_ioerror,misXdet & ok=0
    fifiX='d19_Xdet.cor.gz.20'+an
    fifi = finefile(pathcal+fifiX ,count=fifiN)
    if fifiN eq 0 then fifiX='d19_Xdet.cor.gz'
    openr,u,pathcal+fifiX,/get_lun,/compress
    print, ' Reading '+fifiX+' correction file ...' & wait ,.01
    cor_Xd=fltarr(sx,sx,nmat)
    readf,u,cor_Xd & free_lun,u
    for i=0,nmat-1 do cor_Xd[0,0,i]=transpose(reverse(cor_Xd[*,*,i],1,/overwrite))/10000.
    ok=1
    misXdet: if (not ok) then begin & print,!error_state.msg & return,temporary(Wout) & endif
 endif
 print,' Horizontal electronic corrections started ...',format='(A,$)' & wait ,.01
 nb  = sy/nmat
 Lnb = lindgen(nb)
 for m=0,nmat-1 do begin
       mat = cor_Xd[*,*,m]
       L   = Lnb + nb*m
       for z=0,sz-1 do begin
           Wout[*,L,z]=reverse(mat#Wout[*,L,z])
       endfor
 endfor
 print,strtrim(round(systime(1)-tim2),2)+' sec'
 endif
 if Eok then Eout=sqrt(Wout>1.)
 return,temporary(Wout)>0.

endif else begin
;(2005) and before
 d19_ratios, ratio,lowBord,uppBord ,seq                       ;Get correctors
 Wout =Win*0.           & idx=where(ratio gt 0)                         ; > 0
 if Eok then Eout=Wout
 
 b  =findgen(n_elements(ratio))*nwires  & e=b+nwires-1      ;horizontal steps
 z1 =sy-findgen(sy)-1.  & z2 =z1/(sy-1.)              ;Relative peack voltage
 z2i=1./(z2+1e-20) -1.  & compF=(uppBord-lowBord)

 for nmod=idx[0],idx[n_elements(idx)-1] do begin
     z3=1./(ratio[nmod]*z2i +1.) ;nonlinearity corr. due to nonzero gainRatio
     z5=(z3+lowBord[nmod]/(sy-1.))*compF[nmod]   ;Border corr. due to offsets
    
     s = VALUE_LOCATE(z1, z5) > 0L < (sy-2)              ;Subscript intervals
     z6= z5-z1[s] & z7=z1[s+1]- z1[s] & z8=z6/z7                 ;to interpol
     for nspec=0,sz-1 do for j=b[nmod],e[nmod] do begin       ;For all frames
         v=Win[j,*,nspec]
	     Wout[ j,*,nspec]=z8*(v[s+1]-v[s]) + v[s]                ;Interpolate
        ;Wout (j,*,nspec)=interpol(Win(j,*,nspec),z1,z5)         ;Interpolate
         if Eok then $
         Eout[ j,*,nspec]=z8*(sqrt(v[s+1]+v[s]))+sqrt(v[s])  ;Increase errors
     endfor
 endfor
 if Eok then Eout=Eout>1.
 return,temporary(Wout)>0.
endelse
end
