function d19_nu_bin,W_in, dNu=dNu, Ymargin=Ymargin, Distance=DST
;+
;******* ***********
;**
;** User callable
;** return data rebined to Nu angles
;** dNu is the Nu angle bin width (5 is default)
;** Ymargin is a scalar which means the number of exclusions on top and bottom (0 is default)
;** Distance sample-> detector in Cm (74.3 is default)
;-

siz=size(W_in) & if siz[0] lt 3 then nz=1 else nz=siz[siz[0]]
TAKE_DATP,datp & Y=datp.Y & EE=datp.e      ;Get variables from W_in
if n_elements(EE) eq n_elements(W_in) then Eok=1 else Eok=0
manip=datp.p[27]   & m=(size(datp.pv))[1] -1
if manip ne 3 then chi=fltarr(nz)+datp.p[1] else chi=reform(datp.pv[5<m,*])/1000.
if manip ne 4 then phi=fltarr(nz)+datp.p[0] else phi=reform(datp.pv[6<m,*])/1000.

if  n_elements(DST)     eq 0 then DST=76.3 ;in Cm, sample-> detector for D19 (gap=1.56 mm)
if  n_elements(Ymargin) eq 1 then win=w_in[*,Ymargin:siz[2]-Ymargin-1,*] else Win=W_in
if  n_elements(Ymargin) eq 1 then Y  =Y[     Ymargin:siz[2]-Ymargin-1  ]
if  n_elements(Ymargin) eq 1 then if Eok then EE=EE[*,Ymargin:siz[2]-Ymargin-1,*]
siz=size( Win)
if  n_elements(dNu)     ne 1 then dNu=5.      ; Default to 5 degres
Y  =atan(Y/DST)*180./!pi            ; Tranform Y Height in Y angles
dN2=dNu/2.
idx=where((Y ge -dN2) and (Y le dN2))       ; Begin with the middle
yrg=[idx[0],idx[n_elements(idx)-1]]            ; calculate Y ranges
i=0
while idx[0] ge 0 do begin                         ;Continue  upper
      idx=where((Y gt dN2+dNu*i) and (Y le dN2+dNu*(i+1)))
      if idx[0] ge 0 then yrg=[yrg,idx[0],idx[n_elements(idx)-1]]
      i=i+1 & endwhile
i=0 & idx=0
while idx[0] ge 0 do begin                         ;Continue  lower
      idx=where((Y lt -dN2-dNu*i) and (Y ge -dN2-dNu*(i+1)))
      if idx[0] ge 0 then yrg=[idx[0],idx[n_elements(idx)-1],yrg]
      i=i+1 & endwhile

n   =n_elements(yrg)/2   ;We have the number of resulting Nu angles
Wout=fltarr(siz[1],n,nz)
Yout=fltarr(n,nz)
if Eok then Eout=Wout
;Where Win<0 we have no data so care while rebinning.
yrg_kp=yrg
idx=where(win[*,0,0] ge 0.) & idx0=idx[0] & idxn=idx[n_elements(idx)-1]
; --first the easy bit in the middle
   for j=0,nz-1 do begin
    for i=0,n-1  do begin & i2=i*2  &   nv =yrg[i2+1]-yrg[i2]+1
                                      tmp=Win[idx,yrg[i2]:yrg[i2+1],j]
                                      ytm=Y[      yrg[i2]:yrg[i2+1]  ]
			  if Eok then tme=EE[ idx,yrg[i2]:yrg[i2+1],j]
        if nv gt 1  then  begin &       Wout[idx,i,j]=     total(tmp,2)   /nv
	                              Yout[    i,j]=     total(ytm)     /nv
			  if Eok then Eout[idx,i,j]=sqrt(total(tme^2,2))/nv
        endif else begin &              Wout[idx,i,j]=tmp & Yout[i,j]=ymp
	                  if Eok then Eout[idx,i,j]=tme & endelse
    endfor
    Yout[*,j]=Yout[*,j]+chi[j]                       ;Add Chi angle
   endfor
; --the bit at the start, normalising by the number of active pixels
if idx0 gt 0 then for idx=0,idx0-1 do begin
   idy=where(win[idx,*,0] ge 0.) & idy0=idy[0]>0 & idyn=idy[n_elements(idy)-1]>0<(siz[2]-1)
   yrg=yrg_kp>idy0<idyn
   for j=0,nz-1 do begin
    for i=0,n-1  do begin & i2=i*2  &   nv =yrg[i2+1]-yrg[i2]+1
        if nv gt 1  then  begin &       tmp=Win[idx,yrg[i2]:yrg[i2+1],j]
			  if Eok then tme=EE[ idx,yrg[i2]:yrg[i2+1],j]
                                      Wout[idx,i,j]=     total(tmp,2)   /nv
			  if Eok then Eout[idx,i,j]=sqrt(total(tme^2,2))/nv & endif
endfor & endfor & endfor
; --and the bit at the end, normalising by the number of active pixels
if (idxn lt siz[1]-1) and (idxn gt 0) then for idx=idxn+1,siz[1]-1 do begin
   idy=where(win[idx,*,0] ge 0.) & idy0=idy[0]>0 & idyn=idy[n_elements(idy)-1]>0<(siz[2]-1)
   yrg=yrg_kp>idy0<idyn
   for j=0,nz-1 do begin
    for i=0,n-1  do begin & i2=i*2  &   nv =yrg[i2+1]-yrg[i2]+1
        if nv gt 1  then  begin &       tmp=Win[idx,yrg[i2]:yrg[i2+1],j]
			  if Eok then tme=EE[ idx,yrg[i2]:yrg[i2+1],j]
                                      Wout[idx,i,j]=     total(tmp,2)   /nv
			  if Eok then Eout[idx,i,j]=sqrt(total(tme^2,2))/nv & endif
endfor & endfor & endfor

if manip eq 3 then begin & Wout=reform(Wout,siz[1],n*nz) & Yout=reform(Yout,n*nz)
                         if Eok then Eout=reform(Eout,siz[1],n*nz)          & endif

datp.y_tit='Nu angles'
if Eok then MOD_DATP,datp,'E',Eout
if manip ne 3 then Yout=Yout[*,0]
MOD_DATP,datp,'Y',Yout                            ;Replace Y values
GIVE_DATP,datp                         ;Give variables back to Lamp
return, Wout                                  ;Return new workspace
end

