pro d1b_2_eth, Won ,file=fifi ,datp=datp
;+
;** *********
;**
;** User callable
;** Export 3 columns format data, e.g. for MAUD (Luca Lutterotti)
;-

;D1B!!!
siz=size(Won) & win=reform(won,siz[1],1,siz[2])

;Check for inputs
 if n_elements(Win) le 1 then return
 siz=size(Win) & sx=siz[1] & sy=1 & sz=1
 if siz[0] gt 1 then sy=siz[2] & if siz[0] gt 2 then sz=siz[3]
 if n_elements(datp) eq 0 then take_datp,datp
 if n_elements(fifi) ne 1 then fifi='d1b'
;D1B!!!
 mod_datp,datp,'Y',reform(datp.Y,1,sz) & datp.Y[*]=datp.pv[1,*]
 mod_datp,datp,'X',datp.X[ *,0]
 mod_datp,datp,'E',sqrt(win)
 
 manip=datp.p[27] & m=(size(datp.pv))[1] -1
 if manip ne 2 then omg=fltarr(sz)+datp.p[2] else omg=reform(datp.pv[4<m,*])/1000.
;if manip ne 3 then chi=fltarr(nz)+datp.p(1) else chi=reform(datp.pv(5<m,*))/1000.
 if manip ne 4 then phi=fltarr(sz)+datp.p[0] else phi=reform(datp.pv[6<m,*])/1000.
;D1B!!!
phi=reform(datp.pv[0,*])
 
;Prepare output
 nf =10000 & wout=fltarr(3,sx) & wout[0,*]=round(transpose(datp.X)*1000.)/1000. ;2Theta
 cif=strarr(sy*sz+5)           & if (size(datp.Y))[0] eq 1 then m=0 else m=sz-1
 cif[0]='loop_' & cif[1]='_riet_meas_datafile_name'
 cif[2]='_pd_meas_orientation_omega' & cif[3]='_pd_meas_orientation_chi'
 cif[4]='_pd_meas_orientation_phi'
 on_ioerror,miswrt & u=-1
 
;Write .eth
 for z=0,sz-1 do begin
 for y=0,sy-1 do begin & nf=nf+1 & fil=fifi+strtrim(string(nf),2)+'.eth'
     wout[1,*]=round(transpose(Win[   *,y,z])*1000.)/1000. ;Counts
     wout[2,*]=round(transpose(datp.e[*,y,z])*1000.)/1000. ;Sigma
     chi      =round(datp.Y[y,z<m]           *1000.)/1000.
     idx      =where(wout[1,*] gt 0.)
     openw,u,fil,/get_lun
     printf,u,wout[*,idx],format='(F9.4,F18.3,F12.3)'
     free_lun,u & u=-1
     cif[5+nf-10001]=fil+string(omg[z])+string(chi)+string(phi[z])
 endfor
 endfor
;Write .cif
 openw,u,fifi+'.cif',/get_lun
 for i=0,n_elements(cif)-1 do printf,u,cif[i] & free_lun,u
 
return 
miswrt: if u gt 0 then free_lun,u & print,!error_state.msg
end
