;*********** D2B => Paolo Radaelli ******************

pro dud, dets=d, pts=p, cutoff=c, time=tim, monitor=moni
;+
;** ***
;** User callable
;** author:  (Paolo Radaelli 1998)
;** purpose: Remove bad detectors when reading in data
;** call:    dud, cutoff=2.5, dets=[2,8,20] 
;** more:    dets keyword is used to list bad detectors from 1 to 128
;** more:    cutoff is used to remove detectors with bad efficiencies
;** more:    dets and cutoff are optional, dets=[0] removes no detectors
;-

common c_rdid , dzap, pzap, pzip , pzup
common c_rdid2, zapa, zape, zipi , zupo, zupe

if n_elements(d) gt 0 then dzap=d
if n_elements(p) gt 0 then pzap=p
if n_elements(c) gt 0 then pzip=c

if keyword_set(tim)   then zupe=1 ;If Preset is Time, force to normalise by Monitor
if keyword_set(moni)  then zupe=0

end
