Function read_d2b,file_in
;+
;******* ********
;** User callable
;** procedure to read a data file in 3 column format; 2theta, I, err
;** output file is file_out
;** call is "w18=read_d2b('mydata.dat')" to read mydata.dat into wkspace 18
;-

;open file to read and extract header info

on_ioerror,mis & u=0

openr,u,file_in,/get_lun
wt='' & readf,u,wt    ; title
ot='' & readf,u,ot    ; sub title
par=fltarr(5) & ptxt=strarr(5) & p=0. & t=''
for i=0, 4 do begin   ; read parameters
  readf,u,p,t & par[i]=p & ptxt[i]=t
endfor
npts=0. & vide='' & readf,u,npts,vide       ;'no.of 2theta pts'

;create buffer array
buf=fltarr(3,npts)
readf,u,buf
free_lun,u

;create DATP
datp={X:          reform(buf[0,*]),    $
      E:          reform(buf[2,*]),    $
      W_TIT:      wt,          $
      X_TIT:      '2theta',    $
      Y_TIT:      'counts',    $
      OTHER_TIT:  ot,          $
      P:          par,         $
      PAR_TXT:    ptxt         }

give_datp,datp
return,reform(buf[1,*])

mis:  print,!error_state.msg & if u gt 0 then free_lun,u
      return,0
end
