function str_integrate, w_in,r
;+
;******* *************
;** User callable
;** function to read a workspace containing a number of 2D data sets
;** Integrate the 2D data to 1D
;** Typical call w2=str_integrate(w1)
;-

take_datp,datp
;find dimensions/size of w_in
nx      =(size(datp.x))[1]
nspec   =(size(datp.z))[1]  ; & help,datp,/struct & print, datp.z
w_out   =fltarr(nx,nspec)   ; array for integrated data

;integrate data
for ispec=0,nspec-1 do begin
  w_out[*,ispec]=total(w_in[*,*,ispec],2)
endfor

;return 2D workspace
mod_datp,datp,'y',datp.z
datp.y_tit='scan'
give_datp,datp
return, w_out
end
