FUNCTION straight_1d, win, interpol=inter, distance=e_d, datp=datp, dX=deltaX, texture=txtr, integrate=integ, Weights=Iweight
;+
;******* ***********
;** User callable
;** The call is w6=straight_1d(w1)
;**
;** win  is a 2D (3D) diffractogram i.e. I(2theta,h)
;**      where h is the physical height of the multidetector
;** wout is a 1D diffractogram i.e. sum over h of I(2theta,h)
;** in which the DS cones should be straightened out
;** For each detector height calculate a vector of 2theta
;** angles and "interpolate" onto equatorial plane
;**
;** h is the physical height of the multidetector
;** r is the physical radius of the multidetector
;** set them
;**
;** Nov 2011 call straight_2d adding the integrate keyword
;-

return, straight_2d(win, interpol=inter, distance=e_d, datp=datp, dX=deltaX, /integrate, Weights=Iweight)

end
