PRO write_d2b,file_out,win
;+
;** *********
;** User callable
;** procedure to write the 1D workspace (w) as 3 column data; 2theta, I, err
;** output file is file_out
;** call is "write_d2b,'mydata.dat',w18" to output wkspace 18 to mydata.dat
;-

take_datp, datp

;get number of points in scan
npts=n_elements(datp.x)

;open file and write header
openw,u,file_out,/get_lun
printf,u,datp.w_tit    ; write title
printf,u,datp.other_tit; and sub title
printf,u,datp.p[4], '  wavelength      '
printf,u,datp.p[5], '  requested  temp.'
printf,u,datp.p[6], '  regulation temp.'
printf,u,datp.p[7], '  sample     temp.'
printf,u,datp.p[11],'  monitor         '
printf,u,npts,      '  no.of 2theta pts'

for i=0,npts-1 do begin
  printf,u,format='(3f12.4)',datp.x[i], win[i], datp.e[i]
endfor

;close file
free_lun, u

end
