function d4_QSQ1,Win, Qmin
;+
;******* ***********
;**
;** User callable
;** extrapolate Q(S(Q)-1) to zero i.e. remove beamstop
;** input is a workspace S(Q)
;** call is 'w2=d4_QSQ1(w1,0.5)'
;-

TAKE_DATP,datp & Q=datp.X   ;Get variables from Win
nq  =n_elements(Q) ; number of Q values

; calculate Q(S(Q)-1) and errors
Wout=Q*(Win-1.0) & datp.E=datp.E*Q

; find beamstop
iq_min_vec=where(Q gt Qmin)
iq_min=iq_min_vec[0] ; index to start extrapolation to 0
; interpolate from Qmin to 0
Wout[0:iq_min]=Wout[iq_min]*Q[0:iq_min]/Q[iq_min]

GIVE_DATP,datp ;Give variables back to Lamp
return, Wout      ;Return workspace

end

