function d4_fft,Win, dr
;+
;******* ******
;** User callable
;** evaluate FFT sum([Q(S(Q)-1)sin(Qr)]dQ
;** input is a workspace Q(S(Q)-1), x is Q
;** call is 'w2=d4_fft(w1,0.02)'
;** dr=0.02 is step in r
;**
;** modif 27/4/2009
;** function assumes num r-pts = num q-pts
;** dr is given as input parameter
;** integral is over Q
;** dQ should be constant and calculated
;-

TAKE_DATP,datp & Q=datp.X & ein=datp.E  ;Get variables from Win

nQ  =n_elements(Q) ; number of Q values
r = Q & nr = nQ    ; make r array
Wout = Win         ; make output array

; re-define Q-axis to be regular
Qmin=min(Q) & Qmax=max(Q) & dQ=(Qmax-Qmin)/nQ
Qreg=findgen(nQ)*dQ+Qmin
Win_reg=interpol(Win,Q,Qreg)

; loop over r
for i=0, nr-1 do begin
  rpt = (i+1) * dr & r[i]=rpt   ; r axis above zero to avoid division problems
  sinQr = sin(Qreg*rpt)         ; vector
  QSQ1sinQr = Win_reg*sinQr     ; product of vectors
  Wout[i] = total(QSQ1sinQr)*dQ ; integral over product - rectangle, dQ should be constant
endfor

MOD_DATP,datp,'E',E & MOD_DATP,datp,'X',r ;Replace E and X values
GIVE_DATP,datp                            ;Give variables back to Lamp
return, Wout                              ;Return FFT workspace
end

