; -----------------------------------------------------------------------
;************************************************************************

FUNCTION friedel_fold, w_in
;+
;******* ************
;** User callable
;**  Takes a Qrebin or QxQy output grid, and averages over the Friedel positions
;**  (i.e. (qx,qy) and (-qx,-qy))
;** 
;** 
;**  Last ever D7 macro written by.....
;**               JRS 8/12/10
;** ------------------------------------------------------------------------
;** ************************************************************************
;-
  
  TAKE_DATP, datp
  
  e_in = datp.e
  x_in = datp.x
  y_in = datp.y
  
  nQ = (SIZE(w_in))[2]
  
  w_out = w_in
  e_out = e_in
  
  FOR qy = 0,nQ-1 DO BEGIN
    FOR qx = 0, nQ/2. DO BEGIN
      xpoint = x_in[qx]
      ypoint = y_in[qy]
      wpoint = w_in[qx,qy]
      epoint = e_in[qx,qy]
      qxf = WHERE(x_in EQ -xpoint)
      qyf = WHERE(y_in EQ -ypoint)
      IF qxf EQ -1 OR qyf EQ -1 THEN GOTO,exit
      wfriedel = w_in[qxf,qyf]
      efriedel = e_in[qxf,qyf]
      npoints = 2
      IF (wpoint EQ 0) OR (wfriedel EQ 0) THEN npoints = 1
      w_out[qx,qy]   = (wpoint + wfriedel)/npoints
      w_out[qxf,qyf] = (wpoint + wfriedel)/npoints
      IF epoint EQ -1   THEN epoint = 0
      IF efriedel EQ -1 THEN efriedel = 0
      e_out[qx,qy]   = SQRT(epoint^2 + efriedel^2)/npoints
      e_out[qxf,qyf] = SQRT(epoint^2 + efriedel^2)/npoints
      exit:
    ENDFOR
  ENDFOR
  
  i = WHERE(e_out EQ 0)
  IF N_ELEMENTS(i) GE 1 THEN BEGIN
    w_out[i] = 0.0
    e_out[i] = -1
  ENDIF
  
  ; ---------------------------------------------------------------------
  ;Return data and exit
  
  datp.other_tit = datp.other_tit + ' -ff'
  datp.e = e_out
  
  GIVE_DATP, datp
  RETURN, w_out
  
END

