; ------------------------------------------------------------------------
;*************************************************************************

PRO check_d7, w_in, datp, name, stf, nspectra, nphases, nruns, TOF, nvers
;+
;** ********
;** User callable
;** Checks D7 data for runs, spectra, phases and TOF.  Sends flag to calling
;** in order to stop exectuction if data is not normalised.
;** 
;**                                                      JRS 5/6/07
;** 
;** -------------------------------------------------------------------------
;** *************************************************************************
;-

  nspectra = datp.p[1]
  nphases  = datp.p[2]
  TOF      = datp.p[8]
  
  se = SIZE(datp.e)
  sw = SIZE(w_in)
  
  IF sw[0] EQ 1 THEN nruns = 1.
  IF sw[0] EQ 2 AND nphases GT 1 THEN nruns = 1. ELSE nruns = sw[2]
  IF sw[0] EQ 3 THEN nruns = sw[3]
  
  IF (se[0] NE sw[0]) OR (se[1] NE sw[1]) THEN BEGIN
    s    = STRARR(2)
    s[0] = name + ': Error bars must be defined'
    s[1] = '       - run "normalise" on the workspace first'
    i = dialog_message(s, /ERROR)
    stf = 1
  ENDIF
  
  par_dim = (SIZE(datp.p))[1]
  IF par_dim EQ 34 THEN nvers = 0   ; Pre-1996 data
  IF par_dim EQ 49 THEN nvers = 1   ; mid-1996 data
  IF par_dim EQ 50 THEN nvers = 2   ; end-1996 to 2003 data
  IF par_dim EQ 47 THEN nvers = 3    ; 2003 (Prototype analyser installed)
  IF par_dim GE 48 THEN nvers = 4    ; 2004 (1st MP detector bank installed)
  
  
END

; ------------------------------------------------------------------------
