; ------------------------------------------------------------------------------
;*******************************************************************************

PRO d7_summary, numor1, numor2, cycle=cycle
;+
;** **********
;**
;**  Assumes that data format is new (i.e. same as September 1996)
;** 
;**  ARGUMENTS
;** ----------
;**  numor1, numor2 (optional)  -> defines first and last numor
;**                                if no numor is specified, then all numors in
;**                                the cycle are summarized
;** 
;**  cycle                      -> cycle number (default is current cycle)
;** 
;**               KHA,JRS 28/11/06
;** -------------------------------------------------------------------------------
;** *******************************************************************************
;-

  iprint = 0
  
  @read_d7.cbk
  
  IF N_ELEMENTS(cycle) LT 1 THEN BEGIN
    IF !version.os EQ 'Win32' THEN $
      inpath = '\\serdon\data\d7\' ELSE $
      inpath = '/net/d7/users/data/'
    cys = 'Current cycle'
  ENDIF ELSE BEGIN
    cys = STRTRIM(STRING(cycle),2)
    IF cycle LE 99 THEN cys = '0'  + STRTRIM(STRING(cycle),2)
    IF cycle LE 9  THEN cys = '00' + STRTRIM(STRING(cycle),2)
    IF !version.os EQ 'Win32' THEN $
      ;      inpath = '\\serdon\' + cys + '\d7\' ELSE $
      ;      inpath = '/usr/illdata/' + cys + '/d7/'
      inpath = '/usr/illdata/' + cys + '/d7/'
  ENDELSE
  
  IF iprint THEN PRINT, inpath
  
  IF !version.os EQ 'Win32' THEN $
    listf = file_search(inpath+'*') ELSE $
    SPAWN, 'ls -l '  + inpath + '.', listf
  IF STRMID(listf[10],STRLEN(listf[10]) - 2,2) EQ '.Z' THEN compressed = 1 ELSE compressed = 0
  nums = LONARR((SIZE(listf))[1])
  IF STRMID(listf[0],0,5) EQ 'total' THEN listf = listf[1:(SIZE(listf))[1]-1]
  
  ON_IOERROR, continue
  
  IF compressed THEN aa = 8 ELSE aa = 6
  FOR i = 0, (SIZE(listf))[1] - 1 DO BEGIN
    nums[i] = LONG(STRMID(listf[i],STRLEN(listf[i]) - aa,6))
    continue:
  ENDFOR
  ii     = WHERE(nums GE 100)
  nums   = nums[ii]
  IF N_ELEMENTS(numor1) EQ 0 AND N_ELEMENTS(numor2) EQ 0 THEN BEGIN
    numor1 = MIN(nums)
    numor2 = MAX(nums)
    
  ENDIF ELSE IF N_ELEMENTS(numor2) EQ 0 THEN numor2 = numor1
  
  
  scan = 0
  samerun = 0
  olduser = ''
  old_title = ''
  oldtime1 = -10.
  old_run_time = 0
  old_pol_mode = ''
  old_time_mode = ''
  old_sub_title = ''
  force = 0
  
  num1 = LONG(numor1)
  num2 = LONG(numor2)
  OPENW, lun, 'summary.' + cys, /GET_LUN
  FOR numor = num1, num2 DO BEGIN
    PRINT, 'Reading ' + STRTRIM(STRING(numor),2)
    IF numor GE 10000  THEN file = '0' +  STRTRIM(STRING(numor),2) ELSE $
      IF numor GE 100000 THEN file =        STRTRIM(STRING(numor),2) ELSE $
      file = '00' + STRTRIM(STRING(numor),2)
    IF compressed THEN BEGIN
      IF !version.os EQ 'Win32' THEN BEGIN
        command = 'copy ' + inpath + file + '.Z ' + '.'
        SPAWN, command, /HIDE
        command = 'gzip -d ' + file + '.Z'
        SPAWN, command, /HIDE
      ENDIF ELSE BEGIN
        s = ['cp',inpath + file + '.Z','.']
        SPAWN, s, /NOSHELL
        s = ['uncompress',file + '.Z']
        SPAWN, s, /NOSHELL
      ENDELSE
    ENDIF
    IF NOT compressed THEN read_d7sum, inpath+file
    IF     compressed THEN read_d7sum, file
    IF compressed THEN BEGIN
      IF !version.os EQ 'Win32' THEN BEGIN
        command = 'del ' + file
        SPAWN, command, /HIDE
      ENDIF ELSE BEGIN
        s = ['rm','-f', file]
        SPAWN, s, /NOSHELL
      ENDELSE
    ENDIF
    run_time = FLOAT(run_time/60.)  ; get it in minutes
    
    IF iprint THEN BEGIN
      PRINT, 'NUMOR-------#', numor
      PRINT, 'run_time   = ', run_time
      PRINT, 'pol_mode   = ', pol_mode
      PRINT, 'time_mode  = ', time_mode
      PRINT, 'scan_type  = ', scan_type
      PRINT, 'sub_title  = ', sub_title
      PRINT, 'main_title = ', main_title
      PRINT, 'user       = ', user
    ENDIF
    
    
    IF (scan EQ 1 AND ((scan_type NE '         ' AND npmes EQ 1) OR (scan_type EQ '         '))) THEN BEGIN
      IF (numor - oldnumor GE 2) THEN PRINTF, lun, FORMAT='("     ... ",A," scan up to #",I5)', STRTRIM(oldscan_type,2), numor-1
      scan    = 0
      samerun = 0
    ENDIF ELSE IF (scan_type EQ '         ') THEN BEGIN
      IF (LONG(run_time) EQ LONG(old_run_time) AND pol_mode EQ old_pol_mode AND $
        time_mode EQ old_time_mode AND sub_title EQ old_sub_title AND $
        user EQ olduser AND main_title EQ old_title) THEN BEGIN
        samerun = 1
      ENDIF ELSE IF (samerun EQ 1) THEN BEGIN
        IF (numor-oldnumor GE 2) THEN PRINTF,lun, FORMAT='("     ... identical runs up to #",I5)', numor-1
        samerun = 0
        
      ENDIF
    ENDIF
    IF (scan_type NE '         ') AND (scan EQ 0) AND (samerun EQ 1) THEN BEGIN
      IF (numor-oldnumor GE 2) THEN PRINTF,lun, FORMAT='("     ... identical runs up to #",I5)', numor-1
      samerun = 0
    ENDIF
    
    IF (numor EQ numor1) THEN BEGIN
      PRINTF,lun
      PRINTF,lun,'****************************************************************'
      PRINTF,lun, 'Cycle: ',cys
      PRINTF,lun, FORMAT='("Numors",I6," to",I6)', numor1, numor2
      PRINTF,lun, 'Path: ',inpath
      PRINTF,lun,'----------------------------------------------------------------'
      PRINTF,lun
      PRINTF,lun, FORMAT='("User: ",A8,"   Local Contact: ",A8)', user, local_contact
      PRINTF,lun, FORMAT='("Experiment Title: ",A)', main_title
      PRINTF,lun
      PRINTF,lun, 'Numor   Date     Start    Time   Pol  TOF   Title'
    ENDIF ELSE IF (user NE olduser) OR (main_title NE old_title) THEN BEGIN
      PRINTF,lun,'----------------------------------------------------------------'
      PRINTF,lun
      PRINTF,lun, FORMAT='("User: ",A8,"   Local Contact: ",A8)', user, local_contact
      PRINTF,lun, FORMAT='("Experiment Title: ",A)', main_title
      PRINTF,lun
      PRINTF,lun, 'Numor   Date     Start    Time   Pol  TOF   Title'
    ENDIF
    IF (scan EQ 0 AND samerun EQ 0) THEN BEGIN
      PRINTF,lun, FORMAT='(I5,1X,A18,F7.1,1X,A5,A6,1X,A)', $
        numor, start_time, run_time, pol_mode, Time_mode, sub_title
      oldnumor=numor
      oldscan_type=scan_type
    ENDIF ELSE IF (numor EQ numor2) THEN BEGIN
      IF (scan_type NE '         ' AND npmes NE 1) THEN $
        PRINTF,lun, FORMAT='("     ... ",A," scan up to #",I5)', $
        STRTRIM(scan_type,2), numor
      IF (scan_type EQ '         ' AND $
        LONG(run_time) EQ LONG(old_run_time) AND pol_mode EQ old_pol_mode AND $
        time_mode EQ old_time_mode AND sub_title EQ old_sub_title AND $
        user EQ olduser AND main_title EQ old_title) THEN PRINTF,lun, $
        FORMAT='("     ... identical runs up to #",I5)', numor
    ENDIF
    IF (scan_type NE '         ') THEN scan = 1
    olduser       = user
    old_title     = main_title
    old_run_time  = run_time
    old_pol_mode  = pol_mode
    old_time_mode = time_mode
    old_sub_title = sub_title
  ENDFOR
  
  CLOSE, lun
  RETURN
END
