; ------------------------------------------------------------------------------
;*******************************************************************************
;
FUNCTION divide, w_in1, w_in2
;+
;******* ******
;**  Divides two workspaces with correct error propogation (any dimension)
;** 
;** COMMAND SYNTAX
;**  w3=divide(w1,w2)
;** 
;**             KHA, 6/11/97
;** -------------------------------------------------------------------------------
;** *******************************************************************************
;-

  TAKE_DATP, dat1
  TAKE_DATP, dat2, /third
  
  e_in1 = dat1.e
  e_in2 = dat2.e
  
  zero    = WHERE(w_in2 EQ 0.)
  zero = [zero, WHERE(e_in1 LT -0.9)]
  zero = [zero, WHERE(e_in2 LT -0.9)]
  
  w_out = w_in1 / w_in2
  e_out = SQRT((e_in1/w_in2)^2 + (w_in1*e_in2/w_in2^2)^2)
  
  IF N_ELEMENTS(zero) GT 0 THEN BEGIN
    w_out[zero] =  0.
    e_out[zero] = -1.
  ENDIF
  
  datp = dat1
  MOD_DATP,  datp, "e", e_out
  GIVE_DATP, datp
  RETURN, w_out
END
