; ------------------------------------------------------------------------------
;*******************************************************************************
;
PRO monitor, cycle = cycle, numor1, numor2
;+
;** *******
;**           KHA,JRS 6/4/05
;** -------------------------------------------------------------------------------
;** *******************************************************************************
;-

  IF N_ELEMENTS(cycle) LT 1 THEN BEGIN
    IF !version.os EQ 'Win32' THEN $
      inpath = '\\serdon\data\d7\' ELSE $
      inpath = '/hosts/d7/users/data/'
    cys = 'Current cycle'
  ENDIF ELSE BEGIN
    cys = STRTRIM(STRING(cycle),2)
    IF cycle LE 99 THEN cys = '0'  + STRTRIM(STRING(cycle),2)
    IF cycle LE 9  THEN cys = '00' + STRTRIM(STRING(cycle),2)
    IF !version.os EQ 'Win32' THEN $
      inpath = '\\serdon\' + cys + '\d7\' ELSE $
      inpath = '/usr/illdata/' + cys + '/d7/'
  ENDELSE
  
  IF !version.os EQ 'Win32' THEN $
    listf = file_search(inpath+'*') ELSE $
    SPAWN, 'ls -l '  + inpath, listf
  IF STRMID(listf[10],STRLEN(listf[10]) - 2,2) EQ '.Z' THEN compressed = 1 ELSE compressed = 0
  nums = LONARR((SIZE(listf))[1])
  IF STRMID(listf[0],0,5) EQ 'total' THEN listf = listf[1:(SIZE(listf))[1]-1]
  ON_IOERROR, continue
  IF compressed THEN aa = 8 ELSE aa = 6
  FOR i = 0, (SIZE(listf))[1] - 1 DO BEGIN
    nums[i] = LONG(STRMID(listf[i],STRLEN(listf[i]) - aa,6))
    continue:
  ENDFOR
  ii     = WHERE(nums GE 100)
  nums   = nums[ii]
  IF N_ELEMENTS(numor1) EQ 0 AND N_ELEMENTS(numor2) EQ 0 THEN BEGIN
    numor1 = MIN(nums)
    numor2 = MAX(nums)
    
  ENDIF ELSE IF N_ELEMENTS(numor2) EQ 0 THEN numor2 = numor1
  
  @read_d7.cbk
  
  outfile='monitor.' + cys
  olddate=-10.
  
  IF (N_ELEMENTS(numor2) EQ 0) THEN numor2=numor1
  OPENW, lun, outfile, /GET_LUN
  
  FOR numor = numor1, numor2 DO BEGIN
    IF (numor GE 10000) THEN infile='0' +STRTRIM(STRING(numor),2) $
    ELSE infile='00'+STRTRIM(STRING(numor),2)
    PRINT,' Reading run', numor
    IF compressed THEN BEGIN
      IF !version.os EQ 'Win32' THEN BEGIN
        command = 'copy ' + inpath + infile + '.Z ' + '.'
        SPAWN, command, /HIDE
        command = 'gzip -d ' + infile + '.Z'
        SPAWN, command, /HIDE
      ENDIF ELSE BEGIN
        s = ['cp',inpath + infile + '.Z','.']
        ;        command = 'cp ' + inpath + infile + '.Z ' + '.'
        SPAWN, s, /NOSHELL
        s = ['uncompress',infile + '.Z']
        ;        command = 'uncompress ' + infile + '.Z'
        SPAWN, s, /NOSHELL
      ENDELSE
    ENDIF
    IF NOT compressed THEN read_d7sum, inpath+infile
    IF     compressed THEN read_d7sum, infile
    IF compressed THEN BEGIN
      IF !version.os EQ 'Win32' THEN BEGIN
        command = 'del ' + infile
        SPAWN, command, /HIDE
      ENDIF ELSE BEGIN
        s = ['rm','-f', infile]
        ;        command = 'rm -f ' + infile
        SPAWN, s, /NOSHELL
      ENDELSE
    ENDIF
    PRINTF, lun, numor, mon1rate, dmon1rate
    olddate = date
  ENDFOR
  PRINTF, lun, 'Numor'
  PRINTF, lun, 'Counts/second'
  PRINTF, lun, 'Monitor 1 rate - Cycle ' + cys
  
  FREE_LUN, lun
  
  RETURN
END
