FUNCTION mkcal6,win,i,last,pattern,w,xx,x,error,$
	              excluded_up=excluded_up,excluded_down=excluded_down,$
	              excluded2_up=excluded2_up,excluded2_down=excluded2_down,$
				  plot=plot,print=print,median=median,mean=mean,range=range,$
				  notconsidered=notconsidered ; ### added 16Jul14 by TCH for zero-counting cells ###
;+
;**********************************************************************************************************
;** User callable
;** The call is w6=mkcal6(w5,32,1567,w7,w8,x7,x,e7,excluded_down=-7,excluded_up=7)
;** Thomas Hansen
;**********************************************************************************************************
;-
compile_opt idl2

take_datp,datp
w =win
pv=datp.pv
x =datp.x
e =datp.e
IF NOT KEYWORD_SET(notconsidered) THEN notconsidered = [-1]
IF KEYWORD_SET(plot) THEN BEGIN
	  window,0
    window,1
    window,2
    window,3
    window,4
ENDIF
j=i+1
pattern=REFORM(w[i,*])
error  =REFORM(e[i,*])
xx     =REFORM(pv[13,*])+x[i]-pv[13,0]
Wout=FLTARR(N_ELEMENTS(w[*,0]))
Eout=Wout
Wout[i]=1.0
IF NOT KEYWORD_SET(range)    then range   =0.250
IF NOT KEYWORD_SET(excluded_up)    then excluded_up   =0.0
IF NOT KEYWORD_SET(excluded_down)  then excluded_down =0.0
IF NOT KEYWORD_SET(excluded2_up)   then excluded2_up  =0.0
IF NOT KEYWORD_SET(excluded2_down) then excluded2_down=0.0
FOR j=i+1,last DO BEGIN
 IF where(notconsidered eq j) EQ -1 THEN BEGIN
  IF KEYWORD_SET(plot) THEN wset,0
  IF KEYWORD_SET(plot) THEN plot,xx,pattern
  IF KEYWORD_SET(plot) THEN oplot,pv[13,*]+x[j]-pv[13,0],w[j,*]
  a=MIN(pv[13,*]+x[j]-pv[13,0])
  b=MAX(xx)
  x0=xx[WHERE(xx gt a)]
  c=pattern[WHERE(xx ge a)]
  c_err=error[WHERE(xx ge a)]>.00000000001
  d=INTERPOL(w[j,*],pv[13,*]+x[j]-pv[13,0],x0)
  d_err=INTERPOL(e[j,*],pv[13,*]+x[j]-pv[13,0],x0)
  IF KEYWORD_SET(plot) THEN oplot,x0,c
  IF KEYWORD_SET(plot) THEN oplot,x0,d
;  idx=where((x0 ge excluded_up or x0 le excluded_down) and (x0 ge excluded2_up or x0 le excluded2_down),points)
  idx=where((x0 ge excluded_up or x0 le excluded_down) and (x0 ge excluded2_up or x0 le excluded2_down) and d GT 0,points) ; ### potential bug corrected TCH 16JUL14 ###
  zeros=where(d LE 0,nbofzeros)
  if nbofzeros gt 0 then print,"cell",j," counts zero at steps",zeros," corresponding to",x0[zeros]," degrees"
  tmp_w=c[idx]/d[idx]
  tmp_m=most_likely(tmp_w)
  IF  KEYWORD_SET(median)  then tmp_m=median(tmp_w)
  IF  KEYWORD_SET(mean)    then tmp_m=mean[tmp_w]
  tmp_e=SQRT((c_err[idx]/ABS(c[idx]))^2+(d_err[idx]/ABS(d[idx]))^2)*tmp_w
  tmp_i=WHERE(ABS(tmp_w-tmp_m) LT range*tmp_e)
  IF n_elements(tmp_i) GT 1 THEN idx=idx[tmp_i]
  if n_elements(idx) LT 1 THEN oplot,x0[idx],c[idx]/d[idx],psym=7
  d_min=min(d[where(d GT 0)])
  weight=SQRT((c_err/ABS(c))^2+(d_err/ABS(d>d_min))^2)
  IF n_elements(d) GT n_elements(WHERE(d LE 0)) THEN BEGIN
   IF KEYWORD_SET(plot) THEN BEGIN
    wset,3
    plot,x0,c/d
    oplot,x0[idx],c[idx]/d[idx],psym=7
    oplot,x0,x0*0.+tmp_m
   ENDIF
   Wout[j]=TOTAL(c[idx]/d[idx]            /weight[idx]); ######### WHY DOES THIS RE-APPEAR SOME LINES FURTHER DOWN??? ##########33
   Wout[j]=Wout[j]   /TOTAL(1.            /weight[idx])
   IF KEYWORD_SET(plot) THEN BEGIN
    oplot,x0,x0*0.+Wout[j],psym=7
    wset,4
    plot, x0,     c/     d                /weight
    oplot,x0[idx],c[idx]/d[idx]           /weight[idx],psym=7
   ENDIF
  ENDIF
  Wout[j]=TOTAL(c[idx]/d[idx]            /weight[idx]); ######### WHY DOES THIS APPEAR ALSO SOME LINES FURTHER UP??? ######
  Wout[j]=Wout[j]   /TOTAL(1.            /weight[idx]); ######### No, it's okay, look in detail on the formula!     ######
  my_e=SQRT(TOTAL(weight[idx]^2*1./weight[idx])/TOTAL(1./weight[idx]))*Wout[j]
  Eout[j]=my_e/SQRT(N_ELEMENTS(x0)) ; ################  NEW IDEA 16JUL14 TCH #####################
  IF KEYWORD_SET(plot) THEN BEGIN
   wset,2
   plot,x0[idx],c[idx],psym=7,yr=[min([c[idx],d[idx]]),max([c[idx],d[idx]])]
   plot,x0[idx],d[idx],/noer, yr=[min([c[idx],d[idx]]),max([c[idx],d[idx]])]
   wset,1
   plot,wout[i:j]
  ENDIF
  d     =d     *Wout[j]
  d_err =d_err *Wout[j]+d     *Eout[j]
  w[j,*]=w[j,*]*Wout[j]
  e[j,*]=e[j,*]*Wout[j]+w[j,*]*Eout[j]
  d_err_min=MIN(d_err[where(d_err gt 0)])
  d_tmp=c*(SQRT(c)/c_err)^2+d*(SQRT(d)/(d_err>d_err_min))^2  ; here comes the "mixing-in"
  d_div=  (SQRT(c)/c_err)^2+  (SQRT(d)/(d_err>d_err_min))^2
  d    =     d_tmp /(d_div)      ;>.001)
  d_err=SQRT(d_tmp)/(d_div)     ;>.001)
  IF KEYWORD_SET(print) THEN print,j,Wout[j],tmp_m,Eout[j],my_e,N_ELEMENTS(x0),MIN(xx),a,b,points,TOTAL((d-mean(d))*(d-mean(d)))/n_elements(d)
  x1=WHERE(xx LT a)
  x2=REFORM(pv[13,*]+x[j]-pv[13,0])
  x3=WHERE(x2 GT b)
  xx=[xx[x1],x0,x2[x3]]
  pattern=[pattern[x1],d,    REFORM(w[j,x3])]
  error=  [error[x1],  d_err,REFORM(e[j,x3])]
 ENDIF ; not notconsidered
ENDFOR
mod_datp,datp,'e',Eout
mod_datp,datp,'x',indgen(n_elements(wout))
give_datp,datp
return, Wout
end

