;+
; :author: Thomas Hansen
; 
; Called by rdid to set the D20 input raw data and the parameters in correct order.
;-

PRO rdid_d20, INST,numor,nvers,text,exper,scan,cnt,WOUT,vparm,param,par1,par2,par3,par4,par5,$
              WT ,XT ,YT ,ZT ,OT ,DATE ,PP ,PTXT ,XX ,YY ,ZZ ,NN ,PV ,EE
;+
;** ********
;** Called by rdid to set the D20 input raw data and the parameters in correct order.
;-

  COMMON calibration, pathcal, cal_d19 , cal_d2b , ang_d2b , cal_d1a , ang_d1a , cal_in13 $
    , cal_d16 , cal_in5 , idx_in5 , shf_in5 , cal_in6 , idx_in6  $
    , shf_in6 , cal_d20 , ang_d20 ,inf_d20 $
    , inf_d2b , inf_d1a , inf_in13, inf_d16 , inf_in5 , inf_in6
  COMMON d20, bad_d20 ,flag_d20, wav_d20, psd_d20
  COMMON d20roc,roc_d20, psdroc_d20
  
  IF !version.Release GE '5.0' THEN ii=EXECUTE('FORWARD_FUNCTION sys_dep')
  IF !version.Release GE '5.0' THEN ii=EXECUTE('FORWARD_FUNCTION RDDAT')
  
  WOUT=WOUT>0
  nd=cnt
  DATI     = STRMID(exper[5],20,18)
  flag20101103=0
  IF STRPOS(DATI,'Stop',0) GE 0 THEN BEGIN
    DATI = STRMID(text[0],14,18)
    IF STRPOS(DATI,'-Nov-11 ') THEN flag20101103=1 ELSE DATI='16-Apr-02 20:00:00'
  ENDIF
  day      = STRMID(DATI,0,2)
  month    = STRMID(DATI,3,3)
  year     = STRMID(DATI,7,2)
  hour     = STRMID(DATI,10,2)
  minute   = STRMID(DATI,13,2)
  second   = STRMID(DATI,16,2)
  charpos=0
  IF  STRMID(year,0,1) GT '9' OR  STRMID(year,0,1) LT '0'  OR STRMID(year,1,1) GT '9' OR  STRMID(year,1,1) LT '0' THEN BEGIN
    charpos=STRPOS(TEXT[0],':',0)-2
    hour=STRMID(TEXT[0],charpos,2)
    hour=STRMID('00'+hour,STRLEN(hour),2)
    charpos=charpos+3
    secpos=STRPOS(TEXT[0],':',charpos)
    minute=STRMID(TEXT[0],charpos,secpos-charpos)
    minute=STRMID('00'+minute,STRLEN(minute),2)
    second=STRMID(TEXT[0],secpos+1,2)
    second=STRMID('00'+second,STRLEN(second),2)
    charpos=STRPOS(TEXT[0],' ',secpos)+1
    secpos=STRPOS(TEXT[0],'-',charpos)
    day=STRMID(TEXT[0],charpos,secpos-charpos)
    day=STRMID('00'+day,STRLEN(day),2)
    charpos=secpos+1
    secpos=STRPOS(TEXT[0],"-",charpos)
    month=STRMID(TEXT[0],charpos,secpos-charpos)
    month=STRMID('   '+month,STRLEN(month),3)
    charpos=secpos+1
    year=STRMID(TEXT[0],charpos,2)
    year=STRMID('00'+year,STRLEN(year),2)
    DATI=day+"-"+month+"-"+year+" "+hour+":"+minute+":"+second
  ENDIF ELSE BEGIN
    hour     = STRMID(DATI,10,2)
    minute   = STRMID(DATI,13,2)
    second   = STRMID(DATI,16,2)
  ENDELSE
  IF nd EQ 1600 THEN BEGIN
    IF TOTAL(WOUT[128:1599,*]) EQ 0 AND year EQ "96" THEN BEGIN     ; old PSD 128 cells
      WOUT  =  WOUT[0:127,*]
      nd=128
      IF N_ELEMENTS(vparm) LT 26.*scan THEN vparm=FLTARR(26,scan)
    ENDIF
  ENDIF
  WOUT=FLOAT(WOUT)
  IF N_ELEMENTS(vparm) GE  1 THEN vparm=vparm[*,0:N_ELEMENTS(WOUT[0,*])-1]
  nj = N_ELEMENTS(wout[0,*])
  EE  = WOUT/SQRT(1+WOUT)
  IF N_ELEMENTS(par5) EQ 0 THEN BEGIN                          ; Numor bug fix
    par5=par4
    par4=par3
    par3=0
  ENDIF
  IF year GT 60 THEN par1[51]=par1[51]/1000000.                ; CntTime in sec (raw data before 2000: microsec)
  IF N_ELEMENTS(par5) EQ 25 THEN BEGIN                         ; Numor bug fix
    par5=[par5[0:19],0.,0.,0.,0.,0.,par5[20:24]]
    param=[0.,param]
    FOR i=0,nj-1 DO wout[*,i]=[wout[nd-1,i],wout[0:nd-2,i]]
  ENDIF
  CntTime  = par1[51]
  proposal = STRMID(exper[2],20 ,9)
  WT  =  ' '+STRCOMPRESS(STRMID(exper[0],20,40)) $
    +' '+STRCOMPRESS(STRMID(exper[3],20,40))
  OT = INST[0]  +' '+ DATI $
    +' User '+STRMID(exper[1],20,8)$
    +' L.C.' +STRMID(exper[4],20,7)$
    +' Run'  +STRCOMPRESS(STRING(numor))
  CASE month OF
    'Jan':  MON=1
    'Feb':  MON=2
    'Mar':  MON=3
    'Apr':  MON=4
    'May':  MON=5
    'Jun':  MON=6
    'Jul':  MON=7
    'Aug':  MON=8
    'Sep':  MON=9
    'Oct':  MON=10
    'Nov':  MON=11
    'Dec':  MON=12
  ENDCASE
  IF par5[25] LT 963 THEN BEGIN                                  ; evt. missing reactor cycle
    par5[25]=year*10+ROUND(((mon-1.)*30.5+(day-1.))/366.*5.)
  ENDIF
  CYCLE = LONG(par5[25])
  IF N_ELEMENTS(inf_d20) EQ 0 THEN BEGIN
    IF CYCLE NE LONG(year*10+1+ROUND(((mon-1.)*30.5+(day-1.))/366.*4.)) THEN PRINT,"Cycle is",cycle," but probably should be",LONG(year*10+1+ROUND(((mon-1.)*30.5+(day-1.))/366.*4.))
  ENDIF
  IF year LE 60 THEN century=20 ELSE century=19
  jul_day=julday(mon,day,century*100+year)-julday(1,1,1970)
  jul_sec=hour*3600.0+minute*60.0+second
  ;****** CHECK WAVELENGTH ************
  IF ROUND(10*par5[3]) LE 99 AND ROUND(10*par5[3]) GE 25 THEN BEGIN
    wav=2.41
    IF N_ELEMENTS(inf_d20) LE 1 THEN BEGIN
      IF ROUND(par5[1]) NE   1 THEN PRINT,'2.52A, HOPG-Monochromator, Filters should be in but they are not'
      IF ROUND(par5[4]) NE  44 THEN PRINT,'2.52A, HOPG-Monochromator, TakeOff should be 44deg but it is at',ROUND(par5[4])
    ;IF ROUND(par5(5)) NE 120 THEN PRINT,'2.52A, HOPG-Monochromator, MonoChanger should be 120deg but it is at',ROUND(par5(5))
    ENDIF
  ENDIF ELSE BEGIN
    IF ROUND(10*par5[3]) LE 24 AND ROUND(10*par5[3]) GE  20 THEN BEGIN
      wav=2.41
      IF N_ELEMENTS(inf_d20) LE 1 THEN BEGIN
        IF ROUND(par5[1]) NE   1 THEN PRINT,'2.41A, HOPG-Monochromator, Filters should be in but they are not'
        IF ROUND(par5[4]) NE  42 THEN PRINT,'2.41A, HOPG-Monochromator, TakeOff should be 42 deg but it is at',ROUND(par5[4])
      ;IF ROUND(par5(5)) NE 120 THEN PRINT,'2.41A, HOPG-Monochromator, MonoChanger should be 120 deg but it is at',ROUND(par5(5))
      ENDIF
    ENDIF ELSE BEGIN
      IF ROUND(10*par5[3]) LE 19 AND ROUND(10*par5[3]) GE 14 THEN BEGIN
        wav=1.30
        IF N_ELEMENTS(inf_d20) LE 1 THEN BEGIN
          IF ROUND(par5[1]) NE   0 THEN PRINT,'1.36A, Cu-Monochromator, Filters should be out but they are not'
          IF ROUND(par5[4]) NE  44 THEN PRINT,'1.36A, Cu-Monochromator, TakeOff should be 44 deg but it is at',ROUND(par5[4])
        ;IF ROUND(par5(5)) NE 210 THEN PRINT,'1.36A, Cu-Monochromator, MonoChanger should be 210 deg but it is at',ROUND(par5(5))
        ENDIF
      ENDIF ELSE BEGIN
        IF ROUND(10*par5[3]) LE 13 AND ROUND(10*par5[3]) GE 10 THEN BEGIN
          wav=1.30
          IF N_ELEMENTS(inf_d20) LE 1 THEN BEGIN
            IF ROUND(par5[1]) NE   0 THEN PRINT,'1.30A, Cu-Monochromator, Filters should be out but they are not'
            IF ROUND(par5[4]) NE  42 THEN PRINT,'1.30A, Cu-Monochromator, TakeOff should be 42 deg but it is at',ROUND(par5[4])
          ;IF ROUND(par5(5)) NE 210 THEN PRINT,'1.30A, Cu-Monochromator, MonoChanger should be 210 deg but it is at',ROUND(par5(5))
          ENDIF
        ENDIF ELSE BEGIN
          IF ROUND(100*par5[3]) LE 99 AND ROUND(100*par5[3]) GE 91 THEN BEGIN
            wav=0.94
            IF N_ELEMENTS(inf_d20) LE 1 THEN BEGIN
              IF ROUND(par5[1]) NE   0 THEN PRINT,'0.94A, Cu-Monochromator, Filters should be out but they are not'
              IF ROUND(par5[4]) NE  30 THEN PRINT,'0.94A, Cu-Monochromator, TakeOff should be 30 deg but it is at',ROUND(par5[4])
            ;IF ROUND(par5(5)) NE 210 THEN PRINT,'0.94A, Cu-Monochromator, MonoChanger should be 210 deg but it is at',ROUND(par5(5))
            ENDIF
          ENDIF ELSE BEGIN
            IF ROUND(100*par5[3]) LE 90 AND ROUND(100*par5[3]) GE 85 THEN BEGIN
              wav=0.88
              IF N_ELEMENTS(inf_d20) LE 1 THEN BEGIN
                IF ROUND(par5[1]) NE   0 THEN PRINT,'0.88A, Cu-Monochromator, Filters should be out but they are not'
                IF ROUND(par5[4]) NE  28 THEN PRINT,'0.88A, Cu-Monochromator, TakeOff should be 28 deg but it is at',ROUND(par5[4])
              ;IF ROUND(par5(5)) NE 210 THEN PRINT,'0.88A, Cu-Monochromator, MonoChanger should be 210 deg but it is at',ROUND(par5(5))
              ENDIF
            ENDIF ELSE BEGIN
              IF ROUND(100*par5[3]) LE 84 AND ROUND(100*par5[3]) GE 70 THEN BEGIN
                wav=0.82
                IF N_ELEMENTS(inf_d20) LE 1 THEN BEGIN
                  IF ROUND(par5[1]) NE   0 THEN PRINT,'0.82A, Cu-Monochromator, Filters should be out but they are not'
                  IF ROUND(par5[4]) NE  26 THEN PRINT,'0.82A, Cu-Monochromator, TakeOff should be 28 deg but it is at',ROUND(par5[4])
                ;IF ROUND(par5(5)) NE 210 THEN PRINT,'0.82A, Cu-Monochromator, MonoChanger should be 210 deg but it is at',ROUND(par5(5))
                ENDIF
              ENDIF ELSE BEGIN
                IF N_ELEMENTS(inf_d20) LE 1 THEN PRINT,'Do you really have a wavelength of',par5[3],' Angstroem?'
              ENDELSE
            ENDELSE
          ENDELSE
        ENDELSE
      ENDELSE
    ENDELSE
  ENDELSE
  ;WIDGET_CONTROL,wid1,/APPEND,SET_VALUE='Reading Flags'
  ;########VVVVVVV Reading several flags form rdid.flag VVVVVVV######################
  IF N_ELEMENTS(flag_d20) LT 8 THEN flag,/noprint,old=flag_d20
  bad_flag=     flag_d20[0]
  interpol_flag=flag_d20[1]
  ang_flag=     flag_d20[2]
  wav_flag=     flag_d20[3]
  normalize=    flag_d20[4]
  float_flag=   flag_d20[5]
  eff_flag  =   flag_d20[6]
  cor_flag=     flag_d20[7]
  roc_flag=     flag_d20[8]
  ;########VVVVVV EFFICIENCY/Angle CALIBRATION VVVVVVVV######################
  IF N_ELEMENTS(inf_d20) EQ 0 THEN BEGIN
    inf_d20='autod20.cal'
  ENDIF ELSE IF N_ELEMENTS(inf_d20) EQ 1 THEN IF STRCOMPRESS(inf_d20,/RE) EQ '0' THEN inf_d20 ='autod20.cal'
  IF N_ELEMENTS(cal_d20) EQ 0 THEN BEGIN
    cal_d20=0
  ENDIF
  default_cal = 0
  IF N_ELEMENTS(inf_d20) EQ 0 THEN BEGIN
    default_cal=1
  ENDIF ELSE BEGIN
    IF inf_d20[0] EQ 'autod20.cal' THEN BEGIN
      default_cal=1
    ENDIF ELSE BEGIN
      IF N_ELEMENTS(inf_d20) GE 3 THEN BEGIN
        IF inf_d20[2] EQ 'autod20.cal' THEN BEGIN
          default_cal=1
        ENDIF
      ENDIF
    ENDELSE
  ENDELSE
  IF default_cal EQ 1 AND (ang_flag EQ 1 OR eff_flag EQ 1) THEN BEGIN
    IF N_ELEMENTS(inf_d20) EQ 0 THEN inf_d20=['autod20.cal','not loaded','autod20.cal']
    count=N_ELEMENTS(inf_d20)
    IF count LT 4 THEN BEGIN
      IF pathcal EQ '' THEN PRINT,"LAMP found calibration files in your launch directory, therefore it will only look here therefore!" ;PATHCAL=sys_dep('INSUB',p_lambda(0),'CALIBRATION')
      PRINT,'Looking up for calibration files in ',PATHCAL
      tmf     =PATHCAL
      current_dir=''
      CD,current=current_dir,tmf
      tmp     =file_search(inst[0]+'_????_??_??????.???',count=tmc)
      CD,current_dir
      IF tmc GT 0 THEN filelist=STRMID(tmp,STRPOS(tmp[0],inst[0]),22) ELSE PRINT,"Are you really on the right workstation (d20sgi.ill.fr)?"
      IF N_ELEMENTS(filelist) LE 0 THEN BEGIN
        PRINT,'NO auto-calibration file found!'
        inf_d20=['','','']
        default_cal=0
        filelist=''
      ENDIF ELSE PRINT,'Files in ~lambda/CALIBRATION ',filelist
      IF N_ELEMENTS(inf_d20) LT 2 THEN inf_d20=['autod20.cal','']
      inf_d20=[inf_d20[0:1],'autod20.cal',STRING(filelist)]
    ENDIF ELSE filelist= inf_d20[3:count-1]  ; NEW calibration file naming
    tmplist=filelist
    tmp=WHERE(STRMID(filelist,STRLEN(inst[0])+16,3) EQ STRMID(STRING(f='(I4)',1000+ROUND(100*wav)),1,3),count)
    IF count LE 0 THEN tmp=WHERE(STRMID(filelist,STRLEN(inst[0])+16,2) EQ STRMID(STRING(f='(I4)',1000+ROUND(100*wav)),1,2),count)
    IF count LE 0 THEN BEGIN
      tmp=WHERE(STRMID(filelist,STRLEN(inst[0])+16,1) EQ STRMID(STRING(f='(I4)',1000+ROUND(100*wav)),1,1),count)
      IF count LE 0 THEN tmp=WHERE(STRMID(filelist,STRLEN(inst[0])+16,1) EQ STRMID(STRING(f='(I4)',1000+ROUND(100*((wav+1)<9))),1,1),count)
      IF count LE 0 THEN tmp=WHERE(STRMID(filelist,STRLEN(inst[0])+16,1) EQ STRMID(STRING(f='(I4)',1000+ROUND(100*((wav-1)>0))),1,1),count)
    ENDIF
    IF count GT 0 THEN BEGIN
      tmplist=filelist[tmp]
      tmp=WHERE(tmplist LE inst[0]+'_'+STRCOMPRESS(STRING(century),/re)+STRCOMPRESS(STRING(year),/re)+'_'+STRMID(STRING(f='(I3)',100+mon),1,2)+'_'+STRMID(STRING(f='(I7)',1000000+numor),1,6)+'.'+STRMID(STRING(f='(I4)',1000+ROUND(100*wav)),1,3),count)
    ENDIF
    IF count GT 0 THEN tmp=MAX(tmplist[tmp]) ELSE BEGIN
      PRINT,'Apparently there is no calibration for ',wav,' Angstroem ',STRMID(STRING(f='(I4)',1000+ROUND(100*wav)),1,3)
      tmp=WHERE(filelist LE inst[0]+'_'+STRCOMPRESS(STRING(century),/re)+STRCOMPRESS(STRING(year),/re)+'_'+STRMID(STRING(f='(I3)',100+mon),1,2)+'_'+STRMID(STRING(f='(I7)',1000000+numor),1,6)+'.'+STRMID(STRING(f='(I4)',1000+ROUND(100*par5[3])),1,3),count)
      IF count GT 0 THEN tmp=MAX(filelist[tmp]) ELSE tmp=MIN(filelist)
      PRINT,tmp,' will be taken for calibration'
    ENDELSE
    calfile=STRCOMPRESS(tmp,/re)
  ENDIF
  ON_IOERROR,badmisread
  IF bad_flag EQ 1  OR  bad_flag NE 1 THEN BEGIN
    count=N_ELEMENTS(psd_d20)
    IF count LT 1 THEN psd_d20=['empty']
    IF STRPOS(psd_d20[0],'.bad') LE 0 THEN BEGIN
      IF count LT 2 THEN BEGIN
        tmf     =PATHCAL ; P_LAMBDA(0)+'/BAD_CELLS/'
        CD,current=current_dir,tmf
        tmp     =file_search(tmf+inst[0]+'_????_??_??????.bad',count=tmc) ; NEW  file names
        CD,current_dir
        IF tmc GT 0 THEN badlist=STRMID(tmp,STRPOS(tmp[0],inst[0]),22) ELSE PRINT,"Are you really on the right workstation?"
        IF N_ELEMENTS(badlist) LE 0 THEN BEGIN
          PRINT,'NO bad cells file found!'
          psd_d20=['empty']
          bad_flag=0
          badlist=''
        ENDIF ELSE BEGIN
          IF bad_flag EQ 1 THEN PRINT,'Creating new bad cells filelist'
          IF bad_flag EQ 1 THEN PRINT,' ',badlist
        ENDELSE
        psd_d20=[STRING(psd_d20[0]),badlist]
      ENDIF ELSE badlist=psd_d20[1:count-1]
      tmp=WHERE(badlist LE inst[0]+'_'+STRCOMPRESS(STRING(century),/re)+STRCOMPRESS(STRING(year),/re)+'_'+STRMID(STRING(f='(I3)',100+mon),1,2)+'_'+STRMID(STRING(f='(I7)',1000000+numor),1,6)+'.'+'bad',count)
      IF count GT 0 THEN tmp=MAX(badlist[tmp]) ELSE  tmp=MIN(badlist)
      IF psd_d20[0] NE tmp THEN BEGIN
        psd_d20[0]=tmp
        IF bad_flag EQ 1 THEN PRINT,'data       : ',PATHCAL+psd_d20[0]
        bad_d20=rddat('data',PATHCAL,psd_d20[0],rddat_status,rddat_datp)
        PRINT,'Bad_cells file loaded : ',psd_d20[0]
        IF bad_flag EQ 1 THEN PRINT,'Bad cells: ',STRCOMPRESS(ROUND(bad_d20))
      ENDIF
    ENDIF
  ENDIF
  badmisread:
  ON_IOERROR,rocmisread
  IF roc_flag EQ 1  OR  roc_flag NE 1 THEN BEGIN
    count=N_ELEMENTS(psdroc_d20)
    IF count LT 1 THEN psdroc_d20=['empty']
    IF STRPOS(psdroc_d20[0],'.roc') LE 0 THEN BEGIN
      IF count LT 2 THEN BEGIN
        tmf     =PATHCAL ; P_LAMBDA(0)+'/BAD_CELLS/'
        CD,current=current_dir,tmf
        tmp     =file_search(tmf+inst[0]+'_????_??_??????.roc',count=tmc) ; NEW  file names
        CD,current_dir
        IF tmc GT 0 THEN roclist=STRMID(tmp,STRPOS(tmp[0],inst[0]),22) ELSE PRINT,"Are you really on the right workstation?"
        IF N_ELEMENTS(roclist) LE 0 THEN BEGIN
          PRINT,'NO ROC correction file found!'
          PRINT,'ROC1'
          psdroc_d20=['empty']
          roc_flag=0
          roclist=''  
		  ;print,n_elements(wout[*,0,0])
		  ;help,roc_d20
          roc_d20=fltarr(n_elements(wout[*,0,0]))+1.0      ; MAYBE THIS HELPS? thomas.christian.hansen 20121003
		  ;help,roc_d20
        ENDIF ELSE BEGIN
          IF roc_flag EQ 1 THEN PRINT,'Creating new ROC correction filelist'
          IF roc_flag EQ 1 THEN PRINT,' ',roclist
        ENDELSE
        psdroc_d20=[STRING(psdroc_d20[0]),roclist]
      ENDIF ELSE roclist=psdroc_d20[1:count-1]
      IF N_ELEMENTS(roclist) GT 1 OR STRLEN(roclist[0]) GT 0 THEN BEGIN
        tmp=WHERE(roclist LE inst[0]+'_'+STRCOMPRESS(STRING(century),/re)+STRCOMPRESS(STRING(year),/re)+'_'+STRMID(STRING(f='(I3)',100+mon),1,2)+'_'+STRMID(STRING(f='(I7)',1000000+numor),1,6)+'.'+'roc',count)
        IF count GT 0 THEN tmp=MAX(roclist[tmp]) ELSE  tmp=MIN(roclist)
        IF psdroc_d20[0] NE tmp THEN BEGIN
          psdroc_d20[0]=tmp
          IF roc_flag EQ 1 THEN PRINT,'data       : ',PATHCAL+psdroc_d20[0]
          ;roc_d20=rddat('data',PATHCAL,psdroc_d20[0],rddat_status,rddat_datp)
roc_d20=fltarr(n_elements(wout[*,0,0]))+1.0
openr,u_roc,/get,PATHCAL+psdroc_d20[0]
readf,u_roc,roc_d20
free_lun,u_roc
          PRINT,'ROC correction file loaded : ',psdroc_d20[0]
          IF roc_flag EQ 1 THEN PRINT,'ROC Corrections: ',STRCOMPRESS((roc_d20))  
          ;help,roc_d20
        ENDIF
      ENDIF
    ENDIF
    
  ENDIF
  rocmisread:
  IF wav_flag EQ 1 THEN BEGIN
    count=N_ELEMENTS(wav_d20)
    IF count LT 1 THEN wav_d20=[0.,0.,0.]
    IF count LT 4 THEN BEGIN
      p_lambda,plambda
      tmf     =PLAMBDA+'/RIETVELD/'
      CD,current=current_dir,tmf
      tmp     =file_search(tmf+'?????????.d20',count=tmc)
      CD,current_dir
      IF tmc GT 0 THEN filelist=LONG(STRMID(tmp,STRPOS(tmp[0],'.d20')-9,9))
      IF N_ELEMENTS(filelist) LE 0 THEN BEGIN
        PRINT,'NO wavelength/zeroshift file found!'
        wav_d20=[0.,0.,0.]
        bad_flag=0
        filelist=''
      ENDIF ELSE PRINT,'Creating newwavelength/zeroshift file list',filelist
      wav_d20=[wav_d20[0:2],filelist]
    ENDIF ELSE filelist=wav_d20[1:count-1]
    tmp=WHERE(filelist LE LONG(cycle)*1000000+numor,count)
    IF count GT 0 THEN tmp=MAX(filelist[tmp]) ELSE tmp=MIN(filelist)
    wav_d20[0]=LONG(tmp)
    OPENR,tmp,tmf+STRING(STRCOMPRESS(wav_d20[0],/REMOVE_ALL))+'.d20',/get_lun
    READF,tmp,line
    READF,tmp,wav_d20[1:2]
    FREE_LUN,tmp
  ENDIF
  IF N_ELEMENTS(inf_d20) GE 3 THEN IF N_ELEMENTS(calfile) GE 1 THEN IF calfile NE inf_d20[0] THEN IF inf_d20[2] EQ 'autod20.cal' THEN BEGIN
    inf_d20[2] = 'autochoice'
    p_did_calod, INST[0],calfile, flg
    inf_d20[2] = 'autod20.cal'
  ENDIF
  IF N_ELEMENTS(inf_d20) GE 2 THEN BEGIN
    IF STRMID(inf_d20[1],37,8) LT '3' THEN wavelength=FLOAT(STRMID(inf_d20[1],37,8))
  ENDIF ELSE wavelength=0
  ;####### Efficiency Correction by MULTIPLICATION with efficiency-CORRECTION data! ###########
  IF float_flag EQ 1 THEN WOUT=FLOAT(WOUT)
  IF N_ELEMENTS(cal_d20[*,0]) EQ nd AND eff_flag EQ 1 THEN BEGIN
    OT=OT+'*'+inf_d20[0]
    FOR i=0,nj-1 DO FOR j=0,nd-1 DO BEGIN
      wout[j,i]=wout[j,i]*cal_d20[j,0]
      EE[j,i]= EE[j,i]*cal_d20[j,0]
    ENDFOR
  ENDIF
  IF N_ELEMENTS(roc_d20[*,0]) EQ nd AND roc_flag EQ 1 THEN BEGIN
    OT=OT+'*'+psdroc_d20[0]
    FOR i=0,nj-1 DO FOR j=0,nd-1 DO BEGIN
      wout[j,i]=wout[j,i]*roc_d20[j,0]
      EE[j,i]= EE[j,i]*roc_d20[j,0]
    ENDFOR
  ENDIF
  IF N_ELEMENTS(cal_d20[*,0]) EQ 0 THEN cal_d20=0
  IF float_flag NE 1 THEN BEGIN
    IF eff_flag EQ 1 OR normalize GT 0 THEN PRINT,'Attention : Workspace is NOT floating point, but it should be!'
  ENDIF
  SequenceType    = par1[0]
  StroboType      = par1[40]
  NbOfSegments    = par1[1]
  PV = FLTARR(31,scan)
  NN = FLTARR(scan)
  FOR i=0,scan-1 DO BEGIN
    PV[0:4,i]   = par1[0:4]
    PV[5,i]     = par1[51]		    				; CntTime in sec.
    PV[6:7,i]   = par5[26:27]	  					; RtrPower,D19
    PV[8,i]     = par5[14]		    				; OS
    PV[9:19,i]  = param[0:10] 	 					; SampEnv,TempValues,MotorValues,Voltmeter1
    PV[20,i]    = (par5[12]<30)+(par5[13]<30) 	 	; hor.  MonoSlits
    PV[21,i]    = (par5[10]<140)+(par5[11]<140) 	 	; vert. MonoSlits
    PV[22,i]    = par5[18]+par5[19] 	 				; hor.  SampleSlits
    PV[23,i]    = par5[16]+par5[17] 	 				; vert. SampleSlits
    PV[24,i]    = 0.0		         				; TimeStep
    PV[25:27,i] = par1[45:47]	  					; TimeSlice,TimeDelay,TimeWindow
    PV[28,i]    = i             						; Slice_No or sub-numor, for scans it will contain the inner stepwidth (later on ...)
    PV[29,i]    = numor
    PV[30,i]    = par1[50]      						; monitor
    NN[i]       = par1[50]
  ENDFOR
  IF nj LE 1 THEN NN = par1[50]
  IF N_ELEMENTS(vparm) GE 1 THEN BEGIN
    IF N_ELEMENTS(vparm[*,0]) GE 26 THEN BEGIN                                 ; NOT Stroboscopie
      PV[0:4,*]  = vparm[0:4,*]
      PV[5:20,*] = vparm[6:21,*]
      PV[5,*]    = PV[5,*]/1000000.                          ; CntTime in sec (not microsec)
      NN[*]= (vparm[5,*] EQ 0.)*NN[*]+vparm[5,*]
      PV[30,*]=nn[*]
    ENDIF ELSE BEGIN
      IF N_ELEMENTS(vparm[*,0]) GE 5 THEN BEGIN
        PV[25:27,*]= vparm[0:2,*]
        PV[5,*]    = vparm[4,*] /1000000.                          ; time in sec (not microsec)
        NN[*]= (vparm[3,*] EQ 0.)*NN[*]/PV[5,0]*PV[5,*]+vparm[3,*] ; tot.monitor if slice-mon. zero
        IF vparm[4,0] LT vparm[3,0] THEN BEGIN                     ; Monitor-time confusion in the reading of the 51st scaler
          PV[5,*]    = vparm[3,*] /1000000.                        ; time in sec (not microsec)
          NN[*]      = vparm[4,*]
          IF nvers EQ 2 THEN BEGIN
            brico=INDGEN(nj)*3
            brico=brico[WHERE(brico LT nj)]
            PV[26:27,brico]= vparm[0:1,brico]                                ; even more confusions
            PV[25,brico]   = vparm[2,brico]                                  ; even more confusions
            brico=INDGEN(nj)*3+1
            brico=brico[WHERE(brico LT nj)]
            PV[25:26,brico]= vparm[1:2,brico]                                ; even more confusions
            PV[27,brico]   = vparm[0,brico]                                  ; even more confusions
          ENDIF
        ENDIF
        PV[30,*]=nn[*]
      ENDIF
    ENDELSE
  ENDIF
  IF cor_flag EQ 1 THEN IF Cycle LE 974 THEN IF cycle GE 973 THEN IF numor LE 20200 THEN IF numor GE 8451 THEN BEGIN
    IF StroboType EQ 0 THEN IF scan EQ 1 OR SequenceType NE 0 THEN BEGIN
      p_lambda,plambda
      corname =PLAMBDA+'/MONITOR/'+STRCOMPRESS(STRING(LONG(cycle)), /REMOVE_ALL)+'.cor'
      OPENR,cor,corname,/get_lun
      READF,cor,corrections
      IF corrections GT 0 THEN BEGIN
        cornum=FLTARR(3,corrections)
        READF,cor,cornum
      ENDIF
      FREE_LUN,cor
      corind=WHERE(cornum[0,*] EQ numor,corrections)
      IF corrections EQ 1 THEN BEGIN
        PRINT,'Corrections will be applied: ',corname
        cornum=cornum[1:2,corind]
        PV[30,*]=PV[30,*]-cornum[0]
        NN      =NN      -cornum[0]
        PV[5,*] =PV[5,*] -cornum[1]
      ENDIF ELSE PRINT,'Looked for corrections but found nothing',corrections
    ENDIF
  ENDIF
  MotPar=FLTARR(6)
  MotTxt=['2*Theta/deg.     ','Omega  /deg.     ',$
    'Chi    /deg.     ','Phi    /deg.     ',$
    'Tr.1   /mm (horz)','Tr.2   /mm (vert)']
  FOR i=0,5 DO BEGIN
    IF par1[12+i*5] EQ 0.0 THEN BEGIN
      MotPar[i]=param[4+i]
      MotTxt[i]=MotTxt[i]+'       '
    ENDIF ELSE BEGIN
      MotPar[i]=par1[12+i*5]
      MotTxt[i]=MotTxt[i]+'       '
    ENDELSE
  ENDFOR
  step_or_sub='Sub-Numor or Slice-No.  '
  ScanText=   'Unknown Scan Type       '
  IF  SequenceType EQ  0 THEN ScanText='Single Data Acquisition '
  IF  SequenceType EQ  1 THEN ScanText='Sequential Acquisition  '
  IF  SequenceType EQ  2 THEN ScanText='Temperature Scan        '
  IF  SequenceType EQ  3 THEN ScanText='2Theta Scan             '
  IF  SequenceType EQ  4 THEN ScanText='Omega Scan              '
  IF  SequenceType EQ  5 THEN ScanText='Chi Scan                '
  IF  SequenceType EQ  6 THEN ScanText='Phi Scan                '
  IF  SequenceType EQ  7 THEN ScanText='Translation 1 Scan      '
  IF  SequenceType EQ  8 THEN ScanText='Translation 2 Scan      '
  IF  SequenceType EQ  9 THEN ScanText='Other Scan              '
  inner=LONG(SequenceType)-2
  IF  SequenceType GT 10 THEN BEGIN
    ScanTextArray=['Sing.','Sequ.','Temp.','2Th. ','Omega','Chi  ','Phi  ','Tr.1 ','Tr.2 ','Seven','Else ']
    ScanText=ScanTextArray[(LONG(SequenceType) /   10)<10]
    outertext=ScanText
    outer=(LONG(SequenceType)  /  10) - 2
    ScanText=ScanTextArray[(LONG(SequenceType) MOD   10)<10]
    innertext=ScanText
    inner=(LONG(SequenceType) MOD 10) - 2
    ScanText=outerText+'/'+innertext+'coupled Scan '
  ENDIF
  IF inner GE 0 THEN BEGIN
    PV[28,*]=par1[7+inner*5]
    step_or_sub='Sub-Numor or Slice-No.  '
    step_or_sub='(inner) Scan Step-Width '
  ENDIF
  PP  =[PV[0:30],par5[0:1],par5[3],$
    StroboType,$
    par1[41],0,0,0,0]
  IF CntTime EQ 0.0 THEN BEGIN            ; IF Real Counting Time not measured
    CntTime=PV[25,0]*PP[35]/8000000.      ; missing 51st scaler, 1 ACQ = 1 Slice (before modification)
    PV[5,*]=PV[5,*]>(PV[25,*]*PP[35]/8000000.)
  ENDIF
  IF CntTime LT 0.0 THEN BEGIN            ; Real Counting Time GE 1 hour: Value becomes negative
    CntTime=PV[25,0]*PP[35]/8000000.*2.   ; 51st scaler present, 1 ACQ = 2 Slices (after modification)
    IF StroboType EQ 0 THEN PV[5,*]=PV[5,*]>(PV[25,*]*PP[35]/8000000.*2.) ELSE PV[5,*]=PV[5,*]>(PV[25,*]*PP[35]/8000000.)
  ENDIF
  PP[5]=TOTAL(PV[5,*])                    ; Total counting time in fixed parameter
  CntTime=PP[5]
  IF charpos NE 0 THEN BEGIN
    day  = STRCOMPRESS(STRING(LONG(day)   -   LONG(CntTime)  /  86400),/remove_all)
    hour  =STRCOMPRESS(STRING(LONG(hour)  -  (LONG(CntTime) MOD 86400)  /  3600),/remove_all)
    minute=STRCOMPRESS(STRING(LONG(minute)- ((LONG(CntTime) MOD 86400) MOD 3600)  /  60),/remove_all)
    second=STRCOMPRESS(STRING(LONG(second)-(((LONG(CntTime) MOD 86400) MOD 3600) MOD 60)),/remove_all)
    IF LONG(second) LT 0 THEN BEGIN
      second = STRCOMPRESS(STRING(LONG(second)+60),/remove_all)
      minute = STRCOMPRESS(STRING(LONG(minute)- 1),/remove_all)
    ENDIF
    IF LONG(minute) LT 0 THEN BEGIN
      minute = STRCOMPRESS(STRING(LONG(minute)+60),/remove_all)
      hour   = STRCOMPRESS(STRING(LONG(hour  )- 1),/remove_all)
    ENDIF
    IF LONG(hour  ) LT 0 THEN BEGIN
      hour   = STRCOMPRESS(STRING(LONG(hour  )+60),/remove_all)
      day    = STRCOMPRESS(STRING(LONG(day   )- 1),/remove_all)
    ENDIF
    IF LONG(day   ) LT 0 THEN BEGIN
      second = STRCOMPRESS(STRING(0),/remove_all)
      minute = STRCOMPRESS(STRING(0),/remove_all)
      hour   = STRCOMPRESS(STRING(0),/remove_all)
      day    = STRCOMPRESS(STRING(1),/remove_all)
    ENDIF
    day='00'+day
    day=STRMID(day,STRLEN(day)-2,2)
    hour='00'+hour
    hour=STRMID(hour,STRLEN(hour)-2,2)
    minute='00'+minute
    minute=STRMID(minute,STRLEN(minute)-2,2)
    second='00'+second
    second=STRMID(second,STRLEN(second)-2,2)
    DATI=day+"-"+month+"-"+year+""+hour+":"+minute+":"+second
    OT = INST[0]   +' '+ DATI $
      +' User '+STRMID(exper[1],20,8)$
      +' L.C.' +STRMID(exper[4],20,7);$
  ENDIF
  PTXT=[$
    ScanText   $
    ,'Number of Segments      ','Segment Number          '$
    ,'Number of Data Sets     ','Data Set Number         '$
    ,'TOTAL Counting Time/s   ','Reactor Power / MW      '$
    ,'D19 State               ','OS closed/open (0/1)    '$
    ,'Sample Environment      ','Set Temperature         '$
    ,'Regulation Temperature  ','Sample Temperature      '$
    , MotTxt[0:5]$
    ,'Psample / mbars         ','hor. MonoSlits / mm     '$ ; 20101104
    ,'vert. MonoSlits / mm    ','hor. SampleSlits / mm   '$
    ,'vert. SampleSlits / mm  ','Time Step               '$
    ,'Time Slice              ','Time Delay              '$
    ,'Time Window             ', step_or_sub              $
    ,'Numor                   ','Original Monitor Counts '$
    ,'Incid. divergence alpha1','HOPG Filters IN/OUT     '$
    ,'Wavelength / Angstroem  '$
    ,'Stroboscopic Mode       ','Number of strob. Cycles '$
    ,'Calibration Wavelength/A','Raw Data TwoTheta Offset'$
    ,'Correction Eff./Ang./Bad','Normalisation Mon./Time '$
    ,'Monochromator TakeOff   ','Monochromator Changer   '$
    ,'Monochromator Rocking   ','Monochromator Tilt      '$
    ,'Monochromator Bending   ','Lead Blocks             '$
    ,'Monochromator Slit Top  ','Monochromator Slit Bottm'$
    ,'Monochromator Slit Left ','Monochromator Slit Right'$
    ,'Vacuum tube pressure    '$
    ,'Sample Slit Top         ','Sample Slit Bottom      '$
    ,'Sample Slit Left        ','Sample Slit Right       '$
    ,'ReactorCycle            ','Magnetic Field          '$
    ,'Julian Days since 1970  ','Seconds since noon      '$
    ,'Flipper1                ','Flipper2                '$
    ,'(spare)                 ','Temp2                   '$
    ,'P(setpoint)/bars        ','P(compressor)/bars      '$
    ,'P(buffer)/bars          ','Voltmeter/V             '$
    ,'DAC1/V                  ','DAC2/V                  '$ ; DAC added 20110723
    ,'DAC3/V                  ','DAC4/V                  '$
	,'changer rotation / deg  ','changer translation / mm'] ;  changer added 20141211
  mag=0.0
   IF N_ELEMENTS(param) GE 16 THEN mag=param[15]
  param=[param,fltarr(20)] ; fltarr(5) replaced by fltarr(15) to avoid problems two lines below ... thomas.christian.hansen 20121003
  PP=[PP,par5[4:13],par5[15:19],par5[25],mag,jul_day,jul_sec,param[16:19],param[11:14],$  ; here WAS the mistake with 1997 data, corrected 02/2011
                                                                          param[20:23],$  ; DAC (4 values) added 20110723       
                                                                          param[25:26]]   ; changer (2 values) added 20141211       
  FOR i=0,N_ELEMENTS(PP)-1 DO PTXT[i]=PTXT[i]+' ('+STRMID(STRCOMPRESS(100+i,/RE),1,2)+')'
  IF N_ELEMENTS(PV[0,*]) GT 1 THEN BEGIN
    PV_tmp=PV
    old_dim=N_ELEMENTS(PV[*,0])
    PV=FLTARR(N_ELEMENTS(PP),N_ELEMENTS(PV[0,*]))
    PV[0:old_dim-1,*]=PV_tmp[0:old_dim-1,*]
    FOR i=0,scan-1 DO PV[old_dim:N_ELEMENTS(PP)-1,i]=PP[old_dim:N_ELEMENTS(PP)-1]
  ENDIF ELSE BEGIN
    PV=[PV,PP[N_ELEMENTS(PV):N_ELEMENTS(PP)-1]]
  ENDELSE
  IF N_ELEMENTS(pv[*,0] GE 55) THEN IF N_ELEMENTS(vparm[*,0]) GE 35 THEN BEGIN
    pv[51:54,*]=vparm[26:29,*]
    pv[41,*]=vparm[31,*]
    pv[42,*]=vparm[30,*]
    pv[43,*]=vparm[32,*]
    pv[44,*]=vparm[34,*]
    pv[32,*]=vparm[33,*]
  ENDIF
  IF year GT 60 THEN twotheta_offset=-32.2 ELSE twotheta_offset=0.0
  tmparr=FINDGEN(nd)/10.
  IF nd EQ 3200 THEN BEGIN ; NEW CLET 8 JULY 2014 TCH
  	tmparr=(tmparr)/2. 
	; 19 SEP 2014 TCH correct for first amplifyer box potentially zero-counting ...
	IF TOTAL(WOUT[0:63]) NE 0 OR TOTAL(WOUT[3072:3199]) EQ 0 THEN tmparr=tmparr+3.2
  ENDIF
	;print,tmparr[0:1]
  PP[38]= (N_ELEMENTS(cal_d20) EQ nd AND eff_flag EQ 1)
  IF ang_flag NE 0 AND N_ELEMENTS(ang_d20) EQ nd AND N_ELEMENTS(cal_d20) EQ nd THEN BEGIN
    PP[38]= PP[38]+2
    twotheta_offset = ang_d20[0]
    tmparr=ang_d20-twotheta_offset
    PP[38]= PP[38]+2*(N_ELEMENTS(ang_d20) EQ nd)
    IF wav_flag NE 0 THEN IF Wavelength NE 0 THEN PP[36]=Wavelength
  ENDIF
  IF (TwoTheta_OffSet+PP[13] GE 10 AND nd EQ 1600) THEN TwoTheta_Offset=TwoTheta_Offset-66.666667
  PV[13,*]=TwoTheta_OffSet+PV[13,*]
  PP[13]  =TwoTheta_OffSet+PP[13]
  PP[37]  =TwoTheta_Offset
  XX      =PV[13,0]+tmparr
  ;PRINT,XX[0:10] ; DEBUG 16JUL14 TCH
  tmp     =WHERE([SequenceType,LONG(SequenceType)/10,LONG(SequenceType) MOD 10] EQ 3,count)
  IF count GE 1 THEN BEGIN
    XX=FLTARR(nd,scan)
    FOR i=0,nd-1 DO XX[i,*]=PV[13,*]+tmparr[i]
  ENDIF
  XT  ='2*Theta'
  IF scan GT 1 THEN BEGIN
    YY=FINDGEN(scan)
    IF StroboType LE 0 THEN BEGIN
      IF (SequenceType) MOD 10 GE  2 AND LONG(SequenceType) MOD 10 LE 8 THEN YY[*] = PV[10+LONG(SequenceType) MOD 10,*]
    ENDIF
  ENDIF ELSE YY = ROUND(numor)
  IF StroboType LE 0 THEN YT='Steps' ELSE YT='Slices'
  IF scan LE 1 THEN BEGIN
    YT = 'Counts'
    IF normalize NE 0 THEN YT=YT+'*'+STRCOMPRESS(STRING(ROUND(normalize/PP[30])),/remove_all)+')'
  ENDIF ELSE BEGIN
    IF StroboType LE 0 THEN YT=ScanText
    IF MAX(YY)-MIN(YY) EQ 0.0 THEN BEGIN
      YY=INDGEN(scan)
      IF StroboType LE 0 THEN YT='Steps' ELSE YT='Slices'
    ENDIF
  ENDELSE
  IF  SequenceType GT 10 THEN BEGIN
    YT='Steps'
    YY=INDGEN(scan)
  ENDIF
  IF scan LE 1 THEN BEGIN
    ZT = 'Counts'
    IF normalize NE 0 THEN ZT=ZT+'('+STRCOMPRESS(STRING(normalize),/remove_all)+')'
  ENDIF ELSE ZT  ='Numor' & ZZ=PV
  DATE=DATI
  
  w=wout
  zerocounters=WHERE(TOTAL(REFORM(wout,N_ELEMENTS(wout[*,0]),N_ELEMENTS(wout[0,*])),2) LE 0)
  tmp=N_ELEMENTS(ZeroCounters)
  NbOfZeroCounters=tmp
  tmp=0*ZeroCounters
  IF N_ELEMENTS(bad_d20) GE 1 AND NbOfZeroCounters GE 1 THEN FOR i=0,NbOfZeroCounters-1 DO BEGIN
    FOR j=0,N_ELEMENTS(bad_d20)-1 DO BEGIN
      IF bad_d20[j] EQ ZeroCounters[i] THEN tmp[i]=1
    ENDFOR
  ENDFOR
  IF N_ELEMENTS(bad_d20) GE 1 AND NbOfZeroCounters GE 1 THEN BEGIN
    ind=WHERE(tmp,count)
  ENDIF
  tmp=TOTAL(REFORM(w,N_ELEMENTS(w[*,0]),N_ELEMENTS(w[0,*])),2)
  ind=FINDGEN(N_ELEMENTS(tmp)-4)+2
  
  smoothed=tmp
  smoothed[ind]=2./3.*(tmp[ind-1]+tmp[ind-1])-(tmp[ind-2]+tmp[ind-2])/6.>0
  
  tmp0=TOTAL(REFORM(EE,N_ELEMENTS(EE[*,0]),N_ELEMENTS(EE[0,*])),2)/SQRT(N_ELEMENTS(EE[0,*]))
  tmp1=tmp-tmp0
  tmp2=tmp+tmp0
  
  MCounters=2+WHERE(tmp2[ind] LT (tmp1[ind-2]+tmp1[ind+2])/2./1.06 AND tmp1[ind-1]/1.02 GT (3.*tmp2[ind-2]+tmp2[ind+2])/4. AND tmp1[ind+1]/1.02 GT (tmp2[ind-2]+3.*tmp2[ind+2])/4.,NbOfMCounters)
  IF NbOfMCounters GE 2 THEN MCounters=MCounters[SORT((tmp[MCounters+2]+tmp[MCounters+1]+tmp[MCounters]+tmp[MCounters-1]+tmp[MCounters-2])/((tmp[MCounters+1]+tmp[MCounters-1])/2.-tmp[MCounters]))]
  tmp0=0*MCounters
  IF N_ELEMENTS(bad_d20) GE 1 AND NbOfMCounters GE 1 THEN FOR i=0,NbOfMCounters-1 DO BEGIN
    FOR j=0,N_ELEMENTS(bad_d20)-1 DO BEGIN
      IF bad_d20[j] EQ MCounters[i] THEN tmp0[i]=1
    ENDFOR
  ENDFOR
  IF N_ELEMENTS(bad_d20) GE 1 AND NbOfMCounters GE 1 THEN BEGIN
    ind0=WHERE(tmp0,count)
  ENDIF
  
  WCounters=2+WHERE(tmp1[ind]/1.06 GT (tmp2[ind-2]+tmp2[ind+2])/2. AND tmp2[ind-1] LT (3.*tmp1[ind-2]+tmp1[ind+2])/4./1.02 AND tmp2[ind+1] LT (tmp1[ind-2]+3.*tmp1[ind+2])/4./1.02,NbOfWCounters)
  IF NbOfWCounters GE 2 THEN WCounters=WCounters[SORT((tmp[WCounters+2]+tmp[WCounters+1]+tmp[WCounters]+tmp[WCounters-1]+tmp[WCounters-2])/(tmp[WCounters]-(tmp[WCounters+1]+tmp[WCounters-1])/2.))]
  tmp0=0*WCounters
  IF N_ELEMENTS(bad_d20) GE 1 AND NbOfWCounters GE 1 THEN FOR i=0,NbOfWCounters-1 DO BEGIN
    FOR j=0,N_ELEMENTS(bad_d20)-1 DO BEGIN
      IF bad_d20[j] EQ WCounters[i] THEN tmp0[i]=1
    ENDFOR
  ENDFOR
  IF N_ELEMENTS(bad_d20) GE 1 AND NbOfWCounters GE 1 THEN BEGIN
    ind0=WHERE(tmp0,count)
  ENDIF
  
  ind=FINDGEN(N_ELEMENTS(tmp)-4)+2
  
  LowCounters =2+WHERE(tmp[ind] LT (smoothed[ind]-4.*SQRT(smoothed[ind]>0))-ABS(2.*smoothed[ind]-tmp[ind-1]-tmp[ind+1])/1.-ABS(tmp[ind-1]-tmp[ind+1])/2. AND tmp[ind] GT 0,NbOfLowCounters)
  IF NbOfLowCounters GE 2 THEN LowCounters=LowCounters[SORT(smoothed[LowCounters]/(smoothed[LowCounters]-tmp[LowCounters]))]
  tmp0=0*LoWCounters
  IF N_ELEMENTS(bad_d20) GE 1 AND NbOfLoWCounters GE 1 THEN FOR i=0,NbOfLoWCounters-1 DO BEGIN
    FOR j=0,N_ELEMENTS(bad_d20)-1 DO BEGIN
      IF bad_d20[j] EQ LoWCounters[i] THEN tmp0[i]=1
    ENDFOR
  ENDFOR
  IF N_ELEMENTS(bad_d20) GE 1 AND NbOfLoWCounters GE 1 THEN BEGIN
    ind0=WHERE(tmp0,count)
  ENDIF
  
  HighCounters =2+WHERE(tmp[ind] GT (smoothed[ind]+4.*SQRT(smoothed[ind]>0))+ABS(2.*smoothed[ind]-tmp[ind-1]-tmp[ind+1])/1.+ABS(tmp[ind-1]-tmp[ind+1])/2.,NbOfHighCounters)
  IF NbOfHighCounters GE 2 THEN HighCounters=HighCounters[SORT(smoothed[HighCounters]/tmp[(HighCounters)-smoothed[HighCounters]])]
  tmp0=0*HighCounters
  IF N_ELEMENTS(bad_d20) GE 1 AND NbOfHighCounters GE 1 THEN FOR i=0,NbOfHighCounters-1 DO BEGIN
    FOR j=0,N_ELEMENTS(bad_d20)-1 DO BEGIN
      IF bad_d20[j] EQ HighCounters[i] THEN tmp0[i]=1
    ENDFOR
  ENDFOR
  IF N_ELEMENTS(bad_d20) GE 1 AND NbOfHighCounters GE 1 THEN BEGIN
    ind0=WHERE(tmp0,count)
  ENDIF
  
  good_cells           =INDGEN(nd)
  IF bad_flag EQ 1 AND N_ELEMENTS(bad_d20) GE 1 THEN BEGIN
    PP[38]= PP[38]+4
    good_cells[bad_d20]=-1
    good_cells           =good_cells[WHERE(good_cells GE 0)]
  ENDIF
  IF (bad_flag EQ 1 AND N_ELEMENTS(bad_d20) GE 1) THEN BEGIN
    ZZ=[bad_d20]
  ENDIF ELSE ZZ=[0]
  IF N_ELEMENTS(bad_d20) GE 1 THEN ZZ=[bad_d20] ELSE ZZ=[0]
  IF interpol_flag EQ 1 THEN BEGIN
    IF (bad_flag EQ 1 AND N_ELEMENTS(bad_d20) GE 1) THEN BEGIN
      IF (N_ELEMENTS(ang_d20) NE nd OR ang_flag EQ 0 OR N_ELEMENTS(cal_d20) NE nd) THEN BEGIN ;noang
        PP[38]= PP[38]+8
        IF N_ELEMENTS(WOUT[0,*]) GE N_ELEMENTS(XX[0,*]) THEN BEGIN
          FOR i=0,N_ELEMENTS(WOUT[0,*])-1 DO BEGIN
            WOUT[bad_d20,i]=interpol(WOUT[good_cells,i],XX[good_cells],XX[bad_d20])
            EE[  bad_d20,i]=interpol(EE[  good_cells,i],XX[good_cells],XX[bad_d20])
          ENDFOR
        ENDIF ELSE BEGIN
          WOUT[bad_d20,*]=interpol(WOUT[good_cells,*],XX[good_cells],XX[bad_d20])
          EE[  bad_d20,*]=interpol(EE[  good_cells,*],XX[good_cells],XX[bad_d20])
        ENDELSE
      ENDIF
    ENDIF
    IF N_ELEMENTS(ang_d20) EQ nd AND N_ELEMENTS(cal_d20) EQ nd AND ang_flag EQ 1 THEN BEGIN
      PP[38]= PP[38]+8
      IF N_ELEMENTS(WOUT[0,*]) GE N_ELEMENTS(XX[0,*]) THEN BEGIN
        XXold=XX[good_cells]
        XX=XX[0]+FINDGEN(nd)/10.
        FOR i=0,N_ELEMENTS(WOUT[0,*])-1 DO BEGIN
          WOUT[*,i]=interpol(WOUT[good_cells,i],XXold,XX)
          EE[  *,i]=interpol(EE[  good_cells,i],XXold,XX)
        ENDFOR
      ENDIF ELSE BEGIN
        XXold=XX[good_cells]
        FOR i=0,N_ELEMENTS(WOUT[0,*])-1 DO XX[*,i]=XX[0,i]+FINDGEN(nd)/10.
        WOUT=interpol(WOUT,XXold,XX)
        EE  =interpol(EE  ,XXold,XX)
      ENDELSE
      
    ENDIF;ang
  ENDIF ELSE BEGIN ; NO interpolation
    IF bad_flag EQ 1 AND N_ELEMENTS(bad_d20) GE 1 THEN BEGIN
      WOUT=WOUT[good_cells,*]
      XX  =XX[  good_cells,*]
      EE  =EE[  good_cells,*]
    ENDIF
  ENDELSE
  IF normalize GT 0 AND MIN(NN) GT 0 THEN BEGIN
    FOR i=0,scan-1 DO BEGIN
      WOUT[*,i]=      WOUT[*,i]/ NN[i]*normalize
      EE[  *,i]=      EE[  *,i] /NN[i]*normalize
    ENDFOR
    par1[54]=par1[54]/par1[50]*normalize ; 2nd monitor
    normalization_factor=NN
    normalization_factor=NN/normalize
    normalization_factor=1./normalization_factor
    NN=NN*0+normalize
    PP[39]=normalize
    normalization_factor=NN/normalize
  ENDIF
  IF N_ELEMENTS(pv[0,*]) GT 1 THEN BEGIN
    ;help,NN
    IF normalize GT 0 AND MIN(NN) GT 0 THEN BEGIN
      NN=[[REFORM(NN,1,1,N_ELEMENTS(NN))],[REFORM(PV[5,*]*normalization_factor,1,1,N_ELEMENTS(PV[5,*]))],[REFORM(PV[5,*]*0.+par1[54]*normalization_factor,1,1,N_ELEMENTS(PV[5,*]))]]
    ENDIF ELSE BEGIN
      NN=[[REFORM(NN,1,1,N_ELEMENTS(NN))],[REFORM(PV[5,*],1,1,N_ELEMENTS(PV[5,*]))],[REFORM(PV[5,*]*0.+par1[54],1,1,N_ELEMENTS(PV[5,*]))]]
    ENDELSE
  ENDIF ELSE BEGIN
    IF normalize GT 0 AND MIN(NN) GT 0 THEN BEGIN
      NN=[[NN],[PV[5,*]*normalization_factor],[par1[54]*normalization_factor]]
    ENDIF ELSE BEGIN
      NN=[[NN],[PV[5,*]],[par1[54]]] ; Mod. 4/2/98 Hansen: 2nd monitor
    ENDELSE
  ENDELSE
  IF float_flag EQ 0 THEN WOUT=LONG(WOUT)
  RETURN
END
