function elascan_remove, w_in, badpoints
;+
;******* **************
;** User callable
;*******************************************************************************
;**
;** Remove the points given in array badpoints.
;** Call: w10=elascan_remove(w1,[12,13,20])
;** Note that the indexes of the points to remove must be given considering
;** that the first point is the number 1.
;**
;*******************************************************************************
;-

; ------------------------------------------------------------------------------
; Check for consistancies

w_out=w_in
s_in=size(w_in)
if (s_in[0] ne 2) then begin
   print
   print,'Elascan_remove:'
   print,' Data workspace is not a 2D array. Not valid input!'
   print,' NOTHING DONE!!!'
   return,0
endif
ntemperatures  = s_in[1] & ndetectors = s_in[2]

take_datp, sample         ;take parameters corresponding to w_in
x_out = sample.x ;angle or Q
y_out = sample.y ;temperatures
e_out = sample.e ;errors
n_out = sample.n ;monitor

IF N_ELEMENTS(badpoints) EQ 0 THEN RETURN, w_in

;w_buf = w_in
;w_buf(*, badpoints - 1,*) = 0.0
specs = FLTARR(ndetectors) + 1.
specs[badpoints - 1] = 0.
ispec = WHERE(specs NE 0.0)

w_out = w_in[*,ispec]
e_out = sample.e[*,ispec,*]
y_out = sample.y[ispec]

; Return parameters
mod_datp, sample, 'X', x_out
mod_datp, sample, 'Y', y_out
mod_datp, sample, 'E', e_out
mod_datp, sample, 'N', n_out
give_datp, sample
return,w_out

end
