PRO IN4_summary, numor1, numor2, all=all,cyc=cyc;previous=previous ;cycle=cycle,
;+
;** ***********
;** User callable
;** 
;**  ARGUMENTS
;** ----------
;**  numor1, numor2 (optional)  -> defines first and last numor
;**                                if no numor is specified, then all numors in
;**                                the cycle are summarized
;** 
;**  cycle                      -> cycle number (default is current cycle)
;** 
;**                             KHA,JRS 24/10/06
;**                             LAST MODIFICATION: 05/11/2012 BY SR -> to comply with the data policy!
;**                             LAST MODIFICATION: 18/09/2014 BY SR -> to change the output directory to ~lambda/IN4TEAM/SUMMARY
;-

    iprint = 0
    COMMON c_lamp_access, inst,cycle,path;,irr,cycle1,cycle2,cycle3,cycle4
    COMMON c_lamp_info,   a1,a2,a3,a4,a5,a6,my_path
    COMMON mut,           user, local_contact, main_title, sub_title, $
                          start_time, run_time, loc_inst, temp, date, stop_time, lambda
    cys=cycle
    str=STRMID(my_path[0], strlen(my_path[0])-1,1)
    IF !version.os EQ 'Win32' THEN BEGIN
        if str NE '\' then my_path[0]=my_path[0]+'\'
    ENDIF ELSE BEGIN
        if str NE '/' then my_path[0]=my_path[0]+'/'
    ENDELSE
    ;goto,ici
    ;        IF N_ELEMENTS(cycle) LT 1 THEN BEGIN
    ;               IF N_ELEMENTS(previous) LT 1 THEN BEGIN
    ;               cys = 'Current cycle'
    ;                 IF !version.os EQ 'Win32' THEN $
    ;             inpath = '\\serdon\illdata\data\in4\' ELSE $
    ;             inpath = '/net/serdon/illdata/data/in4/'
    ;               ENDIF ELSE BEGIN
    ;               cys = 'Previous cycle'
    ;                           IF !version.os EQ 'Win32' THEN $
    ;             inpath = '\\serdon\illdata\data-1\in4\' ELSE $
    ;             inpath = '/net/serdon/illdata/data-1/in4/'
    ;               ENDELSE
    ;    ENDIF ELSE BEGIN
    ;                cys = STRTRIM(STRING(cycle),2)
    ;                IF cycle LE 99 THEN cys = '0'  + STRTRIM(STRING(cycle),2)
    ;        IF cycle LE 9  THEN cys = '00' + STRTRIM(STRING(cycle),2)
    ;        IF !version.os EQ 'Win32' THEN $
    ;            inpath = '\\serdon\' + cys + '\in4\' ELSE $
    ;            inpath = '/usr/illdata/' + cys + '/in4/'
    ;    ENDELSE
    ;
    ;ici:  ;IF !version.os EQ 'Win32' THEN $
    ;      ;my_path(0) = my_path(0)+'\' ELSE $
    ;      ;my_path(0) = my_path(0)+'/'
    inpath=path & IF cycle EQ 'Current Path' then inpath=my_path[0]
    ;if n_elements(all) GE 1 THEN BEGIN
    if n_elements(cyc) GE 1 THEN BEGIN
        ;Print,'ERROR: with the /all keyword, the cyc = cycle keyword SHOULD be indicated'
        ;Print,'No file generated'
        ;GOTO,fin
        ;endif
        cys=strcompress(string(cyc),/remove_all)
        IF !version.os EQ 'Win32' THEN BEGIN
            ;       command = '\\serdon\illdata\misc\toolkit\numor_dir'+' in4 '+cys
            ;       SPAWN, command, /HIDE
 ;           inpath='\\serdon\illdata\Numors\'+cys+'\in4\'
            inpath='\\serhom\volumes\data\home\tofhr\lambda\IN4TEAM\SUMMARY\Numors\'+cys+'\in4\'
 
        ENDIF ELSE BEGIN
            ;       s = '/net/serdon/illdata/misc/toolkit/numor_dir'+' in4 '+cys
                   s = '/net/serhom/volumes/data/home/tofhr/lambda/IN4TEAM/SUMMARY/numor_dir'+' in4 '+cys
                   SPAWN, s
            inpath='/net/serhom/volumes/data/home/tofhr/lambda/IN4TEAM/SUMMARY/Numors/'+cys+'/in4/'
        ENDELSE
    ENDIF
    
    print, 'I AM HERE', inpath
    IF !version.os EQ 'Win32' THEN $
        listf = file_search(inpath+'*') ELSE $
        SPAWN, 'ls -l '  + inpath, listf
    IF N_ELEMENTS(listf) LT 2 THEN BEGIN
        PRINT, 'Cycle = '+cys+'  No runs found...'
        RETURN
    ENDIF
    im = 3 & str=STRMID(listf[im],STRLEN(listf[im]) - 2,2)
    IF (str EQ '.Z' OR str EQ 'gz') THEN compressed = 1 ELSE compressed = 0
    if str eq '.Z' then ext='.Z'
    if str eq 'gz' then ext='.gz'
    nums = LONARR((SIZE(listf))[1])
    IF STRMID(listf[0],0,5) EQ 'total' THEN listf = listf[1:(SIZE(listf))[1]-1]
    ON_IOERROR, continue
    IF compressed THEN aa = 8 ELSE aa = 6
    FOR i = 0, (SIZE(listf))[1] - 1 DO BEGIN
        nums[i] = LONG(STRMID(listf[i],STRLEN(listf[i]) - aa,6))
        continue:
    ENDFOR
    ii     = WHERE(nums GE 200)
    nums   = nums[ii]
    IF N_ELEMENTS(numor1) EQ 0 AND N_ELEMENTS(numor2) EQ 0 THEN BEGIN
        numor1 = MIN(nums)
        numor2 = MAX(nums)
    ENDIF ELSE IF N_ELEMENTS(numor2) EQ 0 THEN numor2 = numor1
    
    
    scan = 0
    samerun = 0
    olduser = ''
    old_title = ''
    oldtime1 = -10.
    old_run_time = 0
    old_sub_title = ''
    oldtemp = 0.
    oldlambda = 0.
    force = 0
    
    num1 = LONG(numor1)
    num2 = LONG(numor2)
    OPENW, lun, 'in4_summary.' + cys, /GET_LUN
    FOR numor = num1, num2 DO BEGIN
        PRINT, 'Reading ' + STRTRIM(STRING(numor),2)
        IF numor GE 10000  THEN file = '0' +  STRTRIM(STRING(numor),2) ELSE $
            IF numor GE 100000 THEN file =        STRTRIM(STRING(numor),2) ELSE $
            file = '00' + STRTRIM(STRING(numor),2)
        IF compressed THEN BEGIN
            IF !version.os EQ 'Win32' THEN BEGIN
                command = 'copy ' + inpath + file + ext + '.'
                SPAWN, command, /HIDE
                command = 'gzip -d ' + file + ext
                SPAWN, command, /HIDE
            ENDIF ELSE BEGIN
                s = ['cp',inpath + file + ext,'.']
                SPAWN, s, /NOSHELL
                ;                s = ['uncompress',file + ext]
                s = ['gunzip',file + ext]
                SPAWN, s, /NOSHELL
            ENDELSE
        ENDIF
        IF NOT compressed THEN read_in4sum, inpath+file
        IF     compressed THEN read_in4sum, file
        IF compressed THEN BEGIN
            IF !version.os EQ 'Win32' THEN BEGIN
                command = 'del ' + file
                SPAWN, command, /HIDE
            ENDIF ELSE BEGIN
                s = ['rm','-f', file]
                SPAWN, s, /NOSHELL
            ENDELSE
        ENDIF
        run_time = FLOAT(run_time/60.)    ; get it in minutes
        
        IF iprint THEN BEGIN
            PRINT, 'NUMOR-------#', numor
            PRINT, 'run_time   = ', run_time
            PRINT, 'sub_title  = ', sub_title
            PRINT, 'main_title = ', main_title
            PRINT, 'wavelength = ', lambda
            PRINT, 'temperature= ', temp
            PRINT, 'user       = ', user
            PRINT, 'local_cont = ', local_contact
        ENDIF
        
        
        IF ABS(LONG(run_time) - LONG(old_run_time)) LT 5. AND $
            sub_title EQ old_sub_title AND ABS(LONG(temp) - LONG(oldtemp)) LT 0.5 AND $
            user EQ olduser AND main_title EQ old_title AND ABS(lambda-oldlambda) LT 0.02  THEN BEGIN
            samerun = 1
        ENDIF ELSE IF (samerun EQ 1) THEN BEGIN
            IF (numor-oldnumor GE 2) THEN PRINTF,lun, FORMAT='("     ... identical runs up to #",I5)', numor-1
            samerun = 0
        ENDIF
        
        IF (numor EQ numor1) THEN BEGIN
            PRINTF,lun
            PRINTF,lun,'****************************************************************'
            PRINTF,lun, 'IN4 Run Summary for cycle: ',cys
            PRINTF,lun, FORMAT='("Numors",I6," to",I6)', numor1, numor2
            PRINTF,lun, 'Path: ',inpath
            PRINTF,lun,'----------------------------------------------------------------'
            PRINTF,lun
            PRINTF,lun, FORMAT='("User: ",A8,"   Local Contact: ",A8)', user, local_contact
            ;        PRINTF,lun, FORMAT='("Experiment Title: ",A)', STRTRIM(sub_title,2)
            PRINTF,lun, FORMAT='("Experiment Title: ",A)', STRTRIM(main_title,2)
            PRINTF,lun, FORMAT='("Wavelength: ",F5.2," Ang.")', lambda
            PRINTF,lun
            PRINTF,lun, 'Numor   Date     Start     Time   Temp (K)  Title'
        ENDIF ELSE IF (user NE olduser) OR (sub_title NE old_sub_title) THEN BEGIN &        PRINTF,lun,'----------------------------------------------------------------'
        PRINTF,lun
        PRINTF,lun, FORMAT='("User: ",A8,"   Local Contact: ",A8)', user, local_contact
        ;        PRINTF,lun, FORMAT='("Experiment Title: ",A)', STRTRIM(sub_title,2)
        PRINTF,lun, FORMAT='("Experiment Title: ",A)', STRTRIM(main_title,2)
        PRINTF,lun, FORMAT='("Wavelength: ",F5.2," Ang.")', lambda
        PRINTF,lun
        PRINTF,lun, 'Numor   Date     Start     Time   Temp (K)  Title'
    ENDIF ELSE IF ABS(lambda - oldlambda) GT 0.01 AND ABS(lambda - 3.) GT 0.01 $
        AND ABS(lambda - 4.) GT 0.01 THEN BEGIN
        PRINTF,lun,'----------------------------------------------------------------'
        PRINTF,lun
        PRINTF,lun, FORMAT='("Wavelength changed to : ",F5.2," Ang.")', lambda
        PRINTF,lun
        PRINTF,lun, 'Numor   Date     Start     Time    Temp (K)  Title'
    ENDIF
    IF (samerun EQ 0) THEN BEGIN
        PRINTF,lun, FORMAT='(I5,1X,A18,F7.1,1X,F8.2,4X,A)', $
            ;                numor, start_time, run_time, temp, STRTRIM(main_title,2)
            numor, start_time, run_time, temp, STRTRIM(sub_title,2)
        oldnumor=numor
    ENDIF ELSE IF (numor EQ numor2) THEN BEGIN
        IF LONG(run_time) EQ LONG(old_run_time) AND $
            sub_title EQ old_sub_title AND temp EQ oldtemp AND $
            user EQ olduser AND main_title EQ old_title THEN PRINTF,lun, $
            FORMAT='("     ... identical runs up to #",I5)', numor
    ENDIF
    
    olduser       = user
    oldtemp       = temp
    oldlambda     = lambda
    old_title     = main_title
    old_run_time  = run_time
    old_sub_title = sub_title
ENDFOR

CLOSE, lun

fin:    RETURN
END
