FUNCTION read_time, instring
;+
;******* *********
;** stuff for logger
;-
    
        a = STRPOS(instring,'>')
        READS, STRMID(instring,a+1),h
        READS, STRMID(instring,a+4),m
        READS, STRMID(instring,a+7),s

        RETURN, h + m/60. + s/3600.
END

FUNCTION logger, var, date=date, from=from, to=to, numor=numor
;+
;******* ******
;** User callable
;** log for in4 numors
;-

; var = temp, coldvalve

    COMMON c_lamp_access

    iprint = 1

    TAKE_DATP, datp


    IF N_ELEMENTS(date) -1 AND N_ELEMENTS(numor) LT 1 THEN BEGIN
        s = 'Date or numor must be specified'
        ii = WIDGET_MESSAGE(s,/ERROR)
        RETURN, 0
    ENDIF

    line = ''
; ---------------------------------------------------------------------------
;Find appropriate logfile and time-limits

    IF N_ELEMENTS(numor) GT 0 THEN BEGIN
        CASE 1 OF
            numor[0] GT 99999:  zeros=''
            numor[0] LT 100000: zeros='0'
            numor[0] LT 10000:  zeros='00'
            numor[0] LT 1000:   zeros='000'
            numor[0] LT 100:    zeros='0000'
            numor[0] LT 10:     zeros='00000'
        ENDCASE

        OPENR, lun, path_for_online+zeros+STRTRIM(STRING(numor),2),/GET_LUN 
        
        FOR iline = 0,4 DO BEGIN
            READF, lun, line
        ENDFOR
        dates = STRMID(line,14,9)
        dd = STRMID(dates,0,2)
        CASE STRMID(dates,3,3) OF
            'Jan': mm = '01'
            'Feb': mm = '02'
            'Mar': mm = '03'
            'Apr': mm = '04'
            'May': mm = '05'
            'Jun': mm = '06'
            'Jul': mm = '07'
            'Aug': mm = '08'
            'Sep': mm = '09'
            'Oct': mm = '10'
            'Nov': mm = '11'
            'Dec': mm = '12'
        ENDCASE
        yy = STRMID(dates,7,2)
        
        begin_time = STRMID(line,24,8)
        from = READ_TIME(begin_time)

        FOR iline = 0,21 DO BEGIN
            READF, lun, line
        ENDFOR
        
        end_time = STRMID(line, 30,8)
        to = READ_TIME(end_time)

        FREE_LUN, lun
    ENDIF
    
    IF N_ELEMENTS(date) GT 0 THEN BEGIN
        dd = STRMID(date,0,2)
        mm = STRMID(date,3,2)
        yy = STRMID(date,6,2)
    ENDIF

    IF N_ELEMENTS(from) LT 1 THEN from = 0
    IF N_ELEMENTS(to)   LT 1 THEN to   = 25

    logfile = 'ICS'+yy+mm+dd+'.xml'        


    IF iprint THEN BEGIN
        PRINT, 'Date  = ' + dd + '/' + mm + '/' + yy
        PRINT, 'From  =', from, ' hours'
        PRINT, 'To    =', to,   ' hours'
        PRINT, 'templog: End of parameters setup section'
    ENDIF

; ---------------------------------------------------------------------------
; Get info from logfile section

    OPENR, lun, logfile, /GET_LUN

    numlines = FILE_LINES(logfile)
    line1 = ''
    line2 = ''

    CASE var OF    
        'temp':        obs_var = 'current temperatures'
        'coldvalve':    obs_var = 'cold valve'
    ENDCASE

    ins_time   = FLTARR(numlines)
    a_var   = FLTARR(numlines)
    b_var   = FLTARR(numlines)
    c_var   = FLTARR(numlines)
    itime = -1

    WHILE ~ EOF(lun) DO BEGIN
        READF, lun, line
        IF STRPOS(line,'<time>') LT 0 THEN CONTINUE 
        READF, lun, line1
        READF, lun, line2
        time_stamp = READ_TIME(line)
        IF time_stamp LT from OR time_stamp GT to THEN CONTINUE
        IF STRPOS(line2,obs_var) GT -1 THEN BEGIN
            itime = itime+1
            ins_time[itime] = time_stamp
            CASE obs_var OF
            'current temperatures': BEGIN
                    p1 = STRPOS(line2,'setpoint = ')
                    READS, STRMID(line2,p1+11), a
                    a_var[itime] = a
                    p2 = STRPOS(line2,'gulation = ')
                    READS, STRMID(line2,p2+11), b
                    b_var[itime] = b
                    p3 = STRPOS(line2,', sample = ')
                    READS, STRMID(line2,p3+11), c
                    c_var[itime] = c
                END
            'cold valve': BEGIN
                    p1 = STRPOS(line2,'setpoint')
                    READS, STRMID(line2,p1+20), a
                    a_var[itime] = a
                    p2 = STRPOS(line2,'actual')
                    READS, STRMID(line2,p2+18), b
                    b_var[itime] = b
                END
            ENDCASE
            
        ENDIF
    ENDWHILE

    FREE_LUN, lun

; ------------------------------------------------------------------------------
    
    CASE var OF
    'temp': BEGIN
        yarray = [0,1,2]
        IF N_ELEMENTS(numor) LE 0 THEN $
            wtit = 'Temperature log for ' + dd+'/'+mm+'/'+yy ELSE $
            wtit = 'Temperature log for #' + STRTRIM(STRING(numor),2)
        w_out = [[a_var[0:itime-1]],[b_var[0:itime-1]],[c_var[0:itime-1]]]
        other = 'y[0] = setpoint, y[1] = regulation, y[2] = sample'
        z_tit = 'Temperature(K)'
        END
    'coldvalve':  BEGIN
        yarray = [0,1]
        IF N_ELEMENTS(numor) LE 0 THEN $
            wtit = 'Cold valve log for ' + dd+'/'+mm+'/'+yy ELSE $
            wtit = 'Cold vavle log for #' + STRTRIM(STRING(numor),2)
        w_out = [[a_var[0:itime-1]],[b_var[0:itime-1]]]
        other = 'y[0] = setpoint, y[1] = actual'
        z_tit = 'Pressure (cv units)'
        END
    ENDCASE


    MOD_DATP, datp, "x", ins_time[0:itime-1]
    MOD_DATP, datp, "y", yarray
    datp.x_tit = 'Time (hours since midnight)'
    datp.w_tit = wtit
    datp.other_tit = other
    datp.z_tit = z_tit

    GIVE_DATP, datp

    RETURN, w_out

END
