pro panther,THETA=theta,LAMBDA_I=lambda_i,MONO=mono,FOCUS=focus,SPEED_MAX=speed_max,$
            D_SD=D_Sd,W_D=w_d,W_HD=w_hd,W_MONO=W_Mono,$
            BETA_FC=beta_fc,PHI_S=phi_S,$
            NO_CORR=no_corr,MESOT=mesot,IN4=in4,FILE=file,$
            D_MS=d_MS,X_M=x_M,$
            hw,RES,RES_el
;+
;** *******
;** User callable
;** in4,mono='G_002',focus=0.,x1,w1 & x_tit(1)='Energy (meV)' & w_tit(1)='Energy resolution (meV)'
;** Calculate incident Wavelength-Energy
;-

    d_G002=3.355
    d_G004=d_G002/2.
    d_G006=d_G002/3.
    d_C220=1.278
    d_C111=2.087
    d_m=d_G002
    if n_elements(d_MS) lt 1. then d_MS=2111. ;values fo in4 19.1
    if n_elements(X_M) lt 1. then x_M=9892.   ;values fo in4 19.1
    if n_elements(W_HD) lt 1. then W_HD=80.
    if n_elements(W_D) lt 1. then W_D=80.
    if n_elements(W_Mono) lt 1. then W_Mono=220.
    if n_elements(D_SD) lt 1. then d_SD=2000.
    if n_elements(BETA_FC) lt 1 then beta_fc=1.
    if n_elements(focus) lt 1 then focus=0.
    if n_elements(PHI_S) lt 1 then phi_S=20.
    if n_elements(PHI_D) lt 1 then phi_D=20.
    if n_elements(SPEED_MAX) lt 1 then speed_max = 40000 & speed_max_htz=speed_max/60.; max Fermi speed in HTz
    if n_elements(MONO) eq 1 then begin
        CASE mono OF
            'G_002':BEGIN & d_m=d_G002 & eta=0.5*!pi/180 & END
            'G_004':BEGIN & d_m=d_G004 & eta=0.5*!pi/180 & END
            'G_006':BEGIN & d_m=d_G006 & eta=0.5*!pi/180 & END
            'C_220':BEGIN & d_m=d_C220 & eta=0.3*!pi/180 & END
            'C_111':BEGIN & d_m=d_C111 & eta=0.3*!pi/180 & END
            ELSE: BEGIN
                print,'Mono not recognized.... assume to be HOPG 002'
                mono='G_002' & d_m=d_G002 & eta=0.5*!pi/180
            END
        ENDCASE
    endif else begin
        print,'No mono keyword found... considered as HOPG 002'
        mono='G_002' & d_m=d_G002 & eta=0.5*!pi/180
    endelse
    if (n_elements(lambda_i)) lt 1 then begin
        if n_elements(theta) gt 0 then theta=theta*!pi/180. else theta=19.*!pi/180.
        lambda_i=2.*d_m*sin(theta) & E_i=81.805/lambda_i^2
    endif else begin
        theta=asin(lambda_i/(2.*d_m))
    endelse
    
    ;if n_elements(theta) gt 0 then theta=theta*!pi/180. else theta=19.*!pi/180.
    
    E_i=81.805/lambda_i^2
    ; ---------------------------------------------------------
    ; Define constants:
    ; abscisse given in mm from end of doigt de gant
    W_DDG=100.
    beta_fc=beta_fc*!pi/180.
    W_M=W_Mono*sin(theta) & w_Mloc=20.*sin(theta) ; IN4 Mono face is 11*20=220 mm large
    x_BC1=6000.
    x_D=6582.5
    x_HD=9300.
    d_FS=675.
    
    if (n_elements(IN4) ge 1.) then begin
        x_S=11556. & y_S=1300. & x_M=x_S-y_S/tan(2*theta)
        d_MS=sqrt((x_S-x_M)^2+y_S^2)
    endif else begin
        x_S=x_M+d_MS*cos(2.*theta)
        y_S=d_MS*sin(2.*theta)
    endelse
    ;x_M=x_D+d_MS*comp
    ;x_M=x_S-y_S/tan(2*theta)
    d_FS=675.
    ;d_MS=sqrt((x_S-x_M)^2+y_S^2)
    d_MF=d_MS-d_FS
    d_DM=x_M-x_D & d_HDM=x_M-x_HD
    comp= d_DM/d_MS
    gamma_0D=(W_DDG+W_D)/x_D
    gamma_0HD=(W_DDG+W_HD)/x_HD
    gamma_0M=W_M/d_DM
    gamma_0=gamma_0M
    ;x_VS=x_HD & d_DM=d_HDM
    gamma_1=gamma_0*d_DM/d_MS
    
    ;W_b_at_mono=W_DDG+2*d_DM*tan(gamma_0D) ; beam width (including shadow) @ mono position
    W_b_at_mono=W_HD+2*d_HDM*tan(gamma_0HD*0.5) ; beam width (including shadow) @ mono position
    gamma_1p=min([W_b_at_mono,W_M])/d_MS
    W_b_at_fermi=d_FS*gamma_1p ; beam width (including shadow) @ mono position
    
    R_mono=(2./sin(theta))*(1./d_DM+1./d_MS)^(-1.) ;
    
    
    ; Definition of the local collimations (I DO NOT UNDERSTAND MESOT's DEFINITION given in the FOCUS Document)
    ; ------------------------------------
    ; => Dominant term of the resolution @ elastic (for elastic time focussing)
    if (n_elements(mesot) lt 1) then begin
        ; ---- Stef's alpha- and alpha+
        alpha_0=(W_DDG+W_Mloc)/x_M
        alpha_1=(PHI_S+W_Mloc)/d_MS
    endif else begin
        ; ---- Mesot's alpha- and alpha+
        alpha_0=0.5*(W_DDG+W_Mloc)/x_M
        alpha_1=0.5*(PHI_S+20./sin(theta))/d_MS
    endelse
    
    ;
    ; ------------------------------------------------------------------------------------------------------;
    ; Calculate the energy resolution
    ; ----------------------------------------------------
    K=3956.E3 ; h/m in mm/Angst/s
    C=1./K
    ;C=2.5278
    print,'Calculation of the Resolution for the IN4 configuration chosen'
    ; Fermi speed
    nu_FC_foc=tan(theta)/(!pi*C*lambda_i*abs(gamma_0/gamma_1-1.)*(d_FS+d_SD*(1.-focus/E_i)^(-1.5)))
    nu_FC=nu_FC_foc < speed_max_htz
    T_f=0.5/nu_FC ; time frame en seconde
    DE_min=-200. & DE_max=floor(E_i) & DE=DE_min+findgen(1001)*(DE_max-DE_min)/1000.
    E_f=E_i-DE
    lambda_f=sqrt(81.805/E_f) & tof=d_SD*lambda_f/K
    ; Calcul of DT1: Mono and Fermi contribution
    if (n_elements(NO_CORR) ge 1) then begin
        Dtheta=sqrt((alpha_0^2*eta^2+alpha_1^2*eta^2+alpha_0^2*alpha_1^2)/(alpha_0^2+alpha_1^2+4.*eta^2)) ; no correlation...
        ;Dtheta=0.5*Dtheta
        DT1=C*lambda_i*(d_FS+d_SD*(lambda_f/lambda_i)^3)*Dtheta/tan(theta)
    endif else begin
        Dtheta=sqrt((alpha_0^2*eta^2+alpha_1^2*eta^2+alpha_0^2*alpha_1^2)/(alpha_0^2+alpha_1^2+4.*eta^2)) ; no correlation...
        Dlambdai=lambda_i*Dtheta/tan(theta)
        D_D=(d_FS+d_SD*(lambda_f/lambda_i)^3)*C
        B=(alpha_0^2+2.*eta^2)*alpha_1^2
        A=beta_fc^2*(alpha_0^2+alpha_1^2+4.*eta^2)+alpha_1^2*(alpha_0^2+4.*eta^2)
        Cc=alpha_0^2*alpha_1^2+alpha_0^2*eta^2+alpha_1^2*eta^2
        r_i=B/sqrt(A*Cc)
        DT_i=sqrt(A/(alpha_1^2+alpha_0^2+4*eta^2))/(2*!pi*nu_FC)
        DT1=DT_i^2+D_D^2*Dlambdai^2-2.*D_D*r_i*DT_i*Dlambdai ; sign - to account for the Fermi direction of rotation
        DT1=sqrt(DT1)
    endelse
    ; Calcul of DT2: Defocalisation
    DT2=ABS(C*0.5*lambda_i*(d_FS+d_SD*(lambda_f/lambda_i)^3)*abs(gamma_0-gamma_1)/tan(theta)-gamma_1/(2*!pi*nu_FC))
    ; Calcul of DT3: Sample size
    DT3=C*lambda_i*(1+(lambda_f/lambda_i))*phi_S
    DT3=PHI_S*C*(lambda_i*cos(45.*!pi/180)-lambda_f*cos((45.-55)*!pi/180.))/(2*sin(45.*!pi/180))
    DT3p=0.68*2.*C*(lambda_i-lambda_f*cos(55.*!pi/180))/sin(45.*!pi/180)
    ; Calcul of DT4: Detector size
    DT4=C*lambda_f*phi_D
    ;
    hw=DE
    DE1=DE & DE2=DE & DE3=DE & DE4=DE & r=647.2E6/d_SD/lambda_f^3
    DE1=r*DT1 & DE2=r*DT2 & DE3=r*sqrt(DT3^2+DT3p^2) & DE4=r*DT4
    DE=r*sqrt(DT1^2+DT2^2+DT3^2+DT3p^2+DT4^2)
    RES=[DE,DE1,DE2,DE3,DE4] & RES=reform(RES,n_elements(hw),5,/overwrite)
    i=where(abs(hw) eq min(abs(hw))) & RES_el=RES[i,0]
    ;
    ; ------------------------------------------------------------------------------------------------------;
    ; OUTPUT
    Print,'##------------------------------------------------------------------------##'
    Print,'INPUTS'
    Print,'Incident Wavelength (A): ',strcompress(lambda_i,/remove_all)
    Print,'Incident Energy (meV)  : ',strcompress(E_i,/remove_all)
    Print,'Bragg Angle (degree)   : ',strcompress(string(theta*180./!pi),/remove_all)
    Print,'Mono used              : ',strcompress(mono,/remove_all)
    Print,'SLITS'
    Print,'DDG apperture (mm)     : ',strcompress(W_DDG,/remove_all)
    Print,'D apperture (mm)       : ',strcompress(W_D,/remove_all)
    Print,'HD apperture (mm)      : ',strcompress(W_HD,/remove_all)
    Print,'Sample Size (mm)       : ',strcompress(PHI_S,/remove_all)
    Print,'Beam Hor.Siz.@ M.(mm)  : ',strcompress(W_b_at_mono,/remove_all)
    Print,'Beam Hor.Siz.@ F.(mm)  : ',strcompress(W_b_at_fermi,/remove_all)
    Print,'Total Mono Width (mm)  : ',strcompress(W_Mono,/remove_all)
    Print,'Proj. Mono Width (mm)  : ',strcompress(W_M,/remove_all)
    Print,'DISTANCES'
    Print,'DDG position (mm)      : ',strcompress(0.00,/remove_all)
    Print,'D position (mm)        : ',strcompress(x_D,/remove_all)
    Print,'HD position (mm)       : ',strcompress(x_HD,/remove_all)
    Print,'Mono position (mm)     : ',strcompress(x_M,/remove_all)
    Print,'D-Mono distance (mm)   : ',strcompress(d_DM,/remove_all)
    Print,'Mono-S distance (mm)   : ',strcompress(d_MS,/remove_all)
    Print,'Fermi-S distance (mm)  : ',strcompress(d_FS,/remove_all)
    Print,'TOF Dist. (D_SD) (mm)  : ',strcompress(d_SD,/remove_all)
    Print,'Mon. h.curv. rad. (mm) : ',strcompress(R_Mono,/remove_all)
    Print,'DIVERGENCES'
    Print,'Gamma_0 (deg)          : ',strcompress(string(gamma_0*180./!pi),/remove_all)
    Print,'Gamma_1 (deg)          : ',strcompress(string(gamma_1*180./!pi),/remove_all)
    Print,'Gamma_1p (deg)         : ',strcompress(string(gamma_1p*180./!pi),/remove_all)
    Print,'alpha_0 (deg)          : ',strcompress(string(alpha_0*180./!pi),/remove_all)
    Print,'alpha_1 (deg)          : ',strcompress(string(alpha_1*180./!pi),/remove_all)
    Print,'Fermi Collimator (deg) : ',strcompress(string(beta_fc*180./!pi),/remove_all)
    Print,'TOF'
    Print,'Fermi speed (HTz)      : ',strcompress(nu_FC,/remove_all)
    Print,'Fermi speed (RPM)      : ',strcompress(FLOOR(nu_FC*60.),/remove_all)
    Print,'Fermi speed foc.(RPM)  : ',strcompress(FLOOR(nu_FC_foc*60.),/remove_all)
    Print,'Fermi max. (RPM)       : ',strcompress(FLOOR(speed_max_htz*60),/remove_all)
    Print,'Time Frame (ms)        : ',strcompress(T_f*1000.,/remove_all)
    Print,'Channel Width (micros) : ',strcompress(T_f*1.E6/512,/remove_all)
    Print,'RESOLUTION'
    Print,'Elastic Resol. (meV)   : ',strcompress(Res_el,/remove_all)
    Print,'Horizontal compression : ',strcompress(comp,/remove_all)
    Print,'Taille de la tâche foc.: ',strcompress(W_D/comp,/remove_all)
    Print,'Tache d un crystal     : ',strcompress(20.*sin(theta),/remove_all)
    
    Print,'##------------------------------------------------------------------------##'

    IF (N_ELEMENTS(FILE) GT 0.) THEN BEGIN
      get_lun,iu
      OPENW,iu,file
      for j=0,N_ELEMENTS(hw)-1 do begin
        printf,iu,hw[j],RES[j,0]
      endfor
      free_lun,iu
    ENDIF    
    
end
