PRO read_in4sum, file
;+
;** ***********
;** User callable
;** Reads IN4 summary data. Called from  in4_summary.pro
;**                          KHA,JRS 25/10/06
;-

    COMMON mut,    user, local_contact, main_title, sub_title, $
        start_time, run_time, inst, temp, date, stop_time, lambda
        
        
    iprint = 0
    ON_IOERROR, error_message
    
    IF iprint THEN PRINT,'read_in4_sum: starting'
    IF iprint  THEN PRINT,'Opening ',file
    
    OPENR, ilun, file, /GET_LUN
    
    line = ''    & num = LONG(0)    & num1 = 0    & num2 = 0
    
    READF, ilun, line
    READF, ilun, num,num1,num2    & numor = num & nvers=num2
    READF, ilun, line
    READF, ilun, line
    READF, ilun, line
    inst       = STRMID(line,0,4)
    user          = STRMID(line,4,6)
    local_contact = STRMID(line,10,4)
    READF, ilun, line
    READF, ilun, num    & dummy = LONARR(num)
    READF, ilun, dummy
    READF, ilun, line
    
    READF, ilun, line
    READF, ilun, line
    main_title    = STRMID(line,10,50)
    sub_title     = STRMID(line,60,20)
    READF, ilun, line
    start_time    = STRMID(line,0,18)
    stop_time     = STRMID(line,20,18)
    READF, ilun, line
    READF, ilun, line
    READF, ilun, line
    READF, ilun, line
    READF, ilun, line
    
    ; -----------------------------------
    READF, ilun, line
    READF, ilun, num1
    block0 = FLTARR(num1)
    READF, ilun, block0
    IF iprint THEN PRINT,'Block0 read OK'
    ; -----------------------------------
    READF, ilun, line
    READF, ilun, num1
    block1 = FLTARR(num1)
    READF, ilun, block1
    IF iprint THEN PRINT,'Block1 read OK'
    
    case nvers of
        1: begin
            temp   = block1[10]
            lambda = block1[20]
        end
        2: begin
            temp   = block0[10]
            lambda = block0[20]
        end
    endcase
    h1=LONG(0)    & m1=LONG(0)    & s1=LONG(0)
    h2=LONG(0)    & m2=LONG(0)    & s2=LONG(0)
    IF (start_time NE '' AND stop_time NE '') THEN BEGIN
        ON_IOERROR, notimes
        READS, start_time, FORMAT='(I2,8X,I2,1X,I2,1X,I2)', d1, h1, m1, s1
        READS, stop_time, FORMAT='(I2,8X,I2,1X,I2,1X,I2)', d2, h2, m2, s2
        time1=FLOAT(3600*h1+60*m1+s1)/3600.+24.*d1
        time2=FLOAT(3600*h2+60*m2+s2)/3600.+24.*d2
        IF (h2 GE h1) THEN run_time=FLOAT(3600*(h2-h1)+60*(m2-m1)+(s2-s1)) $
        ELSE run_time=FLOAT(3600*(24+h2-h1)+60*(m2-m1)+(s2-s1))
    ENDIF ELSE BEGIN
        notimes:
        time1    = 0.
        time2    = 0.
        run_time = 0.
    ENDELSE
    
    date = (time1+time2)/48.
    
    IF iprint THEN PRINT,'run time OK'
    
    IF iprint THEN BEGIN
        PRINT, 'inst ',inst
        PRINT, 'user ',user
        PRINT, 'local_contact ',local_contact
        PRINT, 'main_title ',main_title
        PRINT, 'sub_title ',sub_title
        PRINT, 'start_time ',start_time
        PRINT, 'stop_time ',stop_time
        PRINT, 'run_time ',run_time
        PRINT, 'date ',date
        PRINT, 'temp ',temp
        PRINT, 'lambda ',lambda
    ENDIF
    
    GOTO, end_read_in4sum
    
    
    error_message:
    PRINT,'Input/Output error encountered in read_in4sum while reading from ',file
    GOTO, end_read_in4sum
    
    error_message2:
    PRINT,'Data file format error'
    
    end_read_in4sum:
    IF N_ELEMENTS(ilun) GT 0 THEN FREE_LUN, ilun
    
    IF iprint THEN PRINT,'read_in4sum: finished'
    
    RETURN
END
