;d.R. started Octobre 2008

;SANS_SHEET_SYNC     synchronise sans_sheet with sans_settings main application
;SANS_SHEET_RECEIVE  receive usefull informations from sans_settings
;SANS_SHEET_DYING    destroyed GUI
;SANS_SHEET_EVENT    main event handler
;SANS_SHEET          gui constructor

pro sans_sheet_sync, ev, sbaset, kkase, mess, receive=present
;+
;** ***************
;** ***************
;** synchronise sans_sheet with sans_settings main application
;**
;** -------- level 1
;** --------
;** load   ->load file  sbaset.SAVpth+sbaset.curfile (instru,datapth/PATH_FOR_ONLINE,toggles,nsample,vertical,valgrp,comments,tables)
;** grouping ->give sbaset.valgrp to sans_settings
;** toggles  ->give changes to sans_settings      !!!
;** get_trans ->called by sans_settings after a transmission calculation
;** put_trans ->give transmissions back to sans_settings before TREAT (case should be modified by the user)
;** give_IDs  ->called by sans_settings for reform_series, return in mess Sample IDs
;** get_ctr   ->called by sans_settings after a center calculation.Put center in sample comment
;** get_msk   ->called by sans_settings after a file mask is saved or restored, Put mask in sample comment
;** get_mskW  ->called by sans_settings after a file mask is saved or restored. Put mask in water comment
;** get_wdm   ->called by sans_settings after a read run. Put title+Count in correct cell
;** get_error ->called by sans_settings after a read run error
;** get_a_trs ->called by sans_settings to return in mess TRANS values according to OPR string in present
;** --------
;** -------- level 2
;** --------
;** update      ->noop just give tables
;** resize_*    ->NBsamples has changed             !!!
;** clear_*     ->tables has been cleared           !!!
;** fill_*      ->sample table has been filled down !!!
;** save_low    ->save current setting as low (in memory)
;** save_middle ->save current setting as middle (mem)
;** save_high   ->save current setting as high   (mem)
;** --------
;** -------- level 3
;** --------
;** save        ->save file sbaset.SAVpth+sbaset.curfile + text spreadsheet
;** savetxt     ->save text spreadsheet
;** run_WATER   ->give tables(+low|middle|high) and show a run from WATER  table
;** run_BEAM    ->give tables(+low|middle|high) and show a run from BEAM   table
;** run_SAMPLE  ->give tables(+low|middle|high) and show a run from SAMPLE table
;** input_WATER  ->a cell has been entered in WATER  table
;** input_BEAM   ->a cell has been entered in BEAM   table
;** input_SAMPLE ->a cell has been entered in SAMPLE table
;** mask_water    ->give tables          and call sans_settings mask for water
;** mask_detector ->give tables          and call sans_settings mask for detector
;** mask_detector_low
;** mask_detector_middle
;** mask_detector_high
;** auto_mask_water -> call from TREAT
;** --------
;** -------- level 4
;** --------
;** options      ->give tables          and call sans_settings for detector corrections
;** cor_low      ->give tables(+low)     and call sans_settings show corrected data
;** cor_middle   ->give tables(+middle)  and call sans_settings show corrected data
;** cor_high     ->give tables(+high)    and call sans_settings show corrected data
;** mask_low      ->give tables(+low)    and call sans_settings mask
;** mask_middle   ->give tables(+middle) and call sans_settings mask
;** mask_high     ->give tables(+high)   and call sans_settings mask
;** load_mask     ->give tables          and call sans_settings load mask
;** save_mask     ->give tables          and call sans_settings save mask
;** mask_sector   ->give tables          and call sans_settings sector(mask)
;** transmission   ->give tables          and call sans_settings transmission
;** transm_file    ->give tables          and call sans_settings search for transmissions
;** trans_cal      ->give tables          and call sans_settings calculate transmissions
;** ctr_cal_low     ->give tables(+low)    and call sans_settings calculate center
;** ctr_cal_middle  ->give tables(+middle) and call sans_settings calculate center
;** ctr_cal-high    ->give tables(+high)   and call sans_settings calculate center
;** flx_cal_low     ->give tables(+low)    and call sans_settings calculate flux
;** flx_cal_middle  ->give tables(+middle) and call sans_settings calculate flux
;** flx_cal_high    ->give tables(+high)   and call sans_settings calculate flux
;** msk_cal_low     ->give tables(+low)    and call sans_settings calculate mask
;** msk_cal_middle  ->give tables(+middle) and call sans_settings calculate mask
;** msk_cal-high    ->give tables(+high)   and call sans_settings calculate mask
;** center_low      ->give tables(+low)    and call sans_settings center
;** center_middle   ->give tables(+middle) and call sans_settings center
;** center-high     ->give tables(+high)   and call sans_settings center
;** treat_det        ->                         call sans_settings, treat and show detector efficiencies
;** treat_low        ->give tables(+low)    and call sans_settings, treat and return values in tables
;** treat_middle     ->give tables(+middle) and call sans_settings, treat and return values in tables
;** treat_high       ->give tables(+high)   and call sans_settings, treat and return values in tables
;** show_list        ->                         call sans_settings, show one treated list again
;** export_gnum      ->                         call sans_settings, export results
;** export_tnum      ->                         call sans_settings, export results
;** export_3col      ->                         call sans_settings, export results
;** export_coln      ->                         call sans_settings, export results
;** export_png2      ->                         call sans_settings, export results
;** export_nist      ->                         call sans_settings, export results
;-

common c_sans_sheet_sync, readerr, wdm
common c_sanstop, bstop

       if n_elements(readerr) eq 0 then readerr=''
       kase=kkase

if xregistered('sans_settings_win',/noshow) eq 0 then begin ;Destroyed by error!!!
   widget_control,/hourglass
   sans_settings ,instrument=sbaset.instru, map=0, baseSANS=baseSANS & sbaset.baseSANS=baseSANS
   widget_control,ev.top,set_uvalue=sbaset, iconify=0
   widget_control,sbaset.baseSANS,get_uvalue=baset ;SANS_SETTINGS STRUCTURE
   if sbaset.curLMH gt 0 then sans_settings_swap, baset,/get,/memswap,LMH=(["low","middle","high"])[sbaset.curLMH-1] ;curWATER not set!
endif else $
   widget_control,sbaset.baseSANS,get_uvalue=baset ;SANS_SETTINGS STRUCTURE
icoco=-1
                                                                                                ;MAKE KEV a
widget_control,ev.id,get_uvalue=keepUV & KEV=ev & kev.top=sbaset.baseSANS & kev.handler=kev.top ;sans_settings event
CATCH,stat & if stat ne 0 then begin & lamp_error & widget_control,ev.id,set_uvalue=keepUV & mess=!error_state.msg & return & endif

togg   =sbaset.toggles ; 0:? 1:auto_cent 2:auto_trans 3:auto_wrt 4:discardLRP 5:plot 6:radial 7:azimutal 8:sectors
                       ; 9:10:11:12:sector_type 13:Fincr 14:auto_mask 15:re-Read_Data 16:FreeRock
vert   =sbaset.vertical               ;sens of tables
idxa   =sbaset.idxtab                 ;tables  index
idt    =sbaset.tids[1,idxa]           ;get tables ids (water,beam,sample)
unm    =sbaset.unames                 ;get unames of this tables
idc    =where(sbaset.tids[0,*] gt 0L) ;get comments ids
idc    =sbaset.tids[0,idc]            ;""
nsp    =sbaset.nsampl                 ;number of samples
sansref=sbaset.sansref                ;sans=1 reflect=0 sansRotation=2
incr   =sbaset.valgrp                 ;grouping increment
newLMH =sbaset.curLMH                 ;current none low middle high config 0 1 2 3
savLMH =sbaset.savedLMH               ;saved        low middle high config  [1,1,1]
savSMP =sbaset.savedSMP               ;presence of 3samples+water  [n,n,n,1]
LOW    =sbaset.L                      ;label
MIDDLE =sbaset.M                      ;label
HIGH   =sbaset.H                      ;label

;*********************************
;How many sample IDs are selected?
;*********************************
             uset=widget_info(idt[2],/table_select) ;nSampIds = [first,last] index if selected else assume all [-1]
             if (vert) then if (uset[0] le 0)  then  nSampIds = [ uset[1],uset[3] ] else nSampIds = [-1] $
                       else if (uset[1] le 0)  then  nSampIds = [ uset[0],uset[2] ] else nSampIds = [-1]

;******************   *******************************************
;TABLE DEPENDENCIES   use_table_select=[left, top, right, bottom]
;******************   *******************************************
             uset_tW  =[7 , 0, 7 , 0]     ;tr.Water value (WATER)
             uset_tWC =[8 , 0, 8 , 0]     ;tr.Wat.C value (WATER)
             uset_tSC =[4 , 2, 4 , 2]     ;tr.Sam.C value (BEAM)
             uset_tS  =[6 , 0, 6 , nsp-1] ;tr.Sampl value (SAMPLE)       vertical
             uset_tWe =[15, 0, 15, 0]     ;tr.Water value (WATER)  sigma
             uset_tWCe=[16, 0, 16, 0]     ;tr.Wat.C value (WATER)  sigma
             uset_tSCe=[5 , 2, 5 , 2]     ;tr.Sam.C value (BEAM)   sigma
             uset_tSe =[7 , 0, 7 , nsp-1] ;tr.Sampl value (SAMPLE) sigma vertical
             uset_watr=[0 , 0, 0 , 0]
             uset_IDs =[0 , 0, 0 , nsp-1] ;Sampl IDs

             i_tW=4     &  i_tWC=5      &  i_tWB=6      &  i_thinW=3     ;tr.Water, tr.Wat.Cell,  tr.Wat.Beam,    thin.Water   (WATER)
             i_tS=4     &                                  i_thinS=5     ;tr.Sampl(*nsp)                          thin.Sampl   (SAMPLE)
                           i_tSC=[3,2]  &  i_tSB=[3,0]                   ;          tr.Sam.Cell,  tr.Sam.Beam                  (BEAM)

             i_W =0     &  i_WC =2      &  i_WCd=1                       ;   Water     Wat.Cell,     Wat.Cad                   (WATER)
             i_S =1                                                      ;   Sampl(3*nsp)                                      (SAMPLE)
                           i_SC =[0,2]  &  i_SCd=[0,1]  &  i_SDb  =[0,0] ;             Sam.Cell(*3), Sam.Cad(*3), Sam.Beam(*3) (BEAM)
                                                           i_FLX  =[0,3] ;                           alternative  tr.FLUX(*3)  (BEAM)
;******************************
bradin   = baset.bases7[14]
curWATER = baset.curWATER
oldWATER = baset.curWATER
curTRS   = 0. ;baset.curSAMtrs
useWATER = 0
;******************************

on_ioerror,misconv
; ------------------- LEVEL 1 -----------------------------------------------
case kase of
"load":    begin
           on_ioerror,misload
            old_inst=sbaset.instru
            print,"Restore "+sbaset.SAVpth+sbaset.curfile & wait,.1 & empty
            widget_control,/hourglass
            RESTORE,file=sbaset.SAVpth+sbaset.curfile
            print,"Restored" & wait,.1 & empty
            if n_elements(RLstruct) gt 0 then tags=tag_names(RLstruct) else tags=['']
            if tags[0] eq "SBASET" then begin
             baset.curLMH=sbaset.curLMH
            ;prevent sans_settings from being destroyed when instrument is the same
             if RLstruct.sbaset.instru eq old_inst then baset.curLMH=-baset.curLMH-10
             widget_control,bad_id=ii,sbaset.baseSANS,set_uvalue=baset ;""
             print,"" & wait,.1 & empty
             widget_control,ev.top         ,/destroy
             empty & wait,.5
             print,"Creating tables" & wait,.1 & empty
             sans_sheet, instru=RLstruct.sbaset.instru, reload=RLstruct

             cid=where(RLstruct.sbaset.savedLMH*RLstruct.sbaset.savedSMP[0:2] gt 0)
             k  =cid[0]+1
             widget_control,bad_id=ii,sbaset.baseSANS,base_set_title="  "+([" ",LOW,MIDDLE,HIGH])[k]+ " current  "
             mess="ok"
            endif else begin
             if n_elements(settings) gt 0 then tags=tag_names(settings) else tags=['']
             if tags[0] eq "INSTRUMENT" then mess="Must be restored from sans_settings !!!" else mess="Wrong saved file !!!"
             if n_elements(iso_NTC)+n_elements(azi_NTC) gt 2 then mess="results"
            endelse
            return
           misload:mess=!error_state.msg
           on_ioerror,misconv
           end
"grouping":begin
           radin =strtrim(string(incr,format='(f4.1)'),2)
           widget_control,bradin,set_value=radin
           end
"toggles": begin & baset.bases6[17]=togg[13] ;Increment file results
                ;baset.bases6(18)=togg(4)  ;Discard low resolution points (now in sans_settings)
                 baset.bases6[20]=togg[15] ;Force reRead data
                 sans_settings_swap,baset
                 widget_control,sbaset.baseSANS,set_uvalue=baset
           end
"resize" : begin & return
           end
"get_trans": begin & if readerr eq '' then begin ; Fill cells for calculated transmission values
                   trans =string(present[*,0],format='(F5.3)') & trans =trans[ 0:(n_elements(trans)-1)<(nsp+3)]
                   transE=string(present[*,2],format='(F5.3)') & transE=transE[0: n_elements(trans)-1] & ntr=n_elements(trans)-4
                   if ntr eq 0 then trsa =trans[ 2] else trsa =trans[ 4:4+ntr-1]
                   if ntr eq 0 then trsaE=transE[2] else trsaE=transE[4:4+ntr-1] & ntr=ntr>1
                   if vert then if ntr gt 1 then begin & trsa=transpose(trsa) & trsaE=transpose(trsaE) & endif
                   uS=uset_tS  & uS[3]=ntr-1 & if not vert then uS=[uS[1],uS[0],uS[3],uS[2]]
                   uE=uset_tSe & uE[3]=ntr-1 & if not vert then uE=[uE[1],uE[0],uE[3],uE[2]]
                   widget_control,idt[2],set_value=trsa      ,use_table_select=uS           ;tr.Sampl value
                   widget_control,idt[0],set_value=trans[0]  ,use_table_select=uset_tW      ;tr.Water value
                   widget_control,idt[0],set_value=trans[1]  ,use_table_select=uset_tWC     ;tr.Wat.C value
                   widget_control,idt[1],set_value=trans[3]  ,use_table_select=uset_tSC     ;tr.Sam.C value
                   widget_control,idt[0],set_value=transE[0] ,use_table_select=uset_tWE     ;tr.Water value sigma
                   widget_control,idt[0],set_value=transE[1] ,use_table_select=uset_tWCE    ;tr.Wat.C value sigma
                   widget_control,idt[1],set_value=transE[3] ,use_table_select=uset_tSCE    ;tr.Sam.C value sigma
                   widget_control,idt[2],set_value=trsaE     ,use_table_select=uE           ;tr.Sampl value sigma.
                   sbaset.savedTRM=1 & widget_control,ev.top,set_uvalue=sbaset
                  ;if n_elements(mess) eq 1 then readerr=mess !!!!!
                   if n_elements(mess) eq 1 then widget_control,sbaset.Mess,set_value=mess
                   endif
             end
"put_trans": begin ; read cell transmission values and give back to sans_settings
                   uS=uset_tS & uS[3]=nsp-1 & if not vert then uS=[uS[1],uS[0],uS[3],uS[2]]
                   widget_control,idt[2],get_value=trsa      ,use_table_select=uS           ;tr.Sampl value
                   widget_control,idt[0],get_value=trw       ,use_table_select=uset_tW      ;tr.Water value
                   widget_control,idt[0],get_value=trwc      ,use_table_select=uset_tWC     ;tr.Wat.C value
                   widget_control,idt[1],get_value=trsc      ,use_table_select=uset_tSC     ;tr.Sam.C value
                   widget_control,idt[0],get_value=watr      ,use_table_select=uset_watr    ;water sample

                   ;if watr le ' ' then trw=0.
                   sans_settings_trans, baset,trans4=float([trw,trwc,trsa[0],trsc])<6.1>.0, transSample=float(reform(trsa))<6.1>.0
             end
"give_IDs":  begin & uS=uset_IDs & uS[3]=nsp-1 & if not vert then uS=[uS[1],uS[0],uS[3],uS[2]]
                   widget_control,idt[2],get_value=SIDs     ,use_table_select=uS           ;All Sampl IDs
                   mess = strtrim(strcompress(SIDs),2)
             end
"get_ctr" :  begin & if readerr eq '' then begin ; put centers in appropriate comments
                      searc=(["nothing!",LOW+" ",MIDDLE+" ",HIGH+" "])[newLMH]
                      for i=0,n_elements(idc)-1 do begin & widget_control,idc[i],get_value=tmp
                       for j=0,n_elements(tmp)-1 do begin
                          if strpos(tmp[j],searc) ge 0 then begin & a1=-1 &  a2=-1
                             a1=strpos(tmp[j],'[CxCy=') & if a1 ge 0 then  a2=strpos(tmp[j],'] ',a1+1)
                             ln=strlen(present) & if ln lt 22 then present=present+strjoin(replicate(' ',22-ln))
                             if a2 gt a1 then T=strmid(tmp[j],0,a1+6)+present+strmid(tmp[j],a2) $
                                         else T=strmid(tmp[j],0,13)+'[CxCy='+present +'] '+strmid(tmp[j],13)
                             tmp[j]=T & widget_control,idc[i],set_value=tmp & endif
                       endfor
                      endfor ; now center is calculated
                      sbaset.savedCTR[newLMH-1]=1 & widget_control,ev.top,set_uvalue=sbaset
                   endif
             end
"get_msk" :  begin  ; put sample masks in appropriate comments
                      searc=(["nothing!",LOW+" ",MIDDLE+" ",HIGH+" "])[newLMH]
                      for i=0,n_elements(idc)-1 do begin & widget_control,idc[i],get_value=tmp
                       for j=0,n_elements(tmp)-1 do begin
                          if strpos(tmp[j],searc) ge 0 then begin & a1=-1 &  a2=-1
                             a1=strpos(tmp[j],'[Mask=') & if a1 ge 0 then  a2=strpos(tmp[j],'] ',a1+1)
                             ln=strlen(present) & if ln lt 11 then present=present+strjoin(replicate(' ',11-ln))
                             if a2 gt a1 then T=strmid(tmp[j],0,a1+6)+present+strmid(tmp[j],a2) $
                                         else T=strmid(tmp[j],0,13)+'[Mask='+present +'] '+strmid(tmp[j],13)
                             tmp[j]=T & widget_control,idc[i],set_value=tmp & endif
                       endfor
                      endfor
             end
"get_mskW":  begin  ; put water masks in appropriate comments
                      searc="WATER "
                      if curWATER eq 2 then Cf='H' else if curWATER eq 3 then Cf='L' else Cf='D'
                      for i=0,n_elements(idc)-1 do begin & widget_control,idc[i],get_value=tmp
                       for j=0,n_elements(tmp)-1 do begin
                          if strpos(tmp[j],searc) ge 0 then begin & a1=-1 &  a2=-1
                             a1=strpos(tmp[j],'[Mask'+Cf+'=') & if a1 ge 0 then  a2=strpos(tmp[j],'] ',a1+1)
                             ln=strlen(present) & if ln lt 11 then present=present+strjoin(replicate(' ',11-ln))
                             if a2 gt a1 then T=strmid(tmp[j],0,a1+7)+present+strmid(tmp[j],a2) $
                                         else T=strmid(tmp[j],0,13)+'[Mask'+Cf+'='+present +'] '+strmid(tmp[j],13)
                             tmp[j]=T & widget_control,idc[i],set_value=tmp & endif
                       endfor
                      endfor
             end
"get_wdm" :  begin ; put title and count in appropriate cell
                   wdm=present & A=newLMH-1 & count=wdm.count[0:(n_elements(wdm.count)-1)<(nsp-1)] & ns=n_elements(count)-1
                                 W=wdm.watrN-1
                   if sansref ne 0 then begin
                   case wdm.cell of
                   1: begin & B=idt[0] & d= i_tW  & C=sbaset.equiW[d,0,3]         & us=[C , 0    , C , 0   ] ;tr.Water     (WATER)  4
                      end
                   2: begin & B=idt[0] & d= i_tWC & C=sbaset.equiW[d,0,3]         & us=[C , 0    , C , 0   ] ;tr.Wat.Cell  (WATER)  5
                      end
                   3: begin & B=idt[2] & d= i_tS  & C=sbaset.equiS[d,0,3]         & us=[C , 0    , C , ns  ] ;tr.Sam(*nsp) (SAMPLE) 4
                                       if not vert then                           us=[0 , C    , ns, C   ] $
                                       else if ns gt 0 then count=transpose(count)
                      end
                   4: begin & B=idt[1] & d= i_tSC & C=sbaset.equiB[d[0],d[1],3]   & us=[C , d[1] , C , d[1]] ;tr.Sam.Cell  (BEAM)   [3,2]
                      end
                   5: begin & B=idt[1] & d= i_tSB & C=sbaset.equiB[d[0],d[1],3]   & us=[C , d[1] , C , d[1]] ;tr.Sam.Beam  (BEAM)   [3,0]
                      end
                   6: begin & B=idt[0] & d= i_tWB & C=sbaset.equiW[d,0,3]         & us=[C , 0    , C , 0   ] ;tr.Wat.Beam  (WATER)  6
                      end
                   9: begin & B=idt[1] & d= i_SDb & C=sbaset.equiB[d[0]+A,d[1],3] & us=[C , d[1] , C , d[1]] ;Sam.Beam(*3) (BEAM)   [0,0]
                      end
                   10:begin & B=idt[0] & d= i_W   & C=sbaset.equiW[d,0,3]         & us=[C , W    , C , W   ] ;Water        (WATER)  0
                      end
                   11:begin & B=idt[0] & d= i_WC  & C=sbaset.equiW[d,0,3]         & us=[C , W    , C , W   ] ;Wat.Cell     (WATER)  2
                      end
                   12:begin & B=idt[2] & d= i_S   & C=sbaset.equiS[d+A,0,3]       & us=[C , 0    , C , ns  ] ;Sampl(3*nsp) (SAMPLE) 1
                                       if not vert then                           us=[0 , C    , ns, C   ] $
                                       else if ns gt 0 then count=transpose(count)
                      end
                   13:begin & B=idt[1] & d= i_SC  & C=sbaset.equiB[d[0]+A,d[1],3] & us=[C , d[1] , C , d[1]] ;Sam.Cell(*3) (BEAM)   [0,2]
                      end
                   14:begin & B=idt[1] & d= i_SCd & C=sbaset.equiB[d[0]+A,d[1],3] & us=[C , d[1] , C , d[1]] ;Sam.Cad(*3)  (BEAM)   [0,1]
                      end
                   15:begin & B=idt[0] & d= i_WCd & C=sbaset.equiW[d,0,3]         & us=[C   ,W   , C , W   ] ;Wat.Cad      (WATER)  1
                      end
                   26:begin & B=idt[1] & d= i_FLX & C=sbaset.equiB[d[0]+A,d[1],3] & us=[C , d[1] , C , d[1]] ;tr.FLUX(*3)  (BEAM)   [0,0]
                      end
                   else: return
                   endcase
                   widget_control,B ,set_value=count ,use_table_select=uS,alignment=0
                   endif ;sansref
             end
"get_error": begin & readerr=present ;& print,present
             end
"get_a_trs": begin ;return in "mess" TRANS values according to run string in "present"
                   A=(newLMH-1)>0
                   if vert then uSS=[I_S+A ,0 ,I_S+A ,nsp-1] else uSS=[0 ,I_S+A ,nsp-1 ,I_S+A]
                   widget_control,idt[2],get_value=series,use_table_select=uSS
                   idx=strpos(strtrim(series,2),strtrim(present,2))
                   lineTRS=where(idx ge 0) & mess=0. & lineTRS=lineTRS[0]
                   if lineTRS ge 0 then begin
                      uStr=uset_tS & uStr[[1,3]]=lineTRS & if not vert then uStr=[uStr[1],uStr[0],uStr[3],uStr[2]]
                      widget_control,idt[2],get_value=curTRS,use_table_select=uStr
                      if curTRS gt ' ' then mess=float(curTRS)
                   endif
             end
; ------------------- LEVEL 2 ------------------------------------------------
 else:     begin
           readerr='' & wdm=''
           radin =strtrim(string(incr,format='(f4.1)'),2)
           KPkase=kase
           widget_control,bradin,set_value=radin
           widget_control,idt[0],get_value=water ;READ ALL TABLES (or using unames)
           widget_control,idt[1],get_value=beam
           widget_control,idt[2],get_value=sample & if (not vert) then sample=transpose(sample)

           water=strcompress(water,/remove_all) & beam=strcompress(beam,/remove_all) & sample=strcompress(sample,/remove_all)

           if sansref ne 0 then begin
            Twater=water[ i_tW]         & TwaterC =water[i_tWC]             & TwaterB=water[i_tWB]             & thinW =water[ i_thinW]
            Tsampl=sample[i_tS,0:nsp-1] & TsamplC =beam[ i_tSC[0],i_tSC[1]] & TsamplB=beam[ i_tSB[0],i_tSB[1]] & thinSs=sample[i_thinS,0:nsp-1]
           endif else begin
            Twater=''                & TwaterC =''          & TwaterB=''          & thinW ='.1'
            Tsampl=strarr(nsp)       & TsamplC =''          & TsamplB=''          & thinSs=strarr(nsp)+'.1'
           endelse

           ;GET CELL RUN VALUES from WATER, BEAM, SAMPLE cells
           ;**************************************************
            Swater=water[i_W]                           & SwaterCd=water[i_WCd]                   & SwaterC=water[i_WC]
            Nwater=water[i_W,*]                         & NwaterCd=water[i_WCd,*]                 & NwaterC=water[i_WC,*]
            SsamplCd=beam[i_SCd[0]:i_SCd[0]+2,i_SCd[1]] & SsamplC=beam[i_SC[0]:i_SC[0]+2,i_SC[1]] & SDbeam =beam[i_SDb[0]:i_SDb[0]+2,i_SDb[1]]
            Ssampl=sample[i_S[0]  :i_S[0]+2  ,0:nsp-1]                                            & FLXbeam=beam[i_FLX[0]:i_FLX[0]+2,i_FLX[1]]
            Msampl=Ssampl[*,0] & for i=0,2 do if SsamplC[i] gt ' ' then Msampl[i]=SsamplC[i]

            idx=where(Ssampl[0,*] gt '      ') & if idx[0] ge 0 then savSMP[0]=n_elements(idx) else savSMP[0]=0 ;Is there low    samples?
            idx=where(Ssampl[1,*] gt '      ') & if idx[0] ge 0 then savSMP[1]=n_elements(idx) else savSMP[1]=0 ;Is there middle samples?
            idx=where(Ssampl[2,*] gt '      ') & if idx[0] ge 0 then savSMP[2]=n_elements(idx) else savSMP[2]=0 ;Is there high   samples?
            if       (Swater      gt '      ')                  then savSMP[3]=1               else savSMP[3]=0 ;Is there some   water?
            if total(savSMP*[2,4,8,16]) ne total(sbaset.savedSMP*[2,4,8,16]) then begin
               sbaset.savedSMP=savSMP & widget_control,ev.top,set_uvalue=sbaset & endif

               ;EQUIVALENCE with sans_settings
               ; -----------------------------
               ;          bases3 =[bwatr ,bwatre,bsampl,bsampe,bcadmi,bcadmw,  blabw,blabwe,blabs,blabse,blabc ,blabcw,$   ;0 ->11 sample
               ;                   awatr ,awatre,asampl,asampe,abeamS,abeamW,  alabw,alabwe,alabs,alabse,alabbS,alabbW,$   ;12->23 transmission
               ;                                 msampl,mwater,                             mlabs,mlabw ,confus,$          ;24->28 mask ,center
               ;                   Wwatr2,Wwatr3,Wwate2,Wwate3,Wcadc2,Wcadc3,  Wlabw2,Wlabw3,Wlabe2,Wlabe3,Wlabc2,Wlabc3,$ ;29->40 water alternatives
               ;                                                      SampFX,                                     SlabFX,$ ;41->42 FLUX  alternatives

          ;PUT TRANSMISSION RUNS in sans_settings appropriate variables
          ; --------------------
           if sansref ne 0 then begin
           tmp=long(Tsampl) & tmp=long(TsamplC)
           sans_settings_series,(Tsampl), /Tplace & sans_settings_series,(TsamplC)

           widget_control,baset.bases3[12],get_value=_water   &  widget_control,baset.bases3[13],get_value=_waterC
           widget_control,baset.bases3[14],get_value=_sampl   &  widget_control,baset.bases3[15],get_value=_samplC
           widget_control,baset.bases3[17],get_value=_waterB  &  sans_settings_beamST, baset,    get_Tbeam=_samplB  ;Confus...

           widget_control,baset.bases3[12],set_value=Twater   &  widget_control,baset.bases3[13],set_value=TwaterC
           widget_control,baset.bases3[14],set_value=Tsampl   &  widget_control,baset.bases3[15],set_value=TsamplC
           widget_control,baset.bases3[17],set_value=TwaterB  &  sans_settings_beamST, baset,        Tbeam=TsamplB  ;Confus...

           ;IF something has changed then must calculate new transmissions
           if (_water  ne Twater ) or  (_waterC ne TwaterC) or (_sampl ne Tsampl) or (_samplC ne TsamplC) or (_waterB ne TwaterB) or $
             ((_samplB ne TsamplB) and (kase ne 'update')) then begin & sbaset.savedTRM=0
                widget_control,ev.top,set_uvalue=sbaset & endif
                
           endif

          ;PUT A CLOUD OF SCATTERING WATER in sans_settings appropriate variables
          ; ------------------------------
           widget_control,baset.bases3[ 0],set_value=Swater      &  widget_control,baset.bases3[ 5],set_value=SwaterCd
           widget_control,baset.bases3[ 1],set_value=SwaterC     &  widget_control,baset.bases3[25],set_value=Swater ;(mask)

           if n_elements(Nwater) gt 1 then begin    ;Alternative Water2
           widget_control,baset.bases3[29],set_value=Nwater[1]   &  widget_control,baset.bases3[31],set_value=NwaterC[1]
           widget_control,baset.bases3[33],set_value=NwaterCd[1] &  endif
           if n_elements(Nwater) gt 2 then begin    ;Alternative Water3
           widget_control,baset.bases3[30],set_value=Nwater[2]   &  widget_control,baset.bases3[32],set_value=NwaterC[2]
           widget_control,baset.bases3[34],set_value=NwaterCd[2] &  endif

           sans_settings_choice_water, baset, callflag='sync'                   ;The dispatching Water macro
           
           if n_elements(Nwater) gt 1 then begin
              WatSel=widget_info(idt[0],/table_select) & WatSel=Watsel[1]>0
              if (kase eq "mask_water") and (nWATER[WatSel] gt ' ') then begin  ;User want to mask a water
                  useWATER=1
                  curWATER=WatSel+1 ;CARE def, high, low (selWATER)
                  widget_control,baset.bases3[25],set_value=nWATER[WatSel] ;(mask)
              endif
           endif

          ;PUT THICKNESS in sans_settings appropriate variables
          ; ------------
           if sansref ne 0 then begin
            thinW =strtrim(string(thinW,format='(f5.2)'),2)    &  thinS =strtrim(string(thinSs[0],format='(f5.2)'),2)
            widget_control,baset.bases7[4] ,set_value =thinW   &  widget_control,baset.bases2[20],set_value =thinW
            widget_control,baset.bases7[5] ,set_value =thinS   &  widget_control,baset.bases2[21],set_value =thinS
            sans_settings_trans, baset, thickWater=float(thinW),  thickSample=float(thinSs) ;trans4=, transSample=

           ;PUT TRANSMISSION VALUES in sans_settings appropriate variables
           ; ----------------------   
            uS=uset_tS & uS[3]=nsp-1 & if not vert then uS=[uS[1],uS[0],uS[3],uS[2]]
            widget_control,idt[2],get_value=trsa      ,use_table_select=uS           ;tr.Sampl value
            widget_control,idt[0],get_value=trw       ,use_table_select=uset_tW      ;tr.Water value
            widget_control,idt[0],get_value=trwc      ,use_table_select=uset_tWC     ;tr.Wat.C value
            widget_control,idt[1],get_value=trsc      ,use_table_select=uset_tSC     ;tr.Sam.C value
            widget_control,idt[0],get_value=watr      ,use_table_select=uset_watr    ;water sample
            ;if watr le ' ' then trw=0.
            sans_settings_trans, baset,trans4=float([trw,trwc,trsa[0],trsc])<6.1>.0, transSample=float(reform(trsa))<6.1>.0
           endif
           
           widget_control,sbaset.baseSANS,set_uvalue=baset ;SANS_SETTINGS STRUCTURE may have changed !

          ;INPUT OR RIGHT CLICK EVENT
          ;**************************
           if (strpos(kase,"WATER") ge 0) or (strpos(kase,"BEAM") ge 0) or (strpos(kase,"SAMPLE") ge 0) then begin
              if sbaset.input_CELL[0] ge 0 then begin & select=[sbaset.input_CELL,sbaset.input_CELL] & sbaset.input_CELL=[-1,-1]
              endif else select=widget_info(ev.id,/table_select)      ;Because tab button do an enter and change selection!!!!
              if (select[0]-select[2] ge 0) and (select[1]-select[3] ge 0) then begin
                 if strpos(kase,"WATER")  ge 0 then if nWATER[select[1]] gt ' ' then curWATER=select[1]+1 ;CARE def, high, low (selWATER)
                 if strpos(kase,"WATER")  ge 0 then equi=sbaset.equiW[select[0],select[1],*] else $
                 if strpos(kase,"BEAM")   ge 0 then equi=sbaset.equiB[select[0],select[1],*] else $
                 if strpos(kase,"SAMPLE") ge 0 then if vert then equi=sbaset.equiS[select[0],select[1],*] $
                                                            else equi=sbaset.equiS[select[1],select[0],*]
                 if strpos(kase,"run_" )  ge 0 then begin
                 ;SHOW A RUN (LOW MIDDLE HIGH or not) treated inside next CASES
                 ; ---------------------------------  kase is replaced by "run_" , "run_(lmh)" or "run_water"
                    widget_control,ev.id,get_value=run_,use_table_select=select & run_=strcompress(run_[0],/remove_all)
                    tmp=long(run_) & if (run_ gt ' ') and (tmp eq float(run_))  then begin
                      if equi[0] ge 0 then begin ; equi = [bases3 text index (run) , event# , LMH , Count cell index!]
                          kpselect=select
                          if  (strpos(kase,"SAMPLE") ge 0) and (not vert) then kpselect[[1,3]]=equi[3] $
                                                                          else kpselect[[0,2]]=equi[3]
                          if  (strpos(kase,"SAMPLE") ge 0) then begin
                               if (not vert) then kpselect[1]=equi[3]     else kpselect[0]=equi[3]
                               if (not vert) then lineTRS=select[0]       else lineTRS=select[1]
                               uStr=uset_tS & uStr[[1,3]]=lineTRS & if not vert then uStr=[uStr[1],uStr[0],uStr[3],uStr[2]]
                               widget_control,ev.id,get_value=curTRS,use_table_select=uStr
                               if curTRS gt ' ' then curTRS=float(curTRS) else curTRS=0.
                               baset.curSAMtrs=curTRS
                          endif else baset.curSAMtrs=0.
                          
                          evenTXT=((nsp eq 1) or (kase ne "run_SAMPLE")) & mess='run '+run_
                          
                          if  (strpos(kase,"WATER")  ge 0) then begin
                           kase="run_"
                           useWATER=(n_elements(Nwater) gt 1)
                           if (run_ eq Nwater[curWATER-1]) then begin ;(selWATER)
                               kase="run_water"                ;special water-> mask
                               widget_control,baset.bases3[25],set_value=run_ ;(mask)
                           endif
                          endif else kase="run_"+(["","low","middle","high"])[equi[2]]
                      endif ;else not a run
                    endif ;else blank cell
                 endif else if strpos(kase,"input_" ) ge 0 then begin
                 ;A CELL HAS BEEN ENTERED
                 ; ----------------------
                      dodo=0 ;Do nothing for the moment
                      if (equi[0] ge 0) and (dodo) then begin
                          kase="input_"+(["","low","middle","high"])[equi[2]]
                      endif
                 endif
              endif
           endif

          ;PUT LOW-MIDDLE-HIGH OTHER RUNS  in sans_settings appropriate variables when possible
          ; ----------------------------- (SDBEAM , MSAMPL , SCELL , SCADMI , SAMPLES , WATER , FLXbeam)
           if strpos(kase,"_low")    ge 0 then k=0 else $
           if strpos(kase,"_middle") ge 0 then k=1 else $
           if strpos(kase,"_high")   ge 0 then k=2 else k=-1

              def=1 & defw2=1 & defw3=1 ; Waters creasy cases
              if savSMP[1] gt 0 then begin & def=1 & endif else $
              if savSMP[0] gt 0 then begin & def=0 & if n_elements(nWATER) ge 3 then if nWATER[2] gt ' ' then def=-1 & endif else $
              if savSMP[2] gt 0 then begin & def=2 & if n_elements(nWATER) ge 2 then if nWATER[1] gt ' ' then def=-1 & endif
              
              if n_elements(nWATER) ge 2 then if nWATER[1] gt ' ' then defw2=2            ;we have a water in line 2
              if n_elements(nWATER) ge 3 then if nWATER[2] gt ' ' then defw3=3            ;we have a water in line 3
              
           if (useWATER) and (k lt 0) then k       =([-1,  def  ,2   ,0    ])[curWATER] $ ;User selected a water for masking Default=1, High=2, Low=3rd line (selWATER)
           else            if k ge 0  then curWATER=([     defw3,1   ,defw2])[k]          ;User only changed config so water= 3(k=0low), 1(k=1mid), 2(k=2high)
         
           if (curWATER ne baset.curWATER) or (curTRS ne baset.curSAMtrs) then begin
               baset.curWATER=curWATER & baset.curSAMtrs=curTRS
               widget_control,sbaset.baseSANS,set_uvalue=baset ;SANS_SETTINGS STRUCTURE as changed !
           endif

          ;WE ARE HERE WITH: RUN_(show) INPUT_(cell) SAVE_(mem)  TREAT_  MASK_  CENTER_ CLEAR_ useWATER
          ; -------------------------------------------------------------------------------------------
           if k ge 0 then begin & newLMH=k+1            & changA=0
            ;SWAP IF WE CHANGE ANGLE
             if (sbaset.curLMH ne newLMH)  then begin &   changA=1

               baset.curWATER = oldWATER
               if sbaset.curLMH gt 0 then begin & sans_settings_swap, baset,/put,LMH=(["low","middle","high"])[sbaset.curLMH-1]
                  sbaset.savedLMH[sbaset.curLMH-1]=1 & endif                                                     ;update before

              ;curLMH should be 0 (unknown config) if never swaped.
               baset.curWATER = curWATER
               baset.curLMH   = newLMH
               sbaset.curLMH  = newLMH
               if sbaset.savedLMH[k] then         sans_settings_swap, baset,/get,LMH=(["low","middle","high"])[k],/memswap ;The swap

               widget_control,ev.top,set_uvalue=sbaset
               widget_control,sbaset.baseSANS,base_set_title="  "+([LOW,MIDDLE,HIGH])[k]+ " current  " $
                                             ,set_uvalue=baset
             endif

             curDbeam = SDbeam[k]
             sans_settings_beamST, baset,get_Sbeam=oldDbeam                       ;Confus beam
             sans_settings_beamST, baset,    Sbeam=SDbeam[k]
             if oldDbeam ne curDbeam then sbaset.savedCTR[k]=0                    ;must calculate new CENTER

             curDflx  = FLXbeam[k]
             widget_control,baset.bases3[41],get_value=FLXold                     ;alternative FLUX old
             widget_control,baset.bases3[41],set_value=curDflx                    ;alternative FLUX new
             if FLXold   ne curDflx  then begin & sbaset.savedFLX[k]=0            ;must calculate new FLUX
                sans_settings_GetSupl, Supl & supl[60]=0                          ; to be sure!
                sans_settings_SetSupl, Supl                                       ; ""
             endif   
             widget_control,baset.bases3[4] ,set_value=SsamplCd[k]                ;Background
             widget_control,baset.bases3[24],set_value=Msampl[k]                  ;Mask
             
             tmpC=SsamplC[k,*] & tmp=long(tmpC) & sans_settings_series,tmpC       ;Sample cell
             widget_control,baset.bases3[3] ,set_value=tmpC                       ;
                          
             tmpS=Ssampl[k,*]                                                     ;Sample
             if (strpos(kase,"treat_") ge 0) then $                               ;  if TREAT and have selected sample IDs
               if (nSampIds[0] ge 0) then begin                                   ;     reduce to selected IDs
                 if (nSampIds[0] gt 0)     then tmpS[ 0 : nSampIds[0]-1 ]    = '' ;
                 if (nSampIds[1] lt nsp-1) then tmpS[nSampIds[1]+1 : nsp-1 ] = '' ;
               endif
             tmp=long(tmpS) & sans_settings_series,tmpS,/Splace                   ;
             widget_control,baset.bases3[2] ,set_value=tmpS                       ;

            ;SAVE AFTER ANYWAY ?
             if (strpos(kase,"save_")  ge 0) or  (strpos(kase,"clear_") ge 0) or $
               ((strpos(kase,"treat_") ge 0) and (not changA)) then begin
                sans_settings_swap, baset,/put,LMH=(["low","middle","high"])[k]
                sbaset.savedLMH[k]=1
             endif
             
             widget_control,ev.top,set_uvalue=sbaset
             widget_control,sbaset.baseSANS,set_uvalue=baset ;SANS_SETTINGS STRUCTURE may have changed also !

           endif ;k ge 0

; ------------------- LEVEL 3 ------------------------------------------------
           case 1 of
           (kase eq "save") or (kase eq "savetxt"):  begin
                   ;READ ALL COMMENTS
                                                       widget_control,idc[0],get_value=comments
                    for i=1,n_elements(idc)-1 do begin & widget_control,idc[i],get_value=tmp
                                                       comments=[comments,tmp]  &   endfor

                    on_ioerror,missave
                    get_lun,u & free_lun,u & u=-1 & ok=0
                    
                    CALIBRATION ,GET_CAL=g_cal, INF=f_inf
                    if (n_elements(g_cal) gt 1) and (n_elements(f_inf) eq 1) then caltxt=f_inf else caltxt=''

                    ; ----->SAVE A TEXT TABLE FILE
                    a=strpos(sbaset.curfile,'.sav') & if a gt 0 then curtxt=strmid(sbaset.curfile,0,a)+'.txt' else curtxt=sbaset.curfile+'.txt'
                    if kase eq "savetxt" then curtxt='current_spreadsheet.txt'
                    
                    szwat=size(WATER)  & stwat=strtrim(szwat[1],2) & stwat='6'
                    szbim=size(BEAM)   & stbim=strtrim(szbim[1],2) & stbim='5'
                    szsmp=size(SAMPLE) & stsmp=strtrim(szsmp[1],2) & stsmp='6'                   
                    sans_sheet_lampies   , GETpth =datapth & sbaset.DATApth=datapth
                    sans_settings_GetSupl, Supl
                    if Supl[27]  then dtcor='enabled.' else dtcor='disabled.' ;DEAD time
                    if Supl[28]  then sacor='enabled.' else sacor='disabled.' ;Solide angle
                    if Supl[48]  then mtcor='TIMES'    else mtcor='MONITORS'  ;Time or Monitor
                    if Supl[44]  then abcor='No absolute scaling is demanded.'                  else $
                    if Supl[29]  then abcor='Water cross section is SET by the User.'           else abcor=''
                    if incr eq 0 then itcor='Reduction set for 2D correction only.'             else $
                    if Togg[6]   then itcor='Reduction set for 2*Pi radial integration.'        else $
                    if Togg[7]   then itcor='Reduction set for 2*Pi azimuthal integration.'     else $
                    if Togg[9]   then itcor='Sectors set for total symmetrical integration.'    else $
                    if Togg[10]  then itcor='Sectors set for total non-symmetric integration.'  else $
                    if Togg[11]  then itcor='Sectors set for radial symmetrical integration.'   else $
                    if Togg[12]  then itcor='Sectors set for radial non-symmetric integration.' else itcor=''

                    if not file_test(sbaset.SAVpth,/directory)    then sbaset.SAVpth=''
                    openw,u,sbaset.SAVpth+curtxt,/get_lun
                        printf,u,'SPREAD SHEET WRITTEN FOR '+sbaset.instru+' BY LAMP on '+systime() & printf,u,""
                        printf,u,'Lambda:'+string(Supl[0],format='(F5.2)')+' Angstrom.   Delta_L/Lambda:'+string(Supl[50],format='(F4.2)')
                        printf,u,""
                        printf,u,'Dead time correction is '+dtcor +'   Solid angle correction is '+sacor
                        printf,u, mtcor+' are used for normalisations. ' +abcor
                        printf,u,""
                        printf,u, itcor
                        printf,u,""
                        printf,u,'Data path:'+datapth
                        printf,u,""
                        printf,u,'**************'
                        printf,u,'*',comments[0]
                        printf,u,'**************'
                        printf,u,sbaset.col_label[0:stwat-1,idxa[0]]   ,format='(" ",'+stwat+'(A13))'
                        printf,u,                                       format='(" ",'+stwat+'(1X,"------------"))'
                        printf,u,WATER[0:stwat-1,0]  ,format='('+stwat+'(A13))'
                        if szwat[0] eq 2 then for i=1,szwat[2]-1 do $
                        printf,u,WATER[0:2,i]        ,format='('+ '3' +'(A13))'
                        printf,u,sbaset.col_label[stwat  ,idxa[0]],' : ',WATER[stwat  ,0]
                        printf,u,sbaset.col_label[stwat+1,idxa[0]],' : ',WATER[stwat+1,0]
                        printf,u,sbaset.col_label[stwat+2,idxa[0]],' : ',WATER[stwat+2,0]
                        if caltxt gt ' ' then $
                        printf,u,'Calibration: '+caltxt
                        printf,u,"" & printf,u,""

                        printf,u,'**************'
                        printf,u,'*',comments[1]  & printf,u,'*',comments[2]     & printf,u,'*',comments[3]
                        printf,u,'**************'
                        printf,u,"",sbaset.col_label[0:stbim-1,idxa[1]],           format='(" ",A13,'+stbim+'(A13))'
                        printf,u,                                                  format='("              ",'+stbim+'(1X,"------------"))'
                        for i=0,szbim[2]-1 do $
                        printf,u,   sbaset.row_label[i,idxa[1]],BEAM[0:stbim-1,i], format='(A13,'+stbim+'(A13))'
                       ;printf,u,   sbaset.col_label(  stbim  ,idxa(1)),' : ',BEAM(stbim  ,2)
                        printf,u,"" & printf,u,""

                        printf,u,'**************'
                        printf,u,'*',comments[4]
                        printf,u,'**************'
                        printf,u,sbaset.col_label[1:stsmp  ,idxa[2]], format='(" ",'+stsmp+'(A13))'
                        printf,u,                                     format='(" ",'+stsmp+'(1X,"------------"))'
                        if szsmp[0] eq 2 then szsm=szsmp[2]-1 else szsm=0
                        for i=0L,szsm do begin
                        printf,u,' ID'+strtrim(i+1,2)+': '+SAMPLE[0,i]
                        printf,u,SAMPLE[1:stsmp,i],                 format='('+stsmp+'(A13))' ;  & printf,u,""
                        endfor
                        flush ,u
                        free_lun,u & u=-1
                        
                    if kase eq "save" then begin
                    ok=1
                    ; ----->SAVE LIST OF RESULTS
                    a=strpos(sbaset.curfile,'.sav') & if a gt 0 then curlst=strmid(sbaset.curfile,0,a)+'_result.sav' else curlst=sbaset.curfile+'_result.sav'
                    sans_sav_rest_results,'save', path=sbaset.SAVpth, file=curlst

                    ; ----->SAVE THE STRUCTURE
                    widget_control,/hourglass
                    if not sbaset.savedLMH[0] then sans_settings_swap, baset,LMH="low"   , take={bid:0}
                    if not sbaset.savedLMH[1] then sans_settings_swap, baset,LMH="middle", take={bid:0}
                    if not sbaset.savedLMH[2] then sans_settings_swap, baset,LMH="high"  , take={bid:0}
                    if not sbaset.savedLMH[0] then sans_settings_swap, baset,LMH="low"   , take={bid:0},/nodata
                    if not sbaset.savedLMH[1] then sans_settings_swap, baset,LMH="middle", take={bid:0},/nodata
                    if not sbaset.savedLMH[2] then sans_settings_swap, baset,LMH="high"  , take={bid:0},/nodata
                    forceNoData=0
                    if (strpos(sbaset.SAVpth,'/net')    ge 0) or (strpos(sbaset.SAVpth,'/home/')   ge 0) or $  ; Pb reseau AT ILL !!!
                       (strpos(sbaset.SAVpth,'illdata') ge 0) or (strpos(sbaset.SAVpth,'serdon')   ge 0) or (forceNoData)  then begin
                        sans_settings_swap, baset,LMH="low"   , give=low_struct   ,/nodata
                        sans_settings_swap, baset,LMH="middle", give=middle_struct,/nodata
                        sans_settings_swap, baset,LMH="high"  , give=high_struct  ,/nodata
                    endif else begin
                        sans_settings_swap, baset,LMH="low"   , give=low_struct
                        sans_settings_swap, baset,LMH="middle", give=middle_struct
                        sans_settings_swap, baset,LMH="high"  , give=high_struct
                    endelse

                    water_cw =widget_info(idt[0],/column_widths) ;Reminde width of columns
                    beam_cw  =widget_info(idt[1],/column_widths)
                    sample_cw=widget_info(idt[2],/column_widths)
                    RLstruct={SBASET:sbaset,COMMENTS:comments,WATER:water,BEAM:beam,SAMPLE:sample, $
                                            WATERcw:water_cw,BEAMcw:beam_cw,SAMPLEcw:sample_cw, $
                                            INF_CAL:f_inf   ,GET_CAL:g_cal, $
                              low_struct:low_struct,middle_struct:middle_struct,high_struct:high_struct}
                    SAVE,RLstruct,file=sbaset.SAVpth+sbaset.curfile,/compress

                    missave:if not ok then mess=!error_state.msg else mess=sbaset.curfile+" is saved (text in "+curtxt+")"
                    on_ioerror,misconv
                    if u gt 0 then free_lun,u
                    
                    endif else mess='' ; endif 'save' else 'savetxt'
                    end
           (kase eq "clear_low") or (kase eq "clear_middle") or (kase eq "clear_high"): begin
                    end
           (kase eq "run_low") or (kase eq "run_middle") or (kase eq "run_high") or (kase eq "run_water") or (kase eq "run_"): begin
                    widget_control,/hourglass
                    widget_control,ev.id,set_uvalue=[equi[1]] & sans_settings_event,kev & widget_control,ev.id,set_uvalue=keepUV
                    if evenTXT then begin
                       sev="{WIDGET_TEXT_CH,ID:baset.bases3[equi[0]],TOP:sbaset.baseSANS,HANDLER:0L,TYPE:1,OFFSET:0L,CH:10B}"
                       ii=execute("sans_settings_event,"+sev)
                    endif else begin
                       widget_control,baset.bases3[24],get_value=Krun_
                       widget_control,baset.bases3[24],set_value= run_  & sans_settings_runs, baset ,[9,26,8,baset.bases3[24]] ;mask
                       widget_control,baset.bases3[24],set_value=Krun_ ;& widget_control,sbaset.baseSANS,set_uvalue=baset
                    endelse
                    if readerr eq '' then begin & icoco=0
                       if n_tags(wdm) gt 0 then begin
                          mess=mess+'  Wavelength='+wdm.wavel+'  Distance:'+wdm.dist+'  Collim:'+wdm.colli+'  Offset:'+wdm.offs+ $
                                    '  Time(sec):'+wdm.time+'  Count:'+wdm.count[0]
                          if sansref ne 0 then widget_control,ev.id,set_value=wdm.count,use_table_select=kpselect ;DONE IN GET_WDM also
                       endif
                       if kase eq "run_water" then begin & widget_control,ev.id,set_uvalue=[50]      & sans_settings_event,kev ;+WATER MASK
                                                         widget_control,ev.id,set_uvalue=[55,2,-1] & sans_settings_event,kev
                                                         widget_control,ev.id,set_uvalue=keepUV
                                                         
                       endif else if (togg[7]+togg[8]) and (KPkase eq "run_SAMPLE") then $
                          if (kase eq "run_low") or (kase eq "run_middle") or (kase eq "run_high") then begin
                              if togg[7] then widget_control,ev.id,set_uvalue=[80,0,8] ;LOAD SECTORS FOR AZIMUTHAL DISTRIBUTION
                              if togg[8] then widget_control,ev.id,set_uvalue=[80,0,9+where(togg[9:12] eq 1)]     ;LOAD SECTORS
                              sans_settings_event,kev
                              widget_control,ev.id,set_uvalue=keepUV
                              widget_control,baset.bases3[24],set_value= run_ ;put sample in sample mask input text
                          endif
                    endif else mess=readerr
                    end
           (kase eq "mask_water"): begin & icoco=0
                    widget_control,ev.id,set_uvalue=[50]      & sans_settings_event,kev ;show water in mask window
                    widget_control,ev.id,set_uvalue=[55,2,-1] & sans_settings_event,kev
                    widget_control,ev.id,set_uvalue=keepUV
                    end
           (kase eq "mask_detector") or (kase eq "mask_detector_low") or (kase eq "mask_detector_middle") or (kase eq "mask_detector_high"): begin & icoco=0
                    widget_control,ev.id,set_uvalue=[50]      & sans_settings_event,kev ;show detector mask window
                    if kase eq "mask_detector" then v2=3 else v2=4
                    widget_control,ev.id,set_uvalue=[55,v2,0] & sans_settings_event,kev
                    widget_control,ev.id,set_uvalue=keepUV
                    end
           (kase eq "auto_mask_water"): begin
                    widget_control,ev.id,set_uvalue=[50]      & sans_settings_event,kev
                    widget_control,ev.id,set_uvalue=[55,2,1]  & sans_settings_event,kev ;auto water beam mask calculation
                    widget_control,ev.id,set_uvalue=keepUV
                    end
; ------------------- LEVEL 4 ------------------------------------------------
            else: begin
                  ok=1
                  case 1 of
                  (kase eq "options"):       begin & icoco=0
                                   widget_control,ev.id,set_uvalue=[90]
                                   end
                  (kase eq "cor_low") or (kase eq "cor_middle") or (kase eq "cor_high"):    begin & icoco=0
                                   widget_control,ev.id,set_uvalue=[85,newLMH]
                                   end
                  (kase eq "mask_low") or (kase eq "mask_middle") or (kase eq "mask_high"): begin & icoco=0
                                   widget_control,ev.id,set_uvalue=[50]
                                   sans_settings_event,kev
                                   widget_control,ev.id,set_uvalue=[55,1,0]
                                   end
                  (kase eq "load_mask"):     begin
                                   widget_control,ev.id,set_uvalue=[16]
                                   end
                  (kase eq "save_mask"):     begin
                                   widget_control,ev.id,set_uvalue=[13,4,0]
                                   end
                  (kase eq "mask_sector"):   begin & icoco=0
                                   if togg[7] then widget_control,ev.id,set_uvalue=[80,0,8] ;LOAD SECTORS FOR AZIMUTHAL DISTRIBUTION
                                   if togg[8] then widget_control,ev.id,set_uvalue=[80,0,9+where(togg[9:12] eq 1)]     ;LOAD SECTORS
                                   end
                  (kase eq "transmission"):  begin & icoco=0
                                   widget_control,ev.id,set_uvalue=[40]
                                   end
                  (kase eq "transm_file"):   begin
                                   widget_control,ev.id,set_uvalue=[40]
                                   sans_settings_event,kev
                                   widget_control,ev.id,set_uvalue=[72,0,0]
                                   end
                  (kase eq "trans_cal"):     begin
                                   if sansref ne 0 then begin
                                   widget_control,ev.id,set_uvalue=[40]
                                   sans_settings_event,kev
                                   widget_control,ev.id,set_uvalue=[49]
                                   endif
                                   end
                  (kase eq "ctr_cal_low") or (kase eq "ctr_cal_middle") or (kase eq "ctr_cal_high"): begin
                                   widget_control,ev.id,set_uvalue=[30,1]
                                   sans_settings_event,kev
                                   widget_control,ev.id,set_uvalue=[39,0]
                                   end
                  (kase eq "flx_cal_low") or (kase eq "flx_cal_middle") or (kase eq "flx_cal_high"): begin
                                   lamp_journal,'Alternative FLUX calculation'
                                   widget_control,ev.id,set_uvalue=[61,26]
                                   sbaset.savedFLX[newLMH-1]=1  &  widget_control,ev.top,set_uvalue=sbaset ; savedFLX ok
                                   end
                  (kase eq "msk_cal_low") or (kase eq "msk_cal_middle") or (kase eq "msk_cal_high"): begin
                                   widget_control,ev.id,set_uvalue=[50]     & sans_settings_event,kev
                                   widget_control,ev.id,set_uvalue=[55,1,0] & sans_settings_event,kev ;read a sample mask

                                   widget_control,ev.id,set_uvalue=[30,1]   & sans_settings_event,kev
                                   widget_control,ev.id,set_uvalue=[39,1]               ;auto sample beam mask calculation
                                   end
                  (kase eq "center_low") or (kase eq "center_middle") or (kase eq "center_high"): begin
                                   if curDbeam le ' ' then mess="You should provide a Direct Beam !!!"
                                   widget_control,ev.id,set_uvalue=[30,1] & icoco=0
                                   end
                  (kase eq "treat_low") or (kase eq "treat_middle") or (kase eq "treat_high") or (kase eq "treat_det"): begin

                                   widget_control,sbaset.Mess,get_value=memess
                                   if baset.bases6[19] eq 0 then memess=memess+' (normalise by monitors)' else memess=memess+' (normalise by times)'
                                   widget_control,sbaset.Mess,set_value=memess

                                   widget_control, bstop, bad_id=ii, get_uvalue = Ubm
                                   if Ubm[1] then widget_control, bstop, bad_id=ii, map=1 ;Show the stop bitmap button(for rdopr)

                                   if kase eq "treat_det" then $
                                                      widget_control,ev.id,set_uvalue=[72,3,0] else $ ;detector efficiencies
                                   if incr eq 0. then widget_control,ev.id,set_uvalue=[72,1,0] else $ ;corrected data
                                   if togg[6]    then begin
                                                      widget_control,ev.id,set_uvalue=[72,2,0]        ;radial
                                                      sans_settings_event,kev
                                                      widget_control,ev.id,set_uvalue=[71,2,1]        ;show radial list
                                   endif else $
                                   if togg[7]    then begin
                                                      widget_control,ev.id,set_uvalue=[72,4,0]        ;azimutal
                                                      sans_settings_event,kev
                                                      widget_control,ev.id,set_uvalue=[71,4,1]        ;show azimutal list
                                   endif else $
                                   if togg[8]    then begin         ;togg(16) is ROCKING
                                    if togg[9]   then togs=5        ;sector total   sym
                                    if togg[10]  then togs=6        ;sector total  asym
                                    if togg[11]  then togs=7        ;sector radial  sym
                                    if togg[12]  then togs=8        ;sector radial asym
                                                      widget_control,ev.id,set_uvalue=[72,togs,togg[16]]
                                                      sans_settings_event,kev
                                                      widget_control,ev.id,set_uvalue=[71,togs,1]     ;show sector or azim list
                                   endif
                                   
                                   if readerr eq '' then if togg[5] then icoco=0
                                   if Ubm[1]        then widget_control, bstop, bad_id=ii, map=0 ;Hide the bitmap stop button(for rdopr)
                                   end
                  (kase eq "show_list"): begin &   icoco=0 & togs=0
                                   if togg[6]    then togs=2 else $
                                   if togg[7]    then togs=4 else $
                                   if togg[8]    then $
                                    if togg[9]   then togs=5 else $
                                    if togg[10]  then togs=6 else $
                                    if togg[11]  then togs=7 else $
                                    if togg[12]  then togs=8
                                    if togs gt 0 then widget_control,ev.id,set_uvalue=[71,togs,1] else icoco=-1
                                   end
                  (kase eq "export_gnum") or (kase eq "export_tnum") or $
                  (kase eq "export_3col") or (kase eq "export_coln") or $
                  (kase eq "export_png2") or (kase eq "export_nist"): begin
                                     if kase eq "export_gnum" then widget_control,ev.id,set_uvalue=[13,0,19]
                                     if kase eq "export_tnum" then widget_control,ev.id,set_uvalue=[13,2,18]
                                     if kase eq "export_3col" then widget_control,ev.id,set_uvalue=[13,1,19]
                                     if kase eq "export_coln" then widget_control,ev.id,set_uvalue=[13,3,18]
                                     if kase eq "export_png2" then widget_control,ev.id,set_uvalue=[13,6,18]
                                     if kase eq "export_nist" then widget_control,ev.id,set_uvalue=[13,7,18]
                                   end
                   else: ok=0
                   endcase
                   if ok then begin
                      if readerr eq '' then sans_settings_event,kev
                      widget_control,ev.id,set_uvalue=keepUV
                      mess=readerr
                   endif
                  end
           endcase
           end
endcase
if icoco eq 0 then widget_control,sbaset.baseSANS, iconify=0,/show
if icoco eq 1 then widget_control,sbaset.baseSANS,/iconify
return
misconv:mess=!error_state.msg
widget_control,ev.id,set_uvalue=keepUV
end

pro sans_sheet_receive, topev=topev, trans=trans, ctr=ctr, msk=msk, waterbox=Wbox, beambox=Bbox, lmh=lmh, $
                        wave_dist_cnt=wdm, error=err ,mess=mess, topget=topget, gettrans=Gtrs, give_IDs=give_IDs
;+
;** ******************
;** ******************
;** receive usefull informations from sans_settings
;-

common c_sheet_r, topstr
if  n_elements( topev) eq 1 then topstr=topev
if  arg_present(topget)     then topget=topstr.top

widget_control,topstr.top,get_uvalue=sbaset

if n_elements(err)   gt 0 then sans_sheet_sync, topstr, sbaset, 'get_error',       receive=err
if n_elements(trans) gt 0 then sans_sheet_sync, topstr, sbaset, 'get_trans', mess, receive=trans
if n_elements(ctr)   gt 0 then sans_sheet_sync, topstr, sbaset, 'get_ctr'  ,       receive=ctr
if n_elements(msk)   gt 0 then sans_sheet_sync, topstr, sbaset, 'get_msk'  ,       receive=msk ;file
if n_elements(Bbox)  gt 0 then sans_sheet_sync, topstr, sbaset, 'get_msk'  ,       receive=Bbox
if n_elements(Wbox)  gt 0 then sans_sheet_sync, topstr, sbaset, 'get_mskW' ,       receive=Wbox
if n_elements(wdm)   gt 0 then sans_sheet_sync, topstr, sbaset, 'get_wdm'  ,       receive=wdm
if n_elements(Gtrs)  eq 1 then sans_sheet_sync, topstr, sbaset, 'get_a_trs', mess, receive=Gtrs
if n_elements(topev) gt 0 then sans_sheet_sync, topstr, sbaset, 'update'   ,       receive=''
if keyword_set(give_IDs)  then sans_sheet_sync, topstr, sbaset, 'give_IDs' , mess, receive=''
if n_elements(lmh)   eq 1 then $
           if lmh gt " "  then sans_sheet_sync, topstr, sbaset,  '_'+lmh
end

pro sans_sheet_dying,ev
;+
;** ****************
;** ****************
;** destroying the GUI, restarting the GUI
;-
@lamp.cbk
empty & wait,.1
if xregistered('sans_settings_win',/noshow) gt 0 then sans_settings ,baseSANS=baseSANS
if n_elements(baseSANS) eq 1 then begin
             widget_control,bad_id=ii,baseSANS,get_uvalue=baset ;""
             print,"dying" & wait,2.
             if baset.curLMH ge 0 then begin
                widget_control,bad_id=ii,baseSANS,/destroy
                if lamp_b1 le 0 then exit else widget_control,bad_id=ii,lamp_b1,map=1,icon=0
             endif else begin
                baset.curLMH=-baset.curLMH-10
                widget_control,bad_id=ii,baseSANS,set_uvalue=baset & endelse
endif
end

pro sans_sheet_lampies, SETpth=SETpth, GETpth=GETpth
;+
;** ******************
;** ******************
;** ** get or set the path_for_online lamp global access for data_base
;-
@lamp.cbk
if arg_present(GETpth) then GETpth=path_for_online
if arg_present(SETpth) then path_for_online=SETpth
end

pro SANSTOP, res
;+
;** *******
;*** stopping a reading process
;-

common c_sanstop, bstop
empty
res=0
if n_elements(bstop) eq 1 then if bstop gt 0L then begin

   evv=widget_event(bstop,/nowait,bad_id=ii, /save_hourglass)
   if evv.id eq bstop then res=1
   widget_control,bstop,bad_id=ii ,/clear_events
endif
end

pro sans_sheet_event,ev
;+
;** ****************
;** ****************
;** main event handler
;-

CATCH,stat & if stat ne 0 then begin & lamp_error & return & endif

widget_control,ev.top,get_uvalue=sbaset & sbupd=0
widget_control,sbaset.Mess,set_value=''

;TOP BASE RESIZING
; ----------------
if ev.id eq ev.top then begin & empty & wait,.1
   strN=widget_info(ev.top ,/geometry)
   gapX=strN.scr_Xsize-sbaset.stri.scr_Xsize
   gapY=strN.scr_Ysize-sbaset.stri.scr_Ysize
   tids=sbaset.tids
   cr_s=sbaset.cr_s
  ;X resizing
  ; ---------
   if abs(gapX) gt 30 then begin & sbupd=1
      for i=0,n_elements(tids)/2-1 do begin
          if tids[0,i] gt 0L then begin ;COMMENTS
                                  strC=widget_info(tids[0,i],/geometry)
                                  widget_control  ,tids[0,i],scr_xsize=(strC.scr_Xsize)+gapX & endif
          if cr_s[2,i] ge 1  then begin ;TABLES
                                  strX=widget_info(tids[1,i],/geometry)
                                  widget_control  ,tids[1,i],scr_xsize=(strX.scr_Xsize)+gapX & endif
      endfor
      empty & wait,.1 & strN=widget_info(ev.top ,/geometry) & sbaset.stri=strN
   endif
  ;Y resizing
  ; ---------
   if abs(gapY) gt 30 then begin & sbupd=1
      for i=0,n_elements(tids)/2-1 do if cr_s[2,i] eq 2 then begin ;TABLES
                                  strY=widget_info(tids[1,i],/geometry)
                                  widget_control  ,tids[1,i],scr_ysize=(strY.scr_ysize+gapY)>50
      endif
      empty & wait,.1 & strN=widget_info(ev.top ,/geometry) & sbaset.stri=strN
   endif

;OTHER EVENTS
; -----------
endif else begin & messege=''
 widget_control,ev.id ,get_uvalue=uv
 LOW   =sbaset.L
 MIDDLE=sbaset.M
 HIGH  =sbaset.H
 if n_elements(uv) gt 0 then begin
  case uv[0] of

  10:  begin ;CLEAR / RESIZE SAMPLE TABLE
             ; --------------------------
             ;GET NB SAMPLES
             ; -------------
             widget_control,uv[2],get_value=txt & on_ioerror,misnbsamp & ok=0 & nbs=0 & nbs=fix(txt[0])<sbaset.maxns  & ok=1
             misnbsamp: if not ok then messege=!error_state.msg & if (nbs le 0) or  (nbs eq sbaset.nsampl)   then   ok=0
             vert=sbaset.vertical      ;sens of tables
             idx =sbaset.idxtab        ;tables  index
             idt =sbaset.tids[  1,idx] ;get tables ids
             colr=sbaset.cr_s[0:1,idx] ;get tables col & row
             idts=idt[ 2]              ;sample table id
             colr=colr[0:1,2]          ;sample col & row
             ;RESIZE SAMPLE TABLE
             ; ------------------
             if ok then begin
               diff=nbs-sbaset.nsampl
               if diff gt 0 then begin ;-->ADD
                    if vert then widget_control,idts,insert_rows   =diff,alignment=1,background=sbaset.smp_color $
                            else begin
                                 widget_control,idts,insert_columns=diff,alignment=1
                                 for i=0L,colr[1]-1 do widget_control,idts,use_table_select=[colr[0],i,nbs-1,i],background=sbaset.smp_color[*,i]
                            endelse
                    if vert then uset=[0,colr[1], 0,nbs-1] else uset=[colr[0],0,nbs-1,0]
                    setval='  S'+strtrim(indgen(diff)+sbaset.nsampl+1,2) & if vert then setval=transpose(setval)
                    widget_control,idts,set_value=setval,use_table_select=uset
               endif else begin        ;-->DELETE                   ;use_table_select=[left,top      ,right,bottom]
                    if vert then widget_control,idts,/delete_rows   ,use_table_select=[0,colr[1]+diff, 0,colr[1]-1] $
                            else widget_control,idts,/delete_columns,use_table_select=[colr[0]+diff,0, colr[0]-1,0]
               endelse
               if vert then sbaset.cr_s[1,idx[2]]=nbs else sbaset.cr_s[0,idx[2]]=nbs
               if diff gt 0 then sbaset.savedTRM =0
               sbaset.nsampl=nbs & sbupd=1
               sans_sheet_sync, ev, sbaset, "resize"+(["","_low","_middle","_high"])[sbaset.curLMH], messege
             endif
             ;CLEAR TABLES
             ; -----------
             if (uv[1] eq 1) or (uv[1] eq 2) then begin
                if uv[1] eq 2 then idt=idts ;only Sample table
                for i=0L,n_elements(idt)-1 do begin
                    widget_control,idt[i],get_value=tmp & tmp[where(tmp ne '-')]=''
                    widget_control,idt[i],set_value=tmp
                endfor
                if vert then uset=[0,0,0,nbs-1] else uset=[0,0,nbs-1,0]
                setval='  S'+strtrim(indgen(nbs)+1,2) & if vert then if nbs gt 1 then setval=transpose(setval)
                widget_control,idts,set_value=setval,use_table_select=uset
                sans_sheet_sync, ev, sbaset, "clear_low"   , messege & if uv[1] eq 1 then sans_sheet_receive,beambox='00,00,00,00',ctr='00,00,00,00'
                sans_sheet_sync, ev, sbaset, "clear_middle", messege & if uv[1] eq 1 then sans_sheet_receive,beambox='00,00,00,00',ctr='00,00,00,00'
                sans_sheet_sync, ev, sbaset, "clear_high"  , messege & if uv[1] eq 1 then sans_sheet_receive,beambox='00,00,00,00',ctr='00,00,00,00'
               ;if uv(1) eq 1 then if sbaset.toggles(6) then sans_reform_series, clear=2  else $ ;CLEAR RADIAL    OLD RESULTS
               ;if uv(1) eq 1 then if sbaset.toggles(7) then sans_reform_series, clear=4         ;CLEAR AZIMUTAL  OLD RESULTS
                if uv[1] eq 1 then begin
                 sbaset.savedLMH[*]=0       ;saved   low middle high config [1,1,1]
                 sbaset.savedCTR[*]=0       ;saved   center calculated      [1,1,1]
                 sbaset.savedFLX[*]=1       ;saved   alternative FLUX       [1,1,1] (as optional)
                 sbaset.savedSMP[3]=0       ;no more water
                 sans_settings_swap,/reset
                 sans_sheet_receive,waterbox='00,00,00,00'
                 widget_control,bad_id=ii,sbaset.baseSANS,/destroy
                endif
                sbaset.savedSMP[0:2]=0      ;no more samples                [0,0,0,water]
                sbaset.savedTRM     =0      ;transmission calculated         0,1
                sbaset.curLMH       =0      ;current low middle high config  0,1,2,3
                sbupd=1
             endif
             ;CLEAR SELECTED TABLE CELLS
             ; -------------------------
             if (uv[1] eq 3) then begin
                uset=widget_info(idts,/table_select) & widget_control,idts,use_table_select=uset,get_value=tmp & tmp[*]=""
                                                       widget_control,idts,use_table_select=uset,set_value=tmp & endif
             ;REMOVE/INSERT A SAMPLE ID
             ; ------------------------
             if (uv[1] eq 4) or (uv[1] eq 5) then begin & ok=1
                uset=widget_info(idts,/table_select)
                
                if (vert) then nSampIds = uset[3]-uset[1] else nSampIds = uset[2]-uset[0]
                if (vert) then if (uset[0] le 0) and (uset[3]-uset[1] ge 0) then idn=uset[1] else ok=-1 $
                          else if (uset[1] le 0) and (uset[2]-uset[0] ge 0) then idn=uset[0] else ok=-1
                if (uv[1] eq 5) and (nSampIds gt 0) then ok=-1 ;one selected Id for INSERT

                if ok eq -1 then begin & ok=0 & messege="Select one sample ID !!!" & endif
                if ok then begin
                   widget_control,idts,get_value=tmp
                   if vert then vid=strarr(colr[0],1+nSampIds) else vid=strarr(1+nSampIds,colr[1])
                   if uv[1] eq 4 then begin ;REMOVE
                     if vert then begin
                      if idn          eq 0         then tmp=[[tmp[*,1+nSampIds:colr[1]-1]],[vid]] else $
                      if idn+nSampIds eq colr[1]-1 then tmp[*,colr[1]-1-nSampIds:colr[1]-1]=vid $
                                                   else tmp=[[tmp[*,0:idn-1]],[tmp[*,idn+1+nSampIds:colr[1]-1]],[vid]]
                     endif else begin
                      if idn eq 0                  then tmp=[ tmp[1+nSampIds:colr[0]-1,*] , vid ] else $
                      if idn+nSampIds eq colr[0]-1 then tmp[colr[0]-1-nSampIds:colr[0]-1,*]=vid $
                                                   else tmp=[ tmp[0:idn-1,*] , tmp[idn+1+nSampIds:colr[0]-1,*] , vid ]
                     endelse
                   endif
                   if uv[1] eq 5 then begin ;INSERT
                     if vert then begin
                      if idn eq 0         then tmp=[[vid],[tmp[*,0:colr[1]-2]]] else $
                      if idn eq colr[1]-1 then messege="Increase NBsamples" $
                                          else tmp=[[tmp[*,0:idn-1]],[vid],[tmp[*,idn:colr[1]-2]]]
                     endif else begin
                      if idn eq 0         then tmp=[ vid , tmp[0:colr[0]-2,*] ] else $
                      if idn eq colr[0]-1 then messege="Increase NBsamples" $
                                          else tmp=[ tmp[0:idn-1,*] , vid , tmp[idn:colr[0]-2,*] ]
                     endelse
                   endif
                   widget_control,idts,set_value=tmp
                   sans_sheet_sync, ev, sbaset, "clear_low"   , messege
                   sans_sheet_sync, ev, sbaset, "clear_middle", messege
                   sans_sheet_sync, ev, sbaset, "clear_high"  , messege
                   sbaset.savedTRM   =0
                   sbupd=1
                endif
             endif
       end
  11:  begin ;FILL DOWN SAMPLE
             ; ---------------
             if uv[1] eq 0 then widget_control,uv[2],set_value='0.0'
             if uv[1] eq 1 then widget_control,uv[2],set_value='1.0'
             widget_control,uv[2],get_value=txt & on_ioerror,misfincr & ok=0 & inc=0 & inc=float(txt[0])>(-100.)<100. & ok=1
             misfincr: if not ok then messege=!error_state.msg
             vert=sbaset.vertical         ;sens of tables
             idx =sbaset.idxtab           ;tables  index
             idts=sbaset.tids[  1,idx[2]] ;get sample table id (or using unames)
             colr=sbaset.cr_s[0:1,idx[2]] ;get table  col & row
             uset=widget_info(idts,/table_select)
             nbf =0
             if (vert) then if (uset[0]-uset[2] eq 0) and (uset[1] ge 0) then nbf=uset[3]-uset[1] else ok=-1 $
                       else if (uset[1]-uset[3] eq 0) and (uset[0] ge 0) then nbf=uset[2]-uset[0] else ok=-1
             if ok eq -1 then begin & ok=0 & messege="Select one starting cell in sample table !!!" & endif
             ;DO IT
             ; ----
             if ok then begin & widget_control,idts,get_value=val,use_table_select=uset & val=val[0]
                              if vert then equi=(sbaset.equiS[uset[0],uset[1],*])[2]  $ ;LMH?
                                      else equi=(sbaset.equiS[uset[1],uset[0],*])[2]
                              if nbf eq 0 then if vert then uset[3]=colr[1]-1 else uset[2]=colr[0]-1
                              if vert then nbc=uset[3]-uset[1]+1 else nbc=uset[2]-uset[0]+1

                                                          sgPnu='+' & nuPnu = strpos(val,sgPnu)
                              if nuPnu le 0 then  begin & sgPnu='>' & nuPnu = strpos(val,sgPnu) & endif
                              if nuPnu le 0 then  begin & sgPnu=':' & nuPnu = strpos(val,sgPnu) ; enable multiple ':'
                                                  if nuPnu gt 0 then begin & nuPnu0 = nuPnu & nuPnu = strpos(val,sgPnu, /reverse_search)
                                                                             sgPnu  = strjoin(replicate(':',nuPnu-nuPnu0+1)) & endif
                              endif
                              on_ioerror,misnumb & nu=0 & num=0. & nun1=0. & nun2=0.
                                 if nuPnu gt 0 then begin & reads,val,num & reads,strmid(val,nuPnu+1,50)+' 0',nun1,nun2 & nu=1
                                 endif         else begin & reads,val+' 0 0',num,nun1,nun2 & nu=1
                                 endelse & misnumb:
                              lg=0
                              if (long(inc) eq inc) and (long(num) eq num) and (long(nun1) eq nun1) then begin
                                  inc=long(inc) & num=long(num) & nun1=long(nun1) & lg=1 & endif

                              if strtrim(val,2) le ' ' then nu=0
                              if nu and (inc ne 0) then begin
                              ; ->A NUMBER
                                if (nuPnu gt 0) and (nun1 gt 0) and (nun2 eq 0) and (lg) then $ ;-->A NUMBER1+NUMBER2
                                            setval=strtrim(lindgen(nbc)*inc+num,2)+ sgPnu +strtrim(lindgen(nbc)*inc+nun1,2) else $
                                 if lg then setval=strtrim(lindgen(nbc)*inc+num,2) else setval=string(lindgen(nbc)*inc+num,format='(F7.3)')
                                 if vert then if nbc gt 1 then setval=transpose(setval)
                                 widget_control,idts,use_table_select=uset,set_value=setval
                                 if (equi ge 0) then sans_sheet_sync, ev, sbaset, "fill_"+(["","low","middle","high"])[equi] ,messege
                              endif else if inc eq 0 then begin
                              ; ->A STRING
                                 setval=strarr(nbc)+val &  if vert then if nbc gt 1 then setval=transpose(setval)
                                 widget_control,idts,use_table_select=uset,set_value=setval
                              endif else messege="Set increment to 0 for a string or no cell is selected !!!"
             endif
       end
  12:  begin ;LOAD / SAVE
             ; ----------
             if not file_test(sbaset.SAVpth,/directory) then sbaset.SAVpth=''
             defext='sav' & filt='*.sav'    & pth = sbaset.SAVpth & fifi=sbaset.curfile
             if uv[1] eq 1 then $
              result=dialog_pickfile(path=pth,get_path=gpth,file=fifi,default_ext=defext,/read ,resource_name='lamptouch',filter=filt)
             if uv[1] ge 2 then $
              result=dialog_pickfile(path=pth,get_path=gpth,file=fifi,default_ext=defext,/write,resource_name='lamptouch',filter=filt,/overwrite_prompt)

             if result gt ' ' then begin
              fifi  =strmid(result,strlen(gpth))
              b10   =strpos(fifi  ,string(10b) )
              if (uv[1] ge 2) and (b10 gt 0) then fifi = strmid(fifi,0,b10) ;Happens when dialog_pickfile find spaces in entered filename !!!
              
              sbaset.SAVpth=gpth & sbaset.curfile=fifi & sbupd=1
              if uv[1] eq 1 then sans_sheet_sync, ev, sbaset, "load", messege
              if messege eq 'ok'      then return ;OK so nothing we can do (GUI destroyed)
              if messege eq 'results' then begin
                 sans_reform_series,clear=-1
                 sans_sav_rest_results,'rest', path=gpth, file=fifi
                 sans_sheet_sync, ev, sbaset, 'show_list', messege
              endif
              if uv[1] ge 2 then begin
                                 sans_sheet_sync, ev, sbaset, "save_low"
                                 sans_sheet_sync, ev, sbaset, "save_middle"
                                 sans_sheet_sync, ev, sbaset, "save_high"
                                 sans_sheet_sync, ev, sbaset, "save"       ,messege
                                 if uv[1] eq 3 then uv[0]=77 ; exit
              endif
             endif
       end
  13:  begin ;GROUP
             ; ----
             widget_control,ev.id,get_value=grp
             on_ioerror,misgrp1 & ok=0 & grp=float(grp[0]) & ok=1 & misgrp1:
             if ok then begin & sbaset.valgrp=grp & sbupd=1
                sans_sheet_sync, ev, sbaset, 'grouping', messege
             endif else messege="Bad grouping value !!!"
       end
  14:  begin ;TREAT
             ; ----
             widget_control,uv[1],get_value=grp
             on_ioerror,misgrp2 & ok=0 & grp=float(grp[0]) & ok=1 & misgrp2:
             if ok then begin & sbaset.valgrp=grp & sbupd=1
                ctrOK1=(sbaset.toggles[1] or sbaset.savedCTR[0]) & ctrOK2=(sbaset.toggles[1] or sbaset.savedCTR[1])
                ctrOK3=(sbaset.toggles[1] or sbaset.savedCTR[2])
                trmOK =(sbaset.toggles[2] or sbaset.savedTRM)

                if trmOK then begin
                  widget_control,/hourglass
                  sans_sheet_sync, ev, sbaset, 'update'    , messege                           ;just to update savedSMP (configs used)
                  sans_sheet_sync, ev, sbaset, 'put_trans' , messege                           ;give back transm.(may be modified)
                  sans_settings_GetTrans, trans                                                ;get  sans_trans
                  if (sbaset.savedSMP[3]) then okwater=1 else okwater=0                        ;Do we have water
                  Nsam  = max(sbaset.savedSMP)
                  Ntrpos= n_elements(where((trans[2:*,0] le 6.1) and (trans[2:*,0] gt 0.)))-1
                  if (Ntrpos ge Nsam) then oktsamp=1 else oktsamp=0 ;Do we have all TRsamples?

                  if (not sbaset.savedTRM) or (not oktsamp) then begin
                                 widget_control,sbaset.Mess,set_value="TRANSMISSIONS EVALUATION...."
                                 lamp_journal,                        "TRANSMISSIONS EVALUATION...."
                                 sans_sheet_sync, ev, sbaset, 'trans_cal' , messege            ;automatic cal.transmission
                                 sans_settings_GetTrans, trans
                                 sbaset.savedTRM=1
                                 Ntrpos = n_elements(where((trans[2:*,0] le 6.1) and (trans[2:*,0] gt 0.)))-1
                  endif

                  sans_settings_GetBgrd, Sbaset.baseSANS, existSbg, existWbg  
                 
                  Ntrs   = n_elements(trans[*,0])
                  
                  messege=''
                  if ((okwater) and ((trans[0,0] gt 6.1) or (trans[0,0] le 0.)) and (existWbg))  $ ;water
                                then messege='? Bad Water Transmission, use Transmission menu or enter a value manually...'

                  if  (okwater) and  (trans[0,1] eq 0.) and (existWbg) then begin
                                 widget_control,sbaset.Mess,set_value='% No Thickness input for WATER'
                                 lamp_journal,                        '% No Thickness input for WATER' & endif

                  if (uv[2] lt 4) then begin   ;(No need of sample Thickness to show efficiencies uv(2)>3)
                    if (Ntrs ge 5) then begin
                        if (trans[2,0] gt .0) then Ntrpos -=1 ; sample1 is in trans[2 and 4......]

                        idx=where((trans[4:Nsam+3,0] gt .001) and (trans[4:Nsam+3,1] eq 0.))
                        if (idx[0] ne -1) and (existSbg) then begin   ;Thickness is missing for some sample(s)                 
                            widget_control,sbaset.Mess,set_value='% No Thickness input for SAMPLE' ;JUST SAY
                            lamp_journal,                        '% No Thickness input for SAMPLE'
                           if Nsam eq 1 then  messege= '? Thickness for sample is missing...'  ;STOP PROCESS
                        endif
                    endif
                  endif
                  if messege le ' ' then begin & messmask=''

                 ;if (uv(2) eq 0) then if sbaset.toggles(6) then sans_reform_series, clear=2 $ ;CLEAR RADIAL    OLD RESULTS
                 ;                else if sbaset.toggles(7) then sans_reform_series, clear=4   ;CLEAR AZIMUTAL  OLD RESULTS

                 ;Time Progress-bar stuff
                  tot_steps = 1
                  if ((uv[2] eq 0) or (uv[2] eq 1)) and (sbaset.savedSMP[0] gt 0) and (ctrOK1) then tot_steps += 1
                  if ((uv[2] eq 0) or (uv[2] eq 2)) and (sbaset.savedSMP[1] gt 0) and (ctrOK2) then tot_steps += 1
                  if ((uv[2] eq 0) or (uv[2] eq 3)) and (sbaset.savedSMP[2] gt 0) and (ctrOK3) then tot_steps += 1
                  cur_steps = 1
                  UT_Progress, sbaset.bProgress, cur_steps , tot_steps ; Time Progress-bar

                 ;GO TO TREAT ALL [uv(2)=0] or 1 2 3 config
                 ;*****************************************
                  if (uv[2] eq 0) or (uv[2] eq 1) then begin
                    if sbaset.savedSMP[0] gt 0    then if ctrOK1 then begin & sans_sheet_sync, ev, sbaset, "_low"
                       if not sbaset.savedCTR[0]  then begin
                                   widget_control,sbaset.Mess,set_value=LOW+" CENTER EVALUATION..."
                                   lamp_journal,                        LOW+" CENTER EVALUATION..."
                                   sans_sheet_sync, ev, sbaset, "ctr_cal_low"   , messege         ;automatic cal.center
                                   if messege le ' ' then sbaset.savedCTR[0]=1 & endif
                       if not sbaset.savedFLX[0]  then begin
                                   sans_sheet_sync, ev, sbaset, "flx_cal_low"   , messege         ;automatic cal. flux
                                   if messege le ' ' then sbaset.savedFLX[0]=1 & endif
                                     
                       sans_settings_GetBgrd, Sbaset.baseSANS, existSbg, existWbg
                       if (Ntrpos lt sbaset.savedSMP[0])  and (existSbg) $ ;sample
                           then messege='? Bad Low Transmission, use Transmission menu or enter a value manually...'
                  
                       if messege le ' ' then begin
                                   sans_settings_GetMaskBeam, Mbeam
                                   if Mbeam[0]+Mbeam[1] eq 0 then if sbaset.toggles[14] then begin
                                                    sans_sheet_sync, ev, sbaset, "msk_cal_low"
                                                    sans_settings_GetMaskBeam, Mbeam
                                                    if Mbeam[0] eq 0 then messmask=messmask+'(no '+LOW+' beam mask!)' else messmask=messmask+'(auto '+LOW+' mask)'
                                                    endif else messmask=messmask+'('+LOW+' beam mask not set)'
                                                    
                                   if okwater then if Mbeam[3]*Mbeam[5] le 0 then if sbaset.toggles[14] then begin
                                                    sans_sheet_sync, ev, sbaset, "auto_mask_water"
                                                    sans_settings_GetMaskBeam, Mbeam
                                                    if Mbeam[3]*Mbeam[5] le 0 then messmask='(no WATER mask!)' else messmask='(auto WATER mask)'
                                                   endif else messmask='(WATER beam mask not set)'

                                   widget_control,sbaset.Mess,set_value=LOW+" SCATTERING CORRECTION... (reading runs)"
                                   lamp_journal,                        LOW+" SCATTERING CORRECTION..."
                                   lamp_journal,                        LOW+" ---------------------"
                                   sans_sheet_sync, ev, sbaset, "treat_low"     , messege
                                   if messege le ' ' then if sbaset.toggles[3] then if sbaset.valgrp gt 0 then $
                                   sans_sheet_sync, ev, sbaset, "export_gnum"   , messege else $  ;automatic write result
                                   sans_sheet_sync, ev, sbaset, "export_tnum"   , messege
                       endif
                       cur_steps += 1
                       UT_Progress, sbaset.bProgress, cur_steps , tot_steps ; Time Progress-bar

                    endif else messege="Calculation of "+LOW+" CENTER is not automatic !!!"
                  endif
                  
                 ;****************************
                  if messege le ' ' then begin
                  if (uv[2] eq 0) or (uv[2] eq 2) then begin
                    if sbaset.savedSMP[1] gt 0    then if ctrOK2 then begin & sans_sheet_sync, ev, sbaset, "_middle"
                       if not sbaset.savedCTR[1]  then begin
                                   widget_control,sbaset.Mess,set_value=MIDDLE+" CENTER EVALUATION..."
                                   lamp_journal,                        MIDDLE+" CENTER EVALUATION..."
                                   sans_sheet_sync, ev, sbaset, "ctr_cal_middle", messege         ;automatic cal.center
                                   if messege le ' ' then sbaset.savedCTR[1]=1 & endif
                       if not sbaset.savedFLX[1]  then begin
                                   sans_sheet_sync, ev, sbaset, "flx_cal_middle", messege         ;automatic cal. flux
                                   if messege le ' ' then sbaset.savedFLX[1]=1 & endif

                       sans_settings_GetBgrd, Sbaset.baseSANS, existSbg, existWbg  
                       if (Ntrpos lt sbaset.savedSMP[1])  and (existSbg) $ ;sample
                           then messege='? Bad Middle Transmission, use Transmission menu or enter a value manually...'
                           
                       if messege le ' ' then begin
                                   sans_settings_GetMaskBeam, Mbeam
                                   if Mbeam[0]+Mbeam[1] eq 0 then if sbaset.toggles[14] then begin
                                                            sans_sheet_sync, ev, sbaset, "msk_cal_middle"
                                                            sans_settings_GetMaskBeam, Mbeam
                                                            if Mbeam[0] eq 0 then messmask=messmask+'(no '+MIDDLE+' beam mask!)' else messmask=messmask+'(auto '+MIDDLE+' mask)'
                                                         endif else messmask=messmask+'('+MIDDLE+' beam mask not set)'

                                   if okwater then if Mbeam[3]*Mbeam[5] le 0 then if sbaset.toggles[14] then begin
                                                    sans_sheet_sync, ev, sbaset, "auto_mask_water"
                                                    sans_settings_GetMaskBeam, Mbeam
                                                    if Mbeam[3]*Mbeam[5] le 0 then messmask='(no WATER mask!)' else messmask='(auto WATER mask)'
                                                   endif else messmask='(WATER beam mask not set)'

                                   widget_control,sbaset.Mess,set_value=MIDDLE+" SCATTERING CORRECTION... (reading runs)"
                                   lamp_journal,                        MIDDLE+" SCATTERING CORRECTION..."
                                   lamp_journal,                        MIDDLE+" ---------------------"
                                   sans_sheet_sync, ev, sbaset, "treat_middle"  , messege
                                   if messege le ' ' then if sbaset.toggles[3] then if sbaset.valgrp gt 0 then $
                                   sans_sheet_sync, ev, sbaset, "export_gnum"   , messege else $  ;automatic write result
                                   sans_sheet_sync, ev, sbaset, "export_tnum"   , messege
                       endif
                       cur_steps += 1
                       UT_Progress, sbaset.bProgress, cur_steps , tot_steps ; Time Progress-bar

                    endif else messege="Calculation of "+MIDDLE+" CENTER is not automatic !!!"
                  endif
                  
                 ;****************************
                  if messege le ' ' then begin
                  if (uv[2] eq 0) or (uv[2] eq 3) then begin
                    if sbaset.savedSMP[2] gt 0    then if ctrOK3 then begin & sans_sheet_sync, ev, sbaset, "_high"
                       if not sbaset.savedCTR[2]  then begin
                                   widget_control,sbaset.Mess,set_value=HIGH+" CENTER EVALUATION..."
                                   lamp_journal,                        HIGH+" CENTER EVALUATION..."
                                   sans_sheet_sync, ev, sbaset, "ctr_cal_high" , messege          ;automatic cal.center
                                   if messege le ' ' then sbaset.savedCTR[2]=1 & endif
                       if not sbaset.savedFLX[2]  then begin
                                   sans_sheet_sync, ev, sbaset, "flx_cal_high"  , messege         ;automatic cal. flux
                                   if messege le ' ' then sbaset.savedFLX[2]=1 & endif
                                   
                       sans_settings_GetBgrd, Sbaset.baseSANS, existSbg, existWbg  
                       if (Ntrpos lt sbaset.savedSMP[2])  and (existSbg) $ ;sample
                           then messege='? Bad High Transmission, use Transmission menu or enter a value manually...'
                           
                       if messege le ' ' then begin
                                   sans_settings_GetMaskBeam, Mbeam
                                   if Mbeam[0]+Mbeam[1] eq 0 then if sbaset.toggles[14] then begin
                                                            sans_sheet_sync, ev, sbaset, "msk_cal_high"
                                                            sans_settings_GetMaskBeam, Mbeam
                                                            if Mbeam[0] eq 0 then messmask=messmask+'(no '+HIGH+' beam mask!)' else messmask=messmask+'(auto '+HIGH+' mask)'
                                                         endif else messmask=messmask+'('+HIGH+' beam mask not set)'

                                   if okwater then if Mbeam[3]*Mbeam[5] le 0 then if sbaset.toggles[14] then begin
                                                    sans_sheet_sync, ev, sbaset, "auto_mask_water"
                                                    sans_settings_GetMaskBeam, Mbeam
                                                    if Mbeam[3]*Mbeam[5] le 0 then messmask='(no WATER mask!)' else messmask='(auto WATER mask)'
                                                   endif else messmask='(WATER beam mask not set)'

                                   widget_control,sbaset.Mess,set_value=HIGH+" SCATTERING CORRECTION... (reading runs)"
                                   lamp_journal,                        HIGH+" SCATTERING CORRECTION..."
                                   lamp_journal,                        HIGH+" ---------------------"
                                   sans_sheet_sync, ev, sbaset, "treat_high"    , messege
                                   if messege le ' ' then if sbaset.toggles[3] then if sbaset.valgrp gt 0 then $
                                   sans_sheet_sync, ev, sbaset, "export_gnum"   , messege else $  ;automatic write result
                                   sans_sheet_sync, ev, sbaset, "export_tnum"   , messege
                       endif
                       cur_steps += 1
                       UT_Progress, sbaset.bProgress, cur_steps , tot_steps ; Time Progress-bar

                   endif else messege="Calculation of "+HIGH+" CENTER is not automatic !!!"
                  endif
                  if messege le ' ' then begin
                     messege     ="END OF TREATMENT "+messmask
                     lamp_journal,"END OF TREATMENT "+messmask
                     lamp_journal,"---------------- "

                                        sans_sheet_sync, ev, sbaset,"savetxt"             ;save current_spreadsheet.txt
                     if uv[2] eq 4 then sans_sheet_sync, ev, sbaset,"treat_det" , messege ;detector efficiencies

                  endif & endif & endif ;messege le ' ' for the 3 configs
                  
                  UT_Progress, sbaset.bProgress, tot_steps , tot_steps ; Finish Time Progress-bar

                endif              ;Bad Water Transmission or thickness missing?
                endif else messege="Calculation of TRANSMISSIONS is not automatic !!!"
             endif else messege="Bad grouping value !!!"
       end
  15:  begin & sans_sheet_sync, ev, sbaset, 'show_list', messege
       end

  16:  begin & sans_reform_series, clear=2                       ;CLEAR RADIAL    OLD RESULTS
               sans_reform_series, clear=4                       ;CLEAR AZIMUTAL  OLD RESULTS
               sans_sheet_sync, ev, sbaset, 'show_list', messege
       end
  17:  begin ;bSTOP handeld in readin procedure RDOPR (rdmulti).
       end
       
  40:  begin ;CONTEXT TABLE EVENT (right click) TO SHOW A RUN
             if tag_names(ev,/structure_name) eq "WIDGET_CONTEXT" then begin
                uname=widget_info(ev.id,/uname)
                sans_sheet_sync, ev, sbaset, "run_"  +uname, messege
             endif else begin
                tnam=tag_names(ev) & idx=where(tnam eq "TYPE")
               ;ENTER CHARACTER EVENT
                if idx[0] ge 0 then if ev.type eq 0 then begin ; (arrows,tab do an unvisible enter! or change table_select!)
                 uname=widget_info(ev.id,/uname)
                 sbaset.input_CELL=[ev.X,ev.Y]
                 sans_sheet_sync, ev, sbaset, "input_"+uname, messege
                 sbaset.input_CELL=[-1,-1]
                 sbupd=1
                endif
             endelse
       end

  49:  begin ;PANELS/RESOLUTION TOGGLE BUTTONS (NegMask >1)
             widget_control,ev.id ,get_value=text & pls='-ON    ' & mns='-Off-  '
             Npref=strlen(pls)
             t=strpos(text,pls) & if t ne 0 then seti=pls else seti=mns
             messege=seti+strmid(text,Npref,50)
             widget_control,ev.id,set_value=messege
             if seti eq pls then messege=messege+' (ON)' else messege=messege+' (Off)'
             sans_settings_GetSupl, supl
             if uv[1] eq 0 then begin ; On/Off RESOLUTION
                if seti eq pls then supl[67]=1 else supl[67]=2
                RDSET, step=supl[67]
             endif
             if (uv[1] ge 1) and (uv[1] le 3) then begin ; On/Off Panels for config 1 2 3
                if seti eq pls then supl[67+uv[1]]=1 else supl[67+uv[1]]=0
             endif

             widget_control,sbaset.baseSANS,get_uvalue=baset ;SANS_SETTINGS STRUCTURE
             sans_settings_swap, baset, shareSupl=[67,68,69,70] ,supl= supl
             sans_settings_SetSupl, supl
       end
       
  50:  begin ;TOGGLE BUTTONS
             ; -------------
             widget_control,ev.id ,get_value=text & pls='-ON    ' & mns='-Off-  ' & seti=pls
             Npref=strlen(pls)
             t=strpos(text,pls) & if t ne 0 then seti=pls else if uv[2] eq 0 then seti=mns
             messege=seti+strmid(text,Npref,50)
             widget_control,ev.id,set_value=messege
             if seti eq pls then messege=messege+' (ON)' else messege=messege+' (Off)'
             if seti eq pls then sbaset.toggles[uv[1]]=1 else sbaset.toggles[uv[1]]=0
             sbupd=1
             for k=1,uv[2] do begin & widget_control,uv[2+k] ,get_value=txt ,get_uvalue=vv
                                    widget_control,uv[2+k] ,set_value=mns+strmid(txt,Npref,50)
                                    sbaset.toggles[vv[1]]=0   & endfor

             if (uv[2+uv[2]+1] eq 7) then sans_sheet_sync, ev, sbaset, 'mask_sector' else $ ;AZIMUTHAL
             if (uv[2+uv[2]+1] eq 8) then sans_sheet_sync, ev, sbaset, 'mask_sector' $      ;RADIAL
                                     else sans_sheet_sync, ev, sbaset, 'toggles'
             case 1 of
             (uv[1] eq 6) or (uv[1] eq 7) or (uv[1] eq 8): begin
                Pid=widget_info(ev.id,/parent) & t=strpos(text,'->')
                widget_control,Pid,get_uvalue=bidm7
                if uv[1] eq 8 then sensi=1 else sensi=0
                widget_control,bidm7,sens=sensi,get_value=SecMod
                if sensi then messege='Actual'+SecMod
                txt=strmid(text,t+2,50) & widget_control,Pid,set_value='  GROUP  Mode= '+txt & end
                
             (uv[1] eq 9) or (uv[1] eq 10) or (uv[1] eq 11) or (uv[1] eq 12): begin
                Pid=widget_info(ev.id,/parent) & t=strpos(text,'->')
                txt=strmid(text,t+2,50) & widget_control,Pid,set_value='  SECTOR Mode= '+txt & end
              else:
             endcase
       end
  51:  begin ;INSTRUMENT / PATH
             ; ----------------
             case uv[1] of
             1: begin ;INSTRUMENT NAME
                     widget_control,ev.id,get_value=instru
                     if instru ne sbaset.instru then begin
                        if xregistered('sans_settings_win',/noshow) gt 0 then widget_control,sbaset.baseSANS,/destroy
                                                                              widget_control,ev.top         ,/destroy
                        empty & wait,.1 & sans_sheet,instru=instru & return & endif
                end
             2: begin ;PATH EXPLORER
                     result=dialog_pickfile(path=sbaset.DATApth,/directory,resource_name='lamptouch')
                     if result gt ' ' then begin & sbaset.DATApth=result & sbupd=1
                                                 sans_sheet_lampies,SETpth =result
                                                 messege="Data path: "+result & endif
                end
             3: begin ;PATH LAMP
                     if sbaset.lamp_b1 gt 0L then begin
                        widget_control,sbaset.lamp_b1,bad_id=ii,map=1,iconify=0,xoff=1,yoff=1 & ii=xregistered('LAMP')
                        sbaset.DATApth='' & sbupd=1 & messege="Data path is taken from Lamp" & endif
                end
             4: begin ;SHOW PATH
                     sans_sheet_lampies,GETpth=result
                     if result eq '' then CD,current=result & messege="Data path: "+result
                end
             5: begin ;SET WORKING PATH
                     cd,current=mee
                     pptthh=dialog_pickfile(/directory,resource_name='lamptouch')
                     if pptthh gt ' ' then begin & P_SET_PATH,pptthh & mee=pptthh & endif
                     messege="Working path: "+mee
                end
             6: begin ;CALIBRATION FILE (SET)
                       CALIBRATION
                end
             7: begin ;CALIBRATION FILE (SHOW)
                       CALIBRATION ,GET_CAL=g_cal, INF=f_inf
                       if (n_elements(g_cal) gt 1) and (n_elements(f_inf) eq 1) then messege=f_inf else messege='None'
                end
             13:begin ;EXPORT RESULT FILES
                     for i=0,n_elements(sbaset.savedLMH)-1 do if (sbaset.savedSMP[i] gt 0) then begin
                          sans_sheet_sync, ev, sbaset, (["_low","_middle","_high"])[i]
                          case uv[2] of
                          0:begin & XICUTE,'W19=' +  (['W34','W35','W36'])[i]
                                  sans_sheet_sync, ev, sbaset, 'export_gnum', messege
                            end
                          1:begin & XICUTE,'W19=' +  (['W34','W35','W36'])[i]
                                  sans_sheet_sync, ev, sbaset, 'export_3col', messege
                            end
                          2:begin & XICUTE,'W18=' +  (['W31','W32','W33'])[i]
                                  sans_sheet_sync, ev, sbaset, 'export_tnum', messege
                            end
                          3:begin & XICUTE,'W18=' +  (['W31','W32','W33'])[i]
                                  sans_sheet_sync, ev, sbaset, 'export_coln', messege
                            end
                            
                          4: ;reserved for Mask
                          5: ;reserved for legacy
                          
                          6:begin & XICUTE,'W18=' +  (['W31','W32','W33'])[i]
                                  sans_sheet_sync, ev, sbaset, 'export_png2', messege
                            end      
                                  
                          7:begin & XICUTE,'W18=' +  (['W31','W32','W33'])[i]
                                  sans_sheet_sync, ev, sbaset, 'export_nist', messege
                                  
                            end
                          else:
                          endcase
                      endif
               end
             else:
             endcase
       end
  52:  begin ;Options for detector corrections
             ; -------------------------------
             sans_sheet_sync, ev, sbaset, 'options', messege
       end
  53:  begin ;MASK
             ; ---
             if uv[1] eq 1 then sans_sheet_sync, ev, sbaset, "mask_low"     , messege
             if uv[1] eq 2 then sans_sheet_sync, ev, sbaset, "mask_middle"  , messege
             if uv[1] eq 3 then sans_sheet_sync, ev, sbaset, "mask_high"    , messege
             if uv[1] eq 4 then sans_sheet_sync, ev, sbaset, "mask_water"   , messege
             if uv[1] eq 5 then $
             if uv[2] eq 0 then sans_sheet_sync, ev, sbaset, "mask_detector"       , messege else $
             if uv[2] eq 1 then sans_sheet_sync, ev, sbaset, "mask_detector_low"   , messege else $
             if uv[2] eq 2 then sans_sheet_sync, ev, sbaset, "mask_detector_middle", messege else $
             if uv[2] eq 3 then sans_sheet_sync, ev, sbaset, "mask_detector_high"  , messege

             if uv[1] eq 8 then sans_sheet_sync, ev, sbaset, "load_mask"    , messege
             if uv[1] eq 9 then sans_sheet_sync, ev, sbaset, "save_mask"    , messege
             if uv[1] le 3 then begin & sans_settings_GetMaskBeam, Mbeam      & messege=''
                                      if (Mbeam[7] ge 0) and (Mbeam[8] ge 0) and $
                                         (Mbeam[0]+Mbeam[1] eq 0) then messege='Mask Beam for scattering DATA is not set. '
                                      if sbaset.savedSMP[3] then $ ;We have water
                                      if total(Mbeam[3:6]) le 0   then messege=messege+' Mask Beam for WATER is not set.' & endif
       end
  54:  begin ;TRANSMISSION
             ; -----------
             if uv[1] eq 0 then sans_sheet_sync, ev, sbaset, 'transmission', messege
             if uv[1] eq 1 then sans_sheet_sync, ev, sbaset, 'transm_file' , messege
       end
  55:  begin ;CENTER
             ; -----
             if uv[1] eq 1 then sans_sheet_sync, ev, sbaset, "center_low"   , messege
             if uv[1] eq 2 then sans_sheet_sync, ev, sbaset, "center_middle", messege
             if uv[1] eq 3 then sans_sheet_sync, ev, sbaset, "center_high"  , messege
             if uv[1] eq 5 then sans_sheet_sync, ev, sbaset, "save_low"     , messege ;unused
             if uv[1] eq 6 then sans_sheet_sync, ev, sbaset, "save_middle"  , messege ;unused
             if uv[1] eq 7 then sans_sheet_sync, ev, sbaset, "save_high"    , messege ;unused
       end
  56:  begin ;SHOW CORRECTED DATA
             ; ------------------
             sans_sheet_sync, ev, sbaset, 'options', messege
             if uv[1] eq 1 then sans_sheet_sync, ev, sbaset, 'cor_low'   , messege
             if uv[1] eq 2 then sans_sheet_sync, ev, sbaset, 'cor_middle', messege
             if uv[1] eq 3 then sans_sheet_sync, ev, sbaset, 'cor_high'  , messege
       end
  57:  begin ;HELP
             ; ---
             if uv[1] eq 1 then       p_did_journal,0L,[-88,396,0,0]
             if uv[1] eq 2 then begin & p_did_getw_cur, widx
                                      par_disp, 0, widx  & endif
             if uv[1] eq 3 then begin & see, W=uv[2], /below, /image
                                      to_did_cur,'W'+strtrim(uv[2],2) & endif
             if uv[1] eq 4 then begin & Smanual=widget_info(ev.id,/uname)
                                      online_help, book=Smanual,/full & endif
       end
  58:  begin ;Log liste of numors
             if uv[1] eq 0 then $
                if xregistered('LogList') eq 0 then begin
                   common  c_lamp_font
                   Lbase = widget_base(  title='Log of list of numors',/column,resource_name='lamptouch')
                   RunB  = widget_base(  Lbase, /row)
                   lab   = widget_label( RunB ,value='First Run'  ,font=ft_b_normal)
                   FrunB = widget_text(  RunB ,value=' ',xsize=8  ,font=ft_propor,/editable)
                   lab   = widget_label( RunB ,value=' Last Run'  ,font=ft_b_normal)
                   LrunB = widget_text(  RunB ,value=' ',xsize=8  ,font=ft_propor,/editable)

                   Lmess = widget_label( Lbase,value=' ',xsize=170,font=ft_b_normal)
                   
                   DoB   = widget_base(  Lbase, /row)
                   lab   = widget_label( DoB  ,value=' Parameter ',font=ft_b_normal)
                   paramB = widget_text( DoB  ,value=' ',xsize=20 ,font=ft_propor,/editable)

                   Lmess = widget_label( Lbase,value=' ',xsize=170,font=ft_b_normal)
                  
                   DoB2   = widget_base(  Lbase, /row)
                   lab   = widget_label( DoB2 ,value=' Step '     ,font=ft_b_normal)
                   stepB = widget_text(  DoB2 ,value=' 1 ',xsize=3,font=ft_propor,/editable)
                   lab   = widget_label( DoB2 ,value='   '        ,font=ft_propor)
                   okB   = widget_button(DoB2 ,value='Launch'     ,font=ft_b_normal,uvalue=[58,1,FrunB,LrunB,Lmess,stepB,paramB])
                   lab   = widget_label( DoB2 ,value='   '        ,font=ft_propor)
                   noB   = widget_button(DoB2 ,value='Cancel'     ,font=ft_b_normal,uvalue=[58,2])
                   
                   widget_control,Lbase,group_leader=ev.top,/realize
                   xmanager, 'LogList', Lbase,event_handler='sans_sheetLog_event',/just_reg,/no_block
                endif
       end
  else:      messege='NO YET AVAILABLE EVENT..........'
  endcase
  case 1 of
  (uv[0] eq 77) or (uv[0] eq 78):  begin ;EXIT
                                         ; ---
             widget_control,ev.top,/destroy
             print,"" & wait,.2 & empty
             widget_control,bad_id=ii,sbaset.baseSANS,/destroy
             if uv[0] eq 78 then begin
                print,"Creating tables" & wait,.5 & empty
                sans_sheet,horizontal=1-sbaset.vertical
             endif else if sbaset.lamp_b1 gt 0L then widget_control,bad_id=ii,sbaset.lamp_b1,map=1,iconify=0
             return
       end
  else:
  endcase
 endif
 if messege le ' ' then messege='<<:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::>>'
 if messege le ' ' then sens=0 else sens=1
 widget_control,sbaset.Mess,set_value=messege[0], sens=sens
endelse
if sbupd then widget_control,ev.top,set_uvalue=sbaset
end

pro sans_sheetLog_event,ev
;+
;** *******************
;** *******************
;**
;-
CATCH,stat & if stat ne 0 then begin & lamp_error & return & endif

widget_control,ev.id,get_uvalue=uv
if uv[1] eq 1 then begin ;Launch
   widget_control,uv[4],set_value=''
   widget_control,uv[2],get_value=Frun  & Frun =Frun[0]
   widget_control,uv[3],get_value=Lrun  & Lrun =Lrun[0]
   widget_control,uv[5],get_value=step  & step =step[0]
   widget_control,uv[6],get_value=param & param=param[0]
   on_ioerror,badInput
   Frun= long(Frun)>1 & Lrun=long(Lrun) & step=long(step)>1
   if Lrun lt Frun then begin & tmp=Lrun  & Lrun=Frun & Frun=tmp & endif
   widget_control,/hourglass
   okLog=0
   sans_log, Frun, Lrun, okLog, step=step, param=param, /show
   case okLog of
      0:     widget_control,uv[4],set_value=' ? sans_log error'
      1:     widget_control,ev.top,/destroy ; Seems ok
      2:     widget_control,uv[4],set_value=' ? First numor is missing'
      3:     widget_control,uv[4],set_value=' ? Last numor is missing'
      4:     widget_control,uv[4],set_value=' ? write error'
      else:
   endcase
   return
   badInput: widget_control,uv[4],set_value=' ? Bad input'
endif
if uv[1] eq 2 then widget_control,ev.top,/destroy ;Cancel

end
;*********************************************************************************************************************

pro sans_sheet, instrument=instru, reload=RLstruct,  water=Nwater, $
                savfile=savfile, reflectometry=refl ,horizontal=hori
;+
;** **********
;** **********
;** Gui creator
;-
forward_function finefile

common c_sanstop, bstop
@lamp.cbk
version =' V2.7 (Dec 2015)' 

if n_elements(savfile) eq 1 then begin
   RESTORE,file=savfile
   if n_elements(RLstruct) gt 0 then tags=tag_names(RLstruct) else tags=['']
   if tags[0] ne "SBASET" then RETURN ;BAD FILE !!!
   instru = RLstruct.sbaset.instru
endif

sans_settings ,instrument=instru, map=0, baseSANS=baseSANS, InstList=InstList, InstIsOn=InstIsOn, SansRef=Sans_Ref
idx=where(strupcase(instru) eq InstList) & sansref=Sans_Ref[idx]

if sansref ne 0 then titgui='sans_sheet_gui'    else titgui='reflecto_sheet_gui'
if sansref eq 2 then titgui='difsans_sheet_gui'

if (xregistered(titgui) eq 0) then begin

  if keyword_set(hori) then vertical=0 else vertical=1 ;0=sample list horizontal
  fillincr ='1.0'

  ;DEFAULT SETTINGS
  ; ---------------
  widget_control,baseSANS,get_uvalue=baset
  sans_settings_swap,/reset
  sans_settings_GetSupl, supl
     curfile  =''
     ns       =30      ;number of samples
     maxns    =500     ;maximum (arbitrary)
     if n_elements(Nwater) eq 1 then Wn=Nwater>1<3 else Wn=2 ;Default is 2
     if sansref  ne 1 then Wn=1                 ;HOW MANY WATERS (1 for D16)
     if supl[66] gt 1 then Wn=3                 ;HOW MANY WATERS (3 for multiple panels)
     grpincr  ='1.00'  ;group increment
     SAVpth   =''
     DATApth  =''
     ;Defaults toggles should be identical in SANS_SETTINGS for Fincr,Dlp(RLP),rDd !!!
     ;           0    1    2    3    4    5    6    7    8   9   10  11  12   13  14 15  16
     ;           ?   Ctr  Trs  Wrt   Dlp  Plt  Rad  Azm  Sct Sc1 Sc2 Sc3 Sc4 Fcr Msk rRd FreeRock
     toggles  =[ 0  , 1  , 1  , 0  , 1  , 1  , 1  , 0  , 0 , 0 , 0 , 1 , 0 ,  0 , 1 ,0  ,0]

     curLMH   = 0
     savedLMH =[0,0,0]       ; configs saved in sans_settings
     savedCTR =[0,0,0]       ; center LMH not calculated
     savedSMP =[0L,0L,0L,0L] ; sample not present LMH + water
     savedTRM = 0            ; transmission not calculated
     savedFLX =[1,1,1]       ; alternative FLUX calculated (optional)
     RLcomment=['']
     RLwater  =['']
     RLbeam   =['']
     RLsample =['']
    ;Samples, Effic , Sample cor, Sample grp, Sample cor conf123    , Sample grp conf123  
     w12=0  & w17=0 & w18=0     & w19=0     & w31=0 & w32=0 & w33=0 & w34=0 & w35=0 & w36=0

  ;RESTORE SETTINGS
  ; ---------------
  if n_elements(RLstruct) gt 0 then  begin
     alltags   =tag_names(RLstruct)
     vertical  =RLstruct.sbaset.vertical
     curfile   =RLstruct.sbaset.curfile
     ns        =RLstruct.sbaset.nsampl
     grpincr   =RLstruct.sbaset.valgrp & grpincr=strtrim(string(grpincr,format='(f4.1)'),2)
     SAVpth    =RLstruct.sbaset.SAVpth
     DATApth   =RLstruct.sbaset.DATApth
     toggles[0]=RLstruct.sbaset.toggles
     curLMH    =RLstruct.sbaset.curLMH
     savedLMH  =RLstruct.sbaset.savedLMH
     savedCTR  =RLstruct.sbaset.savedCTR
     savedSMP  =RLstruct.sbaset.savedSMP & if n_elements(savedSMP) eq 3 then savedSMP=[savedSMP,1] & savedSMP=long(savedSMP) ;compatibility V0.9
     savedTRM  =RLstruct.sbaset.savedTRM
     RLcomment =RLstruct.comments
     RLwater   =RLstruct.water           & sizrl=size(RLwater) & if sizrl[0] eq 2 then Wn=sizrl[2] ;HOW MANY WATERS
     RLbeam    =RLstruct.beam
     RLsample  =RLstruct.sample & if not vertical then RLsample=transpose(RLsample)
     idx=where(alltags eq 'WATERCW') ;Cell width?
     if idx[0] gt 1 then begin & waterCW =RLstruct.waterCW  & beamCW=RLstruct.beamCW
                               sampleCW=RLstruct.sampleCW & endif
     idx=where(alltags eq 'INF_CAL') ;Calibration?
     if idx[0] gt 1 then begin
        g_cal=RLstruct.GET_CAL
        if n_elements(RLstruct.GET_CAL) gt 1 then CALIBRATION, SET_CAL=g_cal, INF=RLstruct.INF_CAL
     endif

     sans_settings_swap, LMH="low"   , take=RLstruct.low_struct
     sans_settings_swap, LMH="middle", take=RLstruct.middle_struct
     sans_settings_swap, LMH="high"  , take=RLstruct.high_struct
     
     baset.savedLMH=savedLMH
     baset.curWATER=1
     widget_control,baset.bases3[29],set_value='' ;Clear alternative water High
     widget_control,baset.bases3[30],set_value='' ;Clear alternative water Low
     widget_control,baset.bases3[41],set_value='' ;Clear alternative flux
     widget_control,baset.bases3[24],set_value='' ;Clear run for mask data
     widget_control,baset.bases3[25],set_value='' ;Clear run for mask water

     if sansref eq 2 then begin & toggles[14]=0 & endif ; We HAVE XY in 2Thetha unit (1 Center, 14 Mask) auto=1 or 0
     toggles[14:15]   =0      ; No auto mask neither re-read anyway
     baset.bases6[20] =0      ; No re-read in sans_settings toggles also
     
     widget_control,baseSANS,set_uvalue=baset
     if DATApth gt ' ' then sans_sheet_lampies,SETpth=DATApth
     cid       =where(savedLMH*savedSMP[0:2] gt 0)
     curLMH    =cid[0]+1
    ;Init sans_settings also.... better after filling the tables (Water taken from cells!!!)
    ;Do it now just to have a correct sans_supl
     if curLMH gt 0 then sans_settings_swap, baset,/no_toggles, /get,LMH=(["low","middle","high"])[curLMH-1]

  endif ; restoring settings
  sans_settings_GetSupl, Supl

  CALIBRATION, GET_CAL=g_cal, INF=f_cal

  if sansref ne 0 then bckgrd="Cd/B4C"   else bckgrd="Backgrd"
  if sansref ne 0 then titbas="Sans Inputs " else titbas="Reflectometry Inputs " & titbas=titbas+curfile+version

  if sansref eq 2 then begin & LOW ='SCAN1' & MIDDLE='SCAN2'  & HIGH='SCAN3' & LB=' '    & MB=' ' & HB=' '
                             cntL='S1'    & cntM  ='S2'     & cntH='S3'
  endif           else begin & LOW ='LOW'   & MIDDLE='MIDDLE' & HIGH='HIGH'  & LB='    ' & MB=' ' & HB='   '
                             cntL='Lo'    & cntM  ='Md'     & cntH='Hi'    & endelse

 ;DEFINE TABLES
 ; ------------
 ; ------------------------------------------------------------------------------------------------------------
  tog_On   ='-ON    '
  tog_Off  ='-Off-  '
  toggtxt  =strarr(n_elements(toggles))+tog_On
  toggidx  =where(toggles eq 0) & if toggidx[0] ge 0 then toggtxt[toggidx]=tog_Off

  n_tables = 9 ;number of tables and comment texts
  col_row_s=lonarr(4   ,n_tables) ;(ncol),(nraw),(scrollable 1=onX 2=onXY),(1=water_tab 2=beam_tab 3=sample_tab)
  comment_s=strarr(     n_tables) ;comment before each table
  label_s  =strarr(     n_tables) ;label   before each table or memory progress-bar if string is "mpb"
  uname_s  =strarr(     n_tables) ;uname     for  each table
  row_label=strarr(  50,n_tables) ;row label for  each table
  col_label=strarr(  50,n_tables) ;col label for  each table
  tables_id=lonarr(2   ,n_tables) ;widget IDs
  col_color=lonarr(3,50,n_tables) & col_color[*]=255 ;grey for un_editable cells
  smp_color=[255,255,255]

  kRLc=0
  k= -1
  ;*** WATER ***********************
  ;*********************************
  k=k+1 & col_row_s[0,k]=[ 3,Wn,1] & comment_s[k]= "WATER  RUNS.  Notes-> "        ;sans_settings: base3,event,angle,count_pos
          col_row_s[3,k]=1         & uname_s[  k]= "WATER"
                                                     if Wn gt 1 then row_label[0,k]= [" Default"   , $
                                                                                      "(High Q)"     ]
                                                     if Wn gt 2 then row_label[2,k]= ["(Low  Q)"     ]
                                                                     col_label[0,k]= ["Water run",   $ ; 0 , 50 , 0    , 9
                                                                                       bckgrd+" run",$ ; 5 , 61 , 0    ,10
                                                                                      "W. cell run"  ] ; 1 , 61 , 0    ,11
              NL=3 & NM=17 & if sansref  ne 0 then begin &           col_label[NL,k]=["Thickness Cm",$ ;-1 , -1 ,-1    ,-1
                                                                                      "Tr.Water run",$ ;12 , 40 , 0    ,12
                                                                                      "Tr.Wcell run",$ ;13 , 40 , 0    ,13
                                                                                      "Tr.Wbeam run",$ ;17 , 40 , 0    ,14
                                                                                      "<->Tr.Wvalue",$ ;-1 ,-40 ,-1    ,-1
                                                                                      "<->Tr.Cvalue",$ ;-1 ,-40 ,-1    ,-1
                                                                                      "-> Wa.count" ,$ ;-1 , -9 ,-1    ,-1
                                                                                      "-> Bg.count", $ ;-1 , -9 ,-1    ,-1
                                                                                      "-> Ce.count" ,$ ;-1 , -9 ,-1    ,-1
                                                                                      "-> Tr.Wcount",$ ;-1 , -9 ,-1    ,-1
                                                                                      "-> Tr.Ccount",$ ;-1 , -9 ,-1    ,-1
                                                                                      "-> Tr.Bcount",$ ;-1 , -9 ,-1    ,-1
                                                                                      "-> Tr.Werror",$ ;-1 , -1 ,-1    ,-1
                                                                                      "-> Tr.Cerror" ] ;-1 , -1 ,-1    ,-1
                                                   NL=NM & col_row_s[0,k]=NL
                                                   col_color[*,7:8,k]=220 & col_color[*,9:*,k]=200
                                                   endif
  tmp  =strarr(NL,col_row_s[1,k]) & sizrl=size(RLwater) ;to restore a smaller or greater water table
  if sizrl[0] eq 2 then srl2=sizrl[2] else srl2=1 & if sizrl[0] ge 1 then srl1=sizrl[1] else srl1=1
  tmp[0,0]=RLwater[0:(srl1-1)<(NL-1) , 0:(srl2-1)<(col_row_s[1,k]-1)]  &  RLwater=tmp
  
  alW  =bytarr(NL,col_row_s[1,k])+1; Middle alignment Water
  editW=bytarr(NL,col_row_s[1,k]) & editW[0,0]=replicate(1B,9<NL)
  if sansref ne 0 then begin
     alW[9,0]  =replicate(0B,6) ;left alignment for title/count 
     if col_row_s[1,k] gt 1 then for j=1,col_row_s[1,k]-1 do begin
                                     RLwater[3:*,j]="-"
                                     editW[  0:2,j]= 1
                                     alW[9,j]      =replicate(0B,3) & endfor
  endif
  
  equiW=lonarr(NM,col_row_s[1,k],4) & for j=0,col_row_s[1,k]-1 do begin
                         equiW[*,j,0]=[0 ,5 ,1 ,-1,12,13,17,-1 ,-1 ,-1,-1,-1,-1,-1,-1,-1,-1] ;sans_settings text index in base3
                         equiW[*,j,1]=[50,61,61,-1,40,40,40,-40,-40,-9,-9,-9,-9,-9,-9,-1,-1] ;event,LMH(1,2,3)
                         equiW[*,j,3]=[9 ,10,11,-1,12,13,14,-1 ,-1 ,-1,-1,-1,-1,-1,-1,-1,-1] ;and count positions
;          BASE3 TABLE:
;          bases3 =[bwatr ,bwatre,bsampl,bsampe,bcadmi,bcadmw,  blabw,blabwe,blabs,blabse,blabc ,blabcw,$   ;0 ->11 sample
;                   awatr ,awatre,asampl,asampe,abeamS,abeamW,  alabw,alabwe,alabs,alabse,alabbS,alabbW,$   ;12->23 transmission
;                                 msampl,mwater,                             mlabs,mlabw ,confus,$          ;24->28 mask ,center
;                   Wwatr2,Wwatr3,Wwate2,Wwate3,Wcadc2,Wcadc3,  Wlabw2,Wlabw3,Wlabe2,Wlabe3,Wlabc2,Wlabc3,$ ;29->40 water alternatives
;                                                      SampFX,                                     SlabFX,$ ;41->42 FLUX  alternatives

                         if col_row_s[1,k] gt 1 then equiW[0:2,1,0]=[29,33,31] ;alternative Water in Mask
                         if col_row_s[1,k] gt 2 then equiW[0:2,2,0]=[30,34,32]
                                      endfor
;*** BEAM ***********************
;********************************
  k=k+1 & col_row_s[0,k]=[ 0, 0,0] & comment_s[k]= LOW   +LB+ "ANGLE. Notes-> " & label_s[k]="mpb"
  k=k+1 & col_row_s[0,k]=[ 0, 0,0] & comment_s[k]= MIDDLE+MB+ "ANGLE. Notes-> "
  k=k+1 & col_row_s[0,k]=[ 0, 0,0] & comment_s[k]= HIGH  +HB+ "ANGLE. Notes-> "
  k=k+1 & col_row_s[0,k]=[ 3, 4,1]                                                    ;sans_settings: base3,event,angle  base3,event,angle
          col_row_s[3,k]=2         & uname_s[  k]= "BEAM"  &         row_label[0,k]= ["Beam Tr."   , $ ;16 , 30 ,(1,2,3) Tr:16 , 40 , 0
                                                                                       bckgrd +" " , $ ; 4 , 61 ,(1,2,3) Tr:-1 , -1 ,-1
                                                                                      "Cell Bg."   , $ ; 3 , 61 ,(1,2,3) Tr:15 , 40 , 0
                                                                                      " (Flux) "   ]   ;41 , 61 ,(1,2,3) Tr:-1 , -1 ,-1
                                                                     col_label[0,k]= [LOW   +LB+"Q run",$ ;
                                                                                      MIDDLE+MB+"Q run",$ ;
                                                                                      HIGH  +HB+"Q run" ] ;
              NL=3 & NM=10 & if sansref  ne 0 then begin &           col_label[NL,k]=["Transm. run" ,$ ;
                                                                                      "<-> Tr.value",$ ;
                                                                                      "-> Tr.error" ,$ ;
                                                                                      "-> "+cntL+" Counts",$ ;
                                                                                      "-> "+cntM+" Counts",$ ;
                                                                                      "-> "+cntH+" Counts",$ ;
                                                                                      "-> Tr.Counts" ] ;
                                                   NL=NM & col_row_s[0,k]=NL
                                                   col_color[*,4:4,k]=220 & col_color[*,5:*,k]=200
                                                   endif
  tmp  =strarr(NL,col_row_s[1,k]) & tmp[0,0]=RLbeam & RLbeam=tmp ;so we can restore a smaller table
  alB  =bytarr(NL,col_row_s[1,k])+1; Middle alignment Beam
  editB=bytarr(NL,col_row_s[1,k]) & for j=0,col_row_s[1,k]-1 do editB[0,j]=replicate(1B,5<NL)
  if sansref ne 0 then for j=0,col_row_s[1,k]-1 do alB[6,j]    =replicate(0B,4) ;left alignment for title/count
  if sansref ne 0 then                             alB[9,[1,3]]= 1B             ;except middle "-" alignment
  if sansref ne 0 then begin & RLbeam[[3,4,5,9],1]="-" & RLbeam[[4,5],0]="-" & RLbeam[[3,4,5,9],3]="-"
                               editB[ [3,4,5,9],1]= 0  & editB[ [4,5],0]= 0  & editB[ [3,4,5,9],3]= 0 & endif

  equiB=lonarr(NM,4,4) & equiB[*,0,0]=[16,16,16,16,-1,-1,-1,-1,-1,-1] & equiB[*,0,1]=[30,30,30,40,-1 ,-1,-1,-1,-1,-1] ;sans_settings
                         equiB[*,1,0]=[4 ,4 ,4 ,-1,-1,-9,-9,-9,-9,-1] & equiB[*,1,1]=[61,61,61,-1,-40,-9,-9,-9,-9,-1] ;equivalence
                         equiB[*,2,0]=[3 ,3 ,3 ,15,-1,-1,-1,-1,-1,-1] & equiB[*,2,1]=[61,61,61,40,-1 ,-1,-1,-1,-1,-1] ;for text index in base3,
                         equiB[*,3,0]=[41,41,41,-1,-1,-9,-9,-9,-9,-1] & equiB[*,3,1]=[61,61,61,-1,-40,-9,-9,-9,-9,-1] ;event number,

                         equiB[*,0,2]=[1 ,2 ,3 ,0 ,-1,-1,-1,-1,-1,-1] & equiB[*,0,3]=[6 ,7 ,8 ,9 ,-1 ,-1,-1,-1,-1,-1] ;LMH(1,2,3)
                         equiB[*,1,2]=[1 ,2 ,3 ,-1,-1,-9,-9,-9,-9,-1] & equiB[*,1,3]=[6 ,7 ,8 ,-1,-1 ,-9,-9,-9,-9,-1] ;and counts positions
                         equiB[*,2,2]=[1 ,2 ,3 ,0 ,-1,-1,-1,-1,-1,-1] & equiB[*,2,3]=[6 ,7 ,8 ,9 ,-1 ,-1,-1,-1,-1,-1]
                         equiB[*,3,2]=[1 ,2 ,3 ,-1,-1,-9,-9,-9,-9,-1] & equiB[*,3,3]=[6 ,7 ,8 ,-1,-1 ,-9,-9,-9,-9,-1]
;*** SAMPLE ***********************
;**********************************
  if not vertical then begin
  k=k+1 & col_row_s[0,k]=[ns, 4,2] & comment_s[k]= "SAMPLE inputs."                   ;sans_settings: base3,event,angle,count_pos
          col_row_s[3,k]=3         & uname_s[  k]= "SAMPLE" &        row_label[0,k]= ["Sample  IDs ",$    ;-1 , -1 ,-1    ,-1
                                                                                      LOW   +LB+"Q run",$ ; 2 , 61 , 1    , 8
                                                                                      MIDDLE+MB+"Q run",$ ; 2 , 61 , 2    , 9
                                                                                      HIGH  +HB+"Q run" ] ; 2 , 61 , 3    ,10
              NL=4 & NM=12 & if sansref  ne 0 then begin &           row_label[NL,k]=["Transm. run "   ,$ ;14 , 40 , 0    ,11
                                                                                      "Thickness Cm"   ,$ ;-1 , -1 ,-1    ,-1
                                                                                      "<->Tr.values"   ,$ ;-1 ,-40 ,-1    ,-1
                                                                                      "-> Tr.errors"   ,$ ;-1 , -1 ,-1    ,-1
                                                                                      "-> "+cntL+" counts"   ,$ ;-1 , -9 ,-1    ,-1
                                                                                      "-> "+cntM+" counts"   ,$ ;-1 , -9 ,-1    ,-1
                                                                                      "-> "+cntH+" counts"   ,$ ;-1 , -9 ,-1    ,-1
                                                                                      "-> Tr.counts"    ] ;-1 , -9 ,-1    ,-1
                                                   NL=NM & col_row_s[1,k]=NL
                                                   col_color[*,6:6,k]=220 & col_color[*,7:*,k]=200
                                                   smp_color=col_color[*,0:col_row_s[1,k]-1,k] & col_color[*,*,k]=255
                                                   endif
  endif else begin
  k=k+1 & col_row_s[0,k]=[ 4,ns,2] & comment_s[k]= "SAMPLE inputs."
          col_row_s[3,k]=3         & uname_s[  k]= "SAMPLE" &         col_label[0,k]=["Sample IDs"  ,$
                                                                                      LOW   +LB+"Q run",$
                                                                                      MIDDLE+MB+"Q run",$
                                                                                      HIGH  +HB+"Q run" ]
              NL=4 & NM=12 & if sansref  ne 0 then begin &            col_label[4,k]=["Transm. run" ,$
                                                                                      "Thickness Cm",$
                                                                                      "<-> Tr.value",$
                                                                                      "-> Tr.error" ,$
                                                                                      "-> "+cntL+" counts",$
                                                                                      "-> "+cntM+" counts",$
                                                                                      "-> "+cntH+" counts",$
                                                                                      "-> Tr.counts" ]
                                                   NL=NM & col_row_s[0,k]=NL
                                                   col_color[*,6:6,k]=220 & col_color[*,7:*,k]=200
                                                   smp_color=col_color[*,0:col_row_s[0,k]-1,k]
                                                   endif
  endelse
  if n_elements(RLsample) gt 1 then begin
   if vertical then RLsample=RLsample[*,0:ns-1] else RLsample=RLsample[0:ns-1,*]
   tmp  =strarr(NL,ns) & if not vertical then tmp=transpose(tmp) & tmp[0,0]=RLsample & RLsample=tmp ;so we can restore a smaller table
  endif
  alS  =bytarr(NL,ns)+1; Middle alignment Sample
  editS=bytarr(NL,ns)  & for j=0L,ns-1 do editS[0,j]=replicate(1B,7<NL)     ;Input cells
  if NL ge 12 then begin;for j=0L,ns-1 do editS(8,j)=replicate(1B,3<(NL-8)) ;Scrolling cells (titles)
                         for j=0L,ns-1 do   alS[8,j]=replicate(0B,3<(NL-8)) & endif ;left alignment for title/count
                         if not vertical  then editS=transpose(editS)

  equiS=lonarr(NM,maxns,4) & for j=0L,maxns-1 do begin
                          equiS[*,j,0]=[-1,2 ,2 ,2 ,14,-1,-1   ,-1,-1,-1,-1,-1] ;text index in base3
                          equiS[*,j,1]=[-1,61,61,61,40,-1,-40  ,-1,-9,-9,-9,-9] ;event number
                          equiS[*,j,2]=[-1,1 ,2 ,3 ,0 ,-1,-1   ,-1,-1,-1,-1,-1] ;LMH(1,2,3) and count positions
                          equiS[*,j,3]=[-1,8 ,9 ,10,11,-1,-1   ,-1,-1,-1,-1,-1] & endfor ;& if not vertical then equiS=transpose(equiS,[1,0,2])

  if sys_dep('VERSION') lt 6.1    then oldV=1 else oldV=0
  if sys_dep('MACHINE') eq "unix" then ux  =1 else ux  =0
  if ux then gap=" " else gap="  "
  if ux then L_S="-" else L_S="settings"

  wcol_wcar=8 ;table layout
  wcol_main=(13+ux)*wcol_wcar
  hrow_main= 16+ux
  if ux then labl_spch=hrow_main   else labl_spch=0
  if ux then labl_spcw=wcol_wcar*2 else labl_spcw=0

  device,get_screen_size=screen
  if vertical then scrX_main=750 else scrX_main=750 ;640
  if Wn gt 1 then if screen[0] ge 1024 then scrX_main=scrX_main+100 ;+label in Water table
  scrY_main=600
  scrY_maxt=150

 ;GUI CONSTRUCTOR
 ; --------------          Menu bitmap if 1    Button bitmap if 1    Path for bitmap
  P_did_get_etc, d_etc  &  Mbm = d_etc.Mbm  &  Ubm = d_etc.Ubm   &   Pbm = d_etc.Pbm
  
  if oldV then $
  sbase0 = widget_base(  title=titbas,/column,resource_name='lamptouch',MBAR=smbar,rname_mbar='lampben',/tlb_size_event)  else $
  sbase0 = widget_base(  title=titbas,/column,resource_name='lamptouch',MBAR=smbar,rname_mbar='lampben',/tlb_size_event,tab_mod=2)
  widget_control,default_font=ft_propor
  sbasec = widget_base(  sbase0,/column)
  
  Smanual= finefile(lamp_dir+lamp_dvd+'manual'+lamp_dvd+'sans_sheet_manual.pdf')

 ;MENU BAR
 ; -------
 
 ;Image in menu buttons (put in did_etc.Mbmp)
  P_did_get_etc, d_etc  &  Mbm = d_etc.Mbm
  if Mbm then begin
   ListBm=['back','bulb','contour','copy','ellipse','export','gears','image','importd','jst',$
           'layer','open','plot','polar','profile','rectangl','switch_up']
   for i = 0,n_elements(ListBm)-1 do begin
     did_bitmap, ListBm[i], bmImg, cnt
     if cnt eq 1 then begin
       txt = ListBm[i]
       k   = strpos(txt,'-')  &  if k ge 0 then strput,txt,'_',k ;replace '-' by '_'
       k   = strpos(txt,'-')  &  if k ge 0 then strput,txt,'_',k ;replace '-' by '_'
       ii=execute('bm_'+txt+'=bmImg') ; Make the variable containing the byte true image
     endif
   endfor
  endif

  sbinst = widget_button(smbar  ,font=ft_propor,value= instru+"/Path  "        ,/menu)
           if Mbm then widget_control,sbinst, image=bm_open
     bins= widget_button(sbinst ,font=ft_propor,value= 'Change Instrument Name',/menu)
     for i=0,n_elements(InstList)-1 do $
         if InstIsOn[i] then bidi=widget_button(bins,font=ft_propor,value=InstList[i],uvalue=[51,1],sens=InstIsOn[i])
     bid = widget_button(sbinst ,font=ft_propor,value= '')     & widget_control,bid,sens=0
     mpth= widget_button(sbinst ,font=ft_propor,value= 'Set  Data path',/menu)
     bpth= widget_button(mpth   ,font=ft_propor,value= 'Set Data path using Explorer')
     bptl= widget_button(mpth   ,font=ft_propor,value= 'Set Data path using Lamp')
     bid = widget_button(mpth   ,font=ft_propor,value= '---')  & widget_control,bid,sens=0
     bptw= widget_button(mpth   ,font=ft_propor,value= 'Set Working path')
     bid = widget_button(mpth   ,font=ft_propor,value= '')     & widget_control,bid,sens=0
    calis= widget_button(mpth   ,font=ft_propor,value= 'Show current calibration file')
    calif= widget_button(mpth   ,font=ft_propor,value= 'Set Optional Calibration File')
     bpts= widget_button(sbinst ,font=ft_propor,value= 'Show Data path')
     bid = widget_button(sbinst ,font=ft_propor,value= '---')  & widget_control,bid,sens=0
     expo= widget_button(sbinst ,font=ft_propor,value= 'Export...',/menu)
           if Mbm then widget_control,expo, image=bm_export
      be0= widget_button(expo   ,font=ft_propor,value='Export integration Result  -> gnum.100')
           if Mbm then widget_control,be0 , image=bm_profile
      be2= widget_button(expo   ,font=ft_propor,value="Export corrected Data      -> tnum.100 + Q's")
           if Mbm then widget_control,be2 , image=bm_contour
      bid= widget_button(expo   ,font=ft_propor,value=' ')     & widget_control,bid,sens=0
      be1= widget_button(expo   ,font=ft_propor,value='Export integration Result  -> 1D_numor.txt')
           if Mbm then widget_control,be1 , image=bm_profile
      be3= widget_button(expo   ,font=ft_propor,value="Export corrected Data      -> 2D_numor.txt + Q's")
           if Mbm then widget_control,be3 , image=bm_contour
      be6= widget_button(expo   ,font=ft_propor,value="Export corrected Data      -> PNG images")
      be7= widget_button(expo   ,font=ft_propor,value="Export corrected Data      -> NIST 2D format")
  if instru ne 'MILAND' then begin
     bid = widget_button(sbinst ,font=ft_propor,value= '---')  & widget_control,bid,sens=0
   Loglst= widget_button(sbinst ,font=ft_propor,value= 'Log of numors list')
           if Mbm then widget_control,Loglst, image=bm_jst
  endif
     bid = widget_button(sbinst ,font=ft_propor,value= '---')  & widget_control,bid,sens=0
     exis= widget_button(sbinst ,font=ft_propor,value= 'Exit with Save')
     exi = widget_button(sbinst ,font=ft_propor,value= 'Exit')
  sbopt  = widget_button(smbar  ,font=ft_propor,value= "Treatment Options  ",/menu)
           if Mbm then widget_control,sbopt , image=bm_gears
    bid  = widget_button(sbopt  ,font=ft_propor,value=   '--- Toggles ---')   & widget_control,bid,sens=0
    bid1 = widget_button(sbopt  ,font=ft_propor,value=   toggtxt[1] +'Automatic CENTERS setting')
    bid2 = widget_button(sbopt  ,font=ft_propor,value=   toggtxt[2] +'Automatic TRANSMISSIONS setting')
    bid10= widget_button(sbopt  ,font=ft_propor,value=   toggtxt[14]+'Automatic BEAM MASKS setting')
    bid  = widget_button(sbopt  ,font=ft_propor,value=   ' ')  & widget_control,bid,sens=0
    bid3 = widget_button(sbopt  ,font=ft_propor,value=   toggtxt[3] +'Automatic write RESULTS')
    bid9 = widget_button(sbopt  ,font=ft_propor,value=   toggtxt[13]+'Auto increment resulting FILES')
    bid  = widget_button(sbopt  ,font=ft_propor,value=   ' ')  & widget_control,bid,sens=0
;   bid4 = widget_button(sbopt  ,font=ft_propor,value=   toggtxt(4) +'Discard Low-resolution POINTS (for plotting)');Now in sans_settings
    bid5 = widget_button(sbopt  ,font=ft_propor,value=   toggtxt[15]+'Re-read data input Runs  (even if in memory)');& widget_control,bid5,sens=0
    bid  = widget_button(sbopt  ,font=ft_propor,value=   ' ')  & widget_control,bid,sens=0
    bidtxt=['2*PI RADIAL',$
            '2*PI AZIMUTHAL',$
            'By   SECTORS']
    sectxt=['Total  integration   symmetrical',$
            'Total  integration non-symmetric',$
            'Radial integration   symmetrical',$
            'Radial integration non-symmetric']
    bidtog=where(toggles[6:8]  eq 1)>0
    sectog=where(toggles[9:12] eq 1)>0
    
    grpm7= widget_button(sbopt  ,font=ft_propor,value=   '  GROUP  Mode= '+bidtxt[bidtog[0]],/menu)
    bid6 = widget_button(grpm7  ,font=ft_propor,value=   toggtxt[6] +'->'+bidtxt[0])
    bid7 = widget_button(grpm7  ,font=ft_propor,value=   toggtxt[7] +'->'+bidtxt[1])
    bid8 = widget_button(grpm7  ,font=ft_propor,value=   toggtxt[8] +'->'+bidtxt[2])
    lab  = widget_button(grpm7  ,font=ft_propor,value=   ' ')
    lab  = widget_button(grpm7  ,font=ft_propor,value=   '')
    lab  = widget_button(grpm7  ,font=ft_propor,value=   '(Right click on a Sample to see Sectors or Masks)')
    
    bidm7= widget_button(sbopt  ,font=ft_propor,value=   '  SECTOR Mode= '+sectxt[sectog[0]],/menu)
    if not toggles[8] then widget_control,bidm7,sens=0
    widget_control,grpm7,set_uvalue=bidm7
     bsm1= widget_button(bidm7  ,font=ft_propor,value=   toggtxt[9] +'->'+sectxt[0])
     bsm2= widget_button(bidm7  ,font=ft_propor,value=   toggtxt[10]+'->'+sectxt[1])
     lab = widget_button(bidm7  ,font=ft_propor,value=   ' ')
     bsm3= widget_button(bidm7  ,font=ft_propor,value=   toggtxt[11]+'->'+sectxt[2])
     bsm4= widget_button(bidm7  ,font=ft_propor,value=   toggtxt[12]+'->'+sectxt[3])
     bid = widget_button(bidm7  ,font=ft_propor,value=   '---')  & widget_control,bid,sens=0
     lab = widget_button(bidm7  ,font=ft_propor,value=   '')
     lab = widget_button(bidm7  ,font=ft_propor,value=   '(Right click on a Sample to see Sectors and Masks)')
    bid  = widget_button(sbopt  ,font=ft_propor,value=   ' ')    & widget_control,bid,sens=0
    bid  = widget_button(sbopt  ,font=ft_propor,value=   '---')  & widget_control,bid,sens=0
    
    b1dos= widget_button(sbopt  ,font=ft_propor,value=   '  CORRECTIONS: Monitor or Time, Solid angles, Dead times')
    b2dos= widget_button(sbopt  ,font=ft_propor,value=   '               Fixed Water Cross Section, Trs(2theta), Qdep')
    bid  = widget_button(sbopt  ,font=ft_propor,value=   '---')  & widget_control,bid,sens=0
    bid  = widget_button(sbopt  ,font=ft_propor,value=   '')     & widget_control,bid,sens=0
    bidof= widget_button(sbopt  ,font=ft_propor,value=   '  Select a Calibration file (used in read operations)')  ;& widget_control,bidof,sens=0
           if Mbm then widget_control,bidof , image=bm_importd
    bidod= widget_button(sbopt  ,font=ft_propor,value=   '  Show   detector efficiencies (having water or inst.cal)')
           if Mbm then widget_control,bidod , image=bm_image
  if sansref ne 0 then begin
   sbmask= widget_button(smbar  ,font=ft_propor,value= "Mask "        ,/menu)
           if Mbm then widget_control,sbmask, image=bm_rectangl
    if supl[66] gt 1 then begin ;NegMask > 1 (number of panels)
     bidmP=widget_button(sbmask ,font=ft_propor,value=   'PANELS availability and RESOLUTION',/menu)
           if Mbm then widget_control,bidmP , image=bm_back
      if supl[68] then togo =tog_On else togo =tog_Off
      bid= widget_button(bidmp  ,font=ft_propor,value=   togo+'Enable all Panels for '+LOW   +LB+'angle', uvalue=[49,1])
      if supl[69] then togo =tog_On else togo =tog_Off
      bid= widget_button(bidmp  ,font=ft_propor,value=   togo+'Enable all Panels for '+MIDDLE+MB+'angle', uvalue=[49,2])
      if supl[70] then togo =tog_On else togo =tog_Off
      bid= widget_button(bidmp  ,font=ft_propor,value=   togo+'Enable all Panels for '+HIGH  +HB+'angle', uvalue=[49,3])
      bid= widget_button(bidmp  ,font=ft_propor,value=   '')
      if supl[67] eq 1 then togo =tog_On else togo =tog_Off
      bid= widget_button(bidmp  ,font=ft_propor,value=   togo+'High resolution (all Panels selected)'   , uvalue=[49,0])
     bid = widget_button(sbmask ,font=ft_propor,value=   '---')  & widget_control,bid,sens=0
    endif
    bidm1= widget_button(sbmask ,font=ft_propor,value=   'Edit the beam mask for '+LOW   +LB+'angle')
           if Mbm then widget_control,bidm1 , image=bm_ellipse
    bidm2= widget_button(sbmask ,font=ft_propor,value=   'Edit the beam mask for '+MIDDLE+MB+'angle')
    bidm3= widget_button(sbmask ,font=ft_propor,value=   'Edit the beam mask for '+HIGH  +HB+'angle')
    bid  = widget_button(sbmask ,font=ft_propor,value=   '---')  & widget_control,bid,sens=0
    bidm4= widget_button(sbmask ,font=ft_propor,value=   'Edit the mask for (selected) WATER')
    bid  = widget_button(sbmask ,font=ft_propor,value=   '---')  & widget_control,bid,sens=0
    bidm5= widget_button(sbmask ,font=ft_propor,value=   'Additional masks for DETECTOR',/menu)
           if Mbm then widget_control,bidm5 , image=bm_layer
     bm50= widget_button(bidm5  ,font=ft_propor,value=   'Additional masks for ALL    angles')
     bid = widget_button(bidm5  ,font=ft_propor,value=   '---')  & widget_control,bid,sens=0
     bm51= widget_button(bidm5  ,font=ft_propor,value=   'Additional masks for '+LOW   +LB+'angle')
     bm52= widget_button(bidm5  ,font=ft_propor,value=   'Additional masks for '+MIDDLE+MB+'angle')
     bm53= widget_button(bidm5  ,font=ft_propor,value=   'Additional masks for '+HIGH  +HB+'angle')
     bid = widget_button(bidm5  ,font=ft_propor,value=   '---')  & widget_control,bid,sens=0
     bid = widget_button(bidm5  ,font=ft_propor,value=   '!!!WARNING:Do the masks for ALL angles')
     bid = widget_button(bidm5  ,font=ft_propor,value=   '           before specific angle !!!')
    bid  = widget_button(sbmask ,font=ft_propor,value=   '---')  & widget_control,bid,sens=0
    bid  = widget_button(sbmask ,font=ft_propor,value=   ' ')
    bidm9= widget_button(sbmask ,font=ft_propor,value=   'Save Detector Mask to   "file*.msk" (current config)')
    bidm8= widget_button(sbmask ,font=ft_propor,value=   'Load Detector Mask from "file*.msk" (current config)')
   sbtran= widget_button(smbar  ,font=ft_propor,value= "Transmission ",/menu)
           if Mbm then widget_control,sbtran , image=bm_switch_up
    bidt1= widget_button(sbtran ,font=ft_propor,value=   'Set Transmissions from attenuated input data')
     bid = widget_button(sbtran ,font=ft_propor,value=   '---')  & widget_control,bid,sens=0
    bidt2= widget_button(sbtran ,font=ft_propor,value=   'Get Transmissions from an input file')
   sbcent= widget_button(smbar  ,font=ft_propor,value= "Center "      ,/menu)
           if Mbm then widget_control,sbcent , image=bm_polar
    bidc1= widget_button(sbcent ,font=ft_propor,value=   'Verify the center for '+LOW   +LB+'angle and Phi0')
    bidc2= widget_button(sbcent ,font=ft_propor,value=   'Verify the center for '+MIDDLE+MB+'angle and Phi0')
    bidc3= widget_button(sbcent ,font=ft_propor,value=   'Verify the center for '+HIGH  +HB+'angle and Phi0')
  endif
  sbbid  = widget_button(smbar  ,font=ft_propor,value= "    ")
  sbhelp = widget_button(smbar  ,font=ft_propor,value= "Help/Use"        ,/menu)
           if Mbm then widget_control,sbhelp , image=bm_bulb
    bid  = widget_button(sbhelp ,font=ft_propor,value= "-First set a correct PATH for your input DATA. Verify your selected INSTRUMENT")
    bid  = widget_button(sbhelp ,font=ft_propor,value= "-If you have a Calibration File you need to select it before any read operation")
    if supl[66] gt 1 then $     ;NegMask > 1 (number of panels)
    bid  = widget_button(sbhelp ,font=ft_propor,value= "-Mask (unMask) your PANELS and choose a DETECTOR RESOLUTION (unTof)")
    bid  = widget_button(sbhelp ,font=ft_propor,value= "-Then fill all table cells (except those labeled  ->fixed_val , <->editable_val )")
    bid  = widget_button(sbhelp ,font=ft_propor,value=   '---')  & widget_control,bid,sens=0
    bid  = widget_button(sbhelp ,font=ft_propor,value= "-Verify your beam MASKs (one Mask/water) and additional detector MASKs")
    bid  = widget_button(sbhelp ,font=ft_propor,value= "-Verify your Treatment Options")
    bid  = widget_button(sbhelp ,font=ft_propor,value=   '---')  & widget_control,bid,sens=0
    bid  = widget_button(sbhelp ,font=ft_propor,value= "-Finally click on the TREAT button (Sample IDs cells may be selected)")
    bid  = widget_button(sbhelp ,font=ft_propor,value=   '---')  & widget_control,bid,sens=0
    bid  = widget_button(sbhelp ,font=ft_propor,value= "-To see a run number: select a CELL and right click on it.")
    bid  = widget_button(sbhelp ,font=ft_propor,value=   '---')  & widget_control,bid,sens=0
    bid  = widget_button(sbhelp ,font=ft_propor,value= "-To have only corrected data, set group increment to 0 then TREAT.")
;   bid  = widget_button(sbhelp ,font=ft_propor,value=   '---')  & widget_control,bid,sens=0
;   bid  = widget_button(sbhelp ,font=ft_propor,value= "-You can enter different WATER/config then TREAT one by one "+LOW+"|"+MIDDLE+"|"+HIGH)
    bid  = widget_button(sbhelp ,font=ft_propor,value=   '---')  & widget_control,bid,sens=0
    bid  = widget_button(sbhelp ,font=ft_propor,value= "-SYNTAX in CELL runs: 123 or 123+125+127 or 123+125>128+134"     )
    bid  = widget_button(sbhelp ,font=ft_propor,value= "-SYNTAX additional for [Cell Bg.] and [Sample] Series: 123:234 (::: for step=3)")
    bid  = widget_button(sbhelp ,font=ft_propor,value=   '-')    & widget_control,bid,sens=0
    bid  = widget_button(sbhelp ,font=ft_propor,value=   ' ')   ;& widget_control,bid,sens=0
           if Mbm then widget_control,bid , image=bm_copy
    if Smanual gt ' ' then $
    Sman = widget_button(sbhelp ,font=ft_propor,value=   '->Sans sheet manual (pdf)', Uname=Smanual) $
    else $
    Sman = widget_button(sbhelp ,font=ft_propor,value=   '-')   ;& widget_control,Sman,sens=0
    Jou  = widget_button(sbhelp ,font=ft_propor,value=   '->The  JOURNAL')
    WKL  = widget_button(sbhelp ,font=ft_propor,value=   '->DATA INSPECTION available in LAMP',/menu)
      bid= widget_button(WKL    ,font=ft_propor,value=   '(Workspaces containing current config data set)')
      bid= widget_button(WKL    ,font=ft_propor,value=   'W1 = Transmission WATER'                     ,uvalue=[57,3,1])
      bid= widget_button(WKL    ,font=ft_propor,value=   'W2 = Transmission WATER CELL'                ,uvalue=[57,3,2])
      bid= widget_button(WKL    ,font=ft_propor,value=   'W3 = Transmission SAMPLE'                    ,uvalue=[57,3,3])
      bid= widget_button(WKL    ,font=ft_propor,value=   'W4 = Transmission SAMPLE CELL'               ,uvalue=[57,3,4])
      bid= widget_button(WKL    ,font=ft_propor,value=   'W5 = Transmission SAMPLE BEAM'               ,uvalue=[57,3,5])
      bid= widget_button(WKL    ,font=ft_propor,value=   'W6 = Transmission WATER  BEAM'               ,uvalue=[57,3,6])
      bid= widget_button(WKL    ,font=ft_propor,value=   'W9 = Transmission BEAM  for PHI0 and CENTER',uvalue=[57,3,9])
      bid= widget_button(WKL    ,font=ft_propor,value=   '')     & widget_control,bid,sens=0
      bid= widget_button(WKL    ,font=ft_propor,value=   'W7 = Mask using a BACKGROUND (or SECTORS)'   ,uvalue=[57,3,7])
      bid= widget_button(WKL    ,font=ft_propor,value=   'W8 = Mask using a WATER'                     ,uvalue=[57,3,8])
      bid= widget_button(WKL    ,font=ft_propor,value=   '')     & widget_control,bid,sens=0
      bid= widget_button(WKL    ,font=ft_propor,value=   'W10= WATER'                                  ,uvalue=[57,3,10])
      bid= widget_button(WKL    ,font=ft_propor,value=   'W11= WATER  CELL'                            ,uvalue=[57,3,11])
      bid= widget_button(WKL    ,font=ft_propor,value=   'W12= SAMPLE'                                 ,uvalue=[57,3,12])
      bid= widget_button(WKL    ,font=ft_propor,value=   'W13= SAMPLE CELL'                            ,uvalue=[57,3,13])
      bid= widget_button(WKL    ,font=ft_propor,value=   'W14= Cd/B4C SAMPLE'                          ,uvalue=[57,3,14])
      bid= widget_button(WKL    ,font=ft_propor,value=   'W15= Cd/B4C WATER'                           ,uvalue=[57,3,15])
      bid= widget_button(WKL    ,font=ft_propor,value=   '')     & widget_control,bid,sens=0
      bid= widget_button(WKL    ,font=ft_propor,value=   'W16= Corrected DATA selected by the slider'             ,uvalue=[57,3,16])
      bid= widget_button(WKL    ,font=ft_propor,value=   'W17= EFFICIENCY DETECTOR IMAGE'                         ,uvalue=[57,3,17])
      bid= widget_button(WKL    ,font=ft_propor,value=   'W18, W31 W32 W33= CORRECTED DATA: current conf, 1 2 3)' ,uvalue=[57,3,18])
      bid= widget_button(WKL    ,font=ft_propor,value=   'W19, W34 W35 W36= INTEGRATIONS  : current conf, 1 2 3)' ,uvalue=[57,3,19])
      bid= widget_button(WKL    ,font=ft_propor,value=   '')     & widget_control,bid,sens=0
      bid= widget_button(WKL    ,font=ft_propor,value=   'W21= SUPRPLOT inspection'                    ,uvalue=[57,3,21])
      bid= widget_button(WKL    ,font=ft_propor,value=   'W22= MERGED CURVES'                          ,uvalue=[57,3,22])
      bid= widget_button(WKL    ,font=ft_propor,value=   'W23= DELTA Q'                                ,uvalue=[57,3,23])
      bid= widget_button(WKL    ,font=ft_propor,value=   '')     & widget_control,bid,sens=0
      bid= widget_button(WKL    ,font=ft_propor,value=   'W24= Used for ALTERNATIVE WATER'             ,uvalue=[57,3,24])
      bid= widget_button(WKL    ,font=ft_propor,value=   'W25= Used for imported gnum.100 files'       ,uvalue=[57,3,25])
      bid= widget_button(WKL    ,font=ft_propor,value=   'W26= Used for ALTERNATIVE FLUX trs.'         ,uvalue=[57,3,26])
      bid= widget_button(WKL    ,font=ft_propor,value=   ' ')    & widget_control,bid,sens=0
      bip= widget_button(WKL    ,font=ft_propor,value=   '-->SHOW Workspace PARAMETERS read from run files')
      bid= widget_button(WKL    ,font=ft_propor,value=   'Free: W20 , W27->W30 , W37->...')

  widget_control,bid1  ,set_uvalue=[50,1 ,0,0     ,0]        ;auto center TOGGLES
  widget_control,bid2  ,set_uvalue=[50,2 ,0,0     ,0]        ;auto transmission
  widget_control,bid10 ,set_uvalue=[50,14,0,0     ,0]        ;auto masks
  widget_control,bid3  ,set_uvalue=[50,3 ,0,0     ,0]        ;auto write results
  widget_control,bid9  ,set_uvalue=[50,13,0,0     ,0]        ;increment result files
 ;widget_control,bid4  ,set_uvalue=[50,4 ,0,0     ,0]        ;discard LR points (Now in sans_settings)
  widget_control,bid5  ,set_uvalue=[50,15,0,0     ,0]        ;Re-read Data anyway
  widget_control,bid6  ,set_uvalue=[50,6 ,2,bid7 ,bid8 ,6]   ;radial
  widget_control,bid7  ,set_uvalue=[50,7 ,2,bid6 ,bid8 ,7]   ;azimutal
  widget_control,bid8  ,set_uvalue=[50,8 ,2,bid6 ,bid7 ,8]   ;sectors
  widget_control,bsm1  ,set_uvalue=[50,9 ,3,bsm2 ,bsm3 ,bsm4 ,8] ;sector total   sym
  widget_control,bsm2  ,set_uvalue=[50,10,3,bsm1 ,bsm3 ,bsm4 ,8] ;sector total  asym
  widget_control,bsm3  ,set_uvalue=[50,11,3,bsm1 ,bsm2 ,bsm4 ,8] ;sector radial  sym
  widget_control,bsm4  ,set_uvalue=[50,12,3,bsm1 ,bsm2 ,bsm3 ,8] ;sector radial asym

 ;widget_control,bins  ,set_uvalue=[51,1]           ;INSTRUMENT NAME (Menu list)
  widget_control,bpth  ,set_uvalue=[51,2,bpth,bptl] ;DATA PATH (explorer)
  widget_control,bptl  ,set_uvalue=[51,3,bpth,bptl] ;DATA PATH (lamp)
  widget_control,bpts  ,set_uvalue=[51,4,bpth,bptl] ;DATA PATH (to show)
  widget_control,bptw  ,set_uvalue=[51,5,bpth,bptl] ;WORKING PATH (to set)

  widget_control,calis ,set_uvalue=[51,7]           ;CALIBRATION FILE (SHOW)
  widget_control,calif ,set_uvalue=[51,6]           ;CALIBRATION FILE (SET)
  widget_control,bidof ,set_uvalue=[51,6]           ;CALIBRATION FILE (SET)

  widget_control,be0   ,set_uvalue=[51,13,0,19]     ;EXPORT gnum
  widget_control,be2   ,set_uvalue=[51,13,2,18]     ;EXPORT tnum
  widget_control,be1   ,set_uvalue=[51,13,1,19]     ;EXPORT 3col
  widget_control,be3   ,set_uvalue=[51,13,3,18]     ;EXPORT *.column
  widget_control,be6   ,set_uvalue=[51,13,6,18]     ;EXPORT *.png 2d
  widget_control,be7   ,set_uvalue=[51,13,7,18]     ;EXPORT NIST 2d

  widget_control,b1dos ,set_uvalue=[52]             ;OPTIONS for detector corrections
  widget_control,b2dos ,set_uvalue=[52]             ;OPTIONS for detector corrections

  if sansref ne 0 then begin
  widget_control,bidm1 ,set_uvalue=[53,1] ;MASK low
  widget_control,bidm2 ,set_uvalue=[53,2] ;     middle
  widget_control,bidm3 ,set_uvalue=[53,3] ;     high
  widget_control,bidm4 ,set_uvalue=[53,4] ;     water
  widget_control,bm50  ,set_uvalue=[53,5,0] ;   detector ALL
  widget_control,bm51  ,set_uvalue=[53,5,1] ;   detector LOW
  widget_control,bm52  ,set_uvalue=[53,5,2] ;   detector MIDDLE
  widget_control,bm53  ,set_uvalue=[53,5,3] ;   detector HIGH
  widget_control,bidm8 ,set_uvalue=[53,8]
  widget_control,bidm9 ,set_uvalue=[53,9]

  widget_control,bidt1 ,set_uvalue=[54,0] ;TRANSMISSION
  widget_control,bidt2 ,set_uvalue=[54,1]

  widget_control,bidc1 ,set_uvalue=[55,1] ;CENTER
  widget_control,bidc2 ,set_uvalue=[55,2]
  widget_control,bidc3 ,set_uvalue=[55,3]
  endif
  widget_control,sbhelp,set_uvalue=[57,0] ;HELP
  widget_control,jou   ,set_uvalue=[57,1] ;JOURNAL
  widget_control,bip   ,set_uvalue=[57,2] ;PARAMETERS
  widget_control,Sman  ,set_uvalue=[57,4] ;Sans sheet manual

  if n_elements(Loglst) eq 1 then $
  widget_control,Loglst,set_uvalue=[58,0] ;LOG list of numors

  widget_control,exis  ,set_uvalue=[12,3] ;SAVE-EXIT
  widget_control,exi   ,set_uvalue=[77]   ;EXIT

 ;LEADING FIELDS
 ; ------ ------
  row0    = widget_base(  sbasec,/row)
  row1    = widget_base(  sbasec,/row)
  row11   = widget_base(  row1  ,/row)
   bclrs  = widget_button(row11 ,value="Cells..."                          ,font=ft_b_normal,/menu)
    bclrs0= widget_button(bclrs ,value="Reset ALL"                         ,font=ft_b_normal)
    bclrs1= widget_button(bclrs ,value="Clear ALL cells"                   ,font=ft_b_normal)
    bclrs2= widget_button(bclrs ,value="Clear ALL Sample table cells"      ,font=ft_b_normal)
    bclrs3= widget_button(bclrs ,value="Clear selected Sample table cells" ,font=ft_b_normal)
    bid   = widget_button(bclrs ,value=""                                  ,font=ft_b_normal)
    bclrs4= widget_button(bclrs ,value="Remove the selected sample ID line" ,font=ft_b_normal)
    bclrs5= widget_button(bclrs ,value="Insert a new sample ID just before the selected one" ,font=ft_b_normal)
   bid    = widget_label( row11 ,value="Samples #"          ,font=ft_b_normal)
   bnsamp = widget_text(  row11 ,value=strtrim(string(ns),2),font=ft_propor   ,xsize=3 ,/editable)
   bid    = widget_label( row1  ,value=gap                  ,font=ft_propor)
  row12   = widget_base(  row1  ,frame=1,/row)
   bfill  = widget_button(row12 ,value="Fill down sample"   ,font=ft_b_normal,/menu)
   bfill1 = widget_button(bfill ,value="Fill down without increment (from selected cell in sample table)" ,font=ft_b_normal)
   bfill3 = widget_button(bfill ,value="Fill down according to increment value"                           ,font=ft_b_normal)
   bfill2 = widget_button(bfill ,value="Fill down with  1 increment"                                      ,font=ft_b_normal)
   bid    = widget_label( row12 ,value="incr:"              ,font=ft_b_normal)
   bincr  = widget_text(  row12 ,value=fillincr             ,font=ft_propor   ,xsize=3 ,/editable)
   bid    = widget_label( row1  ,value=gap                  ,font=ft_propor)
  row13   = widget_base(  row1  ,frame=1,/row)
   bload  = widget_button(row13 ,value="Load"               ,font=ft_b_normal)
   bid    = widget_label( row13 ,value=L_S                  ,font=ft_b_normal)
   bsave  = widget_button(row13 ,value="Save"               ,font=ft_b_normal)
   bid    = widget_label( row1  ,value=gap                  ,font=ft_propor)
  row14   = widget_base(  row1  ,frame=3,/row)
   bid    = widget_label( row14 ,value="Group:"             ,font=ft_b_normal)
   bgrp   = widget_text(  row14 ,value= grpincr             ,font=ft_propor   ,xsize=4 ,/editable)
   bgo    = widget_button(row14 ,value=" TREAT->"           ,font=ft_b_normal,/menu)
   bgo0   = widget_button(bgo   ,value="TREAT ALL    angles",font=ft_b_normal)
   bid    = widget_button(bgo   ,value=" ")                                    & widget_control,bid,sens=0
   bgo1   = widget_button(bgo   ,value="TREAT "+LOW   +LB+"angles",font=ft_b_normal)
   bgo2   = widget_button(bgo   ,value="TREAT "+MIDDLE+MB+"angles",font=ft_b_normal)
   bgo3   = widget_button(bgo   ,value="TREAT "+HIGH  +HB+"angles",font=ft_b_normal)
   bid    = widget_button(bgo   ,value="-")                                    & widget_control,bid,sens=0
   bgo4i  = widget_button(bgo   ,value="SHOW  Integration Results",font=ft_b_normal)
            if Mbm then widget_control,bgo4i, image=bm_plot
   bid    = widget_button(bgo   ,value=" ")                                    & widget_control,bid,sens=0
   bgo4d  = widget_button(bgo   ,value="SHOW  Corrected Data"     ,font=ft_b_normal, /menu)
            if Mbm then widget_control,bgo4d, image=bm_contour
   bgo4d1 = widget_button(bgo4d ,value="SHOW  Corrected "+LOW     ,font=ft_b_normal)
   bgo4d2 = widget_button(bgo4d ,value="SHOW  Corrected "+MIDDLE  ,font=ft_b_normal)
   bgo4d3 = widget_button(bgo4d ,value="SHOW  Corrected "+HIGH    ,font=ft_b_normal)
   bid    = widget_button(bgo   ,value="-")                                    & widget_control,bid ,sens=0
   bgo5   = widget_button(bgo   ,value="CLEAR RESULTS"      ,font=ft_b_normal)
   bid    = widget_button(bgo   ,value="-")                                    & widget_control,bid ,sens=0

   if Ubm then bstop = widget_button(widget_base(row1), /bitmap,/flat ,value=Pbm+'reset.bmp') $
          else bstop = widget_button(bgo   ,value="STOP!"         ,font=ft_b_normal)
   if Ubm then widget_control,bstop, map=0 ,tooltip='STOP reading Samples in current treated configuration'

  row2    = widget_base(  sbasec,/row)
   sans_sheet_lampies,GETpth=result & if result eq '' then CD,current=result
   
   if (n_elements(g_cal) gt 1) and (n_elements(f_cal) eq 1) then caltxt='  CALIBRATION:'+f_cal $
                                                            else caltxt=' ';(No Calibration file)'
   smess  = widget_label( row2  ,value="Data path: "+result+caltxt,$
                                 xsize=scrX_main,ysize=hrow_main  ,font=ft_b_normal, /dynamic, /align_center)

  widget_control,bclrs0,set_uvalue=[78]          ;Clear ALL
  widget_control,bclrs1,set_uvalue=[10,1,bnsamp] ;Clear ALL cells
  widget_control,bclrs2,set_uvalue=[10,2,bnsamp] ;Clear ALL Sample table cells
  widget_control,bclrs3,set_uvalue=[10,3,bnsamp] ;Clear selected Sample table cells
  widget_control,bclrs4,set_uvalue=[10,4,bnsamp] ;Remove a sample line
  widget_control,bclrs5,set_uvalue=[10,5,bnsamp] ;Insert a sample line
  widget_control,bnsamp,set_uvalue=[10,0,bnsamp] ;Nsamples input
  widget_control,bfill1,set_uvalue=[11,0,bincr]  ;Fill down 0 increment
  widget_control,bfill2,set_uvalue=[11,1,bincr]  ;Fill down 1 increment
  widget_control,bfill3,set_uvalue=[11,2,bincr]  ;Fill down x increment
  widget_control,bload ,set_uvalue=[12,1]        ;Load settings
  widget_control,bsave ,set_uvalue=[12,2]        ;Save
  widget_control,bgrp  ,set_uvalue=[13]          ;Group incr
  widget_control,bgo0  ,set_uvalue=[14,bgrp,0]   ;Treat all
  widget_control,bgo1  ,set_uvalue=[14,bgrp,1]   ;Treat low
  widget_control,bgo2  ,set_uvalue=[14,bgrp,2]   ;Treat middle
  widget_control,bgo3  ,set_uvalue=[14,bgrp,3]   ;Treat high
  widget_control,bidod ,set_uvalue=[14,bgrp,4]   ;Treat to show detector efficiencies
  widget_control,bgo4i ,set_uvalue=[15]          ;Show  result List
  widget_control,bgo4d1,set_uvalue=[56,1]        ;Show  Corrected data low
  widget_control,bgo4d2,set_uvalue=[56,2]        ;Show  Corrected data middle
  widget_control,bgo4d3,set_uvalue=[56,3]        ;Show  Corrected data high
  widget_control,bstop ,set_uvalue=[17,Ubm ]     ;STOP button
  widget_control,bgo5  ,set_uvalue=[16]          ;Clear results

 ;TABLES (...AUTOMATIC CONSTRUCTION...)
 ; ------------------------------------
  j=-1  &  al=1
  while (j lt n_tables-1) do begin & j=j+1 & i=j
   ;LABEL if there
   ; -------------
    if label_s[i] gt '' then begin
       bid=widget_base( sbasec,/row)
       if label_s[i] eq 'mpb' then PUT_Progress, bid, draw=sepPB $
       else lab = widget_label(bid,value=label_s[i],font=ft_b_normal)
    endif
   ;TEXT OF COMMENTS
   ; ---------------
    if comment_s[i] gt '' then begin
       bid=widget_base(sbasec,/row)
       while ((col_row_s[0,j] eq 0) and (j lt n_tables-1)) do j=j+1
       if    ((col_row_s[0,j] ne 0) and (j gt i))        then j=j-1
       tables_id[0,i]= widget_text(  bid,value=comment_s[i:j],scr_xsize=scrX_main-20,ysize=j-i+1,font=ft_propor,/editable)
       if RLcomment[kRLc] gt '' then begin
          widget_control,tables_id[0,i],set_value=RLcomment[kRLc:kRLc+j-i] & kRLc=kRLc+j-i+1 & endif
    endif

   ;TABLES
   ; -----
    if col_row_s[0,j] ne 0 then begin
       bid=widget_base(sbasec,/row)
       c   =col_row_s[0,j]  & r   =col_row_s[1,j] & if uname_s[j] eq "WATER"  then rr=r<2 else rr=r
       scrx=(wcol_main+2)*c & scry=(hrow_main+1)*rr
       nc  =strlen(col_label[0,j])      & nr  =strlen(row_label[0,j])
       nrp =(nr+3.)*wcol_wcar/wcol_main

       if uname_s[j] eq "WATER"  then ag=alW else ag=al ;Alignments
       if uname_s[j] eq "BEAM"   then ag=alB
       if uname_s[j] eq "SAMPLE" then ag=alS

      ;TABLE ROW & COL LABELED
      ; ----------------------
       if (nr gt 0) and (nc gt 0) then begin
          scrx=round(scrx/c *(c +nrp))+labl_spcw
          scry=round(scry/rr*(rr+2.2))+labl_spch ;(+scroll bar + col label)
          if oldV then begin
          tables_id[1,j]= widget_table( bid,xsize=c,ysize=r,column_width=wcol_main,row_height=hrow_main,font=ft_propor,format="(A)" ,$
                                        uname=uname_s[j],alignment=ag,row_labels=row_label[0:r-1,j],column_labels=col_label[0:c-1,j],$
                                       /editable,/context_events,uvalue=[40]) & endif else $
          tables_id[1,j]= widget_table( bid,xsize=c,ysize=r,column_width=wcol_main,row_height=hrow_main,font=ft_propor,format="(A)" ,$
                                        uname=uname_s[j],alignment=ag,row_labels=row_label[0:r-1,j],column_labels=col_label[0:c-1,j],$
                                        background=col_color[*,0:c-1,j],/editable,/context_events,uvalue=[40], /resizeable_columns)
      ;TABLE ROW       LABELED
      ; ----------------------
       endif else if (nr gt 0)    then begin
          scrx=round(scrx/c*(c+nrp))+labl_spcw
          if oldV then begin
          tables_id[1,j]= widget_table( bid,xsize=c,ysize=r,column_width=wcol_main,row_height=hrow_main,font=ft_propor,format="(A)",$
                                        uname=uname_s[j],alignment=ag,row_labels=row_label[0:r-1,j],column_labels='',$
                                       /editable,/context_events,uvalue=[40])
                          widget_control,tables_id[1,j],use_table_select=[-1,-1,-1,-1],row_height=1 & endif else $
          tables_id[1,j]= widget_table( bid,xsize=c,ysize=r,column_width=wcol_main,row_height=hrow_main,font=ft_propor,format="(A)",$
                                        uname=uname_s[j],alignment=ag,row_labels=row_label[0:r-1,j],/no_column_headers,$
                                        background=col_color[*,0:c-1,j],/editable,/context_events,uvalue=[40])

          if c gt 1 then begin & values=strarr(c,r) & values[*,0]='  S'+strtrim(string(indgen(c)+1),2)
                               scry=scry/r*(r+1) ;(+scroll bar)
                               widget_control,tables_id[1,j],set_value=values & endif
      ;TABLE       COL LABELED
      ; ----------------------
       endif else if (nc gt 0)   then begin
          scry=scry/r*(r+1+ux)+labl_spch ;(+col label)
          if r eq 1 then scry=0
          if oldV then begin
          tables_id[1,j]= widget_table( bid,xsize=c,ysize=r,column_width=wcol_main,row_height=hrow_main,font=ft_propor,format="(A)",$
                                        uname=uname_s[j],alignment=ag,column_labels=col_label[0:c-1,j],row_label='',$
                                       /editable,/context_events,uvalue=[40])
                          widget_control,tables_id[1,j],use_table_select=[-1,-1,-1,-1],column_width=1 & endif else $
          tables_id[1,j]= widget_table( bid,xsize=c,ysize=r,column_width=wcol_main,row_height=hrow_main,font=ft_propor,format="(A)",$
                                        uname=uname_s[j],alignment=ag,column_labels=col_label[0:c-1,j],/no_row_headers,$
                                        background=col_color[*,0:c-1,j],/editable,/context_events,uvalue=[40], /resizeable_columns)

          if r gt 1 then begin & values=strarr(c,r) & values[0,*]='  S'+strtrim(string(indgen(r)+1),2)
                               widget_control,tables_id[1,j],set_value=values & endif
      ;TABLE        UN_LABELED
      ; ----------------------
       endif else begin
          tables_id[1,j]= widget_table( bid,xsize=c,ysize=r,column_width=wcol_main,row_height=hrow_main,font=ft_propor,format="(A)",$
                                        uname=uname_s[j],alignment=ag,/no_headers,$
                                       /editable,/context_events,uvalue=[40])
       endelse
       
       widget_control,tables_id[1,j], scr_xsize=scrx<scrX_main , scr_ysize=scry<scrY_maxt
       
       if uname_s[j] eq "WATER"  then if n_elements(RLwater)  gt 1 then widget_control,tables_id[1,j],set_value=RLwater
       if uname_s[j] eq "WATER"  then if not oldV                  then widget_control,tables_id[1,j],editable =editW
       if uname_s[j] eq "WATER"  then if n_elements(waterCW)  gt 1 then widget_control,tables_id[1,j],column_width=waterCW
       
       if uname_s[j] eq "BEAM"   then if n_elements(RLbeam)   gt 1 then widget_control,tables_id[1,j],set_value=RLbeam
       if uname_s[j] eq "BEAM"   then if not oldV                  then widget_control,tables_id[1,j],editable =editB
       if uname_s[j] eq "BEAM"   then if n_elements(beamCW)   gt 1 then widget_control,tables_id[1,j],column_width=beamCW
      
       if uname_s[j] eq "SAMPLE" then if n_elements(RLsample) gt 1 then widget_control,tables_id[1,j],set_value=RLsample
       if uname_s[j] eq "SAMPLE" then if not oldV                  then widget_control,tables_id[1,j],editable =editS
       if uname_s[j] eq "SAMPLE" then if n_elements(sampleCW) gt 1 then widget_control,tables_id[1,j],column_width=sampleCW
       if uname_s[j] eq "SAMPLE" then if (not vertical) then  $
          for k=0L,col_row_s[1,j]-1 do widget_control,tables_id[1,j],use_table_select=[0,k,col_row_s[0,j]-1,k],background=smp_color[*,k]
       if uname_s[j] eq "SAMPLE" then if n_elements(RLsample) gt 1 then $
                                      if vertical                  then widget_control,tables_id[1,j],set_table_select=[1,0,1,0]
    endif
  endwhile

 ;REALIZE
 ; ------
  if n_elements(lamp_b1) ne 1 then lamp_b1=0L & empty
  widget_control  ,sbase0 ,/realize & empty & wait,.1
  if lamp_b1 gt 0L then widget_control  ,sbase0 ,group_leader=lamp_b1
  stri=widget_info(sbase0 ,/geometry)
 ;                            WATER                       BEAM                     SAMPLE ;(or using uname_s)
  idxtab=[where(col_row_s[3,*] eq 1),where(col_row_s[3,*] eq 2),where(col_row_s[3,*] eq 3)]
  unames= uname_s[idxtab]

  sbaset={stri:stri, tids:tables_id, cr_s:col_row_s, Mess:smess, nsampl:ns, idxtab:idxtab, smp_color:smp_color,toggles:toggles,baseSANS:baseSANS,unames:unames,$
          vertical:vertical,bgroup:bgrp,valgrp:float(grpincr),curfile:curfile,SAVpth:savpth,DATApth:datapth,lamp_b1:lamp_b1,instru:instru ,maxns:maxns ,$
          col_label:col_label,row_label:row_label, L:LOW,M:MIDDLE,H:HIGH, input_CELL:[-1,-1] ,  $
          sansref:sansref,equiW:equiW,equiB:equiB,equiS:equiS,curLMH:curLMH, bProgress:sepPB ,  $
          savedLMH:savedLMH, savedCTR:savedCTR, savedTRM:savedTRM, savedSMP:savedSMP, savedFLX:savedFLX}
  widget_control  ,sbase0 ,set_uvalue=sbaset,iconify=0
  
 ;Store topevent in a common and synchronise sans_sheet (alternative Water if restoring!!!)
  sans_sheet_receive,topev={WIDGET_BASE,ID:sbase0,TOP:sbase0,HANDLER:sbase0,X:100,Y:100}, LMH=(["","low","middle","high"])[curLMH]

  if sys_dep('VERSION') ge 5.6 then begin
     widget_control,bfill,Tooltip="Select one starting cell in sample table, verify the increment"
  endif
  xmanager, titgui, sbase0,event_handler='sans_sheet_event',CLEANUP='SANS_SHEET_DYING',/just_reg,/no_block
  widget_control  , sbase0,iconify=0,map=1
  UM_Progress ; Update Memory _ Progress Bar
endif
end
