;** **************************************************************
function fun_gumbel,xinput,sf_new2,i_spectrum
;+
;** **************************************************************
;** On construit la fonction et on convolue par la fonction de resolution
;-

common sc_loc
common sc_lorgau
common sc_convs
common sc_fit
common sc_new

; Here we use the 20 first functions of spherical bessel jl(QR)
; jl(x)=sqrt(!PI/2x)*J(l+0.5)(x)
; J(l+0.5)=BESELJ(X,l+0.5)

qvalue=sy_in[i_spectrum-1]
; -------------------------------------
center=sf_new2[0]
alpha1=sf_new2[1]
alpha2=sf_new2[2]
alpha3=sf_new2[3]
alpha4=sf_new2[4]
ampl=sf_new2[5]

w_resc2_ispe=w_resc2[*,i_spectrum-1]
aamin=aalpha[i_spectrum-1] & aamax=abeta[i_spectrum-1] & ess_conv=w_resc[aamin:aamax,i_spectrum-1] ; REDONDANT ??
falpha=0 & fbeta=nb_channels-1
w_resc2_ispe_all=w_resc[*,i_spectrum-1]

w_to_conv=xinput*0. & w_to_convl=w_to_conv & w_to_convg=w_to_conv
w_to_conv_all=sx_in*0. & w_to_convl_all=w_to_conv_all & w_to_convg_all=w_to_conv_all

w_to_convl=ampl*exp(alpha1*(xinput-center)+alpha2*(xinput-center)^2+alpha3*exp(alpha4*(xinput-center)))
w_to_convl_all=ampl*exp(alpha1*(sx_in-center)+alpha2*(sx_in-center)^2+alpha3*exp(alpha4*(sx_in-center)))
;
; ** Now we do the convolution
; ------------------------------
w_2_fit=convol(w_to_convl,ess_conv,total(ess_conv),/edge_truncate)
w_2_fit_all=convol(w_to_convl_all,ess_conv,total(ess_conv),/edge_truncate)
;
sf_sub_function[i_spectrum-1,*,0]=w_to_convl_all[*]
sf_w_fitted[*,i_spectrum-1]=w_2_fit_all
;
; ** Do the difference exp-th
; ---------------------------
sf_w_exp_fit[*,i_spectrum-1]=sw_in[*,i_spectrum-1]-sf_w_fitted[*,i_spectrum-1]
sf_w_exp_fit_rel[*,i_spectrum-1]=100.*ABS((sw_in[*,i_spectrum-1]-sf_w_fitted[*,i_spectrum-1])/sw_in[*,i_spectrum-1])
return,w_2_fit

end

;** **************************************************************
pro fit_ba_gumbel
;+
;** **************************************************************
;** create the base of the fitting routine for a Lor-Gau fit
;-

@lamp.cbk
common sc_wid
common sc_loc
common sc_flag
common sc_fit
common sc_convs
common sc_new

name_func='GUMBEL'
n_param_1D=6 & n_param_2D=nb_spe_tot*n_param_1D
dimlongtx=3*n_param_1D

; ** Defining the flag for the L and G click box
; ** *******************************************
flag_lfit=0 & flag_gfit=0 & flag_lcfit=0 & flag_gcfit=0 & flag_lwfit=0
flag_gwfit=0 & flag_lifit=0 & flag_gifit=0
flag_dfit=0 & flag_bfit=0 & flag_dcfit=0 & flag_bcfit=0
flag_difit=0 & flag_bifit=0
flag_lgifit=intarr(3)
flag_pl_fit2=not flag_pl_fit2
flag_reverse=0 & flag_fromlast=0 & flag_fit2D=0 & flag_sym=0

; ** Defining the widgetID vectors
; ** *****************************
sw_tx_param=lonarr(dimlongtx)
sw_tx_cstr=lonarr(n_param_1D)


; ** Defining the fit variable vectors
; ** *********************************
sf_index=intarr(nb_spe_tot,n_param_1D)+1 ;& sf_index indicates the fix states of the parameters
lowerb=sf_index*0 & upperb=lowerb & lowerbl=fltarr(nb_spe_tot,n_param_1D) & upperbl=lowerbl;& to indicate eventual parameters limits
sf_tie=strarr(nb_spe_tot,n_param_1D) ;to tie parameters
sf_cstr_write=sf_tie & sf_cstr_write[*,0:4]='1' & sf_cstr_write[*,5]='>0';to record the string value writen by the user into the constrain text box
sf_new_values=fltarr(nb_spe_tot,n_param_1D) & for ii=0,nb_spe_tot-1 do sf_new_values[ii,0]=center_rf[ii]
sf_new_values[0:nb_spe_tot-1,0:4]=0. & sf_new_values[0:nb_spe_tot-1,5]=1.
sf_last_values=fltarr(nb_spe_tot,n_param_1D)
sf_e_values=fltarr(nb_spe_tot,n_param_1D)
sf_sub_function=fltarr(nb_spe_tot,nb_channels,1)
sf_functions_labels=strarr(n_param_1D) & sf_functions_labels2=sf_functions_labels
sf_errors_labels=strarr(n_param_1D) & sf_errors_labels2=sf_errors_labels
chisqr=fltarr(nb_spe_tot)+1.e30

if (xregistered('fit_base') le 0) then begin

; ** Start definition of the widget object
; ** *************************************

; ** Base for the fit
; ** First Base
sw_ba_bot=widget_base(group_leader=sw_ba_leader, /column, $
          Title='Fitted parameters and errors ',$
          resource_name='lamp')

; ** Now do the Lorentzian functions if any

sw_ba_botup1=widget_base(sw_ba_bot,Frame=2,Title='Base botlow left',/column)

sw_ba_botup=widget_base(sw_ba_botup1,/row)
str_il='GUMBEL'
sw_la_lor=widget_label(sw_ba_botup,value=str_il,font=font_smaller,xsize=50,/align_center)
;
str_il='CL'
sw_la_clor=widget_label(sw_ba_botup,value=str_il,font=font_smaller,xsize=30,/align_center);'
sw_tx_param[0]=widget_text(sw_ba_botup,font=font_smaller,value=strcompress(string(center_rf[num_spectrum-1]),/remove_all),/editable,xsize=5,/align_center,uvalue=[6,0,0])
sw_tx_param[1]=widget_text(sw_ba_botup,font=font_smaller,value='0.00',xsize=5,/align_center)
sw_tx_param[2]=widget_text(sw_ba_botup,font=font_smaller,value='0.00',xsize=5,/align_center)
sw_tx_cstr[0]=widget_text(sw_ba_botup,value='1',/editable,xsize=8,/align_center)
;
str_il='a1'
sw_la_wlor=widget_label(sw_ba_botup,value=str_il,font=font_smaller,xsize=30,/align_center);'
sw_tx_param[3]=widget_text(sw_ba_botup,font=font_smaller,value='0.10',/editable,xsize=5,/align_center,uvalue=[6,0,0])
sw_tx_param[4]=widget_text(sw_ba_botup,font=font_smaller,value='0.00',xsize=5,/align_center)
sw_tx_param[5]=widget_text(sw_ba_botup,font=font_smaller,value='0.00',xsize=5,/align_center)
sw_tx_cstr[1]=widget_text(sw_ba_botup,value='1',/editable,xsize=8,/align_center)
;
str_il='a2'
sw_la_ilor=widget_label(sw_ba_botup,value=str_il,font=font_smaller,xsize=30,/align_center);'
sw_tx_param[6]=widget_text(sw_ba_botup,font=font_smaller,value='1.00',/editable,xsize=5,/align_center,uvalue=[6,0,0])
sw_tx_param[7]=widget_text(sw_ba_botup,font=font_smaller,value='0.00',xsize=5,/align_center)
sw_tx_param[8]=widget_text(sw_ba_botup,font=font_smaller,value='0.00',xsize=5,/align_center)
sw_tx_cstr[2]=widget_text(sw_ba_botup,value='1',/editable,xsize=8,/align_center)
sf_functions_labels[0]='Center'
sf_functions_labels[1]='alpha 1'
sf_functions_labels[2]='alpha 2'
sf_errors_labels[0]='with error'
sf_errors_labels[1]='with error'
sf_errors_labels[2]='with error'
sf_functions_labels2[0]='CL'
sf_functions_labels2[1]='a1'
sf_functions_labels2[2]='a2'
sf_errors_labels2[0]='ECL'
sf_errors_labels2[1]='Ea1'
sf_errors_labels2[2]='Ea2'

sw_ba_botup=widget_base(sw_ba_botup1,/row)
str_il='GUMBEL'
sw_la_lor=widget_label(sw_ba_botup,value=str_il,font=font_smaller,xsize=50,/align_center)
;
str_il='a3'
sw_la=widget_label(sw_ba_botup,value=str_il,font=font_smaller,xsize=30,/align_center);'
sw_tx_param[9]=widget_text(sw_ba_botup,font=font_smaller,value='0.00',/editable,xsize=5,/align_center,uvalue=[6,0,0])
sw_tx_param[10]=widget_text(sw_ba_botup,font=font_smaller,value='0.00',xsize=5,/align_center)
sw_tx_param[11]=widget_text(sw_ba_botup,font=font_smaller,value='0.00',xsize=5,/align_center)
sw_tx_cstr[3]=widget_text(sw_ba_botup,value='1',/editable,xsize=8,/align_center)

str_il='a4'
sw_la=widget_label(sw_ba_botup,value=str_il,font=font_smaller,xsize=30,/align_center);'
sw_tx_param[12]=widget_text(sw_ba_botup,font=font_smaller,value='0.00',/editable,xsize=5,/align_center,uvalue=[6,0,0])
sw_tx_param[13]=widget_text(sw_ba_botup,font=font_smaller,value='0.00',xsize=5,/align_center)
sw_tx_param[14]=widget_text(sw_ba_botup,font=font_smaller,value='0.00',xsize=5,/align_center)
sw_tx_cstr[4]=widget_text(sw_ba_botup,value='1',/editable,xsize=8,/align_center)

;
str_il='Am'
sw_la_wlor=widget_label(sw_ba_botup,value=str_il,font=font_smaller,xsize=30,/align_center);'
sw_tx_param[15]=widget_text(sw_ba_botup,font=font_smaller,value='1.00',/editable,xsize=5,/align_center,uvalue=[6,0,0])
sw_tx_param[16]=widget_text(sw_ba_botup,font=font_smaller,value='0.00',xsize=5,/align_center)
sw_tx_param[17]=widget_text(sw_ba_botup,font=font_smaller,value='0.00',xsize=5,/align_center)
sw_tx_cstr[5]=widget_text(sw_ba_botup,value='1',/editable,xsize=8,/align_center)
;
sf_functions_labels[3]='alpha 3'
sf_functions_labels[4]='alpha 4'
sf_functions_labels[5]='Amplitude factor'
sf_errors_labels[3]='with error'
sf_errors_labels[4]='with error'
sf_errors_labels[5]='with error'
sf_functions_labels2[3]='a3'
sf_functions_labels2[4]='a4'
sf_functions_labels2[5]='Am'
sf_errors_labels2[3]='Ea3'
sf_errors_labels2[4]='Ea4'
sf_errors_labels2[5]='EAm'

; ** Insert the "Try without fitting" button and "fitALL" chekbox
; ** *************************************************************
sw_ba_botlow=widget_base(sw_ba_bot,Frame=2,Title='Base bot right',/column)
sw_ba_c1=widget_base(sw_ba_botlow,/row)
sw_bu_try=widget_button(sw_ba_c1,Font=ft_b_smaller,Frame=1,value='Try and enter',uvalue=[6,0,0])
sw_ba_cb1=widget_base(sw_ba_c1,Title='Fit box2',/nonexclusive,/align_center,/row)
sw_bu_fitall=widget_button(sw_ba_cb1,value=' fit all Sp?',uvalue=[6,2,1],/align_center)
sw_bu_reverse=widget_button(sw_ba_cb1,value=' reverse?',uvalue=[6,2,3],/align_center,sensitive=0)
sw_bu_fromlast=widget_button(sw_ba_cb1,value=' from last?',uvalue=[6,2,4],/align_center,sensitive=0)
sw_bu_fit2D=widget_button(sw_ba_cb1,value=' fit 2D?',uvalue=[6,2,6],/align_center)

; ** Insert the "Acquire from Sp#" button and "Sp#" textbox and symetrization possibility
; ** *************************************************************************************
sw_ba_c1=widget_base(sw_ba_botlow,/row)
sw_bu_acquire=widget_button(sw_ba_c1,Font=ft_b_smaller,Frame=1,value='Acquire from Sp#',uvalue=[6,2,2])
sw_tx_acquire=widget_text(sw_ba_c1,font=font_smaller,value=' 1',/editable,xsize=3,/align_center,uvalue=[6,2,2])
sw_bu_giveall=widget_button(sw_ba_c1,Font=ft_b_smaller,Frame=1,value='Give to All',uvalue=[6,2,7])
sw_tx_give=widget_text(sw_ba_c1,font=font_smaller,value=' All',/editable,xsize=7,/align_center,uvalue=[6,2,7])
sw_ba_cb1=widget_base(sw_ba_c1,Title='Fit box1',/nonexclusive,/align_center)
sw_bu_symsqw=widget_button(sw_ba_cb1,value='Sym.S(Q,w)?',/align_center,uvalue=[6,2,5])
sw_tx_temp=widget_text(sw_ba_c1,font=font_smaller,value=' 0',/editable,xsize=7,/align_center,sensitive=0)
sw_la_temp=widget_label(sw_ba_c1,value='K',font=font_smaller,xsize=10,/align_center)
;
;
; ** Realization of the Base
widget_control, sw_ba_bot, /Realize; & put_logo
xmanager,'qens_fit',sw_ba_bot,/just_reg

; ** Set the FIT and DONE button sensitive:
widget_control,sw_bu_fit, sensitive=1
widget_control,sw_bu_done, sensitive=1

endif

end

