;** **************************************************************
function fun_mark,xinput,sf_new2,i_spectrum,w40
;+
;** **************************************************************
;** On construit la fonction et on convolue par la fonction de resolution
;-
common sc_loc
common sc_lorgau
common sc_convs
common sc_fit
common sc_new
;___________________________________________________________
; model for two rotation and one long range translation
; rotations R1 and R2, DR1, DR2
; translation L
; purely elastic part, background, Debye Waller
; 13 parameters
; ---------------------------------------------------------

print, '*********************** This is the server version !!!!!!!!!!!!!!!!!!!!!!!!!!!!'
; Here we use the 20 first functions of spherical bessel jl(QR)
; jl(x)=sqrt(!PI/2x)*J(l+0.5)(x)
; J(l+0.5)=BESELJ(X,l+0.5)

qvalue=sy_in[i_spectrum-1]
; -------------------------------------
Ar1 = sf_new2[0]   ; amplitude of the first rotation
radius1 = sf_new2[1] ; radius of the first rotation
Dr1 = sf_new2[2]   ; diffucion constant of the first rotation
Ar2 = sf_new2[3]   ; amplitude of the second rotation
radius2 = sf_new2[4] ; radius of the second rotation
Dr2 = sf_new2[5]   ; diffucion constant of the second rotation
DL = sf_new2[6]   ; diffusion constant for translatin
u2 = sf_new2[7]   ; amplitude of mean square displacements
As = sf_new2[12]    ; amplitude of solvent subtracted
; -------------------------------------
dcenter=sf_new2[8] & dint=sf_new2[9] ; center of delta function is taken for the center of other function TOO.
; -------------------------------------
slope=sf_new2[10] & const=sf_new2[11]
; -------------------------------------

w_resc2_ispe=w_resc2[*,i_spectrum-1]
aamin=aalpha[i_spectrum-1] & aamax=abeta[i_spectrum-1] & ess_conv=w_resc[aamin:aamax,i_spectrum-1] ; REDONDANT ??
falpha=0 & fbeta=nb_channels-1
w_resc2_ispe_all=w_resc[*,i_spectrum-1]

w_to_conv=xinput*0. & w_to_convl=w_to_conv & w_to_convg=w_to_conv
w_to_conv_all=sx_in*0. & w_to_convl_all=w_to_conv_all & w_to_convg_all=w_to_conv_all


;FIRST ROTATION
; ** Do the sum over the bessel function for first rotation
; ---------------------------------------------------
for il=1,19 do begin
width=il*(il+1)*Dr1+DL*qvalue^2
lor_to_add=n_lorentz(xinput,dcenter,width)
lor_to_add_all=n_lorentz(sx_in,dcenter,width)
ind_lor_0=where(lor_to_add ge 1e-10,nn)
if (nn le 7) and (width le 1e-3) then begin
lor_to_add=0.
lor_to_add_all=0.
                print,'**WARNING: Lorentzian has less than 7 points ne 0 ... treat it as a delta function'
                print,'Parameter # IL is an integrated intensity (no more an amplitude)'
                x_interp=xinput+dcenter & x_interp_all=sx_in+dcenter
                lor_to_add=spline(x_interp,w_resc2_ispe,xinput) & lor_to_add_all=spline(x_interp_all,w_resc2_ispe_all,sx_in)
endif
w_to_convl=w_to_convl+lor_to_add*((sph_beselj(qvalue*radius1,il))^2)*(2*il+1)
w_to_convl_all=w_to_convl_all+lor_to_add_all*((sph_beselj(qvalue*radius1,il))^2)*(2*il+1)
endfor
;
;; ** Now we deal with the elastic part of the model
; --------------------------------------------------------
width=DL*qvalue^2
ela_part=((sph_beselj(qvalue*radius1,0))^2)*n_lorentz(xinput,dcenter,width)
ela_part_all=((sph_beselj(qvalue*radius1,0))^2)*n_lorentz(sx_in,dcenter,width)
;ela_part=((sph_beselj(qvalue*radius1,0))^2)
;ela_part_all=((sph_beselj(qvalue*radius1,0))^2)
; ** Now we multiply this term by the Debye-Waller factor and amplitude
; ** exp(-(qvalue^2*u^2)/3)
; -------------------------------------------------------
w_to_convl=(w_to_convl+ela_part)*exp(-(qvalue^2*u2)/3)*Ar1
w_to_convl_all=(w_to_convl_all+ela_part_all)*exp(-(qvalue^2*u2)/3)*Ar1
;
; ** calculate the subfunction
; ------------------------------
w_2_fit_all=convol(w_to_convl_all,ess_conv,total(ess_conv),/edge_truncate)

sf_sub_function[i_spectrum-1,*,0]=w_2_fit_all

w_temp=w_to_convl
w_temp_all=w_to_convl_all

;SECOND ROTATION
; ** Do the sum over the bessel function for first rotation
; ---------------------------------------------------
w_to_conv=xinput*0. & w_to_convl=w_to_conv & w_to_convg=w_to_conv
w_to_conv_all=sx_in*0. & w_to_convl_all=w_to_conv_all & w_to_convg_all=w_to_conv_all

for il=1,19 do begin
width=il*(il+1)*Dr2+DL*qvalue^2
lor_to_add=n_lorentz(xinput,dcenter,width)
lor_to_add_all=n_lorentz(sx_in,dcenter,width)
ind_lor_0=where(lor_to_add ge 1e-10,nn)
if (nn le 7) and (width le 1e-3) then begin
lor_to_add=0.
lor_to_add_all=0.
                print,'**WARNING: Lorentzian has less than 7 points ne 0 ... treat it as a delta function'
             print,'Parameter # IL is an integrated intensity (no more an amplitude)'
                x_interp=xinput+dcenter & x_interp_all=sx_in+dcenter
                lor_to_add=spline(x_interp,w_resc2_ispe,xinput) & lor_to_add_all=spline(x_interp_all,w_resc2_ispe_all,sx_in)
endif
w_to_convl=w_to_convl+lor_to_add*((sph_beselj(qvalue*radius2,il))^2)*(2*il+1)
w_to_convl_all=w_to_convl_all+lor_to_add_all*((sph_beselj(qvalue*radius2,il))^2)*(2*il+1)
endfor

;; ** Now we deal with the elastic part of the model
; --------------------------------------------------------
width=DL*qvalue^2
ela_part=((sph_beselj(qvalue*radius1,0))^2)*n_lorentz(xinput,dcenter,width)
ela_part_all=((sph_beselj(qvalue*radius1,0))^2)*n_lorentz(sx_in,dcenter,width)

; ** Now we multiply this term by the Debye-Waller factor and amplitude
; ** exp(-(qvalue^2*u^2)/3)
; -------------------------------------------------------
w_to_convl=(w_to_convl+ela_part)*exp(-(qvalue^2*u2)/3)*Ar2
w_to_convl_all=(w_to_convl_all+ela_part_all)*exp(-(qvalue^2*u2)/3)*Ar2
;
; ** calculate the subfunction
; ------------------------------
;w_2_fit=convol(w_to_convl,ess_conv,total(ess_conv),/edge_truncate)
w_2_fit_all=convol(w_to_convl_all,ess_conv,total(ess_conv),/edge_truncate)
;
sf_sub_function[i_spectrum-1,*,1]=w_2_fit_all

; ** Now the convolution
; ------------------------------
w_to_convl=w_to_convl+w_temp
w_to_convl_all=w_to_conv_all+w_temp_all

w_2_fit=convol(w_to_convl,ess_conv,total(ess_conv),/edge_truncate)
w_2_fit_all=convol(w_to_convl_all,ess_conv,total(ess_conv),/edge_truncate)

; ** Subtract off part of the solvent
; -----------------------------------
;w_2_fit=w_2_fit+As*w40
;w_2_fit_all=w_2_fit_all+As*w40


; ** Now deal with the background
; --------------------------------
sf_sub_function[i_spectrum-1,*,3]=slope*sx_in[*]+const
w_2_fit=w_2_fit+slope*xinput+const
w_2_fit_all=w_2_fit_all+slope*sx_in+const
;
; ** ... and multiply by the temperature factor in case of symetric data (detailed balance factor)
; ------------------------------------------------------------------------------------------------
w_2_fit=w_2_fit*exp(0.5*betatemp*xinput)
w_2_fit_all=w_2_fit_all*exp(0.5*betatemp*sx_in)
;
; ** Now deal with the elastic line
; ---------------------------------
x_interp=xinput+dcenter & x_interp_all=sx_in+dcenter
w_resc2_interp=spline(x_interp,w_resc2_ispe,xinput) & w_resc2_interp_all=spline(x_interp_all,w_resc2_ispe_all,sx_in)
w_2_fit=w_2_fit+dint*w_resc2_interp
w_2_fit_all=w_2_fit_all+dint*w_resc2_interp_all
sf_sub_function[i_spectrum-1,*,2]=dint*w_resc2_interp_all[*]
sf_w_fitted[*,i_spectrum-1]=w_2_fit_all
;
; ** Do the difference exp-th
; ---------------------------
sf_w_exp_fit[*,i_spectrum-1]=sw_in[*,i_spectrum-1]-sf_w_fitted[*,i_spectrum-1]
sf_w_exp_fit_rel[*,i_spectrum-1]=100.*ABS((sw_in[*,i_spectrum-1]-sf_w_fitted[*,i_spectrum-1])/sw_in[*,i_spectrum-1])
return,w_2_fit

end

;** **************************************************************
pro fit_ba_mark
;+
;** **************************************************************
;** create the base of the fitting routine for a Lor-Gau fit
;-

@lamp.cbk
common sc_wid
common sc_loc
common sc_flag
common sc_fit
common sc_convs

name_func='MARK_MODEL'
n_param_1D=14 & n_param_2D=nb_spe_tot*n_param_1D

; ** Defining the flag for the L and G click box
; ** *******************************************
flag_lfit=0 & flag_gfit=0 & flag_lcfit=0 & flag_gcfit=0 & flag_lwfit=0
flag_gwfit=0 & flag_lifit=0 & flag_gifit=0
flag_dfit=0 & flag_bfit=0 & flag_dcfit=0 & flag_bcfit=0
flag_difit=0 & flag_bifit=0
flag_lgifit=intarr(3)
flag_pl_fit2=not flag_pl_fit2
flag_reverse=0 & flag_fromlast=0 & flag_fit2D=0 & flag_sym=0

; ** Defining the widgetID vectors
; ** *****************************
dimlongtx=36
sw_tx_param=lonarr(dimlongtx)
sw_tx_cstr=lonarr(n_param_1D)


; ** Defining the fit variable vectors
; ** *********************************
sf_index=intarr(nb_spe_tot,n_param_1D)+1 ;& sf_index indicates the fix states of the parameters
lowerb=sf_index*0 & upperb=lowerb & lowerbl=fltarr(nb_spe_tot,n_param_1D) & upperbl=lowerbl;& to indicate eventual parameters limits
sf_tie=strarr(nb_spe_tot,n_param_1D) ;to tie parameters
sf_cstr_write=sf_tie & sf_cstr_write[*,[0,5,7]]='1' & sf_cstr_write[*,[1,2,3,4,6,8]]='>0';to record the string value writen by the user into the constrain text box
sf_new_values=fltarr(nb_spe_tot,n_param_1D) & for ii=0,nb_spe_tot-1 do sf_new_values[ii,0]=center_rf[ii]
sf_new_values[0:nb_spe_tot-1,1]=0.1 & sf_new_values[0:nb_spe_tot-1,2]=1.
sf_new_values[0:nb_spe_tot-1,3:7]=0. & sf_new_values[0:nb_spe_tot-1,4]=1.
sf_last_values=fltarr(nb_spe_tot,n_param_1D)
sf_e_values=fltarr(nb_spe_tot,n_param_1D)
sf_sub_function=fltarr(nb_spe_tot,nb_channels,4)
sf_functions_labels=strarr(n_param_1D) & sf_functions_labels2=sf_functions_labels
sf_errors_labels=strarr(n_param_1D) & sf_errors_labels2=sf_errors_labels
chisqr=fltarr(nb_spe_tot)+1.e30

if (xregistered('fit_base') le 0) then begin

; ** Start definition of the widget object
; ** *************************************

; ** Base for the fit
; ** First Base
sw_ba_bot=widget_base(group_leader=sw_ba_leader, /column, $
          Title='Fitted parameters and errors ',$
          resource_name='lamp')

; ** Parameters for rot 1
sw_ba_botup1=widget_base(sw_ba_bot,Frame=2,Title='Base botlow left',/column)

sw_ba_botup=widget_base(sw_ba_botup1,/row)
str_il='Rot 1'
sw_la_lor=widget_label(sw_ba_botup,value=str_il,font=font_smaller,xsize=50,/align_center)
;
str_il='Amp1'
sw_la_clor=widget_label(sw_ba_botup,value=str_il,font=font_smaller,xsize=30,/align_center);'
sw_tx_param[0]=widget_text(sw_ba_botup,font=font_smaller,value='0.10',/editable,xsize=5,/align_center,uvalue=[6,0,0])
sw_tx_param[1]=widget_text(sw_ba_botup,font=font_smaller,value='0.00',xsize=5,/align_center)
sw_tx_param[2]=widget_text(sw_ba_botup,font=font_smaller,value='0.00',xsize=5,/align_center)
sw_tx_cstr[0]=widget_text(sw_ba_botup,value='1',/editable,xsize=8,/align_center)
;
str_il='Rg1'
sw_la_wlor=widget_label(sw_ba_botup,value=str_il,font=font_smaller,xsize=30,/align_center);'
sw_tx_param[3]=widget_text(sw_ba_botup,font=font_smaller,value='0.10',/editable,xsize=5,/align_center,uvalue=[6,0,0])
sw_tx_param[4]=widget_text(sw_ba_botup,font=font_smaller,value='0.00',xsize=5,/align_center)
sw_tx_param[5]=widget_text(sw_ba_botup,font=font_smaller,value='0.00',xsize=5,/align_center)
sw_tx_cstr[1]=widget_text(sw_ba_botup,value='>0',/editable,xsize=8,/align_center)
;
str_il='Dr1'
sw_la_ilor=widget_label(sw_ba_botup,value=str_il,font=font_smaller,xsize=30,/align_center);'
sw_tx_param[6]=widget_text(sw_ba_botup,font=font_smaller,value='1.00',/editable,xsize=5,/align_center,uvalue=[6,0,0])
sw_tx_param[7]=widget_text(sw_ba_botup,font=font_smaller,value='0.00',xsize=5,/align_center)
sw_tx_param[8]=widget_text(sw_ba_botup,font=font_smaller,value='0.00',xsize=5,/align_center)
sw_tx_cstr[2]=widget_text(sw_ba_botup,value='>0',/editable,xsize=8,/align_center)
sf_functions_labels[0]='Amplitude rotation 1'
sf_functions_labels[1]='Gyration radius (A�) for rotation 1'
sf_functions_labels[2]='Rotational diffusion constant 1'
sf_errors_labels[0]='with error'
sf_errors_labels[1]='with error'
sf_errors_labels[2]='with error'
sf_functions_labels2[0]='Amp1'
sf_functions_labels2[1]='Rg1'
sf_functions_labels2[2]='Dr1'
sf_errors_labels2[0]='EAmp1'
sf_errors_labels2[1]='ERg1'
sf_errors_labels2[2]='EDr1'

; ** Parameters for rot 2

sw_ba_botup=widget_base(sw_ba_botup1,/row)
str_il='Rot 2'
sw_la_lor=widget_label(sw_ba_botup,value=str_il,font=font_smaller,xsize=50,/align_center)

str_il='Amp2'
sw_la_clor=widget_label(sw_ba_botup,value=str_il,font=font_smaller,xsize=30,/align_center);'
sw_tx_param[9]=widget_text(sw_ba_botup,font=font_smaller,value='0.10',/editable,xsize=5,/align_center,uvalue=[6,0,0])
sw_tx_param[10]=widget_text(sw_ba_botup,font=font_smaller,value='0.00',xsize=5,/align_center)
sw_tx_param[11]=widget_text(sw_ba_botup,font=font_smaller,value='0.00',xsize=5,/align_center)
sw_tx_cstr[3]=widget_text(sw_ba_botup,value='1',/editable,xsize=8,/align_center)
;
str_il='Rg2'
sw_la_wlor=widget_label(sw_ba_botup,value=str_il,font=font_smaller,xsize=30,/align_center);'
sw_tx_param[12]=widget_text(sw_ba_botup,font=font_smaller,value='0.10',/editable,xsize=5,/align_center,uvalue=[6,0,0])
sw_tx_param[13]=widget_text(sw_ba_botup,font=font_smaller,value='0.00',xsize=5,/align_center)
sw_tx_param[14]=widget_text(sw_ba_botup,font=font_smaller,value='0.00',xsize=5,/align_center)
sw_tx_cstr[4]=widget_text(sw_ba_botup,value='>0',/editable,xsize=8,/align_center)
;
str_il='Dr2'
sw_la_ilor=widget_label(sw_ba_botup,value=str_il,font=font_smaller,xsize=30,/align_center);'
sw_tx_param[15]=widget_text(sw_ba_botup,font=font_smaller,value='1.00',/editable,xsize=5,/align_center,uvalue=[6,0,0])
sw_tx_param[16]=widget_text(sw_ba_botup,font=font_smaller,value='0.00',xsize=5,/align_center)
sw_tx_param[17]=widget_text(sw_ba_botup,font=font_smaller,value='0.00',xsize=5,/align_center)
sw_tx_cstr[5]=widget_text(sw_ba_botup,value='>0',/editable,xsize=8,/align_center)

sf_functions_labels[3]='Amplitude rotation 2'
sf_functions_labels[4]='Gyration radius (A�) for rotation 2'
sf_functions_labels[5]='Rotational diffusion constant 2'
sf_errors_labels[3]='with error'
sf_errors_labels[4]='with error'
sf_errors_labels[5]='with error'
sf_functions_labels2[3]='Amp2'
sf_functions_labels2[4]='Rg2'
sf_functions_labels2[5]='Dr2'
sf_errors_labels2[3]='EAmp2'
sf_errors_labels2[4]='ERg2'
sf_errors_labels2[5]='EDr2'

sw_ba_botup=widget_base(sw_ba_botup1,/row)
str_il='DL & u2'
sw_la_lor=widget_label(sw_ba_botup,value=str_il,font=font_smaller,xsize=50,/align_center)
;
str_il='DL'
sw_la=widget_label(sw_ba_botup,value=str_il,font=font_smaller,xsize=30,/align_center);'
sw_tx_param[18]=widget_text(sw_ba_botup,font=font_smaller,value='0.00',/editable,xsize=5,/align_center,uvalue=[6,0,0])
sw_tx_param[19]=widget_text(sw_ba_botup,font=font_smaller,value='0.00',xsize=5,/align_center)
sw_tx_param[20]=widget_text(sw_ba_botup,font=font_smaller,value='0.00',xsize=5,/align_center)
sw_tx_cstr[6]=widget_text(sw_ba_botup,value='>0',/editable,xsize=8,/align_center)
;
str_il='u2'
sw_la_wlor=widget_label(sw_ba_botup,value=str_il,font=font_smaller,xsize=30,/align_center);'
sw_tx_param[21]=widget_text(sw_ba_botup,font=font_smaller,value='0.10',/editable,xsize=5,/align_center,uvalue=[6,0,0])
sw_tx_param[22]=widget_text(sw_ba_botup,font=font_smaller,value='0.00',xsize=5,/align_center)
sw_tx_param[23]=widget_text(sw_ba_botup,font=font_smaller,value='0.00',xsize=5,/align_center)
sw_tx_cstr[7]=widget_text(sw_ba_botup,value='>0',/editable,xsize=8,/align_center)
;
sf_functions_labels[6]='translational diffusion constant'
sf_functions_labels[7]='Mean square displacement'
sf_errors_labels[6]='with error'
sf_errors_labels[7]='with error'
sf_functions_labels2[6]='DL'
sf_functions_labels2[7]='u2'
sf_errors_labels2[6]='EDL'
sf_errors_labels2[7]='Eu2'


; ** The Delta function
; ** ********************************
sw_ba_botlow=widget_base(sw_ba_bot,Frame=2,Title='Base bot right',/column)
idmin=8
idmintx=24

sw_ba_c1=widget_base(sw_ba_botlow,/row)
;
sw_la_del=widget_label(sw_ba_c1,value='D ',font=font_smaller,/align_center,xsize=50)
;
sw_la_cdel=widget_label(sw_ba_c1,value='CD',font=font_smaller,xsize=30,/align_center)
sw_tx_param[idmintx]=widget_text(sw_ba_c1,font=font_smaller,value='0.00',/editable,xsize=5,/align_center,uvalue=[6,0,0])
sw_tx_param[idmintx+1]=widget_text(sw_ba_c1,font=font_smaller,value='0.00',xsize=5,/align_center)
sw_tx_param[idmintx+2]=widget_text(sw_ba_c1,font=font_smaller,value='0.00',xsize=5,/align_center)
sw_tx_cstr[idmin]=widget_text(sw_ba_c1,value='1',/editable,xsize=8,/align_center)

sw_la_idel=widget_label(sw_ba_c1,value='ID',font=font_smaller,xsize=30,/align_center)
sw_tx_param[idmintx+3]=widget_text(sw_ba_c1,font=font_smaller,value='1.00',/editable,xsize=5,/align_center,uvalue=[6,0,0])
sw_tx_param[idmintx+4]=widget_text(sw_ba_c1,font=font_smaller,value='0.00',xsize=5,/align_center)
sw_tx_param[idmintx+5]=widget_text(sw_ba_c1,font=font_smaller,value='0.00',xsize=5,/align_center)
sw_tx_cstr[idmin+1]=widget_text(sw_ba_c1,value='>0',/editable,xsize=8,/align_center)

sf_functions_labels[idmin]='Center value for Delta'
sf_functions_labels[idmin+1]='Intensity value for Delta'
sf_errors_labels[idmin]='with error'
sf_errors_labels[idmin+1]='with error'
sf_functions_labels2[idmin]='CD'
sf_functions_labels2[idmin+1]='ID'
sf_errors_labels2[idmin]='ECD'
sf_errors_labels2[idmin+1]='EID'

; ** Now the slopping background
; ** *************************************************
ibmin=idmin+2
ibmintx=idmintx+6

sw_ba_c1=widget_base(sw_ba_botlow,/row)
;
sw_la_bac=widget_label(sw_ba_c1,value='B ',font=font_smaller,/align_center,xsize=50)
;
sw_la_sbac=widget_label(sw_ba_c1,value='SB',font=font_smaller,xsize=30,/align_center)
sw_tx_param[ibmintx]=widget_text(sw_ba_c1,font=font_smaller,value='0.00',/editable,xsize=5,/align_center,uvalue=[6,0,0])
sw_tx_param[ibmintx+1]=widget_text(sw_ba_c1,font=font_smaller,value='0.00',xsize=5,/align_center)
sw_tx_param[ibmintx+2]=widget_text(sw_ba_c1,font=font_smaller,value='0.00',xsize=5,/align_center)
sw_tx_cstr[ibmin]=widget_text(sw_ba_c1,value='1',/editable,xsize=8,/align_center)

sw_la_idel=widget_label(sw_ba_c1,value='CB',font=font_smaller,xsize=30,/align_center)
sw_tx_param[ibmintx+3]=widget_text(sw_ba_c1,font=font_smaller,value='0.00',/editable,xsize=5,/align_center,uvalue=[6,0,0])
sw_tx_param[ibmintx+4]=widget_text(sw_ba_c1,font=font_smaller,value='0.00',xsize=5,/align_center)
sw_tx_param[ibmintx+5]=widget_text(sw_ba_c1,font=font_smaller,value='0.00',xsize=5,/align_center)
sw_tx_cstr[ibmin+1]=widget_text(sw_ba_c1,value='>0',/editable,xsize=8,/align_center)

sf_functions_labels[ibmin]='Slope value for Backg'
sf_functions_labels[ibmin+1]='Constant value for Backg'
sf_errors_labels[ibmin]='with error'
sf_errors_labels[ibmin+1]='with error'
sf_functions_labels2[ibmin]='SB'
sf_functions_labels2[ibmin+1]='CB'
sf_errors_labels2[ibmin]='ESB'
sf_errors_labels2[ibmin+1]='ECB'

; ** The Solvent amplitude
; ** ********************************
sw_ba_botlow=widget_base(sw_ba_bot,Frame=2,Title='Base bot right',/column)
idmin=12
idmintx=24

sw_ba_c1=widget_base(sw_ba_botlow,/row)
;
sw_la_del=widget_label(sw_ba_c1,value='Solvent',font=font_smaller,/align_center,xsize=50)
;

sw_la_idel=widget_label(sw_ba_c1,value='As',font=font_smaller,xsize=30,/align_center)
sw_tx_param[idmintx+3]=widget_text(sw_ba_c1,font=font_smaller,value='1.00',/editable,xsize=5,/align_center,uvalue=[6,0,0])
sw_tx_param[idmintx+4]=widget_text(sw_ba_c1,font=font_smaller,value='0.00',xsize=5,/align_center)
sw_tx_param[idmintx+5]=widget_text(sw_ba_c1,font=font_smaller,value='0.00',xsize=5,/align_center)
sw_tx_cstr[idmin+1]=widget_text(sw_ba_c1,value='>0',/editable,xsize=8,/align_center)

sf_functions_labels[idmin]='Solvent Subtraction ampiltude'
sf_errors_labels[idmin]='with error'
sf_functions_labels2[idmin]='As'
sf_errors_labels2[idmin]='EAs'

; ** Insert the "Try without fitting" button and "fitALL" chekbox
; ** *************************************************************
sw_ba_botlow=widget_base(sw_ba_bot,Frame=2,Title='Base bot right',/column)
sw_ba_c1=widget_base(sw_ba_botlow,/row)
sw_bu_try=widget_button(sw_ba_c1,Font=ft_b_smaller,Frame=1,value='Try and enter',uvalue=[6,0,0])
sw_ba_cb1=widget_base(sw_ba_c1,Title='Fit box2',/nonexclusive,/align_center,/row)
sw_bu_fitall=widget_button(sw_ba_cb1,value=' fit all Sp?',uvalue=[6,2,1],/align_center)
sw_bu_reverse=widget_button(sw_ba_cb1,value=' reverse?',uvalue=[6,2,3],/align_center,sensitive=0)
sw_bu_fromlast=widget_button(sw_ba_cb1,value=' from last?',uvalue=[6,2,4],/align_center,sensitive=0)
sw_bu_fit2D=widget_button(sw_ba_cb1,value=' fit 2D?',uvalue=[6,2,6],/align_center)

; ** Insert the "Acquire from Sp#" button and "Sp#" textbox and symetrization possibility
; ** *************************************************************************************
sw_ba_c1=widget_base(sw_ba_botlow,/row)
sw_bu_acquire=widget_button(sw_ba_c1,Font=ft_b_smaller,Frame=1,value='Acquire from Sp#',uvalue=[6,2,2])
sw_tx_acquire=widget_text(sw_ba_c1,font=font_smaller,value=' 1',/editable,xsize=3,/align_center,uvalue=[6,2,2])
sw_bu_giveall=widget_button(sw_ba_c1,Font=ft_b_smaller,Frame=1,value='Give to All',uvalue=[6,2,7])
sw_tx_give=widget_text(sw_ba_c1,font=font_smaller,value=' All',/editable,xsize=7,/align_center,uvalue=[6,2,7])
sw_ba_cb1=widget_base(sw_ba_c1,Title='Fit box1',/nonexclusive,/align_center)
sw_bu_symsqw=widget_button(sw_ba_cb1,value='Sym.S(Q,w)?',/align_center,uvalue=[6,2,5])
sw_tx_temp=widget_text(sw_ba_c1,font=font_smaller,value=' 0',/editable,xsize=7,/align_center,sensitive=0)
sw_la_temp=widget_label(sw_ba_c1,value='K',font=font_smaller,xsize=10,/align_center)
;
;
;
; ** Realization of the Base
widget_control, sw_ba_bot, /Realize; & put_logo
xmanager,'qens_fit',sw_ba_bot,/just_reg

; ** Set the FIT and DONE button sensitive:
widget_control,sw_bu_fit, sensitive=1
widget_control,sw_bu_done, sensitive=1

endif

end

