;** **************************************************************
function fun_userdefined,xinput,sf_new2,i_spectrum
;+
;** **************************************************************
;** On construit la fonction et on convolue par la fonction de resolution
;-
common sc_loc
common sc_lorgau
common sc_convs
common sc_fit
common sc_userfunction
common sc_new

; -- Recuperation des valeurs des parametres et initialisation des arrays
;; -- --------------------------------------------------------------------------------
; -- Q vector value
qvalue=sy_in[i_spectrum-1] & u2=0. ; U2=0 at the moment (no Debye-Waller modulation for the moment)
ampl=1. ; ampl is a real number multiplying the overall model function ... fixed for the moment
; -------------------------------------
; -- Delta function parameters
dcenter=sf_new2[n_param_1D-4] & dint=sf_new2[n_param_1D-3]
; -------------------------------------
; -- Sloping Bkgd parameters
slope=sf_new2[n_param_1D-2] & const=sf_new2[n_param_1D-1]
; -------------------------------------
; -- Array initialization and res. function treatment
w_resc2_ispe=w_resc2[*,i_spectrum-1]
aamin=aalpha[i_spectrum-1] & aamax=abeta[i_spectrum-1] & ess_conv=w_resc[aamin:aamax,i_spectrum-1] ; REDONDANT ??
falpha=0 & fbeta=nb_channels-1
w_resc2_ispe_all=w_resc[*,i_spectrum-1]
;
w_to_conv=xinput*0. & w_to_convl=w_to_conv & w_to_convg=w_to_conv & w_to_convdho=w_to_conv & w_to_convsexp=w_to_conv & w_to_convform=w_to_conv
w_to_conv_all=sx_in*0. & w_to_convl_all=w_to_conv_all & w_to_convg_all=w_to_conv_all & w_to_convdho_all=w_to_conv_all & w_to_convsexp_all=w_to_conv_all
w_to_convform_all=w_to_conv_all
;
; -- --------------------------------------------------------------------------------
; -- Do the function model
; -- --------------------------------------------------------------------------------
nlortz=0 & ngauss=0 & nndho=0 & & nnsexp=0 & nformula=0 & indpar=0 & nlordq2=0
nmagnsc=0
for ifunc=0,nb_subfunctions-1 do begin
CASE User_Modl.name[ifunc] of
'Lorentz':begin
nlortz=nlortz+1
center=sf_new2[indpar] & width=sf_new2[indpar+1] & amplitude=sf_new2[indpar+2]
lor_to_add=ampl*qlorentz(xinput,center,width,amplitude)
lor_to_add_all=ampl*qlorentz(sx_in,center,width,amplitude)
ind_lor_0=where(lor_to_add ge 1e-10,nn)
if (nn le 7) and (width le 1e-3) then begin
lor_to_add=0.
lor_to_add_all=0.
                print,'**WARNING: Lorentzian #',nlortz,' has less than 7 points ne 0 ... treat it as a delta function'
                print,'Parameter # IL is an INTEGRATED INTENSITY (no more an amplitude)'
                x_interp=xinput+dcenter & x_interp_all=sx_in+dcenter
                lor_to_add=ampl*spline(x_interp,w_resc2_ispe,xinput) & lor_to_add_all=spline(x_interp_all,w_resc2_ispe_all,sx_in)
endif
sf_sub_function[i_spectrum-1,*,ifunc]=lor_to_add_all[*]
w_to_convl=w_to_convl+lor_to_add
w_to_convl_all=w_to_convl_all+lor_to_add_all
indpar=indpar+3
end
'Gauss':begin
ngauss=ngauss+1
center=sf_new2[indpar] & width=sf_new2[indpar+1] & amplitude=sf_new2[indpar+2]
gau_to_add=ampl*qgauss(xinput,center,width,amplitude)
gau_to_add_all=ampl*qgauss(sx_in,center,width,amplitude)
ind_gau_0=where(gau_to_add ge 1e-10,nn)
if (nn le 7) and (width le 1e-3) then begin
gau_to_add=0.
gau_to_add_all=0.
                print,'**WARNING: Gaussian #',ngauss,'has less than 7 points ne 0 ... treat it as a delta function'
                print,'Parameter # IG is an INTEGRATED INTENSITY (no more an amplitude)'
                x_interp=xinput+dcenter & x_interp_all=sx_in+dcenter
                gau_to_add=ampl*spline(x_interp,w_resc2_ispe,xinput) & gau_to_add_all=spline(x_interp_all,w_resc2_ispe_all,sx_in)
endif
sf_sub_function[i_spectrum-1,*,ifunc]=gau_to_add_all[*]
w_to_convg=w_to_convg+gau_to_add
w_to_convg_all=w_to_convg_all+gau_to_add_all
indpar=indpar+3
end
'DHO':begin
nndho=nndho+1
center=sf_new2[indpar] & width=sf_new2[indpar+1] & amplitude=sf_new2[indpar+2]
dho_to_add=dho(xinput,center,width,amplitude)
dho_to_add_all=dho(sx_in,center,width,amplitude)
sf_sub_function[i_spectrum-1,*,ifunc]=dho_to_add_all[*]
w_to_convdho=w_to_convdho+dho_to_add
w_to_convdho_all=w_to_convdho_all+dho_to_add_all
indpar=indpar+3
end
'Sexp':begin
nnsexp=nnsexp+1
center=sf_new2[indpar] & beta=sf_new2[indpar+1] & tau=sf_new2[indpar+2] & amplitude=sf_new2[indpar+3]
sexp_to_add=amplitude*sexp(xinput,center,beta,tau,amplitude)
sexp_to_add_all=amplitude*sexp(sx_in,center,beta,tau,amplitude)
x_interp=xinput+center & x_interp_all=sx_in+center
;
w=spline(x_interp,sexp_to_add,xinput) & ww=spline(x_interp_all,sexp_to_add_all,sx_in)
sf_sub_function[i_spectrum-1,*,ifunc]=ww[*]
;
w_to_convsexp=w_to_convsexp+w
w_to_convsexp_all=w_to_convsexp_all+ww
indpar=indpar+4
end
'c60isorot':begin
nformula=nformula+1
center=sf_new2[indpar] & Dr=sf_new2[indpar+1] & R=sf_new2[indpar+2] & amplitude=sf_new2[indpar+3] & u2c=sf_new2[indpar+4]
formula_to_add=amplitude*c60isorot(xinput,center,Dr,R,qvalue)*exp(-(qvalue^2*u2c)/3)
formula_to_add_all=amplitude*c60isorot(sx_in,center,Dr,R,qvalue)*exp(-(qvalue^2*u2c)/3)
x_interp=xinput+center & x_interp_all=sx_in+center
;
w=spline(x_interp,formula_to_add,xinput) & ww=spline(x_interp_all,formula_to_add_all,sx_in)
sf_sub_function[i_spectrum-1,*,ifunc]=ww[*]
;
w_to_convform=w_to_convform+w
w_to_convform_all=w_to_convform_all+ww
indpar=indpar+5
end
'lordq2':begin
nlordq2=nlordq2+1
;
qvalue=sy_in[i_spectrum-1]
center=sf_new2[indpar]
Dt=sf_new2[indpar+1]
ampl=sf_new2[indpar+2]
width=Dt*qvalue^2
lor_to_add=ampl*n_lorentz(xinput,center,width)
lor_to_add_all=ampl*n_lorentz(sx_in,center,width)
ind_lor_0=where(lor_to_add ge 1e-10,nn)
if (nn le 7) and (width le 1e-3) then begin
lor_to_add=0.
lor_to_add_all=0.
                print,'**WARNING: Lorentzian #',nlortz,' has less than 7 points ne 0 ... treat it as a delta function'
                print,'Parameter # IL is an INTEGRATED INTENSITY (no more an amplitude)'
                x_interp=xinput+dcenter & x_interp_all=sx_in+dcenter
                lor_to_add=ampl*spline(x_interp,w_resc2_ispe,xinput) & lor_to_add_all=spline(x_interp_all,w_resc2_ispe_all,sx_in)
endif
sf_sub_function[i_spectrum-1,*,ifunc]=lor_to_add_all[*]
w_to_convl=w_to_convl+lor_to_add
w_to_convl_all=w_to_convl_all+lor_to_add_all
indpar=indpar+3
end
'Magnetic Suscept.':begin
nmagnsc=nmagnsc+1
;
qvalue=sy_in[i_spectrum-1]
center=sf_new2[indpar]
G1=sf_new2[indpar+1]
G2=sf_new2[indpar+2]
Umag=sf_new2[indpar+3]
;print,center,G1,G2,Umag
if (ABS(G1-G2) le 1e-5) then begin
formula_to_add=xinput*0.
formula_to_add_all=sx_in*0.
w_to_convform=w_to_convform+formula_to_add
w_to_convform_all=w_to_convform_all+formula_to_add_all
goto, g1eqg2
endif
ind0=where(abs(xinput-center) le 1e-5,complement=indsup0)
if ind0 ne -1 then begin
formula_to_add=xinput*0. & formula_to_add[ind0]=Umag
formula_to_add[indsup0]=Umag*abs(G1*G2*(ATAN((xinput[indsup0]-center)/G1)-ATAN((xinput[indsup0]-center)/G2))/(G1-G2)/(xinput[indsup0]-center))
endif else begin
formula_to_add=Umag*abs(G1*G2*(ATAN((xinput-center)/G1)-ATAN((xinput[indsup0]-center)/G2))/(G1-G2)/(xinput-center))
endelse
ind0=where(abs(sx_in-center) le 1e-5,complement=indsup0)
if ind0 ne -1 then begin
formula_to_add_all=sx_in*0. & formula_to_add_all[ind0]=Umag
formula_to_add_all[indsup0]=Umag*abs(G1*G2*(ATAN((sx_in[indsup0]-center)/G1)-ATAN((sx_in[indsup0]-center)/G2))/(G1-G2)/(sx_in[indsup0]-center))
endif else begin
formula_to_add_all=Umag*abs(G1*G2*(ATAN((sx_in-center)/G1)-ATAN((sx_in-center)/G2))/(G1-G2)/(sx_in-center))
endelse
x_interp=xinput+center & x_interp_all=sx_in+center
;
w=spline(x_interp,formula_to_add,xinput) & ww=spline(x_interp_all,formula_to_add_all,sx_in)
sf_sub_function[i_spectrum-1,*,ifunc]=ww[*]
;
w_to_convform=w_to_convform+w
w_to_convform_all=w_to_convform_all+ww
g1eqg2:indpar=indpar+4
end
'Formula':begin
for ipar=0,User_Modl.npar[ifunc]-1 do begin
print,'Do nothing for the moment'
indpar=indpar+1
endfor
end
endcase
endfor
;
; ** Now we multiply this term by the Debye-Waller factor
; ** exp(-(qvalue^2*u^2)/3)
; -------------------------------------------------------
w_to_conv=(w_to_convl+w_to_convg+w_to_convdho+w_to_convsexp+w_to_convform)*exp(-(qvalue^2*u2)/3)
w_to_conv_all=(w_to_convl_all+w_to_convg_all+w_to_convdho_all+w_to_convsexp_all+w_to_convform_all)*exp(-(qvalue^2*u2)/3)
;
; ** Now we do the convolution
; ------------------------------
w_2_fit=convol(w_to_conv,ess_conv,total(ess_conv),/edge_truncate)
w_2_fit_all=convol(w_to_conv_all,ess_conv,total(ess_conv),/edge_truncate)
;
; ** Now we deal with the elastic part of the model
; --------------------------------------------------------
;x_interp=xinput+dcenter & x_interp_all=sx_in+dcenter
;w_resc2_interp=spline(x_interp,w_resc2_ispe,xinput) & w_resc2_interp_all=spline(x_interp_all,w_resc2_ispe_all,sx_in)
;ela_part=ampl*w_resc2_interp*exp(-(qvalue^2*u2)/3)
;ela_part_all=ampl*w_resc2_interp_all*exp(-(qvalue^2*u2)/3)
;sf_sub_function(i_spectrum-1,*,nb_subfunctions)=ela_part
;
; ** Now we add the delta function to the model function
; -------------------------------------------------------------------------------
;w_2_fit=w_2_fit+ela_part & w_2_fit_all=w_2_fit_all+ela_part_all

; ** Now deal with the background
; --------------------------------
sf_sub_function[i_spectrum-1,*,nb_subfunctions+1]=slope*sx_in[*]+const
w_2_fit=w_2_fit+slope*xinput+const
w_2_fit_all=w_2_fit_all+slope*sx_in+const
;
; ** ... and multiply by the temperature factor in case of symetric data (detailed balance factor)
; ------------------------------------------------------------------------------------------------
if betatemp le 2. then begin
w_2_fit=w_2_fit*exp(0.5*betatemp*xinput)
w_2_fit_all=w_2_fit_all*exp(0.5*betatemp*sx_in)
endif else begin
w_2_fit=w_2_fit*(abs(xinput)/xinput)/(1-exp(-1.*betatemp*xinput))
w_2_fit_all=w_2_fit_all*(abs(sx_in)/sx_in)/(1-exp(-1.*betatemp*sx_in))

endelse
;
; ** Now deal with the elastic line
; ---------------------------------
x_interp=xinput+dcenter & x_interp_all=sx_in+dcenter
w_resc2_interp=spline(x_interp,w_resc2_ispe,xinput) & w_resc2_interp_all=spline(x_interp_all,w_resc2_ispe_all,sx_in)
w_2_fit=w_2_fit+dint*w_resc2_interp*exp(-(qvalue^2*u2)/3)
w_2_fit_all=w_2_fit_all+dint*w_resc2_interp_all*exp(-(qvalue^2*u2)/3)
sf_sub_function[i_spectrum-1,*,nb_subfunctions]=dint*w_resc2_interp_all[*]*exp(-(qvalue^2*u2)/3)
sf_w_fitted[*,i_spectrum-1]=w_2_fit_all
;
; ** Do the difference exp-th
; ---------------------------
sf_w_exp_fit[*,i_spectrum-1]=sw_in[*,i_spectrum-1]-sf_w_fitted[*,i_spectrum-1]
sf_w_exp_fit_rel[*,i_spectrum-1]=100.*ABS((sw_in[*,i_spectrum-1]-sf_w_fitted[*,i_spectrum-1])/sw_in[*,i_spectrum-1])
return,w_2_fit

end


;** **************************************************************
pro fit_ba_userfunction
;+
;** **************************************************************
;** create the base of the fitting routine for a Lor-Gau fit
;
;-
@lamp.cbk
common sc_wid
common sc_loc
common sc_flag
common sc_fit
common sc_convs
common sc_userfunction
common sc_new

name_func='USER_FUNC'

n_param_1D=total(User_Modl.npar)+4 & n_param_2D=nb_spe_tot*n_param_1D
nb_subfunctions=n_elements(User_Modl.npar)
dimlongtx=3*n_param_1D

; ** Defining the flag for the L and G click box
; ** *******************************************
flag_lfit=0 & flag_gfit=0 & flag_lcfit=0 & flag_gcfit=0 & flag_lwfit=0
flag_gwfit=0 & flag_lifit=0 & flag_gifit=0
flag_dfit=0 & flag_bfit=0 & flag_dcfit=0 & flag_bcfit=0
flag_difit=0 & flag_bifit=0
flag_lgifit=intarr(3)
flag_pl_fit2=not flag_pl_fit2
flag_reverse=0 & flag_fromlast=0 & flag_fit2D=0 & flag_sym=0

; ** Defining the widgetID vectors
; ** *****************************
sw_tx_param=lonarr(dimlongtx)
sw_tx_cstr=lonarr(n_param_1D)


; ** Defining the fit variable vectors
; ** *********************************
sf_index=intarr(nb_spe_tot,n_param_1D)+1 ;& sf_index indicates the fix states of the parameters
lowerb=sf_index*0 & upperb=lowerb & lowerbl=fltarr(nb_spe_tot,n_param_1D) & upperbl=lowerbl;& to indicate eventual parameters limits
sf_tie=strarr(nb_spe_tot,n_param_1D) ;to tie parameters

;sf_cstr_write=sf_tie & sf_cstr_write(*,[0,5,7])='1' & sf_cstr_write(*,[1,2,3,4,6,8])='>0';to record the string value writen by the user into the constrain text box
sf_cstr_write=sf_tie & sf_cstr_write[*,*]='1' ;& sf_cstr_write(*,*)='>0';to record the string value writen by the user into the constrain text box

sf_new_values=fltarr(nb_spe_tot,n_param_1D) ;& for ii=0,nb_spe_tot-1 do sf_new_values(ii,0)=center_rf(ii)
;sf_new_values(0:nb_spe_tot-1,1)=0.1 & sf_new_values(0:nb_spe_tot-1,2)=1.
;sf_new_values(0:nb_spe_tot-1,3:7)=0. & sf_new_values(0:nb_spe_tot-1,4)=1.
sf_last_values=fltarr(nb_spe_tot,n_param_1D)
sf_e_values=fltarr(nb_spe_tot,n_param_1D)
sf_sub_function=fltarr(nb_spe_tot,nb_channels,nb_subfunctions+2)
sf_sub_function_name=strarr(nb_subfunctions+2)
sf_functions_labels=strarr(n_param_1D) & sf_functions_labels2=sf_functions_labels
sf_errors_labels=strarr(n_param_1D) & sf_errors_labels2=sf_errors_labels
chisqr=fltarr(nb_spe_tot)+1.e30


; ** Here we treat the structure User_Modl.npar ini order to reconstruct the
; ** user model function as well as to build a user_friendly interface
; ** ***********************************************************************


lortz=where(User_Modl.name eq 'Lorentz',nlortz)       ; we treat the Lorentzian first
gauss=where(User_Modl.name eq 'Gauss',ngauss)       ; then the Gaussian
formula=where((User_Modl.name eq 'Formula') or (User_Modl.name eq 'c60isorot'),nformula)
dhoo=where(User_Modl.name eq 'DHO',nndho)
sexpp=where(User_Modl.name eq 'Sexp',nnsexp)
lordq2=where(User_Modl.name eq 'lordq2',nlordq2)
magnsusc=where(User_Modl.name eq 'Magnetic Suscept.',nmagnsc)
print,'nl=',nlortz,' ng=',ngauss,' ndho=',nndho,'nlordq2=',nlordq2,' nf=',nformula $
,'nmagnsc=',nmagnsc

nlortz=0 & ngauss=0 & nndho=0 & nnsexp=0 & nlordq2=0 & nformula=0 & indpar=0 & nmagnsc=0
for ifunc=0,nb_subfunctions-1 do begin
CASE User_Modl.name[ifunc] of
'Lorentz':begin
nlortz=nlortz+1
strc='CL'+strcompress(string(nlortz),/remove_all) & sf_functions_labels[indpar]=strc
strw='WL'+strcompress(string(nlortz),/remove_all) & sf_functions_labels[indpar+1]=strw
stri='IL'+strcompress(string(nlortz),/remove_all) & sf_functions_labels[indpar+2]=stri
User_Modl.FORMULA[ifunc]='('+stri+'*'+strw+'^2)/(4*(X-'+strc+')^2+'+strw+'^2)'
indpar=indpar+3
end
'Gauss':begin
ngauss=ngauss+1
strc='CG'+strcompress(string(ngauss),/remove_all) & sf_functions_labels[indpar]=strc
strw='WG'+strcompress(string(ngauss),/remove_all) & sf_functions_labels[indpar+1]=strw
stri='IG'+strcompress(string(ngauss),/remove_all) & sf_functions_labels[indpar+2]=stri
User_Modl.FORMULA[ifunc]=stri+'*exp(((X-'+strc+')/'+strw+')^2*4ln(2))'
indpar=indpar+3
end
'DHO':begin
nndho=nndho+1
strc='CDHO'+strcompress(string(nndho),/remove_all) & sf_functions_labels[indpar]=strc
strw='WDHO'+strcompress(string(nndho),/remove_all) & sf_functions_labels[indpar+1]=strw
stri='ADHO'+strcompress(string(nndho),/remove_all) & sf_functions_labels[indpar+2]=stri
User_Modl.FORMULA[ifunc]=stri+'*'+strc+'^2*'+strw+')/((X^2-'+strc+'^2)^2+X^2*'+strw+'^2)'
indpar=indpar+3
end
'Sexp':begin
nnsexp=nnsexp+1
strc='C'+strcompress(string(nndho),/remove_all) & sf_functions_labels[indpar]=strc
strb='B'+strcompress(string(nndho),/remove_all) & sf_functions_labels[indpar+1]=strb
strt='T'+strcompress(string(nndho),/remove_all) & sf_functions_labels[indpar+2]=strt
stri='A'+strcompress(string(nndho),/remove_all) & sf_functions_labels[indpar+3]=stri
User_Modl.FORMULA[ifunc]=stri+'FT(exp(-(X/'+strt+')/^'+strb+'))'
indpar=indpar+4
end
'c60isorot':begin
nformula=nformula+1
strc='C'+strcompress(string(nformula),/remove_all) & sf_functions_labels[indpar]=strc
strw='Dr'+strcompress(string(nformula),/remove_all) & sf_functions_labels[indpar+1]=strw
strr='R'+strcompress(string(nformula),/remove_all) & sf_functions_labels[indpar+2]=strr
stri='A'+strcompress(string(nformula),/remove_all) & sf_functions_labels[indpar+3]=stri
stru2='u2'+strcompress(string(nformula),/remove_all) & sf_functions_labels[indpar+4]=stru2
User_Modl.FORMULA[ifunc]=stri+'exp(-Q2*u2/3)*S_C60_rot(Q,w)'
indpar=indpar+5
end
'lordq2':begin
nlordq2=nlordq2+1
strc='CL'+strcompress(string(nlordq2),/remove_all) & sf_functions_labels[indpar]=strc
strw='Dt'+strcompress(string(nlordq2),/remove_all) & sf_functions_labels[indpar+1]=strw
stri='IL'+strcompress(string(nlordq2),/remove_all) & sf_functions_labels[indpar+2]=stri
User_Modl.FORMULA[ifunc]='('+stri+'*'+strw+'^2)/(4*(X-'+strc+')^2+'+'('+strw+'Q^2)^2)'
indpar=indpar+3
end
'Magnetic Suscept.':begin
nmagnsc=nmagnsc+1
strc='C'+strcompress(string(nmagnsc),/remove_all) & sf_functions_labels[indpar]=strc
strg1='G1'+strcompress(string(nmagnsc),/remove_all) & sf_functions_labels[indpar+1]=strg1
strg2='G2'+strcompress(string(nmagnsc),/remove_all) & sf_functions_labels[indpar+2]=strg2
stru='U'+strcompress(string(nmagnsc),/remove_all) & sf_functions_labels[indpar+3]=stru
User_Modl.FORMULA[ifunc]='see N. Bernhoeft, J. Phys.: Condens. Matter 13 (2001) p774 form (2.4). divided by frequency'
indpar=indpar+4
end
'Formula':begin
for ipar=0,User_Modl.npar[ifunc]-1 do begin
sf_functions_labels[indpar]='P'+strcompress(string(indpar),/remove_all)
indpar=indpar+1
endfor
end
endcase
endfor

str_form_model='Y=['
for istr=0,nb_subfunctions-1 do begin
if istr eq 0 then str_form_model=str_form_model+User_Modl.FORMULA[istr] else str_form_model=str_form_model+'+'+User_Modl.FORMULA[istr]
endfor
str_form_model=str_form_model+']conv(delta(X))+ID*delta(X-CD)+SB*X+CB'
print,str_form_model

if (xregistered('fit_base') le 0) then begin

; ** Start definition of the widget object
; ** *************************************

; ** Base for the fit
; ** First Base
sw_ba_bot=widget_base(group_leader=sw_ba_leader, /column, $
          Title='Fitted parameters and errors ',$
          resource_name='lamp')

; ** Now do the Lorentzian functions if any

sw_ba_botup1=widget_base(sw_ba_bot,Frame=2,Title='Base botlow left',/column)
i_incr=0
for ifunction=0,nb_subfunctions-1 do begin
sw_ba_botup=widget_base(sw_ba_botup1,/row)
str_il='F'+strcompress(string(ifunction+1))
sf_sub_function_name[ifunction]=str_il
sw_la_lor=widget_label(sw_ba_botup,value=str_il,font=font_smaller,xsize=50,/align_center)
;
for ipar=0,User_Modl.npar[ifunction]-1 do begin

str_il=sf_functions_labels[i_incr];'F'+strcompress(string(ifunction+1))+strcompress(string(ipar+1))
sw_la_clor=widget_label(sw_ba_botup,value=str_il,font=font_smaller,xsize=60,/align_center);'
sw_tx_param[i_incr*3]=widget_text(sw_ba_botup,font=font_smaller,value=strcompress(string(User_Modl.params[ipar,ifunction]),/remove_all),/editable,xsize=5,/align_center,uvalue=[6,0,0])
sw_tx_param[i_incr*3+1]=widget_text(sw_ba_botup,font=font_smaller,value='0.00',xsize=5,/align_center)
sw_tx_param[i_incr*3+2]=widget_text(sw_ba_botup,font=font_smaller,value='0.00',xsize=5,/align_center)
sw_tx_cstr[i_incr]=widget_text(sw_ba_botup,value='>0',/editable,xsize=8,/align_center)

;sf_functions_labels(i_incr)=str_il
sf_errors_labels[i_incr]='with error'
sf_functions_labels2[i_incr]=str_il
sf_errors_labels2[0]='E'+str_il+' '

i_incr=i_incr+1

;
endfor
endfor


; ** The Delta function
; ** ********************************
sw_ba_botlow=widget_base(sw_ba_bot,Frame=2,Title='Base bot right',/column)
idmin=n_param_1D-4
idmintx=(n_param_1D-4)*3

sw_ba_c1=widget_base(sw_ba_botlow,/row)
;
sw_la_del=widget_label(sw_ba_c1,value='D ',font=font_smaller,/align_center,xsize=50)
sf_sub_function_name[nb_subfunctions]='D'
;
sw_la_cdel=widget_label(sw_ba_c1,value='CD',font=font_smaller,xsize=60,/align_center)
sw_tx_param[idmintx]=widget_text(sw_ba_c1,font=font_smaller,value='0.00',/editable,xsize=5,/align_center,uvalue=[6,0,0])
sw_tx_param[idmintx+1]=widget_text(sw_ba_c1,font=font_smaller,value='0.00',xsize=5,/align_center)
sw_tx_param[idmintx+2]=widget_text(sw_ba_c1,font=font_smaller,value='0.00',xsize=5,/align_center)
sw_tx_cstr[idmin]=widget_text(sw_ba_c1,value='1',/editable,xsize=8,/align_center)

sw_la_idel=widget_label(sw_ba_c1,value='ID',font=font_smaller,xsize=60,/align_center)
sw_tx_param[idmintx+3]=widget_text(sw_ba_c1,font=font_smaller,value='1.00',/editable,xsize=5,/align_center,uvalue=[6,0,0])
sw_tx_param[idmintx+4]=widget_text(sw_ba_c1,font=font_smaller,value='0.00',xsize=5,/align_center)
sw_tx_param[idmintx+5]=widget_text(sw_ba_c1,font=font_smaller,value='0.00',xsize=5,/align_center)
sw_tx_cstr[idmin+1]=widget_text(sw_ba_c1,value='>0',/editable,xsize=8,/align_center)

sf_functions_labels[idmin]='Center value for Delta'
sf_functions_labels[idmin+1]='Intensity value for Delta'
sf_errors_labels[idmin]='with error'
sf_errors_labels[idmin+1]='with error'
sf_functions_labels2[idmin]='CD'
sf_functions_labels2[idmin+1]='ID'
sf_errors_labels2[idmin]='ECD'
sf_errors_labels2[idmin+1]='EID'

; ** Now the slopping background
; ** *************************************************
ibmin=idmin+2
ibmintx=idmintx+6

sw_ba_c1=widget_base(sw_ba_botlow,/row)
;
sw_la_bac=widget_label(sw_ba_c1,value='B ',font=font_smaller,/align_center,xsize=50)
sf_sub_function_name[nb_subfunctions+1]='B'
;
sw_la_sbac=widget_label(sw_ba_c1,value='SB',font=font_smaller,xsize=60,/align_center)
sw_tx_param[ibmintx]=widget_text(sw_ba_c1,font=font_smaller,value='0.00',/editable,xsize=5,/align_center,uvalue=[6,0,0])
sw_tx_param[ibmintx+1]=widget_text(sw_ba_c1,font=font_smaller,value='0.00',xsize=5,/align_center)
sw_tx_param[ibmintx+2]=widget_text(sw_ba_c1,font=font_smaller,value='0.00',xsize=5,/align_center)
sw_tx_cstr[ibmin]=widget_text(sw_ba_c1,value='1',/editable,xsize=8,/align_center)

sw_la_idel=widget_label(sw_ba_c1,value='CB',font=font_smaller,xsize=60,/align_center)
sw_tx_param[ibmintx+3]=widget_text(sw_ba_c1,font=font_smaller,value='0.00',/editable,xsize=5,/align_center,uvalue=[6,0,0])
sw_tx_param[ibmintx+4]=widget_text(sw_ba_c1,font=font_smaller,value='0.00',xsize=5,/align_center)
sw_tx_param[ibmintx+5]=widget_text(sw_ba_c1,font=font_smaller,value='0.00',xsize=5,/align_center)
sw_tx_cstr[ibmin+1]=widget_text(sw_ba_c1,value='>0',/editable,xsize=8,/align_center)

sf_functions_labels[ibmin]='Slope value for Backg'
sf_functions_labels[ibmin+1]='Constant value for Backg'
sf_errors_labels[ibmin]='with error'
sf_errors_labels[ibmin+1]='with error'
sf_functions_labels2[ibmin]='SB'
sf_functions_labels2[ibmin+1]='CB'
sf_errors_labels2[ibmin]='ESB'
sf_errors_labels2[ibmin+1]='ECB'

; ** Insert the "Try without fitting" button and "fitALL" chekbox
; ** *************************************************************
sw_ba_botlow=widget_base(sw_ba_bot,Frame=2,Title='Base bot right',/column)
sw_ba_c1=widget_base(sw_ba_botlow,/row)
sw_bu_try=widget_button(sw_ba_c1,Font=ft_b_smaller,Frame=1,value='Try and enter',uvalue=[6,0,0])
sw_ba_cb1=widget_base(sw_ba_c1,Title='Fit box2',/nonexclusive,/align_center,/row)
sw_bu_fitall=widget_button(sw_ba_cb1,value=' fit all Sp?',uvalue=[6,2,1],/align_center)
sw_bu_reverse=widget_button(sw_ba_cb1,value=' reverse?',uvalue=[6,2,3],/align_center,sensitive=0)
sw_bu_fromlast=widget_button(sw_ba_cb1,value=' from last?',uvalue=[6,2,4],/align_center,sensitive=0)
sw_bu_fit2D=widget_button(sw_ba_cb1,value=' fit 2D?',uvalue=[6,2,6],/align_center)

; ** Insert the "Acquire from Sp#" button and "Sp#" textbox and symetrization possibility
; ** *************************************************************************************
sw_ba_c1=widget_base(sw_ba_botlow,/row)
sw_bu_acquire=widget_button(sw_ba_c1,Font=ft_b_smaller,Frame=1,value='Acquire from Sp#',uvalue=[6,2,2])
sw_tx_acquire=widget_text(sw_ba_c1,font=font_smaller,value=' 1',/editable,xsize=3,/align_center,uvalue=[6,2,2])
sw_bu_giveall=widget_button(sw_ba_c1,Font=ft_b_smaller,Frame=1,value='Give to All',uvalue=[6,2,7])
sw_tx_give=widget_text(sw_ba_c1,font=font_smaller,value=' All',/editable,xsize=7,/align_center,uvalue=[6,2,7])
sw_ba_cb1=widget_base(sw_ba_c1,Title='Fit box1',/nonexclusive,/align_center)
sw_bu_symsqw=widget_button(sw_ba_cb1,value='Sym.S(Q,w)?',/align_center,uvalue=[6,2,5])
sw_tx_temp=widget_text(sw_ba_c1,font=font_smaller,value=' 0',/editable,xsize=7,/align_center,sensitive=0)
sw_la_temp=widget_label(sw_ba_c1,value='K',font=font_smaller,xsize=10,/align_center)
;
;
; ** Realization of the Base
widget_control, sw_ba_bot, /Realize; & put_logo
xmanager,'qens_fit',sw_ba_bot,/just_reg

; ** Set the FIT and DONE button sensitive:
widget_control,sw_bu_fit, sensitive=1
widget_control,sw_bu_done, sensitive=1

endif

end

