function fun_gauss,xinput,center=center,fwhm=fwhm,height=height,INT=INT
;+
;******* *********
;** This function returns the gaussian giving the parameters of a gaussian
;** The expression is:
;** p1=center p2=FWHM p3=height (intensity is P3*P2P*SQRT(!PI))
;** fun_gauss(x)=(P3/(p2'*sqrt(PI))*EXP(-(x-P1)^2/(P2')^2)
;** in that case, P2'=P2/(2sqrt(Ln(2))) is not the FWHM
;
;-
p1=center & p2=fwhm & p3=height
;
p2p=p2/(2.*sqrt(alog(2.)))
if abs(p2p) le 1e-20 then print,'Probleme p2p'
qgau=p3*EXP(-((xinput-p1)^2)/(p2p^2))
return,qgau
end
