;CALL: qens_user_defined, qensBase, 0
;************************************

;qens_getparams    read parameter values from input fields
;s2v               format float parameter values before writing to file
;qens_write_model  write model to file
;qens_exec_UModl   execute a user formula
;qens_model_event  event handler for user model
;qens_user_defined GUI constructor

pro qens_getparams,btxt, vp,bb,qq
;+
;** **************
;**
;-
widget_control,btxt,get_value=val & val=strlowcase(strcompress(val[0],/remove_all))
sup=strpos(val,'>') & les=strpos(val,'<')
vv =['','','']      & bb =[0,0,0]
vp =[0.,0.,0.]      & qq =''
if  val gt ' ' then begin
;split input  --->
if  sup ge 0 then if les lt sup   then begin
                        vv[1]=strmid(val,sup+1,50)         & bb[1]=1 & endif else $
                  if les gt sup+1 then begin
                        vv[1]=strmid(val,sup+1,les-sup-1)  & bb[1]=1 & endif
if  les ge 0 then if sup lt les   then begin
                        vv[2]=strmid(val,les+1,50)         & bb[2]=1 & endif else $
                  if sup gt les+1 then begin
                        vv[2]=strmid(val,les+1,sup-les-1)  & bb[2]=1 & endif
if (sup*les) eq 0            then begin                              & endif else $
if (sup gt 0) and (les gt 0) then begin
                        vv[0]=strmid(val,0,min([les,sup])) & bb[0]=1 & endif else $
if  sup gt 0 then begin & vv[0]=strmid(val,0,sup)            & bb[0]=1 & endif else $
if  les gt 0 then begin & vv[0]=strmid(val,0,les)            & bb[0]=1 & endif else $
                  begin & vv[0]=val                          & bb[0]=1 & endelse
;numerical    --->
if bb[0] then if strpos(vv[0],'q') ge 0 then qq=vv[0] $
         else begin & on_ioerror,mis0 & bb[0]=0 & vp[0]=float(vv[0]) & bb[0]=1 & mis0: & endelse
if bb[1] then begin & on_ioerror,mis1 & bb[1]=0 & vp[1]=float(vv[1]) & bb[1]=1 & mis1: & endif
if bb[2] then begin & on_ioerror,mis2 & bb[2]=0 & vp[2]=float(vv[2]) & bb[2]=1 & mis2: & endif
;default vp(0)--->
if not bb[0]  then if total(bb) eq 2  then begin & vp[0]=(vp[1]+vp[2])/2. & bb[0]=1    & endif $
                   else  if bb[1]     then begin & vp[0]= vp[1]           & bb[0]=1    & endif $
                   else  if bb[2]     then begin & vp[0]= vp[2]           & bb[0]=1    & endif
;not creasy   --->
if bb[0] and (qq eq '') then if bb[1] then if vp[1] gt vp[0] then bb[0]=0
if bb[0] and (qq eq '') then if bb[2] then if vp[2] lt vp[0] then bb[0]=0

endif
end

function s2v, str
;+
;******* ***
;**
;-
vec=strtrim(string(str),2) & nv=n_elements(vec)
for i=0,nv-1 do begin & ok=strpos(vec[i],'.')            ;Suppress leading zeros
    while ok ge 0 do begin & L=strlen(vec[i])
          if L gt 1   then Z=strmid(vec[i],L-1,1) else Z=''
          if Z eq '0' then vec[i]=strmid(vec[i],0,L-1) else ok=-1
    endwhile
endfor
if nv gt 1 then begin & tb='['  +vec[0]                   ;Make an input vector
   for i=1,nv-1 do tb=tb+' , '+vec[i] & tb=tb+']'
endif else tb=vec
return,tb
end

pro qens_write_model,fifi,User_Modl,ok
;+
;** ****************
;**
;-
ok  =0 & file=fifi & name=fifi
ext =strpos(fifi,'.pro') & if ext gt 0 then name=strmid(name,0,ext) else file=file+'.pro'
nfunc=fix(n_elements(User_Modl.ON)) & npar=max(User_Modl.NPAR)
on_ioerror,misfifi & u=-1
openw,u,file,/get_lun

  printf,u,'pro '+name+' , UserModl     ;Start (procedure)'
  printf,u,';** ******'
  printf,u,';**'
  printf,u,'UserModl=0 ;return "UserModl" as a structure' & printf,u,''
  printf,u,'nfunc=',nfunc,' ;number of functions'
  printf,u,'npar =',npar ,' ;maximum number of parameters'
  printf,u,'umON =intarr(nfunc) & umNPAR=umON & umNAME=strarr(nfunc) & umFORMULA=umNAME'
  printf,u,'umPARAMS=fltarr(npar,nfunc) & umFIXP=intarr(npar,nfunc)  & umQEXP=strarr(npar,nfunc)'
  printf,u,'umBOUNDa=umFIXP & umBOUNDb=umFIXP & umLIMITa=umPARAMS    & umLIMITb=umPARAMS'
  printf,u,'umFIXP[*]=1'
  printf,u,';Functions:'
  printf,u,';**********'
  for i=0,nfunc-1 do begin & is =strtrim(string(i),2) & np=User_Modl.NPAR[i]-1
      printf,u,' umNAME  (   '+is+')='''+User_Modl.NAME[i]+''' & umON('+is+')='+strtrim(string(User_Modl.ON[i]),2) $
                                                         +'  & umNPAR('+is+')='+strtrim(string(User_Modl.NPAR[i]),2)
      if User_Modl.FORMULA[i] gt ' ' then $
      printf,u,' umFORMULA(  '+is+')='''  + User_Modl.FORMULA[i]+''''
      printf,u,' umFIXP   (0,'+is+')=' +s2v(User_Modl.FITP[   0:np,i])
      printf,u,' umPARAMS (0,'+is+')=' +s2v(User_Modl.PARAMS[ 0:np,i])
      for e=0,np do if User_Modl.QEXP[e,i] gt ' ' then begin & s=strtrim(string(e),2)
      printf,u,' umQEXP   ('+s+','+is+')='''+    User_Modl.QEXP[e,i]+'''' & endif
      printf,u,' umBOUNDa (0,'+is+')=' +s2v(User_Modl.BOUNDA[ 0:np,i])
      printf,u,' umLIMITa (0,'+is+')=' +s2v(User_Modl.LIMITA[ 0:np,i])
      printf,u,' umBOUNDb (0,'+is+')=' +s2v(User_Modl.BOUNDB[ 0:np,i])
      printf,u,' umLIMITb (0,'+is+')=' +s2v(User_Modl.LIMITB[ 0:np,i])
      printf,u,';**********'
  endfor
  printf,u,''
  printf,u,'Resolution='+s2v(User_Modl.Resolution)+'      ;0=none 1=Wrkspace 2=Gauss 3=Voigt 4=Spectrum'
  printf,u,'Bose      ='+s2v(User_Modl.Bose      )+'      ;if >0 -> activate detailed balance factor'
  printf,u,'Follow    ='+s2v(User_Modl.Follow    )+'      ;2=2d_fit 0=initial params for all  1 or-1=use previous fit and go 1>N or N>1'
  printf,u,'BkgdMod   ='+s2v(User_Modl.BKGDmod   )+'      ;0=flat 1=linear 2=quadratic'
  printf,u,'BkgdFix   ='+s2v(User_Modl.BKGDfix   )+'      ;0=unfixed flat background 1=fixed'
  printf,u,'BkgdValue ='+s2v(User_Modl.BKGDvalue )+'      ;used if flat background is fixed'
  printf,u,''
  printf,u,';Do not wrap next lines'
  printf,u,'u1=umON & u2=umNAME & u3=umNPAR & u4=umPARAMS & u5=umFIXP & u6=umBOUNDa & u7=umBOUNDb & u8=umLIMITa & u9=umLIMITb'
  printf,u,'v1=umFORMULA & v2=umQEXP & v3=Bose & v4=FOLLOW & v5=Resolution & v6=BkgdMod & v7=BkgdFix & v8=BkgdValue'
  printf,u,'UserModl={ON:u1,NAME:u2,NPAR:u3,PARAMS:u4,FITP:u5,BOUNDA:u6,BOUNDB:u7,LIMITA:u8,LIMITB:u9,FORMULA:v1,QEXP:v2,BOSE:v3,FOLLOW:v4,RESOLUTION:v5,BKGDmod:v6,BKGDfix:v7,BKGDvalue:v8}'
  printf,u,''
  printf,u,'end ;(procedure)'

ok=1
misfifi:if u gt 0 then free_lun,u
if not ok then print,!error_state.msg
end

PRO qens_exec_UModl, npm, formula, X, A, Y, PDER
;+
;** ***************
;**
;-
for j=0,npm-1 do ii=execute('p'+strtrim(string(j+1),2)+'=A[j]') & ii=execute(formula)

if n_params() eq 6 then begin & res=machar() & eps=sqrt(res.eps)
   Yfit=Y
   PDER =dblarr(n_elements(X),npm)           ; define partial_deriv array
   for j=0,npm-1 do begin & js=strtrim(string(j+1),2)
       ii=execute('inc = eps * abs(p'+js+')') & if inc eq 0. then inc=eps
       ii=execute('p'+js+'=p'+js+'+inc')      & ii=execute(formula)
       pder[0,j] = (Y-Yfit)/inc
       ii=execute('p'+js+'=A[j]')
   endfor
   Y=Yfit
endif
end

pro qens_model_event, ev
;+
;** ****************
;**
;-
common sc_userfunction

CATCH,stat & if stat ne 0 then begin & print,!error_state.msg & return & endif

widget_control,ev.id ,get_uvalue=uv & if n_elements(uv) eq 0 then return
top=uv[2]  & uvg={Bgrd:0,FOLLOW:0,Reso:0}
if (uv[0] eq 42) and uv[1] eq 0 then uv[0]=8 ;Fit this model (user own model)

case uv[0] of

8:begin &  okfit=1
         if uv[1] eq 0 then begin & widget_control,uv[4],set_value=' '       ;User Own Model
       cmdfunc=',User_model=User_modl'
       widget_control,uv[3],get_uvalue=uv3 & hed =3    ;[fix_bg, val_bg ,modl_nam ,row1,row2,...]
       if n_elements(uv3) gt hed then begin
        BkgdFix=0 & bkgd=0.
        if uv3[0] eq 1 then begin
           on_ioerror,misnumb & bkgd=0. & widget_control,uv3[1],get_value=txt & bkgd=float(txt[0])
           cmdfixes=cmdfixes+',flat=bkgd' & BkgdFix=1 & misnumb:
        endif
        widget_control,uv3[1],get_uvalue=TBname
        uvF=uv3[hed:*]
        nfunc=n_elements(uvF) & npar=5
        umON =intarr(nfunc) & umNPAR=umON & umNAME=strarr(nfunc) & umFORMULA=umNAME
        umPARAMS=fltarr(npar,nfunc) & umFITP=intarr(npar,nfunc)  & umQEXP=strarr(npar,nfunc)
        umBOUNDA=umFITP & umBOUNDB=umFITP & umLIMITA=umPARAMS    & umLIMITB=umPARAMS
            umFITP[*]=1
        for i=0,nfunc-1 do begin                      ;Loop over functions
         widget_control,uvF[i],get_uvalue=uv4 & hod=3 ;[on/off,numfunc,b_on,f1,txt1,fix1, f2,txt2,fix2,...]
         umON[i]=uv4[0]  & umNAME[i]=TBname[uv4[1]]
         uvP=uv4[hod:*]  & npr=n_elements(uvp)
         umNPAR[i]=npr/3
         if umNPAR[i]*3 lt npr then begin & widget_control,uvp[npr-1],get_value=formu
            formu=strlowcase(strtrim(formu[0],2))     ;We have a formula
       cmt  =strpos(formu,';') & if cmt gt 1 then formu=strmid(formu,0,cmt)
       umFORMULA[i]=formu
       endif
             npepe=umNPAR[i]-1
         for j=0,npepe  do begin                      ;Loop over parameters
           qens_getparams,uvP[j*3+1], vp,bb,qq
           umFITP[j,i] = uvp[j*3]
           if bb[0] then begin                        ;Good input
              umQEXP[  j,i]=qq
              umPARAMS[j,i]=vp[0] & umLIMITA[j,i]=vp[1] & umLIMITB[j,i]=vp[2]
                                    umBOUNDA[j,i]=bb[1] & umBOUNDB[j,i]=bb[2]
           endif else if umON[i] then begin           ;Bad  input?
              pstr=strtrim(string(j+1),2) & idp=strpos(umFORMULA[i],'p'+pstr)
              if (idp ge 0) or (umFORMULA[i] le ' ') or (j eq 0)  then begin
                 widget_control,uv[4],set_value='F'+strtrim(string(i+1),2)+' '+umNAME[i]+' parameter'+strtrim(string(j+1),2)+' is incorrect!'
                     okfit=0
                  endif else umNPAR[i]=umNPAR[i]-1
           endif
         endfor
        endfor
        idb=where((umNAME eq 'Bose') and (umON eq 1)) & if idb[0] ge 0 then bose=umPARAMS[0,idb[0]] else bose=0.
        ido=where((umNAME ne 'Bose') and (umON eq 1))
        if ido[0] ge 0 then begin
           if okfit then widget_control,uv[4],set_value='Good input'
           umON=umON[ido] & umNAME=umNAME[ido] & umNPAR=umNPAR[ido] & umFORMULA=umFORMULA[ido]
           mnp=max(umNPAR)-1
           umPARAMS=umPARAMS[0:mnp,ido] & umFITP  =umFITP[  0:mnp,ido] & umQEXP=umQEXP[0:mnp,ido]
           umBOUNDA=umBOUNDA[0:mnp,ido] & umBOUNDB=umBOUNDB[0:mnp,ido]
           umLIMITA=umLIMITA[0:mnp,ido] & umLIMITB=umLIMITB[0:mnp,ido]
           User_Modl={ON:umON,NAME:umNAME,NPAR:umNPAR,PARAMS:umPARAMS,FITP:umFITP,BOUNDA:umBOUNDA,BOUNDB:umBOUNDB,$
                      LIMITA:umLIMITA,LIMITB:umLIMITB,FORMULA:umFORMULA,QEXP:umQEXP, BOSE:bose, FOLLOW:uvg.Follow,$
                      RESOLUTION:uvg.Reso,BKGDmod:uvg.Bgrd,BKGDfix:BkgdFix,BKGDvalue:bkgd}
           if BkgdFix then User_Modl.BKGDmod=0
        endif else okfit=0
       endif  else okfit=0

           if (uv[5] eq 0) and okfit then begin & okfit=0   ;Write model to disk
               widget_control,uv3[2],get_value=fifi & fifi=strlowcase(strcompress(fifi[0],/remove_all))
               if strpos(fifi,'model') lt 0 then fifi='model_'+fifi
               if strpos(fifi,'.pro' ) lt 0 then fifi=fifi+'.pro'
               qens_write_model,fifi,User_Modl,ok
               if ok then widget_control,uv[4],set_value=fifi+' is written' $
                     else widget_control,uv[4],set_value='?Unable to write '+fifi
           endif
     endif else okfit=0

if okfit eq 1 then begin
        widget_control,bad_id=i,uv[3],/DESTROY
        fit_ba_userfunction
endif


         ;**********************************************
         ; User_Modl contains the structure of the model
         ; if okfit eq 1 we can fit
         ;**********************************************
   end


40:begin & row = widget_base  (uv[3],/row,resource_name='did',/frame) ;Function
         remo= widget_button(row  ,value='Sup',font=ft_b_normal,uvalue=[44,1,top,uv[3],row])
         onfu= widget_button(widget_base(row,/nonexclusive),value='On',font=ft_b_normal,uvalue=[44,2,top,uv[3],row,0,uv[6]])
               widget_control,onfu,set_button=1
           widget_control,uv[3],get_uvalue=uv3 & uv3=[uv3,row] & widget_control,uv[3],set_uvalue=uv3
         case uv[1] of
;    0: begin lab =widget_label  (row ,value='Delta  '  ,font=ft_propor) ;Delta
;       but1=widget_button (widget_base(row,/nonexclusive),value='HT'  ,font=ft_b_normal,uvalue=[44,3,top,uv(3),row,0,uv(6)])
;             txt1=widget_text   (row ,value=' '        ,font=ft_propor,xsize=11,/edit)
;             lab =widget_label  (row ,value=','        ,font=ft_b_normal)
;       but2=widget_button (widget_base(row,/nonexclusive),value='POS' ,font=ft_b_normal,uvalue=[44,3,top,uv(3),row,1,uv(6)])
;             txt2=widget_text   (row ,value=' '        ,font=ft_propor,xsize=11,/edit)
;             lab =widget_label  (row ,value=','        ,font=ft_b_normal)
;       but3=widget_button (widget_base(row,/nonexclusive),value='FWMH',font=ft_b_normal,uvalue=[44,3,top,uv(3),row,2,uv(6)])
;             txt3=widget_text   (row ,value=' '        ,font=ft_propor,xsize=11,/edit)
;             lab =widget_label  (row ,value='(visual)',font=ft_b_normal)
;       widget_control,row,set_uvalue=[1L,uv(1),onfu,0,txt1,but1,0,txt2,but2,0,txt3,but3]
;       end
     1: begin & lab =widget_label  (row ,value='Gauss  '  ,font=ft_propor) ;Gaussian
         but1=widget_button (widget_base(row,/nonexclusive),value='CG'  ,font=ft_b_normal,uvalue=[44,3,top,uv[3],row,0,uv[6]])
              lab =widget_label  (row ,value='CG: '        ,font=ft_b_normal)
              txt1=widget_text   (row ,value=' '        ,font=ft_propor,xsize=11,/edit)
              lab =widget_label  (row ,value=','        ,font=ft_b_normal)
 but2=widget_button (widget_base(row,/nonexclusive),value='WG' ,font=ft_b_normal,uvalue=[44,3,top,uv[3],row,1,uv[6]])
               lab =widget_label  (row ,value='WG: '        ,font=ft_b_normal)
              txt2=widget_text   (row ,value=' '        ,font=ft_propor,xsize=11,/edit)
              lab =widget_label  (row ,value=','        ,font=ft_b_normal)
         but3=widget_button (widget_base(row,/nonexclusive),value='IG',font=ft_b_normal,uvalue=[44,3,top,uv[3],row,2,uv[6]])
               lab =widget_label  (row ,value='IG: '        ,font=ft_b_normal)
              txt3=widget_text   (row ,value=' '        ,font=ft_propor,xsize=11,/edit)
         widget_control,row,set_uvalue=[1L,uv[1],onfu,0,txt1,but1,0,txt2,but2,0,txt3,but3]
        end
     2: begin & lab =widget_label  (row ,value='Lorentz'  ,font=ft_propor) ;Lorentzian
         but1=widget_button (widget_base(row,/nonexclusive),value='CL'  ,font=ft_b_normal,uvalue=[44,3,top,uv[3],row,0,uv[6]])
             lab =widget_label  (row ,value='CL: '        ,font=ft_b_normal)
             txt1=widget_text   (row ,value=' '        ,font=ft_propor,xsize=11,/edit)
             lab =widget_label  (row ,value=','        ,font=ft_b_normal)
         but2=widget_button (widget_base(row,/nonexclusive),value='WL' ,font=ft_b_normal,uvalue=[44,3,top,uv[3],row,1,uv[6]])
             lab =widget_label  (row ,value='WL: '        ,font=ft_b_normal)
              txt2=widget_text   (row ,value=' '        ,font=ft_propor,xsize=11,/edit)
              lab =widget_label  (row ,value=','        ,font=ft_b_normal)
         but3=widget_button (widget_base(row,/nonexclusive),value='IL',font=ft_b_normal,uvalue=[44,3,top,uv[3],row,2,uv[6]])
             lab =widget_label  (row ,value='IL: '        ,font=ft_b_normal)
              txt3=widget_text   (row ,value=' '        ,font=ft_propor,xsize=11,/edit)
         widget_control,row,set_uvalue=[1L,uv[1],onfu,0,txt1,but1,0,txt2,but2,0,txt3,but3]
        end
     3: begin & lab =widget_label  (row ,value='DHO  '  ,font=ft_propor)
         but1=widget_button (widget_base(row,/nonexclusive),value='CDHO'  ,font=ft_b_normal,uvalue=[44,3,top,uv[3],row,0,uv[6]])
             lab =widget_label  (row ,value='CDHO: '        ,font=ft_b_normal)
              txt1=widget_text   (row ,value=' '        ,font=ft_propor,xsize=11,/edit)
              lab =widget_label  (row ,value=','        ,font=ft_b_normal)
         but2=widget_button (widget_base(row,/nonexclusive),value='WDHO' ,font=ft_b_normal,uvalue=[44,3,top,uv[3],row,1,uv[6]])
             lab =widget_label  (row ,value='WDHO: '        ,font=ft_b_normal)
              txt2=widget_text   (row ,value=' '        ,font=ft_propor,xsize=11,/edit)
              lab =widget_label  (row ,value=','        ,font=ft_b_normal)
         but3=widget_button (widget_base(row,/nonexclusive),value='ADHO',font=ft_b_normal,uvalue=[44,3,top,uv[3],row,2,uv[6]])
             lab =widget_label  (row ,value='ADHO: '        ,font=ft_b_normal)
              txt3=widget_text   (row ,value=' '        ,font=ft_propor,xsize=11,/edit)
              lab =widget_label  (row ,value=','        ,font=ft_b_normal)
         widget_control,row,set_uvalue=[1L,uv[1],onfu,0,txt1,but1,0,txt2,but2,0,txt3,but3]
        end
     4: begin & lab =widget_label  (row ,value='Bose   '    ,font=ft_propor) ;det Balance
              lab =widget_label  (row ,value='Temperature',font=ft_b_normal)
              txt1=widget_text   (row ,value='     '      ,font=ft_propor,xsize=5,/edit)
              lab =widget_label  (row ,value='Kelvin'     ,font=ft_b_normal)
         widget_control,row,set_uvalue=[1L,uv[1],onfu,1,txt1,0]
         end
     5: begin & lab =widget_label  (row ,value='Sexp  '  ,font=ft_propor)
         but1=widget_button (widget_base(row,/nonexclusive),value='CSexp'  ,font=ft_b_normal,uvalue=[44,3,top,uv[3],row,0,uv[6]])
             lab =widget_label  (row ,value='CSexp: '        ,font=ft_b_normal)
              txt1=widget_text   (row ,value=' '        ,font=ft_propor,xsize=11,/edit)
              lab =widget_label  (row ,value=','        ,font=ft_b_normal)
         but2=widget_button (widget_base(row,/nonexclusive),value='BSexp' ,font=ft_b_normal,uvalue=[44,3,top,uv[3],row,1,uv[6]])
             lab =widget_label  (row ,value='bSexp: '        ,font=ft_b_normal)
              txt2=widget_text   (row ,value=' '        ,font=ft_propor,xsize=11,/edit)
              lab =widget_label  (row ,value=','        ,font=ft_b_normal)
         but3=widget_button (widget_base(row,/nonexclusive),value='TSexp',font=ft_b_normal,uvalue=[44,3,top,uv[3],row,2,uv[6]])
             lab =widget_label  (row ,value='tSexp: '        ,font=ft_b_normal)
              txt3=widget_text   (row ,value=' '        ,font=ft_propor,xsize=11,/edit)
              lab =widget_label  (row ,value=','        ,font=ft_b_normal)
         but4=widget_button (widget_base(row,/nonexclusive),value='ASexp',font=ft_b_normal,uvalue=[44,3,top,uv[3],row,3,uv[6]])
             lab =widget_label  (row ,value='ASexp: '        ,font=ft_b_normal)
              txt4=widget_text   (row ,value=' '        ,font=ft_propor,xsize=11,/edit)
              lab =widget_label  (row ,value=','        ,font=ft_b_normal)
         widget_control,row,set_uvalue=[1L,uv[1],onfu,0,txt1,but1,0,txt2,but2,0,txt3,but3,0,txt4,but4]
        end
     6: begin & lab =widget_label  (row ,value='C60 rot  '  ,font=ft_propor)
         but1=widget_button (widget_base(row,/nonexclusive),value='C60'  ,font=ft_b_normal,uvalue=[44,3,top,uv[3],row,0,uv[6]])
             lab =widget_label  (row ,value='C: '        ,font=ft_b_normal)
              txt1=widget_text   (row ,value=' '        ,font=ft_propor,xsize=11,/edit)
              lab =widget_label  (row ,value=','        ,font=ft_b_normal)
         but2=widget_button (widget_base(row,/nonexclusive),value='Dr' ,font=ft_b_normal,uvalue=[44,3,top,uv[3],row,1,uv[6]])
             lab =widget_label  (row ,value='Dr: '        ,font=ft_b_normal)
              txt2=widget_text   (row ,value=' '        ,font=ft_propor,xsize=11,/edit)
              lab =widget_label  (row ,value=','        ,font=ft_b_normal)
         but3=widget_button (widget_base(row,/nonexclusive),value='R',font=ft_b_normal,uvalue=[44,3,top,uv[3],row,2,uv[6]])
             lab =widget_label  (row ,value='R: '        ,font=ft_b_normal)
              txt3=widget_text   (row ,value=' '        ,font=ft_propor,xsize=11,/edit)
              lab =widget_label  (row ,value=','        ,font=ft_b_normal)
         but4=widget_button (widget_base(row,/nonexclusive),value='A',font=ft_b_normal,uvalue=[44,3,top,uv[3],row,3,uv[6]])
             lab =widget_label  (row ,value='A: '        ,font=ft_b_normal)
              txt4=widget_text   (row ,value=' '        ,font=ft_propor,xsize=11,/edit)
              lab =widget_label  (row ,value=','        ,font=ft_b_normal)
         but5=widget_button (widget_base(row,/nonexclusive),value='u2',font=ft_b_normal,uvalue=[44,3,top,uv[3],row,4,uv[6]])
             lab =widget_label  (row ,value='u2: '        ,font=ft_b_normal)
              txt5=widget_text   (row ,value=' '        ,font=ft_propor,xsize=11,/edit)
              lab =widget_label  (row ,value=','        ,font=ft_b_normal)
         widget_control,row,set_uvalue=[1L,uv[1],onfu,0,txt1,but1,0,txt2,but2,0,txt3,but3,0,txt4,but4,0,txt5,but5]
        end
     7: begin & lab =widget_label  (row ,value='Lor Diffusion'  ,font=ft_propor) ;Lorentzian
         but1=widget_button (widget_base(row,/nonexclusive),value='CL'  ,font=ft_b_normal,uvalue=[44,3,top,uv[3],row,0,uv[6]])
             lab =widget_label  (row ,value='CL: '        ,font=ft_b_normal)
             txt1=widget_text   (row ,value=' '        ,font=ft_propor,xsize=11,/edit)
             lab =widget_label  (row ,value=','        ,font=ft_b_normal)
         but2=widget_button (widget_base(row,/nonexclusive),value='Dt' ,font=ft_b_normal,uvalue=[44,3,top,uv[3],row,1,uv[6]])
             lab =widget_label  (row ,value='Dt: '        ,font=ft_b_normal)
              txt2=widget_text   (row ,value=' '        ,font=ft_propor,xsize=11,/edit)
              lab =widget_label  (row ,value=','        ,font=ft_b_normal)
         but3=widget_button (widget_base(row,/nonexclusive),value='IL',font=ft_b_normal,uvalue=[44,3,top,uv[3],row,2,uv[6]])
             lab =widget_label  (row ,value='IL: '        ,font=ft_b_normal)
              txt3=widget_text   (row ,value=' '        ,font=ft_propor,xsize=11,/edit)
         widget_control,row,set_uvalue=[1L,uv[1],onfu,0,txt1,but1,0,txt2,but2,0,txt3,but3]
        end
     8: begin & lab =widget_label  (row ,value='Magnetic Suscept.'  ,font=ft_propor) ;Lorentzian
         but1=widget_button (widget_base(row,/nonexclusive),value='CL'  ,font=ft_b_normal,uvalue=[44,3,top,uv[3],row,0,uv[6]])
             lab =widget_label  (row ,value='C: '        ,font=ft_b_normal)
             txt1=widget_text   (row ,value=' '        ,font=ft_propor,xsize=11,/edit)
             lab =widget_label  (row ,value=','        ,font=ft_b_normal)
         but2=widget_button (widget_base(row,/nonexclusive),value='G1' ,font=ft_b_normal,uvalue=[44,3,top,uv[3],row,1,uv[6]])
             lab =widget_label  (row ,value='G1: '        ,font=ft_b_normal)
              txt2=widget_text   (row ,value=' '        ,font=ft_propor,xsize=11,/edit)
              lab =widget_label  (row ,value=','        ,font=ft_b_normal)
         but3=widget_button (widget_base(row,/nonexclusive),value='G2',font=ft_b_normal,uvalue=[44,3,top,uv[3],row,2,uv[6]])
             lab =widget_label  (row ,value='G2: '        ,font=ft_b_normal)
              txt3=widget_text   (row ,value=' '        ,font=ft_propor,xsize=11,/edit)
         but4=widget_button (widget_base(row,/nonexclusive),value='U',font=ft_b_normal,uvalue=[44,3,top,uv[3],row,3,uv[6]])
             lab =widget_label  (row ,value='U: '        ,font=ft_b_normal)
              txt4=widget_text   (row ,value=' '        ,font=ft_propor,xsize=11,/edit)
              lab =widget_label  (row ,value=','        ,font=ft_b_normal)
         widget_control,row,set_uvalue=[1L,uv[1],onfu,0,txt1,but1,0,txt2,but2,0,txt3,but3,0,txt4,but4]
        end
     9: begin & rowt=widget_base   (row ,/column) ;Own formula
              row1=widget_base   (rowt,/row)
         lab =widget_label  (row1,value='Formula'  ,font=ft_propor)
         case uv[5] of
         0:  begin & formu='b=4*alog(2) & Y=P1*exp(-b*((X-P2)/P3)^2) ;RULE: Y=result, X=abcissa, P1,P2...=parameters
                   npp  =5 & end
         1:  begin & formu='t=X*P2 & Y= P1*(3*(sin(t) - X*P2*cos(t))/(t)^3)^2 ;D22 Spherical'
                   npp  =2 & end
         else:
         endcase
         form=widget_text   (row1,value=formu      ,font=ft_propor,xsize=76,/edit)
         row2=widget_base   (rowt,/row)
         but1=widget_button (widget_base(row2,/nonexclusive),value='P1'  ,font=ft_b_normal,uvalue=[44,3,top,uv[3],row,0,uv[6]])
              txt1=widget_text   (row2,value=' '        ,font=ft_propor,xsize=11,/edit)
              uvff=[1L,uv[1],onfu,0,txt1,but1]
              if npp ge 2 then begin
              lab =widget_label  (row2,value=','        ,font=ft_b_normal)
         but2=widget_button (widget_base(row2,/nonexclusive),value='P2'  ,font=ft_b_normal,uvalue=[44,3,top,uv[3],row,1,uv[6]])
              txt2=widget_text   (row2,value=' '        ,font=ft_propor,xsize=11,/edit)
              uvff=[uvff,0,txt2,but2] & endif
              if npp ge 3 then begin
              lab =widget_label  (row2,value=','        ,font=ft_b_normal)
         but3=widget_button (widget_base(row2,/nonexclusive),value='P3'  ,font=ft_b_normal,uvalue=[44,3,top,uv[3],row,2,uv[6]])
              txt3=widget_text   (row2,value=' '        ,font=ft_propor,xsize=11,/edit)
              uvff=[uvff,0,txt3,but3] & endif
              if npp ge 4 then begin
              lab =widget_label  (row2,value=','        ,font=ft_b_normal)
         but4=widget_button (widget_base(row2,/nonexclusive),value='P4'  ,font=ft_b_normal,uvalue=[44,3,top,uv[3],row,3,uv[6]])
              txt4=widget_text   (row2,value=' '        ,font=ft_propor,xsize=4,/edit)
              uvff=[uvff,0,txt4,but4] & endif
              if npp ge 5 then begin
              lab =widget_label  (row2,value=','        ,font=ft_b_normal)
         but5=widget_button (widget_base(row2,/nonexclusive),value='P5'  ,font=ft_b_normal,uvalue=[44,3,top,uv[3],row,4,uv[6]])
              txt5=widget_text   (row2,value=' '        ,font=ft_propor,xsize=3,/edit)
              uvff=[uvff,0,txt5,but5] & endif
         widget_control,row,set_uvalue=[uvff, form]
        end
     else:
     endcase
   end
41:begin & widget_control,uv[4],get_value=fifi & fifi=strcompress(fifi[0],/remove_all) ;Get model from file
         if strpos(fifi,'model') lt 0 then fifi='model_'+fifi
         fofo=fifi
         ext=strpos (fifi,'.pro') & if ext gt 0 then fifi=strmid(fifi,0,ext) else fofo=fofo+'.pro'
         if (not sys_dep("EMBEDDED")) and (not sys_dep("RUNTIME")) then begin
             ii =execute('RESOLVE_ROUTINE,fifi') & ii =execute(fifi+',UserModl')
         endif else begin
             on_ioerror,misfofo & u=-1 & line='' & ii=0
             openr,u,fofo,/get_lun
             while(1) do begin & readf,u,line & if strpos(line,'(procedure)') eq -1 then ii=execute(line) & endwhile
             misfofo: if u gt 0 then free_lun,u
         endelse
         if (ii ne 1) or (n_tags(UserModl) le 1) then begin
             widget_control,uv[5],set_value='?Unable to get this model' & print,!error_state.msg
         endif else begin
       widget_control,uv[3] ,get_uvalue=uv3 & hed =3      ;[fix_bg, val_bg ,modl_nam ,row1,row2,...]
       if n_elements(uv3) gt hed then for i=hed,n_elements(uv3)-1 do widget_control,uv3[i],/destroy
           widget_control,uv[3] ,set_uvalue=uv3[0:hed-1]
       widget_control,uv3[1],get_uvalue=TBname

           widget_control,uv[7] ,set_button=UserModl.BKGDfix ;set background
           widget_control,uv3[1],set_value =s2v(UserModl.BKGDvalue)
           uvg.Bgrd  =UserModl.BKGDmod
           uvg.Follow=UserModl.FOLLOW
           uvg.Reso  =UserModl.RESOLUTION

           NAME=UserModl.NAME & ON=UserModl.ON & NPAR=UserModl.NPAR
           if UserModl.Bose gt 0. then begin & NAME=[NAME,'Bose'] & ON=[ON,1] & NPAR=[NPAR,1] & endif
           nfunc=n_elements(NAME)
           for i=0,nfunc-1 do begin                           ;Loop over functions
               nf=where(TBname eq NAME[i])
               widget_control,uv[6],set_uvalue=[40,nf[0],uv[2],uv[3],uv[6],0,uv[5]]
               qens_model_event, {WIDGET_BUTTON, ID:uv[6], TOP:uv[2], HANDLER:0L, SELECT:1}
               widget_control,uv[3],get_uvalue=uv3
               widget_control,uv3[hed+i],get_uvalue=uvf & hod=3
               uvf[0]=ON[i]
               np    =NPAR[i]
               if NAME[i] eq ('Bose') then widget_control,uvf[hod+1],set_value=s2v(UserModl.Bose) $
               else begin
                 widget_control,uvf[2],set_button=UserModl.ON[i]
                 if UserModl.FORMULA[i] gt ' ' then widget_control,uvf[n_elements(uvf)-1],set_value=UserModl.FORMULA[i]
                 for j=0,np-1 do begin & pl=hod+j*3
                    uvf[pl]=UserModl.FITP[j,i]
                    widget_control,uvf[pl+2],set_button=UserModl.FITP[j,i]
                    ptxt=s2v(UserModl.PARAMS[j,i])
                    if UserModl.QEXP  (j,i) gt ' ' then ptxt=UserModl.QEXP[j,i]
                    if UserModl.BOUNDA[j,i] then ptxt=ptxt+'>'+s2v(UserModl.LIMITA[j,i])
                    if UserModl.BOUNDB[j,i] then ptxt=ptxt+'<'+s2v(UserModl.LIMITB[j,i])
                    widget_control,uvf[pl+1],set_value=ptxt
                 endfor
               endelse
               widget_control,uv3[hed+i],set_uvalue=uvf
           endfor
           widget_control,uv[5],set_value=fifi+' is loaded'
         endelse
   end
42:begin & if uv[1] eq 0 then begin            ;Initiate
         endif else if uv[1] eq 1 then begin ;Background
               if ev.select then memes='Flat background is fixed' else memes=' '
           widget_control,uv[3],get_uvalue=uv3 & uv3[0]=ev.select
           widget_control,uv[3],set_uvalue=uv3
           widget_control,uv[6],set_value =memes
         endif else if uv[1] eq 2 then begin ;Follow parameters
           widget_control,ev.id,get_value =memes
           widget_control,uv[6],set_value =memes
           uvg.Follow=uv[3]
           if uv[3] eq  0 then memes='Init mode'
           if uv[3] eq  1 then memes='Go 1 -> N'
           if uv[3] eq -1 then memes='Go N -> 1'
           if uv[3] eq  2 then memes='2d Fit   '
           widget_control,uv[4],set_value =memes
     endif
   end
43:begin & widget_control,uv[3],/destroy & return
   end
44:begin & case uv[1] of
         1: begin & widget_control,uv[4],/destroy       ;Function Remove
              widget_control,uv[3],get_uvalue=uv3 & idx=where(uv3 ne uv[4])
         widget_control,uv[3],set_uvalue=uv3[idx]
        end
     2: begin & if ev.select then memes=' ' else memes='Function is off'
              widget_control,uv[4],get_uvalue=uv4 & uv4[0]=ev.select
         widget_control,uv[4],set_uvalue=uv4 ;Function on/off
         widget_control,uv[6],set_value =memes
        end
     3: begin & if ev.select then memes='Parameter is fixed' else memes=' ' & hod=3
              widget_control,uv[4],get_uvalue=uv4 & uv4[hod+uv[5]*3]=ev.select
         widget_control,uv[4],set_uvalue=uv4 ;Function fix params
         widget_control,uv[6],set_value =memes
        end
     else:
     endcase
   end
else:
endcase
end

pro qens_user_defined, leader, lamp_b1   ;leader=qens base  lamp_b1=0 ou lamp base
;+
;** *****************
;**
;-
common c_lamp_font

base0=widget_base  (title='User defined fitting model',/column,resource_name='lamp')

row1 =widget_base  (base0,/row,resource_name='don')
row2 =widget_base  (base0,/row)
Minit=widget_button(row2 ,value='FIT this model'                ,font=ft_b_normal)
mess =widget_label (row2 ,value=string(replicate(32b,80))       ,font=ft_propor,xsize=580)
widget_control,mess ,set_value ="Input values: '9.' '9>8.5<10' '>1.1' '2*q/3' (q=spectrum value)"
widget_control,Minit,set_uvalue=[42,0,leader,base0,mess,1]

if lamp_b1 gt 0 then CALL_PROCEDURE,'put_logo',row1
TBname=['Delta','Gauss','Lorentz','DHO','Bose','Sexp','c60isorot','lordq2','Magnetic Suscept.','','Formula']
Flist=widget_button(row1 ,value='Add Function',/menu    ,font=ft_b_normal)
 ;but0=widget_button(Flist,value='Delta'                 ,font=ft_b_normal, uvalue=[40,0,leader,base0,Flist,0,mess])
 but1=widget_button(Flist,value='Gaussian'              ,font=ft_b_normal, uvalue=[40,1,leader,base0,Flist,0,mess])
 but2=widget_button(Flist,value='Lorentzian'            ,font=ft_b_normal, uvalue=[40,2,leader,base0,Flist,0,mess])
 but3=widget_button(Flist,value='Damped Harmonic Oscillator',font=ft_b_normal, uvalue=[40,3,leader,base0,Flist,0,mess])
 but4=widget_button(Flist,value='Streched exponential',font=ft_b_normal, uvalue=[40,5,leader,base0,Flist,0,mess])
 but5=widget_button(Flist,value='C60 isorot',font=ft_b_normal, uvalue=[40,6,leader,base0,Flist,0,mess])
 but6=widget_button(Flist,value='Lor DQ2',font=ft_b_normal, uvalue=[40,7,leader,base0,Flist,0,mess])
 but8=widget_button(Flist,value='Magnetic Suscept.',font=ft_b_normal, uvalue=[40,8,leader,base0,Flist,0,mess])
 but9=widget_button(Flist,value='Enter your Formula'    ,font=ft_b_normal, uvalue=[40,9,leader,base0,Flist,0,mess])
 but =widget_button(Flist,value=' ')
 ;but4=widget_button(Flist,value='Detailed Balance fact.',font=ft_b_normal, uvalue=[40,4,leader,base0,Flist,0,mess])
 ;but5=widget_button(Flist,value='D22_Spherical'         ,font=ft_b_normal, uvalue=[40,9,leader,base0,Flist,1,mess])

txtb =widget_text  (row1 ,value=' 0.0 ',xsize=5,ysize=1,/edit,font=ft_propor,uvalue=TBname)
butbg=widget_button(widget_base(row1,/nonexclusive),value='fix Bgrd',font=ft_b_normal, uvalue=[42,1,leader,base0,0,0,mess])

;butFO=widget_button(row1 ,value='Init mode'                                   ,font=ft_b_normal, /menu)
;  but=widget_button(butFO,value='(In case you are fitting N spectra you can:)',font=ft_b_normal)
;  but=widget_button(butFO,value=' '                                           ,font=ft_b_normal)
;  but=widget_button(butFO,value='->Take the same initial parameters for all spectra'                ,uvalue=[42,2,leader, 0,butFO,0,mess],font=ft_b_normal)
;  but=widget_button(butFO,value='->Loop from 1 to N taking fitted parameters from previous spectrum',uvalue=[42,2,leader, 1,butFO,0,mess],font=ft_b_normal)
;  but=widget_button(butFO,value='->Loop from N to 1 taking fitted parameters from previous spectrum',uvalue=[42,2,leader,-1,butFO,0,mess],font=ft_b_normal)
;  but=widget_button(butFO,value=' '                                           ,font=ft_b_normal)
;  but=widget_button(butFO,value='->Fit all at once ->insert tied parameter value into brackets"[v]"',uvalue=[42,2,leader,2,butFO,0,mess],font=ft_b_normal)
;  widget_control,but,sens=0

lab  =widget_label (row1 ,value=' '                     ,font=ft_propor)
lab  =widget_label (row1 ,value='Name of model'         ,font=ft_b_normal)
m_nam=widget_text  (row1 ,value=''     ,xsize=15,ysize=1,font=ft_propor,/edit)
Msave=widget_button(row1 ,value='File',/menu            ,font=ft_b_normal)
  but=widget_button(Msave,value='Get from disk'         ,font=ft_b_normal, uvalue=[41,1,leader,base0,m_nam,mess,Flist,butbg])
  but=widget_button(Msave,value='save  to disk'         ,font=ft_b_normal, uvalue=[42,0,leader,base0,mess,0])
lab  =widget_label (row1 ,value=' '                     ,font=ft_propor)
done =widget_button(row1 ,value='Done'                  ,font=ft_b_normal, uvalue=[43,0,leader,base0])
lab  =widget_label (row1 ,value='  '                    ,font=ft_propor)
hlp  =widget_button(row1 ,value='Help'                  ,font=ft_b_normal, /menu)
  but=widget_button(hlp  ,value='Just do it'            ,font=ft_propor)
  but=widget_button(hlp  ,value='then press "FIT this model"' ,font=ft_propor)

widget_control,base0 ,set_uvalue=[0L,txtb,m_nam]
widget_control,base0,/realize & if lamp_b1 gt 0 then CALL_PROCEDURE,'put_logo'
XMANAGER,'str_fit',base0,event_handler='qens_model_event',group_leader=leader,/no_block,/just_reg
end
