FUNCTION inter_qeq0,w_in,Inverse=inverse,wait=nwait;,Temp=temp,Emin=emin,Emax=emax,Inverse=inverse,wait=nwait
;+
;******* **********
;** User callable
;** S. Rols 08/03 rols@gdpc.univ-montp2.fr
;** The call is w6=inter_qeq0(w_in)
;** w_in is a workspace treated from gdos in the Pab option
;** Last modifications 29/02/12 by SR : - include the inverse and nwait options
;**                                     - <u2> values output in the z_out vector
;** 
;-

COMMON c_lamp_access, inst
COMMON printing, iprint, outstring

take_datp, datp
par=datp.p
x_in=datp.x
y_in=datp.y
e_in=datp.e
; -------------------------------------------
; Donnees experimentales

Print,'DOS ## S.R 2003 ##'
lambda=0.

CASE inst OF
;        'MiBeMol':BEGIN
;        lambda=FLOAT(par(10))
;        temp=FLOAT(par(5))
;        ei=81.799/(lambda^2)+x_in*0.
;        END
        'DCSasc':BEGIN
        lambda=FLOAT(par[8])
        ei=81.799/(lambda^2)+x_in*0.
        END
        'QENS_raw':BEGIN
        ef=3.167 ;average final neutron energy in meV
        lambda=SQRT(81.799/ef)
        ei=x_in+ef
        END
        ELSE:BEGIN
        lambda=par[21]
        if (n_elements(temp) EQ 0) THEN temp=par[11]
        ei=81.799/(lambda^2)+x_in*0.
        END
ENDCASE
print,inst
IF (temp EQ 0.0) THEN temp=300.0
IF (n_elements(emax) EQ 0) THEN emax=MAX(x_in)
IF (n_elements(emin) EQ 0) THEN emin=MIN(x_in)
print, 'temp=',temp,'lambda=',lambda,'emin=',emin,'emax=',emax
IF (n_elements(nwait) EQ 0) THEN nwait=1

points=where(x_in ge emin and x_in le emax)

w_buf=w_in > 1e-12 & e_buf=e_in & y_out=y_in
nchannels=n_elements(x_in) & nspectra=n_elements(y_in) & w_out=fltarr(nchannels) & usquare=w_out & e_out=w_out
;
;Calcul de Q^2
;************************
q2=w_in*0.0
x_in=FLOAT(x_in)
FOR itet=0,n_elements(y_in)-1 DO q2[*,itet]=2*ei[*]-x_in[*]-2*sqrt(ei[*]*ABS(ei[*]-x_in[*]))*cos(y_in[itet]*!pi/180)
q2=q2/2.072
;print,'q2=',q2
;

lnwin=alog(abs(w_buf))

FOR ichan=0,nchannels-1 DO BEGIN
xx=fltarr(nspectra) & xx[*]=q2[ichan,*]
yy=fltarr(nspectra) & yy[*]=lnwin[ichan,*]
ee=fltarr(nspectra) & ee[*]=e_buf[ichan,*]/abs(w_buf[ichan,*])
;result=regress(xx,yy,CONST=DOS)
result=linfit(xx,yy,YFIT=fit,MEASURE_ERRORS=ee,SIGMA=sigm)
w_out[ichan]=exp(result[0]) & usquare[ichan]=-result[1] ;& fit=xx
e_out[ichan]=sigm[0]*w_out[ichan]
;fit2=result(0)+result(1)*xx
str_title=strcompress(x_in[ichan])+' meV, DOS ='+strcompress(exp(result[0]))+' <u2> = '+strcompress(-result[1])+'+/'+strcompress(sigm[1])
plot,xx,yy,color=1324565,psym=4,TITLE=str_title
errlow=yy-abs(ee) & errhigh=yy+abs(ee)
errplot,xx,errlow,errhigh,color=1324565
oplot,xx,fit
wait,0.05*nwait
ENDFOR
;
;output
x_out=x_in
;e_out=w_out*0.
y_out=0.
z_out=usquare

IF (n_elements(inverse) EQ 0) THEN GOTO, output
x_out=reverse(ABS(x_out))
e_out=reverse(e_out)
w_out=reverse(w_out)
z_out=reverse(z_out)

output:mod_datp, datp, "e", e_out
mod_datp, datp, "x", x_out
mod_datp, datp, "y", y_out
mod_datp, datp, "z", z_out
give_datp, datp

return, w_out
Print,'Calculation of the GDOS via the interpolation at Q=0, DONE'
end
