PRO output_spe, w_in0, file = file, phx = phx
;+
;** **********
;** User callable
;** writes an SPE format file
;-

    iprint = 1        
    TAKE_DATP, datp

    s = SIZE(w_in0)

    OPENW, lun, file + '.dat', /GET_LUN
    PRINTF, lun, FORMAT = '(2I5)', s[2], s[1]
    PRINTF, lun, '### Phi Grid'
    PRINTF, lun, FORMAT = '(8G10.4)', datp.y
    PRINTF, lun, '### Energy Grid'
    PRINTF, lun, FORMAT = '(8G10.4)', datp.x

    FOR iphi = 1, s[2] DO BEGIN
        PRINTF, lun, '### S[Phi,w]'
        PRINTF, lun, FORMAT = '(8E10.4)', w_in0[*,iphi - 1]
        PRINTF, lun, '### Errors'
        PRINTF, lun, FORMAT = '(8E10.4)', datp.e[*,iphi - 1]
    ENDFOR
        
    FREE_LUN, lun

    IF KEYWORD_SET(phx) THEN BEGIN
        delphi = FLTARR(s[2])
        OPENW, lun, 'in4.phx', /GET_LUN
        PRINTF, lun, FORMAT = '(I3)', s[2]
        FOR iphi = 0, s[2] - 1 DO BEGIN
            IF iphi LT s[2] - 1 THEN $
                delphi[iphi] = datp.y[iphi+1] - datp.y[iphi] ELSE $
                delphi[iphi] = delphi[iphi-1]
            PRINTF, lun, $
            FORMAT = '(I10,1X,I10,1X,F10.4,1X,I10,F10.3,1X,F10.6,1X,I10)', $
            10,0,datp.y[iphi],0,delphi[iphi], delphi[iphi]-0.05*delphi[iphi],0
        ENDFOR
        FREE_LUN, lun
    ENDIF

    END
