function read_V1, inst , path , filename , status , datp

; authors: L. Meffo-Fokam, T. Hauss
; Version: 005
; Date: 28.02.2014 16:26
; Date: 05.03.2014 17:40
; Date: 12.03.2014 12:25
; Date: 14.03.2014 17:46

 ;max values from caressglobals.h
 
FORWARD_FUNCTION rdid
junck=rdid()           ;  Compile rdid to access P_DID_CALOD and common

common calibNew,    cal_v1  , ang_v1  , inf_v1  ,$ ;for instrument V1
                    cal_nw1 , ang_nw1 , inf_nw1 ,$ ;for further instruments
                    cal_nw2 , ang_nw2 , inf_nw2 ,$
                    cal_nw3 , ang_nw3 , inf_nw3 ,$
                    cal_nw4 , ang_nw4 , inf_nw4 ,$
                    cal_nw5 , ang_nw5 , inf_nw5
common c_rdid     , dzap, FrameRange , pzip, pzup

MAX_FILE_NAME_LEN   = 256
MAX_STR_LEN         = 4096
MAXMESLENGTH        = 1500            ; /* in short int */
BMAXMESLENGTH       = (2*MAXMESLENGTH); /* in bytes */
MAXTASKNAMELENGTH   = 32
MAX_EXP_NAME_LENGTH = 9
MAXNAMELENGTH       = 32        ;/* max module name length (not incl. 'D'+'\0') */
MAXCOM              = 68        ;/* max length of comment */
MAXIDLENGTH         = 20        ;/* max length of id name */
MAX_MODULES         = 16384     ;/* max number of modules */
MAXNUMBEROFWINDOWS  = 4         ;/* max number of detector windows */
MAXNROFMODULES      = 128       ;/* max number of modules in a data tupel */
MAX_REC_LEN         = 4096      ;/* max length of record for live_prt */
MAXNUMBEROFCHANNELS = 16384     ;/* max number of channels of multi-detector*/
MAX_COUPLED_GROUPS  = 8         ;/* max coupled groups (CSM command) */

; /*> value type ids */ caressglobals.h
 
INTEGERTYPE    =1   ;  /* short int (16 bit) */  
LONGINTEGER    =2   ;  /* int (32 bit) */        
REALTYPE       =5   ;  /* float (32 bit) */      
DOUBLETYPE     =11  ;  /* double (64 bit) */
INT64TYPE      =13  ;  /* long long (64 bit) */
CHARTYPE       =16  ;  /* string (not '\0' terminated) */
STRINGTYPE     =17  ;  /* string ('\0' terminated) */
ADDRTYPE       =18  ;  /* address info */
MODIDTYPE      =19  ;  /* short int (module ID) */
;  /* cmdint - definitions */
ONOFFTYPE      =21  ; /* OT: strings "ON" or "OFF" (e.g. command CHECK) */
PMATRIXTYPE    =22  ; /* PT: strings "XX", "XY",..., "ZZ" (cmd PMATRIX) */
DAUTYPE        =23  ; /* CT: strings "SI" or "MU" */
ENUMERATIONTYPE=24  ; /* EN: indicating enumeration in xx_ranges.dat */
DAUDATATYPE    =25  ; /* IT: strings "I2" or "I4" in CONFIG command */
; end value type ids

len =0
i=0

element_number= 0L
element_type  = 0L
element       = bytarr(MAXNAMELENGTH)    ; must be exact the length of element in raw.c
last_element  = bytarr(MAXNAMELENGTH)    ; must be exact the length of element in raw.c
node          = bytarr(MAXNAMELENGTH)    ; must be exact the length of element in raw.c
data_type     = 0L
data_number   = 0L
item_num      = 0L
remaining_num = 0L
section       =1L
start_num     =1L
numors        = 0L  
act_numor     = ''
curent_numor  = 1                    ; counter of numors in file
b_filename    = bytarr(MAX_FILE_NAME_LEN) 
int_buffer    = intarr(MAXNUMBEROFCHANNELS)
long_buffer   = lonarr(MAXNUMBEROFCHANNELS)
real_buffer   = fltarr(MAXNUMBEROFCHANNELS)
double_buffer = dblarr(MAXNUMBEROFCHANNELS)
int64_buffer  = lon64arr(MAXNUMBEROFCHANNELS)
char_buffer   = bytarr(MAXNUMBEROFCHANNELS)
string_buffer = bytarr(MAXNUMBEROFCHANNELS)
;v18_buffer   = lonarr(262144)
data          = lonarr(128, 128) ; Return value

; Liste von Node       
RELA_TTHS    = fltarr(3)
RELA_NYS     = fltarr(3)
SETV_STEP    = 0
JULABO1      = fltarr(5)
JULABO2      = fltarr(5)
JULABO3      = fltarr(5)
TEMP         = fltarr(5)
TTHS_SGEN1   = fltarr(2)
OMGS_SGEN1   = fltarr(2)
COM          = strarr(10)
S1W          = 0.0 &    S1X       = 0.0  &   S1H          = 0.0  &   S1Y       = 0.0  &   S1L       = 0.0  &   S1R    = 0.0    
S1T          = 0.0 &    S2W       = 0.0  &   S2X          = 0.0  &   S2H       = 0.0  &   S2Y       = 0.0  &   S2L    = 0.0    
S2B          = 0.0 &    S2T       = 0.0  &   YSD          = 0.0  &   NYS       = 0.0  &   HGHT      = 0.0  &   TTHS   = 0.0   
CHIS         = 0.0 &    PHIS      = 0.0  &   TRANSM       = 0.0  &   OMGM      = 0.0  &   INCLM     = 0.0  &   FOCUSM = 0.0 
TTHMA        = 0.0 &    MAGF      = 0.0  &   BALANCE      = 0.0  &   S1B       = 0.0  &   S2R       = 0.0  &   MM1    = 0  ; 0 = MONITOR , 1 = ZEIT
DATE_START   = ''  &    DATE_STOP = ''   &   TIME_START   = ''   &   TIME_STOP = ''   &   TIME_FIRST=1     &   OMGS   = 0.0   
DATE_FIRST   = 1   &    COM_COUNT = 0    &   MON          = 0L   &   TIM1      = 0L   &   T_SAM     = 0.0  &   DAT    = '' 
ADET         = 0L  &    STEP      = 0    &   STEP_REQUEST =0     &   T_REG     = 0.0  &   exp_kind  = ''   &   USN    = '' 
T_MEAN       = 0.0 &    T_DELTA   = 0.0  &   DATPOTHER_TIT=''    &   T_SET     = 0.0  &   exp_axes  = ''   &   SAM    = ''
NUMOR        = 0L  &    PROPOSAL  = ''   &   exp_options  =''    &   WAV       = 0.0  &   exp_name  = ''   &   exp_detector = ''
STEP_MAX     = 1L  	  
STEP_REQUESTED = 1
SCAN_NODE      =''
Mon_MODE       =''
Monitor_MODE   =1.0

Catch, theError
if theError NE 0 then begin
  Catch, /cancel
  print, 'attention some error appeared ' , !error_state.Msg , $ Keyword_set(debug)
  return
endif
short_filename = strmid( filename, 0, 5)
act_numor      = strmid(filename, 5, 3)
short_filename = STRLOWCASE(inst[0])+ short_filename +'.dat'
full_filename  = path + short_filename
len            = strlen(full_filename)

if n_elements(FrameRange) eq 2 then begin
     firstFrame = FrameRange[0]
      lastFrame = FrameRange[1]
endif
   
 ; determine operating system
os = StrUpCase(!Version.OS)
CASE os OF
      'WIN32': begin & raw_library = 'raw_library_win32_64.so'  & dvd = '\' & end
      'LINUX': begin & raw_library = 'raw_library_linux_64.so'  & dvd = '/' & end
      'DARWIN':begin & raw_library = 'raw_library_darwin_64.so' & dvd = '/' & end
      ELSE: Message, 'Do not recognize this operating system.'
ENDCASE   

; define directory Path to raw library

lamd=sys_dep("GETENV","LAMP_DIR")
lib_path= lamd + dvd + 'plug_in' + dvd + raw_library
if (file_test(lib_path) EQ 0) then BEGIN
  print, 'library not found: ', lib_path
  Status = 11
  data = 0
  Return, data
endif

if (len GT MAX_FILE_NAME_LEN || len LT 1 ) then BEGIN 
    Status = 11
    data = 0
    print, " filename to long: length ", len
    Return, data
endif
for i=0,len-1 do b_filename[i] = byte(strmid(full_filename,i,1))
b_filename[len] = byte(0)
R=11L

R = CALL_EXTERNAL(lib_path,'open_data_file_pv',b_filename, /CDECL)
if (R NE 0) then BEGIN
  print,  'error in open data file: ', full_filename
  status = 11
  data = 0
  Return, data
END  


WHILE (R EQ 0 ) DO BEGIN
  ; open file for Header Element
  R= CALL_EXTERNAL(lib_path,'next_data_unit_pv', element_number,element_type,element,node,$
                             data_type,data_number, /CDECL)
  if (R EQ 1) then BEGIN
    print, ' Cant read the file', full_filenameDATPZ     = s_OMGS
    status = 24
    data = 0
  	Return, data
  endif
  if (R EQ 2) then BEGIN
  	break ; , 0L  
  	; end of file
  endif
  ; element DAT sortiren
  if (STRCOMPRESS(string(element), /REMOVE_ALL) EQ 'DAT' && data_type EQ CHARTYPE) then begin
    R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', char_buffer , /CDECL)
    if (R NE 0) then begin
    print, ' Cant read the file', full_filename
      status = 24
      data = 0
      Return, data
    endif
      DAT = string(char_buffer)
  endif
  ; element NUMOR 
  if (STRCOMPRESS(string(element), /REMOVE_ALL) EQ 'NUMOR' && data_type EQ LONGINTEGER) then begin
    R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', long_buffer , /CDECL)
    if (R NE 0) then begin
     print, ' Cant read the file', full_filename
      status = 24
      data = 0
      Return, data
    endif
    NUMOR = long_buffer[0]
  endif
  ; element EXPTYPE sortiren
  if (STRCOMPRESS(string(element), /REMOVE_ALL) EQ 'EXPTYPE' && data_type EQ CHARTYPE) then begin
    R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', char_buffer , /CDECL)
    if (R NE 0) then begin
    print, ' Cant read the file', full_filename
      status = 24
      data = 0
      Return, data
    endif
    CASE string(char_buffer)of
        'V1'    : exp_name     = string(char_buffer)
        'A2'    : exp_axes     = string(char_buffer)
        'ADET'  : exp_detector = string(char_buffer)
        'POWD'  : exp_kind     = string(char_buffer)
        'EULER' : exp_kind     = string(char_buffer)
        'GON'   : exp_kind     = string(char_buffer)
        'TEMP'  : exp_options  = string(char_buffer)
        'MAGF'  : exp_options  = string(char_buffer)
        
    ENDCASE
  endif
  ; element USN sortiren
  if (STRCOMPRESS(string(element), /REMOVE_ALL) EQ 'USN' && data_type EQ CHARTYPE) then begin
    R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', char_buffer , /CDECL)
    if (R NE 0) then begin
     print, ' Cant read the file', full_filename
      status = 24
      data = 0
      Return, data
    endif
    USN = string(char_buffer)
  endif
  ; element PROPOSAL sortiren
  if (STRCOMPRESS(string(element), /REMOVE_ALL) EQ 'PROPOSAL' && data_type EQ CHARTYPE) then begin
    R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', char_buffer , /CDECL)
    if (R NE 0) then begin
 print, ' Cant read the file', full_filename
      status = 24
      data = 0
      Return, data
    endif
    PROPOSAL = string(char_buffer)
  endif
  ; element WAV
  if (STRCOMPRESS(string(element), /REMOVE_ALL) EQ 'WAV' && data_type EQ REALTYPE) then begin
    R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', real_buffer , /CDECL)
    if (R NE 0) then begin
      ;' Cant read the file'
      status = 24
      data = 0
      Return, data
    endif
    WAV = real_buffer[0]
   ; print, 'testwAV: ', WAV
  endif
  ; element MM1
  if (STRCOMPRESS(string(element), /REMOVE_ALL) EQ 'MM1' ) then begin
    if (STRCOMPRESS(string(node), /REMOVE_ALL) EQ 'MON' )  then Mon_MODE = 'MON'
    if (STRCOMPRESS(string(node), /REMOVE_ALL) EQ 'TIM1')  then Mon_MODE = 'TIM1'  
  endif
  ; element RELA sortiren
  if (STRCOMPRESS(string(element),/REMOVE_ALL) EQ 'RELA' && STRCOMPRESS(string(node),/REMOVE_ALL) EQ 'TTHS' && data_type EQ REALTYPE ) then begin
    R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', real_buffer , /CDECL)
    if (R NE 0) then begin
      ;' Cant read the file'
      status = 24
      data = 0
      Return, data
    endif 
    for i = 0, data_number -1 do RELA_TTHS[i] = real_buffer[i]
   ; print, 'testrela_tths: ' , RELA_TTHS
  endif
  ; element RELA_NYS
  if (STRCOMPRESS(string(element),/REMOVE_ALL) EQ 'RELA' && STRCOMPRESS(string(node),/REMOVE_ALL) EQ 'NYS' && data_type EQ REALTYPE ) then begin
    R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', real_buffer , /CDECL)
    if (R NE 0) then begin
      ;' Cant read the file'
      status = 24
      data = 0
      Return, data
    endif
    for i = 0, data_number -1 do RELA_NYS[i] = real_buffer[i]
   ; print, 'testrela_nys: ' , RELA_NYS
  endif
  ; element SAM sortiren
  if (STRCOMPRESS(string(element),/REMOVE_ALL) EQ 'SAM' && data_type EQ CHARTYPE) then begin
    R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', char_buffer , /CDECL)
    if (R NE 0) then begin
      ;' Cant read the file'
      status = 24
      data = 0
      Return, data
    endif
    SAM = string(char_buffer)
      ;print, 'testsam: ' , SAM
  endif
  ; element SETV_STEP
  if (STRCOMPRESS(string(element),/REMOVE_ALL) EQ 'SETV'&& STRCOMPRESS(string(node),/REMOVE_ALL) EQ 'STEP' && data_type EQ INTEGERTYPE) then begin
    R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', int_buffer , /CDECL)
    if (R NE 0) then begin
      ;' Cant read the file'
      status = 24
      data = 0
      Return, data
    endif
    SETV_STEP = int_buffer[0]
  endif
  if (STRCOMPRESS(string(element),/REMOVE_ALL) EQ 'SETVALUE'&& STRCOMPRESS(string(node),/REMOVE_ALL) EQ 'STEP' && data_type EQ LONGINTEGER) then begin
    R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', long_buffer , /CDECL)
    if (R NE 0) then begin
      ;' Cant read the file'
      status = 24
      data = 0
      Return, data
    endif
    STEP_MAX = long_buffer[0]
  endif
  
ENDWHILE 

  if (numors LT act_numor) then begin
   PRINT, 'requested image # ',  act_numor , ' is larger than # of images ' , numors
  endif
; ##################################  close file
 R= CALL_EXTERNAL(lib_path,'close_data_file_pv', /CDECL)
  if (R NE 0) then BEGIN
   ; error in close data file, data incomplete
   status = 13
   Return, data
  endif else begin
   ;print, 'number of numors: ', numors
   status = 0
   
   if n_elements(FrameRange) eq 2 then begin
      if ((lastFrame EQ 0) && (firstFrame EQ 0)) then begin
	firstFrame =1
	lastFrame  = STEP_MAX
      endif 
      if (firstFrame GT STEP_MAX) then print, 'the firstFrame must be less than: ', STEP_MAX
      if (lastFrame GT STEP_MAX) then print, 'the lastFrame must be less than: ', STEP_MAX
      if ((firstFrame GT STEP_MAX) && (lastFrame GT STEP_MAX)) then begin
	print, ' the Framerange must be less than the step max: ', STEP_MAX
      endif else STEP_MAX = lastFrame - firstFrame +1   
   endif else begin
      firstFrame =1
      lastFrame  = STEP_MAX
   endelse
   
   
   ; definition of variable Array

   s_TTHS    = fltarr(STEP_MAX)
   s_OMGS    = fltarr(STEP_MAX)
   s_NYS     = fltarr(STEP_MAX)
   s_T_REG   = fltarr(STEP_MAX)
   s_T_SAM   = fltarr(STEP_MAX)
   s_T_MEAN  = fltarr(STEP_MAX)
   s_T_DELTA = fltarr(STEP_MAX)
   s_YSD     = fltarr(STEP_MAX)
   s_data    = fltarr(128,128,STEP_MAX)
   s_TIM1    = fltarr(STEP_MAX)
   s_CHIS    = fltarr(STEP_MAX)
   s_PHIS    = fltarr(STEP_MAX)
   s_T_SET   = fltarr(STEP_MAX)
   s_MON     = lonarr(STEP_MAX)
   s_TRANSM  = fltarr(STEP_MAX)
   s_OMGM    = fltarr(STEP_MAX)
   s_INCLM   = fltarr(STEP_MAX)
   s_FOCUSM  = fltarr(STEP_MAX)
   s_HGHT    = fltarr(STEP_MAX)
   s_MAGF    = fltarr(STEP_MAX)
   s_BALANCE = fltarr(STEP_MAX)
   s_STEP    = lonarr(STEP_MAX)
   
 ; ################################################################ 
 
 ; reopening file 
 
 R = CALL_EXTERNAL(lib_path,'open_data_file_pv',b_filename, /CDECL)
  if (R NE 0) then BEGIN
   print,  'error in open data file: ', full_filename
   status = 11
   data = 0
   Return, data
  endif
  
 WHILE (R EQ 0 ) DO BEGIN

   R= CALL_EXTERNAL(lib_path,'next_data_unit_pv', element_number,element_type,element,node,$
     data_type,data_number, /CDECL)
   if (R EQ 1) then BEGIN
     print, ' Cant read the file', full_filename
     status = 24
     data = 0
     Return, data
   endif
   if (R EQ 2) then BEGIN
     break ; , 0L
     
   endif ; end of file
  
  ; all READ element 
  if(STRCOMPRESS(string(element),/REMOVE_ALL) EQ 'READ') then begin
      if (STRCOMPRESS(string(node), /REMOVE_ALL) EQ 'JULABO1' && data_type EQ REALTYPE) then begin
        R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', real_buffer , /CDECL)
        if (R NE 0) then begin
          ;' Cant read the file'
          status = 24
          data = 0
          Return, data
        endif
        for i = 0, data_number -1 do JULABO1[i] = real_buffer[i]
       endif ; julabo1
      ; Read von Julabo2
       if (STRCOMPRESS(string(node),/REMOVE_ALL) EQ 'JULABO2' && data_type EQ REALTYPE) then begin
         R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', real_buffer , /CDECL)
         if (R NE 0) then begin
          ;' Cant read the file'
          status = 24
          data = 0
          Return, data
        endif
        for i = 0, data_number -1 do JULABO2[i] = real_buffer[i]
       endif ; julabo2
      ; Read von Julabo3
       if(STRCOMPRESS(string(node),/REMOVE_ALL) EQ 'JULABO3' && data_type EQ REALTYPE) then begin
        R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', real_buffer , /CDECL)
        if (R NE 0) then begin
          ;' Cant read the file'
          status = 24
          data = 0
          Return, data
        endif
        for i = 0, data_number -1 do JULABO3[i] = real_buffer[i]
      endif ; julabo3
        ; Read von TEMP
      if (STRCOMPRESS(string(node),/REMOVE_ALL) EQ 'TEMP' && data_type EQ REALTYPE) then begin
        R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', real_buffer , /CDECL)
        if (R NE 0) then begin
          ;' Cant read the file'
          status = 24
          data = 0
          Return, data
        endif
        for i = 0, data_number -1 do TEMP[i] = real_buffer[i]
        s_T_SET[*]= TEMP[0]
      endif ; TEMP
      ; Read von T_REG
      if (STRCOMPRESS(string(node),/REMOVE_ALL) EQ 'T_REG' && data_type EQ REALTYPE) then begin
        R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', real_buffer , /CDECL)
        if (R NE 0) then begin
          ;' Cant read the file'
          status = 24
          data = 0
          Return, data
        endif
      s_T_REG[*] = real_buffer[0]
      endif ; T_REG
      ; Read von T_SAM
      if (STRCOMPRESS(string(node), /REMOVE_ALL) EQ 'T_SAM' && data_type EQ REALTYPE) then begin
        R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', real_buffer , /CDECL)
        if (R NE 0) then begin
          ;' Cant read the file'
          status = 24
          data = 0
          Return, data
        endif
        s_T_SAM[*] = real_buffer[0]
      endif ; T_SAM
      ; Read von T_MEAN
      if (STRCOMPRESS(string(node),/REMOVE_ALL) EQ 'T_MEAN' && data_type EQ REALTYPE) then begin
        R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', real_buffer , /CDECL)
        if (R NE 0) then begin
          ;' Cant read the file'
          status = 24
          data = 0
          Return, data
        endif
        s_T_MEAN[*] = real_buffer[0]
      endif ; T_MEAN
      ; Read von T_DELTA
      if (STRCOMPRESS(string(node),/REMOVE_ALL) EQ 'T_DELTA' && data_type EQ REALTYPE) then begin
        R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', real_buffer , /CDECL)
        if (R NE 0) then begin
          ;' Cant read the file'
          status = 24
          data = 0
          Return, data
        endif
        s_T_DELTA[*] = real_buffer[0]
      endif ; T_DELTA
      ; Read von S1W
      if (STRCOMPRESS(string(node),/REMOVE_ALL) EQ 'S1W' && data_type EQ REALTYPE) then begin
        R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', real_buffer , /CDECL)
        if (R NE 0) then begin
          ;' Cant read the file'
          status = 24
          data = 0
          Return, data
        endif
        S1W = real_buffer[0]
      endif ; Read von S1W
      ; Read von S1X
      if(STRCOMPRESS(string(node), /REMOVE_ALL) EQ 'S1X' && data_type EQ REALTYPE) then begin
        R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', real_buffer , /CDECL)
        if (R NE 0) then begin
          ;' Cant read the file'
          status = 24
          data = 0
          Return, data
        endif
        S1X = real_buffer[0]
      endif ; Read von S1X
      ; Read von S1H
      if (STRCOMPRESS(string(node), /REMOVE_ALL) EQ 'S1H' && data_type EQ REALTYPE) then begin
        R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', real_buffer , /CDECL)
        if (R NE 0) then begin
          ;' Cant read the file'
          status = 24
          data = 0
          Return, data
        endif
        S1H = real_buffer[0]
      endif ; Read S1H
      ; Read von S1Y
      if (STRCOMPRESS(string(node), /REMOVE_ALL) EQ 'S1Y' && data_type EQ REALTYPE) then begin
        R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', real_buffer , /CDECL)
        if (R NE 0) then begin
          ;' Cant read the file'
          status = 24
          data = 0
          Return, data
        endif
        S1Y = real_buffer[0]
      endif ; Read S1Y
      ; Read von S1L
      if (STRCOMPRESS(string(node), /REMOVE_ALL) EQ 'S1L' && data_type EQ REALTYPE) then begin
        R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', real_buffer , /CDECL)
        if (R NE 0) then begin
          ;' Cant read the file'
          status = 24
          data = 0
          Return, data
        endif
        S1L = real_buffer[0]
      endif ; Read S1L
      ; Read von S1R
      if (STRCOMPRESS(string(node), /REMOVE_ALL) EQ 'S1R' && data_type EQ REALTYPE) then begin
        R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', real_buffer , /CDECL)
        if (R NE 0) then begin
          ;' Cant read the file'
          status = 24
          data = 0
          Return, data
        endif
        S1R = real_buffer[0]
      endif ; Read S1R
      ; Read von S1B
      if (STRCOMPRESS(string(node), /REMOVE_ALL) EQ 'S1B' && data_type EQ REALTYPE) then begin
        R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', real_buffer , /CDECL)
        if (R NE 0) then begin
          ;' Cant read the file'
          status = 24
          data = 0
          Return, data
        endif
        S1B = real_buffer[0]
      endif ; Read S1B
      ; Read von S1T
      if (STRCOMPRESS(string(node), /REMOVE_ALL) EQ 'S1T' && data_type EQ REALTYPE) then begin
        R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', real_buffer , /CDECL)
        if (R NE 0) then begin
          ;' Cant read the file'
          status = 24
          data = 0
          Return, data
        endif
        S1T = real_buffer[0]
      endif ; Read S1T
      ; Read von S2W
      if(STRCOMPRESS(string(node), /REMOVE_ALL) EQ 'S2W' && data_type EQ REALTYPE) then begin
        R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', real_buffer , /CDECL)
        if (R NE 0) then begin
          ;' Cant read the file'
          status = 24
          data = 0
          Return, data
        endif
        S2W = real_buffer[0]
      endif ; Read S2W
      ; Read von S2X
      if (STRCOMPRESS(string(node), /REMOVE_ALL) EQ 'S2X' && data_type EQ REALTYPE) then begin
        R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', real_buffer , /CDECL)
        if (R NE 0) then begin
          ;' Cant read the file'
          status = 24
          data = 0
          Return, data
        endif
        S2X = real_buffer[0]
      endif ; Read S2X
      ; Read von S2H
      if (STRCOMPRESS(string(node), /REMOVE_ALL) EQ 'S2H' && data_type EQ REALTYPE) then begin
        R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', real_buffer , /CDECL)
        if (R NE 0) then begin
          ;' Cant read the file'
          status = 24
          data = 0
          Return, data
        endif
        S2H = real_buffer[0]
      endif ; Read S2H
      ; Read von S2Y
      if (STRCOMPRESS(string(node), /REMOVE_ALL) EQ 'S2Y' && data_type EQ REALTYPE) then begin
        R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', real_buffer , /CDECL)
        if (R NE 0) then begin
          ;' Cant read the file'
          status = 24
          data = 0
          Return, data
        endif
        S2Y = real_buffer[0]
        ;print, 'testS2Y: ', S2Y
       endif ; Read S2Y
       ; Read von S2L
       if (STRCOMPRESS(string(node), /REMOVE_ALL)EQ 'S2L' && data_type EQ REALTYPE) then begin
         R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', real_buffer , /CDECL)
         if (R NE 0) then begin
           ;' Cant read the file'
           status = 24
           data = 0
           Return, data
         endif
         S2L = real_buffer[0]
       endif ; Read S2L
       ; Read von S2R
       if (STRCOMPRESS(string(node), /REMOVE_ALL) EQ 'S2R' && data_type EQ REALTYPE) then begin
         R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', real_buffer , /CDECL)
         if (R NE 0) then begin
           ;' Cant read the file'
           status = 24
           data = 0
           Return, data
         endif
         S2R = real_buffer[0]
       endif ; Read S2R
       ; Read von S2B
       if (STRCOMPRESS(string(node), /REMOVE_ALL) EQ 'S2B' && data_type EQ REALTYPE) then begin
         R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', real_buffer , /CDECL)
         if (R NE 0) then begin
           ;' Cant read the file'
           status = 24
           data = 0
           Return, data
         endif
         S2B = real_buffer[0]
       endif ; Read S2B
       ; Read von S2T
       if (STRCOMPRESS(string(node), /REMOVE_ALL) EQ 'S2T' && data_type EQ REALTYPE) then begin
         R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', real_buffer , /CDECL)
         if (R NE 0) then begin
           ;' Cant read the file'
           status = 24
           data = 0
           Return, data
         endif
         S2T = real_buffer[0]
       endif ; Read S2T
       ; Read von YSD
       if (STRCOMPRESS(string(node), /REMOVE_ALL) EQ 'YSD' && data_type EQ REALTYPE) then begin
         R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', real_buffer , /CDECL)
         if (R NE 0) then begin
           ;' Cant read the file'
           status = 24
           data = 0
           Return, data
         endif
         s_YSD[*] = real_buffer[0]
       endif ; Read YSD
       ; Read von NYS
       if (STRCOMPRESS(string(node), /REMOVE_ALL) EQ 'NYS' && data_type EQ REALTYPE) then begin
         R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', real_buffer , /CDECL)
         if (R NE 0) then begin
           ;' Cant read the file'
           status = 24
           data = 0
           Return, data
         endif
         s_NYS[*] = real_buffer[0]
       endif ; Read NYS
       ; Read von HGHT
       if (STRCOMPRESS(string(node), /REMOVE_ALL) EQ 'HGHT' && data_type EQ REALTYPE) then begin
         R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', real_buffer , /CDECL)
         if (R NE 0) then begin
           ;' Cant read the file'
           status = 24
           data = 0
           Return, data
         endif
         s_HGHT = real_buffer[0]
       endif ; Read HGHT
       ; Read von TTHS
       if (STRCOMPRESS(string(node), /REMOVE_ALL) EQ 'TTHS' && data_type EQ REALTYPE) then begin
         R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', real_buffer , /CDECL)
         if (R NE 0) then begin
           ;' Cant read the file'
           status = 24
           data = 0
           Return, data
         endif
         s_TTHS[*] = real_buffer[0]
       endif ; Read TTHS
       ; Read von OMGS
       if (STRCOMPRESS(string(node), /REMOVE_ALL) EQ 'OMGS' && data_type EQ REALTYPE) then begin
         R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', real_buffer , /CDECL)
         if (R NE 0) then begin
           ;' Cant read the file'
           status = 24
           data = 0
           Return, data
         endif
         s_OMGS[*] = real_buffer[0]
         ;print, 'testOMGS: ', OMGS
       endif ; Read OMGS
       ; Read von CHIS
       if (STRCOMPRESS(string(node), /REMOVE_ALL) EQ 'CHIS' && data_type EQ REALTYPE) then begin
         R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', real_buffer , /CDECL)
         if (R NE 0) then begin
           ;' Cant read the file'
           status = 24
           data = 0
           Return, data
         endif
         s_CHIS[*] = real_buffer[0]
       endif ; Read CHIS
       ; Read von PHIS
       if (STRCOMPRESS(string(node), /REMOVE_ALL) EQ 'PHIS' && data_type EQ REALTYPE) then begin
         R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', real_buffer , /CDECL)
         if (R NE 0) then begin
           ;' Cant read the file'
           status = 24
           data = 0
           Return, data
         endif
         s_PHIS[*] = real_buffer[0]
         ;print, 'testPHIS: ', PHIS
       endif ; Read PHIS
       ; Read von TRANSM
       if (STRCOMPRESS(string(node), /REMOVE_ALL) EQ 'TRANSM' && data_type EQ REALTYPE) then begin
         R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', real_buffer , /CDECL)
         if (R NE 0) then begin
           ;' Cant read the file'
           status = 24
           data = 0
           Return, data
         endif
         s_TRANSM[*] = real_buffer[0]
       endif ; Read TRANSM
       ; Read von OMGM
       if (STRCOMPRESS(string(node), /REMOVE_ALL) EQ 'OMGM' && data_type EQ REALTYPE) then begin
         R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', real_buffer , /CDECL)
         if (R NE 0) then begin
           ;' Cant read the file'
           status = 24
           data = 0
           Return, data
         endif
         s_OMGM[*] = real_buffer[0]
       endif ; Read OMGM
       ; Read von INCLM
       if (STRCOMPRESS(string(node), /REMOVE_ALL)EQ 'INCLM' && data_type EQ REALTYPE) then begin
         R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', real_buffer , /CDECL)
         if (R NE 0) then begin
           ;' Cant read the file'
           status = 24
           data = 0
           Return, data
         endif
         s_INCLM[*] = real_buffer[0]
       endif ; Read INCLM
       ; Read von FOCUSM
       if (STRCOMPRESS(string(node), /REMOVE_ALL) EQ 'FOCUSM' && data_type EQ REALTYPE) then begin
         R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', real_buffer , /CDECL)
         if (R NE 0) then begin
           ;' Cant read the file'
           status = 24
           data = 0
           Return, data
         endif
         s_FOCUSM[*] = real_buffer[0]
       endif ; Read FOCUSM
       ; Read von TTHMI
       if (STRCOMPRESS(string(node), /REMOVE_ALL) EQ 'TTHMI' && data_type EQ REALTYPE) then begin
         R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', real_buffer , /CDECL)
         if (R NE 0) then begin
           ;' Cant read the file'
           status = 24
           data = 0
           Return, data
         endif
         TTHMI = real_buffer[0]
       endif ; Read TTHMI
       ; Read von TTHMA
       if (STRCOMPRESS(string(node), /REMOVE_ALL) EQ 'TTHMA' && data_type EQ REALTYPE) then begin
         R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', real_buffer , /CDECL)
         if (R NE 0) then begin
           ;' Cant read the file'
           status = 24
           data = 0
           Return, data
         endif
         TTHMA = real_buffer[0]
       endif ; Read TTHMA
       ; Read von MAGF
       if (STRCOMPRESS(string(node), /REMOVE_ALL) EQ 'MAGF' && data_type EQ REALTYPE) then begin
         R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', real_buffer , /CDECL)
         if (R NE 0) then begin
           ;' Cant read the file'
           status = 24
           data = 0
           Return, data
         endif
         s_MAGF = real_buffer[0]
       endif ; Read MAGF
       ; Read von BALANCE
       if (STRCOMPRESS(string(node), /REMOVE_ALL) EQ 'BALANCE' && data_type EQ REALTYPE) then begin
         R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', real_buffer , /CDECL)
         if (R NE 0) then begin
           ;' Cant read the file'
           status = 24
           data = 0
           Return, data
         endif
         s_BALANCE = real_buffer[0]
       endif ; Read BALANCE 
     endif   ; element Read
     
              ; element SGEN1
     if(STRCOMPRESS(string(element), /REMOVE_ALL) EQ 'SGEN1') then begin
       if (STRCOMPRESS(string(node), /REMOVE_ALL) EQ 'STEP' && data_type EQ INTEGERTYPE) then begin
         R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', int_buffer , /CDECL)
         if (R NE 0) then begin
           ;' Cant read the file'
           status = 24
           data = 0
           Return, data
         endif
          STEP_REQUESTED = int_buffer[0]
       endif ; node Step
       if (STRCOMPRESS(string(node), /REMOVE_ALL) EQ 'TTHS' && data_type EQ REALTYPE) then begin
         R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', real_buffer , /CDECL)
         if (R NE 0) then begin
           ;' Cant read the file'
           status = 24
           data = 0
           Return, data
         endif
         for i = 0, data_number -1 do TTHS_SGEN1[i] = real_buffer[i]
         ;print, 'testTTHS_SGEN1: ' , TTHS_SGEN1
       endif ; node OMGS_SGEN1
       if (STRCOMPRESS(string(node), /REMOVE_ALL) EQ 'OMGS' && data_type EQ REALTYPE) then begin
         R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', real_buffer , /CDECL)
         if (R NE 0) then begin
           ;' Cant read the file'
           status = 24
           data = 0
           Return, data
         endif
         for i = 0, data_number -1 do OMGS_SGEN1[i] = real_buffer[i]
         ;print, 'testOMGS_SGEN1: ' , OMGS_SGEN1
       endif ; node OMGS_SGEN1
       
   endif ; elment SGEN1
         ; element SGEN
   if(STRCOMPRESS(string(element), /REMOVE_ALL) EQ 'SGEN') then begin
     if (STRCOMPRESS(string(node), /REMOVE_ALL) EQ 'STEP' && data_type EQ INTEGERTYPE) then begin
       R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', int_buffer , /CDECL)
       if (R NE 0) then begin
         ;' Cant read the file'
         status = 24
         data = 0
         Return, data
       endif
       STEP_REQUESTED = int_buffer[0]
     endif ; node Step
     if (STRCOMPRESS(string(node), /REMOVE_ALL) EQ 'TTHS' && data_type EQ REALTYPE) then begin
       R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', real_buffer , /CDECL)
       if (R NE 0) then begin
         ;' Cant read the file'
         status = 24
         data = 0
         Return, data
       endif
        TTHS_SGEN = real_buffer[0]
     endif ; node TTHS_SGEN
            ;Node DTTHS
     if (STRCOMPRESS(string(node), /REMOVE_ALL) EQ 'DTTHS' && data_type EQ REALTYPE) then begin
       R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', real_buffer , /CDECL)
       if (R NE 0) then begin
         ;' Cant read the file'
         status = 24
         data = 0
         Return, data
       endif
       DTTHS_SGEN = real_buffer[0]
     endif ; node DTTHS_SGEN
     if (STRCOMPRESS(string(node), /REMOVE_ALL) EQ 'OMGS' && data_type EQ REALTYPE) then begin
       R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', real_buffer , /CDECL)
       if (R NE 0) then begin
         ;' Cant read the file'
         status = 24
         data = 0
         Return, data
       endif
       OMGS_SGEN = real_buffer[0]
     endif ; node OMGS_SGEN
            ; Node DOMGS
     if (STRCOMPRESS(string(node), /REMOVE_ALL) EQ 'DOMGS' && data_type EQ REALTYPE) then begin
       R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', real_buffer , /CDECL)
       if (R NE 0) then begin
         ;' Cant read the file'
         status = 24
         data = 0
         Return, data
       endif
       DOMGS_SGEN = real_buffer[0]
     endif ; node DOMGS_SGEN
   endif ; elment SGEN
   
   if ( STRCOMPRESS(string(element), /REMOVE_ALL) EQ 'DATE' && data_type EQ CHARTYPE) then begin
     R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', char_buffer , /CDECL)
     if (R NE 0) then begin
       ;' Cant read the file'
       status = 24
       data = 0
       Return, data
     endif
     if (DATE_FIRST) THEN BEGIN
       DATE_START = string(char_buffer)
       DATE_FIRST = 0   
     endif ELSE BEGIN
       DATE_STOP = string(char_buffer)
       DATE_FIRST = 1
     ENDELSE
   endif ; DATE
   if ( STRCOMPRESS(string(element), /REMOVE_ALL) EQ 'TIME' && data_type EQ CHARTYPE) then begin
     R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', char_buffer , /CDECL)
     if (R NE 0) then begin
       ;' Cant read the file'
       status = 24
       data = 0
       Return, data
     endif
     if (TIME_FIRST) THEN BEGIN
       TIME_START = string(char_buffer)
       TIME_FIRST = 0
       ;PRINT, 'TIME_START: ', TIME_START
     endif ELSE BEGIN
       TIME_STOP = string(char_buffer)
       TIME_FIRST = 1
     ENDELSE
     
   endif ; END TIME
   
   if ( STRCOMPRESS(string(element), /REMOVE_ALL) EQ 'COM' && data_type EQ CHARTYPE) then begin
     R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', char_buffer , /CDECL)
     if (R NE 0) then begin
       ;' Cant read the file'
       status = 24
       data = 0
       Return, data
     endif
       COM[COM_COUNT] = string(char_buffer)
       COM_COUNT = COM_COUNT-1
   endif ; COM
   
  ; ################################################################################################################################
   ; setvalue
   
  if (string(element) EQ "SETVALUE" && string(last_element) NE "SETVALUE") then numors++
  last_element = element 
      
      ;if(numors EQ LONG(act_numor) || numors EQ 0) then begin
      
          ; ELEMENT SETVALUE SORTIEREN
          
          if( STRCOMPRESS(string(element), /REMOVE_ALL) EQ 'SETVALUE') then begin
            SCAN_NODE = STRCOMPRESS(string(node), /REMOVE_ALL)
            if (STRCOMPRESS(string(node), /REMOVE_ALL) EQ 'STEP' && data_type EQ LONGINTEGER)then begin
            R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', long_buffer , /CDECL)
            if (R NE 0) then begin
              ;' Cant read the file'
              status = 24
              data = 0
              Return, data
            endif
            STEP = long_buffer[0]
            s_STEP = long_buffer[0]
            endif ; STEP  SETVALUE
            if ((STEP LT firstFrame) || (STEP GT lastFrame)) then continue
                
            ;  ELEMENT SETVALUE TTHS
            if (STRCOMPRESS(string(node), /REMOVE_ALL) EQ 'TTHS' && data_type EQ REALTYPE) then begin
            R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', real_buffer , /CDECL)
            if (R NE 0) then begin
              ;' Cant read the file'
              status = 24
              data = 0
              Return, data
            endif
            s_TTHS[STEP-firstFrame]= real_buffer[0]
            
            endif ; TTHS  SETVALUE
            ;  ELEMENT SETVALUE OMGS
            if (STRCOMPRESS(string(node), /REMOVE_ALL) EQ 'OMGS' && data_type EQ REALTYPE) then begin
              R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', real_buffer , /CDECL)
              if (R NE 0) then begin
                ;' Cant read the file'
                status = 24
                data = 0
                Return, data
              endif
              s_OMGS[STEP- firstFrame] = real_buffer[0]
            endif ; OMGS  SETVALUE
            ; ELEMENT SETVALUE  NODE CHIS
            if (STRCOMPRESS(string(node), /REMOVE_ALL) EQ 'CHIS' && data_type EQ REALTYPE) then begin
              R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', real_buffer , /CDECL)
              if (R NE 0) then begin
                ;' Cant read the file'
                status = 24
                data = 0
                Return, data
              endif
              s_CHIS[STEP- firstFrame] = real_buffer[0]
            endif ; CHIS  SETVALUE
            ; ELEMENT SETVALUE  NODE PHIS
            if (STRCOMPRESS(string(node), /REMOVE_ALL) EQ 'PHIS' && data_type EQ REALTYPE) then begin
              R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', real_buffer , /CDECL)
              if (R NE 0) then begin
                ;' Cant read the file'
                status = 24
                data = 0
                Return, data
              endif
              s_PHIS[STEP- firstFrame] = real_buffer[0]
            endif ; PHIS  SETVALUE
            ; ELEMENT SETVALUE  NODE TEMP
            if (STRCOMPRESS(string(node), /REMOVE_ALL) EQ 'TEMP' && data_type EQ REALTYPE) then begin
              R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', real_buffer , /CDECL)
              if (R NE 0) then begin
                ;' Cant read the file'
                status = 24
                data = 0
                Return, data
              endif
              s_T_SET[STEP- firstFrame] = real_buffer[0]
            endif ; TEMP  SETVALUE
          endif ; ELEMENT SETVALUE
          
   ; ###############################################################################################################
          ; ALL  MASTER1V ELEMENT SORTIEREN
          
          if( STRCOMPRESS(string(element), /REMOVE_ALL) EQ 'MASTER1V') then begin
            if ((STEP LT firstFrame) || (STEP GT lastFrame)) then continue
            if (STRCOMPRESS(string(node), /REMOVE_ALL) EQ 'MON' && data_type EQ LONGINTEGER) then begin
              R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', long_buffer , /CDECL)
              if (R NE 0) then begin
                ;' Cant read the file'
                status = 24
                data = 0
                Return, data
              endif
              s_MON = long_buffer[0]
            endif ; MON  SETVALUE
            
            ; ELEMENT MASTER1V  NODE TTHS
            if (STRCOMPRESS(string(node), /REMOVE_ALL) EQ 'TTHS' && data_type EQ REALTYPE) then begin
              R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', real_buffer , /CDECL)
              if (R NE 0) then begin
                ;' Cant read the file'
                status = 24
                data = 0
                Return, data
              endif
              s_TTHS[STEP- firstFrame] = real_buffer[0]
            endif ; TTHS  MASTER1V
            ;  ELEMENT MASTER1V NODE  NYS
            if (STRCOMPRESS(string(node), /REMOVE_ALL) EQ 'NYS' && data_type EQ REALTYPE) then begin
              R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', real_buffer , /CDECL)
              if (R NE 0) then begin
                ;' Cant read the file'
                status = 24
                data = 0
                Return, data
              endif
              s_NYS[STEP- firstFrame] = real_buffer[0]
            endif ; NYS  MASTER1V
            ;  ELEMENT MASTER1V NODE  YSD
            if (STRCOMPRESS(string(node), /REMOVE_ALL) EQ 'YSD' && data_type EQ REALTYPE) then begin
              R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', real_buffer , /CDECL)
              if (R NE 0) then begin
                ;' Cant read the file'
                status = 24
                data = 0
                Return, data
              endif
              s_YSD[STEP- firstFrame] = real_buffer[0]
            endif ; YSD  MASTER1V
            ;  ELEMENT MASTER1V NODE  ADET
            if (STRCOMPRESS(string(node), /REMOVE_ALL) EQ 'ADET' && data_type EQ LONGINTEGER) then begin
              R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', long_buffer , /CDECL)
              if (R NE 0) then begin
                ;' Cant read the file'
                status = 24
                data = 0
                Return, data
              endif
              data = reform(long_buffer , 128, 128)
              data = rotate(data,7)
              s_data[*,*, STEP- firstFrame]= data
             
            endif ; ADET  MASTER1V
            ; ELEMENT MASTER1V  NODE T_REG
            if (STRCOMPRESS(string(node), /REMOVE_ALL) EQ 'T_REG' && data_type EQ REALTYPE) then begin
              R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', real_buffer , /CDECL)
              if (R NE 0) then begin
                ;' Cant read the file'
                status = 24
                data = 0
                Return, data
              endif
              s_T_REG[STEP- firstFrame] = real_buffer[0]
            endif ; T_REG  MASTER1V
            ; ELEMENT MASTER1V  NODE T_SAM
            if (STRCOMPRESS(string(node), /REMOVE_ALL) EQ 'T_SAM' && data_type EQ REALTYPE) then begin
              R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', real_buffer , /CDECL)
              if (R NE 0) then begin
                ;' Cant read the file'
                status = 24
                data = 0
                Return, data
              endif
              s_T_SAM[STEP- firstFrame] = real_buffer[0]
            endif ; T_SAM  MASTER1V
            ; ELEMENT MASTER1V  NODE T_MEAN
            if (STRCOMPRESS(string(node), /REMOVE_ALL) EQ 'T_MEAN' && data_type EQ REALTYPE) then begin
              R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', real_buffer , /CDECL)
              if (R NE 0) then begin
                ;' Cant read the file'
                status = 24
                data = 0
                Return, data
              endif
              s_T_MEAN[STEP- firstFrame] = real_buffer[0]
            endif ; T_MEAN  MASTER1V
            ; ELEMENT MASTER1V  NODE T_DELTA
            if (STRCOMPRESS(string(node), /REMOVE_ALL) EQ 'T_DELTA' && data_type EQ REALTYPE) then begin
              R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', real_buffer , /CDECL)
              if (R NE 0) then begin
                ;' Cant read the file'
                status = 24
                data = 0
                Return, data
              endif
              s_T_DELTA[STEP- firstFrame] = real_buffer[0]
            endif ; T_DELTA  MASTER1V
    
            ;  ELEMENT MASTER1V NODE  TIM1
            if (STRCOMPRESS(string(node), /REMOVE_ALL) EQ 'TIM1' && data_type EQ LONGINTEGER) then begin
              R= CALL_EXTERNAL(lib_path,'get_data_unit_pv', long_buffer , /CDECL)
              if (R NE 0) then begin
                ;' Cant read the file'
                status = 24
                data = 0
                Return, data
              endif
              s_TIM1[STEP- firstFrame] = long_buffer[0]
            endif ; TIM1  MASTER1V
          endif ;ELEMENT MASTER1V
ENDWHILE ;end of the element sorting
 ;######################################################################################################################
 
 if (numors LT act_numor) then begin
    PRINT, 'requested image # ',  act_numor , ' is larger than # of images ' , numors 
 endif
 
	R= CALL_EXTERNAL(lib_path,'close_data_file_pv', /CDECL)
	if (R NE 0) then BEGIN
	; error in close data file, data incomplete
	status = 13
	Return, data
	endif else begin
	status = 0
	
 ;;;;;;; setting of the mask
 
if (inst[2] eq '0') then begin ; /noRAW switch
mask_x0 = 5
mask_x1 = 122
mask_y0 = 5
mask_y1 = 122
s_data = s_data[mask_x0:mask_x1,mask_y0:mask_y1,*]
endif

dim_xy=sqrt(n_elements(s_data)/STEP_MAX) ; equal dimension in X and Y assumed
reso    = 0.15 ; detector resolution defined as .15   RELA_TTHS[2]    ; in cm
offset = floor(dim_xy/2)

;;;;;;; setting of calibration file

S_DATA = float(S_DATA)
IF n_elements(cal_v1) eq 0 THEN P_DID_CALOD, 'v1' , 'v1.cal', flg ; Default calib. file
IF n_elements(cal_v1) eq (n_elements (s_data)/STEP_MAX) THEN BEGIN   ;sx,sy,STEP_MAX are the dimensions of DATA
     FOR i=0,STEP_MAX-1 DO S_DATA[*,*,i]  /=  cal_v1    ;STEP_MAX should be >= 1
     ;data /= cal_v1
      DATPOTHER_TIT = DATPOTHER_TIT +' /'+inf_v1[0] ;Other_tit
 ENDIF else print, ' ATTENTION: calibration file with wrong dimension, ', sqrt(n_elements(cal_v1))
 
;;;;;;;;setting of the parameter structure

        for i=0, STEP_MAX-1 do begin
	  if (s_YSD[i] GT 800) THEN s_YSD[i] = s_YSD[i]/10.0  ; CONVERT YSD TO CENTIMETER
	endfor

	DATPX     = fltarr(dim_xy,  Step_max)
	DATPY     = fltarr(dim_xy,  Step_max)
	;DATPN    = [s_TIM1/100.0, s_MON, total(data)] ; time in second
	if (Mon_MODE EQ 'TIM1') then begin
	  Monitor_MODE =1.0
	  DATPN     = s_TIM1/100.0
	endif 
	if (Mon_MODE EQ 'MON') then begin
	  Monitor_MODE = 0.0
	  if (s_MON[0] LE 10 ) then begin
	    DATPN     = s_TIM1/100.0		; in case of no Monitor count
	  endif else DATPN = s_MON
	endif
	
	
	
	DATPE     = SQRT(s_data)
	for i=0, step_max -1 do DATPX[*,i]  = atan( (findgen(dim_xy) -offset)* reso/s_YSD[i])*180/!pi+ s_TTHS[i]; twotheta axis
	for i=0, step_max -1 do DATPY[*,i]  = atan( (findgen(dim_xy)-offset)* reso/s_YSD[i])*180/!pi+ s_NYS[i] ; Y axis
	
	CASE SCAN_NODE OF
	  'TEMP':    DATPZ= s_T_SAM
	  'TTHS':    DATPZ= s_TTHS
	  'OMGS':    DATPZ= s_OMGS
	  'CHIS':    DATPZ= s_CHIS
	  'PHIS':    DATPZ= s_PHIS
	  'NYS':     DATPZ= s_NYS     
	  'TRANSM':  DATPZ= s_TRANSM  
	  'OMGM':    DATPZ= s_OMGM   
	  'INCLM':   DATPZ= s_INCLM  
	  'FOCUSM':  DATPZ= s_FOCUSM 
	  'HGHT':    DATPZ= s_HGHT
	  'MAGF':    DATPZ= s_MAGF    
	  'BALANCE': DATPZ= s_BALANCE 
	 ELSE:       DATPZ= s_STEP
	ENDCASE
	DATPW_TIT = com[0] + com[1] + ' sample: ' + SAM
	DATPX_TIT = '2 theta X (degree)'
	DATPY_TIT = '2 theta Y (degree)'
	DATPZ_TIT = SCAN_NODE
	DATPOTHER_TIT =  short_filename  $
	              + ' # '         + act_numor       $
	              + ' user: '     + USN             $
	              + ' proposal: ' + PROPOSAL        $
	              +'  date: '     + DATE_START      $
	              + ' '           + TIME_START 
	DATPTIME  = 'saved: '+ DATE_STOP+ ' ' + TIME_STOP
	
	; Now write the parameter in the DATP.P
	P = dblarr(40)    & PAR_TXT = strarr(40)    
  P[0]= s_TTHS[0]        & PAR_TXT[0] =  ' 00 2 theta'
  P[1]= s_OMGS[0]       & PAR_TXT[1] =  ' 01 omega'
  P[2]= s_CHIS[0]        & PAR_TXT[2] =  ' 02 chi'
  P[3]= s_PHIS[0]        & PAR_TXT[3] =  ' 03 phi'
  P[4]= 0           & PAR_TXT[4] =  ' 04 trans_x'
  P[5]= 0           & PAR_TXT[5] =  ' 05 trans_y'
  P[6]= 0           & PAR_TXT[6] =  ' 06 rot'
  P[7]= 0           & PAR_TXT[7] =  ' 07 beamstop'
  P[8]= WAV         & PAR_TXT[8] =  ' 08  wavlength'
  P[9]= TEMP[0]     & PAR_TXT[9] =  ' 09 requested temperature'
  P[10]= s_T_REG[0]      & PAR_TXT[10] = ' 10 regulation temperature'
  P[11]= s_T_SAM[0]     & PAR_TXT[11] = ' 11 sample temperature'
  P[12]= s_YSD[0]        & PAR_TXT[12] = ' 12 sample detector distance (cm)'  
  P[13]= 0          & PAR_TXT[13] = ' 13 starting angel'
  P[14]= 0          & PAR_TXT[14] = ' 14 variation'
  P[15]= 0          & PAR_TXT[15] = ' 15 angel range'
  P[16]= s_TIM1[0]*10.0  & PAR_TXT[16] = ' 16 preset (mili sec)'
  P[17]= 0          & PAR_TXT[17] = ' 17 coupling factor'
  P[18]= 0          & PAR_TXT[18] = ' 18 motor scan'
  P[19]= STEP_REQUESTED   & PAR_TXT[19] = ' 19 steps requested'
  P[20]= STEP_MAX   & PAR_TXT[20] = ' 20 steps saved'
  P[21]= Monitor_MODE         & PAR_TXT[21] = ' 21 count:monitor (0) or time (1)'
  P[22]= 0          & PAR_TXT[22] = ' 22 type of T-regulation'
  P[23]= 0          & PAR_TXT[23] = ' 23 type of Multi-meter'
  P[24]= 0          & PAR_TXT[24] = ' 24 delta 2theta'
  P[25]= 0          & PAR_TXT[25] = ' 25 unsed'
  P[26]= double(filename)  & PAR_TXT[26] = ' 26 numor'
  P[27]= 0          & PAR_TXT[27] = ' 27 attenuator type'
  P[28]= 0          & PAR_TXT[28] = ' 28 ATT IN/OUT'
  P[29]= 0          & PAR_TXT[29] = ' 29 unsed'
  P[30]= 0          & PAR_TXT[30] = ' 30 unsed'
  P[31]= 0          & PAR_TXT[31] = ' 31 unsed'
  P[32]= S2W        & PAR_TXT[32] = ' 32 slit width'
  P[33]= S2H        & PAR_TXT[33] = ' 33 slit hight'
  P[34]= s_YSD[0]/100.0    & PAR_TXT[34] = ' 34 sample detector distance (m)'
  P[35]= 0          & PAR_TXT[35] = ' 35 unsed'
  P[36]= 0          & PAR_TXT[36] = ' 36 unsed'
  P[37]= s_TIM1[0]/100.0 & PAR_TXT[37] = ' 37 preset (second)'
  P[38]= s_MON[0]          & PAR_TXT[38] = ' 38 preset Monitor'
  P[39]= 0          & PAR_TXT[39] = ' 39 unsed'
  
  ; now into structure DATP
  
  DATP= {  X:          DATPX,      $
           Y:          DATPY,      $
           Z:          DATPZ,      $
           W_TIT:      DATPW_TIT,  $
           X_TIT:      DATPX_TIT,  $
           Y_TIT:      DATPY_TIT,  $
           Z_TIT:      DATPZ_TIT,  $
           N:          DATPN,      $
           E:          DATPE,      $
           OTHER_TIT:  DATPOTHER_TIT, $
           TIME:       DATPTIME ,  $
           P:          P,          $
           PAR_TXT:    PAR_TXT     }

	Return, s_data
	;Successful read 
	endelse 
	END 
Catch, /cancel
end; function