function bin_as, Win , as=Was , X=Xc , Y=Yc , dpin=dpin , dpas=dpas
;+
;******* ******
;**
;** rebin Win as Was   :  (one, two, three dimensionnal data)
;** /X rebin the X axis:  (default)
;** /Y rebin the Y axis:  (/X or /Y , booth not supported)
;** dpin= datp for Win    (if the call do not come from a Do command)
;** dpas= datp for Was    ("")
;**
;** D.Richard Jun 2007 (suggested by A.Murani)
;**           Jul 2011 added dpin,dpas (for prox_sheet)
;-

;Check for dimensions
sizas=size(was) & sizin=size(win) & szyas=sizas[2]  & szyin=sizin[2]
if sizas[0] eq 1  then  szyas=1   & if sizin[0] eq 1 then szyin=1
if sizin[0] lt 3  then  sz  =1 else sz=sizin[3]
szxin=sizin[1] & szxas=sizas[1]

;Check for keywords in call
if sizas[0] eq 1                                   then Xc=1
if (not keyword_set(Xc)) and (not keyword_set(yc)) then Xc=1
if (n_elements(dpin) eq 1) and (n_elements(dpas) eq 1) then DPok=1 else DPok=0

;Return if nothing to do
if (keyword_set(Xc)) and (szxin eq szxas) then return,win
if (keyword_set(Yc)) and (szyin eq szyas) then return,win

;Check for data parameters
if not DPok then TAKE_DATP,dpin,/second & Xin=dpin.X & Yin=dpin.Y & Ein=dpin.E
if not DPok then TAKE_DATP,dpas,/third  & Xas=dpas.X & Yas=dpas.Y & Eas=dpas.E

sxas=size(Xas) & if sxas[0] eq 2 then sxas=sxas[2]-1 else sxas=0
sxin=size(Xin) & if sxin[0] eq 2 then sxin=sxin[2]-1 else sxin=0
syas=size(Yas) & if syas[0] eq 2 then syas=syas[2]-1 else syas=0
syin=size(Yin) & if syin[0] eq 2 then syin=syin[2]-1 else syin=0

;Check for errors
if n_elements(Eas) eq n_elements(Was) then Eok=1  else Eok=0
if n_elements(Ein) ne n_elements(Win) then if Eok then Ein=sqrt(Win)

;Reserve output array
if keyword_set(Xc) then Wout=reform(fltarr(sizas[1],szyin,sz)) $
                   else Wout=reform(fltarr(sizin[1],szyas,sz))
if Eok then Eout=Wout

;Do the work
if keyword_set(Xc) then begin &   for z=0,sz-1 do begin
              for i=0,szyin-1 do Wout[*,i,z]= interpol(win[*,i,z],Xin[*,i<sxin],Xas[*,i<sxas])
  if Eok then for i=0,szyin-1 do Eout[*,i,z]= interpol(Ein[*,i,z],Xin[*,i<sxin],Xas[*,i<sxas])
                                endfor
endif else begin &                for z=0,sz-1 do begin
              if syin eq 0 then $
              for i=0,szxin-1 do Wout[i,*,z]= interpol(win[i,*,z],Yin,Yas) $
              else $
              for i=0,szxin-1 do Wout[i,*,z]= interpol(win[i,*,z],Yin[i<syin,*],Yas[i<syas,*])
  if Eok then if syin eq 0 then $
              for i=0,szxin-1 do Eout[i,*,z]= interpol(Ein[i,*,z],Yin,Yas) $
              else $
              for i=0,szxin-1 do Eout[i,*,z]= interpol(Ein[i,*,z],Yin[i<syin,*],Yas[i<syas,*])
                                endfor
endelse

;Return result
if keyword_set(Xc) then mod_datp ,dpin,'X',Xas $
                   else mod_datp ,dpin,'Y',Yas
if Eok             then mod_datp ,dpin,'E',Eout
if not DPok then GIVE_DATP,dpin
return,wout
end
