function bsnorm, w_in
;+
;******* ******
;**
;** Normalize w_in with monitor spectrum for in10, in16, in13
;-

  w_in  = reform(w_in)
  w_out = float(w_in)
  s     = size( w_in)
    
 ;size vector (IN13 elastic scan): array dimensions, number of detectors, number of temperatures, data type, number of data

;** Check for consistencies (workspace dimension s[0] = 1 or 2)

  if (s[0] gt 0) and (s[0] lt 3) then begin
      
    TAKE_DATP,P
    if n_elements(P.n) eq 1 then mod_datp, P, 'N', P.n[0]  $           ;array(1)->scalar
                           else mod_datp, P, 'N', (reform(P.n))[*,0]  ;else one dimension anyway
    sp = size(P.n)
    P.n = P.n>1 ;ensure monitor counts are positive

    ;normalize only if monitor > 1!

    if max(P.n) gt 1 then begin

;**   Normalize
      ;bidim array
      if s[0] eq 2 then begin
        if (s[1] eq sp[1]) or sp[0] eq 0 then $ ;same number of spectra in data and monitor OR single monitor counting (0 dim)
          for i = 0,s[2]-1 do     w_out[*,i] /= P.n $
        else  for i = 0,s[2]-1 do w_out[*,i] /= P.n[i] ;else divide by channel/temperature monitor
      endif
      ;monodim array
      if s[0] eq 1 then           w_out /= P.n

;**   Errors (Modified to take into account error in monitor)
      if n_elements(P.e) eq n_elements(w_in) then e_out = P.e else e_out = sqrt(w_in)
      
      if strpos(p.other_tit, 'Mon_norm') ge 0 then begin ;data normalized by channel on reading, so no error propagation needed 
        if s[0] eq 2 then begin
          if (s[1] eq sp[1]) or sp[0] eq 0 then for i = 0,s[2]-1 do e_out[*,i] /= P.n $
                                           else for i = 0,s[2]-1 do e_out[*,i] /= P.n[i]
        endif
        if s[0] eq 1 then e_out /= P.n
      endif else begin ;calculate new errors taking into accout error in detector counts and monitor counts 
        if s[0] eq 2 then begin
          if (s[1] eq sp[1]) or sp[0] eq 0 then $
            for i = 0,s[2]-1 do    e_out[*,i] = sqrt( (e_out[*,i]/P.n)^2    + (w_in[*,i]*sqrt(P.n)/P.n/P.n)^2 )  $
          else  for i =0,s[2]-1 do e_out[*,i] = sqrt( (e_out[*,i]/P.n[i])^2 + (w_in[*,i]*sqrt(P.n[i])/P.n[i]/P.n[i])^2 )
        endif
        if s[0] eq 1 then          e_out      = sqrt( (e_out/P.n)^2         + (w_in*sqrt(P.n)/P.n/P.n)^2 )
        
      endelse
  
      P.n[*] = 1 ;make monitor equal 1 after normalization
      P.other_tit = P.other_tit + ' bsnorm'
      MOD_DATP,  P, 'E', e_out
      GIVE_DATP, P
   
    endif
   
  endif
    
  return,w_out
 
end
