pro groupy, w,y,e,n,x ,AVERAGE=average ,PRECISION=dec ,sort=srt
;+
;** ******
;** User callable
;** To group spectra (w) having the same ordinate (y+-PRECISION)
;** call: groupy,w1 OR w2=groupy(w1)
;**       y1,e1,n1,x1 are not used from a DO command
;**       Spectra are added unless AVERAGE is set.
;**       If input spectra are not sorted you must use ,/sort keyword
;-

  if n_elements(dec) eq 1 then d=dec else d=0.01
  
  ;** Check for concistencies
  sw=SIZE(w)
  IF sw[0] eq 2 THEN BEGIN &          tp=0
  IF n_elements(y) le 1 then BEGIN & tp=1  ;Get parameters if not passed
  take_datp,datp & y=datp.y & x=datp.x & e=datp.e & n=datp.n & endif
  
  sy=n_elements(y) & se=n_elements(e) & sn=n_elements(n)
  sx=SIZE(x)
  if (sn  gt 1) then n=reform(n) & ssn=size(n) & tsn=0
  if (ssn[0] eq 2) then begin            ;what contains monitors!
    if ssn[2] eq sy then begin & sn=sy & n=transpose(n) & tsn=1 & endif else $
      if ssn[1] eq sy then       sn=sy
  endif
  
  IF sw[2] eq sy THEN BEGIN & ab=0  & r=0
  IF se eq n_elements(w) THEN    r=1
  IF sx[0] eq 2 then if sx[2] eq sy THEN ab=1
  ;**     Have to sort Y?
  IF keyword_set(srt) then BEGIN
    idx=sort(y)   &  y=y[idx] & w=w[*,idx]
    if sn eq sy THEN n=n[idx,*]
    if r        THEN e=e[*,idx]
    if ab       THEN x=x[*,idx]
  ENDIF
  ;**     Prepare output
  IF r THEN E=E^2
  flg =lonarr(sy)+1
  wout=w*0 & wout[*,0]=w[*,0]
  yout=y*0 & yout[  0]=y[  0]
  j   =  0 & yj=y[0]
  ;**     Grouping
  FOR i=1,sy-1 DO BEGIN
  
    IF  abs(y[i]-yj) le d THEN BEGIN
      wout[*,j] = wout[*,j]  + w[*,i]
      yout[  j] = yout[  j]  + y[  i]
      IF r  THEN  E[   *,j]  = E[*,j]+E[*,i]
      IF ab THEN  X[   *,j]  =(X[*,j]+X[*,i])/2. ;normaly same abscissa
      IF sn eq sy THEN N[j,*]= N[j,*]+N[i,*]
      flg[j]=flg[j]+1
      
    ENDIF ELSE BEGIN
      j=j+1 & yj= y[  i]
      wout[*,j] = w[*,i]
      yout[  j] = y[  i]
      IF r  THEN  E[*,j]=E[*,i]
      IF ab THEN  X[*,j]=X[*,i]
      IF sn eq sy THEN N[j,*]=N[i,*]
    ENDELSE
  ENDFOR
  
  IF r THEN E=SQRT(E)
  
  IF keyword_set(average) THEN FOR i=0,j DO BEGIN
    wout[*,i] = wout[*,i]          /flg[i]
    IF r THEN   E[   *,i]  =E[*,i] /flg[i]
    IF sn eq sy THEN N[i,*]=N[i,*] /flg[i]
  ENDFOR
  w=wout[*,0:j]
  y=yout[  0:j]/flg[0:j]
  IF r  THEN       E=E[*,0:j]
  IF ab THEN       X=X[*,0:j]
  IF sn eq sy THEN N=N[  0:j,*]
  IF n_elements(N) eq 1 then N=N[0] else if tsn then N=transpose(N)
  IF tp THEN BEGIN ;Return parameters if not passed
    mod_datp ,datp,'Y',y
    mod_datp ,datp,'N',n
    mod_datp ,datp,'E',e
    mod_datp ,datp,'X',x
    give_datp,datp
  ENDIF
ENDIF
ENDIF
RETURN
END

function groupy, wksp,yk,ek,nk,xk ,AVERAGE=average ,PRECISION=dec ,sort=srt
;+
;******* ******
;** User callable
;** call groupy procedure
;-
  w=wksp
  if n_elements(yk) gt 0 then y=yk & if n_elements(ek) gt 0 then e=ek
  if n_elements(nk) gt 0 then n=nk & if n_elements(xk) gt 0 then x=xk
  groupy,w,y,e,n,x ,AVERAGE=average ,PRECISION=dec ,sort=srt
  return,w
END
