;+
; :Description:
;    Centers a given dialog in the screen.
;
; :Params:
;    tlb : in, required, type="long"
;       The widget id of the toplevel window.
;       
; :Author: pellegrini
;
; :History:
;    pellegrini, 18 Feb. 2011
;
; :Categories: GUI
;-

pro centertlb, tlb

  ; Gets the screen size.
  device, get_screen_size = screenSize
  
  ; Gets the geometry of the dialog.
  geom = widget_info(tlb, /geometry)
  
  ; Centers the dialog given its dimensions and the screen ones.
  widget_control, tlb,  xoffset = (screenSize[0]/2)-(geom.scr_xsize/2), yoffset = (screenSize[1]/2)-(geom.scr_ysize/2)
  
end

pro parse_widget_tree, parent, idList

  if n_elements(idList) eq 0 then idList = [parent]

  children = widget_info(parent, /ALL_CHILDREN)
    
  if children[0] ne 0 then begin
  
    idList = [idList, children]
  
    for i = 0, n_elements(children) - 1 do begin
    
      parse_widget_tree, children[i], idList
    
    endfor
  
  endif
  
  return

end

;+
; :Description:
;    The module constructor.
;
; :Author: pellegrini
;
; :History:
;    pellegrini, 18 Feb. 2011
;
; :Categories: GUI utilities
;-
pro gui_utilities

end
