;+
; :Description:
;    Opens an url into a web browser.
;
; :Params:
;    url : in, required, type="url str"
;       The url to browse.
;    browser_path : in, optional, type="path str"
;       The full path to the browser executable.
;
; :Author: pellegrini
; 
; :History:
;    pellegrini, 18 Feb. 2011
;    
; :Categories: web utilities
;-

pro open_url, url, browser_path

forward_function finefile

    case !VERSION.os of
    
        'Win32'  : begin & dv=getenv("SystemDrive")
                         Fexpl=dv+'\Program Files\internet explorer\iexplore.exe'
                         a=finefile(Fexpl,count=cnt) ; for XP   ; for more recent windows
                         if cnt gt 0 then ic='"'+Fexpl+'" '  +url else ic='start '+url
                         spawn, /nowait, /hide, ic
                   end
                   
        'darwin' : spawn, 'open ' + url
        
    else : begin
        
        spawn, 'which firefox', Exec_Path
        if strlen(Exec_Path) gt 0 Then Begin
            spawn, Exec_Path + ' ' + url
            return
        endif
     
        spawn, 'which mozilla', Exec_Path
        if strlen(Exec_Path) gt 0 Then Begin
            spawn, Exec_Path + ' ' + url
            return
        endif

        spawn, 'which konqueror', Exec_Path
        if strlen(Exec_Path) gt 0 Then Begin
            spawn, Exec_Path + ' ' + url
            return
        endif
        
        spawn, 'which opera', Exec_Path
        if strlen(Exec_Path) gt 0 Then Begin
            spawn, Exec_Path + ' ' + url
            return
        endif
        
        Spawn, 'which netscape', Exec_Path
        if strlen(Exec_Path) gt 0 Then Begin
            spawn, Exec_Path + ' ' + url
            return
        endif
     
     end
        
     endcase

end

;+
; :Description:
;    The module constructor.
;
; :Author: pellegrini
;
; :History:
;    pellegrini, 18 Feb. 2011
;
; :Categories: web utilities
;-
pro web_utilities

end
