;PROX_SHEET_DYING
;PROX_SHEET_LAMPIES
;PROX_SHEET_EVENT
;PROX_SHEET

;D.R May 2010

;Reload current prox file D.R. May 2011

pro prox_sheet_dying,ev
;+
;** ****************
;** ****************
;** do nothing
;-
end

function PSrun, opr
;+
;******* *****
;******* *****
;** replace '>' by '-' in opr variable
;-

oprName=opr
while strpos(oprName,'>') gt 0 do begin
    p=strpos(oprName,'>') & oprName=strmid(oprName,0,p)+'-'+strmid(oprName,p+1)
endwhile
return,oprName
end

pro prox_sheet_lampies, SETpth=SETpth, GETpth=GETpth, SETcell=SETcell, GETsys=GETsys,$
                        RESwks=Wres,GETmax=GETmax,GETsiz=Rsiz, GET_wd=GET_wd
;+
;** ******************
;** ******************
;** ** return lamp variables (avoid to use global lamp.cbk in calling routines)
;-
@lamp.cbk
common c_did
common for_users, a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z

if arg_present(GETpth)  then GETpth   = path_for_online
if arg_present(SETpth)  then path_for_online=SETpth
if arg_present(GETsys)  then GETsys   = lamp_sys
if arg_present(GET_wd)  then GET_wd   = did_wd
if arg_present(SETcell) then CELL     = SETcell
if arg_present(SETcell) then CELL.Sid =  strcompress(cell.Sid,/remove)
if arg_present(GETmax)  then begin
                             GETmax=Wres & GETmax[*]='?'
                             Rsiz  =lonarr(20,n_elements(Wres))
                             for kr=0,n_elements(Wres)-1 do begin
                               ii=EXECUTE('GETmax[kr]=strtrim(max('+Wres[kr]+'),2)')
                               ii=EXECUTE('Rsiz[0,kr]=size('+Wres[kr]+')')
                             endfor
endif
end

pro prox_sheet_read, proxfile, contain, OK
;+
;** ***************
;** ***************
;** reads an ascii prox file
;-
    OK=0
    on_ioerror,misfil
    OPENR,u,proxfile,/get_lun
      on_ioerror,eoffil
      contain=strarr(600) &  READF,u,contain
      eoffil: free_lun,u  &  OK=1
      message,/reset
    idx    =where(contain gt ' ')
    contain=strtrim(contain[idx],0)
    misfil:
end

pro prox_sheet_event,ev
;+
;** ****************
;** ****************
;** prox_sheet event parser
;-

forward_function bin_as

CATCH,stat & if stat ne 0 then begin &  lamp_error
      widget_control,sbaset.Mess ,set_value=!error_state.msg,sens=1 & return & endif

widget_control,ev.top,get_uvalue=sbaset
widget_control,sbaset.Mess ,set_value=''
widget_control,sbaset.Mess2,set_value=''
sbupd=0

;TOP BASE RESIZING
; ----------------
if ev.id eq ev.top then begin & wait,.1 & empty
   strN    =widget_info(ev.top ,/geometry)
   gapX    =strN.scr_Xsize-sbaset.stri.scr_Xsize
   gapY    =strN.scr_Ysize-sbaset.stri.scr_Ysize
   tids    =sbaset.tids
   cr_s    =sbaset.cr_s
   bforTABS=sbaset.bforTABS
   sheetb  =sbaset.sheetb
  ;X resizing
  ; ---------
   if abs(gapX) gt 30 then begin & sbupd=1
      for i=0,n_elements(tids)/2-1 do begin
          if tids[0,i] gt 0L then begin ;COMMENTS
                                  strC=widget_info(tids[0,i],/geometry)
                                  widget_control  ,tids[0,i],scr_xsize=(strC.scr_Xsize)+gapX & endif
          if cr_s[2,i] ge 1  then begin ;TABLES
                                  strX=widget_info(tids[1,i],/geometry)
                                  widget_control  ,tids[1,i],scr_xsize=(strX.scr_Xsize)+gapX & endif
      endfor
      wait,.1 & empty & strN=widget_info(ev.top ,/geometry) & sbaset.stri=strN
   endif
  ;Y resizing
  ; ---------
   if abs(gapY) gt 30 then begin & sbupd=1
      for i=0,n_elements(tids)/2-1 do if cr_s[2,i] eq 2 then begin      ;TABLES
                                  strY=widget_info(tids[1,i],/geometry)
                                  widget_control  ,tids[1,i],scr_ysize=(strY.scr_ysize+gapY)>50
      endif
      wait,.1 & empty & strN=widget_info(ev.top ,/geometry) & sbaset.stri=strN
   endif
  ;TAB resizing
  ; -----------
   if abs(gapY) gt 30 then begin
      for i=1,n_elements(bforTABS)-1 do if bforTABS[i] gt 0L then begin ;TABS
          TABy=widget_info(sheetb,/geometry)
          widget_control,bforTABS[i],scr_ysize=(TABy.scr_ysize-30)>50
      endif
      wait,.1 & empty & strN=widget_info(ev.top ,/geometry) & sbaset.stri=strN
   endif

;OTHER EVENTS
; -----------
endif else begin & messege=''
 widget_control,ev.id ,get_uvalue=uv
 if n_elements(uv) gt 0 then begin
  if n_elements(sbaset.bcontain) gt 1 then if (uv[0] eq 12) or (uv[0] eq 14) then begin & sbupd=1
    ;SAVE OR TREAT SO, UPDATE INPUT COMMANDS (should be mofified by the User)
     for i=1,n_elements(sbaset.bcontain)-2,2 do begin
         widget_control,sbaset.bcontain[i],get_value=temp
         if sbaset.bcontain[i+1] then temp=';'+temp & sbaset.RLcontain[(i-1)/2]=temp
     endfor
  endif

  case uv[0] of

  10:  begin ;CLEAR / RESIZE SAMPLE TABLE
             ; --------------------------
             ;GET NB SAMPLES
             ; -------------
             widget_control,uv[2],get_value=txt & on_ioerror,misnbsamp & ok=0 & nbs=0 & nbs=fix(txt[0])<sbaset.maxns  & ok=1
             misnbsamp: if not ok then messege=!error_state.msg & if (nbs le 0) or  (nbs eq sbaset.nsampl)   then   ok=0
             vert=sbaset.vertical      ;sens of tables
             idx =sbaset.idxtab        ;tables  index
             idt =sbaset.tids[  1,idx] ;get tables ids
             colr=sbaset.cr_s[0:1,idx] ;get tables col & row
             idts=idt[ 2]              ;sample table id
             colr=colr[0:1,2]          ;sample col & row
             ;RESIZE SAMPLE TABLE
             ; ------------------
             if ok then begin
               diff=nbs-sbaset.nsampl
               if diff gt 0 then begin ;-->ADD
                    if vert then widget_control,idts,insert_rows   =diff,alignment=1,background=sbaset.smp_color $
                            else begin
                                 widget_control,idts,insert_columns=diff,alignment=1
                                 for i=0,colr[1]-1 do widget_control,idts,use_table_select=[colr[0],i,nbs-1,i],background=sbaset.smp_color[*,i]
                            endelse
                    if vert then uset=[0,colr[1], 0,nbs-1] else uset=[colr[0],0,nbs-1,0]
                    setval='  S'+strtrim(indgen(diff)+sbaset.nsampl+1,2) & if vert then setval=transpose(setval)
                    widget_control,idts,set_value=setval,use_table_select=uset
               endif else begin        ;-->DELETE                   ;use_table_select=[left,top      ,right,bottom]
                    if vert then widget_control,idts,/delete_rows   ,use_table_select=[0,colr[1]+diff, 0,colr[1]-1] $
                            else widget_control,idts,/delete_columns,use_table_select=[colr[0]+diff,0, colr[0]-1,0]
               endelse
               if vert then sbaset.cr_s[1,idx[2]]=nbs else sbaset.cr_s[0,idx[2]]=nbs
               sbaset.nsampl=nbs & sbupd=1
             endif
             ;CLEAR TABLES
             ; -----------
             if (uv[1] eq 1) or (uv[1] eq 2) then begin
                if uv[1] eq 2 then idt=idts ;only Sample table
                for i=0,n_elements(idt)-1 do begin
                    widget_control,idt[i],get_value=tmp & tmp[where(tmp ne '-')]=''
                    widget_control,idt[i],set_value=tmp
                endfor
                if vert then uset=[0,0,0,nbs-1] else uset=[0,0,nbs-1,0]
                setval='  S'+strtrim(indgen(nbs)+1,2) & if vert then if nbs gt 1 then setval=transpose(setval)
                widget_control,idts,set_value=setval,use_table_select=uset
                sbupd=1
             endif
             ;CLEAR SELECTED TABLE CELLS
             ; -------------------------
             if (uv[1] eq 3) then begin
                uset=widget_info(idts,/table_select) & widget_control,idts,use_table_select=uset,get_value=tmp & tmp[*]=""
                                                       widget_control,idts,use_table_select=uset,set_value=tmp & endif
             ;REMOVE/INSERT A SAMPLE ID
             ; ------------------------
             if (uv[1] eq 4) or (uv[1] eq 5) then begin & ok=1
                uset=widget_info(idts,/table_select)
                if (vert) then if (uset[0] le 0) and (uset[1]-uset[3] eq 0) then idn=uset[3] else ok=-1 $
                          else if (uset[1] le 0) and (uset[0]-uset[2] eq 0) then idn=uset[2] else ok=-1
                if ok eq -1 then begin & ok=0 & messege="Select one sample ID !!!" & endif
                if ok then begin
                   widget_control,idts,get_value=tmp
                   if vert then vid=strarr(colr[0],1) else vid=strarr(1,colr[1])
                   if uv[1] eq 4 then begin ;REMOVE
                     if vert then begin
                      if idn eq 0         then tmp=[[tmp[*,1:colr[1]-1]],[vid]] else $
                      if idn eq colr[1]-1 then tmp[*,colr[1]-1]=vid $
                                          else tmp=[[tmp[*,0:idn-1]],[tmp[*,idn+1:colr[1]-1]],[vid]]
                     endif else begin
                      if idn eq 0         then tmp=[ tmp[1:colr[1]-1,*] , vid ] else $
                      if idn eq colr[0]-1 then tmp[colr[0]-1,*]=vid $
                                          else tmp=[ tmp[0:idn-1,*] , tmp[idn+1:colr[1]-1,*] , vid ]
                     endelse
                   endif
                   if uv[1] eq 5 then begin ;INSERT
                     if vert then begin
                      if idn eq 0         then tmp=[[vid],[tmp[*,0:colr[1]-2]]] else $
                      if idn eq colr[1]-1 then messege="Increase NBsamples" $
                                          else tmp=[[tmp[*,0:idn-1]],[vid],[tmp[*,idn:colr[1]-2]]]
                     endif else begin
                      if idn eq 0         then tmp=[ vid , tmp[0:colr[1]-2,*] ] else $
                      if idn eq colr[0]-1 then messege="Increase NBsamples" $
                                          else tmp=[ tmp[0:idn-1,*] , vid , tmp[idn:colr[1]-2,*] ]
                     endelse
                   endif
                   widget_control,idts,set_value=tmp
                   sbupd=1
                endif
             endif
       end
  11:  begin ;FILL DOWN SAMPLE
             ; ---------------
             if uv[1] eq 0 then widget_control,uv[2],set_value='0.0'
             if uv[1] eq 1 then widget_control,uv[2],set_value='1.0'
             widget_control,uv[2],get_value=txt & on_ioerror,misfincr & ok=0 & inc=0 & inc=float(txt[0])>(-100.)<100. & ok=1
             misfincr: if not ok then messege=!error_state.msg
             vert=sbaset.vertical         ;sens of tables
             idx =sbaset.idxtab           ;tables  index
             idts=sbaset.tids[  1,idx[2]] ;get sample table id (or using unames)
             colr=sbaset.cr_s[0:1,idx[2]] ;get table  col & row
             uset=widget_info(idts,/table_select)
             nbf =0
             if (vert) then if (uset[0]-uset[2] eq 0) and (uset[1] ge 0) then nbf=uset[3]-uset[1] else ok=-1 $
                       else if (uset[1]-uset[3] eq 0) and (uset[0] ge 0) then nbf=uset[2]-uset[0] else ok=-1
             if ok eq -1 then begin & ok=0 & messege="Select one starting cell in sample table !!!" & endif
             ;DO IT
             ; ----
             if ok then begin & widget_control,idts,get_value=val,use_table_select=uset & val=val[0]
                              if nbf eq 0 then if vert then uset[3]=colr[1]-1 else uset[2]=colr[0]-1
                              if vert then nbc=uset[3]-uset[1]+1 else nbc=uset[2]-uset[0]+1

                              sgPnu='+' & nuPnu = strpos(val,sgPnu)         & if nuPnu le 0 then  begin
                              sgPnu='>' & nuPnu = strpos(val,sgPnu) & endif & if nuPnu le 0 then  begin
                              sgPnu=':' & nuPnu = strpos(val,sgPnu) & endif
                              on_ioerror,misnumb & nu=0 & num=0. & nun1=0. & nun2=0.
                                 if nuPnu gt 0 then begin & reads,val,num & reads,strmid(val,nuPnu+1)+' 0',nun1,nun2 & nu=1
                                 endif         else begin & reads,val+' 0 0',num,nun1,nun2 & nu=1
                                 endelse & misnumb:
                              lg=0
                              if (long(inc) eq inc) and (long(num) eq num) and (long(nun1) eq nun1) then begin
                                  inc=long(inc) & num=long(num) & nun1=long(nun1) & lg=1 & endif

                              if strtrim(val,2) le ' ' then nu=0
                              if nu and (inc ne 0) then begin
                              ; ->A NUMBER
                                if (nuPnu gt 0) and (nun1 gt 0) and (nun2 eq 0) and (lg) then $ ;-->A NUMBER1+NUMBER2
                                            setval=strtrim(lindgen(nbc)*inc+num,2)+ sgPnu +strtrim(lindgen(nbc)*inc+nun1,2) else $
                                 if lg then setval=strtrim(lindgen(nbc)*inc+num,2) else setval=string(lindgen(nbc)*inc+num,format='(F7.3)')
                                 if vert then if nbc gt 1 then setval=transpose(setval)
                                 widget_control,idts,use_table_select=uset,set_value=setval
                              endif else if inc eq 0 then begin
                              ; ->A STRING
                                 setval=strarr(nbc)+val &  if vert then if nbc gt 1 then setval=transpose(setval)
                                 widget_control,idts,use_table_select=uset,set_value=setval
                              endif else messege="Set increment to 0 for a string or no cell is selected !!!"
             endif
       end
  12:  begin ;LOAD / SAVE  1:Load  2:Save  3:Save & exit  4:Reload prox file
             ; ----------
             idxa   =sbaset.idxtab                 ;tables  index
             idt    =sbaset.tids[1,idxa]           ;get tables ids (water,beam,sample)
             unm    =sbaset.unames                 ;get unames of this tables
             idc    =where(sbaset.tids[0,*] gt 0L) ;get comments ids
             idc    =sbaset.tids[0,idc]            ;""

             defext='sav' & filt='*.sav' & pth=sbaset.SAVpth & gpth=pth
             fifi=sbaset.curfile
             pt= strpos(/reverse_search,fifi,'.') & if pt gt 0 then fifi=strmid(fifi,0,pt)+'.sav'
             
             if (uv[1] eq 1) then $
              result=dialog_pickfile(path=pth,get_path=gpth,file=fifi,default_ext=defext,/read ,resource_name='lamptouch',filter=filt)
             if (uv[1] eq 2) or (uv[1] eq 3) then $
              result=dialog_pickfile(path=pth,get_path=gpth,file=fifi,default_ext=defext,/write,resource_name='lamptouch',filter=filt,/overwrite_prompt)
             if (uv[1] eq 4) then begin
              result=sbaset.RLproxbu
              if not file_test(result) then begin
                result=dialog_pickfile( /read ,resource_name='lamptouch',filter='*.prox')
                if result le ' ' then return
                sbaset.RLproxbu = result
              endif
             endif

             if result ne '' then begin & sbupd=1
             
              if  uv[1] ne 4 then begin
                   fifi  =strmid(result,strlen(gpth))
                   sbaset.SAVpth=gpth & sbaset.curfile=fifi
                   fileSR=sbaset.SAVpth+sbaset.curfile & endif $
              else fileSR='ProxSheet_current.sav' ;Unused

              if uv[1] ge 2 then begin                         ;SAVE
                    widget_control,idt[2]       ,get_value =Values
                    widget_control,sbaset.mess2 ,get_uvalue=Reslist
                   ;READ ALL COMMENTS
                                                       widget_control,idc[0],get_value=comments
                    for i=1,n_elements(idc)-1 do begin & widget_control,idc[i],get_value=tmp
                                                       comments=[comments,tmp]  &   endfor
                    on_ioerror,missave & ok=0
                    u=-1
                    if uv[1] ne 4 then begin & openW,u,fileSR,/get_lun,/delete & free_lun,u & ok=1
                    endif         else begin & prox_sheet_read, result, contain, Cok
                                             if n_elements(contain) gt 1 then ok=1 else uv[1]=0
                    endelse

                    if ok then $
                    if n_elements(contain) le 1 then $
                         RLstruct={PROX_SHEET:'yes',SBASET:sbaset,COMMENTS:comments,SAMPLE:Values,RESLIST:Reslist} $
                    else RLstruct={PROX_SHEET:'yes',SBASET:sbaset,COMMENTS:comments,SAMPLE:Values,RESLIST:Reslist,CONTAIN:contain}

                    if uv[1] eq 2 then SAVE,RLstruct,file=fileSR,/compress
                    if uv[1] eq 3 then SAVE,RLstruct,file=fileSR,/compress
                    if uv[1] eq 3 then uv[0]=[77] ;Save & Exit
                    
                   ;SAVE ALSO VALUES IN A TEXT FILE
                    if (uv[1] eq 2) or (uv[1] eq 3) then begin & fileST=fileSR
                      p=strpos(fileSR,'.sav') & if p gt 0 then fileST=strmid(fileSR,0,p) & fileST=fileST+'.txt'
                      N=n_elements(sbaset.RLsamLab)
                      Valtxt=Values & idx=where(Valtxt le ' ') & if idx[0] ge 0 then Valtxt[idx]='<>'

                      openw ,u,fileST,/get_lun
                       printf,u,'PROX SPREAD SHEET WRITTEN FOR '+sbaset.curfile+' BY LAMP on '+systime() & printf,u,""
                       for i=0,n_elements(comments)-1 do printf,u, comments[i]                           & printf,u,""
                       printf,u,'Sid | '+strjoin(sbaset.RLsamLab,' | ')                                  & printf,u,""
                       for i=0,(size(Values))[2]-1               do printf,u,strjoin(Valtxt[0:N,i],' ')  & printf,u,""
                       for i=0,n_elements(sbaset.RLcontain)-1    do printf,u,sbaset.RLcontain[i]
                    endif
                    
                    missave:if not ok     then messege=!error_state.msg else $
                            if uv[1] ne 4 then messege=sbaset.curfile+" is saved"
                            if u gt 0 then free_lun,u
              endif ;Save
              
              if (uv[1] eq 1) or (uv[1] eq 4) then begin       ;LOAD
                    if uv[1] ne 4 then RESTORE,file=fileSR
                    if n_elements(RLstruct) gt 0 then tags=tag_names(RLstruct) else tags=['']
                    if tags[0] eq "PROX_SHEET" then begin
                       widget_control,ev.top,/destroy
                       print,"Creating tables" & wait,1. & empty
                       if uv[1] ne 4 then PROX_SHEET,                  reload=RLstruct
                       if uv[1] eq 4 then PROX_SHEET, sbaset.RLproxbu, reload=RLstruct
                       return
                    endif else messege='*** Bad File !!!'
              endif ;Restore
             endif ;No file
       end

  13:  begin & p_did_getw_cur, widx, wnumber & p_did_save_menu,widx ;EXPORT
       end

  14:  begin ;TREAT
             ; ----
             idx  =sbaset.idxtab        ;tables  index
             idt  =sbaset.tids[  1,idx] ;get tables ids
             idts =idt[ 2]              ;sample table id
             labs =sbaset.RLsamlab      ;columns label
             Wres =sbaset.RLresults     ;result variable names
             blstR=sbaset.Mess2         ;base list of UV_results
             blstV=sbaset.bforTABS[2]   ;base list of results
             bstop=sbaset.bstop         ;stop button
             step =1
             kpu  =0
             case uv[1] of
             0: begin & widget_control,idts,get_value=values ;TREAT ALL
                          if Wres[0] gt ' ' then begin
                             Sv=size(values)
                             uset=[0,0,0,0] ;[left,top , right,bottom]
                             uset[0]=n_elements(labs)+1
                             uset[2]=n_elements(Wres)+uset[0]-1
                             if Sv[0] eq 2 then uset[3]=Sv[2]-1
                          endif
                end
             1: begin & widget_control,idts,get_value=values ;TREAT SELECTED
                      uset=widget_info(idts,/table_select)
                      if (uset[0] eq 0) and (uset[2] eq 0) then begin
                          values=values[*,uset[1]:uset[3]]
                          kpU   =uset[1]
                          if Wres[0] gt ' ' then begin
                             uset[0]=n_elements(labs)+1
                             uset[2]=n_elements(Wres)+uset[0]-1
                          endif
                      endif else values=''
                end
             2: begin & step=0 & messege='Stopping....'      ;STOP
                end
             else:
             endcase
             if n_elements(values) gt 1 then begin         ;START TREATMENT
                values =strtrim(values,2)
                samples=values[0,*]
                values =values[1:n_elements(labs),*]
                idx    =where(values[0,*] gt ' ')                    ;KEEP FILLED SAMPLES
                if idx[0] ge 0 then values=values[*,idx] else values=''
                if idx[0] ge 0 then samples=samples[idx]
                nval   =n_elements(values[*,0])

                if (values[0] gt ' ') and (nval eq n_elements(labs)) then begin
                   catch,stat & if stat eq 0 then call_procedure,"Init_error_string" & catch,/cancel
                   kperror =!error_state.msg & ok=1
                   kpexcept=!except          & !except=0 ; Try without math errors
                   contain=sbaset.RLcontain & samp=''
                   blank  =replicate('-',n_elements(Wres))
                   widget_control,blstR,get_uvalue=vlstR ; File list
                   Sfrst=1
                   prox_sheet_lampies,GET_wd=wdraw

                   on_ioerror,misfor & messege='? Unable to WRITE in the current path'
                   openW   ,u,'test_for_write',/delete,/get_lun
                   free_lun,u        & messege=''

                   bProgress = sbaset.Bprogress ; Time Progress stuff
                   tot_line  = n_elements(samples) * n_elements(contain)

                   FOR S=0,n_elements(samples)-1 do BEGIN            ;LOOP OVER SAMPLES
                      if (not step) or (not ok) then break
                      Sidx =strtrim(kpu+S+1,2)
                      samp =samples[S]+'-> '
                      lamp_journal,'--------------------------'
                      lamp_journal,samp+'PROX commands started'
                      lamp_journal,'--------------------------'
                      if Wres[0] gt ' ' then begin                   ;CLEAR RESULTS
                         if uv[1] eq 0 then uset[[1,3]]=idx[S] $
                                       else uset[[1,3]]=kpu+S
                         widget_control,idts,use_table_select=uset,set_value=blank
                      endif
                      labls=['Sn','Sid','Firstime',labs]             ;Add index + sampleID + Firstime
                      Scell=''
                      Sstr ='labls' + ",'"+Sidx+"'" + ",'"+samples[S]+"'" + ",'"+sbaset.firstime+"'"
                      for nv=0,n_elements(values[*,S])-1 do Sstr=Sstr+",'"+values[nv,S]+"'"
                      ii   =execute('Scell=CREATE_STRUCT('+Sstr+')')
                      prox_sheet_lampies,SETcell=Scell               ;SET CELL STRUCTURE

                      FOR C=0,n_elements(contain)-1 do BEGIN         ;LOOP OVER COMMANDS
                         evv=widget_event(bstop,/nowait,bad_id=ii)
                         if evv.id eq bstop then step=0
                         if (not step) or (not ok)           then break ;Stop ALL
                         RDSTAP  ,1,50,1,STPS & if STPS eq 1 then break ;Stop only for sample (ENDPROX)
                         widget_control,/hourglass
                         comm  = contain[C]
                         commX = strtrim(comm,2)
                         mustX =( (commX gt '') and (strpos(commX,';') ne 0) )
                         if mustX then begin       ;EXECUTE THE COMMAND
                            widget_control,sbaset.Mess,sens=1,set_value=samp+comm
                            XICUTER,comm

                            if kperror ne !error_state.msg then if !error_state.msg gt ' ' then begin
                              ;ENABLE conversion error:
                               if strpos(!error_state.msg,'conver') lt 0 then ok=0 ; Allow this error
                               if not ok then begin
                                  quest='AN ERROR OCCURS: Do you want to CONTINUE?'
                                  resp=dialog_message(quest,/question,title=!error_state.msg,dialog_parent=ev.top,resource='lampben')
                                  if resp eq 'Yes' then ok=1
                               endif
                            endif
                           ;Update Time Progress-bar
                            UT_Progress, bProgress, S*n_elements(contain) + C , tot_line
                         endif
                         
                      ENDFOR ;LOOP OVER COMMANDS
                                                                     ;TREAT RESULTS
                      if (ok) and (step) and (Wres[0] gt ' ') and (STPS eq 0) then begin
                         sbaset.firstime = '0'
                                                                     ;CALCULATE MAXIMA
                         prox_sheet_lampies,RESwks=Wres,GETmax=Rmax,GETsiz=Rsiz
                         widget_control,idts,use_table_select=uset,set_value=Rmax

                         widget_control,sbaset.Mess,sens=1,set_value=samp+' Writing Results ...'
                         for R=0,n_elements(Wres)-1 do begin
                             ww=strmid(Wres[R],0,1) & Ws=strmid(Wres[R],1,3)
                             if strupcase(ww) eq 'W' then begin
                                on_ioerror,misWW & goodW=0 & Wn=0L
                                reads,Ws,Wn & goodW=1 & misWW:
                                on_ioerror,misfor
                                if goodW then begin                  ;WRITE RESULTS IN FILES
                                   if uv[1] eq 0 then Sn=idx[S] else Sn=kpu+S
                                   Sseq =string(Sn+1,format='(I03)')     ;sequence 
                                   Stext=strcompress(samples[S],/remove) ;and real IDs
                                   Stime=strmid(stime(dum),0,2)+strmid(stime(dum),3,3)
                                   Stime=strcompress(Stime,/remove)
                                   Ssize=''
                                   for sz=1,Rsiz[0,R] do begin
                                       if sz gt 1 then Ssize=Ssize+'.'
                                       Ssize=Ssize+strtrim(Rsiz[sz,R],2)
                                   endfor
                                   fifi =Wres[R]+'-'+Sseq+'-dim'+Ssize+'-'+Stext+'-'+Stime+'.hdf' & print,fifi
                                   write_lamp, fifi, W=Wn, format='HDF'
                                   vlstR=[vlstR,fifi]
                                   if sbaset.LogOn then $
                                   if !version.release ge 5.5 then begin ;** e-LogBook-Prox **
                                    ;if Sfrst then did_ContextEvent, 0L ,{but:4, wdraw:0L ,oview:-1} ;Reset
                                        Sfrst=0
                                    ;if Rsiz(0,R) gt 1 then seem,log=1 else seem,log=0
                                     empty
                                     see,W=Wn,/below,/image & empty
                                     did_ContextEvent, 0L ,{but:3, wdraw:wdraw ,oview:-1}
                                   endif
                                endif
                             endif
                         endfor
                         kperror = !error_state.msg
                      endif
                   ENDFOR ;LOOP OVER SAMPLES
                   
                   if not ok   then widget_control,sbaset.Mess2,set_value=!error_state.msg
                   if not ok   then lamp_error
                   if not ok   then messege='*** Error at '  +samp+comm else $
                   if not step then messege='*** Stopped at '+samp+comm $
                               else messege='*** All done ***'
                   vlstR=vlstr[sort(vlstR)]
                   vlstR=vlstr[uniq(vlstR)]
                   widget_control,blstR,set_uvalue=vlstR
                   if blstV gt 0L then $
                   widget_control,blstV,set_value =vlstR             ;REPLACE NEW FILE LIST
                   misfor: !except=kpexcept

                  ;Finish with progress-bar
                   UT_Progress, bProgress, tot_line, tot_line        

                endif else messege='No inputs !!!'
             endif ;no values
       end

  15:  begin & if sbaset.bforTABS[2] gt 0L then begin
                selres=widget_info(sbaset.bforTABS[2],/list_select)  ;SHOW RESULTS
                if selres[0] ge 1 then begin
                  widget_control,sbaset.Mess2,get_uvalue=Thelist
                  keplist=Thelist
                  Thelist=Thelist[selres]

                  if uv[1] eq 0 then begin                     ;DELETE
                    on_ioerror,misdel
                    for kn=0,n_elements(Thelist)-1 do begin
                        openR,u,Thelist[kn],/get_lun,/delete
                        free_lun,u
                        misdel: keplist[selres[kn]]=''
                    endfor
                    keplist=keplist[where(keplist gt '')]
                    widget_control,sbaset.Mess2      ,set_uvalue=keplist
                    widget_control,sbaset.bforTABS[2],set_value =keplist
                  endif

                  if uv[1] eq 1 then begin                     ;SHOW / JOIN
                    widget_control,/hourglass
                    for kn=0,n_elements(Thelist)-1 do begin
                      Ws=strmid(Thelist[kn],1,strpos(Thelist[kn],'-')-1)
                      on_ioerror,misWkn  & Wn=long(Ws)
                      GIVE_W   ,0,W=Wn
                      READ_LAMP,Thelist[kn],W=Wn
                      TAKE_W   ,Data,W=Wn
                      TAKE_DATP,datp,W=Wn
                      SZdata=size(Data)
                      
                      if kn eq 0 then begin & Daccu=Data   & DPaccu=datp & DYv=datp.Y[0]
                                            Eaccu=datp.E & PVaccu=datp.P
                                            Eok   =(n_elements(Data) eq n_elements(datp.E))
                      endif else begin
                         SZaccu=size(Daccu)
                         if SZaccu[0] le SZdata[0]+1 then begin
                            SZdifx=abs(SZaccu[1]-SZdata[1])
                            SZdify=abs(SZaccu[2]-SZdata[2])
                           ;Enable small difference on X,Y axis
                            if (SZdifx gt 0) and (SZdifx lt 5)  then Data=bin_as(Data,AS=Daccu,DPIN=datp,DPAS=DPaccu,/X)
                            if (SZaccu[0] ge 2) and (SZdata[0] eq 2) then $
                            if (SZdify gt 0) and (SZdify lt 5)  then Data=bin_as(Data,AS=Daccu,DPIN=datp,DPAS=DPaccu,/Y)
                           ;Accumulate Data
                            if (SZaccu[0] eq 1) and (SZdata[0] eq 1) then Daccu=[  [Daccu] , [Data]  ]
                            if (SZaccu[0] eq 2) and (SZdata[0] eq 1) then Daccu=[  [Daccu] , [Data]  ]
                            if (SZaccu[0] eq 2) and (SZdata[0] eq 2) then Daccu=[ [[Daccu]],[[Data]] ]
                            if (SZaccu[0] eq 3) and (SZdata[0] eq 2) then Daccu=[ [[Daccu]],[[Data]] ]
                           ;Accumulate Y0 and P
                            DYv=[DYv,datp.Y[0]] & PVaccu=[ [PVaccu] , [datp.p] ]
                           ;Accumulate E
                            if Eok then begin
                            if (SZaccu[0] eq 1) and (SZdata[0] eq 1) then Eaccu=[  [Eaccu] , [datp.E] ]
                            if (SZaccu[0] eq 2) and (SZdata[0] eq 1) then Eaccu=[  [Eaccu] , [datp.E] ]
                            if (SZaccu[0] eq 2) and (SZdata[0] eq 2) then Eaccu=[ [[Eaccu]],[[datp.E]]]
                            if (SZaccu[0] eq 3) and (SZdata[0] eq 2) then Eaccu=[ [[Eaccu]],[[datp.E]]]
                            endif
                         endif
                      endelse
                      misWkn:
                    endfor
                    GIVE_W,Daccu,W=Wn & SZaccu=size(Daccu)
                    if (SZaccu[0] eq 2) and (SZdata[0] eq 1) then begin
                       nY=n_elements(DYv) & if total(DYv)/nY eq DYv[0] then DYv=lindgen(nY)+1
                       if SZdata[0] eq 1 then MOD_DATP ,datp,'Y' ,DYv
                       if Eok            then MOD_DATP ,datp,'E' ,Eaccu
                                              MOD_DATP ,datp,'PV',PVaccu
                       GIVE_DATP,datp,W=Wn & endif
                    if (sbaset.Ushow eq 1) and (SZaccu[0] le 2) then suprplot,Wn
                    if (sbaset.Ushow eq 1) and (SZaccu[0] gt 2) then SEE,W=Wn,/beside
                    if (sbaset.Ushow eq 2)                      then SEE,W=Wn,/beside
                    if (sbaset.Ushow eq 3)                      then SEE,W=Wn,/below
                  endif

                  if uv[1] eq 2 then begin                     ;SPLIT
                    prox_sheet_lampies, GETsys=Wsys
                    widget_control,uv[2],get_value=wcur & wcur=wcur[0]
                    if wcur ge 1 then begin
                     if wcur+n_elements(Thelist)-1 le Wsys then begin
                      widget_control,/hourglass
                      Wstart=wcur
                      for kn=0,n_elements(Thelist)-1 do begin
                          READ_LAMP,Thelist[kn],W=Wcur & Wcur=Wcur+1
                      endfor
                      suprplot,Wstart
                     endif else messege='You have not enought Workspaces to contain the selection !'
                    endif  else messege='Bad starting Workspace !'
                  endif
                endif
             endif
       end

  16:  begin & sbaset.Ushow=uv[1] & sbupd=1 ; SHOW BESIDE OR SUPRPLOT
       end

  20:  begin & case uv[1] of                ; ABOUT e_LOGBOOK
             1:begin &  sbupd=1
               sbaset.LogOn=1-sbaset.LogOn
               if sbaset.LogOn then widget_control,ev.id,set_value='Stop  registering' $
                               else widget_control,ev.id,set_value='Start registering'
               end
             2:did_ContextEvent, 0L ,{but:10, wdraw:0L ,oview:-1} ; SHOW  LOG
             3:did_ContextEvent, 0L ,{but: 4, wdraw:0L ,oview:-1} ; RESET LOG
             4:lamp_journal,'',/show
             else:
             endcase
       end

  40:  begin ;CONTEXT TABLE EVENT (right click) TO SHOW A RUN
             if tag_names(ev,/structure_name) eq "WIDGET_CONTEXT" then begin
                uname=widget_info(ev.id,/uname)
             endif else begin
                tnam=tag_names(ev) & idx=where(tnam eq "TYPE")
             ;ENTER CHARACTER EVENT
                if idx[0] ge 0 then if ev.type eq 0 then begin ;Unusable (arrows,tab do an unvisible enter)
                uname=widget_info(ev.id,/uname)
                endif
             endelse
       end

  51:  begin ;INSTRUMENT / PATH
             ; ----------------
             case uv[1] of
             2: begin ;PATH EXPLORER
                     result=dialog_pickfile(path=sbaset.DATApth,/directory,resource_name='lamptouch')
                     if result gt ' ' then begin & sbaset.DATApth=result & sbupd=1
                                                 prox_sheet_lampies,SETpth =result
                                                 messege="Data path: "+result & endif
                end
             3: begin ;PATH LAMP
                     if sbaset.lamp_b1 gt 0L then begin
                        widget_control,sbaset.lamp_b1,bad_id=ii,map=1,iconify=0,xoff=1,yoff=1 & ii=xregistered('LAMP')
                        sbaset.DATApth='' & sbupd=1 & messege="Data path is taken from Lamp" & endif
                end
             4: begin ;SHOW PATH
                     prox_sheet_lampies,GETpth=result
                     if result eq '' then CD,current=result & messege="Data path: "+result
                end
             5: begin ;SET WORKING PATH
                     cd,current=mee
                     pptthh=dialog_pickfile(/directory,resource_name='lamptouch')
                     if pptthh gt ' ' then begin & P_SET_PATH,pptthh,/silent & mee=pptthh & endif
                     messege="Working path: "+mee
                end
             else:
             endcase
       end

 -88:  begin ;Do Command
             ; ---------
             P_DON_EVENT,ev,uv
       end

  else:      messege='NO YET AVAILABLE EVENT..........'
  endcase
  case 1 of
  (uv[0] eq 77) or (uv[0] eq 78):  begin ;EXIT
                                         ; ---
             widget_control,ev.top,/destroy
             print,"" & wait,.2 & empty
             if uv[0] eq 78 then begin
                print,"Creating tables" & wait,.5 & empty
             endif else if sbaset.lamp_b1 gt 0L then widget_control,bad_id=ii,sbaset.lamp_b1,map=1,iconify=0
             return
       end
  else:
  endcase
 endif ;No UV
 if messege le ' ' then sens=0 else sens=1
 if messege le ' ' then messege='<<:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::>>'
 widget_control,sbaset.Mess,set_value=messege[0], sens=sens
endelse
if sbupd then widget_control,ev.top,set_uvalue=sbaset
end

;*********************************************************************************************************************

pro prox_sheet, proxfile, reload=RLstruct, Unitest=Unitest
;+
;** **********
;** **********
;** User callable
;** creates prox_sheet GUI
;-
@lamp.cbk
version =' V1.2 (Oct 2012)'

  ;DEFAULT SETTINGS
  ; ---------------
     curfile  =''
     if keyword_set(Unitest) then ns = 10 else ns =30 ;number of samples
     maxns    =900
     SAVpth   =''
     DATApth  =''
     RLcomment=['']
     RLsample =['']

if (n_elements(proxfile) ne 1) and (n_elements(RLstruct) eq 0) then begin
    defext='sav' & filt='*.sav' & pth='' & fifi=''
    result=dialog_pickfile(path=pth,get_path=gpth,file=fifi,default_ext=defext,/read ,resource_name='lamptouch',filter=filt)
    if result ne '' then begin
       RESTORE,file=result
       if n_elements(RLstruct) gt 0 then tags=tag_names(RLstruct) else tags=['']
       if tags[0] eq "SBASET" then sans_sheet, instru=RLstruct.sbaset.instru, reload=RLstruct else $
       if tags[0] ne "PROX_SHEET"   then                                         RETURN ;BAD FILE !!!
    endif else                                                                   RETURN ;CANCELED
endif

;READ THE FILE
;*************
if n_elements(proxfile) eq 1 then begin
    prox_sheet_read, proxfile, contain, OK
    if not OK then                                                               RETURN ;NO FILE !!!
    on_ioerror,miscode

    if strpos(strupcase(strcompress(contain[0],/remove)),';COLUMNS:') ne 0 then  RETURN ;NO COLUMN !!!

    L=0 & lab='' & while strpos(  strupcase(contain[L]) ,';COLUMNS:') eq 0 do begin
                         lab=lab+' '+strmid(contain[L]  ,9) & L=L+1  & endwhile

    L=L & res='' & while strpos(  strupcase(contain[L]) ,';RESULTS:') eq 0 do begin
                         res=res+' '+strmid(contain[L]  ,9) & L=L+1  & endwhile

    if strpos(lab,',') ge 0 then lab=strsplit(/EXTRACT,strcompress(lab,/remove)   ,',') else $
    if strpos(lab,';') ge 0 then lab=strsplit(/EXTRACT,strcompress(lab,/remove)   ,';') else $
    if strpos(lab,'\') ge 0 then lab=strsplit(/EXTRACT,strcompress(lab,/remove)   ,'\') else $
    if strpos(lab,'|') ge 0 then lab=strsplit(/EXTRACT,strcompress(lab,/remove)   ,'|') else $
    if strpos(lab,'!') ge 0 then lab=strsplit(/EXTRACT,strcompress(lab,/remove)   ,'!') else $
    if strpos(lab,'/') ge 0 then lab=strsplit(/EXTRACT,strcompress(lab,/remove)   ,'/') else $    ;COLUMNS SEPARATOR "/"
    if strpos(lab,' ') ge 0 then lab=strsplit(/EXTRACT,strtrim(strcompress(lab),2),' ')

    idx=where(lab gt '') & if idx[0] ge 0 then lab=lab[idx] else                 RETURN ;NO COLUMN !!!

    if strpos(res,'{') ge 0 then wks=strsplit(/EXTRACT,strcompress(res,/remove)   ,'{') else $
    if strpos(res,'[') ge 0 then wks=strsplit(/EXTRACT,strcompress(res,/remove)   ,'[') else $    ;RESULTS SEPARATOR "[]"
                                 wks=                  strcompress(res,/remove)
    idx=strpos(wks,'}') & idp=where(idx ge 0)
    if idp[0]  ge 0  then begin & wks=wks[idp] & idx=idx[idp]
                     for L=0,n_elements(idp)-1 do wks[L]=strmid(wks[L],0,idx[L])
    endif else begin
    idx=strpos(wks,']') & idp=where(idx ge 0)
    if idp[0]  ge 0  then begin & wks=wks[idp] & idx=idx[idp]
                     for L=0,n_elements(idp)-1 do wks[L]=strmid(wks[L],0,idx[L])
    endif else wks=wks[0]
    endelse
    po= strpos(/reverse_search,proxfile,lamp_dvd)

    curfile  =proxfile & if po ge 0 then curfile=strmid(proxfile,po+1)
    savPTH   =''       & if po ge 0 then savPTH =strmid(proxfile,0,po+1)
    RLsamLAB =lab
    RLproxbu =proxfile
    RLkeepWks=strcompress(res)
    RLresults=wks
    RLcontain=contain

endif else if n_elements(RLstruct) eq 0 then                                     RETURN ;NO INPUT !!!

vertical =1 ; 0=sample list horizontal (not used)
fillincr ='1.0'

  ;RESTORE SETTINGS (LOAD BUTTON)
  ; ---------------
if n_elements(RLstruct) gt 0 then  begin

     if n_elements(proxfile) eq 1  then reload=1 else reload=0
     vertical  =RLstruct.sbaset.vertical
     ns        =RLstruct.sbaset.nsampl
     DATApth   =RLstruct.sbaset.DATApth
     RLsample  =RLstruct.sample & if not vertical then RLsample=transpose(RLsample)
     
     if not reload then begin
     curfile   =RLstruct.sbaset.curfile
     SAVpth    =RLstruct.sbaset.SAVpth
     RLproxbu  =RLstruct.sbaset.RLproxbu
     Reslist   =RLstruct.Reslist
     RLcomment =RLstruct.comments
     RLsamLAB  =RLstruct.sbaset.RLsamLAB
     RLkeepWks =RLstruct.sbaset.RLkeepWks
     RLresults =RLstruct.sbaset.RLresults
     RLcontain =RLstruct.sbaset.RLcontain
     endif else begin
       sizTable=(size(RLstruct.sbaset.RLsamLAB))[1] ;WE HAVE TO CHECK OLD/NEW #COLUMNS
       sizLab  =(size(RLsamLAB))[1]
       RLoldRes= RLstruct.sbaset.RLresults
       if RLoldRes[0]  le ' ' then sizoldR=0 else sizoldR=n_elements(RLoldRes)
       if RLresults[0] le ' ' then sizRes =0 else sizRes =n_elements(RLresults)
       if (sizTable ne sizLab) or (sizoldR ne sizRes) then begin ;NUMBER OF COLUMNS HAS CHANGED !!!
          subTable=RLsample[1:sizTable-1,*]
          if sizTable gt sizLab  then subTable= subTable[0:sizLab-1,*]
          if sizTable lt sizLab  then subTable=[subTable,strarr(sizLab-sizTable,ns)]
          if RLresults[0] le ' ' then RLsample=[RLsample[0,*],subTable] $
                                 else RLsample=[RLsample[0,*],subTable,strarr(n_elements(RLresults),ns)]
       endif
     endelse

     if DATApth gt ' ' then prox_sheet_lampies,SETpth=DATApth

endif else if n_elements(Cvalues) gt 0 then begin ;We have to check the columns label
endif

po= strpos(/reverse_search,RLproxbu,lamp_dvd)
if po ge 0 then titgui=strmid(RLproxbu,po+1) else titgui=RLproxbu
titbas="Prox Inputs for "+titgui+version


if (xregistered(titgui) eq 0) then begin

 ;DEFINE TABLES
 ; ------------
 ; ------------------------------------------------------------------------------------------------------------
  n_tables = 2 ;number of tables and comment texts
  col_row_s=lonarr(4   ,n_tables) ;(ncol),(nraw),(scrollable 1=onX 2=onXY),(1=sample_tab)
  comment_s=strarr(     n_tables) ;comment before each table
  label_s  =strarr(     n_tables) ;label   before each table
  uname_s  =strarr(     n_tables) ;uname     for  each table
  row_label=strarr(  50,n_tables) ;row label for  each table
  col_label=strarr(  50,n_tables) ;col label for  each table
  tables_id=lonarr(2   ,n_tables) ;widget IDs
  col_color=lonarr(3,50,n_tables) & col_color[*]=255 ;grey for un_editable cells
  smp_color=[255,255,255]

  kRLc=0
  k = -1
  nl= n_elements(RLsamLAB)+1
  k=k+1 & col_row_s[0,k]=[nl,ns,2] & comment_s[k]= "SAMPLE INPUTS. Results: "+RLkeepWks
          col_row_s[3,k]=3         & uname_s[  k]= "SAMPLE" & col_label[0,k]     =["Sample ID",RLsamLAB]
          Nlab=n_elements(RLsamLAB)
          Nres=n_elements(RLresults)
          if RLresults[0] gt ' ' then begin
            NL=1+Nlab+Nres         &      col_row_s[0,k]=NL & col_label[1+Nlab,k]=[RLresults+' (max)']

                                          col_color[*,1+Nlab:1+Nlab+Nres-1,k]=220
          endif
                                          smp_color=col_color[*,0:col_row_s[0,k]-1,k]

  if n_elements(RLsample) gt 1 then begin
   if vertical then RLsample=RLsample[*,0:ns-1] else RLsample=RLsample[0:ns-1,*]
   tmp  =strarr(NL,ns) & if not vertical then tmp=transpose(tmp) & tmp[0,0]=RLsample & RLsample=tmp ;so we can restore a smaller table
  endif

 ; ------------------------------------------------------------------------------------------------------------
 ;SIZING TABLES
 ; ------------
  if sys_dep('VERSION') lt 6.1    then oldV=1 else oldV=0
  if sys_dep('MACHINE') eq "unix" then ux  =1 else ux  =0
  if ux then gap=" " else gap="  "
  if ux then L_S="-" else L_S="settings"

  wcol_wcar=8 ;table layout
  wcol_main=(13+ux)*wcol_wcar
  hrow_main= 16+ux
  if ux then labl_spch=hrow_main   else labl_spch=0
  if ux then labl_spcw=wcol_wcar*2 else labl_spcw=0


  if vertical then scrX_main=750 else scrX_main=750 ;640
  scrY_main=600
  scrY_maxt=150

 ;GUI CONSTRUCTOR
 ; --------------
  if oldV then $
  sbase0 = widget_base(  title=titbas,/column,resource_name='lamptouch',MBAR=smbar,rname_mbar='lampben',/tlb_size_event)  else $
  sbase0 = widget_base(  title=titbas,/column,resource_name='lamptouch',MBAR=smbar,rname_mbar='lampben',/tlb_size_event,tab_mod=2)
  widget_control,default_font=ft_propor
  if b_labins[3] ne 0 then widget_control,sbase0,map=0
  smess  = widget_label( sbase0,xsize=scrX_main,ysize=hrow_main,font=ft_b_normal,/dynamic,/align_center)

;TABS
 ; ---
  if n_elements(Reslist) lt 2 then Reslist=['  '+RLkeepWks]
  bforTABS=[sbase0,0L,0L,0L,0L,0L,0L,0L,0L,0L,0L] ;Used for resizing
  btot    = 0L
  if sys_dep('VERSION') ge 5.6 then begin
     tabase = widget_tab(   sbase0)

     sheetb = widget_base(  tabase,title='SPREADSHEET   ')   ;SPREADSHEET
     sbasec = widget_base(  sheetb,/column)
     bid    = widget_base(  sbasec)

     resub  = widget_base(  tabase,title='RESULTS   ')       ;FILES RESULTS
     sbresu = widget_base(  resub ,/column)
     bid    = widget_label( sbresu,value=' ',font=ft_propor)

     proxb  = widget_base(  tabase,title=titgui+'   ')       ;PROX FILE
     sbprox = widget_base(  proxb ,/column)
     bid    = widget_label( sbprox,value=' ',font=ft_propor)

    ;logeb  = widget_base  (tabase,title='LOG   ')           ;LOG IMAGES

    ;docmb  = widget_base  (tabase,title='DO Cmds   ')       ;DO EXTRA CMDS

    ;PROX TAB
    ; -------
     cnt=8 & Yscr=long(cnt*31.58)
     ncr=80
     if n_elements(RLcontain) le cnt   then $
     box =widget_base(  sbprox,/column)  else $
     box =widget_base(  sbprox,/column,x_scroll=wcol_wcar*ncr,y_scroll=Yscr)
     btot=box

     FOR i=0,n_elements(RLcontain)-1 do begin
         curline=strtrim(RLcontain[i],1)
         if (strmid(curline,0,1) eq ';') then begin
             curline=strmid(curline,1)
             bid=widget_label( box,value=curline,font=ft_b_normal,/align_left)                 & btot=[btot,bid,1]
         endif else begin             
             if (strmid(curline,0,1) eq '&') then curline=strmid(curline,1) else curline=RLcontain[i]
             RLcontain[i]=curline
             txt=widget_text(  box,value=curline,font=ft_propor,/editable,xsize=ncr-5,ysize=1) & btot=[btot,txt,0]
         endelse
     ENDFOR
     
     bid = widget_label( box ,font=ft_propor,value= '---------------------')
     relo= widget_button(box ,font=ft_propor,value= 'Reload this PROX file'    ,uvalue=[12,4])
     bid = widget_label( box ,font=ft_propor,value= 'Un-treated extra Do Cmds:')
     txt1= widget_text(  box ,font=ft_propor,value=' ',/editable,xsize=ncr-15,ysize=1) & widget_control,txt1,set_uvalue=[-88,214,-1,txt1,0]
     txt2= widget_text(  box ,font=ft_propor,value=' ',/editable,xsize=ncr-15,ysize=1) & widget_control,txt2,set_uvalue=[-88,214,-1,txt2,0]

    ;RESULTS TAB
    ; ----------
     tmprow =widget_base(  sbresu,/row)
     lstres =widget_list(  tmprow,value=Reslist,font=ft_propor,xsize=50,scr_ysize=Yscr,/multiple)
     temp   =widget_base(  tmprow,/column)
     resbut =widget_button(temp  ,value='SHOW / JOIN  in',font=ft_b_normal,uvalue=[15,1])
     bid    =widget_label( temp  ,value='(Multiple data selection)',font=ft_propor)
     bid    =widget_label( temp  ,value='(implies identical sizes)',font=ft_propor)
     bidex  =widget_base(  temp  ,/exclusive,/row)
       bid1 =widget_button(bidex ,value='SuperPlot',/no_release,font=ft_b_normal,uvalue=[16,1])
       bid2 =widget_button(bidex ,value='Window' ,/no_release,font=ft_b_normal,uvalue=[16,2])
       bid3 =widget_button(bidex ,value='Lamp' ,/no_release,font=ft_b_normal,uvalue=[16,3])
     bid    =widget_label( temp  ,value=' ')
     splitr =widget_base(  temp  ,/row)
       splL =widget_label( splitR,value='STARTING at W'           ,font=ft_b_normal)
       splT =widget_text(  splitR,value='40 ',xsize=3 ,/editable  ,font=ft_propor)
     splitb =widget_button(temp  ,value='SPLIT THE SELECTION'     ,font=ft_b_normal,uvalue=[15,2,splT])
     bid    =widget_label( temp  ,value=' ')
     delbut =widget_button(temp  ,value='DELETE'     ,font=ft_b_normal,uvalue=[15,0])
     widget_control,bid3,set_button=1

     bforTABS[1]=box
     bforTABS[2]=lstres

  endif else begin
     sbasec =widget_base(  sbase0,/column)
     sheetb=0L & endelse

 ;MENU BAR
 ; -------
  sbfile = widget_button(smbar  ,font=ft_propor,value= "File  "   ,/menu)
     bid = widget_button(sbfile ,font=ft_propor,value= '---')    & widget_control,bid,sens=0
     expo= widget_button(sbfile ,font=ft_propor,value= 'Export...')
     bid = widget_button(sbfile ,font=ft_propor,value= '---')    & widget_control,bid,sens=0
     relo= widget_button(sbfile ,font=ft_propor,value= 'Reload current PROX file')
     bid = widget_button(sbfile ,font=ft_propor,value= '---')    & widget_control,bid,sens=0
     bloo= widget_button(sbfile ,font=ft_propor,value= 'Log file' ,/menu)
     blo1= widget_button(bloo   ,font=ft_propor,value= 'Start registering' )
     blo2= widget_button(bloo   ,font=ft_propor,value= 'Show  the Log file (html)')
     blo3= widget_button(bloo   ,font=ft_propor,value= 'Clear the Log file (html)')
     bid = widget_button(bloo   ,font=ft_propor,value= '')
     blo4= widget_button(bloo   ,font=ft_propor,value= 'Show  the Lamp Journal')

     bid = widget_button(sbfile ,font=ft_propor,value= '---')    & widget_control,bid,sens=0
     exis= widget_button(sbfile ,font=ft_propor,value= 'Exit with Save')
     exi = widget_button(sbfile ,font=ft_propor,value= 'Exit')

  sbinst = widget_button(smbar  ,font=ft_propor,value= "Path  "       ,/menu)
     mpth= widget_button(sbinst ,font=ft_propor,value= 'Set Data path',/menu)
     bpth= widget_button(mpth   ,font=ft_propor,value= 'Set Data path using Explorer')
     bptl= widget_button(mpth   ,font=ft_propor,value= 'Set Data path using Lamp')
     bid = widget_button(mpth   ,font=ft_propor,value= '---')    & widget_control,bid,sens=0
     bptw= widget_button(sbinst ,font=ft_propor,value= 'Set Working path')
     bid = widget_button(sbinst ,font=ft_propor,value= '---')    & widget_control,bid,sens=0
     bpts= widget_button(sbinst ,font=ft_propor,value= 'Show Data path')
     bid = widget_button(sbinst ,font=ft_propor,value= '---')    & widget_control,bid,sens=0

  sbbid  = widget_button(smbar  ,font=ft_propor,value= "    ")
  sbhelp = widget_button(smbar  ,font=ft_propor,value= "Help"         ,/menu)
    bid  = widget_button(sbhelp ,font=ft_propor,value= "-First set a correct path for your input data")
    bid  = widget_button(sbhelp ,font=ft_propor,value= "-Then fill all table cells (except those colored)")
    bid  = widget_button(sbhelp ,font=ft_propor,value=   '---')  & widget_control,bid,sens=0
    bid  = widget_button(sbhelp ,font=ft_propor,value= "-Finally click on the TREAT button")
    bid  = widget_button(sbhelp ,font=ft_propor,value=   '---')  & widget_control,bid,sens=0
    bid  = widget_button(sbhelp ,font=ft_propor,value= "-SYNTAX in CELL runs: 123 , 123+125+127 , 123+125>128+134")
    bid  = widget_button(sbhelp ,font=ft_propor,value= "-SYNTAX in IDs column: use only alphanumeric caracters & ' ','-','_'")
    bid  = widget_button(sbhelp ,font=ft_propor,value=   '---')  & widget_control,bid,sens=0
    bid  = widget_button(sbhelp ,font=ft_propor,value= "-SYNTAX IN THE FIRST 2 LINES OF THE PROX FILE:")
    bid  = widget_button(sbhelp ,font=ft_propor,value= "       ;COLUMNS: label1 / label2 / label3 / label4  ... (a_Z only)")
    bid  = widget_button(sbhelp ,font=ft_propor,value= "       ;RESULTS: {W8} blabla , {W14} blabla , {t}   ...")
    bid  = widget_button(sbhelp ,font=ft_propor,value= " ")
    bid  = widget_button(sbhelp ,font=ft_propor,value= "        CELL structure STRING values are: CELL.label1, CELL.label2 ...")
    bid  = widget_button(sbhelp ,font=ft_propor,value= "        For floating values, use FLOAT(CELL.label) in your PROX file")
    bid  = widget_button(sbhelp ,font=ft_propor,value= "        Use the RDOPR reading function instead of RDSUM and RDAND")
    bid  = widget_button(sbhelp ,font=ft_propor,value= "        Use conditionnal empty cells to disable re-read operations:")
    bid  = widget_button(sbhelp ,font=ft_propor,value= "            IF CELL.Vana_run ne '' THEN W1=RDOPR(CELL.Vana_run)")
    bid  = widget_button(sbhelp ,font=ft_propor,value= "            (AVOID to reference more than one Workspace in IF statements)")
    bid  = widget_button(sbhelp ,font=ft_propor,value= "        CELL.Sn  is current Sample number ('1'->'n')")
    bid  = widget_button(sbhelp ,font=ft_propor,value= "        CELL.Sid    is current Sample ID")
    bid  = widget_button(sbhelp ,font=ft_propor,value= "        CELL.Firstime  is '1' on fisrt call to the prox, '0' after.")
    bid  = widget_button(sbhelp ,font=ft_propor,value= "        ENDPROX  is the procedure call which skips all further commands")

  widget_control,bpth  ,set_uvalue=[51,2,bpth,bptl] ;DATA PATH (explorer)
  widget_control,bptl  ,set_uvalue=[51,3,bpth,bptl] ;DATA PATH (lamp)
  widget_control,bpts  ,set_uvalue=[51,4,bpth,bptl] ;DATA PATH (to show)
  widget_control,bptw  ,set_uvalue=[51,5,bpth,bptl] ;WORKING PATH (to set)

  widget_control,relo  ,set_uvalue=[12,4]   ;RELOAD CURRENT PROX FILE

  widget_control,blo1  ,set_uvalue=[20,1]   ;LOG START/STOP
  widget_control,blo2  ,set_uvalue=[20,2]   ;LOG SHOW
  widget_control,blo3  ,set_uvalue=[20,3]   ;LOG RESET
  widget_control,blo4  ,set_uvalue=[20,4]   ;Lamp Journal

  widget_control,expo  ,set_uvalue=[13]     ;EXPORT
  widget_control,exis  ,set_uvalue=[12,3]   ;SAVE-EXIT
  widget_control,exi   ,set_uvalue=[77]     ;EXIT

 ;LEADING FIELDS
 ; ------ ------
  row0    = widget_base(  sbasec,/row)
  row1    = widget_base(  sbasec,/row)
  row11   = widget_base(  row1  ,frame=1,/row)
   bclrs  = widget_button(row11 ,value="Clear cells"                       ,font=ft_b_normal,/menu)
   ;bclrs0= widget_button(bclrs ,value="Reset ALL"                         ,font=ft_b_normal)
   ;bclrs1= widget_button(bclrs ,value="Clear ALL cells"                   ,font=ft_b_normal)
    bclrs2= widget_button(bclrs ,value="Clear ALL Sample table cells"      ,font=ft_b_normal)
    bclrs3= widget_button(bclrs ,value="Clear selected Sample table cells" ,font=ft_b_normal)
    bid   = widget_button(bclrs ,value=""                                  ,font=ft_b_normal)
    bclrs4= widget_button(bclrs ,value="Remove the selected sample ID line" ,font=ft_b_normal)
    bclrs5= widget_button(bclrs ,value="Insert a new sample ID just before the selected one" ,font=ft_b_normal)
   bid    = widget_label( row11 ,value="NBsamples"          ,font=ft_b_normal)
   bnsamp = widget_text(  row11 ,value=strtrim(ns,2)        ,font=ft_propor   ,xsize=3 ,/editable)
   bid    = widget_label( row1  ,value=gap                  ,font=ft_propor)
  row12   = widget_base(  row1  ,frame=1,/row)
   bfill  = widget_button(row12 ,value="Fill down sample"   ,font=ft_b_normal,/menu)
   bfill1 = widget_button(bfill ,value="Fill down without increment (from selected cell in sample table)" ,font=ft_b_normal)
   bfill3 = widget_button(bfill ,value="Fill down according to increment value"                           ,font=ft_b_normal)
   bfill2 = widget_button(bfill ,value="Fill down with  1 increment"                                      ,font=ft_b_normal)
   bid    = widget_label( row12 ,value="incr:"              ,font=ft_b_normal)
   bincr  = widget_text(  row12 ,value=fillincr             ,font=ft_propor   ,xsize=3 ,/editable)
   bid    = widget_label( row1  ,value=gap                  ,font=ft_propor)
  row13   = widget_base(  row1  ,frame=1,/row)
   bload  = widget_button(row13 ,value="Load"               ,font=ft_b_normal)
   bid    = widget_label( row13 ,value=L_S                  ,font=ft_b_normal)
   bsave  = widget_button(row13 ,value="Save"               ,font=ft_b_normal)
   bid    = widget_label( row1  ,value=gap                  ,font=ft_propor)
  row14   = widget_base(  row1  ,frame=3,/row)
   bgo    = widget_button(row14 ,value=" TREAT "            ,font=ft_b_normal,/menu)
   bgo0   = widget_button(bgo   ,value="Treat ALL Samples"  ,font=ft_b_normal)
   bid    = widget_button(bgo   ,value=" ")                  & widget_control,bid,sens=0
   bgo1   = widget_button(bgo   ,value="Treat Selected Samples"  ,font=ft_b_normal)
   bid    = widget_button(bgo   ,value=" ")                  & widget_control,bid,sens=0
   bstop  = widget_button(bgo   ,value="STOP treating !!!"  ,font=ft_b_normal)

  row2    = widget_base(  sbasec,/row)
   prox_sheet_lampies,GETpth=result & if result eq '' then CD,current=result
   if n_elements(smess2) ne 1   then begin
    smess2= widget_label( row2  ,xsize=scrX_main,ysize=hrow_main ,font=ft_b_normal, /dynamic,/align_center)
   endif
   widget_control,smess ,set_value="Data path: "+result
   widget_control,smess2,set_value=" "

 ;widget_control,bclrs0,set_uvalue=[78]          ;Clear ALL
 ;widget_control,bclrs1,set_uvalue=[10,1,bnsamp] ;Clear ALL cells
  widget_control,bclrs2,set_uvalue=[10,2,bnsamp] ;Clear ALL Sample table cells
  widget_control,bclrs3,set_uvalue=[10,3,bnsamp] ;Clear selected Sample table cells
  widget_control,bclrs4,set_uvalue=[10,4,bnsamp] ;Remove a sample line
  widget_control,bclrs5,set_uvalue=[10,5,bnsamp] ;Insert a sample line
  widget_control,bnsamp,set_uvalue=[10,0,bnsamp] ;Nsamples input
  widget_control,bfill1,set_uvalue=[11,0,bincr]  ;Fill down 0 increment
  widget_control,bfill2,set_uvalue=[11,1,bincr]  ;Fill down 1 increment
  widget_control,bfill3,set_uvalue=[11,2,bincr]  ;Fill down x increment
  widget_control,bload ,set_uvalue=[12,1]        ;Load settings
  widget_control,bsave ,set_uvalue=[12,2]        ;Save
  widget_control,bgo0  ,set_uvalue=[14,0,0]      ;Treat all
  widget_control,bgo1  ,set_uvalue=[14,1,0]      ;Treat selected samples
  widget_control,bstop ,set_uvalue=[14,2,0]      ;Stop treating

 ;TABLES (...AUTOMATIC CONSTRUCTION...)
 ; ------------------------------------
  j=-1  &  al=1
  while (j lt n_tables-1) do begin & j=j+1 & i=j
   ;LABEL if there
   ; -------------
    if label_s[i] gt '' then begin
       bid=widget_base( sbasec,/row)
       lab=widget_label(bid   ,value=label_s[i],font=ft_b_normal)
    endif
   ;TEXT OF COMMENTS
   ; ---------------
    if comment_s[i] gt '' then begin
       bid=widget_base(sbasec,/row)
       while ((col_row_s[0,j] eq 0) and (j lt n_tables-1)) do j=j+1
       if    ((col_row_s[0,j] ne 0) and (j gt i))        then j=j-1
       tables_id[0,i]= widget_text(  bid,value=comment_s[i:j],scr_xsize=scrX_main-20,ysize=j-i+1,font=ft_propor,/editable)
       if RLcomment[kRLc] gt '' then begin
          widget_control,tables_id[0,i],set_value=RLcomment[kRLc:kRLc+j-i] & kRLc=kRLc+j-i+1 & endif
    endif

   ;TABLES
   ; -----
    if col_row_s[0,j] ne 0 then begin
       bid=widget_base(sbasec,/row)
       c   =col_row_s[0,j]              & scrx=(wcol_main+2)*c
       r   =col_row_s[1,j]              & scry=(hrow_main+1)*r
       nc  =strlen(col_label[0,j])      & nr  =strlen(row_label[0,j])
       nrp =(nr+3.)*wcol_wcar/wcol_main

      ;TABLE ROW & COL LABELED
      ; ----------------------
       if (nr gt 0) and (nc gt 0) then begin
          scrx=round(scrx/c*(c+nrp))+labl_spcw
          scry=round(scry/r*(r+2.2))+labl_spch ;(+scroll bar + col label)
          if oldV then begin
          tables_id[1,j]= widget_table( bid,xsize=c,ysize=r,column_width=wcol_main,row_height=hrow_main,font=ft_propor,format="(A)" ,$
                                        uname=uname_s[j],alignment=al,row_labels=row_label[0:r-1,j],column_labels=col_label[0:c-1,j],$
                                       /editable,/context_events,uvalue=[40]) & endif else $
          tables_id[1,j]= widget_table( bid,xsize=c,ysize=r,column_width=wcol_main,row_height=hrow_main,font=ft_propor,format="(A)" ,$
                                        uname=uname_s[j],alignment=al,row_labels=row_label[0:r-1,j],column_labels=col_label[0:c-1,j],$
                                        background=col_color[*,0:c-1,j],/editable,/context_events,uvalue=[40])
      ;TABLE ROW       LABELED
      ; ----------------------
       endif else if (nr gt 0)    then begin
          scrx=round(scrx/c*(c+nrp))+labl_spcw
          if oldV then begin
          tables_id[1,j]= widget_table( bid,xsize=c,ysize=r,column_width=wcol_main,row_height=hrow_main,font=ft_propor,format="(A)",$
                                        uname=uname_s[j],alignment=al,row_labels=row_label[0:r-1,j],column_labels='',$
                                       /editable,/context_events,uvalue=[40])
                          widget_control,tables_id[1,j],use_table_select=[-1,-1,-1,-1],row_height=1 & endif else $
          tables_id[1,j]= widget_table( bid,xsize=c,ysize=r,column_width=wcol_main,row_height=hrow_main,font=ft_propor,format="(A)",$
                                        uname=uname_s[j],alignment=al,row_labels=row_label[0:r-1,j],/no_column_headers,$
                                        background=col_color[*,0:c-1,j],/editable,/context_events,uvalue=[40])

          if c gt 1 then begin & values=strarr(c,r) & values[*,0]='  S'+strtrim(indgen(c)+1,2)
                               scry=scry/r*(r+1) ;(+scroll bar)
                               widget_control,tables_id[1,j],set_value=values & endif
      ;TABLE       COL LABELED
      ; ----------------------
       endif else if (nc gt 0)   then begin
          scry=scry/r*(r+1+ux)+labl_spch ;(+col label)
          if r eq 1 then scry=0
          if oldV then begin
          tables_id[1,j]= widget_table( bid,xsize=c,ysize=r,column_width=wcol_main,row_height=hrow_main,font=ft_propor,format="(A)",$
                                        uname=uname_s[j],alignment=al,column_labels=col_label[0:c-1,j],row_label='',$
                                       /editable,/context_events,uvalue=[40])
                          widget_control,tables_id[1,j],use_table_select=[-1,-1,-1,-1],column_width=1
          endif else $
          tables_id[1,j]= widget_table( bid,xsize=c,ysize=r,column_width=wcol_main,row_height=hrow_main,font=ft_propor,format="(A)",$
                                        uname=uname_s[j],alignment=al,column_labels=col_label[0:c-1,j],/no_row_headers,$
                                        background=col_color[*,0:c-1,j],/editable,/context_events,uvalue=[40], /resizeable_columns)

          if r gt 1 then begin & values=strarr(c,r) & values[0,*]='  S'+strtrim(indgen(r)+1,2)
                    if strlowcase(rlsamlab[0]) eq 'sample' then begin & values[0,0]='Vanadium' & values[1,0]='012345'
                       idV= where((strlowcase(rlsamlab) eq 'is_vana') or (strlowcase(rlsamlab) eq 'isvana'))
                       if idV[0] gt 1 then values[idV[0]+1 , 0]='1'
                    endif
                    widget_control,tables_id[1,j],set_value=values & endif
      ;TABLE        UN_LABELED
      ; ----------------------
       endif else begin
          tables_id[1,j]= widget_table( bid,xsize=c,ysize=r,column_width=wcol_main,row_height=hrow_main,font=ft_propor,format="(A)",$
                                        uname=uname_s[j],alignment=al,/no_headers,$
                                       /editable,/context_events,uvalue=[40])
       endelse
       
       widget_control,tables_id[1,j], scr_xsize=scrx<scrX_main , scr_ysize=scry<scrY_maxt
       if uname_s[j] eq "SAMPLE" then if n_elements(RLsample) gt 1 then widget_control,tables_id[1,j],set_value=RLsample $
                                                                   else if keyword_set(Unitest) then $
                                                                        widget_control,tables_id[1,j],set_value=strarr(c,r)+'1'
       if uname_s[j] eq "SAMPLE" then if (not vertical) then  $
          for k=0,col_row_s[1,j]-1 do widget_control,tables_id[1,j],use_table_select=[0,k,col_row_s[0,j]-1,k],background=smp_color[*,k]
    endif
  endwhile

 ;Memory Progress-bar
  PUT_Progress, sbasec, draw=sepPB

 ;REALIZE
 ; ------
  if n_elements(lamp_b1) ne 1 then lamp_b1=0L & empty
  widget_control  ,sbase0 ,/realize & wait,.1 & empty
  if lamp_b1 gt 0L then widget_control  ,sbase0 ,group_leader=lamp_b1
  stri=widget_info(sbase0 ,/geometry)
 ;                            WATER                       BEAM                     SAMPLE ;(or using uname_s)
  idxtab=[where(col_row_s[3,*] eq 1),where(col_row_s[3,*] eq 2),where(col_row_s[3,*] eq 3)]
  unames= uname_s[idxtab]

  sbaset={stri:stri, tids:tables_id, cr_s:col_row_s, Mess:smess, nsampl:ns, idxtab:idxtab, smp_color:smp_color,unames:unames,$
          vertical:vertical,curfile:curfile,SAVpth:savpth,DATApth:datapth,lamp_b1:lamp_b1, maxns:maxns ,$
          col_label:col_label,row_label:row_label, Bprogress:sepPB, firstime:'1', $
          bforTABS:bforTABS, sheetb:sheetb, bstop:bstop, Mess2:smess2, Bcontain:btot, Ushow:3, LogOn:0 ,$
          RLsamLAB:rlsamlab, RLproxbu:rlproxbu, RLkeepWks:rlkeepwks, RLresults:rlresults, RLcontain:rlcontain}

  widget_control  ,sbase0 ,set_uvalue=sbaset ,iconify=0
  widget_control  ,smess2 ,set_uvalue=Reslist

  if sys_dep('VERSION') ge 5.6 then begin
     widget_control,bfill,Tooltip="Select one starting cell in sample table, verify the increment"
  endif
  xmanager, titgui, sbase0,event_handler='prox_sheet_event',CLEANUP='PROX_SHEET_DYING',/just_reg
  widget_control  , sbase0,iconify=0
  UM_Progress ; Update Memory _ Progress Bar

  if keyword_set(Unitest) then PROX_SHEET_EVENT, {WIDGET_BUTTON, ID:bgo0, TOP:sbase0, HANDLER:sbase0, SELECT:1}

endif ;registered
miscode:
end
