function read_column, fileIN, header=header, bidim=bi_dim, biy=bi_Y, bixy=bi_XY, bixye=bi_XYE, PATH,FILENUME,STATUS,DATP
;+
;******* ***********
;** User callable
;** CALL is :W1=read_column( file, header=header, bidim=bi_dim)
;** Reads a 1,2,3 or 4 columns file in X,W, E, Z
;** Header is the number of header line(s) to skip or an empty header string_array to fill
;** Returns W
;** CALL: W1=read_column( 'filename' [,header=3] )
;-

;** D.R. Apr 2011
;**      Jul 2011 add reading an image including X and Y axis ,bi_dim=[10,35] means [yi+9col , X+34rows] ; NaN,mXa, n[Ya, mY]
;**      Oct 2011 accept having no keywords if file is a Lamp format
;**      Nov 2011 accept Lamp calling parameters
;**      Jul 2013 add reading an image including X axis ,bi_XY =[ 6,35] means [xi+  5col , 35 rows]      ; n[Xa, mY]
;**      Jul 2013 add reading an image including X axis ,bi_XYE=[11,35] means [xi+2*5col , 35 rows]      ; n[Xa, m(Y,Ey)]
;**      Sep 2014 add reading an image                  ,bi_Y  =[ 6,35] means [     6col , 35 rows]      ; n[    mY]

;Check if called from Lamp Menu Inst  or  from command line
;**********************************************************
if n_elements(FILENUME) eq 0 then begin & file=fileIN      & menu=0 & endif $
                             else begin & file=FILENUME[0] & menu=1 & endelse
pp=strpos(file,'.')
;if pp lt 0 then file=file+'.txt'                             
                             
if n_elements(PATH)     eq 1      then  file=PATH+file
if arg_present(DATP)    then dp=1 else  dp=0 ;give_datp if 0

;We may have head lines if header is a number or a string array
;**************************************************************
typH=size(header,/type) & okH=1
if (typH ge 1) and (typH le 3) then if header gt 0 then header=strarr(header) $
                               else okH=0 $
else if (typH ne 7) then   begin &    okH=0 & header='' & endif

if n_elements(bi_dim) eq 2 then biOK=1 else $
if n_elements(bi_Y )  eq 2 then biOK=2 else $
if n_elements(bi_XY ) eq 2 then biOK=3 else $
if n_elements(bi_XYE) eq 2 then biOK=4 else biOK=0

on_ioerror,misfile
  status=11
  OPENR,u,file,/get_lun

  status=13
  on_ioerror,badhead
  line1='' & diese='' & sigma=0 & s1=0L & s2=0L
  X=0 & Y=0 & E=0 & Z=0 & N=0L & Xtit='' & Ytit='' & Ztit='' & Wtit=''

  if okH       then begin & READF,u,header & diese=strmid(header[0],0,1) & endif else $
  if biOK eq 0 then begin & READF,u,line1  & diese=strmid(line1    ,0,1) & endif

 ;IS IT A LAMP FORMAT !!!
 ;*******************
  if diese eq '#' then begin
     if okH then tstLmp=header[0] else tstLmp=line1
     i=strpos(tstLmp,'->Size:') & j=strpos(tstLmp,'Sigma:')
     if (i ge 0) and (j gt i) then begin ;PROBABLY...
       Wtit= strmid(tstLmp,0,i)
       reads,strmid(tstLmp,i+7,50),s1,s2 & reads,strmid(tstLmp,j+6,10),sigma
       if s2 le 1 then biOK=0 $
       else begin
         biOK=1 & bi_dim=[s1+1,s2+1]
       endelse
       i=strpos(tstLmp,'Moni:') & j=strpos(tstLmp,'Xtit:')
       k=strpos(tstLmp,'Ytit:') & l=strpos(tstLmp,'Ztit:')
       if i gt 0 then                reads,strmid(tstLmp,i+5,50)   ,N
       if j gt 0 then if k gt j then reads,strmid(tstLmp,j+5,k-j-5),Xtit $
                                else reads,strmid(tstLmp,j+5,50)   ,Xtit
       if k gt 0 then if l gt k then reads,strmid(tstLmp,k+5,l-k-5),Ytit $
                                else reads,strmid(tstLmp,k+5,50)   ,Ytit
       if l gt 0 then                reads,strmid(tstLmp,l+5,50)   ,Ztit
     endif
     if biOK eq 0 then $
        while diese eq '#' do begin
          READF,u,line1 & diese=strmid(line1,0,1) & endwhile
  endif
  
 ;READ A VECTOR
 ;*************
  if biOK eq 0 then begin
   ;Test number of columns
   ;**********************
    temp=fltarr(10) & READS,line1+' -7e7 -7e7 -7e7 -7e7 -7e7 -7e7 -7e7 -7e7 -7e7', temp
    ncol=n_elements(where(temp ne  -7e7))
    Wout=temp[0:ncol-1]

    if s1 gt 0 then $
    temp=fltarr(ncol,s1-1)  else $
    temp=fltarr(ncol,1000) ;reads by 1000 lines 
                           ;*******************
   ;Read ALL
   ;********
    on_ioerror,onEof
    while (1) do begin
      READF,u,temp
      Wout=[[Wout],[temp]] & temp[*]=0.
      if s1 gt 0 then break
    endwhile
    onEof:free_lun,u
    message,/reset

    if total(temp[*,0]) ne 0. then begin
      tail=n_elements(where(total(temp,1) ne 0.))
      Wout=[[Wout],[temp[*,0:tail-1]]] & endif
  
   ;Dispatch
   ;********
    if ncol ge 2 then W=reform(Wout[1,*]) else W=reform(Wout[0,*])
    if ncol ge 2 then X=reform(Wout[0,*]) else X=0
    if ncol ge 3 then E=reform(Wout[2,*]) else E=0
    if ncol ge 4 then Z=reform(Wout[3,*]) else Z=0
    
 ;READ AN IMAGE WITH X,Y AXIS
 ;***************************
  endif else begin
    if biOK eq 1 then begin ;From Lamp output write columns: mXa , n[Ya , mY]
       data=fltarr(bi_dim) & READF,u,data
       X   =data[1:*,0]
       Y   =reform(data[0,1:*])
       W   =data[1:*,1:*]
       if sigma then begin
          E=fltarr(bi_dim) & READF,u,E & E=E[1:*,1:*]
       endif
    endif

    if biOK eq 2 then begin ;                  Y[m,n]
       data=fltarr(bi_y)   & READF,u,data
       W   =reform(data)
    endif
    
    if biOK eq 3 then begin ;                  n[Xa , mY]
       data=fltarr(bi_xy)  & READF,u,data
       X   =reform(data[0 , *])
       W   =data[1:*,*]    & W = transpose(W)
    endif

    if biOK eq 4 then begin ;From Qens output: n[Xa , m(Y,E)]
       data=fltarr(bi_xye) & READF,u,data
       X   =reform(data[0 , *])
       W   =data[lindgen((bi_xye[0]-1)/2)*2+1 , *] & W = transpose(W)
       E   =data[lindgen((bi_xye[0]-1)/2)*2+2 , *] & E = transpose(E)
      ;Try to find Y
      ;*************
       Yst =strsplit(/EXTRACT,header[0],',')
       if n_elements(Yst) ge bi_xye[0] then begin
          Y = findgen((bi_xye[0]-1)/2)
          for i=1L,bi_xye[0]-1,2 do begin
            p1=strpos(Yst[i],'_') & p2=strpos(Yst[i],'_',p1+1) & p3=strpos(Yst[i],'_',p2+1)
            if p3 gt p2+1 then Y[(i-1)/2]=float(strmid(Yst[i],p2+1,p3-p2-1))
          endfor
       endif
    endif
  endelse

 ;RETURN THE DATA
 ;***************  
  if Wtit lt '   ' then WTIT=file
  Otit=file
  if okH then begin & TXT=header+' =' & P=fltarr(n_elements(header))
                    if Xtit eq '' then XTIT=header[0]
  endif  else begin & TXT='=' & P=0   & endelse
  
  datp= {X:X, Y:Y, E:E, Z:Z, N:N, PAR_TXT:TXT, P:P, $
         W_TIT:WTIT, X_TIT:XTIT, Y_TIT:YTIT, Z_TIT:ZTIT, OTHER_TIT:Otit}
  if not dp then GIVE_DATP,datp
  status=0
  free_lun,u & return,W
  
  badhead: lamp_message,'!!! Verify your header'
           free_lun,u & return,0

misfile:   lamp_error & return,0
end
