pro did_readf,line,fmt,v1,v2,v3,v4,v5,v6,v7,v8,v9,v10
;+
;** *********
;** read number values from the string line variable
;-
on_ioerror,misreads
for i=1,n_elements(fmt) do begin 
    if fmt[i-1] gt 0 then line=strmid(line,fmt[i-1],200)
    if i eq 1 then reads,line,v1,line else $
    if i eq 2 then reads,line,v2,line else $
    if i eq 3 then reads,line,v3,line else $
    if i eq 4 then reads,line,v4,line else $
    if i eq 5 then reads,line,v5,line else $
    if i eq 6 then reads,line,v6,line
endfor
misreads:
end

pro READ_ORG, pthfil, w,x,y,z,e, headr,step,m,n,f,a,b,c,d, org,pair,mxi, status=pp2,ws=ws,strtit=strtit, comhis=comhis
;+
;** ********
;** called when the XY(Z) format is selected from the Import GUI
;-
on_ioerror,misopen
OPENR,u,pthfil,/get_lun & line=' '
on_ioerror,misread

if (step le 1) and (a+b+c+d eq 0) then OKhis=1 else OKhis=0 ; 1 means we may use read_column.pro

case org of
0:	fmt=[a,b]
1:	fmt=[a,b,c]
2:	fmt=[a,b,c]
3:	fmt=[a,b,c,d]
4:	fmt=[a,b,c,d]
else:
endcase

;Skip header if there.
;********************
if headr gt 0 then begin & strtit=strarr(headr<10)           &    readf,u,strtit
                         if headr gt 10 then for i=11L,headr do readf,u,line
endif

clearpar,fix(ws),ws

;READ an n[X, mY] MATRIX
;***********************
if org  eq 5 then begin & w=fltarr(m+1,n)         & readf,u,w & x=reform(w[0,*]) & y=lindgen(m)+1 & w=w[1:*,*]
                  if n gt m then w=transpose(w)   else  begin & t=x & x=y & y=t  & endelse
                  
                  bixy='bixy=['+strtrim(m+1,2)+','+strtrim(n,2)+']'
                  if OKhis then $
                     if headr gt 0 then comhis=comhis+ '; or W=read_column("'+pthfil+'", '+bixy+ ', header='+strtrim(headr,2)+')' $
                                   else comhis=comhis+ '; or W=read_column("'+pthfil+'", '+bixy+ ')'
endif else $

;READ an [m,n,f] TABLE
;*********************
if org  eq 6 then begin & w=reform(fltarr(m,n,f)) & readf,u,w & x=lindgen(m)+1   & y=lindgen(n)+1 & z=lindgen(f)+1
endif else $

;READ an n[Xa, m(Y,Ey)] MATRIX
;*****************************
if org  eq 7 then begin
                  W = read_column(pthfil, header=headr+0, bixye=[m*2+1,n], '' , pthfil , pp2 , datp)
                  X = datp.X
                  Y = datp.Y
                  E = datp.E
                  bixye='bixye=['+strtrim(m*2+1,2)+','+strtrim(n,2)+']'
                  if OKhis then $
                     if headr gt 0 then comhis=comhis+ '; or W=read_column("'+pthfil+'", '+bixye+', header='+strtrim(headr,2)+')' $
                                   else comhis=comhis+ '; or W=read_column("'+pthfil+'", '+bixye+')'
endif else $

;READ an mXa, n(Ya, mY) MATRIX
;*****************************
if org  eq 8 then begin
                  W = read_column(pthfil, header=headr+0, bidim=[m+1,n+1], '' , pthfil , pp2 , datp)
                  X = datp.X
                  Y = datp.Y
                  E = datp.E
                  bidim='bidim=['+strtrim(m+1,2)+','+strtrim(n+1,2)+']'
                  if OKhis then $
                     if headr gt 0 then comhis=comhis+ '; or W=read_column("'+pthfil+'", '+bidim+', header='+strtrim(headr,2)+')' $
                                   else comhis=comhis+ '; or W=read_column("'+pthfil+'", '+bidim+')'
endif else $

;READ OTHER
;**********
if org  eq 9 then begin
             if pair eq 1 then $
                  W = read_column(pthfil, header=headr+0, biY=[m,n], '' , pthfil , pp2 , datp) $
             else W = read_column(pthfil, header=headr+0           , '' , pthfil , pp2 , datp)

                  if pair eq 1 then biy=', biY=['+strtrim(m,2)+','+strtrim(n,2)+']' else biy=''
                  if OKhis then $
                     if headr gt 0 then comhis='W=read_column("'+pthfil+'"'+biy+', header='+strtrim(headr,2)+')' $
                                   else comhis='W=read_column("'+pthfil+'"'+biy+')'
endif else $

;READ BY N or M ELEMENTS
;***********************
if pair eq 1 then begin & mn = max([m,n])
   w=fltarr(mn) & x=fltarr(mn)
   case org of
   0:   begin & readf,u,x & if step gt 1 then for i=2,step do readf,u,line ;*** X,Y
              readf,u,w
        end
   1:   begin & readf,u,x & if step gt 1 then for i=2,step do readf,u,line ;*** X,Y,Sigma
              readf,u,w & if step gt 1 then for i=2,step do readf,u,line & e=fltarr(mn)
              readf,u,e
        end
   2:   begin & y=fltarr(mn) & z=fltarr(mn) & w[*]=1
              readf,u,x & if step gt 1 then for i=2,step do readf,u,line ;*** X,Y,Z
              readf,u,y & if step gt 1 then for i=2,step do readf,u,line
              readf,u,z
        end
   3:   begin & y=fltarr(mn) & z=fltarr(mn)
              readf,u,x & if step gt 1 then for i=2,step do readf,u,line ;*** X,Y,Z,Value
              readf,u,y & if step gt 1 then for i=2,step do readf,u,line
              readf,u,z & if step gt 1 then for i=2,step do readf,u,line
              readf,u,w
        end
   4:   begin & e=fltarr(mn) & z=fltarr(mn)
              readf,u,x & if step gt 1 then for i=2,step do readf,u,line ;*** X,Y,Sigma,dX
              readf,u,w & if step gt 1 then for i=2,step do readf,u,line
              readf,u,e & if step gt 1 then for i=2,step do readf,u,line
              readf,u,z
        end
   else:
   endcase
   
;READ BY LINES
;*************
endif else begin
  on_ioerror,miseof & cnt=0L & dim=500 & tmp=fltarr(dim) & w=fltarr(dim) & x=fltarr(dim)
                      cnp=0L &  v1=0.  & v2=0.  & v3=0.  & v4=0.
                      if org ge 2 then  begin & y =fltarr(dim) & z=fltarr(dim) & endif
                      if org eq 1 then        e =fltarr(dim)
                      if org eq 4 then  begin & e =fltarr(dim) & y=0           & endif
                      if total(fmt) eq 0 then sp=1 else sp=0
 
  if OKhis then if (org eq 0) or (org eq 1) or (org eq 4) then $
     if headr gt 0 then comhis=comhis+ '; or W=read_column("'+pthfil+'", header='+strtrim(headr,2)+')' $
                   else comhis=comhis+ '; or W=read_column("'+pthfil+'")'

  trou=1
  while (trou) do begin
   case org of
   0:   begin & if sp then readf,u,v1,v2       else begin & readf,u,line & did_readf,line,fmt,v1,v2       & endelse
              x[cnp]=v1 & w[cnp]=v2
              if cnt eq dim-1 then begin & w=[w,tmp] & x=[x,tmp]                         & cnt=0  & endif else cnt=cnt+1
        end
   1:   begin & if sp then readf,u,v1,v2,v3    else begin & readf,u,line & did_readf,line,fmt,v1,v2,v3    & endelse
              x[cnp]=v1 & w[cnp]=v2 & e[cnp]=v3
              if cnt eq dim-1 then begin & w=[w,tmp] & x=[x,tmp] & e=[e,tmp]             & cnt=0  & endif else cnt=cnt+1
        end
   2:   begin & if sp then readf,u,v1,v2,v3    else begin & readf,u,line & did_readf,line,fmt,v1,v2,v3    & endelse
              x[cnp]=v1 & y[cnp]=v2 & z[cnp]=v3
              if cnt eq dim-1 then begin & x=[x,tmp] & y=[y,tmp] & z=[z,tmp]             & cnt=0  & endif else cnt=cnt+1
        end
   3:   begin & if sp then readf,u,v1,v2,v3,v4 else begin & readf,u,line & did_readf,line,fmt,v1,v2,v3,v4 & endelse
              x[cnp]=v1 & y[cnp]=v2 & z[cnp]=v3 & w[cnp]=v4
              if cnt eq dim-1 then begin & w=[w,tmp] & y=[y,tmp] & x=[x,tmp] & z=[z,tmp] & cnt=0  & endif else cnt=cnt+1
        end
   4:   begin & if sp then readf,u,v1,v2,v3,v4 else begin & readf,u,line & did_readf,line,fmt,v1,v2,v3,v4 & endelse
              x[cnp]=v1 & w[cnp]=v2 & e[cnp]=v3 & z[cnp]=v4
              if cnt eq dim-1 then begin & w=[w,tmp] & e=[e,tmp] & x=[x,tmp] & z=[z,tmp] & cnt=0  & endif else cnt=cnt+1
        end
   else:
   endcase
   cnp=cnp +1
   if step gt 1 then for i=2,step do readf,u,line
   if mxi  gt 0 then if  cnp  eq mxi then  trou=0
  endwhile
  miseof:
  if org eq 0 then begin & w=w[0:cnp-1] & x=x[0:cnp-1] & endif
  if org eq 1 then begin & w=w[0:cnp-1] & x=x[0:cnp-1] & e=e[0:cnp-1]   & endif
  if org eq 2 then begin & x=x[0:cnp-1] & y=y[0:cnp-1] & z=z[0:cnp-1]   & w=fltarr(cnp) & w[*]=1 & endif
  if org eq 3 then begin & x=x[0:cnp-1] & y=y[0:cnp-1] & z=z[0:cnp-1]   & w=w[0:cnp-1]  & endif
  if org eq 4 then begin & x=x[0:cnp-1] & e=e[0:cnp-1] & z=z[0:cnp-1]   & w=w[0:cnp-1]  & endif
endelse
misread:free_lun,u
pp2=0
misopen:
end
