function read_adam ,inst , path , filename , status , datp
;+
;******* *********
;** reads a file or files in a directory for superADAM
;** use rdedf.pro
;-

forward_function sys_dep, rdedf 

DATA = 0
fifi = filename[0]
if sys_dep('MACHINE') eq 'win' then dvd='\' else dvd='/'
CATCH,stat & if stat ne 0 then begin & lamp_error & RETURN, DATA & endif

;Read a filename.ext ?
;*******************
if not file_test(fifi,/directory) then begin
    fifi = (file_search(fifi+'*'))[0]
    if strpos(fifi,'.edf') gt 0 then DATA=rdedf(     inst , path , fifi , status , datp) $
                                else DATA=read_nexus(inst , path , fifi , status , datp) 

;No, so we read a Numor directory.
;********************************
endif else begin
  cd,current=mee & cd,path+fifi

  files = file_search('*.edf',count=cntEDF)                 ;FILES in fifi directory
  if cntEDF eq 0 then begin
   files= file_search('*.nxs',count=cntNXS)                 ;FILES in fifi directory
   if cntNXS eq 0 then $
    files=file_search('*.h5' ,count=cntNXS)                 ;FILES in fifi directory
  endif

  cd,mee                                                    ;Only those begining
  c1=strmid(files,0,1) & idx=where((c1 ge '0') and (c1 le '9'))   ;with a number
  if idx[0] eq -1 then return,0 else files=files[idx]
  newpath=path+fifi+dvd
  
  if cntEDF gt 0 then DATA = rdedf(     inst, newpath, files[0], status, datp) else $ ;READ first image
  if cntNXS gt 0 then DATA = read_nexus(inst, newpath, files[0], status, datp)        ;READ first image
  nn   = n_elements(files) & pp  = n_elements(datp.P)
  sizD = size(DATA)
  PV   = fltarr(pp,nn)     & BUF = fltarr(sizD[1],sizD[2],nn)     ;MAKE arrays
  PV[*,0] = datp.P         & BUF[*,*,0] = DATA              ;STORE first image

  FOR i=1,nn-1 do begin
    if cntEDF gt 0 then BUF[*,*,i] = rdedf(     inst, newpath, files[i], status, datp) else $  ;READ ALL images
    if cntNXS gt 0 then BUF[*,*,i] = read_nexus(inst, newpath, files[i], status, datp)         ;READ ALL images
    PV[*,i]    = datp.P
  ENDFOR
  MOD_DATP, datp, 'PV', PV & DATA=temporary(BUF)
endelse
sizD = size(DATA)

;NORAW DATA so we can REDUCE.
;***************************
if (INST[2] eq '0') and sizD[0] ge 2 then begin
   ;MIGUEL's CODE...
endif

return,temporary(DATA)

end
