function read_img, fifi, swap=swap
;+
;******* ********
;**
;**  Read a CCD .img image file
;**  D.R. Jul 2011
;
;-
wout=0 & line='' & header=''
if n_elements(swap) eq 0 then swap=0

on_ioerror,misfil & u=-1
openr,u,fifi,/get_lun
  on_ioerror,misdat
  ;Header should begin with '{'
  ; ---------------------------
  while strpos(line,'{') lt 0 do readf,u,line
  ;Header should terminate with '}'
  ; -------------------------------
  while strpos(line,'}') lt 0 do begin & readf,u,line & header=[header,line] & endwhile
  
  ;Header checking
  ; --------------
  header=strtrim(header[1:n_elements(header)-2],2)
  idxeq =strpos(header,'=') & idxok=where(idxeq ge 0)
  header=header[idxok]      & idxeq=idxeq[idxok]
  nh    =n_elements(header)
  P     =fltarr(nh)         & P_txt=strarr(nh)

  on_ioerror,misflt  
  for i=0,nh-1 do begin
      ok=0 & P[i]=float(strmid(header[i],idxeq[i]+1,50)) & ok=1 & misflt:
      if ok then P_txt[i]=strmid(header[i],0,idxeq[i]+1) else P_txt[i]=header[i]+'='
  endfor
  on_ioerror,misdat

  ;How to read
  ; ----------
  endian='' & idx=strpos(P_txt,'BYTE_ORDER')   & idx=where(idx ge 0) & idx=idx[0]
  if idx ge 0 then if strpos(P_txt[idx],'little') gt 0 then endian='L' else $
                   if strpos(P_txt[idx],'big')    gt 0 then endian='B'
  
  type  ='' & idx=strpos(P_txt,'TYPE')         & idx=where(idx ge 0) & idx=idx[0]
  if idx ge 0 then if strpos(P_txt[idx],'short')  gt 0 then type  ='S'

  nhead=0   & idx=strpos(P_txt,'HEADER_BYTES') & idx=where(idx ge 0) & idx=idx[0]
              if idx ge 0 then nhead=P[idx]

  sz1=1 & sz2=1 & sz3=1
  idx=where(P_txt eq 'SIZE1=') & idx=idx[0] & if idx ge 0 then sz1=P[idx]
  idx=where(P_txt eq 'SIZE2=') & idx=idx[0] & if idx ge 0 then sz2=P[idx]
  idx=where(P_txt eq 'SIZE3=') & idx=idx[0] & if idx ge 0 then sz3=P[idx]

  if type eq 'S' then wout=reform(uintarr(sz1,sz2,sz3)) $
                 else wout=reform(lonarr(sz1,sz2,sz3))

  Ot='' & Wt=fifi & Xt='X detector' & Yt='Y detector'
  X=lindgen(sz1)+1  & Y =lindgen(sz2)+1

  datp={X:X,Y:Y,W_tit:Wt,X_tit:Xt,Y_tit:Yt,Other_tit:Ot,P:P,PAR_txt:P_txt}
  give_datp,datp

  ;Read the data
  ; ------------
  r=fstat(u) & npt=sz1*sz2*sz3   ;64b missing?
  if type eq 'S' then pt=r.size-npt*2 else pt=r.size-npt*4
  point_lun,u,pt
  readu,u,wout
  
  if (endian eq 'L')          then byteorder,wout,/swap_if_big_endian    else $
  if (endian eq 'B')          then byteorder,wout,/swap_if_little_endian else $
  if (swap) and (type eq 'S') then byteorder,wout,/Sswap                 else $
  if (swap)                   then byteorder,wout,/Lswap
  
  wout=long(wout)
  misdat:free_lun,u
  
  return,wout
  
misfil:lamp_error
return,wout

end
  
