;************************
function HxF_OPEN       , FileName , create=create
;+
;************************
;** part of hdf lamp api
;-
common   Hxf_com, vers ,gpidx,gpnam  ,curdim,curtypid,curdimid, grpid

if (!version.release ge '6.2') then vers=5 else vers=4 ;Default
     if ((strpos(strlowcase(FileName),'h5') gt 0) or (strpos(strlowcase(FileName),'hdf5') gt 0)) $
              and (!version.release ge '6.2') then vers=5 else $
     if ((strpos(strlowcase(FileName),'h4') gt 0) or (strpos(strlowcase(FileName),'hdf4') gt 0)) then vers=4

if vers eq 5 then begin
   fid  = H5F_CREATE( fileName)
	 grpid= H5G_OPEN(   fid,'/')
	 gpidx=[fid,grpid] & gpnam=[' ','/']
         return,fid
endif else $
return,  HDF_OPEN(        FileName , create=create)
end

;************************
function HxF_SD_START      ,FileName , RDWR=RDWR
;+
;************************
;** part of hdf lamp api
;-
common   HxF_com
if vers eq 5 then begin
         return,gpidx[1] ;root
endif else $
return,  HDF_SD_START(    FileName , RDWR=RDWR)
end

;************************
pro      HxF_SD_ATTRSET    ,sdid ,name ,P ,dim, _extra=ex ;STRING=STRING,FLOAT=FLOAT,LONG=LONG,BYTE=BYTE
;+
;************************
;** part of hdf lamp api
;-
common   HxF_com
if vers eq 5 then begin
  typid= H5T_IDL_CREATE(    P)
  dimid= H5S_CREATE_SIMPLE( size(P,/DIMENSIONS)>1)
  attid= H5A_CREATE(        sdid, name, typid, dimid)
         call_procedure,'H5A_WRITE', attid, P
         call_procedure,'H5S_CLOSE', dimid & call_procedure,'H5T_CLOSE', typid
         call_procedure,'H5A_CLOSE', attid
endif else $
  if n_elements(dim) eq 0 then HDF_SD_ATTRSET    ,sdid ,name ,P ,/string $
  else   HDF_SD_ATTRSET    ,sdid ,name ,P ,dim, _extra=ex
end

;************************
function HxF_VG_ATTACH     ,fid,m1,WRITE=WRITE ,LOC=loc, NAME=name
;+
;************************
;** part of hdf lamp api
;-
common   HxF_com
if vers eq 5 then begin
   gdid = H5G_CREATE(  loc, name)
	 gpidx=[gpidx,gdid] & gpnam=[gpnam,name] & grpid=gdid
	 return,gdid
endif else $
return,  HDF_VG_ATTACH( fid,m1,WRITE=WRITE)
end

;************************
pro      HxF_VG_SETINFO    ,vdid, name =entry, class =NXclass
;+
;************************
;** part of hdf lamp api
;-
common   HxF_com
if vers eq 5 then begin
   idx=where(gpidx eq vdid) & idx=idx[0] & fid=gpidx[0]
	;call_procedure,'H5G_MOVE',fid,gpnam[idx],entry                      ;See new HxF_VG_ATTACH with LOC & NAME (modified Jun 2015)
	 gpnam[idx]=entry
	 HxF_SD_ATTRSET    ,vdid, 'class',NXclass,/STRING
endif else $
         HDF_VG_SETINFO    ,vdid, name =entry, class =NXclass
end

;************************
pro      HxF_VG_INSERT     ,vdid, vdat
;+
;************************
;** part of hdf lamp api
;-
common   HxF_com
if vers eq 5 then begin
   idx=where(gpidx eq vdat) & idx=idx[0] & fid=gpidx[0]
	;call_procedure,'H5G_MOVE',fid,gpnam[idx],gpnam[idx],NEW_LOC_ID=vdid ;See new HxF_VG_ATTACH with LOC & NAME (modified Jun 2015)
endif else $
         HDF_VG_INSERT     ,vdid  , vdat
end

;************************
function HxF_SD_CREATE, sdid,name,sv ,_extra=ex
;+
;************************
;** part of hdf lamp api
;-
common   HxF_com
if vers eq 5 then begin
         sd0id= call_function('H5D_CREATE',grpid, name, curtypid, curdimid ,chunk=curdim,GZIP=6)
         call_procedure,'H5S_CLOSE', curdimid & call_procedure,'H5T_CLOSE', curtypid
	 return,sd0id
endif else $
return,  HDF_SD_CREATE( sdid,name,sv ,_extra=ex)
end

;************************
pro      HxF_SD_ADDDATA    ,sd0id,para
;+
;************************
;** part of hdf lamp api
;-
common   HxF_com
if vers eq 5 then call_procedure,'H5D_WRITE' ,sd0id,Para $
             else            HDF_SD_ADDDATA  ,sd0id,para
end

;************************
function HxF_SD_IDTOREF,sd0id
;+
;************************
;** part of hdf lamp api
;-
common   HxF_com
if vers eq 4 then return,  HDF_SD_IDTOREF(sd0id)
end

;************************
pro      HxF_VG_ADDTR ,vdat,sdtag,ref
;+
;************************
;** part of hdf lamp api
;-
common   HxF_com
if vers eq 4 then          HDF_VG_ADDTR  ,vdat,sdtag,ref
end

;************************
pro      HxF_SD_SETINFO ,sdsid, FORMAT=tip, LABEL=WT
;+
;************************
;** part of hdf lamp api
;-
common   HxF_com
if vers eq 4 then          HDF_SD_SETINFO ,sdsid, FORMAT=tip, LABEL=WT
end

;************************
function HxF_SD_DIMGETID,sd0id, axe
;+
;************************
;** part of hdf lamp api
;-
common   HxF_com
if vers eq 4 then return,  HDF_SD_DIMGETID(sd0id, axe)
end

;************************
pro      HxF_SD_DIMSET ,sdxid,NAME=axname,LABEL=XT,SCALE=coord,BW_INCOMP=BW_INCOMP
;+
;************************
;** part of hdf lamp api
;-
common   HxF_com
if vers eq 4 then          HDF_SD_DIMSET ,sdxid,NAME=axname,LABEL=XT,SCALE=coord,BW_INCOMP=BW_INCOMP
end

;************************
pro      HxF_SD_ENDACCESS,sdsid
;+
;************************
;** part of hdf lamp api
;-
common   HxF_com
if vers eq 5 then begin
         call_procedure,'H5D_CLOSE'      , sdsid
endif else $
         HDF_SD_ENDACCESS,sdsid
end

;************************
pro      HxF_SD_SETCOMPRESS,sdsid,cps
;+
;************************
;** part of hdf lamp api
;-
common   HxF_com
if vers eq 5 then begin
endif else $
         HDF_SD_SETCOMPRESS,sdsid,cps
end

;************************
pro      HxF_VG_DETACH  , gid
;+
;************************
;** part of hdf lamp api
;-
common   HxF_com
if vers eq 5 then begin
	 call_procedure,'H5G_CLOSE'      , gid & grpid=gpidx[1] ;root
endif else $
         HDF_VG_DETACH  , gid
end

;************************
pro      HxF_SD_END     , sdid
;+
;************************
;** part of hdf lamp api
;-
common   HxF_com
if vers eq 5 then begin
         call_procedure,'H5G_CLOSE'      , sdid
endif else $
         HDF_SD_END     , sdid
end

;************************
pro      HxF_CLOSE      , fid
;+
;************************
;** part of hdf lamp api
;-
common   HxF_com
if vers eq 5 then begin
         call_procedure,'H5F_CLOSE'      , fid
        ;call_procedure,'H5_CLOSE'
endif else $
         HDF_CLOSE      , fid
end

;************************
pro     prepare_SD_H5, data
;+
;************************
;** part of hdf lamp api
;-
common   HxF_com
if vers eq 5 then begin
	 curdim  = size(data,/DIMENSIONS)>1
         curtypid= H5T_IDL_CREATE(    data)
         curdimid= H5S_CREATE_SIMPLE( curdim)
endif
end


;** *********
pro write_hdf, FileName , Data , XC=x, YC=y , ZC=z , E=e  , N=n   $
                               , PR=p, PV=pv, P_TXT=p_txt         $
                               , W_tit=wt  , X_tit=xt , Y_TIT=yt  $
                               , Z_tit=zt  , OTHER_TIT=ot, SRC=src, HIST=hist $
			                         , PAR_TXT_ALL=pa_txt, LIM=lim, MACH=mach $
                               , DOE=doe, SNAP=snap, DATE=date, FIFI=fifi
;+
;** *********
;**
;**	Call for data-write HDF NeXus (called by LAMP).
;**
;**	FileName: name of the output file (file.hdf)
;**	Data    : the data of any dimension.
;**	Keywords:
;**		  XC       = vector of x coordinates.
;**		  YC       = vector of y coordinates.
;**		  ZC       = vector of z coordinates (or scalar).
;**		  W_TIT    =   main title
;**		  X_TIT    = x axis title
;**		  Y_TIT    = y axis title
;**		  Z_TIT    = z axis title
;**		  OTHER_TIT=    sub title
;**		  N        = monitors (or scalar).
;**		  PR       = vector of float parameter values (or scalar).
;**		  P_TXT    = string array of text associated to PR (same size).
;**		  PV       = an array of any dimensions containing other parameter values (or 0).
;**		  E        = the errors associated to DATA (same size or 0).
;**		  SRC      = Instrument name.
;**		  HIST     = An history of the Data (string).
;**	Other Keywords:
;**		  PAR_TXT_ALL(unnecessary) p_txt + '=' + string(p) (if "" write_hdf will do for you)
;**		  LIM      = (unnecessary)
;**		  MACH     = (unused)
;**		  DOE      = (unused)
;**		  SNAP     = (optional) a 192*192 bytarea image snapshot of the Data.
;**		  DATE     = (optional) date of experiment (string).
;**		  FIFI     = (unused)
;-
fid=0 & sdid=0
if !version.release lt '4.0' then begin & print,string(7b)+"IDL version is too low !!!"   & return & endif
CATCH,stat &   IF stat ne 0  then begin & print,!error_state.msg & if sdid gt 0 then HxF_SD_END,sdid & if fid gt 0 then HxF_CLOSE,fid & return & endif
ON_IOERROR,mis

;******************
;**For Tests only**
;******************
if n_elements(p) eq 0 then begin
   s=size(Data) & x=indgen(s[1]) & if s[0] gt 1 then y=indgen(s[2]) else y=0
   z=0 & e=findgen(s[1]) & n=[1,2,3] & p=[1.,2.] & p_txt=['a','b'] & pv=findgen(2,3,4)
   wt='W' & xt='X' & yt='Y' & zt='Z' & ot='O' & src='Test'   & hist='Histoire'
   lim='This is limtx' & mach='win'  & snap=bytscl(dist(15)) & date=systime()
   endif
;*****************
;**Preliminaries**
;*****************
if wt eq '' then wt='W' & if xt eq '' then xt='X' & if yt  eq '' then yt='Y'
if zt eq '' then zt='Z' & if ot eq '' then ot='s' & if src eq '' then src='?'
if n_elements(date)   ne 1 then date=''

np=n_elements(p)
if n_elements(pa_txt) lt n_elements(p_txt) then begin & npa=np-n_elements(p_txt) 
                                                      if npa gt 0  then p_txt =[p_txt ,strarr(npa)]
                                                      pa_txt=p_txt + '=' + string(p)
endif else if n_elements(pa_txt) lt np     then begin & npa=np-n_elements(pa_txt) 
                                                      if npa gt 0  then pa_txt=[pa_txt,strarr(npa)]
endif

sdtag=720
myRG =[max(Data,min=mini),mini]

sx=n_elements(X) & sy=n_elements(Y) & sz=n_elements(Z)
if n_elements(Data) eq 1 then Data=[Data]
S =size(Data)
xd=S[1] & if S[0] gt 1 then yd=s[2] else yd=0
          if S[0] gt 2 then begin & zd=s[3]
                            if sz lt zd then Z=findgen(zd)+1 & sz=n_elements(Z)
          endif else zd=0

SV=[S[1:S[0]]]
cps=4
tiip=['ud','byte' ,'short','long' ,'float'  ,'double' ,'double' ,'string','ud','ud','ud','ud','uint'  ,'ulong' ,'ud','ud']
ntip=[ 0L ,  21L  ,  22L  ,  24L  ,  5L     ,   6L    ,   6L    ,   3L   , 0L , 0L , 0L , 0L ,  23L   ,  25L   , 0L , 0L ]
toop=['UD','UINT8','INT16','INT32','FLOAT32','FLOAT64','FLOAT64','CHAR'  ,'UD','UD','UD','UD','UINT16','UINT32','UD','UD']
tip =tiip[s[s[0]+1]]
nip =ntip[s[s[0]+1]]
top ='DFNT_'+toop[s[s[0]+1]]
ymj =bin_date(systime()) & day=string(ymj[0],format='(I4,"-")')+string(ymj[1],format='(I2,"-")')+ $
                               string(ymj[2],format='(I2," ")')+string(ymj[3],format='(I2,":")')+ $
                               string(ymj[4],format='(I2,":")')+string(ymj[5],format='(I2)')
mon =float(N[*,0])
moni=1D/(total(mon)>1)
CAL={ Cal:moni, Cal_Err:0.0D, Offset:0.0D, Offset_Err:0.0D, Num_Type:nip }

;*******************
;**Create HDF file**
;*******************
fid  = HxF_OPEN(     FileName, /CREATE)
;*     ********
if fid gt 0 then begin

 sdid = HxF_SD_START( FileName, /RDWR)
;*      ************

 HxF_SD_ATTRSET, sdid, 'Written_by_LAMP','Lamp & Idl'+!version.release+' on '+!version.os+' '+!version.os_family, /STRING
 HxF_SD_ATTRSET, sdid, 'file_name'      , FileName    , /STRING
 HxF_SD_ATTRSET, sdid, 'file_time'      , day         , /STRING
 HxF_SD_ATTRSET, sdid, 'user'           , src+' '+date, /STRING
 HxF_SD_ATTRSET, sdid, 'creator'        , ot          , /STRING

 vdid = HxF_VG_ATTACH(fid,-1,/WRITE ,LOC=fid ,NAME='entry1') & HxF_VG_SETINFO,vdid, name ='entry1', class ='NXentry'
 vdat = HxF_VG_ATTACH(fid,-1,/WRITE ,LOC=vdid,NAME='data1')  & HxF_VG_SETINFO,vdat, name ='data1' , class ='NXdata'
        HxF_VG_INSERT,vdid  , vdat

 if n_elements(src)   eq 1 then $
 HxF_SD_ATTRSET, sdid, 'SOURCE'        , src , /STRING
;**************
 if n_elements(hist)  eq 1 then $
 HxF_SD_ATTRSET, sdid, 'HISTORY'       , hist, /STRING
;**************
 HxF_SD_ATTRSET, sdid, 'TITLES'        , wt  , /STRING
;**************
 HxF_SD_ATTRSET, sdid, 'OTHER'         , ot  , /STRING
;**************
 if n_elements(lim)   eq 1 then $
 HxF_SD_ATTRSET, sdid, 'MIN_MAX_VALUES', lim , /STRING
;**************
;if n_elements(p)     eq 1 then $
 HxF_SD_ATTRSET, sdid, 'PARAMETERS'    , P   , n_elements(P)    , /FLOAT
;**************
;if n_elements(mach)  eq 1 then $
;HxF_SD_ATTRSET, sdid, 'MACHINE'       ,mach , /STRING
;**************

 if np gt 1 then if n_elements(pa_txt) ge np then begin
    lf=string(10b) & para=''
    for i=0,np-1 do para=para+pa_txt[i]+' '+lf+' '
    prepare_SD_H5, para
    sd0id= HxF_SD_CREATE(   sdid,'PARAMETERS',[strlen(para)] ,/STRING)
           HxF_SD_ADDDATA  ,sd0id,para & ref= HxF_SD_IDTOREF(  sd0id)
           HxF_SD_ENDACCESS,sd0id      &      HxF_VG_ADDTR,vdat,sdtag,ref
;*         ****************
 endif
 sdsid=0
 prepare_SD_H5, data
 if !version.release lt '6.0' then ii=execute('sdsid= HxF_SD_CREATE(sdid,"DATA",SV,/'+top+')') $
 else sdsid=HxF_SD_CREATE(sdid,"DATA",SV,hdf_type=nip)
;*          *************
 if !version.release lt '5.4' then HxF_SD_SETINFO, sdsid, FORMAT=tip,LABEL=WT ;,CALDATA=cal,RANGE=myRG
;*                                 **************
 HxF_SD_ATTRSET, sdsid, 'signal'    , 1      ,1, /LONG
 HxF_SD_ATTRSET, sdsid, 'long_name' , wt       , /STRING
 if n_elements(mon) eq 1 then if mon[0] ne 0. then HxF_SD_ATTRSET, sdsid,'MONITORS',mon     ,1,/FLOAT
 if sy              eq 1 then if y[0]   ne 0. then HxF_SD_ATTRSET, sdsid,'Y_VALUE' ,float(y),1,/FLOAT
 if sz              eq 1 then if z[0]   ne 0. then HxF_SD_ATTRSET, sdsid,'Z_VALUE' ,float(z),1,/FLOAT

 if !version.release lt '5.4' then begin ;Obsolete
  if (s[0] gt 1) or (sy eq 1) then begin & sdxid=HxF_SD_DIMGETID(sdsid,0)
   HxF_SD_DIMSET,sdxid,NAME='X_COORDINATES',LABEL=XT,SCALE=float(X),/BW_INCOMP & endif
;* *************

  if (s[0] gt 1) then begin &              sdyid=HxF_SD_DIMGETID(sdsid,1)
   HxF_SD_DIMSET,sdyid,NAME='Y_COORDINATES',LABEL=YT,SCALE=float(Y),/BW_INCOMP & endif
;* *************

  if (s[0] gt 2) then begin &              sdzid=HxF_SD_DIMGETID(sdsid,2)
   HxF_SD_DIMSET,sdzid,NAME='Z_COORDINATES',LABEL=ZT,SCALE=float(Z),/BW_INCOMP & endif
;* *************
 endif
 if (s[0] eq 1) and (sy gt 1) then $
   HxF_SD_ATTRSET, sdsid, 'X_SPACE', float(x), n_elements(x)  , /FLOAT
 if (s[0] eq 1) and (sy gt 1) then $
   HxF_SD_ATTRSET, sdsid, 'Y_SPACE', float(y), n_elements(y)  , /FLOAT
 if (s[0] eq 1) and (sz gt 1) then $
   HxF_SD_ATTRSET, sdsid, 'Z_SPACE', float(z), n_elements(z)  , /FLOAT

 if !version.release ge '5.2.1' then begin
                                     if strpos(strlowcase(FileName),'_c0') ge 0 then       cps=0
                                     if strpos(strlowcase(FileName),'_c1') ge 0 then       cps=1
                                     if strpos(strlowcase(FileName),'_c3') ge 0 then       cps=3
                                     if strpos(strlowcase(FileName),'_c2') ge 0 then       cps=4
                                     if strpos(strlowcase(FileName),'_c4') ge 0 then       cps=4
                                     if cps gt 0 then HxF_SD_SETCOMPRESS,sdsid,cps
                                     endif
 HxF_SD_ADDDATA, sdsid, Data  & ref= HxF_SD_IDTOREF(   sdsid)
;**************
 HxF_SD_ENDACCESS, sdsid      &      HxF_VG_ADDTR,vdat ,sdtag,ref
;****************

;*****For NEXUS compatibility*****
 if sx gt 1 then begin & sxc=size(x)  & SC=[sxc[1:sxc[0]]] & prepare_SD_H5, float(x)
    sdxid= HxF_SD_CREATE(   sdid ,'X',SC ,/FLOAT)
           HxF_SD_ATTRSET  ,sdxid,'axis',1,1,/LONG & HxF_SD_ATTRSET,sdxid,'long_name',XT,/STRING
           HxF_SD_ADDDATA  ,sdxid,float(x)  &  ref = HxF_SD_IDTOREF(sdxid)
           HxF_SD_ENDACCESS,sdxid           &        HxF_VG_ADDTR  ,vdat,sdtag,ref & endif

 if sy gt 1 then begin & syc=size(y)  & SC=[syc[1:syc[0]]] & prepare_SD_H5, float(y)
    sdyid= HxF_SD_CREATE(   sdid ,'Y',SC ,/FLOAT)
           HxF_SD_ATTRSET  ,sdyid,'axis',2,1,/LONG & HxF_SD_ATTRSET,sdyid,'long_name',YT,/STRING
           HxF_SD_ADDDATA  ,sdyid,float(y)  &  ref = HxF_SD_IDTOREF(sdyid)
           HxF_SD_ENDACCESS,sdyid           &        HxF_VG_ADDTR  ,vdat,sdtag,ref & endif

 if sz gt 1 then begin & szc=size(z)  & SC=[szc[1:szc[0]]] & prepare_SD_H5, float(z)
    sdzid= HxF_SD_CREATE(   sdid ,'Z',SC ,/FLOAT)
           HxF_SD_ATTRSET  ,sdzid,'axis',3,1,/LONG & HxF_SD_ATTRSET,sdzid,'long_name',ZT,/STRING
           HxF_SD_ADDDATA  ,sdzid,float(z)  &  ref = HxF_SD_IDTOREF(sdzid)
           HxF_SD_ENDACCESS,sdzid           &        HxF_VG_ADDTR  ,vdat,sdtag,ref & endif
;*****End NEXUS compatibility*****

 if n_elements(PV)   gt 1 then begin & npv=size(PV)   & SP=[npv[1:npv[0]]] & prepare_SD_H5, PV
    sd2id= HxF_SD_CREATE(   sdid,'VAR_PARAMS',SP ,/FLOAT)
           HxF_SD_ADDDATA  ,sd2id, PV & ref= HxF_SD_IDTOREF(  sd2id)
           HxF_SD_ENDACCESS,sd2id     &      HxF_VG_ADDTR,vdat,sdtag,ref & endif

 if n_elements(E)    gt 1 then begin & nee=size(E)    & SE=[nee[1:nee[0]]] & prepare_SD_H5, E
    sd3id= HxF_SD_CREATE(   sdid,'errors'    ,SE ,/FLOAT)
           HxF_SD_ADDDATA  ,sd3id,  E & ref= HxF_SD_IDTOREF(  sd3id)
           HxF_SD_ENDACCESS,sd3id     &      HxF_VG_ADDTR,vdat,sdtag,ref & endif

 if n_elements(SNAP) gt 1 then begin & snp=size(SNAP) & SN=[snp[1:snp[0]]] & prepare_SD_H5, SNAP
    sd4id= HxF_SD_CREATE(   sdid,'SNAPSHOT'  ,SN ,/BYTE)
           HxF_SD_ADDDATA  ,sd4id,SNAP &  & ref= HxF_SD_IDTOREF(  sd4id)
           HxF_SD_ENDACCESS,sd4id         &      HxF_VG_ADDTR,vdat,sdtag,ref
;*         ****************
 endif

 HxF_VG_DETACH, vdat
;*************
 if (size(N))[1] eq  S[1] then mon=float(N[*,0]) else mon=float(N)
 if n_elements(mon)  gt 1 then begin & smo=size(mon)  & SM=[smo[1:smo[0]]] & prepare_SD_H5, mon
 vmon = HxF_VG_ATTACH(fid,-1,/WRITE ,LOC=vdid, NAME='monitors') & HxF_VG_SETINFO, vmon, name ='monitors' , class ='NXmonitor'
        HxF_VG_INSERT,vdid  , vmon
 sdmon= HxF_SD_CREATE(sdid,'MONITOR1',SM     , /float)
        HxF_SD_ATTRSET  ,sdmon,'signal', 0,1 , /BYTE
        HxF_SD_ADDDATA  ,sdmon, mon & ref= HxF_SD_IDTOREF(  sdmon)
        HxF_SD_ENDACCESS,sdmon      &      HxF_VG_ADDTR,vmon,sdtag,ref
        HxF_VG_DETACH   ,vmon	    & endif
;*      ****************

 HxF_VG_DETACH, vdid

 HxF_SD_END   , sdid
 HxF_CLOSE    , fid
endif
return
mis:	print,!error_state.msg & if fid gt 0 then HxF_CLOSE, fid
end
