#!c:\perl\bin\perl.exe
#!/usr/bin/perl

# D.R Sep 2013

# V1.0

# Run in directory containing .pro files

# For each file, replace header ";**'s"  by  ";+" ";**'s" ";-"
#                make syntax compatible with IDLDOC.

# Output file.pro  ,  macro_list.txt

if (opendir(DIR,"./")) {
    @list = readdir(DIR) ; close(DIR);
    @macrolist = ();

    foreach $fil (@list) {                                   # For each file
      if ($fil =~ /\.pro$/) {
        if (open (PRO, "<$fil"))  {
          @cod = <PRO> ;close(PRO); 
          open (OUTF, ">$fil") || die "cant write new pro file $!";
          $npro= 0;
          $nbeg= 0;
          $nb  = 0;
          $i   = 0;
          while ( $i <= $#cod ) {                            # For each line
            $_  = $cod[$i];

            if ( (/^\s*PRO\s+/i) || (/^\s*FUNCTION\s+/i) ) { # HERE IS A MACRO DECLARATION
                                                             # ---------------------------
                $name = $_; $name =~ s/^\s*\w+\s+(\w+:*\w*).*\n*/\1/;
                $kpro = $_; $name =~ tr/a-z/A-Z/;
                $kpri = $_; if ( /;/ ) {$kpri =~ s/;.*//;}

                if (/^\s*PRO/i) { $type = "proc";} else {$type = "func";}
	            push(@macrolist,"$name   $type in $fil\n");

                $npro= $npro+1;
                if ( $npro == 1 && $i > 0 ) {                # may add an empty line before first macro
                    if ( $cod[$i-1] =~ /^\s*;-\s*$/ ) {print "\n!!! Warning File comment $fil";
                                                       print OUTF "\n";}
                }
                print OUTF "$_";                             # print macro definition line
                $i = $i+1; $_ = $cod[$i];

                while ( /^\s*$/ || /.+\$/ || /^\s*;\s*$/ ) { # skip empty line or parameters line
                    print OUTF "$_";
                    $i = $i+1; $_ = $cod[$i];
                }
                if (($cod[$i-1] =~ /.+\$/) || (!/^\s*;/))  { # skip last parameter line if there
                    print OUTF "$_";
                    $i = $i+1; $_ = $cod[$i]; }
                                                             # if not a one line macro then                                  
                if ( ($kpri !~ /&/) && (/^\s*;\*\*/) ) {     # WE HAVE SYNTAX COMMENT ";**"
                                                             # ----------------------------
                  print OUTF ";+\n";                         # so add   ";+"

                  while ( /^\s*;\*\*/ || /^\s*;[^-]/ ) {     # skip all ";**"

                   #s/(\s*;\*\*\s*)User.*callable/$1Category\:User_callable/i;
                    print OUTF "$_";
                    $i = $i+1; $_ = $cod[$i];
                  }
                  if ( !/^\s*;-$/ ) {print OUTF ";-\n";}     # and add  ";-"
                  $i = $i-1;
                  $nb = $nb+1;                               # occurence + 1

                } else { $i = $i-1;}                         # END SYNTAX COMMENT ";**"
                                                             # ------------------------
            } else {                                         # NOT A MACRO DECLARATION
                                                             # -----------------------

                $kpri= $_; if ( /;/ ) {$kpri =~ s/;.*//;}               # IDLDOC COMPATIBILITY
                if ( $kpri =~ /[\s:&]begin\s*\$/i )     {$nbeg=$nbeg+1; # --------------------
                  s/([\s:&]begin)(\s*)\$/\1\2 /i; }                     # replace "BEGIN $"   by "BEGIN  "
                if ( $kpri =~ /[\s:&]begin\s+[!(*]*\w/i){$nbeg=$nbeg+1;
                  s/([\s:&]begin)(\s)(\s*[!(*]*\w)/\1 & \3/ig; }        # replace "BEGIN exp" by "BEGIN & exp"
                if ( /^\s*;\+\+/ ) { s/\+\+/ \+/; }                     # replace ;+++++  by  ; ++++
                if ( /^\s*;\-\-/ ) { s/\-\-/ \-/; }                     # replace ;-----  by  ; ----
                print OUTF "$_";

            }
            $i = $i+1;                                       # next line loop
          }    # End for each line

          if ( $nb   > 0 ) { $nb   = " with $nb occurences";} else {$nb   = "";}
          if ( $nbeg > 0 ) { $nbeg = " $nbeg BEGIN & ";     } else {$nbeg = "";}
          close(OUTF);
          print "\nTreated $fil $nb $nbeg, $npro routine(s)";
    } } }      # End for each file
}
print "\nEnd\n";
open (OUTF, ">zzmacro_list.txt") || die "cant write macro_list.txt $!";
print OUTF "@macrolist";

1;
