#!c:\perl\bin\perl.exe
#!/usr/bin/perl

# D.R Jul 2013

# V1.0

# Run in directory containing .pro files

# For each file, replace 'ident (' by 'ident( '

# Output file.pro.warn , file.pro.diff , file.pro

$reserved= " AND BEGIN BREAK CASE COMMON COMPILE_OPT CONTINUE DO ELSE END ENDCASE ENDELSE ENDFOR "   .
           " ENDFOREACH ENDIF ENDREP ENDSWITCH ENDWHILE EQ FOR FORWARD_FUNCTION FUNCTION GE GOTO GT ".
           " IF INHERITS LE LT MOD NE NOT OF ON_IOERROR OR PRO REPEAT SWITCH THEN UNTIL WHILE XOR "  ;

if (opendir(DIR,"./")) {
    @list = readdir(DIR) ; close(DIR);

    foreach $fil (@list) {           # For each file
      if ($fil =~ /\.pro$/) {
        if (open (PRO, "<$fil"))  {
          @cod = <PRO> ;close(PRO); 
          open (WARN, ">$fil.warn") || die "cant write warning file $!";
          open (OUTD, ">$fil.diff") || die "cant write .diff   file $!";
          open (OUTF, ">$fil")      || die "cant write new pro file $!";
          print "\nTreating $fil" ;

          foreach $i (0 .. $#cod) {    # For each line
            $_  = $cod[$i];
            $i1 = $i+1;
            if ( (!/^\s*;/) && (!/^\s*$/) ) { # forget comment lines or empty lines
 
              if ( /execute\s*\(/i  ) {       # Warn EXECUTE() function
                print WARN "EXECUTE() <$i1> $_\n" ;

              } else {

              if ( /xicute[r]*\s*,/i  )  {    # Warn XICUTE,  procedure
                print WARN "XICUTE,   <$i1> $_\n" ;

              } else {

              if ( /\+['"]\(/  )  {           # Warn INDEX in a string
                print WARN "INDEX(?)  <$i1> $_\n" ;

              }}}
              
	          if ( /\)\((\s*\d+\s*)\)/  )  {  # TABLE INDEX ()(d) replaced by ()[d]
		          s/\)\((\s*\d+\s*)\)/\)\[$1\]/;
		          $cod[$i] = $_;
                  $line = $_; $line =~ s/^\s*//;
                  print OUTD "$ident$space( <$i1> $line\n";}
		
              if ( /\)\(/  )  {               # Warn TABLE INDEX ()(expression)
                print WARN "TABLE INDEX <$i1> $_\n" ;}
              

              @cases = split(/\w+\s+\(/);     # Find 'ident ('

              foreach $j (1 .. $#cases) {     # For each 'ident (' in same line
                if ( /(\w+)(\s+)\(/ ) {
                  $ident = $1;
                  $space = $2;
                  if ($reserved !~ / $ident /i) { # Not a reserved word
                  if ($ident    !~ /^\d*$/)     { # Not a number

                    if ( /['"][^'"]*$ident$space\([^'"]*['"]/ || # Warning ident is quoted
                         /[^'"]*;.*$ident$space\(/ ) {           # or commented
                      $line = $_; $line =~ s/^\s*//;
                      print WARN "$ident$space( <$i1> $line\n";

                    } else {
                      s/$ident$space\(/$ident\($space/;          # Replace the code
                      $cod[$i] = $_;
                      $line = $_; $line =~ s/^\s*//;
                      print OUTD "$ident$space( <$i1> $line\n";
                    }
                  } # End ident not a number
                  } # End ident not a reserved word
          } } } }   # End for each line

          print OUTF @cod;
          close(OUTF);
          close(WARN);
          close(DIFF)

    } } }         # End for each file
}
print "\nEnd\n";
1;
