print,';*************'
print,';LAMP COMPILED
print,';*************'

ALLm=0  ;Compile also instrument macros
;*****  ;******************************

!quiet=1
;.size 50000 50000
print,''
print,'It is assumed you have added "LampPackage" and "LampPackage\lamp_mac"'
print,'   from File -> Preferences -> Path'
print,''

.run  sys_dep.pro
lamd= sys_dep('GETENV' ,'LAMP_DIR')

cd,current=me_ee
mymac= sys_dep('NEWSUB' ,me_ee,'lamp_mac')
bid  = sys_dep('ADDPATH',mymac)
!path=!path+':'+expand_path('+/home/cs/lambda/macros')

divd = sys_dep('DIVIDER')
if lamd eq '' then divd=''

print,'Compiling lamp ...'
.run lamp.pro
print,'Compiling dids ...'
.run dids.pro
print,'Compiling dons ...'
.run dons.pro
print,'Compiling bens ...'
.run bens.pro


print,'Compiling Lamp macros ...'
.run update_lamp_out.pro
.run update_lamp_in.pro
.run make_volume.pro
.run tomography.pro
.run prox_sheet.pro
.run read_nexus.pro
.run read_spec.pro
.run write_inx.pro
.run write_xml.pro
.run write_org.pro
.run write_pdb.pro
if sys_dep('VERSION') ge 4.0 then resolve_routine,'read_hdf'
if sys_dep('VERSION') ge 4.0 then resolve_routine,'write_hdf'
if sys_dep('VERSION') ge 5.0 then resolve_routine,'livc_lamp'
if sys_dep('VERSION') ge 5.0 then resolve_routine,'liv_objet'
if sys_dep('VERSION') ge 5.0 then resolve_routine,'magnet_win'
if sys_dep('VERSION') le 5.2 then resolve_routine,'rb_routines'
if sys_dep('VERSION') le 5.2 then resolve_routine,'read_binary' ,/is_f
if sys_dep('VERSION') ge 5.0 then resolve_routine,'trackball__define'
if sys_dep('VERSION') ge 5.2 then resolve_routine,'idlgrcolorbar__define'
.run read_column.pro
.run radial_at.pro
.run read_xml.pro
.run read_mag.pro
.run read_mar.pro
.run read_mar.pro
.run read_img.pro
.run read_adam.pro
.run read_par.pro
.run suprplot.pro
.run ligend.pro
.run liv_lamp.pro
.run descript.pro
.run customiz.pro
.run rdfilter.pro
.run str_fit.pro
.run lampico.pro
.run georgeo.pro
.run tagfile.pro
.run regular.pro
.run rpcill.pro
.run groupx.pro
.run groupy.pro
.run bin_as.pro
.run matovr.pro
.run myhelp.pro
.run myinit.pro
.run wdiag.pro
.run corel.pro
.run gfit.pro
.run rdid.pro
.run tripx.pro

print,'Compiling touch_b ...'
.run catalog.pro
.run touch_b.pro
.run touch_u.pro
.run touch_x.pro

print,'Compiling specific read-in ILL macros ...'
;.run read_dcsasc.pro
.run read_neat.pro
.run rdid_d20.pro
.run rdid_d17.pro
.run rdid_d2b.pro
.run rdid_d7.pro
.run rd_mari.pro
.run rdspe.pro
.run rdedf.pro
.run pn1.pro

if ALLm then print,'*********'
if ALLm then print,'D7 macros'
if ALLm then print,'*********'
if ALLm then resolve_routine,/compile_full,/either,'add_xyz'
if ALLm then resolve_routine,/compile_full,/either,'average'
if ALLm then resolve_routine,/compile_full,/either,'background'
if ALLm then resolve_routine,/compile_full,/either,'bin'
if ALLm then resolve_routine,/compile_full,/either,'binq'
if ALLm then resolve_routine,/compile_full,/either,'components'
if ALLm then resolve_routine,/compile_full,/either,'concatenate'
if ALLm then resolve_routine,/compile_full,/either,'corr_xyz'
if ALLm then resolve_routine,/compile_full,/either,'divide'
if ALLm then resolve_routine,/compile_full,/either,'fit_poly'
if ALLm then resolve_routine,/compile_full,/either,'fold'
if ALLm then resolve_routine,/compile_full,/either,'input'
if ALLm then resolve_routine,/compile_full,/either,'input_quartz'
if ALLm then resolve_routine,/compile_full,/either,'input_vanadium'
if ALLm then resolve_routine,/compile_full,/either,'isotropic_ms'
if ALLm then resolve_routine,/compile_full,/either,'norm_inc'
if ALLm then resolve_routine,/compile_full,/either,'norm_van'
if ALLm then resolve_routine,/compile_full,/either,'omega_scan'
if ALLm then resolve_routine,/compile_full,/either,'output'
if ALLm then resolve_routine,/compile_full,/either,'output_gsas'
if ALLm then resolve_routine,/compile_full,/either,'phi2q'
if ALLm then resolve_routine,/compile_full,/either,'qrebin'
if ALLm then resolve_routine,/compile_full,/either,'quartz'
if ALLm then resolve_routine,/compile_full,/either,'qxqy'
if ALLm then resolve_routine,/compile_full,/either,'remove'
if ALLm then resolve_routine,/compile_full,/either,'remove_zeros'
if ALLm then resolve_routine,/compile_full,/either,'slab'
if ALLm then resolve_routine,/compile_full,/either,'smoothx'
if ALLm then resolve_routine,/compile_full,/either,'smoothy'
if ALLm then resolve_routine,/compile_full,/either,'theta_scan'
if ALLm then resolve_routine,/compile_full,/either,'unfold'
if ALLm then resolve_routine,/compile_full,/either,'vanadium'
if ALLm then resolve_routine,/compile_full,/either,'zero_detectors'
if ALLm then resolve_routine,/compile_full,/either,'myhelp_d7'
if ALLm then resolve_routine,/compile_full,/either,'myinit_d7'

if ALLm then print,'**********'
if ALLm then print,'TOF macros'
if ALLm then print,'**********'
if ALLm then resolve_routine,/compile_full,/either,'overlap'
if ALLm then resolve_routine,/compile_full,/either,'corr_tof'
if ALLm then resolve_routine,/compile_full,/either,'elastic'
if ALLm then resolve_routine,/compile_full,/either,'estrip'
if ALLm then resolve_routine,/compile_full,/either,'fitgauss'
if ALLm then resolve_routine,/compile_full,/either,'normalise'
if ALLm then resolve_routine,/compile_full,/either,'output_allangles'
if ALLm then resolve_routine,/compile_full,/either,'output_allqs'
if ALLm then resolve_routine,/compile_full,/either,'overlap'
if ALLm then resolve_routine,/compile_full,/either,'phi2qtof'
if ALLm then resolve_routine,/compile_full,/either,'qstrip'
if ALLm then resolve_routine,/compile_full,/either,'reb'
if ALLm then resolve_routine,/compile_full,/either,'remove_spectra'
if ALLm then resolve_routine,/compile_full,/either,'rescale_t'
if ALLm then resolve_routine,/compile_full,/either,'slab_tof'
if ALLm then resolve_routine,/compile_full,/either,'splice'
if ALLm then resolve_routine,/compile_full,/either,'sqw_interp'
if ALLm then resolve_routine,/compile_full,/either,'sqw_rebin'
if ALLm then resolve_routine,/compile_full,/either,'string_round'
if ALLm then resolve_routine,/compile_full,/either,'sumbank'
if ALLm then resolve_routine,/compile_full,/either,'t2e'
if ALLm then resolve_routine,/compile_full,/either,'vnorm'

print,'Compiling qens_fit macros ...'
.run read_mibemol.pro
.run mib_group.pro
if sys_dep('VERSION') ge 5.4 then resolve_routine,'qens_fit'
if sys_dep('VERSION') ge 5.4 then resolve_routine,'fit_basegl'   ;After qens_fit
if sys_dep('VERSION') ge 5.4 then resolve_routine,'fit_ba_gumbel'
if sys_dep('VERSION') ge 5.4 then resolve_routine,'fit_ba_unirot'
if sys_dep('VERSION') ge 5.4 then resolve_routine,'fit_ba_isorot'
if sys_dep('VERSION') ge 5.4 then resolve_routine,'fit_ba_rwtrans'
if sys_dep('VERSION') ge 5.4 then resolve_routine,'fit_ba_rotctran'
if sys_dep('VERSION') ge 5.4 then resolve_routine,'fit_ba_userfunction'
if sys_dep('VERSION') ge 5.4 then resolve_routine,'mpfit'  ,/is_f
.run sgroup.pro
.run gdos.pro
.run psd_integration ;IN13   (reading in rdid)
.run figaro_grav     ;FIGARO (reading in rdid)

print,"Compiling ATOMS macros ..." & wait,.1
.run myinit_atoms.pro
.run r2x.pro
.run Fragment_AuAg.pro
.run nmoldyn_read.pro
.run read_doscar.pro
.run doscar_read.pro
.run discover_read.pro
.run xdatcar.pro
.run xdat2cont.pro
.run cont2xdat.pro
.run build_q_w.pro
.run ebands.pro
.run conv_ins.pro
.run rotate_q_w.pro
.run gr_angle_n.pro
.run gr_angle_r.pro
.run gr_big.pro
.run gr_coord.pro
.run gr_coord_loop.pro
.run gr_partial.pro
.run gr_stats.pro

print,"Compiling SANS macros ..." & wait,.1
.run sans_inst_init.pro
.run sans_settings.pro
.run sans_sheet

if ALLm then print,'**********'
if ALLm then print,'D17 macros'
if ALLm then print,'**********'
if ALLm then resolve_routine,/compile_full,/either,'d17mono'
if ALLm then resolve_routine,/compile_full,/either,'bundle'
if ALLm then resolve_routine,/compile_full,/either,'bobtof'
if ALLm then resolve_routine,/compile_full,/either,'cosmos'

if ALLm then print,'**********'
if ALLm then print,'LSS macros'
if ALLm then print,'**********'
if ALLm then resolve_routine,/compile_full,/either,'beamcentre'
if ALLm then resolve_routine,/compile_full,/either,'grund_mask'
if ALLm then resolve_routine,/compile_full,/either,'man_mask'
if ALLm then resolve_routine,/compile_full,/either,'norm_water'
if ALLm then resolve_routine,/compile_full,/either,'prime_cell'
if ALLm then resolve_routine,/compile_full,/either,'q_cal'
if ALLm then resolve_routine,/compile_full,/either,'radial'
if ALLm then resolve_routine,/compile_full,/either,'s_background'
if ALLm then resolve_routine,/compile_full,/either,'s_concatenate'
if ALLm then resolve_routine,/compile_full,/either,'water'
if ALLm then resolve_routine,/compile_full,/either,'s_normalise'

print,'Compiling specific old-TOF macros ...'
.run cylindcor.pro
.run lineup.pro
.run didline.pro
.run inx_in.pro
.run dumpx.pro
.run sqwwin.pro
.run bsnorm.pro
.run vanorm.pro
.run rbin.pro
.run ebin.pro
.run sqw.pro
.run tee.pro
.run inx.pro

print,'Compiling specific DIF D20 I/Os ...'
.run rdgsas.pro
.run exriet.pro
.run rddat.pro
.run flag.pro
.run export_dat.pro
.run export_gsa.pro
.run export_cyc.pro
.run export_prn.pro
.run export_xy.pro
.run rdinstr.pro
.run rd_d2b.pro
.run dud.pro

if ALLm then print,'Compiling specific DIF D20 macros ...'
if ALLm then resolve_routine,/compile_full,/either,'d20reg'
if ALLm then resolve_routine,/compile_full,/either,'fcj'
if ALLm then resolve_routine,/compile_full,/either,'lsfit'
if ALLm then resolve_routine,/compile_full,/either,'fwhm'
if ALLm then resolve_routine,/compile_full,/either,'colors'
if ALLm then resolve_routine,/compile_full,/either,'newfit'
if ALLm then resolve_routine,/compile_full,/either,'gauss_poly'
if ALLm then resolve_routine,/compile_full,/either,'gauss_square'
if ALLm then resolve_routine,/compile_full,/either,'myhelp_d20'
if ALLm then resolve_routine,/compile_full,/either,'num2d20reg'
if ALLm then resolve_routine,/compile_full,/either,'clear'
if ALLm then resolve_routine,/compile_full,/either,'monit'
if ALLm then resolve_routine,/compile_full,/either,'d2q'
if ALLm then resolve_routine,/compile_full,/either,'d2tt'
if ALLm then resolve_routine,/compile_full,/either,'tt2sin2t'
if ALLm then resolve_routine,/compile_full,/either,'tt2q'
if ALLm then resolve_routine,/compile_full,/either,'tt2d'
if ALLm then resolve_routine,/compile_full,/either,'plotnclick'
if ALLm then resolve_routine,/compile_full,/either,'plotnzoom'
if ALLm then resolve_routine,/compile_full,/either,'bacon'
if ALLm then resolve_routine,/compile_full,/either,'mkcal'
if ALLm then resolve_routine,/compile_full,/either,'mkcal3'
if ALLm then resolve_routine,/compile_full,/either,'mkcal5'
if ALLm then resolve_routine,/compile_full,/either,'fpread'
if ALLm then resolve_routine,/compile_full,/either,'fpread3'
if ALLm then resolve_routine,/compile_full,/either,'fpread2'
if ALLm then resolve_routine,/compile_full,/either,'fpread4'
if ALLm then resolve_routine,/compile_full,/either,'dial_fpcyc'
if ALLm then resolve_routine,/compile_full,/either,'fpscript'
if ALLm then resolve_routine,/compile_full,/either,'fpscript0'
if ALLm then resolve_routine,/compile_full,/either,'dial_monit'
if ALLm then resolve_routine,/compile_full,/either,'myinit_d20'
if ALLm then resolve_routine,/compile_full,/either,'d20_widget'
if ALLm then resolve_routine,/compile_full,/either,'normalize'
if ALLm then resolve_routine,/compile_full,/either,'readon'
if ALLm then resolve_routine,/compile_full,/either,'tt2tt'
if ALLm then resolve_routine,/compile_full,/either,'y2p'

if ALLm then print,'****************'
if ALLm then print,'D2B SALSA macros'
if ALLm then print,'****************'
if ALLm then resolve_routine,/compile_full,/either,'myhelp_d2b'
if ALLm then resolve_routine,/compile_full,/either,'myinit_d2b'
if ALLm then resolve_routine,/compile_full,/either,'straight_1d'
if ALLm then resolve_routine,/compile_full,/either,'straight_2d'

if ALLm then resolve_routine,/compile_full,/either,'myhelp_d1a'
if ALLm then resolve_routine,/compile_full,/either,'myinit_d1a'
if ALLm then resolve_routine,/compile_full,/either,'str_fit'
if ALLm then resolve_routine,/compile_full,/either,'str_integrate'
if ALLm then resolve_routine,/compile_full,/either,'strain_dat'

print,'Compiling Dials ...'
.run lamp_mac/dial_pad_init.pro
.run lamp_mac/dial_startdial_send.pro
.run lamp_mac/dial_stopdial_send.pro
.run lamp_mac/dial_cleardial_send.pro
.run lamp_mac/dial_resumedial_send.pro
.run lamp_mac/dial_savsession.pro
.run lamp_mac/dial_tornade.pro
.run lamp_mac/dial_xbu.pro
.run lamp_mac/dial_mad_read.pro
.run lamp_mac/dial_mad_send.pro
.run lamp_mac/dial_template1.pro
.run lamp_mac/dial_template2.pro
.run lamp_mac/dial_template3.pro
.run lamp_mac/dial_template4.pro
.run lamp_mac/dial_template_read.pro
.run lamp_mac/dial_template_send.pro

print,'Compiling scan ... (Optional)'
.run surf.pro
.run scan.pro


VV=strtrim(string(sys_dep('VERSION')),2)
VV=strmid (VV,0,1)+strmid (VV,2,1)

print,'Saving '+lamd+divd+'lampV'+VV+'.sav'
if sys_dep('VERSION') eq 5.4 then save,/routines,filename=lamd+divd+'lampV'+VV+'.sav' ,/compress
if sys_dep('VERSION') ne 5.4 then save,/routines,filename=lamd+divd+'lampV'+VV+'.sav'

print,'End'

;print,'launching for test...'
;lamd_dir = LAMD
;lamd_wind= GETENV('LAMP_WIND')
;@lamp.cbk
;if  sys_dep('STUDENT')                then lamp_ziz=600
;restore,lamd+divd+'lampV'+VV+'.sav'
;cd,me_ee
;lamp
