;****************************************************************************
;** MPEG INTERFACE         D.Richard (I.L.L.) Aug 2006                     **
;**                        D.R add MP4,AVI    Feb 2014                     **
;****************************************************************************
;** Use with GUI:
;** ------------
;** DID_MPEG, 'create',wdraw=WidgetDrawId (DrawId from which images are read)
;**
;** without  GUI:
;** ------------
;** DID_MPEG, 'open'  ,wdraw=WidgetDrawId, file='filename', quality={1->100} , dims={%}
;** DID_MPEG, 'put'
;** DID_MPEG, 'put'
;**     ...
;** DID_MPEG, 'save'
;****************************************************************************
;****************************************************************************

pro did_mpeg_event, ev
;+
;** **************
;** mpeg PANEL events
;-

@lamp.cbk ;Just for stand-alone executions
common c_did_mpeg, cm_id, cm_dim, cm_frame, cm_pause, cm_base, cm_win, cm_bfrm, cm_forms, cm_fil, cm_trans

widget_control,ev.id,get_uvalue=flag
case flag of
'open':   did_mpeg, 'open'
'slider':
'pause':  if ev.select then did_mpeg, 'pause' else did_mpeg, 'start'
'save':   did_mpeg, 'save'
'close':  did_mpeg, 'close'
else:
endcase
end

pro did_mpeg_die, id
;+
;** ************
;** mpeg dying
;-
did_mpeg_reset,0
end

pro did_mpeg_reset, exist, table_ext=table_ext
;+
;** **************
;** mpeg panel reset
;-

common c_did_mpeg

CATCH,stat & if stat ne 0 then begin & print,!error_state.msg & return & endif

if n_elements(cm_frame) eq 1 then begin
  if (cm_frame gt 0) and (cm_forms[0] eq cm_forms[2]) then  WRITE_GIF,cm_fil,/close
;                                                           GGGGGGGGGGGGGGGGGGGGGGG
  if n_elements(cm_id) eq 1 then  if obj_valid(cm_id) then $
                      if (cm_forms[0] eq cm_forms[1]) then  call_procedure,'MPEG_CLOSE',cm_id else $
;                                                           MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM
                      if (cm_forms[0] eq cm_forms[3]) then  cm_id->Cleanup   else $
                      if (cm_forms[0] eq cm_forms[4]) then  cm_id->Cleanup
;                                                           MAMAMAMAMAMAMA
  if exist then begin & exist=0 & widget_control,cm_base[0],bad_id=ii,/destroy & endif
endif else begin
  Video = 1
  if !version.release ge '8.1' then begin
    catch,stat & if stat ne 0 then Video=0 else dlm_load,'video'
    catch,/cancel ; Here we tested if 'idl_video.dlm' is in the distribution!
  endif else Video = 0
  if (NOT LMGR('idl_mpeg',VERSION='1.0')) then ISmpeg = '' else ISmpeg = '.mpeg' ; Do we have MPEG-1 license?
  
  if  Video             then cm_forms=['.mp4' ,ISmpeg ,'.gif','.mp4','.avi'] $   ; Default is cm_forms[0]
  else if ISmpeg le ' ' then cm_forms=['.gif' ,ISmpeg ,'.gif',''    , ''   ] $
                        else cm_forms=[ISmpeg ,ISmpeg ,'.gif',''    , ''   ]
endelse

cm_pause  = 1 & cm_win=0 & cm_frame=0 & cm_dim=0 & cm_base=lonarr(8) & cm_bfrm=0
cm_id     = obj_new()
table_ext = cm_forms ; if called from magnet_win
end

pro did_mpeg, flag, wdraw=wdraw, file=file, quality=quality, dims=dims, group=group, frame=frame, title=title
;+
;** ********
;** mpeg PANEL process
;**
;** flag   =create , open , pause , start , put , save , close
;** wdraw  =WidgetDrawId (DrawId from which images are read)
;** file   =filename
;** quality={1->100}
;** dims   =percent of widgetdraw size
;** group  =top base master
;** frame  =widget label base for current frame number
;** title  =label used for create flag
;-

common c_lamp_font
common c_did_mpeg

CATCH,stat & if stat ne 0 then begin & lamp_error & return & endif

if n_elements(flag)  ne  1     then return
if (flag eq 'put') and (n_elements(cm_dim) ne 2) then return ;Quick return
if !version.release  lt '5.4'  then return
obid =obj_new()
if n_elements(cm_id) eq  0     then did_mpeg_reset,0
if n_elements(wdraw) eq  1     then begin & widget_control,wdraw,bad_id=ii,get_value=cm_win
                                    str  =widget_info(wdraw,/geometry)
                                    cm_dim =[str.xsize,str.ysize] & endif
if n_elements(dims)  eq  1     then cm_dim =fix(cm_dim*dims/100)
if n_elements(frame) eq  1     then cm_bfrm=frame
if obj_valid(cm_win) then oo=2 else if cm_win gt 0 then oo=1 else oo=0 ; 2:object , 1:window_id
exist=xregistered('did_mpeg')

case flag of
'create': begin & if exist   then return
                if (oo eq 0) then return
                if obj_valid(cm_id) then did_mpeg_reset, 0
                if n_elements(title) ne 1 then title=''
                qal='100'
                cm_base[0]=widget_base(  title='Movie Panel ->'+title, resource_name='lamptouch')
                cm_base[4]=widget_base(  cm_base[0],/column,map=1)
                cm_base[5]=widget_base(  cm_base[0],/column,map=0)
                br1       =widget_base(  cm_base[4],/row)
                bid       =widget_label( br1       ,value='FileName',font=ft_b_normal)
                cm_base[1]=widget_text(  br1       ,value='lamp'+cm_forms[0],xsize=16,/edit,font=ft_propor)
                cm_base[2]=widget_slider(br1       ,value=fix(qal),minimum=20,maximum=100,title='Quality',uvalue='slider')
                bid       =widget_label( br1       ,value=' size:'      ,font=ft_b_normal)
                cm_base[7]=widget_text(  br1       ,value='100%',xsize=6,font=ft_propor,/editab)
                bid       =widget_label( cm_base[4],value='Fill filename, adjust the quality and size% then OPEN')
                lab_forms='' & for i=1,n_elements(cm_forms)-1 do lab_forms += cm_forms[i]+' '
                bid       =widget_label( cm_base[4],value='Available extensions: '+lab_forms)
                but       =widget_button(cm_base[4],value='OPEN',uvalue='open',font=ft_b_normal)

                br2       =widget_base(  cm_base[5],/row)
                butp      =widget_button(widget_base(br2,/nonexclusive),value='PAUSE',uvalue='pause',font=ft_b_normal)
                cm_base[3]=widget_label( br2       ,value='Frame=0000',font=ft_b_normal)
                cm_base[6]=widget_label( br2       ,value=' File:lamp'+cm_forms[0]+'       Quality:'+qal,font=ft_b_normal)
                bid       =widget_label( cm_base[5],value='(when PAUSE is On, registering is stopped)',font=ft_b_normal)
                br2       =widget_base(  cm_base[5],/row)
                but       =widget_button(br2       ,value='CLOSE' ,uvalue='save' ,font=ft_b_normal)
                bid       =widget_label( br2       ,value='                    ' )
                but       =widget_button(br2       ,value='CANCEL',uvalue='close',font=ft_b_normal)
                widget_control,butp,set_button=cm_pause
                widget_control,cm_base[0],/realize
                if n_elements(group) eq 1 then widget_control,cm_base[0],group_leader=group
                xmanager,'did_mpeg',cm_base[0],event_handler='did_mpeg_event',CLEANUP='did_mpeg_die',/no_block,/just_reg
          end
'open':   begin & if (oo eq 0)                then return
                if n_elements(file)    ne 1 then file='lamp'+cm_forms[0]
                if n_elements(quality) ne 1 then quality=100
                if exist then begin
                   widget_control,cm_base[1],bad_id=ii,get_value=file & file= strcompress(file[0])
                   widget_control,cm_base[2],bad_id=ii,get_value=quality & qal=strtrim(string(quality),2)
                   widget_control,cm_base[6],bad_id=ii,set_value=' File:'+file+' Quality:'+qal
                   widget_control,cm_base[7],bad_id=ii,get_value=siz & siz=siz[0]
                   idx=strpos(siz,'%') & if idx gt 0 then siz=strmid(siz,0,idx) & dims=fix(siz)
                   cm_dim =fix(cm_dim*dims/100)
                   widget_control,cm_base[4],bad_id=ii,map=0
                   widget_control,cm_base[5],bad_id=ii,map=1
                endif
               for i=1,n_elements(cm_forms)-1 do if strpos(strlowcase(file),cm_forms[i]) gt 0 then cm_forms[0]=cm_forms[i]
               cm_fil=file
               cm_dim=round( cm_dim/2)*2
               fps   =30

               if (cm_forms[0] eq cm_forms[1]) then cm_id =call_function('MPEG_OPEN',cm_dim,filename=file,quality=quality,iframe_gap=4) ;'.mpeg'
;                                                          MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM
               if (cm_forms[0] eq cm_forms[3]) or (cm_forms[0] eq cm_forms[4]) then begin ; .mp4 or .avi
                                                    cm_id = IDLffVideoWrite(file)         ; depending of extention
;                                                   MAMAMAMAMAMAMAMAMAMAMAMAMAMAM
                                                vidStream = cm_id->AddVideoStream(cm_dim[0], cm_dim[1], fps) ; Should return 0L
;                                               MAMAMAMAMAMAMAMAMAMAMAMAMAMAMAMAMAMAMAMAMAMAMAMAMAMAMAMAMAMA
               endif
          end
'pause':  cm_pause=1
'start':  cm_pause=0

'put':    if ((obj_valid(cm_id)) or (cm_forms[0] eq cm_forms[2])) and (oo ne 0) then begin
             if (not cm_pause) then begin
                fram=cm_frame+1
                if cm_bfrm gt 0 then begin & widget_control,cm_bfrm,bad_id=ii,set_value='frm='  +strtrim(string(fram),2)
                                  if ii ne 0 then begin & did_mpeg_reset,exist & return & endif & endif
                if exist   then widget_control,  cm_base[3],bad_id=ii,set_value='frame='+strtrim(string(fram),2)
                if oo eq 1 then wset,cm_win

                if (cm_forms[0] eq cm_forms[2]) then begin
                   if oo eq 2 then begin & Oimg=cm_win->read() & Oimg->GetProperty,data=img & endif
                   if oo eq 1 then begin & if !D.N_colors gt 256 then img=tvrd(/true) else img=tvrd() & endif
                   tz=size(img)
                   if tz[0] eq 3 then if (tz[1] ne cm_dim[0]) or (tz[2] ne cm_dim[1]) then img=congrid(img,tz[0],cm_dim[0],cm_dim[1],/interp)
                   if tz[0] lt 3 then if (tz[0] ne cm_dim[0]) or (tz[1] ne cm_dim[1]) then img=congrid(img,      cm_dim[0],cm_dim[1],/interp)
                   if tz[0] eq 3 then if fram eq 1 then img=Color_Quan(img,1,r,g,b,cube=6) $;color=256,/dither,get_translation=cm_trans,/map_all) $
                                                   else img=Color_Quan(img,1,r,g,b,cube=6) $;color=256,/dither,    translation=cm_trans) $
                                 else if fram eq 1 then tvlct,r,g,b,/get
                   if  oo  eq 1  then if sys_dep('MACHINE') eq 'win' then img=reverse(img,2,/overwrite)
                   if fram eq 1  then WRITE_GIF,cm_fil,img,r,g,b,/multiple $
                                 else WRITE_GIF,cm_fil,img      ,/multiple
;                                     GGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGG
                endif
                if (cm_forms[0] eq cm_forms[1]) then begin
                   if oo  eq  2 then call_procedure,'MPEG_PUT',cm_id,window=cm_win,frame=cm_frame $
                                else call_procedure,'MPEG_PUT',cm_id,window=cm_win,frame=cm_frame,/order
;                                    MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM
                endif
                if (cm_forms[0] eq cm_forms[3]) or (cm_forms[0] eq cm_forms[4]) then begin
                                     if oo eq 2 then begin & Oimg= cm_win->read() & Oimg->GetProperty,data=img & endif
                                     if oo eq 1 then         img = tvrd(/true)
                                     time = cm_id->Put(0L,   img)
;                                    MAMAMAMAMAMAMAMAMAMAMAMAMAMA
                endif
                cm_frame=fram
             endif
          endif else did_mpeg_reset, exist

'save':   begin & widget_control,/hourglass ; ** FOR CLOSE BUTTON **
                if (cm_forms[0] eq  cm_forms[2])       then WRITE_GIF,cm_fil,/close else $
;                                                           GGGGGGGGGGGGGGGGGGGGGGG
                if (obj_valid(cm_id)) and (cm_frame gt 0) then $
                if (cm_forms[0] eq  cm_forms[1])       then call_procedure,'MPEG_SAVE',cm_id
;                                                           MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM
                did_mpeg_reset, exist
          end
'close':  did_mpeg_reset, exist             ; ** FOR CANCEL BUTTON **
else:
endcase
end

;+
; READ_FTP
;
; Syntax:
;   READ_FTP, remote_host [, files] [, directory] [,/FILE] [,DATA=variable]
;              [,USER=string] [,PASS=string] [,/PTR] [,OUTFILES=files]
;
; Arguments
;   remote_host - Name of the remote host (ftp server) that you want
;                 to connect to, or a complete ftp location such as for example:
;                      ftp://ftp.rsinc.com/pub/gzip/README.GZIP
;
;   directory - Remote directory where the files reside on the ftp
;               server
;
;   files - A single filename or an array of filenames to be
;           retrieved.
;
; Keywords
;   FILE - Set this keyword to make a local copy of the file to be
;          transferred.  The local file will have the same name as the
;          remote file and will be placed in the current working
;          directory.
;
;   DATA - Set this to a named variable that will contain either a
;          byte array or an array of pointers to byte arrays with the
;          transferred data.  If there is more than one file, an array
;          of pointers is returned, one for each file.
;          Note that when downloading large files using /FILE
;          instead will require much less memory since the entire file
;          is not stored in a variable in that case.
;
;   PTR  - Set this keyword to return an array of pointers
;          even when there is only one file.
;
;   USER - Specify user name to connect to server with.  Default is:
;          anonymous.
;
;   PASS - Specify password to use when connecting.  Default is:
;          test@test.com.
;
; Examples of use.
; 1) Retrieve and print the contents of ftp://ftp.rsinc.com/pub/gzip/README.GZIP:
;   IDL> READ_FTP, 'ftp://ftp.rsinc.com/pub/gzip/README.GZIP', DATA=data
;   IDL> help, data
;          DATA            BYTE      = Array[2134]
;   IDL> print, string(data)
;     ------------------------------------------------------------------------------
;     README file: Research Systems Anonymous FTP site (ftp.rsinc.com)
;                   pub directory
;                   gzip directory
;   ------------------------------------------------------------------------------
;   ...
;
; 2) Retrieve some files from podaac.jpl.nasa.gov and store the files
;    in the current working directory:
;
;    IDL> files = string(lindgen(10)+50,format='(%"MGB370.%3.3d.gz")')
;    IDL> READ_FTP, 'podaac.jpl.nasa.gov', files,  $
;    IDL>       'pub/sea_surface_height/topex_poseidon/mgdrb/data/MGB_370', /FILE
;    IDL> spawn,'dir MGB*',/log_output
;     Volume in drive C is Local Disk
;     Volume Serial Number is 34CE-24DF
;
;     Directory of C:\test\test0307
;
;    07/28/2003  11:58a             362,167 MGB370.050.gz
;    07/28/2003  11:58a             333,005 MGB370.051.gz

pro ftp_post, u, cmd, res, out=out, count=count, bout=bout
;+
;** ********
;** live update stuff
;compile_opt idl2
;-
  
  debug=0
  if (cmd ne '') then begin
    printf, u, cmd, format='(a)'
    if debug then print, '>'+cmd
  endif
  if (size(out,/type) eq 0) then out='2?? *'
  
  catch, err & if (err ne 0) then begin & catch,/cancel
         openw,uu ,'debug_upd.txt',/get_lun,/append
         printf,uu,'ftp_post '+!error_state.msg
         flush,uu & free_lun,uu & return & endif
  line =''
  count=0
  ok   =arg_present(res)
  while ok do begin
    readf, u, line
    if count eq 0 then res=line else res=[res,line]
    count=count+1
    if debug then print, '<'+line
    if strmatch(line,out) then ok=0 ;+ an alternative bout
    if n_elements(bout) eq 1 then if strmatch(line,bout) then ok=0
    if strmatch(line,'4?? *') then begin & count=-1 & ok=0 & endif
  endwhile
end

pro ftp_parse_pasv, text, host, port
;+
;** **************
;** live update stuff
;
;  this catch should be treated in READ_FTP
;  catch, err & if (err ne 0) then begin catch,/cancel
;         openw,uu,'debug_upd.txt',/get_lun,/append
;         printf,uu,'ftp_parse_pasv '+!error_state.msg
;         flush,uu & free_lun,uu & print,!error_state.msg & return   & endif
;-
  
  t=strtrim(text,2)
  ind=where(strcmp(t,'227',3))
  i=ind[0]
  if (i ne -1) then begin
    sub=CALL_FUNCTION('stregex' ,t[i],'\([0-9,]*\)',/extract)
    p  =CALL_FUNCTION('strsplit',strmid(sub,1,strlen(sub)-2),',',/extract)
    p  =strtrim(p,2)
    host=p[0]+'.'+p[1]+'.'+p[2]+'.'+p[3]
    port=256*long(p[4])+long(p[5])
  endif
end

pro read_ftp, site, files, dirftp, port, data=data, file=file, user=user, pass=pass, ptr=ptr ,$
              outfiles=outfiles, test=uub, debug=debug
;+
;** ********
;** live update stuff
;compile_opt idl2
;-
u=-1 & v=-1 & w=-1 & if n_elements(debug) ne 1 then debug=0
      
catch, err
if (err eq 0) then begin
 if debug then begin & openw ,uu,'debug_upd.txt',/get_lun,/append
                     printf,uu,'read_ftp entry '+site+' for '+files[0]
                     printf,uu,'Current error: '+!error_state.msg
                    ;printf,uu,'Path '+!path
                     flush ,uu & free_lun,uu & print,'read_ftp entry '+site & endif

 if n_elements(dirftp) eq 1 then dir=dirftp else dir=' ? '
 if n_elements(port)   eq 0 then port='ftp'
 if n_elements(files)  eq 0 then begin
    if strcmp(site,'ftp://',6) then host=strmid(site,6) else host=site
    pos  =strpos(host,'/')
    dir  =strmid(host,pos)
    host =strmid(host,0,pos)
    pos  =CALL_FUNCTION('strpos',dir,'/',/reverse_search)
    files=strmid(dir,pos+1)
    dir  =strmid(dir,0,pos)
 endif else host=site
 
 if (size(user,/type) eq 0) then user='anonymous'
 if (size(pass,/type) eq 0) then pass='test@test.com'
 n=n_elements(files)
 if n ne n_elements(outfiles) then outfiles=files

 if debug then begin & openw,uu,'debug_upd.txt',/get_lun,/append
    printf,uu,'read_ftp host dir '+host+' '+dir & flush,uu & free_lun,uu & endif

 if !version.release ge 6.4 then begin ; NEW FTP METHOD
;if !version.release ge 8.1 then begin ; NEW FTP METHOD

  dir='/'+dir+'/'

  catch,stat & if stat ne 0 then begin &  catch,/cancel
      openw,uu,'debug_upd.txt',/get_lun,/append
      printf,uu,'read_ftp netUrl catch '+!error_state.msg
      flush,uu & free_lun,uu & print,!error_state.msg
      oUrl->CloseConnections & OBJ_DESTROY, oUrl & return & endif

  if debug then begin & openw ,uu,'debug_upd.txt',/get_lun,/append
                      printf,uu,'Will instanciate IDLnetUrl'
                      flush ,uu & free_lun,uu & endif
  oUrl=obj_new('IDLnetUrl')

  if debug then begin & openw,uu,'debug_upd.txt',/get_lun,/append
     printf,uu,'read_ftp new netUrl ' & flush,uu & free_lun,uu & endif

  oURL->SetProperty, URL_SCHEME     ='ftp'
  oURL->SetProperty, URL_HOSTNAME   =host
  oURL->SetProperty, URL_PATH       =dir
  oURL->SetProperty, URL_USERNAME   =user
  oURL->SetProperty, URL_PASSWORD   =pass
  oURL->SetProperty, CONNECT_TIMEOUT=15
  oURL->SetProperty, TIMEOUT        =120

  oURL->GetProperty, FTP_CONNECTION_MODE =PorA ;1=active(def)  0=Passive
  oURL->SetProperty, FTP_CONNECTION_MODE =0    ;1=active(def)  0=Passive
  oURL->GetProperty, PROXY_HOSTNAME      =px_host
  oURL->GetProperty, PROXY_PORT          =px_port
  oURL->GetProperty, PROXY_AUTHENTICATION=px_auth

  for i=0, n-1 do begin
      if n_elements(uub) eq 1 then if uub gt 0L then begin
         widget_control,uub,bad_id=ii,set_value='3-Loading file '+strtrim(string(i+1),2)+'/'+strtrim(string(n),2)+' ...............'
         if ii ne 0 then break
      endif
      oURL->SetProperty, URL_PATH=dir+files[i]
      if arg_present(data) then data=oURL->Get(/buffer) $
      else                      res =oUrl->Get(FILENAME=outfiles[i])
      if debug then print,files[i]
  endfor

  oUrl->CloseConnections
 ;oUrl->Cleanup
  OBJ_DESTROY, oUrl

 endif else begin ;OLD FTP METHOD
                           ;
  CALL_PROCEDURE,'socket', u, host, port, connect_timeout=15, read_timeout=9, /get_lun

  if debug then begin & openw,uu,'debug_upd.txt',/get_lun,/append
     printf,uu,'read_ftp socket opened ' & flush,uu & free_lun,uu & endif

  ftp_post, u, '', res
  ftp_post, u, 'USER '+user, res, out='3?? *', bout='230 *'
  ftp_post, u, 'PASS '+pass, res
  ftp_post, u, 'TYPE I', res
  if (size(dir,/type) ne 0) then ftp_post, u, 'CWD '+dir, res
  if keyword_set(file) or arg_present(data) then begin
    bufsize=512
    buffer=bytarr(bufsize)
    if arg_present(data) then dat=ptrarr(n)
    for i=0, n-1 do begin
      on_ioerror,misfil & v=-1 & w=-1
      if n_elements(uub) eq 1 then if uub gt 0L then begin
         widget_control,uub,bad_id=ii,set_value='3-Loading file '+strtrim(string(i+1),2)+'/'+strtrim(string(n),2)+' ...............'
         if ii ne 0 then begin & ftp_post, u, 'QUIT', res & free_lun, u & return & endif else empty
      endif
      ftp_post, u, 'SIZE '+files[i], res, out='213 *'
      sz=long64(strmid(res[n_elements(res)-1],4))
      if arg_present(data) then dat[i]=ptr_new(bytarr(sz))
      ftp_post, u, 'PASV', res
      ftp_parse_pasv, res, host, port
      if !version.os eq 'linux' or !version.os eq 'darwin'          then $
         ftp_post, u, 'RETR '+files[i]       ,out='1?? *',count=cnt else $
         ftp_post, u, 'RETR '+files[i]  ,res ,out='1?? *',count=cnt
      if cnt ge 0 then begin
       CALL_PROCEDURE,'socket', v, host, port, connect_timeout=15, read_timeout=120,/get_lun, /rawio
       tc=0ll
       if keyword_set(file) then openw,w,outfiles[i],/get_lun
       while (tc lt sz) do begin
        if (sz-tc lt bufsize) then begin
          bufsize=sz-tc
          buffer=bytarr(bufsize)
        endif
        readu, v, buffer, transfer_count=dtc
        if arg_present(data) then $
           (*dat[i])[tc]=(dtc eq bufsize)?buffer:buffer[0:dtc-1]
        if keyword_set(file) then $
           writeu,w,(dtc eq bufsize)?buffer:buffer[0:dtc-1]
        tc=tc+dtc
       endwhile
       misfil: if v gt 0 then free_lun, v & if w gt 0 then free_lun, w
       ftp_post, u, '', res
      endif
    endfor
    if arg_present(data) then begin
       if (n gt 1 or keyword_set(ptr)) then data=dat $
       else data=temporary(*dat[0])
    endif
  endif
  ftp_post, u, 'QUIT', res
  free_lun, u

 endelse ;Old FTP method

endif else begin & catch,/cancel ; *** Should come also from ftp_post ***
  if u gt 0 then free_lun, u & if v gt 0 then free_lun, v & if w gt 0 then free_lun, w
  openw ,uu,'debug_upd.txt',/get_lun,/append
  printf,uu,'read_ftp catch '+!error_state.msg & flush,uu & free_lun,uu  & print,!error_state.msg
endelse
end

pro liv_upd_call, status, errorST, oBridge, userdata
;+
;** *************
;** live update stuff
;-
if (not obj_valid(oBridge)) then return

  catch, err & if (err ne 0) then begin & catch,/cancel
         openw,uu,'debug_upd.txt',/get_lun,/append
         printf,uu,'liv_upd_call '+!error_state.msg
         flush,uu & free_lun,uu & print,!error_state.msg & return & endif

if (status ne 2) and (strpos(errorST,'READF') lt 0) then print,'<-live-update end ',status,' ',errorST $
                                                    else print,'<-live-update end '           ,errorST
obridge->cleanup
if obj_valid(oBridge) then obj_destroy,oBridge
end

pro lu_lamp, silent=chut, debug=debug, oBridge=oBridge, testUpd=testUpd
;+
;** *******
;** live update entry
;-
@lamp.cbk
if n_elements(chut)    ne 1   then chut=0
if n_elements(debug)   ne 1   then debug=0
if n_elements(testUpd) ne 1   then testUpd=0

  catch, stat & if (stat ne 0) then begin & catch,/cancel
         openw,uu,'debug_upd.txt',/get_lun,/append
         printf,uu,'lu_lamp '+!error_state.msg
         flush,uu & free_lun,uu & print,!error_state.msg & return  & endif ; no update if error
         
if sys_dep('VERSION') lt 5.4 then return                   ; no update before V5.4
if sys_dep('VERSION') lt 6.3 then if chut eq 1 then return ; no automatic update before V6.3

if chut gt 1 then ndays=chut else ndays=20 & chut=chut>0<1

if n_elements(lamp_dir) eq 0 then begin
   lamp_dir='D:\USER\DIDIER\lamp' & lamp_dvd=sys_dep('DIVIDER') ;lamp not running
   lamp_dir='.'
   lamp_dir=sys_dep('GETENV','LAMP_DIR')
endif

now=long(systime(1)/3600./24.) & nows=string(now)
if (chut) and (not testUpd) then begin & time=0L
   on_ioerror,mistim & openr,u,lamp_dir+lamp_dvd+'juldate.upd',/get_lun & readf ,u,time & free_lun,u
   mistim: if (now-time)  lt   ndays then return           ;  no auto-update if time too short
endif
if (not testUpd) then begin
   ko=1
   on_ioerror,misday & openw,u,lamp_dir+lamp_dvd+'juldate.upd',/get_lun & printf,u,nows & free_lun,u & ko=0
   file_chmod, lamp_dir+lamp_dvd+'juldate.upd' , /A_WRITE     ;  writable for all
   misday: if (ko) then return                                ;  no update if write denied
endif
message,/reset
on_ioerror,misbrg

;Update in current process
cd, current=mee
lampdir=lamp_dir
if (sys_dep('VERSION') lt 6.3) or (chut eq 0) then begin
    lu_lampw, silent=chut, lampdir=lampdir, debug=debug, testUpd=testUpd
    return  & endif

pathsep = PATH_SEP(/SEARCH_PATH)
path_1  = !path & path_2=''
pathlng = strlen(!path)  &  pathoff= strpos(!path,pathsep,pathlng/2)
if pathoff gt 0 then begin & path_1= strmid(!path,0,pathoff)
                             path_2= strmid(!path,  pathoff) & endif
                           
VV      = strtrim(long(float(!version.release)*10),2)                     ; The Idl version
livdir  = lamp_dir+lamp_dvd+'lamp_mac'+lamp_dvd+'liv_lamp'+VV+'.rt' 
if file_test(livdir) then livdir = 'restore, "'+livdir+'"' else livdir='' ; Have the corresponding liv_lamp?

;Update in child   process
;debug=1 ;for tests
oBridge =OBJ_NEW('IDL_IDLBridge', CALLBACK='liv_upd_call',USERDATA='live-update',OUTPUT='')
;oBridge=OBJ_NEW('IDL_IDLBridge')
oBridge->SetVar, "lampdir" , lampdir
oBridge->SetVar, "path_1"  , path_1 ;path is splited due to a strlen limitation
oBridge->SetVar, "path_2"  , path_2
oBridge->SetVar, "chut"    , chut
oBridge->SetVar, "debug"   , debug
oBridge->SetVar, "testUpd" , testUpd
oBridge->Execute,"!path=path_1+path_2"
if livdir gt ' ' then $
oBridge->Execute,livdir
oBridge->Execute,"liv_lamp"
print,'->live-updating ' + lampdir ;+ ' from '+ mee
oBridge->Execute,"lu_lampw, silent=chut, lampdir=lampdir, debug=debug, testUpd=testUpd", /NOWAIT

misbrg:
end

pro lu_lampw, silent=chut, lampdir=lampdir, debug=debug, testUpd=testUpd
;+
;** ********
;** live update doing the work
;-
@lamp.cbk

if n_elements(chut)    ne 1 then chut=0
if n_elements(debug)   ne 1 then debug=0
if n_elements(testUpd) ne 1   then testUpd=0

if debug then begin & openw, uu,'debug_upd.txt',/get_lun,/append & printf,uu,stime(dum)
                      printf,uu,'lu_lampw 1<-- '+!error_state.msg & flush,uu & free_lun,uu & endif

catch,stat & if stat ne 0 then begin & catch,/cancel
      openw,uu,'debug_upd.txt',/get_lun,/append
      printf,uu,'lu_lampw '+!error_state.msg
      flush,uu & free_lun,uu & print,!error_state.msg & return & endif

curDIST='8.5'

;Child process?
   lamp_dvd=sys_dep('DIVIDER')
   if n_elements(lampdir) eq 1 then lamp_dir=lampdir ;anyway
;

VV=strtrim(string(sys_dep('VERSION')),2) & vvp=strpos(VV,'.')
VV=strmid( VV,0,vvp)+strmid( VV,vvp+1,1)
if sys_dep('VERSION') ge '5.6' then extm='_' else extm=''

wayt=1  & pass='update@lamp.com' & now=long(systime(1)/3600.) & nows=string(now)
if chut then begin & wayt=0 & pass='silent@lamp.com' & endif

Slocal=sys_dep('MACHINE')
em    =sys_dep('EMBEDDED')
rt    =sys_dep('RUNTIME')
islamp=0 & if n_elements(lamp_b1) eq 1 then if lamp_b1 gt 0 then islamp=1

host='ftp.ill.eu'
dir ='pub/cs/lamp_runtimes/Misc/Others'
info=''
a0=0L & a1=0L & lb=0L & u1=0L & u2=0L & u3=0L & u4=0L

if not chut then begin
  a0=widget_base(  title='Lamp Update',/column,resource_name='lamp',map=1-chut)
  a1=widget_base(  a0,/row,resource_name='mic',/frame) & if islamp then put_logo,a1
  lb=widget_label( a1,value='This updating process loads new macros and plugins',font=ft_b_normal)
  u1=widget_label( widget_base(a0,/row),value='1-Checking for update informations at '+host+' ...' ,font=ft_b_normal)
  u2=widget_label( widget_base(a0,/row),value='2-Comparing files versions  ...'                    ,font=ft_b_normal) & widget_control,u2,sensitive=0
  u3=widget_label( widget_base(a0,/row),value='3-Loading the new files  ...'                       ,font=ft_b_normal) & widget_control,u3,sensitive=0
  u4=widget_label( widget_base(a0,/row),value='4-Replacing old files  ...'                         ,font=ft_b_normal) & widget_control,u4,sensitive=0

  widget_control,bad_id=ii,a0,/realize & if islamp then put_logo
endif

;Get lamp.upd
READ_FTP, host,['lamp.upd'],dir, DATA=info, PASS=pass, debug=debug

if u1 gt 0L then widget_control,u1,bad_id=ii,sensitive=0

if (testUpd) then begin
   if (n_elements(info) gt 1) and (max(info) gt 0) then msg = host+': successfull access ._.' $
                                                   else msg = host+': failed to get info !!!'
   if lb gt 0L then begin & widget_control,bad_id=ii,lb,set_value=msg & wait,4*wayt & endif
   if a0 gt 0L then         widget_control,bad_id=ii,a0,/destroy
   print, msg & testUpd = msg ; Usefull when not IDLBridge
   if ((n_elements(info) le 1) or (max(info) le 0)) and (chut) then ii=execute('failed_to_get_info') ;IDLBridge -> force error 
   return
endif

if (n_elements(info) gt 1) and (max(info) gt 0) then begin
   if u2 gt 0L then begin & widget_control,u2,bad_id=ii,sensitive=1 & if ii ne 0 then return & endif
   info=strsplit(/EXTRACT,string(info),'->',/regex)
   updfile=[''] & upddir=[''] & updload=[0L] & recomp=0

   ;Loop over files
   for i=0,n_elements(info)-1 do begin
     tab=strtrim(strsplit(/EXTRACT,info[i],','),2) ;embd , lamp , sub1.sub2.sub3 , filename , size , 0
     if n_elements(tab) ge 6 then begin
      case tab[0] of
      'embd': ok=em                                        ;if embeded      download
      'runt': ok=rt                                        ;if runtime      download
      'allc': ok=1                                         ;for all distrib download
      'licd': if (not em) and (not rt) then ok=1 else ok=0 ;if licensed     download
      'dele': if (not em) and (not rt) then ok=0 else ok=1 ;if embeded      delete
      'dela': ok=1                                         ;for all distrib delete
      'dell': if (not em) and (not rt) then ok=1 else ok=0 ;if licensed     delete
       else : ok=0
      endcase
      ;Check for file-size different
      ;*****************************
      ook=0 & on_ioerror,misiz & upsize=long(tab[4]) & ook=ok & misiz: on_ioerror,mismis

      if ook then begin &                Flocal='.'        ;any local system
       if strpos(tab[2],'\') gt 0 then Flocal='\' else $ ;for Windows only
       if strpos(tab[2],'/') gt 0 then Flocal='/'        ;for Unix    only
       if (Flocal eq '.') or ((Flocal eq '\') and (Slocal eq 'win')) $
                          or ((Flocal eq '/') and (Slocal ne 'win')) then begin
       ;This line match local system
        sub=strtrim(strsplit(/EXTRACT,tab[2],Flocal),2)
        if tab[1] eq 'lamp' then sdir=FILEPATH('', ROOT_DIR=lamp_dir, SUBDIR=sub)
        if tab[1] eq 'idl'  then sdir=FILEPATH('', SUBDIR=sub)
        sfil=sdir+tab[3]
        res =file_info(sdir)
        if (tab[0] eq 'dele') or (tab[0] eq 'dela') or (tab[0] eq 'dell') then begin
          if res.directory then begin & on_ioerror,misdel & openr,u,sfil,/get_lun,/DELETE & free_lun,u
                                      misdel: cnt=0 & on_ioerror,mismis & endif
        endif else begin
          if strpos(strlowcase(sub[0]),'idl') lt 0 then $
          if (not res.directory) then file_mkdir,sdir   ;Try to create the directory
          res =file_info(sdir)                          ;Test it
          if (not res.directory) then cnt=0 else cnt=1  ;
        endelse

        if cnt gt 0 then begin & ok=1 ;Directory must exist
         if strpos(tab[3],'.rt') gt 0 then if tab[3] ne 'core.rt' then if strpos(tab[3],VV) lt 0 then ok=0
         on_ioerror,misfil & openr,u,sfil    ,/get_lun & res=fstat(u) & free_lun,u
         if upsize eq res.size then ok=0 & misfil: on_ioerror,mismis

         if ok then begin & updfile=[updfile,tab[3]] & upddir=[upddir,sdir]         ;Size different
           if extm ne '' then begin
             on_ioerror,mistmp & openr,u,sfil+extm,/get_lun & res=fstat(u) & free_lun,u
             if upsize eq res.size then ok=0 & mistmp: on_ioerror,mismis
           endif
           if ok then updload=[updload,upsize] else updload=[updload,-upsize]     ;Temporary file to load?
           if (tab[5] eq '1') and (not em) and (not rt) then recomp=1
         endif ;size different

        endif ;directory exists
       endif ;correct local system
      endif ;TAB(0) flag correct for local mode
      mismis:
     endif ;TAB correct ge 6
   endfor ;each line info

   ;Get the new files if needed
   ;***************************
   if u2 gt 0L then widget_control,u2,bad_id=ii,sensitive=0
   message,/reset
                                                    msg=host+': No update is needed '
   if (em) and (sys_dep('VERSION')) lt curDIST then msg="A new distribution "+curDIST+" is available to download!"
   if n_elements(updfile) gt 1 then begin
      if u3 gt 0L then begin & widget_control,u3,bad_id=ii,sensitive=1 & if ii ne 0 then return & endif
      idx=where(updload gt 0)
      if idx[0] ne -1 then begin & outf=[upddir[idx]+updfile[idx]]
          READ_FTP, host,updfile[idx],dir, /FILE, PASS=pass, OUTFILES=outf+extm, TEST=u3, debug=debug
      endif
      if u3 gt 0L then begin & widget_control,u3,bad_id=ii,sensitive=0
                               widget_control,u4,bad_id=ii,sensitive=1 & if ii ne 0 then return & endif
      if extm ne '' then $
      for i=1,n_elements(updfile)-1 do begin & fifi=upddir[i]+updfile[i] & upsize=abs(updload[i])
      on_ioerror,mismov & openr,u,fifi+extm,/get_lun & res=fstat(u) & free_lun,u
      if upsize eq res.size then CALL_PROCEDURE,'file_move'  ,fifi+extm,fifi,/overwrite $
                            else CALL_PROCEDURE,'file_delete',fifi+extm,/quiet  & mismov:
      endfor
      msg='Update will take effect at next Lamp start.'
      if recomp then begin & on_ioerror,mismust & openw,u,lamp_dir+lamp_dvd+'.must.upd',/get_lun & printf,u,stime(dum)
                     free_lun,u & msg='Kernel will be compiled at next Lamp start'   & mismust:
      endif
      if u4 gt 0L then begin & widget_control,bad_id=ii,u4,sensitive=0                             & endif
      if lb gt 0L then begin & widget_control,bad_id=ii,lb,set_value=msg             & wait,4*wayt & endif
      
      if chut   then begin                                                          ;We have an effective auto-update, keep in mind
         on_ioerror,  mischutW  & openw,u,lamp_dir+lamp_dvd+'.chut.upd',/get_lun & printf,u,stime(dum)
         free_lun,u & mischutW: & endif
      
   endif else begin
      if (not chut) and (file_test(lamp_dir+lamp_dvd+'.chut.upd')) then begin ;We just had an effective auto-update
         msg='Update will take effect at next Lamp start.'                    ;so Lamp should be restarted
         on_ioerror,  mischutD  & openr,u,lamp_dir+lamp_dvd+'.chut.upd',/get_lun,/delete
         free_lun,u & mischutD: & endif

      if lb gt 0L then begin & widget_control,bad_id=ii,lb,set_value=msg             & wait,5*wayt & endif
      
   endelse
endif else begin
      msg=host+': failed to get info !!!'
      if lb gt 0L then begin & widget_control,bad_id=ii,lb,set_value=msg             & wait,5*wayt & endif
endelse
if a0 gt 0L then widget_control,bad_id=ii,a0,/destroy
if debug then begin & openw,uu,'debug_upd.txt',/get_lun,/append & printf,uu,'lu_lampw 2<-- '+msg & flush,uu & free_lun,uu & endif
end

pro live_lamp_dens, liveT, xx,yy,zz,w, thresh=thresh, box=cdbox, ax=rx,az=rz, xrange=bx, yrange=by, zrange=bz, group=l_b1, Fidl8=Fidl8
;+
;** **************
;** call to XPLOT3D
;-
common c_live_multi, ID_layout ; for multiplot layout (8.0 graphics)

if keyword_set(Fidl8) then Ftools=1 else Ftools=0 ;Use plot3D function instead of XPLOT3D (8.0)
if !version.release ge '8.0'        then Ftools=1 ;idem when anotation tools

if !version.os eq 'darwin'   then render=1 else render=0                     ;bug MacOs/Xquarz
if !version.release lt '8.2' then render=0

if n_elements(xs) ne 1 then xs=1
tit    = ''
sym_sz = (2000./n_elements(xx)) < 1.
if thresh ne -99 then begin & endif ;thresh already done
Vs=!version.release

if Vs ge 5.4  then begin
;Ftools=0
 if not Ftools then begin ; Use XPLOT3D
   oOrb = OBJ_NEW('orb', COLOR=[0, 0, 255])
   oOrb->Scale, .75*sym_sz, .1, .5*sym_sz
   oSymbol = OBJ_NEW('IDLgrSymbol', oOrb)
   CALL_PROCEDURE,'XPLOT3D',xx,yy,zz,group=l_b1, xrange=bx, yrange=by, zrange=bz, symbol=oSymbol,linestyle=6

 endif else begin         ; Use PLOT3d function
   if xs eq 5 then axe_st=0 else axe_st=2
   tvlct,r,g,b,/get
   live_plotIds, Odx & tit='Opid['+strtrim(Odx,2)+']->plot3d ' +tit
   if ID_layout.insert then begin & multiID8 = ID_layout.ID & layout8 = ID_layout.layout & ID_layout.insert = 0 & endif ; Multi plot

   if render eq 1 then begin
      po = call_function('PLOT3D', window_title=tit, title=!p.title, /widget, renderer=render, $
                                   current=multiID8, layout=layout8,  $
                                   xx,yy,zz, xrange=bx, yrange=by, zrange=bz, symbol="o", $
                                   /sym_filled, axis_style=axe_st, /perspective, xtitle=!x.title, ytitle=!y.title, ztitle=!z.title, $
                                   XY_SHADOW=1, YZ_SHADOW=1, XZ_SHADOW=1, COLOR=[0, 0, 255], sym_size=sym_sz, $
                                   shadow_color=[0, 255, 100], rgb_table=[[r],[g],[b]], vert_colors=bytscl(w))
   endif else begin
      po = call_function('PLOT3D', window_title=tit, title=!p.title, /widget, $
                                   current=multiID8, layout=layout8,  $
                                   xx,yy,zz, xrange=bx, yrange=by, zrange=bz, symbol="o", $
                                   /sym_filled, axis_style=2, /perspective, xtitle=!x.title, ytitle=!y.title, ztitle=!z.title, $
                                   XY_SHADOW=1, YZ_SHADOW=1, XZ_SHADOW=1, COLOR=[0, 0, 255], sym_size=sym_sz, $
                                   shadow_color=[0, 255, 100], rgb_table=[[r],[g],[b]], vert_colors=bytscl(w))
   endelse
   ax=po.axes
   ax[2].HIDE=1 & ax[6].HIDE=1 & ax[7].HIDE=1
   live_plotIds, Odx ,po
 endelse

endif else if liveT ne 3 then $
PLOT_3DBOX, xx,yy,zz,psym=2, ax=rx,az=rz, xrange=bx, yrange=by, zrange=bz, $
       /solid_walls,color=80,background=255, gridstyle=0 $
else $
PLOT_3DBOX, xx,yy,zz,psym=2, ax=rx,az=rz, xrange=bx, yrange=by, zrange=bz, $
       /solid_walls,color=80,background=255, gridstyle=0, $
       /xy_plane, /xz_plane, /yz_plane
end

pro live_lamp_event,ev
;+
;** ***************
;** event for live_tools (old)
;-
widget_control,ev.id, get_uvalue=uv, tlb_get_size=v2 & vv=uv.v2 & uv.v2=v2
if (abs(v2[0]-vv[0]) gt 10) or (abs(v2[1]-vv[1]) gt 10) then begin
    widget_control,ev.id, set_uvalue=uv
    call_procedure,'live_info',    PROPERTIES=proper, WINDOW_IN=uv.win
    proper.dimensions =round(proper.dimensions*[float(v2[0])/vv[0],float(v2[1])/vv[1]])
    call_procedure,'live_control', PROPERTIES=proper, WINDOW_IN=uv.win
endif
end

pro live_plot_functions
;+
;** *******************
;** compile new plotting functions (v8)
;-
forward_function PLOT,BARPLOT,ERRORPLOT,POLARPLOT,PLOT3D,IMAGE,CONTOUR,SURFACE,MAP,VECTOR, $
                 STREAMLINE,WINDOW,WIDGET_WINDOW, ARROW, SYMBOL, $
                 MAPGRID,LEGEND,COLORBAR,TEXT,POLYGON,POLYLINE,AXIS,ELLIPSE,GETWINDOWS, $
                 BOXPLOT, BUBBLEPLOT, SCATTERPLOT, SCATTERPLOT3D, VOLUME

;Only for Lamp runtime Making with Idl>8

id=PLOT(a,b)
id=BARPLOT(a,b)
id=ERRORPLOT(a,b)
id=POLARPLOT(a,b)
id=PLOT3D(a,b)
id=IMAGE(a,b)
id=CONTOUR(a,b)
id=SURFACE(a,b)
id=MAP(a)
id=VECTOR(a,b)
id=STREAMLINE(a,b)
id=WINDOW()
id=WIDGET_WINDOW(a)

id=ARROW(a,b)
id=SYMBOL(a,b)

id=MAPGRID()
MAP_CONTINENTS
id=LEGEND()
id=COLORBAR()
id=TEXT(a,b)
id=POLYGON(a,b)
id=POLYLINE(a,b)
id=AXIS(a)
id=ELLIPSE(a,b)
id=GETWINDOWS(a)

id=BOXPLOT(a,b)         ; Seen in 8.3
id=BUBBLEPLOT(a,b)      ; ""
id=SCATTERPLOT(a,b)     ; ""
id=SCATTERPLOT3D(a,b,c) ; ""
id=volume(a)            ; ""

end

pro live_plotIds_event, ev
;+
;** ************
;** Event handler for the modal dialog helping for the multiplot process layout
;-
common c_live_multi, ID_layout ; for multiplot layout (8.0 graphics)

widget_control,ev.id, get_uvalue=uv

if n_elements(uv) eq 0 then return
if not obj_valid(ID_layout.ID) then widget_control,ev.top,/destroy ; Multiplot Window is dead!
if (uv[0] eq 2L)               then widget_control,ev.top,/destroy ; Plot in a separate Window

if (uv[0] eq 1L) then begin                                        ; Insert a new plot
  widget_control,uv[1], get_value=nCol ; Get Layout
  widget_control,uv[2], get_value=nRow
  widget_control,uv[3], get_value=pCol ; Get position
  widget_control,uv[4], get_value=pRow

 ;Verify layout input numeric texts
  on_ioerror,mis_nCol & ok=0 & nCol = long(nCol[0]) & ok=1 & mis_nCol: & mess='?->Invalid number of Columns [1-25] !!!'
  if ok then if (nCol lt 1) or (nCol gt 25) then ok=0
  if not ok then begin & widget_control,uv[5], set_value=mess & return & endif
  on_ioerror,mis_nRow & ok=0 & nRow = long(nRow[0]) & ok=1 & mis_nRow: & mess='?->Invalid number of Rows [1-25] !!!'
  if ok then if (nRow lt 1) or (nRow gt 25) then ok=0
  if not ok then begin & widget_control,uv[5], set_value=mess & return & endif

 ;Verify position input numeric texts
  on_ioerror,mis_pCol & ok=0 & pCol = long(pCol[0]) & ok=1 & mis_pCol: & mess='?->Invalid Column position [1-nCol] !!!'
  if ok then if (pCol lt 1) or (pCol gt 25) then ok=0
  if not ok then begin & widget_control,uv[5], set_value=mess & return & endif
  on_ioerror,mis_pRow & ok=0 & pRow = long(pRow[0]) & ok=1 & mis_pRow: & mess='?->Invalid Row position [1-nRow] !!!'
  if ok then if (pRow lt 1) or (pRow gt 25) then ok=0
  if not ok then begin & widget_control,uv[5], set_value=mess & return & endif
  
 ;Verify position inside layout
  if pCol gt nCol then begin & widget_control,uv[5], set_value='?->Column position > number of Columns !!!' & return & endif
  if pRow gt nRow then begin & widget_control,uv[5], set_value='?->Row position > number of Rows !!!'       & return & endif
  
  ID_layout.layout = [nCol , nRow , (pRow-1)*nCol+PCol]
  ID_layout.insert = 1 ; *** Accepted ***
  widget_control,ev.top,/destroy
endif

end

pro live_plotIds, Odx, O, multiplot=multiplot
;+
;** ************
;** keep object ID of last beside graphic function
;** handle also the multiplot layout
;-
@lamp.cbk                      ; for Opid
common c_live_multi, ID_layout ; for multiplot layout (8.0 graphics)

if n_elements(Opid)      le 1 then Opid=objarr(lamp_sys+3+1)                          ;defined in lamp.cbk
if n_elements(ID_layout) eq 0 then ID_layout = {ID:obj_new(),layout:[1,1,1],insert:0} ;global structure for layout
okM = obj_valid(ID_layout.ID) & if not okM then ID_layout.ID=obj_new()
ID_layout.insert=0

if not keyword_set(multiplot) then begin ; Beside window object ID, or include next plot in the layout

  if arg_present(O) then Opid[Odx]=O $
  else begin & Odx=0
  
       while (obj_valid(Opid[Odx]) and (Odx lt n_elements(Opid)-1)) do Odx += 1
       if okM then begin
         if !version.release ge '8.1' then ii=execute("ID_layout.ID.window.show")
         if xregistered('live_plotIds_dialog') eq 0 then begin ;Ask the User if he wants to insert the plot (MODAL)
            L123  = ' '+strtrim(ID_layout.layout,2)+' '
            bas0  = widget_base( title='Multiplot Dialog', group_leader=lamp_b1, event_pro='live_plotIds_event',/MODAL,/column)
             bid  = widget_label( bas0 , value='A MULTIPLOT WINDOW IS CURRENTLY DEFINED.'  , font=ft_b_normal)
             bid  = widget_label( bas0 , value='(Plots are repositionnable and resizable)' , font=ft_b_normal)
            brow1 = widget_base(  bas0 ,/row, /align_center)
             bid  = widget_label( brow1, value='Adaptable Layout: nColumns='     , font=ft_b_normal)
             bL1  = widget_text(  brow1, value=L123[0] ,Xsize=3                  , font=ft_propor, /editable)
             bid  = widget_label( brow1, value='nRows='                          , font=ft_b_normal)
             bL2  = widget_text(  brow1, value=L123[1] ,Xsize=3                  , font=ft_propor, /editable)
             bid  = widget_label( bas0 , value=' '                               , font=ft_b_normal)
             brow2 = widget_base( bas0 , /row ,/frame)
             bid  = widget_label( brow2, value='At Column'                       , font=ft_b_normal)
             bL1c = widget_text(  brow2, value='   ' ,Xsize=3                    , font=ft_propor, /editable)
             bid  = widget_label( brow2, value='and Row'                         , font=ft_b_normal)
             bL2c = widget_text(  brow2, value='   ' ,Xsize=3                    , font=ft_propor, /editable)
             but1 = widget_button(brow2, value='-> INSERT YOUR PLOT'             , font=ft_b_normal)
             but2 = widget_button(bas0 , value='-> OR PLOT IN A SEPARATE WINDOW' , font=ft_b_normal)
             bid  = widget_label( bas0 , value=' '                               , font=ft_b_normal)
             blab = widget_label( bas0 , value='Remove the Multiplot Window to hide this Dialog', font=ft_b_normal)
            widget_control,but1,set_uvalue=[1L,bL1,bL2,bL1c,bL2c,blab]
            widget_control,but2,set_uvalue=[2L]
            widget_control,bas0,/REALIZE
           ;xmanager, 'live_plotIds_dialog', bas0, event_handler='live_plotIds_event', /just_reg, /no_block
            EV   = widget_event( bas0 ,BAD_ID=bad_id)
            while bad_id eq 0 do begin
              live_plotIds_event, EV
              EV = widget_event( bas0 ,BAD_ID=bad_id)
            endwhile
            
         endif else begin
         endelse
       endif
  endelse
  
endif else begin                         ; Init a Multi Plot Layout Window
  if not okM then begin
     if !version.os eq 'darwin'   then render=1 else render=0                ;bug MacOs/Xquarz
     if !version.release lt '8.2' then render=0
     sne = strtrim(n_elements(Opid)-1,2)
     if render eq 1 then ID_layout.ID = window(/widget,window_title='Opid['+sne+']->Lamp Multiplot',renderer=render) $
                    else ID_layout.ID = window(/widget,window_title='Opid['+sne+']->Lamp Multiplot')
     Opid[sne] = ID_layout.ID
  endif else lamp_message,'Lamp Multiplot is already created'
  if !version.release ge '8.1' then ii=execute("ID_layout.ID.window.show")
endelse
end

pro live_bug64, ev
;+
;** **********
;** handle a bug of live Itools at first call
;-
@lamp.cbk
CATCH,stat & if stat ne 0 then return
if n_elements(ev) eq 0 then widget_control,l_message,bad_id=ii,TIMER=.2,event_pro='live_bug64' $
else begin &                  widget_control,l_message,bad_id=ii,TIMER=.0,event_pro=''
                            if !version.release lt 7.1 then IT='IT' else IT='I'
                            Ntool=call_function(IT+'GETCURRENT') ;,TOOL =ident)
                           ;print,ntool
                            if  strpos(Ntool,'PLOT') ge 0 then $
                            if (strpos(Ntool,'_') lt 0) or (strpos(Ntool,'_1') gt 0) then $
                                CALL_PROCEDURE,IT+'DELETE' & endelse
end
pro live_bug80
;+
;** **********
;** handle a bug of live Functions at first call
;-
    if sys_dep('VERSION') ge '8.0' then begin
        ii=execute('Pobj=plot(/test)')
        ii=execute('Pobj.close')
        widget_control,/hourglass
    endif
end

pro live_lamp_plot, liveT, xx,ww, xrange=bx, yrange=by, title=tit, error=ee, legende=legnd, xylW=xylW, okT=okT, Fidl8=Fidl8
;+
;** **************
;** vector plot object tool
;-
common here_tools,VV
common c_live_multi, ID_layout ; for multiplot layout (8.0 graphics)

if keyword_set(Fidl8) then Ftools=1 else Ftools=0 ;Use plot functions instead of Itools (8.0) when plot beside
if !version.release ge '8.0'        then Ftools=1 ;idem when anotation tools

Vfirst=1 & if strpos(VV,'first') eq 0 then VV=strmid(VV,5,200) else Vfirst=0 ;bug first plot whith itools
if Ftools and Vfirst then live_bug80
okT   =1
if !version.os eq 'darwin'   then render=1 else render=0                     ;bug MacOs/Xquarz
if !version.release lt '8.2' then render=0

Vs=!version.release
if (VV eq 'No') then begin & print,'...Itools not supported...' & RETURN & endif
if (VV ne ' ') and (VV ne '?') and (VV ne '!') then begin & P_RESTORE,VV ,cnt & if cnt eq 0 then VV='?' else VV=' ' & endif
if (VV eq '?') then Vs=5.4
if (VV eq '!') then Vs=5.9
if !D.N_colors gt 256 then idx_c=0 else idx_c=1
if n_elements(tit) ne 1 then tit=''
if tit le ' ' then tit='Plot: double click on objects to change properties'

cd,current=mee & kpath=!path
if Vs lt 7.1 then IT='IT' else IT='I'
if Vs lt 5.9 then begin & p=widget_base(title=tit,/tlb_size_events) & widget_control,p,/realize
                  xmanager,'live_plot',p,event_handler='live_lamp_event',/just_reg & call_procedure,'live_load' & endif
                 ;CALL_PROCEDURE,'fw_load_generic'
X=xx
W=ww
tfs=9.
eok=1
if (n_elements(ee) ne n_elements(w)*2) and  $
   (n_elements(ee) ne n_elements(w))   then begin & Lstyl=0 & Sidx=0 & eok=0
endif                                  else begin & Lstyl=6 & Sidx=5 & ee2=ee & endelse
z=size(X) & if z[0] eq 2 then kx=(z[2]-1)<24 else kx=0
z=size(W) & if z[0] eq 2 then k =(z[2]-1)<24 else k =0

if n_elements(bx) ne 2 then begin & mini=min(x ,max=maxi) & bx=[mini,maxi]
endif  else  if k eq 0 then begin & id=where((x ge bx[0]) and (x le bx[1]))
                                  if eok then if(n_elements(ee2) eq n_elements(w)*2) then ee2=ee2[*,id] $
                                                                                     else ee2=ee2[id,*]
                                  X=X[id] & w=w[id,*] & endif

if n_elements(by) ne 2 then begin & mini=min(w ,max=maxi) & by=[mini,maxi] & endif

if n_elements(xylW) lt 3 then xylW=[0,0,0]
Qlog  =xylW[0]
Ilog  =xylW[1]
Linear=xylW[2]
Tlog  =Qlog*Ilog

if Qlog then bx=bx>0.
if Ilog then by=by>0.

Fsymb=(['None','+','*','dot','D','tu','s','X','o','',''])[Sidx]

if k eq 0 then begin ; ONE PLOT
   if Vs eq 5.9 then       CALL_PROCEDURE,'LIVE_PLOT', W  , independent=X, xrange=bx, yrange=by, indexed_color=idx_c, error=bidon, title=tit else $
   if Vs lt 6.0 then begin & CALL_PROCEDURE,'LIVE_PLOT', W  , independent=X, xrange=bx, yrange=by, indexed_color=idx_c, error=bidon, parent=p, reference_out=ref
                           widget_control,bad_id=ii ,p ,tlb_get_size=v2
                           widget_control,bad_id=ii ,p ,set_uvalue={win:ref.win,v2:v2}
   endif        else begin
                iok=0
                if eok then if total(ee2) gt 0. then iok=1

                if not Ftools then begin ;Itools
                           if Vfirst then begin & okT=0 & live_bug64 & CALL_PROCEDURE,'IPLOT',identifier=fdmage ,/no_saveprompt ;Just for nothing!
                                                             Ntool=call_function(IT+'GETCURRENT')
                                                             if Ntool gt ' ' then CALL_PROCEDURE,IT+'DELETE' & okT=1 & endif

                           if Vs lt 6.2 then $
                           CALL_PROCEDURE,'IPLOT'      ,   identifier=idmage, title=tit, /no_saveprompt  else $
                           if Vs lt 7.1 then $
                           CALL_PROCEDURE,'IPLOT'      ,   identifier=idmage, title=tit, /no_saveprompt, view_title=!p.title else $
                           CALL_PROCEDURE,'IPLOT'      ,   identifier=idmage, window_title=tit, /no_saveprompt, view_title=!p.title, renderer=render

                           if iok then $
                           CALL_PROCEDURE,'IPLOT'  ,X,W,   overplot=idmage, xtitle=!x.title,ytitle=!y.title, xrange=bx, yrange=by, $
                                                           xtickfont_size=tfs,ytickfont_size=tfs, Xlog=Qlog, Ylog=Ilog,   $
                                                           linestyle=Lstyl, sym_index=Sidx, yerror=ee2, /y_errorbars, errorbar_capsize=.05 else $
                           CALL_PROCEDURE,'IPLOT'  ,X,W,   overplot=idmage, xtitle=!x.title,ytitle=!y.title, xrange=bx, yrange=by, $
                                                           xtickfont_size=tfs,ytickfont_size=tfs,  Xlog=Qlog, Ylog=Ilog,  $
                                                           linestyle=Lstyl, sym_index=Sidx
                endif else begin ;Plot function
                      live_plotIds, Odx & tit='Opid['+strtrim(Odx,2)+']->'+tit
                      if ID_layout.insert then begin & multiID8 = ID_layout.ID & layout8 = ID_layout.layout & ID_layout.insert = 0 & endif ; Multi plot

                      if render eq 1 then begin ;bug MacOs/Xquarz
                        if iok then po=call_function( $
                         'ERRORPLOT', X,W,ee2, window_title=tit, title=!p.title, xtitle=!x.title, ytitle=!y.title, renderer=render, $
                                      current=multiID8, layout=layout8,  $
                                      xrange=bx, yrange=by, xtickfont_size=tfs, ytickfont_size=tfs, WIDGET=1, $
                                      Xlog=Qlog, Ylog=Ilog, linestyle=Lstyl, symbol=Fsymb, errorbar_capsize=.05)   $
                        else po=call_function( $
                         'PLOT'     , X,W,     window_title=tit, title=!p.title, xtitle=!x.title, ytitle=!y.title, renderer=render, $
                                      current=multiID8, layout=layout8,  $
                                      xrange=bx, yrange=by, xtickfont_size=tfs, ytickfont_size=tfs, WIDGET=1, $
                                      Xlog=Qlog, Ylog=Ilog, linestyle=Lstyl, symbol=Fsymb)
                      endif else begin
                        if iok then po=call_function( $
                         'ERRORPLOT', X,W,ee2, window_title=tit, title=!p.title, xtitle=!x.title, ytitle=!y.title, $
                                      current=multiID8, layout=layout8,  $
                                      xrange=bx, yrange=by, xtickfont_size=tfs, ytickfont_size=tfs, WIDGET=1, $
                                      Xlog=Qlog, Ylog=Ilog, linestyle=Lstyl, symbol=Fsymb, errorbar_capsize=.05)   $
                        else po=call_function( $
                         'PLOT'     , X,W,     window_title=tit, title=!p.title, xtitle=!x.title, ytitle=!y.title, $
                                      current=multiID8, layout=layout8,  $
                                      xrange=bx, yrange=by, xtickfont_size=tfs, ytickfont_size=tfs, WIDGET=1, $
                                      Xlog=Qlog, Ylog=Ilog, linestyle=Lstyl, symbol=Fsymb)
                      endelse
                      live_plotIds, Odx ,po
                endelse ;Plot function
   endelse ; Version ge '6.0'
   
endif else begin ; MULTIPLE PLOT
   s=''
   if Vs lt 6.0 then begin
     for i=0,k do s=s+',w[*,'+string(i)+']'
     if Vs eq 5.9 then res=execute('LIVE_PLOT'+s+', independent=X[*,i<kx], xrange=bx, yrange=by, indexed_color=idx_c, error=bidon, title=tit') $
     else        begin & res=execute('LIVE_PLOT'+s+', independent=X[*,i<kx], xrange=bx, yrange=by, indexed_color=idx_c, error=bidon, parent=p, reference_out=ref')
                           widget_control,bad_id=ii ,p ,tlb_get_size=v2
                           widget_control,bad_id=ii ,p ,set_uvalue={win:ref.win,v2:v2} & endelse
   endif else begin
     tvlct,r,g,b,/get
     BTlog = Tlog & BQlog = Qlog & BIlog = Ilog
     if (eok) then begin & Tlog=0 & Qlog=0 & Ilog=0 & endif ; BUG IDL !!!!!
     target= objarr(k+1)

     for i=0,k do begin
       Cidx =legnd.COL[i] & Cidx=[r[Cidx],g[Cidx],b[Cidx]]
       Lstyl=legnd.STY[i]
       Sidx =legnd.SYM[i] ;CARE LEGENDE 6.4 -> !!!!!!!!!!
       Fsymb=(['None','+','*','dot','D','tu','s','X','o','',''])[Sidx]
       Lnam =legnd.NAM[i]
       p    =legnd.NPT[i]-1

       iok=0
       if eok then if total(ee2[i*2,*]) gt 0. then iok=1
       Xcur=X[0:p,i<kx]
       Wcur=W[0:p,i]
       if iok then if n_elements(ee2) eq n_elements(W) then Ecur=ee2[0:p,i] $
                                                       else Ecur=ee2[i*2:i*2+1,0:p]
      ;Ftools=0 ; Test IPLOT or PLOT()
       if not Ftools then begin ;Itools
                        if i eq 0 then begin
                           if Vfirst then begin & okT=0 & live_bug64 & CALL_PROCEDURE,'IPLOT',identifier=fdmage ,/no_saveprompt ;Just for nothing!
                                                             Ntool=call_function(IT+'GETCURRENT')
                                                             if Ntool gt ' ' then CALL_PROCEDURE,IT+'DELETE' & okT=1 & endif

                           if Vs lt 6.2 then $
                           CALL_PROCEDURE,'IPLOT'      ,   identifier=idmage, title=tit, /no_saveprompt  else $
                           if Vs lt 7.1 then $
                           CALL_PROCEDURE,'IPLOT'      ,   identifier=idmage, title=tit, /no_saveprompt, view_title=!p.title else $
                           CALL_PROCEDURE,'IPLOT'      ,   identifier=idmage, window_title=tit, /no_saveprompt, view_title=!p.title, renderer=render
                        endif

                           IF Vs GE 6.4 THEN BEGIN

                             if iok then $
                             CALL_PROCEDURE,'IPLOT' ,Xcur,Wcur,overplot=idmage, xtitle=!x.title,ytitle=!y.title, xrange=bx, yrange=by,  $
                                                             xtickfont_size=tfs,ytickfont_size=tfs, name=Lnam, color=Cidx,   $
                                                             sym_color=Cidx, errorbar_color=Cidx, /insert_legend, Xlog=Qlog, Ylog=Ilog, $
                                                             linestyle=Lstyl, sym_index=Sidx, yerror=Ecur, /y_errorbars, errorbar_capsize=.05 else $
                             CALL_PROCEDURE,'IPLOT' ,Xcur,Wcur,overplot=idmage, xtitle=!x.title,ytitle=!y.title, xrange=bx, yrange=by,  $
                                                             xtickfont_size=tfs,ytickfont_size=tfs, name=Lnam, color=Cidx,   $
                                                             sym_color=Cidx,                      /insert_legend, Xlog=Qlog, Ylog=Ilog, $
                                                             linestyle=Lstyl, sym_index=Sidx
                           ENDIF ELSE BEGIN ;Vs LE 6.3
                            if iok then $
                             CALL_PROCEDURE,'IPLOT' ,Xcur,Wcur,overplot=idmage, xtitle=!x.title,ytitle=!y.title, xrange=bx, yrange=by, $
                                                             xtickfont_size=tfs,ytickfont_size=tfs, name=Lnam, color=Cidx,$
                                                             sym_color=Cidx, errorbar_color=Cidx, $
                                                             linestyle=Lstyl, sym_index=Sidx, yerror=Ecur, /y_errorbars, errorbar_capsize=.05 else $
                             CALL_PROCEDURE,'IPLOT' ,Xcur,Wcur,overplot=idmage, xtitle=!x.title,ytitle=!y.title, xrange=bx, yrange=by, $
                                                             xtickfont_size=tfs,ytickfont_size=tfs, name=Lnam, color=Cidx,$
                                                             sym_color=Cidx, $
                                                             linestyle=Lstyl, sym_index=Sidx
                           ENDELSE

       endif else begin ;Plot function
             if i eq 0 then begin
                      live_plotIds, Odx & tit='Opid['+strtrim(Odx,2)+']->'+tit
                      if ID_layout.insert then begin & multiID8 = ID_layout.ID & layout8 = ID_layout.layout & ID_layout.insert = 0 & endif ; Multi plot

                      if render eq 1 then begin ;bug MacOs/Xquarz
                        if iok then po=call_function( $
                         'ERRORPLOT', Xcur,Wcur,Ecur, window_title=tit, title=!p.title, xtitle=!x.title, ytitle=!y.title, renderer=render, $
                                      current=multiID8, layout=layout8,  $
                                      xrange=bx, yrange=by, xtickfont_size=tfs, ytickfont_size=tfs, WIDGET=1, $
                                      name=Lnam, color=Cidx, sym_color=Cidx, errorbar_color=Cidx, $
                                      Xlog=BQlog, Ylog=BIlog, linestyle=Lstyl, symbol=Fsymb, errorbar_capsize=.05)   $
                        else po=call_function( $
                         'PLOT'     , Xcur,Wcur,      window_title=tit, title=!p.title, xtitle=!x.title, ytitle=!y.title, renderer=render, $
                                      current=multiID8, layout=layout8,  $
                                      xrange=bx, yrange=by, xtickfont_size=tfs, ytickfont_size=tfs, WIDGET=1, $
                                      name=Lnam, color=Cidx, sym_color=Cidx, $
                                      Xlog=BQlog, Ylog=BIlog, linestyle=Lstyl, symbol=Fsymb)
                      endif else begin
                        if iok then po=call_function( $
                         'ERRORPLOT', Xcur,Wcur,Ecur, window_title=tit, title=!p.title, xtitle=!x.title, ytitle=!y.title, $
                                      current=multiID8, layout=layout8,  $
                                      xrange=bx, yrange=by, xtickfont_size=tfs, ytickfont_size=tfs, WIDGET=1, $
                                      name=Lnam, color=Cidx, sym_color=Cidx, errorbar_color=Cidx, $
                                      Xlog=BQlog, Ylog=BIlog, linestyle=Lstyl, symbol=Fsymb, errorbar_capsize=.05)   $
                        else po=call_function( $
                         'PLOT'     , Xcur,Wcur,      window_title=tit, title=!p.title, xtitle=!x.title, ytitle=!y.title, $
                                      current=multiID8, layout=layout8,  $
                                      xrange=bx, yrange=by, xtickfont_size=tfs, ytickfont_size=tfs, WIDGET=1, $
                                      name=Lnam, color=Cidx, sym_color=Cidx, $
                                      Xlog=BQlog, Ylog=BIlog, linestyle=Lstyl, symbol=Fsymb)
                      endelse
                      live_plotIds, Odx ,po
                      target[0] = po
             endif else begin
                        if iok then pop=call_function( $
                         'ERRORPLOT', Xcur,Wcur,Ecur, overplot=1, $
                                      name=Lnam, color=Cidx, sym_color=Cidx, errorbar_color=Cidx, $
                                      linestyle=Lstyl, symbol=Fsymb, errorbar_capsize=.05)   $
                        else pop=call_function( $
                         'PLOT'     , Xcur,Wcur,      overplot=1, $
                                      name=Lnam, color=Cidx, sym_color=Cidx, $
                                      linestyle=Lstyl, symbol=Fsymb)
                        target[i] = pop
             endelse ; i > 0
             po.window_title=tit ; Be sure having wanted title
       endelse ; Ftools plot function
     endfor
     
     if not Ftools then begin ;Itools bug Log plot
        bugx=[bx[1],bx[1]] & bugy=[by[1],by[1]]
        if BTlog then CALL_PROCEDURE,'IPLOT' ,bugx,bugy,overplot=idmage,/hide,/Xlog,/Ylog else $
        if BQlog then CALL_PROCEDURE,'IPLOT' ,bugx,bugy,overplot=idmage,/hide,/Xlog       else $
        if BIlog then CALL_PROCEDURE,'IPLOT' ,bugx,bugy,overplot=idmage,/hide,/Ylog
     endif else begin
        Oleg = call_function('LEGEND' , target=target )
     endelse
   endelse ; Version ge '6.0'
endelse    ; Multiple plot
cd,mee & !path=kpath
end

pro live_lamp_img, liveT, w,xx,yy, xstyle=xs,ystyle=ys,zstyle=zs, xrange=bx, yrange=by, title=tit, bst_xy=bst_xy, bst_ixy=bst_ixy,$
                                   xticks=xm,yticks=ym,xtickv=xv, ytickv=yv, xtickname=xn, ytickname=yn, okT=okT, Fidl8=Fidl8, Palette=palette
;+
;** *************
;** image plot object tool
;-
common here_tools,VV
common c_live_multi, ID_layout ; for multiplot layout (8.0 graphics)

if keyword_set(Fidl8) then Ftools=1 else Ftools=0 ;Use plot functions instead of Itools (8.0) when plot beside
if !version.release ge '8.0'        then Ftools=1 ;idem when anotation tools

Vfirst=1 & if strpos(VV,'first') eq 0 then VV=strmid(VV,5,200) else Vfirst=0 ;bug first plot whith itools
if Ftools and Vfirst then live_bug80
okT   =1
if !version.os eq 'darwin'   then render=1 else render=0                     ;bug MacOs/Xquarz
if !version.release lt '8.2' then render=0

Vs=!version.release
if (VV eq 'No') then begin & print,'...Itools not supported...' & RETURN & endif
if (VV ne ' ') and (VV ne '?') and (VV ne '!') then begin & P_RESTORE,VV ,cnt & if cnt eq 0 then VV='?' else VV=' ' & endif
if (VV eq '?') then Vs=5.4
if (VV eq '!') then Vs=5.9
if n_elements(tit) ne 1 then tit=''
if tit le ' ' then tit='Image: double click on objects to change properties'
cd,current=mee & kpath=!path
if Vs lt 7.1 then IT='IT' else IT='I'
if Vs lt 5.9 then begin & p=widget_base(title=tit,/tlb_size_events) & widget_control,p,/realize
                  xmanager,'live_image',p,event_handler='live_lamp_event',/just_reg & call_procedure,'live_load' & endif
                 ;CALL_PROCEDURE,'fw_load_generic'
;Handle colors
if (size(palette))[1] eq 3 then begin
  r=reform(palette[0,*]) & g=reform(palette[1,*]) & b=reform(palette[2,*])
endif else tvlct,r,g,b,/get

if n_elements(xs) ne 1 then xs=1
tfs=9.
Xmj=6 & Ymj=6

siz=size(W)
if siz[0] eq 3 then siz = siz[ [0,where(siz[1:3] gt 4)+1] ] ;Case true color , alpha channels

if n_elements(xx) eq 0 then if n_elements(bx) eq 0 then begin
                                       xx =  findgen(siz[1])+1
                                       bx = [1,siz[1]]
                            endif else begin & xx = (findgen(siz[1])/(siz[1]-1.))*(bx[1]-bx[0])+bx[0]  ;assume regular
                                               if n_elements(xn) gt 0 then bid = temporary(xn) & endelse
if n_elements(yy) eq 0 then if n_elements(by) eq 0 then begin
                                       yy =  findgen(siz[2])+1
                                       by = [1,siz[2]]
                            endif else begin & yy = (findgen(siz[2])/(siz[2]-1.))*(by[1]-by[0])+by[0]  ;assume regular
                                               if n_elements(yn) gt 0 then bid = temporary(yn) & endelse

if n_elements(xn) gt 1 then xv =float(xn)      & if n_elements(yn) gt 1 then yv =float(yn)
if n_elements(xv) gt 1 then Xmj=n_elements(xv) & if n_elements(yv) gt 1 then Ymj=n_elements(yv)

if Vs eq 5.9 then       CALL_PROCEDURE,'LIVE_IMAGE', w, error=bidon, title=tit else $
if Vs lt 6.0 then begin & CALL_PROCEDURE,'LIVE_IMAGE', w, error=bidon, parent=p, reference_out=ref
                        widget_control,bad_id=ii ,p ,tlb_get_size=v2
                        widget_control,bad_id=ii ,p ,set_uvalue={win:ref.win,v2:v2}
endif        else begin
      if xs eq 5 then axe_st=0 else axe_st=1
      ;Ftools=0 ; Test IIMAGE or IMAGE()
       if not Ftools then begin ; Itools
                        if Vfirst then begin & okT=0 & live_bug64 & CALL_PROCEDURE,'IPLOT',identifier=fdmage ,/no_saveprompt ;Just for nothing!
                                               Ntool=call_function(IT+'GETCURRENT')
                                               if Ntool gt ' ' then CALL_PROCEDURE,IT+'DELETE' & okT=1 & endif

                        if Vs lt 6.2 then $
                        CALL_PROCEDURE,'IIMAGE'    ,  identifier=idmage, title=tit, /no_saveprompt  else $
                        if Vs lt 7.1 then $
                        CALL_PROCEDURE,'IIMAGE'    ,  identifier=idmage, title=tit, /no_saveprompt, view_title=!p.title else $
                        CALL_PROCEDURE,'IIMAGE'    ,  identifier=idmage, window_title=tit, /no_saveprompt, view_title=!p.title, renderer=render

                        if xs eq 5 then $ ;No Axes
                        CALL_PROCEDURE,'IIMAGE'    , w      , overplot=idmage,xtitle=!x.title,ytitle=!y.title, rgb_table=[[r],[g],[b]] $
                        else if Vs lt 8.1 then $
                        CALL_PROCEDURE,'IIMAGE'    , w,xx,yy, overplot=idmage,xtitle=!x.title,ytitle=!y.title, rgb_table=[[r],[g],[b]] $
                                                      ,xmajor=Xmj,ymajor=Ymj,xtickname=xn,ytickname=yn   $ ;,ytickvalues=yv
                                                      ,xtickfont_size=tfs,ytickfont_size=tfs ,xrange=bx, yrange=by $
                        else $
                        CALL_PROCEDURE,'IIMAGE'    , w,xx,yy, overplot=idmage,xtitle=!x.title,ytitle=!y.title, rgb_table=[[r],[g],[b]] $
                                                      ,xmajor=Xmj,ymajor=Ymj,xtickname=xn,ytickname=yn   $ ;,ytickvalues=yv
                                                      ,xtickfont_size=tfs,ytickfont_size=tfs ,xrange=bx, yrange=by, axis_style=1, aspect_ratio=0
       endif else begin ; image function
                      live_plotIds, Odx & tit='Opid['+strtrim(Odx,2)+']->'+tit
                      if ID_layout.insert then begin & multiID8 = ID_layout.ID & layout8 = ID_layout.layout & ID_layout.insert = 0 & endif ; Multi plot

                      if render eq 1 then begin ;bug MacOs/Xquarz
                           po = call_function('IMAGE'    , w,xx,yy, window_title=tit, title=!p.title, renderer=render $
                                                                  , current=multiID8, layout=layout8  $
                                                                  , xtitle=!x.title,ytitle=!y.title, rgb_table=[[r],[g],[b]] ,/widget $
                                                                  , xmajor=Xmj,ymajor=Ymj,xtickname=xn,ytickname=yn, aspect_ratio=0   $ ;,xtickvalues=xv
                                                                  , xtickfont_size=tfs,ytickfont_size=tfs ,xrange=bx, yrange=by, axis_style=axe_st)
                      endif else begin
                           po = call_function('IMAGE'    , w,xx,yy, window_title=tit, title=!p.title  $
                                                                  , current=multiID8, layout=layout8  $
                                                                  , xtitle=!x.title,ytitle=!y.title, rgb_table=[[r],[g],[b]] ,/widget $
                                                                  , xmajor=Xmj,ymajor=Ymj,xtickname=xn,ytickname=yn, aspect_ratio=0   $ ;,ytickvalues=yv
                                                                  , xtickfont_size=tfs,ytickfont_size=tfs ,xrange=bx, yrange=by, axis_style=axe_st)
                      endelse
                      if Vs ge '8.2.2' then begin
                        minD  = .15 ;Must resize too small images ...
                        xypos = po.position
                        xdim  = xypos[2] - xypos[0]
                        ydim  = xypos[3] - xypos[1]
                        if xdim lt minD then begin & scal = (minD-xdim)/2.
                           xypos[0]=xypos[0]-scal  & xypos[2]=xypos[2]+scal & po.position = xypos & endif
                          
                        if ydim lt minD then begin & scal = (minD-ydim)/2.
                           xypos[1]=xypos[1]-scal  & xypos[3]=xypos[3]+scal & po.position = xypos & endif
                      endif
                      pc = CALL_FUNCTION('COLORBAR' , target=po, orientation=1, textpos=1, font_size=tfs)

                      live_plotIds, Odx ,po
       endelse ; Ftools plot function
endelse ; version ge "6.0"
cd,mee & !path=kpath
end

pro live_lamp_surf, liveT, w,xx,yy, xstyle=xs,ystyle=ys,zstyle=zs, xrange=bx, yrange=by, title=tit, bst_xy=bst_xy, bst_ixy=bst_ixy,$
                                    xticks=xm,yticks=ym,xtickv=xv, ytickv=yv, xtickname=xn, ytickname=yn, $
                                    ax=rx,az=rz ,rrr=rrr, style=styles, n_levels=nlv, texture=W4d, okT=okT, Fidl8=Fidl8
;+
;** **************
;** surface plot object tool
;** rrr=1 image+surface         rrr=2 image  +contour
;** rrr=3 image+surface+contour rrr=4 surface+contour
;** rrr=5 contour               rrr=6 surface
;** rrr=7 vrml
;** style 4:mesh 5:lego 6:vectors else:shade
;-
common here_tools,VV
common c_live_multi, ID_layout ; for multiplot layout (8.0 graphics)

if keyword_set(Fidl8) then Ftools=1 else Ftools=0 ;Use plot functions instead of Itools (8.0) when plot beside
if !version.release ge '8.0'        then Ftools=1 ;idem when anotation tools

Vfirst=1 & if strpos(VV,'first') eq 0 then VV=strmid(VV,5,200) else Vfirst=0 ;bug first plot whith itools
if Ftools and Vfirst then live_bug80
okT   =1
if !version.os eq 'darwin'   then render=1 else render=0                     ;bug MacOs/Xquarz
if !version.release lt '8.2' then render=0

Vs=!version.release
if (VV eq 'No') then begin & print,'...Itools not supported...' & RETURN & endif
if (VV ne ' ') and (VV ne '?') and (VV ne '!') then begin & P_RESTORE,VV ,cnt & if cnt eq 0 then VV='?' else VV=' ' & endif
if (VV eq '?') then Vs=5.4
if (VV eq '!') then Vs=5.9
if !D.N_colors gt 256 then idx_c=0 else idx_c=1
if n_elements(tit) ne 1 then tit=''
if tit le ' ' then tit='Contour: double click on objects to change properties'
cd,current=mee & kpath=!path

if n_elements(nlv) eq 1 then if nlv gt 1 then rgb_i = findgen(nlv)/(nlv-1)*254
if Vs  lt 7.1 then IT='IT' else IT='I'
if Vs  lt 5.9 then begin & p=widget_base(title=tit,/tlb_size_events) & widget_control,p,/realize
                   xmanager,'live_contour',p,event_handler='live_lamp_event',/just_reg & call_procedure,'live_load' & endif
                  ;CALL_PROCEDURE,'fw_load_generic'

tvlct,r,g,b,/get
if n_elements(xs) ne 1 then xs=1
tfs=9.
siz=size(W)
Xmj=-1 & Ymj=-1

if n_elements(xx) eq 0 then begin & xx = findgen(siz[1])+1 ;& xx = (findgen(siz[1])/(siz[1]-1.))*(bx[1]-bx[0])+bx[0]
                                    bx = [1,siz[1]] & endif
if n_elements(yy) eq 0 then begin & yy = findgen(siz[2])+1 ;& yy = (findgen(siz[2])/(siz[2]-1.))*(by[1]-by[0])+by[0]
                                    by = [1,siz[2]] & endif
if n_elements(xn) gt 1 then xv =float(xn)      & if n_elements(yn) gt 1 then yv =float(yn)
if n_elements(xv) gt 1 then Xmj=n_elements(xv) & if n_elements(yv) gt 1 then Ymj=n_elements(yv)

if (size(xx))[0] gt 1 then x=xx[*,0]         else x=xx
if (size(yy))[0] gt 1 then y=reform(yy[0,*]) else y=yy

if (rrr eq 2) or (rrr eq 5) then begin ;2=image+contour , 5=contour
                                       ;***************   *********
  if Vs eq 5.9 then         CALL_PROCEDURE,'LIVE_CONTOUR', w, Xindependent=X, Yindependent=Y, indexed_color=idx_c, error=bidon, title=tit else $
  if Vs lt 6.0 then begin & CALL_PROCEDURE,'LIVE_CONTOUR', w, Xindependent=X, Yindependent=Y, indexed_color=idx_c, error=bidon, parent=p, reference_out=ref
                          widget_control,bad_id=ii ,p ,tlb_get_size=v2
                          widget_control,bad_id=ii ,p ,set_uvalue={win:ref.win,v2:v2}
  endif        else begin
       if rrr eq 2 then Fill=1   else Fill=0
       if xs  eq 5 then axe_st=0 else axe_st=1
      ;Ftools=0 ; Test ICONTOUR or CONTOUR()
       if not Ftools then begin ; Itools
                          if Vfirst then begin & okT=0 & live_bug64 & CALL_PROCEDURE,'IPLOT',identifier=fdmage ,/no_saveprompt ;Just for nothing!
                                                             Ntool=call_function(IT+'GETCURRENT')
                                                             if Ntool gt ' ' then CALL_PROCEDURE,IT+'DELETE' & okT=1 & endif

                          if Vs lt 6.2 then $
                          CALL_PROCEDURE,'ICONTOUR'  ,  identifier=idmage, title=tit, /no_saveprompt  else $
                          if Vs lt 7.1 then $
                          CALL_PROCEDURE,'ICONTOUR'  ,  identifier=idmage, title=tit, /no_saveprompt, view_title=!p.title else $
                          CALL_PROCEDURE,'ICONTOUR'  ,  identifier=idmage, window_title=tit, /no_saveprompt, view_title=!p.title, renderer=render

                          if xs eq 5 then $ ;No Axes
                          CALL_PROCEDURE,'ICONTOUR'  , w      , overplot=idmage,xtitle=!x.title,ytitle=!y.title, rgb_table=[[r],[g],[b]], $
                                                       n_levels=nlv,Fill=Fill, c_label_show=0, rgb_indices=rgb_i  $
                          else $
                          CALL_PROCEDURE,'ICONTOUR'  , w,xx,yy, overplot=idmage,xtitle=!x.title,ytitle=!y.title, rgb_table=[[r],[g],[b]], $
                                                       xtickname=xn,ytickname=yn, $
                                                       n_levels=nlv,Fill=Fill, c_label_show=0, rgb_indices=rgb_i, $
                                                       xrange=bx, yrange=by, xtickfont_size=tfs,ytickfont_size=tfs
       endif else begin ; contour function
                      live_plotIds, Odx & tit='Opid['+strtrim(Odx,2)+']->'+tit
                      if ID_layout.insert then begin & multiID8 = ID_layout.ID & layout8 = ID_layout.layout & ID_layout.insert = 0 & endif ; Multi plot

                      if render eq 1 then begin ;bug MacOs/Xquarz
                          po=CALL_FUNCTION('CONTOUR' , window_title=tit, title=!p.title, /widget, renderer=render, $
                                                       current=multiID8, layout=layout8,  $
                                                       w,xx,yy, xtitle=!x.title,ytitle=!y.title, rgb_table=[[r],[g],[b]], $
                                                       xtickname=xn,ytickname=yn, $
                                                       n_levels=nlv,Fill=Fill, c_label_show=0, rgb_indices=rgb_i, axis_style=axe_st, $
                                                       xrange=bx, yrange=by, xtickfont_size=tfs,ytickfont_size=tfs)
                          pc=CALL_FUNCTION('COLORBAR', target=po, orientation=1)
                      endif else begin
                          po=CALL_FUNCTION('CONTOUR' , window_title=tit, title=!p.title, /widget, $
                                                       current=multiID8, layout=layout8,  $
                                                       w,xx,yy, xtitle=!x.title,ytitle=!y.title, rgb_table=[[r],[g],[b]], $
                                                       xtickname=xn,ytickname=yn, $
                                                       n_levels=nlv,Fill=Fill, c_label_show=0, rgb_indices=rgb_i, axis_style=axe_st, $
                                                       xrange=bx, yrange=by, xtickfont_size=tfs,ytickfont_size=tfs)
                          pc=CALL_FUNCTION('COLORBAR', target=po, orientation=1)
                      endelse
                      live_plotIds, Odx ,po
       endelse
  endelse
endif else begin ;rrr=1 image+surface , rrr=3 image+surface+contour , rrr=4 surface+contour
                 ;*******************   ***************************   *********************
  if Vs eq 5.9 then       CALL_PROCEDURE,'LIVE_SURFACE', w, Xindependent=X, Yindependent=Y, indexed_color=idx_c, error=bidon, title=tit else $
  if Vs lt 6.0 then begin & CALL_PROCEDURE,'LIVE_SURFACE', w, Xindependent=X, Yindependent=Y, indexed_color=idx_c, error=bidon, parent=p, reference_out=ref
                          widget_control,bad_id=ii ,p ,tlb_get_size=v2
                          widget_control,bad_id=ii ,p ,set_uvalue={win:ref.win,v2:v2}
  endif        else begin
       ;** style 4:mesh 5:lego 6:vectors else:shade
       Styl=2 & style=styles[0,0]
       if (rrr eq 1) then Styl=1 & if (rrr eq 3) then Styl=0 ;mesh or point
       if (rrr eq 6) then if style eq 4 then Styl=1 $        ;Mesh
       else if style eq 5 then Styl=6 $                      ;Logo
       else if style eq 6 then Styl=3 $                      ;Vector
       else if style eq 2 then Styl=2 $                      ;Textured from W10    (W4d)
       else if style eq 1 then Styl=2                        ;Textured from itself (W4d)
       if rrr eq 6 then if style ne 3 then $
          if n_elements(W4d) ne n_elements(w) then V_col = bytscl(w) ;for graphics function
       if xs  eq 5 then axe_st=0 else axe_st=1
      ;Ftools=0 ; Test ITOOLS or functions()
       if not Ftools then begin ; Itools
                          if Vfirst then begin & okT=0 & live_bug64 & CALL_PROCEDURE,'IPLOT',identifier=fdmage ,/no_saveprompt ;Just for nothing!
                                                             Ntool=call_function(IT+'GETCURRENT')
                                                             if Ntool gt ' ' then CALL_PROCEDURE,IT+'DELETE' & okT=1 & endif

                          if Vs lt 6.2 then $
                          CALL_PROCEDURE,'ISURFACE'  ,  identifier=idmage, title=tit, /no_saveprompt  else $
                          if Vs lt 7.1 then $
                          CALL_PROCEDURE,'ISURFACE'  ,  identifier=idmage, title=tit, /no_saveprompt, view_title=!p.title else $
                          CALL_PROCEDURE,'ISURFACE'  ,  identifier=idmage, window_title=tit, /no_saveprompt, view_title=!p.title, renderer=render

                          if xs eq 5 then $ ;No Axes
                          CALL_PROCEDURE,'ISURFACE'  , w      , overplot=idmage,xtitle=!x.title,ytitle=!y.title, rgb_table=[[r],[g],[b]], $
                                                       shading=1, vert_colors=V_col  $
                          else begin

                          CALL_PROCEDURE,'ISURFACE'  , w,xx,yy, overplot=idmage,xtitle=!x.title,ytitle=!y.title,ztitle=!z.title, rgb_table=[[r],[g],[b]],  $
                                                       xrange=bx, yrange=by, xtickname=xn,ytickname=yn,style=Styl,texture_image=W4d, $
                                                       shading=1, vert_colors=V_col,xtickfont_size=tfs,ytickfont_size=tfs,ztickfont_size=tfs
;                         if (rrr eq 6) then $ ; In case of irregular axis surface bug (should be suppressed)
;                         CALL_PROCEDURE,'ICONTOUR'  , w,xx,yy, overplot=idmage,xrange=bx, yrange=by, xtickname=xn,ytickname=yn, rgb_table=[[r],[g],[b]], $
;                                                       transparency=100, n_levels=2
                          if (rrr eq 1) or (rrr eq 3)  then $
                          CALL_PROCEDURE,'ICONTOUR'  , w,xx,yy, overplot=idmage,xrange=bx, yrange=by, xtickname=xn,ytickname=yn, rgb_table=[[r],[g],[b]], $
                                                       n_levels=nlv, Zvalue=min(w), c_label_show=0, rgb_indices=rgb_i, /fill
;Asks for interpolation!  CALL_PROCEDURE,'IIMAGE'    , w,xx,yy, overplot=idmage,xrange=bx, yrange=by, xtickname=xn,ytickname=yn, rgb_table=[[r],[g],[b]]

                          if (rrr eq 3)  then $
                          CALL_PROCEDURE,'ICONTOUR'  , w,xx,yy, overplot=idmage,xrange=bx, yrange=by, xtickname=xn,ytickname=yn, rgb_table=[[r],[g],[b]], $
                                                       n_levels=nlv, Zvalue=max(w), c_label_show=0, rgb_indices=rgb_i
                          if (rrr eq 4)  then $
                          CALL_PROCEDURE,'ICONTOUR'  , w,xx,yy, overplot=idmage,xrange=bx, yrange=by, xtickname=xn,ytickname=yn, rgb_table=[[r],[g],[b]], $
                                                       n_levels=nlv, Zvalue=min(w), c_label_show=0, rgb_indices=rgb_i
                          endelse
       endif else begin ; surface , contour , image functions
                      live_plotIds, Odx & tit='Opid['+strtrim(Odx,2)+']->'+tit
                      if ID_layout.insert then begin & multiID8 = ID_layout.ID & layout8 = ID_layout.layout & ID_layout.insert = 0 & endif ; Multi plot

                      if render eq 1 then begin ;bug MacOs/Xquarz
                          po =CALL_FUNCTION('SURFACE' , window_title=tit, title=!p.title, /widget, vert_colors=V_col, renderer=render, $
                                                        current=multiID8, layout=layout8,  $
                                                        w,xx,yy, xtitle=!x.title,ytitle=!y.title,ztitle=!z.title, rgb_table=[[r],[g],[b]],  $
                                                        xrange=bx, yrange=by, xtickname=xn,ytickname=yn,style=Styl,texture_image=W4d, $
                                                        shading=1,xtickfont_size=tfs,ytickfont_size=tfs,ztickfont_size=tfs, axis_style=axe_st)
                      endif else begin
                          po =CALL_FUNCTION('SURFACE' , window_title=tit, title=!p.title, /widget, vert_colors=V_col, $
                                                        current=multiID8, layout=layout8,  $
                                                        w,xx,yy, xtitle=!x.title,ytitle=!y.title,ztitle=!z.title, rgb_table=[[r],[g],[b]],  $
                                                        xrange=bx, yrange=by, xtickname=xn,ytickname=yn,style=Styl,texture_image=W4d, $
                                                        shading=1,xtickfont_size=tfs,ytickfont_size=tfs,ztickfont_size=tfs, axis_style=axe_st)
                      endelse
                      if (rrr eq 1) or (rrr eq 3)  then $
                        if !version.release lt '8.3' then $ limited for image interpolation
                          poo=CALL_FUNCTION('CONTOUR' , w,xx,yy, /overplot ,xrange=bx, yrange=by, xtickname=xn,ytickname=yn, rgb_table=[[r],[g],[b]], $
                                                        n_levels=nlv, Zvalue=min(w), c_label_show=0, rgb_indices=rgb_i, axis_style=axe_st, /fill)     $
                        else $
                          poo=CALL_FUNCTION('IMAGE'   , w,xx,yy, /overplot ,xrange=bx, yrange=by, xtickname=xn,ytickname=yn, rgb_table=[[r],[g],[b]], $
                                                        axis_style=axe_st, aspect_ratio=0)
                      if (rrr eq 3)  then $
                          poo=CALL_FUNCTION('CONTOUR' , w,xx,yy, /overplot ,xrange=bx, yrange=by, xtickname=xn,ytickname=yn, rgb_table=[[r],[g],[b]], $
                                                        n_levels=nlv, Zvalue=max(w), c_label_show=0, rgb_indices=rgb_i, axis_style=axe_st)
                      if (rrr eq 4)  then $
                          poo=CALL_FUNCTION('CONTOUR' , w,xx,yy, /overplot ,xrange=bx, yrange=by, xtickname=xn,ytickname=yn, rgb_table=[[r],[g],[b]], $
                                                        n_levels=nlv, Zvalue=(max(w,min=mini)+mini)/2., c_label_show=0, rgb_indices=rgb_i, axis_style=axe_st)
                      live_plotIds, Odx ,po
                      po.window_title=tit ; Be sure having wanted title
       endelse
  endelse
endelse
cd,mee & !path=kpath
end

pro live_lamp_cont, w,GROUP=group, TIT=tit, XTIT=xtit, YTIT=ytit, XX=xx, YY=yy ,WI=idn, Fidl8=Fidl8
;+
;** **************
;** contour plot object tool
;**
;-
    CALL_PROCEDURE,'livc_lamp', w,GROUP=group, TIT=tit, XTIT=xtit, YTIT=ytit, XX=xx, YY=yy ,WI=idn
end

pro live_lamp_vol , liveT, w, ax=rx,az=rz ,rrr=rrr, thresh=thresh, name=str, group=l_b1, $
                              XX=xx,YY=yy,ZZ=zz,title=tit,bst_xy=bst_xy, okT=okT, Fidl8=Fidl8
;+
;** **************
;** volume plot object tool
;**
;-
common here_tools,VV
common c_live_multi, ID_layout ; for multiplot layout (8.0 graphics)

if keyword_set(Fidl8) then Ftools=1 else Ftools=0 ;Use plot functions instead of Itools (8.0) when plot beside
if !version.release ge '8.0'        then Ftools=1 ;idem when anotation tools
if !version.release lt '8.4'        then Ftools=0 ;but not before 8.4
;Ftools=0 ;if Volume function is not achived...

Vfirst=1 & if strpos(VV,'first') eq 0 then VV=strmid(VV,5,200) else Vfirst=0 ;bug first plot whith itools
if Ftools and Vfirst then live_bug80
okT   =1
if !version.os eq 'darwin'   then render=1 else render=0                     ;bug MacOs/Xquarz
if !version.release lt '8.2' then render=0

Vs=!version.release
if n_elements(tit) ne 1 then tit=str
if tit le ' ' then tit='Volume: double click on objects to change properties'
tvlct,r,g,b,/get
tfs=9.
siz=size(W)
if n_elements(xx) ne siz[1] then xx=lindgen(siz[1])
if n_elements(yy) ne siz[2] then yy=lindgen(siz[2])
if n_elements(zz) ne siz[3] then zz=lindgen(siz[3])
xv=[xx[0],xx[round(siz[1]/4.)],xx[round(siz[1]/2.)],xx[round(siz[1]*3/4.)],xx[siz[1]-1]]
yv=[yy[0],yy[round(siz[2]/4.)],yy[round(siz[2]/2.)],yy[round(siz[2]*3/4.)],yy[siz[2]-1]]
zv=[zz[0],zz[round(siz[3]/4.)],zz[round(siz[3]/2.)],zz[round(siz[3]*3/4.)],zz[siz[3]-1]]

if Vs lt 7.1 then IT='IT' else IT='I'
if Vs lt 5.4 then pointr=ptr_new(w)
if Vs lt 5.4 then CALL_PROCEDURE,'slicer3' , pointr,data_names=str else $
if Vs lt 6.0 then CALL_PROCEDURE,'XVOLUME' ,bytscl(w) ,/interpolate, group=l_b1 $
else begin
      ;Ftools=0 ; Test IVOLUME or VOLUME()
       if not Ftools then begin ; Itools
                           if Vfirst then begin & okT=0 & live_bug64 & CALL_PROCEDURE,'IPLOT',identifier=fdmage ,/no_saveprompt ;Just for nothing!
                                                             Ntool=call_function(IT+'GETCURRENT')
                                                             if Ntool gt ' ' then CALL_PROCEDURE,IT+'DELETE' & okT=1 & endif

          if Vs lt 6.2 then $
          CALL_PROCEDURE,'IVOLUME'   ,  identifier=idmage, title=tit, /no_saveprompt  else $
          if Vs lt 7.1 then $
          CALL_PROCEDURE,'IVOLUME'   ,  identifier=idmage, title=tit, /no_saveprompt, view_title=!p.title else $
          CALL_PROCEDURE,'IVOLUME'   ,  identifier=idmage, window_title=tit, /no_saveprompt, view_title=!p.title, renderer=render

          CALL_PROCEDURE,'IVOLUME'   , w, overplot=idmage,xtitle=!x.title,ytitle=!y.title,ztitle=!z.title, rgb_table0=[[r],[g],[b]] $
                                                     ;,xtickvalues=xv,ytickvalues=yv,ztickvalues=zv $
                                                      ,xtickname=string(xv),ytickname=string(yv),ztickname=string(zv) $
                                                      ,xtickfont_size=tfs,ytickfont_size=tfs,ztickfont_size=tfs $
                                                      ,/interpolate ,opacity_table0=r*0+10 ,/auto_render
       endif else begin ; volume function
          live_plotIds, Odx & tit='Opid['+strtrim(Odx,2)+']->'+tit
          if ID_layout.insert then begin & multiID8 = ID_layout.ID & layout8 = ID_layout.layout & ID_layout.insert = 0 & endif ; Multi plot

            po=CALL_FUNCTION('VOLUME'   , w, window_title=tit, title=!p.title, /widget, renderer=render $
                                                      ,current=multiID8, layout=layout8  $
                                                      ,xtitle=!x.title,ytitle=!y.title,ztitle=!z.title, rgb_table0=[[r],[g],[b]] $
                                                     ;,xtickvalues=xv,ytickvalues=yv,ztickvalues=zv $
                                                      ,xtickname=string(xv),ytickname=string(yv),ztickname=string(zv) $
                                                      ,xtickfont_size=tfs,ytickfont_size=tfs,ztickfont_size=tfs $
                                                      ,/interpolate ,opacity_table0=r*0+10 ,/auto_render)
          live_plotIds, Odx ,po
       endelse
endelse
end

pro live_lamp_Iopen, typ, outDATA, group=l_b1
;+
;** **************
;** use of Iopen IDL routine
;-
if typ eq 1 then filt=['*.isv'] ;Itool saved file
if typ eq 2 then filt=['*.bmp','*.dcm','*.gif' , '*.jp2','*.j2k' ,'*.jpx' ,'*.jpg','*.jpeg', $
                       '*.pct','*.pict','*.png', '*.tif','*.tiff']
if typ eq 3 then filt=['*.txt'] ;Text file
if typ eq 4 then filt=['*.h5']  ;HDF5 file

if !version.release lt 7.1 then return

gpth=''
result=dialog_pickfile(get_path=gpth,filter=filt,dialog=l_b1,/read,resource_name='lamptouch')
if result ne '' then begin
   widget_control,/hourglass
   if typ eq 1 then begin & IOPEN,result, outDATA, palette
   endif
   if typ eq 2 then begin
     if (strpos(result,'.pct') ge 0) or (strpos(result,'.pict') ge 0) then begin
       read_pict,result, outDATA, r,g,b
       live_lamp_img, liveT, outDATA, Palette=transpose([[r],[g],[b]]), Title=file_basename(result)
     endif else $
     if !version.release lt '8.1' then IOPEN,result, outDATA, palette, /VISUALIZE $
     else begin
                                       IOPEN,result, outDATA, palette
                                       live_lamp_img, liveT, outDATA, Palette=palette, Title=file_basename(result)
     endelse
   endif
   if typ eq 3 then begin & tStruct = ASCII_TEMPLATE(result)
                            if n_tags(tStruct) gt 0 then $
                            IOPEN,result, outDATA, palette, TEMPLATE=tStruct
   endif
   if typ eq 4 then begin & IOPEN,result, outDATA, /SHOW_HARDLINKS
   endif
endif
end

pro live_lamp_Anim, w, TITLE=tit, GROUP=group, smoo=smoo, surf=did_repr, az=rz,ax=rx ,regul=regul, Fidl8=Fidl8
;+
;** **************
;** use of xinteranimate
;-
if keyword_set(Fidl8) then Ftools=1 else Ftools=0 ;Use plot functions instead of Itools (8.0)

surfc=0 & regul=0
if n_elements(smoo)     ne 1  then smoo=0
if n_elements(did_repr) gt 6  then begin & surfc=did_repr[2] & regul=did_repr[6]
    ;Care trap_current if surface mode !!!!!
endif
siz =size(w)  & sx=siz[1] & sy=siz[2] & nf=siz[3]
mini=min(w, max=maxi)
          winx=384       &   winy=384
          xi= winx/siz[1]    &   yi=winy/siz[2]
          if (xi eq 0) then xi= -(float(siz[1])/winx)
          if (yi eq 0) then yi= -(float(siz[2])/winy)
          if  xi le -1 then fx= -1./xi else fx=xi
          if  yi le -1 then fy= -1./yi else fy=yi

          fm=min([fx,fy])    & fx=fm & fy=fm

          xi= fix(siz[1]*fx) & yi= fix(siz[2]*fy)

          if xi/yi gt 4 then yi=xi/4 else if yi/xi gt 4 then xi=yi/4

          if winx lt xi then xi=winx   &  if winy lt yi then yi=winy

          ff=fix((float(xi)/sx)*(float(yi)/sy)/2)*smoo

;loadct,4,/silent
if xregistered('XInterAnimate') then Xinteranimate,/close

Xinteranimate,set=[xi,yi,nf], /cycle, mpeg_file="lamp.mpg", $
              /showload, /track, title=tit, BLOCK=0

ff=fix((float(xi)/sx)*(float(yi)/sy)/2)*smoo

for i=0,nf-1 do $
if (xi eq sx) and (yi eq sy) then $
     Xinteranimate, frame=i, image=bytscl(w[*,*,i], max=maxi, min=mini) $
else begin
     if ff lt 3 then $
     Xinteranimate, frame=i, image=bytscl(congrid(w[*,*,i],xi,yi), max=maxi, min=mini) else $
     Xinteranimate, frame=i, image=bytscl(smooth(congrid(w[*,*,i],xi,yi),ff<6), max=maxi, min=mini)
endelse

 Xinteranimate, GROUP=group
;Xinteranimate, RATE=50
end

pro did_ContextCreat, wDraw, oView, cntxtid
;+
;** ****************
;** create the context draw menue (mouse right click)
;-
   cntxtid=widget_base(  wDraw,/CONTEXT_MENU)
   bid    =widget_button(cntxtid,value='Copy image to ClipBoard'       ,EVENT_PRO = 'did_ContextEvent',uvalue={but:0 ,wDraw:wDraw,oView:oView})
   bid    =widget_button(cntxtid,value='Copy image to lamp.png'        ,EVENT_PRO = 'did_ContextEvent',uvalue={but:1 ,wDraw:wDraw,oView:oView})
   bid    =widget_button(cntxtid,value='Copy image to e-LogBook'       ,EVENT_PRO = 'did_ContextEvent',uvalue={but:3 ,wDraw:wDraw,oView:oView})
   bid    =widget_button(cntxtid,value='-----') & widget_control,bid,sensitive=0
   bid    =widget_button(cntxtid,value='Add your COMMENT to e-LogBook' ,EVENT_PRO = 'did_ContextEvent',uvalue={but:12,wDraw:wDraw,oView:oView})
   bid    =widget_button(cntxtid,value='Add a  txt file to e-LogBook'  ,EVENT_PRO = 'did_ContextEvent',uvalue={but:7 ,wDraw:wDraw,oView:oView})
   bid    =widget_button(cntxtid,value='Add an html file to e-LogBook' ,EVENT_PRO = 'did_ContextEvent',uvalue={but:5 ,wDraw:wDraw,oView:oView})
   bid    =widget_button(cntxtid,value='Add an image file to e-LogBook',EVENT_PRO = 'did_ContextEvent',uvalue={but:8 ,wDraw:wDraw,oView:oView})
   bid    =widget_button(cntxtid,value='-----') & widget_control,bid,sensitive=0
   bid    =widget_button(cntxtid,value='SHOW current e-LogBook'        ,EVENT_PRO = 'did_ContextEvent',uvalue={but:10,wDraw:wDraw,oView:oView})
   bid    =widget_button(cntxtid,value='Choose an e-LogBook path'      ,EVENT_PRO = 'did_ContextEvent',uvalue={but:9 ,wDraw:wDraw,oView:oView})
  ;bid    =widget_button(cntxtid,value='Move e-LogBook to http://barns.ill.eu' ,EVENT_PRO = 'did_ContextEvent',uvalue={but:11,wDraw:wDraw,oView:oView})
end
function did_ContextJou, wi
;+
;******* **************
;** context draw menue journaling
;**
;-
common c_lamp_his ;(lamp.cbk)
common c_cntxt, ebook, jou_idx, Bnote

if n_elements(wi) eq 1 then begin & hi='' & if (wi gt 0) and (wi lt n_elements(his)) then hi=his[wi]
                                  return, hi & endif
n=n_elements(jou_c)-1 & jou=''
if jou_idx lt n then begin & jou=jou_c[jou_idx+1:n]+'     '+jou_w[jou_idx+1:n] & jou_idx=n & endif
return,jou
end

pro did_ContextEvent, ev ,uv
;+
;** ****************
;** context draw menue events
;**
;-
common c_cntxt, ebook, jou_idx, Bnote
common c_lamp_font
forward_function tvrdd,finefile

stat=0 & catch,stat & if (stat ne 0) then begin & print,!error_state.msg & return & endif

if n_elements(uv) eq 0 then WIDGET_CONTROL, ev.id   , GET_UVALUE=uv
if n_elements(uv) gt 0 then begin
WIDGET_CONTROL, uv.wDraw,bad_id=ii, GET_VALUE =Wind , GET_UVALUE=uvdw
oo  =obj_valid(uv.oView)
stim=strmid(systime(),0,16)
divi=sys_dep('DIVIDER')
name='e-LogBook'

Prox=0 & if (not oo) then if uv.oView  eq -1 then Prox=1                    ;Do we come from prox_sheet?
if Prox then name=name+'-Prox'

; ---------------------
if (uv.but ge 3) and (uv.but le 10) then begin & new=0                              ;Concerning e-LogBook
  if uv.but eq 9 then begin
     path=dialog_pickfile(/directory,title="Select a directory for the Log Book")   ;Choose a directory
     if path gt " " then new=1 else return
  endif else begin & if n_elements(ebook) eq 0 then new=1 else $
                   if (finefile(ebook+name+'.html'))[0] eq '' then new=1
                   if (uv.but eq 4) and (not new) then begin
                      file_delete,ebook,/quiet,/recursive & new=1 & endif
                   if (uv.but eq 4) then return
                   cd,current=path
  endelse

  if new then begin
     cd,current=mee
     if strpos(strupcase(path),strupcase(name)) gt 0 then begin
        cd,path & cd,'..' & cd,current=path & cd,mee   &  endif
     if strmid(path,strlen(path)-1,1) ne divi then path=path+divi
     if (finefile(path+name))[0] eq '' then begin & cd,path & bid=sys_dep('MKDIR',name) & cd,mee & endif
      path=path+name+divi
      file=path+name+'.html'
      bid =finefile(file,count=cnt)
      if cnt eq 0 then begin                                                         ;Create e-LogBook
        
       p_did_get_etc, d_etc  &  hexBg = d_etc.hexBg  &  curBg = d_etc.curBg
       hexBg = '#'+strmid(hexBg,4,2)+strmid(hexBg,2,2)+strmid(hexBg,0,2)
       
       img=2 & LOGO,img & img=bytscl(img,top=(!D.n_colors-1)<255)
      ;if !D.n_colors le 256 then tvlct,kr,kg,kb,/get
                                  tvlct,kr,kg,kb,/get  &  trs = kr*0+255 & trs[250:255]=0
       if n_elements(kr) gt 1 then WRITE_PNG,path+'logo.png',img,kr,kg,kb,TRANSP=trs else WRITE_PNG,path+'logo.png',img,TRANSP=trs
       openw,u,file,/get_lun
       printf,u,'<html><head><title>Lamp e-LogBook></title></head><body bgcolor="'+hexBg+'">' 
       printf,u,'<font face="Comic Sans MS">'
       printf,u,'<h1><b><u>'+name+' started with Lamp on '+strmid(stime(dum),0,17)+'</u></b></h1>'
       printf,u,'<nobr><img src="logo.png"><b><a href="FTP://ftp.ill.eu/pub/cs/lampnews.txt">FTP://ftp.ill.eu/pub/cs/lampnews.txt</a></b></nobr><br></font>'
       printf,u,'</body></html>'
       free_lun,u
       
      endif
     ebook=path & if n_elements(jou_idx) eq 0 then jou_idx=0
  endif else file=ebook+name+'.html'

  if uv.but eq 10 then begin & print,file & bid=sys_dep('BROWSE','file://'+file) & return & endif ;Browse

  on_ioerror,endbufe
  openr,u,file,/get_lun & n=2000                                                ;Read e-LogBook in bufe
    bufe=strarr(n) & readf,u,bufe
    on_ioerror,endbufi
      bufi=strarr(n*4) & readf,u,bufi
    endbufi: bufe=[bufe,bufi]
  endbufe: bufe=bufe[where(bufe gt ' ')] & bufe=bufe[0:n_elements(bufe)-2]
  free_lun,u

  jou=did_ContextJou()
  if jou[0] gt ' ' then begin                                            ;Add lamp journal (incremental)
     nl=n_elements(jou) & if nl gt 7 then $
          addon=['<textarea rows="7" cols="80" wrap="off">',jou,'</textarea>'] $
     else addon=[jou+'<br>']
     addon=['<form><font size="+0"><nobr><b>',addon,'</b></nobr></font></form>']
     bufe=[bufe,addon]
  endif
endif
; ---------------------

case 1 of
(uv.but eq 0): begin & empty & wait,.3 ; CLIPBOARD
         if oo then begin
          Wind       -> GetProperty,Dimensions=windowSize,Resolution=reso
          oClipboard =  OBJ_NEW('IDLgrClipboard', DIMENSIONS=windowSize, Resolution=reso)
          oClipboard -> Draw, uv.oView
          OBJ_DESTROY,  oClipboard
         endif else begin
          wset,wind & img=tvrdd(r,g,b)
          if n_elements(r) le 1 then tvlct,r,g,b,/get
          windowSize=(size(img))[1:2]
          oView  = OBJ_NEW('IDLgrView', DIMENSIONS=windowSize ,VIEWPLANE_RECT=[0., 0.,windowSize])
          oModel = OBJ_NEW('IDLgrModel')
          oP = OBJ_NEW('IDLgrPalette',r,g,b)
          oI = OBJ_NEW('IDLgrImage',img,palette=oP)
          oModel -> Add, oI
          oModel -> Add, OBJ_NEW('IDLgrLight', TYPE=0, INTENSITY=.9, COLOR=[255,255,255])
          oView  -> Add, oModel
          oClipboard =  OBJ_NEW('IDLgrClipboard', DIMENSIONS=windowSize, Resolution=1D/[!D.X_PX_CM, !D.Y_PX_CM], palette=oP, color_model=1)
          oClipboard -> Draw, oView
          OBJ_DESTROY, [oClipboard,oView,oModel,oP,oI]
         endelse
   end
(uv.but eq 1) or (uv.but eq 3):begin & empty & wait,.3 ; PNG or eLogBook
         if oo then begin
            Oimg=Wind->read() & Oimg->GetProperty,data=img & obj_destroy,Oimg
         endif else begin
            wset,wind & img=tvrdd(kr,kg,kb)
         endelse
         if uv.but eq 1 then begin & fifi='lamp.png' & pph=''
         endif else begin & pph=ebook
            fifi=strtrim(strmid(stime(dum),0,11),2)+'-'+strmid(stime(dum),12,2)+strmid(stime(dum),15,2)+strmid(stime(dum),18,2)+'.png'
            ws=''
            if n_elements(uvdw) gt 4 then if (uvdw[0] eq -88) and (uvdw[1] eq 390) then ws=did_ContextJou(uvdw[3])
            if ws le ' ' then bufe=[bufe,'<p><img src="'+fifi+'">'] $
                         else bufe=[bufe,'<p><b><font face="Comic Sans MS" color="blue"><i><u>'+stim+' '+ws+'</u></i></font></b><br><img src="'+fifi+'">']
         endelse
         if (size(img))[0] gt 2 then img=Color_Quan(img,1,kr,kg,kb,/dither) $
                                else if !D.n_colors le 256 then tvlct,kr,kg,kb,/get ;d'nt know why !!!!!!
         if n_elements(kr) gt 1 then WRITE_PNG,pph+fifi,img,kr,kg,kb else WRITE_PNG,pph+fifi,img,TRANSP=[0]
         end
(uv.but eq 5):begin ; Add an html
         filt='*.htm;*.html'
         bfil=dialog_pickfile(filter=filt,/fix_filter,/must_exist,/read,resource_name='lampdid')
         j  = strpos(/reverse_search,bfil,'.')
         dvd=sys_dep('DIVIDER')
         k  = strpos(/reverse_search,bfil,dvd)
         if j gt 0 then begin
            fifi=strmid(bfil,0,j)+'*'
            FILE_COPY,fifi,ebook,/overwrite
            if k ge 0 then bfil=strmid(bfil,k+1,80)
            bufe=[bufe,'<p><b><font face="Comic Sans MS">LINK: <a href="'+bfil+'">'+bfil+'</a></font></b>']
         endif else bufe=''
         end
(uv.but eq 6):begin ; Add  a comment
            widget_control,ev.top,get_uvalue=btxt
            widget_control,btxt  ,get_value =comment
            widget_control,ev.top,map=0
            bufe=[bufe,'<p><b><font face="Comic Sans MS" color="red"><i><u>'+stim+' Comment</u></i><br>',comment+'<br>','</font></b>']
         end
(uv.but eq 7):begin ; Add a text
         filt='*.txt;*.text'
         bfil=dialog_pickfile(filter=filt,/fix_filter,/must_exist,/read,resource_name='lampdid')
         if bfil gt '' then begin
            on_ioerror,endtxt & u=-1 & line=''
            openr,u,bfil,/get_lun
            bufe=[bufe,'<p><b><font face="Comic Sans MS" color="green"><i><u>'+stim+' '+bfil+'</u></i><nobr><br>']
            while (not eof(u)) do begin
               readf,u,line & if line gt '' then bufe=[bufe,line+'<br>']
            endwhile
            bufe=[bufe,'</nobr></font></b>']
            endtxt: if u gt 0 then free_lun,u
         endif else bufe=''
         end
(uv.but eq 8):begin ; Add an image
         filt=['*.jpeg;*.jpg','*.png','*.gif','*.bmp','*.cgm','*.wmf']
         bfil=dialog_pickfile(filter=filt,/fix_filter,/must_exist,/read,resource_name='lampdid')
         j= strpos(/reverse_search,bfil,'.')
         if j gt 0 then begin
            fifi=strtrim(strmid(stime(dum),0,11),2)+'-'+strmid(stime(dum),12,2)+strmid(stime(dum),15,2)+strmid(stime(dum),18,2)+strmid(bfil,j,8)
            FILE_COPY,bfil,ebook+fifi
            bufe=[bufe,'<p><b><font face="Comic Sans MS" color="blue"><i><u>'+stim+' '+bfil+'</u></i></font></b><br><img src="'+fifi+'">']
         endif else bufe=''
         end
(uv.but eq 12):begin ; Open input Comment
            if xregistered('EbookNote') eq 0 then begin & uvv=uv
               bnote=widget_base(  title='Comment for e-Logbook',/column,resource_name='lampdid')
               bid  =widget_label( bnote,value='Enter a text to insert in ...'+name+divi+name+'.html', font=ft_b_normal)
               btxt =widget_text(  bnote,xsize=80,ysize=7,/editable,font=ft_propor)
               brow =widget_base(  bnote,/row)
               uvv.but=6
               bid  =widget_button(brow ,value='Accept',font=ft_b_normal,uvalue=uvv)
               bid  =widget_label( brow ,value='      ',font=ft_propor)
               uvv.but=13
               bid  =widget_button(brow ,value='Cancel',font=ft_b_normal,uvalue=uvv)
               bid  =widget_label( brow ,value='      ',font=ft_propor)
               uvv.but=14
               bid  =widget_button(brow ,value='Clear' ,font=ft_b_normal,uvalue=uvv)
               widget_control,        Bnote ,set_uvalue=btxt,/realize
               XMANAGER, 'EbookNote', Bnote ,group_leader=wdraw,event_handler='did_ContextEvent',/just_reg
            endif else widget_control,Bnote ,map=1
         end
(uv.but eq 13):begin ; Cancel comment
            widget_control,ev.top,map=0
         end
(uv.but eq 14):begin ; Clear a comment
            widget_control,ev.top,get_uvalue=btxt
            widget_control,btxt  ,set_value =''
         end
else:
endcase
nl=n_elements(bufe)
if nl gt 1 then begin
   openw,u,file,/get_lun
   for i=0,nl-1 do printf,u,bufe[i]
   printf,u,'</body></html>' & free_lun,u
end

endif ;n_elements(uv) gt 0
end

pro liv_lamp
;+
;** *********
;** liv_lamp compiling
;-
common here_tools,VV
Vs=!version.release
VV=' '
if Vs ge 6.0 then begin
   if (sys_dep('EMBEDDED') or sys_dep('RUNTIME')) and (Vs ge 6.0) then begin
       VV=strtrim(string(Vs),2) & vvp=strpos(VV,'.')
       VV=strmid( VV,0,vvp)+strmid( VV,vvp+1,1)
       VV=CALL_FUNCTION('file_search',FILEPATH('', SUBDIR=['lib','hook'])+"itools"+VV+".sav")
       if Vs ge 8.4 then VV=' ' $     ;we use graphic functions rather than itools
       else if VV le ' ' then VV='No' ;else we must restore itools if there
       if (sys_dep('MACHINE') ne 'win') and (Vs lt 6.3) then VV='!'
   endif else if (sys_dep('MACHINE') ne 'win') and (Vs lt 6.3) then VV='?'
endif else if  sys_dep('EMBEDDED') then VV='!' else VV='?'
;VV='No'        means no Tools at all
;VV='!'         means V6 && embedded && not win   --> lunch live_tools as is.
;VV='!'         means old V52 embedded            --> lunch live_tools as is.
;VV='?'         means not embedded && not win V6  --> lunch live_tools in a parent base
;VV='filename'  means V6 && embedded     && win   --> lunch itools (+load)
;VV=' '         means V6 && not embedded && win   --> lunch itools

if  Vs le 8.1 then VV='first'+VV $
              else VV='first'+VV ; Anyway, the bug is here at first Itool call!
              
; An other bug when a drop-property-widget is active while the win close icon is pressed              
if (Vs ge 8.2) and (Vs le 8.5) and (!version.os_family eq 'unix') and (not sys_dep('EMBEDDED')) and (not sys_dep('RUNTIME')) then $ 
 ;if file_search(filepath('idlitwdpropertysheet_copy.pro',root=sys_dep('GETENV','LAMP_DIR'),subdir=['legacy'])) gt ' ' $
  if file_which('idlitwdpropertysheet_copy.pro') gt ' ' $
    then resolve_routine, 'idlitwdpropertysheet_copy'

end
