//
//  LL_getVersion.c
//  Test-Lamp-Loop
//
//  Created by Yannick Raoul on 6/21/13.
//  Copyright 2013 ILL/CS. All rights reserved.
//

#include "lamp_loops.h"
#include <string.h>

//User specified version info of this build to display in Lamp during startup.

//#define STRING_VERSION "LL v0.9" // 21 juin 2013
//#define STRING_VERSION "LL v0.95" // 26 juin 2013
//#define STRING_VERSION "LL v0.96" // 14 aout 2013 ; add IN5_dist, STR_textu
#define STRING_VERSION "LL v0.97" // 14 aout 2013 ; add STR_proj

#define STRING_AUTHOR "YR" //Who made the changes.

/*
 * Small utility used to test the presence and runnable state of Lamp Loop library
 * No parameter in entry, return a (static) string, as documented by IDL.
 *
 */
char* LL_getVersion (int argc, void *argv[])
{
    /*
     * IDL will make a copy of the string that is returned (if it is not NULL).
     * One way to avoid a memory leak is therefore to return a pointer to
     * a static buffer containing a null terminated string. IDL will copy
     * the contents of the buffer and drop the reference to our buffer
     * immediately on return.
     */
#define MAX_OUT_LEN 255
    static char result[MAX_OUT_LEN+1];	/* leave a space for a '\0' on the longest string */

    sprintf(result, "%s ; Build on %s, %s ; by %s", STRING_VERSION, __DATE__, __TIME__, STRING_AUTHOR);
    return(result);
    
}