//
//  lamp_loops.h
//  IDL-Loops
//
//  Created by Yannick Raoul on 5/17/13.
//  Copyright 2013 ILL/ADHOC. All rights reserved.
//

#include <stdio.h>
#include "idl_export.h"


char*  LL_getVersion (int argc, void *argv[]);

IDL_LONG D33_panels_loop (int argc, void *argv[]);
IDL_LONG D33_panels_loop_natural (
                             IDL_LONG NxV,
                             IDL_LONG sz,
                             IDL_LONG * xVa,
                             IDL_LONG * yVa,
                             IDL_LONG * xVb,
                             IDL_LONG * yVb,
                             IDL_LONG dim_i_mergCNT,
                             float * mergCNT,
                             IDL_LONG dim_i_merDET,
                             IDL_LONG dim_j_merDET,
                             float * merDET,
                             IDL_LONG dim_i_curPan,
                             float * curPan 
                             );



IDL_LONG D33_tof1 (int argc, void *argv[]);
IDL_LONG D33_tof1_natural(
                    IDL_LONG NFix,
                    IDL_LONG * SFix1,
                    IDL_LONG * SFix2,
                    IDL_LONG * SFiy1,
                    IDL_LONG * SFiy2,
                    IDL_LONG dim_i_fullimage,// First dimension of fullimage
                    float * fullimage,
                    float * Data
                    );



IDL_LONG D33_tof2 (int argc, void *argv[]);
IDL_LONG D33_tof2_natural(
                    IDL_LONG NFix,
                    IDL_LONG * SFix1,
                    IDL_LONG * SFix2,
                    IDL_LONG * SFiy1,
                    IDL_LONG * SFiy2,
                    IDL_LONG dim_i_fullimage,// First dimension of fullimage
                    float * fullimage,
                    float * Data,
                    float * SFfullCount,
                    float * SFweight
                    );



IDL_LONG HKL_vol (int argc, void *argv[]);
IDL_LONG HKL_vol_natural(
                    IDL_LONG n_elements_WOUT,
                    float * WOUT,
                    IDL_LONG dim_i_Wtmp,
                    IDL_LONG dim_j_Wtmp,
                    IDL_LONG dim_k_Wtmp,
                    float * Wtmp,
                    IDL_LONG n_elements_z1H,
                    IDL_LONG * z1H,
                    IDL_LONG * z1K,
                    IDL_LONG * z1L
                    );



IDL_LONG HKL_calc (int argc, void *argv[]);
IDL_LONG HKL_calc_natural(
                     IDL_LONG n_elements_z,
                     IDL_LONG n_elements_sgamp,
                     float* sgamp,
                     IDL_LONG n_elements_cgamp,
                     float* cgamp,
                     IDL_LONG n_elements_cnu,
                     float* cnu,
                     float wave,
                     IDL_LONG n_elements_a,
                     IDL_LONG dim_i_zz,
                     IDL_LONG dim_j_zz,
                     float* zz,
                     IDL_LONG n_elements_snup,
                     float* snup,
                     IDL_LONG k,
                     IDL_LONG dim_i_z1H,
                     IDL_LONG dim_j_z1H,
                     IDL_LONG dim_k_z1H,
                     float* z1H,
                     float* z1K,
                     float* z1L
                     );



IDL_LONG D19_Xcor (int argc, void *argv[]);
IDL_LONG D19_Xcor_natural (
                      IDL_LONG sz,
                      IDL_LONG dim_i_L,
                      const IDL_LONG* L,
                      IDL_LONG dim_i_mat,
                      IDL_LONG dim_j_mat,
                      const float* mat,
                      IDL_LONG dim_i_Wout,
                      IDL_LONG dim_j_Wout,
                      IDL_LONG dim_k_Wout,
                      float* Wout
                      );


IDL_LONG D19_Ycor (int argc, void *argv[]);
IDL_LONG D19_Ycor_natural (
                      IDL_LONG sx,
                      IDL_LONG sy,
                      IDL_LONG sz,                
                      IDL_LONG dim_i_cor_Yd,
                      IDL_LONG dim_j_cor_Yd,
                      float* cor_Yd,
                      IDL_LONG dim_i_Win,
                      IDL_LONG dim_j_Win,
                      IDL_LONG dim_k_Win,
                      float* Win,                      
                      IDL_LONG reb,
                      IDL_LONG dim_i_Wout,
                      IDL_LONG dim_j_Wout,
                      IDL_LONG dim_k_Wout,
                      float * Wout
                      );


IDL_LONG STR_textu (int argc, void *argv[]);
IDL_LONG STR_textu_natural(
                           IDL_LONG n_elements_sk,
                           IDL_LONG * ind,
                           IDL_LONG Eok,
                           IDL_LONG * jof1,
                           IDL_LONG * jof2,
                           IDL_LONG * ik,
                           IDL_LONG * ik1,
                           IDL_LONG  dim_i_out,
                           IDL_LONG  dim_j_out,
                           IDL_LONG  dim_k_out,
                           float * Wout,
                           float * Eout,
                           IDL_LONG  dim_v_e_1,
                           IDL_LONG  dim_v_e_2,
                           IDL_LONG  dim_v_e_3,
                           const float * v,
                           const float * e,
                           const float * PA01,
                           const float * PA02,
                           const float * PA11,
                           const float * PA12
                           );


IDL_LONG STR_proj (int argc, void *argv[]);
IDL_LONG STR_proj_natural(
                          IDL_LONG n_elements_sk,
                          const IDL_LONG * ind,
                          const IDL_LONG * ik,
                          const IDL_LONG * ik1,
                          IDL_LONG j,
                          IDL_LONG Eok,
                          IDL_LONG  dim_i_out,
                          IDL_LONG  dim_j_out,
                          IDL_LONG  dim_k_out,
                          float * Wout,
                          float * Eout,
                          float * Iweight,
                          IDL_LONG  dim_v_e_1,
                          IDL_LONG  dim_v_e_2,
                          IDL_LONG  dim_v_e_3,
                          const float * v,
                          const float * e,
                          const float * PA,
                          const float * PA1
                          );


IDL_LONG IN5_dist (int argc, void *argv[]);
IDL_LONG IN5_dist_natural(
                          IDL_LONG n_elements_indLim,
                          const IDL_LONG * indLim,
                          IDL_LONG  dim_i_DATA,
                          IDL_LONG  dim_j_DATA,
                          IDL_LONG  dim_k_DATA,
                          const float * DATA,
                          IDL_LONG  j,
                          float * W_out,
                          const IDL_LONG * ind,
                          const IDL_LONG * ind1,
                          float * unMoinsPA,
                          float * PA,
                          IDL_LONG Eok,
                          const float * E,
                          float * E_out
                          );

