pro python_stuff, flags, status
;+
;** ************
;** 
;-

status = 0
if !version.release lt '8.5' then return
return ; Anyway 
os  = !version.os ;'Win32' or 'darwin' or 'linux'

PATH                = getenv('PATH')

pathl = strlowcase(PATH)
if (strpos(pathl, 'python') lt 0) and (strpos(pathl, 'anaconda') lt 0) then return

if flags eq 'check' then begin
  PYTHONPATH        = getenv('PYTHONPATH')        ; All
  LD_LIBRARY_PATH   = getenv('LD_LIBRARY_PATH')   ; Linux
  DYLD_LIBRARY_PATH = getenv('DYLD_LIBRARY_PATH') ; Mac
  PYTHONHOME        = getenv('PYTHONHOME')        ; Mac
  SHELL             = getenv('SHELL')             ; Mac , Linux

  if os eq 'Win32'  then sep=';' else sep=':'
  if os eq 'Win32'  then div='\' else div='/'
  IDLLIB = !dir + div + 'lib' + div + 'bridges'
  if os eq 'Win32'  then IDLBIN = !dir + div + 'bin' + div + 'bin.x86_64'
  if os eq 'darwin' then IDLBIN = !dir + div + 'bin' + div + 'bin.darwin.x86_64'
  if os eq 'linux'  then IDLBIN = !dir + div + 'bin' + div + 'bin.linux.x86_64'

  pathlst = strsplit(pathl , sep,/extract) ; lowercase
  pathTBL = strsplit(PATH  , sep,/extract) ; as is

 ;****PYTHONHOME
  if (PYTHONHOME le ' ') then begin
 ;****PYTHONHOME
    idxa = strpos(pathlst, 'anaconda') & idxa = where(idxa gt 0) & idxa=idxa[0]
    idxp = strpos(pathlst, 'python')   & idxp = where(idxp gt 0) & idxp=idxp[0]
    if idxa ge 0 then begin
       PYTHONHOME =  pathTBL[idxa]
       idx1 = strpos(pathlst[idxa], 'anaconda') & idx2 = strpos(pathlst[idxa], div, idx1)
       if idx2 gt idx1 then PYTHONHOME = strmid(PYTHONHOME,0,idx2)
    endif else begin
       PYTHONHOME =  pathTBL[idxp]
       idx1 = strpos(pathlst[idxp], 'python')   & idx2 = strpos(pathlst[idxa], div, idx1)
       if idx2 gt idx1 then PYTHONHOME = strmid(PYTHONHOME,0,idx2)
    endelse
    ii=execute("SETENV, 'PYTHONHOME="+PYTHONHOME+"'")
  endif
  
 ;****PYTHONPATH
  if (PYTHONPATH le ' ') or (strpos(PYTHONPATH, !dir) lt 0) then begin
 ;****PYTHONPATH
    if PYTHONPATH le ' ' then PYTHONPATH =                    IDLBIN + sep + IDLLIB $
                         else PYTHONPATH = PYTHONPATH + sep + IDLBIN + sep + IDLLIB
    ii=execute("SETENV, 'PYTHONPATH="+PYTHONPATH+"'")
  endif
  
 ;****PATH
  if os eq 'Win32'   then if strpos(PATH, IDLBIN) lt 0 then begin
 ;****PATH
    PATH = PATH + sep + IDLBIN
    ii=execute("SETENV, 'PATH="+PATH+"'")
  endif

  if os eq 'darwin'  then if strpos(pathTBL[0], PYTHONHOME+'/bin') lt 0 then begin
    PATH = PYTHONHOME+'/bin' + sep + PATH
    ii=execute("SETENV, 'PATH="+PATH+"'")
  endif

 ;****DYLD_LIBRARY_PATH
  if os eq 'darwin'  then if (strpos(DYLD_LIBRARY_PATH, IDLBIN) lt 0) or (strpos(DYLD_LIBRARY_PATH, PYTHONHOME) lt 0) then begin
 ;****DYLD_LIBRARY_PATH
    addon = '/System/Library/Frameworks/ImageIO.framework/Resources' + sep + '/usr/lib' + sep + PYTHONHOME+'/lib' + sep + IDLBIN
    if DYLD_LIBRARY_PATH le ' ' then DYLD_LIBRARY_PATH =                           addon $
                                else DYLD_LIBRARY_PATH = DYLD_LIBRARY_PATH + sep + addon
    ii=execute("SETENV, 'DYLD_LIBRARY_PATH="+DYLD_LIBRARY_PATH+"'")
  endif

  ;****LD_LIBRARY_PATH
  if os eq 'linux'   then if (strpos(LD_LIBRARY_PATH, IDLBIN) lt 0) or (strpos(LD_LIBRARY_PATH, PYTHONHOME) lt 0) then begin
  ;****LD_LIBRARY_PATH
    addon = PYTHONHOME+'/lib' + sep + IDLBIN
    if LD_LIBRARY_PATH le ' ' then LD_LIBRARY_PATH =                        addon $
                              else LD_LIBRARY_PATH = LD_LIBRARY_PATH + sep + addon
    ii=execute("SETENV, 'LD_LIBRARY_PATH="+LD_LIBRARY_PATH+"'")
  endif

;darwin
;******
;PATH="/Applications/anaconda/bin:"+PATH
;            export PATH
;PYTHONPATH="/Applications/exelis/idl85/bin/bin.darwin.x86_64:/Applications/exelis/idl85/lib/bridges" (ONLY PYTHON TO IDL?)
;            export PYTHONPATH
;DYLD_LIBRARY_PATH="/System/Library/Frameworks/ImageIO.framework/Resources:/usr/lib:/Applications/anaconda/lib:/Applications/exelis/idl85/bin/bin.darwin.x86_64"
;            export DYLD_LIBRARY_PATH
;PYTHONHOME="/Applications/anaconda"
;            export PYTHONHOME

;Win32
;*****
;PATH = .....;c:\Program Files\Exelis\IDLXX\bin\bin.x86_64;...
;PYTHONPATH = c:\Program Files\Exelis\IDLXX\bin\bin.x86_64; C:\Program Files\Exelis\IDLXX\lib\bridges (ONLY PYTHON TO IDL)

;linux
;*****
;LD_LIBRARY_PATH = "/usr/local/anaconda3/linux_34x/lib:/usr/local/idl/bin/bin.linux.x86_64"

endif

end
