;
;                      ******************
;                      *** Super_Plot ***
;                      ******************
;                a graphical tool to compare scans
;
;                Written by JOUFFREY Romuald
;                August,September,October, November, ..., etc 1995
;                (Hoping this Help...)
;
;
; Procedures of this file are :
;
; *************************** Procedures
; p_rom_super_event           Event Manager for Super_Plot
; p_rom_super_plot            Plots making procedure
; p_rom_super_select          plot Getting procedure
; p_rom_super_filter          filter/copy local workspaces for plotting
; p_rom_super_done            Done button was pushed
; p_rom_cleanup, id           called when window is killed to restore colors
; p_rom_redefine_slider
; p_rom_send_txt_wd
; ***************************** Widgets Creating Procedure
; superplot, widx       Create Super_plot Interface
;
; Little explanation on variables
; - Each Super_Plot Variable begins with s_
; - Local variables are normaly named
; - sw_ stands for  Super_Plot Widgets identifier variables
; - sc_ stands for  Super_Plot Commons
;
; The event procedure for superplot is called by the event_lamp_parser
; which gives it back the Uvalue as a parameter, so superplot interface
; is a real part of the whole Lamp package.


;*****************************************************************************
pro p_rom_super_event, event, test ;******************************************
;+
;** *****************
;** Called when an event is generated by Super_Plot widgets tree
;-

@lamp.cbk                      ; call back the lamp common block
common c_trap, trap_x1,trap_x2,trap_y1,trap_y2,trap_ws, trap_current

common sc_superdid  ,s_sym,s_err, $        ; Array of boolean Set for psym , error
                     s_lv,s_lx,s_lbx,s_lby ; For live annotation
common sc_supordid  ,s_xylv,s_xylw         ; For XY limits and there widgets + log10 + linear
common sc_supardid  ,s_np, snapall         ; # of keeps, more....
common sc_rom_filter,sc_filt,sc_f_fac,$    ; Voigt w_id for pvfactor
                     sc_f_wid,sc_f_stp,$   ; and width and step Xcoord
                     sc_f_cvr,sc_f_chg     ; Voigt convolution & flag to re-calculate

common sc_superplot,s_wid,$    ; # of the workspace processed (string)
               s_siz,    $     ; The size of current workspace processed
               s_wset,   $     ; # of the draw window
               s_hid,    $     ; Array of boolean Set if hided
               s_scl,    $     ; Array of boolean Set if scaled
               s_hid2,   $     ; as s_hid but when s_cutall is set
               s_off_arr,$     ; Array of idx
               s_num_wrk,$     ; Array of workspace number
               s_cut,    $     ; Array of boolean Set if cutting x
               s_cut_values, $ ; Array of cutting values
               s_xcut,   $     ; Boolean set if cutting X
               s_filter, $     ; Boolean set if filter is on
               s_color,  $     ; Boolean set if colored mode
               s_show_err, $   ; boolean set if show error is on
               s_normalize,$   ; Boolean set if normalization is on
               s_cutall, $     ; Boolean set if cutting apply to all
               s_psymb,  $     ; Boolean set if plot symbol is on
               s_xmin,   $     ; xmin range value (%)
               s_xmax,   $     ; xmax range value (%)
               s_ctred,  $     ; buffer for user color palet (red)
               s_ctgreen,$     ; " (green)
               s_ctblue, $     ; " (blue)
               s_scratio,$     ; float (maximum scale ratio)
               s_printno,$     ; int (number of next print)
               s_var1,   $
               s_var2,   $
               s_var3,   $
               s_var4,   $
               s_yscale, $     ; Y scale percentage
               s_yoffset,$     ; Y Offset percentage
               s_0 ,s_1 ,s_2 ,s_3 ,s_4 ,s_5 ,s_6 , $ ; local workspaces (data)
               s_e0,s_e1,s_e2,s_e3,s_e4,s_e5,s_e6, $ ; local errors
               s_x0,s_x1,s_x2,s_x3,s_x4,s_x5,s_x6, $ ; X vectors for data arrays
               s_p0,s_p1,s_p2,s_p3,s_p4,s_p5,s_p6, $ ; plotted local workspaces
               sw_id0,   $     ; widget id of multi_plot widget tree
               sw_drw,   $     ; array of id widget draw  (0->s_np-1)
               sw_hid,   $     ; array of id widget button(0->s_np-1)
               sw_lab,   $     ; array of id widget label (0->s_np-1)
               sw_err          ; Widget of the 'Error message' label

common sc_superplot_did, s_7,s_8,s_9 ,s_e7,s_e8,s_e9 ,s_x7,s_x8,s_x9 ,s_p7,s_p8,s_p9, s_pp ,b_redim, $ ;added local wksp (dids)
                         s_ddr,s_ddg,s_ddb, s_le, legende, lgnd_on

IF (TAG_NAMES(event, /STRUCTURE_NAME) EQ 'WIDGET_KBRD_FOCUS') THEN BEGIN
    if (not s_color) then TVLCT, s_ctred, s_ctgreen, s_ctblue,/GET
    if (event.enter eq 1) and (s_color) then begin
                     TVLCT, s_ddr  , s_ddg    , s_ddb ,2
                     if sys_dep('MACHINE') ne 'win' then p_rom_super_plot,0 ; Redraw (MAC PROBLEM SLIDER!!!!)
    endif
    if (event.enter eq 0) and (s_color) then TVLCT, s_ctred, s_ctgreen, s_ctblue
    return
ENDIF

IF (TAG_NAMES(event, /STRUCTURE_NAME) EQ 'WIDGET_BASE') THEN BEGIN
    gm0=widget_info(  event.top  ,/geometry) & b0x=gm0.scr_xsize & b0y=gm0.scr_ysize
   ;b_redim={ori_win1:[xsiz,ysiz],cur_win1:[xsiz,ysiz],ori_bas0:[b0x,b0y],cur_bas0:[b0x,b0y],winb:sw_draw,wins:s_wset}
   ;return
    offx=b0x-b_redim.cur_bas0[0]
    offy=b0y-b_redim.cur_bas0[1]
    if (abs(offx) gt 30) or (abs(offy) gt 30)  then begin
        newXw1=(b_redim.cur_win1[0]+offx)>b_redim.ori_win1[0]
        newYw1=(b_redim.cur_win1[1]+offy)>b_redim.ori_win1[1]
        if (newXw1 ne b_redim.cur_win1[0]) or (newYw1 ne b_redim.cur_win1[1]) then begin ;RESIZE win1
            widget_control,b_redim.winb ,XSIZE=newXw1, YSIZE=newYw1
            b_redim.cur_win1   =[newXw1,newYw1]
            gm0=widget_info(  event.top  ,/geometry) & b0x=gm0.scr_xsize & b0y=gm0.scr_ysize
            b_redim.cur_bas0   =[b0x   ,b0y   ]
            p_rom_super_plot,0 ;redraw
        endif
    endif
    return
ENDIF
catch,stat & if stat ne 0 then return

uv=test
siz_test = size(test)
t1 = test[0]                            ; always -88 (Lamp event)
IF siz_test[1] gt 1 then t2 = test[1]   ; code of the event
IF siz_test[1] gt 2 then t3 = test[2]   ; another code for the event
IF siz_test[1] gt 3 then t4 = test[3]   ; id of cut slider
IF siz_test[1] gt 4 then t5 = test[4]   ; id of cut label
IF siz_test[1] gt 5 then t6 = test[5]   ; id of X Button or (0:replace  1:groupe)
IF siz_test[1] gt 6 then t7 = test[6]   ; id of Y Button
IF siz_test[1] gt 7 then t8 = test[7]   ; id of cutting base
IF siz_test[1] gt 8 then t9 = test[8]   ; id of Workspace slider

CASE t2 OF
    353:BEGIN ; *************************** Worspace Modification
        CASE t3 OF
            0 : BEGIN ; ------------------------------------ Workspace slider moved
                   p_rom_super_select,test,2 ; Process new selection
               END
            1 : BEGIN ; ------------------------------------ Cut slider moved
                   p_rom_super_select,test,1 ; Process new selection
               END
            2 : BEGIN ; ------------------------------------ X Button Pushed
                   s_xcut = 1                     ; Set flag xcut on
                   p_rom_super_select,test,1 ; Process new selection
               END
            3 : BEGIN ; ------------------------------------ Y Button Pushed
                   s_xcut = 0                     ; Set flag xcut off
                   p_rom_super_select,test,1 ; Process new selection
               END
            ENDCASE
        END
    354:BEGIN ; *************************** Plotting parameters modification
        CASE t3 OF
            0 : BEGIN ; ------------------------------------ XMin slider moved
                   old_s_xmin = s_xmin
                   s_xmin = event.value
                   s_var1 = 1 & s_var2 = 0
                   IF old_s_xmin ne s_xmin THEN BEGIN
                     p_rom_super_plot,0 ; Redraw
                   ENDIF
               END
            1 : BEGIN ; ------------------------------------ XMax slider moved
                   old_s_xmax = s_xmax
                   s_xmax = event.value
                   s_var2 = 1 & s_var1 = 0
                   IF old_s_xmax ne s_xmax THEN BEGIN
                     p_rom_super_plot,0 ; Redraw
                   ENDIF
               END
            2 : BEGIN ; --------------------------------- Y_scale slider moved
                   old_s_yscale = s_yscale
                   if s_yscale lt 0 THEN s_yscale = -(event.value) ELSE $
                                         s_yscale =  (event.value)
                   IF old_s_yscale ne s_yscale THEN BEGIN
                     p_rom_super_plot,0 ; Redraw
                   ENDIF
               END
            3 : BEGIN ; --------------------------------- Y Offset slider moved
                   old_s_yoffset = s_yoffset
                   s_yoffset = event.value
                   IF old_s_yoffset ne s_yoffset THEN BEGIN
                     p_rom_super_plot,0 ; Redraw
                   ENDIF
               END
            4 : BEGIN ; --------------------------------- Button one event
                   s_cutall = 3
                   p_rom_send_txt_wd ,sw_err,'.... Select your WorkSpace # ....'
                   p_rom_super_filter,/clear
                   FOR i=1,s_np do BEGIN
                     IF s_num_wrk[i] gt 0 then BEGIN   ; if a W is defined
                         wid = strtrim(string(s_num_wrk[i]),2)
                         V = s_cut_values[i]
                         siz=0 & res = execute('siz = Size(w' +wid+')')
                         IF siz[0] eq 2 THEN BEGIN ; IF WKS is bi-dimensional
                          IF s_cut[i] THEN BEGIN
                              didsx=0 & res = execute('didsx=size(x'+wid+')')
                              if didsx[0] ne 1 then st=V+1 else $
                                res=execute('st = x'+wid+'[V]')
                              ii = strmid(strtrim(string(st),2),0,6)
                             ;ss='W'+wid+' '+w_numor(FIX(wid))+' X='+ii
                              ss='W'+wid+'X'+ii+' '
                          ENDIF ELSE BEGIN
                              didsy=0 & res = execute('didsy=size(y'+wid+')')
                              if didsy[0] ne 1 then st=V+1 else $
                                res=execute('st = y'+wid+'[V]')
                              ii = strmid(strtrim(string(st),2),0,6)
                             ;ss='W'+wid+' '+w_numor(FIX(wid))+' Y='+ii
                              ss='W'+wid+'Y'+ii+' '
                          ENDELSE
                         ENDIF ELSE ss='W'+wid+' ' ;+w_numor(FIX(wid))
                           WIDGET_CONTROL, bad_id=j,sw_lab[i-1],Set_Value=ss
                     ENDIF
                   ENDFOR
                   p_rom_super_select,test,1 ; Process new selection
               END
            5 : BEGIN ; --------------------------------- Button all event
                   s_cutall = 1
                   p_rom_super_filter,/clear
                   p_rom_super_select,test,1 ; Process new selection
               END
            6 : BEGIN ; --------------------------------- Button scale 0
                  s_yscale = -s_yscale
                  p_rom_super_plot,0 ; Redraw
               END
            7 : BEGIN ; --------------------------------- Just redraw
                  p_rom_super_plot,0 ; Redraw
               END
            8 : BEGIN ; --------------------------------- Filter as changed (input text)
                   sc_f_chg=1
                  p_rom_super_plot,0 ; Redraw
               END
            9 : BEGIN ; --------------------------------- Filter as changed (smooth button)
                   if t4 eq 1 then begin
                      sc_filt[6]=1
                      widget_control,sc_filt[4],set_value=strtrim(string(sc_filt[7]),2)
                      widget_control,sc_filt[1],sens=0 & widget_control,sc_filt[2],sens=0
                      widget_control,sc_filt[3],set_value='Kernel >= 3 '
                   endif else if t4 eq 2 then begin
                      sc_filt[6]=0
                      widget_control,sc_filt[4],set_value=strtrim(string(sc_f_wid),2)
                      widget_control,sc_filt[1],sens=1 & widget_control,sc_filt[2],sens=1
                      widget_control,sc_filt[3],set_value='Full width  '
                   endif
                   sc_f_chg=1
                  p_rom_super_plot,0 ; Redraw
               END
            ENDCASE
        END
    355:BEGIN ; *************************** Local W parameters modification
        CASE t3 OF
        ; Here t4 is the number of processed local workspace
            0 : BEGIN ; ------------------------- Keep Button Pushed
                    s   = strtrim(string(t4),2) & wkee=0; t4 = # of local dataset
                    res = execute('wkee=s_' +s)
                    if  t6 then if event.type ne 1 then return ;Keep grouping released?
                    if  n_elements(s_0)  eq 1      then return ;No plot yet?
                    if  n_elements(wkee) eq 1 then t6=0
                    if (n_elements(wkee) ne n_elements(s_0)) and (t6) then begin
                        p_rom_send_txt_wd ,sw_err, 'Incompatible dimension !!!'
                        return & endif
                   s_hid[0] = 1                   ; m_0 is now undrawable
                   s_hid[t4]= 0                   ; m_# t4 becomes drawable
                   s_sym[t4]=s_psymb              ; psym  flag
                   s_err[t4]=s_show_err           ; error flag
                   WIDGET_CONTROL, bad_id = i, sw_hid[t4-1], Set_Button=0
                   res = execute('s_' +s+ '=s_0')    ; copy s_0 in s_i
                   res = execute('s_e'+s+ '=s_e0')   ; copy s_e0 in s_ei
                   res = execute('s_x'+s+ '=s_x0')   ; copy s_x0 in s_xi
                   i=0. & ii='' & V = 0
                   sw_scut=t5
                   WIDGET_CONTROL, bad_id=i,sw_scut,Get_Value = V & V=V-1
                   siz=0 & res = execute('siz = Size(w' +s_wid+')')
                   IF siz[0] eq 2 THEN BEGIN ; IF WKS is bi-dimensional
                     IF s_xcut then BEGIN
                         didsx=0 & res = execute('didsx=size(x'+s_wid+')')
                         if didsx[0] ne 1 then i=V+1 else $
                           res=execute('i = x'+s_wid+'[V]')
                         ii = strmid(strtrim(string(i),2),0,6)
                        ;s='W'+s_wid+' '+w_numor(FIX(s_wid))+'X='+ii
                         s='W'+s_wid+'X'+ii+' '
                     ENDIF ELSE BEGIN
                         didsy=0 & res = execute('didsy=size(y'+s_wid+')')
                         if didsy[0] ne 1 then i=V+1 else $
                           res=execute('i = y'+s_wid+'[V]')
                         ii = strmid(strtrim(string(i),2),0,6)
                        ;s='W'+s_wid+' '+w_numor(FIX(s_wid))+' Y='+ii
                         s='W'+s_wid+'Y'+ii+' '
                     ENDELSE
                   ENDIF ELSE BEGIN & s='W'+s_wid+' ' & V=0 & ENDELSE ;Care V=-1 with offsets
                   s_cut_values[t4]=V         ; store idx of cut for 'cut one' mode
                   s_cut[t4]=s_xcut           ; store cutting axis
                   s_off_arr[t4]=V            ; store idx of cut for plot idx
                   s_num_wrk[t4]=FIX(s_wid)   ; store number of kept workspace
                   s_num_wrk[0]=-1            ; s_0 offset inactivated
                   s_off_arr[0]=-1            ; s_0 offset inactivated
                   WIDGET_CONTROL, bad_id=i, sw_lab[t4-1], Get_Value = sk
                   if t6 then s=sk+s
                   WIDGET_CONTROL, bad_id=i, sw_lab[t4-1], Set_Value = s  ;below store t4 properties
                   kp_prop=[s_sym[t4],s_err[t4],s_cut_values[t4],s_cut[t4],s_off_arr[t4],s_num_wrk[t4]]
                   p_rom_super_filter,keepin=[t4,t6,kp_prop] ; process filtering
                   p_rom_super_plot,0                        ; Redraw
               END
            1 : BEGIN ; ------------------------- Hide Button event
                   s_hid[t4] = event.select   ; t4 = # of local dataset
                   i = strtrim(string(t4),2)
                   s_s = [0L]
                   res = execute('s_s = SIZE(s_'+i+')')
                   IF s_s[0] ne 0 THEN BEGIN
                     p_rom_super_plot,0       ; Redraw
                   ENDIF
                END
            2 : BEGIN ; ------------------------- Scale Button event
                   s_scl[t4] = event.select   ; t4 = # of local dataset
                   p_rom_super_plot,0         ; Redraw
               END
            3 : BEGIN ; ------------------------- Clean Out Button pushed
                   s_hid=[1,1,1,1,1,1,1,1,1,1]; each plot is undrawable
                   s_0 = 0                    ; erase local workspace 0
                   s_siz = size(s_0)
                   s_1 =s_0 & s_2 =s_0 & s_3 =s_0; and 1 to 9
                   s_4 =s_0 & s_5 =s_0 & s_6 =s_0
                   s_7 =s_0 & s_8 =s_0 & s_9 =s_0
                   s_p0=s_0 & s_p1=s_0 & s_p2=s_0 & s_p3=s_0    ; Erase keeping data
                   s_p4=s_0 & s_p5=s_0 & s_p6=s_0 & s_pp=s_0
                   s_p7=s_0 & s_p8=s_0 & s_p9=s_0
                   s_off_arr =  [-1,-1,-1,-1,-1,-1,-1,-1,-1,-1]
                   s_num_wrk =  [-1,-1,-1,-1,-1,-1,-1,-1,-1,-1] ; Clear workspace number array
                   s_cut_values=[-1,-1,-1,-1,-1,-1,-1,-1,-1,-1] ; Clear cutting values
                   FOR j=0,s_np-1 do BEGIN                      ; Reset widget values
                     WIDGET_CONTROL, bad_id=i, sw_hid[j], Set_Button=0
                     WIDGET_CONTROL, bad_id=i, sw_lab[j], Set_Value=' '
                   ENDFOR
                   s_xmin = 0 & s_xmax = 500
                   s_var1 = 0 & s_var2 = 0
                   s_yscale  =  s_scratio
                   s_yoffset =  0       ; no yoffset
                   s_xylv[*] =  0       ; For XY limits
                   WIDGET_CONTROL, bad_id=i,s_xylw[0], Set_Value = ""
                   WIDGET_CONTROL, bad_id=i,s_xylw[1], Set_Value = ""
                   WIDGET_CONTROL, bad_id=i,s_xylw[2], Set_Value = ""
                   WIDGET_CONTROL, bad_id=i,s_xylw[3], Set_Value = ""

                   WIDGET_CONTROL, bad_id=i, t4      , Set_Value = 0         ;slider offset
                   WIDGET_CONTROL, bad_id=i, t5      , Set_Value = s_scratio ;slider yscale
                   WIDGET_CONTROL, bad_id=i, t6      , Set_Value = 0         ;slider xmin
                   WIDGET_CONTROL, bad_id=i, t7      , Set_Value = 500       ;slider xmax
                   WSET, snapall[0] & ERASE,   2            ; Clear snap window
                   WSET, s_wset     & ERASE, 255            ; Clear draw window
               END
            4 : BEGIN ; ------------------------- Normalize all Button event
                   s_normalize = event.select
                   p_rom_super_plot,0          ; Redraw
               END
            5 : BEGIN ; ------------------------- Filter Button event
                   s_filter = event.select
                   p_rom_super_filter,/change  ; process filtering or copy
                   p_rom_super_plot,0          ; Redraw
               END
            6 : BEGIN ; ------------------------- Colored Button event
                   s_color = event.select
                   IF s_color then BEGIN
                     TVLCT, s_ctred, s_ctgreen, s_ctblue, /GET
                     TVLCT, s_ddr  , s_ddg    , s_ddb ,2
                   ENDIF ELSE BEGIN
                     TVLCT, s_ctred, s_ctgreen, s_ctblue
                   ENDELSE
                   tmp=fix(s_ctred)+s_ctgreen+s_ctblue
                   pop=min(tmp) & ccol=!C
                   pup=max(tmp) & bcol=!C
                   FOR j=0,s_np-1 do BEGIN
                     WIDGET_CONTROL,bad_id=i,sw_drw[j] ,Get_Value = w
                     wset, w
                     IF s_color then begin & ERASE, j+3
                     endif else begin
                         erase, bcol
                         PLOTS, 0,13, /Device
                         PLOTS, FIndGen(49), SIN(FIndGen(49)/7)*10+13, /Continue, Color=ccol,LineStyle=(j mod 6)  ,/Device
                         PLOTS, 0,11, /Device
                         if j gt 5 then $
                         PLOTS, FIndGen(49), SIN(FIndGen(49)/7)*10+11, /Continue, Color=ccol,LineStyle=(j mod 6)+1,/Device
                     ENDELSE
                     xyouts,0,7,'->',color=ccol,charsize=1.,font=0,/device
                   ENDFOR
                   p_rom_super_plot,0               ; Redraw
               END
            7 : BEGIN ; ------------------------- Show errors Button event
                   s_show_err = event.select
                   p_rom_super_plot,0               ; Redraw
               END
            8 : BEGIN ; ------------------------- Plot Symbol Button event
                   s_psymb = event.select
                   p_rom_super_plot,0               ; Redraw
               END
            9 : BEGIN ; ------------------------- YLog10 scaling
                   s_xylw[4] = event.select
                   p_rom_super_plot,0               ; Redraw
               END
           10 : BEGIN ; ------------------------- Linear X axis (index)
                   s_xylw[5] = event.select & s_xylw[6]=0 & widget_control,uv[3],set_button=0
                   p_rom_super_plot,0               ; Redraw
               END
           11 : BEGIN ; ------------------------- XLog10 scaling
                   s_xylw[6] = event.select & s_xylw[5]=0 & widget_control,uv[3],set_button=0
                   p_rom_super_plot,0               ; Redraw
               END
           12 : BEGIN ; ------------------------- legend on/off , position
                   if uv[3] eq -1 then lgnd_on[0]=1-lgnd_on[0] $
                   else begin & lgnd_on[0]=1 &  lgnd_on[1]=uv[3] & endelse
                   p_rom_super_plot,0               ; Redraw
               END
            ENDCASE
        END
    356:BEGIN ; *************************** Others global events
        CASE t3 OF
            0 : BEGIN ; ------------------------- Print Button Pushed
                   PsFile = 'super_p'     ; construct PS filename
                   doit=0
                   FOR i=s_np,0,-1 do BEGIN
                     si= strtrim(string(i),2) & s_s=0L
                     IF NOT(s_hid[i]) and NOT(s_hid2[i]) then BEGIN
                        res = execute('s_s = size(s_'+si+')')
                        IF s_s[0]       gt 0 Then doit=s_num_wrk[i]>1
                     ENDIF
                   ENDFOR
                   IF doit gt 0 THEN BEGIN
                     PsFile=PsFile+STRTRIM(STRING(s_printno), 2)+'.ps'
                     PRINT, 'Print Generating : '+PsFile
                     wplot = !D.name
                     on_ioerror, iferr
                     set_plot,'PS' & sx=7. & sy=11.5
                     device, yoffset=sy-0.5,xoffset=.5,/inches,/Landscape
                     device, filename=PsFile
                     device, bits_per_pixel=8,/color
                     p_rom_super_plot,1   ; Redraw with print option
                     ii=execute('P_DID_PS_HEADER,7.,doit,PsFile')
                     s_printno=s_printno+1
                     iferr :
                     DEVICE,/close
                     set_plot, wplot
                   ENDIF ELSE PRINT, string(7B)+'no print generated'
                END
            1 : p_rom_super_done          ; DONE Button pushed

            2 : BEGIN ; ------------------------- Motion event
                 if event.type eq 2 then $
                 if trap_current eq s_wset then begin
                     WSET,s_wset
                     tmXYZ=CONVERT_COORD(event.X,event.Y,/dev,/to_data)
                     XV=tmXYZ[0] & YV=tmXYZ[1] ;CURSOR,XV,YV ,/nowait,/data
                     tx1='X='+strtrim(string(XV),2) & ty1='Y='+strtrim(string(YV),2)
                     widget_control,bad_id=i,t4,set_value=tx1
                     widget_control,bad_id=i,t5,set_value=ty1
                     endif
                END
            3 : if n_elements(s_lv) gt 1 then BEGIN ; -------- Live Tools
                     i =legende.WRK[0]>1
                     !p.title=w_tit[i] & !x.title='' & !y.title=''
                     IF s_xcut then !x.title=y_tit[i] else !x.title=x_tit[i]
                     sz_lv=size(s_lv)
                     if sz_lv[0] eq 2 then by=sz_lv[2] else by=1
                     sz_le=size(s_le)
                     if sz_le[0] eq 2 then if sz_le[2] eq 2*by then s_le=transpose(s_le)
                     if s_xylw[7] then xylW3=[0,0,0] else xylW3=[s_xylw[6],s_xylw[4],s_xylw[5]]
                     ii=execute('LIVE_LAMP_PLOT, 1, s_lx, s_lv, xrange=s_lbx, yrange=s_lby, title="", error=s_le'+ $
                                                 ', legende=legende, xylW=xylW3, okT=okT')
                     if not okT then $
                     ii=execute('LIVE_LAMP_PLOT, 1, s_lx, s_lv, xrange=s_lbx, yrange=s_lby, title="", error=s_le'+ $
                                                 ', legende=legende, xylW=xylW3')
                     !p.title='' & !x.title='' & !y.title=''
                ENDIF
            4 : BEGIN ; ------------------------- Png Button Pushed
                   PsFile = 'super_p'     ; construct filename
                   doit=0
                   FOR i=s_np,0,-1 do BEGIN
                     IF NOT(s_hid[i]) and NOT(s_hid2[i]) then BEGIN
                         IF s_num_wrk[i] gt 0 THEN doit=s_num_wrk[i]
                     ENDIF
                   ENDFOR
                   IF doit gt 0 THEN BEGIN
                     PsFile=PsFile+STRTRIM(STRING(s_printno), 2)+'.png'
                     PRINT, 'Generating : '+PsFile
                     p_rom_super_plot,2   ; Redraw with print option
                     r=0 & buf=tvrdd(r,g,b)
                     if n_elements(r) le 1 then tvlct ,r,g,b ,/get
                     WRITE_KIF,PsFile,buf,r,g,b
                     s_printno=s_printno+1
                   ENDIF ELSE PRINT, string(7B)+'no PNG generated'
               END
            5 : BEGIN ; ------------------------- Mpeg panel Button Pushed
                    did_mpeg,'create',wdraw=sw_drw[s_np],group=event.top,title='Overplotting'
                END
            ENDCASE
        END
    ENDCASE
END

;*****************************************************************************
pro p_rom_super_plot, psp ;***************************************************
;+
;** ****************
;** The plotting procedure
;** psp stands for PoScript Printing=1 or PNG=2
;** if psp eq 1 then p_rom_super_plot is used to print on Postcript device
;-

@lamp.cbk
common c_trap, trap_x1,trap_x2,trap_y1,trap_y2,trap_ws, trap_current
common sc_superdid               ; Array of boolean Set for psym
common sc_supordid               ; For XY limits and there widgets
common sc_supardid               ; # of keeps, more....
common sc_superplot              ; Call Back Super_Plot block
common sc_superplot_did
common sc_rom_filter

if s_xylw[5] then begin & XMin=0 & XMax=n_elements(s_x0)-1
endif else XMin = Min(s_x0,Max=XMax)    ; Default Values for XMin, XMax
           YMin = Min(s_0 ,Max=YMax, /NaN)    ; and YMin, Ymax
if finite(YMin,/NaN) then YMin=0.
Ymax0=Ymax

FOR i=0,s_np do BEGIN      ; For each local data set
    s_s=[0L] & si= strtrim(string(i),2)
    res = execute('s_s = size(s_'+si+')')
    IF s_s[0] gt 0 THEN BEGIN
        mimax=[i,Ymin,Ymax,Xmin,Xmax]
        p_rom_super_filter,MIMAX=mimax

        tmp = 0. &  tmm = 0.
        if s_xylw[5] then  res = execute('tmm=n_elements(s_x'+si+')-1') $
        else begin & tmp=mimax[3] & tmm=mimax[4] & endelse

        if XMin gt tmp then XMin = tmp ; Calculate XMin ...
        if XMax lt tmm then XMax = tmm ; Calculate XMax ...
        tmp=mimax[1] & tmm=mimax[2]
        if finite(tmp,/NaN) then tmp=0.
        if YMin gt tmp then YMin = tmp ; Calculate YMin ...
        if YMax lt tmm then YMax = tmm ; Calculate YMax
    ENDIF
ENDFOR

; Voigt ,smooth filter (Kernel)
on_ioerror,misfilt
if sc_filt[6] eq 0 then begin
   WIDGET_CONTROL,bad_id=i,sc_filt[2],get_value=bitx  & bitx=strcompress(bitx[0],/remove_all)
   if bitx ne "" then tm1=float(bitx) & if tm1 ne sc_f_fac   then sc_f_chg=1 & sc_f_fac=tm1
   WIDGET_CONTROL,bad_id=i,sc_filt[4],get_value=bitx  & bitx=strcompress(bitx[0],/remove_all)
   if bitx ne "" then tm2=float(bitx) & if tm2 ne sc_f_wid   then sc_f_chg=1 & sc_f_wid=tm2
endif
if sc_filt[6] eq 1 then begin
   WIDGET_CONTROL,bad_id=i,sc_filt[4],get_value=bitx  & bitx=strcompress(bitx[0],/remove_all)
   if bitx ne "" then tm3=fix(bitx)>3 & if tm3 ne sc_filt[7] then sc_f_chg=1 & sc_filt[7]=tm3
endif
if sc_f_chg then p_rom_super_filter,/change
misfilt:
; Limited values for YMin, Ymax, XMin, XMax
s_xylv[*]=0
NormVxr  =0
on_ioerror,misbit
WIDGET_CONTROL,bad_id=i,s_xylw[0],get_value=bitx & bitx=strcompress(bitx[0],/remove_all)
if bitx gt " " then tm1=float(bitx) else tm1=YMin
WIDGET_CONTROL,bad_id=i,s_xylw[1],get_value=bitx & bitx=strcompress(bitx[0],/remove_all)
if bitx gt " " then tm2=float(bitx) else tm2=YMax
s_xylv[0]=tm1 & s_xylv[1]=tm2 & misbit:on_ioerror,misbot

WIDGET_CONTROL,bad_id=i,s_xylw[2],get_value=bitx & bitx=strcompress(bitx[0],/remove_all)
if bitx gt " " then tm1=float(bitx) else tm1=XMin
if bitx gt " " then NormVxr = 1
WIDGET_CONTROL,bad_id=i,s_xylw[3],get_value=bitx & bitx=strcompress(bitx[0],/remove_all)
if bitx gt " " then tm2=float(bitx) else tm2=XMax
if bitx gt " " then NormVxr = 1
s_xylv[2]=tm1 & s_xylv[3]=tm2 & misbot:

if s_xylv[1] gt s_xylv[0] then begin & YMin=s_xylv[0] & YMax=s_xylv[1] & endif
if s_xylv[3] gt s_xylv[2] then begin & XMin=s_xylv[2] & XMax=s_xylv[3] & endif

on_ioerror,misplot

; ---------------------------------- if scale 0 button is set
if s_yscale lt 0 THEN BEGIN
    butscl0 =1
    s_yscale=-s_yscale
ENDIF ELSE butscl0=0

; ---------------------------------- calculate correct XRange (sliders)
if s_var1 eq 1 then BEGIN
    XMinP =XMin + (s_var4-XMin)/500.*s_xmin
    if XMinP le XMin then s_var1=0
    if XMinP ge XMax then s_var1=0
    s_var3 = XMinP
    XMaxP = s_var4
ENDIF
if s_var2 eq 1 then BEGIN
    XMaxP =XMax - (XMax-s_var3)/500.*(500.-s_xmax)
    if XMaxP ge XMax then s_var2=0
    if XMaxP le XMin then s_var2=0
    s_var4 = XMaxP
    XMinP = s_var3
ENDIF

if (s_var1 eq 0) and (s_var2 eq 0) then BEGIN
    XMinP =XMin + (XMax-XMin)/500.*s_xmin
    XMaxP =XMax - (XMax-XMin)/500.*(500.-s_xmax)
    s_var3 = XMinP
    s_var4 = XMaxP
ENDIF


; ---------------------------------- calculate correct YRange
; gjk touched here!!!

  YMinP = YMin
  YMimi = YMin
  YMaxP = YMax

  Ilog=s_xylw[4]
  Qlog=s_xylw[6]
  Olog=s_xylw[7]  ;Old Log settings if 1
  Tlog=Ilog*Qlog

  if s_xylw[4] then begin
     YMinp=YMinp>(1E-9)
     YMaxp=YMaxp>(1E-8)
     if Olog then YMinP=alog10(YMinP)
     YMimi=YMinP
     if Olog then YMaxP=alog10(YMaxP)
  endif

  if butscl0 eq 1 THEN YMinP = 0

  if s_normalize then begin
     YMinP=YminP/abs(YMaxP)
     YMaxP=1.1
  endif else begin
     YMaxP=YMaxP+(YMaxP-YMinP)*0.1
  endelse
; gjk end of touch

; ---------------------------------- Calculate yoffset ...
IF s_yoffset ne 0 THEN BEGIN    ; .. if offset slider not equal 0
    ; ------------------------------ Adapt array of offset on s_cutall
    ; --- woffarr is a local OFFSET Array declared for the process, it permit ...
    ; --- to preserve both s_off_arr (idx of cutting) and s_num_wrk (# of W)
    IF (s_cutall eq 1) THEN woffarr=s_num_wrk ELSE woffarr=s_off_arr
    IF  s_normalize    THEN yoffset = float(s_yoffset/100.)*float(s_yscale/s_scratio) $
                       ELSE yoffset = float(s_yoffset/100.)*float(s_yscale/s_scratio)*(YmaxP-YminP)
    IF s_hid[0] then s_off_arr[0]=-1
    off_arr=woffarr
    woffarr2=intarr(n_elements(where(woffarr ge 0)), 2)
    woffarr2[*, 0] = woffarr[where(woffarr ge 0)]
    woffarr2[*, 1] = indgen(n_elements(where(woffarr ge 0)))
    woffarr2[*,1]  = woffarr2[SORT(woffarr2[*,0]),1]
    j=0                      ; replace data where it is greater or equal 0
    FOR i=0, s_np DO BEGIN
        IF off_arr[i] GE 0 THEN BEGIN
            off_arr[i]=woffarr2[j, 1]
            j=j+1
        ENDIF
   ENDFOR
   YMaxP = YMaxP + Max(off_arr)*yoffset; Adapt YMaxP with offset
ENDIF ELSE BEGIN                       ; s_yoffset = 0
    yoffset = 0.
    off_arr =[0,0,0,0,0,0,0,0,0,0]
ENDELSE

s_lx = s_x0
IF n_elements(s_x1) gt n_elements(s_lx) then s_lx = s_x1
if n_elements(s_x2) gt n_elements(s_lx) then s_lx = s_x2
if n_elements(s_x3) gt n_elements(s_lx) then s_lx = s_x3
if n_elements(s_x4) gt n_elements(s_lx) then s_lx = s_x4
if n_elements(s_x5) gt n_elements(s_lx) then s_lx = s_x5
if n_elements(s_x6) gt n_elements(s_lx) then s_lx = s_x6
if n_elements(s_x7) gt n_elements(s_lx) then s_lx = s_x7
if n_elements(s_x8) gt n_elements(s_lx) then s_lx = s_x8
if n_elements(s_x9) gt n_elements(s_lx) then s_lx = s_x9
s_lx=findgen(n_elements(s_lx))/(n_elements(s_lx)-1)*(Xmax-Xmin)+Xmin

; ---------------------------------- printing or not printing ?
subt='' & tit ='' & xtit='' & ytit=''
lwth=1
if s_num_wrk[0] gt 0 then j=s_num_wrk[0] else j=s_wid
if s_xcut then xtit=y_tit[j] else xtit=x_tit[j]

IF psp gt 0 THEN BEGIN           ; printing ...
    IF s_color THEN $
    styles=['Grey:','Red:','Green:','Blue:', 'Yelow:','wBlue:','Pink:','dGreen:','Brown:','Purple:'] $
    else $
    styles=['Grey:','___' ,'...'   ,'_ _'  , '._._.' ,'..._'  ,'__ __','__.__'  ,'===='  ,'=.=.='  ]
    ok=1
    FOR i=0, s_np DO BEGIN
    IF NOT(s_hid[i]) and NOT(s_hid2[i]) THEN BEGIN
        IF s_num_wrk[i] gt 0 THEN BEGIN
          if ok then begin & ok=0
            st1 = strtrim(string(s_num_wrk[i]),2)
            IF s_cut[i] eq 1 then st2='x' ELSE st2='y'
            st3 = strtrim(string(s_cut_values[i]),2)
            str0= st2+st1+'['+st3+']'
            res = execute('str0='+str0)
            st4 = strtrim(string(str0),2)
            xtit= x_tit[    s_num_wrk[i]]
            ytit= y_tit[    s_num_wrk[i]]
            IF s_cut[i] eq 1  then begin & titit=xtit & xtit=ytit & ytit=titit & endif
            if psp eq 2 then $
            tit = w_tit[    s_num_wrk[i]]
            if i eq 0 then subt= subt +styles[i]+'W'+st1 + st2 + st4+'  '
          endif ;else begin
            if i gt 0 then widget_control,sw_lab[i-1], Get_Value = sk
            if i gt 0 then subt= subt +styles[i]+strcompress(sk[0]) +'  '
         ;endelse
        ENDIF
    ENDIF
    ENDFOR
ENDIF
IF psp ne 1 then  WSET, s_wset      ; ... set the correct window to plot in

tvlct ,pos_r  ,pos_g ,pos_b ,/get
tmp=fix(pos_r)+pos_g +pos_b
pop=min(tmp) & ccol=!C
pup=max(tmp) & bcol=!C

;if psp eq 1 then if pop eq 0 then bcol=ccol

; ---------------------------------- Do the plot without dataset with axis

s_lbx=[XMinP,XMaxP] & if s_xylw[6] then begin & s_lbx=s_lbx>(1E-9) & s_lx=s_lx>(1E-9) ;X values
                                              if Olog then s_lbx=alog10(s_lbx)
                                              if Olog then s_lx =alog10(s_lx )
                                        endif
s_lby=[YMinP,YMaxP*(s_yscale/s_scratio)]
s_lv    =0.      ;Y values              for itools
s_lvt   =s_lx*0. ;temp, s_lx=X values   for itools
s_le    =0.      ;E values              for itools
legende =0 ;{Npoints, colors, linestyle, sym_index, names, wrkspace} for itools
s_lvd   =0
s_xn    =0
ee      =0
trap_current=s_wset

if Olog then begin
   PLOT, s_lx,XRange=s_lbx, YRange=s_lby, title = tit, SubTitle=subt, xtick_get=V,    $
                         XTitle=xtit, YTitle=ytit,/NoData, Background=bcol,color=ccol
   if s_xylw[5] then $
   PLOT, s_lx,XRange=s_lbx, YRange=s_lby, title = tit, SubTitle=subt, xtickv=s_lx[V], $
                         XTitle=xtit, YTitle=ytit,/NoData, Background=bcol,color=ccol
   if s_xylw[6] then $
   PLOT, s_lx,XRange=s_lbx, YRange=s_lby, title = tit, SubTitle=subt, $ ;xtick_get=V, $
                         XTitle=xtit, YTitle=ytit,/NoData, Background=bcol,color=ccol

endif else begin
 if Tlog then $
   PLOT, s_lx,XRange=s_lbx, YRange=s_lby, title = tit, SubTitle=subt, /Xlog, /Ylog,$
                         XTitle=xtit, YTitle=ytit,/NoData, Background=bcol,color=ccol else $
 if Qlog then $
   PLOT, s_lx,XRange=s_lbx, YRange=s_lby, title = tit, SubTitle=subt, /Xlog,       $
                         XTitle=xtit, YTitle=ytit,/NoData, Background=bcol,color=ccol else $
 if Ilog then $
   PLOT, s_lx,XRange=s_lbx, YRange=s_lby, title = tit, SubTitle=subt, /Ylog,       $
                         XTitle=xtit, YTitle=ytit,/NoData, Background=bcol,color=ccol      $
 else $
   PLOT, s_lx,XRange=s_lbx, YRange=s_lby, title = tit, SubTitle=subt,              $
                         XTitle=xtit, YTitle=ytit,/NoData, Background=bcol,color=ccol
 endelse

; --------------------------------- Plot local workspaces #1 -> s_np

FOR i=1,s_np do begin
    s_s=[0L] & si= strtrim(string(i),2)

    si2 = (((i-1) mod 6)  )*(s_color ne 1) ;linestyle
    si3 = (((i-1) mod 6)+1)*(s_color ne 1)

    res = execute('s_s = size(s_'+si+')')
   ;c   = (((i-1)*(!D.n_colors/9)+7)*FIX(s_color eq 1))>ccol
    c   = ccol

    IF s_s[0] ne 0 THEN $             ; plot only not empty workspace
      IF not(s_hid[i]) and not(s_hid2[i]) THEN BEGIN ; and not hided workspace
         nsp=1
         WHILE nsp ge 1 do begin
          sget=[i,nsp,0] & p_rom_super_filter, GET=sget
          IF sget[2] then begin
            res =execute('s_lvd=s_' +si)
            res =execute('ee   =s_e'+si)
            res =execute('s_xn =s_x'+si)
            if (n_elements(ee) le 1) or (max(ee) eq 0.) then ee=0.
            if (nsp gt 1) and (s_color) then si2=((nsp-1) mod 6)
            if (nsp gt 1) and (s_color) then si3=((nsp-1) mod 6)+1

           ;gjk The following line makes a start on getting the normalisation correct
            if s_xylw[4] and Olog then begin & errl1=alog10((s_lvd+ee)>(1E-9))
                                             errl2=alog10((s_lvd-ee)>(1E-9))
                                             idel =where( (s_lvd-ee) le (1E-9))
                                             s_lvd=alog10((s_lvd)>(1E-9))
                                             if idel[0] ge 0 then errl2[idel]=3*s_lvd[idel]-2*errl1[idel]
            endif else begin & errl1=0. & errl2=0. & endelse

           ;DR normalize inside X range (right input text) & Aug 2015
            if NormVxr then begin
               NormIdx = where((s_xn ge Xmin) and (s_xn le Ymax))
               if NormIdx[0] gt -1 then YNor = max(s_lvd[NormIdx]) else YNor = 1.
            endif else                  YNor = max(s_lvd)

            YNor = FLOAT(s_normalize ne 1)+YNor*FLOAT(s_normalize eq 1)
           ; 
           ; ------------------------------ Calculate scaling parameter
           ; if local w isn't scaled, then yscale=s_scratio/s_yscale else yscale=1
           ; this is to cancel the effect of YRange modified by s_yscale
           ; ------------------------------
           ; 

            yscale = FLOAT(s_scl[i] eq 1)+(s_yscale/s_scratio)*FLOAT(s_scl[i] ne 1)

            s_lvd=(YMimi+(s_lvd/YNor-YMimi)*yscale)+yoffset*off_arr[i]
            errl1=(YMimi+(errl1/YNor-YMimi)*yscale)+yoffset*off_arr[i] ;Old log plot (Olog=1)
            errl2=(YMimi+(errl2/YNor-YMimi)*yscale)+yoffset*off_arr[i] ;Old log plot (Olog=1)

            v=n_elements(s_lvd) & vl=400
            if s_xylw[5] then s_xn=findgen(v)
            if s_xylw[6] then begin & s_xn=s_xn>(1E-9)
                                    if Olog then s_xn=alog10(s_xn)
                              endif
            if (s_color) then c=i+2 else c=ccol
            IF psp eq 1 THEN lwth=3 else if v gt vl then lwth=1 else lwth=2
            psymb=s_sym[i]*i & IF psymb GE 3 THEN psymb=psymb+1
            psym3=psymb
            IF psymb EQ 0 THEN begin & psymb=!P.PSYM & psym3=psymb  & endif

            if (psymb gt 7) then begin & psymb=psymb-4 & psym3=3 & lwth=2 & endif
            if (i*(1-s_color) gt 6) or (nsp gt 6) then begin
               lwth=lwth>2
               if si2 eq 0 then begin & sit=si2 & si2=si3 & si3=sit & endif
            endif else si3=si2

            st='OPLOT ,s_xn ,s_lvd ,PSym=psymb, linestyle=si2,thick=lwth ,color=c'
            res = execute(st)

            kp_COL=c & kp_STY=si2 & kp_SYM=psymb & kp_NPT=V
            if  lwth gt 1 then $
            if (i*(1-s_color) gt 6) or (nsp gt 6) $
            or ((s_color) and (v le vl*(1+4*sqrt(psp)))) then begin & c=2 & lwth=1 & si2=si3 & psymb=psym3
                                                         res = execute(st) & c=i+2 & endif

            st1 = strtrim(string(s_num_wrk[i]),2) & st2='' & st4=''      ;Legend composition for itools
            IF s_cut_values[i] ge 0 then begin
               IF s_cut[i] eq 1 then st2='x' ELSE st2='y'
               st3 = strtrim(string(s_cut_values[i]),2) & str0= st2+st1+'['+st3+']'
               res = execute('str0='+str0) & st4 = strtrim(string(str0),2) & ENDIF
            name='W'+st1 + st2 + st4
            widget_control,sw_lab[i-1], Get_Value = lab_name
            if (strpos(lab_name[0],'W') ne 0) then name=lab_name[0]

            if n_elements(s_lv) eq 1 then begin & s_lv=s_lvt & s_lv[0]=s_lvd & s_lvt[0]=s_xn & s_lx=s_lvt & s_lvt=s_lvt*0.
                             lgndCOL= kp_col          & lgndNPT =V               & lgndNAM =name
                             lgndSTY= kp_sty          & lgndSYM =kp_sym          & lgndWRK =s_num_wrk[i]
            endif else begin & s_lvt[0]=s_lvd & s_lv =[[s_lv] ,[s_lvt]]
                             s_lvt[0]=s_xn  & s_lx =[[s_lx] ,[s_lvt]] & s_lvt=s_lvt*0.
                             lgndCOL=[lgndCOL,kp_col] & lgndNPT=[lgndNPT,V]      & lgndNAM =[lgndNAM,name]
                             lgndSTY=[lgndSTY,kp_sty] & lgndSYM=[lgndSYM,kp_sym] & lgndWRK =[lgndWRK,s_num_wrk[i]]
            endelse
           ; ------------------------------ Plotting corrected data versus errors
            IF s_show_err THEN BEGIN
              IF N_ELEMENTS(ee) GT 1 THEN BEGIN                 ;2009-> never show SQRT(I) if no errors !!!
               keepcol=!P.COLOR & !P.COLOR=c
               if (not s_xylw[4] or (not Olog)) then begin
                     ee=ee/YNor*Yscale
                     errl1=s_lvd+ee & errl2=s_lvd-ee
               endif
               ERRPLOT, s_xn, errl1,errl2
               !P.COLOR=keepcol
              ENDIF
              errl1=errl1-s_lvd & errl2=s_lvd-errl2
              if n_elements(s_le) eq 1 then begin & s_le =s_lvt & s_le[0]=errl2 & s_lvt[0]=errl1 ;for itools
                                                  s_le =[[s_le],[s_lvt]] & s_lvt=s_lvt*0.
              endif                    else begin & s_lvt[0]=errl2 & tmp2=s_lvt & tmp2[0]=errl1
                                                  s_le =[[s_le],[s_lvt],[tmp2] ] & s_lvt=s_lvt*0. & endelse
            ENDIF

            nsp=nsp+1
          ENDIF else nsp=0
         ENDWHILE
      ENDIF
ENDFOR

; ---------------------------------- plot local workspace #0
IF s_siz[0] ne 0 THEN $
    IF NOT(s_hid[0]) and not(s_hid2[0]) THEN BEGIN
        i=0
        sget =[0,1,0] & p_rom_super_filter, GET=sget
        s_lvd=s_0
        ee   =s_e0
        if (n_elements(ee) ne n_elements(s_lvd)) then ee=0.
        if s_xylw[4] and Olog then begin & errl1=alog10((s_lvd+ee)>(1E-9))
                                         errl2=alog10((s_lvd-ee)>(1E-9))
                                         idel =where( (s_lvd-ee) le (1E-9))
                                         s_lvd=alog10((s_lvd)>(1E-9))
                                         if idel[0] ge 0 then errl2[idel]=3*s_lvd[idel]-2*errl1[idel]
        endif else begin & errl1=0. & errl2=0. & endelse

        YNor=max(s_lvd)

        YNor = FLOAT(s_normalize ne 1)+YNor*FLOAT(s_normalize eq 1)
        s_lvd= YMimi+(s_lvd/YNor-YMimi)  +yoffset*off_arr[0]
        errl1= YMimi+(errl1/YNor-YMimi)  +yoffset*off_arr[0]
        errl2= YMimi+(errl2/YNor-YMimi)  +yoffset*off_arr[0]

        v=n_elements(s_lvd)
        if s_xylw[5] then s_xn=findgen(v) else s_xn=s_x0
        if s_xylw[6] then begin & s_xn=s_xn>(1E-9)
                                if Olog then s_xn=alog10(s_xn)
                          endif

        if (s_color) then c =2 else c=ccol

        st='OPLOT, s_xn, s_lvd ,Thick=1+s_color, PSym=7*s_psymb ,color=c'
        res = execute(st)

        kp_COL=c & kp_STY=0 & kp_SYM=7*s_psymb & kp_NPT=V

            st1 = strtrim(string(s_num_wrk[i]),2) & st2='' & st4=''      ;Legend composition for itools
            IF s_cut_values[i] ge 0 then begin
               IF s_cut[i] eq 1 then st2='x' ELSE st2='y'
               st3 = strtrim(string(s_cut_values[i]),2) & str0= st2+st1+'['+st3+']'
               res = execute('str0='+str0) & st4 = strtrim(string(str0),2) & ENDIF
            name='W'+st1 + st2 + st4
            if n_elements(s_lv) eq 1 then begin & s_lv=s_lvt & s_lv[0]=s_lvd & s_lvt[0]=s_xn & s_lx=s_lvt & s_lvt=s_lvt*0.
                             lgndCOL= kp_col          & lgndNPT =V               & lgndNAM =name
                             lgndSTY= kp_sty          & lgndSYM =kp_sym          & lgndWRK =s_num_wrk[i]
            endif else begin & s_lvt[0]=s_lvd & s_lv =[[s_lv] ,[s_lvt]]
                             s_lvt[0]=s_xn  & s_lx =[[s_lx] ,[s_lvt]] & s_lvt=s_lvt*0.
                             lgndCOL=[lgndCOL,kp_col] & lgndNPT=[lgndNPT,V]      & lgndNAM =[lgndNAM,name]
                             lgndSTY=[lgndSTY,kp_sty] & lgndSYM=[lgndSYM,kp_sym] & lgndWRK =[lgndWRK,s_num_wrk[i]]
            endelse

        ; ------------------------------ Plotting corrected data versus errors
        IF s_show_err THEN BEGIN
           IF N_ELEMENTS(ee) GT 1 THEN BEGIN   ;2009-> never show SQRT errors !!!
               keepcol=!P.COLOR & !P.COLOR=c
               if (not s_xylw[4] or (not Olog)) then begin
                     ee=ee/YNor
                     errl1=s_lvd+ee & errl2=s_lvd-ee
               endif
               ERRPLOT, s_xn ,errl1,errl2
               !P.COLOR=keepcol
           ENDIF
           errl1=errl1-s_lvd & errl2=s_lvd-errl2
           if n_elements(s_le) eq 1 then begin & s_le =s_lvt & s_le[0]=errl2 & s_lvt[0]=errl1 ;for itools
                                               s_le =[[s_le],[s_lvt]] & s_lvt=s_lvt*0.
           endif                    else begin & s_lvt[0]=errl2 & tmp2=s_lvt & tmp2[0]=errl1
                                               s_le =[[s_le],[s_lvt],[tmp2] ] & s_lvt=s_lvt*0. & endelse
        ENDIF
    ENDIF

; ---------------------------------- reset y_scale if negative
IF butscl0 eq 1 THEN s_yscale=-s_yscale

if psp ne 1 then if !version.release ge '5.0' then did_mpeg,'put'

; ---------------------------------- Legend structure
if n_elements(s_lv) gt 1 then begin
   legende={NPT:lgndNPT,COL:lgndCOL,STY:lgndSTY,SYM:lgndSYM,NAM:lgndNAM,WRK:lgndWRK}
   if lgnd_on[0] then begin
      kp_bcol =!p.background & !p.background=bcol
      kp_ccol =!p.color      & !p.color     =ccol
      if lgnd_on[1] eq 0 then ligend, lgndNAM, psym=lgndSYM, colors=lgndCOL, textcolors=lgndCOL, linestyle=lgndSTY, thick=2,/TOP,/LEFT ;, /clear
      if lgnd_on[1] eq 1 then ligend, lgndNAM, psym=lgndSYM, colors=lgndCOL, textcolors=lgndCOL, linestyle=lgndSTY, thick=2,/BOTTOM,/LEFT
      if lgnd_on[1] eq 2 then ligend, lgndNAM, psym=lgndSYM, colors=lgndCOL, textcolors=lgndCOL, linestyle=lgndSTY, thick=2,/TOP,/RIGHT
      if lgnd_on[1] eq 3 then ligend, lgndNAM, psym=lgndSYM, colors=lgndCOL, textcolors=lgndCOL, linestyle=lgndSTY, thick=2,/BOTTOM,/RIGHT
      !p.color= ccol         & !p.background=kp_bcol
   endif
endif
misplot:
END

;*****************************************************************************
pro p_rom_super_select,test, flg ;*********************************************
;+
;** ******************
;** Called when a NEW Workspace is selected
;** (New Workspace number, Cutting Axis or Cutting Value)
;** flag eq 1
;** flag eq 2 if workspace slider was moved, to invoke new w in cuting all mode
;-

@lamp.cbk                  ; call back the lamp common block
common sc_superplot        ; Call Back Super_Plot block
common sc_superplot_did
common sc_superdid
common sc_supordid
common sc_supardid

sw_scut = test[3]       ; id of cut slider
sw_lcut = test[4]       ; id of cut label
sw_bty  = test[6]       ; id of Y Button
sw_cutb = test[7]       ; id of cutting base
sw_sw   = test[8]       ; id of workspace slider

IF (flg eq 2 and s_cutall eq 1) or (flg gt 0 and s_cutall ne 1) THEN BEGIN
    WIDGET_CONTROL,bad_id=i,sw_sw,Get_Value = widx ; Get selected Workspace #
    s_wid= strtrim(string(widx),2)                 ; get new workspace #
    res =execute('s_siz=size(w' +s_wid +')' )
    ; --------- if W isn't correct
    IF (s_siz[0] lt 1) or (s_siz[0] gt 2) then BEGIN
        p_rom_send_txt_wd, sw_err, 'Mono or Bidimensional W only'
        print, string(7b)      ; BELL to signify error
        s_hid[0] = 1           ; s_0 becomes undrawable
        WIDGET_CONTROL, bad_id=i,sw_cutb, Sensitive=0
        return
    ENDIF ELSE BEGIN
        IF flg eq 2 then p_rom_send_txt_wd, sw_err,'W'+s_wid+' '+strmid(w_tit[FIX(s_wid)],0,29)
        IF flg eq 2 then IF (s_siz[0] eq 2) THEN WIDGET_CONTROL, bad_id=i,sw_cutb, /Sensitive
        s_hid[0] = 0           ; s_0 becomes drawable
    ENDELSE
ENDIF

IF s_cutall eq 1 THEN BEGIN
   ;IF flg gt 0 then wait,.3
    p_rom_send_txt_wd, sw_err,'Cut is applied on ALL W'
ENDIF

; ----------------------- Retrieve Cutting Value
WIDGET_CONTROL, bad_id=i, sw_scut, Get_Value = V & V=V-1

if s_hid[0] eq 0 then s_off_arr[0]=V
s_cut_values[0]=V
s_cut[0]       =s_xcut
IF (s_cutall eq 1) THEN s_num_wrk[0]=FIX(s_wid)
s_num_wrk[0]   =FIX(s_wid)
slide_max      =0

; ------------------------------- For all W if cutall is on (1 or 3)
; ------------------------------- For W#0 if cutall is off
s_e0=0
FOR j=0,s_np*FIX(s_cutall eq 1 or s_cutall eq 3) do BEGIN
    IF s_num_wrk[j] gt 0 then BEGIN   ; if a W is defined
        IF (s_cutall eq 0) or (s_cutall eq 3) THEN V=s_cut_values[j]
        wid = strtrim(string(s_num_wrk[j]),2)
        si =  strtrim(string(j),2)
        siz=0 & res = execute('siz = Size(w' +wid+')')
        IF siz[0] eq 1 THEN BEGIN              ; wk has one dimension
            IF NOT(s_cutall) THEN BEGIN
               WIDGET_CONTROL, bad_id=i, sw_lcut, Set_Value=''
               WIDGET_CONTROL, bad_id=i, sw_cutb, Sensitive = 0
            ENDIF
            res = execute('s_' +si+' = w'+wid) ; copy workspace array
            res = execute('s_e'+si+' = e'+wid) ; copy error array
            s_cut[j]=-1
            res = execute('s_x'+si+' = x'+wid)
            ss='W'+wid+' '                     ; or w_numor(FIX(wid))
            nb_element=0 & res = execute('nb_element =n_elements(s_x'+si+')')
            IF nb_element ne siz[1] THEN  res = execute('s_x'+si+' = indgen(siz[1])')
            nb_element=0 & res = execute('nb_element =n_elements(s_e'+si+')')
            IF nb_element ne siz[1] THEN  res = execute('s_e'+si+' = 0.')
        ENDIF ELSE BEGIN                       ; wk has two dimensions
            cutx=s_xcut
            IF (s_cutall eq 0 or s_cutall eq 3) then cutx = s_cut[j]
            ; ------------------ Get correct Cut in correct W
            s = 0.
            didsx=0 & res = execute('didsx=size(x'+wid+')')
            didsy=0 & res = execute('didsy=size(y'+wid+')')
            didse=0 & res = execute('didse=size(e'+wid+')')
            if didsx[0] le 1 then if didsx[1] ne siz[1] then res=execute('x'+wid+'=indgen(siz[1])+1 & didsx=size(x'+wid+')')
            if didsy[0] le 1 then if didsy[1] ne siz[2] then res=execute('y'+wid+'=indgen(siz[2])+1 & didsy=size(y'+wid+')')
            if didse[0] le 2 then if didse[1] ne siz[1] then res=execute('e'+wid+'=0.               & didse=size(e'+wid+')')
            IF cutx THEN BEGIN
               smax=siz[1]-1               ; define new slider max
               IF ((V ge siz[1]) AND s_cutall eq 1) then BEGIN
                 s_hid2[j]=1
               ENDIF ELSE BEGIN
                 s_hid2[j]=0
                 IF V ge siz[1] then V=siz[1]-1
                 if didsy[0] ne 2 then res = execute('s_x'+si+' = y'+wid) $
                                  else res = execute('s_x'+si+' = reform(y'+wid+'[V,*])')
                 nb_element=0     &    res = execute('nb_element =n_elements(s_x'+si+')')
                 IF nb_element ne siz[2] THEN $
                                       res = execute('s_x'+si+' = indgen(siz[2])')

                 if didsx[0] ne 1 then st=V+1 $
                                  else res=execute('st = x'+wid+'[V]')
                 ii = strmid(strtrim(string(st),2),0,6)
                ;ss='W'+wid+' '+w_numor(FIX(wid))+' X='+ii
                 ss='W'+wid+'X'+ii+' '
                 res = execute('s_' +si+' = REFORM(w'+wid+'[V,*])')
                 if didse[0] eq 2 then res = execute('s_e'+si+' = REFORM(e'+wid+'[V,*])')
                 s = strtrim(string(st),2)+' '+x_tit[FIX(wid)]
               ENDELSE
            ENDIF ELSE BEGIN
               smax=siz[2]-1                ; define new slider max
               IF ((V ge siz[2]) AND s_cutall eq 1) then BEGIN
                 s_hid2[j]=1
               ENDIF ELSE BEGIN
                 s_hid2[j]=0
                 IF V ge siz[2] then V=siz[2]-1
                 if didsx[0] ne 2 then res = execute('s_x'+si+' = x'+wid) $
                                  else res = execute('s_x'+si+' = reform(x'+wid+'[*,V])')
                 nb_element=0     &    res = execute('nb_element =n_elements(s_x'+si+')')
                 IF nb_element ne siz[1] THEN $
                                       res = execute('s_x'+si+' = indgen(siz[1])')

                 if didsy[0] ne 1 then st=V+1 else $
                 res=execute('st = y'+wid+'[V]')
                 ii = strmid(strtrim(string(st),2),0,6)
                ;ss='W'+wid+' '+w_numor(FIX(wid))+' Y='+ii
                 ss='W'+wid+'Y'+ii+' '
                 res = execute('s_'+si+' = w'+wid+'[*,V]')
                 if didse[0] ne 2 then res = execute('s_e'+si+' = e'+wid) $
                                  else res = execute('s_e'+si+' = e'+wid+'[*,V]')
                 s = strtrim(string(st),2)+' '+y_tit[FIX(wid)]
               ENDELSE
            ENDELSE
            IF (s_cutall eq 0 or s_cutall eq 3) THEN BEGIN
                WIDGET_CONTROL, bad_id=i, sw_lcut, Set_Value = s
                p_rom_redefine_slider, sw_scut, V+1, smax+1
            ENDIF ELSE BEGIN
                IF slide_max lt smax then slide_max = smax
                IF j ne 0 THEN WIDGET_CONTROL,bad_id=i,sw_lab[j-1],Set_Value=ss
            ENDELSE
        ENDELSE
        kp_prop=[s_sym[j],s_err[j],s_cut_values[j],s_cut[j],s_off_arr[j],s_num_wrk[j]]
        p_rom_super_filter,select=[j,0,kp_prop]    ; process filtering
    ENDIF
ENDFOR
IF (s_cutall eq 1) THEN BEGIN
    WIDGET_CONTROL, bad_id=i, sw_lcut, Set_Value = 'idx='+strtrim(string(V),2)
    WIDGET_CONTROL, bad_id=i, sw_cutb, /Sensitive
    WIDGET_CONTROL, bad_id=i, sw_scut, Set_Slider_Max = slide_max+1
ENDIF
p_rom_super_plot,0      ; Redraw
if s_cutall eq 3 then s_cutall=0        ; end of the redraw calculation

if (flg eq 2) and (s_cutall eq 0) then begin ;Draw snapshot windows
    wset,snapall[0]
    if s_siz[0] eq 2 then begin & snapi=0
       ii=execute('snapi=congrid(W'+s_wid+',snapall[1],snapall[2],/interp)')
       if ii eq 1 then if s_xylw[4] then tvscl, alog10(snapi>0.001) else tvscl,snapi
    endif
    if s_siz[0] eq 1 then begin
       plot,s_0,xmargin=[0,0],ymargin=[0,0],xstyle=1,ystyle=1,color=200
    endif
    snapall[3]=0
endif
if  s_siz[0] eq 2 then begin ;Show cutting position
    wset,snapall[0]
    device,set_graphics =6
    if snapall[3] gt 0 then plots ,snapall[4:5],snapall[6:7],/device, color=255
    V= float(s_cut_values[0]+1)
    if s_cut[0] then begin ;X cut
       snapall[4:5]=round([V,V]*snapall[1]/s_siz[1]-1.)>0<(snapall[1]-1)
       snapall[6:7]=[0,snapall[2]-1]
    endif else begin       ;Y cut
       snapall[4:5]=[0,snapall[1]-1]
       snapall[6:7]=round([V,V]*snapall[2]/s_siz[2]-1.)>0<(snapall[2]-1)
    endelse
    plots ,snapall[4:5],snapall[6:7],/device, color=255
    snapall[3]=1
    device,set_graphics =3
endif
END

;***********************
function p_rom_do_filter, s_in, s_x, s_ee
;+
;******* ***************
;** apply strfit or smoothing function
;-

common sc_rom_filter   ;, sc_filt, sc_f_fac, sc_f_wid, sc_f_stp, sc_f_cvr, sc_f_chg

sc_f_chg=0
if (sc_f_fac   ge 0.) and (sc_f_fac le 1.) and (sc_f_wid gt 0.) then ok=1 else ok=0
if (sc_filt[6] eq 0 ) and (ok) then begin
   xstp=(s_x[n_elements(s_x)-1]-s_x[0])/n_elements(s_x)

   if  sc_f_stp ne xstp then sc_f_chg=1
  ;New filter function
  ; ------------------
   if (sc_f_chg) then begin
       sc_f_stp=xstp
       bid=str_fit(/none)
   endif
  ;Do filter
  ; --------
   s_out=str_fit(s_in,xin=s_x,ein=s_ee,flat=0.,/Multi_mod,Multi_fine=2,Res_voi=sc_f_wid,Res_pvf=sc_f_fac,/res_filter)
   sc_f_chg=0
endif
if sc_filt[6] eq 1 then begin & kn=sc_filt[7]<(n_elements(s_in)/3) ;Kernel
                        if kn ge 3 then begin
                           s_out=SMOOTH(MEDIAN(s_in,(kn/2)>3),kn)
                           if n_elements(s_in) eq n_elements(s_ee) then s_ee=SMOOTH(MEDIAN(s_ee,(kn/2)>3),kn)/(kn/2.)
                           return,s_out
endif &                 endif
return, s_in
end

;****************************************************************************************************
PRO p_rom_super_filter, SELECT=j, KEEPIN=t4, CHANGE=change, GET=sget, MIMAX=mimax, CLEAR=clear ;*****
;+
;** ******************
;** SELECT-> keep ONE s_pj entry (cuttall is on OR j=0)                          P_ROM_SUPER_SELECT
;** KEEPIN-> group in s_p(t4(0)) t4=[i,bool,...] if bool=0 keep one else group KEEP   BUTTON PUSHED
;**                t4(2:*)=[s_sym, s_err, s_cut_values, s_cut, s_off_arr, s_num_wrk]
;** CHANGE-> filter<-> not filter (s_filter)                                    FILTER BUTTON EVENT
;** GET   -> replace s_pi into s_i                                      P_ROM_SUPER_PLOT GET GROUPS
;** MIMAX -> return ymin,ymax,xmin,xmax                     P_ROM_SUPER_PLOT DEFINE XY GLOBAL RANGE
;** CLEAR -> keep only one s_pi entry                                          BUTTON ONE/ALL EVENT
;-

common sc_superdid
common sc_superplot
common sc_superplot_did
common sc_supardid

szp0=[size(s_p0),0] & szp1=[size(s_p1),0] & szp2=[size(s_p2),0] & szp3=[size(s_p3),0]
szp4=[size(s_p4),0] & szp5=[size(s_p5),0] & szp6=[size(s_p6),0]
szp7=[size(s_p7),0] & szp8=[size(s_p8),0] & szp9=[size(s_p9),0]
szpp= size(s_pp)
szp =[[szp0[0:3]],[szp1[0:3]],[szp2[0:3]],[szp3[0:3]],[szp4[0:3]],[szp5[0:3]],[szp6[0:3]],[szp7[0:3]],[szp8[0:3]],[szp9[0:3]]]

; KEEPIN-> group in s_p't4'
if n_elements(t4) gt 2 then begin & j=t4[0] & t6=t4[1]
   si= strtrim(string(j),2)
   if (n_elements(s_e0) ne n_elements(s_0)) then s_e0=s_0*0. $
   else s_e0 =s_p0[*,3,0]

        s_0  =s_p0[*,0,0]
        s_ee0=s_e0
   tmp=[[s_0],[p_rom_do_filter(s_0,s_x0,s_ee0)],[s_x0],[s_e0],[s_ee0]] ;keep plotting values
   if (szp[0,j] ge 2) and (t6)  then  ii=execute('s_p'+si+'=[[[s_p'+si+']],[[tmp]]]') $
                                else  ii=execute('s_p'+si+'=tmp')
   if n_elements(s_pp) lt 2     then  s_pp=t4 $                        ;keep properties
   else if (t6)                 then  s_pp=[[s_pp],[t4]] $
   else begin & idx=where(s_pp[0,*] ne j) & if idx[0] ge 0 then s_pp=s_pp[*,idx]
                                      s_pp=[[s_pp],[t4]] & endelse
endif else $

; SELECT-> replace s_p'j'
if n_elements(j)  ge 1 then begin & t4=j & t6=j[1] & j=j[0]              ;keep plotting values
   si=strtrim(string(j),2)
   ii=execute('s_ee=s_e'+si) & ii=execute('nel=n_elements(s_'+si+')')
   ii=execute('s_p'+si+'=[[s_'+si+'],[p_rom_do_filter(s_'+si+',s_x'+si+',s_ee)],[s_x'+si+'],[fltarr(nel)+s_e'+si+'],[fltarr(nel)+s_ee]]')
   if j gt 0 then $
   if n_elements(s_pp) lt 2     then  s_pp=t4 $                        ;keep properties
   else begin & idx=where(s_pp[0,*] ne j) & if idx[0] ge 0 then s_pp=s_pp[*,idx]
                                      s_pp=[[s_pp],[t4]] & endelse
endif else $

; CHANGE-> filter<-> not filter (s_filter)
if keyword_set(change) and (s_filter) then begin
   FOR i=0,s_np do if szp[0,i] ge 2 then begin
       if szp[0,i] ge 3 then np=szp[3,i] else np=1
       si= strtrim(string(i),2)
       for ij=0,np-1 do begin
           res=execute('s_ee=s_p'+si+'[*,3,ij]')
           res=execute('s_p'+si+'[*,1,ij]=p_rom_do_filter(s_p'+si+'[*,0,ij],s_p'+si+'[*,2,ij],s_ee)')
           res=execute('s_p'+si+'[*,4,ij]=s_ee')
       endfor
   ENDIF
endif else $

; GET   -> restore s_pi into s_i
if n_elements(sget) eq 3 then begin & sp=sget[0] & np=sget[1] & sget[2]=0
   if szp[0,sp] ge 2 then begin
      if (np eq 1) or ((szp[0,sp] ge 3) and (szp[3,sp] ge np)) then begin & sget[2]=1 ;ok
          si= strtrim(string(sp),2)
          if  s_filter then n=1 else n=0 &             ii=execute('s_' +si+'=s_p'+si+'[*,n  ,np-1]')
          if (sp gt 0) then                            ii=execute('s_x'+si+'=s_p'+si+'[*,2  ,np-1]')
          if (sp gt 0) or (n_elements(s_e0) gt 1) then ii=execute('s_e'+si+'=s_p'+si+'[*,3+n,np-1]')
      endif
      if  n_elements(s_pp) gt 2 then begin  ;restore properties s_sym, s_err, s_cut_values, s_cut, s_off_arr, s_num_wrk
          idx=where(s_pp[0,*] eq sp)
          if (idx[0] ge 0) and (n_elements(idx) ge np) then begin & prop=s_pp[2:*,idx[np-1]]
              s_cut_values[sp]=prop[2]      ;restore properties for legend.....
              s_cut[sp]       =prop[3]
              s_off_arr[sp]   =prop[4]      ;!!!
              s_num_wrk[sp]   =prop[5]
      endif & endif
   endif
endif else $

; MIMAX -> return ymin,ymax,xmin,xmax
if n_elements(mimax) eq 5 then begin & si=strtrim(string(fix(mimax[0])),2) & mim=0. & mix=0. & xim=0. & xix=0.
   ii=execute('mim=min(s_p'+si+'[*,0,*],max=mix, /NaN)')
   ii=execute('xim=min(s_p'+si+'[*,2,*],max=xix)')
   mimax[1]=mim & mimax[2]=mix & mimax[3]=xim & mimax[4]=xix
endif else $

; CLEAR -> keep only one s_pi entry
if keyword_set(clear) then begin
   if s_filter then n=1 else n=0
   if szp1[0] eq 3 then begin & s_p1=s_p1[*,*,szp1[3]-1] & s_1=s_p1[*,n] & s_x1=s_p1[*,2] & s_e1=s_p1[*,3+n] & endif
   if szp2[0] eq 3 then begin & s_p2=s_p2[*,*,szp2[3]-1] & s_2=s_p2[*,n] & s_x2=s_p2[*,2] & s_e2=s_p2[*,3+n] & endif
   if szp3[0] eq 3 then begin & s_p3=s_p3[*,*,szp3[3]-1] & s_3=s_p3[*,n] & s_x3=s_p3[*,2] & s_e3=s_p3[*,3+n] & endif
   if szp4[0] eq 3 then begin & s_p4=s_p4[*,*,szp4[3]-1] & s_4=s_p4[*,n] & s_x4=s_p4[*,2] & s_e4=s_p4[*,3+n] & endif
   if szp5[0] eq 3 then begin & s_p5=s_p5[*,*,szp5[3]-1] & s_5=s_p5[*,n] & s_x5=s_p5[*,2] & s_e5=s_p5[*,3+n] & endif
   if szp6[0] eq 3 then begin & s_p6=s_p6[*,*,szp6[3]-1] & s_6=s_p6[*,n] & s_x6=s_p6[*,2] & s_e6=s_p6[*,3+n] & endif
   if szp7[0] eq 3 then begin & s_p7=s_p7[*,*,szp7[3]-1] & s_7=s_p7[*,n] & s_x7=s_p7[*,2] & s_e7=s_p7[*,3+n] & endif
   if szp8[0] eq 3 then begin & s_p8=s_p8[*,*,szp8[3]-1] & s_8=s_p8[*,n] & s_x8=s_p8[*,2] & s_e8=s_p8[*,3+n] & endif
   if szp9[0] eq 3 then begin & s_p9=s_p9[*,*,szp9[3]-1] & s_9=s_p9[*,n] & s_x9=s_p9[*,2] & s_e9=s_p9[*,3+n] & endif
   if n_elements(s_pp) gt 2 then begin
      s_pp=s_pp[sort(s_pp[0,*]),*] & s_pp=s_pp[*,uniq(s_pp[0,*])] & endif
endif
END

;*****************************************************************************
PRO p_rom_super_done ;********************************************************
;+
;** ****************
;** Called when Done Button is pushed
;-

@lamp.cbk
COMMON sc_superplot
common sc_superplot_did

IF s_color THEN $       ; if color table has been saved
        TVLCT, s_ctred,s_ctgreen,s_ctblue ; restore old color table
if lamp_b1 gt 0 then WIDGET_CONTROL,bad_id=i,sw_id0,map=0 ; Hide Super_Plot Window
if lamp_b1 le 0 then WIDGET_CONTROL,bad_id=i,sw_id0,/destroy
return
END

;*****************************************************************************
PRO p_rom_cleanup, id
;+
;** *************
;** Called when Superplot window is dying
;-

common sc_superplot
common sc_superplot_did

IF s_color then TVLCT, s_ctred, s_ctgreen, s_ctblue
END

;*****************************************************************************
PRO p_rom_redefine_slider, wid, value, maxi ;*********************************
;+
;** *********************
;** Redefine slider MAXImum and slide VALUE for the WID slider
;-

WIDGET_CONTROL, bad_id=i, wid, Set_Slider_Max = maxi
WIDGET_CONTROL, bad_id=i, wid, Set_Value = value
END

;*****************************************************************************
PRO p_rom_send_txt_wd, wid, str ;*********************************************
;+
;** *****************
;** Modifie STR value for the WID slider
;-

WIDGET_CONTROL, bad_id=i, wid, Set_Value = str
END

;*****************************************************************************
pro suprplot, widx, legende=ligende, xylW=xylW3  ;****************************
;+
;** ********
;** Create the Super_Plot interface.
;** widx is an optional default workspace number (between 1 and lamp_sys)
;-

@lamp.cbk                        ; call back the lamp common block
common sc_superdid               ; Array of boolean Set for psym
common sc_supordid               ; For XY limits and there widgets
common sc_supardid               ; # of keeps, more....
common sc_superplot              ; Call Back Super_Plot block
common sc_superplot_did
common sc_rom_filter

if (!D.flags and 95536)   eq 0 then print,'set_plot,"X" before using'  else begin

  if ((n_elements(ligende) gt 0) or (n_elements(xylW3) ge 3)) $
  and (xregistered('SUPER_PLOT',/noshow) gt 0) then widget_control,sw_id0,/destroy
    
  if xregistered('SUPER_PLOT') le 0 then BEGIN  ; If Super_Plot doesn't exist..
    ii=execute("P_MUS,'mus_harp'")              ; PLAY a tune
    ;*********************************************Create Widget tree

    winis=(sys_dep('MACHINE') eq 'win') & NP=6
    macis=(!version.os eq 'darwin')
    if !D.name ne 'NULL'  then begin & device,get_screen_size=screen
                                    if screen[0] ge 1024 then NP=7
                                    if screen[0] ge 1240 then NP=8
                                    if screen[0] gt 1500 then NP=9
                                    if screen[0] ge 1280 then if winis then NP=9
                                    if screen[0] ge 1240 then if macis then NP=9
    endif ;& NP=6
    ; -------------------------------------------- Variables initialisation
    s_np        = np             ; np=number of plots
    s_xcut      = 0              ; Cutting Y axis is default
    s_filter    = 0              ; Filter Off is default
    s_color     = 1              ; color or Black/White mode
    s_show_err  = 0              ; Show errors is off
    s_normalize = 0              ; Normalization Off
    s_cutall    = 0              ; cutting doesn't apply to all
    s_psymb     = 0              ; plot symbol (*) or not
    s_xmin      = 0              ; No X scale
    s_xmax      = 500            ; No X scale
    s_ctred     = 0              ; red
    s_ctgreen   = 0              ; green
    s_ctblue    = 0              ; blue
    s_scratio   = 500.           ; scale ratio range
    s_yscale    = s_scratio      ; no scale is default
    s_printno   = 1              ; next print number is 1
    s_lv        = 0              ; plot array for live_plot
    s_var1      = 0
    s_var2      = 0
    s_var3      = 0
    s_var4      = 0
    s_yoffset   = 0              ; no offset is default
    s_hid       =lonarr(np+1)+1  ; Set all hided flags on
    s_scl       =lonarr(np+1)+1  ; Set all scaled flags on
    s_sym       =lonarr(np+1)    ; Set all psym to 0
    s_err       =lonarr(np+1)    ; Set all show_error to 0
    s_hid2      =lonarr(np+1)    ; No plot hided (cutall)
    s_off_arr   =lonarr(np+1)-1  ; Offsetarray Inactive
    s_num_wrk   =lonarr(np+1)-1  ; Clear workspace number array
    s_cut       =lonarr(np+1)    ; cutting axis Y is default
    s_cut_values=lonarr(np+1)-1                 ; Clear cutting values
    s_0 =0   & s_1 =s_0 & s_2 =s_0 & s_3=s_0    ; Clear local Workspaces
    s_4 =s_0 & s_5 =s_0 & s_6 =s_0
    s_7 =s_0 & s_8 =s_0 & s_9 =s_0
    s_p0=s_0 & s_p1=s_0 & s_p2=s_0 & s_p3=s_0   ; Clear plotted Workspaces
    s_p4=s_0 & s_p5=s_0 & s_p6=s_0 & s_pp=s_0
    s_p7=s_0 & s_p8=s_0 & s_p9=s_0

    s_xylv   =fltarr(4)  & s_xylw=lonarr(8)     ; For XYW limits + YLog10 + Linear + XLog10 + Old log setting
    s_xylw[7]=0                                 ; 0 for new log setting (Axis keywords)
    lgnd_on  =[0,0]                             ; Legend on/off , position
    sc_f_fac =.1 & sc_f_wid=0.  & sc_f_cvr=-1   ; For Voigt filter
    sc_filt  =lonarr(8)  & sc_f_chg=0           ; For Voigt filter
    sc_f_stp =0.                                ; For Voigt filter

    sw_lab=lonarr(np) & sw_hid=lonarr(np) & sw_scl=lonarr(np) & sw_drw=lonarr(np+1) & sw_bts=sw_drw

    s_ddr        =[100,250, 20, 20,200,  5,250, 20,250,150] ;Predefined np+1 colors
    s_ddg        =[100, 20,250, 20,200,250, 10,150,150, 10]
    s_ddb        =[100, 20, 20,250,  0,250,250, 20,  5,150]

    IF N_ELEMENTS(widx) eq 0 then widx=0
    IF widx le 0 then s_wid='1' $
        ELSE s_wid= strtrim(string(widx),2)     ; sw_wid=current workspace number
    res=execute('s_siz=size(w'+s_wid+')')
    if s_siz[0] eq 1 or s_siz[0] eq 2 then s_hid[0]=0

    ; Get correct slider cut max
    s=[0L] & res = execute('s = size(y'+s_wid+')')
    if s[0] eq 2 then nb = s[2]-1 else nb = s[1]-1
    IF nb eq 0 then nb=1

    ; the whole lamp size depending modifications is here
    xsiz        =800     ;Default Width of SuperPlot Draw
    f_NP        =((NP-1)>6)/6.
    snapx       =140
    snapy       =92
    if lamp_siz ge 900 then ysiz=480 else ysiz=380
    if lamp_siz lt 800 then BEGIN       ; adapt help text to lamp size
        txt1 = 'Select Workspace you want to see, its cutting axis and cutting value.'
        txt2 = 'Fix it by pushing one of the "Keep ->" buttons. Press "HELP" for more'
        xsiz=480 & ysiz=250       ; adapt plotting window size
        txt3='Keep'               ; adapt text button
        txt4='Hide' & txt5='Scale'
        txt6='Hi'   & txt7='Sc' & txt8='___________' & sl_8=11
        sl_size=15
        sl_siz=xsiz
    ENDIF ELSE BEGIN
        txt1  = 'Select Workspace you want to see, its cutting axis and cutting value.'+ $
                'Fix it by pushing one of the "Keep ->" buttons. Press "HELP" for more'
        txt2  = ''
        txt3='Keep ->'
        txt4='Hide' & txt5='Scale'
        txt6='Hide' & txt7='Scale' & txt8='________________'
        if winis then sl_8=22  else  sl_8=16
        sl_size=16
        sl_siz=(xsiz-100) *f_NP
    ENDELSE
    sxsiz=xsiz & xsiz=xsiz*f_NP ;True Width of SuperPlot Draw

    ; --------------------------------- Create SUPER_PLOT Interface

    sw_id0      =WIDGET_BASE(  title='Lamp Super Plot (1995) Version: Aug 2015', $
                               Resource_Name='lampdon',/tlb_size_events,/kbrd_focus_events)
    sw_id       =WIDGET_BASE(  sw_id0,/column)
    sw_l        =WIDGET_LABEL( sw_id,Value=txt1 ,Font=ft_smaller)
    if txt2 ne '' then sw_l=WIDGET_LABEL( sw_id,Value=txt2 ,Font=ft_smaller)
    sw_b00      =WIDGET_BASE(  sw_id  ,/Row)
    sw_b0       =WIDGET_BASE(  sw_b00 ,/Column, /Frame)
    sw_b1       =WIDGET_BASE(  sw_b0  ,/Row)
    sw_sw       =WIDGET_SLIDER(sw_b1,Title='',Minimum=1,Maximum=lamp_sys,Value=s_wid,$
                               Font=ft_b_normal, Xsize=sl_siz-300, YSize=sl_size)
    sw_err      =WIDGET_LABEL( sw_b1,Value='---- Select your WorkSpace # ----',YSize=sl_size+15, $
                               Resource_Name='discret', Font=ft_b_normal)
    sw_b2       =WIDGET_BASE(  sw_b0  ,/Row)
    sw_scut     =WIDGET_SLIDER(sw_b2,Title='',Minimum=0+1,Maximum=nb+1,/Drag,$
                               Font=ft_b_normal,Xsize=sl_siz-300, YSize=sl_size)
    sw_bxy      =WIDGET_BASE(  sw_b2,/Row,/Exclusive)
    sw_btx      =WIDGET_BUTTON(sw_bxy ,Value='X',Font=ft_b_bigger,/No_Release)
    sw_bty      =WIDGET_BUTTON(sw_bxy ,Value='Y',Font=ft_b_bigger,/No_Release)
    sw_lcutv    =WIDGET_LABEL( sw_b2,Value='-----------------------',Font=ft_b_normal, $
                               Resource_Name='discret')
    if winis then bb=WIDGET_LABEL( sw_b00 ,Value=' '    ,Font=ft_propor )
    sw_b        =WIDGET_BASE(  sw_b00, /Frame, /Column)
    sw_lbt      =WIDGET_LABEL( sw_b,Value='Apply cut to',Font=ft_normal)
    sw_bb       =WIDGET_BASE(  sw_b,/Exclusive,/Column)
    sw_btone    =WIDGET_BUTTON(sw_bb,Value='current W'  ,Font=ft_smaller)
    sw_btall    =WIDGET_BUTTON(sw_bb,Value='ALL Wk.Sp.' ,Font=ft_smaller)
    if winis then bb=WIDGET_LABEL( sw_b00 ,Value=' '    ,Font=ft_propor )

    snapw       =WIDGET_DRAW(  sw_b00   ,Retain=2,Xsize=snapx,Ysize=snapy)

    if (winis) or (np gt 6) then begin
    sw_motio    =WIDGET_BASE(  sw_b00,/column)
    bid         =WIDGET_LABEL( sw_motio,Value='X & Y Cursor'       ,Font=ft_b_normal)
    sw_motx     =WIDGET_LABEL( sw_motio,Value='X= ................',Font=ft_normal)
    sw_moty     =WIDGET_LABEL( sw_motio,Value='Y= ................',Font=ft_normal)
    endif

    sw_b3       =WIDGET_BASE(  sw_id  ,/Column,Frame=2)
    sw_b31      =WIDGET_BASE(  sw_b3  ,/Row)

    FOR i=1,np do BEGIN
        sw_b311        =WIDGET_BASE(  sw_b31, /Column, /Frame)
        sw_b312        =WIDGET_BASE(  sw_b311,/Row)
        sw_bts[i-1]    =WIDGET_BUTTON(sw_b312,Value=txt3 ,Font=ft_b_normal,UValue=[-88,355,0,i,sw_scut,0])
        sw_drw[i-1]    =WIDGET_DRAW(  sw_b312, XSize=sxsiz/18+5, YSize=26 ,UValue=[-88,355,0,i,sw_scut,1],/button_event)
        if sys_dep('VERSION') ge 5.6 then widget_control,sw_bts[i-1],Tooltip='Keep one only'
        if sys_dep('VERSION') ge 5.6 then widget_control,sw_drw[i-1],Tooltip='Keep grouping (must have a uniq size)'
        sw_b3111=WIDGET_BASE(  sw_b311,/Row, /NonExclusive)
        IF i eq 1 then BEGIN
        sw_hid[0]      =WIDGET_BUTTON(sw_b3111,Value=txt4 ,Font=ft_normal, $
                          UValue=[-88,355,1,i], Resource_Name='discret')
        sw_scl[0]      =WIDGET_BUTTON(sw_b3111,Value=txt5 ,Font=ft_normal  , $
                          UValue=[-88,355,2,i], Resource_Name='discret')
        ENDIF ELSE BEGIN
        sw_hid[i-1]    =WIDGET_BUTTON(sw_b3111,Value=txt6 ,Font=ft_normal, $
                          UValue=[-88,355,1,i], Resource_Name='discret')
        sw_scl[i-1]    =WIDGET_BUTTON(sw_b3111,Value=txt7 ,Font=ft_normal  , $
                          UValue=[-88,355,2,i], Resource_Name='discret')
        ENDELSE
        sw_lab[i-1]    =WIDGET_TEXT(  sw_b311,Value=txt8, xsize=sl_8,Font=ft_smaller,/editable,uvalue=[-88,354,7])
        if winis then bb=WIDGET_LABEL( sw_b31 ,Value=' '            ,Font=ft_propor )
    ENDFOR

    if n_elements(sw_motio) eq 0 then begin
    sw_motio    =WIDGET_BASE(  sw_b31,/column)
    bid         =WIDGET_LABEL( sw_motio,Value='X & Y Cursor'       ,Font=ft_b_normal)
    sw_motx     =WIDGET_LABEL( sw_motio,Value='X= ................',Font=ft_normal)
    sw_moty     =WIDGET_LABEL( sw_motio,Value='Y= ................',Font=ft_normal)
    endif

    sw_b32      =WIDGET_BASE(  sw_b3    ,/Row)
    sw_b321     =WIDGET_BASE(  sw_b32   ,/Column)
    sw_ssc      =WIDGET_SLIDER(sw_b321  ,Title='' ,Minimum=1,Maximum=s_scratio,$
                               Value=s_scratio,/Suppress_Value,/Vertical,/Drag,$
                               YSize=ysiz,XSize=sl_size)

    sw_draw     =WIDGET_DRAW(  sw_b32   ,Retain=2,Xsize=xsiz,Ysize=ysiz,/motion_events,/button_event)
    sw_drw[s_np]=sw_draw
    sw_syoffset =WIDGET_SLIDER(sw_b32   ,Title='' ,Minimum=0,Maximum=100,Value=0,/Drag,$
                          /Suppress_Value,/Vertical,YSize=ysiz,XSize=sl_size)
    if (lamp_siz le 800) and (not winis) then $
         sw_b320=WIDGET_BASE(  sw_b32   ,/Column,y_scroll=ysiz-2*sl_size) $
    else sw_b320=WIDGET_BASE(  sw_b32   ,/Column)
    sw_b321     =WIDGET_BASE(  sw_b320  ,/Column,/frame)
    bidon       =WIDGET_LABEL( sw_b321  ,Value='X & Y Ranges',Font=ft_b_normal)
    bidon       =WIDGET_LABEL( sw_b321  ,Value='Y min',Font=ft_b_normal)
    s_xylw[0]   =WIDGET_TEXT(  sw_b321  ,Value=''     ,Font=ft_propor ,xsize=7,uvalue=[-88,354,7],/EDITABLE)
    bidon       =WIDGET_LABEL( sw_b321  ,Value='Y max',Font=ft_b_normal)
    s_xylw[1]   =WIDGET_TEXT(  sw_b321  ,Value=''     ,Font=ft_propor ,xsize=7,uvalue=[-88,354,7],/EDITABLE)
    if (lamp_siz ge 900) and (winis) then $
    bidon       =WIDGET_LABEL( sw_b321  ,Value='     ',Font=ft_b_normal)
    bidon       =WIDGET_LABEL( sw_b321  ,Value='X min',Font=ft_b_normal)
    s_xylw[2]   =WIDGET_TEXT(  sw_b321  ,Value=''     ,Font=ft_propor ,xsize=7,uvalue=[-88,354,7],/EDITABLE)
    bidon       =WIDGET_LABEL( sw_b321  ,Value='X max',Font=ft_b_normal)
    s_xylw[3]   =WIDGET_TEXT(  sw_b321  ,Value=''     ,Font=ft_propor ,xsize=7,uvalue=[-88,354,7],/EDITABLE)

    if (lamp_siz ge 900) and (winis) then $
    bidon       =WIDGET_LABEL( sw_b320  ,Value=''     ,Font=ft_b_normal)

    sw_b322     =WIDGET_BASE(  sw_b320  ,/Column,/frame)
    bidon       =WIDGET_LABEL( sw_b322  ,Value='- FILTER -' ,Font=ft_b_normal)
    wsmoo       =WIDGET_BASE(  sw_b322  ,/exclusive,/column)
    sc_filt[5]  =WIDGET_BUTTON(wsmoo    ,Value='smooth'     ,Font=ft_b_normal,uvalue=[-88,354,9,1],/no_release)
    sc_filt[0]  =WIDGET_BUTTON(wsmoo    ,Value='p.Voigt'    ,Font=ft_b_normal,uvalue=[-88,354,9,2],/no_release)
    sc_filt[1]  =WIDGET_LABEL( sw_b322  ,Value='Lor:1 Gau:0',Font=ft_b_normal)
    sc_filt[2]  =WIDGET_TEXT(  sw_b322  ,Value=' 0.1 '      ,Font=ft_propor ,xsize=7,uvalue=[-88,354,8],/EDITABLE)
    sc_filt[3]  =WIDGET_LABEL( sw_b322  ,Value='Kernel >= 3',Font=ft_b_normal)
    sc_filt[4]  =WIDGET_TEXT(  sw_b322  ,Value='  3  '      ,Font=ft_propor ,xsize=7,uvalue=[-88,354,8],/EDITABLE)
    widget_control,sc_filt[5],set_button=1 & sc_filt[6]=1 & sc_filt[7]=3
    widget_control,sc_filt[5],sens=1
    widget_control,sc_filt[0],sens=0 & widget_control,sc_filt[1],sens=0 & widget_control,sc_filt[2],sens=0


    sw_b33      =WIDGET_BASE(  sw_b3    ,/Row)
    sw_basebt   =WIDGET_BASE(  sw_b33  , /NonExclusive)
    sw_btscl0   =WIDGET_BUTTON(sw_basebt, Value='', XSize=sl_size)
    sw_sxmin    =WIDGET_SLIDER(sw_b33,Title='X_min' ,Minimum=0,Maximum=499,/Drag, $
                          Value=0 ,/Suppress_Value,Xsize=xsiz/2, $
                          YSize=sl_size, Font=ft_b_normal)
    sw_sxmax    =WIDGET_SLIDER(sw_b33,Title='X_max' ,Minimum=1,Maximum=500,/Drag, $
                          Value=500,/Suppress_Value,Xsize=xsiz/2, $
                          YSize=sl_size, Font=ft_b_normal)
;    sw_basebt  =WIDGET_BASE  (sw_b33  , /NonExclusive)
;    sw_btidx   =WIDGET_BUTTON(sw_basebt, Value='idx');, XSize=sl_size)

    sw_b33      =WIDGET_BASE(  sw_b3   ,/row)
    sw_btco     =WIDGET_BUTTON(sw_b33  ,Value='Reset', Font=ft_b_normal, $
                          UValue=[-88,355,3,sw_syoffset,sw_ssc,sw_sxmin,sw_sxmax])
    sw_btp      =WIDGET_BUTTON(sw_b33  ,Value='Print'    , Font=ft_b_normal, $
                          UValue=[-88,356,0])
    sw_bta      =WIDGET_BUTTON(sw_b33  ,Value='Annot.tools' , Font=ft_b_normal)
    sw_b331     =WIDGET_BASE(  sw_b33  ,/Row, /NonExclusive)
    sw_btn      =WIDGET_BUTTON(sw_b331 ,Value='Norm', $
                          Font=ft_b_normal,UValue=[-88,355,4])
    sw_btnly    =WIDGET_BUTTON(sw_b331 ,Value='Ylog', $
                          Font=ft_b_normal,UValue=[-88,355,9])
    sw_btnl     =WIDGET_BUTTON(sw_b331 ,Value='Xlog', $
                          Font=ft_b_normal,UValue=[-88,355,11,0L])
    sw_btidx    =WIDGET_BUTTON(sw_b331 ,Value='Linear', $
                          Font=ft_b_normal,UValue=[-88,355,10,sw_btnl])
                WIDGET_CONTROL,sw_btnl     ,set_Uvalue=[-88,355,11,sw_btidx]
    sw_btf      =WIDGET_BUTTON(sw_b331 ,Value='Filter', $
                          Font=ft_b_normal,UValue=[-88,355,5])
    sw_btc      =WIDGET_BUTTON(sw_b331 ,Value='Color', $
                          Font=ft_b_normal,UValue=[-88,355,6])
    sw_pltsymb  =WIDGET_BUTTON(sw_b331 ,Value='Symb', $
                          Font=ft_b_normal,UValue=[-88,355,8])
    sw_bterr    =WIDGET_BUTTON(sw_b331 ,Value='Err', $
                          Font=ft_b_normal,UValue=[-88,355,7])
   ;logs
    if n_elements(xylW3) ge 3 then begin & s_xylw[6] =xylW3[0] & s_xylw[4]=xylW3[1] & s_xylw[5]=xylW3[2] & endif
    if n_elements(xylW3) ge 4 then       s_show_err=xylW3[3] ; error
    if n_elements(xylW3) ge 5 then       s_psymb   =xylW3[4] ;symbol
    
    WIDGET_CONTROL,sw_btnly  ,set_button=s_xylw[4]  ;Y log
    WIDGET_CONTROL,sw_btnl   ,set_button=s_xylw[6]  ;X log
    WIDGET_CONTROL,sw_btidx  ,set_button=s_xylw[5]  ;linear
    WIDGET_CONTROL,sw_btc    ,set_button=s_color    ;color
    WIDGET_CONTROL,sw_pltsymb,set_button=s_psymb    ;symbol
    WIDGET_CONTROL,sw_bterr  ,set_button=s_show_err ;error

    if NP gt 6 then begin
    sw_blgnd    =WIDGET_BUTTON(sw_b33  ,Value='Legend'      , Font=ft_b_normal,/menu)
         bid    =WIDGET_BUTTON(sw_blgnd,Value='ON/OFF'      , Font=ft_b_normal,UValue=[-88,355,12,-1])
         bid    =WIDGET_BUTTON(sw_blgnd,Value='LEFT  TOP'   , Font=ft_b_normal,UValue=[-88,355,12, 0])
         bid    =WIDGET_BUTTON(sw_blgnd,Value='LEFT  BOTTOM', Font=ft_b_normal,UValue=[-88,355,12, 1])
         bid    =WIDGET_BUTTON(sw_blgnd,Value='RIGHT TOP'   , Font=ft_b_normal,UValue=[-88,355,12, 2])
         bid    =WIDGET_BUTTON(sw_blgnd,Value='RIGHT BOTTOM', Font=ft_b_normal,UValue=[-88,355,12, 3])
         bid    =WIDGET_BUTTON(sw_blgnd,Value='')
         bid    =WIDGET_BUTTON(sw_blgnd,Value='To modify the legend, edit the text')
         bid    =WIDGET_BUTTON(sw_blgnd,Value='fields under the Keep buttons.')
    endif
    sw_btpng    =WIDGET_BUTTON(sw_b33  ,Value='Png', $
                          Font=ft_b_normal,UValue=[-88,356,4])
    sw_btmpeg   =WIDGET_BUTTON(sw_b33  ,Value='Mpeg', $
                          Font=ft_b_normal,UValue=[-88,356,5])
    sw_bthelp   =WIDGET_BUTTON(sw_b33  ,Value='Help' ,$
                       Font=ft_b_normal,UValue=[-88,591,0])
    sw_btdone   =WIDGET_BUTTON(sw_b33  ,Value='Done' , $
                          Font=ft_b_normal,UValue=[-88,356,1])
                ii=execute('put_logo,sw_b33')

   ;if sys_dep('EMBEDDED') then if (NOT LMGR('idl_mpeg',VERSION='1.0')) then $
   ;widget_control,sw_btmpeg,sensitive=0

    ; ************Set UValues to permit widget id knowledge in parsed procedures
    WIDGET_CONTROL,bad_id=i,sw_sw ,Set_UValue= $
                     [-88,353,0,sw_scut,sw_lcutv,sw_btx,sw_bty,sw_b2,sw_sw]
    WIDGET_CONTROL,bad_id=i,sw_scut ,Set_UValue= $
                     [-88,353,1,sw_scut,sw_lcutv,sw_btx,sw_bty,sw_b2,sw_sw]
    WIDGET_CONTROL,bad_id=i,sw_btx ,Set_UValue= $
                     [-88,353,2,sw_scut,sw_lcutv,sw_btx,sw_bty,sw_b2,sw_sw]
    WIDGET_CONTROL,bad_id=i,sw_bty ,Set_UValue= $
                     [-88,353,3,sw_scut,sw_lcutv,sw_btx,sw_bty,sw_b2,sw_sw]
    WIDGET_CONTROL,bad_id=i,sw_btone ,Set_UValue= $
                     [-88,354,4,sw_scut,sw_lcutv,sw_btx,sw_bty,sw_b2,sw_sw]
    WIDGET_CONTROL,bad_id=i,sw_btall ,Set_UValue= $
                     [-88,354,5,sw_scut,sw_lcutv,sw_btx,sw_bty,sw_b2,sw_sw]

    ; --------------------------------- Set correct UValues
    WIDGET_CONTROL, bad_id=i, sw_sxmin   , Set_UValue=[-88,354,0,sw_sxmax]
    WIDGET_CONTROL, bad_id=i, sw_sxmax   , Set_UValue=[-88,354,1,sw_sxmin]
    WIDGET_CONTROL, bad_id=i, sw_ssc     , Set_UValue=[-88,354,2]
    WIDGET_CONTROL, bad_id=i, sw_syoffset, Set_UValue=[-88,354,3]
    WIDGET_CONTROL, bad_id=i, sw_btscl0  , Set_UValue=[-88,354,6,sw_btscl0]

    WIDGET_CONTROL, bad_id=i, sw_id0      , Set_UValue=[-88,355,6,sw_sw]

    ; --------------------------------- Construct Widget Tree
    ii=execute("bid=sys_dep('DYNLAB', sw_id, 1)")

    WIDGET_CONTROL,bad_id=i,sw_id0, Group_Leader=lamp_b1, /Realize & ii=execute('put_logo')

    ; --------------------------------- Get the Window id of draw widget
    WIDGET_CONTROL,bad_id=i,sw_draw,Get_Value =s_wset
    WIDGET_CONTROL,bad_id=i,sw_draw,Set_UValue=[-88,356,2,sw_motx,sw_moty]
    ; --------------------------------- Set correct UValue for Annotate Button
    if !version.release ge '5.1' then $
    WIDGET_CONTROL,bad_id=i,sw_bta,Set_UValue=[-88,356,3] else $
    WIDGET_CONTROL,bad_id=i,sw_bta,Set_UValue=[-88,346, s_wset ]
    ; --------------------------------- set cut 'Y' button on
    WIDGET_CONTROL,bad_id=i,sw_bty ,/Set_Button
    ; --------------------------------- set btone button on
    WIDGET_CONTROL,bad_id=i,sw_btone ,/Set_Button
    ; --------------------------------- set all SCALED Buttons to on
    FOR j=0,s_np-1 do WIDGET_CONTROL,bad_id=i,sw_scl[j] ,/Set_Button
    ; --------------------------------- Draw lines into widget draws
    TVLCT,  s_ctred, s_ctgreen, s_ctblue,/GET
    tmp=fix(s_ctred)+s_ctgreen +s_ctblue
    pop=min(tmp) & ccol=!C
    pup=max(tmp) & bcol=!C
    FOR j=0,s_np-1 do BEGIN
        WIDGET_CONTROL,bad_id=i,sw_drw[j] ,Get_Value = w
        wset, w & erase, bcol
        PLOTS, 0,13, /Device
        PLOTS, FIndGen(49), SIN(FIndGen(49)/7)*10+13, /Continue, Color=ccol,LineStyle=(j mod 6)  ,/Device
        PLOTS, 0,11, /Device
        if j gt 5 then $
        PLOTS, FIndGen(49), SIN(FIndGen(49)/7)*10+11, /Continue, Color=ccol,LineStyle=(j mod 6)+1,/Device
        xyouts,0,7,'->',color=ccol,charsize=1.,font=0,/device
    ENDFOR

    WIDGET_CONTROL,bad_id=i,snapw,Get_Value=snapw & wset,snapw & erase,bcol & snapall=[snapw,snapx,snapy,0,0,0,0,0]

    gm0=widget_info(  sw_id0 ,/geometry) & b0x=gm0.scr_xsize & b0y=gm0.scr_ysize

    b_redim={ori_win1:[xsiz,ysiz],cur_win1:[xsiz,ysiz],ori_bas0:[b0x,b0y],cur_bas0:[b0x,b0y],winb:sw_draw,wins:s_wset}

    ; --------------------------------- Send all Widget tree to Lamp Parser
    IF lamp_b1 gt 0  THEN $
    XMANAGER, 'SUPER_PLOT' ,sw_id0,event_handler='LAMP_EVENT_PARSER', $
                           /Just_Reg, Cleanup='p_rom_cleanup', /NO_BLOCK
    ; --------------------------------- END OF INTERFACE GENESIS

    ; --------------------------------- Generate a slider W event to
    ; --------------------------------- have a plot immediatly

    WIDGET_CONTROL,bad_id=i,sw_sw   ,Get_UValue= v
    p_rom_super_select,v,2

    if n_elements(xylW3) ge 6 then if xylW3[5] gt 1 then begin ;Keep some
       WIDGET_CONTROL,/hourglass
       WIDGET_CONTROL,bad_id=i,sw_id0  ,MAP=0
       WIDGET_CONTROL,bad_id=i,sw_scut ,Get_UValue= test
       eventS={WIDGET_BUTTON,ID:sw_bts[0],TOP:sw_id0,HANDLER:sw_id0,SELECT:1}
       nx=xylW3[5]<NP
       for i=1,nx do begin
           WIDGET_CONTROL,sw_scut    ,SET_VALUE =i
           WIDGET_CONTROL,sw_bts[i-1],GET_UVALUE=uv
           P_rom_super_select,test,1
           eventS.ID=sw_bts[i-1]
           P_rom_super_event, eventS, uv
       endfor
       if xylW3[5] le 9 then lgnd_on[0:1]=[1,2]
       WIDGET_CONTROL,bad_id=i,sw_id0  ,MAP=1
    endif

    IF lamp_b1 le 0  THEN XMANAGER, 'SUPER_PLOT' ,sw_id0,$
                       event_handler='LAMP_EVENT_PARSER',Cleanup='p_rom_cleanup', /NO_BLOCK

  ENDIF ELSE BEGIN ;Xregistered=1
    IF n_elements(widx) eq 1 then if (widx ge 1) and (widx le lamp_sys) then begin
       widget_control,sw_id0  ,get_Uvalue=uvdid
       widget_control,uvdid[3],set_value =widx
       widget_control,uvdid[3],get_Uvalue=v & p_rom_super_select,v,2
    ENDIF
    WIDGET_CONTROL,bad_id=i,sw_id0,map=1,iconify=0 ; and show existing Multi_Plot
  ENDELSE
  ; if color mode is on, set best color table
  IF s_color then begin & TVLCT, s_ddr , s_ddg   , s_ddb ,2
                      FOR j=0,s_np-1 do BEGIN
                          WIDGET_CONTROL,bad_id=i,sw_drw[j] ,Get_Value = w
                          wset, w & ERASE, j+3 & endfor
  ENDIF
  p_rom_super_plot,0  ;redraw
ENDELSE ;No window server
RETURN
END
