pro Show_Version, wid, version, bil
;+
;** ************
;** return lamp version , keep some pseudo colors for lamp windows at start
;-
@lamp.cbk
    version='01 Jan 2016 for Idl -> 8.5' 

    if wid gt 0 then begin
     bil=widget_base( wid,/row)
     bid   =widget_label( bil  ,value='Version '+version            ,font=ft_smaller)
     bid   =widget_label( bil  ,value='.',resource_name='spelab1'   ,font=ft_smaller)
     bid   =widget_label( bil  ,value='.',resource_name='spelab2'   ,font=ft_smaller)
     bid   =widget_label( bil  ,value='.',resource_name='spelab3'   ,font=ft_smaller)
     bid   =widget_label( bil  ,value='.',resource_name='spelab4'   ,font=ft_smaller)
     bid   =widget_label( bil  ,value='.',resource_name='spelab5'   ,font=ft_smaller)
     bid   =widget_label( bil  ,value='.',resource_name='spelab6'   ,font=ft_smaller)
     bid   =widget_label( bil  ,value='.',resource_name='spelab7'   ,font=ft_smaller)
     bid   =widget_label( bil  ,value='.',resource_name='spelab8'   ,font=ft_smaller)
     bid   =widget_label( bil  ,value='.',resource_name='spelab9'   ,font=ft_smaller)
    endif
end

function finefile, pth, count=nn
;+
;*******
;** Pb MacosX (duplicated)
;-
if !version.release gt '5.5' then return,call_function('file_search',pth,count=nn) $
                             else return,call_function('findfile'   ,pth,count=nn)
end

;** *********************
;** *********************
;**        *** ****
           PRO LAMP_,just
;+
;**        *** ****
;** *********************
;** *********************
;**     LARGE ARRAY MANIPULATION PROGRAM
;**     ----- ----- ------------ -------
;** This module manages the LAMP application.
;** It is written at ILL Grenoble (www.ill.eu) by
;**                   M. Ferrand  for data integrity
;**                   G. Kearley  for users  integrity
;**                   D. Richard  for project  integrity
;**                   B. Vettier  for excellent functions
;**                   R. Jouffrey for wonderfull superplot
;** The LAMP package is distributed as "Shareware". If you find this application
;** useful, you may register your copy simply by sending an electronic mail
;** message to lamp@ill.eu. We would gratefully appreciate any feedback on the
;** LAMP application.
;-

;*  Is LAMP already managed ...
;*  -- ---- ------- -------
@lamp.cbk
common for_users,   a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z

  if n_elements(just)    ne 1 then just=''
  if (!D.name eq 'NULL') and (just ne 'just')              then LAMP_B
  if n_elements(lamp_focus) eq 1 then if lamp_focus eq -1  then LAMP_B

  if n_elements(lamp_b1) gt 0 then ii=xregistered('LAMP') else ii=0
  if ii eq 0 then                  ii=xregistered('TOUCH')
  if ii eq 0 then                  ii=xregistered('TRIPX')
  if ii gt 0 then if just ne 'just' then ii=widget_info(lamp_b1,/realize)
  if ii gt 0 then begin & if sys_dep('VERSION') le 5.0 then XMANAGER
  endif else begin

;***************************************
    if !D.name ne 'NULL' then ii=sys_dep('PSEUDO')
;***************************************
    !quiet=1
    p_screen
    if n_elements(lamp_dir) eq 0 then lamp_dir=sys_dep('GETENV','LAMP_DIR')

;** Workspaces
;** ----------
;** Wi      = input data and manipulated data
;** wtb(i)  = 0 each time the contents of Wi is modified and set to 1 on display
;** wintb(i)= used by Scan

    w1 =0 & w2 =0 & w3 =0 & w4 =0 & w5 =0 & w6 =0 & w7 =0 & w8 =0 & w9 =0 & w10=0
    w11=0 & w12=0 & w13=0 & w14=0 & w15=0 & w16=0 & w17=0 & w18=0 & w19=0 & w20=0
    w21=0 & w22=0 & w23=0 & w24=0 & w25=0 & w26=0 & w27=0 & w28=0 & w29=0 & w30=0
    w31=0 & w32=0 & w33=0 & w34=0 & w35=0 & w36=0 & w37=0 & w38=0 & w39=0 & w40=0
    w41=0 & w42=0 & w43=0 & w44=0 & w45=0 & w46=0 & w47=0 & w48=0 & w49=0 & w50=0
    w51=0 & w52=0 & w53=0 & w54=0 & w55=0 & w56=0 & w57=0 & w58=0 & w59=0 & w60=0
    w61=0 & w62=0 & w63=0
    w_in =0 & w_out=0 & w_buf=0

   ;Actually 60 Workspaces (check also commons in W_store...)
    if n_elements(lamp_sys) ne 1 then lamp_sys=40L ;old lamp.cbk
    wn      =lamp_sys+3+1

    wtb  =bytarr(wn) & wtb[  *]= 0
    wintb=intarr(wn) & wintb[*]=-1

    w_min  =fltarr(wn)
    w_max  =fltarr(wn)
    w_numor=strarr(wn) & w_numor[0]='lamp.ps'

;** Titles
;** ------
    x_tit    =strarr(wn)
    y_tit    =strarr(wn)
    z_tit    =strarr(wn)
    w_tit    =strarr(wn)
    other_tit=strarr(wn)
    head_tit =strarr(wn,10)

;** Pi     = set of scalars used in interactive commands (data parameters)
;** --
    p0 =0 & p1 =0 & p2 =0 & p3 =0 & p4 =0 & p5 =0 & p6 =0 & p7 =0 & p8 =0 & p9 =0 & p10=0
    p11=0 & p12=0 & p13=0 & p14=0 & p15=0 & p16=0 & p17=0 & p18=0 & p19=0 & p20=0
    p21=0 & p22=0 & p23=0 & p24=0 & p25=0 & p26=0 & p27=0 & p28=0 & p29=0 & p30=0
    p31=0 & p32=0 & p33=0 & p34=0 & p35=0 & p36=0 & p37=0 & p38=0 & p39=0 & p40=0
    p41=0 & p42=0 & p43=0 & p44=0 & p45=0 & p46=0 & p47=0 & p48=0 & p49=0 & p50=0
    p51=0 & p52=0 & p53=0 & p54=0 & p55=0 & p56=0 & p57=0 & p58=0 & p59=0 & p60=0
    p61=0 & p62=0 & p63=0
    p_in =0 & p_out=0 & p_buf=0

    pv0 =0 & pv1 =0 & pv2 =0 & pv3 =0 & pv4 =0 & pv5 =0 & pv6 =0 & pv7 =0 & pv8 =0 & pv9 =0 & pv10=0
    pv11=0 & pv12=0 & pv13=0 & pv14=0 & pv15=0 & pv16=0 & pv17=0 & pv18=0 & pv19=0 & pv20=0
    pv21=0 & pv22=0 & pv23=0 & pv24=0 & pv25=0 & pv26=0 & pv27=0 & pv28=0 & pv29=0 & pv30=0
    pv31=0 & pv32=0 & pv33=0 & pv34=0 & pv35=0 & pv36=0 & pv37=0 & pv38=0 & pv39=0 & pv40=0
    pv41=0 & pv42=0 & pv43=0 & pv44=0 & pv45=0 & pv46=0 & pv47=0 & pv48=0 & pv49=0 & pv50=0
    pv51=0 & pv52=0 & pv53=0 & pv54=0 & pv55=0 & pv56=0 & pv57=0 & pv58=0 & pv59=0 & pv60=0
    pV61=0 & pv62=0 & pv63=0
    pv_in =0 & pv_out=0 & pv_buf=0

    if  n_elements(npars) eq 0 then npars=200L
    par_txt=strarr(wn ,npars)
    par_txt_all=strarr(npars)

;** Motif
;** -----

    p_set_font,0

;   Stuff for data transformations
;** ----- --- ---- ---------------
    x0 =0 & x1 =0 & x2 =0 & x3 =0 & x4 =0 & x5 =0 & x6 =0 & x7 =0 & x8 =0 & x9 =0
    x10=0 & x11=0 & x12=0 & x13=0 & x14=0 & x15=0 & x16=0 & x17=0 & x18=0
    x19=0 & x20=0 & x21=0 & x22=0 & x23=0 & x24=0 & x25=0 & x26=0 & x27=0 & x28=0 & x29=0 & x30=0
    x31=0 & x32=0 & x33=0 & x34=0 & x35=0 & x36=0 & x37=0 & x38=0 & x39=0 & x40=0
    x41=0 & x42=0 & x43=0 & x44=0 & x45=0 & x46=0 & x47=0 & x48=0 & x49=0 & x50=0
    x51=0 & x52=0 & x53=0 & x54=0 & x55=0 & x56=0 & x57=0 & x58=0 & x59=0 & x60=0
    x61=0 & x62=0 & x63=0
    x_in =0 & x_out=0 & x_buf=0

    y0 =0 & y1 =0 & y2 =0 & y3 =0 & y4 =0 & y5 =0 & y6 =0 & y7 =0 & y8 =0 & y9 =0
    y10=0 & y11=0 & y12=0 & y13=0 & y14=0 & y15=0 & y16=0 & y17=0 & y18=0
    y19=0 & y20=0 & y21=0 & y22=0 & y23=0 & y24=0 & y25=0 & y26=0 & y27=0 & y28=0 & y29=0 & y30=0
    y31=0 & y32=0 & y33=0 & y34=0 & y35=0 & y36=0 & y37=0 & y38=0 & y39=0 & y40=0
    y41=0 & y42=0 & y43=0 & y44=0 & y45=0 & y46=0 & y47=0 & y48=0 & y49=0 & y50=0
    y51=0 & y52=0 & y53=0 & y54=0 & y55=0 & y56=0 & y57=0 & y58=0 & y59=0 & y60=0
    y61=0 & y62=0 & y63=0
    y_in =0 & y_out=0 & y_buf=0

    z0 =0 & z1 =0 & z2 =0 & z3 =0 & z4 =0 & z5 =0 & z6 =0 & z7 =0 & z8 =0 & z9 =0
    z10=0 & z11=0 & z12=0 & z13=0 & z14=0 & z15=0 & z16=0 & z17=0 & z18=0
    z19=0 & z20=0 & z21=0 & z22=0 & z23=0 & z24=0 & z25=0 & z26=0 & z27=0 & z28=0 & z29=0 & z30=0
    z31=0 & z32=0 & z33=0 & z34=0 & z35=0 & z36=0 & z37=0 & z38=0 & z39=0 & z40=0
    z41=0 & z42=0 & z43=0 & z44=0 & z45=0 & z46=0 & z47=0 & z48=0 & z49=0 & z50=0
    z51=0 & z52=0 & z53=0 & z54=0 & z55=0 & z56=0 & z57=0 & z58=0 & z59=0 & z60=0
    z61=0 & z62=0 & z63=0
    z_in =0 & z_out=0 & z_buf=0

    e0 =0 & e1 =0 & e2 =0 & e3 =0 & e4 =0 & e5 =0 & e6 =0 & e7 =0 & e8 =0 & e9 =0
    e10=0 & e11=0 & e12=0 & e13=0 & e14=0 & e15=0 & e16=0 & e17=0 & e18=0
    e19=0 & e20=0 & e21=0 & e22=0 & e23=0 & e24=0 & e25=0 & e26=0 & e27=0 & e28=0 & e29=0 & e30=0
    e31=0 & e32=0 & e33=0 & e34=0 & e35=0 & e36=0 & e37=0 & e38=0 & e39=0 & e40=0
    e41=0 & e42=0 & e43=0 & e44=0 & e45=0 & e46=0 & e47=0 & e48=0 & e49=0 & e50=0
    e51=0 & e52=0 & e53=0 & e54=0 & e55=0 & e56=0 & e57=0 & e58=0 & e59=0 & e60=0
    e61=0 & e62=0 & e63=0
    e_in =0 & e_out=0 & e_buf=0

    n0 =0 & n1 =0 & n2 =0 & n3 =0 & n4 =0 & n5 =0 & n6 =0 & n7 =0 & n8 =0 & n9 =0
    n10=0 & n11=0 & n12=0 & n13=0 & n14=0 & n15=0 & n16=0 & n17=0 & n18=0
    n19=0 & n20=0 & n21=0 & n22=0 & n23=0 & n24=0 & n25=0 & n26=0 & n27=0 & n28=0 & n29=0 & n30=0
    n31=0 & n32=0 & n33=0 & n34=0 & n35=0 & n36=0 & n37=0 & n38=0 & n39=0 & n40=0
    n41=0 & n42=0 & n43=0 & n44=0 & n45=0 & n46=0 & n47=0 & n48=0 & n49=0 & n50=0
    n51=0 & n52=0 & n53=0 & n54=0 & n55=0 & n56=0 & n57=0 & n58=0 & n59=0 & n60=0
    n61=0 & n62=0 & n63=0
    n_in =0 & n_out=0 & n_buf=0

    par0 =0 & par1 =0 & par2 =0 & par3 =0 & par4 =0 & par5 =0 & par6 =0 & par7 =0 & par8 =0
    par9 =0 & par10=0 & par11=0 & par12=0 & par13=0 & par14=0 & par15=0 & par16=0
    par17=0 & par18=0 & par19=0 & par20=0 & par21=0 & par22=0 & par23=0 & par24=0
    par25=0 & par26=0 & par27=0 & par28=0 & par29=0 & par30=0 & par31=0 & par32=0
    par33=0 & par34=0 & par35=0 & par36=0 & par37=0 & par38=0 & par39=0 & par40=0
    par41=0 & par42=0 & par43=0 & par44=0 & par45=0 & par46=0 & par47=0 & par48=0
    par49=0 & par50=0 & par51=0 & par52=0 & par53=0 & par54=0 & par55=0 & par56=0
    par57=0 & par58=0 & par59=0 & par60=0 & par61=0 & par62=0 & par63=0

    Sna0 =0 & Sna1 =0 & Sna2 =0 & Sna3 =0 & Sna4 =0 & Sna5 =0 & Sna6 =0 & Sna7 =0 & Sna8 =0
    Sna9 =0 & Sna10=0 & Sna11=0 & Sna12=0 & Sna13=0 & Sna14=0 & Sna15=0 & Sna16=0 & Sna17=0
    Sna18=0 & Sna19=0 & Sna20=0 & Sna21=0 & Sna22=0 & Sna23=0 & Sna24=0 & Sna25=0 & Sna26=0
    Sna27=0 & Sna28=0 & Sna29=0 & Sna30=0 & Sna31=0 & Sna32=0 & Sna33=0 & Sna34=0 & Sna35=0
    Sna36=0 & Sna37=0 & Sna38=0 & Sna39=0 & Sna40=0 & Sna41=0 & Sna42=0 & Sna43=0 & Sna44=0
    Sna45=0 & Sna46=0 & Sna47=0 & Sna48=0 & Sna49=0 & Sna50=0 & Sna51=0 & Sna52=0 & Sna53=0
    Sna54=0 & Sna55=0 & Sna56=0 & Sna57=0 & Sna58=0 & Sna59=0 & Sna60=0 & Snapix=0

;   Stuff for DIALS
;** ----- --- -----
    d0 =0 & d1 =0 & d2 =0 & d3 =0 & d4 =0 & d5 =0 & d6 =0 & d7 =0 & d8 =0 & d9 =0
    d10=0 & d11=0 & d12=0 & d13=0 & d14=0 & d15=0 & d16=0 & d17=0 & d18=0
    d19=0 & d20=0 & d21=0 & d22=0 & d23=0
    dial_ini=0
    duduch1 =0
    duduch2 =0
    duduch3 =''
    proxcod =''
    if  n_elements(GEORGE) eq 0 then GEORGE=0

;   W info's
;** --------
    lamp_devps=''
    lamp_dvd  =sys_dep('DIVIDER')
    ihis      =0
    his_info  =0
    his       =strarr(wn+1) & his[ *] =' ' & his[ wn]='.'
    lims      =strarr(wn+1) & lims[*] =' ' & lims[wn]='.'
    histxt    =strarr(1)
    limtxt    =strarr(1)
    tolerance =0. & toler=0. & monimon=-1
    inst_value='    '
    inst_group=''
    cycle     ='  ????  '
    one=1 & two=0 & three=0 & alone=0

    if (just ne 'just') then begin
;** User Directory
;** ---- ---------
@dons.cbk
      basem=widget_base( title='Lamp',/column,resource_name='lamp')
      bidon=widget_label(basem,value='-LARGE ARRAY MANIPULATION PROGRAM-',font=ft_biggest)
      Show_Version,basem
      w0=2
      LOGO,w0 & pax1=size(w0)
      bidon=widget_base( basem,/row)
      bicon=widget_draw( bidon,retain=2,xsize=pax1[1],ysize=pax1[2]    ,colors=-30)
      bidon=widget_label(basem,value='                               ' ,font=ft_normal)
      basm1=widget_base( basem,       /column)
      basm2=widget_base( basem,       /column)
      basm3=widget_label(basem,value='__________________________________________' ,font=ft_biggest)
      bid=sys_dep('DYNLAB',basem,1)
      widget_control,bad_id=ii  ,basem,/realize
      widget_control,bad_id=ii  ,bicon,get_value=pax4 & wset,pax4
      tvscl,w0,0,0 & pax2=0   &  pax3=pax1[1]

      lamp_user =''  & lamp_user =STRLOWCASE(sys_dep('GETENV','USER'))
           host =''  &      host =STRLOWCASE(sys_dep('GETENV','HOST'))
      instrument=''  & instrument=STRLOWCASE(sys_dep('GETENV','INSTRUMENT'))
                       if instrument gt ' ' then inst_value=instrument
      cd,current=mee & sl=strlen(host)+1
      path='lambda'  & sp=strlen(path)+1
;           ******
    if n_elements(file_found) ne 1 then file_found='' ;file_found may contain a session file to restore
    if file_found le ' ' then $
    if (lamp_user eq path) or (strpos(mee,path,/reverse_search) ge (strlen(mee)-sp))    or $
                             ((strpos(mee,host,/reverse_search) ge (strlen(mee)-sl)>0 ) and (sl gt 2)) then begin
    mess=widget_label( basm1,value='Your name is the way to define your own directory',font=ft_bigger)
    namm=widget_text(  basm1,xsize=15,ysize=1,font=ft_biggest,/editable)
    rbut=widget_base(  basm1,/frame,/row)
    if sys_dep('MAP') ne -1 then $
    okbt=widget_button(rbut,value='OK',font=ft_bigger,resource_name='discret') else $
    okbt=widget_button(rbut,value='OK',font=ft_bigger)
    print,string(7b)
    name='' & ii=0
    while (name eq '') and (ii eq 0) do begin
       widget_control,bad_id=ii,namm,/input_focus
       even=widget_event( basm1,bad_id=ii)
            widget_control,bad_id=ii,namm,get_value=name
            name=strupcase(strcompress(name[0],/remove_all))
    endwhile
    widget_control,bad_id=ii,basm1,sensitive=0
    if (name ne '') and (ii eq 0) then begin
       pwd=sys_dep('NEWDIR',lamp_user,name)
           stat=0 & ii=0
           catch,stat
           if (stat ne 0) and (ii eq 0) then begin
                  ii=1
                  bid=sys_dep('MKDIR',pwd)
                  catch,stat & if stat eq 0 then cd,pwd
           endif
           if stat eq 0 then cd,pwd & catch,/cancel
    endif
;   device,copy=[pax2,0,pax1(1),pax1(2),pax2+pax3,0,pax4] & pax2=pax2+pax3
    endif

;** Restore last session
;** ------- ---- -------
    load_session=0      ;file_found may contain a session file to restore
    if file_found gt ' ' then begin & fil=file_found & true=0 & load_session=1 & file_found=''
    endif                else       fil=finefile('lamp.ses',count=true)
    if (true gt 0) then true=100 ;else fil=finefile('lamp.ses.Z',count=true)
    if (true gt 0) and (ii eq 0) then begin
     cd,current=mee & if strmid(mee,strlen(mee)-1,1) ne lamp_dvd then mee=mee+lamp_dvd
     mess =widget_label( basm2,value='A previous Session of Lamp exists !!',font=ft_biggest)
     tses =widget_text(  basm2,value=mee+'lamp.ses'      ,font=ft_propor,/editable)
     but  =widget_base(  basm2,/row)
     r_rm =widget_button(but ,value='Restore then Remove',font=ft_b_normal)
     r_kp =widget_button(but ,value='Restore and Keep'   ,font=ft_b_normal)
     rm_  =widget_button(but ,value='Remove'             ,font=ft_b_normal)
     ign  =widget_button(but ,value='Ignore'             ,font=ft_b_normal)
     print,string(7b)
     bid=sys_dep('DYNLAB',basm2,0)
     widget_control,bad_id=ii  ,basm2,/realize
     even=widget_event( basm2  ,bad_id=ok)
     widget_control,bad_id=ii  ,basm2,sensitive=0
     widget_control,bad_id=ii  ,tses ,get_value=fil & fil=fil[0]
     if ok eq 0 then begin
       if (even.id eq r_rm) or (even.id eq r_kp) then begin
         if true ne 100 then bid=sys_dep('UN_Z','lamp.ses.Z',lamp_dir)
         load_session=2
       endif else true=0
       if (even.id eq rm_)   then bid=sys_dep('DELET',fil)
     endif
;   device,copy=[pax2,0,pax1(1),pax1(2),pax2+pax3,0,pax4] & pax2=pax2+pax3
    endif

    if load_session gt 0 then begin
         kpGEORGE=GEORGE
         catch,stat
         if stat eq 0 then begin & widget_control,bad_id=ii,basm3,set_value='RESTORING '+fil+' ...'
                    RESTORE, fil  &  GEORGE=kpGEORGE
                    AFTER_RESTORE
                    if load_session eq 2 then if (even.id eq r_rm) then bid=sys_dep('DELET',fil)
                    print,fil+' IS RESTORED'
         endif else begin &        widget_control,bad_id=ii,basm3,set_value='BAD FILE VERSION !!!'
                    print,"Bad version: "+fil+" !!!" & endelse
         catch,/cancel
    endif else begin
       w1=shift(sin( dist(64)/15),-12,-12)*30    & w_tit[1]='w1=shift(sin( dist(64)/15),-12,-12)*30'
       x1=long( alog(findgen(64)+1.)*20) & y1=x1 & x_tit[1]='x1=long( alog(findgen(64)+1.)*20)'
       y_tit[1]='Y axis' & z_tit[1]='Counts' & other_tit[1]='Just an example'
    endelse

    aa=-1 & bb=0 & sl_lampscan, 'test' ,aa,bb
    if (lamp_siz ge 800) and (sys_dep('MACHINE') eq 'win' or $
          sys_dep('MACHINE') eq 'mac') and (aa eq -1)   then $
          SL_RESTSCAN,lamp_dir+lamp_dvd+'scan.exe' ,cnt

    endif ;no just

;** Developers
;** ----------
    lamp_b1    =0L
    lamp_act   =0
    lamp_focus =0
    lamp_entry =['',' ']
    l_message  =0L
    b_labins   =lonarr(10) & b_labins[*]=0
    jou_c      =['*******','SESSION','*******'] & jou_w=[' ',stime(dum),' ']
    last_form  =''
    path       =''
    my_path    =[path,'','',!D.NAME]

;** Data base directories
;** --------- -----------
    P_ENVI
;** Base Constitution
;** ---- ------------
    if (just ne 'just') then $
        widget_control,bad_id=ii,basm3,set_value='CREATING manipulation-display TOOLS'

    if (just eq '') or (just eq 'lamp') then begin
    mbar=0L
    if sys_dep('VERSION') lt 4.0 then mkbar=0 else mkbar=1 ;& mkbar=0 ;;;for tests
    tit='LAMP '
    mmp =1
    if lamp_siz ge 600  then  if mkbar     then  mmp=0
    if sys_dep('MACHINE') eq 'mac'         then  mmp=1
    if sys_dep('MATLAB')  or (GEORGE eq 0) then  mmp=1
    if GEORGE eq 3 then begin & GEORGE=2       &   mmp=1 & endif
    if GEORGE eq 1 then begin & tit='GEORGE '  &   mmp=1 & endif

    if GEORGE eq 2 then tit='LAMP'
    tit      =tit+' ftp.ill.eu/pub/cs/lamp... (email:lamp@ill.eu)'
    tit      =tit+'     powered by Idl'
    if sys_dep('EMBEDDED') then tit=tit+' from Exelis Vis'
    AppIco   =lamp_dir+lamp_dvd+'Lamp.ico'

    if lamp_siz lt 600 then $
     if not mkbar then $
      lamp_b1  =widget_base(title=tit,resource_name='lamp',kill_notify='P_DYING',/column,$
                            x_scroll=590,y_scroll=lamp_siz-50) else $
      lamp_b1  =widget_base(title=tit,resource_name='lamp',kill_notify='P_DYING',/column,$
                            x_scroll=590,y_scroll=lamp_siz-50,MBAR=mbar,rname_mbar='lampben')

    if lamp_siz ge 600 then $
     if not mkbar then $
      lamp_b1  =widget_base(title=tit,resource_name='lamp',kill_notify='P_DYING',/column) else $
     if sys_dep('VERSION') lt 6.4 then $
      lamp_b1  =widget_base(title=tit,resource_name='lamp',kill_notify='P_DYING',/column,$
                            MBAR=mbar,rname_mbar='lampben') else $
      lamp_b1  =widget_base(title=tit,resource_name='lamp',kill_notify='P_DYING',/column,$
                            MBAR=mbar,rname_mbar='lampben',bitmap=AppIco)

    lamp_tmp1=widget_base(  lamp_b1  ,/row)
;don
    lamp_don   =lonarr(5)
    lamp_don[0]=widget_base( lamp_b1  ,/frame,resource_name='don',map=mmp)

    lamp_tmp2  =widget_base( lamp_tmp1,/column)

;ben
    lamp_ben   =lonarr(18)
    if GEORGE eq 2 then begin & lamp_ben[0] =widget_base( lamp_tmp1   ,map=mmp)
            lamp_ben[7] =widget_base( lamp_ben[0] ,/column,map=1)   & bas_ben=lamp_ben[7]
            lamp_ben[8] =widget_base( lamp_ben[0] ,/column,map=0)   & endif

    if GEORGE ne 2 then begin & lamp_ben[0] =widget_base( lamp_tmp1   ,map=mmp)
            bas_ben     =widget_base( lamp_ben[0] ,/column)
            lamp_ben[7] =bas_ben   &  lamp_ben[8] =bas_ben          & endif

    if mbar   gt 0 then begin
            lamp_ben[10]=widget_base( lamp_ben[0] ,/column,map=0)
            lamp_ben[11]=widget_base( lamp_ben[10],/column,/frame,resource_name='ben')
            mllab       =widget_label(lamp_ben[11],value='....MACROS LIST....',font=ft_propor)
            endif
    ben_f=1
    if GEORGE ne 1  then begin
      lamp_ben[2]=widget_base(  bas_ben ,/frame,resource_name='ben')
      lamp_ben[1]=widget_base(  bas_ben)
      ben_f=0
    endif
    if GEORGE ne 0  then begin
      if lamp_siz ge 900 then lab='..Other functions..' else lab='....Other functions....'
      if sys_dep('MACHINE')   eq  'mac'                 then lab='..Functions..'
      if GEORGE eq 1 then bas_geo2   =widget_button(lamp_ben[8],value=lab,font=ft_b_normal,menu=2)
      if GEORGE eq 1 then lamp_ben[2]=bas_geo2
    endif else bas_geo2=0
;micmac
    lamp_mac =widget_base( lamp_tmp2,/frame,resource_name='mic',/row)
    lamp_mac1=widget_base( lamp_mac)
    lamp_mac2=widget_base( lamp_mac,/row) & lamp_mac=lamp_mac1
    lamp_ben[9] =lamp_mac
    lamp_ben[17]=lamp_mac2
;did
    lamp_did   =lonarr(10)
    if  lamp_siz ge 700 then $
    sepdid    =widget_draw( lamp_tmp2,xsize=600,ysize=4,retain=2) else sepdid=0
    lamp_did[0]=widget_base( lamp_tmp2,/frame,resource_name='did')

    lamp_don[2]=lamp_ben[2]
    lamp_don[3]=lamp_did[0]

    if  lamp_siz ge 900 then $
    sepdon    =widget_draw( lamp_tmp2,xsize=600,ysize=4,retain=2) else sepdon=0

    widget_control,bad_id=ii,lamp_b1,default_font=ft_normal

;** Run  Selector Unit Creation
;** ---- -------- ---- --------
    if lamp_asite eq 'mic' then MIC,1

    ;** Main Display Unit Creation
    ;** ---- ------- ---- --------
    P_DID_CREATE ,(lamp_did[0])

    ;** Workspace Manipulation Unit Creation
    ;** --------- ------------ ---- --------
    P_DON_CREATE ,(lamp_don[0])

;** File Selector Unit Creation
;** ---- -------- ---- --------
    P_MAC_CREATE ,(lamp_mac+0) ,mbar ,wread ,b33 ,b1,cque

;** Specific Display Unit Creation
;** -------- ------- ---- --------
    P_BEN_CREATE ,(lamp_ben[2]),ben_f

;** General Functions Unit Creation
;** ------- --------- ---- --------
    P_FCT_CREATE ,(bas_ben), bas_geo2

;** Menu-bar Creation
;** -------- --------
    lamp_ben[15]=wread[0]
    lamp_ben[16]=wread[1]

    IF mbar gt 0 then begin &    IF b33 gt 0 then widget_control,bad_id=i,b33, get_uvalue=uvbuti
    if n_elements(uvbuti) eq 0 then uvbuti=0
    Show_version,0,lamp_version
    L_upd=0
    if (sys_dep('VERSION') ge 5.4) and (not sys_dep('DEMO')) then begin
       trydir=lamp_dir+lamp_dvd+'lamp.info' & un=0
       on_ioerror,misinfo & openw,un,trydir,/get_lun,/delete & L_upd=1 & free_lun,un & misinfo:
    endif
    P_table =0
    catch,stat & if stat eq 0 then begin & resolve_routine,'periodic_table',/no_recompile & P_table=1 & endif
    catch,/cancel
    
    L_idldoc= finefile(lamp_dir+lamp_dvd+'manual'+lamp_dvd+'idldoc'+lamp_dvd+'index.html')
    L_xref_1= finefile(lamp_dir+lamp_dvd+'manual'+lamp_dvd+'idldoc'+lamp_dvd+'Lamp-XREF-1.txt')
    L_xref_2= finefile(lamp_dir+lamp_dvd+'manual'+lamp_dvd+'idldoc'+lamp_dvd+'Lamp-XREF-2.txt')
    L_unit_T= finefile(lamp_dir+lamp_dvd+'test_unit'+lamp_dvd+'in4_gdos.prox')
    L_git   = finefile(lamp_dir+lamp_dvd+'.git')
    D_upd   = 0
    runt    = 0
    L_python= 0
    if (sys_dep('MACHINE')  eq 'win') and (sys_dep('EMBEDDED')) then D_upd = 1
    if (sys_dep('EMBEDDED') or sys_dep('RUNTIME'))              then runt  = 1
    if (sys_dep('VERSION')  ge '8.5')  then python_stuff,'check',     L_python                         

   ;Commented items
    Mfilet = 0L ; 'CATALOG of data runs'                 -> in "File" menu-bar
    Mfilem = 0L ; 'MAKE a User MACRO'                    ->
    MfileI = 0L ; 'Internet access: search data, Tables' -> 
    Minfor = 0L ; 'Template for READ IN procedures'      -> in "Info" menu-bar

   ;Image in menu buttons (put in did_etc.Mbmp)
    P_did_get_etc, d_etc  &  Mbm = d_etc.Mbm
    if Mbm then begin
      ListBm=['advanced','ascii','back','bulb','button','camera','copy','dataspace','demo','dm','export'   ,$
              'freehand','gears','hand','hdf','help','help2','image','importd','importf','legend','lft'    ,$
              'mcr','new','open','palette' ,'plot','polar','profile','prop','propsheet','save','shift_down',$
              'style','surface','switch_up','undo','volume','vw-dtls','vw-list']
      for i = 0,n_elements(ListBm)-1 do begin     
        did_bitmap, ListBm[i], bmImg, cnt
        if cnt eq 1 then begin
          txt = ListBm[i]
          k   = strpos(txt,'-')  &  if k ge 0 then strput,txt,'_',k ;replace '-' by '_'
          k   = strpos(txt,'-')  &  if k ge 0 then strput,txt,'_',k ;replace '-' by '_'
          ii=execute('bm_'+txt+'=bmImg') ; Make the variable containing the byte true image
        endif
      endfor
    endif

    Mfile  =widget_button(mbar,font=ft_propor,/menu,value='File ')
            if Mbm then widget_control,Mfile, image=bm_open
    Mcustom=widget_button(mbar,font=ft_propor,/menu,value='Customize ')
    Medit  =widget_button(mbar,font=ft_propor,/menu,value='Edit ')
    Minfo  =widget_button(mbar,font=ft_propor,/menu,value='Info ')
    Mtool  =widget_button(mbar,font=ft_propor,/menu,value='Tools ')
            if Mbm then widget_control,Mtool, image=bm_shift_down
    Mwind  =widget_button(mbar,font=ft_propor,/menu,value='Lamp/Layout ')
    Mhelp  =widget_button(mbar,font=ft_propor,/menu,value=' Help')
            if Mbm then widget_control,Mhelp, image=bm_bulb

    Mfile1 =widget_button(Mfile    ,font=ft_b_normal,value='IMPORT File and Workspace'          ,uvalue=[-88,380,0,0,0,0])
            if Mbm then widget_control,Mfile1, image=bm_open
    Mfiler =widget_button(Mfile    ,font=ft_b_normal,value='Multiple READ (Selector access)'    ,uvalue=uvbuti)
            if Mbm then widget_control,Mfiler, image=bm_style
    Mbid   =widget_button(Mfile    ,font=ft_b_normal,value='Import Prox, SpreadSheet, Image ...',/menu)
            if Mbm then widget_control,Mbid  , image=bm_open
    Mfile1 =widget_button(Mbid     ,font=ft_b_normal,value='Import sequencial Batch file(.prox)',uvalue=[-88,224])
            if Mbm then widget_control,Mfile1, image=bm_open
    Mfile1 =widget_button(Mbid      ,font=ft_b_normal,value='Import advanced   Batch file(.xbu)' ,uvalue=[-88,226])
    Mfile1 =widget_button(Mbid      ,font=ft_b_normal,value='Import SpreadSheet save file(.sav)' ,uvalue=[-88,571,10])
    if (sys_dep('VERSION') ge 7.1) then begin
      bid   =widget_button(Mbid     ,value='---')          & widget_control,bid,sensitive=0
      if (not runt) or (sys_dep('VERSION') le 8.1) then    $
        bid=widget_button(Mbid      ,font=ft_b_normal,value='Import an ISV file (saved by Itool)' ,uvalue=[-88,571,11,1])
      Mfile1=widget_button(Mbid     ,font=ft_b_normal,value='Import an IMAGE (bmp,png,jpeg,....)',uvalue=[-88,571,11,2])
             if Mbm then widget_control,Mfile1, image=bm_demo
      bid   =widget_button(Mbid     ,value='---')          & widget_control,bid,sensitive=0
      Mfile1=widget_button(Mbid     ,font=ft_b_normal,value='Import the structure of a .txt file',uvalue=[-88,571,11,3])
      Mfile1=widget_button(Mbid     ,font=ft_b_normal,value='Import the structure of a .h5  file',uvalue=[-88,571,11,4])
             if Mbm then widget_control,Mfile1, image=bm_hdf
      bid   =widget_button(Mbid     ,value=                 ' (result in W60 and in the Journal)')
    endif
    Mfile1 =widget_button(Mfile    ,value='--------')     & widget_control,Mfile1,sensitive=0

    Mfile1 =widget_button(Mfile    ,font=ft_b_normal,value='EXPORT Workspace'                   ,uvalue=[-88,370,0,0,0,0])
            if Mbm then widget_control,Mfile1, image=bm_export

    Mfile1 =widget_button(Mfile    ,value='--------')     & widget_control,Mfile1,sensitive=0
    Mfile1 =widget_button(Mfile    ,font=ft_b_normal,value='BROWSE selected instrument path'    ,uvalue=[-88,562,0,wread[0],wread[1],-2,-2,0])
            if Mbm then widget_control,Mfile1, image=bm_image
    Mfilec =widget_button(Mfile    ,font=ft_b_normal,value='CALIBRATION files for instruments'  ,uvalue=[-88,307,11])
            if Mbm then widget_control,Mfilec, image=bm_importd
;   Mfilet =widget_button(Mfile    ,font=ft_b_normal,value='CATALOG of data runs'               ,uvalue=[-88,331,0])
;   Mfile1 =widget_button(Mfile    ,value='--------')     & widget_control,Mfile1,sensitive=0
;   Mfilem =widget_button(Mfile    ,font=ft_b_normal,value='MAKE a User MACRO'                  ,uvalue=[-88,203,0,0])
    Mfile1 =widget_button(Mfile    ,value='--------')     & widget_control,Mfile1,sensitive=0
    Mfile1 =widget_button(Mfile    ,font=ft_b_normal,value='Live update features and macros'    ,uvalue=[-88,581,0])
            if Mbm then widget_control,Mfile1, image=bm_gears
    if ( not L_upd) then widget_control,Mfile1,sens=0,set_value='Live update:Write access DENIED!' $
    else if (L_git gt " ") then begin & L_upd = 0
                         widget_control,Mfile1,       set_value='Live update:Not recommended (.git)!'
    endif
    Mfile1 =widget_button(Mfile    ,value='--------')     & widget_control,Mfile1,sensitive=0
    Mfile1 =widget_button(Mfile    ,font=ft_b_normal,value='restore a previous session (browse)',uvalue=[-88,565,0])
            if Mbm then widget_control,Mfile1, image=bm_back
    Mfile1 =widget_button(Mfile    ,font=ft_b_normal,value='Save current state (browse)'        ,uvalue=[-88,397,1])
            if Mbm then widget_control,Mfile1, image=bm_save
    Mfile1 =widget_button(Mfile    ,font=ft_b_normal,value='Save and exit ->lamp.ses'           ,uvalue=[-88,307,12])
    Mfile1 =widget_button(Mfile    ,font=ft_b_normal,value='Exit'                               ,uvalue=[-88,398,0])

    Mcustom1=widget_button(Mcustom ,font=ft_b_normal,value='COLORS table'                       ,uvalue=[-88,347,0])
             if Mbm then widget_control,Mcustom1, image=bm_palette
    Mcustom1=widget_button(Mcustom ,font=ft_b_normal,value='PLOTTING preferences'               ,uvalue=[-88,360,0])
             ;if Mbm then widget_control,Mcustom1, image=bm_plot
             if Mbm then widget_control,Mcustom1, image=bm_propsheet
   ;Mcustom1=widget_button(Mcustom ,font=ft_b_normal,value='Default PRINTER (Unix)'         ,uvalue=[-88,360,0])
    Mcustom1=widget_button(Mcustom ,value='--------')     & widget_control,Mcustom1,sensitive=0
    Mcustomf=widget_button(Mcustom ,font=ft_b_normal,value='INSTRUMENTS and DATA PATH Tables'            ,uvalue=[-88,560,0,0,0,-1])
             if Mbm then widget_control,Mcustomf, image=bm_prop
    if (not runt) and (GEORGE ne 1) then                  $
    Mcustomr=widget_button(Mcustom ,font=ft_b_normal,value='READ IN template (read_tmp), macros LOCATION',uvalue=[-88,560,0,0,0,-1])
    Mcustom1=widget_button(Mcustom ,value='--------')     & widget_control,Mcustom1,sensitive=0
    Mcustoms=widget_button(Mcustom ,font=ft_b_normal,value='How to implement "INSTRUMENT MACROS" layout' ,uvalue=[-88,596,0,0])
             if Mbm then widget_control,Mcustoms, image=bm_help
    if D_upd then begin
    Mcustomd=widget_button(Mcustom ,font=ft_b_normal,value='How to set your WORKING PATH at launch',/menu)
    Mcustom1=widget_button(Mcustomd,font=ft_b_normal,value='Edit the file Free_Lamp\lamp\work\myinit.prox')
    Mcustom1=widget_button(Mcustomd,font=ft_b_normal,value='Add a line like: P_SET_PATH,"D:\Users\Me" ')
    endif

   ;Medit1 =widget_button(Medit    ,font=ft_b_normal,value='COLORS table'                   ,uvalue=[-88,347,0])
    Medit1 =widget_button(Medit    ,font=ft_b_normal,value='DATA PARAMETERS values'         ,uvalue=[-88,204,0,0])
            if Mbm then widget_control,Medit1, image=bm_vw_dtls
   ;Meditc =widget_button(Medit    ,font=ft_b_normal,value='Instrument CALIBRATION'         ,uvalue=[-88,307,11])
    Medit1 =widget_button(Medit    ,font=ft_b_normal,value='User batch files , MACROS'      ,uvalue=[-88,203,0,0])
            if Mbm then widget_control,Medit1, image=bm_lft
    Medit1 =widget_button(Medit    ,value='--------')     & widget_control,Medit1,sensitive=0
    Medit1 =widget_button(Medit    ,font=ft_b_normal,value='DO  input and Batch files (@prox)'   ,uvalue=[-88,224])
            if Mbm then widget_control,Medit1, image=bm_button
    Mwindxx=widget_button(Medit    ,font=ft_b_normal,value='XBU input commands (DO loops)'       ,uvalue=[-88,226])
            if Mbm then widget_control,Mwindxx,image=bm_lft

    Medit1 =widget_button(Medit    ,value='--------')     & widget_control,Medit1,sensitive=0
    Meditms=widget_button(Medit   ,font=ft_b_normal,value='SAVING Workspaces in temporary MEMORY' ,/menu)
            if Mbm then widget_control,Meditms, image=bm_save
    Meditw1=widget_button(Meditms ,font=ft_b_normal,value='STORE all Workspaces in   temporary memory' ,uvalue=[-88,572,0,1])
            if Mbm then widget_control,Meditw1, image=bm_export
    Meditw2=widget_button(Meditms ,font=ft_b_normal,value='RESTORE   Workspaces from temporary memory' ,uvalue=[-88,572,0,2])
            if Mbm then widget_control,Meditw2, image=bm_importf
    Meditw3=widget_button(Meditms ,font=ft_b_normal,value='EXCHANGE  Workspaces with temporary memory' ,uvalue=[-88,572,0,3])
            if Mbm then widget_control,Meditw3, image=bm_undo
    Meditw4=widget_button(Meditms ,font=ft_b_normal,value='CLEAR all Workspaces and  memories'         ,uvalue=[-88,572,0,4])
            if Mbm then widget_control,Meditw4, image=bm_new

    Minfo1 =widget_button(Minfo    ,font=ft_b_normal,value='JOURNAL of current session'     ,uvalue=[-88,396,0,0])
            ;if Mbm then widget_control,Minfo1, image=bm_ascii
            if Mbm then widget_control,Minfo1, image=bm_copy
    Minfo1 =widget_button(Minfo    ,font=ft_b_normal,value='DATA PARAMETERS'                ,uvalue=[-88,204,0,0])
            if Mbm then widget_control,Minfo1, image=bm_vw_dtls
    Minfo1 =widget_button(Minfo    ,value='--------')     & widget_control,Minfo1,sensitive=0
    Minfo1 =widget_button(Minfo    ,font=ft_b_normal,value='Internal ROUTINES (lamp)'       ,uvalue=[-88,203,0,1])
    Minfo1 =widget_button(Minfo    ,font=ft_b_normal,value='Available User BATCH files'     ,uvalue=[-88,203,1,0])
            if Mbm then widget_control,Minfo1, image=bm_lft
    Minfo1 =widget_button(Minfo    ,font=ft_b_normal,value='Available Workspaces->ShowFreeW',uvalue=[-88,571,5])
            if Mbm then widget_control,Minfo1, image=bm_legend
    Minfo1 =widget_button(Minfo    ,value='--------')     & widget_control,Minfo1,sensitive=0
    if P_table then begin
    Minfo1 =widget_button(Minfo    ,font=ft_b_normal,value='Periodic Table (SLD)'           ,uvalue=[-88,571,12])
            if Mbm then widget_control,Minfo1, image=bm_vw_list & endif
    MfileL =widget_button(Minfo    ,font=ft_b_normal,value='Internet access: Tables, Data, Forge',/menu)
            if Mbm then widget_control,MfileL, image=bm_image
    Minfo1e=widget_button(Minfo    ,font=ft_b_normal,value='Electronic LogBook access'           ,/menu)
            if Mbm then widget_control,Minfo1e, image=bm_camera
       bid =widget_button(Minfo1e  ,font=ft_propor  ,value='--- To have an access to your LogBook ---')
       bid =widget_button(Minfo1e  ,font=ft_propor  ,value='---  just right click with the mouse  ---')
       bid =widget_button(Minfo1e  ,font=ft_propor  ,value='---      in a draw window of Lamp     ---')
;   Minfo1 =widget_button(Minfo    ,value='--------')     & widget_control,Minfo1,sensitive=0
;   Minfor =widget_button(Minfo    ,font=ft_b_normal,value='Template for READ IN procedures',uvalue=[-88,560,0,0,0,-1])
;   Minfo1 =widget_button(Minfo    ,value='--------')     & widget_control,Minfo1,sensitive=0
    Mwindsa=widget_button(Minfo    ,font=ft_b_normal,value='Help for INSTRUMENT MACROS',/menu)
            if Mbm then widget_control,Mwindsa, image=bm_advanced

    Mtool1 =widget_button(Mtool    ,font=ft_b_normal,value='OVERPLOTTING (superplot)'       ,uvalue=[-88,352])
            if Mbm then widget_control,Mtool1, image=bm_plot
    Mtool1 =widget_button(Mtool    ,font=ft_b_normal,value='SCROLL spectra within 2D workspaces'        ,uvalue=[-88,402,0])
            if Mbm then widget_control,Mtool1, image=bm_switch_up
    Mtool1 =widget_button(Mtool    ,value='--------')     & widget_control,Mtool1,sensitive=0
    MtoolGP=widget_button(Mtool    ,font=ft_b_normal,value='SANS TREATMENTS'                            ,uvalue=[-88,571,7])
            if Mbm then widget_control,MtoolGP, image=bm_polar
    Mtool1 =widget_button(Mtool    ,font=ft_b_normal,value='REFLECTOMETRY with Cosmos'                  ,uvalue=[-88,571,8])
            if Mbm then widget_control,Mtool1, image=bm_profile
    Mtoul1 =widget_button(Mtool    ,value='--------')     & widget_control,Mtoul1,sensitive=0
    Mtool1 =widget_button(Mtool    ,font=ft_b_normal,value='STRUCTURES MAGDRAW-ATOMS-EDITOR'            ,uvalue=[-88,571,3])
            if Mbm then widget_control,Mtool1, image=bm_dataspace
    Mtoul1 =widget_button(Mtool    ,value='--------')     & widget_control,Mtoul1,sensitive=0
    Mtool1 =widget_button(Mtool    ,font=ft_b_normal,value='FITTING with STRfit (general fit,convolution)',uvalue=[-88,571,4,Mtoul1])
            ;if Mbm then widget_control,Mtool1, image=bm_freehand
            if Mbm then widget_control,Mtool1, image=bm_surface
    Mtool1 =widget_button(Mtool    ,font=ft_b_normal,value='FITTING with GKfit  (gauss,lorentz only)'   ,uvalue=[-88,580,0,0])
;   Provisoirement
    macr='str_fit' & topic='Fitting' & purp='Fit the Bragg reflections in a 2D data set' & auth='(Mark Johnson 2004 Didier Richard)'
    coll="w3=str_fit(w2,'filename','title',bkgd=b) ;,Wout=4" & icof='' & lnk=''
    more=[[''],['w2 is the 2D data , optional Wout keyword returns fitted functions in w4'],$
          ['w3 contains fit parameters and errors (use kword /noweight for poor data)'],$
      ['Fit parameters and errors are also written to file (filename) with title'] ,$
      ['Default fit is with flat background. If keyword bkgd is given,'],$
      ['a linear (b=1) and quadratic (b=2) background is used.'],$
      ['Use keyword ",Xrange=[xmin,xmax]" to delimit a fitting region.'],$
      ['Other keywords  ",/Pseudo or Pseudo=.4" ",/Lorentz" ",/Gauss (default)"']]
    stuc={topic:topic,macro:macr,purpose:purp,author:auth,call:coll,more:more,logo:icof,link:lnk}
    widget_control,Mtoul1,set_uvalue=stuc
;   ---------------
    Mtool1 =widget_button(Mtool    ,value='--------')     & widget_control,Mtool1,sensitive=0
    Mtool1 =widget_button(Mtool    ,font=ft_b_normal,value='Qens_fit (Quasi-functions, resolution) for TOF',uvalue=[-88,571,2])
    if sys_dep('VERSION') lt 5.4 then widget_control,Mtool1,sensitive=0
   ;Mtool1 =widget_button(Mtool    ,font=ft_b_normal,value='Spectra GROUPING for TOF'            ,uvalue=[-88,403,0])
    Mtool1 =widget_button(Mtool    ,font=ft_b_normal,value='INXviewer for TOF (ILL)'             ,uvalue=[-88,571,1])
    Mtool1 =widget_button(Mtool    ,value='--------')     & widget_control,Mtool1,sensitive=0
;   Mtoolo =widget_button(Mtool    ,font=ft_b_normal,value='CRON tasks (toggle)')
;   Mtool1 =widget_button(Mtool    ,value='--------')     & widget_control,Mtool1,sensitive=0
    Mtool1 =widget_button(Mtool    ,font=ft_b_normal,value='LOG_BOOK access'           ,/menu)
            if Mbm then widget_control,Mtool1, image=bm_camera
       bid =widget_button(Mtool1   ,font=ft_propor  ,value='--- To have an access to your LogBook ---')
       bid =widget_button(Mtool1   ,font=ft_propor  ,value='---  just right click with the mouse  ---')
       bid =widget_button(Mtool1   ,font=ft_propor  ,value='---      in a draw window of Lamp     ---')

    Mtool1 =widget_button(Mtool    ,font=ft_b_normal,value='Multiple READ (Selector access)'     ,uvalue=uvbuti)
            if Mbm then widget_control,Mtool1, image=bm_style

    MtoolGP=widget_button(Mtool    ,font=ft_b_normal,value='Basic Sector integrations' ,/menu)
            Mtool1=widget_button(MtoolGP  ,font=ft_b_normal,value='Basic Sector integrations (small 2D wksp)'  ,uvalue=[-88,401,0])
            Mtool1=widget_button(MtoolGP  ,font=ft_b_normal,value='Unrolling for integration (large 2D wksp)'  ,uvalue=[-88,401,-1])
                   if Mbm then widget_control,Mtool1, image=bm_freehand
            Mtool1=widget_button(MtoolGP  ,font=ft_b_normal,value='SANS_settings: Grouping 1 configuration'    ,uvalue=[-88,571,6])
                   if Mbm then widget_control,Mtool1, image=bm_polar

    Mtool1 =widget_button(Mtool    ,font=ft_b_normal,value='Tomography'                          ,uvalue=[-88,401,-2])
            if Mbm then widget_control,Mtool1, image=bm_volume
    Mtooln =widget_button(Mtool    ,font=ft_b_normal,value='Fourre-tout (scan)'                  ,uvalue=[-88,306,0,-1])

    Mwindf =widget_button(Mwind    ,font=ft_b_normal,value='Extend to classical Lamp')
            if Mbm then widget_control,Mwindf, image=bm_advanced
    Mwindm =widget_button(Mwind    ,font=ft_b_normal,value='Light  configuration')
    Mwind1 =widget_button(Mwind    ,value='--------')     & widget_control,Mwind1,sensitive=0
    Mwindl =widget_button(Mwind    ,font=ft_b_normal,value='LAMP   layout')
    Mwindg =widget_button(Mwind    ,font=ft_b_normal,value='GEORGE layout (dials)')
            if Mbm then widget_control,Mwindg, image=bm_mcr
    Mwind1 =widget_button(Mwind    ,value='--------')     & widget_control,Mwind1,sensitive=0
    Mwind1 =widget_button(Mwind    ,font=ft_b_normal,value='DO  input and Batch files (@prox)'   ,uvalue=[-88,224])
            if Mbm then widget_control,Mwind1, image=bm_button
    Mwind1 =widget_button(Mwind    ,font=ft_b_normal,value='XBU input commands (DO loops)'       ,uvalue=[-88,226])
            if Mbm then widget_control,Mwind1, image=bm_lft
    Mwind1 =widget_button(Mwind    ,value='--------')     & widget_control,Mwind1,sensitive=0
   ;if L_upd then $
   ;Mwind1 =widget_button(Mwind    ,font=ft_b_normal,value='Live update features and macros'     ,uvalue=[-88,581,0])
    Mwinds =widget_button(Mwind    ,font=ft_b_normal,value='Help for INSTRUMENT MACROS',/menu)
             if Mbm then widget_control,Mwinds, image=bm_advanced

    Mhelp1 =widget_button(Mhelp    ,font=ft_b_normal,value='Reference Guide (Idl)'             ,uvalue=[-88,573,0,0])
            if Mbm then widget_control,Mhelp1, image=bm_bulb
    Mhelp1 =widget_button(Mhelp    ,font=ft_b_normal,value='Internal ROUTINES (lamp)'          ,uvalue=[-88,203,0,1])
   ;Mhelp1 =widget_button(Mhelp    ,font=ft_b_normal,value='Functional List of Routines (Idl)' ,uvalue=[-88,573,0,1])
    Mhelp1 =widget_button(Mhelp    ,font=ft_b_normal,value='Lamp Manual:lamp/manual/front.html',uvalue=[-88,201,0,0])
    if L_idldoc gt ' ' then $
    Mhelp1 =widget_button(Mhelp    ,font=ft_b_normal,value='Technical Doc (lamp)'              ,uvalue=[-88,573,0,2], Uname=L_idldoc)
    Mhelp1 =widget_button(Mhelp    ,value='--------')     & widget_control,Mhelp1,sensitive=0
    MhelpH =widget_button(Mhelp    ,font=ft_b_normal,value='Select, Manipulate, Display DATA' ,/menu)    
            if Mbm then widget_control,MhelpH, image=bm_prop
     Mhelp1=widget_button(MhelpH   ,font=ft_b_normal,value='Manipulation syntax overview'   ,uvalue=[-88,588,0,0])
     Mhelp1=widget_button(MhelpH   ,font=ft_b_normal,value='Help for selected instrument'   ,uvalue=[-88,586,0,0])
     Mhelp1=widget_button(MhelpH   ,font=ft_b_normal,value='Displaying workspaces'          ,uvalue=[-88,587,0,0])
     Mhelp1=widget_button(MhelpH   ,font=ft_b_normal,value='Sequential file access'         ,/menu)
            if Mbm then widget_control,Mhelp1, image=bm_style
        bid=widget_button(Mhelp1   ,font=ft_b_normal,value='1) See the GUI accessible via File->Multiple READ or the [Self] button')
        bid=widget_button(Mhelp1   ,font=ft_b_normal,value=' ')
        bid=widget_button(Mhelp1   ,font=ft_b_normal,value='2) For numerical filenames only:')
        bid=widget_button(Mhelp1   ,font=ft_b_normal,value="  -To join data do: W1 = RDOPR('1:10 , 15:::21')")
        bid=widget_button(Mhelp1   ,font=ft_b_normal,value="  -To add  data do: W1 = RDOPR('1+2+ 15>20')")
        bid=widget_button(Mhelp1   ,font=ft_b_normal,value=' ')
        bid=widget_button(Mhelp1   ,font=ft_b_normal,value='3) Do input or Batch @file.prox example:')
        bid=widget_button(Mhelp1   ,font=ft_b_normal,value="  -RDSET, inst   ='Column'           ;Set input format")
        bid=widget_button(Mhelp1   ,font=ft_b_normal,value="  -RDSET, prefix ='TiO2_01C_14keV_'  ;Set file prefix")
        bid=widget_button(Mhelp1   ,font=ft_b_normal,value="  -RDSET, suffix ='_mar3450.txt'     ;Set file suffix")
        bid=widget_button(Mhelp1   ,font=ft_b_normal,value="  -W3 = RDOPR('001:040')             ;Read 40 scan files")
        bid=widget_button(Mhelp1   ,font=ft_b_normal,value="  -SEE, W=3, /image,/below           ;Plot result")
        bid=widget_button(Mhelp1   ,font=ft_b_normal,value="  -WRITE_LAMP,'join.hdf', W=2, format='hdf' ;Write a NeXus hdf file")
        bid=widget_button(Mhelp1   ,font=ft_b_normal,value="  -RDSET, prefix='', suffix=''       ;Reset prefix and suffix")
        bid=widget_button(Mhelp1   ,font=ft_b_normal,value=' ')
        bid=widget_button(Mhelp1   ,font=ft_b_normal,value='4) Join SPEC scans using the widget input text "File:"')
        bid=widget_button(Mhelp1   ,font=ft_b_normal,value="  -spec_str.spec{1:40}")
     if (runt) and (sys_dep('VERSION') ge 8.4) then begin
        bid=widget_button(MhelpH   ,value='--------')     & widget_control,bid   ,sensitive=0
        bid=widget_button(MhelpH   ,font=ft_b_normal,value='Unit Converter'                 ,uvalue=[-88,571,13])
     endif
     if (runt) and (sys_dep('VERSION') ge 8.5) then begin
       bid=widget_button(MhelpH    ,value='--------')     & widget_control,bid   ,sensitive=0
      ;bid=widget_button(MhelpH    ,font=ft_b_normal,value='Load Imsl library (no License!)',uvalue=[-88,571,14])
      ;                                                     widget_control,bid   ,sensitive=0
       bid=widget_button(MhelpH    ,font=ft_b_normal,value='Load Wavelet library'           ,uvalue=[-88,571,15])
     endif
    if (not runt) then begin
     MhelpM=widget_button(Mhelp    ,font=ft_b_normal,value='Lamp enhancements or Git users' ,/menu)
     Mhelp1=widget_button(MhelpM   ,font=ft_b_normal,value='LAMP ENHANCEMENTS (.pro , .prox files):')
     Mhelp1=widget_button(MhelpM   ,font=ft_b_normal,value='**************************************')
     Mhelp1=widget_button(MhelpM   ,font=ft_b_normal,value='- On your local distribution, put your new/modified macros in lamp/lamp_mac/"INST"/')
     Mhelp1=widget_button(MhelpM   ,font=ft_b_normal,value='- On the ILL server, put your new/modified macros in serhom/home/cs/lambda/macros/"INST"/')
     Mhelp1=widget_button(MhelpM   ,font=ft_b_normal,value='  ("INST" corresponds to the relevant instrument or technique)')
     Mhelp1=widget_button(MhelpM   ,font=ft_b_normal,value='-')
     Mhelp1=widget_button(MhelpM   ,font=ft_b_normal,value='For your new files to be part of the standard distribution and "live update" of Lamp:')
     Mhelp1=widget_button(MhelpM   ,font=ft_b_normal,value='ftp://ftp.ill.eu/pub/cs/... , please send an Email to lamp@ill.eu or a CS-ILL member.')
     Mhelp1=widget_button(MhelpM   ,font=ft_b_normal,value='-')
     Mhelp1=widget_button(MhelpM   ,font=ft_b_normal,value='You can also create a new issue from the Lamp repository:')
     Mhelp1=widget_button(MhelpM   ,font=ft_b_normal,value='http://forge.epn-campus.eu/projects/lamp (ask to be a "reporter" in this case).')
     if (L_git gt " ") then begin
     Mhelp1=widget_button(MhelpM   ,font=ft_b_normal,value='-')
     Mhelp1=widget_button(MhelpM   ,font=ft_b_normal,value='For registered LAMP developers-> GIT commands to synchronise LOCAL/"EPN-CAMPUS" sites:')
     Mhelp1=widget_button(MhelpM   ,font=ft_b_normal,value='*************************************************************************************')
     Mhelp1=widget_button(MhelpM   ,font=ft_b_normal,value='- ... Modify your files outside of the lamp/ application path or commit before pulling.')
     Mhelp1=widget_button(MhelpM   ,font=ft_b_normal,value='- git pull origin master (update lamp/ from "epn-campus" to your local application repository).')
     Mhelp1=widget_button(MhelpM   ,font=ft_b_normal,value='- git status             (should say "working directory clean").')
     Mhelp1=widget_button(MhelpM   ,font=ft_b_normal,value='- ... Copy your modified/tested files in the lamp/ application path.')
     Mhelp1=widget_button(MhelpM   ,font=ft_b_normal,value='- git status             (should say what has been modified).')
     Mhelp1=widget_button(MhelpM   ,font=ft_b_normal,value='- git add .              (record your modifications for next local commit).')
     Mhelp1=widget_button(MhelpM   ,font=ft_b_normal,value='- git commit -m "explanation text for your modifications"   (local commit).')
     Mhelp1=widget_button(MhelpM   ,font=ft_b_normal,value='- git push origin master (push your local commit to the "epn-campus" repository).')
     Mhelp1=widget_button(MhelpM   ,font=ft_b_normal,value='-')
     Mhelp1=widget_button(MhelpM   ,font=ft_b_normal,value='  if a "git pull" error occurs, you should use "git stash" before pulling.')
;    Mhelp1=widget_button(MhelpM   ,font=ft_b_normal,value=' "git pull" to force:')
;    Mhelp1=widget_button(MhelpM   ,font=ft_b_normal,value='      - git stash                 (save your current sources in a "cache").')
;    Mhelp1=widget_button(MhelpM   ,font=ft_b_normal,value='      - git pull origin master    (update lamp/ from "epn-campus")')
;    Mhelp1=widget_button(MhelpM   ,font=ft_b_normal,value='      - git stash pop             (un-cache only if necessary!)')
     endif
    endif
    Mhelp1 =widget_button(Mhelp    ,value='--------')     & widget_control,Mhelp1,sensitive=0
    Mhelp1 =widget_button(Mhelp    ,font=ft_b_normal,value='PROX SpreadSheet Template'      ,uvalue=[-88,571,9])
            if Mbm then widget_control,Mhelp1, image=bm_dm
    Mhelp1 =widget_button(Mhelp    ,value='--------')     & widget_control,Mhelp1,sensitive=0
    if L_upd then $
    Mhelp1 =widget_button(Mhelp    ,font=ft_b_normal,value='Live update features and macros',uvalue=[-88,581,0])
    Mhelpc =widget_button(Mhelp    ,font=ft_b_normal,value='About Lamp',/menu)
            if Mbm then widget_control,Mhelpc, image=bm_hand
    Mh =widget_button(Mhelpc   ,font=ft_propor,value='Start Lamp project: Apr 1994     WWW.ILL.EU/lamp')
    Mh =widget_button(Mhelpc   ,font=ft_propor,value='This update: '+lamp_version)
    Mh =widget_button(Mhelpc   ,font=ft_propor,value=' ')
    Mh =widget_button(Mhelpc   ,font=ft_propor,value='Publication reference:')
    Mh =widget_button(Mhelpc   ,font=ft_propor,value='        Analysis and visualisation of neutron-scattering data')
    Mh =widget_button(Mhelpc   ,font=ft_propor,value='        Didier   Richard,  Michel Ferrand,  Gordon J. Kearley')
    Mh =widget_button(Mhelpc   ,font=ft_propor,value='        Journal of Neutron Research 4, 33-39, 1996')
    Mh =widget_button(Mhelpc   ,font=ft_propor,value=' ')
    Mh =widget_button(Mhelpc   ,font=ft_propor,value='Actual manager:')
    Mh =widget_button(Mhelpc   ,font=ft_propor,value='        Miguel   Gonzalez  (ILL  scientist    CS   qens, sans)')
    Mh =widget_button(Mhelpc   ,font=ft_propor,value='        Stephane Rols      (ILL  scientist    TOF  modelisation)')
    Mh =widget_button(Mhelpc   ,font=ft_propor,value=' ')
    Mh =widget_button(Mhelpc   ,font=ft_propor,value='Scientific macros support:')
    Mh =widget_button(Mhelpc   ,font=ft_propor,value='        Marc     Johnson   (ILL  scientist    DIR)')
    Mh =widget_button(Mhelpc   ,font=ft_propor,value='        Jacques  Ollivier  (ILL  scientist    TOF  mono Xtal)')
    Mh =widget_button(Mhelpc   ,font=ft_propor,value='        Andrew   Wildes    (ILL  scientist    D7   polarisation)')
    Mh =widget_button(Mhelpc   ,font=ft_propor,value='        Thomas   Hansen    (ILL  scientist    DIF  powder)')
    Mh =widget_button(Mhelpc   ,font=ft_propor,value='        Bob      Cubitt    (ILL  scientist    LSS  sans)')
    Mh =widget_button(Mhelpc   ,font=ft_propor,value='        Ken      Andersen  (ILL  scientist -->2011 LUND)')
    Mh =widget_button(Mhelpc   ,font=ft_propor,value='        J.Ross   Stewart   (ILL  scientist -->2007 ISIS)')
    Mh =widget_button(Mhelpc   ,font=ft_propor,value=' ')
    Mh =widget_button(Mhelpc   ,font=ft_propor,value='First development:')
    Mh =widget_button(Mhelpc   ,font=ft_propor,value='        Arne     Dallmeyer (PhD      1994)')
    Mh =widget_button(Mhelpc   ,font=ft_propor,value='        Benjamin Vettier   (Grenoble university 1994)')
    Mh =widget_button(Mhelpc   ,font=ft_propor,value='        Romuald  Jouffrey  (Grenoble university 1995,96)')
    Mh =widget_button(Mhelpc   ,font=ft_propor,value='        Philippe Cuerq     (Grenoble university 1996)')
    Mh =widget_button(Mhelpc   ,font=ft_propor,value=' ')
    Mh =widget_button(Mhelpc   ,font=ft_propor,value='Mail: lamp@ill.eu')
    Mh =widget_button(Mhelpc   ,font=ft_propor,value='www.ill.eu/instruments-support/computing-for-science/data-analysis/')
    Mh =widget_button(Mhelpc   ,font=ft_propor,value='www.ill.eu/instruments-support/instruments-groups/groups/tof/software')
    Mh =widget_button(Mhelpc   ,font=ft_propor,value='www.ill.eu/instruments-support/instruments-groups/instruments/d7/more/data-analysis')
    Mh =widget_button(Mhelpc   ,font=ft_propor,value='http://barns.ill.eu         (Web  application)')
    Mh =widget_button(Mhelpc   ,font=ft_propor,value='http://ftp.ill.eu/pub/cs    (Take-away sources , runtimes)')
   ;Mwindsb=widget_button(Mhelp    ,font=ft_b_normal,value='Help for INSTRUMENT MACROS',/menu)
    lamp_ben[12]=Mwindl
    lamp_ben[13]=Mwindg
    lamp_ben[14]=Mwindm
    if mmp                 then widget_control,Mwindf  ,sensitive=0
    if lamp_siz lt 600     then widget_control,Mwindf  ,sensitive=0
    if lamp_siz lt 600     then widget_control,Mwindm  ,sensitive=0
    if lamp_siz lt 800     then widget_control,Mtooln  ,sensitive=0
   ;if runt                then widget_control,Mfilem  ,sensitive=0, bad_id=ii ;Commented in "File" menu-bar
   ;if runt                then widget_control,Mcustomr,sensitive=0
   ;if runt                then widget_control,Minfor  ,sensitive=0, bad_id=ii ;Commented in "Info" menu-bar
   ;if runt                then widget_control,MhelpM  ,sensitive=0
    if cque     eq 0       then widget_control,Mwindg  ,sensitive=0
    if cque     eq 0       then widget_control,Mwindl  ,sensitive=0
    if GEORGE   eq 2       then widget_control,Mwindl  ,sensitive=0
    if GEORGE   eq 1       then widget_control,Mwindg  ,sensitive=0
    if GEORGE   eq 1       then widget_control,Mfiler  ,sensitive=0
    if GEORGE   eq 1       then widget_control,Mcustomf,sensitive=0
    if GEORGE   eq 1       then widget_control,Mcustoms,sensitive=0
   ;if GEORGE   eq 1       then widget_control,Mcustomr,sensitive=0
   ;if GEORGE   eq 1       then widget_control,Minfor  ,sensitive=0, bad_id=ii ;Commented in "Info" menu-bar
    if GEORGE   eq 1       then widget_control,Mwinds  ,sensitive=0
    if GEORGE   eq 1       then widget_control,Mwindsa ,sensitive=0
   ;if GEORGE   eq 1       then widget_control,Mwindsb ,sensitive=0, bad_id=ii ;Commented in "Help" menu-bar
    if GEORGE   eq 0       then widget_control,Mwindxx ,sensitive=0

    P_LAMBDA,pathmac
   ;pathcal =sys_dep('INSUB',pathmac,'CALIBRATION') & calfile =finefile(pathcal+'*',count=cnt)
   ;if cnt      eq 0       then widget_control,Meditc  ,sensitive=0
;  ;if cnt      eq 0       then widget_control,Mfilec  ,sensitive=0

   ;toufile =finefile(lamp_touch+lamp_dvd+'*',count=cnt)
    toufile =finefile(lamp_touch             ,count=cnt)
   ;if (cnt eq 0) or (lamp_touch eq '') then widget_control,Mfilet  ,sensitive=0, bad_id=ii ;Commented in "File" menu-bar

    widget_control,Meditw1,set_uvalue=[-88,572,0,1,Meditw2,Meditw3]
    widget_control,Meditw2,sensitive=0
    widget_control,Meditw3,sensitive=0
    empty & sby=0 & sp=0
    if sys_dep('MACHINE') eq 'win' then begin & sby=30 & sp=1 & endif

    gml=widget_info(lamp_b1    ,/geometry) & sty=gml.scr_ysize+2*gml.margin + sby
    gmm=widget_info(lamp_don[0],/geometry) & ssy=gmm.scr_ysize+2*gmm.margin & ssy=sty-ssy

    if not mmp then widget_control,lamp_b1,scr_ysize=ssy
    if not mmp then b_labins[6]=1

   ;Instrument macros liste
    fullist=[''] & MAC_LIST,n_em,fullist,maclist,THISFILE='A_List_*.prox'
    widget_control,Mwinds  ,set_uvalue=fullist
    Lclass=0L
    if fullist[0] gt ' ' then begin
       idx=sort(maclist) & maclist=maclist[idx] & fullist=fullist[idx]
       idx=uniq(maclist) & maclist=maclist[idx] & fullist=fullist[idx]
       for i=0,n_elements(maclist)-1 do begin
           bid =widget_button( Mwinds ,font=ft_b_normal,value=maclist[i],uvalue=[-88,570,0,Mwinds,Mwindl,Mwindg,Mwindm,i])
           bid =widget_button( Mwindsa,font=ft_b_normal,value=maclist[i],uvalue=[-88,570,0,Mwinds,Mwindl,Mwindg,Mwindm,i])
          ;bid =widget_button( Mwindsb,font=ft_b_normal,value=maclist[i],uvalue=[-88,570,0,Mwinds,Mwindl,Mwindg,Mwindm,i])
       endfor
       Lclass  =widget_button( Mwinds ,font=ft_b_normal,value='Classical layout')
       widget_control,Mwinds,set_uvalue=fullist
       lamp_did[6:9]=[Mwinds,Mwindl,Mwindg,Mwindm]
    endif else begin & widget_control,Mwinds ,sensitive=0 & widget_control,Mwindsa,sensitive=0
                     ; widget_control,Mwindsb,sensitive=0
    endelse

   ;Internet access
    ok=0
    for j=0,n_elements(lamp_ali)-1 do if strpos(strlowcase(lamp_path[j]),'://') gt 0 then begin & ok=1
       ;bid =widget_button( MfileI,font=ft_b_normal,value=lamp_ali[j],uvalue=[-88,542,0,j]) ;Commented in "File" menu-bar
        bid =widget_button( MfileL,font=ft_b_normal,value=lamp_ali[j],uvalue=[-88,542,0,j])
        endif
    if not ok then widget_control,MfileL,sensitive=0
    endif
;** Event Loop
;** ----- ----
    P_MUS,''
    widget_control,bad_id=ii,basem ,/destroy
    P_MUS,'mus_shot'

    bid=sys_dep('DYNLAB',lamp_b1,1)
    widget_control,bad_id=ii  ,lamp_b1 ,/realize

    IF mbar gt 0 then begin
       gml=widget_info(lamp_b1    ,/geometry) & stx=gml.scr_xsize+2*gml.margin
       gmd=widget_info(lamp_ben[0],/geometry) & ssx=gmd.scr_xsize+2*gmd.margin & ssx=stx-ssx
       widget_control,lamp_ben[10],set_uvalue=[-99,0L,mllab,stx]
       widget_control,Mwindm      ,set_uvalue=[-88,307,62,ssx,ssy,stx,sty,Mwindf,Mwindm]
       widget_control,Mwindf      ,set_uvalue=[-88,307,61,ssx,ssy,stx,sty,Mwindf,Mwindm]

       widget_control,Mwindl,set_uvalue=[-88,557,0,b1,cque,-1,Mwindl,Mwindg,Mwindm,ssx,stx]
       if Lclass gt 0L then $
       widget_control,Lclass,set_uvalue=[-88,557,0,b1,cque,-1,Mwindl,Mwindg,Mwindm,ssx,stx]
       widget_control,Mwindg,set_uvalue=[-88,557,0,b1,cque, 1,Mwindl,Mwindg,Mwindm,ssx,stx]
;      widget_control,Mtoolo,set_uvalue=[-88,557,0,b1,cque, 1,Mwindl,Mwindg,Mwindm,ssx,stx]
    endif
    if not mmp then begin &   widget_control,bad_id=ii,lamp_b1,scr_xsize=ssx
           widget_control,bad_id=ii,Mwindm     ,sensitive=0
           endif

    P_AFTER_REALIZE_DID,sepben,sepdon,sepdid

    if GEORGE ne 0 then GEORGEO,  /init $
    else if (lamp_siz lt 800) then put_logo, /TIO

    if sys_dep('VERSION') lt 5.0 then XMANAGER, 'LAMP' ,lamp_b1  ,event_handler='LAMP_EVENT_PARSER',CLEANUP='P_DYING' $
    else begin & XMANAGER, 'LAMP' ,lamp_b1  ,event_handler='LAMP_EVENT_PARSER',CLEANUP='P_DYING',/just_reg,/NO_BLOCK
         if L_upd then LU_LAMP, /silent, oBridge=SNA40 ;Keep thread object in a global to prevent from garbage.
         widget_control, lamp_b1, set_uvalue=[-85,700,1,runt], TIMER=1.

         CALL_PROCEDURE,'XMANAGER' ,/NO_BLOCK
         update_lamp_out,lamp_dir  ;& print,'Going...'
    endelse
    endif else begin
     if lamp_asite eq 'mic'   then MIC,1
     if just       eq 'touch' then begin
       TOUCH_B,1,'','+'
       P_MUS,'' & widget_control,bad_id=ii,basem,/destroy & XMANAGER
       if lamp_b1 eq -100  then  LAMP
     endif else $
     if just       eq 'tripx' then begin
       CALL_PROCEDURE,'tripx',/three_axis
       P_MUS,'' & widget_control,bad_id=ii,basem,/destroy & XMANAGER
       if lamp_b1 eq -100  then  LAMP
     endif
    endelse

  endelse
; -------
; if just ne 'just'  then bid=sys_dep('EXIT')
end

pro P_LAYOUT, flag ,prox=fiprox ,xbu=fixbu
;+
;** ********
;** User callable
;**       This procedure should be used as commands in MYINIT procedure.
;**       flag='george' , 'lamp' , 'light' , 'full' , 'hide' , 'show' FOR LAMP LAYOUT
;**       flag='List_oldTOF' TO LOAD 'A_List_oldTOF.prox' FOR MACROS LAYOUT
;**       prox=['file1','file2'] TO LOAD 'file1.prox' & 'file2.prox' IN DO COMMAND GUI
;-
@lamp.cbk
ev=CALL_FUNCTION('create_struct','id',0L,'top',lamp_b1,'handler',0L,'select',1,name='WIDGET_BUTTON') ;PB IDL36 IDL4

if n_elements(flag) eq 1 then case strlowcase(flag) of
  'george': begin & ev.id=lamp_ben[13]          & end
  'lamp':   begin & ev.id=lamp_ben[12]          & end
  'light':  begin & ev.id=lamp_ben[14]          & end
  'full':   begin & widget_control,bad_id=ii,lamp_ben[14],get_uvalue=uv
                  if ii eq 0 then ev.id=uv[7] & end
  'hide':   if lamp_b1  gt 0 then widget_control,bad_id=ii,lamp_b1,iconify=1
  'show':   if lamp_b1  gt 0 then widget_control,bad_id=ii,lamp_b1,iconify=0
   else:    if strpos(strlowcase(flag),'list_') ge 0 then begin

               if n_elements(lamp_did) gt 6 then $
               if lamp_did[6] gt 0 then begin & widget_control,lamp_did[6],get_uvalue=fullist
                  if fullist[0] gt ' ' then begin
                     pos=strpos(strlowcase(fullist),strlowcase(flag)) & idx=where(pos ge 0) & idx=idx[0]
                     if idx ge 0 then P_MAC_EVENT,ev,[-88,570,0,lamp_did[6:9],idx] $
                     else begin
                          fil=finefile(flag,count=cnt)
                          if cnt gt 0 then begin & fullist=[fullist,fil] & idx=n_elements(fullist)-1
                                      widget_control,lamp_did[6],set_uvalue=fullist
                                      P_MAC_EVENT,ev,[-88,570,0,lamp_did[6:9],idx]
                          endif
                     endelse
                  endif
               endif
            endif
endcase
if ev.id gt 0 then LAMP_EVENT_PARSER, ev

if n_elements(fiprox) eq 1 then don_do_cmd, prox=fiprox
if n_elements(fixbu)  eq 1 then begin & fifi=fixbu
   if sys_dep('VERSION') ge 5.5 then begin & nfif=0 & tfif=''
                         tfif=call_function('file_search',lamp_dir  ,fixbu,count=nfif,/fold_case)
      if nfif eq 0 then  tfif=call_function('file_search',lamp_macro,fixbu,count=nfif,/fold_case)
      if nfif gt 0 then  fifi=tfif[0] & endif
   DialInit,'xbu' & xbucontrol, 'read',FILE=fifi
endif
end

pro AFTER_RESTORE
;+
;** *************
;** arrange some variables after restoring a lamp session (lamp.ses)
;-
@lamp.cbk
    lamp_sys  = n_elements(w_min)-3-1
    lamp_b1   = 0L & p_screen  & p_set_font, 0
    lamp_act  = 0L & lamp_focus =0 & l_message  =0L
    b_labins  = lonarr(9)   & b_labins[*]=0L
    Snapix    = 0L
    for i=0,lamp_sys do ii=execute('Sna'+strtrim(string(i),2)+'=0')

    jou_c     =['*******','SESSION','*******'] & jou_w=[' ',stime(dum),' ']
    last_form =''
    path      ='' & my_path   =[path,'','',!D.NAME]
    lamp_cyc  =[strtrim(lamp_cyc,2),'',''] ;Just in case:we have added a !proposal! in 2012
end

pro P_ENVI ,cust
;+
;** ******
;**
;** Track environments and custome variables.
;** see customiz , read_par.pro , read_par.ill
;** it calls P_NEWCUST to complete the work
;-
@lamp.cbk
    p_screen

    lamp_user ='' & lamp_user =STRLOWCASE(sys_dep('GETENV','USER'))
    lamp_dir  ='' & lamp_dir  =sys_dep(   'GETENV','LAMP_DIR' ) & lamp_dir=strtrim(lamp_dir,2)
    lamp_exec ='' & lamp_exec =sys_dep(   'GETENV','LAMP_EXEC')
    lamp_host ='' & lamp_host =sys_dep(   'GETENV','HOST')
            instrument=STRLOWCASE(sys_dep('GETENV','INSTRUMENT'))
            if instrument gt '' then lamp_host=instrument
            if lamp_host  eq '' then lamp_host=getenv('SYS$NODE')
            if lamp_dir   eq '' then cd,current=lamp_dir
    j=STRPOS( lamp_host, ':') & if j ge 0 then lamp_host=STRMID(lamp_host,0,j)
    lamp_host =STRLOWCASE(lamp_host)

    lamp_dvd  =sys_dep('DIVIDER')
    lamp_6    =6
    lamp_proxy=''

    lamp_ins  =['demo']
    lamp_wrti =[' '] & lamp_wrtp =[' ']
    lamp_grp  =[' ']
    lamp_ali  =['Current Path']
    lamp_path =['']
    lamp_asite= 'rdfilter'
    lamp_fsite= ' '

    lamp_proc    =strarr(n_elements(lamp_ins))
    lamp_proc[*] ='rdid'
    lamp_proc[0] ='read_tmp'
    lamp_touch   ='demo/TOUCH_BASE'
    lamp_macro   ='~lambda/macros'

    lamp_data = lamp_path[0]
   ;             index in path,ali  ,cycle RDSET keyword ,wanted proposal ,previous proposal
    lamp_cyc  = ['0'                ,'0'                 ,''              ,''              ]
    cycle     =lamp_ali[lamp_cyc[0]]
    path_for_online=lamp_path[lamp_cyc[0]]

    if (lamp_dir eq '') then cd,current=lamp_dir
    nld=strlen(lamp_dir)
    if (lamp_dir ne '')   then begin
     if strmid( lamp_dir,nld-1,1) eq lamp_dvd then lamp_dir=strmid(lamp_dir,0,nld-1)
     bid=sys_dep('IDLPATH',lamp_dir,nld)
    endif

    if n_elements(cust) eq 0 then P_NEWCUST

;   if sys_dep('MACHINE') eq 'vms' then lamp_touch=' '

;   sort by group keeping a certain order!
    grp =reverse(lamp_grp[sort(lamp_grp)]) & grp =grp[uniq(grp)]
    if n_elements(grp) gt 1 then begin
       for i=0,n_elements(grp)-1 do begin
        idx   =where(lamp_grp eq grp[i])
        if i gt 0 then p_grp =[p_grp ,lamp_grp[ idx]] else p_grp  =lamp_grp[ idx]
        if i gt 0 then p_ins =[p_ins ,lamp_ins[ idx]] else p_ins  =lamp_ins[ idx]
        if i gt 0 then p_proc=[p_proc,lamp_proc[idx]] else p_proc =lamp_proc[idx]
       endfor
       lamp_grp=p_grp & lamp_ins=p_ins & lamp_proc=p_proc
    endif
;   idx      =sort(lamp_grp)
;   lamp_grp =lamp_grp (idx)
;   lamp_ins =lamp_ins (idx)
;   lamp_proc=lamp_proc(idx)

    if n_elements(lamp_ins) eq 2 then begin & inst_value=lamp_ins[0] & inst_group=lamp_grp[0]
    endif else  for i=0,n_elements(lamp_ins)-1 do begin
                    if strpos(strlowcase(lamp_ins[i]),lamp_host) ge 0 then begin
                    inst_value=lamp_ins[i] & inst_group=lamp_grp[i]   &    endif
                endfor

   ;if  strpos(!path,"home") lt 0 then  begin   ta=finefile('home') & l_me=''
   ;          ;if n_elements(ta) ge 1 then   l_me=expand_path('+home')
   ;          ;if n_elements(ta) ge 1 then   l_me=expand_path( 'home')
   ;           if l_me ne '' then bid=sys_dep ('ADDPATH',l_me)
   ;          endif
   ;meed=sys_dep ('NEWSUB',sys_dep ('HOME'),'../DIALS')
   ;
   ;if  strpos(!path,"DIAL") lt 0 then  begin   ta=finefile(meed)   & l_me=''
   ;          if n_elements(ta) gt 1 then   l_me=expand_path('+'+meed)
   ;          if l_me ne '' then bid=sys_dep ('ADDPATH',l_me)
   ;          endif
    if (lamp_macro gt ' ') then  lamp_macro=expand_path(lamp_macro)
    if (lamp_macro gt ' ') then  begin
             ;ta=finefile(lamp_macro+lamp_dvd+'*') & l_me=''
             ;if n_elements(ta) gt 1 then   l_me=expand_path('+'+lamp_macro)
                                            l_me=expand_path('+'+lamp_macro)
              if l_me ne '' then bid=sys_dep('ADDPATH',l_me)
              if l_me ne '' then bid=sys_dep('ADDPATH',lamp_macro) else lamp_macro=''
    endif
;** Local or Remote
;** ----- -- ------
    lamp_loc  =0
    disp  ='' &      disp =sys_dep('GETENV','DISPLAY')
    if disp           eq '' then lamp_loc=1 else $
    if strpos(disp,':')       eq 0  then lamp_loc=1 else $
    if strpos(disp,lamp_host) eq 0  then lamp_loc=1
return
end

FUNCTION P_LAMBDA, dummy
;+
;******* ********
;** User callable
;** give back the lamp_macros localisation for the user (function)
;-
@lamp.cbk

if n_elements(lamp_macro) ne 1 then return,''
rst=lamp_macro
idx=strpos(lamp_macro,'macros')
if  idx gt 0 then begin & rst= strmid(lamp_macro,0,idx-1) +lamp_dvd
                        if   lamp_dvd eq "" then rst=rst+"]"
             endif else if   lamp_dvd ne "" then rst=rst+lamp_dvd

if rst gt ' ' then if strmid(rst,strlen(rst)-1,1) ne lamp_dvd then rst=rst+lamp_dvd
;bid= finefile   (rst+'*',count=n)
 bid= finefile(   rst    ,count=n)
if n eq 0 then rst=''
return, rst
end
PRO P_LAMBDA, rst
;+
;** ********
;** User callable
;** give back the lamp_macros localisation for the user (procedure)
;**
;-
rst=P_LAMBDA( dum)
end

pro P_ILLproposal, flag, runtxt, okProposal, ask=ask
;+
;** *************
;** Comes from P_MAC_EVENT
;**flag='560:(inst)'  Change instrument, path contained /(inst)/users/data/
;**     '560:newInst' Change instrument, path contains  'Cycle'/'inst'/
;**     '561:browse'  Change path,       ali path is '...BROWSE...'
;**     '561:(inst)'  Change path,       path contained /(inst)/users/data/
;**     '561:newPath' Change path,       path contains  'Cycle'/'inst'/
;**     '563:browse'  Browse from File menu_bar
;-
@lamp.cbk

OK_Prop=0                 ;activate proposal (since 2012)
OK_Inst=0                 ;inst_value is in path_for_online
curProp= lamp_cyc[3]      ;Current proposal
                          ;lamp_cyc(2) is not empty only when is set by RDSET
Pfilter='exp_*'           ;proposal form
internU='internalUse'     ;special experiment
Pp     ='exp_'            ;Pp should be at position 0
d      =lamp_dvd          ;divider /,\
my_D   ='byInstrument'    ;String which may be present in path_for_online, include proposals
raw_D  ='rawdata'         ;Directory of rawdata after the proposal directory
raw_L  =strlen(raw_D)
ins_L  =strlen(inst_value)
pth_L  =strlen(path_for_online)

;Is inst_value in path_for_online?
idxInst=strpos(strlowcase(path_for_online),d+strlowcase(inst_value)+d) & idxInst=idxInst[0]
if idxInst gt 0 then OK_Inst=1

;In case we have a cycle in path_for_online: activate proposal after the Dday
Dday   =systime(1)/86400-15635  ;The day since 2012 cycle 3 (21~24 Oct)

if strpos(path_for_online, d+my_D+d) ge 0                                             then OK_Prop=1

if (strmid(path_for_online, pth_L -1-raw_L-1,raw_L+1) eq d+raw_D) and (OK_Inst)       then OK_Prop=1 $ ;ends with /raw_D/  (561:browse)
else if strpos(path_for_online, d+my_D+d) ge 0                                        then OK_Prop=1 $ ;MyData/ in ~/
else begin
     Pcyc=strmid(path_for_online, pth_L - ins_L -1 -8,8)
     if (Pcyc eq d+'data-1'+d)                                                        then OK_Prop=1 $ ;/data-1/ (19 Feb)
     else begin &       Pcyc=strmid(path_for_online, pth_L - ins_L -1 -6,6)
                      if (Pcyc eq d+'data'+d)                                         then OK_Prop=1 $ ;/data/   (24 Oct)
                      else begin & Pcyc=strmid(path_for_online, pth_L - ins_L -1 -5,5)
                                 if (Pcyc ge d+'123'+d) and (Pcyc le d+'523'+d)       then OK_Prop=1   ;/cycle/ Untill I'm 100 year old !!!
     endelse    &     endelse
    ;print,Pcyc
endelse
if not OK_Prop then lamp_cyc[2:3]=''

;print,flag,' ',path_for_online,' ',' ',OK_Inst,OK_Prop

case flag of
'561:browse':  begin ;User choose '...BROWSE...' in the path alias menu
                iniPath=''
                if OK_Prop and OK_Inst then begin
                   iniPath=path_for_online                          ;We may browse a proposal
                   iniPath=strmid(iniPath,0,idxInst+ins_L+2)        ;Ends with inst_value
                endif
                pptthh=CALL_FUNCTION("dialog_pickfile",/directory,path=iniPath,group=lamp_b1)
                if pptthh gt ' ' then begin
                  if strmid(pptthh,strlen(pptthh)-1,1) ne d then pptthh=pptthh+d
                  Lpth=strlen(pptthh)
                  lamp_path[lamp_cyc[0]]=strmid(pptthh,0,Lpth-1)    ;put the path in ...BROWSE... alias !
                  path_for_online=pptthh
                  ;Is inst_value in path_for_online?
                  idxInst=strpos(strlowcase(path_for_online),d+strlowcase(inst_value)+d) & idxInst=idxInst[0]
                  
                  if idxInst gt 0 then begin   ;check if user choose a proposal
                     idxM = strpos(path_for_online, d+internU)
                     if (idxM le 0) then idxM =strpos(path_for_online, d+Pp)
                     if (idxM gt 0) then begin
                       expD = strmid(path_for_online, idxM+1)
                       idxM = strpos(expD,d)
                       
                       if idxM gt 0 then begin ;YES IT IS ...
                         if strlen(expD) eq idxM+1 then path_for_online=path_for_online+raw_D+d ;add /raw_D/ if not there
                         expD = strmid(expD, 0, idxM)
                         lamp_cyc[3]=expD & lamp_cyc[2]=''          ;put this proposal in lamp_cyc
                         okProposal=1
                       endif
                     endif
                  endif
                endif
               end
'563:browse':  begin ;We may browse a proposal from [File] in menu_bar
               if OK_Prop and OK_Inst then begin
                     idxM =strpos(runtxt,Pp)
                     if (idxM ne 0) then idxM =strpos(runtxt,internU)
                     if (idxM eq 0) then begin      ;YES IT IS ...
                         lamp_cyc[3]=runtxt & lamp_cyc[2]=''          ;put this proposal in lamp_cyc
                         okProposal =1
                         runtxt     =runtxt+d+raw_D                   ;add raw_D
                        ;path_for_online=path_for_online+runtxt+d     ;path_for_online is updated at 564
                     endif
               endif
               end
'560:(inst)': ;Nothing to do, no restriction, users/data/ contains only the current experiment.
'561:(inst)': ;Nothing to do, no restriction, users/data/ contains only the current experiment.

else:          begin;'560:newInst' ***or*** '561:newPath'
               if OK_Prop and OK_Inst then begin              ;We may have a proposal directory
                   filou=finefile(path_for_online+Pfilter,count=n) & okU=0
                   if n eq 0 then filou=finefile(path_for_online+internU,count=n) else okU=1
                   
                   if n gt 0 then begin
                      testFile=filou[(n_elements(filou)-1)/2] ;take one name (middle one)
                      post =strpos(testFile,d,/reverse_search)
                      if post ge 0 then testFile=strmid(testFile,post+1)
                      idxM =strpos(testFile,Pp)               ;and check if it is a proposal
                      if (idxM ne 0) then idxM =strpos(testFile,internU)
                      if (idxM eq 0) then begin               ;YES WE HAVE ...
                          filou=strmid(filou,post+1)          ;all Proposals in filou
                          
                          if okU then begin & filou=[filou,internU] & n=n+1 & endif ;+internU
                          
                          if n eq 1 then idx=[0] else $
                          if lamp_cyc[2] gt ' '  then idx=where(filou eq lamp_cyc[2]) else idx=[-1]

                          if (idx[0] ge 0) or (n eq 1) then begin                   ;WE HAVE ONLY ONE PROPOSAL or RDSET,proposal='...'
                              lamp_cyc[3]=filou[idx[0]] & lamp_cyc[2]=''            ;put this proposal in lamp_cyc
                              okProposal=1
                              path_for_online=path_for_online+lamp_cyc[3]+d+raw_D+d ;update path_for_online
                              
                          endif else if ask then begin              ;else request if not comming from RDSET
                              pptthh=CALL_FUNCTION("dialog_pickfile",/directory,path=path_for_online,group=lamp_b1)
                              if pptthh gt ' ' then begin
                                 if strmid(pptthh,strlen(pptthh)-1,1) ne d then pptthh=pptthh+d
                                 idx=strpos(pptthh,d+Pp)
                                 if idx eq -1 then idx=strpos(pptthh,d+internU)
                                 if idx gt  0 then lamp_cyc[3]=strmid(pptthh,idx+1 , strpos(pptthh,d,idx+1)-idx-1 )
                                 lamp_cyc[2]=''                     ;to be able to change proposal
                                 okProposal=1
                                 path_for_online = pptthh                  ;update path_for_online
                                 if strmid(pptthh,strlen(pptthh)-1-raw_L,raw_L) ne raw_D then $
                                 path_for_online=path_for_online+raw_D+d ;add /raw_D/ if not there
                              endif
                          endif
                      endif
                   endif
               endif
               end
endcase
end

function P_ONLYONE ,pth, lamp_dvd
;+
;******* *********
;**
;** Choose path corresponding to the platform.
;** called after readding read_par.pro (customize)
;-

    domain=sys_dep('GETENV','USERDNSDOMAIN')
    if strpos(strupcase(domain),'ILL.') eq 0 then domain='ILL'
    npth=strsplit(/EXTRACT,pth,',')
    npdx=-1
    for k=0,n_elements(npth)-1 do begin & npth[k]=strtrim(npth[k],2)
        if (strpos(npth[k],'\\serhom\') lt 0) or (domain eq 'ILL') and $
           (strpos(npth[k],'\\serdon\') lt 0) or (domain eq 'ILL') then begin
            nld=strlen(npth[k])
            if (strpos(npth[k],lamp_dvd) ge 0) and (npdx lt 0) then npdx=k
            if  strmid(npth[k],nld-1,1)  eq lamp_dvd then npth[k]=strmid(npth[k],0,nld-1)
        endif
    endfor
return, npth[npdx>0]
end

pro P_NEWCUST ,fromcust=fromcust
;+
;** *********
;**
;** Update customisable tables.
;** Track environments and custome variables.
;** see customiz , read_par.pro , read_par.ill
;** called by P_ENVI and complete the work
;-
@lamp.cbk

    datp      = ''    & init= 'init'
    stat=0 & catch,stat
    if stat  ne 0  then catch,/cancel else begin
         pth=sys_dep('NEWSUB',lamp_dir,'lamp_mac')
         t = finefile( pth + 'read_par.pro',count = exist)
         if (exist eq 0) then begin & pth=!dir    +sys_dep("DIVIDER")
         t = finefile( pth + 'read_par.pro',count = exist) & endif
         if (exist eq 0) then begin & status=23 & datp=0 & bid=0
                         bid=CALL_FUNCTION('read_par',"","",status,datp)
                         endif
         on_ioerror, mis_par & in=-1

         OPENR,in,pth+'read_par.pro',/get_lun
         on_ioerror, end_par
               ligne=' '   & ttinst='' & ttproc ='' & ttgroup ='' & ttsymbol='' & ttpath=''
               ttwall=''   & ttouch='' & ttmacro='' & ttaccess='' & ttsite  ='' & ttmagi='6'
               ttpars='120'
               WHILE not eof(in) DO begin
                             readf,in,ligne
                             IF not sys_dep('VM') then $
                             IF (strpos(ligne,';exec') gt 0) THEN r=execute(ligne)
               ENDWHILE
               end_par: datp={a:ttinst,  b:ttproc,  c:ttgroup,  $
                        d:ttsymbol,e:ttpath,  f:ttouch,   $
                        g:ttmacro, h:ttaccess,i:ttsite,j:ttmagi,k:ttwall,l:ttpars}
         mis_par:if in gt 0 then FREE_LUN,in
         catch,/cancel
    endelse

    if n_tags(datp) gt 0 then  begin
            nins = datp.a
            nproc= datp.b
            ngrp = datp.c
            lamp_wrti =[' '] & lamp_wrtp =[' ']
;**
            for i= 0,n_elements(nins)-1 do begin &  pos=-1
                if strpos(nins[i],'.') ne strlen(nins[i])-1 then begin
                   for j=0,n_elements(lamp_ins)-1 do if lamp_ins[j] eq nins[i] then pos=j
                   if  pos ge 0 then begin
                       lamp_proc[pos]=nproc[i]
                       lamp_grp[ pos]=ngrp[ i]
                   endif else begin
                       lamp_ins    =[lamp_ins ,nins[ i]]
                       lamp_proc   =[lamp_proc,nproc[i]]
                       lamp_grp    =[lamp_grp ,ngrp[ i]]

                       if n_elements(b_labins) gt 0 then if b_labins[0] gt 0 then begin
                          n  =n_elements(lamp_ins)-1
                          bid=widget_button(b_labins[0],font=ft_b_normal,value=lamp_ins[n],$
                                            uvalue=[-88,560,0,b_labins[0] , b_labins[1],n,0,0])
                       endif
                   endelse
                endif else begin & lamp_wrti=[lamp_wrti,strmid(nins[i],0,strlen(nins[i])-1)]
                                 lamp_wrtp=[lamp_wrtp,nproc[i]] & endelse
            endfor
;**
            nali =datp.d
            npath=datp.e
            n_ali=min([n_elements(nali),n_elements(npath)])-1 ; Corrupted read_par.pro !!!
            for i= 0,n_ali do begin &  pos=-1
                for j=0,n_elements(lamp_ali)-1 do if lamp_ali[j] eq nali[i] then pos=j
                npath[i]=P_ONLYONE(npath[i],lamp_dvd)
                if strpos(npath[i],'~') ge 0 then npath[i]=expand_path(npath[i])
                if  pos ge 0 then begin
                   lamp_path[pos]=npath[i]
                endif else begin
                   lamp_ali    =[lamp_ali ,nali[ i]]
                   lamp_path   =[lamp_path,npath[i]]

                   if n_elements(b_labins) gt 0 then if b_labins[1] gt 0 then begin
                      n  =n_elements(lamp_ali)-1
                      OKcyc=0
                      if strpos(strlowcase( lamp_ali[ n]),'c_year') eq 0 then begin ; SHOULD ADD CYCLES (like P_DATA_ACCESS in dids)
                         yr =strtrim(strmid(lamp_ali[ n] ,7,15),2) & yr=strmid(yr,2,2)
                         if (yr gt '00') and (yr le '99') then begin
                           OKcyc=1
                           didon=widget_button(b_labins[1],font=ft_b_normal,menu=2 ,value=lamp_ali[n])
                           for c=1,5 do begin &  yrs=yr+strtrim(c,2)
                             bid=widget_button(didon  ,font=ft_b_normal,value='Cycle '+yrs ,$
                                        uvalue=[-88,561,0,b_labins[0], b_labins[1] ,n,0,long(yrs)])
                           endfor
                         endif
                      endif
                      if not OKcyc then $
                      bid=widget_button(b_labins[1],font=ft_b_normal,value=lamp_ali[n] ,$
                                        uvalue=[-88,561,0,b_labins[0], b_labins[1] ,n,0,0])
                   endif
               endelse
            endfor
 ;**
        if keyword_set(fromcust) then RDSET,inst=inst_value
            lamp_touch=P_ONLYONE(datp.f,lamp_dvd)
            lamp_macro=P_ONLYONE(datp.g,lamp_dvd)
            idxm=strpos(lamp_macro,'\\serhom') & idxt=strpos(lamp_touch,'\\serhom') ;TREAT BUG OF IDL WITH \\address
            if (idxm ge 0) or (idxt ge 0) then begin & res=[""] & call_procedure,'spawn','ipconfig',res,/hide,/noshell
                               idxi=strpos(res,'ill.') & idxi=where(idxi gt 0)
                               if idxi[0] lt 0 then begin
                                  if idxm ge 0 then lamp_macro="" & if idxt ge 0 then lamp_touch="" & endif & endif
            lamp_asite=datp.h
            lamp_fsite=datp.i
            lamp_6    =long(datp.j)
            lamp_proxy=datp.k
        if strpos(strupcase(lamp_fsite),'GEORGE') ge 0 then begin
           GEORGE=1 & lamp_fsite=""
           if strpos(strupcase(lamp_fsite),'LAMP') ge 0 then GEORGE=2
        endif
        npp          =long(datp.l)<10000
        if n_elements(par_txt) eq 0 then npars=npp else $
        if npp gt  npars then begin & nw=(size(par_txt))[1] & nww=(size(par_txt))[2]  & tmp=strarr(nw,npp)
              for i=0,nw-1 do   tmp[i,0:nww-1]=par_txt[i,*]   & par_txt    =tmp
              tmp=strarr(npp) & tmp[0:nww-1]  =par_txt_all[*] & par_txt_all=tmp
              npars=npp & endif
        lamp_path[0]=''
        if n_elements(b_labins) gt 0 then if b_labins[2] gt 0 then $
              widget_control,bad_id=i,b_labins[2],set_value=lamp_fsite
    endif
return
end

pro P_SCREEN
;+
;** ********
;** update the screen size common variable
;-
@lamp.cbk
screen=[800,600]
if !D.name eq 'Z'     then screen=[1024,1280] else $
if !D.name ne 'NULL'  then device,get_screen_size=screen

   if (screen[0] ge 1024) then screen[1]=screen[1]>800
   if (screen[1] lt 800 ) and (screen[1] gt 750) then screen[1]=800
   if (n_elements(lamp_ziz) ne 1) then if !version.os eq 'darwin' then if screen[1] le 900 then lamp_ziz=(screen[1]-100)>600 ;16/9eme
   if (n_elements(lamp_ziz) ne 1) then if !version.os eq 'linux'  then if screen[1] le 800 then lamp_ziz=(screen[1]-100)>600 ;16/9eme
   if (n_elements(lamp_ziz) eq 1) then screen[1]=min([screen[1],lamp_ziz])>480
   lamp_ziz=screen[1]
   lamp_siz=screen[1]

return
end

pro P_SET_FONT, n ,lamp_font
;+
;** **********
;** choose the fonts to adapte guis to the screen size
;**     Changes the look of next graphics interfaces. size is 0,1,2 for large,medium,small 
;**     The  call is P_SET_FONT ,2
;-
@lamp.cbk

    lamp_font = sys_dep('FONTS')
    fk=n
    if (lamp_ziz le 950 ) and (fk eq 0) then fk=1
    if (lamp_ziz lt 800 ) and (fk lt 2) then fk=2

    ft_propor    = lamp_font[0,fk]
    ft_biggest   = lamp_font[1,fk]
    ft_bigger    = lamp_font[2,fk]
    ft_b_bigger  = lamp_font[3,fk]
    ft_normal    = lamp_font[4,fk]
    ft_b_normal  = lamp_font[5,fk]
    ft_smaller   = lamp_font[6,fk]
    ft_smallest  = lamp_font[7,fk]


    if n_elements(lamp_b1) gt 0 then $
    if lamp_b1 gt 0 then widget_control,bad_id=ii,lamp_b1,default_font=ft_normal

    if n  eq 0 then lamp_siz=lamp_ziz else $
    if fk eq 1 then lamp_siz=900      else lamp_siz=780
return
end

; -----------------------------------------------------------------------------
; -----------------------------------------------------------------------------
; -----------------------------------------------------------------------------



;**      ********************************
;**      **                            **
             PRO LAMP_EVENT_PARSER,ev ,uv
;+
;**      **                            **
;**      ********************************
;** main lamp event parser for lamp, dons, dids, bens, georgeo, scan files
;** User_Value for lamp's widgets having an event has the following structure:
;** [lampcode, sequence , 0 , 0 , 0 , 0 , 0 , 0 , 0]
;**     where:
;**  lampcode=-88  for widgets under lamp
;**          =-87  for widgets under scan
;**          =-86  for others  front windows
;**          =-85  lamp_b1 Timer
;**  sequence= 100 --> 199 for MIC   unit
;**      = 200 --> 299 for DON   unit
;**      = 300 --> 399 for DID   unit
;**      = 400 --> 499 for BEN   unit
;**      = 500 --> 599 for MAC   unit
;**      = 600 --> 699 for GEO   unit
;**  others  = 7 free parameters
;-

@lamp.cbk
    if ev.id gt 0 then begin &  i=0

       if (tag_names(ev,/structure_name) EQ 'WIDGET_BASE') and (ev.id eq lamp_b1) then begin ;User resizing
           P_DID_RESIZE,ev & return & endif

       if n_elements(uv) eq 0 then widget_control, ev.id ,bad_id=i, get_uvalue=uv

       if i eq 0 then if n_elements(uv) gt 1 then begin

             stat=0 & catch,stat
             if stat  ne 0  then begin & catch,/cancel
                catch,stat & if stat ne 0 then retall
                therror=strmid(!error_state.msg,0,65)
                widget_control,bad_id=i,l_message,set_value=therror
                set_plot,my_path[3]
                P_MUS,'mus_cannon'
                if b_labins[6] then  if b_labins[7] gt 0 then $
                   widget_control,bad_id=i,b_labins[7],set_value=therror
                return & endif

        if  tag_names(ev,/structure_name) ne 'WIDGET_DRAW'  then  nodr=1 else nodr=0

        if uv[0] eq -85  then begin & if uv[2] ge 1 then widget_control,ev.id,TIMER=uv[2]
           if uv[2] eq 1 then begin & uv[2]=2  & widget_control,ev.id,set_uvalue=uv
                                    if not uv[3] then retall else return & endif
           if uv[2] eq 2 then begin & uv[2]=0  & widget_control,ev.id,set_uvalue=uv
              print,'%Lamp successfully loaded' & print,''
              if not uv[3] then print,'(Enter @lamp.cbk if you want to define Lamp variables at command line)' ;not runt
              if not uv[3] then widget_control,lamp_b1,/show ;not runt
           endif
           if lamp_siz ge 600 then widget_control,lamp_b1,/tlb_size_events
           dialinit,'tornade',D=12
        endif else $
        if uv[0] eq -87  then                P_DID_EVENT,ev,uv  else $
        if uv[0] eq -88  then  begin

           p_did_getw_cur, widx, wids & s=[0L] & bb=execute( 's=size(W'+wids+')' )
           dialtag,'tornade',tag='onoff',get=onoff & if s[0]*onoff gt 0 then dialstop,'tornade'

           if ( lamp_act eq 1) and (nodr)           then P_DID_EVENT,ev,[-88,300]
           if my_path[1] ne '' then if uv[1] ne 576 then P_SET_PATH

           if (uv[1] ge 600)  and (uv[1] le 699) then P_GEO_EVENT,ev,uv $
           else begin

           if  nodr  then widget_control,/hourglass
           if (uv[1] ge 100)  and (uv[1] le 199) then CALL_PROCEDURE,'P_MIC_EVENT',ev,uv
           if (uv[1] ge 200)  and (uv[1] le 299) then P_DON_EVENT,ev,uv
           if (uv[1] ge 300)  and (uv[1] le 399) then P_DID_EVENT,ev,uv
           if (uv[1] ge 400)  and (uv[1] le 499) then begin
                          P_BEN_EVENT,ev,uv
                          P_DID_SETWIN0
                          endif
           if (uv[1] ge 500)  and (uv[1] le 599) then P_MAC_EVENT,ev,uv
           if (uv[1] eq 222)  or  (uv[1] eq 342) or $
                     (uv[1] eq 422) then CALL_PROCEDURE,'P_EXTEND'   ,ev,uv

           if not nodr then if  ev.type eq 1 then if (ev.release eq 4) then $
           if sys_dep('VERSION') ge 5.5 then begin  ;Context menu creation or display
               cntxtid=widget_info(ev.id,/child)
               if cntxtid eq 0 then call_procedure,'did_ContextCreat',ev.id,0,cntxtid
               call_procedure,'WIDGET_DISPLAYCONTEXTMENU', ev.id, ev.X, ev.Y, cntxtid
           endif

           if lamp_b1 gt 0 then begin
             if (GEORGE eq 0) and (uv[1] ne 390) then that=lamp_b1 else that=long(lamp_don[0])
             evv=widget_event(that,/nowait,bad_id=i)
             widget_control,bad_id=i, that ,/clear_events
             if b_labins[8] gt 0 then begin
                evv=widget_event(b_labins[8],/nowait,bad_id=i)
                if i ne 0 then b_labins[8]=0 $
                          else widget_control,bad_id=i,b_labins[8],/clear_events
             endif
           endif
           ;**Repares bad manipulations
           wn=lamp_sys+3+1
           if n_elements(other_tit) ne wn       then other_tit=strarr(wn)
           if n_elements(w_tit)     ne wn       then w_tit    =strarr(wn)
           if n_elements(x_tit)     ne wn       then x_tit    =strarr(wn)
           if n_elements(y_tit)     ne wn       then y_tit    =strarr(wn)
           if n_elements(z_tit)     ne wn       then z_tit    =strarr(wn)
           if n_elements(par_txt)   ne wn*npars then par_txt  =strarr(wn,npars)
           endelse
        endif
       endif
    endif
return
end

; -----------------------------------------------------------------------------
; -----------------------------------------------------------------------------
; -----------------------------------------------------------------------------

pro P_MAC_CREATE ,base ,mbar ,wread ,b33 ,b1,cque
;+
;** ************
;** create the data collector frame of main lamp window
;-
@lamp.cbk
    b1   = widget_base(  base,/column)
    b11  = widget_base(  b1  ,/row ,/base_align_center)
    
    P_did_get_etc, d_etc  &  Pbm = d_etc.Pbm  &  Ubm = d_etc.Ubm
;b11
    bid=' DATA COLLECTOR'
    btitl= widget_label( b11 ,font=ft_biggest ,value=bid)
    bidon=''
    catch,stat & if stat eq 0 then CALL_PROCEDURE,'myhelp',bidon & catch,/cancel

    fhrt=finefile('myhelp.rt',count=nn) & if nn gt 0 then begin
      on_ioerror, mishlp & in=-1
      OPENR,in,'myhelp.rt',/get_lun
      line=''
      WHILE not eof(in) DO begin & readf,in,line & bidon=[bidon,'line'] & ENDWHILE
      mishlp: if in gt 0 then FREE_LUN,in
    endif
    if n_elements(bidon) gt 1  then begin
      bhelp=widget_button(b11 ,font=ft_b_normal  ,value='-Help-')
      bidon=widget_label( b11 ,font=ft_biggest ,value='   ')
    endif else begin
      if Ubm then bhelp=widget_button(b11 ,/bitmap,/flat ,value=Pbm+'bulb.bmp') $
             else bhelp=widget_button(b11 ,font=ft_normal,value='?')
      bidon=widget_label( b11 ,font=ft_propor  ,value='        ')
    endelse
    cd,current =path
    pwd_l=  widget_label( b11 ,font=ft_b_normal,value='Working path')
    btog =  widget_base(  b11,/nonexclusive, /align_top)
    togw =  widget_button(btog,font=ft_smallest,value='',resource_name='discret')
    pwd_t=  widget_text(  b11 ,value=path,font=ft_b_bigger,xsize=24,ysize=1,/editable,/all_events)
    butbbq= widget_base(  b11 ,/row)
    if sys_dep('VERSION') ge 5.6 then widget_control,togw,Tooltip='Input Working Path / Input Idl Command'
    if sys_dep('VERSION') ge 5.2 then begin
     if sys_dep('AT_ILL') then begin
          bubbb=  widget_button(butbbq,font=ft_smaller,value='Browse...',resource_name='discret',/menu)
          bubb =  widget_button(bubbb ,font=ft_propor ,value='Browse')
          bubbp=  widget_button(bubbb ,font=ft_propor ,value='Processed Experiment data')
          widget_control,bubb ,set_uvalue=[-88,541,0,pwd_t]
          widget_control,bubbp,set_uvalue=[-88,541,1,pwd_t]
     endif else begin
       if sys_dep('MAP') ne -1 then $
          bubb =  widget_button(butbbq,font=ft_smaller,value='Browse'   ,resource_name='discret') $
       else bubb =widget_button(butbbq,font=ft_smaller,value='Browse')
       widget_control,bubb,set_uvalue=[-88,541,0,pwd_t]
     endelse
    endif
    sel    =[strlen(path),0]
    my_path=[path,'',string(pwd_t),!D.NAME]

    laber=l_message
    cque =0
;b33
    if (n_elements(lamp_ins) le 1) or (lamp_asite eq 'customiz')  then text='Customize' $
          else if lamp_siz ge 800 then text='Data...' else text='Data...'

    if GEORGE ne 0 then begin
       bgeo2= laber

       if GEORGE eq 1 then begin & txt='Data' & map1=1 & map2=0 & b_labins[5]=1
       endif          else begin & txt='Pad'  & map1=0 & map2=1 & b_labins[5]=0 & endelse

       aque = widget_base(  b1,/row)

       if mbar eq 0 then begin
          bque = widget_button(aque ,font=ft_b_normal,value=txt)
          if sys_dep('MACHINE') eq 'win'  then val='  ' else val=' '
          bid  = widget_label( aque ,font=ft_propor  ,value=  val ) & endif

       aque = widget_base(  aque )
;      cque = widget_base  (aque ,/row,resource_name="geo",map=map1,frame=3)
       cque = widget_base(  aque ,/row,resource_name="geo",map=map1)

    ;  STACKER DATA ACCESS MODEL
;      b1= widget_base  (aque ,map=map2,/column,frame=3)
       b1= widget_base(  aque ,map=map2,/column)

    ;  BESIDE  DATA ACCESS MODEL
    ;  ttl='DATA Access....'
    ;  if sys_dep('VERSION') lt 4.0 then $
    ;         b1=widget_base(title=ttl,/column,map=0,resource_name="lampmic") $
    ;  else   b1=CALL_FUNCTION('widget_base',title=ttl,/column,map=0,resource_name="lampmic",tlb_frame_attr=8+2)
    ;  bu   = widget_base (b1 ,/row)
    ;  put_logo,bu
    ;  laber= widget_label(bu ,font=ft_b_normal,value='                     ',xsize=(lamp_siz/2)<600>300)
    ;  Widget_Control, b1 ,group_leader=lamp_b1,/Realize & put_logo
    ;  Xmanager,'Daccess' , b1 ,Event_Handler='LAMP_EVENT_PARSER',/just_reg

       if mbar eq 0 then  widget_control,bque,set_uvalue=[-88,557,0,b1,cque,0]

       dque = widget_base(  cque ,/column)
       eque = widget_base(  dque ,/row, /base_align_center)
       bid  = widget_label( eque ,font=ft_b_bigger,value='COMMAND Control PAD')
       if Ubm then bid = widget_button(eque ,/bitmap,/flat ,value=Pbm+'bulb.bmp',uvalue=[-88,595,laber,0]) $
              else bid = widget_button(eque ,font=ft_b_bigger,value='?'         ,uvalue=[-88,595,laber,0])
       eque = widget_base(  dque ,/row, /base_align_center)
       bido = widget_text(  eque ,font=ft_propor  ,xsize=20,ysize=1,/editable)
       bidu = widget_button(eque ,font=ft_b_bigger,value='Send')

       ii   = finefile('dial_pad_init.prox',count=nn)
       if  nn gt 0 then COMMSI,'dial_pad_init.prox', /EXEC $
       else begin & par1=''
                            Mach=strlowcase(getenv('INSTRUMENT'))
        if Mach le " " then Mach=strlowcase(getenv('HOST'))
        id=strpos(Mach,'.') & if id gt 0 then Mach=strmid(Mach,0,id)
        if Mach ne '' then begin
          catch,stat & if stat eq 0 then par1=CALL_FUNCTION('dial_pad_init_'+(Mach),dummy)
          catch,/cancel
          endif
        sz=SIZE(par1)
        if  sz[0]  lt 2 then begin
          catch,stat & if stat eq 0 then par1=CALL_FUNCTION('dial_pad_init',dummy)
          catch,/cancel
        endif
       endelse
       sz=SIZE(par1)
       if (sz[0] ne 2) or (sz[1] ne 5) then begin & par1=strarr(5,17) & par1[*,*]='0'
                                                  par1[0,0]='' & par1[3,0]='lamp'  & endif
       widget_control,bido,set_value=par1[0,0]
       PROX=par1[*,0]
       GEORGEO, duduch=PROX
       uvv =[-88,540,0,cque]
       widget_control,cque,set_uvalue=par1
       widget_control,bido,bad_id=i,set_uvalue=[uvv,0,PROX,bido,0]
       widget_control,bidu,bad_id=i,set_uvalue=[uvv,0,PROX,bido,0]

       i=1 & k=0 & n_e=n_elements(par1)/5
       par1=[[par1],['','','','','']]
       while i  lt n_e do begin
        val=par1[0,i]
        j=k/2 & if j*2 eq k then dque = widget_base(  cque ,/column)
        eque  = widget_base(  dque ,/row)
        k=k+1
;** level1
        if par1[2,i] eq '-' then begin
         bid1= widget_button(eque ,font=ft_b_bigger,value=val ,menu=2)
         i=i+1
         while strpos(par1[0,i],'-') eq 0 do begin
          val =strmid(par1[0,i],1,15)
;** level2
          if par1[2,i] eq '-' then begin
           bid2=widget_button(bid1 ,font=ft_b_bigger,value=val ,menu=2)
           i=i+1
           while strpos(par1[0,i],'--') eq 0 do begin
            val =strmid(par1[0,i],2,15)
;** level3
            if par1[2,i] eq '-' then begin
             bid3=widget_button(bid2 ,font=ft_b_bigger,value=val ,menu=2)
             i=i+1
             while strpos(par1[0,i],'---') eq 0 do begin
              val =strmid(par1[0,i],3,15)
              SetDuduch,"_send", par1[3,i], PROX
              bid4=widget_button(bid3 ,font=ft_b_bigger,value=val,uvalue=[uvv,i,PROX,bido,i])
              i=i+1
             endwhile
            endif else begin
             SetDuduch,"_send", par1[3,i], PROX
             bid3=widget_button(bid2 ,font=ft_b_bigger,value=val,uvalue=[uvv,i,PROX,bido,i])
             i=i+1 & endelse
           endwhile
          endif else begin
           SetDuduch,"_send", par1[3,i], PROX
           bid2=widget_button(bid1 ,font=ft_b_bigger,value=val,uvalue=[uvv,i,PROX,bido,i])
           i=i+1 & endelse
         endwhile
        endif else begin
         SetDuduch,"_send", par1[3,i], PROX
         bid = widget_button(eque ,font=ft_b_bigger,value=val,uvalue=[uvv,i,PROX,bido,i])
         i=i+1 & endelse
       endwhile
    endif
;b22
    if (lamp_siz ge 800) or (GEORGE ne 0) then $
        laber=  widget_label( b1 ,font=ft_b_normal,value='Click below to select experiment data (instrument macros)',$
                                  xsize=(lamp_siz*2/3)<600>300, /align_left)
        b_labins[7]=laber
;   b77=  widget_base  (b1  ,map=0)
    b88=  widget_base(  b1  ,/row)
    bac=  widget_button(b88 ,font=ft_b_normal,value=text)
    if sys_dep('VERSION') ge 5.6 then widget_control,bac,Tooltip='Access instrument data'
    b33=  widget_base(  b88 ,/row, map=0)
;b44
    IF mbar eq 0 then begin
      b44  =  widget_base(  b1  ,/row)
      if GEORGE ne 0 then bid='IMPORT FILES, Workspaces' $
          else bid='IMPORT FILES  or  RESTORE Workspaces'
      butl =  widget_button(b44 ,font=ft_b_normal,value=bid)
      buts =  widget_button(b44 ,font=ft_b_normal,value='EXPORT')
      if (lamp_touch gt ' ') and (lamp_siz ge 800) then $
        if sys_dep('MAP') ne -1 then $
           butt =  widget_button(b44 ,font=ft_b_normal,value='Catalog...',uvalue=[-88,331,0],$
                    resource_name='discret')  else $
           butt =  widget_button(b44 ,font=ft_b_normal,value='Catalog...',uvalue=[-88,331,0])
      if   sys_dep('MAP') ne -1 then $
           butb =  widget_button(b44 ,font=ft_b_normal,value='Browse...'    , $
                    resource_name='discret') else $
           butb =  widget_button(b44 ,font=ft_b_normal,value='Browse...')

      widget_control,butl ,bad_id=i,set_uvalue=[-88,380,0    ,0,0,0,0,0,0]
      widget_control,buts ,bad_id=i,set_uvalue=[-88,370,0    ,0,0,0,0,0,0]

      bs1f =widget_base(  b44,/row,/frame)
      if sys_dep('MAP') ne -1 then $
      bs1b1=widget_button(bs1f,font=ft_smaller ,value='<-',resource_name='discret') else $
      bs1b1=widget_button(bs1f,font=ft_smaller ,value='<-')
      wread=widget_label( bs1f,font=ft_b_normal,value='W1 ',xsize=32)
      if sys_dep('MAP') ne -1 then $
      bs1b2=widget_button(bs1f,font=ft_smaller ,value='->',resource_name='discret') else $
      bs1b2=widget_button(bs1f,font=ft_smaller ,value='->')

      widget_control, bs1b1  ,bad_id=i,set_uvalue=[-88,310,wread,0   ,0,0,0,0,0]
      widget_control, bs1b2  ,bad_id=i,set_uvalue=[-88,311,wread,0   ,0,0,0,0,0]
      widget_control, butb   ,bad_id=i,set_uvalue=[-88,562,0,0,wread ,-2,-2,0]

    endif else begin & butb=b88 & widget_control,butb,bad_id=i,set_uvalue=[-88,562,0,0,0 ,-1,-1,0] & endelse

    P_DATA_ACCESS, laber,b33,bac,butb,1

    if n_elements(lamp_wrd) ne 1 then lamp_wrd='W1'

    widget_control,butb ,bad_id=i,get_uvalue=uv & wread=[uv[3],uv[4]]
    widget_control,bhelp,bad_id=i,set_uvalue=[-88,586,laber,0,0,0,0,0,0]
    widget_control,pwd_t,bad_id=i,set_uvalue=[-88,576,laber,0,0,0,0,0,0],SET_TEXT_SELECT=sel
    widget_control,togw ,bad_id=i,set_uvalue=[-88,543,laber, pwd_t, pwd_l, butbbq], set_button=1

    widget_control,bac  ,bad_id=i,set_uvalue=[-88,558,laber,b33,bac,butb]
return
end

pro P_MAC_EVENT  ,event ,uv
;+
;** ***********
;** events handled by lamp.pro
;-
@lamp.cbk

    if (uv[2] gt 1) and (size(uv,/type) eq 3) then widget_control,uv[2],bad_id=i,set_value='                   '
    icoco=0

;**PAD  Control
    if uv[1] eq 540 then begin                         ;uv[3]=cque  uv[7]=widget_text
       widget_control,uv[3],get_uvalue=PadTab          ;uv[8]=idx in padtab
       ncomm=-1
       bito = 0
       if uv[4] le 0 then begin                        ;*Comes from input widget_text
         widget_control,uv[7],get_value =comm
         comm =comm[0] & ncomm=uv[8]                   ;  will xecute the command
       endif else begin                                ;*Comes from button
          if PadTab[2,uv[8]] eq "t" then begin         ;   Put command to widget_text
         widget_control,uv[7],set_value =PadTab[1,uv[8]]
         widget_control,uv[7],get_uvalue=uvv & uvv[8]=uv[8]
         widget_control,uv[7],set_uvalue=uvv           ;   and put index in uv
          endif else $
          if (uv[4] ne 100) and $
            (PadTab[2,uv[8]] eq "c") then begin & k=uv[8];   Create a GUI-input command
             str8="PAD_" +strtrim(  string(k),2)
         if xregistered(str8) le 0 then begin
            padr=strsplit(/EXTRACT,    PadTab[1,k],"<cr>",/regex)
            padb=widget_base(title=PadTab[0,k],resource_name='lamp',/column)
            for r=0,n_elements(padr)-1 do begin
              padt =strsplit(/EXTRACT, Padr[r],"~")
              n    =n_elements(    padt)
              if (n/2)*2 ne n then padt=[padt,' ']
              n    =n_elements(    padt) & biti =lonarr(n)
              padg =widget_base(   padb,/row,resource_name='geo',/frame)
              for i=0,n-1,2 do begin
                    bid=widget_base(  padg,/column)
                    bil=widget_label( bid ,value=padt[i]  ,font=ft_b_bigger) & biti[i]=bil
                    bit=widget_text(  bid ,value=padt[i+1],font=ft_propor ,/editable, xsize=strlen(padt[i+1])+3) & biti[i+1]=bit
              endfor
            if r eq 0 then bito=biti else bito=[bito,-1,-1,biti]
            endfor
            ivv  =uv & ivv[4]=100
            padg =widget_base(  padb,/row,resource_name='geo') & put_logo,padg
            bid  =widget_button(padg,value='SEND ->',font=ft_b_bigger,uvalue=ivv)
            bid  =widget_button(padg,value=' CLOSE ',font=ft_b_bigger,uvalue=[-88,399,0])
            err  =widget_label( padg,value='       ',font=ft_b_normal,xsize=250)
            bito =[bito,err]
            widget_control,padb,group_leader =lamp_b1,set_uvalue=bito,/realize & put_logo
            XMANAGER, str8,padb,event_handler='LAMP_EVENT_PARSER',/just_reg,/NO_BLOCK
         endif
          endif else begin
             ncomm=uv[8]          ;   will execute the command
         if (uv[4] ne 100) then  comm =PadTab[1,uv[8]] $   ;from button
         else begin &    como='' & comm =[''] & r=0 & sep=''       ;from GUI
          widget_control, event.top, get_uvalue=bito
          nbito= n_elements(bito)-1
          for j=1,nbito-1,2 do begin &   comi=''
                   if bito[j] gt 0 then begin
              widget_control,bad_id=ii,bito[j-1],get_value=labi
              widget_control,bad_id=ii,bito[j]  ,get_value=comu
              comi   = strtrim( comu[0],2)
              comm[r]= comm[r] +comi+' '
              if comi eq '' then ncomm=-1
              como   = como+sep+labi[0]+"~"+comi & sep="~"
                   endif else begin & r=r+1  & sep=""
              comm   =[comm,'']  & como=como+"<cr>" & endelse
          endfor
          PadTab[1,uv[8]]=como
          widget_control,uv[3]    ,set_uvalue=PadTab
          if ncomm lt 0 then txt='!!! Cmd is incomplete.' else txt='Sending ...'
          bito=bito[nbito]
          widget_control,bito,bad_id=ii,set_value =txt
         endelse
          endelse
       endelse
       if ncomm ge 0 then begin                        ;*Executes the command
         d0={GENERIC:PadTab[3,ncomm],NAME:PadTab[0,ncomm],TYPE:'PAD',PROS:[uv[5],uv[6]]}
         on_ioerror, mischk & check=0. & check=float(PadTab[4,ncomm]) & mischk:
         R=0L & R=CALL_FUNCTION('DialControl',comm,d=0,check=check)
         if (R lt 0) or (R gt 1) then txt="error-code "+string(R) else txt= '- Sent -'
         if bito gt 0 then widget_control,bito,set_value =txt     else print,txt+': '+comm
       endif
       endif

;**Browse working path
    if uv[1] eq 541 then begin & pptthh=''
                               if uv[2] eq 0 then begin
                                 pptthh=CALL_FUNCTION("dialog_pickfile",/directory,group=lamp_b1)
                               endif else if uv[2] eq 1 then begin
                                 rawidx=strpos(path_for_online,lamp_dvd+'rawdata')
                                 if rawidx ge 0 then pptthh=strmid(path_for_online,0,rawidx+1)+ 'processed'+lamp_dvd
                                 if not file_test(pptthh,/directory) then begin
                                        lamp_message,'!UNACCESSIBLE: '+pptthh &  pptthh='' & endif
                               endif
                               if pptthh gt ' ' then begin
                                   widget_control,uv[3],get_uvalue=rv
                                   if rv[1] eq 576 then widget_control,uv[3],set_value=pptthh
                                   P_SET_PATH,pptthh,/silent
                               endif
    endif
;**Browse internet access
    if uv[1] eq 542 then bid=sys_dep('BROWSE',lamp_path[uv[3]])

;**Toggle working path and do button
    if uv[1] eq 543 then begin & if event.select  then begin & cd,current=papath & sel=[strlen(papath),0]
                                  widget_control,uv[3],set_value=papath,SET_TEXT_SELECT=sel,ALL_TEXT_EVENTS=1,set_uvalue=[-88,576,uv[2],0,0]
                               endif else begin
                                  widget_control,uv[3],set_value='    ;<-Idl input command',ALL_TEXT_EVENTS=0,set_uvalue=[-88,214,0,uv[3],0],/input_focus
                               endelse
                               widget_control,uv[4],sensitive=event.select
                               widget_control,uv[5],map=      event.select
    endif
;**Hide / Show data access
    if uv[1] eq 544 then begin & uv[4]=1-uv[4] ;toggle map/nomap
                                 widget_control,event.id, set_uvalue= uv
                                 widget_control,uv[3],bad_id=ii, map= uv[4] & endif
;**Lamp and George configuration
    if uv[1] eq 557 then begin & widget_control,event.id,get_value=labbut
             widget_control,bad_id=i,l_message,set_value=''
             if n_elements(uv) gt 6 then idx=uv[5] else idx=0
             if   idx eq 0 then begin
              idx=strpos(strupcase(labbut),'PAD')
              if  idx ge 0 then widget_control,event.id,set_value="Data" $
                           else widget_control,event.id,set_value="Pad"
             endif else begin
              if  idx gt 0 then widget_control,uv[6],sensitive=1 else widget_control,uv[6],sensitive=0
              if  GEORGE gt  0  then $
              if  idx gt 0 then widget_control,uv[7],sensitive=0 else widget_control,uv[7],sensitive=1
             endelse
             if idx eq -1 then begin
              widget_control,bad_id=i,uv[4],map=0
              widget_control,bad_id=i,uv[3],map=1 & b_labins[5]=0
              if GEORGE       eq 2 then widget_control,bad_id=i,lamp_ben[8] , map=0
                                        widget_control,bad_id=i,lamp_ben[7] , map=1
              if lamp_ben[10] gt 0 then widget_control,bad_id=i,lamp_ben[10], map=0

              if b_labins[6]  eq 1 then widget_control,bad_id=i,lamp_ben[0] , map=0
              if b_labins[6]  eq 1 then widget_control,bad_id=i,lamp_b1     , scr_xsize=uv[9]
              if b_labins[6]  eq 1 then widget_control,bad_id=i,uv[8]       , sensitive=0

             endif else begin
              widget_control,bad_id=i,uv[3],map=0
              widget_control,bad_id=i,uv[4],map=1 & b_labins[5]=1
              if GEORGE       eq 2 then widget_control,bad_id=i,lamp_ben[7] , map=0
              if GEORGE       eq 2 then widget_control,bad_id=i,lamp_ben[8] , map=1
              if lamp_ben[10] gt 0 then widget_control,bad_id=i,lamp_ben[10], map=0

              if b_labins[6]  eq 1 then widget_control,bad_id=i,lamp_b1     , scr_xsize=uv[10]
              if b_labins[6]  eq 1 then widget_control,bad_id=i,lamp_ben[0] , map=1
              if b_labins[6]  eq 1 then widget_control,bad_id=i,uv[8]       , sensitive=1
             endelse
             endif
;**Data Access Creation
    if uv[1] eq 558 then begin & if n_elements(lamp_ins) le 1 then customiz,1
             P_DATA_ACCESS, uv[2],uv[3],uv[4],uv[5],0
             widget_control,bad_id=i,uv[3],map=1 & endif
    if uv[1] eq 559 then begin & if n_elements(lamp_ins) le 1 then customiz,1 ; 559 never used !!!
             P_DATA_ACCESS, uv[2],uv[3],uv[4],uv[5],2
             widget_control,bad_id=i,uv[3],map=1 & endif

;**Change Instrument Name
    if uv[1] eq 560 then begin
     if uv[5] ge 0  then begin
       messege=''
       if uv[6] eq -2 then CF_rdset=1 else CF_rdset=0 ;Comes From rdset
       inst_old  =strlowcase(inst_value)
       inst_value=lamp_ins[uv[5]]
       inst_new  =strlowcase(inst_value)
       inst_group=lamp_grp[uv[5]]
       idx =where(lamp_entry eq inst_group)
       if idx[0] lt 0 then lamp_entry=[lamp_entry,inst_group]
      ;plug_in
      ;*******
      ;if idx[0] lt 0 then begin
          VV=strtrim(string(sys_dep('VERSION')),2)
          VV=strmid( VV,0,1)+strmid( VV,2,1)
          plugpth=sys_dep('NEWSUB',lamp_dir,'plug_in')
          plugfli=finefile(plugpth+'*'+inst_new              +'*'+VV+'*.rt',count=n1)
          plugflg=finefile(plugpth+'*'+strlowcase(inst_group)+'*'+VV+'*.rt',count=n2)
          nn=0 & if n1+n2 gt 0 then begin
                 if n2 gt 0 then if n1 gt 0 then plugfil=[plugfli,plugflg] else plugfil=plugflg else plugfil=plugfli
                 plugfil=plugfil[uniq(plugfil)] & nn=n_elements(plugfil) & endif
          if nn gt 0 then for i=0,nn-1 do begin
             idx =where(lamp_entry eq plugfil[i])
             if idx[0] lt 0 then begin & lamp_entry=[lamp_entry,plugfil[i]]
              P_RESTORE,plugfil[i] ,rflg
              if rflg gt 0 then PRINT    ,plugfil[i] +' plug_in loaded ...'
              if rflg gt 0 then to_don_history,-1,0,plugfil[i] +' plug_in loaded ...'
             endif
          endfor
      ;endif
       if uv[3] gt 0 then widget_control,uv[3]   ,bad_id=i,set_value=inst_value
       if uv[7] gt 0 then widget_control,uv[7]   ,bad_id=i,set_value=inst_value
       if lamp_cyc[1]  eq 0 then cycle = lamp_ali[lamp_cyc[0]]
       p_ath=lamp_path[lamp_cyc[0]]+lamp_dvd

      ;path to data base: p_ath is the customiz path for current alias path
      ;*****************: path_for_online is the actual path
       if  cycle ne 'Current Path' then begin
        strpUser=strpos(p_ath,'(user)')                   ;User to insert
        strpInst=strpos(p_ath,'(inst)')                   ;Instrument to insert
        strpOld =strpos(path_for_online, lamp_dvd+inst_old+lamp_dvd) ;Old instrument to replace
        strpNew =strpos(path_for_online, lamp_dvd+inst_new+lamp_dvd) ;
        if strpInst ge 0 then p_ath=strmid(p_ath,0,strpInst)+inst_new+strmid(p_ath,strpInst+6)
        if strpUser ge 0 then begin
           if sys_dep('MACHINE') eq 'win' then lamp_user=getenv('USERNAME') else lamp_user=getenv('USER')
           lamp_user=strlowcase(lamp_user)
           userlet  =strmid(lamp_user,0,1)+lamp_dvd ;User initial
           p_ath    =strmid(p_ath,0,strpUser)+userlet+lamp_user+strmid(p_ath,strpUser+6)
        endif
        if (strpos(strlowcase(cycle),'browse') ge 0) or $
           (strpos(strlowcase(cycle),'My Proposal')  ge 0) then $
            if (inst_old ne inst_new)  and (strpOld  ge 0) then $ ;Petit extra
                p_ath=strmid(path_for_online,0,strpOld+1)+inst_new+lamp_dvd
        
        if strpos(strlowcase(cycle),'cycle') lt 0   then begin
        
           if strpInst gt 0 then begin ;*** INSTRUMENT CONTROL MACHINE ASKED ***
              n = file_test(p_ath)
              if n le 0 then messege='Connection failed !!!'
              if uv[2] gt 0  then widget_control,bad_id=i,uv[2],set_value=messege else print,messege
              if n gt 0 then begin
                 path_for_online=p_ath
                 okProposal=0
                 if strpos(cycle,'On_Line') eq 0 then P_ILLproposal, '560:(inst)' $
                                                 else P_ILLproposal, '560:newInst', filou, okProposal, ask= (1-CF_rdset)
              endif
              if strpos(cycle,'On_Line') eq 0  then cycle=inst_value
              
           endif else begin & path_for_online=p_ath
                 P_ILLproposal, '560:newInst', filou, okProposal, ask= (1-CF_rdset)
           endelse
           
        endif else begin           ;*** CYCLE ILL DATA BASE ASKED ***
           if lamp_cyc[1] gt 0 then begin &  p_ath=path_for_online
             ;Because we have the cycle in path_for_online------
              if strpOld  gt 0 then p_ath=strmid(p_ath,0,strpOld+1) else $ 
              if strpNew  gt 0 then p_ath=strmid(p_ath,0,strpNew+1)
           endif
           p_ath=sys_dep('INSUB',p_ath,inst_new)
           n = file_test(p_ath)
           if n le 0 then messege='Connection failed !!!'
           if uv[2] gt 0  then widget_control,bad_id=i,uv[2],set_value=messege else print,messege
           if n gt 0 then begin
              path_for_online=p_ath
              okProposal=0
              P_ILLproposal, '560:newInst', filou, okProposal, ask= (1-CF_rdset)
           endif
        endelse
       endif
       RDSET,/clear
       to_don_history,-1,0,'RDSET,inst="'+inst_value+'"'
       lamp_message,messege+' DataPath is:"'+path_for_online+'"'
       lamp_journal,messege+' DataPath is:"'+path_for_online+'"'
      ;SIM card
      ;********
      if n_elements(lamp_did) gt 6 then $
      if lamp_did[6] gt 0 then begin & widget_control,lamp_did[6],get_uvalue=fullist
         if (fullist[0] gt ' ') and (inst_new gt ' ') then begin
            pos=strpos(fullist,lamp_dvd,/reverse_search)+1 & fullist = strmid(fullist,pos,30)
            pos=strpos(strlowcase(fullist),inst_new+'_')               & idx=where(pos ge 0)

            if (idx[0] lt 0) and (inst_group gt ' ') then $
            pos=strpos(strlowcase(fullist),strlowcase(inst_group)+'_') & idx=where(pos ge 0)

            if idx[0] ge 0 then begin
               pos=strpos(strlowcase(fullist[idx]),'_sim')             & idy=where(pos ge 0) & idy=idy[0]
               if idy ge 0 then P_LAYOUT, fullist[idx[idy]]
               return
            endif ;else begin & b_labins[9]=1 & P_LAYOUT,'List_CSgeneral'
                  ;             b_labins[9]=0 & return &  endelse
         endif
      endif

     endif else  customiz,1
    endif
    
;**Change Cycle, Path
    if uv[1] eq 561 then begin
       messege=''
       if uv[6] eq -2 then CF_rdset=1 else CF_rdset=0 ;Comes From rdset
       lamp_cyc[0:1]=[uv[5],uv[7]]
       inst_cur=strlowcase(inst_value)
       if uv[7] gt 0 then begin & YT=strtrim(string(uv[7]),2) ;comes from RDSET, cycle=
               if strlen(YT) eq 1 then YT='0'+YT
               if strlen(YT) eq 2 then YT='0'+YT & cycle='Cycle '+YT ;Comes from RDSET
       endif else cycle  =lamp_ali[lamp_cyc[0]]                      ;Comes from Menu
       tmps=''
       if uv[4] gt 0 then widget_control,uv[4]   ,bad_id=i,set_value=cycle
       if uv[6] gt 0 then widget_control,uv[6]   ,bad_id=i,set_value=cycle

       if strpos(strlowcase(cycle),'current path') ge 0 then path_for_online='' else $
       if strpos(strlowcase(cycle),'browse') ge 0  then begin
                P_ILLproposal, '561:browse'
       endif else begin
        p_ath   =lamp_path[lamp_cyc[0]]+lamp_dvd
        strpUser=strpos(p_ath,'(user)')                   ;User to insert
        strpInst=strpos(p_ath,'(inst)')                   ;Instrument to insert
        if strpInst ge 0 then p_ath=strmid(p_ath,0,strpInst)+inst_cur+strmid(p_ath,strpInst+6)
        if strpUser ge 0 then begin
           if sys_dep('MACHINE') eq 'win' then lamp_user=getenv('USERNAME') else lamp_user=getenv('USER')
           lamp_user=strlowcase(lamp_user)
           userlet  =strmid(lamp_user,0,1)+lamp_dvd ;User initial
           p_ath    =strmid(p_ath,0,strpUser)+userlet+lamp_user+strmid(p_ath,strpUser+6)
        endif
        
        if strpos(strlowcase(cycle),'cycle')  lt 0  then begin
        
           if strpInst gt 0 then begin ;*** INSTRUMENT CONTROL MACHINE ASKED ***
              n = file_test(p_ath)
              if n le 0 then messege='Connection failed !!!'
              if uv[2] gt 0  then widget_control,bad_id=i,uv[2],set_value=messege else print,messege
              if n gt 0 then begin
                 path_for_online=p_ath
                 okProposal=0
                 if strpos(cycle,'On_Line') eq 0 then P_ILLproposal, '561:(inst)' $
                                                 else P_ILLproposal, '561:newPath', filou, okProposal, ask= (1-CF_rdset)
              endif
              if strpos(cycle,'On_Line') eq 0  then cycle=inst_value

           endif else begin & path_for_online=p_ath
                            P_ILLproposal, '561:newPath', filou, okProposal, ask= (1-CF_rdset)
           endelse
           
        endif else begin           ;*** CYCLE ILL DATA BASE ASKED ***
             bid   = 'Connecting '+p_ath+' ...' & n=0
             if uv[2] gt 0 then widget_control,bad_id=i,uv[2] ,set_value=bid else print ,bid
             if uv[7] gt 0 then begin & tmps=',cycle='+YT
                bid  =where(lamp_ali eq 'archive') & bid=bid[0]
                if bid ge 0 then p_arc =lamp_path[bid] else p_arc= '?'
                p_ath=sys_dep('INSUB',p_ath,YT)
                n = file_test(p_ath)
                if n le 0 then begin     ;Historycal !!!
                   if p_arc ne '?' then begin & p_ath=sys_dep('INSUB',p_arc+lamp_dvd,YT)
                      bid =  'Connecting the archive system ...'
                      if uv[2] gt 0  then widget_control,bad_id=i,uv[2] ,set_value=bid else print,bid
                      n = file_test(p_ath)
                   endif
                endif
                if n gt 0 then if strpos(p_ath,p_arc) ge 0 then n = file_test('/CDBOX')
             endif else begin &  catch,stat & if stat eq 0 then begin & cd,p_ath,current=mee & cd,mee & n=1 & endif & catch,/cancel
             endelse
             if n le 0 then messege='Connection failed !!!'
             if uv[2] gt 0  then widget_control,bad_id=i,uv[2],set_value=messege else print,messege
             if n gt 0 then begin
                path_for_online=sys_dep('INSUB',p_ath, inst_cur)
                okProposal=0
                P_ILLproposal, '561:newPath', filou, okProposal, ask= (1-CF_rdset)
             endif
        endelse
       endelse
       to_don_history,-1,0,'RDSET,base="'+lamp_ali[lamp_cyc[0]]+'"'+tmps
       lamp_message,messege+' DataPath is:"'+path_for_online+'"'
       lamp_journal,messege+' DataPath is:"'+path_for_online+'"'
    endif

;**Browse instrument file path
    if uv[1] eq 562 then begin
       lamp_man=finefile(path_for_online,count=n)
       if n le 1 then lamp_man=finefile(path_for_online+'*',count=n)
       uvv=uv & uvv[1]=563
       if n gt 0 then begin & cd,path_for_online,current=mee & cd,mee,current=p_f_o
               p_o=path_for_online              ; first  alternative for data-1 ...
               p_f=expand_path(path_for_online) ; second alternative for links
               if strmid(p_f_o,strlen(p_f_o)-1,1) ne lamp_dvd then p_f_o=p_f_o+lamp_dvd
               if strmid(p_o  ,strlen(p_o)  -1,1) ne lamp_dvd then p_o  =p_o  +lamp_dvd
               if strmid(p_f  ,strlen(p_f)  -1,1) ne lamp_dvd then p_f  =p_f  +lamp_dvd
               ln=strpos(strupcase(lamp_man[n_elements(lamp_man)-1]),strupcase(p_f_o))
               if ln ge 0 then lamp_man=strmid(lamp_man,ln+strlen(p_f_o),30) $
               else begin & ln=strpos(strupcase(lamp_man[n_elements(lamp_man)-1]),strupcase(p_o))
                          if ln ge 0 then lamp_man=strmid(lamp_man,ln+strlen(p_o),30) $
               else begin & ln=strpos(strupcase(lamp_man[n_elements(lamp_man)-1]),strupcase(p_f))
                          if ln ge 0 then lamp_man=strmid(lamp_man,ln+strlen(p_f),30)
               endelse
               endelse
       endif
       if uv[5] gt 0 then widget_control,bad_id=i,uv[5],/destroy
       base =widget_base(  title='Select File to Read',resource_name='lamptouch',/column)
       uv[5]=base
       bid  =widget_label( base,value="PATH="+path_for_online,font=ft_b_normal)
       lab  =widget_base(  base,/row)
       lub  =widget_list(  lab ,value=lamp_man,xsize=15,ysize=15,font=ft_propor)
       lab  =widget_base(  lab ,/column)
       lib  =widget_base(  lab,/row) & put_logo,lib
       bid  =widget_label( lib,value="sub",font=ft_b_normal)
       lyb  =widget_text(  lib,xsize=8,ysize=1,font=ft_propor,/editable,uvalue=[-88,564,lub])
       lob  =widget_draw(  lab ,retain=2  ,xsize=192,ysize=192)
       lib  =widget_base(  lab,/row)
       bid  =widget_button(lib,value='Done'   ,font=ft_b_normal,uvalue=[-88,399,0])
       bid  =widget_button(lib,value='Refresh',font=ft_b_normal,uvalue=uv)

       widget_control,bad_id=i,event.id,set_uvalue=uv
       widget_control,bad_id=i,base,group_leader=lamp_b1,set_uvalue=uv[1],/realize & put_logo
       widget_control,bad_id=i,lob,get_value = loob
       uvv[6]=loob & uvv[7]=lyb
       widget_control,bad_id=i,lub,set_uvalue= uvv
       XMANAGER, 'BROWS' ,base ,event_handler='LAMP_EVENT_PARSER',/just_reg,/NO_BLOCK
    endif
    if uv[1] eq 563 then begin
       runtxt=lamp_man[event.index]  & uv[1]=577
       okProposal=0
       P_ILLproposal, '563:browse', runtxt,okProposal
       if okProposal or $                                            ;(proposal) or
         (strpos(runtxt,strlowcase(inst_value)+'_') eq 0) then begin ;(Sub dir)
         uv[1]=564
         uv[2]=event.id
         event.id=uv[7]
         widget_control,bad_id=i,uv[7],set_value=runtxt ;runtxt now ends with proposal/rawdata
       endif else begin
         icoco =1
         idx   =strpos(runtxt,'.Z')    & if idx gt 0 then runtxt=strmid(runtxt,0,idx)
         widget_control,bad_id=i,uv[3],set_value=runtxt
       endelse
    endif
    if uv[1] eq 564 then begin
       widget_control,bad_id=i,event.id,get_value=newsub   &   newsub=strcompress(newsub[0],/remove_all)
       if newsub ne '' then begin & l_man=finefile(sys_dep('INSUB',path_for_online,newsub)    ,count=n)
             if n le 1 then       l_man=finefile(sys_dep('INSUB',path_for_online,newsub)+'*',count=n)
             if n ge 1 then begin & lamp_man=l_man
                 poth=path_for_online+newsub & ln=strpos(strupcase(lamp_man[0]),strupcase(poth))
                 if ln lt 0 then begin & poth=path_for_online & ln=strpos(strupcase(lamp_man[0]),strupcase(poth)) & endif
                 if ln ge 0 then lamp_man=strmid(lamp_man,ln+strlen(poth),30)
                 surp=strmid(lamp_man[0],0,1) & if surp eq lamp_dvd then lamp_man=strmid(lamp_man,1,30)
                 widget_control,bad_id=i,uv[2],set_value=lamp_man
                 if n_elements(okProposal) eq 1 then if okProposal  then begin
                    path_for_online=path_for_online+newsub+lamp_dvd   ;add proposal in path_for_online
                    lamp_message,'DataPath is:"'+path_for_online+'"'
                    lamp_journal,'DataPath is:"'+path_for_online+'"'
                 endif
             endif
       endif
    endif

;**Browse a session to restore
    if uv[1] eq 565 then begin & kpGEORGE=GEORGE
         catch,stat
         if stat eq 0 then begin & pptph=''
            pptfil=CALL_FUNCTION("dialog_pickfile",filter='*.ses',get_path=pptph,group=lamp_b1)
            if (pptfil gt ' ') and (pptph gt ' ') then begin
               DON_WRITE_PROG_MAC ,1
               DID_WRITE_JOURNAL
               bidbas=widget_base(title='bidbas',map=0) & widget_control,bidbas,/realize
               XMANAGER,'bidbas',bidbas ,/just_reg,/NO_BLOCK
               W1=-77
               widget_control,lamp_b1,/destroy
               file_found=pptfil
               P_SET_PATH,pptph,/silent & lamp_b1=0L & lamp
               widget_control,bidbas ,/destroy
               return ;retall now do an exit !!!
            endif
         endif else print,"Bad version for session file !!!" & catch,/cancel
    endif

;**Browse URL
    if uv[1] eq 567 then begin & widget_control,uv[3],bad_id=ii,get_uvalue=url
                               bid=sys_dep('BROWSE',url) & endif

;**More for Instrument specific
    if uv[1] eq 568 then begin & widget_control,uv[3],bad_id=ii,get_uvalue=stuc
    if (xregistered('A_'+stuc.macro)) eq 0 then begin
       bas  =widget_base(  title=stuc.macro,/column,resource_name='lampmic')
       llg  =widget_base(  bas,/row) & put_logo,llg
       bid  =widget_label( llg,value=stuc.macro   ,font=ft_biggest)
       bid  =widget_label( llg,value=stuc.author  ,font=ft_b_normal)
       if stuc.link gt ' ' then begin
         bod=widget_button(llg,value='Url'        ,font=ft_b_normal,/menu)
         widget_control,bod,bad_id=ii,set_uvalue = stuc.link
         bid=widget_button(bod,value=stuc.link    ,font=ft_b_normal,uvalue=[-88,567,0,bod])
       endif
       bid  =widget_label( bas,value=stuc.purpose ,font=ft_b_bigger)
       for i=1,n_elements( stuc.more)-1 do $
       bid  =widget_label( bas,value=stuc.more[i] ,font=ft_propor,/align_left)
       bss  =widget_base(  bas,/row)
       txt  =widget_text(  bss,value=stuc.call    ,font=ft_propor,/editable,xsize=50,ysize=1)
       bid  =widget_button(bss,value='Do'         ,font=ft_b_normal,uvalue=[-88,214,-1,txt,0])
                                             widget_control,txt,set_uvalue=[-88,214,-1,txt,0]
       bss  =widget_base(  bas,/row)
       txt  =widget_text(  bss,value=' '          ,font=ft_propor,/editable,xsize=50,ysize=1)
       bid  =widget_button(bss,value='Do'         ,font=ft_b_normal,uvalue=[-88,214,-1,txt,0])
                                             widget_control,txt,set_uvalue=[-88,214,-1,txt,0]

       widget_control,bas,group_leader=lamp_b1,/realize
       if stuc.logo gt ' ' then put_logo, file=stuc.logo else put_logo
       XMANAGER,'A_'+stuc.macro,bas,event_handler='LAMP_EVENT_PARSER',/just_reg,/NO_BLOCK
    endif & endif

;**Run macro for Instrument specific
    if uv[1] eq 569 then begin
       CASE uv[3] of
       -1:  begin & spec_wplot,event,runtxt
            if runtxt gt '' then begin
               uv=[-88,579,b_labins[7],lamp_ben[15],lamp_ben[16]]
               widget_control,bad_id=i,uv[3],set_value=runtxt & endif
            end
       ELSE:begin
            catch,stat
            if  stat eq 0 then begin & widget_control,uv[4],get_uvalue=run
                          idp=strpos(strlowcase(run),'.prox') & if idp gt 0 then run=strmid(run,0,idp)
                          idu=strpos(strlowcase(run),'.xbu')
                          if idp gt 0 then P_LAYOUT,prox=run else $
                          if idu gt 0 then P_LAYOUT,xbu =run else CALL_PROCEDURE,run & endif
            catch,/cancel
            if (stat ne 0)  then $
            if (b_labins[6]) and (b_labins[7] gt 0 ) then widget_control,b_labins[7],bad_id=ii,set_value=!error_state.msg $
                                                     else widget_control,l_message  ,bad_id=ii,set_value=!error_state.msg
            end
       ENDCASE
    endif

;**Instrument specific
    if uv[1] eq 570 then if n_elements(lamp_ben) ge 15 then $
                         if lamp_ben[10] gt 0 then begin
                           widget_control,bad_id=ii,lamp_ben[10], get_uvalue=bu
                           widget_control,bad_id=ii,lamp_ben[7] , map=0
       if GEORGE eq 2 then widget_control,bad_id=ii,lamp_ben[8] , map=0
                           if b_labins[6] then if not b_labins[9] then $
                           widget_control,bad_id=ii,lamp_b1     , scr_xsize=bu[3]
                           widget_control,bad_id=ii,lamp_ben[0] , map=1
                           widget_control,bad_id=ii,lamp_ben[10], map=1
       if GEORGE eq 2 then widget_control,bad_id=ii,lamp_ben[13], sensitive=1
                           widget_control,bad_id=ii,lamp_ben[14], sensitive=1
                           widget_control,bad_id=ii,lamp_ben[12], sensitive=1
       if  uv[3] gt 0  then  uv7=uv[7] else uv7=uv[3]
       if (bu[0] ne uv7) or (uv7 lt 0) then begin
        widget_control,bu[1],bad_id=ii,/destroy & bu[0] =uv7
        gm0  =widget_info(lamp_ben[0] ,/geometry) & b0x =gm0.scr_xsize & b0y =gm0.scr_ysize
        bu[1]=widget_base(lamp_ben[11],/column,y_scroll =b0y-80) ;fix(lamp_siz/2.1)<435)
        tmpbase=0 & P_messi,tmpbase,bu[1]
        widget_control,lamp_ben[10],bad_id=ii,set_uvalue=bu
        widget_control,bu[2] ,bad_id=ii, set_value='--------------'

        CASE uv7 of
        -1:  begin & widget_control,bu[2] ,bad_id=ii, set_value='SPEC contents'
             spec_wlist,bu[1]
             end
        ELSE:begin & titl='MACROS LIST'
         if event.id gt 0 then widget_control,event.id    ,bad_id=ii, get_value=titl
         pos=strpos(strupcase(titl),'LIST_') & if pos ge 0 then titl=strmid(titl,pos+5,20)
         widget_control,bu[2]       ,bad_id=ii,  set_value=strupcase(strmid(titl,0,15))
         widget_control,uv[3]       ,bad_id=ii, get_uvalue=fifis
         fifi=fifis[uv[7]]
         topic='' & macr='' & purp='' & auth='' & coll='' & bmc=0 & more=[''] & icof='' & lnk=''
         on_ioerror,misfifi & lun=-1  & lin=''
         OPENR,lun,fifi,/get_lun
         while not eof(lun) do begin
         READF,lun,lin & lon=strlowcase(lin)

         if (strpos(lon,'topic:') ge 0) or (strpos(lon,'macro:') ge 0) then $
                    if n_elements(more) gt 1 then if bmc gt 0 then begin
                       widget_control,bmc,set_uvalue=$
                       {topic:topic,macro:macr,purpose:purp,author:auth,call:coll,more:more,logo:icof,link:lnk}
                       bid=widget_button(bmc  ,value='More...',font=ft_propor,uvalue=[-88,568,b_labins[7],bmc])
                       endif
         c=strpos(lon,'topic:')    & if c ge 0 then begin & topic=strmid(strtrim(strmid(lin,c+6,150),2),0,13)
                    if bmc gt 0 then $
                    bid  =widget_label( bu[1],value='---')
                    bid  =widget_label( bu[1],value=topic ,font=ft_b_normal)
                    macr='' & purp='' & auth='' & coll='' & bmc=0 & more=[''] & lnk='' & endif

         c=strpos(lon,'macro:')    & if c ge 0 then begin
                    macr =strmid(strtrim(strmid(lin,c+6,150),2),0,13)
                    bmc  =widget_button(bu[1],value=macr  ,font=ft_b_normal,menu=2)
                    purp='' & auth='' & coll='' & more=[''] & lnk='' & endif

         c=strpos(lon,'purpose:') & if c ge 0 then begin & purp =strmid(strtrim(strmid(lin,c+8,150),2),0,80)
                    if bmc gt 0 then  if purp gt ' ' then $
                    bid  =widget_button(bmc  ,value='Purpose: '+purp,font=ft_propor) & endif

         c=strpos(lon,'author:')   & if c ge 0 then begin & auth =strmid(strtrim(strmid(lin,c+7,150),2),0,80)
                    if bmc gt 0 then  if auth gt ' ' then $
                    bid  =widget_button(bmc  ,value='Author:  '+auth,font=ft_propor) & endif

         c=strpos(lon,'call:')     & if c ge 0 then begin & coll =strmid(strtrim(strmid(lin,c+5,150),2),0,80)
                    if bmc gt 0 then  if coll gt ' ' then $
                    bid  =widget_button(bmc  ,value='Call:    '+coll,font=ft_propor) & endif

         c=strpos(lon,'more:')     & if c ge 0 then more=[more, strmid(strmid(lin,c+5,150),0,80)]

         c=strpos(lon,'run:')  & if c ge 0 then begin & run  =strmid(strtrim(strmid(lin,c+4,150),2),0,150)
                    if bmc gt 0 then  if run gt ' ' then begin
                    widget_control,bmc,set_uvalue=run
                    bid  =widget_button(bmc  ,value='Run....',font=ft_propor,uvalue=[-88,569,b_labins[7],0,bmc])
                    endif & endif

         c=strpos(lon,'logo:')     & if c ge 0 then begin & icof =strmid(strtrim(strmid(lin,c+5,60 ),2),0,40)
                    p=strpos(strlowcase(fifi),'a_list') & cof =''
                    if p gt 0 then cof=strmid(fifi,0,p) & icof=cof+icof & endif

         c=strpos(lon,'link:')     & if c ge 0 then lnk=strmid(strtrim(strmid(lin,c+5,150),2),0,150)

         endwhile
                    if n_elements(more) gt 1 then if bmc gt 0 then begin
                       widget_control,bmc,set_uvalue=$
                       {topic:topic,macro:macr,purpose:purp,author:auth,call:coll,more:more,logo:icof,link:lnk}
                       bid=widget_button(bmc  ,value='More...',font=ft_propor,uvalue=[-88,568,b_labins[7],bmc])
                    endif

         misfifi:if lun gt 0 then FREE_LUN,lun
         end
        ENDCASE
        P_messi, tmpbase,bu[1]
       endif
    endif
;**LampINX
;**qens_fit
;**magdraw
;**str_fit
;**ShowFreeW
;**SANS_settings
;**SANS_sheet
;**Cosmos
;**prox_sheet_template
;**prox_sheet
;**Iopen
;**periodic_table
;**idl_convert
    VV = strtrim(long(float(!version.release)*10),2) ; The Idl version
    
    if uv[1] eq 571    then if uv[2] eq 1  then inx $
                       else if uv[2] eq 2  then CALL_PROCEDURE,"qens_fit" $
                       else if uv[2] eq 3  then magnet_win $
                       else if uv[2] eq 4  then bid=CALL_FUNCTION("str_fit") $
                       else if uv[2] eq 5  then ShowFreeW $
                       else if uv[2] eq 6  then sans_settings $
                       else if uv[2] eq 7  then sans_sheet $
                       else if uv[2] eq 8  then CALL_PROCEDURE,"cosmos",group_leader=lamp_b1 $
                       else if uv[2] eq 9  then XICUTER,'@prox_sheet_template' $
                       else if uv[2] eq 10 then prox_sheet $
                       else if uv[2] eq 11 then begin & xicute,'W60=0'
                               live_lamp_Iopen,uv[3] ,W60,group=lamp_b1
                               if (n_elements(W60) gt 1) or (n_tags(W60) gt 0) then begin
                                  HELP,W60,OUTPUT=outDATA
                                  lamp_journal,   outDATA
                                  to_don_history, 60 , -1 , ''
                               endif
                            endif $
                       else if uv[2] eq 12 then periodic_table $
                       else if uv[2] eq 13 then CALL_PROCEDURE,"idl_convert" $
                       else if uv[2] eq 14 then restore, lamp_dir+lamp_dvd+'idl'+VV+lamp_dvd+'lib'+lamp_dvd+'imsl'+lamp_dvd+'imsl.sav' $
                       else if uv[2] eq 15 then restore, lamp_dir+lamp_dvd+'idl'+VV+lamp_dvd+'lib'+lamp_dvd+'wavelet'+lamp_dvd+'source'+lamp_dvd+'wavelet.sav'

;**Workspace operations.
    if uv[1] eq 572 then case uv[3] of
       1: begin & W_store   ,/ALL
          widget_control,uv[4],bad_id=ii,sensitive=1
          widget_control,uv[5],bad_id=ii,sensitive=1
          end
       2:     W_restore ,/ALL
       3:     W_exchange,/ALL
       4:     W_clear   ,/ALL
       else:
       endcase
;**Idl help
    if uv[1] eq 573 then begin
       if uv[3] eq 0 then language_help
       if uv[3] eq 1 then begin
          helpfile=!dir+lamp_dvd+'help'+lamp_dvd+'online_help'+lamp_dvd+'Functional_List_of_IDL_Routines.html'
          hfile=finefile(helpfile,count=cnt)
          if cnt gt 0 then bid=sys_dep('BROWSE',helpfile) else language_help
       endif
       if uv[3] eq 2 then begin
          L_idldoc=widget_info(event.id,/uname) & online_help, book=L_idldoc,/full
       endif
    endif
;**Create display function site UI.
    if uv[1] eq 574 then $
        if lamp_fsite gt ' ' then  CALL_PROCEDURE,lamp_fsite $
        else widget_control,bad_id=i,l_message,set_value =   $
                 'Well, indeed, so, good .. need to be customized!'
;**Create access site UI.
    if uv[1] eq 575 then $
        if lamp_asite gt ' ' then  CALL_PROCEDURE,lamp_asite $
        else widget_control,bad_id=i,uv[2]    ,set_value =   $
                 'Well, indeed, so, good .. need to be customized!'

;**Change Path
    if uv[1] eq 576 then if event.type lt 3 then begin & my_path[1]='1'
              if event.type eq 0 then if event.ch eq byte(10) then P_SET_PATH
              endif
;**Get Run
    if (uv[1] eq 577) or (uv[1] eq 578) or (uv[1] eq 579) then begin

       widget_control,bad_id=i,uv[4],get_value=wnumber
       i =strpos( wnumber[0],'W')
       ws=strtrim(strmid(wnumber[0],i+1,4),2)
       wi=fix(ws)

       widget_control,bad_id=i,uv[3],get_value=runtxt
       runtxt=strtrim(strcompress(runtxt[0]),2)
       i =-1
       k =strpos(runtxt,'+') + $
          strpos(runtxt,'-') + $
          strpos(runtxt,':') + $
          strpos(runtxt,'>')
       if (k eq -4) or (strpos(runtxt,'.') ge 0) then begin
        i=strpos(runtxt,'.htm')
        if i lt 0 then       i=strpos(runtxt,'LAMP.hdf')
        if i lt 0 then       i=strpos(runtxt,'LAMP.xml')
        if i lt 0 then       i=strpos(runtxt,'.nxs')
        if i lt 0 then begin & i=strpos(runtxt,'.hdf')
                                  ;if i gt 0 then if strlowcase(inst_group) ne 'nexus' then i=-1
                  endif
        if i lt 0 then begin & i=strpos(runtxt,'.xml')    & endif
        if i lt 0 then begin & i=strpos(runtxt,'.xdr')
                             if i gt 0 then runtxt=strmid(runtxt,0,i)+'.htm'  & endif
       ;if i lt 0 then begin i=strpos(runtxt,'.zip')
       ;                     if i gt 0 then runtxt=strmid(runtxt,0,i)+'.htm'  & endif
        if i lt 0 then begin & i=strpos(runtxt,'_LAMP')
                             if i gt 0 then begin
                                     runtxt=strmid(runtxt,0,i)+'_LAMP'
                                     bid   =sys_dep('POT',runtxt)      & endif
        endif
       endif
       if i gt 0 then begin
           j = strpos(runtxt,'{')
           if (j gt 0) and (uv[1] eq 578) then begin
             k=strpos(runtxt,'}')
             strun =strtrim(string(strmid(runtxt,j+1,k-j-1)+uv[5]),2)
             runtxt=strmid( runtxt,0,j+1)+strun+'}'
           endif
           READ_LAMP,runtxt, w=wi, path=path_for_online
           widget_control,bad_id=i,uv[3],set_value=runtxt
           if (uv[1] gt 577) then P_DID_EVENT,0,[-88,301,0,wi,0]

       endif else begin &  if (strpos(runtxt,'.gif') le 0) and $
                            (strpos(runtxt,'.jpg') le 0) and $
                            (strpos(runtxt,'.png') le 0) then GMY_run, uv,runtxt, wi $
                         else READ_myGIF,path_for_online+runtxt,w=wi
       endelse
       if icoco eq 1 then begin & wset,uv[6] & erase,255 & xx=1L & yy=1L & wr=1L
             if sys_dep('VM') ne 1 then begin & i=execute('xx = x' +ws)
                                              i=execute('yy = y' +ws)   & endif
             p_did_makeicon, ws,xx,yy, 192,192 ,0 ,wr ,'i'
             widget_control,bad_id=i,l_message,set_value='Read in W'+ws & endif
    endif
;**FIT
    if (uv[1] eq 580) then CALL_PROCEDURE,'gfit'  ;bid=CALL_FUNCTION("str_fit")
;**Live update
    if (uv[1] eq 581) then CALL_PROCEDURE,'lu_lamp'

;**Helps
    if (uv[1] ge 585) and (uv[1] le 598) then show_helps,uv
return
end

pro GMY_run   ,uv ,runtxt ,wi
;+
;** *******
;** analyse the syntax in the file input field of lamp and call appropriate routine
;-
        status=12
        j = strpos(runtxt,'{')
        if (j gt 0) and (uv[1] eq 578) then begin
         k=strpos(runtxt,'}')
         strun =strtrim(string(strmid(runtxt,j+1,k-j-1)+uv[5]),2)
         runtxt=strmid( runtxt,0,j+1)+strun+'}'
         widget_control,bad_id=i,uv[3],set_value=runtxt
        endif

        i = strpos(runtxt,'.',/reverse_search)
        k = strpos(runtxt,'+') + $
            strpos(runtxt,'-') + $
            strpos(runtxt,':') + $
            strpos(runtxt,'>')
            
        if (i gt 0) and (k eq -4) and (uv[1] eq 578) then begin ;Case (de)increment with an extension
           on_ioerror,miscrement
           Stocrem=strmid(runtxt,0,i) & Itocrem=Stocrem+uv[5] & lngh=strtrim(strlen(Stocrem),2)
           Stocrem=string(Itocrem,format='(I0'+lngh+')')+strmid(runtxt,i,50) & runtxt=Stocrem
           miscrement:
        endif
        
        on_ioerror,misrun
        if (i lt 0) or ((j gt 0) and (k gt -4)) then begin
           if k gt -4 then begin
                UT_Progress, 0 , 0 , 1 ; Time Progress-bar
                P_DID_GET_IT,runtxt              ,wi,status,uv ,'opr'
                if ((uv[1] gt 577) and (status eq 0)) then P_DID_EVENT,0,[-88,301,0,wi,0]
                UT_Progress, 0 , 1 , 1 ; Time Progress-bar finished
                return
           endif

                                j =strpos(strupcase(runtxt),' SUMTO ')
           if j lt 0 then begin & j =strpos(runtxt,'>')
                     if j gt 0 then j=j+100 & endif
           if j lt 0 then       i =strpos(strupcase(runtxt), ' TO ')

           if (i le 0) and (j le 0) then begin
             k=0 & for i=0,strlen(runtxt)-1 do begin & car   =strmid(runtxt,i,1)
                       if (car lt '0') or (car gt '9') then k=1   &  endfor
             if k eq 0 then begin
               run=runtxt
               if (uv[1] eq 578) then begin ;Keep leading 0
                  on_ioerror,miscrement2
                  Stocrem=strmid(runtxt,0,i) & Itocrem=Stocrem+uv[5] & lngh=strtrim(strlen(Stocrem),2)
                  Stocrem=string(Itocrem,format='(I0'+lngh+')')+strmid(runtxt,i,50) & run= Stocrem
                  miscrement2: on_ioerror,misrun
                  widget_control,bad_id=i,uv[3],set_value=run
                endif
                
                status=1
                UT_Progress, 0 , 0 , 1 ; Time Progress-bar
                P_DID_GET_IT,run              ,wi,status,uv ,'run'

                if ((uv[1] gt 577) and (status eq 0)) then P_DID_EVENT,0,[-88,301,0,wi,0]
                UT_Progress, 0 , 1 , 1 ; Time Progress-bar finished
                return
             endif
           endif else if (uv[1] lt 578) then begin
              cmd='w'+strtrim(string(wi),2)
              if i gt 0 then begin
                 run1=float(strtrim(strmid(runtxt,0  ,i     ),2)) & run1=long( run1)
                 run2=float(strtrim(strmid(runtxt,i+4,lamp_6),2)) & run2=long( run2)
                 cmd =cmd+'=RDAND('
              endif     else begin
                 run1=float(strtrim(strmid(runtxt,0  ,j),2))        & run1=long( run1)
                 if j lt 100 then k=6 else begin & k=1 & j=j-100      & endelse
                 run2=float(strtrim(strmid(runtxt,j+k,lamp_6+1),2)) & run2=long( run2)
                 cmd =cmd+'=RDSUM('
              endelse
              UT_Progress, 0 , 0 , 1 ; Time Progress-bar
              cmd =cmd+strtrim(string(run1),2)+','+strtrim(string(run2),2)+',z0)'
              z0  =-1
              xicuter ,cmd
              if z0 gt 0 then begin & prt='Missing '  +string(z0)
                 if uv[2] gt 0 then widget_control,uv[2],bad_id=i,set_value=prt else print,prt
              endif
              UT_Progress, 0 , 1 , 1 ; Time Progress-bar finished
              return
           endif
        endif
        misrun:
        UT_Progress, 0 , 0 , 1 ; Time Progress-bar
        P_DID_GET_IT,runtxt,wi,status,uv ,'fil'
        if ((uv[1] gt 577) and (status eq 0)) then P_DID_EVENT,0,[-88,301,0,wi,0]
        UT_Progress, 0 , 1 , 1 ; Time Progress-bar finished
end

pro SHOW_HELPS, uv
;+
;** **********
;** create a help label window on demand
;-
@lamp.cbk

     if uv[1] eq 585 then widget_control,bad_id=i,lamp_hlp,map=0 $
     else begin
           iii=xregistered('HELPS')
       if (iii gt 0) then begin
           widget_control,bad_id=i,lamp_hlp,get_uvalue=uval
           if uval eq uv[1] then widget_control,bad_id=i,lamp_hlp,map=1
           if uval ne uv[1] then widget_control,bad_id=i,lamp_hlp,/destroy
           if uval ne uv[1] then iii=0
       endif
       if (iii le 0) then begin
        formu='' & formt='' & ttl=''

        if uv[1] eq 586 then begin
               ttl='READING INTO WORKSPACES'
           if sys_dep('VM') ne 1 then $
              ii=execute('myhelp_'+strlowcase(inst_value)+',formu')
           if n_elements(formu) le 1 then begin
              catch,stat    & if stat eq 0 then CALL_PROCEDURE,'myhelp',formu
              catch,/cancel & endif
           if n_elements(formu) le 1 then p_did_help,uv[1],formu,formt $
           else ttl='MYHELP.PRO'
        endif
        if uv[1] eq 587 then begin
               ttl='DISPLAYING THE WORKSPACES'
               p_did_help,uv[1],formu,formt
        endif
        if uv[1] eq 588 then begin
               ttl='A few TIPS (See INTERNAL in User Macros?)'
               p_did_help,uv[1],formu,formt
        endif
        if uv[1] eq 589 then begin
               ttl='CALLING OTHER DISPLAY FACILITIES'
               p_did_help,uv[1],formu,formt
        endif
        if uv[1] eq 590 then begin
               ttl='GK_FIT FITTING FACILITY'
               gfit_help ,uv[1],formu,formt
        endif
        if uv[1] eq 591 then begin
               ttl='SUPERPLOT : The Multipurpose Superpose Plotting Tool for Lamp'
               p_did_help,uv[1],formu,formt
        endif
        if uv[1] eq 592 then begin
               ttl='SELECTING RUNS'
               p_did_help,uv[1],formu,formt
        endif
        if uv[1] eq 593 then begin
               ttl='3 AXES FACILITY'
               CALL_PROCEDURE,'tx_help',uv[1],formu,formt
        endif
        if uv[1] eq 594 then begin
               ttl='SELECTING RUNS'
               p_did_help,uv[1],formu,formt
        endif
        if uv[1] eq 595 then begin
               ttl='PAD for Command Control'
               p_did_help,uv[1],formu,formt
        endif
        if uv[1] eq 596 then begin
               ttl='HELP for Instrument macros'
               p_did_help,uv[1],formu,formt
        endif
        if uv[1] gt 596 then return

        lamp_hlp=widget_base(   title='Lamp helps those who help themselves',$
                  resource_name='lamptouch',/column)
        lamp_hls=widget_base(   lamp_hlp,/column)
        lab        =widget_base(   lamp_hls,/row)
            put_logo    ,lab
        lab        =widget_label(  lab     ,value=ttl,font=ft_biggest)

        if n_elements(formu) ne n_elements(formt) then $
       blab=widget_text(   lamp_hls,value=formu,xsize=80,ysize=30,font=ft_b_normal,/scroll)$
        else for i=0,n_elements(formu)-1 do begin
             blab=widget_base(   lamp_hls,/row)
             lab=widget_label(  blab    ,value=formu[i]    ,font=ft_b_bigger)
             lab=widget_label(  blab    ,value=formt[i]    ,font=ft_normal)
        endfor

        base_wel=widget_button( lamp_hlp,value='Hide'      ,font=ft_b_normal ,$
                    uvalue=[-88,585,0])
        bid=sys_dep('DYNLAB',lamp_hlp,0)
        widget_control,bad_id=i,lamp_hlp,group_leader=lamp_b1,set_uvalue=uv[1],/realize & put_logo
        XMANAGER, 'HELPS' ,lamp_hlp ,event_handler='LAMP_EVENT_PARSER',/just_reg,/NO_BLOCK
       endif
     endelse
return
end

pro P_SET_PATH,ppth, silent=silent
;+
;** **********
;** User callable
;** This procedure should be used as command in MYINIT procedure.
;** it sets the working path
;-
@lamp.cbk
       if n_elements(my_path) gt 1 then my_path[1]=''

       if n_elements(ppth) eq 1 then  path=[ppth] $
       else widget_control,long(my_path[2]),bad_id=i,get_value=path
       path=path[0]
       stat=0
       catch,stat
       if stat ne 0 then begin
            catch,/cancel
            P_MUS,'mus_cannon'
            path=path+'???'
            if n_elements(ppth) eq 0 then $
            widget_control,long(my_path[2]),bad_id=i,set_value=path,SET_TEXT_SELECT=[strlen(path),0]
            print,string(7b)+path
            return
       endif

       if n_elements(ppth) eq 0 then DON_WRITE_PROG_MAC ,0
       cd,path
       if n_elements(my_path) gt 1 then begin
          my_path[0]=path
          DON_INIT_PROG_MAC  ,1
          to_don_history,-1,0,'P_SET_PATH,"'+path+'"'
          if (n_elements(ppth) eq 1) and (not keyword_set(silent)) then $
              widget_control,long(my_path[2]),bad_id=i,set_value=path,SET_TEXT_SELECT=[strlen(path),0]
              
          if not file_test(path,/directory) then lamp_message,'!WARNING: the Path is not a directory...'
       endif
return
end

pro P_FCT_CREATE ,base ,bas_geo2
;+
;** ************
;** create the default right frame of main lamp window, where should be the SIM cards
;-
@lamp.cbk

    P_did_get_etc, d_etc  &  Pbm = d_etc.Pbm  &  Ubm = d_etc.Ubm

    if GEORGE eq 1 then   base0      =lamp_ben[2] $
    else     begin &  bid        = widget_label( base ,font=ft_smallest ,value=' ')
                      lamp_ben[4]= widget_base(base ,/frame,resource_name='ben')
                      base0      = widget_base(lamp_ben[4],/column)
    endelse
    base1=widget_button(base0,font=ft_normal   ,value=lamp_fsite          ,uvalue=[-88,574,0,0])
    b_labins[2] =base1
    base1=widget_button(base0,font=ft_normal   ,value=' Load new Colors  ',uvalue=[-88,347])
    base1=widget_button(base0,font=ft_normal   ,value='    STR_Fit       ',uvalue=[-88,580,0,0])
    lamp_don   =[lamp_don,base1]
    base1=widget_button(base0,font=ft_normal   ,value='    SuperPlot     ',uvalue=[-88,352])
    lamp_don   =[lamp_don,base1]

    if GEORGE eq 2 then begin
      ;base1=widget_button(bas_geo2,font=ft_normal   ,value=' Load new Colors  ',uvalue=[-88,347])     ;removed for george=2
      ;base1=widget_button(bas_geo2,font=ft_normal   ,value='     GK_Fit       ',uvalue=[-88,580,0,0]) ;removed for george=2
      ;base1=widget_button(bas_geo2,font=ft_normal   ,value='    SuperPlot     ',uvalue=[-88,352])     ;removed for george=2
    endif

    if GEORGE eq 1 then begin
      bid=widget_button(base0,font=ft_normal   ,value='      ------      ')
;     bid=widget_button(base0,font=ft_normal   ,value='   Dial Macros?   ',uvalue=[-88,203,0,0])
;     bid=widget_button(base0,font=ft_normal   ,value='   The Journal    ',uvalue=[-88,396,0,0])
      bid=widget_button(base0,font=ft_normal   ,value='   Data Params    ',uvalue=[-88,204,0,0])
      if sys_dep('VERSION') ge 4.0 then widget_control,base0,/destroy
    endif

    if (lamp_siz ge 800) and (GEORGE ne 1) then begin
    if abs(sys_dep('MAP')) ne 1 then baba=base0 else baba=base
    brow =widget_base(  baba ,/row)
    lamp_don   =[lamp_don,brow]
    bs1bs=widget_button(brow ,font=ft_normal   ,value='SCAN W 1'          ,uvalue=[-88,306,0,0])
    if  Ubm                 then bs1b1 = widget_button(brow, /bitmap,/flat,value=Pbm+'spindown.bmp') else $
    if sys_dep('MAP') ne -1 then $
    bs1b1=widget_button(brow ,font=ft_normal ,value='<',resource_name='discret') else $
    bs1b1=widget_button(brow ,font=ft_normal ,value='<')
    if  Ubm                 then bs1b2 = widget_button(brow, /bitmap,/flat,value=Pbm+'spinup.bmp')   else $
    if sys_dep('MAP') ne -1 then $
    bs1b2=widget_button(brow ,font=ft_normal ,value='>',resource_name='discret') else $
    bs1b2=widget_button(brow ,font=ft_normal ,value='>')
    widget_control,bad_id=i,bs1b1,set_uvalue=[-88,310,bs1bs,3,0,0,0,0,0]
    widget_control,bad_id=i,bs1b2,set_uvalue=[-88,311,bs1bs,3,0,0,0,0,0]
    endif

    if GEORGE eq 1 then begin & GEORGEO, CONSTRUCT=base   &   base0=base & endif
    if GEORGE eq 2 then         GEORGEO, CONSTRUCT=lamp_ben[8]

    if GEORGE ne 1 then begin
       
       if  (lamp_siz gt 950) or   sys_dep('MATLAB')  or $
          ((lamp_siz ge 900) and (sys_dep('MACHINE') eq 'unix')) then plog=1 else plog=0
          
       if (not plog) then lamp_ben[3]=widget_label(base ,font=ft_smallest,value=' ' )
       lamp_ben[5]=widget_base(  base ,/frame,resource_name='ben')
       base0      =widget_base(  lamp_ben[5],/column)
       if plog then begin
               w0=2 & LOGO,w0 & pax1=size(w0)
               lamp_ben[6]=widget_draw( base0,retain=2,xsize=pax1[1],ysize=pax1[2],/button_event)
       endif else begin
              if lamp_siz lt 800  then put_logo,base
       endelse
       base1=widget_button(base0,      font=ft_normal,value='    The Manual    ',uvalue=[-88,201,0])
    endif

      base1 =widget_button(base0      ,font=ft_normal,value='SAVE this Session ',uvalue=[-88,397])
      lamp_don   =[lamp_don,base1]
      base1 =widget_button(base0      ,font=ft_normal,value='  SWITCH  OFF     ',uvalue=[-88,398])
    if GEORGE eq 2 then begin
      base1 =widget_button(lamp_ben[8],font=ft_normal,value='SAVE this Session ',uvalue=[-88,397])
      base1 =widget_button(lamp_ben[8],font=ft_normal,value='  SWITCH  OFF     ',uvalue=[-88,398])
    endif
return
end

pro MIC ,nocre
;+
;** ***
;** legacy
;-
@lamp.cbk
common okitis, yo

    if n_elements(yo)    eq 0 then begin
           keep_p=path_for_online & keep_i=inst_value  & keep_c=cycle
           P_RESTORE,lamp_dir+lamp_dvd+'mics.exe' ,cnt & CALL_PROCEDURE,'mics'
           yo=1
           CALL_PROCEDURE,'P_MIC_CREATE' ,0 ,'just'
           path_for_online=keep_p & inst_value=keep_i  & cycle=keep_c
    endif

    if n_elements(nocre) eq 0 then begin
       i=xregistered('MIC')
       if i gt 0 then widget_control,bad_id=i,lamp_mic,map=1 $
       else begin
            lamp_mic =widget_base( title='LAMP Data Instrument Access',resource_name='lampmic')
            CALL_PROCEDURE,'P_MIC_CREATE',(lamp_mic+0)
            bid=sys_dep('DYNLAB',lamp_mic,1)
            widget_control,bad_id=i   ,lamp_mic,group_leader=lamp_b1,/realize
            XMANAGER, 'MIC' ,lamp_mic ,event_handler='LAMP_EVENT_PARSER',/just_reg,/NO_BLOCK
       endelse
    endif
return
end

pro P_MUS  ,file
;+
;** *****
;** play a music
;-
@lamp.cbk
common  c_mus  ,mus_driv,mus_id,mus_fils

       if n_elements(mus_driv) lt 1 then begin
       mus_driv =  ''
       mus_id   =  0
       if lamp_loc eq 1 then begin
        mus_driv=sys_dep('PLAYER')
;       cd,lamp_dir,current=mee
;       mus_fils=finefile     ('mus_*')
;       cd,mee
       endif
       endif

       if n_elements(b_labins) ge 4 then if b_labins[3] eq 2 then mus_driv=''
       if mus_driv ne '' then begin
       if file  eq '' then begin & if mus_id gt 0 then bid=sys_dep('PLAY_OF',0,0,0,mus_id)
                                    mus_id =0
       endif else bid=sys_dep('PLAY_ON',mus_driv,lamp_dir,file,mus_id)
    endif
    if strpos(file,'cannon') ge 0 then p_tremble
return
end

pro MANUAL ,res
;+
;** ******
;** show the lamp book
;-
@lamp.cbk
    res=''
    if lamp_dir eq '' then man_dir=sys_dep('HOME') else man_dir=lamp_dir
    res=sys_dep('MANUAL',man_dir,lamp_macro)
    if l_message gt 0 then widget_control,bad_id=iii,l_message,set_value=$
          'See '+res
end

pro P_MESSI , base ,topb
;+
;** *******
;** used to speed up when updating windows
;-
@lamp.cbk
map=abs(sys_dep('MAP'))
if map eq 0 then return

if map eq 1 then begin
   if base  le 0 then begin
         base =widget_base(   title='Lamp')
         bid  =widget_label(  base,value='LAMP RECONSTRUCTION ...',font=ft_b_bigger)
         widget_control,topb ,bad_id=i,map=0
         widget_control,base ,group_leader=topb   ,bad_id=i,/realize
   endif   else  begin
         widget_control,base ,bad_id=i,/destroy
         widget_control,topb ,bad_id=i,map=1
   endelse
endif
if map eq 2 then begin
   if base  le 0 then begin
          base=1 &  widget_control,bad_id=i,topb,UPDATE=0
   endif else begin & widget_control,bad_id=i,topb,UPDATE=1 & empty & endelse
endif
return
end

pro dynlabel_call, w
;+
;** *************
;** at start set the attribute DYNAMIC_RESIZE for all widget_button !!!
;** initialy for all widget_label !!!
;-
        type = WIDGET_INFO(w, /TYPE)
;       IF ((type EQ 1) OR (type EQ 5)) THEN BEGIN
        IF ((type EQ 1))  THEN BEGIN
                WIDGET_CONTROL, /DYNAMIC_RESIZE, w
        ENDIF ELSE IF (type EQ 0) THEN BEGIN
                child = WIDGET_INFO(W, /CHILD)
                WHILE (child NE 0) DO BEGIN
                  DYNLABEL_CALL, CHILD
                  CHILD = WIDGET_INFO(CHILD, /SIBLING)
                ENDWHILE
        ENDIF
END

pro resizeButton_call, w ,val
;+
;** *****************
;** at start set correct XSIZE for all widget_button !!!
;-

        type = WIDGET_INFO(w, /TYPE)
        IF (type EQ 1) THEN BEGIN
            geo = WIDGET_INFO(w, /GEOMETRY)
            WIDGET_CONTROL, w, XSIZE=(geo.scr_xsize+val)>15

        ENDIF ELSE IF (type EQ 0) THEN BEGIN
            child = WIDGET_INFO(W, /CHILD)
            WHILE ( child NE 0 ) DO BEGIN
                    resizeButton_call, child,val
                    child = WIDGET_INFO(child, /SIBLING) & ENDWHILE
        ENDIF
END

pro P_DYING,id
;+
;** *******
;** lamp is dying so write lamp.jou and lamp.cds
;-
@lamp.cbk
    if l_message eq 0 then exok=1 else exok=0
    lamp_b1 =0 ;<---  IMPORTANT
    if GEORGE  ne 0 then WebOff
    P_MUS,'mus_cannon'
    DON_WRITE_PROG_MAC ,1
    DID_WRITE_JOURNAL
    wait,.3 & EMPTY
    if w1[0] ne -77 then $
    if (sys_dep('EMBEDDED')  or sys_dep('RUNTIME')) then EXIT
    rout=[1L]
    if  sys_dep('VERSION') ge 5.1 then rout=CALL_FUNCTION('widget_info',/managed)
    if  rout[0]  gt 0 then exok=0 else exok=1
    if (sys_dep('MACHINE') eq 'unix') and (exok)    then EXIT
return
end

pro P_LAMP_STOP
;+
;** ***********
;** for debugging send a message before stop command
;-
@lamp.cbk
@dons.cbk
       stat=0
       catch,stat
       if stat eq 0 then widget_control,bad_id=i,lamp_b1,show=0
       if stat eq 0 then bid=sys_dep('AFTES')
       if stat eq 0 then print,string(7b),' Type RETALL & LAMP to continue'
       if stat eq 0 then stop
return
end

pro P_LAMP_INIT, lamp_ziz=lps, george=geo
;+
;** ***********
;** at start set global lamp_ziz and george variables
;-
@lamp.cbk
    if n_elements(lps) eq 1 then lamp_ziz =lps
    if n_elements(geo) eq 1 then george   =geo
return
end

pro P_MYINIT_PROX
;+
;** *************
;** at start search for myinit.prox file to execute it (embeded version)
;-
    catch,stat
    if stat eq 0 then begin
       na=finefile('myinit.prox',count=nn)
       if nn gt 0 then begin
          on_ioerror, misini & in=-1
          OPENR,in,'myinit.prox',/get_lun
          line=''
          WHILE (not eof(in)) DO begin & readf,in,line & iii=EXECUTE(line) & ENDWHILE
          misini: if in gt 0 then FREE_LUN,in
          CD,current=mee
          P_SET_PATH,mee
       endif
    endif
    catch,/cancel
end

pro P_DO_THAT
;+
;** *********
;** handel problems when starting old embedded versions
;-
@lamp.cbk
 lamd_dir =           sys_dep('GETENV','LAMP_DIR' )
 lamd_wind=strlowcase(sys_dep('GETENV','LAMP_WIND'))
 cd,current=mee
 mydir=''

;Just for Idl5.2 embedded
;************************
 while strpos(!path,'..') ge 0 do begin
    i1=strpos(!path,'..')
    if strpos(!path,'..\..') ge 0 then j1=5  else j1=2
    if strpos(!path,'../..') ge 0 then j1=5
    if i1 gt 0 then deb=strmid(!path,0,i1-1) else deb=''
    !path=deb+lamd_dir +strmid(!path,i1+j1,300)
 endwhile
 if  strtrim(  !path,2)    eq '.'  then !path=mee else $
 while (strpos(!path,'.\') ge 0) or (strpos(!path,'./') ge 0) do begin
    i1= strpos(!path,'.\') & if i1 lt 0 then i1=strpos(!path,'./')
    if i1 gt 0 then deb=strmid(!path,0,i1-1) else deb=''
    !path=deb+ mee +strmid(!path,i1+1,300)
 endwhile
;************************
 if  strtrim(  !dir,2)     eq '.'  then !dir =mee

 catch,stat & if stat eq 0 then begin & cd,!dir+sys_dep('DIVIDER')+".." & cd,current=meelam
                cd,meelam+sys_dep('DIVIDER')+"lamp_mac"               & cd,current=meemac
                lamd_dir=meelam
                bid=sys_dep("ADDPATH",meemac)
                bid=sys_dep("ADDPATH",meelam) & lamp_dir=meelam
              endif
 catch,stat & if stat eq 0 then begin & pth  =sys_dep("NEWSUB",lamd_dir,"work")
                                      mydir=sys_dep('GETENV','LAMP_PWD' )
                                      if mydir gt ' ' then cd,mydir else cd,pth
              endif & catch,/cancel
 if mydir le ' ' then if sys_dep('MACHINE') eq 'unix' then cd,mee else P_MYINIT_PROX

 if strpos( !path,"lamp_mac") le 0 then begin
    pth  =sys_dep("NEWSUB" ,lamd_dir,"lamp_mac")
    bid  =sys_dep("ADDPATH",pth)
    endif

 if (!D.flags and 65536)   eq 0 then set_plot,'NULL' else $
 if strpos(lamd_wind,'nw') ge 0 then set_plot,'Z'
 if  sys_dep('STUDENT')                then lamp_ziz=600
 if (strpos(lamd_wind,'small'  ) ge 0) then lamp_ziz=480
 if (strpos(lamd_wind,'medium' ) ge 0) then lamp_ziz=600
 if (strpos(lamd_wind,'large'  ) ge 0) then lamp_ziz=800
 if (strpos(lamd_wind,'wide'   ) ge 0) then lamp_ziz=1024
 GEORGE=2
 if (strpos(lamd_wind,'lamp')    ge 0) then GEORGE  =0
 if (strpos(lamd_wind,'geo')     ge 0) then GEORGE  =1
 if (strpos(lamd_wind,'lampgeo') ge 0) then GEORGE  =2
 if (strpos(lamd_wind,'geolamp') ge 0) then GEORGE  =2
 if (strpos(lamd_wind,'full')    ge 0) then GEORGE  =3
end

pro SL_RESTSCAN, file, cnt
;+
;** ***********
;** load the scan application when needed for embedded version
;-
@lamp.cbk
    P_RESTORE,file ,cnt
    if cnt eq 0  then  P_RESTORE,!dir+lamp_dvd+'lib'+lamp_dvd+'hook'+lamp_dvd+'scan.sav' ,cnt
    if cnt gt 0  then  begin
             sl_lampscan, 'test' ,did_scan,tso
             if did_scan ge 0 then CALL_PROCEDURE,'scan',1 else cnt=0
        endif
end
pro SL_SCANLOAD, p1,p2
;+
;** ***********
;** load the scan application when needed for embedded version
;**
;-
    if p1 eq -1 then begin
            VV = strtrim(long(float(!version.release)*10),2) ; The Idl version
            pth=sys_dep("NEWSUB" ,p2,"lamp_mac")
            SL_RESTSCAN,pth+'scan'+VV+'.sav' ,cnt
            if cnt le 0 then SL_RESTSCAN,pth+'scan'+VV+'.rt' ,cnt
            if cnt le 0 then p1=-2 else p1=1
    endif
end
pro LANGUAGE_HELP
;+
;** *************
;** start IDL help application
;-
      if sys_dep('VERSION') ge 5.0 then CALL_PROCEDURE,'online_help' $
                                   else CALL_PROCEDURE,'man_proc','?'
end
pro ShowFreeW
;+
;** *********
;** show free workspaces
;-
@lamp.cbk
p0='' & n=0
for i=1,lamp_sys do begin
    si=strtrim(string(i),2)
    ii=execute('n=n_elements(W'+si+')')
    if n le 1 then p0=p0+'W'+si+' '
endfor
if p0 eq '' then p0="None"
show,'p0' & print,'Free Workspaces:'+p0
SnapShotWks_event, /map
end
; -----------------------------------------------------------------------------
; -----------------------------------------------------------------------------
; -----------------------------------------------------------------------------
; Procedures for Mini-Lamp ****** GET OUT OF LAMPRT.pro
; -----------------------------------------------------------------------------
; -----------------------------------------------------------------------------
; -----------------------------------------------------------------------------

pro SL_LAMPSCAN, flg,p1,p2,p3,p4,p5
;+
;** ***********
;** seems legacy
;-
    if flg eq 'test' then begin & p1=-1 & p2=0 & endif
end

pro P_RESTORE,file,cnt
;+
;** *********
;** restore a .sav file
;-
    cnt= 0
    i  = finefile(file,count=cnt)
    if cnt gt 0  then begin & catch,stat & if stat eq 0 then restore,file else cnt=0 & endif
end

pro P_ZOOM,  x,y,xd,yx,bb
;+
;** ******
;** seems legacy
;-
    forward_function sl_zoom
    bb=sl_zoom(x,y,xd,yx)
end

;pro P_DON_CREATE ,base
;;** ************
;@lamp.cbk
;    base0=widget_base     (base ,/column)
;    base1=widget_base     (base0,/row)
;    btitl=widget_label    (base1,font=ft_biggest,value=' FORMULA ENTRY')
;    bhelp=widget_button   (base1,font=ft_normal ,value='?'       ,uvalue=[-88,201,0])
;    bform=widget_text     (base1,font=ft_b_bigger,xsize=50,ysize=1,/editable,uvalue=[-88,200,0])
;    bsav =widget_button   (base1,font=ft_normal ,value='Extend...',uvalue=[-88,222,0])
;    l_message=widget_label(base0,font=ft_normal)
;end
;
;pro P_DID_CREATE ,base
;;** ************
;@lamp.cbk
;    bs0  =widget_base  (base ,/column)
;    bs1  =widget_base  (bs0  ,/row) & base1=widget_base(bs1,/row)
;    btitl=widget_label (base1,font=ft_biggest,value=' DISPLAY WORKSPACE')
;    bhelp=widget_button(base1,font=ft_normal ,value='Extend...',uvalue=[-88,342,0])
;
;    bsrow=widget_base  (bs0  ,/row)
;    bsopt=widget_base  (bsrow,/column,/frame)
;    baswb=widget_base  (bsrow)
;    d_x  =512
;    d_y  =256
;    if lamp_siz gt  950 then d_y  =320
;    if lamp_siz lt  800 then d_x  =300
;    if lamp_siz lt  800 then d_y  =230
;    bdraw=widget_draw  (baswb,xsize=d_x,ysize=d_y)
;    lamp_wrd     =bdraw
;    lamp_did(0:5)=[lamp_did(0),base1,bs1,bsrow,bsopt,bdraw]
;end
;pro P_BEN_CREATE ,base,f
;;** ************
;@lamp.cbk
;    base0=widget_base  (base ,/column)
;    base1=widget_base  (base0,/row)
;    btitl=widget_label (base1,font=ft_biggest,value=' DISPLAY')
;    bhelp=widget_button(base1,font=ft_normal ,value='x',uvalue=[-88,422,0])
;    btitl=widget_label (base0,font=ft_biggest,value=' FUNCTIONS')
;end
;pro P_MIC_CREATE ,base,p2
;;** ************
;end
;pro P_DID_PS_HEADER,p1,p2,p3
;;** ***************
;end
;pro DID_PARAM_HTM  ,p1
;;** *************
;end
;pro P_AFTER_REALIZE_DID, s1,s2,s3
;;** *******************
;@lamp.cbk
;    widget_control,lamp_wrd,bad_id=i,get_value=did_win0 & lamp_wrd='?'
;    wset,did_win0 & erase,100
;end
;pro P_DATA_ACCESS, p1,p2,p3,p4,p5
;;** *************
;end
;pro CLEARPAR, p1,p2
;;** ********
;end
;pro MOVEPAR, p1,p2,p3,p4
;;** *******
;end
;pro SETDATP, p1
;;** *******
;end
;pro GETDATP, p1
;;** *******
;end
;pro COMMSI,p1, exec=e
;;** *******
;end
;pro SETCOL,  n
;;** ******
;    if (n ge 0) and (n lt 40) then loadct,n
;end
;pro TO_DID_CUR, dummy
;;** **********
;end
;pro P_DID_GETW_CUR,p1,p2
;;** **************
;    p1=1 & p2='1'
;end
;pro GFIT_HELP, flg, formu,formt
;;** *********
;end
;pro P_DID_HELP, flg, formu,formt
;;** **********
;end
;pro DID_WRITE_JOURNAL
;;** *****************
;end
;pro P_DID_SETWIN0
;;** *************
;end
;pro PUT_LOGO       ,p1,TIO=p2 ,FILE=p3
;;** ********
;end
;pro TAKE_DATP      ,p1,W=p2
;;** *********
;end
;pro TAKE_W         ,p1,W=p2
;;** ******
;end
;pro GIVE_DATP      ,p1,W=p2
;;** *********
;end
;pro GIVE_W         ,p1,W=p2
;;** ******
;end
;pro MOD_DATP       ,p1,W=p2
;;** ********
;end
;pro P_DID_GET_IT   ,p1,p2,p3,p4,p5
;;** ************
;end
;pro P_MIC_GETRUN   ,p1,p2,status
;;** ************
;    status=3
;end
;pro P_MIC_SETRUN   ,p1,p2,p3,p4
;;** ************
;end
;pro TO_DON_HISTORY ,p1,p2,p3
;;** **************
;end
;pro MAC_LIST       ,p1,fl,p3,THISFILE=p4
;;** ********
;    fl=[' ']
;end
;function SL_ZOOM, x,y,xd,yx
;;******* *******
;;** Scan function
;return, -1
;end
;pro P_MIC_EVENT  ,event ,uv
;;** ************
;end
;pro P_DON_EVENT  ,event ,uv
;;** ************
;@lamp.cbk
;common  for_users,  a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
;
;    widget_control,bad_id=iii,l_message,set_value=' '
;   ;if uv(1) eq 201 then if sys_dep('MAP') le 0 then man_proc,'' else online_help
;    if uv(1) eq 200 then begin
;       widget_control,event.id,get_value=formu & formu=strtrim(formu(0),2)
;       wset,did_win0
;       stat=0 & ii=1
;       catch,stat
;       if  (stat eq 0)  and   (ii eq 1) then $
;         if strpos(formu,'$') eq 0  then spawn,strmid(formu,1,100) $
;         else if sys_dep('VM') ne 1 then begin ii=execute(formu)
;              widget_control,bad_id=iii,event.id ,set_value=''  & endif
;       if ii ne 1 or stat ne 0 then widget_control,bad_id=iii,l_message,set_value=!error_state.msg
;    endif
;return
;end
;
;pro P_DID_EVENT  ,event ,uv
;;** ************
;;**
;@lamp.cbk
;
;        CASE uv(1) of
;
;    342:
;;** Load colors
;;** ---- ------
;    347:   begin
;       i=xregistered('xloadct')
;       if i lt 1 then xloadct,group=lamp_b1,/use_current
;       end
;
;;** Multi_plot create
;;** ---------- ------
;    352:suprplot, 0
;
;;** Multi_plot event (353:slider_w_x_y 354:slider_range 355:keep etc. 356:buttons)
;;** ---------- -----
;    353:   p_rom_super_event, event,uv
;    354:   p_rom_super_event, event,uv
;    355:   p_rom_super_event, event,uv
;    356:   p_rom_super_event, event,uv
;;** Exit
;;** ----
;    398:   widget_control,/reset
;    else:  widget_control,l_message,set_value='!Not available from Mini_Lamp'
;    ENDCASE
;return
;end
;pro P_BEN_EVENT  ,event ,uv
;;** ************
;@lamp.cbk
;return
;end
;pro P_EXTEND ,event ,uv
;;** ********
;@lamp.cbk
;    if uv(1) eq 222 then begin
;           P_RESTORE,lamp_dir+lamp_dvd+'dons.exe' ,cnt
;           if cnt gt 0  then  begin
;               bastmp=0 & P_messi,bastmp,(lamp_b1+0)
;              widget_control,bad_id=i,lamp_don(0),/destroy
;              lamp_don(0) =widget_base  (lamp_b1 ,/frame,resource_name='don')
;              P_DON_CREATE ,(lamp_don(0))
;              bid=sys_dep('DYNLAB',lamp_don(0),0)
;              P_messi,bastmp,(lamp_b1+0)
;           endif
;    endif  else $
;    if uv(1) eq 342 then begin
;            P_RESTORE,lamp_dir+lamp_dvd+'dids.exe' ,cntd
;            if cntd gt 0  then begin
;               bastmp=0 & P_messi,bastmp,(lamp_b1+0)
;               widget_control,bad_id=i,lamp_did(1),/destroy
;               P_DID_CREATE ,lamp_did(0) ,lamp_did(2:5)
;               bid=sys_dep('DYNLAB',lamp_did(0),1)
;               P_messi,bastmp,(lamp_b1+0)
;           endif
;           SL_RESTSCAN,lamp_dir+lamp_dvd+'scan.exe'    ,cnt
;           P_RESTORE  ,lamp_dir+lamp_dvd+'touch_b.exe' ,cnt
;
;           if cntd gt 0  then P_AFTER_REALIZE_DID ,0,0,0
;    endif   else $
;    if uv(1) eq 422 then begin
;           P_RESTORE,lamp_dir+lamp_dvd+'bens.exe' ,cnt
;           if cnt gt 0  then  begin
;              bastmp=0 & P_messi,bastmp,(lamp_b1+0)
;              widget_control,bad_id=i,lamp_ben(2),/destroy
;              P_BEN_CREATE ,(lamp_ben(1)),0
;              bid=sys_dep('DYNLAB',lamp_ben(1),0)
;              P_messi,bastmp,(lamp_b1+0)
;           endif
;    endif
;return
;end
;pro DON_INIT_PROG_MAC , flg
;;** *****************
;return
;end
;pro DON_WRITE_PROG_MAC, flg
;;** ******************
;return
;end
;pro DON_DO_CMD, prox=p
;;** ******************
;return
;end
;pro XICUTER, cmd
;;** *******
;return
;end
;pro XICUTE , cmd
;;** ******
;return
;end
;pro SET_HISTORY
;;** ***********
;return
;end
;pro READ_DATA
;;** *********
;return
;end
;pro P_TREMBLE
;;** *********
;return
;end
;pro LOGO, w
;;** *****
;w=congrid(dist(64),128,64)
;return
;end
;
;;------------------------------------------------------------------------------
;;                                    Upgrade LAMP (old method) see liv_lamp.pro
;;------------------------------------------------------------------------------
;pro upg_kill,id
;;** ********
;common desk,whatdo,b11
;widget_control,bad_id=i,b11(0),map=1
;end
;
;pro upi,lodtx,out
;;** ***
;;**
;k=0
;p_set_font,k ,lamp_font
;a0=widget_base  (title='Lamp Upgrade',/column,resource_name='lamp')
;a1=widget_base  (a0,/row,resource_name='mic')
;lb=widget_label (a1,value='If you are behind a FireWall, enter the FTP Proxy:',font=lamp_font(5,k))
;px=widget_text  (a1,value=out,xsize=10,ysize=1,/editable,font=lamp_font(5,k))
;a2=widget_base  (a0,/row)
;bt=widget_base  (a2,/column,resource_name='did')
;ct=widget_text  (a2,xsize=60,ysize=8,/scroll,resource_name='don',font=lamp_font(5,k))
;uv=[lodtx(0:5),0,px,ct,a0] & uv(3)=10
;uv(6)=1 & b1=widget_button(bt,value='Read last News',uvalue=uv,font=lamp_font(3,k))
;uv(6)=2 & b2=widget_button(bt,value='Upgrade Lamp'  ,uvalue=uv,font=lamp_font(3,k))
;uv(6)=3 & b3=widget_button(bt,value='Cancel'        ,uvalue=uv,font=lamp_font(3,k))
;
;w0=2 & LOGO,w0 & pax1=size(w0)
;tmpdid=widget_base(bt,/row)
;b4    =widget_draw  (tmpdid,xsize=pax1(1),ysize=pax1(2),retain=2)
;
;widget_control,bad_id=i,lodtx(5),map=0
;widget_control,bad_id=i,a0,/realize
;widget_control,bad_id=i,b4,get_value=jj & wset,jj & tvscl,w0,0,0
;
;XMANAGER, 'LAMP_UPG',a0,event_handler='DESKTOP_EVENT',CLEANUP='UPG_KILL',/just_reg,/NO_BLOCK
;end
;
;function ulamp,p1,p2,p3
;;******* *****
;;**
;;p1=1   --> res=-1    bad lamp_dir
;;       res=-2    write not allowed
;;       res=0 ok
;;p1=2   --> res='?'   Problem with .netrc
;;       res='.'   Unable to get the file
;;       res=lampnews.txt
;;p1=3   --> res='?'   Problem with .netrc
;;       res='.'   Unable to get the file
;;       res='ok'  Got lamp_light.tar.Z
;;p1=4   --> res=-1    faile
;;       res=0 MAKE_LAMP.unix successful
;
;;p2=''      no firewall
;;p2='fname' firewall internal name
;;p3= lamp_dir
;
;ON_IOERROR,mispriv
;
;IF p1 eq 1 THEN BEGIN
;   res=-1 & OPENR,lun,p3+'lamp.pro',/get_lun         & FREE_LUN,lun
;   res=-2 & OPENW,lun,p3+'wrtest'  ,/get_lun,/delete & FREE_LUN,lun & res=0
;
;ENDIF ELSE IF (p1 eq 2) or (p1 eq 3) THEN BEGIN
;
;   f=finefile('~/.netrc',count=N1)
;   IF N1 gt 0  then SPAWN, 'mv -f ~/.netrc ~/.netrc_lampsav'
;   PAS=getenv('USER')+'@'+getenv('HOST')+'.lamp'
;   ILL='ftp.ill.eu'
;
;   IF p2 eq '' then TRG=ILL ELSE TRG=p2
;   IF p2 eq '' then V1 ='machine '+ILL+' login anonymous'
;   IF p2 ne '' then V1 ='machine '+p2 +' login anonymous@'+ILL
;           V1 = V1+' password '+PAS
;   IF P1 eq 2  then V2 = 'lampnews.txt'
;   IF P1 eq 3  then V2 = 'lamp_light.tar.Z'
;   V3 =['get '+V2,'quit','','']
;   VAR=[ V1 ,'macdef init','bin','cd pub/cs',V3]
;;  VAR=[ V1 ,'macdef init','bin','cd to_ill/cs',V3]
;
;   res='?' & OPENW ,lun,'~/.netrc',/get_lun
;   FOR i=0,n_elements(VAR)-1 DO PRINTF,lun,VAR(i)  & FREE_LUN ,lun
;   SPAWN, 'chmod 700 ~/.netrc'
;
;   f=finefile(V2,count=N3)
;   if N3 gt 0 then   OPENR,lun,V2,/get_lun,/delete & FREE_LUN ,lun
;
;   WIDGET_CONTROL,/hourglass
;   SPAWN,'ftp '+TRG,unit=U  &  printf,U,'quit'
;   ON_IOERROR,goon      &  readf,U,res
;   goon:free_lun,U
;
;   if N1 gt 0  then spawn, 'mv -f ~/.netrc_lampsav ~/.netrc' else SPAWN, 'rm ~/.netrc'
;
;   res='.' & f=finefile (V2,count=N2)
;   IF N2 gt 0 then BEGIN res='ok'
;      IF P1 eq 2 then BEGIN
;     SPAWN,'cat  '+V2+' ; rm '+V2  ,res
;      ENDIF
;      IF P1 eq 3 then BEGIN
;     CD,current=mee
;     SPAWN,'cd '+p3+' ; cp lamp_mac/read_par.pro lamp_mac/read_par.loc'
;     SPAWN,'cd '+p3+' ; cp START_LAMP.unix START_LAMP.loc'
;     SPAWN,'cd '+p3+' ; cd .. ; zcat '+mee+'/'+v2+' | tar xf - '
;     SPAWN,'cd '+p3+' ; mv lamp_mac/read_par.loc lamp_mac/read_par.pro'
;     SPAWN,'cd '+p3+' ; mv START_LAMP.loc START_LAMP.unix'
;     SPAWN,'rm '+V2
;      ENDIF
;   ENDIF
;ENDIF ELSE IF p1 eq 4 THEN BEGIN res=0
;   SPAWN,'cd '+p3+' ; source MAKE_LAMP.unix',res
;   SPAWN,'echo "" > lamp.upg'
;ENDIF
;
;mispriv:return,res
;end
;
; END GET OUT OF LAMPRT.pro
; *************************
; 
; -----------------------------------------------------------------------------
;                                      DESKTOP
; -----------------------------------------------------------------------------

pro desktop_event, event
;+
;** *************
;** legacy (lamp.ini)
;-
common desk,whatdo,b11

    stat=0 & catch,stat
    if stat  ne 0  then begin & print,string(7b)+!error_state.msg & return & endif
    lodtx=[0]
    widget_control,bad_id=i ,event.id,get_uvalue=lodtx
    if n_elements(lodtx) ge 5 then begin

    widget_control,bad_id=i ,lodtx[5],/clear_events
    widget_control,bad_id=i ,lodtx[4],set_value=' '
    widget_control,/hourglass

    CASE lodtx[3] OF

    1:   desktop_lamp,lodtx

    2:   begin & desktop_tuch,tbas,lbas
       if (tbas gt ' ') then begin
          maj_desktop, lodtx , ' Loading TOUCH BASE ...',0
              P_RESTORE,lbas+'touch_b.exe' ,cnt
              if cnt gt 0 then begin
                  desktop_lamp,lodtx
              endif else $
          maj_desktop, lodtx , ' Sorry, TOUCH BASE is not available',0
       endif else $
          maj_desktop, lodtx , ' Sorry, TOUCH BASE is not available',0
         end
    3:   begin & whatdo = lodtx[3]
          MANUAL,res
          if res eq '' then $
             maj_desktop,lodtx, ' Sorry, no HTML BROWSER found in local/bin',0
         end

    4:   begin & whatdo = lodtx[3]  &  widget_control,bad_id=i,event.top,/destroy
                 widget_control,/reset & end

    5:   if whatdo ne -5 then begin
        desktop_tuch,tbas,lbas
        if (tbas gt ' ') then begin
          maj_desktop, lodtx , ' Loading TOUCH UPDATE ...',0
          lamp,'just'
          maj_desktop, lodtx , ' TOUCH UPDATE running...',0
          maj_desktop, lodtx , ' TOUCH UPDATE running...',0
          whatdo = lodtx[3]
          touch_u,1,lodtx[4],lodtx[1],lodtx[5]
       endif
         endif

    6:   desktop_lamp,lodtx

    7:   begin & whatdo = lodtx[3]
          P_ENVI
          desktop_tuch,tbas,lbas,lsiz,lins
          TOUCH_X,lins,tbas,1
         end

    8:   CUSTOMIZ,1

    9:   BEGIN & desktop_tuch,tbas,lbas,lsiz,lins,out & CALL_PROCEDURE,'UPI',lodtx,out & END

    10:  if lodtx[6] lt 3 then begin
          desktop_tuch,tbas,lbas
          out='' & widget_control,bad_id=i,lodtx[7],get_value=out
          out=strtrim(out[0],2)
          if lodtx[6] eq 1 then begin
         widget_control,bad_id=i,lodtx[8],set_value=['','Downloading the News ...']
         res=ulamp[2, out ,lbas]
         if n_elements(res) eq 1 then begin
            if res eq '?' then res=['','!! Problem with .netrc file ...'] else $
            if res eq '.' then res=['','!! Can"t download the news ...']
         endif else desktop_puch,out
         widget_control,bad_id=i,lodtx[8],set_value=res
          endif
          if lodtx[6] eq 2 then begin
         res=ulamp[1, out ,lbas]
         if res eq 0 then begin
            widget_control,bad_id=i,lodtx[8],set_value=['','Downloading ...']
            res=ulamp[3, out ,lbas]
            if res eq 'ok' then begin
          desktop_puch,out
                 widget_control,bad_id=i,lodtx[8],set_value=['','Making LAMP ...']
          res=ulamp[4, out ,lbas]
          widget_control,/reset
            endif else begin
                 if res eq '?' then res=['','!! Problem with .netrc file ...'] else $
                 if res eq '.' then res=['','!! Can"t download the upgrade ...']
          widget_control,bad_id=i,lodtx[8],set_value=res
            endelse
         endif else begin
            if res eq -1 then txt='!! Bad Lamp-directory '+lbas
            if res eq -2 then txt='!! Your are not allowed to modify the lamp-directory ...'
            widget_control,bad_id=i,lodtx[8],set_value=['',txt]
         endelse
          endif
         endif else widget_control,bad_id=i,lodtx[9],/destroy

    11:  desktop_lamp,lodtx

    -87: LAMP_EVENT_PARSER,event
    -88: LAMP_EVENT_PARSER,event
    else:
    endcase
    endif
return
end

pro desktop_tuch,tbas,lbas,lsiz,lins,out,geor
;+
;** ************
;** legacy (lamp.ini)
;-
@lamp.cbk
tbas=lamp_touch+lamp_dvd
lbas=lamp_dir  +lamp_dvd
lsiz=lamp_ziz
lins=lamp_ins
out =lamp_proxy
if n_elements(GEORGE) eq 1 then geor=GEORGE else geor=2
end
pro desktop_puch,out, geo=geo
;+
;** ************
;** legacy (lamp.ini)
;-
@lamp.cbk
if n_elements(geo) ne 1 then lamp_proxy=out else GEORGE=geo
end

pro desktop_lamp,lodtx
;+
;** ************
;** legacy (lamp.ini)
;-
common desk,whatdo,b11
       if lodtx[2] gt 0 then begin
          desktop_tuch,tbas,lbas,lsiz,lins,out,geor
          if (lodtx[3] eq 11) then begin
            desktop_puch,geo=1
            lodtx[3]=1
          endif else begin
            maj_desktop, lodtx , ' Loading Image Processing modules ...',90
            desktop_tuch,tbas,lbas
                SL_RESTSCAN,lbas+'scan.exe' ,cnt
            if cnt gt 0  then loadct,1
            i= xregistered( 'TOUCH')
            if (i gt 0) then TOUCH_DONE,0,0
          endelse
       endif
       whatdo =lodtx[3] & widget_control,bad_id=i,b11[0],/destroy
return
end

pro desktop_kill, id
;+
;** ************
;** legacy (lamp.ini)
;-
return
end

pro maj_desktop, lodtx , text , pcent
;+
;** ***********
;** legacy (lamp.ini)
;-
common desk,whatdo,b11

if !D.name ne 'NULL' then begin

    if (pcent eq 70) then begin

       desktop_tuch,tbas,lbas,lamp_siz
       pixmap=0 & LOGO,pixmap
       !order=1 & wset,lodtx[2]
       if n_elements(pixmap) eq 1 then $
       if lamp_siz  ge 800 then device,copy=[0,0,512,256,    0  ,  0  ,pixmap] $
       else device,copy=[0,0,300,150,(300-300)/2,(200-150)/2,pixmap]
       !order=0
    endif

    widget_control,bad_id=ii,lodtx[1],set_value=text

    if ii ne 0 then exit

    wset,lodtx[0]
    if pcent le 100 then plots,[0,2*pcent-1],[9,9],color=120,/device,thick=5

    if pcent eq 100 then begin
    if b11[1] gt 0  then begin
      whatdo=0
      print,string(7b)
      wset,lodtx[0] & erase
      plots,indgen(200),sin(findgen(200)/10)*4+9,color=120,/device,thick=5
      widget_control,bad_id=i ,b11[1]  ,sensitive=1
      widget_control,bad_id=i ,lodtx[5],/clear_events
      XMANAGER, 'LAMP_DESKTOP',lodtx[5],event_handler='DESKTOP_EVENT',CLEANUP='DESKTOP_KILL'
      lodtx[0]=-whatdo


      IF lodtx[0] EQ -1 THEN LAMP      ELSE  $
      IF lodtx[0] EQ -2 THEN LAMP,'touch'  ELSE  $
      IF lodtx[0] EQ -6 THEN LAMP,'tripx'
      bid=sys_dep('EXIT')
    endif else pcent=101
    endif

    if pcent eq 101 then begin
       desktop_lamp,lodtx
       lodtx[0]=-1
       LAMP
    endif

endif else begin
    print,text & lodtx[0]=-1
endelse
return
end

pro desktop, lodtx ,menu=menu ,nomenu=nomenu
;+
;** *******
;** legacy (lamp.ini)
;** First window when LAMP is started.
;-

common desk,whatdo,b11

if n_elements(lodtx) ne 6 then lodtx=lonarr(6)
if !D.name ne 'NULL' then begin

ii=xregistered('LAMP_DESKTOP')
if (ii le 0) or (lodtx[5] le 0) then begin

    ii=sys_dep('PSEUDO')

    P_ENVI
    P_MUS ,'mus_start'

    k=0
    p_set_font,k ,lamp_font
    ft_biggest  =lamp_font[1,k]
    ft_b_bigger =lamp_font[3,k]
    ft_normal   =lamp_font[4,k]
    ft_b_normal =lamp_font[5,k]
    ft_smaller  =lamp_font[6,k]
                sizex=512   &   sizey=256
    desktop_tuch,tbas,lbas, lamp_siz
    if lamp_siz lt 800 then begin & sizex=300   &   sizey=230 & endif

    b1 =widget_base(  title='Lamp Desktop',/column,resource_name='lamp',$
                           kill_notify='desktop_kill')
    row1=0L
    if keyword_set(menu) then begin
    row1   =widget_base(  b1   ,/row)
    but1   =widget_button(row1 ,value=' LAMP '     ,font=ft_biggest)
    but6   =widget_button(row1 ,value=' GEORGE '     ,font=ft_biggest)
    but2   =widget_button(row1 ,value=' TOUCH L. '     ,font=ft_biggest)
;   but5  =widget_button(row1 ,value= 'INST'     ,font=ft_biggest,menu=2)
    but5_4 =widget_button(row1 ,value= 'Customize' ,font=ft_b_bigger)
    but3   =widget_button(row1 ,value=' MANUAL '     ,font=ft_b_bigger)
    but4   =widget_button(row1 ,value=' EXIT'       ,font=ft_b_bigger)

;   but5_1  =widget_button(but5 ,value=' 3 AXES '     ,font=ft_b_bigger)
;   but5_4  =widget_button(but5 ,value=' CUSTO Mize   '   ,font=ft_b_bigger)
;   but5_3  =widget_button(but5 ,value=' TOUCH Manage '   ,font=ft_b_bigger)
;   but5_2  =widget_button(but5 ,value=' TOUCH Update '   ,font=ft_b_bigger)

    bid    =widget_label( b1   ,value=' '        ,font=ft_biggest)
    endif
    Show_Version,b1,version,bil
    but9   =widget_button(bil  ,value='NEWs !!!'      ,font=ft_smaller)

    row2   =widget_base(  b1   ,/row)

    lodtx[0]=widget_draw(  row2 ,xsize=200  ,ysize=20   ,retain=2,colors=-30)
    lodtx[1]=widget_label( row2 ,xsize=sizex-200,value=' ' ,font=ft_b_normal)

    lodtx[4]=widget_label( b1   ,xsize=sizex    ,value=' ' ,font=ft_b_normal)

    icon    =widget_draw(  b1   ,xsize=sizex,ysize=sizey,retain=2,/button_events)

    bid    =widget_label( b1   ,value='Didier RICHARD @ill.eu  -  Don KEARLEY @iri.nl  -  '+$
                 'Michel FERRAND @cea.fr' ,font=ft_smaller)
    bil    =widget_base(  b1   ,/row)
    bid    =widget_label( bil  ,value='ILL:'            ,font=ft_b_bigger)
    bid    =widget_label( bil  ,value='Institut-Laue-Langevin  Grenoble France'    $
                           ,font=ft_normal)
    bid    =widget_label( bil  ,value='(anonymous@ftp.ill.eu  /pub/cs/lamp...)'   $
                            ,font=ft_smaller)

    bid=sys_dep('DYNLAB',b1,1)
    widget_control,bad_id=i   ,b1  ,/realize
    b11=[b1,row1]
    if row1 gt 0 then widget_control,bad_id=i   ,row1,sensitive=0
    widget_control,bad_id=i   ,lodtx[0],get_value =jj & lodtx[0]=jj & loadct,27
    widget_control,bad_id=i   ,icon    ,get_value =jj & lodtx[2]=jj
    bid=sys_dep('AFTER')
    if  sys_dep('MACHINE') ne 'unix' then $
    widget_control,bad_id=i,but9,sensitive=0
    lodtx[5]=b1
    lodtx[3]=0  &  widget_control,bad_id=i,icon  ,set_uvalue=lodtx

    if keyword_set(menu) then begin
    lodtx[3]=1  &  widget_control,bad_id=i,but1  ,set_uvalue=lodtx
    lodtx[3]=2  &  widget_control,bad_id=i,but2  ,set_uvalue=lodtx
    lodtx[3]=3  &  widget_control,bad_id=i,but3  ,set_uvalue=lodtx
    lodtx[3]=4  &  widget_control,bad_id=i,but4  ,set_uvalue=lodtx
;   lodtx(3)=5  &  widget_control,bad_id=i,but5_2,set_uvalue=lodtx
;   lodtx(3)=6  &  widget_control,bad_id=i,but5_1,set_uvalue=lodtx
;   lodtx(3)=7  &  widget_control,bad_id=i,but5_3,set_uvalue=lodtx
    lodtx[3]=8  &  widget_control,bad_id=i,but5_4,set_uvalue=lodtx
    lodtx[3]=11 &  widget_control,bad_id=i,but6  ,set_uvalue=lodtx
    endif
    lodtx[3]=9  &  widget_control,bad_id=i,but9  ,set_uvalue=lodtx
    lodtx[3]=1

    widget_control,/hourglass
endif
endif
return
end

;****************************** B.A.R.N.S interfaces **************************************
;****************************** B.A.R.N.S interfaces **************************************
;****************************** B.A.R.N.S interfaces **************************************
pro BARNS_R ,remove=rem
;+
;** *******
;** restore a session for a web client
;-
@lamp.cbk
@dons.cbk
common  for_users
    fil=finefile('lamp.ses',count=true)
    if  true gt 0 then begin
         P_RESTORE, 'lamp.ses', cnt
         AFTER_RESTORE
         if keyword_set(rem) then bid=sys_dep('DELET','lamp.ses')
         print,'Previous Session is restored ....'
    endif
end
function BARNS_I    ,val
;+
;******* *******
;** interfacing a webLamp client
;-

common c_barns  ,wk_read ,wk_plot ,wk_year,wk_raw ,wk_rot ,wk_repi ,wk_repc ,wk_reps $
       ,wk_fu   ,wk_fil  ,wk_reg  ,wk_log ,wk_wr  ,wk_xr  ,wk_yr   ,wk_kef  $
       ,wk_bx   ,wk_by   ,wk_bw   ,wk_fx  ,wk_fy  ,wk_fz  ,wk_px   ,wk_py   $
       ,wk_pz   ,wk_save ,wk_fmt  ,wk_ins ,wk_cyc

eff=0
txt=strlowcase(val)
k  =strpos(txt,','+string(9b)+'"') ;Care!!!   ',<tab>"'
if k gt 0 then begin
    if n_elements(wk_raw) eq 0 then begin
          wk_raw =0      & wk_fil ='Gif'       & wk_save= 1
          wk_repi=''     & wk_repc=''          & wk_plot='1'
          wk_reps=''     & wk_fu  =',/below'   & wk_fmt = 3
          wk_reg =',regular=0'    & wk_rot ='30'
          wk_log =',log=0'        & wk_wr  = 0.
          wk_xr   = [0.,0.] & wk_yr  = [0.,0.] & wk_year=''
          wk_bx  =  0       & wk_by  =  0      & wk_bw  =0
          wk_fx  =  0       & wk_fy  =  0      & wk_fz  =0
          wk_px  =  0       & wk_py  =  0      & wk_pz  =0
          wk_kef =  0       & wk_ins = ''      & wk_cyc =''
          seem,view=60.
          endif
    eff=1
    txt=strmid(txt,0,k)    & cmd=strmid(val,k+2)
    ln =strlen(cmd)        & cmv=strmid(cmd,1,ln-2)

    CASE txt of
    "set_inst":if cmd ne wk_ins then begin & CALL_PROCEDURE,'RDSET',inst=cmv
          wk_ins=cmd
          cmv=strlowcase(cmv) & hhh=''
          if sys_dep('VM') ne 1 then   begin
          iii=execute('myinit_'+cmv) & iii=execute('myhelp_'+cmv+ ',hhh') & endif
          nn=n_elements(hhh)
          if nn gt 1 then begin & on_ioerror,misop      & u =0
               openw ,u,'help_'+cmv+'.htm',/get_lun
               printf,u,'<HTML><PRE>'
               for i=0,nn-1 do printf,u,hhh[i]
               printf,u,'</PRE></HTML>'
               misop: if u gt 0 then free_lun,u & endif
               endif
    "set_base":if wk_ins+wk_year+cmd ne wk_cyc then begin
          wk_cyc =wk_ins +wk_year+cmd
          IF strpos(cmd,'Cycle -') lt 0 then $
             XICUTER ,'RDSET,base='+cmd $
          else begin
             cyclo=strmid(wk_year,2,2)+strmid(cmv,7,1)
             XICUTER ,'RDSET,base="C_Year '+wk_year+'",cycle='+cyclo
             IF (cyclo ge '123') and (cyclo lt '731') then XICUTER,'RDSET,proposal="internalUse"'
          endelse
               endif
    "set_year":     wk_year   = cmv
    ;**********
    "do_filt" :begin & on_ioerror,fsx_err  &  rdtmp=[0.,0.]  & reads   , cmv+' 0 0',rdtmp
          RDFILTER, xrange=rdtmp       & fsx_err:
          if wk_fx eq 0 then RDFILTER,xrange=[0,0]
          if wk_fy eq 0 then RDFILTER,yrange=[0,0]
          if wk_fz eq 0 then RDFILTER,zrange=[0,0]
          if wk_px eq 0 then RDFILTER,xproj = 0
          if wk_py eq 0 then RDFILTER,yproj = 0
          if wk_pz eq 0 then RDFILTER,zproj = 0
          wk_kef=wk_fx + wk_fy + wk_fz + wk_px + wk_py + wk_pz
          wk_fx =0 & wk_fy =0 & wk_fz =0 & wk_px =0 & wk_py =0 & wk_pz =0
          end
    "r_scly"  :begin & on_ioerror,fsy_err  &  rdtmp=[0.,0.]  & reads   , cmv+' 0 0',rdtmp
          RDFILTER, yrange=rdtmp       & fsy_err: & end
    "r_sclz"  :begin & on_ioerror,fsz_err  &  rdtmp=[0.,0.]  & reads   , cmv+' 0 0',rdtmp
          RDFILTER, zrange=rdtmp       & fsz_err: & end
    "r_chkx"  :     wk_fx = 1
    "r_chky"  :     wk_fy = 1
    "r_chkz"  :     wk_fz = 1
    "r_prjx"  :begin & RDFILTER,/xproj & wk_px = 1 & end
    "r_prjy"  :begin & RDFILTER,/yproj & wk_py = 1 & end
    "r_prjz"  :begin & RDFILTER,/zproj & wk_pz = 1 & end
    ;**********
    "do_read" :IF cmv gt " " then begin
          IF wk_raw then RDSET,/raw else RDSET,/default
          ffl=strpos(cmv,':')
          if (wk_kef ge 1) or (ffl ge 1) then begin
                    if wk_raw then RDFILTER,monimod=2 $
                         else RDFILTER,monimod=1
                 RDFILTER,selection=cmv,wksp=fix(wk_read)
          endif else  GMY_run ,[0,0,0,0],cmv,     fix(wk_read)
          wk_raw   =   0  & wk_plot=wk_read  & ENDIF
    "r_raw"   :     wk_raw       = 1
    "set_wks" :     wk_read   = cmv
    ;**********
    "do_save" :     WRITE_LAMP    ,   cmv ,w=wk_save ,fmt=wk_fmt
    "s_wks"   :     wk_save   =   fix(cmv)
    "s_fmt"   :     wk_fmt    =   fix(cmv)
    ;**********
    "do_plot" :begin & wk_plot  = cmv
          if wk_bx eq 0 then wk_xr[*]=0. & if wk_by eq 0 then wk_yr[*]=0.
          if wk_bw eq 0 then wk_wr   =0.
          range=strcompress(',xrange=['+string(wk_xr[0])+','+string(wk_xr[1])+'],'+$
                     'yrange=['+string(wk_yr[0])+','+string(wk_yr[1])+'],'+$
                     'zlim='   +string(wk_wr),/remove_all)
          cmd = 'SEEM, rot='+wk_rot +wk_reg +wk_fu +wk_log +range
          XICUTER ,   cmd
          if wk_fil eq 'Wrl'  then begin & wk_reps=',/surface' & wk_repi='' & wk_repc=''
                   fil=',/vrml'  & endif else $
          if wk_fil eq 'Ps'   then fil=',/pscript' else $
          if wk_fil eq 'Java' then fil=',/htm'     else fil=''
          cmd = 'SEE, w=' +wk_plot +wk_repi +wk_repc +wk_reps +fil
          XICUTER ,   cmd
          wk_repi =   ''       & wk_repc = ''
          wk_reps =   ''       & wk_log  = ',log=0'
          wk_reg   =   ',regular=0'  & wk_wr   = 0.
          wk_xr[*]    =   0.   & wk_yr[*]= 0.
          wk_bx     =     0    & wk_by   = 0    & wk_bw = 0
          end
    "d_fil"   :     wk_fil       = cmv
    "d_repi"  :     wk_repi   = ',/image'
    "d_repc"  :     wk_repc   = ',/contour'
    "d_reps"  :     wk_reps   = ',/surface'
    "d_repr"  :     wk_reg    = ',regular=1'
    "d_angl"  :begin & on_ioerror,rot_err
          wk_rot   =     string(fix(cmv)) & rot_err: & end
    "d_befu"  :     wk_fu     =  cmv
    "d_sclx"  :begin & on_ioerror,chx_err
          reads     ,    cmv+' 0 0',wk_xr & chx_err: & end
    "d_scly"  :begin & on_ioerror,chy_err
          reads     ,    cmv+' 0 0',wk_yr & chy_err: & end
    "d_sclw"  :begin & on_ioerror,chw_err
          reads     ,    cmv+' 0 0',wk_wr & chw_err: & end
    "d_chkl"  :     wk_log    = ',log=1'
    "d_chkx"  :     wk_bx     =  1
    "d_chky"  :     wk_by     =  1
    "d_chkw"  :     wk_bw     =  1
    ;**********
    "do_cmd"  :     XICUTER   , cmv
    "submit"  :CASE  cmv of
          "The Journal": DID_WRITE_JOURNAL ,/htm
          "Parameters" : DID_PARAM_HTM     ,wk_plot
          "The Manual" :
          else:
          ENDCASE
    ;**********
    "do_color":     setcol       ,   fix(cmv)
    ;**********
     else     :     eff=0
    ENDCASE
endif
return,eff
end

PRO LAMP_B
;+
;** ******
;** running lamp in terminal mode
;-
@lamp.cbk

if  b_labins[3] le 0 then begin
 if (strpos(strlowcase(sys_dep('GETENV','LAMP_WIND')),'nws') ge 0) or (!D.Name eq 'Z')  then begin
         BARNS_R ,/remove & b_labins[3] = 2 & SET_PLOT,"Z"
 endif else begin & BARNS_R & b_labins[3] = 1 & endelse
 P_DON_INIT_VAR
 P_DID_SETVAR
 P_DATA_IDOL
 RDFILTER
 GEORGEO,/nowin
 lamp_focus =-1
endif

if b_labins[3] eq 1 then begin
 print,' **********************'
 print,' * Remember INTERNALS *'
 print,' **********************'
 print,'Available Bases       : ',lamp_ali[*]+','
 print,''
 print,'To set your instrument : RDSET   ,inst="D20"'
 print,'To set your base       : RDSET   ,base="C_Year 1996" ,cycle=964'
 print,"To use Windows or X11  : SET_PLOT,'WIN' or set_plot,'X'
 print,'Actual display is '+!D.Name+' , Instrument is '+inst_value+' , Base is '+path_for_online
 print,''
endif

CATCH,stat & if stat ne 0 then print,!error_state.msg
text=''
    while (1) do begin
       ON_IOERROR,NO_MATTER
       READ,'Lamp> ',text    &  text=strtrim(text,2)
       NO_MATTER: IF text ne '' then begin ;if b_labins(3) eq 2  then print,'Barns-sent'
                      if not barns_i(text) then XICUTER,text
                                           ;if b_labins(3) eq 2  then print,'Barns-done'
                      ENDIF
    endwhile
return
end

; GET OUT FROM LAMPRT.pro
; ***********************

PRO RUNTIME
;+
;** *******
;** first call in embedded version
;-
    cd,current=mee & cd,!dir & cd,current=idldir & !dir=idldir
    fl=finefile('core.rt' ,count=cnt )
    if cnt gt 0 then begin & catch,stat & if stat eq 0 then restore,'core.rt' & endif & catch,/cancel
    cd,mee
    if (!D.flags and 65536) ne 0 then bid=sys_dep('PSEUDO')
    RUNTIM
end

PRO RUNTIM
;+
;** ******
;** first call in embedded version, do some restores
;-
    pth=sys_dep('GETENV','LAMP_DIR')
    VV=strtrim(string(sys_dep('VERSION')),2) & vvp=strpos(VV,'.')
    VV=strmid( VV,0,vvp)+strmid( VV,vvp+1,1)
    CD,current=mee
    dv=sys_dep('DIVIDER')
    if pth ne '' then begin & if strlowcase(!dir) eq strlowcase(pth) then pth=pth+dv+'..'
                            catch,stat & if stat eq 0 then CD,pth
                            cd,current=pth
                            catch,/cancel &  endif
    fl=finefile('update'+VV+'a.rt' ,count=cnt )
    if cnt eq 0 then begin &  pth=!dir+dv+'..'
             fl=finefile(pth +dv+'update'+VV+'a.rt' ,count=cnt)
             if cnt gt 0 then   CD, pth
             cd,current=pth
    endif
    if cnt eq 0 then begin &  pth=!dir+dv+'..'+dv+'..'
             fl=finefile(pth +dv+'update'+VV+'a.rt' ,count=cnt)
             if cnt gt 0 then   CD, pth
             cd,current=pth
    endif
    if cnt gt 0 then bid=sys_dep('ADDPATH',pth)
    if cnt gt 0 then setenv,'LAMP_DIR='+pth

;   RESTORE AVAILABLE COMPILED FILES.
;   --------------------------------
    NW=strpos(strlowcase(sys_dep('GETENV','LAMP_WIND')),'nw')
    fl=finefile('*'+VV+'a.rt' ,count=cnt )
    fs=finefile('*'+VV+'.sav' ,count=cnts)
    if cnts gt 0 then if cnt gt 0 then fl=[fl,fs] else fl=fs & cnt=cnt+cnts
    if cnt  gt 0 then begin
      if NW lt 0 then begin
         bload=widget_base( title='Large Array Manipulation Program',/column,resource_name='lamp') & valb='Loading... '
         Show_Version,bload
         bloab=widget_label(bload,value=valb+'............ ............ ............')
         widget_control,bload,/realize
      endif
         CD,current=mpth
         ln=strpos(strupcase(fl[0]),strupcase(mpth))
         if ln ge 0 then ln=ln+strlen(mpth) else ln=0
         for i=0,cnt-1 do begin
          if (strpos(strupcase(fl[i]),'LAMP') ne 0) then $
          if (NW lt 0) or ((strpos(strupcase(fl[i]),'SCAN'+VV) lt 0)  and  $
                           (strpos(strupcase(fl[i]),'LIVE'+VV) lt 0)) then begin
             fufu=strmid(fl[i] ,ln,35)
             if NW lt 0 then valb=valb+fufu+' '
             if NW lt 0 then widget_control,bloab,bad_id=ii,set_value=valb
             P_RESTORE,fufu ,rflg
             if rflg gt 0 then print,fufu +' loaded ...'
          endif
         endfor
      if NW lt 0 then widget_control,bload,bad_id=ii,/destroy
    endif
    CD,mee

;   RUN SPECIFIC STARTUP.
;   --------------------
    P_DO_THAT
;   NO WINDOW OPTION.
;   ----------------
    if NW ge 0 then begin
       SET_PLOT,'NULL' & LAMP,'just' & LAMP_B
       endif     else    LAMP
    return
    end
    
PRO MAIN
;+
;** ****
;** first call in embedded version
;-
    RUNTIME
    return
    end
    
; END GET OUT FROM LAMPRT.pro
; ***************************

;** ****
pro LAMP ,just ,NW=nw ,GEO=geo ,SMALL=small ,MEDIUM=medium ,LARGE=large ,WIDE=wide ,GEOLAMP=geolamp ,LAMPGEO=lampgeo ,ONLY=lamp ,FULL=full, MINI=mini
;+
;** ****
;** command to start lamp is lamp.
;** /NW for terminal mode
;** /SMALL /MEDIUM /LARGE /WIDE to force lamp size
;** /FULL to get the original GUI
;-
@lamp.cbk
    !quiet=1
    if n_elements(just)     eq 0 then just=''
    if (sys_dep('VERSION') ge 5.4) and (not keyword_set(mini)) and (just ne 'just') then begin
     if sys_dep('EMBEDDED') eq 0 then begin &  rout=['']
        cd,current=me_ee
        catch,stat & if stat eq 0 then begin
          rout=CALL_FUNCTION('routine_info',/functions) & dx=where(rout eq 'RLAMP')
          if dx[0] lt 0 then begin
             lamd_dir=sys_dep('GETENV','LAMP_DIR')
             if lamd_dir gt ' ' then cd,lamd_dir
             chk_kernel, cnt,wnt, /fromlamp ; Ensure we get an up-to-date (re-compiled) "lamp.sav" file to restore.
             if (wnt gt 0) then restore, 'lamp.sav'
          endif
        endif else begin & GEORGE=0 & print,!error_state.msg
          if strpos(!error_state.msg,'RESTORE:') ge 0 then begin
             print,'Warning: Lamp should be re-compiled !!! (see AA_README.txt)' & return
          endif
        endelse
        catch,/cancel
        cd,me_ee
     endif
     fileChut = sys_dep('GETENV','LAMP_DIR') + sys_dep('DIVIDER') + '.chut.upd' ; live-update stuff
     if file_test(fileChut) then begin & on_ioerror, mischutD  & openr,u,fileChut,/get_lun,/delete & free_lun,u & mischutD: & endif
    endif    else  GEORGE=0
    
    if sys_dep('MATLAB')         then GEORGE  =0
    if n_elements( GEORGE)  eq 0 then GEORGE  =2
    if keyword_set(LAMP)         then GEORGE  =0
    if keyword_set(GEO)          then GEORGE  =1
    if keyword_set(LAMPGEO)      then GEORGE  =2
    if keyword_set(GEOLAMP)      then GEORGE  =2
    if keyword_set(FULL)         then GEORGE  =3
    if  sys_dep('STUDENT')       then lamp_ziz=600
    if keyword_set(SMALL)        then lamp_ziz=480
    if keyword_set(MEDIUM)       then lamp_ziz=600
    if keyword_set(LARGE)        then lamp_ziz=800
    if keyword_set(WIDE)         then lamp_ziz=1024
    if (!D.flags and 65536) eq 0 then if (!D.Name ne 'Z') then set_plot,'NULL'
    if keyword_set(NW)           then LAMP_,   'just'
    if keyword_set(NW)           then LAMP_B  $
    else begin & lm_tool=getenv('FULLPROF')     & ok=0
         if (lm_tool gt ' ') and (xregistered('Magnet_win') eq 0) then begin
              fifi=lm_tool+sys_dep('DIVIDER')+'magdraw.atm' & fil= finefile(fifi)
              if (sys_dep('VERSION') ge 5.4) then $
              if fil[0] gt ' ' then begin & u=0 & on_ioerror,misFP & openr,u,fifi,/get_lun & str=fstat(u) & free_lun,u
                 if (systime(1)-str.ctime)/60. lt 5. then begin &   ok=1
                     LAMP_,'just'  & b_labins[3]=1 & P_DON_INIT_VAR & P_DID_SETVAR
                     P_DATA_IDOL   & RDFILTER      & GEORGEO,/nowin
                     magdraw,fifi,timer=str.ctime,/plot     ;should not return
                 endif
                 misFP:
              endif
         endif
         if not ok then LAMP_,just
    endelse
    return
    end
