
;...             ;** Miscelaneous functions

;STR_GETPARAMS   ;** Read params from GUI User_model
;STR_GET_MODEL   ;** Get model from disk
;STR_WRITE_MODEL ;** Write model to disk
;STR_FIT_EVENT   ;** Event handler
;STR_FIT_PLOT    ;** Plotting routine
;STR_BKG_SPEC    ;** Get background     for one spectrum
;STR_SUB_FUNC    ;** Get a sub function for one spectrum
;STR_OUT_PAR     ;** Results output    (in workspace or file)

;STR_FIT_WIN     ;** GUI constructor STR_FIT
;STR_USER_DEFINED;** GUI constructor USER_MODEL
;STR_SLIDER_PARAM;** Make a sliders base for model parameters

;COOL2MP        ;** Interface Coolfit to MPfit,TNMIN,RMD_GA
;COOLFIT        ;** Default FIT ENGINE
;MP2COOL        ;** Interface MPfit to Coolfit

;...            ;** Miscelaneous functions DI_*

;DI_INST_DRESO  ;** INSTRUMENT RESOLUTION, POLY_DISPERSITY
;STR_GUMBEL     ;** GUMBEL model
;STR_EXP        ;** STRETCHED EXPONENCIAL model
;STR_ISOROT     ;** ISO_ROTATION model
;STR_UNIROT     ;** UNI_ROTATION model
;STR_RWTRANS    ;** RW_TRANS
;STR_GAUSS      ;** GAUSS model
;STR_LORENTZ    ;** LORENTZ model
;STR_PSEUDO     ;** PSEUDO-VOIGT model
;STR_EXEC_UMODL ;** EXECUTE the UserModel string
;STR_USERMODL   ;** USER MODEL & FORMULA
;STR_INTEGRAL   ;** Data & Fit integral calculation
;STR_BOSE       ;** Detailed Balance factor

;STR_FIT        ;** USER ENTRY CALL 

function str_gettext ,wid,numb
;+
;******* ***********
;** get a text field float value in numb. return 1 if success
;-

on_ioerror,misnumb & numb=0. & widget_control,wid,get_value=txt & numb=float(txt[0]) & return,1
misnumb: return,0
end

pro str_getparams,btxt, vp,bb,qq,qqinf,qqsup ,pname
;+
;** *************
;** analyse syntax of an input text field parameters
;** dispatch the componantes
;-

widget_control,btxt,get_value=val & val=strcompress(val[0],/remove_all)
c=';'
cp1=strpos(val,c) & pname=''
if cp1 ge 0 then  begin & cp2= strpos(/reverse_search,val,c)
   if cp2 eq cp1  then  cp2=strlen( val)
   if cp2 gt cp1  then begin & pname=strmid(val,cp1+1,cp2-cp1-1)
      if cp1 gt 0 then  val=strmid(val,0,cp1)+strmid(val,cp2+1,120) $
                  else  val=strmid(val,cp2+1,120)
   endif else val=''
endif
cp1=strpos(val,':') ;NORMAL PARAMETER LABELLING
if cp1 gt 0 then  begin & pname=strmid(val,0,cp1) & val=strmid(val,cp1+1,120) & endif

sup=strpos(val,'>') & les=strpos(val,'<')

vv =['','',''] ;vv(0)=  param value  vv(1)=  sup value  vv(2)=  inf value
bb =[0 ,0 ,0 ] ;bb(0)=1 param set    bb(1)=1 sup set    bb(2)=1 inf set
vp =[0.,0.,0.] ;vp(0)   param float
qq ='' & qqinf='' & qqsup=''

if  val gt ' ' then begin & val=strlowcase(val)
;split input  ---> val0 > val1 < val2
if  sup ge 0 then if les lt sup   then begin ;**SUP**
                        vv[1]=strmid(val,sup+1,50)         & bb[1]=1 & endif else $
                  if les gt sup+1 then begin
                        vv[1]=strmid(val,sup+1,les-sup-1)  & bb[1]=1 & endif
if  les ge 0 then if sup lt les   then begin ;**INF**
                        vv[2]=strmid(val,les+1,50)         & bb[2]=1 & endif else $
                  if sup gt les+1 then begin
                        vv[2]=strmid(val,les+1,sup-les-1)  & bb[2]=1 & endif
if (sup*les) eq 0            then begin                              & endif else $
if (sup gt 0) and (les gt 0) then begin      ;**VAL**
                        vv[0]=strmid(val,0,min([les,sup])) & bb[0]=1 & endif else $
if  sup gt 0 then begin & vv[0]=strmid(val,0,sup)            & bb[0]=1 & endif else $
if  les gt 0 then begin & vv[0]=strmid(val,0,les)            & bb[0]=1 & endif else $
                  begin & vv[0]=val                          & bb[0]=1 & endelse
;VAL numerical or expression   --->
if bb[0] then if strpos(vv[0],'(q' ) ge 0 then qq=vv[0] $
         else if strpos(vv[0],'(p' ) ge 0 then qq=vv[0] $
         else if strpos(vv[0],'['  ) ge 0 then qq=vv[0] $
         else begin & on_ioerror,mis0 & bb[0]=0 & vp[0]=float(vv[0]) & bb[0]=1 & mis0: & endelse
if bb[0] then if strpos(vv[0],'['  ) ge 0 then if strpos(vv[0],'(q' ) lt 0 then if strpos(vv[0],'q' ) ge 0 then bb[0]=0 ;should be creasy

;SUP numerical or expression   --->
if bb[1] then begin & bb[1]=0
                    if strpos(vv[1],'(p' ) ge 0 then begin & qqsup=vv[1] & endif $
                    else begin & on_ioerror,mis1 & vp[1]=float(vv[1])    & bb[1]=1 & mis1: & endelse & endif
;SUP numerical or expression   --->
if bb[2] then begin & bb[2]=0
                    if strpos(vv[2],'(p' ) ge 0 then begin & qqinf=vv[2] & endif $
                    else begin & on_ioerror,mis2 & vp[2]=float(vv[2])    & bb[2]=1 & mis2: & endelse & endif
;default vp(0)--->
if not bb[0]  then if total(bb) eq 2  then begin & vp[0]=(vp[1]+vp[2])/2. & bb[0]=1    & endif $
                   else  if bb[1]     then begin & vp[0]= vp[1]           & bb[0]=1    & endif $
                   else  if bb[2]     then begin & vp[0]= vp[2]           & bb[0]=1    & endif
;Creasy   --->
if bb[0] and (qq eq '') then if bb[1] then if vp[1] gt vp[0] then bb[0]=0
if bb[0] and (qq eq '') then if bb[2] then if vp[2] lt vp[0] then bb[0]=0

endif
end

function s4v, str, min=minfrac
;+
;******* ***
;** change an array of numbers to a cleaned string
;** if array, return '[ 1.0 , 2e-1 , 5]' else return '1.0'
;-

vec=strtrim(str,2) & nv=n_elements(vec)
for i=0,nv-1 do begin & Pp=strpos(vec[i],'.')
    Ep=strpos(strupcase(vec[i]),'E')>0
    if Ep gt 0 then begin & Es=strmid(vec[i],Ep,Ep+5)     ;Keep 'E-20' in Es
                          Ep=strlen(vec[i])-Ep
                          endif else Es=''
    ok=Pp
    while ok ge 0 do begin & L=strlen(vec[i])-Ep          ;Suppress tailing zeros after '.'
          if L gt 1   then Z=strmid(vec[i],L-1,1) else Z=''
          if Z eq '0' then vec[i]=strmid(vec[i],0,L-1)+Es else ok=-1
    endwhile
    if (keyword_set(minfrac)) and (Pp ge 0) and (Es eq '') then begin ;Limit fractional numbers
      Pp0=Pp+1
      while  strmid(vec[i],Pp0,1) eq '0' do Pp0=Pp0+1
      dig3  =strmid(vec[i],Pp0,3)
      if  strlen(dig3) eq 3 then  dig3=strtrim(round(dig3/10.),2) ;Round on 2 digits ?
      if  strlen(dig3) eq 3 then  dig3=strmid(vec[i],Pp0,2)       ;finally not
      vec[i]=strmid(vec[i],0,Pp0)+dig3
    endif
endfor
if nv gt 1 then begin & tb='['  +vec[0]                   ;Make an input vector
   for i=1,nv-1 do tb=tb+' , '+vec[i] & tb=tb+']'
endif else tb=vec
return,tb
end

pro str_IO_session, fifi, save=save, restore=restore
;+
;** **************
;** save/restore commons associated with current model
;-
common strfit_out , data,par,sout,dcfit, User_Modl
common strfit_outC, Cfunc, bid_other
common strfit_col , bcol, col, mcol, scol, tcol
forward_function finefile

idx  = strpos(fifi,'.pro')
if idx eq -1 then fofo = fifi+'.sav'    else fofo = strmid(fifi,0,idx)+'.sav'
if n_tags(bid_other) eq 0 then gui = 0  else gui  = 1

if keyword_set(save)    then save, file=fofo, /variables, /compress

if keyword_set(restore) then begin
   bid = finefile(fofo,count=nn)
   if nn eq 1 then begin
      if (gui) then KPbid_other = bid_other            ; Keep widget identifiers
      n  = n_elements(data)                            ; Restore only if data is matching.
      save,    file='tmp_'+fofo, /variables, /compress ; in case data in not matching
      ok = 1
      restore, file=fofo       ; RESTORING ***
     ;Check if restore is ok
      if (n gt 1) and (n_elements(data) ne n) then ok = 0
      if (n_elements(data) le 1) then ok = 0
      if not ok then restore, file='tmp_'+fofo

      openr,u, 'tmp_'+fofo, /get_lun, /delete & free_lun,u
      if (gui) then begin
        Chi2      = bid_other.Chi2
        bid_other = KPbid_other     ; Restore widget identifiers
        if (ok) then begin          ; Show results restored with this model
            bid_other.Chi2 = Chi2
            bid_other.Restoring = 1
            ii=execute('str_fit_event,{WIDGET_BUTTON ,ID:bid_other.Minit    ,TOP:bid_other.bas0,HANDLER:0L,SELECT:1}')
            bid_other.Restoring = 0
        endif
      endif
   endif
endif
end

pro str_get_model,fifi,UserModl,ii
;+
;** *************
;** read a model file in UserModl structure variable
;-

         if strpos(fifi,'model') lt 0 then fifi='model_'+fifi
         fofo=fifi
         ext=strpos( fifi,'.pro') & if ext gt 0 then fifi=strmid(fifi,0,ext) else fofo=fofo+'.pro'
         if (not sys_dep("EMBEDDED")) and (not sys_dep("RUNTIME")) then begin
             ii =execute('RESOLVE_ROUTINE,fifi') & ii =execute(fifi+',UserModl')
         endif else begin
             on_ioerror,misfofo & u=-1 & line='' & ii=0
             openr,u,fofo,/get_lun
             while (not eof(u)) do begin & readf,u,line & if strpos(line,'(procedure)') eq -1 then ii=execute(line) & endwhile
             misfofo: if u gt 0 then free_lun,u else lamp_error
         endelse
         if ii eq 1 then str_IO_session, fofo, /restore
end

pro str_write_model,fifi,User_Modl,ok
;+
;** ***************
;** write a model structure in a file 
;-
ok  =0 & file=fifi & name=fifi
ext =strpos(fifi,'.pro') & if ext gt 0 then name=strmid(name,0,ext) else file=file+'.pro'
nfunc=fix(n_elements(User_Modl.ON)) & npar=max(User_Modl.NPAR)
on_ioerror,misfifi & u=-1
openw,u,file,/get_lun

  printf,u,'pro '+name+' , UserModl     ;Start (procedure)'
  printf,u,';** ******'
  printf,u,';**'
  printf,u,'UserModl=0 ;return "UserModl" as a structure' & printf,u,''
  printf,u,'nfunc=',nfunc,' ;number of functions'
  printf,u,'npar =',npar ,' ;maximum number of parameters'
  printf,u,'umON =intarr(nfunc) & umNPAR=umON & umNAME=strarr(nfunc) & umFORMULA=umNAME'
  printf,u,'umPARAMS=fltarr(npar,nfunc) & umFIXP=intarr(npar,nfunc)  & umQEXP=strarr(npar,nfunc)'
  printf,u,'umBOUNDa=umFIXP & umBOUNDb=umFIXP & umLIMITa=umPARAMS    & umLIMITb=umPARAMS'
  printf,u,'umFIXP[*]=1     & umQINF  =umQEXP & umQSUP  =umQEXP      & umPNAMES=umQEXP'
  printf,u,';Functions:'
  printf,u,';**********'

  for i=0,nfunc-1 do begin & is =s4v(i)   & np=User_Modl.NPAR[i]-1
      printf,u,' umNAME[     '+is+']='''+User_Modl.NAME[i]+''' & umON['+is+']='+s4v(User_Modl.ON[i]) $
                                                          +' & umNPAR['+is+']='+s4v(User_Modl.NPAR[i])
      if User_Modl.FORMULA[i] gt ' ' then $
      printf,u,' umFORMULA[  '+is+']='''  + User_Modl.FORMULA[i]+''''
      printf,u,' umFIXP[   0,'+is+']=' +s4v(User_Modl.FITP[  0:np,i])
      printf,u,' umPARAMS[ 0,'+is+']=' +s4v(User_Modl.PARAMS[0:np,i])

      for e=0,np do if User_Modl.PNAMES[e,i] gt ' ' then begin & s=s4v(e)
      printf,u,' umPNAMES[ '+s+','+is+']='''+    User_Modl.PNAMES[ e,i]+'''' & endif
      for e=0,np do if User_Modl.QEXP[  e,i] gt ' ' then begin & s=s4v(e)
      printf,u,' umQEXP[   '+s+','+is+']='''+    User_Modl.QEXP[   e,i]+'''' & endif
      for e=0,np do if User_Modl.QINF[  e,i] gt ' ' then begin & s=s4v(e)
      printf,u,' umQINF[   '+s+','+is+']='''+    User_Modl.QINF[   e,i]+'''' & endif
      for e=0,np do if User_Modl.QSUP[  e,i] gt ' ' then begin & s=s4v(e)
      printf,u,' umQSUP[   '+s+','+is+']='''+    User_Modl.QSUP[   e,i]+'''' & endif

      printf,u,' umBOUNDa[ 0,'+is+']=' +s4v(User_Modl.BOUNDA[ 0:np,i])
      printf,u,' umBOUNDb[ 0,'+is+']=' +s4v(User_Modl.BOUNDB[ 0:np,i])
      printf,u,' umLIMITa[ 0,'+is+']=' +s4v(User_Modl.LIMITA[ 0:np,i])
      printf,u,' umLIMITb[ 0,'+is+']=' +s4v(User_Modl.LIMITB[ 0:np,i])
      printf,u,';**********'
  endfor
  printf,u,''
  printf,u,'Resolution='+s4v(User_Modl.Resolution)+'      ;0=none 1=Wrkspace 2=Gauss 3=Voigt 4=Spectrum'
  printf,u,'Bose      ='+s4v(User_Modl.Bose      )+ '     ;if >0 -> activate detailed balance factor'
  printf,u,'Follow    ='+s4v(User_Modl.Follow    )+'      ;2;3;-3->2d_fit 0;1;-1->1d_fit (initial params for all; use previous fit go 1>N; go N>1)'
  printf,u,'BkgdMod   ='+s4v(User_Modl.BKGDmod   )+'      ;0=flat 1=linear 2=quadratic 3=none'
  printf,u,'BkgdFix   ='+s4v(User_Modl.BKGDfix   )+'      ;0=unfixed flat background 1=fixed'
  printf,u,'BkgdValue ='+s4v(User_Modl.BKGDvalue )+ '     ;used if flat background is fixed'
  printf,u,''
  printf,u,';Do not wrap next 3 lines'
  printf,u,'u1=umON & u2=umNAME & u3=umNPAR & u4=umPARAMS & u5=umFIXP & u6=umBOUNDa & u7=umBOUNDb & u8=umLIMITa & u9=umLIMITb'
  printf,u,'v1=umFORMULA & v2=umQEXP & v3=Bose & v4=FOLLOW & v5=Resolution & v6=BkgdMod & v7=BkgdFix & v8=BkgdValue & v9=umQINF & v10=umQSUP & v11=umPNAMES'
  printf,u,'UserModl={ON:u1,NAME:u2,NPAR:u3,PARAMS:u4,FITP:u5,BOUNDA:u6,BOUNDB:u7,LIMITA:u8,LIMITB:u9,FORMULA:v1,QEXP:v2,BOSE:v3,FOLLOW:v4,RESOLUTION:v5,BKGDmod:v6,BKGDfix:v7,BKGDvalue:v8,QINF:v9,QSUP:v10,PNAMES:v11}'
  printf,u,''
  printf,u,'end ;(procedure)'

ok=1
str_IO_session,fifi, /save

misfifi:if u gt 0 then free_lun,u
if not ok then lamp_error ;print,!error_state.msg
end

pro str_mod_struct, struc, TAG, val
;+
;** **************
;** modify a model structure
;-
      sv=n_elements(val)
      sz=0L & ii=execute('sz=n_elements(struc.'+TAG+')')
      if sz ne sv then begin &    TAG = strupcase(TAG)
         elsa = '' & tlist=tag_names(struc) & vg=''
         for k=0,n_elements(tlist)-1 do begin
          CASE tlist[k] of
           TAG:       elsa =elsa+vg+tlist[k]+':val'
           ELSE:      elsa =elsa+vg+tlist[k]+':struc.'+tlist[k]
          ENDCASE
          vg=','
         endfor
                 ii=execute('struc={'+elsa+'}')
      endif else ii=execute('struc.'+tag+'=val')
end

pro str_fit_event,ev
;+
;** *************
;**
;** Event handler of str_fit
;-
@lamp.cbk
common strfit_out , data,par,sout,dcfit, User_Modl
common strfit_outC, Cfunc, bid_other

CATCH,stat & if stat ne 0 then begin & print,!error_state.msg & return & endif

widget_control,ev.id ,get_uvalue=uv & if n_elements(uv) eq 0 then return

top=ev.top
if n_tags(uv) eq 0 then begin
  IF (TAG_NAMES(ev, /STRUCTURE_NAME) EQ 'WIDGET_TRACKING') THEN BEGIN ;Comming from USER MODEL input parameters
    widget_control,ev.top ,get_uvalue=uvUM
    widget_control,uvUM[2],get_uvalue=messUM
    if ev.ENTER eq 0 then                   widget_control,messUM[0],set_value=' '
    if ev.ENTER eq 1 then if uv gt ' ' then widget_control,messUM[0],set_value=uv
    ;return
  ENDIF else $
  if (uv[0] eq 36) or ((uv[0] ge 40) and (uv[0] le 49)) then begin & top=uv[2] ;USER MODEL leader is in uv(2)
    if (uv[0] eq 42) and uv[1] le 0 then uv[0]=8        ;Fit this model (user own model)
  endif
endif

widget_control,top,get_uvalue=uvg & if n_tags(uvg) eq 0 then return

IF (TAG_NAMES(ev, /STRUCTURE_NAME) EQ 'WIDGET_BASE') THEN BEGIN ;Resizing

    gm0=widget_info(  top  ,/geometry) & b0x=gm0.scr_xsize & b0y=gm0.scr_ysize
   ;redim={ori_win1:[dxs,dys], ori_win0:[drawx0,drawy0], ori_wins:[drawxs,drawys],$
          ;cur_win1:[dxs,dys], cur_win0:[drawx0,drawy0], cur_wins:[drawxs,drawys],$
          ;ori_bas0:[b0x,b0y], cur_bas0:[b0x,b0y],$
          ;TabDoff: TabDoff}
   ;winb =[win1,win21,win22,win23,win1,win0] ;[curDraw,snap1,snap2,,snap3,smallDraw,largeDraw]
   ;junk =[bhelp, scrollSnap, Constraint, leftBase, largeDraw, Results, Psliders]
   ;return
    offx=b0x-uvg.redim.cur_bas0[0]
    offy=b0y-uvg.redim.cur_bas0[1]
    if (abs(offx) gt 30) or (abs(offy) gt 30)  then begin
       ;Resize Ysize sixty/forty leftBase/bottomBase
        offyBt=offy*40/100
        offy  =offy*60/100
        newXw1=fix((uvg.redim.cur_win1[0]+offx)>uvg.redim.ori_win1[0])
        newYw1=fix((uvg.redim.cur_win1[1]+offy)>uvg.redim.ori_win1[1])
        if (newXw1 ne uvg.redim.cur_win1[0]) or (newYw1 ne uvg.redim.cur_win1[1]) then begin ;RESIZE win1,win0,Snaps,Results,Psliders
            widget_control,top, UPDATE=0
            newXw0=fix((uvg.redim.cur_win0[0]+offx)   >uvg.redim.ori_win0[0])
            newYw0=fix((uvg.redim.cur_win0[1]+offy)   >uvg.redim.ori_win0[1])
            newXws=fix((uvg.redim.cur_wins[0]+offx/3) >uvg.redim.ori_wins[0])
            newYws=fix((uvg.redim.cur_wins[1]+offyBt) >uvg.redim.ori_wins[1])
            
            newTabDonOFF=uvg.redim.TabDoff + fix(newYw1 - uvg.redim.ori_win1[1])>0
            if uvg.Bempty gt 0 then widget_control,uvg.Bempty,YSIZE=newTabDonOFF  ;REPOSITIONING THE DOWN TABS
            
            widget_control,uvg.winb[4] ,XSIZE=newXw1, YSIZE=newYw1  ;LEFT DRAW PLOT WINDOW
            widget_control,uvg.winb[5] ,XSIZE=newXw0, YSIZE=newYw0  ;FULL DRAW PLOT WINDOW
            widget_control,uvg.winb[1] ,XSIZE=newXws, YSIZE=newYws  ;SCROLL SNAP1
            widget_control,uvg.winb[2] ,XSIZE=newXws, YSIZE=newYws  ;SCROLL SNAP1
            widget_control,uvg.winb[3] ,XSIZE=newXws, YSIZE=newYws  ;SCROLL SNAP1
            widget_control,uvg.Junk[5] ,get_uvalue=btexts
            widget_control,btexts      ,SCR_XSIZE=newXws*3, SCR_YSIZE=newYws ;PARAM RESULTS
            widget_control,uvg.Junk[6] ,SCR_XSIZE=newXws*3, SCR_YSIZE=newYws ;PARAM SLIDERS
            uvg.redim.cur_win1   =[newXw1,newYw1]
            uvg.redim.cur_win0   =[newXw0,newYw0]
            uvg.redim.cur_wins   =[newXws,newYws]
            gm0=widget_info(  top  ,/geometry) & b0x=gm0.scr_xsize & b0y=gm0.scr_ysize
            uvg.redim.cur_bas0   =[b0x   ,b0y   ]
            widget_control,top, set_uvalue=uvg
            widget_control,top, UPDATE=1
            str_fit_plot, 'scroll', uvg ;redraw
        endif
    endif
    return
ENDIF

messg=' '
ws=s4v(uvg.Iwks)
if (uv[0] ne 22) and (uv[0] ne 23)   then begin ; and (uv(0) ne 6) and (uv(0) ne 24) and (uv(0) ne 26)
    uvg.YMax=0. & uvg.Xtmp=[0.,0.] & endif ;6=Weighting 22=Spectra_slider 23=Mouse 24=Residue 26=Func_slider

case uv[0] of

-1:begin & widget_control,uvg.Junk[uvg.toggln], map=0
         case ev.TAB of                         ;TABS BOTTOM FRAME
         0: uvg.toggln=1                        ;Scroll Spectra
         1: if uvg.Func eq 6 then uvg.toggln=6  ;Parameter boundaries
         2: uvg.toggln=5                        ;Parameter results
         3: if uvg.Func ne 6 then uvg.toggln=2  ;Contraints
         else:
         endcase
         widget_control,uvg.Junk[uvg.toggln], map=1
   end
0: begin & if uv[1] eq 1 then begin & widget_control,uvg.Junk[5], get_uvalue=btexts          ;P.result or Help
                                  widget_control,btexts, get_value=texts & endif
         if n_elements(texts) le 1 then begin ;Help
            if uvg.Toggln ne 0 then begin & map0=uvg.Junk[uvg.Toggln] & uvg.Toggln=0
               widget_control,map0  ,map=0 & widget_control,uvg.Junk[uvg.Toggln],map=1
              if uvg.TabDon gt 0 then widget_control,uvg.TabDon,set_tab_current=3
            endif
         endif else begin & map0=uvg.Junk[uvg.Toggln] & uvg.Toggln=5
               widget_control,map0  ,map=0 & widget_control,uvg.Junk[uvg.Toggln],map=1
               if uvg.TabDon gt 0 then widget_control,uvg.TabDon,set_tab_current=2
         endelse & end
1: begin & ws=s4v(uv[2]) & widget_control,uv[1],set_value='W'+ws                              ;Input data workspace
         sz=[0,0,0] & ii=execute('sz=(size(w'+ws+'))[0:2]')
         if sz[0] eq 1 then sz=[1,sz[1],1] else if sz[0] eq 2 then sz=[2,sz[1],sz[2]] else sz=[0,0,0] ;!!!
         if sz[2] gt 1 then sens=1 else sens=0
         widget_control,uvg.Srgb1,sensitive=sens & widget_control,uvg.Srgb2,sensitive=sens
         uvg.Isiz=sz
         if sz[1] gt 1 then begin & uvg.Iwks=uv[2] & par=0 & data=0 & dcfit=0 & sout=0

            widget_control,uv[1] ,get_uvalue=BsensB
            for i=0,n_elements(BsensB)-1 do widget_control,BsensB[i] ,sens=1

            slmax=sz[2] & uvg.Vslid=uvg.Vslid>1<slmax    & uvg.Vslidp=0
            if slmax eq 1 then slmin=0 else slmin=1
            widget_control,uvg.Slid[ 0],set_slider_min=slmin,set_slider_max=slmax,set_value=uvg.Vslid  ;Spectrum
            widget_control,uvg.Slid[ 1],set_slider_min=slmin,set_slider_max=slmax,set_value=uvg.Vslid
            widget_control,uvg.Slidp[0],set_slider_min=0    ,set_slider_max=1    ,set_value=uvg.Vslidp ;Fun
            widget_control,uvg.Ttl  ,set_value=w_tit[uvg.Iwks]
            
           ;Fit range
            widget_control,uvg.Xrgb1,get_value=xr1 & j=strpos(strlowcase(xr1[0]),'in') ;Min
            widget_control,uvg.Xrgb2,get_value=xr2 & k=strpos(strlowcase(xr2[0]),'ax') ;Max
            l=strpos(strlowcase(xr1[0]),'w')       & m=strpos(strlowcase(xr2[0]),'w' ) ;Workspace
            win1=0 & win2=0 & w=0
            if  l ge 0 then begin & ii=execute('win1='+xr1[0]) ;accept win1 or not ?
                if ((size(win1))[0] ne 1) or ((size(win1))[1] ne uvg.Isiz[1]) then begin & l=-1 & j=1 & endif & endif
            if  m ge 0 then begin & ii=execute('win2='+xr2[0]) ;accept win2 or not ?
                if ((size(win2))[0] ne 1) or ((size(win2))[1] ne uvg.Isiz[1]) then begin & m=-1 & k=1 & endif & endif
            if (l ge 0) and (m gt 0) then str_mod_struct,uvg,'xrang',transpose([[win1],[win2]]) else $
            if  l ge 0 then               str_mod_struct,uvg,'xrang',transpose([[win1],[win1]]) else $
            if  m ge 0 then               str_mod_struct,uvg,'xrang',transpose([[win2],[win2]]) $
                       else if n_elements(uvg.xrang) ne 2 then str_mod_struct,uvg,'xrang',[0.,0.]
            if  j ge 0 then ii=execute('uvg.xrang[0,*]=min(X'+ws+')') else $
            if  l lt 0 then ii=execute('uvg.xrang[0,*]=float(xr1[0])')
            if  k ge 0 then ii=execute('uvg.xrang[1,*]=max(X'+ws+')') else $
            if  m lt 0 then ii=execute('uvg.xrang[1,*]=float(xr2[0])')

           ;Spectra range
            widget_control,uvg.Prgb1,get_value=pr1 & j=strpos(strlowcase(pr1[0]),'in')
            widget_control,uvg.Prgb2,get_value=pr2 & k=strpos(strlowcase(pr2[0]),'ax')
            if  j ge 0 then ii=execute('uvg.prang[0]=min(X'+ws+')') else ii=execute('uvg.prang[0]=float(pr1[0])')
            if  k ge 0 then ii=execute('uvg.prang[1]=max(X'+ws+')') else ii=execute('uvg.prang[1]=float(pr2[0])')

            uvg.srang=[1L,uvg.Isiz[2]]
            str_fit_plot,'erase' ,uvg
            str_fit_plot,'plot'  ,uvg & str_fit_plot,'scroll',uvg
         endif & end
2: begin & if uv[2] eq -1 then w='File' else widget_control,ev.id,get_value=w
         widget_control,uv[1],set_value=w                                    ;Output parameters  workspace
         uvg.Pwks=uv[2] & str_out_par,uvg ,'par' & end
3: begin & if uv[2] eq -1 then w='File' else widget_control,ev.id,get_value=w
         widget_control,uv[1],set_value=w                                    ;Output fitted data workspace
         uvg.Fwks=uv[2] & str_out_par,uvg ,'fit' & end
4: begin & uf=ev.id & widget_control,uv[2],get_uvalue=uv2val                   ;User Choose a Function
                    if uv[1] eq 40 then begin & res='0.' & uf=uv[4] & uv[1]=1  ;Here for a PVfactor
                          if str_gettext(ev.id,pvf) then begin & pvf=pvf>0.<1.
                             res=s4v(pvf) & uf=uv[3] & uv[1]=4 & endif
                          uvg.PVf=float(res)
                          if uvg.PVf eq 0. then uf=uv[4] else if uvg.PVf eq 1. then uf=uv[5]
                          if uvg.PVf eq 0. then uv[1]=1  else if uvg.PVf eq 1. then uv[1]=2
                    endif
                    if uv[1] eq 4 then mapy=1 else mapy=0 & widget_control,uv2val[1],map=mapy ;map PVf
                    toto=uvg.Toggln
                    if uv[1] eq 6 then begin & if xregistered('str_user_def') eq 0 then begin
                                             str_user_defined,top,lamp_b1 & toto=0 & uvg.follow=0 & endif
                    endif
                    if uvg.Toggln ne toto then begin & map0=uvg.Junk[uvg.Toggln] & uvg.Toggln=toto
                       widget_control,map0  ,map=0 & widget_control,uvg.Junk[uvg.Toggln],map=1
                       if uvg.TabDon gt 0 then widget_control,uvg.TabDon,set_tab_current=3
                    endif
         psens=1
         uvg.Func=uv[1] & widget_control,uf   ,get_value=b & widget_control,uv[2],set_value=b
         if uv[1] eq 6 then psens=0
         widget_control,uv2val[0],sens=psens
         end
5: begin & uvg.Bgrd=uv[1] & widget_control,ev.id,get_value=b & widget_control,uv[2],set_value=b  ;Background
         end
6: begin & uvg.Wght=ev.select & str_fit_plot,'scroll',uvg                                         ;Weighting
         end
7: begin & if uv[1] eq 0 then uvg.Xrg=ev.select                                  ;Fit  X range
         if uv[1] eq 1 then uvg.Prg=ev.select                                  ;Plot X range
         if uv[1] eq 2 then uvg.Yrg=ev.select                                  ;Plot Y max
         str_fit_plot,'plot'  ,uvg    & str_fit_plot,'scroll',uvg & end
;FIT NOW
;*******
8: if uvg.Iwks  gt 0 then begin ;uv(1)=1 classical funct, 0 User model, -1 see only, -2 sliders param
         if (uv[1] eq 1) and (uvg.Func eq 6) then begin & widget_control,ev.id,sens=0
                              widget_control,uv[2],bad_id=ii,set_value='.......Choice.......'
                              widget_control,uvg.mess       ,set_value='? Using a User model'
                              return & endif
         if (uv[1] eq 1) and (uvg.Ftech eq 4) then begin
                              widget_control,uvg.mess       ,set_value='?Genetic:Use a model'
                              return & endif
         okfit=1 & cmdxrange='' & if n_elements(User_Modl) gt 0 then KP_UM=User_Modl & User_Modl=0
                                                                                           ;Keyword Xrange
         if uvg.Xrg and (uvg.xrang[0] lt uvg.xrang[1]) then begin & Dim2_N_Wi=    uvg.xrang
                    if n_elements(uvg.xrang) eq 2 then cmdxrange=',Xrange='+s4v(uvg.xrang) $
                                                  else cmdxrange=',Xrange=Dim2_N_Wi' & endif
         srg=[1L,uvg.Isiz[2]] & cmdsrange=''                                            ;Get Spectra range
         if uvg.Srg then begin
                    widget_control,uvg.Srgb1,get_value=sr1 & j=strpos(strlowcase(sr1[0]),'f')
                    widget_control,uvg.Srgb2,get_value=sr2 & k=strpos(strlowcase(sr2[0]),'l')
                    if (j lt 0) or (k lt 0) then begin &  on_ioerror,misrgs
                        if j lt 0 then srg[0]=float(sr1[0])>1<uvg.Isiz[2]
                        if k lt 0 then srg[1]=float(sr2[0])>1<uvg.Isiz[2]
                        if (srg[0] ne 1) or (srg[1] ne uvg.Isiz[2]) then cmdsrange=',Srange='+s4v(srg)
                        misrgs:
                    endif
         endif
         
         uvg.srang=srg  &  kp_Srang=srg
         
        ;USER_MODEL ASKS TO FIT ONLY THE SELECTED SPECTRUM
         if uv[1] eq 0 then if uv[5] eq -1 then begin & srg=[uvg.Vslid,uvg.Vslid]
                                                      cmdsrange=',Srange='+s4v(srg) & endif

         ;SHOW initial functions only or use slider parameters?
         ;****************************************************
         itmax=100
         if uv[1] lt  0 then begin & itmax=1
            if (uvg.follow eq 0) or (uvg.follow eq 2) then srg=[uvg.Vslid,uvg.Vslid] else $
            if  uvg.follow lt 0                       then srg=[srg[1]   ,srg[1]]    else srg=[srg[0],srg[0]]
            if  uvg.TabDon gt 0 then widget_control,uvg.TabDon,set_tab_current=1        
            cmdsrange=',Srange='+s4v(srg)+',itmax=1'
            uvg.srang=srg
         endif

         if uvg.Wght then  cmdnoweight='' else cmdnoweight=',/noweight'

         if uv[1] le 0 then uvg.Func=6

         case uvg.Func of 
          1:   cmdfunc=''
          2:   cmdfunc=',/lorentz'
          3:   cmdfunc=',/pseudo'
          4:   cmdfunc=',pseudo='+s4v(uvg.PVf)
          5:   cmdfunc='' ;FREE
          6:   cmdfunc=',User_model=User_modl'
         else:cmdfunc=''
         endcase
         
         if uvg.Fwks gt 0 then cmdwout=',Fout='+s4v(uvg.Fwks) else cmdwout=''
         if uvg.Bwks gt 0 then begin & cmdbgd =',num_bkgd=W'+s4v(uvg.Bwks)
             if uvg.BSfix then       cmdbgd =cmdbgd+',/num_bfix '    & endif else cmdbgd=''
         widget_control,uvg.Filn,get_value=file & file=strtrim(strcompress(file[0]),2)
         widget_control,uvg.Ttl ,get_value=titl & titl=strtrim(strcompress(titl[0]),2)

        ;if uvg.Vslidp gt 0 then begin
        ;   cmdwout=cmdwout+', out_subIndex='+s4v(uvg.Vslidp)+', out_subF=out_subF, out_Bkg=out_Bkg' & endif

        ;Constraints inputs
        ;******************
         cmdfixes=''
         strBG2='"'+(['flat','linear','quadr','none'])[uvg.Bgrd]+'"'
         
         if uv[1] le 0 then begin & widget_control,uv[4],set_value=' '       ;***User Own Model***

           cmdfunc=',User_model=User_modl'
           widget_control,uv[3],get_uvalue=uv3 & hed =3    ;[fix_bg, val_bg ,modl_nam ,row1,row2,...]
           if n_elements(uv3) gt hed then begin
            BkgdFix=0 & bkgd=0.
            if uv3[0] ne 1 then if uvg.Bgrd eq 3 then begin
               BkgdFix=1 & widget_control,uv3[1],set_value='0.0' & endif
            if uv3[0] eq 1 then begin ;background
               on_ioerror,misnumb & bkgd=0. & widget_control,uv3[1],get_value=txt & bkgd=float(txt[0])
               cmdfixes=cmdfixes+',flat='+s4v(bkgd) & BkgdFix=1 & misnumb:
            endif else begin
               on_ioerror,misinib & bkgd=0. & widget_control,uv3[1],get_value=txt & bkgd=float(txt[0])
               if bkgd ne 0. then cmdfixes=cmdfixes+',startBG='+s4v(bkgd) & misinib:
            endelse
            widget_control,uv3[1],get_uvalue=TBname
            uvF      =uv3[hed:*]
            nfunc    =n_elements(uvF) & npar=15
            umON     =intarr(nfunc) & umNPAR=umON & umNAME=strarr(nfunc) & umFORMULA=umNAME
            umPARAMS =fltarr(npar,nfunc) & umFITP=intarr(npar,nfunc)
            umQEXP   =strarr(npar,nfunc) & umQinf=umQEXP & umQsup=umQEXP & umPNAMES=umQEXP
            umBOUNDA =umFITP & umBOUNDB=umFITP  & umLIMITA=umPARAMS      & umLIMITB=umPARAMS
            umFITP[*]=1
            for i=0,nfunc-1 do begin                      ;Loop over functions
             widget_control,uvF[i],get_uvalue=uv4 & hod=3 ;[on/off,numfunc,b_on,f1,txt1,fix1, f2,txt2,fix2,...]
             umON[i]=uv4[0]  & umNAME[i]=TBname[uv4[1]]
             uvP=uv4[hod:*]  & npr=n_elements(uvp)
             umNPAR[i]=npr/3
             if umNPAR[i]*3 lt npr then begin & widget_control,uvp[npr-1],get_value=formu
                formu=          (strtrim(formu[0],2))     ;We have a formula
               ;formu=strlowcase(strtrim(formu(0),2))     ;We have a formula
               ;cmt  =strpos(formu,';') & if cmt gt 1 then formu=strmid(formu,0,cmt)
                umFORMULA[i]=formu
             endif
             npepe=umNPAR[i]-1
             for j=0,npepe  do begin                      ;Loop over parameters
               str_getparams,uvP[j*3+1], vp,bb,qq,qqinf,qqsup ,pname
               umFITP[j,i] = uvp[j*3]
               pstr=s4v(j+1)  &  idp=strpos(strlowcase(umFORMULA[i]),'p'+pstr)
               
               if bb[0] then begin                             ;***GOOD INPUT***
                  umQEXP[  j,i]=qq
                  umQINF[  j,i]=qqinf
                  umQSUP[  j,i]=qqsup
                  umPNAMES[j,i]=pname
                  umPARAMS[j,i]=vp[0] & umLIMITA[j,i]=vp[1] & umLIMITB[j,i]=vp[2]
                                        umBOUNDA[j,i]=bb[1] & umBOUNDB[j,i]=bb[2]
               endif else if umON[i] then begin                ;***BAD  INPUT***
                  if (idp ge 0) or (umFORMULA[i] le ' ') or (j eq 0)  then begin
                     widget_control,uv[4],set_value='F'+s4v(i+1)+' '+umNAME[i]+' parameter '+s4v(j+1)+' is incorrect!'
                     okfit=0
                  endif else umNPAR[i]=umNPAR[i]-1
               endif
               if (uvg.Ftech eq 4) and (umFITP[j,i] eq 0) and (idp ge 0) and $
                   umBOUNDA[j,i]*umBOUNDB[j,i] eq 0 then begin ;***GENETIC BOUNDS***
                     widget_control,uv[4],set_value='F'+s4v(i+1)+' '+umNAME[i]+' parameter'+s4v(j+1)+ $
                                                    ' GENETIC engine needs close upper & lower bounds!'
                     okfit=0
               endif
             endfor
            endfor
            
            idb=where((umNAME eq 'Bose') and (umON eq 1)) & if idb[0] ge 0 then bose=umPARAMS[0,idb[0]] else bose=0.
            if (uv[5] eq 0) then ido=where((umNAME ne 'Bose')) $
                            else ido=where((umNAME ne 'Bose')  and (umON eq 1)) ;????????? PB umON
                                ;ido=where((umNAME ne 'Bose'))                  ;Test anyway
            if ido[0] ge 0 then begin
               engine=' (engine:???)'
               if uvg.Ftech eq 1 then engine=' (engine:COOLfit)'
               if uvg.Ftech eq 2 then engine=' (engine:MPfit)'
               if uvg.Ftech eq 3 then engine=' (engine:TNMIN)'
               if uvg.Ftech eq 4 then engine=' (engine:RMD_GA)'

               if uvg.Reso   gt 0 then UseReso=' (Resolution USED)' else UseReso=''
               if uvg.Bwks   gt 0 then strBG3 =' (Bck:"shape")'     else strBG3 =' (Bck:'+strBG2+')'
               if uvg.FPDisp gt 0 then UseDisp=' (PolyDisp USED)'   else UseDisp=''

               if okfit then widget_control,uv[4],set_value= $
                            'Good input'+engine+ strBG3+ UseReso+ useDisp

               umON=umON[ido] & umNAME=umNAME[ido] & umNPAR=umNPAR[ido] & umFORMULA=umFORMULA[ido]
               mnp=max(umNPAR)-1
               umPARAMS=umPARAMS[0:mnp,ido] & umFITP  =umFITP[  0:mnp,ido] & umQEXP=umQEXP[0:mnp,ido]
               umBOUNDA=umBOUNDA[0:mnp,ido] & umBOUNDB=umBOUNDB[0:mnp,ido] & umQINF=umQINF[0:mnp,ido]
               umLIMITA=umLIMITA[0:mnp,ido] & umLIMITB=umLIMITB[0:mnp,ido] & umQSUP=umQSUP[0:mnp,ido]
               umPNAMES=umPNAMES[0:mnp,ido]

               User_Modl={ON:umON,NAME:umNAME,NPAR:umNPAR,PARAMS:umPARAMS,FITP:umFITP,BOUNDA:umBOUNDA,BOUNDB:umBOUNDB,$
                          LIMITA:umLIMITA,LIMITB:umLIMITB,FORMULA:umFORMULA,QEXP:umQEXP, BOSE:bose, FOLLOW:uvg.Follow,$
                          RESOLUTION:uvg.Reso,BKGDmod:uvg.Bgrd,BKGDfix:BkgdFix,BKGDvalue:bkgd,QINF:umQINF,QSUP:umQSUP,$
                          PNAMES:umPNAMES }
              ;if BkgdFix then User_Modl.BKGDmod=0
               if uv[1] eq -2 then begin & User_Modl.PARAMS=KP_UM.PARAMS
                                         User_modl.QEXP  =KP_UM.QEXP
                                         User_Modl.PARAMS[uv[6],uv[7]]=ev.value ;Slider params player
                                         User_modl.QEXP[  uv[6],uv[7]]='' & endif
            endif else okfit=0
           endif  else okfit=0

           if (uv[5] eq 0) and okfit then begin & okfit=0   ;Write model to disk
               widget_control,uv3[2],get_value=fifi & fifi=strlowcase(strcompress(fifi[0],/remove_all))
               idx=strpos(fifi,'.')   & if idx gt 0 then fifi=strmid(fifi,0,idx)
               if  strpos(fifi,'model') lt 0 then fifi='model_'+fifi
               if  strpos(fifi,'.pro' ) lt 0 then fifi=fifi+'.pro'

               filt='*model*.pro'
               bfil=dialog_pickfile(filter=filt,file=fifi,get_path=pth,/write,title='Saving a User Model')

               if bfil ne '' then begin
                cd,current=mee
                idx=STRPOS(bfil,lamp_dvd,/REVERSE_SEARCH)
                if idx ge 0 then begin
                   bfil=strmid(bfil,idx+1,100) & cd,pth
                endif
                str_write_model,bfil,User_Modl,ok
                cd,mee
                if ok then widget_control,uv3[2],set_value=bfil
                if ok then widget_control,uv[4] ,set_value=bfil+' is written' $
                      else widget_control,uv[4] ,set_value='?Unable to write '+bfil
               endif
               return
           endif else if (okfit) and (uv[1] ne -2) then str_write_model,'model_User_last',User_Modl,ok
                                                           ;Write anyway the model to keep info.
         endif else if uvg.Constr then begin
          if (not uvg.Shemf[0]) then if uvg.Bgrd eq 3 then begin & endif ;background
          if (not uvg.Shemf[0]) then if uvg.Bgrd eq 0 then begin
                                if str_gettext(uvg.Shemt[0],bkgd) then $
                                if bkgd ne 0.                     then cmdfixes=cmdfixes+',startBG=' +s4v(bkgd)
          endif
          if  uvg.Shemf[0] then if str_gettext(uvg.Shemt[0],bkgd) then cmdfixes=cmdfixes+',flat='    +s4v(bkgd)
          if (uvg.Sheme ne 4) and (uvg.Sheme ne 5) then begin
           if uvg.Shemf[1] then if str_gettext(uvg.Shemt[1],ctrx) then cmdfixes=cmdfixes+  ',Center='+s4v(ctrx)
           if uvg.Shemf[2] then if str_gettext(uvg.Shemt[2],lowc) then cmdfixes=cmdfixes+',L_Center='+s4v(lowc)
           if uvg.Shemf[3] then if str_gettext(uvg.Shemt[3],uppc) then cmdfixes=cmdfixes+',U_Center='+s4v(uppc)
          endif
           fWmH=0. & loww=0. & uppw=0. & npeak=0
           if uvg.Shemf[4] then if str_gettext(uvg.Shemt[4],fWmH) then cmdfixes=cmdfixes+  ',fWmH='+s4v(fWmH)
           if uvg.Shemf[5] then if str_gettext(uvg.Shemt[5],loww) then cmdfixes=cmdfixes+',L_fWmH='+s4v(loww)
           if uvg.Shemf[6] then if str_gettext(uvg.Shemt[6],uppw) then cmdfixes=cmdfixes+',U_fWmH='+s4v(uppw)

          case uvg.Sheme of
          1: begin ;default is one peak
             end
          2: begin &                                            cmdfixes=cmdfixes+',/C2_mod'           ;Centered
                                                              cmdfixes=cmdfixes+',/Pm_sep'
                   if str_gettext(uvg.Shemt[11],height2) then cmdfixes=cmdfixes+',C2_Height='+s4v(height2)
                   if str_gettext(uvg.Shemt[12],fWmH2)   then cmdfixes=cmdfixes+',C2_fWmH='  +s4v(fWmH2)
                   if uvg.Shemf[8]  then                      cmdfixes=cmdfixes+',P_extra=1'
             end
          3: begin &                                            cmdfixes=cmdfixes+',/P2_mod'           ;Double
                   if uvg.Shemf[7]  then                      cmdfixes=cmdfixes+',/Pm_sep'
                   if uvg.Shemf[8]  then                      cmdfixes=cmdfixes+',P_extra=1'
             end                                                                                     ;Overlapped peaks
          4: begin & quality=uvg.Shemf[10] &                                       cmdfixes=cmdfixes+',/Multi_mod,Multi_fine='+s4v(quality)
                   if uvg.Shemf[9]  then if str_gettext(uvg.Shemt[9],npeak) then cmdfixes=cmdfixes+', Multi_U='+s4v(npeak)

                  ;if npeak    eq 0 then begin okfit=0 & messg='?I need peaks# (max)' & endif
                   if uvg.Reso eq 0 then begin & okfit=0 & messg='?I need a resolution' & endif
             end                                                                                     ;Multiple peaks
          5: begin & quality=uvg.Shemf[10] &                                       cmdfixes=cmdfixes+',/Multi_mod,Multi_fine='+s4v(quality)
                   if uvg.Shemf[9]  then if str_gettext(uvg.Shemt[9],npeak) then cmdfixes=cmdfixes+',Multi_U='   +s4v(npeak)
                   if str_gettext(uvg.Shemt[13],meanw)                      then cmdfixes=cmdfixes+',Multi_fast='+s4v(meanw)

                  ;if uvg.Reso gt 0 then if npeak eq 0 then begin okfit=0 & messg='?I need peaks# (max)' & endif
                   if uvg.Reso eq 0 then if meanw eq 0 then begin & okfit=0 & messg='?I need a mean width' & endif
             end
          else:
          endcase
         endif
         if (uvg.Ftech gt 1) and (itmax ne 1) then cmdtech=',mpfit='+strtrim(uvg.Ftech-1,2) else cmdtech=''

        ;Resolution inputs
        ;*****************
         cmdresol='' & case uvg.Reso of
                       0:
                       1: if  uvg.ResoW gt 0 then begin &                          cmdresol=',Res_wks='+s4v(uvg.ResoW)
                           if str_gettext(uvg.Resob[3],rxrg1) then $
                           if str_gettext(uvg.Resob[4],rxrg2) then $
                                           if rxrg1 lt rxrg2  then               cmdresol=cmdresol+',Res_xrg='+s4v([rxrg1,rxrg2])
                           if uvg.Interp[0]                   then               cmdresol=cmdresol+',/Res_interp'
                          endif
                       2: if  str_gettext(uvg.Resob[0],r_wth)    then $
                          if  r_wth gt 0  then begin &                             cmdresol=',Res_gau='+s4v(r_wth)
                              if uvg.ResoGUM ne 0                then            cmdresol=cmdresol+',Res_Gum='+s4v(uvg.ResoGUM)
                          endif
                       3: begin
                          if  str_gettext(uvg.Resob[1],r_pvf)    then $
                          if (r_pvf ge 0) and (r_pvf le 1)       then begin
                          if not str_gettext(uvg.Resob[0],r_wth) then r_wth=0
                          if (r_wth gt 0) or (uvg.ResoDTI ne 0)  then begin &      cmdresol=',Res_pvf='+s4v(r_pvf)
                              if (uvg.ResoDTI ne 0)              then            cmdresol=cmdresol+',Res_dti='+s4v(uvg.ResoDTI) $
                                                                 else            cmdresol=cmdresol+',Res_voi='+s4v(r_wth)
                          endif
                          endif
                          end
                       4: if  str_gettext(uvg.Resob[2],r_spc)    then $
                          if (r_spc ge 1) and (r_spc le uvg.Isiz[2]) then begin &  cmdresol=',Res_spc='+s4v(r_spc)
                           if str_gettext(uvg.Resob[5],rxrg1) then $
                           if str_gettext(uvg.Resob[6],rxrg2) then $
                                           if rxrg1 lt rxrg2  then               cmdresol=cmdresol+',Res_xrg='+s4v([rxrg1,rxrg2])
                           if uvg.Interp[1]                   then               cmdresol=cmdresol+',/Res_interp'
                       endif
                       else:
                       endcase
                       if  uvg.FPDisp gt 0                      then             cmdresol=cmdresol+',Res_disp='+s4v(uvg.FPDisp)
                       if (uvg.Reso ne 0) and (cmdresol eq '')  then begin
                           okfit=0 & messg='?Resolution incorrect' & endif
                           
        ;We may have a spectra range so we should
        ;keep the previous fit if it was in FULL RANGE.
         kpPrevious=0 & szD=size(data)
         if szD[0] eq 2 then $                                    ;We have a previous 2D fit
          if (srg[0] ne 1) or (srg[1] ne uvg.Isiz[2]) then $            ;we have a sub_range
           if ((szD[1] eq uvg.Isiz[1]) and (szD[2] eq uvg.Isiz[2])) $ ;previous fit was full
              or (itmax eq 1) then begin                          ;or playing with P.sliders
               kpPrevious=1 ;May be but only if we have the same number of functions!
               kp_par=par & kp_data=data & kp_dcfit=dcfit & kp_sout=sout & kp_Cfunc=Cfunc
           endif
        ;print,okfit ,kpPrevious     
        ;print, srg , szD(1) , uvg.Isiz(1) , szD(2) , uvg.Isiz(2)

         strBG=s4v(uvg.Bgrd)     ; or
         strBG='"'+(['flat','linear','quadr','none'])[uvg.Bgrd]+'"'      ;Make keywords
         if uvg.append then cmdapd=',/append' else cmdapd=''
         cmd='par=str_fit(0,file,titl'+cmdapd+',Win='+s4v(uvg.Iwks)+',Bkgd='+strBG+cmdxrange+cmdsrange $
                         +cmdfunc+cmdnoweight+cmdwout+cmdbgd+cmdfixes+cmdtech+cmdresol
         cmdc=cmd +',Fit=data,Sigma=sout,Id_Lab=uvg.mess,Stop_id=ev.id,Res_dfit=dcfit,input_cmd=cmd'
         cmdc=cmdc+', ConvFunc=Cfunc, ChiRes=ChiRes , ChiMean=ChiMean)'  ;CMDC IS THE EXECUTABLE STRING
  
         cmd =cmd + ',Fit=f,Res_Dfit=d,Sigma=s,ConvFunc=c, Out_SubF=o)'  ;CMD  IS PRINTED IN OUTPUT FILE
         
         if uvg.Func eq 6 then cmdfunc2=',User_model="model_User_last.pro"' else cmdfunc2=cmdfunc

         cmd2='P=STR_FIT(W'+s4v(uvg.Iwks)+',"str_fitpar.txt","titl"'+cmdapd+',Bkgd='+strBG2+cmdxrange+cmdsrange $
                           +cmdfunc2+cmdnoweight+cmdwout+cmdbgd+cmdfixes+cmdtech+cmdresol
                         
         cmd2=cmd2+', Fit=f,Res_Dfit=d,Sigma=s,ConvFunc=c, Out_SubF=o)'  ;CMD2 IS SHOWN IN P.RESULT

         if okfit then begin
           ChiRes = 0.   & ChiMean = bid_other.Chi2
           as=systime(1) & ii = 1
           
           if not bid_other.Restoring then begin ; Not restoring a model
              par    = 0  & data = 0.    & dcfit = 0.   & sout = uvg.Pwks
              if uv[1] eq 1 then widget_control,ev.id,set_value=' STOP <-'
              widget_control,/hourglass
              ii=EXECUTE(cmdc)                                         ;***************** Call STR_FIT ******************
              if uv[1] eq 1 then widget_control,ev.id,set_value='->FIT NOW'
              bid_other.Chi2 = ChiMean
           endif

           bs=systime(1)
           slmax=1 & str_fit_plot,'erase',uvg
           slmin=1
           uvg.Vslidp=0
           sizpar=size(par) & if sizpar[0] eq 3 then plmax=sizpar[3] else plmax=1

           widget_control,uvg.Junk[5],get_uvalue=btexts

           if (ii eq 1) and (n_elements(data) gt 1) and (n_elements(sout) gt 1) then begin            ;Success

             if kpPrevious then begin ;We may insert this fit range into a previous full range fit
               ;First check if we have the same number of functions
                sizkp_par=size(kp_par) ;(npec,npar,nfunc)
                if sizkp_par[0] eq 3 then kp_plmax=sizkp_par[3] else kp_plmax=1
                if (sizpar[1] lt sizkp_par[1]) and $
                   (sizpar[2] eq sizkp_par[2]) and (plmax eq kp_plmax) then begin ;OK

                    if itmax eq 1 then begin ;Keep all previous fits, "see only"
                       kp2_par =kp_par  & kp2_data =kp_data  & kp2_dcfit=kp_dcfit
                       kp2_sout=kp_sout & kp2_Cfunc=kp_Cfunc
                    endif

                    kp_par[    srg[0]-1 : srg[1]-1,*,*] =par
                    kp_sout[   srg[0]-1 : srg[1]-1,*,*] =sout
                    kp_data[ *,srg[0]-1 : srg[1]-1]     =data
                    kp_dcfit[*,srg[0]-1 : srg[1]-1]     =dcfit
                    kp_Cfunc[*,srg[0]-1 : srg[1]-1,*]   =Cfunc
                    par=kp_par & data=kp_data & dcfit=kp_dcfit & sout=kp_sout & Cfunc=kp_Cfunc
                    srg = [1,uvg.isiz[2]] ;!!!
                    if ((szD[1] eq uvg.Isiz[1]) and (szD[2] eq uvg.Isiz[2])) then kp_Srang= srg
                    uvg.Srang=kp_Srang
                endif
             endif

             if itmax ne 1 then begin ; Show P.results if not "see only"
               if uvg.TabDon gt 0 then widget_control,uvg.TabDon,set_tab_current=2
               str_out_par,uvg ,'par'                                                                 ;params output
               if uvg.Fwks lt 0 then str_out_par,uvg ,'fit'   ;fit file output
             endif

             slmin=srg[0]
             slmax=srg[1] & uvg.Vslid=uvg.Vslid>srg[0]<srg[1]
             if slmax eq 1 then slmin=0 else slmin=srg[0]
             str_fit_plot,'plot'  ,uvg                        ;Plot the fit

            ;Restore previous fit after the plot when "see only"
             if (itmax eq 1) and (n_elements(kp_par) eq n_elements(kp2_par)) and (n_elements(kp2_par) gt 1) then begin
                 par=kp2_par & data=kp2_data & dcfit=kp2_dcfit & sout=kp2_sout & Cfunc=kp2_Cfunc
             endif

            ;PUT ALL PARAMETERS IN THE TEXT WINDOW
            ;if uvg.Func eq 6 then texts=['str_get_model, "model_User_last.pro", U',cmd2] else texts=[cmd2]
             texts=[cmd2]
             if bid_other.Restoring then texts=[texts,'','!!!!!!!!! JUST RESTORED WITH CURRENT MODEL !!!!!!!!!']
             sizp =size(par)
             nspec=sizp[1] & npr=sizp[2] & if sizp[0] eq 3 then nk=sizp[3] else nk=1
             if uvg.Func eq 6 then begin & umON=where(User_Modl.ON eq 1)  &  nk=n_elements(umON)
                umNAME  =User_Modl.NAME
                umNPAR  =User_Modl.NPAR
                umPNAMES=User_Modl.PNAMES
                umFORM  =User_Modl.FORMULA
             endif else begin
                umON    =indgen(nk)
                umNAME  =strarr(nk)
                umNPAR  =lonarr(nk)+3
                umFORM  =strarr(nk)
                umPNAMES=strarr(3,nk) & for i=0,nk-1 do umPNAMES[0:2,i]=['Height','Position','FWidth']
                case uvg.Func of 
                 1:   umFORM=umFORM+'Gaussian'
                 2:   umFORM=umFORM+'lorentzian'
                 3:   umFORM=umFORM+'Pseudo-Voigt'
                 4:   umFORM=umFORM+'Pseudo-Voigt PVf='+s4v(uvg.PVf)
                else:
                endcase
             endelse
             parf=float(par) & psig=float(sout)*100.>0.
             idx =where(parf ne 0.) & if idx[0] ge 0 then psig[idx]=abs(psig[idx]/parf[idx])
             
             for kk=0,nk-1 do begin
              k=umON[kk]
              Fstr = string(k+1,format='(i2)')
              texFU='Function'+Fstr+'  '+umNAME[k]+'  '+umFORM[k]+'  (P= value % error)'
              for j=0,(size(umPNAMES))[1]-1 do begin & pname =umPNAMES[j,k]
                  if pname gt ' ' then texFU=texFU+'  P'+strtrim(j+1,2)+'='+pname
              endfor
              if kk eq 0 then texFU=texFU+'   CHI2(total average)='+string(round(ChiMean*100.)/100.,format='(f6.2)') $
                                         +'   Time:'               +string(round((bs-as)*10)/10.,format='(f6.1)')+' Sec'

              texts=[texts,' ',texFU,'--------']
              bkgrd=''
              for i=0,nspec-1 do begin
                  if uvg.Bgrd lt 3 then bkgrd=      '  Bgrd C='     +string(parf[i,4,0],format='(G)')+' %'+string(psig[i,4,0],format='(F6.2)')
                  if uvg.Bgrd lt 3 then $
                  if uvg.Bgrd ge 1 then bkgrd=bkgrd+'  B[x]='  +string(parf[i,5,0],format='(G)')+' %'+string(psig[i,5,0],format='(F6.2)')
                  if uvg.Bgrd eq 2 then bkgrd=bkgrd+'  A(x^2)='+string(parf[i,6,0],format='(G)')+' %'+string(psig[i,5,0],format='(F6.2)')
                  Sstr = string(i+srg[0],format='(i4)')
                  allpr='Fc'+Fstr+' Sp'+Sstr+':'+ $
                               '  P1=' +string(parf[i,1,k],format='(G)')+' %' +string(psig[i,1,k],format='(F6.2)')+ $
                               '  P2=' +string(parf[i,2,k],format='(G)')+' %' +string(psig[i,2,k],format='(F6.2)')+ $
                               '  P3=' +string(parf[i,3,k],format='(G)')+' %' +string(psig[i,3,k],format='(F6.2)')+ bkgrd

                  if uvg.Func eq 3 then allpr=allpr+ $
                               '  PVf' +string(parf[i,0,k],format='(G)')+' %' +string(psig[i,0,k],format='(F6.2)')

                  for j=4,umNPAR[k] do begin & n=6+j
                      strP='  P'+strtrim(j,2)+'='
                      allpr=allpr+strp +string(parf[i,n,k],format='(G)')+' %' +string(psig[i,n,k],format='(F6.2)')
                  endfor
                  allpr=allpr+'  ('+'Fc'+Fstr+' Sp'+Sstr+')'
                  if n_elements(ChiRes) eq nspec then begin
                     allpr=allpr+'  Chi2='+string(round(ChiRes[i]*100.)/100.,format='(f6.2)')
                     if (nk gt 1) and (i eq 0) then allpr=allpr+' (total functions)'
                  endif
                  texts=[texts,allpr]
              endfor
             endfor
             
             if (uvg.Toggln ne 2) and (uvg.Func ne 6) then str_fit_plot,'scroll',uvg
             if (itmax gt 1) then begin
                explain=['',$
                     'Sigma=s     return errors for all fitted parameters [nspectra , nparams , nfunct]',$
                     'Res_dfit=d  return filtered fit (no background, deconvoluted)  [nx , nspectra]'   ,$
                     'Fit=f       return fitted spectra (+background,   convoluted)  [nx , nspectra]'   ,$
                     'Fout=n      return fitted spectra in Wrks number Nout          [nx , nspectra]'   ,$
                     'Conv_func=c return convoluted functions (no background) [nx , nspectra , nfunct]' ,$
                     'out_subF=r  return deconvoluted functions indexed by out_subi=[index] [nx , nspectra , nindex]']
                texts=[texts,explain]
                widget_control,btexts, set_value=texts
                if (uvg.Toggln ne 2) or  (uvg.Func eq 6) then $
                 if uvg.Toggln ne 5 then begin & map0=uvg.Junk[uvg.Toggln] & uvg.Toggln=5
                    widget_control,map0  ,map=0 & widget_control, uvg.Junk[uvg.Toggln],map=1
                    if uvg.TabDon gt 0 then widget_control,uvg.TabDon,set_tab_current=2
                endif
             endif
             
             if uv[1] eq -1 then begin ;User touch the "see only button"
                 TAKE_DATP,datp,W=uvg.Iwks & Q=datp.Y
                 Q=Q[uvg.Vslid-1<(n_elements(Q)-1)]
                 uvshow=uv & uvshow[1]=-2
                 str_slider_param,base=uvg.Junk[6], model=User_Modl,Q=Q, UV=uvshow, CMD=cmd2
                 if uvg.Toggln ne 6 then begin & map0=uvg.Junk[uvg.Toggln] & uvg.Toggln=6
                    widget_control,map0  ,map=0 & widget_control, uvg.Junk[uvg.Toggln],map=1
                    if uvg.TabDon gt 0 then widget_control,uvg.TabDon,set_tab_current=1
                 endif
             endif
             
             if uv[1] eq -2 then begin ;User play with the params sliders
             endif
             
           endif else begin &  messg=' ?Bad input         ' ;not success
             uvg.Vslid=1
             widget_control,btexts, set_value=['Fit aborted. ['+!error_state.msg+']']
           endelse
           if itmax gt 1 then widget_control,uvg.Slid[ 0],set_slider_min=slmin,set_slider_max=slmax
                              widget_control,uvg.Slid[ 0],set_value=uvg.Vslid
           if itmax gt 1 then widget_control,uvg.Slid[ 1],set_slider_min=slmin,set_slider_max=slmax
                              widget_control,uvg.Slid[ 1],set_value=uvg.Vslid
           widget_control,uvg.Slidp[0],set_slider_min=0    ,set_slider_max=plmax,set_value=uvg.Vslidp
           messg='-'
           
         endif ;ok to fit
         
         uvg.Srang=kp_Srang
         
        ;if okfit then if uv(1) lt 0 then str_fit_plot,'plot'  ,uvg ;Plot See/Slider curve !!!

   endif else messg=' ?Select input Data '

9: begin & if uv[1] le 0 then begin & vmap=uv[n_elements(uv)-1]                      ;Resolution map
            if ev.select eq 0 then begin & uv[1]=-uvg.Reso
                                         widget_control,ev.id,set_uvalue=uv & uv[1]=0
                                         widget_control,vmap ,map=0
            endif             else begin & uv[1]=-uv[1]
                                         widget_control,vmap ,map=1 & endelse
         endif
         uvg.Reso=uv[1] & for i=2,4 do widget_control,uv[i] ,map=0               ;Resolution
                                       widget_control,uv[7] ,map=0 ;gumbel
                                       widget_control,uv[8] ,map=0 ;inst
                                       widget_control,uv[11],map=0 ;regular Wks
                                       widget_control,uv[12],map=0 ;regular Spc
                          case uv[1]  of
                          0:                                                     ;None
                          1: begin & widget_control,uv[2] ,map =1                  ;Workspace
                                   widget_control,uv[11],map =1 ;regular Wks
                             end
                          2: begin & widget_control,uv[3] ,map =1                  ;Gauss/Gumbel
                                   widget_control,uv[7] ,map =1 ;gumbel
                                   widget_control,uv[9] ,sens=1
                                   widget_control,uv[10],sens=1
                                   widget_control,uv[6] ,sens=0
                             end
                          3: begin & widget_control,uv[3] ,map =1                  ;Inst/Voigt
                                   if uvg.ResoDTI eq 0   then sensr=1 else sensr=0
                                   widget_control,uv[9] ,sens=sensr
                                   widget_control,uv[10],sens=sensr
                                   widget_control,uv[8] ,map =1 ;inst
                                   widget_control,uv[5] ,sens=1
                                   widget_control,uv[6] ,sens=1
                             end
                          4: begin & widget_control,uv[4] ,map =1                  ;spectrum
                                   widget_control,uv[12],map =1 ;regular Spc
                             end
                          else:
                          endcase
         if uv[1] eq 0 then widget_control,uvg.labWTH,set_value='<-->(fWmH)' $
                       else widget_control,uvg.labWTH,set_value='Dconv(Wth)'
   end
10:begin & widget_control,ev.id,get_value=w & widget_control,uv[1],set_value=w         ;Resolution workspace
         uvg.ResoW=uv[2] & end
11:begin & uvg.Srg =ev.select                                                                 ;Spectra range
         if uvg.Isiz[0] eq 2 then begin
            widget_control,uvg.Slid[0],set_slider_min=1,set_slider_max=uvg.Isiz[2]
            widget_control,uvg.Slid[1],set_slider_min=1,set_slider_max=uvg.Isiz[2]
         endif & end
12:begin & widget_control,ev.id,get_value=w & widget_control,uv[1],set_value=w    ;Input num bkgrd workspace
         uvg.Bwks =uv[2] & end
13:begin & uvg.BSfix=ev.select  & end                                                ;Background shape fixed

14:begin & widget_control,ev.id,get_value=xr & xr=xr[0] & l=-1                           ;Fit or Plot  range
        ;UV(1): 0,1 -> Fit  xmin,xmax
        ;UV(1): 2,3 -> Plot xmin,xmax
        ;UV(1): 4   -> Plot      ymax
         if (uv[1] eq 0) or (uv[1] eq 2)  then j=strpos(strlowcase(xr),'in') $
                                          else j=strpos(strlowcase(xr),'ax')
         if (uv[1] eq 0) or (uv[1] eq 1)  then l=strpos(strlowcase(xr),'w' )
         win1=0 &  w=0
         
         if l ge 0 then begin & ii=execute('win1='+xr) ;accept win1 or not in Fit range ?
            if ((size(win1))[0] ne 1) or ((size(win1))[1] ne uvg.Isiz[1]) then begin & l=-1 & j=1 & endif & endif
         if l ge 0 then begin                        ;yes
            if n_elements(uvg.Xrang) gt 2 then uvg.Xrang[uv[1],*]=win1 $
            else begin & tmpRang=uvg.xrang
                       str_mod_struct,uvg,'Xrang',transpose([[win1],[win1]])
                       uvg.Xrang[1-uv[1],*]=tmpRang[1-uv[1]] & endelse
         endif
         if l lt 0 then $
         if j lt 0 then begin & on_ioerror,misrgx & xr=float(xr)
                         if (uv[1] lt 2) then uvg.xrang[uv[1],*] =xr else $
                         if (uv[1] eq 4) then uvg.pYrgM          =xr $
                                         else uvg.prang[uv[1]-2] =xr  & misrgx:
         endif else if uv[1] eq 0 then ii=execute('uvg.xrang[0,*]=min(X'+ws+')') $
               else if uv[1] eq 1 then ii=execute('uvg.xrang[1,*]=max(X'+ws+')') $
               else if uv[1] eq 2 then ii=execute('uvg.prang[0]  =min(X'+ws+')') $
               else if uv[1] eq 3 then ii=execute('uvg.prang[1]  =max(X'+ws+')') $
               else if uv[1] eq 4 then uvg.pYrgM = 0.
           
         if ev.type eq 0 then if ev.ch le 15B then begin
            str_fit_plot,'plot',uvg & str_fit_plot,'scroll',uvg & endif
   end
15:if uvg.Func ne 6 then begin ;Not user model!
         if (uv[1] eq 0) then if uvg.Toggln ne 2 then begin                         ;Constraints on off
            map0=uvg.Junk[uvg.Toggln] & uvg.Toggln=2
            widget_control,map0  ,map=0 & widget_control,uvg.Junk[uvg.Toggln],map=1
         endif
         if uvg.TabDon gt 0 then widget_control,uvg.TabDon,set_tab_current=3
         
         if uv[1] eq 1 then uvg.Constr=ev.select
         if uv[1] eq 1 then widget_control,uv[2]      ,sensitive =ev.select
         if uv[1] eq 1 then widget_control,uvg.Junk[2],sensitive =ev.select
   endif else if uv[1] eq 1 then widget_control,ev.id ,set_button=0
16:begin & if uv[1] eq 2 then if ev.select eq 0 then uv[1]=3                          ;Double or Centered
         if uv[1] eq 3 then widget_control,uv[9],set_button=0
         case uv[1] of
         1:begin & widget_control,uv[2],sens=1 & widget_control,uv[3],sens=1          ;One peak
                 widget_control,uv[4],sens=0
                 widget_control,uv[5],sens=0 & widget_control,uv[6],sens=0 & end
         2:begin & widget_control,uv[2],sens=1 & widget_control,uv[3],sens=1          ;Centered peaks
                 widget_control,uv[4],sens=1
                 widget_control,uv[5],sens=1 & widget_control,uv[6],sens=0 & end
         3:begin & widget_control,uv[2],sens=0 & widget_control,uv[3],sens=1          ;Double peak
                 widget_control,uv[4],sens=0
                 widget_control,uv[5],sens=1 & widget_control,uv[6],sens=0 & end
         4:begin & widget_control,uv[2],sens=0 & widget_control,uv[3],sens=1          ;Overlapped peaks
                 widget_control,uv[4],sens=0
                 widget_control,uv[5],sens=0 & widget_control,uv[6],sens=1
                 widget_control,uv[7],sens=0 & widget_control,uv[8],sens=0 & end
         5:begin & widget_control,uv[2],sens=0 & widget_control,uv[3],sens=1          ;Multi peaks
                 widget_control,uv[4],sens=0
                 widget_control,uv[5],sens=0 & widget_control,uv[6],sens=1
                 widget_control,uv[7],sens=1 & widget_control,uv[8],sens=1 & end
         else:
         endcase
         uvg.Sheme=uv[1] & end
17:      begin & uvg.Shemf[uv[1]]=ev.select                                       ;Constraints fixed buttons
               if (uv[1] eq 0) then if ev.select then uvg.Bgrd=0                               ;background
         end
18:      begin & uvg.Ftech=uv[1]                                                           ;Technique engine
               for i=2,n_elements(uv)-1 do begin
                 widget_control,uv[i],get_value=labl1 & labl1=strmid(labl1,2,80)
                 if uv[1] eq i-1 then labl1='* '+ labl1 else labl1='  '+labl1
                 widget_control,uv[i],set_value=labl1
               endfor
         end
19:begin & case uv[2] of                                                                            ;Quality
         1:   text='Noisy'
         2:   text='Normal'
         3:   text='Good'
         4:   text='Smooth'
         5:   text='Excel.'
         else:text=' ? '
         endcase
         uvg.Shemf[uv[1]]=uv[2]
         widget_control,uv[3],set_value=text
   end
20:begin ;if (size(par))[0] ge 2 then if uv(1) lt (size(par))[2] then begin
             uvg.Plot =uv[1] & str_fit_plot,'plot',uvg                                       ;What to plot
         ;endif
   end
21:begin & map1=1 & map2=0 & if uv[1] eq 0 then begin & map1=0 & map2=1 & endif             ;Toogle large draw
         widget_control,uvg.Junk[3],map=map1 & widget_control,uvg.Junk[4],map=map2
         widget_control,ev.id,set_button=0   & uvg.wins[0]=uvg.wins[5-uv[1]]
         tmp=uvg.wdraw[0] & uvg.wdraw[0]=uvg.wdraw[1] & uvg.wdraw[1]=tmp
         str_fit_plot,'plot',uvg
   end
22:begin & uvg.Vslid=ev.value & YM=uvg.YMax & XM=uvg.Xtmp                                    ;Spectra Slider
         if YM eq 0. then if XM[0] ne XM[1] then str_fit_plot,'scroll',uvg, Xtmp=XM $
                                            else str_fit_plot,'scroll',uvg
         if YM ne 0. then if XM[0] ne XM[1] then str_fit_plot,'scroll',uvg, Xtmp=XM, YMAX=YM $
                                            else str_fit_plot,'scroll',uvg, YMAX=YM
         if ev.id eq uvg.Slid[0] then slid=uvg.Slid[1] else slid=uvg.Slid[0]
         widget_control,slid,set_value=uvg.Vslid
         
         if uvg.TabDon gt 0 then widget_control,uvg.TabDon,set_tab_current=0
   end
23:begin
   if ev.type eq 1 then if (ev.release eq 4) then call_procedure,'lamp_event_parser',ev,[-88,0] ;Clipboard
   if ev.type eq 1 then if (ev.release ne 4) then $                                             ;Draw button
   if (uvg.plot lt 4) or (uvg.plot eq 7) or (uvg.plot eq 8) or (uvg.plot eq 9) or (uvg.plot ge 10) then begin
    if (size(data))[0] gt 1 then begin
      xy=CONVERT_COORD(ev.x,ev.y,/dev,/to_data)                             ;select one spectrum
      ii=execute('yc=Y'+ws) & ii=execute('sz2=(size(w'+ws+'))[2]')
      if n_elements(yc) eq sz2 then begin & idx=where(yc ge xy[0]) & xy[0]=(idx[0]>0)+1 & endif

      uvg.Vslid=round(xy[0]) & widget_control,uvg.Slid[0],set_value=uvg.Vslid
                               widget_control,uvg.Slid[1],set_value=uvg.Vslid
      str_fit_plot,'scroll',uvg
    endif
   endif else if (uvg.plot eq 4) then begin                                 ;X or Y range
      xy=CONVERT_COORD(ev.x,ev.y,/dev,/to_data)
      if (ev.x lt 0 ) or (ev.y lt 0 ) or $
         (ev.x lt 20) or (ev.y lt 30) or (ev.release eq 2) then begin       ;Clear all
                          uvg.YMax=0.  &  uvg.Xtmp=[0.,0.]
      endif else begin
         if abs(ev.x-uvg.Xd[0]) lt 15 then begin                            ;Y range
              if  (uvg.YMax gt 0) and (uvg.YMax lt xy[1]) then uvg.YMax=0 $
              else if uvg.Plog lt 2 then uvg.YMax=xy[1] ;& uvg.Xtmp=[0.,0.]
         endif else begin
              xp=CONVERT_COORD(uvg.Xd[0],uvg.Xd[1],/dev,/to_data)           ;X range
              uvg.Xtmp=[min([xp[0],xy[0]],max=mmx),mmx]
         endelse
      endelse
      YM=uvg.YMax & XM=uvg.Xtmp
      if YM eq 0. then if XM[0] ne XM[1] then str_fit_plot,'scroll',uvg, Xtmp=XM $
                                         else str_fit_plot,'scroll',uvg
      if YM ne 0. then if XM[0] ne XM[1] then str_fit_plot,'scroll',uvg, Xtmp=XM, YMAX=YM $
                                         else str_fit_plot,'scroll',uvg, YMAX=YM
   endif
   if ev.type eq 0 then if (ev.press eq 1) and (uvg.plot eq 4) then $       ;Prepare for X range
      uvg.Xd=[ev.x,ev.y]
   end
24:begin & uvg.Pres =ev.select & str_fit_plot,'scroll',uvg                                         ;%Residue
         if uvg.Plot eq 5 then str_fit_plot,'plot'  ,uvg      & end

25:for i=1,n_elements(uv)-1 do widget_control,uv[i],map=ev.select                              ;map Output

26:begin & if uv[1] ge 0 then uvg.Vslidp=uv[1] else uvg.Vslidp=ev.value
         str_fit_plot,'plot',uvg                                                  ;show one peak parameter
   end

27:uvg.Interp[uv[1]]=ev.select                                                        ;Regular convolution

28:uvg.append       =ev.select                                                         ;Append File output

29:begin & uvg.Px=uv[1] & togoff='- ' & togon='* ' & nh=2                        ;Parameter output selection
         for i=nh,n_elements(uv)-1 do begin &  widget_control,uv[i],get_value=vv
             vv=togoff+strmid(vv,2,50)     & widget_control,uv[i],set_value=vv
         endfor
         widget_control,ev.id,get_value=vv & vv=togon+strmid(vv,2,50)
         widget_control,ev.id,set_value=vv & uvg.Ptit=vv
         str_out_par,uvg ,'par'
   end

30:begin & widget_control,/hourglass
         case uv[1] of                                                                              ;Tools
         1: suprplot,uvg.Iwks
         2: p_ben_event,0,[0,402,0]
         3: gfit
         4: don_do_cmd
         5:
         6: did_mpeg,'create',wdraw=uvg.wdraw[0],group=top,title='Str_Fit'
         7: p_ick_init,0
         8: par_disp  ,0
         else:
         endcase & end
31:begin & kplot=uvg.Plot & uvg.Plot=uv[1] & str_fit_plot,'plot',uvg,/livc & uvg.Plot=kplot ;3d contour plot
   end
32:begin & uvg.Y0=ev.select  &   str_fit_plot,'plot',uvg                                                 ;Y0
   end
33:begin & if uv[2] eq  0 then ws='None' else $                                ;Instrument Dx Resolution Wks
         if uv[2] eq -1 then ws='Z'+s4v(uvg.Iwks) $
                        else ws='W'+s4v(uv[2])
         widget_control,uv[1],set_value=ws
         if uv[2] eq 0 then sensr=1 else sensr=0 & uvg.ResoDTI=uv[2]
         widget_control,uv[3],sens=sensr & widget_control,uv[4],sens=sensr & end
34:begin & uvg.ResoGUM=uv[1]  & end                                                ;Gumbel Resolution (Gauss)

35:begin & widget_control,ev.id,get_value=lab & uvg.Plog=uv[1]                                 ;Plot X/Y log
         widget_control,uv[2],set_value=lab & str_fit_plot,'plot',uvg & end

36:begin & uvg.FPDisp=uv[1] & widget_control,ev.id,get_value=polyF & polyM='POLY DISPERSITY function('+polyF+')'
         widget_control,uv[3],set_value=polyM & end

37:begin & widget_control,uv[1],/input_focus & end

38:begin & str_out_par, uvg ,'sub' & end

39:begin & uvg.SubConv=ev.select   & str_fit_plot,'plot',uvg  & end

;User defined fitting model
;**************************
40:begin & widget_control,uv[3],get_uvalue=uv3 & nbuv3=n_elements(uv3)
           widget_control,uv[3], UPDATE=0
         if long(nbuv3/2)*2 ne nbuv3 then RS_n='don' else RS_n='did'
         row = widget_base(  uv[3],/row,resource_name=RS_n,/frame) ;Function
         remo= widget_button(row  ,value='del',font=ft_b_normal,uvalue=[44,1,top,uv[3],row])
         onfu= widget_button(widget_base(row,/nonexclusive),value='On',font=ft_b_normal,uvalue=[44,2,top,uv[3],row,0,uv[6]])
               widget_control,onfu,set_button=1
               uv3 =[uv3,row] & widget_control,uv[3],set_uvalue=uv3
               Pexplain=strarr(16)
               bszo=20
               bsz =bszo
               cas =uv[1]<9
         case  cas of
         0: begin & lab =widget_label(  row ,value='Delta  '  ,font=ft_propor) ;Delta
                  but1=widget_button( widget_base(row,/nonexclusive),value='P1.ht'  ,font=ft_b_normal,uvalue=[44,3,top,uv[3],row,0,uv[6]])
                  txt1=widget_text(   row ,value='Ht: '     ,font=ft_propor,xsize=bsz,/edit); & widget_control,but1,sens=0
                  lab =widget_label(  row ,value=','        ,font=ft_b_normal)
                  but2=widget_button( widget_base(row,/nonexclusive),value='P2.pos' ,font=ft_b_normal,uvalue=[44,3,top,uv[3],row,1,uv[6]])
                  txt2=widget_text(   row ,value='Pos: 0.0' ,font=ft_propor,xsize=bsz,/edit); & widget_control,but2,sens=0
                  lab =widget_label(  row ,value=','        ,font=ft_b_normal)
                  but3=widget_button( widget_base(row,/nonexclusive),value='P3.fwmh',font=ft_b_normal,uvalue=[44,3,top,uv[3],row,2,uv[6]])
                  txt3=widget_text(   row ,value='Res: 0.08',font=ft_propor,xsize=bsz,/edit); & widget_control,but3,sens=0
                  lab =widget_label(  row ,value='(resol. width)' ,font=ft_b_normal)
                 widget_control,row,set_uvalue=[1L,uv[1],onfu,0,txt1,but1,0,txt2,but2,0,txt3,but3]
            end
         1: begin & lab =widget_label(  row ,value='Gauss  '  ,font=ft_propor) ;Gaussian
                  but1=widget_button( widget_base(row,/nonexclusive),value='P1.ht'  ,font=ft_b_normal,uvalue=[44,3,top,uv[3],row,0,uv[6]])
                  txt1=widget_text(   row ,value='Ht: '     ,font=ft_propor,xsize=bsz,/edit)
                  lab =widget_label(  row ,value=','        ,font=ft_b_normal)
                  but2=widget_button( widget_base(row,/nonexclusive),value='P2.pos' ,font=ft_b_normal,uvalue=[44,3,top,uv[3],row,1,uv[6]])
                  txt2=widget_text(   row ,value='Pos: '    ,font=ft_propor,xsize=bsz,/edit)
                  lab =widget_label(  row ,value=','        ,font=ft_b_normal)
                  but3=widget_button( widget_base(row,/nonexclusive),value='P3.fwmh',font=ft_b_normal,uvalue=[44,3,top,uv[3],row,2,uv[6]])
                  txt3=widget_text(   row ,value='Fw: '     ,font=ft_propor,xsize=bsz,/edit)
                 widget_control,row,set_uvalue=[1L,uv[1],onfu,0,txt1,but1,0,txt2,but2,0,txt3,but3]
            end
         2: begin & lab =widget_label(  row ,value='Lorentz'  ,font=ft_propor) ;Lorentzian
                  but1=widget_button( widget_base(row,/nonexclusive),value='P1.ht'  ,font=ft_b_normal,uvalue=[44,3,top,uv[3],row,0,uv[6]])
                  txt1=widget_text(   row ,value='Ht: '     ,font=ft_propor,xsize=bsz,/edit)
                  lab =widget_label(  row ,value=','        ,font=ft_b_normal)
                  but2=widget_button( widget_base(row,/nonexclusive),value='P2.pos' ,font=ft_b_normal,uvalue=[44,3,top,uv[3],row,1,uv[6]])
                  txt2=widget_text(   row ,value='Pos: '    ,font=ft_propor,xsize=bsz,/edit)
                  lab =widget_label(  row ,value=','        ,font=ft_b_normal)
                  but3=widget_button( widget_base(row,/nonexclusive),value='P3.fwmh',font=ft_b_normal,uvalue=[44,3,top,uv[3],row,2,uv[6]])
                  txt3=widget_text(   row ,value='Fw: '     ,font=ft_propor,xsize=bsz,/edit)
                 widget_control,row,set_uvalue=[1L,uv[1],onfu,0,txt1,but1,0,txt2,but2,0,txt3,but3]
            end
         3: begin & lab =widget_label(  row ,value='Voigt  '  ,font=ft_propor) ;Pseudo-Voigt
                  but1=widget_button( widget_base(row,/nonexclusive),value='P1.ht'  ,font=ft_b_normal,uvalue=[44,3,top,uv[3],row,0,uv[6]])
                  txt1=widget_text(   row ,value='Ht: '     ,font=ft_propor,xsize=bsz,/edit)
                  lab =widget_label(  row ,value=','        ,font=ft_b_normal)
                  but2=widget_button( widget_base(row,/nonexclusive),value='P2.pos' ,font=ft_b_normal,uvalue=[44,3,top,uv[3],row,1,uv[6]])
                  txt2=widget_text(   row ,value='Pos: '    ,font=ft_propor,xsize=bsz,/edit)
                  lab =widget_label(  row ,value=','        ,font=ft_b_normal)
                  but3=widget_button( widget_base(row,/nonexclusive),value='P3.fwmh',font=ft_b_normal,uvalue=[44,3,top,uv[3],row,2,uv[6]])
                  txt3=widget_text(   row ,value='Fw: '     ,font=ft_propor,xsize=bsz,/edit)
                  lab =widget_label(  row ,value=','        ,font=ft_b_normal)
                  but4=widget_button( widget_base(row,/nonexclusive),value='P4.Pfct',font=ft_b_normal,uvalue=[44,3,top,uv[3],row,3,uv[6]])
                  txt4=widget_text(   row ,value='Pf: .5>0<1'  ,font=ft_propor,xsize=10,/edit)
                 widget_control,row,set_uvalue=[1L,uv[1],onfu,0,txt1,but1,0,txt2,but2,0,txt3,but3,0,txt4,but4]
            end
         4: begin & lab =widget_label(  row ,value='Bose   '    ,font=ft_propor) ;det Balance
                  lab =widget_label(  row ,value='Temperature',font=ft_b_normal)
                  txt1=widget_text(   row ,value='     '      ,font=ft_propor,xsize=6,/edit)
                  lab =widget_label(  row ,value='Kelvin'     ,font=ft_b_normal)
                 widget_control,row,set_uvalue=[1L,uv[1],onfu,1,txt1,0]
            end
         9: begin & rowt=widget_base(   row ,/column) ;Own formula
                  row1=widget_base(   rowt,/row)
                  lab =widget_label(  row1,value='Formula'  ,font=ft_propor)

                 case uv[5] of
;FORMULA 5 parameters
                 0:  begin & formu='b=4*alog(2) & Y=P1*exp(-b*((X-P2)/P3)^2) ;RULE: Y=function, X=abcissa, P1,P2...=parameters'
                           npp  =5 & fixpi=[0,0,0,0,0] & txtpi=['P1 ','P2 ','P3 ','P4 ','P5 ']
                                     valpi=[' ',' ',' ',' ',' ']
                           editf=1 & end
;SANS SPHERE, PolyName= 'SANS_Sphere'
                 1:  begin & formu='t=X*P2 & Y=(P1 *4.*!Pi *P2^3 *(sin(t)-t*cos(t))/t^3 )^2 ;SANS Sphere'
                           npp  =3 & fixpi=[0,0,0]     & txtpi=['P1.density','P2.radius','P3.deltaR']
                                     valpi=['Dens: .1 >0','R: 100 >1<9000','dR: 20 >.001<100']
                           Pexplain[1]='Scale * SLD difference between particle and matrix'
                           editf=1 & end
;TOF BOSON peak
                 2:  begin & formu='P2=abs(P2)>.001 & X=abs(X)>.001 & Y=P1*exp(-((alog(X)-alog(P2))^2/(2*P3^2))>(-70.))/P3/(2*!pi)^.5 ;Boson peak'
                           npp  =3 & fixpi=[0,0,0]     & txtpi=['P1','P2','P3']
                                     valpi=[' ',' ',' ']
                           editf=0 & end
;GUMBEL
                 3:  begin & formu='Y=str_gumbel(X,P1,P2,P3,P4); P4= -1 or 1 (1 for left dissymmetry) ,P1=height ,P2=position of maximum ,P3=full width at middle height'
                           npp  =4 & fixpi=[0,0,0,1]   & txtpi=['P1.ht','P2.pos','P3.fwmh','P4.s']
                                     valpi=['Ht: ','Pos: ','fW: ','s:1']
                           editf=0 & end
;SANS HOLLOW SPHERE, PolyName= 'SANS_H_Sphere'
                 4:  begin & formu='t1=X*P2 & t2=X*P3 & Y=(4.!Pi*(P1*P2^3 *(sin(t1)-t1*cos(t1))/t1^3) - (P1*P4*P3^3 *(sin(t2)-t2*cos(t2))/t2^3) )^2 ;SANS Hollow Sphere'
                           npp  =5 & fixpi=[0,0,0,0,0] & txtpi=['P1.dens','P2.R1','P3.R2','P4.Mu','P5.dR']
                                     valpi=['Dens: .1 >0','R1: 100 >1<9000','R2: 90 >1<9000','Mu:1','dR:20 >.001<100']
                           editf=1 & end
;FORMULA 10 parameters
                 5:  begin & formu='Y= yourFunction(X,P1,P2,P3,...) ;RULE: Y=function, X=abcissa, P1,P2...=parameters. You should enter a formula as well'
                           npp =10 & fixpi=[0,0,0,0,0,0,0,0,0,0]
                                     txtpi=['P1 ','P2 ','P3 ','P4 ','P5 ','P6 ','P7 ','P8 ','P9 ','P10']
                                     valpi=[' ',' ',' ',' ',' ',' ',' ',' ',' ',' ']
                           editf=1 & end
;FORMULA 15 parameters
                 6:  begin & formu='Y= yourFunction(X,P1,P2,P3,...) ;RULE: Y=function, X=abcissa, P1,P2...=parameters. You should enter a formula as well'
                           npp =15 & fixpi=[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]
                                     txtpi=['P1 ','P2 ','P3 ','P4 ','P5 ','P6 ','P7 ','P8 ','P9 ','P10','P11','P12','P13','P14','P15']
                                     valpi=[' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ']
                           editf=1 & end
;TOF D.H.O.
                 7:  begin & formu='Y= P1* P3 * P2^2 /( (X^2-P2^2)^2 + (X*P3)^2 ) ;D.H.O.'
                           npp  =3 & fixpi=[0,0,0]     & txtpi=['P1.amplitude','P2.position','P3.width']
                                     valpi=['Amplitude: 0.1 >0','Position: 0.5 >0','Width: 1.0 >0']
                           editf=1 & end
;STRETCHED EXPONENTIAL
                 8:  begin & formu='Y= spline(X+P2 , P1*STR_EXP(X , P3,P4) , X) ;Stretched Exponential'
                           npp  =4 & fixpi=[0,0,0,0]   & txtpi=['P1.amplitude','P2.pos','P3.beta','P4.tau']
                                     valpi=['Amplitude: ','Position: ','Beta: >.51 <.99','Tau:1 >2e-3']
                           editf=0 & end
;TOF ISO ROTATION
                 9:  begin & formu='Y= STR_ISOROT(X, P1,P2,P3,P4,P5, Loop=19) ;Iso_Rotation'
                           npp  =5 & fixpi=[0,0,0,0,0] & txtpi=['P1.ampli','P2.pos','P3.Dr','P4.rad','P5.u2']
                                     valpi=['Amplitude:[.1] >0','Center: 0 ','Dr:[1] >0','Rad:[1]*(Q)>0','u2:[0]*(Q)^2']
                           editf=0 & end
;TOF UNI ROTATION
                 10: begin & formu='Y= STR_UNIROT(X, P1,P2,P3,P4,P5, Loop=19) ;Uni_Rotation'
                           npp  =5 & fixpi=[0,0,0,0,0] & txtpi=['P1.ampli','P2.pos','P3.Dr','P4.rad','P5.u2']
                                     valpi=['Amplitude:[.1] >0','Center: 0 ','Dr:[1] >0','Rad:[1]*(Q)>0','u2:[0]*(Q)^2']
                           editf=1 & end
;TOF RW TRANSLATION
                 11: begin & formu='Y= STR_RWTRANS(X, P1,P2,P3,P4) ;Random Walk Translation'
                           npp  =4 & fixpi=[0,0,0,0] & txtpi=['P1.amplitude','P2.center','P3.Dt','P4.u2']
                                     valpi=['Amplitude:[.1] >0','Center: 0 ','Dt:[1]*(Q)^2 >0','u2:[0]*(Q)^2']
                           editf=0 & end
;TOF ROTC TRANSLATION
                 12: begin & formu='Y= STR_ROTCTRAN(X, P1,P2,P3,P4,P5,P6, Loop=19) ;Rotc_Trans'
                           npp  =6 & fixpi=[0,0,0,0,0,0] & txtpi=['P1.ampli','P2.pos','P3.Dr','P4.rad','P5.u2','P6.Dt-->']
                                     valpi=['Amplitude:[.1] >0','Center: 0 ','Dr:[1] >0','Rad:[1]*(Q)>0','u2:[0]*(Q)^2','Dt: [1] *(Q)^2 >0']
                           editf=1 & end
;TOF F.O.U.
                 13: begin & formu='Y= spline(X + P2 , P1 * STR_FOU( X, P3,P4,P5,P6,P7, LOOP=8), X ) ;F.O.U'
                           npp  =7 & fixpi=[0,0,0,0,1,0,0] & txtpi=['P1.ampli','P2.pos','P3.X2','P4.D','P5.Q','P6.Alpha','P7.Tau']
                                     valpi=['Amplitude: 1 >0','Center: 0 ','X2: ','D: ','Q:(Q)^2','Alpha: ','Tau: ']
                           editf=1 & end
;***************

;SANS HARD SPHERE structure
                 21: begin & formu='Y= STR_HARD_SPHERE( X, P1, P2 ) ;(*)SANS HARD SPHERE structure'
                           npp  =2 & fixpi=[0,0] & txtpi=['P1.VolumeFraction','P2.SphereRadius']
                                     valpi=['Fp: .5 <.99','Rhs: 50 ']
                           editf=0 & end
;SANS MULTI LAMELLAR thermal disorder
                 22: begin & formu='Y= STR_MULTILAM( X, P1, P2, P3, P4, /TD) ;(*)SANS MULTI LAMELLAR (TD) structure'
                           npp  =4 & fixpi=[0,0,0,0] & txtpi=['P1.Stacks','P2.Dist','P3.DWd','P4.Nu']
                                     valpi=['Stacks:10 >2','Distance: 20 >1','Disorder:2 >0','Nu: >0']
                           editf=0 & end
;SANS MULTI LAMELLAR paracrystalline
                 23: begin & formu='Y= STR_MULTILAM( X, P1, P2, P3, P4, /PC) ;(*)SANS MULTI LAMELLAR (PC) structure'
                           npp  =4 & fixpi=[0,0,0,0] & txtpi=['P1.Stacks','P2.Dist','P3.DWd','P4.Nu']
                                     valpi=['Stacks:10 >2','Distance: 20 >1','Disorder:2 >0','Nu: >0']
                           editf=0 & end
;SANS MULTI LAMELLAR modified Caillé
                 24: begin & formu='Y= STR_MULTILAM( X, P1, P2, P3, P4, /MC) ;(*)SANS MULTI LAMELLAR (MC) structure'
                           npp  =4 & fixpi=[0,0,0,0] & txtpi=['P1.Stacks','P2.Dist','P3.Cai','P4.Nu']
                                     valpi=['Stacks:10 >2','Distance: 20 >1','CAILLE: .2 >0','Nu: >0']
                           editf=0 & end
;SANS MEAN SPHERICAL APPROXIMATION
                 25: begin & formu='Y= STR_MSA( X, P1, P2, P3, P4, P5, P6) ;(*)SANS MSA structure (Hayter-Penfold)'
                           npp  =6 & fixpi=[0,0,0,0,1,1] & txtpi=['P1.ETAv','P2.Rd','P3.z','P4.k','P5.T','P6.Epsr']
                                     valpi=['ETA: .3 >0 <.99','Rhs: 25 >0','Z: 20. >0','k: .04 >0','T:298 >0','Epsr: 80 >0']
                           Pexplain[1]='Volume fraction of Particules'
                           Pexplain[2]='Radius of Particule'
                           Pexplain[3]='Charge in e units'
                           Pexplain[4]='Debye-Huckel inverse screening length'
                           Pexplain[5]='Temperature in Kelvin'
                           Pexplain[6]='Dielectric constant of Solvent'
                           editf=0 & end

;SANS GUINIER APPROXIMATION
                 30: begin & formu='Y = P1* EXP(-((((X*P2)^2)/3.)<70.)) ;SANS Guinier approximation'
                           npp  =2 & fixpi=[0,0] & txtpi=['P1.I0','P2.Radius']
                                     valpi=['I0: 1.','Rg: 50 ']
                           editf=1 & end
;SANS POROD LIMIT
                 31: begin & formu='Y = P1/(X^4) ;SANS Porod limit'
                           npp  =1 & fixpi=[0] & txtpi=['P1.Scale']
                                     valpi=['Scale: 1']
                           editf=1 & end
;SANS POWER LAW
                 32: begin & formu='Y = P1/(X^P2) ;SANS Power Law'
                           npp  =2 & fixpi=[0,0] & txtpi=['P1.Scale','P2.Power']
                                     valpi=['Scale: 1.','m: 4. ']
                           editf=1 & end
;SANS DEBYE (LINEAR POLYMER CHAIN)
                 33: begin & formu='QRg=(X*P2)^2 & Y = P1*2.*(exp(-(QRg<70.))+QRg-1.)/QRg^2 ;SANS Debye (Linear Polymer Chain)'
                           npp  =2 & fixpi=[0,0] & txtpi=['P1.Scale','P2.Radius']
                                     valpi=['Scale: 1.','Rg: 50 ']
                           editf=1 & end
;SANS TEUBNER-STREY
                 34: begin & formu='Y = P1 /(1.+ P2*X^2 + P3*X^4) ;SANS Teubner Strey'
                           npp  =3 & fixpi=[0,0,0] & txtpi=['P1.Scale','P2.C1','P3.C2']
                                     valpi=['Scale: 1.','C1: -1 ','C2: 1']
                           editf=1 & end

;SANS Bilayer VESICLE, PolyName= 'SANS_Bilayer_VESICLE'
                 41: begin & formu='Y= STR_VESICLE(X, P1, P2, P3, P4, P5, P6, P7) ;SANS Bilayer VESICLE'
                           npp  =7 & fixpi=[0,0,0,0,0,0,0] & txtpi=['P1.Radius','P2.Ro','P3.T','P4.Nsol','P5.Nh','P6.Nt','P7.DeltaR']
                                     valpi=['Radius: 100 >1','ThickIN: 1 >0 ','ThickLayer: 1 >0 ','sldSOLV:1>0','sldI:1>0','sldLAYER: 1 >0','DeltaR: 1 >.001']
                           Pexplain[1]='Inner Solvent Radius'
                           Pexplain[2]='Layer Solvent Thickness'
                           Pexplain[3]='Layer Thickness'
                           Pexplain[4]='SLD Solvent'
                           Pexplain[5]='SLD Layer Solvent'
                           Pexplain[6]='SLD Layer'
                           Pexplain[7]='Delta Inner Solvent Radius'
                           editf=0 & end
;SANS SHELL with Linear varying constrast, PolyName= 'SANS_Sphere_SHELL'
                 42: begin & formu='Y= STR_LINSHELL(X, P1, P2, P3, P4, P5, P6, P7, P8) ;SANS LINEAR VARYING SHELL'
                           npp  =8 & fixpi=[0,0,0,0,0,0,0,0] & txtpi=['P1.Radius','P2.T','P3.Sin','P4.Sout','P5.sldS','P6.sldC','P7.sldSH','P8.DeltaR']
                                     valpi=['Radius: 30 >1','ThickLayer: 10 >0 ','SolvIn: 1 >0 ','SolvOut:1>0 ','sldS:0>0','sldCore: 1 >0','sldPureSh: 1 >0','DeltaR: 1 >.001']
                           Pexplain[1]='Inner Solvent Radius'
                           Pexplain[2]='Shell Thickness'
                           Pexplain[3]='Inner amount of Solvent in Shell'
                           Pexplain[4]='outer amount of Solvent in Shell'
                           Pexplain[5]='SLD Solvent'
                           Pexplain[6]='SLD Core Shell'
                           Pexplain[7]='SLD Pure Shell'
                           Pexplain[8]='Delta Inner Solvent Radius'
                           editf=0 & end
;SANS Multi Lamelar VESICLE, PolyName= 'SANS_Multi_Lam_VESICLE'
                 43: begin & formu='Y= STR_Mlam_Vesicle(X, P1, P2, P3, P4, P5, P6, P7, P8) ;SANS MULTI LAMELLAR VESICULE'
                           npp  =8 & fixpi=[0,0,0,0,0,0,1,0] & txtpi=['P1.Inner','P2.S_thick','P3.L_thick','P4.sldS','P5.sldL','P6.Nlayer','P7.delta_in','P8.Delta_Solv_thick']
                                     valpi=['RSol_in: 30 >.01','S_thick: 10 >.01 ','L_thick: 1 >.01 ','sldS:1 >0 ','sldL:1 >0','Nlayer: 2 >2','DeltaR: 0','DeltaR: 1 >.001']
                           Pexplain[1]='Inner Solvent Radius'
                           Pexplain[2]='Layer Solvent Thickness'
                           Pexplain[3]='Layer Thickness'
                           Pexplain[4]='SLD Solvent'
                           Pexplain[5]='SLD Layer'
                           Pexplain[6]='number of Layers'
                           Pexplain[7]='Delta Inner Solvent Radius'
                           Pexplain[8]='Delta Solvent Thickness'
                           editf=0 & end
;SANS ELLIPSOID, PolyName= 'SANS_ELLIPSOID'
                 44: begin & formu='Y= STR_ELLIPSOID(X, P1, P2, P3, P4, LOOP=50) ;SANS ELLIPSOID'
                           npp  =4 & fixpi=[0,0,0,0] & txtpi=['P1.Sld','P2.Radius','P3.Ratio','P4.dR']
                                     valpi=['Density: 1 >0','Radius: 20 >0','Ra/Rb: 1 >0','dR:1>.001']
                           editf=1 & end
;SANS STAR POLYMER, PolyName= 'SANS_STAR_Polymer'
                 46: begin & formu='Y = STR_STARPOLYGAUSS(X, P1, P2, P3, P4) ;SANS STAR Polymer'
                           npp  =4 & fixpi=[0,0,0,0] & txtpi=['P1.Scale','P2.gRadius','P3.nArms','P4.dR']
                                     valpi=['I0: 1 >0','Rg: 20 >1','Arms: 16>2','dR:1>.001']
                           editf=1 & end
;SANS STAR Polydisperse POLYMER, PolyName= 'SANS_STAR_PolyPoly'
                 47: begin & formu='Y = STR_STARPOLYPOLYG(X, P1, P2, P3, P4) ;SANS STAR Polydisperse Polymer'
                           npp  =4 & fixpi=[0,0,0,0] & txtpi=['P1.Scale','P2.gRadius','P3.nArms','P4.dR']
                                     valpi=['I0: 1 >0','Rg: 20 >1','Arms: 16>2','dR:1>.001']
                           editf=1 & end
;SANS DISK, PolyName= 'SANS_DISK'
                 48: begin & formu='Y = STR_DISK(X, P1, P2, P3) ;SANS DISK'
                           npp  =3 & fixpi=[0,0,0] & txtpi=['P1.ScatContrast','P2.Radius','P3.DeltaR']
                                     valpi=['Density: 1.','R: 50 >1','dR: 20>.001<100']
                           editf=0 & end
;SANS ROD, PolyName= 'SANS_ROD'
                 49: begin & formu='Y = STR_ROD( X, P1, P2, P3) ;SANS ROD'
                           npp  =3 & fixpi=[0,0,0] & txtpi=['P1.ScatContrast','P2.Length','P3.DeltaL']
                                     valpi=['Density: 1.','L: 50 >1','dL: 20>.001<100']
                           editf=0 & end
;***************

;QENS_Delta
                 70: begin & formu ='Y = QENS_Delta(X, P1, P2, P3, P4) ;QENS Delta'
                           npp     = 4                                                 ;Number of parameters
                           editf   = 0                                                 ;Not editable formula
                           fixpi   = [0,0,0,0]                                         ;Fixed params (definitively)
                           txtpi   = ['P1.scale', 'P2.u2', 'P3.pos', 'P4.fract']       ;Parameter's Names
                           valpi   = ['I: 1 >0', 'u2: 0 >0', 'C: 0', 'W: 1 >0<1']        ;Initial values
                           Pexplain[1] = 'Scaling factor'                              ;Tracking explanation event
                           Pexplain[2] = 'u^2 for DW term'
                           Pexplain[3] = 'Position'
                           Pexplain[4] = 'Fraction of atoms'
                     end

;QENS_Lorentz
                 71: begin & formu ='Y = QENS_Lorentz(X, P1, P2, P3, P4, P5) ;QENS Lorentzian'
                           npp     = 5                                                              ;Number of parameters
                           editf   = 0                                                              ;Not editable formula
                           fixpi   = [0,0,0,0,0]                                                    ;Fixed params (definitively)
                           txtpi   = ['P1.scale', 'P2.u2', 'P3.pos', 'P4.fraction', 'P5.hwhm']      ;Parameter's Names
                           valpi   = ['I: 1 >0', 'u2: 0 >0', 'C: 0', 'W: 1 >0<1', 'G: 0.1 >0']     ;Initial values
                           Pexplain[1] = 'Scaling factor'                                           ;Tracking explanation event
                           Pexplain[2] = 'u^2 for DW term'
                           Pexplain[3] = 'Position'
                           Pexplain[4] = 'Fraction of atoms'
                           Pexplain[5] = 'HWHM'
                     end

;QENS_Gauss
                 72: begin & formu ='Y = QENS_Gauss(X, P1, P2, P3, P4, P5) ;QENS Gaussian'
                           npp     = 5                                                               ;Number of parameters
                           editf   = 0                                                               ;Not editable formula
                           fixpi   = [0,0,0,0,0]                                                     ;Fixed params (definitively)
                           txtpi   = ['P1.scale', 'P2.u2', 'P3.pos', 'P4.fraction', 'P5.sigma']      ;Parameter's Names
                           valpi   = ['I: 1 >0', 'u2: 0 >0', 'C: 0', 'W: 1 >0<1', 'S: 0.1 >0']     ;Initial values
                           Pexplain[1] = 'Scaling factor'                                            ;Tracking explanation event
                           Pexplain[2] = 'u^2 for DW term'
                           Pexplain[3] = 'Position'
                           Pexplain[4] = 'Fraction of atoms'
                           Pexplain[5] = 'sigma'
                     end

;QENS Random Walk Translation
                 73: begin & formu ='Y = QENS_RandomWalkTranslation(X, P1, P2, P3, P4, P5) ;QENS Continuous diffusion model'
                           npp     = 5                                                             ;Number of parameters
                           editf   = 0                                                             ;Not editable formula
                           fixpi   = [0,0,0,0,0]                                                   ;Fixed params (definitively)
                           txtpi   = ['P1.scale', 'P2.u2', 'P3.pos', 'P4.fraction', 'P5.D']        ;Parameter's Names
                           valpi   = ['I: 1 >0', 'u2: 0 >0', 'C: 0', 'W: 1 >0<1','D: 0.1 >0']        ;Initial values
                           Pexplain[1] = 'Scaling factor'                                          ;Tracking explanation event
                           Pexplain[2] = 'u^2 for DW term'
                           Pexplain[3] = 'Position'
                           Pexplain[4] = 'Fraction of atoms'
                           Pexplain[5] = 'Self-diffusion coefficient (in E/Q^2 units)'
                     end
                     
;QENS Jump Diffusion Translation
                 74: begin & formu ='Y = QENS_JumpDiffusionTranslation(X, P1, P2, P3, P4, P5, P6) ;QENS Jump-diffusion model'
                           npp     = 6                                                                  ;Number of parameters
                           editf   = 0                                                                  ;Not editable formula
                           fixpi   = [0,0,0,0,0,0]                                                      ;Fixed params (definitively)
                           txtpi   = ['P1.scale', 'P2.u2', 'P3.pos', 'P4.fraction', 'P5.D', 'P6.ResidTime'] ;Parameter's Names
                           valpi   = ['I: 1 >0', 'u2: 0 >0', 'C: 0', 'W: 1 >0<1', 'D: 0.1 >0', 'T: 1 >0'] ;Initial values
                           Pexplain[1] = 'Scaling factor'                                               ;Tracking explanation event
                           Pexplain[2] = 'u^2 for DW term'
                           Pexplain[3] = 'Position'
                           Pexplain[4] = 'Fraction of atoms'
                           Pexplain[5] = 'Self-diffusion coefficient (in E/Q^2 units)'
                           Pexplain[6] = 'Residence time (in 1/E units)'
                           end

;QENS Chudley-Elliot model for jump Diffusion Translation
                 75: begin & formu ='Y = QENS_ChudleyElliot(X, P1, P2, P3, P4, P5, P6) ;QENS Chudley-Elliot model'
                           npp     = 6                                                                  ;Number of parameters
                           editf   = 0                                                                  ;Not editable formula
                           fixpi   = [0,0,0,0,0,0]                                                      ;Fixed params (definitively)
                           txtpi   = ['P1.scale', 'P2.u2', 'P3.pos', 'P4.fraction', 'P5.L', 'P6.ResidTime'] ;Parameter's Names
                           valpi   = ['I: 1 >0', 'u2: 0 >0', 'C: 0', 'W: 1 >0<1', 'L: 1 >0', 'T: 1 >0'] ;Initial values
                           Pexplain[1] = 'Scaling factor'                                               ;Tracking explanation event
                           Pexplain[2] = 'u^2 for DW term'
                           Pexplain[3] = 'Position'
                           Pexplain[4] = 'Fraction of atoms'
                           Pexplain[5] = 'Jump distance (in 1/Q units)'
                           Pexplain[6] = 'Residence time (in 1/E units)'
                     end
                     
;QENS_JumpsNsites
                 76: begin & formu ='Y = QENS_JumpsNsites(X, P1, P2, P3, P4, P5, P6, P7) ;QENS jumps between equivalent sites in a circle'
                           npp     = 7                                                           ;Number of parameters
                           editf   = 0                                                           ;Not editable formula
                           fixpi   = [0,0,0,0,0,0,0]                                             ;Fixed params (definitively)
                           txtpi   = ['P1.scale', 'P2.u2', 'P3.pos', 'P4.fraction', 'P5.sites', 'P6.radius', 'P7.ResidTime']  ;Parameter Names
                           valpi   = ['I: 1 >0', 'u2: 0 >0', 'C: 0', 'W: 1 >0<1', 'N:', 'R: 1 >0', 'T: 1 >0'] ;Initial values
                           Pexplain[1] = 'Scaling factor'                                        ;Tracking explanation event
                           Pexplain[2] = 'u^2 for DW term'
                           Pexplain[3] = 'Position'
                           Pexplain[4] = 'Fraction of atoms'
                           Pexplain[5] = 'Number of sites (integer, fixed value)'
                           Pexplain[6] = 'Radius of circle  (in 1/Q units)'
                           Pexplain[7] = 'Residence time between 2 jumps (in 1/E units)'
                     end

;QENS_JumpsNsitesLogNormDist
                 77: begin & formu ='Y = QENS_JumpsNsitesLogNormDist(X, P1, P2, P3, P4, P5, P6, P7, P8) ;QENS JumpsNsites with a log-norm distribution of relaxation times'
                           npp     = 8                                                           ;Number of parameters
                           editf   = 0                                                           ;Not editable formula
                           fixpi   = [0,0,0,0,0,0,0,0]                                           ;Fixed params (definitively)
                           txtpi   = ['P1.scale', 'P2.u2', 'P3.pos', 'P4.fraction', 'P5.sites', 'P6.radius', 'P7.ResidTime', 'P8.sigma']  ;Parameter Names
                           valpi   = ['I: 1 >0', 'u2: 0 >0', 'C: 0', 'W: 1 >0<1', 'N:', 'R: 1 >0', 'T: 1 >0', 'S: 0.1 >0']    ;Initial values
                           Pexplain[1] = 'Scaling factor'                                        ;Tracking explanation event
                           Pexplain[2] = 'u^2 for DW term'
                           Pexplain[3] = 'Position'
                           Pexplain[4] = 'Fraction of atoms'
                           Pexplain[5] = 'Number of sites (integer, fixed value)'
                           Pexplain[6] = 'Radius of circle (in 1/Q units)'
                           Pexplain[7] = 'Residence time between 2 jumps (in 1/E units)'
                           Pexplain[8] = 'Sigma of the log-norm distribution'
                     end

;QENS_IsotropicRotationalDiffusion
                 78: begin & formu = 'Y = QENS_IsotropicRotationalDiffusion(X, P1, P2, P3, P4, P5, P6) ;QENS Isotropic rotational diffusion in a sphere of radius R'
                           npp     = 6                                                           ;Number of parameters
                           editf   = 0                                                           ;Not editable formula
                           fixpi   = [0,0,0,0,0,0]                                               ;Fixed params (definitively)
                           txtpi   = ['P1.scale', 'P2.u2', 'P3.pos', 'P4.fraction', 'P5.radius', 'P6.Dr']  ;Parameter Names
                           valpi   = ['I: 1 >0', 'u2: 0 >0' , 'C: 0', 'W: 1 >0<1', 'R: 1 >0', 'DR: 1 >0'] ;Initial values
                           Pexplain[1] = 'Scaling factor'                                        ;Tracking explanation event
                           Pexplain[2] = 'u^2 for DW term'
                           Pexplain[3] = 'Position'
                           Pexplain[4] = 'Fraction of atoms'
                           Pexplain[5] = 'Radius of the sphere (in 1/Q units)'
                           Pexplain[6] = 'Rotational diffusion constant (in E units)'
                     end
                     
                     
;QENS RotTrans
                 79: begin & formu ='Y = QENS_RotTrans( X, P1, P2, P3, P4, P5, P6, P7, P8) ;QENS jump-diffusion translation + isotropic rotational diffusion'
                           npp     = 8                                                                 ;Number of parameters
                           editf   = 0                                                                 ;Not editable formula
                           fixpi   = [0,0,0,0,0,0,0,0]                                                 ;Fixed params (definitively)
                           txtpi   = ['P1.scale', 'P2.u2', 'P3.pos', 'P4.fraction', 'P5.D', 'P6.ResidTime', 'P7.radius', 'P8.Dr' ] ;Parameter's Names
                           valpi   = ['I: 1 >0', 'u2: 0 >0' , 'C: 0', 'W: 1 >0<1', 'D: 0.1 >0', 'T: 1 >0', 'R: 1 >0'  , 'DR: 1 >0']    ;Initial values
                           Pexplain[1] = 'Scaling factor'                                              ;Tracking explanation event
                           Pexplain[2] = 'u^2 for DW term'
                           Pexplain[3] = 'Position'
                           Pexplain[4] = 'Fraction of atoms'
                           Pexplain[5] = 'Self-diffusion coefficient (in E/Q^2 units)'
                           Pexplain[6] = 'Residence time (in 1/E units)'
                           Pexplain[7] = 'Radius of circle (in 1/Q units)'
                           Pexplain[8] = 'Rotational diffusion constant (in E units)'
                     end
                           
;QENS_3DLocalizedTranslation
                 80: begin & formu ='Y = QENS_3DLocalizedTranslation(X, P1, P2, P3, P4, P5, P6) ;QENS Gaussian model for localized translational motion (3D)'
                           npp     = 6                                                           ;Number of parameters
                           editf   = 0                                                           ;Not editable formula
                           fixpi   = [0,0,0,0,0,0]                                               ;Fixed params (definitively)
                           txtpi   = ['P1.scale', 'P2.u2', 'P3.pos' , 'P4.fraction', 'P5.D', 'P6.Variance']  ;Parameter Names
                           valpi   = ['I: 1 > 0', 'u2: 0 >0', 'C: 0.', 'W: 1 >0<1', 'D: 0.1 >0', 'V: 0.5 >0'] ;Initial values
                           Pexplain[1] = 'Scaling factor'                                        ;Tracking explanation event
                           Pexplain[2] = 'u^2 for DW term'
                           Pexplain[3] = 'Position'
                           Pexplain[4] = 'Fraction of atoms'
                           Pexplain[5] = 'Self-diffusion coefficient (in E/Q^2 units)'
                           Pexplain[6] = 'Variance [<Ux^2>] (in 1/Q^2 units) defining confinement region'
                     end
                           
;***************

;QENS_DeltaLorentz
                 81: begin & formu ='Y = QENS_DeltaLorentz(X, P1, P2, P3, P4, P5) ;QENS Delta + 1 Lorentz'
                           npp     = 5                                                           ;Number of parameters
                           editf   = 0                                                           ;Not editable formula
                           fixpi   = [0,0,0,0,0]                                                 ;Fixed params (definitively)
                           txtpi   = ['P1.scale', 'P2.u2', 'P3.pos', 'P4.DeltaFract', 'P5.hwhm'] ;Parameter's Names
                           valpi   = ['I: 1 >0', 'u2: 0 >0' , 'C: 0.', 'W: 1 >0<1', 'G: 0.1 >0'] ;Initial values
                           Pexplain[1] = 'Scaling factor'                                        ;Tracking explanation event
                           Pexplain[2] = 'u^2 for DW term'
                           Pexplain[3] = 'Position'
                           Pexplain[4] = 'Fraction of atoms contributing to delta'
                           Pexplain[5] = 'HWMH of Lorentzian'
                     end
                     
;QENS_DeltaLorentz2
                 82: begin & formu ='Y = QENS_DeltaLorentz2(X, P1, P2, P3, P4, P5, P6, P7) ;QENS Delta + 2 Lorentz'
                           npp     = 7                                                           ;Number of parameters
                           editf   = 0                                                           ;Not editable formula
                           fixpi   = [0,0,0,0,0,0,0]                                             ;Fixed params (definitively)
                           txtpi   = ['P1.scale', 'P2.u2', 'P3.pos', 'P4.DeltaFract', 'P5.Lor1Fract', 'P6.hwhm1', 'P7.hwhm2']  ;Parameter Names
                           valpi   = ['I: 1 >0', 'u2: 0 >0', 'C: 0', 'WD: 0.5 >0<1', 'WL1: 0.5 >0<1', 'G1: 0.1 >0', 'G2: 0.5 >0'] ;Initial values
                           Pexplain[1] = 'Scaling factor'                                        ;Tracking explanation event
                           Pexplain[2] = 'u^2 for DW term'
                           Pexplain[3] = 'Position'
                           Pexplain[4] = 'Fraction of atoms contributing to delta'
                           Pexplain[5] = 'Fraction of atoms contributing to first Lorentzian'
                           Pexplain[6] = 'HWMH of first Lorentzian'
                           Pexplain[7] = 'HWMH of second Lorentzian'
                     end

;QENS_DeltaLorentz2b
                 83: begin & formu ='Y = QENS_DeltaLorentz2b(X, P1, P2, P3, P4, P5, P6, P7) ;QENS Delta + 2 Lorentz'
                           npp     = 7                                                           ;Number of parameters
                           editf   = 0                                                           ;Not editable formula
                           fixpi   = [0,0,0,0,0,0,0]                                             ;Fixed params (definitively)
                           txtpi   = ['P1.scale', 'P2.u2', 'P3.pos', 'P4.DeltaFract', 'P5.Lor1Fract', 'P6.hwhm1', 'P7.hwhm2']  ;Parameter Names
                           valpi   = ['I: 1 >0', 'u2: 0 >0', 'C: 0', 'WL1: 0.5 >0<1', 'WL2: 0.5 >0<1', 'G1: 0.1 >0', 'G2: 0.5 >0'] ;Initial values
                           Pexplain[1] = 'Scaling factor'                                        ;Tracking explanation event
                           Pexplain[2] = 'u^2 for DW term'
                           Pexplain[3] = 'Position'
                           Pexplain[4] = 'Fraction of atoms contributing to first Lorentzian'
                           Pexplain[5] = 'Fraction of atoms contributing to second Lorentzian'
                           Pexplain[6] = 'HWMH of first Lorentzian'
                           Pexplain[7] = 'HWMH of second Lorentzian'
                   end

;QENS_Gauss2
                 84: begin & formu ='Y = QENS_Gauss2(X, P1, P2, P3, P4, P5, P6, P7) ;QENS 2 Gaussians'
                           npp     = 7                                                           ;Number of parameters
                           editf   = 0                                                           ;Not editable formula
                           fixpi   = [0,0,0,0,0,0,0]                                             ;Fixed params (definitively)
                           txtpi   = ['P1.scale', 'P2.u2', 'P3.G1pos', 'P4.G1Fract', 'P5.G1sigma', 'P6.G2pos', 'P7.G2sigma']  ;Parameter Names
                           valpi   = ['I: 1 >0', 'u2: 0 >0', 'CG1: 0', 'WG1: 0.5 >0<1', 'SG1: 0.1 >0', 'CG2: 0', 'SG2: 0.5 >0'] ;Initial values
                           Pexplain[1] = 'Scaling factor'                                        ;Tracking explanation event
                           Pexplain[2] = 'u^2 for DW term'
                           Pexplain[3] = 'Position of first Gaussian'
                           Pexplain[4] = 'Fraction of atoms contributing to first Gaussian'
                           Pexplain[5] = 'Sigma of first Gaussian'
                           Pexplain[6] = 'Position of second Gaussian'
                           Pexplain[7] = 'Sigma of second Gaussian'
                 end

;QENS_Gauss3
                 85: begin & formu ='Y = QENS_Gauss3(X, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10) ;QENS 3 Gaussians'
                           npp     = 10                                                          ;Number of parameters
                           editf   = 0                                                           ;Not editable formula
                           fixpi   = [0,0,0,0,0,0,0,0,0,0]                                             ;Fixed params (definitively)
                           txtpi   = ['P1.scale', 'P2.u2', 'P3.G1pos', 'P4.G1Fract', 'P5.G1sigma', $
                                      'P6.G2pos', 'P7.G2Fract', 'P8.G2sigma', 'P9.G3pos', 'P10.G3sigma']  ;Parameter Names
                           valpi   = ['I: 1 >0', 'u2: 0 >0', 'CG1: 0', 'WG1: 0.5 >0<1', 'SG1: 0.1 >0', $
                                      'CG2: 0', 'WG2: 0.5 >0<1', 'SG2: 0.5 >0', 'CG3: 0', 'SG3: 1 >0']    ;Initial values
                           Pexplain[1] = 'Scaling factor'                                        ;Tracking explanation event
                           Pexplain[2] = 'u^2 for DW term'
                           Pexplain[3] = 'Position of first Gaussian'
                           Pexplain[4] = 'Fraction of atoms contributing to first Gaussian'
                           Pexplain[5] = 'Sigma of first Gaussian'
                           Pexplain[6] = 'Position of second Gaussian'
                           Pexplain[7] = 'Fraction of atoms contributing to second Gaussian'
                           Pexplain[8] = 'Sigma of second Gaussian'
                           Pexplain[9] = 'Position of third Gaussian'
                           Pexplain[10] = 'Sigma of third Gaussian'
                     end


;QENS Fraction of fixed atoms + Chudley-Elliot model for jump Diffusion Translation
                 86: begin & formu ='Y = QENS_DeltaChudleyElliot(X, P1, P2, P3, P4, P5, P6) ;QENS Delta + Chudley-Elliot model'
                           npp     = 6                                                                  ;Number of parameters
                           editf   = 0                                                                  ;Not editable formula
                           fixpi   = [0,0,0,0,0,0]                                                      ;Fixed params (definitively)
                           txtpi   = ['P1.scale', 'P2.u2', 'P3.pos', 'P4.fraction', 'P5.L', 'P6.ResidTime'] ;Parameter's Names
                           valpi   = ['I: 1 >0', 'u2: 0 >0', 'C: 0', 'W: 0.5 >0<1', 'L: 1 >0', 'T: 1 >0'] ;Initial values
                           Pexplain[1] = 'Scaling factor'                                               ;Tracking explanation event
                           Pexplain[2] = 'u^2 for DW term'
                           Pexplain[3] = 'Position'
                           Pexplain[4] = 'Fraction of fixed atoms'
                           Pexplain[5] = 'Jump distance (in 1/Q units)'
                           Pexplain[6] = 'Residence time (in 1/E units)'
                     end

;QENS_Natali
                 87: begin & formu ='Y = QENS_Natali(X, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10, P11, P12, P13, P14, P15) ;QENS Water in biomolecular systems'
                           npp     = 15                                                          ;Number of parameters
                           editf   = 0                                                           ;Not editable formula
                           fixpi   = [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]                             ;Fixed params (definitively)
                           txtpi   = ['P1.scale', 'P2.u2', 'P3.pos', 'P4.fract', 'P5.fract', 'P6.D', 'P7.ResidTime' , $  ;Parameter Names
                                      'P8.radius', 'P9.DR', 'P10.fract', 'P11.D', 'P12.ResidTime', 'P13.radius' , $
                                      'P14.DR' , 'P15.HWHM']
                           valpi   = ['I: 1 >0', 'u2: 0 >0', 'C: 0', 'f0: 0.5 >0<1' , 'f1: 0.3 >0<1', $ ;Initial values
                                      'D1: 0.1 >0', 'T1: 1 >0', 'R1: 1 >0', 'DR1: 1 >0', 'f2: 0.2 >0<1', $
                                      'D2: 0.5 >0', 'T2: 2 >0', 'R2: 1 >0', 'DR2: 2 >0', 'G3: 3 >0']
                           Pexplain[1]  = 'Intensity scaling (arbitrary units).'
                           Pexplain[2]  = 'u^2 for DW term'
                           Pexplain[3]  = 'Position'
                           Pexplain[4]  = 'Fraction of immobile protons [f0]'
                           Pexplain[5]  = 'Fraction of protons contributing to 1st roto-translational Lorentzian [f1]'
                           Pexplain[6]  = 'Self-diffusion constant [D] (in E/Q^2 units) for free water'
                           Pexplain[7]  = 'Residence time (in 1/E units) for free water'
                           Pexplain[8]  = 'Radius (in 1/Q units) of the sphere of rotation for free water (usually fixed to 1)'
                           Pexplain[9]  = 'Rotational diffusion constant (in E units) for free water'
                           Pexplain[10] = 'Fraction of protons contributing to 2nd roto-translational Lorentzian [f2]'
                           Pexplain[11] = 'Self-diffusion constant [D] (in E/Q^2 units) for restricted water.'
                           Pexplain[12] = 'Residence time (in 1/E units) for restricted water.'
                           Pexplain[13] = 'Radius (in 1/Q units) of the sphere of rotation for restricted water (usually fixed to 1).'
                           Pexplain[14] = 'Rotational diffusion constant (in E units) for restricted water.'
                           Pexplain[15] = 'HWHM (in E units) of 3rd Lorentzian related to a faster relaxation.'
                     end
                     
;QENS_Iri
                 88: begin & formu ='Y = QENS_Iri(X, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10, P11) ;QENS Water in biomolecular systems (No water rotation)'
                           npp     = 11                                                          ;Number of parameters
                           editf   = 0                                                           ;Not editable formula
                           fixpi   = [0,0,0,0,0,0,0,0,0,0,0]                                     ;Fixed params (definitively)
                           txtpi   = ['P1.scale', 'P2.u2', 'P3.pos', 'P4.fract', 'P5.fract', 'P6.D', 'P7.ResidTime' , $  ;Parameter Names
                                      'P8.fract', 'P9.D', 'P10.ResidTime', 'P11.HWHM']
                           valpi   = ['I: 1 >0', 'u2: 0 >0', 'C: 0', 'f0: 0.5 >0<1' , 'f1: 0.3 >0<1', $ ;Initial values
                                      'D1: 0.1 >0', 'T1: 1 >0', 'f2: 0.2 >0<1', 'D2: 0.5 >0', 'T2: 2 >0', 'G3: 3 >0']
                           Pexplain[1]  = 'Intensity scaling (arbitrary units).'
                           Pexplain[2]  = 'u^2 for DW term'
                           Pexplain[3]  = 'Position'
                           Pexplain[4]  = 'Fraction of immobile protons [f0]'
                           Pexplain[5]  = 'Fraction of protons contributing to 1st translational Lorentzian [f1]'
                           Pexplain[6]  = 'Self-diffusion constant [D] (in E/Q^2 units) for free water'
                           Pexplain[7]  = 'Residence time (in 1/E units) for free water'
                           Pexplain[8] = 'Fraction of protons contributing to 2nd translational Lorentzian [f2]'
                           Pexplain[9] = 'Self-diffusion constant [D] (in E/Q^2 units) for restricted water.'
                           Pexplain[10] = 'Residence time (in 1/E units) for restricted water.'
                           Pexplain[11] = 'HWHM (in E units) of 3rd Lorentzian related to a faster relaxation.'
                     end
                     
;QENS_Iri2
                 89: begin & formu ='Y = QENS_Iri2(X, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10) ;QENS Water in biomolecular systems (Only 1 roto-translational component)'
                           npp     = 10                                                          ;Number of parameters
                           editf   = 0                                                           ;Not editable formula
                           fixpi   = [0,0,0,0,0,0,0,0,0,0]                                       ;Fixed params (definitively)
                           txtpi   = ['P1.scale', 'P2.u2', 'P3.pos', 'P4.fract', 'P5.fract', $
                                      'P6.D', 'P7.ResidTime' , 'P8.radius', 'P9.DR', 'P10.HWHM']
                           valpi   = ['I: 1 >0', 'u2: 0 >0', 'C: 0', 'f0: 0.5 >0<1' , 'f1: 0.3 >0<1', $ ;Initial values
                                      'D1: 0.1 >0', 'T1: 1 >0', 'R1: 1 >0', 'DR1: 1 >0', 'G2: 3 >0']
                           Pexplain[1]  = 'Intensity scaling (arbitrary units).'
                           Pexplain[2]  = 'u^2 for DW term'
                           Pexplain[3]  = 'Position'
                           Pexplain[4]  = 'Fraction of immobile protons [f0]'
                           Pexplain[5]  = 'Fraction of protons contributing to 1st roto-translational Lorentzian [f1]'
                           Pexplain[6]  = 'Self-diffusion constant [D] (in E/Q^2 units) for free water'
                           Pexplain[7]  = 'Residence time (in 1/E units) for free water'
                           Pexplain[8]  = 'Radius (in 1/Q units) of the sphere of rotation for free water (usually fixed to 1)'
                           Pexplain[9]  = 'Rotational diffusion constant (in E units) for free water'
                           Pexplain[10] = 'HWHM (in E units) of 2nd Lorentzian related to a faster relaxation.'
                           end
;QENS_IL1
                 90: begin & formu ='Y = QENS_IL1(X, P1, P2, P3, P4, P5, P6) ;QENS Ionic liquids (trans + 1 localized component)'
                           npp     = 6                                                           ;Number of parameters
                           editf   = 0                                                           ;Not editable formula
                           fixpi   = [0,0,0,0,0,0]                                               ;Fixed params (definitively)
                           txtpi   = ['P1.scale', 'P2.u2', 'P3.pos', 'P4.EISF', 'P5.hwhmT'  , 'P6.hwhmL'] ;Parameter Names
                           valpi   = ['I: 1 >0', 'u2: 0 >0', 'C: 0', 'EISF: 0.9 >0<1', 'GT: 0.1 >0', 'GL: 0.5 >0']  ;Initial values
                           Pexplain[1]  = 'Intensity scaling (arbitrary units).'
                           Pexplain[2]  = 'u^2 for DW term '
                           Pexplain[3]  = 'Position'
                           Pexplain[4]  = 'EISF of localized component (range [0, 1])'
                           Pexplain[5]  = 'HWHM (in E units) of translational component'
                           Pexplain[6]  = 'HWHM (in E units) of localized component'
                     end
                     
;QENS_IL2
                 91: begin & formu ='Y = QENS_IL2(X, P1, P2, P3, P4, P5, P6, P7, P8) ;QENS Ionic liquids (trans + 2 localized components)'
                           npp     = 8                                                           ;Number of parameters
                           editf   = 0                                                           ;Not editable formula
                           fixpi   = [0,0,0,0,0,0,0,0]                                           ;Fixed params (definitively)
                           txtpi   = ['P1.scale', 'P2.u2', 'P3.pos', 'P4.EISF1', 'P5.EISF2', 'P6.hwmhT', $
                                      'P7.hwmhL1', 'P8.hwmhL2'] ;Parameter Names
                           valpi   = ['I: 1 >0', 'u2: 0 >0', 'C: 0', 'E1: 0.9 >0<1', 'E2: 0.9 >0<1', $
                                      'GT: 0.1 >0', 'GL1: 0.3 >0', 'GL2: 1 >0']  ;Initial values
                           Pexplain[1]  = 'Intensity scaling (arbitrary units).'
                           Pexplain[2]  = 'u^2 for DW term'
                           Pexplain[3]  = 'Position'
                           Pexplain[4]  = 'EISF of 1st localized component (range [0, 1])'
                           Pexplain[5]  = 'EISF of 2nd localized component (range [0, 1])'
                           Pexplain[6]  = 'HWHM (in E units) of translational component'
                           Pexplain[7]  = 'HWHM (in E units) of 1st localized component'
                           Pexplain[8]  = 'HWHM (in E units) of 2nd localized component'
                     end
                     
;QENS_IL3
                 92: begin & formu ='Y = QENS_IL3(X, P1, P2, P3, P4, P5, P6, P7, P8, P9) ;QENS Ionic liquids (trans + localized trans (Volino) + local)'
                           npp     = 9                                                          ;Number of parameters
                           editf   = 0                                                           ;Not editable formula
                           fixpi   = [0,0,0,0,0,0,0,0,0]                                           ;Fixed params (definitively)
                           txtpi   = ['P1.scale', 'P2.u2', 'P3.pos', 'P4.D', 'P5.ResidTime', 'P6.Dconf', $
                                      'P7.Variance', 'P8.EISF', 'P9.hwhmL'] ;Parameter Names
                           valpi   = ['I: 1 >0', 'u2: 0 >0', 'C: 0', 'D: 0.1 >0', 'T: 1 >0', 'DC: 0.5 >0', $
                                      'V: 0.1 >0', 'EL: 0.9 >0<1', 'GL: 1 >0']  ;Initial values
                           Pexplain[1] = 'Intensity scaling (arbitrary units).'
                           Pexplain[2] = 'u^2 for DW term'
                           Pexplain[3] = 'Position'
                           Pexplain[4] = 'Self-diffusion constant [D] (in E/Q^2 units) for long-range translation'
                           Pexplain[5] = 'Residence time (in 1/E units) for long-range translation'
                           Pexplain[6] = 'Self-diffusion coefficient (in E/Q^2 units) for confined translation'
                           Pexplain[7] = 'Variance [<Ux^2>] (in 1/Q^2 units) for confined translation'
                           Pexplain[8] = 'EISF of localized component (range [0, 1])'
                           Pexplain[9] = 'HWHM (in E units) of localized component'
                     end
                    
;QENS_Fixed_JumpsNsites
                 93: begin & formu ='Y = QENS_Fixed_JumpsNsites(X, P1, P2, P3, P4, P5, P6, P7) ;QENS Fixed atoms + Jumps in N sites in circle'
                           npp     = 7                                                         ;Number of parameters
                           editf   = 0                                                           ;Not editable formula
                           fixpi   = [0,0,0,0,0,0,0]                                           ;Fixed params (definitively)
                           txtpi   = ['P1.scale', 'P2.u2', 'P3.pos', 'P4.fixed', 'P5.sites', 'P6.radius', 'P7.ResidTime'] ;Parameter Names
                           valpi   = ['I: 1 >0', 'u2: 0 >0', 'C: 0', 'f: 0.5 >0', 'N: ', 'R: 1 >0', 'T: 1 >0']  ;Initial values
                           Pexplain[1] = 'Intensity scaling (arbitrary units).'
                           Pexplain[2] = 'u^2 for DW term'
                           Pexplain[3] = 'Position'
                           Pexplain[4] = 'Fraction of fixed atoms'
                           Pexplain[5] = 'Number of sites (integer, fixed value)'
                           Pexplain[6] = 'Radius of circle  (in 1/Q units)'
                           Pexplain[7] = 'Residence time between 2 jumps (in 1/E units)'
                     end

;QENS_Fixed_2JumpsNsites
                 94: begin & formu ='Y = QENS_Fixed_2JumpsNsites(X, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10, P11) ;QENS Fixed atoms + Jumps in N & M sites in circle'
                           npp     = 11                                                         ;Number of parameters
                           editf   = 0                                                           ;Not editable formula
                           fixpi   = [0,0,0,0,0,0,0,0,0,0,0]                                           ;Fixed params (definitively)
                           txtpi   = ['P1.scale', 'P2.u2', 'P3.pos', 'P4.fraction', 'P5.sites', 'P6.radius', $
                                      'P7.ResidTime', 'P8.fraction', 'P9.sites', 'P10.radius', 'P11.ResidTime'] ;Parameter Names
                           valpi   = ['I: 1 >0', 'u2: 0 >0', 'C: 0', 'f1: 0.5 >0', 'N1: ', 'R1: 1 >0', 'T1: 1 >0', $
                                      'f2: 0.5 >0', 'N2: ', 'R2: 1 >0', 'T2: 1 >0']  ;Initial values
                           Pexplain[1] = 'Intensity scaling (arbitrary units).'
                           Pexplain[2] = 'u^2 for DW term'
                           Pexplain[3] = 'Position'
                           Pexplain[4] = 'Fraction of atoms rotating in circle 1'
                           Pexplain[5] = 'Number of sites in circle 1 (integer, fixed value)'
                           Pexplain[6] = 'Radius of circle 1 (in 1/Q units)'
                           Pexplain[7] = 'Residence time between 2 jumps in circle 1 (in 1/E units)'
                           Pexplain[8] = 'Fraction of atoms rotating in circle 2'
                           Pexplain[9] = 'Number of sites in circle 2 (integer, fixed value)'
                           Pexplain[10] = 'Radius of circle 2 (in 1/Q units)'
                           Pexplain[11] = 'Residence time between 2 jumps in circle 2 (in 1/E units)'
                     end

;QENS_Fixed_JumpsNsitesLogNormDist
                 95: begin & formu ='Y = QENS_Fixed_JumpsNsitesLogNormDist(X, P1, P2, P3, P4, P5, P6, P7, P8) ;QENS Fixed atoms + Jumps in N sites in circle with log-norm dist'
                           npp     = 8                                                        ;Number of parameters
                           editf   = 0                                                           ;Not editable formula
                           fixpi   = [0,0,0,0,0,0,0,0]                                           ;Fixed params (definitively)
                           txtpi   = ['P1.scale', 'P2.u2', 'P3.pos', 'P4.fixed', 'P5.sites', 'P6.radius', $
                                      'P7.ResidTime', 'P8.sigma'] ;Parameter Names
                           valpi   = ['I: 1 >0', 'u2: 0 >0', 'C: 0', 'f: 0.5 >0', 'N: ', 'R: 1 >0', 'T: 1 >0', 'S: 0.1 >0']  ;Initial values
                           Pexplain[1] = 'Intensity scaling (arbitrary units).'
                           Pexplain[2] = 'u^2 for DW term'
                           Pexplain[3] = 'Position'
                           Pexplain[4] = 'Fraction of fixed atoms'
                           Pexplain[5] = 'Number of sites (integer, fixed value)'
                           Pexplain[6] = 'Radius of circle  (in 1/Q units)'
                           Pexplain[7] = 'Residence time between 2 jumps (in 1/E units)'
                           Pexplain[8] = 'Sigma of log-norm distribution'
                     end

;QENS_Mix1
                 96: begin & formu ='Y = QENS_Mix1(X, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10, P11, P12) ;QENS delta + translation + confined translation + isotropic rotation'
                           npp     = 12                                                          ;Number of parameters
                           editf   = 0                                                           ;Not editable formula
                           fixpi   = [0,0,0,0,0,0,0,0,0,0,0,0]                                   ;Fixed params (definitively)
                           txtpi   = ['P1.scale', 'P2.u2', 'P3.pos', 'P4.fixed', 'P5.fraction', 'P6.D', 'P7.ResidTime' , $  ;Parameter Names
                                      'P8.fraction', 'P9.Dconf', 'P10.var', 'P11.radius', 'P12.DR']
                           valpi   = ['I: 1 >0', 'u2: 0 >0', 'C: 0', 'f0: 0.5 >0<1', 'f1: 0.3 >0<1', $ ;Initial values
                                      'D1: 0.1 >0', 'T1: 1 >0', 'f2: 0.2 >0<1', 'D2: 0.5 >0', 'S: 0.1 >0', $
                                      'R2: 1 >0', 'DR2: 2 >0']
                           Pexplain[1]  = 'Intensity scaling (arbitrary units).'
                           Pexplain[2]  = 'u^2 for DW term'
                           Pexplain[3]  = 'Position'
                           Pexplain[4]  = 'Fraction of immobile protons [f0]'
                           Pexplain[5]  = 'Fraction of protons contributing to 1st Lorentzian for long-range translation [f1]'
                           Pexplain[6]  = 'Self-diffusion constant [D] (in E/Q^2 units) for long-range translation'
                           Pexplain[7]  = 'Residence time (in 1/E units) for long-range translation'
                           Pexplain[8]  = 'Fraction of protons contributing to 2nd Lorentzian for confined translation [f2]'
                           Pexplain[9]  = 'Self-diffusion constant [D] (in E/Q^2 units) for confined translation'
                           Pexplain[10] = 'Variance (in 1/Q^2 units) defining size of confinement region'
                           Pexplain[11] = 'Radius (in 1/Q units) of the sphere of rotation '
                           Pexplain[12] = 'Rotational diffusion constant (in E units)'
                     end

                 endcase

                 bsf=115
                 form=widget_text(   row1,value=formu      ,font=ft_propor,xsize=bsf) & if editf then widget_control,form,editable=1
                 row2=widget_base(   rowt,/row)

                 k=0
                 but1=widget_button( widget_base(row2,/nonexclusive),value=txtpi[k],font=ft_propor,uvalue=[44,3,top,uv[3],row,k,uv[6]])
                 txt1=widget_text(   row2,value=' '        ,font=ft_propor,xsize=bsz,/edit)
                 if fixpi[k]              then widget_control,but1,set_button=1,sensitive=0
                 if valpi[k]      ne ' '  then widget_control,txt1,set_value=valpi[k]
                 if Pexplain[k+1] gt ' '  then widget_control,txt1,/tracking,set_uvalue=Pexplain[k+1]
                 uvff=[1L,uv[1],onfu]
                 uvff=[uvff,fixpi[k],txt1,but1]

                 if npp ge 2  then begin & k=k+1
                  lab =widget_label(  row2,value=','        ,font=ft_b_normal)
                  but2=widget_button( widget_base(row2,/nonexclusive),value=txtpi[k],font=ft_propor,uvalue=[44,3,top,uv[3],row,k,uv[6]])
                  txt2=widget_text(   row2,value=' '        ,font=ft_propor,xsize=bsz,/edit)
                  if fixpi[k]             then widget_control,but2,set_button=1,sensitive=0
                  if valpi[k]      ne ' ' then widget_control,txt2,set_value=valpi[k]
                  if Pexplain[k+1] gt ' ' then widget_control,txt2,/tracking,set_uvalue=Pexplain[k+1]
                  uvff=[uvff,fixpi[k],txt2,but2] & endif

                 if npp ge 3  then begin & k=k+1
                  lab =widget_label(  row2,value=','        ,font=ft_b_normal)
                  but3=widget_button( widget_base(row2,/nonexclusive),value=txtpi[k],font=ft_propor,uvalue=[44,3,top,uv[3],row,k,uv[6]])
                  txt3=widget_text(   row2,value=' '        ,font=ft_propor,xsize=bsz,/edit)
                  if fixpi[k]             then widget_control,but3,set_button=1,sensitive=0
                  if valpi[k]      ne ' ' then widget_control,txt3,set_value=valpi[k]
                  if Pexplain[k+1] gt ' ' then widget_control,txt3,/tracking,set_uvalue=Pexplain[k+1]
                  uvff=[uvff,fixpi[k],txt3,but3] & endif

                 if npp ge 4  then begin & k=k+1 & bsz=bszo*3/4
                  lab =widget_label(  row2,value=','        ,font=ft_b_normal)
                  but4=widget_button( widget_base(row2,/nonexclusive),value=txtpi[k],font=ft_propor,uvalue=[44,3,top,uv[3],row,k,uv[6]])
                  txt4=widget_text(   row2,value=' '        ,font=ft_propor,xsize=bsz,/edit)
                  if fixpi[k]             then widget_control,but4,set_button=1,sensitive=0
                  if valpi[k]      ne ' ' then widget_control,txt4,set_value=valpi[k]
                  if Pexplain[k+1] gt ' ' then widget_control,txt4,/tracking,set_uvalue=Pexplain[k+1]
                  uvff=[uvff,fixpi[k],txt4,but4] & endif

                 if npp ge 5  then begin & k=k+1 & bsz=bszo*3/4
                  lab =widget_label(  row2,value=','        ,font=ft_b_normal)
                  but5=widget_button( widget_base(row2,/nonexclusive),value=txtpi[k],font=ft_propor,uvalue=[44,3,top,uv[3],row,k,uv[6]])
                  txt5=widget_text(   row2,value=' '        ,font=ft_propor,xsize=bsz,/edit)
                  if fixpi[k]             then widget_control,but5,set_button=1,sensitive=0
                  if valpi[k]      ne ' ' then widget_control,txt5,set_value=valpi[k]
                  if Pexplain[k+1] gt ' ' then widget_control,txt5,/tracking,set_uvalue=Pexplain[k+1]
                  uvff=[uvff,fixpi[k],txt5,but5] & endif

                 if npp ge 6  then begin & row2=widget_base(rowt,/row) & bsz=bszo & endif

                 if npp ge 6  then begin & k=k+1
                  but1=widget_button( widget_base(row2,/nonexclusive),value=txtpi[k],font=ft_propor,uvalue=[44,3,top,uv[3],row,k,uv[6]])
                  txt1=widget_text(   row2,value=' '        ,font=ft_propor,xsize=bsz,/edit)
                  if fixpi[k]             then widget_control,but1,set_button=1,sensitive=0
                  if valpi[k]      ne ' ' then widget_control,txt1,set_value=valpi[k]
                  if Pexplain[k+1] gt ' ' then widget_control,txt1,/tracking,set_uvalue=Pexplain[k+1]
                  uvff=[uvff,fixpi[k],txt1,but1] & endif

                 if npp ge 7  then begin & k=k+1
                  lab =widget_label(  row2,value=','        ,font=ft_b_normal)
                  but2=widget_button( widget_base(row2,/nonexclusive),value=txtpi[k],font=ft_propor,uvalue=[44,3,top,uv[3],row,k,uv[6]])
                  txt2=widget_text(   row2,value=' '        ,font=ft_propor,xsize=bsz,/edit)
                  if fixpi[k]             then widget_control,but2,set_button=1,sensitive=0
                  if valpi[k]      ne ' ' then widget_control,txt2,set_value=valpi[k]
                  if Pexplain[k+1] gt ' ' then widget_control,txt2,/tracking,set_uvalue=Pexplain[k+1]
                  uvff=[uvff,fixpi[k],txt2,but2] & endif

                 if npp ge 8  then begin & k=k+1
                  lab =widget_label(  row2,value=','        ,font=ft_b_normal)
                  but3=widget_button( widget_base(row2,/nonexclusive),value=txtpi[k],font=ft_propor,uvalue=[44,3,top,uv[3],row,k,uv[6]])
                  txt3=widget_text(   row2,value=' '        ,font=ft_propor,xsize=bsz,/edit)
                  if fixpi[k]             then widget_control,but3,set_button=1,sensitive=0
                  if valpi[k]      ne ' ' then widget_control,txt3,set_value=valpi[k]
                  if Pexplain[k+1] gt ' ' then widget_control,txt3,/tracking,set_uvalue=Pexplain[k+1]
                  uvff=[uvff,fixpi[k],txt3,but3] & endif

                 if npp ge 9  then begin & k=k+1 & bsz=bszo*3/4
                  lab =widget_label(  row2,value=','        ,font=ft_b_normal)
                  but4=widget_button( widget_base(row2,/nonexclusive),value=txtpi[k],font=ft_propor,uvalue=[44,3,top,uv[3],row,k,uv[6]])
                  txt4=widget_text(   row2,value=' '        ,font=ft_propor,xsize=bsz,/edit)
                  if fixpi[k]             then widget_control,but4,set_button=1,sensitive=0
                  if valpi[k]      ne ' ' then widget_control,txt4,set_value=valpi[k]
                  if Pexplain[k+1] gt ' ' then widget_control,txt4,/tracking,set_uvalue=Pexplain[k+1]
                  uvff=[uvff,fixpi[k],txt4,but4] & endif

                 if npp ge 10 then begin & k=k+1 & bsz=bszo*3/4
                  lab =widget_label(  row2,value=','        ,font=ft_b_normal)
                  but5=widget_button( widget_base(row2,/nonexclusive),value=txtpi[k],font=ft_propor,uvalue=[44,3,top,uv[3],row,k,uv[6]])
                  txt5=widget_text(   row2,value=' '        ,font=ft_propor,xsize=bsz,/edit)
                  if fixpi[k]             then widget_control,but5,set_button=1,sensitive=0
                  if valpi[k]      ne ' ' then widget_control,txt5,set_value=valpi[k]
                  if Pexplain[k+1] gt ' ' then widget_control,txt5,/tracking,set_uvalue=Pexplain[k+1]
                  uvff=[uvff,fixpi[k],txt5,but5] & endif

                 if npp ge 11 then begin & row2=widget_base(rowt,/row) & bsz=bszo & endif

                 if npp ge 11 then begin & k=k+1
                  but1=widget_button( widget_base(row2,/nonexclusive),value=txtpi[k],font=ft_propor,uvalue=[44,3,top,uv[3],row,k,uv[6]])
                  txt1=widget_text(   row2,value=' '        ,font=ft_propor,xsize=bsz,/edit)
                  if fixpi[k]             then widget_control,but1,set_button=1,sensitive=0
                  if valpi[k]      ne ' ' then widget_control,txt1,set_value=valpi[k]
                  if Pexplain[k+1] gt ' ' then widget_control,txt1,/tracking,set_uvalue=Pexplain[k+1]
                  uvff=[uvff,fixpi[k],txt1,but1] & endif

                 if npp ge 12 then begin & k=k+1
                  lab =widget_label(  row2,value=','        ,font=ft_b_normal)
                  but2=widget_button( widget_base(row2,/nonexclusive),value=txtpi[k],font=ft_propor,uvalue=[44,3,top,uv[3],row,k,uv[6]])
                  txt2=widget_text(   row2,value=' '        ,font=ft_propor,xsize=bsz,/edit)
                  if fixpi[k]             then widget_control,but2,set_button=1,sensitive=0
                  if valpi[k]      ne ' ' then widget_control,txt2,set_value=valpi[k]
                  if Pexplain[k+1] gt ' ' then widget_control,txt2,/tracking,set_uvalue=Pexplain[k+1]
                  uvff=[uvff,fixpi[k],txt2,but2] & endif

                 if npp ge 13 then begin & k=k+1
                  lab =widget_label(  row2,value=','        ,font=ft_b_normal)
                  but3=widget_button( widget_base(row2,/nonexclusive),value=txtpi[k],font=ft_propor,uvalue=[44,3,top,uv[3],row,k,uv[6]])
                  txt3=widget_text(   row2,value=' '        ,font=ft_propor,xsize=bsz,/edit)
                  if fixpi[k]             then widget_control,but3,set_button=1,sensitive=0
                  if valpi[k]      ne ' ' then widget_control,txt3,set_value=valpi[k]
                  if Pexplain[k+1] gt ' ' then widget_control,txt3,/tracking,set_uvalue=Pexplain[k+1]
                  uvff=[uvff,fixpi[k],txt3,but3] & endif

                 if npp ge 14 then begin & k=k+1 & bsz=bszo*3/4
                  lab =widget_label(  row2,value=','        ,font=ft_b_normal)
                  but4=widget_button( widget_base(row2,/nonexclusive),value=txtpi[k],font=ft_propor,uvalue=[44,3,top,uv[3],row,k,uv[6]])
                  txt4=widget_text(   row2,value=' '        ,font=ft_propor,xsize=bsz,/edit)
                  if fixpi[k]             then widget_control,but4,set_button=1,sensitive=0
                  if valpi[k]      ne ' ' then widget_control,txt4,set_value=valpi[k]
                  if Pexplain[k+1] gt ' ' then widget_control,txt4,/tracking,set_uvalue=Pexplain[k+1]
                  uvff=[uvff,fixpi[k],txt4,but4] & endif

                 if npp ge 15 then begin & k=k+1 & bsz=bszo*3/4
                  lab =widget_label(  row2,value=','        ,font=ft_b_normal)
                  but5=widget_button( widget_base(row2,/nonexclusive),value=txtpi[k],font=ft_propor,uvalue=[44,3,top,uv[3],row,k,uv[6]])
                  txt5=widget_text(   row2,value=' '        ,font=ft_propor,xsize=bsz,/edit)
                  if fixpi[k]             then widget_control,but5,set_button=1,sensitive=0
                  if valpi[k]      ne ' ' then widget_control,txt5,set_value=valpi[k]
                  if Pexplain[k+1] gt ' ' then widget_control,txt5,/tracking,set_uvalue=Pexplain[k+1]
                  uvff=[uvff,fixpi[k],txt5,but5] & endif

                 widget_control,row,set_uvalue=[uvff, form]
            end
         else:
         endcase
         widget_control,uv[3], UPDATE=1
   end
41:begin & if uv[1] eq 1 then begin ;Come from "Get Model"
           widget_control,uv[4],get_value=fifi & fifi=strcompress(fifi[0],/remove_all) ;Get model from file
           if strpos(fifi,'model') lt 0 then fifi='model_'+fifi

           filt='*model*.pro'
           bfil=dialog_pickfile(filter=filt,file=fifi,get_path=pth,/read,title='Search for a User Model')

           if bfil ne '' then begin
            cd,current=mee
            idx=STRPOS(bfil,lamp_dvd,/REVERSE_SEARCH)
            if idx ge 0 then begin
               bfil=strmid(bfil,idx+1,100) & cd,pth
            endif
            str_get_model,bfil,UserModl,ii
            cd,mee
            if (ii ne 1) or (n_tags(UserModl) le 1) then begin
              widget_control,uv[5],set_value='?Unable to get '+bfil & lamp_error ;print,!error_state.msg
              UserModl=0
            endif
            widget_control,uv[4] ,set_value=bfil
           endif
         endif else UserModl=User_Modl ;Come from "Fill parameters" (42,3)
         
         if n_tags(UserModl) gt 1 then begin
           widget_control,uv[3] ,get_uvalue=uv3 & hed =3      ;[fix_bg, val_bg ,modl_nam ,row1,row2,...]
           if n_elements(uv3) gt hed then for i=hed,n_elements(uv3)-1 do widget_control,uv3[i],/destroy
           widget_control,uv[7] ,set_button=UserModl.BKGDfix  ;set background
                                     uv3[0]=UserModl.BKGDfix  ;""
           widget_control,uv[3] ,set_uvalue=uv3[0:hed-1]
           widget_control,uv3[1],get_uvalue=TBname

           tags=tag_names(UserModl) & okQ=where(tags eq 'QINF')   & if okQ[0] ge 0 then okQ=1 else okQ=0 ;Compatibilities (old Vers)
                                      okP=where(tags eq 'PNAMES') & if okP[0] ge 0 then okP=1 else okP=0
           widget_control,uv3[1],set_value =s4v(UserModl.BKGDvalue)
           uvg.Bgrd  =UserModl.BKGDmod
           uvg.Follow=UserModl.FOLLOW     ;-> TO IMPLEMENT !!!
          ;uvg.Reso  =UserModl.RESOLUTION ;-> TO IMPLEMENT !!!

           NAME=UserModl.NAME & ON=UserModl.ON & NPAR=UserModl.NPAR
           if UserModl.Bose gt 0. then begin & NAME=[NAME,'Bose'] & ON=[ON,1] & NPAR=[NPAR,1] & endif
           nfunc=n_elements(NAME)
           for i=0,nfunc-1 do begin                           ;Loop over functions
               nf=where(TBname eq NAME[i])
               np=NPAR[i] & if np gt 10 then np=6 else if np gt 5 then np=5 else np=0 ;TO CHANGE IN THE FUTURE
               if nf gt 9 then np=nf-9                                                ;BETTER LIKE THIS (the future)
               widget_control,uv[6],set_uvalue=[40,nf[0],uv[2],uv[3],uv[6],np,uv[5]]
               str_fit_event, {WIDGET_BUTTON, ID:uv[6], TOP:uv[2], HANDLER:0L, SELECT:1}
               widget_control,uv[3],get_uvalue=uv3
               widget_control,uv3[hed+i],get_uvalue=uvf & hod=3
               uvf[0]=ON[i]
               np    =NPAR[i]
               if NAME[i] eq ('Bose') then widget_control,uvf[hod+1],set_value=s4v(UserModl.Bose) $
               else begin
                 widget_control,uvf[2],set_button=UserModl.ON[i]
                 if UserModl.FORMULA[i] gt ' ' then begin
                    if strpos(UserModl.FORMULA[i],NAME[i]) lt 0 then addon=' ;'+NAME[i] else addon=''
                    widget_control,uvf[n_elements(uvf)-1],set_value=UserModl.FORMULA[i]+addon
                 endif
                 for j=0,np-1 do begin & pl=hod+j*3
                    uvf[pl]=UserModl.FITP[j,i]
                    widget_control,uvf[pl+2],set_button=UserModl.FITP[j,i]

                    if UserModl.QEXP[  j,i] gt ' ' then ptxt=UserModl.QEXP[j,i] $
                                                   else   if UserModl.FITP[j,i] then ptxt=s4v(UserModl.PARAMS[j,i]) $
                                                   else ptxt=s4v(UserModl.PARAMS[j,i],/min)
                    if okQ then $
                    if UserModl.QSUP[  j,i] gt ' ' then ptxt= ptxt+'>' +UserModl.QSUP[j,i]
                    if UserModl.BOUNDA[j,i]        then ptxt= ptxt+'>' +s4v(UserModl.LIMITA[j,i])
                    if okQ then $
                    if UserModl.QINF[  j,i] gt ' ' then ptxt= ptxt+'<' +UserModl.QINF[j,i]
                    if UserModl.BOUNDB[j,i]        then ptxt= ptxt+'<' +s4v(UserModl.LIMITB[j,i])
                    if okP then $
                    if UserModl.PNAMES[j,i] gt ' ' then ptxt= UserModl.PNAMES[j,i]+': '+ptxt
                    widget_control,uvf[pl+1],set_value= ptxt
                 endfor
               endelse
               widget_control,uv3[hed+i],set_uvalue=uvf
           endfor
           widget_control,uv[5],set_value='File is loaded'
         endif ;UserModl is ok
   end
42:begin & if uv[1] le 0 then begin            ;Initiate
        ;When uv(1)=0 then uv(0)<-8 (see at begining of str_fit_event)
         endif else if uv[1] eq 1 then begin ;Background
               if ev.select      then memes='Flat background is fixed' else memes=' '
               if uvg.Bgrd eq 3  then memes='No background is set'
               if uvg.Bgrd eq 3  then ev.select=0
               if uvg.Bgrd eq 3  then widget_control,ev.id,set_button=0 $
               else if ev.select then uvg.Bgrd=0
               widget_control,uv[3],get_uvalue=uv3 & uv3[0]=ev.select
               widget_control,uv[3],set_uvalue=uv3
               widget_control,uv[6],set_value =memes
         endif else if uv[1] eq 2 then begin ;Follow parameters
               widget_control,ev.id,get_value =memes
               widget_control,uv[6],set_value =memes
               uvg.Follow=uv[3]
               if uv[3] eq  0 then memes='<- Seq ->'
               if uv[3] eq  1 then memes='Go 1 -> N'
               if uv[3] eq -1 then memes='Go N -> 1'
               if uv[3] eq  2 then memes='2d Fit   '
               if uv[3] eq  3 then memes='2d 1 -> N'
               if uv[3] eq -3 then memes='2d N -> 1'
               widget_control,uv[4],set_value =memes
         endif else if uv[1] eq 3 then begin ;Fill fitted parameters
               sizp=size(par)
               if (n_tags(User_Modl) gt 1) and (sizp[0] gt 0) then begin  ;We have a Fit
                ;PAR is (nspec , npar , nfunc)
                 spec=(uvg.Vslid-1)>0   & spoc=(spec-uvg.Srang[0]+1)>0
                 if uv[4]            eq 1 then parf=reform(float(par[spoc,*,*])) else $ ;Selected spectrum or
                 if User_Modl.follow lt 0 then parf=reform(float(par[sizp[1]-1,*,*])) $ ;Last  spec or
                                          else parf=reform(float(par[0        ,*,*]))   ;First spec
                ;PARF is (npar , nfunc)
                 nfunc=n_elements(User_Modl.ON)
                 FOn   =0
                 for nk=0,nfunc-1 do begin                              ;For all (On) functions
                   if User_Modl.ON[nk] then begin & npf=1                 ;Jump PVfactor in parf
                      for np=0,User_Modl.NPAR[nk]-1 do begin
                          if npf eq 4 then npf=npf+6                    ;Jump background & sums in parf
                          if User_Modl.QEXP[  np,nk] le ' ' then $      ;For all (no Qexp) parameters
                             User_Modl.PARAMS[np,nk] = parf[npf,FOn] $  ;Take fitted parameter
                          else begin                                    ;Or sample tied params
                            L= strlen(User_Modl.QEXP[np,nk])
                            if strmid(User_Modl.QEXP[np,nk],0  ,1) eq '[' and  $
                               strmid(User_Modl.QEXP[np,nk],L-1,1) eq ']' then $
                               User_Modl.QEXP[np,nk]='['+s4v(parf[npf,FOn],/min) +']'
                          endelse
                          npf=npf+1
                      endfor
                      FOn=FOn+1
                   endif
                 endfor
                 uvNEW=uv & uvNEW[0:1]=[41,0]
                 widget_control,ev.id,set_uvalue=uvNEW ;Reconstruct the User model
                 str_fit_event, {WIDGET_BUTTON, ID:ev.id, TOP:ev.top, HANDLER:0L, SELECT:1}
                 widget_control,ev.id,set_uvalue=uv
               endif
         endif
   end
43:begin & widget_control,uv[3],/destroy & return
   end
44:begin & case uv[1] of
         1: begin & widget_control,uv[4],/destroy       ;Function Remove
                  widget_control,uv[3],get_uvalue=uv3 & idx=where(uv3 ne uv[4])
                  widget_control,uv[3],set_uvalue=uv3[idx]
            end
         2: begin & if ev.select then memes=' ' else memes='Function-is-off'
                  widget_control,uv[4],get_uvalue=uv4 & uv4[0]=ev.select
                  widget_control,uv[4],set_uvalue=uv4 ;Function on/off
                  widget_control,uv[6],set_value =memes
            end
         3: begin & if ev.select then memes='Parameter is fixed' else memes=' ' & hod=3
                  widget_control,uv[4],get_uvalue=uv4 & uv4[hod+uv[5]*3]=ev.select
                  widget_control,uv[4],set_uvalue=uv4 ;Function fix params
                  widget_control,uv[6],set_value =memes
            end
         else:
         endcase
   end
45:begin ;Display PDF manual
         if uv[1] eq 1 then begin & Qmanual=widget_info(ev.id,/uname)
                                    online_help, book=Qmanual,/full & endif
   end
;**************************

50:begin & widget_control,top  ,/destroy & return ;CLOSE
   end
   
else:
endcase
widget_control,top  ,set_uvalue=uvg
if messg ne '-' then widget_control,uvg.mess,set_value =messg
end

pro str_fit_plot, flaag, uvg ,livc=livc ,ymax=ymax ,xtmp=xtmp
;+
;** ************
;** plotting routine
;-
@lamp.cbk
common strfit_out , data,par,sout,dcfit, User_Modl
common strfit_outC, Cfunc, bid_other
common strfit_col , bcol, col, mcol, scol, tcol
common c_str_fitqens, func_resol, Qcurrent1D, Qcurrent2D, mig2, mig3, mig4, mig5

if uvg.Isiz[1] gt 1 then begin

ws  =s4v(uvg.Iwks) & wb =s4v(uvg.Bwks)

spec=(uvg.Vslid-1)>0   & spoc=(spec-uvg.Srang[0]+1)>0

sz  =size(data) & sx=0 & ii=execute('sx=size(x'+ws+')') & if sx[0] eq 2 then sx=sx[2]-1 else sx=0
                  se=0 & ii=execute('se=size(e'+ws+')') & if se[0] eq 2 then se=se[2]-1 else se=0
                  sb=0 & ii=execute('sb=size(w'+wb+')') & if sb[0] eq 2 then sb=sb[2]-1 else sb=0
                  sw=0 & ii=execute('sw=size(w'+ws+')') & if sw[0] eq 2 then sw=sw[2]-1 else sw=0      
                  sy=0 & ii=execute('sy=size(y'+ws+')') & if sy[0] eq 1 then if sy[1] gt spoc then $
                                                          ii=execute('Qcurrent1D = Y'+ws+'[spoc]')

ns=0 & vv=0 & xx=0 & ss=0 & bk=0
if n_elements(data)   gt 1 then if sz[0] eq 2 then ns=sz[2] else ns=1

um=uvg.Plot & tpeak=0
if (um eq 0) or (um eq 2) or (um eq 3) or (um eq 8) or (um eq 9) or (um ge 10) then tpeak=uvg.Vslidp
if (um ge 10) then um=um<((size(par))[2]-1)

if (n_elements(bcol) eq 0) or (flaag eq 'plot') then begin
    tvlct, rrr,ggg,bbb,/GET & ttt=long(rrr)+ggg+bbb
    mini=min(ttt) &  col=!C
    maxi=max(ttt) & bcol=!C
    mcol=where((ttt ge (mini+maxi)/4-50) and (ttt le (mini+maxi)/4+50))
    scol=where((ttt ge (mini+maxi)/3-20) and (ttt le (mini+maxi)/3+20))
    if mcol[0] lt 0 then mcol=col else mcol=mcol[0] ;& mcol=col
    if scol[0] lt 0 then scol=col else scol=scol[0] ;& scol=col
endif

if (size(uvg.xrang))[0] eq 1 then xrgS=0 else xrgS=(size(uvg.xrang))[2] - 1
xrgSmin=min(uvg.Xrang,max=xrgSmax)

if n_elements(Ymax) ne 1 then if uvg.Yrg then if uvg.pYrgM ne 0 then Ymax=uvg.pYrgm

kpcol=!P.color & !P.color=col
Pres=uvg.Pres
case flaag of
'erase': for i=0,3 do begin & wset,uvg.wins[i] & erase,bcol & endfor

'plot':  begin & wset,uvg.wins[0]
         if ns gt 0 then begin                 ;Plot parameters
               if sz[0] eq 2 then begin
                  case uvg.Plot<10 of
                  0: begin & vv=par[ *,2 ,*] & ss=sout[*,2 ,*] & tit='P2 (Position)' & end
                  1: begin & vv=par[ *,8 ,0] & ss=par[ *,7 ,0] & tit='Integral'      & end
                  2: begin & vv=par[ *,3 ,*] & ss=sout[*,3 ,*] & tit='P3 (Width)'    & end
                  3: begin & vv=par[ *,1 ,*] & ss=sout[*,1 ,*] & tit='P1 (Height)'   & end
                  7: begin & vv=sout[*,7 ,0] & ss=0            & tit='Fit/Data Integral'     & end
                  8: begin & vv=par[ *,0 ,*] & ss=sout[*,0 ,*] & tit='Pseudo-Voigt factor'   & end
                  9: begin & vv=par[ *,9 ,*] & ss=sout[*,9 ,*] & tit='Theorical F.Integral'  & end
                  10:begin & vv=par[ *,um,*] & ss=sout[*,um,*] & tit='P'+strtrim(um-6,2)     & end
                  else:
                  endcase
                  if n_elements(vv) gt 1 then begin
                     vv =reform(vv) & if n_elements(ss) gt 1 then ss=reform(ss)
                     svv=  size(vv) & if svv[0] eq 1 then svv2=1 else svv2=svv[2]
                     ii =execute('yc=Y'+ws)
                     xx =indgen(sz[2])+uvg.Srang[0] & if n_elements(yc) eq sw+1 then xx=yc[xx-1]

                     ym1=min([vv],max=ym2) & my=(ym2-ym1)/20.
                     if  uvg.Y0  then ym1=my

                     if uvg.Plot eq 1 then begin
                        plot,   xx,vv,background=bcol,charsize=1.2,color=col,title=tit,xtitle='Spectra (...Data  ___Fit)',$
                                psym=0,linestyle=0,font=0,xmargin=[7,2],ytitle='',ystyle=16,yrange=[ym1-my,ym2+my]
                        oplot,  xx,ss,psym=0,linestyle=1,color=col

                     endif else begin
                     if uvg.Plot ne 7 then begin & id0=-1
                      if par[0] ge 0 then if uvg.Plot eq 3 then id0=where(par[ *,1,*] le 0) ;if no user model (height)
                      if par[0] ge 0 then if uvg.Plot eq 2 then id0=where(par[ *,3,*] le 0) ;if no user model (width)
                      if tpeak gt 0 then begin &  tpeak=tpeak<svv2 & vv=vv[  *,tpeak-1] & tit=tit+' Function:'+s4v(tpeak)
                                                if par[0] ge 0 then if uvg.Plot eq 3 then id0=where(par[ *,1,tpeak-1] le 0)
                                                if par[0] ge 0 then if uvg.Plot eq 2 then id0=where(par[ *,3,tpeak-1] le 0)
                                                ym1=min([vv],max=ym2) & my=(ym2-ym1)/20.
                                                svv=size(vv)     & ss=ss[  *,tpeak-1] & endif
                      if id0[0] ge 0 then begin ;We have bad peaks in there.
                      vv[id0]=ym2 & ym1=min([vv],max=ym2) & my=(ym2-ym1)/20.
                      for i=0,n_elements(id0)-1 do begin & sp=id0[i] mod svv[1] & np=fix(id0[i]/svv[1])
                                                ii=execute('vv[sp,np]=!values.f_nan') & endfor & endif
                     endif
                     if uvg.Y0  then ym1=my
                      if svv[0] eq 1 then begin ;**> one peak parameter <**
                        plot,   xx,vv,background=bcol,charsize=1.2,color=col,title=tit,xtitle='Spectra',$
                                psym=0,linestyle=0,font=0,xmargin=[7,2],ytitle='',ystyle=16,yrange=[ym1-my,ym2+my]
                        if n_elements(ss) gt 1 then errplot,xx,vv-ss,vv+ss
                      endif else begin          ;**> Multi peaks parameter <**
                        surface,vv,xx,indgen(svv[2])+1,background=bcol,charsize=1.2,color=col,title=tit,xtitle='Spectra',ytitle='Functions   ',$
                               /horizontal,ax=0.,az=0.,font=0,xmargin=[7,2],ymargin=[2,2],zrange=[ym1-my,ym2+my]
                      endelse
                     endelse
                  endif
               endif
              if (uvg.Plot ne 4) then begin                      ;Show parameters value
                   if (n_elements(vv) le 1) and (sz[0] eq 1) and (spoc eq 0) then begin
                       yp =300 & dp=30
                   endif else begin & yp=150 & dp=15 & wset,uvg.wins[2] & endelse

                   pir=reform(par[ spoc,*,*])
                   sou=reform(sout[spoc,*,*])
                   spr=size(pir)
                   if (tpeak gt 0) and (spr[0] eq 2) then begin &  tpeak=tpeak<spr[2]
                       pir=pir[*,tpeak-1] & sou=sou[*,tpeak-1] & spr=size(pir) & endif

                   vv=[0,0]
                   if spr[0] eq 1 then begin & vv=[0,0] & erase,bcol

                     xyouts,4,yp-dp*1,'PVf     ='+string(pir[0])+'     Sigma='  +string(sou[0]),charsize=1.2,font=0,color=col,/device
                     xyouts,4,yp-dp*2,'P1 Ht   ='+string(pir[1])+'     Sigma='  +string(sou[1]),charsize=1.2,font=0,color=col,/device
                     xyouts,4,yp-dp*3,'P2 Pos  ='+string(pir[2])+'     Sigma='  +string(sou[2]),charsize=1.2,font=0,color=col,/device
                     xyouts,4,yp-dp*4,'P3 fWmH ='+string(pir[3])+'     Sigma='  +string(sou[3]),charsize=1.2,font=0,color=col,/device
                     xyouts,4,yp-dp*5,'Backgrd ='+string(pir[4])+'     Sigma='  +string(sou[4]),charsize=1.2,font=0,color=col,/device
                     xyouts,4,yp-dp*6,'Func Int='+string(pir[9])+'     Sigma='  +string(sou[9]),charsize=1.2,font=0,color=col,/device
                     xyouts,4,yp-dp*7,'Data Int='+string(pir[7])                               ,charsize=1.2,font=0,color=col,/device
                     xyouts,4,yp-dp*8,'Fit  Int='+string(pir[8])+'     F/D Int='+string(sou[7]),charsize=1.2,font=0,color=col,/device
                     if (tpeak gt 0) or (sz[0] gt 1) then $
                     xyouts,4,yp-dp*9,'Function' +string(tpeak>1)+'     Spectrum'+string(spec+1),charsize=1.2,font=0,color=col,/device
                   endif else begin ;**> Multi spectra <**
                     case uvg.Plot<10 of
                     0: begin & vv=pir[ 2 ,*] & ss=sou[ 2 ,*] & tit='P2 (Position)' & end
                     1: begin & vv=pir[ 8 ,0] & ss=pir[ 7 ,0] & tit='Integral'      & end
                     2: begin & vv=pir[ 3 ,*] & ss=sou[ 3 ,*] & tit='P3 (Width)'    & end
                     3: begin & vv=pir[ 1 ,*] & ss=sou[ 1 ,*] & tit='P1 (Height)'   & end
                     7: begin & vv=sou[ 7 ,0] & ss=0          & tit='Fit/Data Integral'     & end
                     8: begin & vv=pir[ 0 ,*] & ss=sou[ 0 ,*] & tit='Pseudo-Voigt factor'   & end
                     9: begin & vv=pir[ 9 ,*] & ss=sou[ 9 ,*] & tit='Theorical F.Integral'  & end
                     10:begin & vv=pir[ um,*] & ss=sou[ um,*] & tit='P'+strtrim(um-6,2)     & end
                     else:    vv=0
                     endcase
                     if (uvg.Plot eq 1) then begin & erase,bcol
                        xyouts,4,yp-dp*3,'Fit  Int='+string(vv)+'  Data Int='+string(ss)+'  Spec'+string(spec+1),charsize=1.2,font=0,color=col,/device
                        vv=[0,0] & endif else $
                     if (uvg.Plot eq 7) then begin & erase,bcol
                        xyouts,4,yp-dp*3,'Fit/Data Int='+string(vv)+'  Spectrum'+string(spec+1),charsize=1.2,font=0,color=col,/device
                        vv=[0,0] & endif $
                     else if n_elements(vv) gt 1 then begin & erase,bcol
                        xx =indgen(n_elements(vv))+1
                        ym1=min(vv,max=ym2) & my=(ym2-ym1)/20. & if  uvg.Y0  then ym1=my
                        plot,   xx,vv,background=bcol,charsize=1.2,color=col,title=tit,xtitle='Functions Sp='+string(spec+1),$
                                psym=0,linestyle=0,font=0,xmargin=[7,2],ytitle='',ystyle=16,yrange=[ym1-my,ym2+my]
                        if n_elements(ss) gt 1 then errplot,xx,vv-ss,vv+ss
                     endif
                   endelse
                   wset,uvg.wins[0]
               endif ;show parameters value
         endif;end of plot parameters

         if not keyword_set(livc) then $
         if (uvg.Plot eq 4) or ((n_elements(vv) eq 1) and (ns le 1)) then begin  ;Plot data over Fitted function
                  if uvg.Bwks gt 0 then $
                  ii=execute('bk=w'+wb+'[*,spec<sb]')
                  ii=execute('xx=x'+ws+'[*,spec<sx]')
                  ii=execute('vv=w'+ws+'[*,spec]')
                  ii=execute('ss=e'+ws+'[*,spec<se]')
                  if n_elements(xx) ne n_elements(vv) then xx=indgen(n_elements(vv))+1 & tit='Fit__ & bkground... -> Spectrum '
                  if (spoc ge 0) and (spoc lt ns) then begin & str_bkg_spec, xx, par[spoc,*], bk, background=fitb
                                            endif else begin & fitb=xx*0.+vv[0] & tit='Spectrum ' & endelse

                  if n_elements(Xtmp) eq 2 then xrg=Xtmp else if uvg.prg then xrg=uvg.prang $
                                                         else if uvg.xrg then xrg=uvg.xrang[*,spec<xrgS] else xrg=[0.,0.]

                  if (n_elements(ss) eq n_elements(vv)) and (uvg.Wght)   then psy=4 $
                  else if (n_elements(vv) gt 300) and (xrg[0] eq xrg[1]) then psy=1 else psy=4
                  okerr=((uvg.Wght) and (psy ne 1) and (max(ss,min=minss) ne minss))

                  if n_elements(ymax) eq 1 then begin & ids=where(vv gt ymax)
                    if (ids[0] ge 0) and (n_elements(ids) ne n_elements(vv)) then begin
                        vv=vv<ymax & if okerr then ss[ids]=0. & endif & endif

                  yrang=[min([min(fitb,/NAN),min(vv,max=maxvv,/NAN)]),maxvv] & if (uvg.Y0) and (uvg.plog le 1) then yrang[0]=0.

                  if xrg[0] lt xrg[1] then begin
                       ida1=where(xx ge xrg[0])>0  & ida2=where(xx ge xrg[1])
                       if ida2[0] le 0 then ida2[0]=n_elements(xx)-1 & yrang[1]=max(vv[ida1[0]:ida2[0]],min=mom,/NAN) & yrang[0]=mom
                       if (uvg.Y0) and (uvg.plog le 1) then yrang[0]=0.
                       case uvg.plog of  ;plot original data
                        3: plot,   xx,vv,background=bcol,charsize=1.2,color=col,title=tit+s4v(spec+1),xtitle='',ytitle='',$
                                   psym=psy,font=0,xmargin=[7,2],ymargin=[2,2],ystyle=1,yrange=yrang>(1e-7),xrange=xrg>(1e-7),/YLOG,/XLOG 
                        2: plot,   xx,vv,background=bcol,charsize=1.2,color=col,title=tit+s4v(spec+1),xtitle='',ytitle='',$
                                   psym=psy,font=0,xmargin=[7,2],ymargin=[2,2],ystyle=1,yrange=yrang>(1e-7),xrange=xrg       ,/YLOG
                        1: plot,   xx,vv,background=bcol,charsize=1.2,color=col,title=tit+s4v(spec+1),xtitle='',ytitle='',$
                                   psym=psy,font=0,xmargin=[7,2],ymargin=[2,2],ystyle=1,yrange=yrang       ,xrange=xrg>(1e-7),/XLOG 
                        0: plot,   xx,vv,background=bcol,charsize=1.2,color=col,title=tit+s4v(spec+1),xtitle='',ytitle='',$
                                   psym=psy,font=0,xmargin=[7,2],ymargin=[2,2],ystyle=1,yrange=yrang       ,xrange=xrg
                        else:
                       endcase
                  endif else begin
                       case uvg.plog of  ;plot original data
                        3: plot,   xx>(1e-7),vv,background=bcol,charsize=1.2,color=col,title=tit+s4v(spec+1),xtitle='',ytitle='',$
                                   psym=psy,font=0,xmargin=[7,2],ymargin=[2,2],ystyle=1,yrange=yrang>(1e-7),/YLOG,/XLOG
                        2: plot,   xx       ,vv,background=bcol,charsize=1.2,color=col,title=tit+s4v(spec+1),xtitle='',ytitle='',$
                                   psym=psy,font=0,xmargin=[7,2],ymargin=[2,2],ystyle=1,yrange=yrang>(1e-7),/YLOG
                        1: plot,   xx>(1e-7),vv,background=bcol,charsize=1.2,color=col,title=tit+s4v(spec+1),xtitle='',ytitle='',$
                                   psym=psy,font=0,xmargin=[7,2],ymargin=[2,2],ystyle=1,yrange=yrang       ,/XLOG
                        0: plot,   xx       ,vv,background=bcol,charsize=1.2,color=col,title=tit+s4v(spec+1),xtitle='',ytitle='',$
                                   psym=psy,font=0,xmargin=[7,2],ymargin=[2,2],ystyle=1,yrange=yrang
                        else:
                       endcase
                  endelse
                  if okerr then errplot,xx,vv-ss,vv+ss
                  
                  if (spoc ge 0) and (spoc lt ns) then begin
                      ;oplot,xx,data(*,spoc),color=mcol,psym=0,linestyle=0,thick=2   ;plot fitted data before
                      ;oplot,xx,fitb        ,color=mcol,psym=0,linestyle=1,thick=2   ;plot  background

                       pars=reform(par[spoc,*,*])   & spp=size(pars)                 ;PARS ONLY FOR CURRENT SPECTRUM
                       if spp[0] eq 2  then spp=spp[2] else spp=1
                       if (uvg.Reso gt 0) or (spp gt 1) or (uvg.Bwks gt 0) then $
                           for i=0,spp-1 do begin                   ;plot sub functions
                                   pvf=pars[0,i] & Subf=0. & sscol=scol & sthick=1
                                   if  i  eq uvg.Vslidp-1 then sthick=3

                                   if uvg.SubConv then subf=reform(Cfunc[*,spoc,i]) $
                                   else str_sub_func, xx, pars[*,i], User_Modl, (i), sub=subf

                                   if n_elements(subf) gt 1 then oplot,xx,Subf+fitb,color=sscol,thick=sthick
                           endfor
                       oplot,xx,data[*,spoc],color=mcol,psym=0,linestyle=0,thick=2   ;plot fitted data after
                       oplot,xx,fitb        ,color=mcol,psym=0,linestyle=1,thick=2   ;plot  background
                 endif
         endif ;of plot data over Fitted function

         if (ns gt 1) or ((sw gt 0) and (ns eq 0)  and ((uvg.Plot le 5) or (uvg.Plot ge 10)))  then $
             if keyword_set(livc) or (uvg.Plot eq 5) or (uvg.Plot eq 6) then begin
                 ax=80.  & az=0.
                 ii=execute('xx=x'+ws+'[*,(uvg.Srang[0]-1)<sx:(uvg.Srang[1]-1)<sx]')  ;Plot 2d Fitted function or bkgrd or data
                 ii=execute('yc=Y'+ws)
                 if ns eq 0 then nns=sw+1 else nns=ns
                 yy=indgen(nns)+uvg.Srang[0] & if n_elements(yc) eq sw+1 then YY=yc[yy-1]

                 if (uvg.Plot eq 6) then begin & ttl='Fitted background' & fitd=fltarr(sz[1],ns) & xc=xx^2 & az=40.
                                          if uvg.Bwks gt 0 then ii=execute('bk=w'+wb+'[*,(uvg.Srang[0]-1)<sb:(uvg.Srang[1]-1)<sb]')
                                          for i=0,ns-1 do begin & fitd[*,i]=par[i,6]*xc[*,i<sx] +par[i,4]
                                              if uvg.Bwks gt 0 then fitd[*,i]=fitd[*,i]+par[i,5]*bk[*,i<sb] $
                                                               else fitd[*,i]=fitd[*,i]+par[i,5]*xx[*,i<sx]+par[i,6]*xx[*,i<sx]^2
                                          endfor & endif
                 if (uvg.Plot eq 4) or ((uvg.Plot eq 5) and Pres) or (ns eq 0) then begin & ttl='Original data'
                                          ii=execute('fitd=w'+ws+'[*,uvg.Srang[0]-1:uvg.Srang[1]-1]') & endif

                 if (uvg.Plot eq 5) and (not Pres) and (ns gt 1) then begin & ttl='Fitted spectra'
                                          if n_elements(dcfit) ne n_elements(data) then fitd=data  $
                                                                                   else fitd=dcfit & endif
                 idx1=0
                 if uvg.prg then uvgx0=uvg.prang[0] else if uvg.xrg then uvgx0=xrgSmin else uvgx0=0 ;uvg.xrang(0)
                 if uvg.prg then uvgx1=uvg.prang[1] else if uvg.xrg then uvgx1=xrgSmax else uvgx1=0 ;uvg.xrang(1)
                  if (uvgx0 lt uvgx1) then begin
                      xx=xx[*,spoc<(nns-1)<sx]
                      idx1=where((xx ge uvgx0) and (xx le uvgx1))
                      if n_elements(idx1) ge 3 then begin & xx=xx[idx1] & fitd=fitd[idx1,*] & endif
                  endif
                 ym1=min(fitd,max=ym2) & if uvg.Y0 then ym1=0. & zran=[ym1,ym2]
                 if (uvg.Plot eq 5) and (ns gt 1) and Pres  then begin & ttl='Residuals (Data-fit)/Dmax*100' & zran=[0.,25] & ax=70. & az=20
                               if n_elements(idx1) ge 3  then  dataa=data[idx1,*] else dataa=data
                               for i=0,ns-1 do fitd[*,i]=smooth((fitd[*,i]-dataa[*,i])*100./max(fitd[*,i]),3)
                               tot=total(abs(fitd))/100. & avg=round((tot/ns)*100.)/100.
                               ttl=ttl+'  Avg: '+s4v(round(tot))+' / '+s4v(ns)+' = '+strtrim(string(avg,format='(f6.2)'),2)
                 endif
                 if keyword_set(livc) then livc_lamp,fitd ,GROUP=lamp_b1 ,TIT=ttl+' '+w_tit[uvg.Iwks] ,XTIT=x_tit[uvg.Iwks], YTIT=y_tit[uvg.Iwks] $
                                                    ,XX=xx ,YY=yy ,WI=uvg.Iwks $
                 else surface,fitd,xx,yy,background=bcol,charsize=1.2,color=col,title=ttl,xtitle='',ytitle='',$
                             /horizontal,ax=ax,az=az,font=0,xmargin=[7,2],ymargin=[2,2],zrange=zran
         endif ;of 2D plot
         if !version.release ge '5.0' then did_mpeg,'put'
         end
'scroll':begin & if uvg.Isiz[0] eq 2 then ms=uvg.Isiz[2] else ms=1
            for i=1,3 do begin & wset,uvg.wins[i] & erase,bcol
                idx=spec-2+i
                idk=idx-uvg.Srang[0]+1
                if (idx ge 0) and (idx lt ms) then begin      ;Original data
                 ii=execute('xx=x'+ws+'[*,idx<sx]')
                 ii=execute('vv=w'+ws+'[*,idx]')
                 ii=execute('ss=e'+ws+'[*,idx<se]')
                 if n_elements(xx) ne n_elements(vv) then xx=indgen(n_elements(vv))+1
                 if (idk ge 0) and (idk lt ns)       then fitc=data[*,idk] else fitc=0.

                 if  n_elements(Xtmp) eq 2 then xrg=Xtmp else if uvg.prg then xrg=uvg.prang $
                                                         else if uvg.xrg then xrg=uvg.xrang[*,idx<xrgS] else xrg=[0.,0.]

                 if (n_elements(ss) eq n_elements(vv)) and (uvg.Wght)   then psy=4 $
                 else if (n_elements(vv) gt 200) and (xrg[0] eq xrg[1]) then psy=1 else psy=4
                 okerr=((uvg.Wght) and (psy ne 1) and (max(ss,min=minss) ne minss))

                ;if n_elements(ss) eq n_elements(vv) then psy=1 else if n_elements(vv) gt 20 then psy=0 else psy=2
                ;okerr=((psy eq 1) and (max(ss,min=minss) ne minss))
                ;if not uvg.Wght then okerr=0

                 if  n_elements(ymax) eq 1 then begin & ids=where(vv gt ymax)
                     if (ids[0] ge 0) and (n_elements(ids) ne n_elements(vv)) then begin
                         vv=vv<ymax & fitc=fitc<ymax & if okerr then ss[ids]=0. & endif & endif

                 if not Pres then begin                      ;Plot data over Fitted function
                   tit='Spectrum '+strtrim(idx+1,2)
                   if xrg[0] lt xrg[1]  then begin
                     case uvg.plog of
                      3: plot,   xx,vv>(1e-7),background=bcol,charsize=.9,color=col,title=tit,xtitle='',ytitle='',$
                                 psym=psy,font=-1,xmargin=[7,2],ymargin=[2,2],ystyle=16,xrange=xrg>(1e-7),/YLOG,/XLOG
                      2: plot,   xx,vv>(1e-7),background=bcol,charsize=.9,color=col,title=tit,xtitle='',ytitle='',$
                                 psym=psy,font=-1,xmargin=[7,2],ymargin=[2,2],ystyle=16,xrange=xrg       ,/YLOG
                      1: plot,   xx,vv       ,background=bcol,charsize=.9,color=col,title=tit,xtitle='',ytitle='',$
                                 psym=psy,font=-1,xmargin=[7,2],ymargin=[2,2],ystyle=16,xrange=xrg>(1e-7),/XLOG
                      0: plot,   xx,vv       ,background=bcol,charsize=.9,color=col,title=tit,xtitle='',ytitle='',$
                                 psym=psy,font=-1,xmargin=[7,2],ymargin=[2,2],ystyle=16,xrange=xrg
                      else:
                     endcase
                   endif else begin
                     case uvg.plog of
                      3: plot,   xx>(1e-7),vv>(1e-7),background=bcol,charsize=.9,color=col,title=tit,xtitle='',ytitle='',$
                                 psym=psy,font=-1,xmargin=[7,2],ymargin=[2,2],ystyle=16,/YLOG,/XLOG
                      2: plot,   xx       ,vv>(1e-7),background=bcol,charsize=.9,color=col,title=tit,xtitle='',ytitle='',$
                                 psym=psy,font=-1,xmargin=[7,2],ymargin=[2,2],ystyle=16,/YLOG
                      1: plot,   xx>(1e-7),vv       ,background=bcol,charsize=.9,color=col,title=tit,xtitle='',ytitle='',$
                                 psym=psy,font=-1,xmargin=[7,2],ymargin=[2,2],ystyle=16,/XLOG
                      0:  plot,   xx,vv       ,background=bcol,charsize=.9,color=col,title=tit,xtitle='',ytitle='',$
                                 psym=psy,font=-1,xmargin=[7,2],ymargin=[2,2],ystyle=16
                      else:
                     endcase
                   endelse
                   if okerr then errplot,xx,vv-ss,vv+ss
                   if (idk ge 0) and (idk lt ns)       then oplot,xx,fitc,color=mcol,psym=0,linestyle=0,thick=2

                 endif else begin                            ;Plot residual
                  mxv=max(vv)
                  df =(vv-fitc)/mxv & if okerr then idf=where(abs(df)*mxv le ss) else idf=-1
                  if n_elements(ss) ne n_elements(vv) then df=smooth(df,3) else if idf[0] ge 0 then df[idf]=0.
                              ;   i0     =where(vv ne 0.)
                  dft=df*100. ; & dft(i0)=dft(i0)/abs(vv(i0))
                  if okerr then tit='% RESIDUAL OUTSIDE ERROR Spectrum '+strtrim(idx+1,2) else $
                                tit='% RESIDUAL Spectrum '+strtrim(idx+1,2)
                  if (idk ge 0) and (idk lt ns) then yran=[-50.,50] else yran=[0.,100]
                   if xrg[0] lt xrg[1]  then $
                         plot,   xx,dft,background=bcol,charsize=.9,color=col,title=tit,xtitle='',ytitle='', $
                                 psym=0,font=-1,xmargin=[7,2],ymargin=[2,2],ystyle=16,yrange=yran,thick=2,yticklen=1.,ygridstyle=1,xrange=xrg $
                   else  plot,   xx,dft,background=bcol,charsize=.9,color=col,title=tit,xtitle='',ytitle='', $
                                 psym=0,font=-1,xmargin=[7,2],ymargin=[2,2],ystyle=16,yrange=yran,thick=2,yticklen=1.,ygridstyle=1
                 endelse
                endif
            endfor
         if (uvg.Plot eq 4) then str_fit_plot,'plot',uvg ,ymax=ymax, xtmp=xtmp
         if (uvg.Plot lt 4) or (uvg.Plot gt 6) then str_fit_plot,'plot',uvg ;for button event CONVERT_COORD!

         if (ms gt 1) or (uvg.Pres) then $
         if uvg.Toggln ne 1 then begin & map0=uvg.Junk[uvg.Toggln] & uvg.Toggln=1
            widget_control,map0,map=0  & widget_control,uvg.Junk[uvg.Toggln],map=1
            widget_control,uvg.bas0,set_uvalue=uvg
            if uvg.TabDon gt 0 then widget_control,uvg.TabDon,set_tab_current=0
         endif & end
   else:
endcase
!P.color=kpcol
endif
end

pro str_bkg_spec, xx, pars, Fshape, background=fitb
;+
;** ************
;** Get Background for one spectrum (xx is full range) (called from 'plot' and str_fit)
;**
;-

fitb=pars[4]+xx*0.                                                                          ;FLAT term
if   pars[5] ne 0. then if n_elements(Fshape) eq n_elements(xx) then fitb=fitb+pars[5]*Fshape $
                                                                else fitb=fitb+pars[5]*xx ;LINEAR term
if   pars[6] ne 0. then fitb=fitb + pars[6]*xx^2                                       ;QUADRATIC term
end

pro str_sub_func, xx, pars, User_Modl, nFunc, sub=subf
;+
;** ************
;** Get a sub function for one spectrum (xx is full range) (called from 'plot' , str_out_par , str_fit)
;** Care with FUNC_CONV if called from str_fit !!!
;**
;-
pvf=pars[0] & Subf=0.
if (pvf ge 0) and (n_tags(User_Modl) le 1) then begin                ;Classical function
   if pvf ne 1. then str_Gauss  ,xx,[pars[1:3],0.],gF else gF=0.
   if pvf ne 0. then str_Lorentz,xx,[pars[1:3],0.],lF else LF=0.
   Subf =pvf*lF + (1.-pvf)*gF
endif else if (pvf eq -.0077) or (n_tags(User_Modl) gt 1) then begin
   if  User_Modl.ON[  nFunc] then begin
   npm=User_Modl.NPAR[nFunc]                                         ;Formula
   if npm gt 3 then tpars=[pars[1:3],pars[10:10+npm-4]] else tpars=pars[1:npm]
   case strlowcase(User_Modl.NAME[nFunc]) of
  'gauss':   str_Gauss  ,XX, [tpars    ,0.] , Subf
  'delta':   str_Delta  ,XX, [tpars    ,0.] , Subf
  'lorentz': str_Lorentz,XX, [tpars    ,0.] , Subf
  'voigt':   str_Pseudo ,XX, [pars[0:3],0.] , Subf
   else:     str_exec_UModl, npm,User_Modl.FORMULA[nFunc], XX, tpars, Subf, User_Modl.NAME[nFunc]
   endcase
   endif
endif
end

pro str_out_par, uvg ,flaag
;+
;** ***********
;** output params or total fit or subfunctions in a workspace or in files
;-

common strfit_out,  data,par,sout,dcfit, User_Modl
common strfit_outC, Cfunc, bid_other

if uvg.Iwks gt 0 then begin
 TAKE_DATP,Idp,W=uvg.Iwks
 if (flaag eq 'sub') and (uvg.Vslidp eq 0) and (uvg.Fwks gt 0) then flaag='fit'
 fifi='str_W'+strtrim(uvg.Iwks,2)+'_F'+strtrim(uvg.Vslidp,2)
 case flaag of
 'par': if (uvg.Pwks ne 0) and (n_elements(par[*,0,*]) gt 1) and (n_elements(sout) gt 1) then begin ;par=(nspec,pars,nk)
 
           if uvg.Vslidp gt 0 then  outpar=par[ *,*,uvg.Vslidp-1]     else outpar=par            ;One function  is choosen
           if uvg.Vslidp gt 0 then  outsig=sout[*,*,uvg.Vslidp-1]     else outsig=sout
           if uvg.Px     ge 0 then  outpar=reform(outpar[*,uvg.Px,*]) else outpar=reform(outpar) ;One parameter is choosen
           if uvg.Px     ge 0 then  outsig=reform(outsig[*,uvg.Px,*]) else outsig=reform(outsig)
           GIVE_W ,outpar,W=uvg.Pwks
           if (size(outpar))[0] eq 3 then begin & Idp.X_tit=Idp.Y_tit & Idp.Y_tit=uvg.Ptit & MOD_DATP,Idp,'z_tit','Functions' & endif
           if (size(outpar))[0] eq 2 then begin
            if n_elements(par[*,0,0]) gt 1 then begin & Idp.X_tit=Idp.Y_tit & Idp.Y_tit=uvg.Ptit & if uvg.Px ge 0 then Idp.Y_tit=Idp.Y_tit+'(by Function)'
            endif                          else begin & Idp.X_tit=uvg.Ptit  & Idp.Y_tit='Functions' & endelse
           endif
           if (size(outpar))[0] eq 1 then begin
            if n_elements(par[*,0,0]) gt 1 then begin & Idp.X_tit=Idp.Y_tit & Idp.Y_tit=uvg.Ptit
            endif                          else if uvg.Px ge 0 then begin &   Idp.X_tit='Functions' & Idp.Y_tit=uvg.Ptit
                                                endif          else begin &   Idp.X_tit=uvg.Ptit    & Idp.Y_tit='values' & endelse
           endif
           xx=indgen((size(outpar))[1])+1 & if (size(outpar))[0] eq 2 then yy=indgen((size(outpar))[2]) else yy=0
           if n_elements(par[*,0,0]) gt 1 then ii =execute('xx=Idp.Y[xx+uvg.Srang[0]-2]')
           MOD_DATP ,Idp,'x',xx
           MOD_DATP ,Idp,'y',yy
           MOD_DATP ,Idp,'e',outsig
           if uvg.Pwks gt 0 then begin ; OUTPUT IN A WORKSPACE
              GIVE_W   ,outpar,W=uvg.Pwks
              GIVE_DATP,Idp   ,W=uvg.Pwks
           endif else begin            ; OUTPUT IN FILES
              nspec = n_elements(xx)
              Sspec = '_S'+strtrim(nspec,2)
              if uvg.Px ge 0 then fifi=fifi+'_P'+strtrim(uvg.Px+1,2)+Sspec else fifi=fifi+'_Pall'+Sspec
              w_store   ,W=60
              GIVE_W    ,outpar     ,W=60
              GIVE_DATP ,Idp        ,W=60
              write_lamp,fifi+'.txt',W=60,format='column'
              sizpar=size(par)
              if sizpar[1] gt 1 then $ ; We have many spectra
               if (uvg.Px  lt 0)  or $ ; and (many parameters or many functions)
                 ((sizpar[0] eq 3) and (uvg.Vslidp eq 0)) then begin ; So write ALSO one file/parameter/function
                   if (sizpar[0] eq 3) and (uvg.Vslidp eq 0) then nk=sizpar[3] else nk=1     ;number of functions
                   parf=float(par) & psig=float(sout)
                   
                   if uvg.Func eq 6 then begin & umON=where(User_Modl.ON eq 1)  &  nk=n_elements(umON)
                      umNAME  =User_Modl.NAME
                      umNPAR  =User_Modl.NPAR
                      umPNAMES=User_Modl.PNAMES
                      umFORM  =User_Modl.FORMULA
                   endif else begin
                      umON    =indgen(nk)
                      umNAME  =strarr(nk)
                      umNPAR  =lonarr(nk)+3
                      umFORM  =strarr(nk)
                      umPNAMES=strarr(3,nk) & for i=0,nk-1 do umPNAMES[0:2,i]=['Height','Position','FWidth']
                      case uvg.Func of 
                       1:   umFORM=umFORM+'Gaussian'
                       2:   umFORM=umFORM+'lorentzian'
                       3:   umFORM=umFORM+'Pseudo-Voigt'
                       4:   umFORM=umFORM+'Pseudo-Voigt PVf='+s4v(uvg.PVf)
                      else:
                      endcase
                   endelse
                   MOD_DATP  ,Idp,'y',0
                   MOD_DATP  ,Idp,'z',0 & Idp.Z_tit=''
                   
                   for kk = 0,nk-1 do begin ; *** FOR EACH FUNCTION ***
                       k    = umON[kk]
                       Fstr = strtrim(k+1, 2)
                       fifi ='str_W'+strtrim(uvg.Iwks,2)+'_F'+Fstr+'_P'
                       
                       for pp = 1,umNPAR[k] do begin ; *** FOR EACH PARAMETER ***
                           if pp gt 3 then j = pp+6 else j = pp
                           Spp= strtrim(j,2)
                           Idp.Y_tit='P'+Spp+'F'+Fstr
                           Idp.X_tit='Spectra P'+Spp+'.'+umPNAMES[pp-1,k] + ' F'+Fstr+'.'+umNAME[k]
                           GIVE_W    ,        reform(parf[*,j,k]), W=60
                           MOD_DATP  ,Idp,'e',reform(psig[*,j,k])
                           GIVE_DATP ,Idp    ,W=60
                           write_lamp,fifi+Spp+Sspec+'.txt',W=60,format='column'
                       endfor
                   endfor
              endif ; Many spectra -> many output files
              w_restore ,W=60
           endelse
       endif
 'fit': if (uvg.Fwks ne 0) and (n_elements(data) gt 1) then begin
           if (size(data))[0] ge 2 then yy=indgen((size(data))[2])+1 else yy=0
           if (size(data))[0] ge 2 then ii =execute('yy=Idp.Y[yy+uvg.Srang[0]-2]') else Idp.Y_tit='Value'
           Idp.X_tit='Fitted '+Idp.X_tit
           MOD_DATP ,Idp,'y',yy
           MOD_DATP ,Idp,'e',0.
           if uvg.Fwks gt 0 then begin ;output in a workspace
              GIVE_W   ,data,W=uvg.Fwks
              GIVE_DATP,Idp ,W=uvg.Fwks
           endif else begin            ;output in a file
              w_store   ,W=60
              GIVE_W    ,data       ,W=60
              GIVE_DATP ,Idp        ,W=60
              write_lamp,fifi+'.txt',W=60,format='column'
              w_restore ,W=60
           endelse
       endif
 'sub': if (uvg.Fwks ne 0) and (n_elements(data) gt 1) then begin
           if (size(data))[0]  ge 2 then yy=indgen((size(data))[2])+1 else yy=0
           if (size(data))[0]  ge 2 then ii =execute('yy=Idp.Y[yy+uvg.Srang[0]-2]') else Idp.Y_tit='Value'
           xx=Idp.X & sizx=size(xx)
           if sizx[0] eq 2 then sx=sizx[2]-1 else sx=0
           data_sub=fltarr(sizx[1],n_elements(yy))
           
           if (size(Cfunc))[0] eq 3 then kn =(size(Cfunc))[3] -1 else kn =0
           if uvg.Vslidp eq 0 then k1=0 else begin & k1 = uvg.Vslidp-1
                                                   kn = k1  &  endelse
           for k= k1,kn do begin               ;function loop
             for i=0,n_elements(yy)-1 do begin ;spectrum loop
                 if uvg.SubConv then subf=reform(Cfunc[*, i, k]) $  ; Cfunc=[nX , nSpectra , nFunct])
                 else str_sub_func, xx[*,i<sx], par[i,*,k], User_Modl, k , sub=subf
                 data_sub[0,i]=subf
             endfor
             Idp.X_tit='Function'+strtrim(k+1,2)+' '+Idp.X_tit
             MOD_DATP ,Idp,'y',yy
             MOD_DATP ,Idp,'e',0.
             if uvg.Fwks gt 0 then begin ;output in a workspace
                GIVE_W   ,data_sub,W=uvg.Fwks
                GIVE_DATP,Idp     ,W=uvg.Fwks
             endif else begin            ;output in a file
                fifi='str_W'+strtrim(uvg.Iwks,2)+'_F'+strtrim(k+1,2)
                if uvg.Reso gt 0 then if uvg.SubConv then fifi=fifi+'_conv' else fifi=fifi+'_Dconv'
                w_store   ,W=60
                GIVE_W    ,data_sub   ,W=60
                GIVE_DATP ,Idp        ,W=60
                write_lamp,fifi+'.txt',W=60,format='column'
                w_restore ,W=60
             endelse
           endfor ;function loop
       endif
 else:
 endcase
endif
end

pro str_fit_win, noTabs=noTab, iniGUI=iniGUI
;+
;** ***********
;**
;** GUI for the use of str_fit procedure
;-
@lamp.cbk
common strfit_outC, Cfunc, bid_other

if xregistered('str_fit_win') eq 0 then begin
if n_elements( lamp_b1) ne 1 then begin & lamp_b1=0 & fk=1
    lamp_font = sys_dep('FONTS')
    ft_propor    = lamp_font[0,fk] & ft_biggest   = lamp_font[1,fk]
    ft_bigger    = lamp_font[2,fk] & ft_b_bigger  = lamp_font[3,fk]
    ft_normal    = lamp_font[4,fk] & ft_b_normal  = lamp_font[5,fk]
    ft_smaller   = lamp_font[6,fk] & ft_smallest  = lamp_font[7,fk] & endif

bas0    =widget_base(title='STR_FIT input parameters Vs(Dec 2015)',/column,resource_name='lamp',/TLB_SIZE_EVENTS, YOFFSET=60)
junk1   =widget_base(bas0)
junk2   =widget_base(bas0)
bas00   =widget_base(junk1,/row)
baspara =widget_base(bas00,/column)
basdraw =widget_base(bas00,/column)

if !version.os_family eq 'unix' then frm=0   else frm=4
if sys_dep('VERSION') ge  5.6   then TabOn=1 else TabOn=0
if keyword_set(noTab)           then TabOn=0

;Left input parameters
; --------------------
  ;TabOn=0
if TabOn then begin
   bastab= widget_base(  baspara, resource_name='did')
   widget_control,default_font=ft_propor

   tabup = widget_tab(   bastab)

   tabup0  =widget_base(  tabup,title='Data  ')             ;INPUT DATA
     bR00  =widget_base(  tabup0,/column)
     bid   =widget_label( bR00,value='')
     bR0   =widget_base(  bR00, /row    , /base_align_center, /grid_layout)
     a1    =widget_base(  bR0,  /column , /base_align_left,   /grid_layout)
     a2    =widget_base(  bR0,  /column , /base_align_left,   /grid_layout)
     a3    =widget_base(  bR0,  /column , /base_align_left,   /grid_layout)

   tabup1  =widget_base(  tabup,title='Resolution ')        ;RESOLUTION
     bR1   =widget_base(  tabup1,/column) & BsensB=[bR1]
     bid   =widget_label( bR1,value='')
     butb  =widget_button(widget_base(bR1,/nonexclusive),value='Use a Resolution',font=ft_b_normal)
     butes =widget_base(  bR1  ,/exclusive,/row,map=0)
     junky =widget_base(  bR1)
     junky2=widget_base(  bR1)

   tabup2  =widget_base(  tabup,title='Model  ')            ;MODEL
     bR2   =widget_base(  tabup2,/column) & BsensB=[BsensB,bR2]
     bid   =widget_label( bR2,value='')
     b2    =widget_base(  bR2   ,/row)
     b22   =widget_base(  bR2   ,/row)

   tabup3  =widget_base(  tabup,title='Output  ')           ;OUTPUT
     br3   =widget_base(  tabup3,/column)  & BsensB=[BsensB,bR3]
     bid   =widget_label( bR3,value='')
     b3    =widget_base(  bR3 ,/row)
     b33   =widget_base(  bR3 ,/row)
     b333  =widget_base(  bR3 ,/row)
     
   tabup4  =widget_base(  tabup,title='Tools')              ;TOOLS
     bR4   =widget_base(  tabup4,/column)
     bid   =widget_label( bR4 ,value='')

endif else begin 
   baspar1 =widget_base(  baspara,frame=frm,/row,/base_align_left ,/grid_layout,resource_name='mic')
     a1    =widget_base(  baspar1,/column,/base_align_left ,/grid_layout)   ;DATA
     a2    =widget_base(  baspar1,/column,/base_align_left ,/grid_layout)
     a3    =widget_base(  baspar1,/column,/base_align_left ,/grid_layout)

     b1    =widget_base(  baspara,/row,resource_name='mic')               & BsensB=[b1]
     butb  =widget_button(widget_base(b1,/nonexclusive),value='Resolution', font=ft_b_normal)
     butes =widget_base(  b1   ,/exclusive,/row,map=0)      ;RESOLUTION
     junky =widget_base(  baspara     ,resource_name='mic')
     
   baspar2 =widget_base(  baspara,frame=frm,/column, resource_name='did') & BsensB=[BsensB,baspar2]
     b2    =widget_base(  baspar2,/row)                     ;MODEL
     b22   =widget_base(  baspar2,/row)                

   baspar3 =widget_base(  baspara,frame=frm,/column,resource_name='don')  & BsensB=[BsensB,baspar3]
     b3    =widget_base(  baspar3,/row, /base_align_center) ;OUTPUT
     bubu  =widget_button(widget_base(b3,/nonexclusive),value='OUTPUT'    , font=ft_b_normal)
     b3    =widget_base(  b3     ,/row,map=0) & uvbubu=[25,b3]
     b33   =widget_base(  baspar3,/row,map=0) & uvbubu=[uvbubu,b33]
     b333  =widget_base(  baspar3,/row,map=0) & uvbubu=[uvbubu,b333]
     widget_control,bubu,set_uvalue=uvbubu
endelse ;Tabulations

lab     =widget_label( a1   ,value='INPUT DATA '   ,font=ft_b_normal)
butmm   =widget_button(a2   ,value='None'    ,/menu,font=ft_b_normal)
butm1   =widget_button(butmm,value='W1 ->W20',/menu,font=ft_b_normal)
butm2   =widget_button(butmm,value='W21->W40',/menu,font=ft_b_normal)
if lamp_sys gt 40 then $
butm3   =widget_button(butmm,value='W41->W60',/menu,font=ft_b_normal)
for i=1,20 do begin & sa=s4v(i) & sb=s4v(i+20) & sc=s4v(i+40)
    but =widget_button(butm1,value='W'+sa,font=ft_b_normal,uvalue=[1L,butmm,i   ])
    but =widget_button(butm2,value='W'+sb,font=ft_b_normal,uvalue=[1L,butmm,i+20])
    if n_elements(butm3) eq 1 then $
    but =widget_button(butm3,value='W'+sc,font=ft_b_normal,uvalue=[1L,butmm,i+40])
endfor
but     =widget_button(butmm,value='Import File'   ,font=ft_b_normal,uvalue=[30,7])
bute    =widget_base(  a3   ,/nonexclusive)
butwght =widget_button(bute ,value='Weighting',uvalue=[6],font=ft_b_normal)
widget_control,butwght,set_button=1

bute    =widget_base(  a3   ,/nonexclusive)
butFR   =widget_button(bute ,value='Fit range'  ,uvalue=[7,0] ,font=ft_b_normal) & widget_control,but,set_button=0
xrg1    =widget_text(  a1   ,value=' Xmin  ' ,xsize=7,ysize=1,/edit,/all_event,uvalue=[14,0],font=ft_propor)
xrg2    =widget_text(  a2   ,value=' Xmax  ' ,xsize=7,ysize=1,/edit,/all_event,uvalue=[14,1],font=ft_propor)

bute    =widget_base(  a3   ,/nonexclusive)
butSpc  =widget_button(bute ,value='Data range' ,uvalue=[11],font=ft_b_normal) & widget_control,butSPC,set_button=1
srg1    =widget_text(  a1   ,value=' 1 '     ,xsize=3,ysize=1,/edit,font=ft_propor)
srg2    =widget_text(  a2   ,value='Last'    ,xsize=4,ysize=1,/edit,font=ft_propor)

baspar1 =widget_base(  baspara,/column,resource_name='mic')

;******** RESOLUTION ********

 butRw  =widget_button(butes,value='Wksp'         ,/no_release,font=ft_b_normal)
 butRg  =widget_button(butes,value='Gauss'        ,/no_release,font=ft_b_normal)
 butRl  =widget_button(butes,value='Inst/Voigt'   ,/no_release,font=ft_b_normal)
 butRs  =widget_button(butes,value='Spec#'        ,/no_release,font=ft_b_normal)

 b1k    =widget_base(  junky,/row,map=0,frame=1)         ;*******;MAP=0 WkSpce resolution
 labm   =widget_label( b1k  ,value='   WkSpce=',font=ft_b_normal)
 butm   =widget_button(b1k  ,value='None'         ,/menu,font=ft_b_normal)
 but    =widget_button(butm ,value='None'         ,font=ft_b_normal,uvalue=[10L,butm,0   ])
 butm1  =widget_button(butm ,value='W1 ->W20'     ,/menu,font=ft_b_normal)
 butm2  =widget_button(butm ,value='W21->W40'     ,/menu,font=ft_b_normal)
if lamp_sys gt 40 then $
 butm3  =widget_button(butm ,value='W41->W60'     ,/menu,font=ft_b_normal)
 for i=1,20 do begin & sa=s4v(i) & sb=s4v(i+20) & sc=s4v(i+40)
    but =widget_button(butm1,value='W'+sa         ,font=ft_b_normal,uvalue=[10L,butm,i   ])
    but =widget_button(butm2,value='W'+sb         ,font=ft_b_normal,uvalue=[10L,butm,i+20])
    if n_elements(butm3) eq 1 then $
    but =widget_button(butm3,value='W'+sc         ,font=ft_b_normal,uvalue=[10L,butm,i+40])
 endfor
 but    =widget_button(butm ,value='Import File'  ,font=ft_b_normal,uvalue=[30,7])
 labm   =widget_label( b1k  ,value='   X range='  ,font=ft_b_normal)
 rxrg1  =widget_text(  b1k  ,value='-2    '       ,xsize=6,ysize=1,/edit,font=ft_propor)
 lab    =widget_label( b1k  ,value=','            ,font=ft_b_normal)
 rxrg2  =widget_text(  b1k  ,value=' 2    '       ,xsize=6,ysize=1,/edit,font=ft_propor)
 if TabOn then BBB=junky2 else begin & BBB=b1k
                    lab=widget_label(BBB  ,value=' ',font=ft_b_normal) & endelse
 binterpr=widget_base( BBB,/nonexclusive,map=0)          ;*******;MAP=0 WkSpce resolution Regular
  interpr=widget_button(binterpr,value='Set regular',font=ft_b_normal,uvalue=[27,0])

b2k     =widget_base(  junky,/row,map=0,frame=1)         ;*******;MAP=0 Gauss resolution
 labr   =widget_label( b2k  ,value='    fWmH='    ,font=ft_b_normal)
 txtr   =widget_text(  b2k  ,value=' 0.0  '       ,xsize=5,ysize=1,/edit,font=ft_propor)
 labf   =widget_label( b2k  ,value=' pVf='        ,font=ft_b_normal)
 txtf   =widget_text(  b2k  ,value='.0 '          ,xsize=3,ysize=1,/edit,font=ft_propor)
 lab    =widget_label( b2k  ,value='  '           ,font=ft_propor)
if TabOn then          BBB=junky2  else BBB=b2k
b2kk    =widget_base(  BBB)
b2k1    =widget_base(  b2kk ,/exclusive,/row,map=0)      ;*******;MAP=0 G/Gumbel resolution
 gum1   =widget_button(b2k1 ,value='Gauss'        ,font=ft_b_normal,uvalue=[34L, 0])
 gum2   =widget_button(b2k1 ,value='Left Gumbel'  ,font=ft_b_normal,uvalue=[34L, 1])
 gum3   =widget_button(b2k1 ,value='Right'        ,font=ft_b_normal,uvalue=[34L,-1])
b2k2    =widget_base(  b2kk ,/row,map=0)                 ;*******;MAP=0 Inst deltaX resolution
 lab    =widget_label( b2k2 ,value=' '                     ,font=ft_propor)
 lab    =widget_label( b2k2 ,value='Instrument Delta.X '   ,font=ft_b_normal)
 butm   =widget_button(b2k2 ,value='None'         ,/menu   ,font=ft_b_normal)  & butdti=[butRl,butm,labr,txtr]
 but    =widget_button(butm ,value='None'                  ,font=ft_b_normal    ,uvalue=[33L,butm,0,labr,txtr])
 butm1  =widget_button(butm ,value='W1 ->W20'     ,/menu   ,font=ft_b_normal)
 butm2  =widget_button(butm ,value='W21->W40'     ,/menu   ,font=ft_b_normal)
 if lamp_sys gt 40 then $
 butm3  =widget_button(butm ,value='W41->W60'     ,/menu   ,font=ft_b_normal)
 but    =widget_button(butm ,value='Use Z value from the Data' ,font=ft_b_normal,uvalue=[33L,butm,-1,labr,txtr])
 but    =widget_button(butm ,value='Import from File XY'   ,font=ft_b_normal,uvalue=[30,7])
 lab    =widget_button(butm ,value=''                      ,font=ft_b_normal)  & widget_control,lab,sens=0
 but    =widget_button(butm ,value='Set pVf: 0=Gauss 1=Lorentz',font=ft_b_normal,uvalue=[37L,txtf])
 for i=1,20 do begin & sa=s4v(i) & sb=s4v(i+20) & sc=s4v(i+40)
     but=widget_button(butm1,value='W'+sa,font=ft_b_normal,uvalue=[33L,butm,i   ,labr,txtr])
     but=widget_button(butm2,value='W'+sb,font=ft_b_normal,uvalue=[33L,butm,i+20,labr,txtr])
     if n_elements(butm3) eq 1 then $
     but=widget_button(butm3,value='W'+sc,font=ft_b_normal,uvalue=[33L,butm,i+40,labr,txtr])
 endfor

b3k     =widget_base(  junky,/row,map=0,frame=1)        ;*******;MAP=0 Spect# resolution
 labs   =widget_label( b3k  ,value='    Spec#'    ,font=ft_b_normal)
 txts   =widget_text(  b3k  ,value='0  '          ,xsize=3,ysize=1,/edit,font=ft_propor)
 labm   =widget_label( b3k  ,value='   X range='  ,font=ft_b_normal)
 sxrg1  =widget_text(  b3k  ,value='       '      ,xsize=7,ysize=1,/edit,font=ft_propor)
 lab    =widget_label( b3k  ,value=','            ,font=ft_b_normal)
 sxrg2  =widget_text(  b3k  ,value='       '      ,xsize=7,ysize=1,/edit,font=ft_propor)

 if TabOn then BBB=junky2  else begin & BBB=b3k
                     lab=widget_label(BBB  ,value=' ',font=ft_b_normal) & endelse
 binterps=widget_base(BBB,/nonexclusive,map=0)          ;*******;MAP=0 Spect# regular
  interps=widget_button(binterps,value='Set regular',font=ft_b_normal,uvalue=[27,1])

widget_control,butb ,set_uvalue=[9L,0,b1k,b2k,b3k,labf,txtf,b2k1,b2k2,labr,txtr,binterpr,binterps,butes]
widget_control,butRw,set_uvalue=[9L,1,b1k,b2k,b3k,labf,txtf,b2k1,b2k2,labr,txtr,binterpr,binterps]
widget_control,butRg,set_uvalue=[9L,2,b1k,b2k,b3k,labf,txtf,b2k1,b2k2,labr,txtr,binterpr,binterps]
widget_control,butRl,set_uvalue=[9L,3,b1k,b2k,b3k,labf,txtf,b2k1,b2k2,labr,txtr,binterpr,binterps]
widget_control,butRs,set_uvalue=[9L,4,b1k,b2k,b3k,labf,txtf,b2k1,b2k2,labr,txtr,binterpr,binterps]
resob   =[txtr,txtf,txts,rxrg1,rxrg2,sxrg1,sxrg2]

widget_control,gum1 ,set_button=1

;******** MODEL ********

lab     =widget_label( b2   ,value='MODEL   '              ,font=ft_b_normal)
buttC   =widget_button(b2   ,value='.......Choice.......'  ,/menu,font=ft_b_normal)
buttU   =widget_button(buttC,value='Enter your Model'      ,uvalue=[4,6,buttC],font=ft_b_normal)
but     =widget_button(buttC,value='or'                                       ,font=ft_b_normal) ; & widget_control,but,sens=0
butte   =widget_button(buttC,value='Let find a peak using:',/menu             ,font=ft_b_normal)
butg    =widget_button(butte,value='Gaussians'             ,uvalue=[4,1,buttC],font=ft_b_normal)
butl    =widget_button(butte,value='Lorentzians'           ,uvalue=[4,2,buttC],font=ft_b_normal)
butp    =widget_button(butte,value='Pseudo-Voigts'         ,uvalue=[4,3,buttC],font=ft_b_normal)
butf    =widget_button(butte,value='Pseudo-V (fixed)'      ,uvalue=[4,4,buttC],font=ft_b_normal)
butevent=widget_button(buttC,value=' '                                        ,font=ft_b_normal) & widget_control,but,sens=0 ;Used to create an event
lab     =widget_label( b2   ,value=' '                     ,font=ft_propor)
b11PV   =widget_base(  b2   ,/row,map=0)
labPV   =widget_label( b11PV,value='PVfixed='              ,font=ft_b_normal)
txtf    =widget_text(  b11PV,value='.50'                   ,xsize=3,ysize=1,/edit,/all_event,font=ft_propor)
widget_control,txtf,set_uvalue=[4,40,buttC,butf,butg,butl,butp]
if TabOn then BBB0=widget_base(bR2,/row) else BBB0=b22
if TabOn then begin & BBB =widget_base(bR2,/row) ;UNUSED YET
endif    else begin & BBB =b2
                    lab     =widget_label( BBB,value=' ',font=ft_propor)
                    conse   =widget_button(BBB,value='Constraints',uvalue=[15,0,0],font=ft_b_normal)
                    but_on  =widget_button(widget_base(BBB,/nonexclusive),value='On',uvalue=[15,1,conse],font=ft_b_normal)
                    widget_control,conse,sens=0
endelse

lab     =widget_label( b22  ,value='Background: ',font=ft_b_normal)
butm    =widget_button(b22  ,value='Flat bkgrd'  ,/menu,font=ft_b_normal)
but     =widget_button(butm ,value='None'        ,uvalue=[5,3,butm],font=ft_b_normal)
but     =widget_button(butm ,value='Flat'        ,uvalue=[5,0,butm],font=ft_b_normal)
but     =widget_button(butm ,value='Linear'      ,uvalue=[5,1,butm],font=ft_b_normal)
but     =widget_button(butm ,value='Quadratic'   ,uvalue=[5,2,butm],font=ft_b_normal)
lab     =widget_label( b22  ,value='   '                           ,font=ft_propor)

lab     =widget_label( BBB0 ,value='[ Optional Shape Bgrd'          ,font=ft_b_normal)
butm    =widget_button(BBB0 ,value='None'        ,/menu,font=ft_b_normal)
but     =widget_button(butm ,value='None'        ,font=ft_b_normal,uvalue=[12L,butm,0   ])
butm1   =widget_button(butm ,value='W1 ->W20'    ,/menu,font=ft_b_normal)
butm2   =widget_button(butm ,value='W21->W40'    ,/menu,font=ft_b_normal)
if lamp_sys gt 40 then $
butm3   =widget_button(butm ,value='W41->W60'    ,/menu,font=ft_b_normal)
for i=1,20 do begin & sa=s4v(i) & sb=s4v(i+20) & sc=s4v(i+40)
    but =widget_button(butm1,value='W'+sa        ,font=ft_b_normal,uvalue=[12L,butm,i   ])
    but =widget_button(butm2,value='W'+sb        ,font=ft_b_normal,uvalue=[12L,butm,i+20])
    if n_elements(butm3) eq 1 then $
    but =widget_button(butm3,value='W'+sc        ,font=ft_b_normal,uvalue=[12L,butm,i+40])
endfor
but     =widget_button(butm ,value='Import File' ,font=ft_b_normal,uvalue=[30,7])
but     =widget_button(widget_base(BBB0,/nonexclusive),value='fix ]' ,uvalue=[13],font=ft_b_normal)

;******** OUTPUT ********

lab     =widget_label( b3   ,value='File(str_params) '                      ,font=ft_b_normal)

filn    =widget_text(  b3   ,value='str_fit.txt    ',xsize=18,ysize=1,/edit ,font=ft_propor)
fapp    =widget_button(widget_base(b3,/nonexclusive),value='Append'         ,font=ft_b_normal,uvalue=[28,0])

lab     =widget_label( b33  ,value='Title',font=ft_b_normal)
ttl     =widget_text(  b33  ,value=' '    ,xsize=38,ysize=1,/edit,font=ft_propor)

lab     =widget_label( b333 ,value='Fit parameters output',font=ft_b_normal)
butm    =widget_button(b333 ,value='None'    ,/menu,font=ft_b_normal)
but     =widget_button(butm ,value='None'    ,font=ft_b_normal,uvalue=[2L,butm,0   ])
butm1   =widget_button(butm ,value='W1 ->W20',/menu,font=ft_b_normal)
butm2   =widget_button(butm ,value='W21->W40',/menu,font=ft_b_normal)
if lamp_sys gt 40 then $
butm3   =widget_button(butm ,value='W41->W60',/menu,font=ft_b_normal)
for i=1,20 do begin & sa=s4v(i) & sb=s4v(i+20) & sc=s4v(i+40)
    but =widget_button(butm1,value='W'+sa,font=ft_b_normal,uvalue=[2L,butm,i   ])
    but =widget_button(butm2,value='W'+sb,font=ft_b_normal,uvalue=[2L,butm,i+20])
    if n_elements(butm3) eq 1 then $
    but =widget_button(butm3,value='W'+sc,font=ft_b_normal,uvalue=[2L,butm,i+40])
endfor
butm4   =widget_button(butm ,value='In File "str_Wi_Fk_Pj.txt"',uvalue=[2L,butm,-1  ],font=ft_b_normal)
but     =widget_button(butm ,value=' '                    ,font=ft_b_normal)
butP    =widget_button(butm ,value='Parameter selection'  ,font=ft_b_normal,/menu)
  btmp    =lonarr(23)
  btmp[0] =widget_button(butP ,value='- P0 (0 pseudo-voigt factors)',font=ft_b_normal)
  btmp[1] =widget_button(butP ,value='- P1 (1 or Heights)'          ,font=ft_b_normal)
  btmp[2] =widget_button(butP ,value='- P2 (2 or Centers)'          ,font=ft_b_normal)
  btmp[3] =widget_button(butP ,value='- P3 (3 or Widths)'           ,font=ft_b_normal)
  btmp[4] =widget_button(butP ,value='- A0 (4 flat   backgrd)'              ,font=ft_b_normal)
  btmp[5] =widget_button(butP ,value='- A1 (5 slope  backgrd fct)'          ,font=ft_b_normal)
  btmp[6] =widget_button(butP ,value='- A2 (6 quad.  backgrd fct)'          ,font=ft_b_normal)
  btmp[7] =widget_button(butP ,value='- I1 (7 spectrum-backgrd sums)'       ,font=ft_b_normal)
  btmp[8] =widget_button(butP ,value='- I2 (8 fit-backgrd sums)'            ,font=ft_b_normal)
  btmp[9] =widget_button(butP ,value='- I3 (9 theorical functions integral)',font=ft_b_normal)
  btmp[10]=widget_button(butP ,value='- P4 (10)'                       ,font=ft_b_normal)
  btmp[11]=widget_button(butP ,value='- P5 (11)'                       ,font=ft_b_normal)
  butPP   =widget_button(butP ,value='Other parameters P6...'     ,font=ft_b_normal,/menu)
  btmp[12]=widget_button(butPP,value='- P6  (12)'                      ,font=ft_b_normal)
  btmp[13]=widget_button(butPP,value='- P7  (13)'                      ,font=ft_b_normal)
  btmp[14]=widget_button(butPP,value='- P8  (14)'                      ,font=ft_b_normal)
  btmp[15]=widget_button(butPP,value='- P9  (15)'                      ,font=ft_b_normal)
  btmp[16]=widget_button(butPP,value='- P10 (16)'                      ,font=ft_b_normal)
  btmp[17]=widget_button(butPP,value='- P11 (17)'                      ,font=ft_b_normal)
  btmp[18]=widget_button(butPP,value='- P12 (18)'                      ,font=ft_b_normal)
  btmp[19]=widget_button(butPP,value='- P13 (19)'                      ,font=ft_b_normal)
  btmp[20]=widget_button(butPP,value='- P14 (20)'                      ,font=ft_b_normal)
  btmp[21]=widget_button(butPP,value='- P15 (21)'                      ,font=ft_b_normal)
  but     =widget_button(butP ,value='    '                       ,font=ft_b_normal)
  btmp[22]=widget_button(butP ,value='* All parameters'           ,font=ft_b_normal)
  j=n_elements(btmp)-1
  for i=0,j-1 do widget_control,btmp[i],set_uvalue=[29, i,btmp]
                 widget_control,btmp[j],set_uvalue=[29,-1,btmp]

lab     =widget_label( b333 ,value='  ',font=ft_propor)
if TabOn then BBB=widget_base(bR3,/row) else BBB=b333
lab     =widget_label( BBB  ,value='Fitted data output',font=ft_b_normal)
butm    =widget_button(BBB  ,value='None'    ,/menu,font=ft_b_normal)
but     =widget_button(butm ,value='None'          ,font=ft_b_normal,uvalue=[3L,butm,0   ])
butm1   =widget_button(butm ,value='W1 ->W20',/menu,font=ft_b_normal)
butm2   =widget_button(butm ,value='W21->W40',/menu,font=ft_b_normal)
if lamp_sys gt 40 then $
butm3   =widget_button(butm ,value='W41->W60',/menu,font=ft_b_normal)
for i=1,20 do begin & sa=s4v(i) & sb=s4v(i+20) & sc=s4v(i+40)
    but =widget_button(butm1,value='W'+sa,font=ft_b_normal,uvalue=[3L,butm,i   ])
    but =widget_button(butm2,value='W'+sb,font=ft_b_normal,uvalue=[3L,butm,i+20])
    if n_elements(butm3) eq 1 then $
    but =widget_button(butm3,value='W'+sc,font=ft_b_normal,uvalue=[3L,butm,i+40])
endfor
butm4   =widget_button(butm ,value='In File "str_Wi_Fk.txt"',uvalue=[3L,butm,-1  ],font=ft_b_normal)

lab     =widget_button(butm ,value=' '                                            ,font=ft_b_normal)
lab     =widget_button(butm ,value='To export a (de)convoluted Sub-Function,'     ,font=ft_b_normal,uvalue=[38])
lab     =widget_button(butm ,value='select a number with the FunctionNB slider'   ,font=ft_b_normal,uvalue=[38])
lab     =widget_button(butm ,value='(un)check the []Convol right button'          ,font=ft_b_normal,uvalue=[38])
lab     =widget_button(butm ,value='then --> CLICK ON THIS TEXT'                  ,font=ft_b_normal,uvalue=[38])

;********
if Tabon then begin & bempty= widget_base(baspara, ysize=50)
           baspar4 =widget_base(  baspara          ,/column,resource_name='did')
endif else baspar4 =widget_base(  baspara,frame=frm,/column,resource_name='did')
BsensB  =[BsensB,baspar4]
b4      =widget_base(  baspar4,/row)
if lamp_b1 gt 0 then CALL_PROCEDURE,'put_logo',b4
lab     =widget_label( b4   ,value=' '        ,font=ft_propor)
but_FIT =widget_button(b4   ,value='->FIT NOW',font=ft_b_normal,uvalue=[8,1,buttC])
         widget_control,buttC,set_uvalue=[but_FIT,b11PV]
mess    =widget_label( b4   ,value='                    ',font=ft_propor)

tabdon =0L
tabdon3=0L
bempty =0L
tabdOFF=0
if Tabon then begin
  tabdOFF= 100
  bempty = widget_base(  baspara, ysize=tabdOFF)
  bastab = widget_base(  baspara, resource_name='don',/base_align_bottom)

  tabdon = widget_tab(   bastab, uvalue=[-1])

     tabdon0  =widget_base(  tabdon ,title='Spectra  ')     ;SPECTRA
     bid      =widget_label( tabdon0,value="Use the Spectra slider for scrolling          ",font=ft_propor)
   
     tabdon1  =widget_base(  tabdon ,title='P Limits  ')    ;P.SLIDERS
     bid      =widget_label( tabdon1,value="Use the [See only] button in your MODEL Window",font=ft_propor)
   
     tabdon2  =widget_base(  tabdon ,title='P Result  ')   ;P.RESULTS
     bid      =widget_label( tabdon2,value="The Last Fitted Parameters Values             ",font=ft_propor)
   
     tabdon3  =widget_base(  tabdon ,title='Constraint')    ;CONSTRAINTS
     bid      =widget_label( tabdon3,value="This option is unusable from a User MODEL     ",font=ft_propor)

  bTool   =bR4
  dxsTab  =145
endif else begin
  dxsTab  =0
  bTool   =b4
  but_Pr  =widget_button(b4   ,value='P result' ,font=ft_b_normal,uvalue=[0,1])
  lab     =widget_label( b4   ,value=' '        ,font=ft_propor)
endelse

if lamp_b1 le 0 then $
  but  =widget_button(bTool,value='Close'       ,font=ft_b_normal,uvalue=[50]) $
else begin
  if TabOn then begin
   tool1=widget_button(bTool,value='About Input  DATA'      ,font=ft_b_normal,/menu)
     but=widget_button(tool1,value='OverPlotting'           ,font=ft_b_normal,uvalue=[30,1])
     but=widget_button(tool1,value='Scroll Spectra'         ,font=ft_b_normal,uvalue=[30,2])
     but=widget_button(tool1,value='3d contour'             ,font=ft_b_normal,uvalue=[31,4])
     but=widget_button(tool1,value='Import DATA'            ,font=ft_b_normal,uvalue=[30,7])
     but=widget_button(tool1,value='Show data Parameters'   ,font=ft_b_normal,uvalue=[30,8])
   tool2=widget_button(bTool,value='About Fitted DATA'      ,font=ft_b_normal,/menu)
     but=widget_button(tool2,value='3d contour of fitted Data' ,font=ft_b_normal,uvalue=[31,5])
     but=widget_button(tool2,value='3d contour of fitted Bkgd' ,font=ft_b_normal,uvalue=[31,6])
   tool3=widget_button(bTool,value='FIT ENGINE USED'   ,font=ft_b_normal,/menu)
     bu1=widget_button(tool3,value='* DR.gradient-expansion technique (COOLFIT based upon Numerical Recipes)',font=ft_propor)
     bu2=widget_button(tool3,value='  Levenberg-G.Marquardt technique (MPFIT   based upon Minpack-1)'        ,font=ft_propor)
     bu3=widget_button(tool3,value='  G.Marquardt-SG.Nash   technique (TNMIN   Truncated-Newton Method)'     ,font=ft_propor)
     bu4=widget_button(tool3,value='  RM. Dimeo             technique (RMD_GA  Genetic Algorithm Search)'    ,font=ft_propor)
   tool4=widget_base(  btool,/row)
     but=widget_button(tool4,value='Do a command'      ,font=ft_b_normal,uvalue=[30,4])
     but=widget_button(tool4,value='Help'              ,font=ft_b_normal,uvalue=[0,0])
     but=widget_button(tool4,value='Exit'              ,font=ft_b_normal,uvalue=[50])
   
  endif else begin
   tools=widget_button(bTool,value='Tools'       ,font=ft_b_normal,/menu)
     but=widget_button(tools,value='OverPlotting   (Input)'    ,font=ft_b_normal,uvalue=[30,1])
     but=widget_button(tools,value='Scroll Spectra (Input)'    ,font=ft_b_normal,uvalue=[30,2])
     but=widget_button(tools,value='GK-fit         (Input)'    ,font=ft_b_normal,uvalue=[30,3])
     bum=widget_button(tools,value='3d contour plot'           ,font=ft_b_normal,/menu)
     but=widget_button(bum  ,value='3d contour of input  Data' ,font=ft_b_normal,uvalue=[31,4])
     but=widget_button(bum  ,value='3d contour of fitted Data' ,font=ft_b_normal,uvalue=[31,5])
     but=widget_button(bum  ,value='3d contour of fitted Bkgd' ,font=ft_b_normal,uvalue=[31,6])
     but=widget_button(tools,value='Mpeg Movie panel'  ,font=ft_b_normal,uvalue=[30,6])
     but=widget_button(tools,value='Do input cmd'      ,font=ft_b_normal,uvalue=[30,4])
     but=widget_button(tools,value='Stress supplement' ,font=ft_b_normal,uvalue=[30,5])  & widget_control,but,sensitive=0
     but=widget_button(tools,value='FIT ENGINE USED'   ,font=ft_b_normal,/menu)
     bu1=widget_button(but  ,value='* DR.gradient-expansion technique (COOLFIT based upon Numerical Recipes)',font=ft_propor)
     bu2=widget_button(but  ,value='  Levenberg-G.Marquardt technique (MPFIT   based upon Minpack-1)'        ,font=ft_propor)
     bu3=widget_button(but  ,value='  G.Marquardt-SG.Nash   technique (TNMIN   Truncated-Newton Method)'     ,font=ft_propor)
     bu4=widget_button(but  ,value='  RM. Dimeo             technique (RMD_GA  Genetic Algorithm Search)'    ,font=ft_propor)
     but=widget_button(tools,value='Help'              ,font=ft_b_normal,uvalue=[0,0])
     but=widget_button(tools,value='Exit'              ,font=ft_b_normal,uvalue=[50])
  endelse
  widget_control,bu1,set_uvalue=[18L,1,bu1,bu2,bu3,bu4]
  widget_control,bu2,set_uvalue=[18L,2,bu1,bu2,bu3,bu4]
  widget_control,bu3,set_uvalue=[18L,3,bu1,bu2,bu3,bu4] ,sens=0
  widget_control,bu4,set_uvalue=[18L,4,bu1,bu2,bu3,bu4] ,sens=0
endelse

;Large draw windows
; -----------------
basdrwL =widget_base(  junk1,/column,resource_name='did',map=0)
b1      =widget_base(  basdrwL,/row)
sld0    =widget_slider(b1   ,xsize=125, title='',/drag,uvalue=[22])
;lab    =widget_label (b1   ,value=' '           ,font=ft_propor)
but     =widget_button(b1   ,value='Fct'         ,/menu,font=ft_b_normal)
 bid    =widget_button(but  ,value='(See selected parameter for one Function)' ,font=ft_b_normal)
 bid    =widget_button(but  ,value=' '                          ,font=ft_b_normal)
 bid    =widget_button(but  ,value='ALL'         ,uvalue=[26,0] ,font=ft_b_normal)
 bid    =widget_button(but  ,value='Func 1'      ,uvalue=[26,1] ,font=ft_b_normal)
 bid    =widget_button(but  ,value='Func 2'      ,uvalue=[26,2] ,font=ft_b_normal)
 bid    =widget_button(but  ,value='Func 3'      ,uvalue=[26,3] ,font=ft_b_normal)
 bid    =widget_button(but  ,value='Func 4'      ,uvalue=[26,4] ,font=ft_b_normal)
 bid    =widget_button(but  ,value='Func 5'      ,uvalue=[26,5] ,font=ft_b_normal)
 bid    =widget_button(but  ,value='Func 6'      ,uvalue=[26,6] ,font=ft_b_normal)
 bid    =widget_button(but  ,value='Func 7'      ,uvalue=[26,7] ,font=ft_b_normal)
 bid    =widget_button(but  ,value='Func 8'      ,uvalue=[26,8] ,font=ft_b_normal)
 bid    =widget_button(but  ,value='Func 9'      ,uvalue=[26,9] ,font=ft_b_normal)
 bid    =widget_button(but  ,value='Func 10'     ,uvalue=[26,10],font=ft_b_normal)
bute    =widget_base(  b1   ,/exclusive,/row)
butcS1  =widget_button(bute ,value='Sum'         ,uvalue=[20,1] ,/no_release,font=ft_b_normal)
butFctA =widget_button(bute ,value='Fct Int'     ,uvalue=[20,9] ,/no_release,font=ft_b_normal)
but     =widget_button(bute ,value='p1.Ht'       ,uvalue=[20,3] ,/no_release,font=ft_b_normal)
but     =widget_button(bute ,value='p2.Pos'      ,uvalue=[20,0] ,/no_release,font=ft_b_normal)
but     =widget_button(bute ,value='p3.fW'       ,uvalue=[20,2] ,/no_release,font=ft_b_normal)
butdat1 =widget_button(bute ,value='Data'        ,uvalue=[20,4] ,/no_release,font=ft_b_normal)
but     =widget_button(bute ,value='2d'          ,uvalue=[20,5] ,/no_release,font=ft_b_normal)
but     =widget_button(bute ,value='2d Bkgd'     ,uvalue=[20,6] ,/no_release,font=ft_b_normal)
but     =widget_button(bute ,value='Fit/Data'    ,uvalue=[20,7] ,/no_release,font=ft_b_normal)
butPVf  =widget_button(bute ,value='PVfact'      ,uvalue=[20,8] ,/no_release,font=ft_b_normal)
bmor    =widget_button(b1   ,value='more'        ,/menu                     ,font=ft_b_normal)
but     =widget_button(bmor ,value='Reduce the plot area' ,uvalue=[21,1]    ,font=ft_b_normal)
butp4   =widget_button(bmor ,value='Plot parameters P4...',/menu            ,font=ft_b_normal)
but     =widget_button(butp4,value='P4'          ,uvalue=[20,10]            ,font=ft_b_normal)
but     =widget_button(butp4,value='P5'          ,uvalue=[20,11]            ,font=ft_b_normal)
but     =widget_button(butp4,value='P6'          ,uvalue=[20,12]            ,font=ft_b_normal)
but     =widget_button(butp4,value='P7'          ,uvalue=[20,13]            ,font=ft_b_normal)
but     =widget_button(butp4,value='P8'          ,uvalue=[20,14]            ,font=ft_b_normal)
but     =widget_button(butp4,value='P9'          ,uvalue=[20,15]            ,font=ft_b_normal)
but     =widget_button(butp4,value='P10'         ,uvalue=[20,16]            ,font=ft_b_normal)
but     =widget_button(butp4,value='P11'         ,uvalue=[20,17]            ,font=ft_b_normal)
but     =widget_button(butp4,value='P12'         ,uvalue=[20,18]            ,font=ft_b_normal)
but     =widget_button(butp4,value='P13'         ,uvalue=[20,19]            ,font=ft_b_normal)
but     =widget_button(butp4,value='P14'         ,uvalue=[20,20]            ,font=ft_b_normal)
but     =widget_button(butp4,value='P15'         ,uvalue=[20,21]            ,font=ft_b_normal)

dxsnp=300        & dysnp=150          ;Size One Scroll Spectrum
dxs  =440+dxsTab & dys  =320 & gap=6  ;Size Draw Plot Left

draw0   =widget_draw(  basdrwL,colors=-30,xsize=dxs,ysize=dys,/button_event,uvalue=[23])

;Right draw windows
; -----------------
basdrw1 =widget_base(  basdraw,frame=frm,/column,resource_name='did') & BsensB=[BsensB,basdraw]
b1      =widget_base(  basdrw1,/row)
bute    =widget_base(  b1   ,/exclusive,/row)
butcS2  =widget_button(bute ,value='Sum'         ,uvalue=[20,1] ,/no_release,font=ft_b_normal)
if TabOn then $
butFctB =widget_button(bute ,value='Fct Int'     ,uvalue=[20,9] ,/no_release,font=ft_b_normal)
if TabOn then $
but     =widget_button(bute ,value='Fit/Data'    ,uvalue=[20,7] ,/no_release,font=ft_b_normal)

but     =widget_button(bute ,value='p1.Ht'       ,uvalue=[20,3] ,/no_release,font=ft_b_normal)
but     =widget_button(bute ,value='p2.Pos'      ,uvalue=[20,0] ,/no_release,font=ft_b_normal)
but     =widget_button(bute ,value='p3.fW'       ,uvalue=[20,2] ,/no_release,font=ft_b_normal)
butdat2 =widget_button(bute ,value='Data'        ,uvalue=[20,4] ,/no_release,font=ft_b_normal)
but     =widget_button(bute ,value='2d'          ,uvalue=[20,5] ,/no_release,font=ft_b_normal)
bmor    =widget_button(b1   ,value='more'        ,/menu                     ,font=ft_b_normal)
but     =widget_button(bmor ,value='Extend the plot area',uvalue=[21,0]     ,font=ft_b_normal)
butp4   =widget_button(bmor ,value='Plot parameters P4...',/menu            ,font=ft_b_normal)
but     =widget_button(butp4,value='P4'          ,uvalue=[20,10]            ,font=ft_b_normal)
but     =widget_button(butp4,value='P5'          ,uvalue=[20,11]            ,font=ft_b_normal)
but     =widget_button(butp4,value='P6'          ,uvalue=[20,12]            ,font=ft_b_normal)
but     =widget_button(butp4,value='P7'          ,uvalue=[20,13]            ,font=ft_b_normal)
but     =widget_button(butp4,value='P8'          ,uvalue=[20,14]            ,font=ft_b_normal)
but     =widget_button(butp4,value='P9'          ,uvalue=[20,15]            ,font=ft_b_normal)
but     =widget_button(butp4,value='P10'         ,uvalue=[20,16]            ,font=ft_b_normal)
but     =widget_button(butp4,value='P11'         ,uvalue=[20,17]            ,font=ft_b_normal)
but     =widget_button(butp4,value='P12'         ,uvalue=[20,18]            ,font=ft_b_normal)
but     =widget_button(butp4,value='P13'         ,uvalue=[20,19]            ,font=ft_b_normal)
but     =widget_button(butp4,value='P14'         ,uvalue=[20,20]            ,font=ft_b_normal)
but     =widget_button(butp4,value='P15'         ,uvalue=[20,21]            ,font=ft_b_normal)
widget_control,butdat2,set_button=1
draw1   =widget_draw(  basdrw1,colors=-30,xsize=dxs,ysize=dys,/button_event,uvalue=[23])

b1      =widget_base(  basdraw,/row, /base_align_bottom)
lab     =widget_label( b1   ,value=' Spectra'      ,font=ft_b_normal, /align_bottom)
sld     =widget_slider(b1   ,xsize=235, title=''   ,/drag,uvalue=[22])
if TabOn then FuncLab= '     Function_Nb' else FuncLab=' Func'
lab     =widget_label( b1   ,value=FuncLab         ,font=ft_b_normal, /align_bottom)
sldp    =widget_slider(b1   ,xsize=115, title=''   ,/drag,uvalue=[26,-1])
if TabOn then $
butconv =widget_button(widget_base(b1,/nonexclusive, /align_bottom),value='Convol',uvalue=[39],font=ft_b_normal)

b2      =widget_base(  basdraw,/row, /base_align_center)
bute    =widget_base(  b2   ,/nonexclusive)
but     =widget_button(bute ,value='Residuals'     ,font=ft_b_normal,uvalue=[24])
bute    =widget_base(  b2   ,/nonexclusive,/row)
butPrg  =widget_button(bute ,value=' Xplot'  ,uvalue=[7,1] ,font=ft_b_normal) & widget_control,butPrg,set_button=0
prg1    =widget_text(  b2   ,value=' Xmin  ' ,xsize=7,ysize=1,/edit,/all_event,uvalue=[14,2],font=ft_propor)
lab     =widget_label( b2   ,value=','       ,font=ft_b_normal)
prg2    =widget_text(  b2   ,value=' Xmax  ' ,xsize=7,ysize=1,/edit,/all_event,uvalue=[14,3],font=ft_propor)
Yrgm    =0L
if TabOn then begin
  bute  =widget_base(  b2   ,/nonexclusive)
  butYrg=widget_button(bute ,value=' Ymax'   ,uvalue=[7,2] ,font=ft_b_normal) & widget_control,butYrg,set_button=0
  Yrgm  =widget_text(  b2   ,value=' Ymax  ' ,xsize=7,ysize=1,/edit,/all_event,uvalue=[14,4],font=ft_propor)
endif
bute    =widget_base(  b2   ,/nonexclusive,/row)
but     =widget_button(bute ,value=' Y0'      ,uvalue=[32]  ,font=ft_b_normal) & widget_control,but,set_button=0

butlg   =widget_button(b2   ,value='NoLog'   ,/menu              ,font=ft_b_normal)
but     =widget_button(butlg,value='NoLog'   ,uvalue=[35,0,butlg],font=ft_b_normal) & XYlog=[but]
but     =widget_button(butlg,value='X Log'   ,uvalue=[35,1,butlg],font=ft_b_normal) & XYlog=[XYlog,but]
but     =widget_button(butlg,value='Y Log'   ,uvalue=[35,2,butlg],font=ft_b_normal) & XYlog=[XYlog,but]
but     =widget_button(butlg,value='XYLog'   ,uvalue=[35,3,butlg],font=ft_b_normal) & XYlog=[XYlog,but]

btext   =widget_base(  junk2        ,map=0) ;text (Parameters results)
bhelp   =widget_base(  junk2,/column,map=1) ;help
bas01   =widget_base(  junk2,/row   ,map=0) ;scroll (3 snaps plots base)
cstra   =widget_base(  junk2,/column,map=0) ;constraints
fview   =widget_base(  junk2,        map=0  ,scr_xsize=dxsnp*3,scr_ysize=dysnp,/scroll,/frame) ;Formula parameter player

;Formula params player
fviewer =widget_base(  fview,/column)
widget_control,fview,set_uvalue=fviewer

;Text (Parameters results)
;****
btexts  =widget_text(  btext,scr_xsize=dxsnp*3,scr_ysize=dysnp,/scroll,font=ft_propor)
widget_control,btext,set_uvalue=btexts

;Scroll (3 snaps plots base)
;******
draw21  =widget_draw(  bas01,xsize=dxsnp,ysize=dysnp,/button_event,uvalue=[-88,0],event_pro='lamp_event_parser')
draw22  =widget_draw(  bas01,xsize=dxsnp,ysize=dysnp,/button_event,uvalue=[-88,0],event_pro='lamp_event_parser')
draw23  =widget_draw(  bas01,xsize=dxsnp,ysize=dysnp,/button_event,uvalue=[-88,0],event_pro='lamp_event_parser')

;Help
;****
lab     =widget_label( widget_base(bhelp,/row),value='INPUT:  Select at least a workspace containing the input spectrum(a). Use Fit range to bound a fit region. Use Spectra range to fit few of them.'  ,font=ft_b_normal)
lab     =widget_label( widget_base(bhelp,/row),value='ENTER A MODEL: This feature allows you to choose many functions in a new window. Bound, tie, fix any parameters, enter your formula (see RULES).' ,font=ft_b_normal)
lab     =widget_label( widget_base(bhelp,/row),value='FIND A PEAK: Use this feature to fit rapidly using one classical function. Selecting Pseudo-Voigt unfixed implies that pvFactor will be fitted.'  ,font=ft_b_normal)
lab     =widget_label( widget_base(bhelp,/row),value='             Multiple/Overlapped Peaks Outline works with a Resolution function. Shape_Background: level is fitted unless fix is not set.'        ,font=ft_b_normal)
lab     =widget_label( widget_base(bhelp,/row),value='PLOTTING:    Move "SPECTRA/FUNC" to scroll on fit/parameters results. Click on left mouse-button to change Ymax (drag to change Xrange).'         ,font=ft_b_normal)

;Constraints
;***********
col1    =widget_base(  cstra,/row)
 lab    =widget_label( col1 ,value='CONSTRAINTS OUTLINE:',font=ft_b_normal)
 sheme  =widget_base(  col1 ,/exclusive,/row)
   but1p=widget_button(sheme,value='ONE peak'            ,font=ft_b_normal,/no_release)
   but2p=widget_button(sheme,value='DOUBLE peak'         ,font=ft_b_normal,/no_release)
   butml=widget_button(sheme,value='MULTIPLE peaks'      ,font=ft_b_normal,/no_release)
   butsp=widget_button(sheme,value='OVERLAPPED peaks  '  ,font=ft_b_normal,/no_release)
 lab    =widget_label( col1 ,value='FLAT BACKGROUND'     ,font=ft_b_normal)
 txtb   =widget_text(  col1 ,value=' 0.0 ',xsize=5,ysize=1,/edit        ,font=ft_propor)
 butbg  =widget_button(widget_base(col1 ,/nonexclusive),value='fix'     ,font=ft_b_normal,uvalue=[17,0])

col2    =widget_base(  cstra,/row,resource_name='did')
 col21  =widget_base(  col2 ,/row,frame=1)
  lab   =widget_label( col21,value='CENTER'                             ,font=ft_b_normal)
  txtc  =widget_text(  col21,value='     ',xsize=5,ysize=1,/edit        ,font=ft_propor)
  but   =widget_button(widget_base(col21,/nonexclusive),value='fix ,'   ,font=ft_b_normal,uvalue=[17,1])
  lowc  =widget_text(  col21,value='     ',xsize=5,ysize=1,/edit        ,font=ft_propor)
  but   =widget_button(widget_base(col21,/nonexclusive),value='low ,'   ,font=ft_b_normal,uvalue=[17,2])
  uppc  =widget_text(  col21,value='     ',xsize=5,ysize=1,/edit        ,font=ft_propor)
  but   =widget_button(widget_base(col21,/nonexclusive),value='up'      ,font=ft_b_normal,uvalue=[17,3])
 lab    =widget_label( col2 ,value=' '                                  ,font=ft_b_normal)
 col22  =widget_base(  col2 ,/row,frame=1)
  labwth=widget_label( col22,value='<-->(fWmH)'                         ,font=ft_b_normal)
  txtw  =widget_text(  col22,value='     ',xsize=5,ysize=1,/edit        ,font=ft_propor)
  but   =widget_button(widget_base(col22,/nonexclusive),value='fix ,'   ,font=ft_b_normal,uvalue=[17,4])
  loww  =widget_text(  col22,value='     ',xsize=5,ysize=1,/edit        ,font=ft_propor)
  but   =widget_button(widget_base(col22,/nonexclusive),value='low ,'   ,font=ft_b_normal,uvalue=[17,5])
  uppw  =widget_text(  col22,value='     ',xsize=5,ysize=1,/edit        ,font=ft_propor)
  but   =widget_button(widget_base(col22,/nonexclusive),value='up'      ,font=ft_b_normal,uvalue=[17,6])

col3    =widget_base(  cstra,/row,resource_name='did')
 col31  =widget_base(  col3 ,/row,frame=1)
  lab   =widget_label( col31,value='2nd Height~'                        ,font=ft_b_normal)
  txth2 =widget_text(  col31,value='     ',xsize=5,ysize=1,/edit        ,font=ft_propor)
  lab   =widget_label( col31,value=', fWmH~'                            ,font=ft_b_normal)
  txtw2 =widget_text(  col31,value='     ',xsize=5,ysize=1,/edit        ,font=ft_propor)
 col32  =widget_base(  col3 ,/row,frame=1)
  but   =widget_button(widget_base(col32,/nonexclusive),value='+3rd ,'  ,font=ft_b_normal,uvalue=[17,8])
 ;but   =widget_button(widget_base(col32,/nonexclusive),value='Split params' ,font=ft_b_normal,uvalue=[17,7]) & widget_control,but,set_button=1
  but2c =widget_button(widget_base(col32,/nonexclusive),value='Centered',font=ft_b_normal)
 lab    =widget_label( col3 ,value=''                                   ,font=ft_b_normal)
 col33  =widget_base(  col3 ,/row,frame=1)
  lab   =widget_label( col33,value='# Peaks ~'                          ,font=ft_b_normal)
  txtn1 =widget_text(  col33,value='   ',xsize=3,ysize=1,/edit          ,font=ft_propor)
  but   =widget_button(widget_base(col33,/nonexclusive),value='fix ,'   ,font=ft_b_normal,uvalue=[17,9])
  lab   =widget_label( col33,value='quality'                            ,font=ft_b_normal)
  butz  =widget_button(col33,/menu,value='Normal'                       ,font=ft_b_normal)
   but  =widget_button(butz ,value='Give a quality 1->5 to your data'   ,font=ft_b_normal)
   but  =widget_button(butz ,value='Good data improve the process of peaks separation',font=ft_b_normal)
   but  =widget_button(butz ,value='Overestimate should produce imaginary peaks'      ,font=ft_b_normal)
   but  =widget_button(butz ,value=' '                                  ,font=ft_b_normal)
   but  =widget_button(butz ,value='-> 1 noisy'                         ,font=ft_b_normal,uvalue=[19,10,1,butz])
   but  =widget_button(butz ,value='-> 2 normal'                        ,font=ft_b_normal,uvalue=[19,10,2,butz])
   but  =widget_button(butz ,value='-> 3 good-looking'                  ,font=ft_b_normal,uvalue=[19,10,3,butz])
   but  =widget_button(butz ,value='-> 4 smooth'                        ,font=ft_b_normal,uvalue=[19,10,4,butz])
   but  =widget_button(butz ,value='-> 5 top-quality (analytical)'      ,font=ft_b_normal,uvalue=[19,10,5,butz])
   labw =widget_label( col33,value='mean Width'                         ,font=ft_b_normal)
  txtmw =widget_text(  col33,value='     ',xsize=5,ysize=1,/edit        ,font=ft_propor)

uvs=[col21,col22,col31,col32,col33,labw,txtmw,but2c]
uvt=[txtb,txtc,lowc,uppc,txtw,loww,uppw ,0L,0L,txtn1,0L ,txth2,txtw2,txtmw] & uvf=uvt*0
uvf[7]=1 & uvf[10]=2 ;split_params (7) & quality (10)
widget_control,but1p,set_uvalue=[16,1,uvs],set_button=1
widget_control,but2c,set_uvalue=[16,2,uvs]
widget_control,but2p,set_uvalue=[16,3,uvs]
widget_control,butsp,set_uvalue=[16,4,uvs]
widget_control,butml,set_uvalue=[16,5,uvs]
widget_control,col31,sens=0 & widget_control,col32,sens=0 & widget_control,col33,sens=0

widget_control,bas0  ,/realize & if lamp_b1 gt 0 then CALL_PROCEDURE,'put_logo'
gml=widget_info(  junk1 ,/geometry) & stx=gml.scr_xsize & sty=gml.scr_ysize
gm0=widget_info(  bas0  ,/geometry) & b0x=gm0.scr_xsize & b0y=gm0.scr_ysize

drawx1=dxs         &   drawy1=dys                   ;small draw
drawx0=stx-2*gap   &   drawy0=sty-(sty-dys)/2       ;large draw
drawxs=stx/3-gap   &   drawys=dysnp                 ;3 snaps

widget_control,btexts,scr_xsize=drawxs*3
widget_control,fview ,scr_xsize=drawxs*3

widget_control,draw1 ,get_value=win1
widget_control,draw0 ,get_value=win0  ,xsize=drawx0 ,ysize=drawy0
widget_control,draw21,get_value=win21 ,xsize=drawxs
widget_control,draw22,get_value=win22 ,xsize=drawxs
widget_control,draw23,get_value=win23 ,xsize=drawxs
wins=[ win1, win21, win22, win23, win1, win0]
winb=[draw1,draw21,draw22,draw23,draw1,draw0]

redim={ori_win1:[dxs,dys],ori_win0:[drawx0,drawy0],ori_wins:[drawxs,drawys],$
       cur_win1:[dxs,dys],cur_win0:[drawx0,drawy0],cur_wins:[drawxs,drawys],$
       ori_bas0:[b0x,b0y],cur_bas0:[b0x,b0y],$
       TabDoff:TabDoff}

uvg={Iwks:0,Pwks:0,Fwks:0,Func:3,PVf:0.50,PVtxt:txtf,Bgrd:0,Wght:1,Xrg:0,Xrgb1:xrg1,Xrgb2:xrg2,Xrang:[0.,0.],Filn:filn,labWTH:labwth, $
     Ttl:ttl,Reso:0,ResoW:0,ResoDTI:0,ResoGUM:0,Resob:resob,Plot:4,Wins:wins,Slid:[sld,sld0],Vslid:0,Mess:mess,Junk:[bhelp,bas01,cstra,bas00,basdrwL,btext,fview],$
     Srg:1,Srgb1:srg1,Srgb2:srg2,Srang:[0L,0L],Isiz:[0L,0L,0L],Pres:0,Bwks:0,BSfix:0 ,Toggln:0,Sheme:1,Shemt:uvt,Shemf:uvf,Constr:1,Y0:0,wdraw:[draw1,draw0],$
     YMax:0.,Xtmp:[0.,0.],Xd:[0L,0L],Ftech:1,Follow:0,Interp:[0,0],Append:0,Prg:0,Prgb1:prg1,Prgb2:prg2,Prang:[0.,0.],Yrg:0,Pyrgm:0.,Slidp:[sldp],Vslidp:0,$
     Plog:0,FPDisp:0,Px:-1,Ptit:'f H C W b l q D F'  ,redim:redim,Winb:winb,BAS0:bas0, TabDon:TabDon, Tabconstrain:TabDon3, Bempty:bempty, SubConv:0}

widget_control,butmm ,set_uvalue=BsensB
for i=0,n_elements(BsensB)-1 do widget_control,BsensB[i] ,sens=0

widget_control,bas0,set_uvalue=uvg
XMANAGER,'str_fit_win',bas0,event_handler='str_fit_event',/no_block,/just_reg
if lamp_b1 le 0 then XMANAGER,/no_block $
                else widget_control,bas0,group_leader=lamp_b1

if sys_dep('VERSION') ge 5.6 then begin
   widget_control,butFR  ,Tooltip="Fit range: Enter one or two scalars or one or two 1D Wi"
   widget_control,butSPc ,Tooltip="Spectra range"
   widget_control,butRw  ,Tooltip="Numerical resolution is in a Workspace"
   widget_control,butRg  ,Tooltip="Gaussian analytical resolution"
   widget_control,butRl  ,Tooltip="Pseudo analytical , delta_X numerical , Poly_disperse Resolutions"
   widget_control,butRs  ,Tooltip="Numerical resolution is in One of Spectra"
   
   if n_elements(conse)   eq 1 then widget_control,conse  ,Tooltip="Un-used with Models"
   if n_elements(but_on)  eq 1 then widget_control,but_on ,Tooltip="Un-used with Models"
   if n_elements(but_pr)  eq 1 then widget_control,but_Pr ,Tooltip="List of fitted parameters"
   
   widget_control,butPrg ,Tooltip="PLOT range only"
   widget_control,butcS1 ,Tooltip="Fit integral in fit range"
   widget_control,butcS2 ,Tooltip="Fit integral in fit range"
   widget_control,butFctA,Tooltip="Theorical full function_integral"
   if n_elements(butFctB) eq 1 then widget_control,butFctB,Tooltip="Theorical full function_integral"
   if n_elements(butConv) eq 1 then widget_control,butConv,Tooltip="Show sub_functions 'convoluted'."
   widget_control,butdat1,Tooltip="Show spectra and fit"
   widget_control,butdat2,Tooltip="Show spectra and fit"
   widget_control,butPVf ,Tooltip="Pseudo-Voigt factor"
   
   widget_control,butwght,set_button=1 ;Bug Idl !
endif
;Register also good widgets used when iniGUI is set
;                     just a button      input data   fit range    Xrang1      Xrang2    use reso   FIT model button
bid_other={bas0:bas0, butevent:butevent, butmm:butmm, butFR:butFR, Xrg1:Xrg1, Xrg2:Xrg2, butB:butB, Minit:0L, $
           butDTI:butDTI, baseU:0L     , buttU:buttU, pdisp:lonarr(10), XYlog:XYlog, S_STRU:lonarr(10), Restoring:0, CHI2:0.}
;         [butRl,butm,labr,txtr]         userModel    dispers(0:3)      Plog(0:3)    sans_structure     restoring=1  Chi2 mean

endif ;already registered

if n_tags(iniGUI) gt 0 then begin ; INITIATE THE GUI WITH WHAT IS IN iniGUI.
   initags=tag_names(iniGUI)
   for it=0,n_elements(initags)-1 do $
   case initags[it] of
   'WIN':  BEGIN ;INPUT DATA -> a workspace number
            widget_control,bid_other.butevent ,set_uvalue=[1L, bid_other.butmm, iniGUI.WIN]
            ii=execute('str_fit_event,{WIDGET_BUTTON ,ID:bid_other.butevent,TOP:bid_other.bas0,HANDLER:0L,SELECT:1}')
           end
   'FRNG': BEGIN ;FIT RANGE -> two strings
            widget_control,bid_other.Xrg1     ,set_value=iniGUI.FRNG[0]
            widget_control,bid_other.Xrg2     ,set_value=iniGUI.FRNG[1]
            ii=execute('str_fit_event,{WIDGET_TEXT_CH,ID:bid_other.Xrg1     ,TOP:bid_other.bas0,HANDLER:0L,TYPE:0,OFFSET:0L,CH:15B}')
            ii=execute('str_fit_event,{WIDGET_TEXT_CH,ID:bid_other.Xrg2     ,TOP:bid_other.bas0,HANDLER:0L,TYPE:0,OFFSET:0L,CH:15B}')
            widget_control,bid_other.butFR    ,set_button=1      ;Fit range button event
            ii=execute('str_fit_event,{WIDGET_BUTTON ,ID:bid_other.butFR    ,TOP:bid_other.bas0,HANDLER:0L,SELECT:1}')
           end
   'DTI':  BEGIN ;INSTRUMENT RESOLUTION -> a workspace number
            widget_control,bid_other.butB     ,set_button=1      ;Use resolution event
            ii=execute('str_fit_event,{WIDGET_BUTTON ,ID:bid_other.butB     ,TOP:bid_other.bas0,HANDLER:0L,SELECT:1}')
            widget_control,bid_other.butDTI[0],set_button=1      ;Use Inst/Voigt event
            ii=execute('str_fit_event,{WIDGET_BUTTON ,ID:bid_other.butDTI[0],TOP:bid_other.bas0,HANDLER:0L,SELECT:1}')
            widget_control,bid_other.butevent ,set_uvalue=[33, bid_other.butDTI[1], iniGUI.DTI, bid_other.butDTI[2:3]]
            ii=execute('str_fit_event,{WIDGET_BUTTON ,ID:bid_other.butevent ,TOP:bid_other.bas0,HANDLER:0L,SELECT:1}')
           end
   'MODL': BEGIN ;USER MODEL WINDOW
            if bid_other.baseU gt 0L then widget_control,bid_other.baseU,bad_id=ii,/destroy

            ii=execute('str_fit_event,{WIDGET_BUTTON ,ID:bid_other.buttU    ,TOP:bid_other.bas0,HANDLER:0L,SELECT:1}')

            idx=where(initags eq 'DISP') ;POLY DISPERSITY
            if idx[0] ge 0 then begin
              j =iniGUI.DISP
              if j ge 0 then $
              ii=execute('str_fit_event,{WIDGET_BUTTON ,ID:bid_other.pdisp[j] ,TOP:bid_other.bas0,HANDLER:0L,SELECT:1}')   
            endif
            
            idx=where(initags eq 'S_STRU') ;SANS STRUCTURE
            if idx[0] ge 0 then begin
              j =iniGUI.S_STRU
              if j ge 0 then $
              ii=execute('str_fit_event,{WIDGET_BUTTON ,ID:bid_other.s_stru[j] ,TOP:bid_other.bas0,HANDLER:0L,SELECT:1}')   
            endif
           end
   'DISP': BEGIN  ;POLY DISPERSITY TREATED IN 'MODL' TAG
           end
   'S_STRU':BEGIN ;SANS STRUCTURE TREATED IN 'MODL' TAG
            end
   'IQLG': BEGIN
            jk=iniGUI.IQLG
            if jk[0]*jk[1] eq 1 then j=3 else $
            if jk[0]       eq 1 then j=2 else $
            if jk[1]       eq 1 then j=1 else j=0
            ii=execute('str_fit_event,{WIDGET_BUTTON ,ID:bid_other.XYlog[j] ,TOP:bid_other.bas0,HANDLER:0L,SELECT:1}')   
           end
   else:
   endcase
endif

end

pro str_user_defined, leader, lamp_base
;+
;** ****************
;** GUI for user models
;-

common c_lamp
common c_lamp_font
common strfit_outC, Cfunc, bid_other

if xregistered('str_user_def') eq 0 then begin

base0=widget_base(  title='User defined fitting model',/column,resource_name='lamp')

row1 =widget_base(  base0,/row,resource_name='don')
row2 =widget_base(  base0,/row)
Shoit=widget_button(row2 ,value='See only'                      ,font=ft_b_normal)
Minit=widget_button(row2 ,value='FIT model'                     ,font=ft_b_normal)
mess =widget_label( row2 ,value=string(replicate(32b,80))       ,font=ft_propor,xsize=590)

widget_control,mess ,set_value ="See the RULEs for the use of input syntax"
widget_control,Minit,set_uvalue=[42, 0,leader,base0,mess,1]
widget_control,Shoit,set_uvalue=[42,-1,leader,base0,mess,1]

bid_other.Minit = Minit

if lamp_b1 gt 0 then CALL_PROCEDURE,'put_logo',row1

Qmanual= finefile(lamp_dir+lamp_dvd+'manual'+lamp_dvd+'STR_FIT_QENS_models.pdf')

;NAME OF FUNCTIONS
;*****************                    
;        0       1       2         3       4                  9 ->      10            11       12       13
TBname=['Delta','Gauss','Lorentz','Voigt','Bose','','','','','Formula','SANS_Sphere','BosonP','Gumbel','SANS_H_Sphere']
;SubIndex UV(5)                                               0, 5, 6   1             2        3        4
;
;                     16    17        18        19        20         21           22               
TBname=[TBname,'','','DHO','Str_Exp','Iso_Rot','Uni_Rot','Rw_Trans','Rotc_Trans','FOU','','','','','']
;SubIndex UV(5)       7     8         9         10        11         12           13
;
;                     30            31              32              33              34
TBname=[TBname,'','','SANS_str_HS','SANS_str_MLtd','SANS_str_MLpc','SANS_str_MLmc','SANS_str_MSA','','','','']
;SubIndex UV(5)       21            22              23              24              25
;
;                     39             40           41              42           43
TBname=[TBname,      'SANS_Guinier','SANS_Porod','SANS_PowerLaw','SANS_Debye','SANS_TS','','','','','','']
;SubIndex UV(5)       30             31           32              33           34
;
;                     50                     51                  52                       53               54
TBname=[TBname,      'SANS_Bilayer_VESICLE','SANS_Sphere_SHELL','SANS_Multi_Lam_VESICLE','SANS_ELLIPSOID','SANS_Ellips_Core_SHELL']
;SubIndex UV(5)       41                     42                  43                       44               45
;
;                     55                  56                   57          58         59              60
TBname=[TBname,      'SANS_STAR_Polymer','SANS_STAR_PolyPoly','SANS_DISK','SANS_ROD','SANS_CYLINDER','SANS_H_CYLINDER']
;SubIndex UV(5)       46                  47                   48          49         50              51
;
;                          65               70               75         78
TBname=[TBname,'','','','','',  '','','','','',  '','','','','',  '','','']
;SubIndex UV(5)            56               61               66         69
;
;                     79            80              81            82
TBname=[TBname,      'QENS_Delta', 'QENS_Lorentz', 'QENS_Gauss', 'QENS_RandomWalkTranslation']
;SubIndex UV(5)       70            71              72            73
;
;                     83                               84                    85            
TBname=[TBname,      'QENS_JumpDiffusionTranslation', 'QENS_ChudleyElliot', 'QENS_JumpNsites']
;SubIndex UV(5)       74                               75                    76            
;
;                     86                             87                  
TBname=[TBname,      'QENS_JumpsNsitesLogNormDist', 'QENS_IsotropicRotationalDiffusion']
;SubIndex UV(5)       77                             78                  
;
;                     88               89
TBname=[TBname,      'QENS_RotTrans', 'QENS_3DLocalizedTranslation']
;SubIndex UV(5)       79               80
;
;                      90                   91                    92         
TBname=[TBname,       'QENS_DeltaLorentz', 'QENS_DeltaLorentz2', 'QENS_DeltaLorentz2b']
;SubIndex UV(5)        81                   82                    83 
;
;                      93             94             95
TBname=[TBname,       'QENS_Gauss2', 'QENS_Gauss3', 'QENS_DeltaChudleyElliot']
;SubIndex UV(5)        84             85             86
;
;                      96             97           98
TBname=[TBname,       'QENS_Natali', 'QENS_Iri1', 'QENS_Iri2']
;SubIndex UV(5)        87             88           89
;
;                      99          100         101
TBname=[TBname,       'QENS_IL1', 'QENS_IL2', 'QENS_IL3']
;SubIndex UV(5)        90          91          92
;
;                      102                       103                        104
TBname=[TBname,       'QENS_Fixed_JumpsNsites', 'QENS_Fixed_2JumpsNsites', 'QENS_Fixed_JumpsNsitesLogNormDist']
;SubIndex UV(5)        93                        94                         95
;
;                      105                       
TBname=[TBname,       'QENS_Mix1']
;SubIndex UV(5)        96                       
;

Flist=widget_button(row1 ,value='ADD a Function',/menu    ,font=ft_b_normal) ;         ,TBname IDX           ,Case IDX
 but1=widget_button(Flist,value='Gaussian'                ,font=ft_b_normal, uvalue=[40, 1,leader,base0,Flist,0, mess])
 but2=widget_button(Flist,value='Lorentzian'              ,font=ft_b_normal, uvalue=[40, 2,leader,base0,Flist,0, mess])
 but3=widget_button(Flist,value='Pseudo-Voigt'            ,font=ft_b_normal, uvalue=[40, 3,leader,base0,Flist,0, mess])
 but9=widget_button(Flist,value='Gumbel'                  ,font=ft_b_normal, uvalue=[40,12,leader,base0,Flist,3, mess])
 but9=widget_button(Flist,value='Enter your Formula -> 5P',font=ft_b_normal, uvalue=[40, 9,leader,base0,Flist,0, mess])
 but9=widget_button(Flist,value='Enter your Formula ->10P',font=ft_b_normal, uvalue=[40, 9,leader,base0,Flist,5, mess])
 but9=widget_button(Flist,value='Enter your Formula ->15P',font=ft_b_normal, uvalue=[40, 9,leader,base0,Flist,6, mess])
 but =widget_button(Flist,value=' ')

 but =widget_button(Flist,value='SANS'                    ,font=ft_b_normal,/menu)

mau1 =widget_button(but  ,value='Shape Independent' ,/menu,font=ft_b_normal) ;         ,TBname IDX           ,Case IDX
but9 =widget_button(mau1 ,value='- Guinier approximation' ,font=ft_b_normal, uvalue=[40,39,leader,base0,Flist,30, mess])
but9 =widget_button(mau1 ,value='- Porod limit'           ,font=ft_b_normal, uvalue=[40,40,leader,base0,Flist,31, mess])
but9 =widget_button(mau1 ,value='- Power law'             ,font=ft_b_normal, uvalue=[40,41,leader,base0,Flist,32, mess])
but9 =widget_button(mau1 ,value='- Debye (for linear polymer chain)',font=ft_b_normal, uvalue=[40,42,leader,base0,Flist,33, mess])
but9 =widget_button(mau1 ,value='- Teubner-Strey'         ,font=ft_b_normal, uvalue=[40,43,leader,base0,Flist,34, mess])
 bid =widget_button(but  ,value=''                        ,font=ft_b_normal)
 bid =widget_button(but  ,value=' '                       ,font=ft_b_normal)
 pdsp=widget_button(but  ,value='POLY DISPERSITY function:(None)'    ,/menu)
  bid=widget_button(pdsp  ,font=ft_propor                 ,value='None'       ,uvalue=[36,0,leader,pdsp]) & pdisp=[bid]
  bid=widget_button(pdsp  ,font=ft_propor                 ,value='Gaussian'   ,uvalue=[36,1,leader,pdsp]) & pdisp=[pdisp,bid]
  bid=widget_button(pdsp  ,font=ft_propor                 ,value='Log Norm'   ,uvalue=[36,2,leader,pdsp]) & pdisp=[pdisp,bid]
  bid=widget_button(pdsp  ,font=ft_propor                 ,value='Schultz '   ,uvalue=[36,3,leader,pdsp]) & pdisp=[pdisp,bid]
  bid_other.pdisp[0:n_elements(pdisp)-1]=pdisp
 bid =widget_button(but  ,value=' '                       ,font=ft_b_normal)

 bid =widget_button(but  ,value='STRUCTURES:'             ,font=ft_b_normal)
 bid =widget_button(but  ,value='-----------'             ,font=ft_b_normal) ;                     ,TBname IDX           ,Case IDX
 but9=widget_button(but  ,value='- Hard SPHERE'           ,font=ft_b_normal            , uvalue=[40,30,leader,base0,Flist,21 ,mess]) & S_STRU=[but9] ;0

 butb=widget_button(but  ,value='- Multi LAMELLAR'        ,font=ft_b_normal, /menu)
 but9=widget_button(butb ,value='- Multi LAMELLAR (Thermal Disorder)' ,font=ft_b_normal, uvalue=[40,31,leader,base0,Flist,22, mess]) & S_STRU=[S_STRU,but9] ;1
 but9=widget_button(butb ,value='- Multi LAMELLAR (ParaCristalline)'  ,font=ft_b_normal, uvalue=[40,32,leader,base0,Flist,23, mess]) & S_STRU=[S_STRU,but9] ;2
 but9=widget_button(butb ,value='- Multi LAMELLAR (Modified CAILLE)'  ,font=ft_b_normal, uvalue=[40,33,leader,base0,Flist,24, mess]) & S_STRU=[S_STRU,but9] ;3

 but9=widget_button(but  ,value='- Mean Spherical Approximation z>0'  ,font=ft_b_normal, uvalue=[40,34,leader,base0,Flist,25, mess]) & S_STRU=[S_STRU,but9] ;4

 bid_other.S_STRU[0:n_elements(S_STRU)-1]=S_STRU

 bid =widget_button(but  ,value=' '                       ,font=ft_b_normal)
 bid =widget_button(but  ,value='FORMS:'                  ,font=ft_b_normal)
 bid =widget_button(but  ,value='------'                  ,font=ft_b_normal) ;         ,TBname IDX           ,Case IDX
 but9=widget_button(but  ,value='- SPHERE'                ,font=ft_b_normal, uvalue=[40,10,leader,base0,Flist,1 , mess])
 but9=widget_button(but  ,value='- Hollow SPHERE'         ,font=ft_b_normal, uvalue=[40,13,leader,base0,Flist,4 , mess])
 but9=widget_button(but  ,value='- Bilayered VESICLE'     ,font=ft_b_normal, uvalue=[40,50,leader,base0,Flist,41, mess])
 but9=widget_button(but  ,value='- Spherical SHELL (linear varying contrast)' ,font=ft_b_normal,      uvalue=[40,51,leader,base0,Flist,42, mess])
 but9=widget_button(but  ,value='- Multi LAMELLAR VESICLE',font=ft_b_normal, uvalue=[40,52,leader,base0,Flist,43, mess])
 bid =widget_button(but  ,value='-'                       ,font=ft_b_normal)
 but9=widget_button(but  ,value='- ELLIPSOID'             ,font=ft_b_normal, uvalue=[40,53,leader,base0,Flist,44, mess])
 but9=widget_button(but  ,value='- Ellipsoidal core SHELL',font=ft_b_normal, uvalue=[40,54,leader,base0,Flist,45, mess])
 widget_control,but9,sens=0
 bid =widget_button(but  ,value='-'                       ,font=ft_b_normal)
 but9=widget_button(but  ,value='- STAR POLYMER (gaussian statistic)' ,font=ft_b_normal,              uvalue=[40,55,leader,base0,Flist,46, mess])
 but9=widget_button(but  ,value='- STAR polydisperse POLYMER (gaussian statistic)' ,font=ft_b_normal, uvalue=[40,56,leader,base0,Flist,47, mess])
 bid =widget_button(but  ,value='-'                       ,font=ft_b_normal)
 but9=widget_button(but  ,value='- DISK'                  ,font=ft_b_normal, uvalue=[40,57,leader,base0,Flist,48, mess])
 but9=widget_button(but  ,value='- ROD'                   ,font=ft_b_normal, uvalue=[40,58,leader,base0,Flist,49, mess])
 but9=widget_button(but  ,value='- CYLINDER'              ,font=ft_b_normal, uvalue=[40,59,leader,base0,Flist,50, mess])
 widget_control,but9,sens=0
 but9=widget_button(but  ,value='- Hollow CYLINDER'       ,font=ft_b_normal, uvalue=[40,60,leader,base0,Flist,51, mess])
 widget_control,but9,sens=0

 but =widget_button(Flist,value='TOF'                     ,font=ft_b_normal,/menu) ;   ,TBname IDX           ,Case IDX
 but8=widget_button(but  ,value='Detailed Balance fact.'  ,font=ft_b_normal, uvalue=[40, 4,leader,base0,Flist,0, mess])
 but0=widget_button(but  ,value='Delta peak'              ,font=ft_b_normal, uvalue=[40, 0,leader,base0,Flist,0, mess])
 bid =widget_button(but  ,value=' '                       ,font=ft_b_normal)
 but9=widget_button(but  ,value='D.H.Oscillator'          ,font=ft_b_normal, uvalue=[40,16,leader,base0,Flist,7, mess])
 but9=widget_button(but  ,value='Boson peak'              ,font=ft_b_normal, uvalue=[40,11,leader,base0,Flist,2, mess])
 but9=widget_button(but  ,value='Stretched Exponential'   ,font=ft_b_normal, uvalue=[40,17,leader,base0,Flist,8, mess])
 but9=widget_button(but  ,value='Iso_Rotation (Stef)'     ,font=ft_b_normal, uvalue=[40,18,leader,base0,Flist,9, mess])
 but9=widget_button(but  ,value='Uni_Rotation (Stef)'     ,font=ft_b_normal, uvalue=[40,19,leader,base0,Flist,10,mess])
 but9=widget_button(but  ,value='Rw_Trans     (Stef)    ' ,font=ft_b_normal, uvalue=[40,20,leader,base0,Flist,11,mess])
 but9=widget_button(but  ,value='Rotc_Trans   (Stef)'     ,font=ft_b_normal, uvalue=[40,21,leader,base0,Flist,12,mess])
 but9=widget_button(but  ,value='FOU Fractional brownian dynamics' ,font=ft_b_normal, uvalue=[40,22,leader,base0,Flist,13,mess])

 but =widget_button(Flist,value='QENS'                    ,font=ft_b_normal,/menu) ;        ,TBname IDX           ,Case IDX
 
 but9=widget_button(but  ,value='- Delta'                                                 ,font=ft_b_normal, uvalue=[40,79,leader,base0,Flist,70, mess])
 but9=widget_button(but  ,value='- Lorentzian (function of HWHM)'                         ,font=ft_b_normal, uvalue=[40,80,leader,base0,Flist,71, mess])
 but9=widget_button(but  ,value='- Gaussian (function of sigma)'                          ,font=ft_b_normal, uvalue=[40,81,leader,base0,Flist,72, mess])
 but9=widget_button(but  ,value='- Random Walk Translation (continuous diffusion model)'  ,font=ft_b_normal, uvalue=[40,82,leader,base0,Flist,73, mess])
 but9=widget_button(but  ,value='- Jump Diffusion Translation (jump-diffusion model)'     ,font=ft_b_normal, uvalue=[40,83,leader,base0,Flist,74, mess])
 but9=widget_button(but  ,value='- Chudley-Elliot (jump-diffusion model for translation)' ,font=ft_b_normal, uvalue=[40,84,leader,base0,Flist,75, mess])
 but9=widget_button(but  ,value='- Jumps between N equivalent sites in a circle'          ,font=ft_b_normal, uvalue=[40,85,leader,base0,Flist,76, mess])
 but9=widget_button(but  ,value='- Jumps between N sites in a circle with log-norm distr' ,font=ft_b_normal, uvalue=[40,86,leader,base0,Flist,77, mess])
 but9=widget_button(but  ,value='- Isotropic rotational diffusion'                        ,font=ft_b_normal, uvalue=[40,87,leader,base0,Flist,78, mess])
 but9=widget_button(but  ,value='- Jump-diffusion translation + isotropic rotational diff',font=ft_b_normal, uvalue=[40,88,leader,base0,Flist,79, mess])
 but9=widget_button(but  ,value='- Localized translation (Volino model)'                  ,font=ft_b_normal, uvalue=[40,89,leader,base0,Flist,80, mess])
 bid =widget_button(but  ,value='---') & widget_control,bid,sens=0
 but9=widget_button(but  ,value='- One Lorentzian  + Delta'                               ,font=ft_b_normal, uvalue=[40,90,leader,base0,Flist,81, mess])
 but9=widget_button(but  ,value='- Two Lorentzians + Delta'                               ,font=ft_b_normal, uvalue=[40,91,leader,base0,Flist,82, mess])
 but9=widget_button(but  ,value='- Two Lorentzians + Delta (using Lorentz fractions)'     ,font=ft_b_normal, uvalue=[40,92,leader,base0,Flist,83, mess])
 but9=widget_button(but  ,value='- Two Gaussians'                                         ,font=ft_b_normal, uvalue=[40,93,leader,base0,Flist,84, mess])
 but9=widget_button(but  ,value='- Three Gaussians'                                       ,font=ft_b_normal, uvalue=[40,94,leader,base0,Flist,85, mess])
 but9=widget_button(but  ,value='- Fixed population + Chudley-Elliot translation'         ,font=ft_b_normal, uvalue=[40,95,leader,base0,Flist,86, mess])
 but9=widget_button(but  ,value='- Water in biomolecular systems 15P (Natali model)'      ,font=ft_b_normal, uvalue=[40,96,leader,base0,Flist,87, mess])
 but9=widget_button(but  ,value='- Water in biomolecular systems 11P, no water rotation'  ,font=ft_b_normal, uvalue=[40,97,leader,base0,Flist,88, mess])
 but9=widget_button(but  ,value='- Water in biomolecular systems 10P, 1 roto-trans component'              , uvalue=[40,98,leader,base0,Flist,89, mess], font=ft_b_normal)
 but9=widget_button(but  ,value='- Ionic liquids, long-range translation + one component' ,font=ft_b_normal, uvalue=[40,99,leader,base0,Flist,90, mess])
 but9=widget_button(but  ,value='- Ionic liquids, long-range translation + two components',font=ft_b_normal, uvalue=[40,100,leader,base0,Flist,91, mess])
 but9=widget_button(but  ,value='- Ionic liquids, long-range + confined translation + 1 component'         , uvalue=[40,101,leader,base0,Flist,92, mess], font=ft_b_normal)
 but9=widget_button(but  ,value='- Fixed pop + Jumps on N equivalent sites in a circle'   ,font=ft_b_normal, uvalue=[40,102,leader,base0,Flist,93, mess])
 but9=widget_button(but  ,value='- Fixed pop + Jumps between N & M sites in a circle '    ,font=ft_b_normal, uvalue=[40,103,leader,base0,Flist,94, mess])
 but9=widget_button(but  ,value='- Fixed pop + Jumps on N sites in a circle with log-norm distribution'    , uvalue=[40,104,leader,base0,Flist,95, mess], font=ft_b_normal)
 but9=widget_button(but  ,value='- Fixed pop + Long-range and confined translation + isotropic rotation'   , uvalue=[40,105,leader,base0,Flist,96, mess], font=ft_b_normal)
 bid =widget_button(but  ,value='---') & widget_control,bid,sens=0

 if Qmanual gt ' ' then begin
   bid= widget_button(but ,value='---') & widget_control,bid,sens=0
   Qman=widget_button(but ,value='Qens models MANUAL (pdf)', font=ft_b_normal, uvalue=[45,1,leader], Uname=Qmanual)
 endif

;END NAME OF FUNCTIONS
;*********************                   


butbg=widget_button(widget_base(row1,/nonexclusive),value='fix   Bkgrd:',font=ft_b_normal, uvalue=[42,1,leader,base0,0,0,mess])
txtb =widget_text(  row1 ,value=' 0.0 ',xsize=5,ysize=1,/edit,font=ft_propor,uvalue=TBname)
lab  =widget_label( row1 ,value=' '                          ,font=ft_propor)

butFO=widget_button(row1 ,value='<- Seq ->'                                   ,font=ft_b_normal, /menu)
  but=widget_button(butFO,value='(In case you are fitting N spectra you can:)',font=ft_b_normal)
  but=widget_button(butFO,value=' '                                           ,font=ft_b_normal)
  but=widget_button(butFO,value='->Take the same initial parameters for all spectra'                ,uvalue=[42,2,leader, 0,butFO,0,mess],font=ft_b_normal)
  but=widget_button(butFO,value='->Loop from 1 to N taking fitted parameters from previous spectrum',uvalue=[42,2,leader, 1,butFO,0,mess],font=ft_b_normal)
  but=widget_button(butFO,value='->Loop from N to 1 taking fitted parameters from previous spectrum',uvalue=[42,2,leader,-1,butFO,0,mess],font=ft_b_normal)
  but=widget_button(butFO,value=' '                                           ,font=ft_b_normal)
  but=widget_button(butFO,value='->Fit all at once (2d)->see the rules for tied parameters'         ,uvalue=[42,2,leader, 2,butFO,0,mess],font=ft_b_normal)
  but=widget_button(butFO,value='->Fit all at once (2d)->loop from 1 to N before 2d fit (see the rules to tie params)',uvalue=[42,2,leader, 3,butFO,0,mess],font=ft_b_normal)
  but=widget_button(butFO,value='->Fit all at once (2d)->loop from N to 1 before 2d fit (see the rules to tie params)',uvalue=[42,2,leader,-3,butFO,0,mess],font=ft_b_normal)
  but=widget_button(butFO,value=' '                                           ,font=ft_b_normal)
 ;next UVALUE IS CHANGES IN 42:3 [42,3,]->[41,0,]->event->[42,3,]
  but=widget_button(butFO,value='FILL initial input values with LAST FITTED PARAMETERS',uvalue=[42,3,leader,base0, 0L ,mess,Flist,butbg],font=ft_b_normal)
  but=widget_button(butFO,value='FILL initial input values from  THE SELECTED SPECTRUM',uvalue=[42,3,leader,base0, 1L ,mess,Flist,butbg],font=ft_b_normal)
 ;next UVALUE [42,0,] -> [8,0,] (uv(1)=0 means UserModel , uv(5)=-1 means re-fit selected spectra
  but=widget_button(butFO,value='re-FIT only  THE SELECTED SPECTRUM',uvalue=[42,0,leader,base0,mess,-1],font=ft_b_normal)

lab  =widget_label( row1 ,value=' '                     ,font=ft_propor)
lab  =widget_label( row1 ,value='Name of model'         ,font=ft_b_normal)
m_nam=widget_text(  row1 ,value='User_last'             ,xsize=15,ysize=1,font=ft_propor,/edit,uvalue=[mess])
Msave=widget_button(row1 ,value='File',/menu            ,font=ft_b_normal)
  but=widget_button(Msave,value='Get from disk'         ,font=ft_b_normal, uvalue=[41,1,leader,base0,m_nam,mess,Flist,butbg])
  but=widget_button(Msave,value='save  to disk'         ,font=ft_b_normal, uvalue=[42,0,leader,base0,mess,0])
  but=widget_button(Msave,value='How to use this model as a cmd',font=ft_b_normal,/menu)
  bid=widget_button(but  ,value='1: Save a tested model to disk (file ex: "myfitmod")'  ,font=ft_propor)
  bid=widget_button(but  ,value='   lamp will write the file "model_myfitmod.pro"'      ,font=ft_propor)
  bid=widget_button(but  ,value='2: Have a look to the file "str_params.txt"'           ,font=ft_propor)
  bid=widget_button(but  ,value='   to know how is the call to str_fit'                 ,font=ft_propor)
 ;bid=widget_button(but  ,value='3: Do the command: model_myfitmod,U'                   ,font=ft_propor)
 ;bid=widget_button(but  ,value='   to read your model into the variable U'             ,font=ft_propor)
 ;bid=widget_button(but  ,value='   (for lamp_runtime use str_get_model,"myfitmod",U)'  ,font=ft_propor)
 ;bid=widget_button(but  ,value='4: Do the call to str_fit replacing'                   ,font=ft_propor)
 ;bid=widget_button(but  ,value='   User_Model=User_modl  by  User_Model=U'             ,font=ft_propor)
  bid=widget_button(but  ,value=' '                                                     ,font=ft_propor)
  bid=widget_button(but  ,value='(Edit model_myfitmod.pro to change initial parameters)',font=ft_propor)
lab  =widget_label( row1 ,value=' '                     ,font=ft_propor)
hlp  =widget_button(row1 ,value='Parameters Rules'      ,font=ft_b_normal, /menu)
  but=widget_button(hlp  ,value='Click on parameter"s name to fix it',font=ft_propor)
  but=widget_button(hlp  ,value=' ')
  but=widget_button(hlp  ,value='Input values for parameters:'                       ,font=ft_propor)
  but=widget_button(hlp  ,value='-->  9.         start with 9.'                      ,font=ft_propor)
  but=widget_button(hlp  ,value='-->   <1.1      start with 1.1  upper limit is 1.1' ,font=ft_propor)
  but=widget_button(hlp  ,value='-->   >5  <8    start with 6.5  lower limit is 5.0' ,font=ft_propor)
  but=widget_button(hlp  ,value='-->  9>8.5<10   start with 9.'                      ,font=ft_propor)
  but=widget_button(hlp  ,value='-->  2/3.*(q)^2 within PARENTHESES q is the spectrum value (y in lamp)' ,font=ft_propor)
  but=widget_button(hlp  ,value=' ')
  but=widget_button(hlp  ,value='Tied parameter syntax: (do not forget PARENTHESES) F1 is 1st function...'   ,font=ft_propor)
  but=widget_button(hlp  ,value='-->  2.0 *(P2)  is twice parameter:2 in same function',font=ft_propor)
  but=widget_button(hlp  ,value='-->  (P2F1) *2. is twice parameter:2 in function:1'   ,font=ft_propor)
  but=widget_button(hlp  ,value=' ')
  but=widget_button(hlp  ,value='Tied to itself in a 2d fit: (use BRACKETS)'           ,font=ft_propor)
  but=widget_button(hlp  ,value='-->  CHOOSE a 2D sequence from the "<-Seq->" button'  ,font=ft_propor)
  but=widget_button(hlp  ,value='-->  [9.] <11   start with 9., search for the best 2d fit',font=ft_propor)
  but=widget_button(hlp  ,value='-->  [.5]*(q)^2 start with .5, (q) is the spectrum value (y in lamp)',font=ft_propor)
  but=widget_button(hlp  ,value=' ')
  but=widget_button(hlp  ,value='Labelling: (do not forget the COLUMN)'              ,font=ft_propor)
  but=widget_button(hlp  ,value='-->  PLABEL: 9.     start with 9.'                  ,font=ft_propor)
  but=widget_button(hlp  ,value=' ')
  but=widget_button(hlp  ,value='Press "FIT model" to start the fit'                 ,font=ft_propor)
lab  =widget_label( row1 ,value=' '                     ,font=ft_propor)
done =widget_button(row1 ,value='Exit'                  ,font=ft_b_normal, uvalue=[43,0,leader,base0])

widget_control,base0 ,set_uvalue=[0L,txtb,m_nam]
widget_control,base0,/realize & if lamp_b1 gt 0 then CALL_PROCEDURE,'put_logo'
XMANAGER,'str_user_def',base0,event_handler='str_fit_event',group_leader=leader,/no_block,/just_reg
bid_other.baseU=base0

endif
end

pro str_slider_param,base=bas6, model=UM, Q=Q, UV=uvshow, cmd=cmd2
;+
;** ****************
;**
;** Make a sliders base for model parameters
;-
common c_lamp_font

  widget_control,bas6,get_uvalue=baslid        ;Re-construct the column base
  widget_control,baslid, bad_id=ii,/destroy
  baslid=widget_base(bas6  ,/column)
  widget_control,bas6,set_uvalue=baslid
  widget_control,default_font=ft_b_normal

  umON =where(UM.ON eq 1) & nk=n_elements(umON)
  nbSLD=6
  for kk =0,nk-1 do begin
    k    =umON[kk]
    Fstr = strtrim(k+1,2)
    brow =widget_base( baslid,/row)
    labV ='F'+Fstr+'->'+UM.NAME[k]+' '+UM.FORMULA[k]
    if kk eq 0 then labV=labV+'    ***PLAY WITH THE SLIDERS TO ADJUST YOUR PARAMETERS***'
    bid  =widget_label(brow,value=labV, font=ft_b_normal)
    S    =nbSLD+1
    for j=0,UM.NPAR[k]-1 do begin
      qexp=UM.QEXP[j,k]
      if (UM.FITP[j,k] eq 0) and (strpos(strupcase(qexp),'(P') eq -1) then begin ;not fixed neither tied
        pname =UM.PNAMES[j,k]
        Px    ='P'+strtrim(j+1,2)
        if pname le ' ' then pname=Px
        Sval=UM.PARAMS[j,k]
        if qexp gt ' '    then ii=execute('Sval='+qexp)
        if Sval eq 0. then Mval=Sval+0.1 else Mval=Sval
        if UM.BOUNDA[j,k] then Sinf=UM.LIMITA[j,k] $
                          else Sinf=Sval-10.*Mval
        if UM.BOUNDB[j,k] then Supr=UM.LIMITB[j,k] $
                          else Supr=Sval+10.*Mval
        S  =S+1
        if S gt nbSLD then begin & brow=widget_base( baslid,/row) & S=1 & endif
        tit='F'+Fstr+' '+Px+'->  '+pname
        uvS=[uvshow,j,k]
        bid=CW_Fslider(brow, xsize=115, title=tit, mini=Sinf, maxi=Supr, value=Sval, $
                       uvalue=uvS, /edit, /frame) ;,/drag)
       ;print,'F'+Fstr+' '+pname+': '+strtrim(Sval,2)+' > '+strtrim(Sinf,2)+' < '+strtrim(Supr,2)
      endif
    endfor
  endfor
  bid  =widget_label(baslid,value=cmd2, font=ft_b_normal)
end

;Coolfit to MPfit interface (TNfit)(GAfit)
;**************************
;Coolfit engine
;**************
;MPfit to Coolfit interface
;**************************

function cool2ga_eval, p, dp, _EXTRA=extra
;+
;******* ************
;** rmd_ga evaluation interface (un_used)
;-
common mpcoolfit_common, fcn, x, y, wts, f

  if n_params() GT 1 then call_procedure, fcn, x, p, f, dp $
  else                    call_procedure, fcn, x, p, f
  return, total(wts*(y-f)^2)  ;return a scalar for minGA
end
function cool2tn_eval, p, dp, _EXTRA=extra
;+
;******* ************
;** tnmin evaluation interface (un_used)
;-
common mpcoolfit_common, fcn, x, y, wts, f

  if n_params() GT 1 then call_procedure, fcn, x, p, f, dp $
  else                    call_procedure, fcn, x, p, f
  if n_params() GT 1 then begin
                          pder=reform(dp,n_elements(x),n_elements(p))
                          for i=0,n_elements(p)-1 do pder[*,i]=pder[*,i]*wts
                          dp  =reform(total( abs(pder),1))  & endif
  return, total(wts*(y-f)^2)  ;return a scalar for TNmin
end
function cool2mp_eval, p, dp, _EXTRA=extra
;+
;******* ************
;** coolfit to mpfit evaluation interface
;-
common mpcoolfit_common, fcn, x, y, wts, f

  if n_params() GT 1 then call_procedure, fcn, x, p, f, dp $
  else                    call_procedure, fcn, x, p, f
  return, (y-f)*wts
end

;******* *******
function COOL2MP,  x, y, weightsIn, a, sigma,    FUNCTION_NAME =Function_Name,  $
                   FITA  =fita,   ITMAX =itmax,  ITER          =iter, TOL=tol,  $
                   CHISQ =chisq,  DOUBLE=double, NODERIVATIVE  =noderivative,   $
                   YERROR=yerror, STATUS=status, BOUNDA=bounda ,LIMITA=limita ,TIED=tied ,MPf=mpf
;+
;******* *******
;** coolfit to mpfit engine interface
;-

forward_function mpfit, tnmin, rmd_ga

common mpcoolfit_common, fc, xc, yc, wc, mc

  if n_elements(noderivative) ne 1 then noderivative = 0 & errmsg='' & status= 0
  fc = Function_Name & xc = x & yc = y & wc = sqrt(weightsIn) & mc = 0L & ac = 0
  if n_elements(tol) GT 0 then ftol = tol
  na = n_elements(a)
  nfree=n_elements(y)-na
  if n_elements(tied) eq 0 then tie_idx=-1 else tie_idx=where(tied gt ' ')

  if (n_elements(fita) gt 0) or (n_elements(bounda) gt 0) or (tie_idx[0] ge 0) then begin
      parinfo = replicate({value:0.D, fixed:0.D, limited:[0,0], limits:[0.D,0], tied:''}, na)
      if (n_elements(fita)   gt 0) then       parinfo[*].fixed      =1-fita
      if (n_elements(bounda) gt 0) then begin
          idx= where(bounda[0,*] eq 1) & if idx[0] ge 0 then a[idx]=a[idx] > limita[0,idx]
          idx= where(bounda[1,*] eq 1) & if idx[0] ge 0 then a[idx]=a[idx] < limita[1,idx]
                                              parinfo[*].limited    =bounda
                                              parinfo[*].limits     =limita & endif
      if (tie_idx[0] ge 0)         then       parinfo[*].tied       =tied
                                              parinfo[*].value      =a

      idf=where(parinfo[*].fixed eq 1) & afx =n_elements(idf)
      if idf[0] ge 0               then begin & nfree=nfree +afx
                                              parinfo[idf].limits[0]=a[idf]
                                              parinfo[idf].limits[1]=a[idf] & endif else afx=0
  endif

  if mpf eq 1 then begin
     autoderiv=noderivative & autoderiv=1 ;MPFIT dont like my derivatives!!!
     a = mpfit('cool2mp_eval', a, maxiter=itmax,   $
             autoderivative=autoderiv, ftol=ftol,  $
             parinfo=parinfo, STATUS=status, nfev=nfev, BESTNORM=fnorm,   $
             covar=covar, perror=sigma, niter=iter,$ ;nfree=nfree,dof=dof,$
             ERRMSG=errmsg, quiet=1,/fastnorm)
     chisq =fnorm/(nfree>1)
    ;print,'MPFIT Chi2=',chisq, ' nfree=',nfree
  endif
  if mpf eq 2 then begin
     autoderiv=0
     a = call_function('tnmin','cool2tn_eval', a, maxiter=itmax,   $
             autoderivative=autoderiv,             $
             parinfo=parinfo, STATUS=status, nfev=nfev, BESTMIN =minTN,   $
             niter=iter, ERRMSG=errmsg, quiet=1)
     errmsg=''
     sigma =a*0.
     chisq =minTN/(nfree>1) ;no sens (just to compare)
    ;print,'TNMIN Chi2=',chisq, ' nfree=',nfree
  endif
  if mpf eq 3 then begin & ftol=0.015
     a = call_function('rmd_ga',ftol,  function_name='cool2ga_eval', function_value=minGA, $
             prange=parinfo[*].limits, itmax=itmax, stretch_factor=.5, $
             GENE_LENGTH=10, ncalls=iter,   NPOP=((na-afx)*7)>20, quiet=1)
     a=reform(a)
     sigma =a*0.
     chisq =minGA/(nfree>1) ;no sens (just to compare)
    ;print,'RMD_GA Chi2=',chisq, ' nfree=',nfree
  endif

  if errmsg gt ' ' then print,errmsg
  if status eq  5  then status=2 else status=0

  yfit = temporary(mc) & xc   = 0 & yc = 0 & wc = 0 & mc = 0 & ac = 0

  yerror = a[0]*0.
  if n_elements(yerror) ne 0 then $
  if n_elements(dof) GT 0 then if dof[0] GT 0 then yerror[0]=sqrt( total((y-yfit)^2 )/dof[0])

  return, yfit
end

;Make NR_fit (6.0) available for all Idl versions  -->added: Lower limits. Upper limits. Tied (!!!dids)
;Make NR_fit (6.0) available for all Idl versions  -->added: Lower limits. Upper limits. Tied
;Make NR_fit (6.0) available for all Idl versions  -->added: ....
FUNCTION COOLFIT,  x, y, weightsIn, a, sigma,    FUNCTION_NAME =Function_Name,  $
                   FITA  =fita,   ITMAX =itmax,  ITER          =iter,TOL=tole,  $
                   CHISQ =chisq,  DOUBLE=double, NODERIVATIVE  =noderivative,   $
                   YERROR=yerror, STATUS=status, BOUNDA=bounda ,LIMITA=limita ,TIED=tied ,MPf=mpf
;+
;******* *******
;** coolfit engine
;-

    if n_elements(mpf) ne 1 then mpf=0
    if mpf ne 0 then return,COOL2MP( $
                   x, y, weightsIn, a, sigma,    FUNCTION_NAME =Function_Name,  $
                   FITA  =fita,   ITMAX =itmax,  ITER          =iter,TOL=tole,  $
                   CHISQ =chisq,  DOUBLE=double, NODERIVATIVE  =noderivative,   $
                   YERROR=yerror, STATUS=status, BOUNDA=bounda ,LIMITA=limita ,TIED=tied ,MPf=mpf)

    status = 0   ; Assume success
    toldef = 1d-3
    dendef = 1d7

    sza=size(a) & type=sza[sza[0]+1]
    double = (N_ELEMENTS(double) LT 1) ? (type EQ 5) : KEYWORD_SET(double)
    CASE double OF
    0: IF (type NE 4) THEN a = float(a)  ;Make params floating
    1: IF (type NE 5) THEN a = double(a) ;Make params double
    ENDCASE
    IF n_elements(tole)  EQ 0 THEN tole  = double ? 1d-3 : 1e-3  ;Convergence tol
    IF n_elements(itmax) EQ 0 THEN itmax = 20                    ;Maximum # iterations
    tol= tole & itrmax=itmax

   ;IF we will be estimating partial derivatives THEN compute machine precision
    res = machar() & RMIN=1.e-15  ;& RMIN=res.xmin   ;!!!dids ,note keyword double is absent
    eps = sqrt(double(res.eps))

   ;Handle fixed parameters
   ;***********************
        NODERIV= keyword_set(NODERIVATIVE)
        nterms = N_ELEMENTS(a)              ; # of parameters
        nspect = 1
        if (N_ELEMENTS(fita) ne nterms)   then fita = REPLICATE(1, nterms)
        if (N_ELEMENTS(tied) lt nterms)   then tied =['']
   ;Keep all parameters in matricies !!!dids
   ;********************************
        iparam= lindgen(nterms) & nparam=nterms
        nY    = n_elements(y)
        nfree = nY - nparam                 ; Degrees of freedom

        bidt=-1
        bid =where(fita eq 0)
        if bid[0] ge 0 then begin
           if (N_ELEMENTS(bounda) ne nterms*2) then bounda=lonarr(2,nterms)
           if (N_ELEMENTS(limita) ne nterms*2) then limita=dblarr(2,nterms)
           bounda[*,bid]=1 & limita[0,bid]=transpose(a[bid]) & limita[1,bid]=limita[0,bid]
           nfree=nfree+n_elements(bid)
        endif
        if n_elements(bid) eq nterms then itrmax=1 ;one shoot to see initial function
 
       ;DEFINE TIEPOS 1D and 2D to handle derivatives and 2D mean -> -1 or TIED PARARM index
       ;*********************************************************
        tie_idx=where(tied gt ' ') & tie_idx1=-1 & tie_idx2=-1

        if tie_idx[0] ge 0 then begin & tiepos=lonarr(nterms)-1 & tiepos1D=tiepos & tiepos2D=tiepos & pn=0L
           for iq=0,n_elements(tie_idx)-1 do begin & cur=tie_idx[iq]                   ; cur  is current the index in tied expressions
               expr=strlowcase(tied[cur]) & bid1='p[' & bid2='p['                      ; expr is current expression
               ip =strpos(expr,bid1) & ipp=strpos(expr,bid2) & if ipp ge 0 then ip=ipp ; ip   is position of 'p[' in expr
               if ip ge 0 then begin & reads, strmid(expr,ip+2,5),pn & tiepos[cur]= pn ; pn   is extracted from p[pn]
                  if ip eq 0 then tiepos2D[cur]= pn      else tiepos1D[cur]= pn
                  ;          **** Tied on itself 'P[pn]' **** Tied with an other '(P[pn])*expr'
                  if ip eq 0 then tiepos2D[pn] = pn    & endif
           endfor
           tie_idx1= where(tiepos1D ge 0) & Ntie_idx1=n_elements(tie_idx1)
           tie_idx2= where(tiepos2D ge 0) & Ntie_idx2=n_elements(tie_idx2)
           tie_idx = where(tiepos   ge 0) & Ntie_idx =n_elements(tie_idx)  ;Unused
          ;Fix the tied parameters
           if tie_idx1[0] ge 0 then begin & temp=where(fita[tie_idx1] eq 1)
              if temp[0] ge 0 then begin & fita[tie_idx1[temp]]=0 & nfree=nfree+n_elements(temp) & bidt=where(fita eq 0) & endif
           endif
          ;Prepare 2D param index
           if tie_idx2[0] ge 0 then begin
              nspect=n_elements(where(tiepos2D eq tiepos2D[tie_idx2[0]])) ;Number of spectra
              index2D=lonarr(nspect , Ntie_idx2/nspect)
              for tp=0,(Ntie_idx2/nspect) -1 do begin & cur=tie_idx2[tp] & p2D=tiepos2D[cur]
                  index2D[*,tp] = where(tiepos2D eq p2D) & endfor         ;Tp is the nuber of 2D> parameters
           endif
        endif
        

        IF nfree LE 0 THEN MESSAGE,'Number of parameters in A must be less than number of dependent values in Y.'

        IF (nterms EQ 1) THEN a = a[0]      ; Ensure a is a scalar
        flambda=double ? 0.001d : 0.001     ; Initial lambda
        diag   =LINDGEN(nparam)*(nparam + 1); Subscripts of diagonal elements
        sigma  =double ? DBLARR(nterms) : FLTARR(nterms)
        sigma1 =sigma
        Fpara1 =FLTARR(nparam)+1

   ;Handle boundaries  ;!!!dids
   ;*****************
        low_idx=[-1] & upp_idx=[-1]
        if (N_ELEMENTS(bounda) eq nterms*2) and (N_ELEMENTS(limita) eq nterms*2) then begin
            low_idx=WHERE(bounda[0,*])
            upp_idx=WHERE(bounda[1,*])
            if low_idx[0] ge 0 then a[low_idx]=a[low_idx]>limita[0,low_idx]
            if upp_idx[0] ge 0 then a[upp_idx]=a[upp_idx]<limita[1,upp_idx] & endif

       ;EXECUTE FIRST WHAT IS IN TIED EXPRESSIONS should be already done for 2D param!!
       ;*****************************************
        if tie_idx1[0] ge 0 then begin & P=A
           for tp=0,Ntie_idx1-1 do ii=execute('a[tie_idx1[tp]]='+tied[tie_idx1[tp]]) & endif

   ;Define the partial derivative array
   ;***********************************
        IF NODERIV THEN $
        pder = double ? dblarr(nY, nterms) : fltarr(nY, nterms)

        noWeighting = N_ELEMENTS(weightsIn) le 1
        weights     = noWeighting ? REPLICATE(1.0, nY) : weightsIn
        if not noWeighting then noWeighting = min(weights,max=mx)+mx eq 2.

    error_msg1 = 'Result F from "'+ Function_name+'" must have same number of elements as Y.'
    error_msg2 = 'PDER from "'    + Function_name+'" must be of size N_ELEMENTS(Y) by N_ELEMENTS(A).'

   ;MAIN ITERATION LOOP
   ;*******************
    FOR iter   = 1, itrmax DO BEGIN

          IF NODERIV THEN BEGIN                   ;Evaluate function and estimate partial derivatives
            call_procedure, Function_name, x, a, yfit
            if iter eq 1 then IF (N_ELEMENTS(yfit) NE nY) THEN MESSAGE, error_msg1
            FOR term= 0, nterms-1 DO BEGIN        ; Evaluate parameters to fit
              if fita[term] then begin
                p   = a                           ; Copy current parameters
                inc = eps * abs(p[term])          ; Increment size for forward difference derivative
                IF (inc EQ 0.) THEN inc = eps
                p[term] = p[term] + inc

               ;if nspect gt 1 then begin idxD=where(tiepos2D eq term) ; FIT 2D: tied itself parameter
               ;   if idxD(0) ge 0 then P(idxD)=P(idxD)+inc & endif    ; seems  giving same results!!!
                    
                call_procedure, function_name, x, p, yfit1
                pder[0,term] = (yfit1-yfit)/inc
              endif
            ENDFOR

          ENDIF ELSE BEGIN ; The user's procedure will return partial derivatives
            call_procedure, function_name, x, a, yfit, pder
            IF iter eq 1 then IF  N_ELEMENTS(yfit) NE nY        THEN MESSAGE, error_msg1
            IF iter eq 1 then IF  N_ELEMENTS(pder) ne nY*nterms THEN MESSAGE, error_msg2
            IF  nterms EQ 1 THEN pder = reform(pder,  nY, 1)
          ENDELSE

         ;Tied derivatives !!!dids
         ;****************
          if NODERIV then $
          if bidt[0]     ge  0 then pder[*,bidt]=RMIN else $ ; fixed params including tied 1D param
          if bid[ 0]     ge  0 then pder[*,bid] =RMIN        ; fixed params if none are tied

         ;Evaluate alpha and beta matricies.

          pderT = pder[*,iparam]
          beta  = (nparam eq 1) ? [TOTAL((y-yfit)*Weights*pderT)] : (y-yfit)*Weights # pderT
          alpha = TRANSPOSE(pderT) # (Weights # Fpara1 * pder)
          array = alpha
          Narray= n_elements(alpha)
          
          alphaD= alpha[diag]>RMIN ;!!!dids >0.
          alpha[diag]=alphaD

         ;save current values of return parameters
          sigma1[*]    = sqrt( 1.0 / alphaD )   ; Current sigma.
          sigma[iparam]= sigma1

          chisq1 = total(Weights*(y-yfit)^2)/nfree   ; Current chi squared.
          chisq  = chisq1
          yfit1  = yfit

          done_early = chisq1 LT total(abs(y))/dendef/nfree
          IF done_early THEN if tol  lt toldef THEN GOTO, done $
                             else begin & tol=tol/10. & dendef=dendef*10. & endelse

          c = sqrt(alphaD)
          c = c # c

          lambdaCount = 0

          if itrmax gt 1 then begin
          REPEAT BEGIN

             lambdaCount = lambdaCount + 1
             array[*]    = alpha / c                ; Normalize alpha to have unit diagonal.
             array[diag] = array[diag]*(1.+flambda) ; Augment the diagonal.

            ;Invert modified curvature matrix to find new parameters.
             IF Narray EQ 1 THEN array=(1.0 / array) ELSE array = invert(temporary(array))
             arrayD      = array[diag]>0.  ;!!!dids >0.
             array[diag] = arrayD

             b = a
             b[iparam] = a[iparam] + array/c # transpose(beta) ; New params
             IF (nterms EQ 1) THEN b = b[0]                    ; Ensure b is a scalar

            ;Lower limits. Upper limits ;!!!dids
            ;**************************
             Sdid=1. ;0->4 ;S adjustment*
             if upp_idx[0] ge  0 then begin & idp=where(b[upp_idx] gt limita[1,upp_idx]) ; out of limits params
                 if idp[0] ge  0 then b[upp_idx[idp]]=(a[upp_idx[idp]] +Sdid*limita[1,upp_idx[idp]])/(Sdid+1.)
             endif
             if low_idx[0] ge  0 then begin & idp=where(b[low_idx] lt limita[0,low_idx]) ; out of limits params
                 if idp[0] ge  0 then b[low_idx[idp]]=(a[low_idx[idp]] +Sdid*limita[0,low_idx[idp]])/(Sdid+1.)
             endif

            ;Tied parameters 1D , 2D  ;!!!dids
            ;***********************
               ;Tied 2D parameters on itself SO PUT THE MEAN IN EACH CONCERNED
                if tie_idx2[0] ge 0 then begin
                  for tp=0,(Ntie_idx2)/nspect -1 do begin
                    idx   = index2D[*,tp]
                    val   = b[idx]
                   ;b(idx)= total( val)/nspect
                   ;b(idx)= median(val,/even) ;Seems faster when all params are different
                    b[idx]= median([val[ uniq(val,sort(val)) ]],/even )
                  endfor
                endif
                
               ;Tied 1D expressions to execute in B
                if tie_idx1[0] ge 0 then begin
                  P=B & for tp=0,Ntie_idx1-1 do ii=execute('b[tie_idx1[tp]]='+tied[tie_idx1[tp]])
                endif

             call_procedure, function_name, x,b, yfit          ; Evaluate function

             chisq = total(Weights*(y-yfit)^2)/nfree           ; New chisq
             sigma[iparam] = SQRT(arrayD/alphaD)

             IF (finite(chisq) EQ 0) OR (lambdaCount GT 30 AND chisq GE chisq1) THEN BEGIN
               ;Reject changes made this iteration, use old values.
                yfit          = yfit1
                sigma[iparam] = sigma1
                chisq         = chisq1
                status        = 1
                GOTO, done
             ENDIF

             flambda = flambda*10. ; Assume fit got worse

          ENDREP UNTIL chisq LE chisq1

          flambda = flambda/100.
          a=b                      ; Save new parameter estimate.
          IF ((chisq1-chisq)/chisq1) LE tol THEN GOTO,done   ;Finished?
          endif else done_early=1  ;itrmax eq 1
       ENDFOR

       status = 2
done:

   ;If no weighting, then we need to boost error estimates by sqrt(chisq).
   ;See Numerical Recipes section 15.2 for details.
    if noWeighting then sigma = sigma*SQRT(chisq)
    if low_idx[0] ge 0 then sigma[low_idx]=sigma[low_idx]<abs(a[low_idx])
    if upp_idx[0] ge 0 then sigma[upp_idx]=sigma[upp_idx]<abs(a[upp_idx])
    if bid[0]     ge 0 then sigma[bid]=0.

   ;Experimental variance estimate, unbiased
    var    = (nY GT nterms) ? TOTAL((yfit-y)^2 )/nfree : (double ? 0d : 0.0)
    yerror = SQRT(var)

    chi2   = chisq       ; Return chi-squared (chi2 obsolete-still works)
    if done_early then iter=iter-1
   ;print,'COOLFIT Chi2=',chisq, ' nfree=',nfree

    return,yfit          ; return result
END
;** ************

pro mp2cool_eval, X, A, YFIT, pder
;+
;** ************
;** mpfit to coolfit evaluation interface
;-

common mpcoolfit_common, fc, xc, yc, wc, mc
                                           ;'cool2mp_eval' or fc
  if n_params() GT 3 then YMR=call_function(fc,           A, pder, XVAL=xc, YVAL=yc, ERRVAL=wc) $
  else                    YMR=call_function(fc,           A,       XVAL=xc, YVAL=yc, ERRVAL=wc)
  YFIT=yc-YMR*wc
end
;******* *******
function MP2COOL,  Function_Name,   aa, functargs=functargs,   maxiter=itmax,       $
                   autoderivative=autoderiv, FTOL=ftol, XTOL=xtol, GTOL=gtol,       $
                   parinfo=parinfo, STATUS=status, nfev=nfev,  BESTNORM=chisq,      $
                   covar=covar,     perror=sigma,  niter=iter, nfree=nfree, dof=dof,$
                   ERRMSG=errmsg,   quiet=quiet,   fastnorm=fastnorm
;+
;******* *******
;** mpfit to coolfit engine interface
;-

common mpcoolfit_common, fc, xc, yc, wc, mc

if n_elements(functargs) eq 1 then begin & X=functargs.XVAL & Y=functargs.YVAL  & wc=1/functargs.ERRVAL
                                         xc=X  & yc=Y     & weightsIn=wc^2
endif                         else begin & X=xc  & Y=yc     & wc[*]=1.   & weightsIn=wc     & endelse
fc=Function_Name
if n_elements(autoderiv) ne 1 then autoderiv=1
na=n_elements(aa)        & if na gt 0 then a=aa
np=n_elements(parinfo)   & if np gt 0 then begin & ltags=tag_names(parinfo[0])
                              for i=0,n_elements(ltags)-1 do case ltags[i] of
                           'VALUE':  if np gt na then a=parinfo[*].value
                           'FIXED':  fita  =1-parinfo[*].fixed
                           'TIED':   tied  =  parinfo[*].tied
                           'LIMITED':bounda=  parinfo[*].limited
                           'LIMITS': limita=  parinfo[*].limits
                            else:
                            endcase & endif
                            
nfree = n_elements(y)-n_elements(a)
if n_elements(fita) gt 0 then begin
   idf=where(fita eq 0) & afx = n_elements(idf)
   if idf[0] ge 0 then  nfree = nfree +afx
endif

mc=COOLFIT(        x, y, weightsIn, a, sigma,    FUNCTION_NAME ='mp2cool_eval' ,$
                   FITA  =fita,   ITMAX =itmax,  ITER=iter,     TOL=ftol       ,$
                   CHISQ =chisq,  DOUBLE=double, NODERIVATIVE  =autoderiv,      $
                   YERROR=yerror, STATUS=status, BOUNDA=bounda ,LIMITA=limita ,TIED=tied ,MPf=0)
chisq = chisq * (nfree>1) ; as defined by mpfit
nfev  = iter
if status ne 0 then status=5
return,a
end

;************************** Miscellaneous functions **********************
;************************** Miscellaneous functions **********************
;************************** Miscellaneous functions **********************
;******* ******   *
function di_rev , c
;+
;******* ******   *
;** reverse a 1D or 2D array
;-

if (size(c))[0] eq 2 then return, REVERSE(REVERSE(c,1),2) $
                     else return, REVERSE(c)
end
;** ******   ************** Return s1,s4 margin & s2,s3 vector index range
pro di_mka , c ,s1,s2,s3,s4
;+
;** ******   ************** **********************************************
;** Return s1,s4 margin & s2,s3 vector index range, used to centerize the resolution
;
   ;tm= findgen(n_elements(c))
   ;i = round  (total(tm*c)/total(c)) ;Gravity
;-
    m=max(c) & i=!C
    id= where(  c gt 0)   & nc= n_elements(id)
    s2= id[0] & s3=id[nc-1]
    a1=i-s2
    a2=s3-i
    if a1 le a2 then a=a1 else a=a2
    s1=a2-a+1
    s4=a1-a+1
end

;******* *********  *********** Normalize Centerize & reverse the resolution function
function di_CVnorm, Fres, FC, flaag
;+
;******* *********  *********** *****************************************************
;** Normalize Centerize & reverse the resolution function
;-

Fres = Fres/total(Fres)    & maxc=max(Fres,imax)          ;Normalize

if not flaag then LC= maxc*FC else LC=max([min(Fres[0:imax]),maxc*FC,min(Fres[imax:*])])

Fres = Fres>LC -LC & Fres=Fres/total(Fres)

DI_MKA,Fres, s1,s2,s3,s4                                  ;Centerize & reverse
tmp  =reverse([fltarr(s1) , Fres[s2:s3] , fltarr(s4)])

Ntmp =n_elements(tmp)
NFres=n_elements(Fres)
if Ntmp gt NFres then begin & dif=ceil((Ntmp-NFres)/2.)
                            tmp=tmp[dif:Ntmp-dif-1] ;bad resolution fit !!!
                            tmp=tmp/total(tmp) & endif
return,tmp
end

;******* *******  *********** Solve linear or bilinear function (coef. of convolution steps)
function di_solv, R,bi,R2,bi2,METHOD=met,GUESS=guess
;+
;******* *******  *********** **************************************************************
;** Solve linear or bilinear function (coef. of convolution steps)
;-

common c_solv ,A,B
s =size( R)
nc=s[1] & mi=(nc-1)/2

   if  n_elements(B)  ne nc then begin & A=dblarr(nc,nc)  & B=dblarr(nc) & endif
   if  n_elements(bi) eq nc then B=bi else begin & B[*]=0 & B[mi]=bi     & endelse

   for i = 0  ,mi   do A[0,i]   =R[ mi-i:nc-1]         ;fill each coefficient
   for i =mi+1,nc-1 do A[i-mi,i]=R[ 0   :nc-1-(i-mi)]  ;fill each coefficient

   SVDC,A,w,u,v
   CZ = SVSOL(u,w,v,B)  ;Other methods has been removed from here

if n_elements(R2) gt 1 then begin
   s = size( R2)
   n2= s[1] & m2=(n2-1)/2
   if  n_elements(B)   ne n2 then begin & A=dblarr(n2,n2)   & B=dblarr(n2) & endif
   if  n_elements(bi2) gt 1  then B=bi2 else begin & B[*]=0 & B[m2]=bi2    & endelse
   for i = 0  ,m2   do A[0,i]   =R2[m2-i:n2-1]
   for i =m2+1,n2-1 do A[i-m2,i]=R2[0   :n2-1-(i-m2)]
   SVDC,A,w,u,v
   CZ2= SVSOL(u,w,v,B)
   CZ = CZ#CZ2         ;make 2D function CZ = DI_TWO(CZ,CZ2,1)
endif
return,CZ
end
;******* *******  *** Just do a convolution
function di_conv, F,C
;+
;******* *******  *** *********************
;** Just do a convolution
;-

sf =size(F) & sc =size(C)
nf1=sf[1]   & nc1=sc[1] & mi=(nc1-1)/2

if sf[0] eq 1 then begin & a=F[0] & b=F[sf[1]-1] & ajou=fltarr(mi)
   t=CONVOL([ajou+a,F,ajou+b],C)
   return,t[mi:nf1-1+mi]
endif else begin
   nf2=sf[2] & nc2=sc[2] & ni=(nc2-1)/2
   if (nf1 gt nc1) and (nf2 gt nc2) then return,CONVOL(F   ,C) $
   else begin
        if nf1 le nc1 then nf1=nf1+2*mi else mi=0
        if nf2 le nc2 then nf2=nf2+2*ni else ni=0
        tmp=fltarr(nf1,nf2) & tmp[mi,ni]=F & t =CONVOL(tmp ,C)
        return,t[mi:nf1-1-mi,ni:nf2-1-ni]
   endelse
endelse
end
;******* *******  ************* Derivatives: return all max values
function di_keeb, V ,mi, D ,idx ,shf
;+
;******* *******  ************* **********************************
;** Derivatives: return all max values
;-

gi =mi
s  =size( V)
if s[0] eq 1 then begin
   v1 =shift(V, 1)     & res=    ((V-v1)>0) & res[0]       =0
   v1 =shift(V,-1)     & res=res*((V-v1)>0) & res[s[1]-1]  =0
endif else begin
   v1 =shift(V, 1, 0)  & res=    ((V-v1)>0) & res[0,*]     =0
   v1 =shift(V,-1, 0)  & res=res*((V-v1)>0) & res[s[1]-1,*]=0
   v1 =shift(V, 0,-1)  & res=res*((V-v1)>0) & res[*,0]     =0
   v1 =shift(V, 0, 1)  & res=res*((V-v1)>0) & res[*,s[2]-1]=0
endelse

idx=where(res gt 0)
if  idx[0] eq -1 then bid=max(V,idx)
shf=idx*0
;Gravity center for better peak positions. (Code is removed)
;******* ****** *** ****** **** *********

res[*]=0 & res[idx]=D[idx]
return,res
end
;** *************  ************* Prepare the instrument resolution depending on Q or Theta....
pro di_inst_Dreso, flaag, Q=Q ,deltaQ=deltaQ ,pVf=pvf ,GetX=getx, GetY=gety, Fdisp=Fdisp, Rdisp=Rdisp, Kdisp=Kdisp, Rbdisp=Rbdisp, GetA=geta, active=act
;+
;** *************  ************* **********************************************************************************************************************
;**
;** Prepare the instrument resolution depending on Q or Theta....
;-

common c_str_fit_Dreso ,Dreso ,DXreso, DFdisp, DRdisp, Ddisp, active, Rb
;** Dreso  = Instrument kernel resolution
;** DXreso = Instrument X dQs
;
;** DFdisp = Poly dispersity function
;** DRdisp = Poly dispersity current [R,detaR] values
;** Ddisp  = Poly dispersity kernel resolution
;** Rb     = poly dispersity Ray bounds

if n_elements(act) eq 1 then begin & active=act  & return 
                        endif else if n_elements(active) ne 1 then active=0 ;active is for inst resolution only
if arg_present(geta)    then begin & geta=active & return & endif

;******************* RESOLUTION *******************

case flaag of
'prep': begin & sH=3.               ;FWMH = N / sH
        Fsig=2.*sqrt(2.*alog(2.)) ;FWMH = Fsig * Sigma
        n1=15                     ;nb of points in the kernel resolution function (impair)
        Xb=findgen(n1)-(n1-1)/2
        str_Pseudo,Xb ,[1.,0.,n1/sH,0.] ,Dreso ;should be an other function!! (fpsd already set so pvf is not used)
        Dreso =Dreso/total(Dreso)              ;Normalise
        Xb    =Xb/((n1-1)/2)
        DXreso=fltarr(n1*n_elements(Q))
        for i=0,n_elements(Q)-1 do DXreso[i*n1:(i+1)*n1-1]=Xb * deltaQ[i] * Fsig*1.27 + Q[i]
        active=1
        end

'clear':begin & active=0 & Dreso=0 & DXreso=0 & DFdisp=0 & DRdisp=[0.,0.] & Ddisp=0 & Rb=0 & end

'getx': if n_elements(DXreso) eq n_elements(Dreso)*n_elements(getx)*active then getx=DXreso                         ;Replace Q by all DQs then ...

'gety': if n_elements(DXreso) eq n_elements(gety)*active then begin & n1=n_elements(Dreso) & ny=n_elements(DXreso)/n1 ;Give back the convoluted function
           Y=gety[0:ny-1]
           for i=0,ny-1 do Y[i]=total(gety[i*n1:(i+1)*n1-1]*Dreso)
           gety=Y
        endif

;******************* POLYDISPERITY *******************

'Fdisp':DFdisp=Fdisp                                                                ;Register Poly_dispersity function only

'Rdisp':begin & if (DFdisp gt 0) and (Rdisp[0] gt 0.) and (Rdisp[1] gt 0.) then begin ;Poly_dispersity functions
               if (Rdisp[0] ne DRdisp[0]) or (Rdisp[1] ne DRdisp[1]) then begin
                n1=15       & Rb=(findgen(n1)-(n1-1)/2)/((n1-1)/2)
                R2=Rdisp[0] & dR=Rdisp[1]
                Rb=(Rb * dR*3. + R2)>1e-1
                
                case DFdisp of
                1:begin
                    Ddisp =exp((-(Rb-R2)^2/(2.*dR^2))>(-70.)) / (dR*sqrt(!pi*2.))         ;Gaussian
                  end
                2:begin & S0=double(dR/R2)
                    Ddisp =exp((-1./(2.*S0^2)*alog(R2/Rb)^2)>(-70.))/(Rb*S0*sqrt(!pi*2.)) ;Log-Norm
                  end
                3:begin & Z1=(double(R2/dR)^2)<100D
                    Ddisp =(Z1/R2)^Z1 * Rb^(Z1-1) * exp((-Rb*(Z1/R2))>(-70.)) / gamma(Z1) ;Schultz
                  end
                else:
                endcase
                tmp   =total(Ddisp) & if tmp gt 0 then Ddisp =float(Ddisp/tmp)
                DRdisp=Rdisp
               endif
              endif
              Kdisp =Ddisp
              Rbdisp=Rb
        end
else:
endcase
end

;************************** MODELS ***************************************
;************************** MODELS ***************************************
;************************** MODELS ***************************************

;===============================================================================
function str_Gumbel, X, A0,A1,A2,S        ;CALLED FROM FORMULA ; ===============
;+
;******* **********
;** Gumbel
;** S=+1 dissymetry on left , -1 on right
;** A0=height
;** A1=position of maximum
;** A2=width
;-

lim=-70.
if  S  gt 0. then S=1 else S=-1
if  A2 ne 0. then begin & b=2.4463860371   & z=(X-A1)/A2
                        z=(S*b*z)>lim & F=b/A2 * exp(z)*exp((-exp(z))>lim)
                        F= F* A0/abs(max(F))
endif else F=X*0.
return,temporary(F)
end

;===============================================================================
function str_Exp, X, A2,A3                ;CALLED FROM FORMULA ; ===============
;+
;******* *******
;** Stretched Exponantial
;** Inspired by Stef Rols
;** Y=amplitude * FT(EXP(-(X/beta)^tau)) centered at position
;** A0=amplitude
;** A1=position
;** A2=beta
;** A3=tau
;-

lim=-70.
if  A2*A3 gt 0. then begin

  Tmax=(5.*ALOG(10))^(1./A2)
  Wmax= MAX(abs(X))
  dt  = 2.*!PI/Wmax/10.
  nbrt= long(Tmax/dt)>200<1000
  T   = double(FINDGEN(nbrt)*Tmax/nbrt)
  F   = X*0.
  expT= EXP((-(T/A3)^A2)>lim)
  FOR iw=0,n_elements(X)-1 do $
      F[iw]=INT_TABULATED(T,COS(X[iw]*T) * expT)

 ;Treating the bizarre things about sexp
  index=where(abs(F) le (max(abs(F))/250.))
  if index[0] ne -1 then begin
     xx =X[index] & xmin=min(ABS(xx))
     ind=where(abs(X) le xmin,complement=nind)
     if ind[0] ne -1 then F[nind]=0.
  endif


endif else F=X*0.
return,temporary(F)
end

;===============================================================================
function str_IsoRot, X, A0,A1,A2,A3,A4, LOOP=nloop  ;CALLED FROM FORMULA ; =====
;+
;******* **********
;** IsoRot
;** Inspired by Stef Rols
;** Here we use the 20 first functions of spherical bessel jl(QR)
;** jl(x)=sqrt(!PI/2x)*J(l+0.5)(x)
;** J(l+0.5)=BESELJ(X,l+0.5)
;** Amplitude=A0 , Center   =A1
;** Dr       =A2 , Radius   =A3 ;radius*Q
;** U2       =A4 ;u2*Q^2
;-
Amplitude=A0
Center   =A1
Dr       =A2
Radius   =A3 ;radius*Q
U2       =A4 ;u2*Q^2
if n_elements(nloop) ne 1 then Nloop=19 else nloop=nloop>1<19
Y        =X*0.

FOR il=1,nloop do begin
  Width= il*(il+1)*Dr
  STR_LORENTZ, X, [Amplitude, Center, Width, 0.], F
  Y    = temporary(Y) + F*sqrt(!Pi/2./Radius)*BESELJ(Radius, il+.5)^2 * (2*il+1)
ENDFOR

if U2 gt 0. then Y= temporary(Y) * EXP((-U2/3.)>(-70.))

return,temporary(Y)
end

;===============================================================================
function str_UniRot, X, A0,A1,A2,A3,A4, LOOP=nloop  ;CALLED FROM FORMULA ; =====
;+
;******* **********
;** UniRot
;** Inspired by Stef Rols
;** Here we use the 20 first functions of sphericalcylindrical bessel Jl(QR)
;** Jl(X)=BESELJ(X,l)
;** Amplitude=A0 , Center   =A1 , Dr       =A2
;** Radius   =A3 ;radius*Q      , U2       =A4 ;u2*Q^2
;-
Amplitude=A0
Center   =A1
Dr       =A2
Radius   =A3 ;radius*Q
U2       =A4 ;u2*Q^2
if n_elements(nloop) ne 1 then Nloop=19 else nloop=nloop>1<19
Y        =X*0.

Theta_int=!Pi/2.*FINDGEN(101)/100.
Theta_sin=SIN(Theta_int)
Theta_QRS=Theta_sin*radius

FOR il=1,nloop do begin
  Width= il^2*Dr
  STR_LORENTZ, X, [Amplitude, Center, Width, 0.], F
  to_integrate= theta_sin*BESELJ(Theta_QRS,il)^2
  integrated  = INT_TABULATED(Theta_int,to_integrate)
  Y           = temporary(Y) + F*2.*integrated
ENDFOR

if U2 gt 0. then Y= temporary(Y) * EXP((-U2/3.)>(-70.))

return,temporary(Y)
end

;===============================================================================
function str_RwTrans, X, A0,A1,A2,A3                ;CALLED FROM FORMULA ; =====
;+
;******* **********
;** RwTrans
;** Inspired by Stef Rols
;** Amplitude=A0 , Center   =A1
;** Dt       =A2 ;dt*Q^2 , U2       =A3 ;u2*Q^2
;-

Amplitude=A0
Center   =A1
Dt       =A2*2.0 ;dt*Q^2
U2       =A3     ;u2*Q^2

STR_LORENTZ, X, [Amplitude, Center, Dt, 0.], Y

if U2 gt 0. then Y= temporary(Y) * EXP((-U2/3.)>(-70.))

return,temporary(Y)
end

;===============================================================================
function str_RotcTran, X, A0,A1,A2,A3,A4,A5, LOOP=nloop  ;CALLED FROM FORMULA ;=
;+
;******* ************
;** RotcTran
;** Inspired by Stef Rols
;** Amplitude=A0 , Center   =A1 , Dr       =A2
;** Radius   =A3 ;radius*Q , U2       =A4 ;u2*Q^2
;** Dt       =A5 ;dt*Q^2
;-

Amplitude=A0
Center   =A1
Dr       =A2
Radius   =A3 ;radius*Q
U2       =A4 ;u2*Q^2
Dt       =A5 ;dt*Q^2
if n_elements(nloop) ne 1 then Nloop=19 else nloop=nloop>1<19
Y        =X*0.

FOR il=1,nloop do begin
  width= il*(il+1)*Dr+Dt
  STR_LORENTZ, X, [Amplitude, Center, Width, 0.], F
  Y    = temporary(Y) + F * BESELJ(Radius, il)^2 * (2*il+1)
ENDFOR

if U2 gt 0. then Y= Y * EXP((-U2/3.)>(-70.))

return,temporary(Y)
end

;===============================================================================
function str_FOU, w, x2_, D_, q2, alpha_ , Tau_, Loop=nloop
;+
;**
;** Inspired by Vania Calandrini
;** CALL: Y = str_FOU (X, p1,p2,p3,p4,p5,p6, LOOP=8)
;-

;Constraints
;***********
EXPmin    = -70.
alpha     = alpha_ >.1 < .9999
Tau       = Tau_   > 2e-3
D         = D_     > 1e-5
x2        = x2_    > 1e-5

;Intermediate variables
;**********************
w2    = w^2
Dq2   = D*q2
Dqw   = sqrt(  w2 + Dq2^2 )
Dqw2  = 2./DqW
Dqwi  = atan(  w  , Dq2   ) ; Arg(complex(Dq2 , iw))
CosD  = cos(   Dqwi       )
CosaD = 2*cos( alpha*Dqwi )
CosbD = cos(  (alpha-1) * Dqwi)
LD    = 1./!pi * Dq2 / (Dq2^2 + w2)

if n_elements(nloop) ne 1 then Nloop=8 else nloop=nloop>1<20
Y     = w*0.
for n = 1,nloop do begin

 ;N dependent variables
 ;*********************
  Tn   = Tau  * (n)^(-1./alpha)
  DTn  = Dqw  * Tn
  DTna = DTn^( alpha)
  DTnb = DTn^(-alpha)
  qx2n = (q2^n * x2^n) / (2.*!pi*factorial(n))

  LML  = Dqw2 * ( DTna * CosD  + CosbD ) $
;               ------------------------
              / ( DTna + CosaD + DTnb  )

  Y    = temporary(Y)+ qx2n * LML
endfor
return, exp((-q2 * x2)>EXPmin) * (LD + Y)
end


;*******************************************************************
; STRUCTURES FACTORS
;*******************************************************************
function str_Hard_Sphere, X, Fv, Rs
;+
;******* ***************
;**
;** HARD SPHERE STRUCTURE FACTOR
;** Fp  is Volume Fraction
;** Rhs is Sphere Radius
;-

Fp =Fv > 0.  < .99
Rhs=Rs > .01 

alpha = (1. + 2.*Fp)^2 / (1. - Fp)^4
beta  = -6.*Fp * (1. + Fp/2.)^2 / (1. - Fp)^4
gamma = Fp*alpha/2.

A     = 2.*Rhs*X
sinA  = sin(A)  &  AsinA = A*sinA  &  A2=A^2  &  A3=A^3
cosA  = cos(A)  &  AcosA = A*cosA  &  A4=A^4  &  A5=A^5 

Gq    = alpha* (sinA-AcosA) /A2                  + $
        beta*  (2.*AsinA + (2.-A2)*cosA -2.) /A3 + $
        gamma* (-A4*cosA + 4.*( (3.*A2-6.)*cosA  + (A3-6.*A)*sinA+6.)) /A5

return, 1./ (1.+24.*Fp*Gq/A)

end ;HARD SPHERE STRUCTURE FACTOR

function str_MultiLam, X, mNs, ds, Delt, Nub, TD=TD, PC=PC, MC=MC
;+
;******* ************
;**
;** MULTI LAMELLAR THERMAL DISORDER or PARACRYSTALLINE OR CAILLE STRUCTURE FACTOR
;** mNs   is mean number of stacks (10)
;** d     is stacking separation   (20)
;** Delta is DW disorder or Caillé parameter (2 or .2)
;** Nu    is number of uncorrelated scattering bilayers
;**
;** TD    for Thermal Disorder
;** PC    for ParaCrystalline
;** MC    for Modified Caillé
;-
mN    = mNs  > 2.
d     = ds   >.01
Delta = Delt > 0.
if n_elements(Nub) ne 1 then Nu=0. else Nu=Nub >0.

if round(mN) ge 5 then sig2=sqrt(mN)*2. else sig2=(mN-1.)
sig    = sig2/2.
NkL    = round(2*sig2+1)
Nkn    = findgen(NkL)+mN-sig2                                          ;Vector(NKn)

xk     = 1./(sig*sqrt(!Pi*2.)) * exp(-((Nkn-mN)^2 / (2.*sig^2))>(-70)) ;Vector(NKn)
Vm     = findgen(round(mN+sig2-1.))+1.                                 ;Vector(Vm)
Euler  = .5772156649D 
EQD    = 2.
cosXdm = cos(X#(d*Vm))                                                 ;Matrix(X,Vm)

if keyword_set(PC) then $     ;ParaCristalline
cosXdm = cosXdm* exp( (-( (X^2)#(Vm^2*Delta^2/2.) )>(-70.)) )          ;Matrix(X,Vm)

if keyword_set(MC) then begin ;Modified Caillé
VmPi   = (X*0.+1.) # (Vm*!DPi)                                         ;Matrix(X,Vm)
term   =((-(d/2./!DPi)^2 * X^2 * Delta)>(-70./Euler)) # (Vm*0.+1.)     ;Matrix(X,Vm)
cosXdm = cosXdm* ( exp(term*Euler) * (VmPi^term) )                     ;Matrix(X,Vm)
endif

if keyword_set(TD) then $     ;Thermal Disorder
EQD    = EQD*exp( (-(X^2 * Delta^2 /2.)>(-70.)) )                      ;Vector(X)

Y   = 0.
For i =0,NkL-1 do begin & Nk=Nkn[i]
  Ym= 0
  For m =1,Nk-1 do Ym =Ym+ (Nk-m) * cosXdm[*,m-1]
  Y = Y+ xk[i]* (Nk+ EQD*Ym)
endfor

return, Y+Nu

end ;MULTI LAMELLAR THERMAL DISORDER or PARACRYSTALLINE OR CAILLE STRUCTURE FACTOR

function str_MSA, X, ETA, Rd, Ze, Kappa, T, epsR, Salt
;+
;******* *******
;**
;** RESCALED MEAN SPHERICAL APPROXIMATION (Hayter, Penfold, Hansen)
;** ETA   Volume fraction of Particules    (.3)
;**       Pn=!Pi*ETA*(Rhs*2.)^3/6. Pn is particule number density
;** Rd   Radius of hard sphere             (25.)
;** Z     Charge unit                      (20.)
;** Kappa Debye-Huckel inverse screening L (.04)      
;** T     Sample Temperature               (298.)
;** epsR  Dielectric constant of solvent   (80.)
;** Salt  Salt ions charge density: Pi*Zi  [Z*A-3] * 10^6 (Unused at this time)
;-
 Kb  = double(1.3806503e-23)                                        ; Boltzmann constant [J/K]
 e   = double(1.60217653e-19)                                       ; electron charge [C]
 eps0= double(8.85418782e-12)                                       ; permitivity of free space
 eps = eps0*epsR

;*** CONSTANTS ******************
Z    = double(abs(Ze)) >.01D
Rhs  = double(Rd)      >.01D
N    = double(ETA)     > 0D < .99D  &  rN=N  &  S=N^(1./3.)         ; Volume fraction of Particules Pn*!dPi*(Rhs*2.)^3/6.
Pn   = 6.*ETA/(!dPi*(Rhs*2.)^3)                                     ; Particle number density  [A^-3]

;Xr  =(3./(4.*!dPi*Pn))^(1./3.)/Rhs                                 ; r/sigma (interParticule/diameter)
;Xr  = 1./(2.*ETA^(1./3.))*2.                                       ; r/sigma (interParticule/diameter)
;LB  = e^2 /(4.*!dPi *eps *Kb*T)                                    ; Bjerrum Length
;salt= Kappa^2 *(Kb*T*eps) /e^2 /1.e9 - Pn*Z                        ; Salt ions charge density

DH   = sqrt(e^2*(Pn*Z+Salt)*1.e9 /(Kb*T*eps))                       ; Debye-Huckel inverse screening length
DH   = double(Kappa) > 0D                                           ; Debye-Huckel inverse screening length [A^-1]
K    = float(DH*Rhs*2.) & rK=K                                      ; Kappa*sigma in HP paper

;Phi0= Z*e    /     (!dPi*eps *2.*Rhs*1.e-10*(2.+K))                ; Surface potential [J/C = V]
;Cc  = (1./(Kb*T))  *!dPi*eps *2.*Rhs*1.e-10* Phi0^2  *exp(K<70D)   ; Coupling constant
GAMMA= (Z*e)^2/(Kb*T*!dPi*eps *2.*Rhs*1.e-10*(2.+K)^2)*exp(K<70D)   ; Coupling constant [adim], Gamma in HP paper
GEK  = GAMMA * exp(-(K<70D)) & rGEK=GEK                             ; Contact potential
GAMK = GEK   * 2.*S *exp(K-K/S)                                     ; Coupling

RESCALING=1 & ITER = 0 & ACCURACY=1.e-3
;*** Rescaling loop *******************
WHILE (RESCALING) DO BEGIN
;**************************************
ITER=ITER+1
if ITER gt 40 then break ; Loop limitation if no convergence


;*** COEFFICIENTS FOR THE SOLUTION ************************
coshK= cosh(K) & sinhK= sinh(K)
S    = (1.-N)  &  S2=S^2  &  S4=S^4   &  N2=N^2  &   N3=N^3  &  K2=K^2  &  K4=K^4

alph1=-(2.*N +1.)    *S/K  &  alph2= (14.* N2 -4.*N -1.)/K2  &  alph3= 36.*N2/K4
beta1=-(N2 +7.*N +1.)*S/K  &  beta2= 9.*N*(N2 +4.*N -2.)/K2  &  beta3= 12.*N*(2.*N2 +8.*N -1.)/K4

a1   = (24.*N*GEK*(alph1+alph2+(1.+K)*alph3)        -(2.*N+1.)^2)   /S4
a2   =  24.*N*(alph3*(sinhK -K*coshK) +alph2*sinhK  -alph1*coshK)   /S4
a3   =  24.*N*((2.*N+1.)^2/K2 -S2/2. +alph3*(coshK-1.-K*sinhK) -alph1*sinhK +alph2*coshK) /S4
b1   = (3. *N*(N+2.)^2/2. -12.*N*GEK*(beta1+beta2+(1.+K)*beta3))    /S4
b2   =  12.*N*(beta3*(K*coshK-sinhK) -beta2*sinhK  +beta1*coshK)    /S4
b3   =  12.*N*(S2*(N+2.)/2. -3.*N*(N+2.)^2/K2 -beta3*(coshK-1.-K*sinhK) +beta1*sinhK -beta2*coshK) /S4

v1   =-(N3    +3.*N2 +45.*N +5. )*S/K   &   v2   = (2.*N3 +3.*N2 +42.*N -20.)/K2
v3   = (2.*N3        +30.*N -5. )/K4    &   v4   =  v1 +24.*N*K*v3
v5   =  6.*N*(v2 +4.*v3)
phi1 =  6.*N/K                          &   phi2 =  S -12.*N/K2

et1  = (N+5.)/(5.*K)                    &   et2  = (N+2.)/K2
et3  = -12.*N*GEK*(et1+et2)             &   et4  =  3.*N*K2*(et1^2 -et2^2)
et5  =  3.*N*(N+8.)/10. -2.*(2.*N +1.)^2 /K2

V11  = ((2.*N +1.)*(N2 -2.*N +10.)/4. -GEK*(v4+v5)) /(5.*S4)
V22  = (v4*coshK -v5*sinhK)/(5.*S4)
V33  = ((N3 -6.*N2 +5.)*S -6.*N*(2.*N3 -3.*N2 +18.*N +10.)/K2 +24.*N*v3 +v4*sinhK -v5*coshK)/(5.*S4)
P1   = (GEK*(phi1-phi2)^2      -(N+2.)/2.)          /S2
P2   = ((phi1^2 +phi2^2)*sinhK +2.*phi1*phi2*coshK) /S2
P3   = ((phi1^2 +phi2^2)*coshK +2.*phi1*phi2*sinhK +phi1^2 -phi2^2) /S2
t1   =  et3    + et4*a1 +et5*b1
t2   =  et4*a2 + et5*b2 +12.*N*(et1*coshK -et2*sinhK)
t3   =  et4*a3 + et5*b3 +12.*N*(et1*sinhK -et2*(coshK-1.)) -2.*N*(N+10.)/5. -1.

mu1  =  t2*a2 -12.*N*V22^2              &   mu2  =  t1*a2 +t2*a1 -24.*N*V11*V22
mu3  =  t2*a3 +t3*a2 -24.*N*V22*V33     &   mu4  =  t1*a1 -12.*N*V11^2
mu5  =  t1*a3 +t3*a1 -24.*N*V11*V33     &   mu6  =  t3*a3 -12.*N*V33^2
lmd1 =  12.*N*P2^2                      &   lmd2 =  24.*N*P1*P2 -2.*b2
lmd3 =  24.*N*P2*P3                     &   lmd4 =  12.*N*P1^2  -2.*b1
lmd5 =  24.*N*P1*P3 -2.*b3 -K2          &   lmd6 =  12.*N*P3^2

w12  =  mu1*lmd2 -mu2*lmd1  &  w13  =  mu1*lmd3 -mu3*lmd1
w14  =  mu1*lmd4 -mu4*lmd1  &  w15  =  mu1*lmd5 -mu5*lmd1  &  w16  =  mu1*lmd6 -mu6*lmd1
w24  =  mu2*lmd4 -mu4*lmd2  &  w25  =  mu2*lmd5 -mu5*lmd2  &  w26  =  mu2*lmd6 -mu6*lmd2
w32  =  mu3*lmd2 -mu2*lmd3  &  w34  =  mu3*lmd4 -mu4*lmd3  &  w35  =  mu3*lmd5 -mu5*lmd3
w36  =  mu3*lmd6 -mu6*lmd3  &  w46  =  mu4*lmd6 -mu6*lmd4  &  w56  =  mu5*lmd6 -mu6*lmd5
w4   =  w16^2 -w13*w36
w3   =  2.*w16*w15 -w13*(w35+w26) -w12*w36
w2   =  w15^2 +2.*w16*w14 -w13*(w34+w25) -w12*(w35+w26)
w1   =  2.*w15*w14 -w13*w24 -w12*(w34+w25)
w0   =  w14^2 -w12*w24
;*** End coefficients ***********************

;*** FINDING F [w4*F^4 +w3*F3 +w2*F^2 +w1*F +w0 = 0] **********
CATCH,stat
IF stat eq 0 then begin & IR=[-1]
  yf   = abs(w4/w0)^(.25)                            ; Rescale F
  Roots= FZ_ROOTS([abs(w4/w0)*(w0/w4), w1*yf^3/w4, w2*yf^2/w4, w3*yf/w4, 1.])
 ;Roots= FZ_ROOTS([w0,w1,w2,w3,w4]) & yf=1.
  IR   = where(float(imaginary(Roots)/yf) eq 0.)
ENDIF
CATCH,/cancel

IF IR[0] ge  0 then Rootr= real_part(Roots[IR])/yf $ ; UnRescale Roots
ELSE begin & IR=0            ; No Root found; we should return something!
   IR=0 & print,'!No root found'
   if K gt (1.+8.*N) then begin & if K gt 15. then Rootr =-(w46/w56) else $         ; very Large screening
                                Rootr = (w14-w34-w46) / (w12-w15+w35-w26+w56-w32) ;      large screening
   endif else begin &             Ca    =-(K2*p1 + 2.*(b3*p1-b1*p3)) / (k2*p2 + 2.*(b3*p2-b2*p3))
                                Rootr =-(p1+p2*Ca)/p3                             ; Guillan condition
   endelse
   FOR i=1,60 do begin                           ; Un petit Newton !
       Fa   =Rootr
       Fun  =w0+(w1+(w2+(w3+ w4*Fa)*Fa)*Fa)*Fa
       FunD =w1+(2.*w2+(3.*w3+4.*w4*Fa)*Fa)*Fa
       Rootr=Fa -FUN/FUND
       if abs((Rootr-Fa)/Fa) le 1.e-6 then Break ; Converging
   endfor
ENDELSE
               
IF n_elements(IR) gt 1 then firstL=1 else firstL=2 ; One or many roots?
GxSum    = 1.e10 ;G(X<1)

FOR loop=firstL,2 DO BEGIN ; First  loop is to find the physical root (if many)
                           ; Second loop calculates the S(K) for User
 IF loop eq 1 then begin
   ;Prepare Qd for G(x) to find a physical root.
   Npt   = 256.
   Q     = findgen(Npt)/(Npt-1.)*2.+1.e-3                  ; Q = [1e-3:2]
   Qd    = double(Q*Rhs*2.)                                ; Q*sigma
   dK    =(Qd[n_elements(Qd)-1]-Qd[0])/(n_elements(Qd)-1)  ; Increment
   sinQ  = sin(Qd)  &  cosQ  = cos(Qd)  &  QcosQ = Qd*cosQ
   Q2    = Qd^2     &  Q3    = Qd^3     &  Q4    = Qd^4
   Xv    = findgen(Npt)*!dPi/(Npt*dK)+1.e-3                ; Xv is a range for G(x)
   XvRang= where((Xv gt 1.e-3) and (Xv lt 1.))             ; Xv < 1.
   Xv    = Xv[XvRang]
   GXf   = 1./(12.*!dPi*N*Xv)  &  sinQx= sin(Xv#Qd)        ; Operands for G(x)
 ENDIF else begin
   ;Prepare Qd from the User Data. K = Q*sigma in HP paper
   Qd    = double(X*Rhs*2.)                                ; K = Q*sigma in HP paper
   if Qd[0] le 0. then Qd[0]=Qd[1]*1e-1                    ; Limit S(0)=-1/A
   sinQ  = sin(Qd)  &  cosQ  = cos(Qd)  &  QcosQ = Qd*cosQ
   Q2    = Qd^2     &  Q3    = Qd^3     &  Q4    = Qd^4
 ENDELSE
 
 FOR i=0,n_elements(IR)-1 do begin
  F= Rootr[i]
  C=-(w16*F^2 +w15*F +w14)/(w13*F +w12)
  B= b1 +b2*C +b3*F
  A= a1 +a2*C +a3*F

  Y= ( A*  (sinQ - QcosQ)                                            $
     + B*  ((2./Q2 -1.)*QcosQ + 2.*sinQ - 2./Qd)                     $
     + A*N*(24./Q3 + (4.-24./Q2)*sinQ - (1.-12./Q2+24./Q4)*QcosQ)/2. $
     )     /Q3                                                       $ 

   + ( C*  (K*coshK*sinQ - QcosQ*sinhK )       $
     + F*  (K*sinhK*sinQ - QcosQ*coshK + Qd)   $ 
     - GEK*(K*sinQ + QcosQ)                    $
     )     /(Q3+Qd*K^2)                        $

   + ( F*  (cosQ -1.) $
     )     /Q2
  
  Y= 1./(1.- 24.*N*Y)

  if loop eq 1 then begin  ; Evaluate G(x)
    Gx = 0.  &  Ym1=Y-1.
    for ff=0,n_elements(Qd)-1 do Gx = Gx + Ym1[ff]*Qd[ff]*sinQx[*,ff] ; Integral
    Gx = 1. + GXf*Gx*dK                                               ; G(x)
    sum=total(abs(Gx))                                                ; sum should be 0 for Xv<1
    if sum lt GxSum then begin & RootI=i & GxSum=sum & endif            ; Keep good Root
  endif
  
 ENDFOR ; Over the Roots
 if loop eq 1 then begin & Rootr=Rootr[RootI] & IR=0 & endif

ENDFOR  ; Over loop, only if many Roots

;Now check if a rescale is necessary.
;***********************************
GxContact = -(p1 +p2*C +p3*F)    ;G(X=1+)
if (GxContact ge -ACCURACY) and (ITER eq 1) then RESCALING=0 ; None negative contact
if RESCALING then begin
  ;print, GxContact,Rhs, K, ITER
   if abs(GxContact) lt ACCURACY then break      ; Thats enough
   GxContact=GxContact >(-Rhs) <Rhs
   Rhs   =Rhs -GxContact*2./3.  &  scal  =Rd/Rhs ; Rescale particule
   N     =rN/(scal^3)                            ; Rescale volume fraction
   K     =rK/ scal                               ; Rescale Kappa*sigma
   GEK   =rGEK*scal*exp((rK-K)>(-70.)<70.)       ; Rescale Contact potential
end
;RESCALING=0
ENDWHILE

return, float(Y)

end ;RESCALED MEAN SPHERICAL APPROXIMATION

;*******************************************************************
; FORMS FACTORS
;*******************************************************************

;*******************
; SPHERICAL
;*******************
function str_Vesicle, X, Ri, Rs, Tl, sldS, sldO, sldT, dR1
;+
;******* ***********
;**
;** BILAYERED VESICULE FORM FACTOR
;** R1   Inner Solvent Radius    Rc
;** Ro   Layer Solvent Thickness Th
;** T    Layer Thickness         Tt
;** sldS SLD Solvent             Nsol
;** sldO SLD Layer Solvent       Nh
;** sldT SLD Layer               Nt
;-
R1   = Ri >.01
Ro   = Rs >.01   
T    = Tl >.01

R2    = R1+T      & R3   = R1+T+Ro   & R4   = R1+2.*T+Ro
QR1   = X*R1      & QR2  = X*R2      & QR3  = X*R3       & QR4  = X*R4
sld1  = sldS-sldT & sld2 = sldT-sldO & sld3 = sldO-sldT  & sld4 = sldT-sldS

return,(R1^3 * sld1 * (sin(QR1) - QR1*cos(QR1)) / QR1^3 + $
        R2^3 * sld2 * (sin(QR2) - QR2*cos(QR2)) / QR2^3 + $
        R3^3 * sld3 * (sin(QR3) - QR3*cos(QR3)) / QR3^3 + $
        R4^3 * sld4 * (sin(QR4) - QR4*cos(QR4)) / QR4^3 )^2 * (!Pi*4.)^2

end ;BILAYERED VESICLE FORM FACTOR

function str_LinShell, X, R, dT, xSin, xSout, sldS, sldC, sldT, dR
;+
;******* ************
;**
;** SPHERICAL SHELL WITH LINEAR VARYING CONTRAST PROFILE FORM FACTOR
;** Ri    Inner Solvent Radius             (R   :30)
;** T     Shell Thickness                  (dR  :10)
;** pSin  inner amount of solvent in shell (Xin :1 )
;** pSout outer amount of solvent in shell (Xout:.5)
;** sldS  SLD Solvent                      (Nsol:0 )
;** sldC  SLD core shell                   (Nc  :1 )
;** sldT  SLD pure shell                   (Nsh :1 )
;-
pSin = xSin  >0. <1.
pSout= xSout >0. <1.
Ri   = R     >.01
T    = dT    >.01

sldOUT  = (1.-pSout)*sldT + pSout*sldS - sldS  
sldIN   = (1.-pSin )*sldT + pSin *sldS - sldS
m       = (sldOUT-sldIN)/T
b       = -m*Ri + sldIN
Rt      =  Ri+T     &  P4    = !Pi*4.
QR      =  X*Ri     &  QR2   = QR^2    &  Q3 =X^3
QRt     =  X*Rt     &  QRt2  = QRt^2   &  Q4 =X^4
sinQR   =  sin(QR)  &  cosQR = cos(QR)
sinQRt  =  sin(QRt) &  cosQRt= cos(QRt)

Fsph    = (sinQR  - QR *cosQR) / Q3
Fspht   = (sinQRt - QRt*cosQRt)/ Q3
Fsh     = (2.*cosQR  + 2.*QR *sinQR  - QR2 *cosQR) / Q4
Fsht    = (2.*cosQRt + 2.*QRt*sinQRt - QRt2*cosQRt)/ Q4

return,(P4*((sldC-sldS-b)*Fsph - m*Fsh + m*Fsht + b*Fspht))^2

end ;SPHERICAL SHELL WITH LINEAR VARYING CONTRAST PROFILE FORM FACTOR

function str_Mlam_Vesicle, X, R, Ts, Tl, sldS, sldT, Nl, DeltaR, DeltaTs
;+
;******* ****************
;**
;** MULTI LAMELLAR VESICULE FORM FACTOR
;** Ri   Inner Solvent Radius
;** Ro   Layer Solvent Thickness
;** T    Layer Thickness
;** sldS SLD Solvent
;** sldT SLD Layer
;** N    number of Layers
;-
Ri =R  > .01
Ro =Ts > .01
T  =Tl > .01
N  =Nl > 2.

Nid    = findgen(N)        &  P4     = !Pi*4.
sld1   = sldS-sldT         &  sld2   = sldT-sldS              ;SCALAR
R1     = Ri+ Nid*(T + Ro)  &  R2     = Ri+ (Nid+1)*T + Ro     ;VECTOR(N)
Qc     = X^3                                                  ;VECTOR(X)
QR1    = X#R1              &  QR2    = X#R2                   ;MATRIX(X,N)
sinQR1 = sin(QR1)          &  sinQR2 = sin(QR2)               ;MATRIX(X,N)
cosQR1 = cos(QR1)          &  cosQR2 = cos(QR2)               ;MATRIX(X,N)

Y=0.
FOR i = 0L,N-1 do $
    Y = Y+ sld1 *(sinQR1[*,i] - QR1[*,i]*cosQR1[*,i])/ Qc + $
           sld2 *(sinQR2[*,i] - QR2[*,i]*cosQR2[*,i])/ Qc 

return, (P4*temporary(Y))^2

end ;MULTI LAMELLAR VESICULE FORM FACTOR

;*******************
; ELLIPSOIDAL
;*******************
function str_Ellipsoid, X, Dens, Ra, Nab, dR, LOOP=N
;+
;******* *************
;**
;** ELLIPSOID FORM FACTOR
;** Dens density
;** R    Radius of rotational axis (Ra)
;** Nu   Ratio between both axis   (Ra/Rb)
;** N    number of iterations for integration
;-
R  = Ra  >.01
Nu = Nab > 1.e-7
Rb = R   / Nu

if n_elements(N) ne 1 then Nb=60 else Nb=N>50<200

dx    = !Pi/2./(Nb-1)
loo   = findgen(Nb)/(Nb-1)*!Pi/2.                           ;Vector(Nb)
sind  = sin(loo)   &  sind2=sind^2   &  cosd2 = cos(loo)^2  ;Vector(Nb)
Rnb   = (R *sqrt(Nu^2*cosd2 + sind2))                       ;Vector(Nb)
QR    = X#Rnb                                               ;Matrix(X,Nb)
K2    =((sin(QR) - QR*cos(QR))/QR^3)^2                      ;Matrix(X,Nb)

Y=0.
FOR i =0L,Nb-1 do  Y =Y+ sind[i] * K2[*,i]

return, temporary(Y) * (4./3.*!Pi*Nu*R^3*Dens)^2 *dx

end ;ELLIPSOID FORM FACTOR

function str_Ellipsoid2, X, Dens, Ra, Nab, dR, LOOP=N
;+
;******* **************
;**
;** ELLIPSOID FORM FACTOR ; Faster but to be verified ...
;** Dens density
;** R    Radius of rotational axis (Ra)
;** Nu   Ratio  between  both axis (Ra/Rb)
;** N    number of iterations for integration
;-
R  = Ra  >.01
Nu = Nab > 1.e-7
Rb = R / Nu

if n_elements(N) ne 1 then Nb=60 else Nb=N>50<200

dx    = 1./(Nb-1)
loo   = findgen(Nb)/(Nb-1)                                  ;Vector(Nb)
Rnb   = R  *sqrt(1. +loo^2 *(Nu^2 -1.))                     ;Vector(Nb)
QR    = X#Rnb                                               ;Matrix(X,Nb)
K2    =((sin(QR) - QR*cos(QR))/QR^3)^2                      ;Matrix(X,Nb)

Y     = total(K2,2)*dx

return, temporary(Y) * (4./3.*!Pi *Nu*R^3*Dens)^2

end ;ELLIPSOID FORM FACTOR

;*******************
; POLYMERS
;*******************
function str_StarPolyGauss, X, I0, R, fa, dR
;+
;******* *****************
;**
;** STAR POLYMER GAUSSIAN STATISTIC FORM FACTOR
;** Rg  Radius of gyration
;** fa  number of Arms
;** I0  at Q0
;-
Rg = R > .01
f  = fa> 2.

u  = (X*Rg)^2
V  = (u*f)/(f*3 -2.)  &  Ev = 1. - exp((-V)>(-70.))

return, I0*2./(f*V^2)*(V - Ev + (f-1.)/2. * Ev^2)

end ;STAR POLYMER GAUSSIAN STATISTIC FORM FACTOR

function str_StarPolyPolyG, X, I0, R, fa, dR
;+
;******* *****************
;**
;** STAR POLYDISPERSE POLYMER GAUSSIAN STATISTIC FORM FACTOR
;** Rg  Radius of gyration
;** fa  number of Arms
;** I0  at Q0
;-
Rg = R > .01
f  = fa> 2.

u2 = (X*Rg)^2

return, I0* (1.+u2/(3*f)) / ( 1.+ (u2*(f+1.)/(6*f)) )^2

end ;STAR POLYDISPERSE POLYMER GAUSSIAN STATISTIC FORM FACTOR


;*******************
; CYLINDRICAL
;*******************
function str_Disk, X, Sc, Rd, dR
;+
;******* ********
;**
;** DISK FORM FACTOR
;** R   Radius of Disk
;** Sc  Scattering contrast
;-
R = Rd>.01

if n_elements(Sc) ne 1 then Sc=1.

QR = X*R

return, (!Pi*Sc*R^2)^2 *2./QR^2 *(1.- beselj(QR*2.,1)/QR)

end ;DISK FORM FACTOR

function str_Rod, X, Sc, Lr, dL
;+
;******* *******
;**
;** ROD FORM FACTOR
;** L  Lenght of Rod
;** Sc  Scattering contrast
;-
L = Lr>.01

if n_elements(Sc) ne 1 then Sc=1.

QL = X*L
Si = QL
for i=0,n_elements(Si)-1 do begin & int=[1e-15,QL[0:i]]
    Si[i]=Int_Tabulated( int ,sin(int)/int) & endfor

;for i=0,n_elements(Si)-1 do Si(i)=QROMB('romb_rod', 1e-15, QL(i)) ; Other integration method

return, (Sc*L)^2 *(2.*Si/QL -(sin(QL/2.)/QL*2.)^2)

end ;ROD FORM FACTOR
function romb_rod, X  &  return,sin(X)/X  &  end
;******* ********
;** romb_rod

;**************************************************************************************************
;Start QENS functions
;
;Common/related parameters for all functions: 
;  Scale    = Intensity or scaling factor
;  u^2      = To compute DW. If used all functions should be multiplied by same factor, i.e. exp(-u^2*Q^2/3)
;  Center   = Position of the function
;  Fraction = To use if not all atoms participate in fitted motion (sum of fractions should be 1)

;===============================================================================

FUNCTION strnormLORENTZ, X, p1, p2
  ;+
  ;******* **************
  ;** Lorentzian function (unit area)
  ;** p1 = position
  ;** p2 = hwhm
  ;-
  return, (p2 / ((X-p1)^2 + p2^2) / !pi) > (1e-16) & end

FUNCTION strnormGAUSS, X, p1, p2
  ;+
  ;******* **************
  ;** Gaussian function (unit area)
  ;** p1 = position
  ;** p2 = sigma
  ;-
  return, (exp(-0.5*((X-p1)/p2)^2) / p2 / sqrt(2*!pi)) > (1e-16) & end


function QENS_Delta, X, P1, P2, P3, P4
  ;+
  ;*******************************************************
  ;** Delta function
  ;**   As the position of the delta can be between two energy values,
  ;**   the intensity of the delta is shared into 2 deltas placed at those two energies.
  ;**
  ;** Parameters:
  ;**   P1 = Scaling factor
  ;**   P2 = u^2 for DW term
  ;**   P3 = Center
  ;**   P4 = Fraction of atoms
  ;-

  common c_str_fitqens, func_resol, Qcurrent1D, Qcurrent2D, mig2, mig3, mig4, mig5

  ;area of resolution function (QENS --> assume center at 0)
  if n_elements(func_resol) ge 3 then begin
    idx = value_locate(X, 0.0) >0 <(n_elements(X)-2)  ;avoid idx out of range
    if (X[idx+1]-P3) lt (P3-X[idx]) then idx += 1     ;select closest channel to delta position
    half = n_elements(func_resol)/2
    imin = (idx-half)>0
    imax = (idx+half)<(n_elements(X)-1)
    xresol = X[imin:imax]
    if n_elements(xresol) eq n_elements(func_resol) then begin
      ;remove duplicated values of X before calling int_tabulated
      ;this was needed e.g. in the case where extra points have been added
      ;to a dataset in order to combine it with another in a single workspace
      tmp = uniq(xresol, sort(xresol))
      area = int_tabulated(xresol[tmp], func_resol[tmp])
    endif else area = 1.0
  endif else area = 1.0

  Y = X*0.0
  idx = value_locate(X, P3) >0 <(n_elements(X)-2)  ;avoid idx out of range
  frac_left  = (X[idx+1] - P3) / (X[idx+1]-X[idx])
  frac_right =   (P3 - X[idx]) / (X[idx+1]-X[idx])
  Y[idx]   = frac_left  / area
  Y[idx+1] = frac_right / area
  ;scaling x participation ratio & DW
  Y *= P1 * P4
  if P2 gt 0. then Y *= EXP((-P2*Qcurrent1D^2/3.)>(-70.))

  return, Y

end


function QENS_Lorentz, X, P1, P2, P3, P4, P5
  ;+
  ;*******************************************************
  ;** Lorentzian function of HWHM = P5
  ;**    
  ;** Parameters:
  ;**   P1 = Scaling factor
  ;**   P2 = u^2 for DW term
  ;**   P3 = Center
  ;**   P4 = Fraction of atoms
  ;**   P5 = HWHM (e.g. = D*Q^2 for Random Walk Translation)
  ;-

  common c_str_fitqens, func_resol, Qcurrent1D, Qcurrent2D, mig2, mig3, mig4, mig5

  Y = strnormLorentz(X, P3, P5)
  ;scaling x participation ratio & DW
  Y *= P1 * P4
  if P2 gt 0. then Y *= EXP((-P2*Qcurrent1D^2/3.)>(-70.)) 
  
  return, Y
  
end


function QENS_Gauss, X, P1, P2, P3, P4, P5
  ;+
  ;*******************************************************
  ;** Gaussian function of sigma = P5
  ;**
  ;** Parameters:
  ;**   P1 = Scaling factor
  ;**   P2 = u^2 for DW term
  ;**   P3 = Center
  ;**   P4 = Fraction of atoms
  ;**   P5 = sigma of Gaussian distribution 
  ;-

  common c_str_fitqens, func_resol, Qcurrent1D, Qcurrent2D, mig2, mig3, mig4, mig5

  Y = strnormGauss(X, P3, P5)
  ;scaling x participation ratio & DW
  Y *= P1 * P4
  if P2 gt 0. then Y *= EXP((-P2*Qcurrent1D^2/3.)>(-70.))

  return, Y

end


function QENS_RandomWalkTranslation, X, P1, P2, P3, P4, P5
  ;+
  ;*******************************************************
  ;** Continuous diffusion model
  ;**
  ;** Parameters:
  ;**   P1 = Scaling factor
  ;**   P2 = u^2 for DW term or 0.
  ;**   P3 = Center
  ;**   P4 = Fraction of atoms
  ;**   P5 = D (self-diffusion coefficient in A^2*meV)
  ;-

  common c_str_fitqens, func_resol, Qcurrent1D, Qcurrent2D, mig2, mig3, mig4, mig5

  hwhm = P5 * Qcurrent1D^2 
  Y = strnormLorentz(X, P3, hwhm)
  ;scaling x participation ratio & DW
  Y *= P1 * P4
  if P2 gt 0. then Y *= EXP((-P2*Qcurrent1D^2/3.)>(-70.)) 

  return, Y

end


function QENS_JumpDiffusionTranslation, X, P1, P2, P3, P4, P5, P6
  ;+
  ;*******************************************************
  ;** Jump-diffusion model 
  ;**
  ;** Parameters:
  ;**   P1 = Scaling factor
  ;**   P2 = u^2 for DW term
  ;**   P3 = Center
  ;**   P4 = Fraction of atoms
  ;**   P5 = D (self-diffusion coefficient in A^2*meV)
  ;**   P6 = Residence time (meV^-1)
  ;-

  common c_str_fitqens, func_resol, Qcurrent1D, Qcurrent2D, mig2, mig3, mig4, mig5

  hwhm = P5 * Qcurrent1D^2 / (1.0 + P6 * P5 * Qcurrent1D^2)
  Y = strnormLorentz(X, P3, hwhm)
  ;scaling x participation ratio & DW
  Y *= P1 * P4
  if P2 gt 0. then Y *= EXP((-P2*Qcurrent1D^2/3.)>(-70.)) 

  return, Y

end


function QENS_ChudleyElliot, X, P1, P2, P3, P4, P5, P6
  ;+
  ;*******************************************************
  ;** Chudley-Elliot model
  ;**
  ;** Parameters:
  ;**   P1 = Scaling factor
  ;**   P2 = u^2 for DW term
  ;**   P3 = Center
  ;**   P4 = Fraction of atoms
  ;**   P5 = l (jump distance in A)
  ;**   P6 = Residence time (meV^-1)
  ;-

  common c_str_fitqens, func_resol, Qcurrent1D, Qcurrent2D, mig2, mig3, mig4, mig5

  hwhm = (1.0 - (sin(Qcurrent1D*P5)/(Qcurrent1D*P5))) / P6
  Y = strnormLorentz(X, P3, hwhm)
  ;scaling x participation ratio & DW
  Y *= P1 * P4
  if P2 gt 0. then Y *= EXP((-P2*Qcurrent1D^2/3.)>(-70.))

  return, Y

end


function QENS_JumpsNsites, X, P1, P2, P3, P4, P5, P6, P7
  ;+
  ;********************************************************
  ;** Model of jumps between N equivalent sites in a circle
  ;**
  ;** Parameters:
  ;**   P1 = Scaling factor
  ;**   P2 = u^2 for DW term
  ;**   P3 = Center
  ;**   P4 = Fraction of atoms
  ;**   P5 = number of sites (integer)
  ;**   P6 = radius of the circle 
  ;**   P7 = average residence time on a site 
  ;-

  common c_str_fitqens, func_resol, Qcurrent1D, Qcurrent2D, mig2, mig3, mig4, mig5

  nsites = fix(P5)>2  ;minimum is 2 sites
  ivector=findgen(nsites) & j0 = fltarr(nsites) & isf = fltarr(nsites)
  qrjump = 2.0 * P6 * sin(ivector*!pi/nsites) * Qcurrent1D                    ;Q*r_i
  hwhm   = (2.0/P7) * (sin(ivector*!pi/nsites))^2                           ;Gamma_i
  j0[0] = 1.0 & j0[1:nsites-1] = sin(qrjump[1:nsites-1]) / qrjump[1:nsites-1] ;first spherical bessel function
  for isite=0, nsites-1 do begin
    for jsite=0, nsites-1 do begin
      isf[isite] += j0[jsite] * cos(2.0*isite*jsite*!pi/nsites)
    endfor
    isf[isite] /= nsites
  endfor

  ;elastic term (EISF)
  Y = isf[0] * QENS_delta(X, 1.0, 0.0, P3, 1.0) ;delta (area=1, DW=0, position, fraction=1)
  ;quasielastic terms
  for isite=1, nsites-1 do begin
    Y += isf[isite] * strnormLorentz(X, P3, hwhm[isite])
  endfor
  ;scaling x participation ratio & DW
  Y *= P1 * P4
  if P2 gt 0. then Y *= EXP((-P2*Qcurrent1D^2/3.)>(-70.)) 

  return, Y

end


function QENS_JumpsNsitesLogNormDist, X, P1, P2, P3, P4, P5, P6, P7, P8
  ;+
  ;********************************************************
  ;** Model of jumps between N equivalent sites in a circle
  ;** with a log-norm distribution of relaxation times
  ;** Ref. A. Chaid et al., Macromolecules 27, 3282 (1994)
  ;**
  ;** Parameters:
  ;**   P1 = Scaling factor
  ;**   P2 = u^2 for DW term
  ;**   P3 = Center
  ;**   P4 = Fraction of atoms
  ;**   P5 = number of sites (integer)
  ;**   P6 = radius of the circle
  ;**   P7 = average residence time on a site
  ;**   P8 = sigma of the log-norm distribution
  ;-

  common c_str_fitqens, func_resol, Qcurrent1D, Qcurrent2D, mig2, mig3, mig4, mig5

  nsites = fix(P5)>2  ;minimum is 2 sites
  ivector=findgen(nsites) & j0 = fltarr(nsites) & isf = fltarr(nsites)
  qrjump = 2.0 * P6 * sin(ivector*!pi/nsites) * Qcurrent1D                    ;Q*r_i
  hwhm   = (2.0/P7) * (sin(ivector*!pi/nsites))^2                             ;Gamma_i
  j0[0] = 1.0 & j0[1:nsites-1] = sin(qrjump[1:nsites-1]) / qrjump[1:nsites-1] ;first spherical bessel function
  for isite=0, nsites-1 do begin
    for jsite=0, nsites-1 do begin
      isf[isite] += j0[jsite] * cos(2.0*isite*jsite*!pi/nsites)
    endfor
    isf[isite] /= nsites
  endfor

  ;elastic term (EISF)
  Y = isf[0] * QENS_delta(X, 1.0, 0.0, P3, 1.0) ;delta (area=1, DW=0, position, fraction=1)
  
  ;log-norm distribution --> described by 2*nmax+1 points = 2*nmax+1 lorentzian functions
  nmax = 10                                 ;number of lorentzians used in distribution is 2*nmax+1
  lowlim = 0.1                              ;lower value of gi/max(gi) to be used
  range = P8*sqrt(-2.0*alog(lowlim))        ;max (absolute) value of log(x) range to explore
  dr = range/float(nmax)
  ratio = exp(findgen(2*nmax+1)*dr - range) ;vector of gamma_i / gamma_average values to use
  gi = exp(-0.5*alog(ratio)^2/P8^2)         ;distribution of weights
  gi /= total(gi)                           ;normalize so sum gi = 1
  hi = fltarr(nsites,2*nmax+1)              ;distribution of hwhm for each jumping distance
  for isite=0, nsites-1 do hi[isite,*] = hwhm[isite] * ratio  ;corresponding hwhm for each gi and jumping distance

  ;quasielastic terms
  for ilor=0, 2*nmax do begin
    for isite=1, nsites-1 do begin
      Y += isf[isite] * gi[ilor] * strnormLorentz(X, P3, hi[isite,ilor])
    endfor
  endfor
  
  ;scaling x participation ratio & DW
  Y *= P1 * P4
  if P2 gt 0. then Y *= EXP((-P2*Qcurrent1D^2/3.)>(-70.)) 

  return, Y

end


function QENS_IsotropicRotationalDiffusion, X, P1, P2, P3, P4, P5, P6
  ;+
  ;********************************************************
  ;** Model of isotropic rotational diffusion 
  ;**
  ;** Parameters:
  ;**   P1 = Scaling factor
  ;**   P2 = u^2 for DW term
  ;**   P3 = Center
  ;**   P4 = Fraction of atoms
  ;**   P5 = radius of the sphere
  ;**   P6 = rotational diffusion constant (meV)
  ;-

  common c_str_fitqens, func_resol, Qcurrent1D, Qcurrent2D, mig2, mig3, mig4, mig5

  nmax = 10 ;number of lorentzians to use in sum (theoretically is infinite)
  jl = fltarr(nmax+1) & hwhm = fltarr(nmax+1)  
  arg = Qcurrent1D * P5
  ;elastic term
  if arg gt 0.0 then jl[0] = sqrt(!pi/2/arg)*beselj(arg,0.5) else jl[0]=1.0
  ;quasielastic terms
  for i = 1, nmax do begin
    if arg gt 0.0 then jl[i] = sqrt(!pi/2/arg)*beselj(arg,i+0.5) else jl[i]=0.0 
    hwhm[i] = i * (i+1) * P6
  endfor
  jl2 = jl^2

  ;elastic term (EISF)
  Y = jl2[0] * QENS_delta(X, 1.0, 0.0, P3, 1.0) ;delta (area=1, DW=0, position, fraction=1)
  ;quasielastic terms
  for i=1, nmax do begin
    Y += (2*i+1) * jl2[i] * strnormLorentz(X, P3, hwhm[i])
  endfor
  ;scaling x participation ratio & DW
  Y *= P1 * P4
  if P2 gt 0. then Y *= EXP((-P2*Qcurrent1D^2/3.)>(-70.)) 

  return, Y

end


function QENS_RotTrans, X, P1, P2, P3, P4, P5, P6, P7, P8
  ;+
  ;***********************************************************************
  ;** Model of jump-diffusion translation + isotropic rotational diffusion
  ;**
  ;** Parameters:
  ;**   P1 = Scaling factor
  ;**   P2 = u^2 for DW term
  ;**   P3 = Center
  ;**   P4 = Fraction of atoms
  ;**   P5 = D (self-diffusion coefficient in A^2*meV)
  ;**   P6 = Residence time (meV^-1)
  ;**   P7 = radius of the sphere
  ;**   P8 = rotational diffusion constant (meV)
  ;-

  common c_str_fitqens, func_resol, Qcurrent1D, Qcurrent2D, mig2, mig3, mig4, mig5

  ;translational diffusion
  hwhm_trans = P5 * Qcurrent1D^2 / (1.0 + P6 * P5 * Qcurrent1D^2)

  ;rotational diffusion
  nmax = 10 ;number of lorentzians to use in sum (theoretically is infinite)
  jl = fltarr(nmax+1) & hwhm_rot = fltarr(nmax+1)
  arg = Qcurrent1D * P7
  ;elastic term
  if arg gt 0.0 then jl[0] = sqrt(!pi/2/arg)*beselj(arg,0.5) else jl[0]=1.0
  ;quasielastic terms
  for i = 1, nmax do begin
    if arg gt 0.0 then jl[i] = sqrt(!pi/2/arg)*beselj(arg,i+0.5) else jl[i]=0.0
    hwhm_rot[i] = i * (i+1) * P8
  endfor
  jl2 = jl^2

  ;first term (EISF)
  Y = jl2[0] * strnormLorentz(X, P3, hwhm_trans)
  ;quasielastic terms
  for i=1, nmax do begin
    Y += (2*i+1) * jl2[i] * strnormLorentz(X, P3, hwhm_trans+hwhm_rot[i])
  endfor
  ;scaling x participation ratio & DW
  Y *= P1 * P4
  if P2 gt 0. then Y *= EXP((-P2*Qcurrent1D^2/3.)>(-70.)) 

  return, Y

end


function QENS_3DLocalizedTranslation, X, P1, P2, P3, P4, P5, P6
  ;+
  ;********************************************************
  ;** Gaussian model for localized translational motion in 3D
  ;** Ref. F. Volino et al., J. Phys. Chem. B 110, 11217 (2006)
  ;**
  ;** Parameters:
  ;**   P1 = Scaling factor
  ;**   P2 = u^2 for DW term
  ;**   P3 = Center
  ;**   P4 = Fraction of atoms
  ;**   P5 = D (self-diffusion coefficient in A^2*meV)
  ;**   P6 = Variance of Gaussian distribution corresponding to the displacement (A^2) = <ux^2>
  ;-

  common c_str_fitqens, func_resol, Qcurrent1D, Qcurrent2D, mig2, mig3, mig4, mig5

  nmax = 100 ;number of lorentzians to use in sum (theoretically is infinite)
  al = fltarr(nmax+1) & hwhm = fltarr(nmax+1)
  arg = double(Qcurrent1D^2 * P6)
  exparg = EXP((-arg)>(-70.))
  ;elastic term
  if arg gt 0.0 then al[0] = exparg else al[0]=1.0
  ;quasielastic terms
  for i = 1, nmax do begin
    if arg gt 0.0 then begin
      al[i] = exparg*(arg^i)/factorial(i) 
      hwhm[i] = i*P5/P6
    endif else al[i]=0.0
  endfor

  ;elastic term (EISF)
  Y = al[0] * QENS_delta(X, 1.0, 0.0, P3, 1.0) ;delta (area=1, DW=0, position, fraction=1)
  ;quasielastic terms
  for i=1, nmax do begin
    Y += al[i] * strnormLorentz(X, P3, hwhm[i])
  endfor
  
  ;scaling x participation ratio & DW
  Y *= P1 * P4
  if P2 gt 0. then Y *= EXP((-P2*Qcurrent1D^2/3.)>(-70.))

  return, Y

end


; Combined functions --> Need care if combined with other functions
; as the parameter P4 does not represent now the fraction of atoms
; 'assigned' to the function. 

function QENS_DeltaLorentz, X, P1, P2, P3, P4, P5
  ;+
  ;*******************************************************
  ;** Delta + Lorentzian
  ;**   As the position of the delta can be between two energy values,
  ;**   the intensity of the delta is shared into 2 deltas placed at those two energies.
  ;**
  ;** Parameters:
  ;**   P1 = Scaling factor
  ;**   P2 = u^2 for DW term
  ;**   P3 = Center
  ;**   P4 = Fraction of atoms contributing to delta
  ;**   P5 = HWHM
  ;-

  common c_str_fitqens, func_resol, Qcurrent1D, Qcurrent2D, mig2, mig3, mig4, mig5

  Y = QENS_delta(X, 1.0, 0.0, P3, P4) ;delta (area=1, DW=0, position, fraction=P4)
  Y += (1.0-P4) * strnormLorentz(X, P3, P5)
  ;scaling & DW
  Y *= P1 
  if P2 gt 0. then Y *= EXP((-P2*Qcurrent1D^2/3.)>(-70.))

  return, Y

end


function QENS_DeltaLorentz2, X, P1, P2, P3, P4, P5, P6, P7
  ;+
  ;*******************************************************
  ;** Delta + 2 Lorentzians
  ;**   As the position of the delta can be between two energy values,
  ;**   the intensity of the delta is shared into 2 deltas placed at those two energies.
  ;**
  ;** Parameters:
  ;**   P1 = Scaling factor
  ;**   P2 = u^2 for DW term
  ;**   P3 = Center
  ;**   P4 = Fraction of atoms contributing to delta
  ;**   P5 = Fraction of atoms contributing to first lorentzian
  ;**   P6 = HWHM of first lorentzian
  ;**   P7 = HWHM of second lorentzian
  ;-

  common c_str_fitqens, func_resol, Qcurrent1D, Qcurrent2D, mig2, mig3, mig4, mig5

  Y = QENS_delta(X, 1.0, 0.0, P3, P4) ;delta (area=1, DW=0, position, fraction=P4)
  Y += P5 * strnormLorentz(X, P3, P6)
  Y += (1.0-P4-P5) * strnormLorentz(X, P3, P7)
  ;scaling & DW
  Y *= P1
  if P2 gt 0. then Y *= EXP((-P2*Qcurrent1D^2/3.)>(-70.))

  return, Y

end


function QENS_DeltaLorentz2b, X, P1, P2, P3, P4, P5, P6, P7
  ;+
  ;*******************************************************
  ;** Delta + 2 Lorentzians
  ;**   As the position of the delta can be between two energy values,
  ;**   the intensity of the delta is shared into 2 deltas placed at those two energies.
  ;**
  ;** Parameters:
  ;**   P1 = Scaling factor
  ;**   P2 = u^2 for DW term
  ;**   P3 = Center
  ;**   P4 = Fraction of atoms contributing to first lorentzian
  ;**   P5 = Fraction of atoms contributing to second lorentzian
  ;**   P6 = HWHM of first lorentzian
  ;**   P7 = HWHM of second lorentzian
  ;-

  common c_str_fitqens, func_resol, Qcurrent1D, Qcurrent2D, mig2, mig3, mig4, mig5

  Y = QENS_delta(X, 1.0, 0.0, P3, 1.0-P4-P5) ;delta (area=1, DW=0, position, fraction=1-P4-P5)
  Y += P4 * strnormLorentz(X, P3, P6)
  Y += P5 * strnormLorentz(X, P3, P7)
  ;scaling & DW
  Y *= P1
  if P2 gt 0. then Y *= EXP((-P2*Qcurrent1D^2/3.)>(-70.))

  return, Y

end


function QENS_Gauss2, X, P1, P2, P3, P4, P5, P6, P7
  ;+
  ;*******************************************************
  ;** Sum of 2 Gaussians
  ;**
  ;** Parameters:
  ;**   P1 = Scaling factor
  ;**   P2 = u^2 for DW term
  ;**   P3 = Position of first Gaussian
  ;**   P4 = Fraction of atoms contributing to first Gaussian
  ;**   P5 = sigma of first Gaussian
  ;**   P6 = Position of second Gaussian
  ;**   P7 = sigma of second Gaussian
  ;-

  common c_str_fitqens, func_resol, Qcurrent1D, Qcurrent2D, mig2, mig3, mig4, mig5

  Y = P4 * strnormGauss(X, P3, P5) 
  Y += (1-P4) * strnormGauss(X, P6, P7)
  ;scaling & DW
  Y *= P1
  if P2 gt 0. then Y *= EXP((-P2*Qcurrent1D^2/3.)>(-70.))

  return, Y

end


function QENS_Gauss3, X, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10
  ;+
  ;*******************************************************
  ;** Sum of 3 Gaussians
  ;**
  ;** Parameters:
  ;**   P1 = Scaling factor
  ;**   P2 = u^2 for DW term
  ;**   P3 = Position of first Gaussian
  ;**   P4 = Fraction of atoms contributing to first Gaussian
  ;**   P5 = sigma of first Gaussian
  ;**   P6 = Position of second Gaussian
  ;**   P7 = Fraction of atoms contributing to second Gaussian
  ;**   P8 = sigma of second Gaussian
  ;**   P9 = Position of third Gaussian
  ;**   P10 = sigma of third Gaussian
  ;-

  common c_str_fitqens, func_resol, Qcurrent1D, Qcurrent2D, mig2, mig3, mig4, mig5

  Y = P4 * strnormGauss(X, P3, P5)
  Y += P7 * strnormGauss(X, P6, P8)
  Y += (1-P4-P7) * strnormGauss(X, P9, P10)
  ;scaling & DW
  Y *= P1
  if P2 gt 0. then Y *= EXP((-P2*Qcurrent1D^2/3.)>(-70.))

  return, Y

end


function QENS_DeltaChudleyElliot, X, P1, P2, P3, P4, P5, P6
  ;+
  ;*******************************************************
  ;** Delta + Lorentzian with HWHM given by Chudley-Elliot model
  ;**   As the position of the delta can be between two energy values,
  ;**   the intensity of the delta is shared into 2 deltas placed at those two energies.
  ;**
  ;** Parameters:
  ;**   P1 = Scaling factor
  ;**   P2 = u^2 for DW term
  ;**   P3 = Center
  ;**   P4 = Fraction of atoms contributing to delta
  ;**   P5 = l (jump distance in A)
  ;**   P6 = Residence time (meV^-1)
  ;-

  common c_str_fitqens, func_resol, Qcurrent1D, Qcurrent2D, mig2, mig3, mig4, mig5

  Y = QENS_delta(X, 1.0, 0.0, P3, P4) ;delta (area=1, DW=0, position, fraction=P4) 
  hwhm = (1.0 - (sin(Qcurrent1D*P5)/(Qcurrent1D*P5))) / P6
  Y += (1.0-P4) * strnormLorentz(X, P3, hwhm)
  ;scaling & DW
  Y *= P1
  if P2 gt 0. then Y *= EXP((-P2*Qcurrent1D^2/3.)>(-70.))

  return, Y

end


function QENS_Natali, X, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10, P11, P12, P13, P14, P15
  ;+
  ;******************************************************************************
  ;** Delta + RotoTrans Lorentzian + RotoTrans Lorenzian + 'Fast' Lorentzian
  ;**   Described in detail in F. Natali, Y. Gerelli, C. Stelletta and J. Peters,
  ;**   AIP Conf. Proc. 1518, 551 (2013).
  ;**
  ;**   As the position of the delta can be between two energy values,
  ;**   the intensity of the delta is shared into 2 deltas placed at those two energies.
  ;**
  ;** Parameters:
  ;**   P1  = Scaling factor
  ;**   P2  = u^2 for DW term
  ;**   P3  = Center
  ;**   P4  = Fraction of atoms contributing to delta
  ;**   P5  = Fraction of atoms contributing to 1st lorentzian
  ;**   P6  = D (self-diffusion coefficient in A^2*meV) for 1st lorentzian
  ;**   P7  = Residence time (meV^-1) for 1st lorentzian
  ;**   P8  = Radius of the circle  for 1st lorentzian
  ;**   P9  = Rotational diffusion constant (meV) for 1st lorentzian
  ;**   P10 = Fraction of atoms contributing to 2nd lorentzian
  ;**   P11 = D (self-diffusion coefficient in A^2*meV) for 2nd lorentzian
  ;**   P12 = Residence time (meV^-1) for 2nd lorentzian
  ;**   P13 = Radius of the circle  for 2nd lorentzian
  ;**   P14 = Rotational diffusion constant (meV) for 2nd lorentzian
  ;**   P15 = HWHM of 3rd lorentzian
  ;-

  common c_str_fitqens, func_resol, Qcurrent1D, Qcurrent2D, mig2, mig3, mig4, mig5

  nmax = 10 ;number of lorentzians to use in sum of rotational part (theoretically is infinite)

  Y = QENS_delta(X, 1.0, 0.0, P3, P4) ;delta (area=1, DW=0, position, fraction=P4)
  
  ;first rototrans lorentzian
  hwhm_trans = P6 * Qcurrent1D^2 / (1.0 + P7 * P6 * Qcurrent1D^2)
  jl = fltarr(nmax+1) & hwhm_rot = fltarr(nmax+1)
  arg = Qcurrent1D * P8
  if arg gt 0.0 then jl[0] = sqrt(!pi/2/arg)*beselj(arg,0.5) else jl[0]=1.0
  for i = 1, nmax do begin
    if arg gt 0.0 then jl[i] = sqrt(!pi/2/arg)*beselj(arg,i+0.5) else jl[i]=0.0
    hwhm_rot[i] = i * (i+1) * P9
  endfor
  jl2 = jl^2
  Y += jl2[0] * P5 * strnormLorentz(X, P3, hwhm_trans) 
  for i=1, nmax do Y += (2*i+1) * jl2[i] * P5 * strnormLorentz(X, P3, hwhm_trans+hwhm_rot[i])

  ;second rototrans lorentzian
  hwhm_trans = P11 * Qcurrent1D^2 / (1.0 + P12 * P11 * Qcurrent1D^2)
  jl = fltarr(nmax+1) & hwhm_rot = fltarr(nmax+1)
  arg = Qcurrent1D * P13
  if arg gt 0.0 then jl[0] = sqrt(!pi/2/arg)*beselj(arg,0.5) else jl[0]=1.0
  for i = 1, nmax do begin
    if arg gt 0.0 then jl[i] = sqrt(!pi/2/arg)*beselj(arg,i+0.5) else jl[i]=0.0
    hwhm_rot[i] = i * (i+1) * P14
  endfor
  jl2 = jl^2
  Y += jl2[0] * P10 * strnormLorentz(X, P3, hwhm_trans)
  for i=1, nmax do Y += (2*i+1) * jl2[i] * P10 * strnormLorentz(X, P3, hwhm_trans+hwhm_rot[i])
  
  ;third lorentzian (general one to account for fast motion)
  Y += (1.0-P4-P5-P10) * strnormLorentz(X, P3, P15)

  ;scaling & DW
  Y *= P1
  if P2 gt 0. then Y *= EXP((-P2*Qcurrent1D^2/3.)>(-70.))

  return, Y

end


function QENS_Iri, X, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10, P11
  ;+
  ;******************************************************************************
  ;** Delta + 2 jump_diffusion lorentzians + 'Fast' Lorentzian
  ;**   Previous model simplified (no rotational motion considered).
  ;**
  ;**   As the position of the delta can be between two energy values,
  ;**   the intensity of the delta is shared into 2 deltas placed at those two energies.
  ;**
  ;** Parameters:
  ;**   P1  = Scaling factor
  ;**   P2  = u^2 for DW term
  ;**   P3  = Center
  ;**   P4  = Fraction of atoms contributing to delta
  ;**   P5  = Fraction of atoms contributing to 1st lorentzian
  ;**   P6  = D (self-diffusion coefficient in A^2*meV) for 1st lorentzian
  ;**   P7  = Residence time (meV^-1) for 1st lorentzian
  ;**   P8  = Fraction of atoms contributing to 2nd lorentzian
  ;**   P9  = D (self-diffusion coefficient in A^2*meV) for 2nd lorentzian
  ;**   P10 = Residence time (meV^-1) for 2nd lorentzian
  ;**   P11 = HWHM of 3rd lorenzian
  ;-

  common c_str_fitqens, func_resol, Qcurrent1D, Qcurrent2D, mig2, mig3, mig4, mig5

  nmax = 10 ;number of lorentzians to use in sum of rotational part (theoretically is infinite)

  Y = QENS_delta(X, 1.0, 0.0, P3, P4) ;delta (area=1, DW=0, position, fraction=P4) 

  ;first jump-diffusion lorentzian
  hwhm_trans = P6 * Qcurrent1D^2 / (1.0 + P7 * P6 * Qcurrent1D^2)
  Y += P5 * strnormLorentz(X, P3, hwhm_trans)

  ;second jump-diffusion lorentzian
  hwhm_trans = P9 * Qcurrent1D^2 / (1.0 + P10 * P9 * Qcurrent1D^2)
  Y += P8 * strnormLorentz(X, P3, hwhm_trans)

  ;third lorentzian (general one to account for fast motion)
  Y += (1.0-P4-P5-P8) * strnormLorentz(X, P3, P11)

  ;scaling & DW
  Y *= P1
  if P2 gt 0. then Y *= EXP((-P2*Qcurrent1D^2/3.)>(-70.))

  return, Y

end


function QENS_Iri2, X, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10
  ;+
  ;******************************************************************************
  ;** Delta + RotoTrans Lorentzian + 'Fast' Lorentzian
  ;**   QENS_Natali model simplified (only 1 roto-translational lorentzian)
  ;**
  ;**   As the position of the delta can be between two energy values,
  ;**   the intensity of the delta is shared into 2 deltas placed at those two energies.
  ;**
  ;** Parameters:
  ;**   P1  = Scaling factor
  ;**   P2  = u^2 for DW term
  ;**   P3  = Center
  ;**   P4  = Fraction of atoms contributing to delta
  ;**   P5  = Fraction of atoms contributing to 1st lorentzian
  ;**   P6  = D (self-diffusion coefficient in A^2*meV) for 1st lorentzian
  ;**   P7  = Residence time (meV^-1) for 1st lorentzian
  ;**   P8  = Radius of the circle  for 1st lorentzian
  ;**   P9  = Rotational diffusion constant (meV) for 1st lorentzian
  ;**   P10 = HWHM of 3rd lorenzian
  ;-

  common c_str_fitqens, func_resol, Qcurrent1D, Qcurrent2D, mig2, mig3, mig4, mig5

  nmax = 10 ;number of lorentzians to use in sum of rotational part (theoretically is infinite)

  Y = QENS_delta(X, 1.0, 0.0, P3, P4) ;delta (area=1, DW=0, position, fraction=P4)

  ;first rototrans lorentzian
  hwhm_trans = P6 * Qcurrent1D^2 / (1.0 + P7 * P6 * Qcurrent1D^2)
  jl = fltarr(nmax+1) & hwhm_rot = fltarr(nmax+1)
  arg = Qcurrent1D * P8
  if arg gt 0.0 then jl[0] = sqrt(!pi/2/arg)*beselj(arg,0.5) else jl[0]=1.0
  for i = 1, nmax do begin
    if arg gt 0.0 then jl[i] = sqrt(!pi/2/arg)*beselj(arg,i+0.5) else jl[i]=0.0
    hwhm_rot[i] = i * (i+1) * P9
  endfor
  jl2 = jl^2
  Y += jl2[0] * P5 * strnormLorentz(X, P3, hwhm_trans)
  for i=1, nmax do Y += (2*i+1) * jl2[i] * P5 * strnormLorentz(X, P3, hwhm_trans+hwhm_rot[i])

  ;second lorentzian (general one to account for fast motion)
  Y += (1.0-P4-P5) * strnormLorentz(X, P3, P10)

  ;scaling & DW
  Y *= P1
  if P2 gt 0. then Y *= EXP((-P2*Qcurrent1D^2/3.)>(-70.))

  return, Y

end


function QENS_IL1, X, P1, P2, P3, P4, P5, P6
  ;+
  ;******************************************************************************
  ;** Translational-like lorentzian + 1 localized lorentzian
  ;**
  ;** Parameters:
  ;**   P1  = Scaling factor
  ;**   P2  = u^2 for DW term
  ;**   P3  = Center
  ;**   P4  = EISF of localized lorentzian
  ;**   P5  = HWHM of translational lorentzian
  ;**   P6  = HWHM of localized lorentzian
  ;-

  common c_str_fitqens, func_resol, Qcurrent1D, Qcurrent2D, mig2, mig3, mig4, mig5

  ;translational lorentzian
  Y = P4 * strnormLorentz(X, P3, P5)

  ;localized lorentzian
  Y += (1-P4) * strnormLorentz(X, P3, P5+P6)

  ;scaling & DW
  Y *= P1
  if P2 gt 0. then Y *= EXP((-P2*Qcurrent1D^2/3.)>(-70.))

  return, Y

end


function QENS_IL2, X, P1, P2, P3, P4, P5, P6, P7, P8
  ;+
  ;******************************************************************************
  ;** Translational-like lorentzian + 2 localized lorentzians
  ;**
  ;** Parameters:
  ;**   P1  = Scaling factor
  ;**   P2  = u^2 for DW term
  ;**   P3  = Center
  ;**   P4  = EISF of first localized lorentzian
  ;**   P5  = EISF of second localized lorentzian
  ;**   P6  = HWHM of translational lorentzian
  ;**   P7  = HWHM of first localized lorentzian
  ;**   P8  = HWHM of second localized lorentzian
  ;-

  common c_str_fitqens, func_resol, Qcurrent1D, Qcurrent2D, mig2, mig3, mig4, mig5

  ;translational lorentzian
  Y = P4 * P5 * strnormLorentz(X, P3, P6)

  ;first localized lorentzian
  Y += (1-P4) * P5 * strnormLorentz(X, P3, P6+P7)

  ;second localized lorentzian
  Y += P4 * (1-P5) * strnormLorentz(X, P3, P6+P8)

  ;both lorentzians
  Y += (1-P4) * (1-P5) * strnormLorentz(X, P3, P6+P7+P8)

  ;scaling & DW
  Y *= P1
  if P2 gt 0. then Y *= EXP((-P2*Qcurrent1D^2/3.)>(-70.))

  return, Y

end


function QENS_IL3, X, P1, P2, P3, P4, P5, P6, P7, P8, P9
  ;+
  ;******************************************************************************
  ;** Jump-diffusion translation x Confined translation (Volino) x Localized motion
  ;**
  ;** Parameters:
  ;**   P1  = Scaling factor
  ;**   P2  = u^2 for DW term
  ;**   P3  = Center
  ;**   P4  = D for long-range translation
  ;**   P5  = Residence time for long-range translation
  ;**   P6  = D for confined translation
  ;**   P7  = u^2 for confined translation
  ;**   P8  = EISF of localized lorentzian
  ;**   P9  = HWHM of localized lorentzian
  ;-

  common c_str_fitqens, func_resol, Qcurrent1D, Qcurrent2D, mig2, mig3, mig4, mig5

  ;width of long-range translational lorentzian
  hwhm_t = P4 * Qcurrent1D^2 / (1.0 + P5 * P4 * Qcurrent1D^2)
  
  ;A_i and Gamma_i terms in Volino's model 
  nmax = 100 ;number of lorentzians to use in sum (theoretically is infinite)
  al = fltarr(nmax+1) & hwhm_v = fltarr(nmax+1)
  arg = double(Qcurrent1D^2 * P7)
  exparg = EXP((-arg)>(-70.))
  ;elastic term
  if arg gt 0.0 then al[0] = exparg else al[0]=1.0
  ;quasielastic terms
  for i = 1, nmax do begin
    if arg gt 0.0 then begin
      al[i] = exparg*(arg^i)/factorial(i)
      hwhm_v[i] = i*P6/P7
    endif else al[i]=0.0
  endfor

  ;First term = A0_V * A0_L * Lorentz(Gamma_T)
  Y = al[0] * P8 * strnormLorentz(X, P3, hwhm_t)
  
  ;Second term = A0_L * Sum(AV_i * Lorentz(Gamma_T+GammaV_i)
  for i = 1, nmax do begin
    Y += P8 * al[i] * strnormLorentz(X, P3, hwhm_t+hwhm_v[i])
  endfor
  
  ;Third term = A0_V * (1-A0_L) * Lorentz(Gamma_T + Gamma_L)
  Y += al[0] * (1-P8) * strnormLorentz(X, P3, hwhm_t+P9)
  
  ;Fourth term = (1-A0_L) * Sum(AV_i * * Lorentz(Gamma_T+GammaV_i+Gamma_L)
  for i = 1, nmax do begin
    Y += (1-P8) * al[i] * strnormLorentz(X, P3, hwhm_t+hwhm_v[i]+P9)
  endfor

  ;scaling & DW
  Y *= P1
  if P2 gt 0. then Y *= EXP((-P2*Qcurrent1D^2/3.)>(-70.))

  return, Y

end


function QENS_Fixed_JumpsNsites, X, P1, P2, P3, P4, P5, P6, P7
  ;+
  ;********************************************************
  ;** Model of jumps between N equivalent sites in a circle
  ;**
  ;** Parameters:
  ;**   P1 = Scaling factor
  ;**   P2 = u^2 for DW term
  ;**   P3 = Center
  ;**   P4 = Fraction of fixed atoms
  ;**   P5 = number of sites (integer)
  ;**   P6 = radius of the circle
  ;**   P7 = average residence time on a site
  ;-

  common c_str_fitqens, func_resol, Qcurrent1D, Qcurrent2D, mig2, mig3, mig4, mig5

  nsites = fix(P5)>2  ;minimum is 2 sites
  ivector=findgen(nsites) & j0 = fltarr(nsites) & isf = fltarr(nsites)
  qrjump = 2.0 * P6 * sin(ivector*!pi/nsites) * Qcurrent1D                    ;Q*r_i
  hwhm   = (2.0/P7) * (sin(ivector*!pi/nsites))^2                             ;Gamma_i
  j0[0] = 1.0 & j0[1:nsites-1] = sin(qrjump[1:nsites-1]) / qrjump[1:nsites-1] ;first spherical bessel function
  for isite=0, nsites-1 do begin
    for jsite=0, nsites-1 do begin
      isf[isite] += j0[jsite] * cos(2.0*isite*jsite*!pi/nsites)
    endfor
    isf[isite] /= nsites
  endfor

  ;elastic term (EISF)
  Y = (P4 + (1-P4)*isf[0]) * QENS_delta(X, 1.0, 0.0, P3, 1.0) ;delta (area=1, DW=0, position, fraction=1)
  ;quasielastic terms
  for isite=1, nsites-1 do begin
    Y += (1-P4) * isf[isite] * strnormLorentz(X, P3, hwhm[isite])
  endfor
  
  ;scaling x participation ratio & DW
  Y *= P1 
  if P2 gt 0. then Y *= EXP((-P2*Qcurrent1D^2/3.)>(-70.))

  return, Y

end


function QENS_Fixed_2JumpsNsites, X, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10, P11
  ;+
  ;********************************************************
  ;** Model for a system consisting on a fraction (1-P4-P8) of fixed atoms,
  ;** a fraction P4 of atoms doing jumps between N equivalent sites in a circle,
  ;** and a fraction of P8 of atoms doing jumps between N' equivalent sites in a circle.
  ;**
  ;** Parameters:
  ;**   P1 = Scaling factor
  ;**   P2 = u^2 for DW term
  ;**   P3 = Center
  ;**   P4 = Fraction of atoms for first set of jumps
  ;**   P5 = number of sites (integer)
  ;**   P6 = radius of the circle
  ;**   P7 = average residence time on a site
  ;**   P8 = Fraction of atoms for second set of jumps
  ;**   P9 = number of sites (integer)
  ;**   P10 = radius of the circle
  ;**   P11 = average residence time on a site
  ;-

  common c_str_fitqens, func_resol, Qcurrent1D, Qcurrent2D, mig2, mig3, mig4, mig5

  ;first type of jumps
  nsites1 = fix(P5)>2  ;minimum is 2 sites
  ivector =findgen(nsites1) & j0 = fltarr(nsites1) & isf1 = fltarr(nsites1)
  qrjump = 2.0 * P6 * sin(ivector*!pi/nsites1) * Qcurrent1D                          ;Q*r_i
  hwhm1  = (2.0/P7) * (sin(ivector*!pi/nsites1))^2                                   ;Gamma_i
  j0[0] = 1.0 & j0[1:nsites1-1] = sin(qrjump[1:nsites1-1]) / qrjump[1:nsites1-1]     ;first spherical bessel function
  for isite=0, nsites1-1 do begin
    for jsite=0, nsites1-1 do begin
      isf1[isite] += j0[jsite] * cos(2.0*isite*jsite*!pi/nsites1)
    endfor
    isf1[isite] /= nsites1
  endfor

  ;second type of jumps
  nsites2 = fix(P9)>2  ;minimum is 2 sites
  ivector =findgen(nsites2) & j0 = fltarr(nsites2) & isf2 = fltarr(nsites2)
  qrjump = 2.0 * P10 * sin(ivector*!pi/nsites2) * Qcurrent1D                          ;Q*r_i
  hwhm2  = (2.0/P11) * (sin(ivector*!pi/nsites2))^2                                   ;Gamma_i
  j0[0] = 1.0 & j0[1:nsites2-1] = sin(qrjump[1:nsites2-1]) / qrjump[1:nsites2-1]      ;first spherical bessel function
  for isite=0, nsites2-1 do begin
    for jsite=0, nsites2-1 do begin
      isf2[isite] += j0[jsite] * cos(2.0*isite*jsite*!pi/nsites2)
    endfor
    isf2[isite] /= nsites2
  endfor

  ;elastic term (EISF)
  Y = ((1-P4-P8) + P4*isf1[0] + P8*isf2[0]) * QENS_delta(X, 1.0, 0.0, P3, 1.0) ;delta (area=1, DW=0, position, fraction=1)
  ;quasielastic terms for first type of jumps
  for isite=1, nsites1-1 do begin
    Y += P4 * isf1[isite] * strnormLorentz(X, P3, hwhm1[isite])
  endfor
  ;quasielastic terms for second type of jumps
  for isite=1, nsites2-1 do begin
    Y += P8 * isf2[isite] * strnormLorentz(X, P3, hwhm2[isite])
  endfor
  
  ;scaling x participation ratio & DW
  Y *= P1
  if P2 gt 0. then Y *= EXP((-P2*Qcurrent1D^2/3.)>(-70.))

  return, Y

end


function QENS_Fixed_JumpsNsitesLogNormDist, X, P1, P2, P3, P4, P5, P6, P7, P8
  ;+
  ;********************************************************
  ;** Model of jumps between N equivalent sites in a circle
  ;** with a log-norm distribution of relaxation times
  ;** Ref. A. Chaid et al., Macromolecules 27, 3282 (1994)
  ;**
  ;** Parameters:
  ;**   P1 = Scaling factor
  ;**   P2 = u^2 for DW term
  ;**   P3 = Center
  ;**   P4 = Fraction of fixed atoms
  ;**   P5 = number of sites (integer)
  ;**   P6 = radius of the circle
  ;**   P7 = average residence time on a site
  ;**   P8 = sigma of the log-norm distribution
  ;-

  common c_str_fitqens, func_resol, Qcurrent1D, Qcurrent2D, mig2, mig3, mig4, mig5

  nsites = fix(P5)>2  ;minimum is 2 sites
  ivector=findgen(nsites) & j0 = fltarr(nsites) & isf = fltarr(nsites)
  qrjump = 2.0 * P6 * sin(ivector*!pi/nsites) * Qcurrent1D                    ;Q*r_i
  hwhm   = (2.0/P7) * (sin(ivector*!pi/nsites))^2                             ;Gamma_i
  j0[0] = 1.0 & j0[1:nsites-1] = sin(qrjump[1:nsites-1]) / qrjump[1:nsites-1] ;first spherical bessel function
  for isite=0, nsites-1 do begin
    for jsite=0, nsites-1 do begin
      isf[isite] += j0[jsite] * cos(2.0*isite*jsite*!pi/nsites)
    endfor
    isf[isite] /= nsites
  endfor

  ;elastic term (EISF)
  Y = (P4 + (1-P4)*isf[0]) * QENS_delta(X, 1.0, 0.0, P3, 1.0) ;delta (area=1, DW=0, position, fraction=1)

  ;log-norm distribution --> described by 2*nmax+1 points = 2*nmax+1 lorentzian functions
  nmax = 10                                 ;number of lorentzians used in distribution is 2*nmax+1
  lowlim = 0.1                              ;lower value of gi/max(gi) to be used
  range = P8*sqrt(-2.0*alog(lowlim))        ;max (absolute) value of log(x) range to explore
  dr = range/float(nmax)
  ratio = exp(findgen(2*nmax+1)*dr - range) ;vector of gamma_i / gamma_average values to use
  gi = exp(-0.5*alog(ratio)^2/P8^2)         ;distribution of weights
  gi /= total(gi)                           ;normalize so sum gi = 1
  hi = fltarr(nsites,2*nmax+1)              ;distribution of hwhm for each jumping distance
  for isite=0, nsites-1 do hi[isite,*] = hwhm[isite] * ratio  ;corresponding hwhm for each gi and jumping distance

  ;quasielastic terms
  for ilor=0, 2*nmax do begin
    for isite=1, nsites-1 do begin
      Y += (1-P4) * isf[isite] * gi[ilor] * strnormLorentz(X, P3, hi[isite,ilor])
    endfor
  endfor

  ;scaling x participation ratio & DW
  Y *= P1
  if P2 gt 0. then Y *= EXP((-P2*Qcurrent1D^2/3.)>(-70.))

  return, Y

end


function QENS_Mix1, X, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10, P11, P12
  ;+
  ;******************************************************************************
  ;** Delta + 
  ;** Jump Translation Diffusion + 
  ;** Localized Diffusion (Gaussian model from Volino) + 
  ;** Isotropic Rotation
  ;**
  ;**   This assumes 4 independent populations, each contributing to
  ;**   a single type of motion. However there is no way to ensure
  ;**   that P4+P5+P8 < 1, so the fit can go to non-physical values
  ;**   such that the fraction for the last component 1-P4-P5-P8 < 0.
  ;**
  ;**   As the position of the delta can be between two energy values,
  ;**   the intensity of the delta is shared into 2 deltas placed at those two energies.
  ;**
  ;** Parameters:
  ;**   P1  = Scaling factor
  ;**   P2  = u^2 for DW term
  ;**   P3  = Center
  ;**   P4  = Fraction of atoms contributing to delta
  ;**   P5  = Fraction of atoms contributing to 1st lorentzian (jump translational diff)
  ;**   P6  = D (self-diffusion coefficient in A^2*meV) for 1st lorentzian
  ;**   P7  = Residence time (meV^-1) for 1st lorentzian
  ;**   P8  = Fraction of atoms contributing to 2nd lorentzian (Volino's model for localized diff)
  ;**   P9  = D (self-diffusion coefficient in A^2*meV) for 2nd lorentzian
  ;**   P10  = Variance <ux^2> in Volino's model for 2nd lorentzian
  ;**   P11 = Radius of the sphere for the isotropic rotation for 3rd lorentzian
  ;**   P12 = Rotational diffusion constant (meV) for 3rd lorentzian
  ;-

  common c_str_fitqens, func_resol, Qcurrent1D, Qcurrent2D, mig2, mig3, mig4, mig5

  nmax1 = 100 ;number of lorentzians to use in sum of localized diff part (theoretically is infinite)
  nmax2 = 10  ;number of lorentzians to use in sum of rotational part (theoretically is infinite)

  Y = QENS_delta(X, 1.0, 0.0, P3, P4) ;delta (area=1, DW=0, position, fraction=P4)

  ;first jump diffusion lorentzian
  hwhm1 = P6 * Qcurrent1D^2 / (1.0 + P7 * P6 * Qcurrent1D^2)
  Y += P5 * strnormLorentz(X, P3, hwhm1)
  
  ;second localized lorentzian
  al = fltarr(nmax1+1) & hwhm2 = fltarr(nmax1+1)
  arg = double(Qcurrent1D^2 * P10)
  exparg = EXP((-arg)>(-70.))
  ;elastic term
  if arg gt 0.0 then al[0] = exparg else al[0]=1.0
  ;quasielastic terms
  for i = 1, nmax1 do begin
    if arg gt 0.0 then begin
      al[i] = exparg*(arg^i)/factorial(i)
      hwhm2[i] = i*P9/P10
    endif else al[i]=0.0
  endfor
  ;elastic term (EISF)
  Y += P8 * al[0] * QENS_delta(X, 1.0, 0.0, P3, 1.0) ;delta (area=1, DW=0, position, fraction=1)
  ;quasielastic terms
  for i=1, nmax1 do begin
    Y += P8 * al[i] * strnormLorentz(X, P3, hwhm2[i])
  endfor
  
  ;third isotropic rotational lorentzian
  jl = fltarr(nmax2+1) & hwhm3 = fltarr(nmax2+1)
  arg = Qcurrent1D * P11
  ;elastic term
  if arg gt 0.0 then jl[0] = sqrt(!pi/2/arg)*beselj(arg,0.5) else jl[0]=1.0
  ;quasielastic terms
  for i = 1, nmax2 do begin
    if arg gt 0.0 then jl[i] = sqrt(!pi/2/arg)*beselj(arg,i+0.5) else jl[i]=0.0
    hwhm3[i] = i * (i+1) * P12
  endfor
  jl2 = jl^2
  ;elastic term (EISF)
  Y += (1-P4-P5-P8) * jl2[0] * QENS_delta(X, 1.0, 0.0, P3, 1.0) ;delta (area=1, DW=0, position, fraction=1)
  ;quasielastic terms
  for i=1, nmax2 do begin
    Y += (1-P4-P5-P8) * (2*i+1) * jl2[i] * strnormLorentz(X, P3, hwhm3[i])
  endfor
  
  ;scaling & DW
  Y *= P1
  if P2 gt 0. then Y *= EXP((-P2*Qcurrent1D^2/3.)>(-70.))

  return, Y

end

;
;;End QENS functions
;******************************************************************************


;===============================================================================
FUNCTION strGAUSS,X,p1,p2,p3 & str_Gauss, X,[p1,p2,p3,0.],Y
;******* ********
;** Gaussian function
return,Y & end
;===============================================================================
PRO str_Gauss, X, A, F, PDER                                    ; ==============
;+
;** *********
;** Gaussians procedure
;** A(0)=height A(1)=position A(2)=width
;** A(3)=flat_background
;** A(4)=slope or func_bkgd factor
;** A(5)=quadratic_background
;-
common c_str_fit, fpsd ,func_bkgd ,func_conv ,crr, UserModl ,D_bal

di_Inst_Dreso,'',geta=acti ; acti=1 means ***we have a X dependent instrument resolution function***

NAA   =n_elements(A)
NXX   =n_elements(X)
ns    =long((NAA-1)/3) ;Number of functions
N_npar=n_params()
if N_npar eq 4 then if n_elements(PDER) eq NXX*NAA then PDER=reform(PDER,NXX,NAA)+1.e15 else PDER=dblarr(NXX,NAA)+1.e15

   NBal=n_elements(D_bal)
if NBAL gt 1 then begin ;Check for elastic position channel width
   idxa=where(X lt 0.) & if idxa[0] ge 0 then idxa=max(X[idxa]) else NBal=0
   idxb=where(X gt 0.) & if idxb[0] ge 0 then idxb=min(X[idxb]) else NBal=0 & idxab=idxb-idxa
endif

F    =X*0. & FFs=0. & zs=0. & z2s=0. & ezs=0.
b    =4.*alog(2.)                             ;b=0.5 using width(sigma)
for k=0,ns-1 do begin & ks=k*3

 ;***THE FUNCTION
  if acti then begin & kpX=X & di_Inst_Dreso,'getx' ,GetX=X  & endif ;Instrument Resolution  X  with DX's
  xvt=X-A[ks+1]
  if  A[ks+2] ne 0. then z=xvt/A[ks+2] else z=X*0.+50.
  z2 =z^2 & ez =exp((-b*z2)>(-70.)) & FF =A[ks]*ez
  if acti then begin & X=kpX & di_Inst_Dreso,'gety' ,GetY=FF & endif ;Instrument Resolution: FF convoluted
 ;***

  if NBal gt 1 then begin                            ;Detailed balance factor (symetric function)
     if abs(A[ks+1]) gt idxab then begin
        xvts=X+A[ks+1]
        if  A[ks+2] ne 0. then zs=xvts/A[ks+2] else zs=X*0.+50.
        z2s =zs^2 & ezs =exp((-b*z2s)>(-70.)) & FFs =A[ks]*ezs
     endif else FFs=0.
  endif
  if N_npar eq 4  then begin                         ;% derivatives
     if acti then begin & xvt=X-A[ks+1] & if  A[ks+2] ne 0. then z=xvt/A[ks+2] else z=X*0.+50. ;must redo FF with initial X
                        z2 =z^2 & ez =exp((-b*z2)>(-70.)) & FF =A[ks]*ez &  endif
     if A[ks+2] ne 0. then $
     PDER[*,ks+1]=2.*b/A[ks+2]*(FF*z -FFs*zs) *D_bal ;% posit
     if A[ks+2] ne 0. then $
     PDER[*,ks+2]=2.*b/A[ks+2]*(FF*z2+FFs*z2s)*D_bal ;% width
     PDER[*,ks+0]=(ez +ezs)                   *D_bal ;% height
  endif

  F  =temporary(F) +(FF+FFs)*D_bal
endfor

npar =NAA-ns*3+3                    ;>4->linear  >5->quadratic
nk   =(ns-1)*3
if N_npar eq 4 then begin                       ;% derivatives
    PDER[*,nk+3]=1.                                           ;% constant
    if npar gt 4 then if n_elements(func_bkgd) gt 1 $
                 then PDER[*,nk+4]=func_bkgd $                ;% func_bkgd factor
                 else PDER[*,nk+4]=X                          ;% linear
    if npar gt 5 then PDER[*,nk+5]=X^2                        ;% quadratic
endif

if n_elements(func_conv) ge 3 then begin & F =di_conv(F,func_conv)
   if N_npar  eq 4  then    for k=0,nk+2 do PDER[*,k]=di_conv(PDER[*,k],func_conv)
   if n_elements(crr) eq 1 then if crr eq 1 then F = abs(F)
endif

F=temporary(F) + A[nk+3] ;Backgrounds
if npar gt 4 then if n_elements(func_bkgd) gt 1 $
             then F=temporary(F) + A[nk+4]* func_bkgd $
             else F=temporary(F) + A[nk+4]*X
if npar gt 5 then F=temporary(F) + A[nk+5]*X^2
end

;===============================================================================
FUNCTION strDELTA,X,p1,p2,p3 & str_Delta, X,[p1,p2,p3,0.],Y
;******* ********
;** Delta function
return,Y & end
;===============================================================================
PRO str_Delta, X, A, F, PDER ;same as str_Gauss but ignore Detail_balance ; ====
;+
;** *********
;** Delta procedure
; A(0)=height A(1)=position A(2)=width
; A(3)=flat_background
; A(4)=slope or func_bkgd factor
; A(5)=quadratic_background
;-
common c_str_fit, fpsd ,func_bkgd ,func_conv ,crr, UserModl ,D_bal

NAA   =n_elements(A)
NXX   =n_elements(X)
ns    =long((NAA-1)/3) ;Number of functions
N_npar=n_params()
if N_npar eq 4 then if n_elements(PDER) eq NXX*NAA then PDER=reform(PDER,NXX,NAA)+1.e15 else PDER=dblarr(NXX,NAA)+1.e15

F    =X*0. & FFs=0. & zs=0. & z2s=0. & ezs=0.
b    =4.*alog(2.)                             ;b=0.5 using width(sigma)
for k=0,ns-1 do begin & ks=k*3

 ;***THE FUNCTION
  xvt=X-A[ks+1]
  if  A[ks+2] ne 0. then z=xvt/A[ks+2] else z=X*0.+50.
  z2 =z^2 & ez =exp((-b*z2)>(-70.)) & FF =A[ks]*ez
 ;***

  if N_npar eq 4      then begin                     ;% derivatives
     if A[ks+2] ne 0. then $
     PDER[*,ks+1]=2.*b/A[ks+2]*(FF*z -FFs*zs)        ;% posit
     if A[ks+2] ne 0. then $
     PDER[*,ks+2]=2.*b/A[ks+2]*(FF*z2+FFs*z2s)       ;% width
     PDER[*,ks+0]=(ez +ezs)                          ;% height
  endif
  F  =temporary(F) +(FF+FFs)
endfor

npar =NAA-ns*3+3                    ;>4->linear  >5->quadratic
nk   =(ns-1)*3
if N_npar eq 4 then begin                       ;% derivatives
    PDER[*,nk+3]=1.                                           ;% constant
    if npar gt 4 then if n_elements(func_bkgd) gt 1 $
                 then PDER[*,nk+4]=func_bkgd $                ;% func_bkgd factor
                 else PDER[*,nk+4]=X                          ;% linear
    if npar gt 5 then PDER[*,nk+5]=X^2                        ;% quadratic
endif

if n_elements(func_conv) eq 3 then begin &        F        =di_conv(F        ,func_conv)
   if N_npar      eq 4  then    for k=0,nk+2 do PDER[*,k]=di_conv(PDER[*,k],func_conv)
   if n_elements(crr) eq 1 then if crr eq 1 then F = abs(F)
endif

F=temporary(F) + A[nk+3] ;Backgrounds
if npar gt 4 then if n_elements(func_bkgd) gt 1 $
             then F=temporary(F) + A[nk+4]* func_bkgd $
             else F=temporary(F) + A[nk+4]*X
if npar gt 5 then F=temporary(F) + A[nk+5]*X^2
end


;===============================================================================
FUNCTION strLORENTZ,X,p1,p2,p3,norm=norm & str_Lorentz, X,[p1,p2,p3,0.],Y
;******* **********
;** Lorentzian function
return,Y & end
;===============================================================================
PRO str_Lorentz, X, A, F, PDER                                  ; ==============
;+
;** ***********
;** Lorentzians procedure
;** A(0)=height A(1)=position A(2)=width
;** A(3)=flat_background
;** A(4)=slope or func_bkgd factor
;** A(5)=quadratic_background
;-
common c_str_fit, fpsd ,func_bkgd ,func_conv ,crr, UserModl ,D_bal

di_Inst_Dreso,'',geta=acti ; acti=1 means ***we have a X dependent instrument resolution function***

NAA   =n_elements(A)
NXX   =n_elements(X)
ns    =long((NAA-1)/3) ;Number of functions
N_npar=n_params()
if N_npar eq 4 then if n_elements(PDER) eq NXX*NAA then PDER=reform(PDER,NXX,NAA)+1.e15 else PDER=dblarr(NXX,NAA)+1.e15

   NBal=n_elements(D_bal)
if NBAL gt 1 then begin ;Check for elastic position channel width
   idxa=where(X lt 0.) & if idxa[0] ge 0 then idxa=max(X[idxa]) else NBal=0
   idxb=where(X gt 0.) & if idxb[0] ge 0 then idxb=min(X[idxb]) else NBal=0 & idxab=idxb-idxa
endif

F    =X*0. & FFs=0. & xvts=0.
for k=0,ns-1 do begin & ks=k*3

 ;***THE FUNCTION
  if acti then begin & kpX=X & di_Inst_Dreso,'getx' ,GetX=X  & endif ;Instrument Resolution  X  with DX's
  xvt=X-A[ks+1]
  if A[ks+2] ne 0. then Den =1.+4.*(xvt/A[ks+2])^2 else Den=0.
  if A[ks+2] ne 0. then FF  =A[ks]/Den             else FF =X*0.
  if acti then begin & X=kpX & di_Inst_Dreso,'gety' ,GetY=FF & endif ;Instrument Resolution: FF convoluted
 ;***

  if NBal gt 1 then begin                                          ;Detailed balance factor (symetric function)
     if abs(A[ks+1]) gt idxab then begin
        xvts=X+A[ks+1]
        if A[ks+2] ne 0. then Dens=1.+4.*(xvts/A[ks+2])^2 else Dens=0.
        if A[ks+2] ne 0. then FFs =A[ks]/Dens             else FFs=X*0.
     endif else FFs=0.
  endif
  if N_npar     eq 4  then begin                                        ;% derivatives
   if acti then begin & xvt=X-A[ks+1] & if A[ks+2] ne 0. then Den =1.+4.*(xvt/A[ks+2])^2 else Den=0. ;must redo FF with initial X
                      if A[ks+2] ne 0. then FF  =A[ks]/Den else FF =X*0. &  endif
   if Den[0]*A[ks] ne 0. then begin
    PDER[*,ks+1]=2.*4./A[ks]/A[ks+2]^2 * (xvt*FF^2 - xvts*FFs^2) *D_bal ;% posit
    PDER[*,ks+2]=2.*4./A[ks]/A[ks+2]^3 *((xvt*FF)^2+(xvts*FFs)^2)*D_bal ;% width
   endif
   if A[ks] ne 0. then PDER[*,ks+0]=(FF + FFs)/A[ks]             *D_bal ;% height
  endif

  F  =temporary(F)+(FF+FFs)*D_bal
endfor

npar =NAA-ns*3+3                    ;>4->linear  >5->quadratic
nk   =(ns-1)*3
if N_npar   eq 4 then begin                     ;% derivatives
    PDER[*,nk+3]=1.                                           ;% constant
    if npar gt 4 then if n_elements(func_bkgd) gt 1 $
                 then PDER[*,nk+4]=func_bkgd $                ;% func_bkgd factor
                 else PDER[*,nk+4]=X                          ;% linear
    if npar gt 5 then PDER[*,nk+5]=X^2                        ;% quadratic
endif

if n_elements(func_conv) ge 3 then begin & F =di_conv(F,func_conv)
   if N_npar      eq 4  then    for k=0,nk+2 do PDER[*,k]=di_conv(PDER[*,k],func_conv)
   if n_elements(crr) eq 1 then if crr eq 1 then F = abs(F)
endif

F=temporary(F)+ A[nk+3] ;Backgrounds
if npar gt 4 then if n_elements(func_bkgd) gt 1 $
             then F=temporary(F)+ A[nk+4]* func_bkgd $
             else F=temporary(F)+ A[nk+4]*X
if npar gt 5 then F=temporary(F)+ A[nk+5]*X^2
end

;===============================================================================
FUNCTION strPSEUDO,X,p1,p2,p3,P4 & str_Pseudo, X,[p4,p1,p2,p3,0.],Y
;******* *********
;** Pseudo Voigt function
return,Y & end
;===============================================================================
PRO str_Pseudo, X, AA, F, PDER                                 ; ==============
;+
;** **********
;** Pseudo Voigt procedure
;** AA(0)=fractional pseudo parameter if not fixed
;** A(0)=height A(1)=position A(2)=width
;** A(3)=flat_background
;** A(4)=slope or func_bkgd factor
;** A(5)=quadratic_background
;-
common c_str_fit, fpsd ,func_bkgd ,func_conv ,crr, UserModl ,D_bal ; fpsd=fractional pseudo parameter if fixed

if n_elements(fpsd) eq 0 then np=4 else if fpsd[0] eq -1 then np=4 else np=3
ns  =long((n_elements(AA)-1)/np)  ;Number of functions

if np eq 3 then begin & fixed=1 & frac=fltarr(ns)+fpsd & A=AA       & endif $
           else begin & fixed=0 & frac=AA[0:ns-1]      & A=AA[ns:*] & endelse

NAA   =n_elements(A)
NXX   =n_elements(X)
N_npar=n_params()
if N_npar eq 4 then if n_elements(PDER) eq NXX*NAA then PDER=reform(PDER,NXX,NAA)+1.e15 else PDER=dblarr(NXX,NAA)+1.e15
if not fixed   then $
if N_npar eq 4 then PDOR =dblarr(NXX,ns)            ; define partial_deriv array for PVf
F    =X*0.

for k=0,ns-1 do begin & ks=k*3
  U=[A[ks:ks+2],0.]                     ; note that background is not passed
  if N_npar eq 4 then str_Gauss  ,X,U,gF,gPDER else str_Gauss  ,X,U,gF
  if N_npar eq 4 then str_Lorentz,X,U,lF,lPDER else str_Lorentz,X,U,lF

  F= F+ (frac[k]*lF + (1.-frac[k])*gF)
  if N_npar eq 4 then begin
     PDER[*,ks:ks+2]=    frac[k] *lPDER[*,0:2]
     PDER[*,ks:ks+2]=(1.-frac[k])*gPDER[*,0:2] + PDER[*,ks:ks+2]
     if not fixed then PDOR[*,k]= lF-gF
  endif
endfor

npar =NAA-ns*3+3                    ;>4->linear  >5->quadratic
nk   =(ns-1)*3
if N_npar   eq 4 then begin                     ;% derivatives
    PDER[*,nk+3]=1.                                           ;% constant
    if npar gt 4 then if n_elements(func_bkgd) gt 1 $
                 then PDER[*,nk+4]=func_bkgd $                ;% func_bkgd factor
                 else PDER[*,nk+4]=X                          ;% linear
    if npar gt 5 then PDER[*,nk+5]=X^2                        ;% quadratic
    if not fixed then PDER=[[PDOR],[PDER]]
endif

F=F+ A[nk+3] ;Backgrounds
if npar gt 4 then if n_elements(func_bkgd) gt 1 $
             then F=F+ A[nk+4]* func_bkgd $
             else F=F+ A[nk+4]*X
if npar gt 5 then F=F+ A[nk+5]*X^2
end

;===============================================================================
PRO str_exec_UModl, npmnpm, formula, XXX, AAA, Y, name, PDER
;+
;** **************
;** execute the user model formula
;** treat also Sans dispersity as instrument sigma Q resolution
;-

di_Inst_Dreso,'',geta=acti ; acti=1 means ***we have a X dependent instrument resolution function***

X=XXX & okdisp=0 ;prevent from X modifications in formula

for j=0,npmnpm-1 do iii=execute('p'+s4v(j+1)+'=AAA[j]') ;put parameters in formula

;SPECIAL FUNCTIONS having Poly_dispersity
;****************************************
case name of
'SANS_Sphere':  if n_elements(AAA) ge 3 then if AAA[2] gt 0. then begin            ;Poly_dispersity convolution R1
                  ;A0=P1.density , A1=P2.R1 , A2=P3.dR
                   rrr=0.  &  p_1='p2' & p_a1=1
                   di_Inst_Dreso,'Rdisp',Rdisp=[AAA[1],AAA[2]], Kdisp=Kdisp, Rbdisp=Rbdisp
                   if n_elements(Kdisp) gt 1 then okdisp=1
                endif
'SANS_H_Sphere':if n_elements(AAA) ge 5 then if AAA[4] gt 0. then begin            ;Poly_dispersity convolution R1,R2
                  ;A0=P1.density , A1=P2.R1 , A2=P3.R2 , A3=P4.Mu , A4=P5.dR
                   rrr=(AAA[1]-AAA[2])/2.  &  p_1='p2'  &  p_2='p3' & p_a1=1 & p_a2=2
                   di_Inst_Dreso,'Rdisp',Rdisp=[(AAA[1]+AAA[2])/2.,AAA[4]], Kdisp=Kdisp, Rbdisp=Rbdisp
                   if n_elements(Kdisp) gt 1 then okdisp=1
                endif
'SANS_ELLIPSOID':if n_elements(AAA) ge 4 then if AAA[3] gt 0. then begin           ;Poly_dispersity convolution Rb
                  ;A0=P1.density , A1=P2.Radius , A2=P3.Ra/Rb , A3=P4.dR
                   rrr=0.  &  p_1='p2' & p_a1=1
                   di_Inst_Dreso,'Rdisp',Rdisp=[AAA[1],AAA[3]], Kdisp=Kdisp, Rbdisp=Rbdisp
                   if n_elements(Kdisp) gt 1 then okdisp=1
                endif
'SANS_STAR_Polymer':if n_elements(AAA) ge 4 then if AAA[3] gt 0. then begin        ;Poly_dispersity convolution Rg
                  ;A0=P1.scale , A1=P2.Rg , A2=P3.arms , A3=P4.dR
                   rrr=0.  &  p_1='p2' & p_a1=1
                   di_Inst_Dreso,'Rdisp',Rdisp=[AAA[1],AAA[3]], Kdisp=Kdisp, Rbdisp=Rbdisp
                   if n_elements(Kdisp) gt 1 then okdisp=1
                endif
'SANS_STAR_PolyPoly':if n_elements(AAA) ge 4 then if AAA[3] gt 0. then begin       ;Poly_dispersity convolution Rg
                  ;A0=P1.scale , A1=P2.Rg , A2=P3.arms , A3=P4.dR
                   rrr=0.  &  p_1='p2' & p_a1=1
                   di_Inst_Dreso,'Rdisp',Rdisp=[AAA[1],AAA[3]], Kdisp=Kdisp, Rbdisp=Rbdisp
                   if n_elements(Kdisp) gt 1 then okdisp=1
                endif
'SANS_DISK':    if n_elements(AAA) ge 3 then if AAA[2] gt 0. then begin            ;Poly_dispersity convolution R1
                  ;A0=P1.density , A1=P2.R1 , A2=P3.dR
                   rrr=0.  &  p_1='p2' & p_a1=1
                   di_Inst_Dreso,'Rdisp',Rdisp=[AAA[1],AAA[2]], Kdisp=Kdisp, Rbdisp=Rbdisp
                   if n_elements(Kdisp) gt 1 then okdisp=1
                endif
'SANS_ROD':     if n_elements(AAA) ge 3 then if AAA[2] gt 0. then begin            ;Poly_dispersity convolution L
                  ;A0=P1.density , A1=P2.R1 , A2=P3.dR
                   rrr=0.  &  p_1='p2' & p_a1=1
                   di_Inst_Dreso,'Rdisp',Rdisp=[AAA[1],AAA[2]], Kdisp=Kdisp, Rbdisp=Rbdisp
                   if n_elements(Kdisp) gt 1 then okdisp=1
                endif
'SANS_Bilayer_VESICLE': if n_elements(AAA) ge 7 then if AAA[6] gt 0. then begin    ;Poly_dispersity convolution Inner Radius
                  ;A0=Radius ... A6=P7.dR
                   rrr=0.  &  p_1='p1' & p_a1=0
                   di_Inst_Dreso,'Rdisp',Rdisp=[AAA[0],AAA[6]], Kdisp=Kdisp, Rbdisp=Rbdisp
                   if n_elements(Kdisp) gt 1 then okdisp=1
                endif
'SANS_Sphere_SHELL': if n_elements(AAA) ge 8 then if AAA[7] gt 0. then begin       ;Poly_dispersity convolution Inner Radius
                  ;A0=Radius ... A7=P8.dR
                   rrr=0.  &  p_1='p1' & p_a1=0
                   di_Inst_Dreso,'Rdisp',Rdisp=[AAA[0],AAA[7]], Kdisp=Kdisp, Rbdisp=Rbdisp
                   if n_elements(Kdisp) gt 1 then okdisp=1
                endif
'SANS_Multi_Lam_VESICLE':if n_elements(AAA) ge 8 then if AAA[7] gt 0. then begin   ;Poly_dispersity convolution Tickness Solv.
                  ;A0=P1.RSin , A1=P2.ThS , A2=P3.ThL ... A6=P7.dRin unused!!! , A7=P8.dRts
                   rrr=0.  &  p_1='p2' & p_a1=1
                   di_Inst_Dreso,'Rdisp',Rdisp=[AAA[1],AAA[7]], Kdisp=Kdisp, Rbdisp=Rbdisp
                   if n_elements(Kdisp) gt 1 then okdisp=1
                endif

else:
endcase
;***************** END SPECIAL FUNCTIONS

 ;***THE FUNCTION
  if acti then di_Inst_Dreso,'getx' ,GetX=X  ;Instrument Resolution  X  with DX's

  if okdisp then begin & YYY=0. & for jjj=0,n_elements(Kdisp)-1 do begin
                                    if rrr eq 0. then iii=execute(p_1+'=Rbdisp[jjj]') $           ;Put Rays in formula R1
                                    else iii=execute(p_1+'=Rbdisp[jjj]+rrr & '+p_2+'=Rbdisp[jjj]-rrr')   ;          R1,R2
                                    iii=execute(formula)                                          ;Get Y
                                   ;********************
                                    YYY=YYY+Y*Kdisp[jjj] & endfor                                 ;Weighting
                                Y=YYY
                                ii=execute(p_1+'=AAA[p_a1]')                                      ;Reset parameter value
                                if rrr ne 0. then ii=execute(p_2+'=AAA[p_a2]')
  endif else iii=execute(formula)
            ;********************
  if acti then di_Inst_Dreso,'gety' ,GetY=Y  ;Instrument Resolution: Y is convoluted
 ;*******

if n_params() eq 7 then begin & resres=machar() & epseps=sqrt(resres.eps)
   if acti then begin & X=XXX & iii=execute(formula) & endif
   Yfit=Y
   NXX =n_elements(XXX)
   if n_elements(PDER) eq NXX*npmnpm then PDER=reform(PDER,NXX,npmnpm) else PDER=dblarr(NXX,npmnpm)
   for jjj=0,npmnpm-1 do begin & js=s4v(jjj+1)
       ii=execute('incinc = epseps * abs(p'+js+')') & if incinc eq 0. then incinc=epseps
       ii=execute('p'+js+'=p'+js+'+incinc')         & X=XXX & iii=execute(formula)
       pder[0,jjj] = reform(Y-Yfit)/incinc
       ii=execute('p'+js+'=AAA[jjj]')             ; reset parameter value
   endfor
   Y=reform(temporary(Yfit))
endif else $
   Y=reform(temporary(Y))
end

;===============================================================================
PRO str_UserModl, XX, AAA, FF, PPDER                            ; ==============
;+
;** ************
;** dispatch the user model formula
;** A(*)  =parameters of all functions defined in structure UserModl
;** A(*+1)=flat_background
;** A(*+2)=slope or func_bkgd factor
;** A(*+3)=quadratic_background
;-
common c_str_fit, fpsd ,func_bkgd ,func_conv ,crr, UserModl ,D_bal
common c_str_2df, folSpec, folXn, folBo, folXb, KPdim2, KPfct2, folQexp, FitOrNot,bid3,bid4
common c_str_fitqens, func_resol, Qcurrent1D, Qcurrent2D, mig2, mig3, mig4, mig5

AA  =AAA
NAA =n_elements(AA)
NXX =n_elements(XX)
sx  =n_elements(folXn) & na=NAA/folSpec & nn=0 ;(if 2D fit then folSpec>1)

ns  =n_elements(UserModl.name) ;Number of functions
mpm =max(UserModl.npar)
np4 =(n_params() eq 4)
if np4 then if n_elements(PPDER) eq NXX*NAA then PPDER=reform(PPDER,NXX,NAA) else PPDER=dblarr(NXX,NAA)

if n_elements(folQexp) gt 0 then begin & idxq=where(folQexp gt ' ') & P=AA  ;Q expression (partial param fit)
   if idxq[0] ge 0 then for i=0,n_elements(idxq)-1 do ii=execute( 'AA[idxq[i]]='+folQexp[idxq[i]] ) & endif

idxf=where(strlowcase(tag_names(UserModl)) eq 'on')
if idxf[0] ge 0 then Uon=UserModl.On else Uon=lonarr(ns)+1

FOR F2d=0,folSpec-1 do begin ;Loop if 2D fit
;** ***************           **************
 if folSpec  gt 1 then begin & n=abs(folXn[F2d<(sx-1)])
    Qcurrent1D=Qcurrent2D[F2d]  ;For Qens function
    A=AA[F2d*na:(F2d+1)*na-1]   &   X          =XX[nn:nn+n-1] & nn=nn+n
                                   ;X
    if n_elements(KPdim2) gt 1 then kpfunc_conv=KPfct2[0:KPdim2[F2d]-1,F2d] else kpfunc_conv=func_conv ;Resolution
    if n_elements(folXb)  gt 1 then func_bkgd  =folXb[ 0:n-1,F2d]                                ;Background shape
    if n_elements(folBo)  gt 1 then if sx gt 1 then D_bal=folBo[ 0:n-1,F2d]                                  ;Bose

 endif else begin & A=AA & X=XX & kpfunc_conv=func_conv & endelse

 if np4 then PDEV =dblarr(n_elements(X),na)   ; define partial_deriv array
 KPfpsd=fpsd & fpsd=-1                        ; (if pseudo then always in parameter)
 func_resol = kpfunc_conv & func_conv =0      ; (no convolution in sub_functions)
 F     =X*0. & ks=0
 
 FstrF       =F+1.                            ; FstrF is eventually a Structure Factor ';(*)'
 WeHaveFstrF =0

 FOR k=0,ns-1 do if Uon[k] then begin         ; LOOP on functions
;************                                   *****************
  npm=UserModl.npar[k]
  nam=UserModl.name[k]
  kid=indgen(npm)+ks

  case strlowcase(nam) of
  'gauss':   if np4 then str_Gauss  ,X, [A[kid],0.]         , FFF, PDER $
                    else str_Gauss  ,X, [A[kid],0.]         , FFF
                        ;*********
  'delta':   begin
             if np4 then str_Delta  ,X, [A[kid],0.]         , FFF, PDER $
                    else str_Delta  ,X, [A[kid],0.]         , FFF
                        ;*********
             Adelta=A[kid]
             Odelta=FitOrNot[kid]
             Fdelta=FFF             ;Eventualy keep Fdelta to play with
             end
  'lorentz': begin
             if np4 then str_Lorentz,X, [A[kid],0.]         , FFF, PDER $
                    else str_Lorentz,X, [A[kid],0.]         , FFF
                        ;***********
             end
  'voigt':   begin
             if np4 then str_Pseudo ,X, [A[shift(kid,1)],0.], FFF, PDER $
                    else str_Pseudo ,X, [A[shift(kid,1)],0.], FFF
                        ;**********
             if np4 then PDER=PDER[*,[1,2,3,0]] ;pvf position
             end
  else:      if UserModl.formula[k] gt ' ' then begin & Y=F*0.  
             if np4 then str_exec_UModl, npm,UserModl.formula[k], (X), A[kid], Y, nam, PDER $
                    else str_exec_UModl, npm,UserModl.formula[k], (X), A[kid], Y, nam
                        ;**************
             if n_elements(Y) eq 1 then Y=F*0.+Y[0]  ;No result !
             if strpos(UserModl.formula[k],';(*)') gt 1 then begin
                WeHaveFstrF=1
                FstrF=FstrF*Y                        ;We have a structure factor formula
                FFF  =0.
             endif else FFF=Y*D_bal ;'formula'
             endif else FFF=0.
  endcase

  if np4 then PDEV[*,kid]=PDER[*,kid-kid[0]] ;% derivatives for params
  
  F =F+FFF ;ADD each function
            ks=ks+mpm
 endif else ks=ks+mpm
;ENDFOR ns FUNCTIONS

 if WeHaveFstrF then if total(F) eq 0. then F = FstrF else F = F * FstrF  ;In case we have a structure factor
                                                                          ;MULTIPLY (do not ADD)
 func_conv=kpfunc_conv

 npar =n_elements(A)-ks                        ;>1->linear  >2->quadratic
 if np4 then begin                             ;% derivatives for background
    PDEV[*,ks]=1.                                             ;% constant
    if npar gt 1 then if n_elements(func_bkgd) gt 1 $
                 then PDEV[*,ks+1]= func_bkgd $               ;% func_bkgd factor
                 else PDEV[*,ks+1]= X                         ;% linear
    if npar gt 2 then PDEV[*,ks+2]= X^2                       ;% quadratic
 endif


 if n_elements(func_conv) ge 3 then begin
 
    NoGauss=0                                               ; TEST flag
    if (NoGauss) and (n_elements(Fdelta) gt 1) then begin   ; We can place here the resolution function itself,
       if Odelta[2] eq 1 then idx=[-1] else idx= where(X ge Adelta[1]) ; only if Width is fixed and position in X range
       idx=idx[0]
       if idx gt 0 then begin
          decaya=X[idx]-Adelta[1] & decayb=Adelta[1]-X[idx-1]
          if decaya gt decayb then begin & idx=idx-1 & decaya=decayb & endif ; Adjust idx...
          NEfunc=n_elements(func_conv) & mid=(NEfunc)/2     ; Normally NEf  should be odd
          NEa   =(mid-idx) >0
          NEb   =(NEfunc-1)  <(NXX-1-Nea)                   ; was <(NXX-1-idx)!
          height= Adelta[0]/max(func_conv)
          F     = F - Fdelta &   FFF=X*0.                   ; Remove  the gaussian Delta traited before (Fdelta)
          FFF[(idx-mid)>0]=(reverse(func_conv))[NEa:NEb]    ; replaced by the resolution curve 'FFF'
          if decaya gt 0. then FFF=spline(X+decaya , height*FFF , X)          ; in precise position
          F =di_conv(F,func_conv)
          F  =F + FFF
       endif else  F =di_conv(F,func_conv)                  ; else keep convoluted gaussian (position outside Xrange)
    endif else     F =di_conv(F,func_conv)                  ; else keep convoluted gaussian (NoGauss=0)
    if np4 then    for k=0,ks-1 do PDEV[*,k]=di_conv(PDEV[*,k],func_conv)
 endif ;Convolute

 F=F+ A[ks]   ;Backgrounds
 if npar gt 1 then if n_elements(func_bkgd) gt 1 $
              then F=F+ A[ks+1]* func_bkgd $
              else F=F+ A[ks+1]* X
 if npar gt 2 then F=F+ A[ks+2]* X^2

 if F2d eq 0 then FF =F else FF  =[ FF , F ]
 if np4 then if folSpec eq 1 then PPDER=PDEV $
                             else PPDER[nn-n:nn-1,F2d*na:(F2d+1)*na-1]=PDEV
ENDFOR ;folSpec 2D FIT

fpsd=KPfpsd
end

;=============================================================================================
PRO str_Integral, X, A, Data, F_i, D_i, F_a,F_e,S, epsd ,modl,npr,npb ,mfit ,pdelta, Cfunc ;==
;+
;** ************
;** This procedure is called for ONE spectra
;** A(0)=height A(1)=position A(2)=width
;** A(3)=flat_background
;** A(4)=slope or func_bkgd factor
;** A(5)=quadratic_background
;** Data=input spectrum
;** return F_i fit   integral in X range (total)
;** return D_i data  integral in X range (total)
;** return F_a funct integrals theorical        (by functions, classical mod)
;** return F_e funct integrals theorical errors (by functions, classical mod)
;** return mfit      the fit deconvoluted
;** return Cfunc     the fit convoluted to show for each function
;-

common c_str_fit, fpsd ,func_bkgd ,func_conv ,crr, UserModl ,D_bal

di_Inst_Dreso,'',geta=acti ; acti=1 means ***we have a X dependent instrument resolution function***

ns       = n_elements(epsd)      ; Number of functions
nX       = n_elements(X)         ; Number of points
nXu      = nX
nConv    = n_elements(func_conv) ; Convolution kernel
kp_except=!except & !except=0

; Data-background (for integral)
F    =Data-A[ns*npr]
if npb gt 1  then if n_elements(func_bkgd) gt 1 $
             then F=F- A[ns*npr+1]* func_bkgd   $
             else F=F- A[ns*npr+1]*X
if npb gt 2  then F=F- A[ns*npr+2]*X^2

if modl eq 5 then begin
   idxf=where(strlowcase(tag_names(UserModl)) eq 'on')
   if idxf[0] ge 0 then Uon=UserModl.On else Uon=lonarr(ns)+1
   KPm5=UserModl
endif

;To integrate we need a sorted uniq axis
Xunit=abs(X[nX-1]-X[0])/(nX-1)
if X[1]-X[0] eq Xunit then noInT=1 else noInT=0 ; noInt means we have a regular axis
if noInT then begin
  D_i =total(F)*Xunit       ; Input Spectrum Integral
  Xb  =X
endif else begin
  ids =sort(X)  & Xb  = X[ids] & Fb=F[ids]
  Xunq=uniq(Xb) & nXu = n_elements(Xunq)
  if nXu ne nX then begin & Xb=Xb[Xunq] & Fb=Fb[Xunq] & endif
  D_i =int_tabulated(Xb,Fb) ; Input Spectrum Integral
endelse

b    =2.*sqrt(2.*alog(2.)); we use FwMh
F_i  =0.
mfit =X*0.

;Loop over Functions
;*******************
for k=0,ns-1 do begin

 if modl eq 4 then begin & ks=k*2   ;FREE (UnUsed)
 endif else begin
 
  if modl eq 5 then mpm =max(KPm5.npar) else mpm=3
  ks=k*mpm
 ;Next 3 lines just in case we have a classical distribution function
  if mpm ge 3 then begin
   E  =sqrt((A[ks]*S[ks+2])^2 + (A[ks+2]*S[ks])^2)            ;(S(ks)*S(ks+2))^2 is a correlation term to add
   I_G=sqrt(2.*!pi)*A[ks]*A[ks+2]/b   &  G_e=E*sqrt(2.*!pi)/b ; Gaussian theorical integral
   I_L=A[ks]*A[ks+2]*!pi/2.           &  L_e=E*!pi/2.         ; Lorentz  theorical integral
  endif
  
 ;USER MODEL
 ;**********
  if modl eq 5 then begin
   if Uon[k] and (strpos(KPm5.formula[k],';(*)') le 0) then begin ;Do not integrate a Structure Factor
   rpm=KPm5.npar[k]

   if KPm5.formula[k] gt ' ' then $
          UserModl={ON:Uon[k],NAME:KPm5.name[k],NPAR:rpm,FORMULA:KPm5.formula[k]} $
   else   UserModl={ON:Uon[k],NAME:KPm5.name[k],NPAR:rpm}

  ;Sum function in X range   
   str_UserModl,Xb,[A[ks:ks+rpm-1],0.],UF
   if noInT then I_U=total(UF)*Xunit else I_U=int_tabulated(Xb,UF)
   F_i       = I_U + F_i                ; function integral
   
   if not noInT then str_UserModl,X ,[A[ks:ks+rpm-1],0.],UF
   Cfunc[*,k]= UF                       ; convoluted function to show
   
   case strlowcase(KPm5.name[k]) of     ; theorical integral
   'delta':   begin & fpsd[k]=0.          & F_a[k] =I_G  &  F_e[k] =G_e                & end
   'gauss':   begin & fpsd[k]=0.          & F_a[k] =I_G  &  F_e[k] =G_e                & end
   'lorentz': begin & fpsd[k]=1.          & F_a[k] =I_L  &  F_e[k] =L_e                & end
   'voigt':   begin & fpsd[k]=A[ks+3]     & F_a[k] =fpsd[k]*I_L + (1.-fpsd[k])*I_G
                      epsd[k]=S[ks+3]     & F_e[k] =fpsd[k]*L_e + (1.-fpsd[k])*G_e     & end
             ;Not theorical here (unknown formula)
   else:      begin & fpsd[k]=-.0077      & F_a[k] =I_U  &  F_e[k] =0.                 & end
   endcase
   if k eq 0 then pdelta=UF ;!!!
   
  ;Recalculate the deconvoluted model for mfit if we have a resolution
   if (nConv ge 3) or (acti) then begin
      KPfunc_conv=func_conv & func_conv=0 & di_Inst_Dreso,'',active=0    ; fit function deconvoluted
      str_UserModl,X ,[A[ks:ks+rpm-1],0.],UF
      func_conv=KPfunc_conv               & di_Inst_Dreso,'',active=acti
   endif
   
   mfit= temporary(mfit)+ UF ; sum fit function deconvoluted
   
   endif ;Uon(k)
   
 ;CLASSICAL FUNCTIONS integrals
 ;*******************
  endif else begin
   str_Gauss  ,Xb,[A[ks:ks+2],0.],gF
   str_Lorentz,Xb,[A[ks:ks+2],0.],lF
   if noInT then I_Ug=total(gF)*Xunit else I_Ug=int_tabulated(Xb,gF)
   if noInT then I_Ul=total(lF)*Xunit else I_Ul=int_tabulated(Xb,lF)
   F_i    =fpsd[k]*I_Ul + (1.-fpsd[k])*I_Ug + F_i            ; integral (total)
   F_a[k] =fpsd[k]*I_L  + (1.-fpsd[k])*I_G                   ; theorical integral by function
   F_e[k] =fpsd[k]*L_e  + (1.-fpsd[k])*G_e                   ; errors on integral by function

   if not noInT then str_Gauss  ,X ,[A[ks:ks+2],0.],gF
   if not noInT then str_Lorentz,X ,[A[ks:ks+2],0.],lF

   Cfunc[*,k]= fpsd[k]*lF + (1.-fpsd[k])*gF                  ; convoluted function to show

   if k eq 0 then pdelta=fpsd[k]*lF  + (1.-fpsd[k])*gF ;!!!
   
  ;Recalculate the deconvoluted function for mfit if we have a resolution
   if (nConv ge 3) or (acti) then begin
      KPfunc_conv=func_conv & func_conv=0 & di_Inst_Dreso,'',active=0         ; fit function deconvoluted
      str_Gauss  ,X ,[A[ks:ks+2],0.],gF   & str_Lorentz,X ,[A[ks:ks+2],0.],lF
      func_conv  =KPfunc_conv             & di_Inst_Dreso,'',active=acti
   endif
   mfit=temporary(mfit)+ fpsd[k]*lF  + (1.-fpsd[k])*gF ; sum fit function deconvoluted
  endelse
 endelse
endfor
   
if modl eq 5 then UserModl=KPm5

cmm= CHECK_MATH() & !except=kp_except
end

pro str_wks_in_cmd, flaag
;+
;** **************
;** 
;-
@lamp.cbk
if one gt 0 then flaag=1 else flaag=0
end

function str_bose,X,Temperature=T
;+
;******* ********
;** calculate Bose vector
;-
if T le 0. then return,1.
     w_t  =X*11.6045/T
     idx  =where(abs(w_t) gt 5e-5)
     e_w_t=EXP(-w_t>(-70.))
     D_bal=w_t*0.+1.
     if idx[0] ge 0 then D_bal[idx]=w_t[idx]/(1.-e_w_t[idx])
return,D_bal
end

;***************
function str_fit, W_in, file_out, title, bkgd=bb, Xrange=xr,  Pseudo_Voigt=f, Gauss=gau, Lorentz=lor , follow=follow, itmax =itmaxx, $
                  Fout=NOUT, noweight=nowe  , Srange=rsp, num_bkgd=num_bkgd, num_bfix=num_bfix,User_model=User_model,append=append, $
;
                  None=none, Flat=flat, startBG=startBG, Center=center,L_Center=lcenter,U_Center=ucenter,fWmH=fWmH,L_fWmH=lfWmH,U_fWmH=ufWmH,$
                  P2_mod=p2_mod,Pm_Sep=sep2 , C2_mod=c2_mod,C2_Height=ht2,C2_fWmH=fw2,Multi_mod=Mlt_mod,Multi_N=Mlt_N,Multi_U=Mlt_U  , $
                  Multi_fine=Mlt_fine,Multi_fast=Mlt_fWmH,P_extra=p_extra, mpfit=mpf ,debug=debug,stop_id=stop_id,Bose=bose , $
;
                  Res_wks=res_wks, Res_Xin=Res_Xin, Res_Zin=Zres, Res_gau=res_gau, Res_voi=res_voi, Res_pvf=res_pvf, Res_gum=res_gum, Res_spc=res_spc, $
                  Res_xrg=res_xrg, Res_dti=Res_dti, Res_disp=Res_disp, Res_dfit=mfit, Res_interp=interp, Res_filter=Res_flt, fit=wout   , delta=delta, $
;
                  out_subIndex=out_subi , out_subF=out_subF, out_Bkg=out_Bkg, ConvFunc=Cfunc, noTabs=noTab, iniGUI=iniGUI, $
                  ChiRes=ChiRes , ChiMean = ChiMean, $
;
                  Win =wnin, Xin=xin, Yin=yin, ein=ein, sigma=fit_sigmas, Id_Lab=ilab, input_cmd=incmd ;call from a procedure
;+
;******* ********
;** User callable
;** function to read a workspace containing a number of 1D data sets
;** fit the peaks, write (append if /append) the title and fit parameters to file_out
;** and fit_pars to output workspace (return of the function)
;**
;** W_in     =input data (a workspace from a do command else you must use Xin,Yin,Ein)
;** number of background parameters is determined by bb
;**           0=flat, 1=linear, 2=quadratic, 3=none  or  'flat','linear','quadratic','none'
;** startBG  =if flat background and un_fixed this is an initial start
;** Xrange   =[xmin,xmax] (abscissa must be sorted in ascending)
;** Srange   =[first spectrum , last]
;** num_bkgd contains 1D or 2D numerical background shape (same Xsize as W)
;** /num_bfix=if set then do not fit the level of num_bkgd
;** Pseudo_Voigt may contain the fixed factor f*Lorentz + (1-f)Gauss
;** /Gauss   to fit all gaussian
;** /Lorentz to fit all lorentzian
;** follow   to fit next spectra with initial params of previous fitted spectra 1:ascend -1:descending
;** itmax    maximum of fit iterations, default is 100, set to 1 to see initial functions in a user_model
;** User_model is a structure which describes a user specific model or the name of a saved model file.
;** /noweight gives a better ration fit_int/data_int for poor data
;** NOUT is a workspace number which will contain the fitted functions
;** wnin should be a workspace number if W_in is 0
;** xin,yin,ein,fit_sigmas,ilab are used only when call is from a procedure (not from a do cmd)
;** 
;** CONSTRAINTS
;** -----------
;**   Flat     =fixed background
;**   Center   =fixed position
;** L_Center   =lower position
;** U_Center   =upper position
;**   fWmH     =fixed width
;** L_fWmH     =lower width
;** U_fWmH     =upper width
;** 
;** OUTLINE
;** -------
;** /P2_mod     one double peak
;** 
;** /C2_mod     2 centered peaks
;**  C2_Height =initial height of second centered peak
;**  C2_fWmH   =initial width  of second centered peak
;** 
;**  P_extra   =# extra peaks for double/centered outline
;**  Pm_Sep    =double/centered peaks: return splited fit parameters
;** 
;**  Mlt_mod   =multi peak search (resolution is requiered *DECONVOLUTION*)
;**  Mlt_fast  =multi peak medium fWmH (resolution is not requiered)
;**  Mlt_N     =multi peak exact   nb of peaks
;**  Mlt_U     =multi peak maximum nb of peaks
;**  Mlt_fine  =multi peak fine peak search (data quality 1->5)
;** 
;**  Bose      =if >0. this is the temperature(K) for detailed balance factor
;** 
;** RESOLUTION
;** ----------
;** Res_wks    =workspace# or data containing the numerical resolution function
;** Res_xin    =Xresolution if data are passed instead of workspace#
;** Res_zin    =width for each resolution if they are not to be fitted
;** 
;** Res_gau    =width of gaussian resolution to construct
;** Res_gum    =1 or -1 resolution will be an assymetric gaussian, Res_gau must be present
;** Res_voi    =width of voigt    resolution to construct
;** Res_pvf    =factor for the voigt resolution 1 is lorentzian (may be linked with Res_dti)
;** Res_dti    =Delta(Q or Theta) instrumental resolution for each Xin points or workspace#
;**             Res_pvf must be present.
;** Res_disp   =Poly_dispersity function(SANS) 1:Gaussian 2:Log_norm 3:Schultz
;** Res_spc    =spectrum# to take as the resolution
;** Res_xrg    =X range for Res_wks or Res_spc
;** /Res_interp=interpolate the data to a regular grid for convolution
;** /Res_filter do not fit but results of the function are spectra filtered with F(Resolution)
;** 
;** RETURNS
;** -------
;** return of the function is  all fitted parameters       [nspectra , nparams , nfunct]
;** Sigma=Fit_sigmas :return err for all fitted parameters [nspectra , nparams , nfunct]
;** 
;** Res_dfit=mfit    :return filtered fit (no background,[deconvoluted])
;** Fit=Wout         :return fitted spectra (+background,[  convoluted])
;** Fout=Nout        :return fitted spectra in Wrks number Nout
;** 
;** Convfunc=cfunc   :return convoluted functions
;** Delta=delta      :return delta peak deconvoluted
;** 
;** out_subF   =return fitted  spectra for functions indexed by out_subi [nx , nspectra , nfunct]
;** out_Bkg    =return backgrd spectra for functions indexed by out_subi [nx , nspectra]
;**
;** ChiRes     =return Chi square for all spectra
;** ChiMean    =return mean Chi square value
;-

common c_str_fit, fpsd ,func_bkgd ,func_conv ,crr, UserModl ,D_bal
common c_str_2df, folSpec, folXn, folBo, folXb, KPdim2, KPfct2, folQexp, FitOrNot,bid3,bid4
common c_str_fitqens, func_resol, Qcurrent1D, Qcurrent2D, mig2, mig3, mig4, mig5

if keyword_set(none) then return,1
if n_elements( Wnin) ne 1 then Wnin=0
if n_elements( W_in) le 1 then if Wnin gt 0 then TAKE_W,W_in,W=Wnin $
                               else    begin & str_fit_win, noTabs=notab, iniGUI=iniGUI & return,0 & endelse
sw  =size(W_in)
swww=sw[sw[0]+1]
if sw[0] lt 2 then sw[2]=1
if !version.release gt 5.0 then begin & bopL='p[' & bopR=']' & endif else begin & bopL='p[' & bopR=']' & endelse

func_bkgd=0 & func_conv=0 & func_dti=0 & fpsd=[-1] & UserModl=0 & D_bal=1.
folSpec=1 & folXx=0 & folBo=0 & folXb=0 & KPdim2=0 & folQexp=[''] & FitOrNot=0

;Check for numerical background shape
;************************************
sb= (size(num_bkgd))[0]
if ((size(num_bkgd))[1] eq sw[1]) and (sb ge 1) then begin & nozeros=0
  if sb gt 1 then sb=(size(num_bkgd))[2]
  sf_bkgd=num_bkgd
  if nozeros then begin & id0 =where(sf_bkgd le 0)
     if id0[0] ge 0 then begin & sf_bkgd[id0] =max(sf_bkgd) & minB=  min(sf_bkgd)
                               sf_bkgd[id0] =minB         & endif
  endif
endif else  sb=0

;variables/parameters
;********************
pseudo=0 & npars=4 & oklab=0 & it=0 & maystop=0 & toti=0 & delta=0
if not keyword_set(debug) then debug=0
if n_elements(mpf)  ne 1  then mpf  =0
if sb gt 0  then npars=5  else $
if n_elements(flat) ne 1  then $
if n_elements(bb) eq 1 then begin & b=bb
   if (size(b))[1] eq 7 then begin & b=strlowcase(strmid(b,0,4))
       if (b eq 'flat') or (b eq '0') then b=0   else $
       if (b eq 'line') or (b eq '1') then b=1   else $
       if (b eq 'quad') or (b eq '2') then b=2   else $
       if (b eq 'none') or (b eq '3') then b=3 & endif
   if b eq 1 then npars=5 else $                                 ; background params
   if b eq 2 then npars=6 else $
   if b eq 3 then flat =0.
endif
if n_elements(f) eq 1 then begin                                 ; prefered function
   frac =f>0.<1.
   if f eq 1 then begin & frac=.5 & pseudo=1 & endif
   if keyword_set(lor) then frac=.8 else if keyword_set(gau) then frac=.2

endif else if keyword_set(lor) then frac=1. else frac=0.       ; default is Gaussian

if  n_elements(ilab)       eq 1 then if ilab    gt 0 then oklab  =1  ; message label
if  n_elements(stop_id)    eq 1 then if stop_id gt 0 then maystop=1 ; interupt id ok
if  n_elements(fit_sigmas) eq 1 then pout=fit_sigmas else pout   =0; output wkspce #
if  n_elements(title)      ne 1 then title =' '
if  n_elements(bose)       ne 1 then bose  =0.
if  n_elements(interp)     ne 1 then interp=0
if  n_elements(itmaxx)     ne 1 then itmax =100 else itmax=itmaxx

if (n_elements(xin) gt 1)  or (Wnin ne 0) then begin & comd=0
   if n_elements(xin)  eq 0 then xin=0                         ; call from a program
   if n_elements(yin)  eq 0 then yin=0                         ; call from a program
   if n_elements(ein)  eq 0 then ein=0
   if Wnin gt 0 then TAKE_DATP,datp,W=Wnin $
   else begin & datp={X:xin,Y:yin,E:ein,N:1,W_TIT:title,X_TIT:'',Y_TIT:'Spectra',PAR_TXT:[' '],OTHER_TIT:'',HISTORY:''}
                 comd=-1  & endelse
endif else begin & comd= 1                                       ; call from Do command
   TAKE_DATP,datp
endelse
if (size(datp.x))[1] ne sw[1] then MOD_DATP,datp,'x',findgen(sw[1])+1.

minix=min(datp.x,max=maxix) & rangex=maxix-minix
miniw=min(W_in  ,max=maxiw) & rangew=maxiw-miniw

if n_elements(res_dti) eq 1 then if res_dti ne 0 then begin             ;Delta(Q or Theta) instrumental resolution for each Xin points
   if res_dti gt 0 then begin
      TAKE_DATP,dtip,W=res_dti & TAKE_W,func_dti,W=res_dti              ;*** Take from a workspace
      if n_elements(dtip.X) gt 1 then   func_dti=INTERPOL(func_dti[*,0],dtip.X[*,0],datp.X[*,0]) ;Interpolate anyway
   endif                         else   func_dti=datp.Z                 ;*** Take from the data (Z)
endif
if n_elements(res_dti)  gt 1 then func_dti=res_dti                      ;*** Take from parameter res_dti
if n_elements(func_dti) ne (size(datp.x))[1] then func_dti=0

if sw[0] eq 2 then nspec=sw[2] else nspec=1 & vspec=nspec     ; dimensions/size of W
frst=0 & lst=nspec-1
if (nspec gt 1) and (n_elements(rsp) eq 2) then begin             ; range of spectra
    frst=(rsp[0]-1)>0<(nspec-1)
    lst =(rsp[1]-1)>0<(nspec-1) & nspec=lst-frst+1
endif

wout      =W_in[*,frst:lst]*0.
mfit      =wout
ddx       =0

;Models
;******
npr =3 ;******* default for Gauss Lorentz pseudo_Voigt ******** (without backgrounds)
npb =npars-3
modl=0 & nk=1 & noderiv=0 ;default is one peak search Model 0
if n_elements( p_extra) eq 1 then p_extra=p_extra>0<2 else p_extra=0

if keyword_set(c2_mod)                         then begin & modl=1 & nk=2+p_extra  & endif ; Centered peaks
if n_elements( ht2)   eq 1 then if ht2   gt 0. then begin & modl=1 & nk=2+p_extra  & endif ; ""
if n_elements( fw2)   eq 1 then if fw2   gt 0. then begin & modl=1 & nk=2+p_extra  & endif ; ""
if keyword_set(p2_mod)                         then begin & modl=2 & nk=2+p_extra  & endif ; Double peak
if n_elements( Mlt_fWmH) eq 1                  then begin & modl=3 & nk=2          & endif ; Multi peaks
if keyword_set(Mlt_mod)                        then begin & modl=3 & nk=2          & endif ; Multi peaks
if n_elements( Mlt_U) eq 1 then if Mlt_U gt 0  then begin & modl=3 & nk=Mlt_U      & endif ; ""
if n_elements( Mlt_N) eq 1 then if Mlt_N gt 0  then begin & modl=3 & nk=Mlt_N      & endif ; ""
if n_elements( MLT_fine) ne 1 then MLT_fine=-1                                           ; ""
if keyword_set(SANS_s)     then begin & npb=1 & sb=0      & modl=4 & nk=1                  ; FREE
                                 myfunc='FREE'   & npr=3  & noderiv=1     & endif
fpsd=frac & epsd=0.
if modl eq 1  then begin & pseudo=0 & frac=.5 & fpsd=fltarr(nk)+1. & fpsd[0]=0. & endif
if frac eq 0. then myfunc='str_Gauss' else if frac eq 1. then myfunc='str_Lorentz' else myfunc=''

if n_elements(User_model) gt 0 then begin                           ;Test if a file_name  or a structure
   if (n_elements(User_model) eq 1) and (n_tags(User_model) eq 0)    then $
                                  str_get_model,User_model,User_modl else User_modl=User_model
endif
OK2dFit=0
if n_tags(User_modl)  gt 1 then  begin &   frac=0         & modl=5 & nk=n_elements(User_modl.name)
                                 myfunc  ='str_UserModl'& npr =max(User_modl.npar)       ; User Model
                                 UserModl=User_Modl
                                 idxb=where(strlowcase(tag_names(UserModl)) eq 'bose')
                                 if idxb[0] ge 0 then bose  =UserModl.Bose
                                 idxf=where(strlowcase(tag_names(UserModl)) eq 'follow')
                                 if idxf[0] ge 0 then follow=UserModl.follow
                                 idxb=where(strlowcase(tag_names(UserModl)) eq 'bkgdfix')
                                 if idxb[0] ge 0 then if UserModl.BKGDfix then flat=UserModl.BKGDvalue

                                 idxq=where(strlowcase(tag_names(UserModl)) eq 'qexp')   ;**************** QEXP ********
                                 if idxq[0] ge 0 then begin
                                 
                                  idxq=where(UserModl.qexp gt ' ')
                                  if idxq[0] ge 0 then begin
                                  
                                     tiepos=lonarr(npr*nk,5,9) ;[NPAR*NFUNC , d=5 , d=9)
                                     
                                     for iq=0,n_elements(idxq)-1 do begin  ; LOOP  OVER QEXPs NOT EMPTY
                                       iqp =idxq[iq]                       ; iqp IS THE QEXP  INDEX
                                       curf=fix(iqp/npr)                   ; curf IS THE FUNCTION 0->n CONTAINING QEXP
                                                                           ; (the default if 'F'  is not found in QEXP)
                                       expr=strlowcase(UserModl.qexp[iqp]) ; PUT QEXP IN expr
                                       ip  =strpos(expr,'(p')
                                       t3  =0
                                       while ip ge 0 do begin              ; LOOP OVER # OF '(Pn)' or '(PnFm)' IN CURRENT QEXP
                                         ik=strpos(expr,')',ip)                      ; We have a tied parameter '(Pn)' or '(PnFm)'
                                         ij=strpos(expr,'f',ip)                      ; so will insert a correct number 'pn'->'p(n-1)'
                                         if (ij gt ip) and (ij lt ik) then $
                                             curf=fix(strmid(expr,ij+1,ik-ij-1))-1 $ ; 'F' is found so CORRECT pn -> 'P[pn]'
                                         else ij=ik
                                         on_ioerror,errwhile & pn=s4v(fix(strmid(expr,ip+2,ij-ip-2))-1+curf*npr)
                                         UserModl.qexp[iqp]=strmid(expr,0,ip+1)+bopL+pn+bopR+strmid(expr,ik,120) ; QEXP is now '(P[pn])'

                                         tiepos[iqp,0,t3]=ip+3        ; 0-> ip+3 is the index of pn in  '(P[pn])'
                                         tiepos[iqp,1,t3]=strlen(pn)  ; 1-> the lenght of pn (1 or 2 rarely 3)
                                         tiepos[iqp,2,t3]=1           ; 2-> 1 means tied parameter
                                         expr=UserModl.qexp[iqp] & ip=strpos(expr,'(p',ip+3) & t3=t3+1 ; INCREMENT T3
                                       endwhile
                                       errwhile:if ip ge 0 then begin & print,UserModl.qexp[iqp] & itmax=1 & endif

                                      ;IN CASE WE HAVE AN ITSELF TIED PARAM
                                       ip=strpos(expr,'[')                     ;We have an itself tied parameter?
                                       if strmid(expr,(ip-1)>0,1) ne 'p' then $
                                       if ip ge 0 then begin 
                                         tiepos[iqp,3,0]=ip                ; 3-> index of '['
                                         tiepos[iqp,4,0]=strpos(expr,']')  ; 4-> index of ']'
                                         tiepos[iqp,2,*]=tiepos[iqp,2,*]+2 ; 2-> new is 2 if ONLY itself tied OR 3 if BOTH
                                         OK2dFit=1 & endif
                                     endfor
                                  endif
                                 endif
                                 
                                 idxq=where(strlowcase(tag_names(UserModl)) eq 'qinf')   ;**************** QINF ** DO AS QEXP
                                 if idxq[0] ge 0 then begin
                                  
                                  idxq=where(UserModl.qinf gt ' ')
                                  if idxq[0] ge 0 then begin
                                   tieinf=lonarr(npr*nk,5,9)
                                   
                                   for iq=0,n_elements(idxq)-1 do begin & iqp=idxq[iq] & curf=fix(iqp/npr)
                                    expr=strlowcase(UserModl.qinf[iqp]) & ip=strpos(expr,'(p')
                                    t3=0
                                    while ip ge 0 do begin
                                       ik=strpos(expr,')',ip) ;We have a tied parameter
                                       ij=strpos(expr,'f',ip) ;so insert a correct number 'pn'->'p(n-1)'
                                       if (ij gt ip) and (ij lt ik) then curf=fix(strmid(expr,ij+1,ik-ij-1))-1 $
                                       else ij=ik
                                       on_ioerror,errwhili & pn=s4v(fix(strmid(expr,ip+2,ij-ip-2))-1+curf*npr)
                                       UserModl.qinf[iqp]=strmid(expr,0,ip+1)+bopL+pn+bopR+strmid(expr,ik,120)
                                       
                                       tieinf[iqp,0,t3]=ip+3        ; 0-> ip+3 is the index of pn in  '(P[pn])'
                                       tieinf[iqp,1,t3]=strlen(pn)  ; 1-> the lenght of pn (1 or 2 rarely 3)
                                       tieinf[iqp,2,t3]=1           ; 2-> 1 means tied parameter
                                       expr=UserModl.qinf[iqp] & ip=strpos(expr,'(p',ip+3) & t3=t3+1
                                    endwhile
                                    errwhili:if ip ge 0 then begin & print,UserModl.qinf[iqp] & itmax=1 & endif
                                   endfor
                                 endif & endif
                                 
                                 idxq=where(strlowcase(tag_names(UserModl)) eq 'qsup')   ;**************** QSUP ** DO AS QEXP
                                 if idxq[0] ge 0 then begin
                                  
                                  idxq=where(UserModl.qsup gt ' ')
                                  if idxq[0] ge 0 then begin
                                   tiesup=lonarr(npr*nk,5,9)
                                   
                                   for iq=0,n_elements(idxq)-1 do begin & iqp=idxq[iq] & curf=fix(iqp/npr)
                                    expr=strlowcase(UserModl.qsup[iqp]) & ip=strpos(expr,'(p')
                                    t3=0
                                    while ip ge 0 do begin
                                       ik=strpos(expr,')',ip) ;We have a tied parameter
                                       ij=strpos(expr,'f',ip) ;so insert a correct number 'pn'->'p(n-1)'
                                       if (ij gt ip) and (ij lt ik) then curf=fix(strmid(expr,ij+1,ik-ij-1))-1 $
                                       else ij=ik
                                       on_ioerror,errwhils & pn=s4v(fix(strmid(expr,ip+2,ij-ip-2))-1+curf*npr)
                                       UserModl.qsup[iqp]=strmid(expr,0,ip+1)+bopL+pn+bopR+strmid(expr,ik,120)
                                       
                                       tiesup[iqp,0,t3]=ip+3        ; 0-> ip+3 is the index of pn in  '(P[pn])'
                                       tiesup[iqp,1,t3]=strlen(pn)  ; 1-> the lenght of pn (1 or 2 rarely 3)
                                       tiesup[iqp,2,t3]=1           ; 2-> 1 means tied parameter
                                       expr=UserModl.qsup[iqp] & ip=strpos(expr,'(p',ip+3) & t3=t3+1
                                    endwhile
                                    errwhils:if ip ge 0 then begin & print,UserModl.qsup[iqp] & itmax=1 & endif
                                   endfor
                                 endif & endif
endif
if  keyword_set(sep2)  or (modl eq 3)   or (modl eq 5) then sep2=1 else sep2=0
if (n_elements(follow) ne 1) or (sw[0]  lt 2) or (modl ne 5) then follow=0
if not OK2dFit then if abs(follow) ge 2 then follow=(follow-2)>(-1)<1         ;Check if 2dFit asked is possible
if  abs(follow) gt 1 then msg='2d fit ' else msg='1d fit '
if  oklab then widget_control,ilab,bad_id=ii,set_value='-> preparing '+msg
Nflat=n_elements(flat)

;Find level for Numerical background
;***********************************
if sb gt 0 then begin & if Nflat eq 1 then bgF=flat else bgf=0.      ; Numerical background  <-----
   levls=fltarr(nspec)+1.
   if not keyword_set(num_bfix) then $
   for ispec=frst,lst do begin
       sf_c=sf_bkgd[*,ispec<(sb-1)] & dt_c=w_in[*,ispec]-bgf
       sf_b=smooth(sf_c,3) & id0 =where( sf_b gt 0.)
       divi=smooth(smooth(dt_c[id0],3)/sf_b[id0],3)                ;spec/shape
       maxd=max(divi,min=mind) & avgd=total(divi)/n_elements(divi) ;sampling
       divb=round(((divi<avgd)-mind)/(avgd-mind)*100.)             ; ""
       his =histogram(divb,min=0,max=99,reverse=idr)               ;density
       bid =max(his[0:30],imax)                                    ;imax
       idi =idr[idr[imax]:idr[imax+1]-1]                           ;index of canditates
       avgf=total(divi[idi])/n_elements(idi)
       ki2 =total((dt_c-sf_c*avgd)^2)*2.                           ;fit in interval [avgf,avgd]
       for r=avgd,avgf,(avgf-avgd)/20. do begin                    ;""
           kk2=total((dt_c-sf_c*r)^2)                              ;""
           if kk2 lt ki2 then begin & levls[ispec-frst]=r & ki2=kk2 & endif
       endfor
   endfor
endif else num_bfix=0

;Check for errors (dont like error=0)
;************************************
me=datp.e & if n_elements(me) ne n_elements(W_in) then begin & me=sqrt(W_in>0.)>1. & nowe=1 & endif
if not keyword_set(nowe) then begin & me=abs(me) &  nowe=0 & nme=n_elements(me)
   id0    =where(me eq 0.) & if id0[0] ge 0  then me[id0]=total(me)/nme
   monitor=round(total((W_in>0.)/me^2)/nme)>1. &  wei=1D/me^2
endif else wei=W_in*0.+1.

;treat Xrange now
;****************
sx=(size(datp.x))[0]  & if sx gt 1 then sx=(size(datp.x))[2]
X =float(datp.x[*,frst<(sx-1)])

;We may have a range per spectrum
if (vspec gt 1) and (n_elements(xr) eq vspec*2) then begin
      if sx eq 1 then begin & Xtmp=congrid([[X],[X]],sw[1],vspec)
                       mod_datp,datp,'X',temporary(Xtmp) & sx =vspec   & endif
      if (size(xr))[1] eq vspec   then begin & xr0=xr[*,0] & xr1=xr[*,1] & endif $
                                  else begin & xr0=xr[0,*] & xr1=xr[1,*] & endelse
endif else if n_elements(xr) eq 2 then begin & xr0=xr[0]   & xr1=xr[1]   & endif $
                                  else begin & xr0=0       & xr1=sw[1]-1 & endelse
szXr0=n_elements(xr0)-1
folXi=lonarr(2,nspec<sx) & folXi[0,*]=reform(xr0[frst<szXr0:lst<szXr0])
                           folXi[1,*]=reform(xr1[frst<szXr0:lst<szXr0])

if n_elements(xr) ge 2  then begin
      Lxr=n_elements(xr0)-1
      for i=frst<(sx-1),lst<(sx-1) do begin & kspec=(i-frst)>0
       idx1=where((datp.X[*,i] ge xr0[i<Lxr]) and (datp.X[*,i] le xr1[i<Lxr]))
       if n_elements(idx1) ge 3 then begin & if kspec eq 0 then begin       ;Instrument resolution X dependent (1D at this time)
                                              if n_elements(func_dti) gt 1 then func_dti=func_dti[idx1]
                                              X=X[idx1] & endif                                        ;(for Xunit evaluation)
                     folXi[0,kspec]=idx1[0] & folXi[1,kspec]=idx1[n_elements(idx1)-1] & endif
      endfor
endif
NXX=n_elements(X) ; ' X ' ,  'X='

;********** ;********** ;********** ;********** ;********** ;**********
;Resolution ;Resolution ;Resolution ;Resolution ;Resolution ;Resolution
;********** ;********** ;********** ;********** ;********** ;**********

resot=0 & resotF=0 & fwdt_conv=1. & nloop=1 & fxreso=0 & rfxwidth=0 & fxwidth=[1.]
if n_elements( res_wks)  eq 1 then if res_wks      gt 0  then begin & resot =1  & endif ; resolution in  workspace
if n_elements( res_wks)  gt 1 then if n_elements(res_xin) gt 1 then resot =1          ; resolution in  res_wks
if n_elements( res_gum)  ne 1 then res_gum=0
if n_elements( res_gau)  eq 1 then if res_gau      gt 0. then begin & resot =2  & endif ; resolution is  gaussian
if n_elements( res_voi)  eq 1 then if res_voi      gt 0. then $
                      if n_elements(  func_dti)    le 1  then $
                      if n_elements(  res_pvf)     eq 1  then begin & resot =3  & endif ; resolution is  p_voigt
if n_elements( res_spc)  eq 1 then if res_spc      ge 1  then begin & resot =4  & endif ; resolution is  in input W
if n_elements( mlt_fwmh) eq 1 then if mlt_fwmh     gt 0  then begin & resotF=1  & endif ; resolution for fast multi search
if  resot gt 0 then resotF=0
;Commented for Miguel
;if  itmax eq 1 then resot =0 ;Show only
if (resot gt 0) or (resotF gt 0) then begin & nloop=2 & noderiv=1
   nex  =n_elements( X)
   XU   =X[uniq(X)]
   nexU =n_elements( XU)
   xdv  =abs( (shift(XU ,-1)-XU)[0:nexU-2])                         ;Calculate current data X_unit
   his  =histogram(xdv ,binsize=min(xdv),reverse=idr)               ; ""
   bin  =n_elements(his)
   bid  =max(his[0:bin/3],imax) & idi=idr[idr[imax]:idr[imax+1]-1]  ; ""
   Xunit=total(xdv[idi])/n_elements(idi)                            ; ""
    ;** Adjustment variables:
    FC=0.00014   ;**Default cutting value factor for normalised resolution (use cut if defined)
    F_=1./1000.  ;**Starting epsilon for CZ calculation (c+|eps)~CZ=|1 (self adjusted)
    if resotF then F_= F_*10.
    LS=10.       ;**Lowest limit factor for maximum/second_maximum in CZ
    ahuit=8.     ;**target width divider (if not |1)
    t2d  =0 & x2d=0
    bgau = 2.*sqrt(2.*alog(2.))/sqrt(!pi*2.)

   if resot gt 0 then if modl eq 1 then fxreso=1 else $    ;**Used to calculate the delta peak width
                      if modl eq 5 then if (where(strlowcase(UserModl.NAME) eq 'delta'))[0] ge 0 then fxreso=1
     ;fxreso if model=1 or Delta function selected
   if fxreso then delta=wout

   KPfpsd=fpsd & KPUserModl=UserModl
   case 1 of
   (resot eq 1) or (resot eq 4):begin
          if resot eq 1 then begin & if n_elements(res_wks) eq 1 then begin & TAKE_DATP,resp,W=res_wks  & Xres=resp.X & Zres=resp.Z
                                                                          TAKE_W   ,Wres,W=res_wks
                                              if fxreso and (n_elements(Wout) eq n_elements(W_in))$
                                              then if (n_elements(Zres) eq nspec) then rfxwidth=1 ;write more
                                              ;Zres comes from didline & fres is fitted
                                   endif else begin & Xres=res_xin & Wres=res_wks & endelse ;Wrkspace <****
          endif         else begin & Wres=W_in[*,res_spc-1] & Xres=float(datp.x)            ;spectrum <****
                                   if (sx gt 1) then Xres=float(datp.x[*,(res_spc<sx)-1])
                        endelse
          w2d=(size(Wres))[0:2]

          if  (w2d[0] eq 1) or (w2d[2] eq sw[2]) then begin
            if w2d[0] eq 1          then t2d=0 else begin & Wres=Wres[*,frst:lst] & t2d=nspec-1
                if (n_elements(Zres) eq sw[2]) or (n_elements(Zres) eq sw[2]*3) then Zres=Zres[  frst:lst,*] & endelse
            if (size(Xres))[0] eq 1 then x2d=0 else begin & Xres=Xres[*,frst:lst] & x2d=nspec-1 & endelse
            w2d=(size(Wres))[0:2] & idrx=0
            if t2d gt 0 then KPfct2=fltarr(w2d[1],t2d+1)
            KPwdt  =fltarr(t2d+1)
            KPdim  =lonarr(t2d+1)
            fxwidth=fltarr(t2d+1,3)
            NZres  =n_elements(Zres)
            for i=0,t2d do begin
               if (i eq 0) or (x2d gt 0) then begin
                 Xires =Xres[*,i<x2d]
                 if  n_elements(Res_xrg) eq 2 then idrx=where((Xires ge Res_xrg[0]) and (Xires le Res_xrg[1]))
                 if  n_elements(idrx)    ge 3 then Xires=Xires[idrx]
                 w1d=n_elements(Xires)
                 if Xires[w1d-1] gt Xires[0]  then sens=1 else sens=-1
                 n=round(abs(Xires[w1d-1]-Xires[0])/Xunit)+1
                 if (n ne w1d) and (interp)   then okinterp=1 else okinterp=0
               endif
               if (x2d gt 0) then begin
                  if (n_elements(idrx) ge 3)    then Wires=double(Wres[idrx,i])  else Wires =double(Wres[*,i])
                  if (NZres eq nspec) or (NZres eq nspec*3)   then Zrw=Zres[i,0] else Zrw=0.
                  if  Zrw gt 0. then begin & Fres=Wires & bidpar=[0.,0.,0.,Zrw] & endif $
                  else bidpar=str_fit(Wires,bkgd=1,xin=Xires,Res_dfit=Fres ,/Pseudo,/P2_mod,/noweight)
                      ;****************************************************************************** each time
               endif else begin
                 if (i eq 0) then begin
                  if (n_elements(idrx) ge 3) then Wires=double(Wres[idrx,*])   else Wires =double(Wres)
                  if (NZres eq nspec) or (NZres eq nspec*3) then Zrw=Zres[i,0] else Zrw=0.
                  if Zrw gt 0. then begin & FFres=Wires & bonpar=fltarr(nspec,4)
                                          if nspec eq 1 then bonpar[3]=Zres[0] else bonpar[*,3]=Zres[*,0]
                                          bonpar=reform(bonpar) & endif $

                  else bonpar=str_fit(Wires,bkgd=1,xin=Xires,Res_dfit=FFres,/Pseudo,/P2_mod,/noweight)
                      ;****************************************************************************** one time

                  if w2d[0] gt 1 then FTres=total(FFres,2) else FTres=FFres & FC=(max(FTres/total(FTres))/500.) >FC < 0.001
                 endif
                 if t2d gt 0 then Fres  =FFres[ *,i] else Fres  =FFres
                 if t2d gt 0 then bidpar=bonpar[i,*] else bidpar=bonpar
               endelse

               if fxreso then begin & nloop=1 ;calculate real delta thin width 'Delta' function or model=1
                  if (NZres eq nspec*3) then fxwidth[*]=Zres[*] $
                  else begin
                   if x2d gt 0 then begin & fxpar=str_fit(Fres ,xin=Xires,res_wks=Fres ,res_xin=Xires,res_zin=bidpar[3],/noweight)
                                          fxwidth[i,0]=bidpar[3] & fxwidth[i,1]=fxpar[3] & fxwidth[i,2]=fxpar[2]
                   endif else $
                   if  i  eq 0 then begin & if t2d gt 0 then tmpzin=bonpar[*,3] else tmpzin=bonpar[3]
                                          fxpar=str_fit(FFres,xin=Xires,res_wks=FFres,res_xin=Xires,res_zin=tmpzin   ,/noweight)
                                          fxwidth[*,0]=tmpzin
                                          if t2d gt 0 then fxwidth[*,1]=fxpar[*,3] else fxwidth[*,1]=fxpar[3]
                                          if t2d gt 0 then fxwidth[*,2]=fxpar[*,2] else fxwidth[*,2]=fxpar[2]
                   endif
                  endelse
               endif

               if okinterp then begin       ;Interpolate if resolution Xunit is different
                      Fres=Fres/total(Fres) & LC=max(Fres,imax)*FC & idx=where(Fres gt LC)
                      if n_elements(idx) ne w1d then begin     ;Reduce to peak region (Vana...)
                         Fres=Fres[idx] & XireZ=Xires[idx]
                         n=round(abs(XireZ[n_elements(XireZ)-1]-XireZ[0])/Xunit)+1
                      endif else XireZ=Xires
                      xcv=sens*findgen(n)*Xunit +XireZ[0] & Fres=INTERPOL(Fres,XireZ,xcv,/quad)>0
               endif
               KPwdt[i]   =bidpar[3]/Xunit

               kpfunc_conv=DI_CVnorm(Fres, FC, 1)                 ;Normalize, centerize & reverse

               if t2d gt 0 then begin & kpn=n_elements(kpfunc_conv) & KPfct2[0:kpn-1,i]=kpfunc_conv & KPdim[i]=kpn & endif
            endfor

            if rfxwidth then begin & TAKE_DATP,rdatp,W=res_wks & MOD_DATP,rdatp,'Z',fxwidth & GIVE_DATP,rdatp,W=res_wks & endif ;not used (didline)
            KPdim2   =KPdim
            fwdt_conv=total(KPwdt)/(t2d+1)
          endif else begin &   resot=0 & nloop=1 & lamp_message,'? Resolution workspace: bad dimension ...'
                             if  oklab then widget_control,ilab,bad_id=ii,set_value='? Resolution bad dim.'
                             return,0 & endelse
      end

    (resot eq 2) or (resot eq 3):begin                                                       ;Gauss/Lorentz <****
           if resot eq 3 then pvf=Res_pvf>0.<1.  else pvf=0.
           if resot eq 3 then wth=Res_voi/Xunit  else wth=Res_gau/Xunit
           fxwidth=fltarr(1,3) & fxwidth[0,0]=wth*Xunit & fxwidth[0,1]=Xunit*2./3.
           hg= bgau/wth     & hv=2./!pi/wth
           he= hv*pvf + hg*(1.-pvf) & n1=  round(wth*15.)+1     & Xb= findgen(n1)-n1/2
               fpsd=pvf
               if res_gum eq 0 then      str_Pseudo,Xb,[he,0.,wth,0.],Wres $
                               else Wres=str_Gumbel(Xb, he,0.,wth,res_gum)
               fwdt_conv=wth
               kpfunc_conv=DI_CVnorm(Wres, FC, 0)                 ;Normalize, centerize & reverse
      end
    else:
    endcase

    if resotF and (resot eq 0) then begin & wth=mlt_fWmH/Xunit & pvf=0.
           hg= bgau/wth     & hv=2./!pi/wth
           he= hv*pvf + hg*(1.-pvf) & n1=  round(wth*15.)+1     & Xb= findgen(n1)-n1/2      ;Fast multi search <****
               fpsd=pvf
               str_Pseudo,  Xb, [he,0.,wth,0.],Wres
               fwdt_conv=wth
               kpfunc_conv=DI_CVnorm(Wres, FC, 0)                 ;Normalize, centerize & reverse
    endif

    fpsd =KPfpsd & UserModl=KPUserModl
    fxwsz=(size(fxwidth))[1]-1
endif

di_inst_Dreso, 'clear'
if NXX           eq n_elements(func_dti) then begin & noderiv=1 & KPfpsd=fpsd  ;Instrument resolution Xdependent 1D at this time (keep resot=0)
                 if n_elements(res_pvf) eq 1 then fpsd=res_pvf else fpsd=0. & fpsd=fpsd>0.<1.
                 di_inst_Dreso, 'prep', Q=X ,deltaQ=func_dti ,pVf=fpsd & fpsd=KPfpsd
endif
if n_elements(Res_disp) eq 1 then  if Res_disp gt 0 then begin & noderive=1    ;Polydispersity function[1=Gauss 2=Log_Norm 3=Schultz]
                 di_inst_Dreso, 'Fdisp',Fdisp=Res_disp & endif

;********** ;********** ;********** ;********** ;********** ;**********
;********** ;********** ;********** ;********** ;********** ;**********

if modl eq 3 then if (resot gt 0) or (resotF gt 0) then begin
     ;CZ IS A DECONVOLUTION FUNCTION OF PROFILE+DELTA (R+|f)
     ;** ** * ************* ******** ** ********************
     ;(R+|f)~CZ= |1       (target ct=|1)
     ;*************
     ;Target width if not |1
     ;**********************
      case Mlt_fine of
      1: ahuit=1.5 ;noisy
      2: ahuit=3.  ;normal
      3: ahuit=5.  ;good-looking
      4: ahuit=8.  ;smooth
      5: ahuit=0.  ;top-quality
      else: ahuit=3;defaulting
      endcase
      WTH=.8 & Wres=[0.,1.,0.] & KPWth2=WTH & KPWres2=[Wres,fltarr(n_elements(kpfunc_conv))] & KPDem2=3
      if   ahuit gt 0 then begin
        if t2d gt 0 then begin & KPWres2=KPfct2*0. & KPWth2=KPwdt*0. & KPDem2=KPDim2*0 & endif
        for i=0,t2d do begin
           if t2d gt 0 then fwdt_conv=KPwdt[i]
           WTH=(fwdt_conv/ahuit)>.8  & he=bgau/wth             ;Gives a width
           n1 = round(wth*15.)+1     & Xb=findgen(n1)-n1/2
           str_Gauss,  Xb, [he,0.,wth,0.],Wres
           Wres=DI_CVnorm(Wres, FC, 0)                         ;Normalize, centerize & reverse
           KPWth2[   i]=WTH & KPWres2[0,i]=Wres & KPDem2[i]=n_elements(Wres)
        endfor
      endif

      if (t2d gt 0) and (x2d eq 0) then begin                  ;Adjust eps F_ from average resolutions
          cv=DI_CVnorm(FTres, FC, 1)
          ok=0 & nc= n_elements(cv) & mi=(nc-1)/2 & ct=cv*0. & ct[mi]=1.
          WHILE not ok do begin
                R  =cv  & R[  mi]=R[ mi]+F_  & CZ=di_solv(R ,ct)
                bid=min(CZ[0:mi],mi1) & bid=min(reverse(CZ[mi:*]),mi2) & mi2=nc-mi2-1
                rcz=CZ  & rcz[mi1:mi2]=0.
                if (CZ[mi]/max(rcz))  lt LS then F_=F_*1.5 else ok=1
                if (F_ gt cv[mi]/10.) then ok=1
          ENDWHILE
      endif

  ;Maximum number of peaks
  ;******************************
      if n_elements( Mlt_U) ne 1 then pmaxnk=0 else pmaxnk=1
      if n_elements( Mlt_U) eq 1 then Mlt_U=Mlt_U >1 <(nex/3) else Mlt_U=nex/3
      if n_elements( Mlt_N) eq 1 then Mlt_U=Mlt_N >1 <(nex/3)
      nk=round(nex/fwdt_conv)> 1 <Mlt_U   & curnk =1 & maxnk =nk
  ;******************************
endif else begin & modl=0 & nk=1 & endelse;Resolution is missing for multi peak search!!!

;*****************************************  ;*****************************************
;Should interpolate if resolution is there? ;Should interpolate if resolution is there?
;*****************************************  ;*****************************************
folXn=lonarr(nspec<sx) & sizi0=NXX & sizi1=sizi0

if (resot gt 0) or (resotF gt 0) or (abs(follow) gt 1) then begin
    if (resot gt 0) or (resotF gt 0) then $
    for i=frst <(sx-1),lst<(sx-1) do  begin & kspec=(i-frst)>0    ;find maximum interpolate size
        nex=folXi[1,kspec]-folXi[0,kspec]+1
        n=round(abs(datp.X[folXi[0,kspec],i]-datp.X[folXi[1,kspec],i])/Xunit)+1 ;Xunit was calculated from datp.X(idx1,frst) !!!
        if (n ne nex) and (interp) then if n gt 1 then folXn[kspec]=n
    endfor
    sizi1=max([folXn,reform(folXi[1,*]-folXi[0,*]+1)]) ;create arrays to store F,X,Err,Bshape
    folXx=fltarr(sizi1,nspec<sx) & folXf=fltarr(sizi1,nspec) & folXe=double(folXf) & if sb gt 0 then folXb=folXf
    for i=frst,lst do begin
          kspec=i-frst & n=folXn[kspec<(sx-1)]
          if (kspec lt sx) then begin
                 ddx=folXi[0,kspec] & dlx=folXi[1,kspec]
                 kpX=datp.X[ddx:dlx,i<(sx-1)]
                if n gt 1 then begin
                    if kpX[dlx-ddx] gt kpX[0] then sens=1 else sens=-1
                    xcvn=sens*findgen(n)*Xunit + kpX[0] & folXx[0,kspec]=xcvn ;new X
                    if kspec eq 0 then X=xcvn
                endif else folXx[0,kspec]=kpX
          endif
          if n gt 1 then begin
             if sb gt 0 then $
             folXb[0,kspec]=INTERPOL(sf_bkgd[ddx:dlx,i<(sb-1)],kpX,xcvn,/quad)
             folXf[0,kspec]=INTERPOL(W_in[   ddx:dlx,i]       ,kpX,xcvn,/quad)
             folXe[0,kspec]=INTERPOL(wei[    ddx:dlx,i]       ,kpX,xcvn,/quad)>min(me[ ddx:dlx,i])
          endif else begin
             if sb gt 0 then $
             folXb[0,kspec]=sf_bkgd[ddx:dlx,i<(sb-1)]
             folXf[0,kspec]=W_in[   ddx:dlx,i]
             folXe[0,kspec]=wei[    ddx:dlx,i]
             folXn[kspec<(sx-1)] =-(dlx-ddx+1)
          endelse
    endfor
endif

;*****************************************  ;*****************************************
;*****************************************  ;*****************************************
;Bose asked?
;***********
if bose gt 0. then begin & folBo=fltarr(max([sizi0,sizi1]),nspec<sx)
     debal=bose/11.6045
     for i=frst,lst do begin & kspec=i-frst & n=abs(folXn[kspec<(sx-1)])
         if (kspec lt sx) then begin
                 ddx=folXi[0,kspec] & dlx=folXi[1,kspec]
                 if n gt 1 then kpX=folXx[0:n-1,kspec] else kpX=datp.X[ddx:dlx,i<(sx-1)]
                 D_bal=str_bose(kpX,T=bose)
                 folBo[0,kspec]=D_bal
endif & endfor & endif

;*************
;Create arrays nspec=number of spectra    nk=number of functions
;*************
a         =dblarr(npr*nk+npb) & aa=dblarr(nk+npr*nk+npb)        ; array for fit pars
s         =dblarr(npr*nk+npb) & ss=dblarr(nk+npr*nk+npb)        ; and sigmas
fita      =intarr(npr*nk+npb)+1                                 ; fixed parameters=0
bounda    =intarr(2,npr*nk+npb)                                 ; bounded parameters
limita    =dblarr(2,npr*nk+npb)
ChiRes    =fltarr(nspec)                                        ; Chi results
fit_pars  =dblarr(nspec,1+3+3+3+((npr-3)>0+1),nk)                 ; array for all fit pars (note: pvf+(npr>3<3)+(npb>3<3)+3+reste(npr)) ;MAG: Added 1 to store also Chi2 values per spectrum
fit_sigmas=dblarr(nspec,1+3+3+3+((npr-3)>0+1),nk)                 ; and sigmas (note: pvf+(npr>3<3)+(npb>3<3)+3+reste(npr)) ;MAG: Added 1 to have same dimensions as fit_pars
kas=dblarr(nk) & k2as= dblarr(2,nk)                             ; temporaries
if modl le 3 then ind=indgen(nk)*npr else ind=[-1]
f_a       =dblarr(nk) & f_e = f_a
Cfunc     =dblarr((size(mfit))[1],nspec,nk)
SpecCfunc =dblarr(NXX,nk)

;********************************************************************
;********************************************************************
;fit peak for each spectrum, write peak params into array fit_pars(i)
;********************************************************************
;********************************************************************

kp_error=!error_state.msg
prems=frst & derch=lst & fol=1 & if follow lt 0 then begin & prems=lst & derch=frst & fol=-1 & endif ;Gives a sens

for ispec=prems,derch,fol do begin

  if oklab then widget_control,ilab,bad_id=ii,set_value=strmid('-> '+s4v(ispec+1)+'                ',0,20)

  kspec=ispec-frst & ddx=folXi[0,kspec<(sx-1)] & dlx=folXi[1,kspec<(sx-1)] ;X range

  if (resot gt 0) or (resotF gt 0) then begin

      if t2d gt 0 then begin & nc =KPdim2[kspec] & KPfunc_conv=KPfct2[ 0:nc-1,kspec] & fwdt_conv  =KPwdt[ kspec] & endif
      if n_elements( KPDem2) gt 1  then begin
                             nh =KPDem2[kspec] & Wres       =KPWres2[0:nh-1,kspec] & WTH        =KPWth2[kspec] & endif
      if nloop eq 2 then func_conv=0 else func_conv=KPfunc_conv
  endif
  if  n_elements(folXx) gt 1 then begin
      n=abs(folXn[kspec<(sx-1)])
      if sb ge 1 then func_bkgd=folXb[0:n-1,kspec]                ;Numerical background
      if sx gt 1 then X        =folXx[0:n-1,kspec]                ;X
                      F        =folXf[0:n-1,kspec]                ;Spectrum
                      weight   =folXe[0:n-1,kspec]                ;Errors
  endif else begin
      if sb ge 1 then func_bkgd=sf_bkgd[ddx:dlx,ispec<(sb-1)]     ;Numerical background
      if sx gt 1 then X        =datp.X[ ddx:dlx,ispec]            ;X
                      F        =w_in[   ddx:dlx,ispec]            ;Spectrum
                      weight   =wei[    ddx:dlx,ispec] & endelse  ;Errors
  NXX=n_elements(X)

  if bose gt 0. then D_bal=folBo[0:NXX-1,kspec<(sx-1)]  ;Bose

  ;**************************** ;**************************** ;****************************
  ;Calculate initial parameters ;Calculate initial parameters ;Calculate initial parameters
  ;**************************** ;**************************** ;****************************
  n   =NXX & if (n gt (fwdt_conv>5)) then sF=smooth(F,5>fwdt_conv) else sF=F
  minF=min(sF)  & bgF=minF
  Xa  =min([X[n-1],X[0]],max=Xb)

  if  Nflat               eq 1 then bgF=flat  else $                            ; fixed flat background? <----------
   if n_elements(startBG) eq 1 then bgF=(startBG<bgF) else $                    ; started    background?
   if itmax eq 1               then bgF=0.
  if sb gt 0 then begin                                                         ; Numerical  background? <-----
     if Nflat ne 1 then bgF=0.
     normi=levls[kspec]
     Y=F-bgF-func_bkgd*normi & C=[bgf,normi]
  endif
  if (npb gt 1) and (sb eq 0) then begin                                        ; Linear Background
                           C=poly_fit(X,sF,(npb-1)<1,Y) & Y=Y<sF>minF           ; ""
                           C=poly_fit(X,Y ,(npb-1)<1,Y) & Y=Y<sF>minF           ; ""
                           C=poly_fit(X,Y ,(npb-1)<1,Y) & Y=F-Y & endif         ; Y=F-Linear Background
  if (npb eq 1) and (sb eq 0) then begin & C=bgF  & Y=F-bgF       & endif         ; Y=F-Flat   Background

 ;KPA?***************************************************************
  if (follow eq 0) or (follow eq 2) or (ispec eq prems) then begin
 ;KPA?***************************************************************

  if modl le 2 then begin                                                       ;******* estimate classical models 0,1,2
 ;***********************
    dvexp=exp(1.)
    if (n gt (fwdt_conv>5)) and (n gt 15)  then Y=smooth(Y,5>fwdt_conv)           ; smooth poor data
                                          ;else dvexp=2.0
    if n_elements(center) eq 1 then begin                                         ; Given Position <-----------------
               i0=where(X ge center)  & if i0[0] lt 0 then i0=n-1 else begin
                                tmp=min(X[i0],imi) & i0=i0[imi] & endelse
    endif else begin & ymax=max(Y,imax) & i0=imax>0<(n-1) & endelse                 ; position

    if (n_elements(fWmH) eq 1) and (resot eq 0) then awidth=fWmH $                ; Given Width    <-----------------
    else begin & del =Y[i0]/dvexp & i1=0 & i2=0 & i=0                               ; width
         while (i0+i2+1 lt n) and (Y[i0+i2] gt del) do i2=i2+1                    ; ""
         while (i0-i1   gt 0) and (Y[i0-i1] gt del) do i1=i1+1                    ; ""
         if (i0+i2+1 eq n) and (Y[i0+i2] gt del) then i2=i1 else $ ; out of bound
         if (i0-i1   eq 0) and (Y[i0-i1] gt del) then i1=i2        ; out of bound
         i=((i1+i2)/2)>1 & i0=i0+(i2-i1)/2                         ; position
         ib=(i0+i-n+1)>0 & ia=(i-i0)>0
         awidth=abs(x[abs(i0+i+ia-ib)<(n-1)]-x[abs(i0-i+ia-ib)])   ; width
    endelse
    a[0:0+2]  =[Y[i0], X[i0],awidth]                                              ; height,position,width

  endif else if modl eq 3 then begin                                            ;******* estimate Multi  peaks
 ;**********************************
   if (t2d gt 0) or (ispec eq prems) then begin & ok=0           ;get resol. in cr
      cr =kpfunc_conv   & cv=reverse(cr) & nc= n_elements(cv) & mi=(nc-1)/2
   endif  else ok=1
   if not ok then begin & ct=Wres & nct=n_elements(ct)           ;get target in ct
      if nct ne nc then begin & Un=cv*0 & Un[mi]=1. & sup=abs(nct-nc)/2
         if nct gt nc then ct=ct[sup:nct-sup-1] $
                      else ct=[fltarr(sup),ct,fltarr(sup)]
      endif
      ;CZ IS A DECONVOLUTION FUNCTION OF PROFILE+DELTA (R+|f)
      ;** ** * ************* ******** ** ********************
      ;(R+|f)~CZ= |1       (target ct=|1)
      ;*************
      ;CZ~CZi=|1 -> R~CZ~rev(CZi)=c*f ; CZi=(R+|f)
      ;******************************
      ;  B~cr      = D   -bg } sum --> B~cr + (D+fB)~CZ/T = D+ B/T
      ; (D+fB)~CZ/T= B/T +bg }     --> B~(|1/T -fCZ/T-cr) = D~CZ/T -D
      ;                                B~ a1              = D~ a2
      ;                            --> We could have a model under the peaks
      ;                                B~ a1 +S~rev(cv~a2)= D~ a2 with B=0
      ;************************************************************************
      Fe=F_
      WHILE not ok do begin                                    ;get deconvol. in cz
        R  =cv  & R[  mi]=R[ mi]+Fe  & CZ=di_solv(R ,ct)
        bid=min(CZ[0:mi],mi1) & bid=min(reverse(CZ[mi:*]),mi2) & mi2=nc-mi2-1
        rcz=CZ  & rcz[mi1:mi2]=0.
        maxcz=max(rcz)
        if maxcz gt 0. then if (CZ[mi]/maxcz)  lt LS then Fe=Fe*1.5 else ok=1 else ok=1
      ENDWHILE
      mct=max(ct)
      T  =abs(total(CZ)) & CZt=CZ/T
      Ft =mct/(total(CZt*cv))
      CZ0=CZT - 1./nc              ;  Just for fitting
      a11=reverse(di_conv(cv,CZ0))
      F1 =mct/ total( cv*CZ0)      ;  Adjustment factor for fitting

     ;FOU IS A FUNCTION USED TO REMOVE STATISTICS (f_ is small against stat! so R~FOU=cv)
     ;*** ** ********** ******* ****** **********
     ;A1 A2
     ;*****
        ;T  =  abs(total(CZ))
        ;a2 =  CZ/T & a2 (mi) =a2 (mi)-total(a2)
        ;a1 =-(CZ/T*f_+cr)+ct/T
        ;Fa =max(ct)/ total(cv * a2) ;**Adjustment factor for BB
      if (n_elements(FOU) lt 3) or (Fe ne F_) then begin & FOU=di_solv(R,cr)
          FOU[mi]=FOU[mi]+1.-total(FOU)  ;FOU=FOU/total(fou)
          endif
   endif
   ;www =[fltarr(30),cv,cv/2,cv*1.5,fltarr(30)] ;For debuging
   ;ww  = www*1000. & fwdt_conv=1.
   ;ww  = di_conv(www,di_gauss(-1,2.,0))
   ;wa  = di_conv(www,di_gauss(-1,3.,0))
   ;ww  = ww+shift(ww,7)  +shift(ww,14)/2. ;+shift(ww,15)/4.
   ;ww  = ww+findgen(n_elements(ww))/1. ; +background
   ;un  = Y*0. & un(50)=1000 & un(91)=500 & un(132)=1500
   ;un  = un+shift(un,7)  +shift(un,14)/2.
   ;un  = un+findgen(n_elements(un))/1.
   ;F   = ww & n=n_elements(F) &X=findgen(n) & Xunit=1. & mei=X*0.+1. & wout=F*0. & mfit=wout

    if MLT_fine lt 5 then begin & dif=(abs(shift(Y,1)-Y)+abs(shift(Y,-1)-Y))/2. & dif[0]=0. & dif[n-1]=0.
                                Wf = DI_CONV(Y ,FOU)>(Y-dif)<(Y+dif)    ;first, apply filter (necessary)
                    endif else Wf = Y

    if keyword_set(res_flt) then return,Wf

    Wf   =Wf-min(Wf)

    DD2G = di_conv(Wf  ,CZ0)                                                  ;DD2G will be used to estimate fit params
    DD2f = di_conv(Wf  ,CZt)                                                  ;DE-CONVOLUATE.......................
    wlim = round((fwdt_conv)/4.) >1                                           ;suppress edges artifacts
    DD2G[0:wlim-1]=total(DD2G[0:wlim-1])/wlim & DD2G[n-wlim:n-1]=total(DD2G[n-wlim:n-1])/wlim
    DD2f[0:wlim-1]=total(  Wf[0:wlim-1])/wlim & DD2f[n-wlim:n-1]=total(  Wf[n-wlim:n-1])/wlim
    DD2k = DD2f
    aa   =(DD2f-DD2G)                                                         ;aa should be used for fit

    for i=1,3 do begin & DD2r=di_conv(DD2k,cr)  & DD2k=DD2k +(Wf-dd2r) & endfor ;artifact minimisation
    DD2p = DD2k
    ;limit # of peaks
    if pmaxnk then epslim=0. else begin & idv=where(dd2p gt Wf)                 ;# peaks not given
                                  epslim=total((dd2p-Wf)>0.)/n_elements(idv)/2. & endelse
    idk=WHERE(DD2k lt Wf+epslim)
    DD2k=(2*DD2k-Wf)
    if MLT_fine le 3 then begin & DD2k=(2*DD2k-Wf);*Wf             ;(2*DD2k-Wf) to keep peaks with next di_conv
                                DD2k=di_conv(DD2k,wres)          ;*Wf to keep a good position
    endif else                  DD2k=(DD2k-Wf)
    DD2k[idk]=0.                                                 ;only what was higher Wf

    BB   =di_keeb(DD2K>0.,0,(DD2p-Wf)/2.,idd0,shf) & BB[0:wlim-1]=0 & BB[n-wlim:n-1]=0 ;get Bands in BB
    idx  =where(BB[idd0] gt 0.)                                                        ; ""
    if idx[0] ge 0 then APx=idd0[idx] else begin & bid=max(DD2G,APx) & BB[APx]=DD2G[APx] & endelse
    mwth =1.
    AH   =BB[APx]*Ft/mwth                            ;Initial height
    BB=BB*0. & BB[APx]=AH
    DDtmp=DD2f[APx]<DD2p[APx]                        ;Initial height review
    for i=1,6 do begin & DD2r=di_conv(BB,a11) & BB[APx]=BB[APx]*abs(DDtmp/(DD2r[APx]+aa[APx])) & endfor

    if n_elements(APx) gt ceil(maxnk*1.3) then begin ;limit to maxnk*1.3
       sdx=sort((BB)[APx]) & APx=APx[sdx[n_elements(APx)-ceil(maxnk*1.3):*]] & APx=APx[sort(APx)]
      ;tmp=BB(APx) & BB=BB*0. & BB(APx)=tmp
    endif
    AH   =BB[APx]/WTH
    AP   =X[ APx]                            ;Initial positions
    WD   =AH*0.+Xunit*WTH*mwth               ;Initial width (delta*WTH)

  endif else if modl eq 4 then begin                                            ;******* estimate exotic models
    a[0:1]=[1000.,100.,.05]*.7 ;UNUSED (see UserModel)
  endif
  if modl eq 5 then begin                                                       ;******* estimate User Model
    Uparams= UserModl.params & nba=n_elements(Uparams)
    if nba gt 1 then Uparams = reform(Uparams,nba)
    a[0:nba-1]=Uparams
  endif

  a[npr*nk] =C[0]                                                             ; flat bg
  if npb gt 1 then a[npr*nk+1]=C[1]                                           ; estimate linear term
  if npb gt 2 then a[npr*nk+2]=0.                                             ; zero for quadratic estimate

  if debug then print,'initial1',ispec+1,' f=',frac[0],' H=',a[0],' P=',a[1],' W=',a[2],' bg=',a[npr*nk]

  ;First adjustement using a light fit
  ;***********************************
  if (modl eq 0) or (modl eq 1) or (modl eq 2) then begin                       ; re_estimate classical A with 1 peak
      ida     =[0,1,2,npr*nk] & if npb gt 1 then ida=[ida,npr*nk+1]
      if npb gt 2 then ida=[ida,npr*nk+2] & atmp=a[ida]
      fite=fix(atmp*0.)+1
      if (n_elements(center) eq 1)                  then fite[1]=0 ;fixe it
      if (n_elements(fWmH)   eq 1) and (resot eq 0) then fite[2]=0
      if (Nflat              eq 1)                  then fite[3]=0
      if  keyword_set(num_bfix)                     then fite[4]=0
      peak_fit=coolfit(X,F, weight ,atmp,fita=fite,function_name='str_Gauss',MPF=mpf,CHISQ=chisq,noderiv=noderiv)
      atmp[2]=abs(atmp[2]) & a[ida]=atmp
  endif else $

  if (modl eq 3) then begin & lop=1 & nek =n_elements(AP)                         ; re-estimate multi peaks
      KPfunc_bkgd=func_bkgd  & KP_D_bal=D_bal & D_bal=1. & func_bkgd=0. ;**Enable peak search
      func_conv=a11 & crr=1; & crr=aa
      if crr eq 1 then DD2 =abs(DD2G) else DD2=DD2G
      if crr eq 1 then noderiv3=1     else noderiv3=0

      if (n_elements(lfWmH) eq 1) then lowth=lfWmH    else $
                  if (resot gt 0) then lowth=Xunit/2. else lowth= fwdt_conv*Xunit/2.
      if (n_elements(ufWmH) eq 1) then upwth=ufWmH    else upwth=(fwdt_conv*Xunit*10.)<(Xb-Xa)/2.
;**** voir DD2 *** close position *** criteria H*W or W/S
;********************************************************
      wmp =max([fwdt_conv*Xunit,lowth])/3.*0. ;critical close position
      Wght=weight*0.+1.
    while (lop gt 0) do begin
      ind =indgen(nek)*npr & nek3=nek*npr
      atmp=dblarr(nek3+1) & bounda=intarr(2,nek3+1)  & limita=dblarr(2,nek3+1)
      fita=intarr(nek3+1)+1 ; not fixed
      atmp[ind]=AH & atmp[ind+1]=AP & atmp[ind+2]=WD
      bounda[0,ind]   =1 & limita[0,ind]  =0.                                    ;**height>0
      bounda[*,ind +1]=1 & limita[0,ind+1]=Xa-wmp & limita[1,ind+1]=Xb+wmp       ;**position in data range
      if (n_elements(fWmH) eq 1) and (resot gt 0) then begin & atmp[ind+2]=fWmH & fita[ind+2]=0
      endif else bounda[*,ind+2]=1                                               ;**width
      atmp[ind+2]=atmp[ind+2]>lowth<upwth
      limita[0,ind+2]=lowth & limita[1,ind+2]=upwth
      fita[nek3]=0                                                       ;**flat  =0
      if lop eq 1 then begin & fita[ind+1]=0 & fita[ind+2]=0 & endif       ;Adjust heights  first
                            ;limita(0,ind)  = atmp(ind)/F1 & endif       ;(prevent from disappear)
      if lop eq 2 then begin & fita[ind  ]=0 & fita[ind+2]=0 & endif       ;Adjust position then
      if lop eq 3 then begin & fita[ind+1]=0                 & endif       ;Adjust heights and width then
      if lop eq 4 then begin                               & endif       ;Adjust all   finaly
      peak_fit=coolfit(X,DD2,Wght,atmp,fita=fita,bounda=bounda,limita=limita,s,function_name='str_Gauss',iter=it,noderiv=noderiv3,MPF=mpf,CHISQ=chisq)
      toti=toti+it
;print,lop,toti
     ;****************
     ;******** Get out bad peaks
      AH2 =atmp[ind]  & AP2=atmp[ind+1] & WD2=abs(atmp[ind+2]) & WDs=s[ind+2] & st=sort(AP2)
      APx =round((AP2-Xa)/Xunit)
      AH2 =AH2[ st]   & AP2=AP2[ st]    & WD2=WD2[st] &  APx=APx[st] & WDs=WDs[st]

      idk =where((AH2  gt 0) and (AP2 ge Xa) and (AP2 le Xb));height>0 and position in margin
      if idk[0] ge 0 then begin
         AH2 =AH2[idk]  & AP2=AP2[idk] & WD2=WD2[idk] & APx=APx[idk] & WDs=WDs[idk] & nek=n_elements(AP2)
;print,ap2,ah2,wd2,apx
;func_conv=0 & str_gauss,x,atmp,pp & func_conv=a11
;wset,0 & plot,x,di_conv(pp,a11)+aa,color=1 & oplot,x,dd2f,line=1,color=1 & stop
         if wmp gt 0. then begin & AHW=AH2*WD2
          for i=0,nek-2 do if AP2[i+1]-AP2[i] lt wmp then begin & newAP=(AP2[i+1]*AHW[i+1]+AP2[i]*AHW[i])/(AHW[i+1]+AHW[i])
                           if AHW[i+1] gt AHW[i] then begin & AH2[i]  =-1. & AP2[i+1]=newAP & endif $ ;Position too close
                                              else begin & AH2[i+1]=-1. & AP2[i]  =newAP & endelse
         endif     &      endif
         idk=where((AH2 gt 0.))
         if idk[0] ge 0 then begin & AH2=AH2[idk]   & AP2=AP2[idk] & WD2=WD2[idk] & APx=APx[idk] & WDs=WDs[idk]  & endif
      endif
      if idk[0] eq -1 then begin & AH2=max(AH,imax) & AP2=AP[imax] & WD2=WD[imax] & APx=APx[imax] & endif ;Keep one
      nek =n_elements(AP2)
      if nek gt 1 then begin
         if (lop ge 4) and (nek gt maxnk) then begin & lop=lop+1         ;to much positions from asked
               nmx=ceil((nek-maxnk)/2.) & crit=WD2/(WDs>1e-8) ;AH2*WD2
               ids=sort(crit) & ids=ids[nmx:*] & ids=ids[sort(ids)] & nek=nek-nmx
               AH2=AH2[ids]  & AP2= AP2[ids]   & WD2=WD2[ids] & APx=APx[ids] & WDs=WDs[ids]
         endif else if (lop ge 4) and (it le 2) then lop=0 $
                    else begin & lop=lop+1
                         if (lop ge 4) then begin & crit=WD2/(WDs>1e-8)  ;else eliminate bad sigmas
                               ids=where((crit gt .5) and (WDs gt 0.))
                               if (ids[0] ge 0) and (n_elements(ids) lt nek) then begin
                               AH2=AH2[ids]  & AP2= AP2[ids]   & WD2=WD2[ids] & APx=APx[ids] & WDs=WDs[ids]
                               nek=n_elements(AP2) & endif
                         endif
                    endelse
      endif else lop=0
      AH=AH2 & AP=AP2 & WD=WD2
    endwhile
      tmb=a[npr*nk:*] & nk =nek
      a  =dblarr(npr*nk+npb) & aa=dblarr(nk+npr*nk+npb)                ; array for fit pars
      s  =dblarr(npr*nk+npb) & ss=dblarr(nk+npr*nk+npb)                        ; and sigmas
      fita  =intarr(npr*nk+npb)+1                                      ; fixed parameters=0
      bounda=intarr(2,npr*nk+npb)                                      ; bounded parameters
      limita=dblarr(2,npr*nk+npb)
      kas=dblarr(nk) & k2as=dblarr(2,nk) & ind=indgen(nk)*npr                 ; temporaries
      f_a=dblarr(nk) & f_e =f_a

      a[npr*nk:*]=tmb
      a[ind]     =AH & a[ind+1]=AP & a[ind+2]=WD
      if nk gt curnk then curnk=nk
      crr=0 & nloop=1
      func_bkgd=KPfunc_bkgd & D_bal=KP_D_bal
      if resot gt 0 then func_conv=KPfunc_conv $           ;**Enable convolution in fitting
      else begin & func_conv=0                               ;  else   fast multi search
                 newidth  =(a[ind+2] > (fwdt_conv*Xunit))           ;anlarge  width
                 a[ind+0] =(a[ind+0] * a[ind+2]/newidth/1.2)>1e-14  ;decrease height
                 a[ind+2] = newidth
      endelse
  endif

 ;*****************************************************
 ;*****************************************************
  endif else a=KPa ;Take previous fitted params (follow)
 ;*****************************************************
 ;*****************************************************

  if debug then print,'initial2',ispec+1,' f=',frac[0],' H=',a[0],' P=',a[1],' W=',a[2],' bg=',a[npr*nk]

  ;************************************* ;*************************************
  ;Set boundaries according to the model ;Set boundaries according to the model
  ;************************************* ;*************************************
  if modl eq 5 then begin
    nba=n_elements(UserModl.params) & na=n_elements(a)
 
    ;Treate here Q & tied expressions
    if n_elements(datp.y) eq sw[2] then  q=datp.y[ispec] else q=1. & qs=strtrim(string(q,format='(g)'),2)
    Qcurrent1D = q

    if n_elements(tiepos) gt 1 then begin ;we have tied or tied_itself parameters
     ;TIEPOS=[NPAR*NFUNC , d=5 , d=9)
     ;d=5: 0-> is the index of pn in '(P[pn])'
     ;     1-> the lenght of pn (1 or 2 rarely 3)
     ;     2-> 1 means tied parameter , 0 means not tied
     ;     2-> 2 if ONLY itself tied  , 3 if BOTH tied with an other and tied itself
     ;     3-> index of '['
     ;     4-> index of ']'
     ;d=9: number of (P1F1) in one expression
     
     ;TIED is EXECUTED in THE ENGINE and used to handle derivatives and 2D mean
      tied=strarr(na)  & tiedd=tied
      tiebug=0

     ;TIED parameters (p1f2) (NOT itself)      
      for t3=0,(size(tiepos))[3]-1 do begin & tiepo=tiepos[*,*,t3]
        idxq=where((tiepo[*,0] gt 0) and (tiepo[*,2] ne 2))

        if idxq[0] ge 0 then $
        for iq=0,n_elements(idxq)-1 do begin ; FOR EACH TIED PARAMETERS
          iqp=idxq[iq]
          if t3 eq 0 then begin & tied[iqp]=UserModl.Qexp[iqp]   & tiedd[iqp]=tied[iqp] & endif     ; PUT QEXP IN TIED ONCE
          
          pos=tiepo[iqp,0] & ln=tiepo[iqp,1]
          pn =s4v(fix(strmid(tied[iqp],pos,ln)))             ; EXTRACT pn from '(P[pn])'
          pnd=s4v(fix(strmid(tied[iqp],pos,ln)+kspec*na))    ; pnd is now relative to the first spectra in case of 2D FIT
          tmq=bopL+pn+bopR
          pos=strpos(tiedd[iqp],tmq)                         ; NOW REPLACE IN tiedd '(P[pn])' BY '(P[pnd])'
          tiedd[iqp] =strmid(tiedd[iqp],0,pos)+bopL+ pnd +bopR+strmid(tiedd[iqp],pos+3+ln,120)      ; ""
        endfor
      endfor

     ;TREAT (Q) in tied parameters '(P[pn])'
      pos =strpos(tied,'(q)') & posd=strpos(tiedd,'(q)')
      idxp=where( pos ge 0)
      while idxp[0] ge 0 do begin
        for iq=0,n_elements(idxp)-1 do begin & iqp=idxp[iq] & ip =pos[iqp] & ipd=posd[iqp]
             tied[ iqp]=strmid(tied[ iqp],0,ip +1)+qs+strmid(tied[ iqp],ip +2,120)
             tiedd[iqp]=strmid(tiedd[iqp],0,ipd+1)+qs+strmid(tiedd[iqp],ipd+2,120) ;for 2d fit also (in case)
        endfor
        pos =strpos(tied,'(q)') & posd=strpos(tiedd,'(q)')
        idxp=where( pos ge 0)
      endwhile

     ;TREAT (Q) un_tied (supposed in a fixed parameter may be)
      idxq=where(tiepos[*,2,0] eq 0)
      if idxq[0] ge 0 then begin
            for iq=0,n_elements(idxq)-1 do begin & iqp=idxq[iq]
                expr=strlowcase(UserModl.qexp[iqp]) & ip=strpos(expr,'(q)')
                while ip ge 0 do begin
                  expr=strmid(expr,0,ip +1)+qs+strmid(expr,ip +2,120)
                  ii=execute('A[iqp]='+expr) & ip=strpos(expr,'(q)')       ;WE PUT (Q) IN A() PARAMETER
                endwhile
            endfor
      endif

      if tiebug then for ii=0,n_elements(tied)-1  DO PRINT,'{'+tied[ii]+'}->{'+tiedd[ii]+'}'

     ;ITSELF TIED PARAMETERS
      idxq=where(tiepos[*,2,0] ge 2)
      if idxq[0] ge 0 then begin
        ;FOLQEXP is EXECUTED in UserModl and before str_integral for 1D and 2D
        ;WHILE TIEDD IS USED IN THE ENGINE (contains only 'P[n]')
         folQexp=strarr(na) & folQexpd=folQexp
         
         for iq=0,n_elements(idxq)-1 do begin & iqp =idxq[iq]                         ; LOOP FOR THIS PARAMETERS
           if tied[ iqp] gt ' ' then qexp =tied[ iqp] else qexp =UserModl.Qexp[iqp] ; TAKE THOSE NOT ALREADY TIED
           if tiedd[iqp] gt ' ' then qexpd=tiedd[iqp] else qexpd=UserModl.Qexp[iqp]
           iqps =s4v(iqp)              ; iqps  1D FIT
           iqpsd=s4v(iqp+ kspec   *na) ; iqpsd 2D FIT
           iqlsd=s4v(iqp+(nspec-1)*na) ; iqlsd 2D FIT (follow negative, attache last!)
           tiepos3 =strpos(qexp ,'[') & tiepos4 =strpos(qexp, ']')            ;position may change if p() or (q) was in there
           tiepos3d=strpos(qexpd,'[') & tiepos4d=strpos(qexpd,']')            ;position may change if p() or (q) was in there
           A[iqp]=float(strmid(qexp,tiepos3+1, tiepos4-tiepos3-1))            ;WE PUT [value] IN A() PARAMETER
           if tiepos3  gt 0 then  folQexp[ iqp] =strmid(qexp ,0,tiepos3 )     ;we may take what is before '[]'
           if tiepos3d gt 0 then  folQexpd[iqp] =strmid(qexpd,0,tiepos3d)     ;we may take what is before '[]'
           folQexp[ iqp]=folQexp[ iqp]+bopL+iqps +bopR+strmid(qexp ,tiepos4  +1,120)
           folQexpd[iqp]=folQexpd[iqp]+bopL+iqpsd+bopR+strmid(qexpd,tiepos4d +1,120)    ;for 2d fit
 
          ;TREAT (Q) in tied_itself parameters
           ip =strpos(folQexp[ iqp],'(q)') & ipd=strpos(folQexpd[iqp],'(q)')
           while ip ge 0 do begin
             folQexp[ iqp]=strmid(folQexp[ iqp],0,ip +1)+qs+strmid(folQexp[ iqp],ip +2,120)
             folQexpd[iqp]=strmid(folQexpd[iqp],0,ipd+1)+qs+strmid(folQexpd[iqp],ipd+2,120) ;for 2d fit
             ip =strpos(folQexp[ iqp],'(q)')
             ipd=strpos(folQexpd[iqp],'(q)')
           endwhile
           if follow lt 0 then if ispec ne lst  then tiedd[iqp]=bopL+iqlsd+bopR else tiedd[iqp]='' $
                          else if ispec ne frst then tiedd[iqp]=bopL+iqps +bopR else tiedd[iqp]=''

          ;tied(iqp)='' ;no other tied for 2d fit (only itself in tiedd)
         endfor
         if tiebug then for ii=0,n_elements(folQexp)-1  DO PRINT,'|'+folQexp[ii]+'|->|'+folQexpd[ii]+'|->{'+tiedd[ii]+'}'
       endif
    endif

    if (follow eq 0) or (follow eq 2) or (ispec eq prems) or (fxreso) then begin

     idxf= where(strlowcase(tag_names(UserModl))  eq 'on')
     if idxf[0] ge 0 then idoff=where(UserModl.ON eq 0) else idoff=[-1]
    ;Get user boundaries
     fita[0:nba-1]=1 ; not fixed
     idxf=where(strlowcase(tag_names(UserModl)) eq 'fitp')
     if idxf[0] ge 0 then begin
         if idoff[0] ge 0  then UserModl.fitp[*,idoff]=1
         if nba gt 1 then fita[0:nba-1] = 1-reform(UserModl.fitp,nba)   else fita[0] = 1-UserModl.fitp[0]   & endif

     idxf=where(strlowcase(tag_names(UserModl)) eq 'bounda')
     if idxf[0] ge 0 then begin
         if nba gt 1 then bounda[0,0:nba-1]=reform(UserModl.bounda,nba) else bounda[0,0]=UserModl.bounda[0]
     endif else bounda[0,*]=0
     idxf=where(strlowcase(tag_names(UserModl)) eq 'boundb')
     if idxf[0] ge 0 then begin
         if nba gt 1 then bounda[1,0:nba-1]=reform(UserModl.boundb,nba) else bounda[1,0]=UserModl.boundb[0]
     endif else bounda[1,*]=0

     idxf=where(strlowcase(tag_names(UserModl)) eq 'limita')
     if idxf[0] ge 0 then begin
         if nba gt 1 then limita[0,0:nba-1]=reform(UserModl.limita,nba) else limita[0,0]=UserModl.limita[0]
     endif
     idxf=where(strlowcase(tag_names(UserModl)) eq 'limitb')
     if idxf[0] ge 0 then begin
         if nba gt 1 then limita[1,0:nba-1]=reform(UserModl.limitb,nba) else limita[1,0]=UserModl.limitb[0]
     endif

     if Nflat            eq 1 then begin & a[npr*nk]  =flat & fita[npr*nk]=0 & endif   ; fixed background
     if keyword_set(num_bfix) then    fita[npr*nk+1]=0

    ;Add new constraints for classical functions
     name=strlowcase(UserModl.NAME)
     idn=where((name eq 'delta') or (name eq 'gauss') or (name eq 'voigt') or (name eq 'lorentz'))
     if idn[0] ge 0 then begin
      mnp =max(UserModl.NPAR) & ind=lonarr(n_elements(idn))

      for i=0,n_elements(idn)-1 do begin & k=idn[i]
      
       indu=k*mnp & ind[i]=indu & dx=a[indu+2]

       if bounda[1,indu]   eq 0 then         limita[0,indu]  = limita[0,indu] > 1e-14  ;height>0
       if fita[indu]            then begin &   bounda[0,indu]  = 1
                                             a[indu]=a[indu] > limita[0,indu]
                                     endif
       if bounda[1,indu+1] eq 0 then         limita[1,indu+1]= Xb+dx            ;Position in data range
       if bounda[0,indu+1] eq 0 then         limita[0,indu+1]= Xa-dx
       if fita[    indu+1]      then begin &   bounda[*,indu+1]= 1
                                             a[indu+1]=a[indu+1]>limita[0,indu+1]<limita[1,indu+1]
                                     endif
       if bounda[1,indu+2] eq 0 then         limita[1,indu+2]=(Xb-Xa)*3./2.     ;Width reasonable
       if bounda[0,indu+2] eq 0 then         limita[0,indu+2]=(dx/10.)          ;""
       if fita[    indu+2]      then begin &   bounda[*,indu+2]= 1
                                             a[indu+2]=a[indu+2]>limita[0,indu+2]<limita[1,indu+2]
                                     endif
       if name[k] eq 'voigt'    then begin
       if bounda[1,indu+3] eq 0 then         limita[1,indu+3]= 1.               ;0< PVfct <1
       if bounda[0,indu+3] eq 0 then         limita[0,indu+3]= limita[0,indu+3]>0.
       if fita[    indu+3]      then         bounda[*,indu+3]= 1
                                     endif

       if (resot gt 0) and (name[k] eq 'delta') then begin

          if fxreso then begin & func_conv=KPfunc_conv & nloop=1 & endif
          if fxreso then begin ;It seems that width 'Delta' or model=1 then nloop=1
             if nloop eq 2 then begin & if fita[indu+2] then a[indu+2]=fxwidth[kspec<fxwsz,0]
             endif         else begin & if fita[indu+2] then a[indu+2]=fxwidth[kspec<fxwsz,1]
                                      limita[0,indu+2]=Xunit/3.
                                      limita[0,indu+1]=a[indu+1]-fxwidth[kspec<fxwsz,0]/2.
                                      limita[1,indu+1]=a[indu+1]+fxwidth[kspec<fxwsz,0]/2.
                                      if fita[indu] then $
                                        if (follow eq 0) or  (follow eq 2) or (ispec eq prems) then $
                                          a[indu]  =a[indu]*fxwidth[kspec<fxwsz,0]/fxwidth[kspec<fxwsz,1]*2/3 $
                                        else if (follow ne 0) and (follow ne 2) then a[indu]=a[indu]
             endelse
             if (fita[indu+1]) and (long(abs(a[indu+1])) eq 0.) then a[indu+1]=fxwidth[kspec<fxwsz,2]
            ;GENIOUS !!!
             if (resot eq 1) or (resot eq 4) then fita[indu+2]=0 ;From a wks or a spectrum

          endif else if (fita[indu+2]) then begin ;Never goes here !!!
           limita[0,indu+2]=Xunit/3.
           if nloop eq 1 then begin
             newidth  =(a[indu+2]-(fwdt_conv*Xunit/2.))>(Xunit)    ;new Width  decreased
             newheight= a[indu]*a[indu+2]/ newidth                 ;new Height increased
             if fita[indu]   then a[indu]  = newHeight
             if fita[indu+2] then a[indu+2]= newidth
           endif
          endif      
       endif
       
      endfor
     endif;classical functions
    endif;follow or prems
    
    FitOrNot=fita ;Used by model=5 in str_UserModl, 0 is fixed

  endif else begin ;other models
    if n_elements(lcenter)  eq 1  then begin & a[ind+1]=a[ind+1]>lcenter & bounda[0,ind+1]=1 & limita[0,ind+1]=lcenter & endif
    if n_elements(ucenter)  eq 1  then begin & a[ind+1]=a[ind+1]<ucenter & bounda[1,ind+1]=1 & limita[1,ind+1]=ucenter & endif

    if (nloop eq 1) and (ind[0] ge 0) then begin ;----------------fWmH if one loop only (else at resolution time: loop=2)

      if n_elements(lfWmH)    eq 1  then $
      if (modl eq 0) or (modl eq 1) then begin & a[0+2]  =a[0+2]  >lfWmH   & bounda[0,0+2]  =1 & limita[0,0+2]  =lfWmH   & endif $
                                    else begin & a[ind+2]=a[ind+2]>lfWmH   & bounda[0,ind+2]=1 & limita[0,ind+2]=lfWmH   & endelse
      if n_elements(ufWmH)    eq 1  then $
      if (modl eq 0) or (modl eq 1) then begin & a[0+2]  =a[0+2]  <ufWmH   & bounda[1,0+2]  =1 & limita[1,0+2]  =ufWmH   & endif $
                                    else begin & a[ind+2]=a[ind+2]<ufWmH   & bounda[1,ind+2]=1 & limita[1,ind+2]=ufWmH   & endelse

      if n_elements(fWmH)     eq 1  then $                                                 ;   fixed width      <-----------
      if (modl eq 0) or (modl eq 1) then begin & a[0+2]   =fWmH   & fita[0+2]   =0 & endif $ ;   for 1 or frst centered peak
                                    else begin & a[ind+2] =fWmH   & fita[ind+2] =0 & endelse ;   for all if double or multi peaks
    endif                     ;---------------------

    if Nflat                eq 1  then begin & a[npr*nk]  =flat   & fita[npr*nk]=0 & endif ; fixed background <-----------
    if keyword_set(num_bfix)      then    fita[npr*nk+1]=0                               ; fixed shape bkgd <-----------
    if n_elements(center)   eq 1  then $                                                 ; fixed position   <-----------
    if (modl eq 0) or (modl eq 1) then begin & a[ind+1]   =center & fita[ind+1] =0 & endif ; for 1 or centered peaks
  endelse
  if (modl eq 1) or (modl eq 2) then begin
   if modl eq 1 then begin                                                      ; ****** Model centered peaks ******
     nx0=a[1] & nw0=a[2] & t1=2. & t2=1. & dv=2.
     in1=ind[1:*] & if nk ne 4 then inm=findgen(nk-1)+1. else inm=[1.,2.,2.]
     if n_elements(ht2) eq 1 then a[in1]  =ht2/inm else a[in1]  =a[0]/inm/20.   ; other height much lower
     a[0]=a[0]-total(a[in1])
     a[ind+1]=a[1]                                                              ; same position  or
     if nk eq 4 then begin & a[ind[2]+1]=a[1]-a[2]/dv & fita[ind[2]+1]=1          ; + right & left center if nk=4
                           a[ind[3]+1]=a[1]+a[2]/dv & fita[ind[3]+1]=1 & endif  ;    ""
     if n_elements(fw2) eq 1 then a[in1+2]=fw2*inm else a[in1+2]=a[2]*inm*3.    ; other width  much wider
   endif

   if modl eq 2 then begin                                                      ; ****** Model double peak ******
     nx0=a[1] & nw0=a[2] & t1=1. & t2=2. & dv=2.
     a[ind+2] =a[2] & if fita[0+2] eq 1 then a[ind+2]=a[ind+2]*2./3.            ; width*2/3 (if not fWmH)
     a[ind]   =a[0]/2.  & hdj=1.03                                              ; height /2
     if nx0 lt X[i0] then begin & a[0]=a[0]/hdj & a[3]=a[3]*hdj & endif           ; ""
     if nx0 gt X[i0] then begin & a[0]=a[0]*hdj & a[3]=a[3]/hdj & endif           ; ""
     a[ind+1] =a[1] & a[1]=a[1]-a[2]/dv  & a[4]=a[4]+a[2]/dv  & fita[ind+1]=1   ; positions right & left center
     if nk gt 2 then begin                                                      ; additionnal peaks:
          a[6]=a[6]/1.5 & if nk gt 3 then begin
                          a[9]=a[9]/10. & a[11]=a[11]*4.      & endif & endif   ; Fourth: H/20 & W*2
   endif

     bounda[0,ind]  =1 & limita[0,ind]  =1e-14                                  ; height>0
     bounda[1,ind]  =1 & limita[1,ind]  =a[0]*3.                                ; height<a(0)*3.
     a[ind]=a[ind] > 1e-14 < (a[0]*3.)
     
     dx0=a[2]/2.
     if n_elements(lcenter) ne 1 then begin & bounda[0,ind+1]=1  ; position inside data -
        limita[0,ind+1]   = (nx0-nw0/t1) > (Xa  -dx0)
        a[ind+1]=a[ind+1] >((nx0-nw0/t1) > (Xa  -dx0)) ;Take a long?
     endif else a[ind+1]=a[ind+1]>limita[0,ind+1]
     
     if n_elements(ucenter) ne 1 then begin & bounda[1,ind+1]=1  ; position inside data +
        limita[1,ind+1]   = (nx0+nw0/t1) < (Xb+dx0)
        a[ind+1]=a[ind+1] <((nx0+nw0/t1) < (Xb+dx0)) ;Take a long?
     endif else a[ind+1]=a[ind+1]<limita[1,ind+1]

     if n_elements(lfWmH)   ne 1 then begin & bounda[0,ind+2]=1  ; width >0<(abs(X(n-1)-X(0))/2)
        limita[0,ind+2]   =1e-14
        a[ind+2]=a[ind+2] >1e-14
     endif else for L=0,n_elements(ind)-1 do if limita[0,ind[L]+2] eq 1 then a[ind[L]+2]=a[ind[L]+2]>limita[0,ind[L]+2]
     
     if n_elements(ufWmH)   ne 1 then begin & bounda[1,ind+2]=1
        limita[1,ind+2]   = (Xb-Xa)/t2
        a[ind+2]=a[ind+2] <((Xb-Xa)/t2)
     endif else for L=0,n_elements(ind)-1 do if limita[1,ind[L]+2] eq 1 then a[ind[L]+2]=a[ind[L]+2]>limita[1,ind[L]+2]

    ;if npb eq 1   then  if Nflat   ne 1 then bounda(0,npr*nk)=1 & limita(0,npr*nk)=0.; backgrd >0  POURQUOI????
     if bounda[0,npr*nk] eq 1 then a[npr*nk]=a[npr*nk]   > limita[0,npr*nk]                      ; ""

     if fxreso then if nloop eq 1 then if n_elements(fWmH) eq 0  then begin
                                tmp=a[0+2]  & a[0+2]=fxwidth[kspec<fxwsz,1] ;<----------- fxreso modl=1 ->fixed width
                                a[0]=a[0]*tmp/a[0+2]*2/3 & bounda[1,0]=0
                                limita[0,1]=a[1]-fxwidth[kspec<fxwsz,0]/2.
                                limita[1,1]=a[1]+fxwidth[kspec<fxwsz,0]/2.
                                if (fita[0+1]) and (long(a[0+1] eq 0.)) then a[0+1]=fxwidth[kspec<fxwsz,2]
                                if (resot eq 1) or (resot eq 4) then fita[0+2]=0 & endif
  endif ;modl 1 or 2

  if modl eq 3 then begin                                                       ; ****** Model several peaks ******
     dx=a[ind+2]/2.
     bounda[0,ind]  =1                                                          ;Height>0
     bounda[*,ind+1]=1 & limita[0,ind+1]=Xa-dx & limita[1,ind+1]=Xb+dx          ;Position in data range
     if n_elements(lfWmH) ne 1 then limita[0,ind+2]=Xunit/3.                    ;Width reasonable
     if n_elements(ufWmH) ne 1 then limita[1,ind+2]=(fwdt_conv*Xunit*10.)<(Xb-Xa)/2.
     bounda[*,ind+2]=1
     if (fita[npr*nk] eq 1) and (npb eq 1) then bounda[0,npr*nk]=1              ;Flat  >0
  endif

  for jlo=1,nloop do begin ;Loop once if no resolution (or fxresol), twice if resolution is there

  ;*******************************************************
  ;CURVE FITTING CURVE FITTING CURVE FITTING CURVE FITTING
  ;*******************************************************
  if myfunc gt ' ' then peak_fit=coolfit(X,F,weight,a,fita=fita,bounda=bounda,limita=limita,s,tied=tied,function_name=myfunc,itmax=itmax,iter=it,tol=1e-3,noderiv=noderiv,MPF=mpf,CHISQ=chisq)
  if myfunc gt ' ' then toti=toti+it
  if (frac gt 0.) and (frac lt 1.) then begin & ok=1
    if pseudo then begin
       aa[*]=[kas+frac,a] & ss[*]=[kas,s]  & fpsd=[-1]                      ; fit pseudo fractional parameter
       peak_fit=coolfit(X,F,weight,aa,fita=[kas+1,fita],bounda=[[k2as],[bounda]],limita=[[k2as],[limita]],ss,function_name='str_pseudo',itmax=itmax,iter=it,noderiv=noderiv,MPF=mpf,CHISQ=chisq)
       toti=toti+it
       fpsd= round((aa[0:nk-1]>0.<1.)*100.) /100.
       epsd= round((ss[0:nk-1]>0.<1.)*1000.)/1000.
       ok=0 & for q=0,nk-1 do if (aa[q] lt 0.) or (aa[q] gt 1.) then ok=1
       if ok eq 0 then begin & a=aa[nk:*] & s=ss[nk:*] & endif            ; do not re_fit if 0<f<1
    endif                                                               ; fit with pseudo factor fixed 0<f<1
    if ok then peak_fit=coolfit(X,F,weight,a,fita=fita,bounda=bounda,limita=limita ,s ,function_name='str_pseudo',itmax=itmax,iter=it,noderiv=noderiv,MPF=mpf,CHISQ=chisq)
    if ok then toti=toti+it
  endif
 ;s(where(fita eq 0))=0.
  if modl lt 5 then if ind[0] ge 0 then a[ind+2]=abs(a[ind+2])
  ;*******************************************************
  ;*******************************************************


  if ((abs(follow) eq 1) or (abs(follow) eq 3)) then if (jlo eq 1) then KPa=a else KPb=a

  if (nloop  eq 2) and (jlo eq 1) then begin ;Fit again with the convolution function  (modl 0,1,2,5)
 ;****************************************** ;Not 'Delta'
   if (itmax gt 1) and ind[0] ge 0 then begin            ;if itmax >1 (not "see only")
    newidth   =(a[ind+2] -(fwdt_conv*Xunit/2.))>(Xunit)  ;decrease width
    newheight = a[ind+0] * a[ind+2]/newidth              ;increase height
    for ii=0,n_elements(ind)-1  do begin
      if fita[ind[ii]]   ne 0   then begin & a[ind[ii]]  =newheight[ii]>1e-14
         if modl ne 5 then bounda[1,ind[ii]] =0
         if bounda[0,ind[ii]]   then a[ind[ii]]   =a[ind[ii]]  >limita[0,ind[ii]]
         if bounda[1,ind[ii]]   then a[ind[ii]]   =a[ind[ii]]  <limita[1,ind[ii]]
      endif
      if fita[ind[ii]+2] ne 0   then begin & a[ind[ii]+2]=newidth[ii]
         if modl ne 5 then limita[0,ind[ii]+2]=Xunit/3.
         if bounda[0,ind[ii]+2] then a[ind[ii]+2] =a[ind[ii]+2]>limita[0,ind[ii]+2]
         if bounda[1,ind[ii]+2] then a[ind[ii]+2] =a[ind[ii]+2]<limita[1,ind[ii]+2]
      endif
    endfor
    
   ;Repeated code ------------------ (modl 0,1,2)
    if n_elements(lfWmH)    eq 1  then $
    if (modl eq 0) or (modl eq 1) then begin & a[0+2]  =a[0+2]  >lfWmH   & bounda[0,0+2]  =1 & limita[0,0+2]  =lfWmH   & endif $
                                  else begin & a[ind+2]=a[ind+2]>lfWmH   & bounda[0,ind+2]=1 & limita[0,ind+2]=lfWmH   & endelse
    if n_elements(ufWmH)    eq 1  then $
    if (modl eq 0) or (modl eq 1) then begin & a[0+2]  =a[0+2]  <ufWmH   & bounda[1,0+2]  =1 & limita[1,0+2]  =ufWmH   & endif $
                                  else begin & a[ind+2]=a[ind+2]<ufWmH   & bounda[1,ind+2]=1 & limita[1,ind+2]=ufWmH   & endelse

    if n_elements(fWmH)     eq 0  then $
    if (modl eq 1)                then if fxreso then begin & a[0+2]=fxwidth[kspec<fxwsz,1]                  ;<-----------
                                       if (resot eq 1) or (resot eq 4) then fita[0+2]=0 & endif            ;<-----------
    if n_elements(fWmH)     eq 1  then $                                                 ; fixed width      <-----------
    if (modl eq 0) or (modl eq 1) then begin & a[0+2]   =fWmH   & fita[0+2]   =0 & endif $ ; for 1 or frst centered peak
                                  else begin & a[ind+2] =fWmH   & fita[ind+2] =0 & endelse ; for all if double or multi peaks
   ; -------------------------------
   endif
   func_conv=kpfunc_conv ;set convolution in func_conv
  endif
  endfor

  if abs(follow) lt 2 then begin

    if (nowe) and (mpf eq 1) then begin & nfax=where(fita eq 0) & nfree=NXX
                                        if nfax[0] ge 0 then nfree=(nfree-n_elements(nfax))>1
                                       ;Chisq already divided by nfree in COOL2MP
                                        s=s*sqrt(chisq/1.)  & endif ;No weighting
    if n_elements(fpsd) ne nk then fpsd=fltarr(nk)+fpsd[0]          ;was fixed or modl=5
    if n_elements(epsd) ne nk then epsd=fltarr(nk)

    if (folQexp[0] gt ' ') or (n_elements(folQexp) gt 1) then begin
       idxq=where(folQexp gt ' ') & P=A  ;Q expression (partial param fit)
       for i=0,n_elements(idxq)-1 do begin & ii=execute( 'A[idxq[i]]='+folQexp[idxq[i]]+' & fcte='+folQexp[idxq[i]]+'/P[idxq[i]]' )
                                          ;ii=execute( 'S[idxq[i]]=S[idxq[i]]*fcte')
       endfor
    folQexp=[''] & endif

    str_Integral, X, A, F, F_i, D_i, F_a,F_e,S, epsd ,modl,npr,npb ,mfitc ,pdelta ,SpecCfunc

   ;*************************************************************************
   ;STORE FITTED PARAMETERS ;STORE FITTED PARAMETERS ;STORE FITTED PARAMETERS
   ;*************************************************************************
    ;Should back interpolate if resolution is there?
    ;**********************************************
    n=folXn[kspec<(sx-1)]
    if n gt 1 then begin
       peak_fit=INTERPOL(peak_fit,X,datp.X[ddx:dlx,ispec<(sx-1)],/quad)
       mfitc   =INTERPOL(mfitc   ,X,datp.X[ddx:dlx,ispec<(sx-1)],/quad)>0.
    endif

    if debug then print,'finals  ',ispec+1,' f=',fpsd[0],' H=',a[0],' P=',a[1],' W=',a[2],' bg=',a[npr*nk],' data_int-bg [Xrange]=',D_i,' fit_int [Xrange]=',F_i
    fit_pars[  kspec,0,0:nk-1]         =fpsd                         ; get PVfactor from fit
    fit_sigmas[kspec,0,0:nk-1]         =epsd                         ; and errors
    for ik=0,nk-1 do begin
    fit_pars[  kspec,1:npr<3,ik]       =a[npr*ik:npr*ik+(npr<3)-1]   ; get other parameters from fit
    fit_sigmas[kspec,1:npr<3,ik]       =s[npr*ik:npr*ik+(npr<3)-1]   ; and errors
    if npr gt 3 then begin
    fit_pars[  kspec,10:10+npr-4,ik]   =a[npr*ik+3:npr*ik+3+npr-4]   ; put other parameters (4,5..) at the end
    fit_sigmas[kspec,10:10+npr-4,ik]   =s[npr*ik+3:npr*ik+3+npr-4]   ; and errors
    endif
    endfor
    fit_pars[  kspec,1+3:3+npb,0]      =a[npr*nk:npr*nk+npb-1]       ; get background
    fit_sigmas[kspec,1+3:3+npb,0]      =s[npr*nk:npr*nk+npb-1]       ; ""

    fit_pars[  kspec,7,0:nk-1]         = D_i                         ; and integrals data
    fit_pars[  kspec,8,0:nk-1]         = F_i                         ; and integrals fit
    fit_pars[  kspec,9,0:nk-1]         = F_a                         ; and function theorical area
    fit_sigmas[kspec,9,0:nk-1]         = F_e                         ; with errors
    if D_i ne 0. then $
    fit_sigmas[kspec,7,0]              =(F_i/D_i)>0.<10.             ; int ratio

    Wout[  ddx,kspec]                  = peak_fit                    ; and peak_fit
    mfit[  ddx,kspec]                  = mfitc                       ; peak_fit - background (deconvoluted)
    if fxreso then delta[ddx,kspec]    = pdelta                      ; delta peak (convoluted) !!!

    for ik=0,nk-1 do Cfunc[ddx,kspec,ik] =SpecCfunc[*,ik]

  endif else if ispec eq prems then begin     ;2d fit <************
             a_=a      & fita_= fita         & bounda_ =  bounda               & limita_=  limita
             if n_elements(folQexpd) gt 1 then folQexp_=  folQexpd & if n_elements(tiedd) gt 0 then tied_=tiedd
        endif else if follow gt 0 then begin
             a_=[a_,a] & fita_=[fita_,fita]  & bounda_ =[[bounda_] ,[bounda]]  & limita_=[[limita_],[limita]]
             if n_elements(folQexpd) gt 1 then folQexp_=[ folQexp_ , folQexpd]
             if n_elements(tiedd)    gt 0 then tied_   =[ tied_    , tiedd]
        endif else begin
             a_=[a,a_] & fita_=[fita,fita_]  & bounda_ =[[bounda]  ,[bounda_]] & limita_=[[limita],[limita_]]
             if n_elements(folQexpd) gt 1 then folQexp_=[ folQexpd , folQexp_]
             if n_elements(tiedd)    gt 0 then tied_   =[ tiedd    , tied_]
        endelse

  if maystop then begin & evv=widget_event(stop_id,/nowait,bad_id=ii); Check for interrupt
     if evv.id eq stop_id then goto,end4                           ; break introduced Idl5.4
     widget_control,/hourglass & endif

  ChiRes[kspec] = ChiSQ
  fit_pars[  kspec, -1, 0:nk-1] = ChiRes[kspec]

endfor ;fitting all spectra
;**************************
;**************************

ChiMean = total(ChiRes) / nspec

;2D Fit
;******
if abs(follow) gt 1 then begin

 if oklab then widget_control,ilab,bad_id=ii,set_value='-> 2d fitting       '

 for ispec=frst,lst do begin & kspec=ispec-frst
    n=abs(folXn[kspec<(sx-1)])
    if kspec eq 0 then begin & X_=folXx[0:n-1,kspec] & F_=folXf[0:n-1,kspec] & weight_=folXe[0:n-1,kspec]
    endif else begin
      if sx gt 1 then X_       =[X_     ,folXx[0:n-1,kspec]] $         ;X
                 else X_       =[X_     ,X]
                      F_       =[F_     ,folXf[0:n-1,kspec]]           ;Spectrum
                      weight_  =[weight_,folXe[0:n-1,kspec]] & endelse ;Errors
 endfor
 if n_elements(folQexp_) gt 1 then folQexp=folQexp_
 noTie2D=(mpf eq 3) ;RMD_GA
 folSpec=nspec
 
 if nspec gt 1 then begin                                   ; We will replace tied a_ by there MEDIAN.
    tmpT =reform(tied_,n_elements(tied_)/nspec,nspec)
    idxT0=strpos(tmpT[*,0],bopL) & idxT0=where( idxT0 eq 0) ; Tied on itself ONLY.
    idxT =strpos(tmpT[*,1],bopL) & idxT =where( idxT  eq 0) ; We may have only two spectra
    if idxT[0] eq -1 then idxT=idxT0                        ; and follow is pos or neg....
    if idxT[0] ge 0 then begin
       fita_=reform(fita_ ,n_elements(fita_)/nspec,nspec)
       a_   =reform(a_    ,n_elements(a_)   /nspec,nspec)   ; reform just to do the work

       for ntie=0,n_elements(idxT)-1 do a_[idxt[ntie],*]=reform(median(a_[idxt[ntie],*],/even))
       if noTie2D then fita_[idxT,*]=0 ;RMD_GA

       a_   =reform(a_    ,n_elements(a_))                  ; reform back
       fita_=reform(fita_ ,n_elements(fita_))
    endif
 endif
 FitOrNot=fita_            ;Used only by model=5 in str_UserModl

 if n_elements(datp.y) ge nspec then Qcurrent2D=datp.Y[frst:lst] ;Used only by model=5 in str_UserModl (for Qens functions)

;******************
 peak_fit2d=coolfit(X_,F_,weight_,a_,fita=fita_,bounda=bounda_,limita=limita_,s,tied=tied_,function_name=myfunc,itmax=itmax,iter=it,tol=1.e-3,noderiv=noderiv,MPF=mpf,CHISQ=chisq)
;******************

;s(where(fita eq 0))=0.
 folSpec= 1
 folQexp= ['']
 toti   = toti+it
 nfax   = where(fita_ eq 0) & nfree=n_elements(F_) ; calculate freedom parameters
 if nfax[0] ge 0 then nfree =(nfree-n_elements(nfax)) > 1

 if (nowe) and (mpf eq 1) then begin ;Chisq already divided by nfree in COOL2MP
                                      s=s*sqrt(chisq/1.)  & endif                ;No weighting
 if n_elements(folQexp_) gt 1 then begin & idxq=where(folQexp_ gt ' ') & P=A_    ;Q expression (partial param fit)
    for i=0,n_elements(idxq)-1 do ii=execute( 'A_[idxq[i]]='+folQexp_[idxq[i]] ) & endif
 a_=reform(a_,n_elements(a_)/nspec,nspec)
 s_=reform(s ,n_elements(s) /nspec,nspec)
 nn=0
 for ispec=frst,lst do begin & kspec=ispec-frst
    ddx=folXi[0,kspec<(sx-1)]  & dlx=folXi[1,kspec<(sx-1)]
    n  =folXn[kspec<(sx-1)]    & nab=abs(n)
    if sx gt 1 then   X        = folXx[0:nab-1,kspec]                ;X
                      F        = folXf[0:nab-1,kspec]                ;Spectrum
                      weight   = folXe[0:nab-1,kspec]                ;Errors
                     peak_fit = peak_fit2d[nn:nn+nab-1] & nn=nn+nab  ;Fit
    A=a_[*,kspec]
    S=s_[*,kspec]

    ChiRes[kspec] = total(Weight*(F-peak_fit)^2)/((nfree/nspec)>1)   ; Chi2 by spectrum

    if n_elements(Qcurrent2D) gt kspec then Qcurrent1D =  Qcurrent2D[kspec]
    if n_elements(KPdim2) gt 1 then func_conv=KPfct2[0:KPdim2[kspec]-1,kspec]  ;Resolution

    fpsd=fltarr(nk)+frac & epsd=fpsd*0.

    str_Integral, X, A, F, F_i, D_i, F_a,F_e,S, epsd ,modl,npr,npb ,mfitc ,pdelta ,SpecCfunc

    ;Should back interpolate if resolution is there?
    ;**********************************************
    if n gt 1 then begin
       peak_fit=INTERPOL(peak_fit,X,datp.X[ddx:dlx,ispec<(sx-1)],/quad)
       mfitc   =INTERPOL(mfitc   ,X,datp.X[ddx:dlx,ispec<(sx-1)],/quad)>0.
    endif

    fit_pars[  kspec,0,0:nk-1]         =fpsd                               ; get PVfactor from fit
    fit_sigmas[kspec,0,0:nk-1]         =epsd                               ; and errors
    for ik=0,nk-1 do begin
    fit_pars[  kspec,1:npr<3,ik]       =a[npr*ik:npr*ik+(npr<3)-1]         ; get other parameters from fit
    fit_sigmas[kspec,1:npr<3,ik]       =s[npr*ik:npr*ik+(npr<3)-1]         ; and errors
    if npr gt 3 then begin
    fit_pars[  kspec,10:10+npr-4,ik]   =a[npr*ik+3:npr*ik+3+npr-4]         ; put other parameters (4,5..) at the end
    fit_sigmas[kspec,10:10+npr-4,ik]   =s[npr*ik+3:npr*ik+3+npr-4]         ; and errors
    endif
    endfor
    fit_pars[  kspec,1+3:3+npb,0]      =a[npr*nk:npr*nk+npb-1]             ; get background
    fit_sigmas[kspec,1+3:3+npb,0]      =s[npr*nk:npr*nk+npb-1]             ; ""

    fit_pars[  kspec,7,0:nk-1]         = D_i                               ; and integrals data
    fit_pars[  kspec,8,0:nk-1]         = F_i                               ; and integrals fit
    fit_pars[  kspec,9,0:nk-1]         = F_a                               ; and function theorical area
    fit_sigmas[kspec,9,0:nk-1]         = F_e                               ; with errors
    if D_i ne 0. then $
    fit_sigmas[kspec,7,0]              =(F_i/D_i)>0.<10.                   ; int ratio

    Wout[  ddx,kspec]                  = peak_fit                          ; and peak_fit
    mfit[  ddx,kspec]                  = mfitc                             ; peak_fit - background (deconvoluted)
    if fxreso then delta[ddx,kspec]    = pdelta                            ; delta peak (convoluted) !!!

    for ik=0,nk-1 do Cfunc[ddx,kspec,ik] =SpecCfunc[*,ik]
    
    fit_pars[  kspec, -1, 0:nk-1] = ChiRes[kspec]

 endfor
  
 ChiMean = ChiSQ
 
endif ;2D FIT
;************
end4:

;**************************************************
;**************************************************
if (modl eq 1) or (modl eq 2) then if not sep2 then begin ;return a one peak parameter set from a double peak
   for i=0,nspec-1 do begin & fct=fit_pars[i,1+0,*] * fit_pars[i,1+2,*] & tfct=total(fct)
       for j=0,npr do begin & fit_pars[  i,j,0]=total(fit_pars[  i,j,*]*fct,3)/tfct
                            fit_sigmas[i,j,0]=total(fit_sigmas[i,j,*]*fct,3)/tfct & endfor
       mmx  =max(  mfit[*,i]) & fit_pars[i,1,0]=mmx            ;Height

       mm2  =mmx/2. & ida=where(mfit[*,i] ge mm2)                                    ;Width
       nida =n_elements(ida)-1 & npnt =n_elements(mfit)-1 & j=i<(sx-1)
       frsth=mfit[   ida[0]     ,i]         & lasth =mfit[   ida[nida]        ,i]
       lefth=mfit[  (ida[0]-1)>0,i]         & righth=mfit[  (ida[nida]+1)<npnt,i]
       lfact=((frsth-mm2)/(frsth-lefth))>0. & rfact =((lasth-mm2)/(lasth-righth))>0.
       frstp=datp.X[ ida[0]     ,j]         & lastp =datp.X[ ida[nida]        ,j]
       leftp=datp.X[(ida[0]-1)>0,j]         & rightp=datp.X[(ida[nida]+1)<npnt,j]
       sunit=abs((lastp*(1.-rfact)+rightp*rfact) - (frstp*(1.-lfact)+leftp*lfact))
       fit_pars[i,3,0]=Sunit                                                         ;Width

       fit_pars[i,9,0]=total(fit_pars[i,9,*])                  ;Sum
   endfor
   fit_pars=fit_pars[*,*,0] & fit_sigmas=fit_sigmas[*,*,0] & nk=1
endif
if (modl eq 3) then begin & nk=curnk
    fit_pars  =fit_pars[*,*,0:nk-1]
    fit_sigmas=fit_sigmas[*,*,0:nk-1]
endif 

if swww ne 5 then begin & fit_pars=float(fit_pars) & fit_sigmas=float(fit_sigmas) & endif

;Where the data come from (D20 ID31 SALSA Unknown)
ptxt=datp.par_txt & xtr =[0.] & ytr =[0.] & ztr=[0.] & omg=[0.] & tth=[0.] 
xro=[0.] & yro=[0.] & zro=[0.] & inst='?'
moni=reform([datp.N]) & time=reform([datp.N])

;D20
if n_elements(ptxt) gt 18 then if strpos(ptxt[17],'Tr.1') eq 0 then begin
    idx=17 & ido=14 & idt=13 & inst='D20'
    if (size(datp.pv))[1] eq n_elements(datp.p) then begin
        xtr=datp.pv[idx,*] & ytr=datp.pv[idx+1,*] ;& ztr=datp.pv(idx+2,*)
        omg=datp.pv[ido,*] & tth=datp.pv[idt,*]
    endif else begin
        xtr=datp.p[idx]  & ytr=datp.p[idx+1] 
        omg=datp.p[ ido] & tth=datp.p[ idt]   
    endelse
endif
   
;ID31
if strpos(ptxt[0],'#F ') eq 0 then begin 
    idx=0 & ido=0 & idt=0
    for i=0,n_elements(ptxt)-1 do if strpos(ptxt[i],'X Translation') eq 0 then idx=i else $
                                  if strpos(ptxt[i],'Omega=') eq 0 then ido=i else $
                                  if strpos(ptxt[i],'2_theta=') eq 0 then idt=i else $
                                  if strpos(ptxt[i],'Chi=')   eq 0 then idc=i & if idx gt 0 then inst ='ID31'
    if idx gt 0 then if (size(datp.pv))[1] eq n_elements(datp.p) then begin 
        xtr =datp.pv[idx,*]    & ytr =datp.pv[idx+1,*] & ztr=datp.pv[idx+2,*]
        omg =datp.pv[ido,*]    & tth =datp.pv[idt,*]
    endif else begin
        xtr=datp.p[idx]   & ytr=datp.p[idx+1] & ztr =datp.p[idx+2]     
        omg =datp.p[ ido] & tth=datp.p[ idt] 
    endelse 
endif
    
;SALSA --> Firt parameter written either as 2*Theta (before 2019) or 0) 2*Theta
if strpos(ptxt[0],'2*Th') eq 0 or strpos(ptxt[0],'2*Th') eq 3 then begin
    idx=0 & ido=1 & idt=0
    for i=0,n_elements(ptxt)-1 do begin
        if strpos(ptxt[i],'X_translation') eq 0 or strpos(ptxt[i],'X_translation') eq 3 then idx=i 
        if idx gt 0 then inst='SALSA'
    endfor
    if idx gt 0 then if (size(datp.pv))[1] eq n_elements(datp.p) then begin
        xtr =datp.pv[idx,*]    & ytr =datp.pv[idx+1,*] & ztr=datp.pv[idx+2,*]
        xro =datp.pv[idx+3,*]  & yro =datp.pv[idx+4,*] & zro=datp.pv[idx+5,*]
        omg =datp.pv[ido,*]    & tth =datp.pv[idt,*]
    endif else begin
        if (((size(datp.pv))[2] eq vspec) and ((size(datp.pv))[1] ge 10)) $
           or ( (vspec eq 1) and (n_elements(datp.pv) ge 10) and (n_elements(datp.pv) lt  n_elements(datp.p)) ) then begin
               idx =5 & ido=4 & idt=3 
               datp.pv=round(datp.pv*10.)/10000.
               xtr  = datp.pv[idx,*]    & ytr  = datp.pv[idx+1,*] & ztr = datp.pv[idx+2,*]
               xro  = datp.pv[idx+3,*]  & yro  = datp.pv[idx+4,*] & zro = datp.pv[idx+5,*]
               omg  = datp.pv[ido,*]    & tth  = datp.pv[idt,*]
               time = datp.pv[0,*]*1000 & moni = datp.pv[1,*]*1000
               chi  = datp.pv[20,*]     & phi  = datp.pv[21,*]
               angl = datp.pv[12,*]
        endif else begin
             xtr = datp.p[idx]    & ytr = datp.p[idx+1]  & ztr = datp.p[ idx+2] 
             xro = datp.p[ idx+3] & yro = datp.p[ idx+4] & zro = datp.p[ idx+5] 
             omg = datp.p[ ido]   & tth = datp.p[ idt]
        endelse 
    endelse    
endif
nxtr =n_elements(xtr) -1 & nytr =n_elements(ytr) -1 & nztr=n_elements(ztr)-1
nomg =n_elements(omg) -1 & ntth =n_elements(tth) -1 & nxro=n_elements(xro)-1 & nyro=n_elements(yro)-1 & nzro=n_elements(zro)-1
nmoni=n_elements(moni)-1 & ntime=n_elements(time)-1

;WRITE OUTPUT FILE
;*****************

title=title+' Fit_function:'
if modl eq 5  then for i =0,nk-1 do title=title+' ,'+UserModl.name[i] else $
if modl eq 4  then title =title+'FREE' else $
if frac eq 0. then title =title+'Gauss'       else $
if frac eq 1. then title =title+'Lorentz'     else   title=title+'Pseudo_Voigt'
if sb   gt 0  then bktxt ='(+a1.shapeBgd)              '
if sb   le 0  then bktxt ='(+a1.x +a2.x^2)             '

ChiText = 'Mean CHI square = '+ string(round(ChiMean*100.)/100. ,format='(F6.2)')

if n_elements(datp.y) eq sw[2] then YY=datp.y else YY=indgen(sw[2])+1
 
 
if n_elements(file_out) ne 1 then file_out=''
if file_out gt ' ' then begin

on_ioerror,miswrt & u=-1
explain=['']
if keyword_set(append) then openw,u,file_out,/append,/get_lun else openw,u,file_out,/get_lun
if keyword_set(append) then begin & printf,u,'' & printf,u,'***New fit' & printf,u,'***New fit' & printf,u,''
endif else if inst ne 'SALSA' then explain=['',$
                      'Sigma=s     return errors for all fitted parameters [nspectra , nparams , nfunct]',$
                      'Res_dfit=d  return filtered fit (no background, deconvoluted)  [nx , nspectra]'   ,$
                      'Fit=f       return fitted spectra (+background,   convoluted)  [nx , nspectra]'   ,$
                      'Fout=n      return fitted spectra in Wrks number N             [nx , nspectra]'   ,$
                      'Convfunc=c  return convoluted functions (no background) [nx , nspectra , nfunct]' ,$
                      'out_subF=r  return deconvoluted functions indexed by out_subi=[index] [nx , nspectra , nindex]']
 
if swww eq 5 then begin & fit_pars=float(fit_pars) & fit_sigmas=float(fit_sigmas) & endif
 
if oklab then widget_control,ilab,bad_id=ii,set_value=strmid('-> '+file_out+'                ',0,20)

printf,u,title
if datp.other_tit gt '' then printf,u,datp.other_tit
if datp.history   gt '' then printf,u,datp.history
printf,u,ChiText
if n_elements(incmd) eq 1 then printf,u,'Call: '+incmd else printf,u,' '
printf,u,' '

if inst ne '?' then begin
    printf, u, format='("Spectra", 2x, "pseudo_V", 1x, "e", 11x, "height", 9x, "e", $)'
    printf, u, format='(14x, "center", 7x, "e", 16x, "fWmH", 11x, "e", 14x, "background", $)'
    printf, u, format='(6x, "e", 14x, A, 2x, "a2", 13x, "e", 13x, "fit_area", 7x, "e", $)', bktxt
    printf, u, format='(14x, "raw_int", 9x, "Xtransl.", 7x, "Ytransl.", 7x, "Ztransl.", $)
    printf, u, format='(7x, "Omega", 10x, "2_theta", 6x, "Xrotation", 4x, "Yrotation", $)
    printf, u, format='(7x, "Zrotation", 5x, "Monitor", 3x, "Time", $)
    ;extra fields added for Salsa
    if n_elements(chi) gt 0 then printf, u, format='(14x, "Chi", $)'
    if n_elements(phi) gt 0 then printf, u, format='(12x, "Phi", $)'
    if n_elements(angl) gt 0 then printf, u, format='(10x, "Anglesx1000", $)'
    printf, u, format=''  
    for i=0,nspec-1 do begin
        for k=0,nk-1 do begin
            printf, u, YY[frst+i], '  ', $
              (fit_pars[i,0,k]>0), (fit_sigmas[i,0,k]), $
              (fit_pars[i,1,k])  , (fit_sigmas[i,1,k]), $
              (fit_pars[i,2,k])  , (fit_sigmas[i,2,k]), $
              (fit_pars[i,3,k])  , (fit_sigmas[i,3,k]), $
              (fit_pars[i,4,k])  , (fit_sigmas[i,4,k]), $
              (fit_pars[i,5,k])  , (fit_sigmas[i,5,k]), $
              (fit_pars[i,6,k])  , (fit_sigmas[i,6,k]), $
              (fit_pars[i,9,k])  , (fit_sigmas[i,9,k]), $
              (fit_pars[i,7,k]), $
              xtr[(frst+i)<nxtr], ytr[(frst+i)<nytr], ztr[(frst+i)<nztr], $
              omg[(frst+i)<nomg], tth[(frst+i)<ntth], $
              xro[(frst+i)<nxro], yro[(frst+i)<nyro], zro[(frst+i)<nzro],$
              long(moni[(frst+i)<nmoni]), $
              long(time[(frst+i)<ntime]), $
              format='(F7.2,A,F5.3,4X,F5.3,23G,4X,I8,1X,I8,$)'
            ;print extra info (for Salsa) only if available 
            if n_elements(chi)  gt 0 then printf, u, chi[(frst+i)<nxtr],  format='(1X, G, $)'
            if n_elements(phi)  gt 0 then printf, u, phi[(frst+i)<nxtr],  format='(1X, G, $)'
            if n_elements(angl) gt 0 then printf, u, angl[(frst+i)<nxtr], format='(1X, G, $)'
            printf, u, format=''
        endfor
    endfor                      
 endif else begin
    printf,u,'Spectra  pseudo_V e           P1.height      e           P2.center       e             P3.fWmH           e              background      e              '   +bktxt+  '  a2             e             fit_area       e      '+$
                                                                                                                                            '        raw_int'
    for i=0,nspec-1 do for k=0,nk-1 do $
                       printf,u,YY[frst+i],'  ',(fit_pars[i,0,k]>0),(fit_sigmas[i,0,k]),$
                                                (fit_pars[i,1,k])  ,(fit_sigmas[i,1,k]),$
                                                (fit_pars[i,2,k])  ,(fit_sigmas[i,2,k]),$
                                                (fit_pars[i,3,k])  ,(fit_sigmas[i,3,k]),$
                                                (fit_pars[i,4,k])  ,(fit_sigmas[i,4,k]),$
                                                (fit_pars[i,5,k])  ,(fit_sigmas[i,5,k]),$
                                                (fit_pars[i,6,k])  ,(fit_sigmas[i,6,k]),$
                                                (fit_pars[i,9,k])  ,(fit_sigmas[i,9,k]),$
                                                (fit_pars[i,7,k]),$
                                format='(F7.2,A,F5.3,4X,F5.3,15G)'
   if npr gt 3 then begin
    frmetc= strtrim((npr-3)*2,2)
    tmpetc= fltarr( (npr-3)*2)
    idxetc= indgen(  npr-3)*2
    paretc='Spectra        '
    for i=4,npr do paretc=paretc+'P'+strtrim(i,2)+'             e              '
    printf,u,''
    printf,u,paretc
    for i=0,nspec-1 do for k=0,nk-1 do begin
                       tmpetc[idxetc]   =(fit_pars[  i,10:10+npr-4,k])
                       tmpetc[idxetc+1] =(fit_sigmas[i,10:10+npr-4,k])
                       printf,u,YY[frst+i],'  ',tmpetc,format='(F7.2,A,'+frmetc+'G)'
    endfor
   endif
 endelse
 for i=0,n_elements(explain)-1 do printf,u,explain[i]

 miswrt: if u gt 0 then free_lun,u else lamp_error ;print,!error_state.msg

endif else if comd ge 0 then begin ;No output fileName So write in 'str_params.txt' if comd >=0

 on_ioerror,mispar & u=-1
 openw,u,'str_params.txt',/get_lun
 
 if swww eq 5 then begin & fit_pars=float(fit_pars) & fit_sigmas=float(fit_sigmas) & endif
 
 if oklab then widget_control,ilab,bad_id=ii,set_value=strmid('-> str_params.txt                ',0,20)
  
 printf,u,title
 printf,u,ChiText
 if n_elements(incmd) eq 1 then printf,u,'Call: '+incmd else printf,u,' '
 paretc=''
 sigetc=''
 frmetc=['8','9']
 if npr gt 3 then for i=4,npr do paretc=paretc+'             P'+strtrim(i,2)
 if npr gt 3 then sigetc='  ---  Other sigmas'
 if npr gt 3 then frmetc=[strtrim(8+npr-3,2),strtrim(9+npr-3,2)]
 printf,u,' '
 printf,u,'Spectra  PV_f          P1             P2            P3            background     '   +bktxt+  '  fit_area       raw_int'+paretc
 for i=0,nspec-1 do begin & for k=0,nk-1 do begin
     if npr le 3 then   printf,u,YY[frst+i],'  ',(fit_pars[i,0:6,k]), (fit_pars[i,9,k]), (fit_pars[i,7,k]) ,format='(F7.2,A,F5.3,8G)'
     if npr gt 3 then   printf,u,YY[frst+i],'  ',(fit_pars[i,0:6,k]), (fit_pars[i,9,k]), (fit_pars[i,7,k]), (fit_pars[i,10:10+npr-4,k]) ,format='(F7.2,A,F5.3,'+frmetc[0]+'G)'
 endfor & endfor
 printf,u,' '
 printf,u,'        1-sigma error on parameters  ---  fit_int/raw_int'+sigetc
 for i=0,nspec-1 do begin & for k=0,nk-1 do begin
     if npr le 3 then   printf,u,YY[frst+i],'  ',(fit_sigmas[i,0:6,k]), (fit_sigmas[i,9,k]), (fit_sigmas[i,7,k]), format='(F7.3,A,F5.3,9G)'
     if npr gt 3 then   printf,u,YY[frst+i],'  ',(fit_sigmas[i,0:6,k]), (fit_sigmas[i,9,k]), (fit_sigmas[i,7,k]), (fit_sigmas[i,10:10+npr-4,k]),format='(F7.3,A,F5.3,'+frmetc[1]+'G)'
 endfor & endfor
 for i=0,n_elements(explain)-1 do printf,u,explain[i]

 mispar: if u gt 0 then free_lun,u else lamp_error ;print,!error_state.msg

endif ;output parameters in a file

;give back fitted SUB FUNCTIONS if asked
;***************************************
if (arg_present(out_subf)) and (n_elements(out_subi) eq 0) then out_subi=indgen(nk)+1
if (n_elements( out_subi)  ge 1) and (n_elements(out_subi) le nk) then begin
    out_subi=out_subi>1<nk
    nx      =(size(datp.X))[1]
    out_subF=fltarr(nx,nspec,n_elements(out_subi))
    out_Bkg =fltarr(nx,nspec)
    Fshape  =0.
    for i=0,nspec-1 do begin
        for k=0,n_elements(out_subi)-1 do begin & nFunc=out_subi[k]-1
            str_sub_func, datp.X[*,i<(sx-1)], fit_pars[i,*,nFunc], UserModl, nFunc, sub=subf
            out_subF[*,i,k]=subF
        endfor
        if sb ge 1 then Fshape=sf_bkgd[*,i<(sb-1)]
        str_bkg_spec,     datp.X[*,i<(sx-1)], fit_pars[i,*,0], Fshape, background=fitb
        out_Bkg[*,i]=fitb
    endfor
    out_subF=reform(out_subF)
    out_Bkg =reform(out_Bkg)
endif

;give back fitted functions if asked
;***********************************
 newx=datp.y
 if n_elements(nout) eq 1 then begin
   datp.x_tit='Fitted '+datp.x_tit
   GIVE_W ,wout,W=nout
   if n_elements(datp.y) ge sw[2] then $
   if n_elements(rsp) eq 2 then if (size(datp.y))[0] eq 2 then MOD_DATP,datp,'y',datp.y[*,frst:lst] else MOD_DATP,datp,'y',datp.y[frst:lst]
   MOD_DATP ,datp,'e',0
   GIVE_DATP,datp,W=nout
 endif

;return fitted parameters and errors
;***********************************
 datp.x_tit=datp.y_tit
 datp.y_tit='f H C W b l q D F'
 MOD_DATP,datp,'z_tit','Functions'  ;pb with resolution function
 if n_elements(newx) ge sw[2] then $
 if n_elements(rsp) eq 2 then if (size(newx))[0] eq 2 then newx=reform(newx[0,frst:lst]) else newx=newx[frst:lst]
 if (pout gt 0) or (comd eq 1) then begin
     MOD_DATP,datp,'x',newx
     MOD_DATP,datp,'y',indgen((size(fit_pars))[2])
     MOD_DATP,datp,'e',reform(fit_sigmas)
     if pout gt 0 then begin & GIVE_DATP, datp,W=pout & GIVE_W, reform(fit_pars), W=pout & endif
     if comd eq 1 then begin & str_wks_in_cmd, flaag
                             if flaag then  GIVE_DATP, datp ;We have Wi=str_fit(Wj,.....)
     endif
 endif
func_bkgd=0 & func_conv=0 & func_dti=0 & fpsd=[-1] & UserModl=0 & D_bal=1.
folSpec=1 & folXx=0 & folBo=0 & folXb=0 & KPdim2=0 & folQexp=[''] & FitOrNot=0
;di_inst_Dreso, 'clear'
 di_inst_Dreso, '',active=0

if oklab then begin & if (kp_error ne !error_state.msg) and (toti le 1) then itmess=!error_state.msg else $
                      if (itmax    gt 1)                and (toti le 1) then itmess='??? iter='+s4v(toti)+'          ' $
                                                                        else itmess=' Ok iter='+s4v(toti)+'          '
                    widget_control,ilab,bad_id=ii,set_value=strmid(itmess,0,20) & endif

if maystop then if evv.id eq stop_id then widget_control,stop_id,/clear_events

return, fit_pars
end

pro str_fit,     noTabs=noTab, iniGUI=iniGUI
;+
;** *******
;** User callable
;** call str_fit as a procedure
;-
    str_fit_win, noTabs=noTab, iniGUI=iniGUI & end
